Generating the Patch files for MacPort

1) Why
  MacPorts uses "configure" to generate its current Makefiles and/or installation
  scripts from the generic ones with the appropriate compiler version and
  compilation switches
  
  Imager (as Gildas) did that in a different way
  
  Thus, the explicit names of compiler and explicit switches in some Makefile.*
  or *.sh in admin/ must be replaced by the usual "configure" symbols, e.g.
    @CC@ for  cc
    @PYTHON@ for Python
  etc..
  
  see the "configure" section in the Portfile.txt for a complete list
  
2) Unfortunately, there is no automatic way to generate the patch files for MacPorts
  This has to be done by manually editing the relevant files to do this "by hand"
  
  As a result, any modification in these files is dangerous, and may require
  a similar change in the .diff patch file
  
3) Verifying the patch files

  $ cd MacPorts
  $ cp ../admin/(file)
  $ patch < patch-admin-(file).diff
  
  A) If it works, then the patch is still valid.
  B) If not, it must be either edited (usually a small change of line numbers
      by a couple of units, rarely more), 
  C) or, in more complex cases, it must be re-created. See instructions below
      A good way to generate the modified patched file is to generate a patch 
      file from the Git repository for the changes in the original file version, 
      and apply this patch to the local patched copy of the file (because the
      2 patches at stake are independent).
  D) Ultimately, one may even simply handle that through a MacPorts branch ??
  
4) MacPort uses a relative path structure and the first 2 lines of the .diff patch
  files to figure out on which files the patch applies. 
  
  Thus, the patch should be generated by
    $ diff -u 
  from 1 directory atop the admin/ directory (in order to allow simple versioning)
  and the -p1 flag is used by "patch", through the appropriate switch in the 
  Portfile.txt
  
5) List of patch files

patch-admin-Makefile.build.diff
patch-admin-Makefile.def.diff
patch-admin-Makefile.python.diff
patch-admin-define-system.sh.diff
patch-admin-imager-env.sh.diff

subroutine jjdate (tjj,date)
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! ASTRO
  !
  !  Conversion d'une date julienne en date du calendrier gregorien
  !  from EPHAUT / BDL / ? / 82-1
  !
  !  modified 29 november 1984 by Michel Perault  
  !  en entree : TJJ date julienne (jours juliens)  
  !  en sortie : DATE date gregorienne (year, month, day, hour, minute, second)  
  !
  !  remarque  : le calcul couvre la periode julienne de l'an  
  !              4713 avant notre ere a l'an 3267 de notre ere.  
  !              les annees sont comptees en millesimes astronomiques  
  !              l'annee qui precede l'an 1 de notre ere est l'an 0  
  !              ex : l'an 80 avant notre ere a le millesime -79.  
  !  rappel    : la periode du 5 octobre 1582 0h au 14 octobre 1582  
  !              24 h n'existe pas
  !!
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: tjj  !! Julian Date (days)
  integer(kind=4), intent(out) :: date(7)  !! Gregorian date 
  !! D(year, month, day, hou, minute, second) 
  !
  ! Local --
  integer(kind=4) :: year,month,day,hour,minute,second,millisec
  integer(kind=4) :: i
  real(kind=8) :: t,z,f,a,x,b,c,d,e
  !
  ! Code ----
  do i=1,7
    date(i)=0
  enddo
  if (tjj.le.0.d0) return
  ! T=TJJ+0.5D0/86400.D0+0.5D0
  t=tjj+0.5d0
  z=int(t)
  f=t-z
  a=z
  if (z.ge.2299161.d0) then
    x=int((z-1867216.25d0)/36524.25d0)
    a=z+1.d0+x-int(x/4.d0)
  endif
  b=a+1524.d0
  c=int((b-122.1d0)/365.25d0)
  d=int(365.25d0*c)
  e=int((b-d)/30.6001d0)
  day=b-d-int(30.6001d0*e)
  month=e-1.d0
  if (e.gt.13.5d0) month=e-13.d0
  year=c-4716.d0
  if (month.lt.2.5d0) year=c-4715.d0
  second=+1
  f=f*24.d0
  hour=f
  f=(f-hour)*60.d0
  minute=f
  f=(f-minute)*60.d0
  second=f
  f = (f-second)*1000.d0
  millisec=f
  date(1)=year
  date(2)=month
  date(3)=day
  date(4)=hour
  date(5)=minute
  date(6)=second
  date(7) = millisec
  return
end subroutine jjdate
!
subroutine datejj (date,tjj)
  !---------------------------------------------------------------------
  ! @ public
  ! ASTRO
  !*
  !  ASTRO - Utility routine 
  !
  !  conversion d'une date du calendrier gregorien en date julienne
  !  from EPHAUT / BDL / ? / 82-1
  !
  !  modified 29 november 1984 by Michel Perault
  !
  !  en entree : DATE date gregorienne (year, month, day, hour, minute, second
  !		, millisecond)  
  !  en sortie : TJJ date julienne (jours juliens)
  !!
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: date(7)        !! Gregorian date 
  !! D(year, month, day, hour, minute, second) 
  real(kind=8), intent(out) :: tjj              !! Julian Date (days)
  !
  ! Local
  integer(kind=4) :: year,month,day,hour,minute,second, millisecond
  integer(kind=4) :: m
  real(kind=8) :: b,c,y,a
  !
  tjj=0.d0
  year=date(1)
  month=date(2)
  day=date(3)
  hour=date(4)
  minute=date(5)
  second=date(6)
  millisecond = date(7)
  if (year.lt.-4712.or.year.gt.3267) return
  if (month.lt.1.or.month.gt.12) return
  if (day.lt.0.or.day.gt.31) return
  if (hour.lt.0.or.hour.gt.24) return
  if (minute.lt.0.or.minute.gt.60) return
  if (second.lt.0.or.second.gt.60) return
  if (millisecond.lt.0.or.millisecond.gt.1000) return
  y=year
  m=month
  b=0.d0
  c=0.d0
  if (month.le.2) then
    y=y-1.d0
    m=m+12
  endif
  if (y.lt.0) then
    c=-0.75d0
  else
    if (year.gt.1582 .or. (year.eq.1582 .and. (month.gt.10 .or. (month.eq.10  &
       .and. day.gt.14)))) then
      a=int(y/100.d0)
      b=2.d0-a+int(a/4.d0)
    elseif (year.eq.1582 .and. month.eq.10 .and. day.ge.5 .and. day.le.14) then
      return
    endif
  endif
  tjj=int(365.25d0*y+c)+int(30.6001d0*(m+1))+day+dble(hour)/24.d0+            &
      dble(minute)/1440.d0+dble(second)/86400.d0+dble(millisecond)/86400.d3+  &
      1720994.5d0+b
  return
end subroutine datejj
!
function tsmg (tjj)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO - Temps Sideral Moyen Greewich
  !
  !  calcul du temps sideral moyen de Greenwich (radian)
  !  from EPHAUT / BDL / A002 / 82-1
  !
  !  reference Aoki et al. (1982, Astron. Astrophys. 105, 359)
  !
  !  remarques : on utilise le formulaire UAI84
  !              l'epoque de reference est J2000.0 (JJ2451545.0)
  !              le temps est compte en siecle julien
  !!
  !---------------------------------------------------------------------
  real(kind=8) :: tsmg              !! Function value
  real(kind=8), intent(in) :: tjj   !! Julian day 
  !
  ! Local
  real(kind=8), parameter :: tf=2451545.0d0  ! J2000.0 Julian date
  real(kind=8), parameter :: shrad=0.7272205216643040d-4
  real(kind=8) :: t,t2,t3,alfsm,h,x
  !
  t=(tjj-tf)/36525.d0
  t2=t*t
  t3=t2*t
  !
  !  calcul du temps sideral moyen
  alfsm=67310.54841d0+8640184.812866d0*t+0.93104d-1*t2-0.62d-5*t3
  h=(tjj-int(tjj))*86400.d0
  x=dmod(alfsm+h,86400.d0)
  if (x.lt.0.d0) x=x+86400.d0
  x=x*shrad
  tsmg=x
end function tsmg
!
function oblimo (tjj)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO -- Ephemeris routine
  !
  !  calcul de l'obliquite moyenne (radian), precession selon Lieske et al. (1977)
  !  from EPHAUT / BDL / C004 / 82-1
  !  modified 29 november 1984 by Michel Perault
  !  en entree : TJJ date (jours juliens)
  !!
  !---------------------------------------------------------------------
  real(kind=8) :: oblimo              !! Obliquity
  real(kind=8) :: tjj                 !! Julian day
  !
  real(kind=8), parameter :: sdrad=0.4848136811095360d-5
  real(kind=8), parameter :: tj0=2451545.d0
  real(kind=8), parameter :: siecle=36525.d0
  !
  ! Local
  real(kind=8) :: epsm,t,t2,t3
  !
  ! calcul de l'obliquite
  t=(tjj-tj0)/siecle
  t2=t*t
  t3=t2*t
  epsm=84381.448d0-46.815d0*t-0.59d-3*t2+0.1813d-2*t3
  oblimo=epsm*sdrad
  return
end function oblimo
!
subroutine nuta (tjj,dpsi,deps)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO -- Ephemeris routine
  !
  !  calcul de la nutation en longitude et en obliquite a la date TJJ
  !  d'apres les formules de WAHR (1981)
  !  from EPHAUT / BDL / D003 / 81-1
  !  modified 29 november 1984 by Michel Perault
  !  only the terms with amplitude larger than 0.004 arcsec are kept
  !  en entree :  TJJ date (jours juliens)
  !  en sortie :  DPSI nutation en longitude (radian)
  !		DEPS nutation en obliquite (radian)
  !  remarques :  l'epoque de reference pour le calcul de la nutation
  !		est TF1 : 1 janvier 2000 12h (J2000.0)
  !		l'epoque de reference pour le calcul des arguments
  !		fondamentaux est TF2 : 0 janvier 1900 12h
  !!
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: tjj               !! Julian date
  real(kind=8), intent(out) :: dpsi             !! Longitude nutation
  real(kind=8), intent(out) :: deps             !! Obliquity nutation
  !
  real(kind=8), parameter :: sdrad=0.4848136811095360d-5
  real(kind=8), parameter :: dgrad=0.1745329251994330d-1
  real(kind=8), parameter :: tf1=2451545.d0
  real(kind=8), parameter :: tf2=2415020.0d0
  real(kind=8), parameter :: siecle=36525.d0
  !
  ! Local ---
  real(kind=8) :: l,p,f,d,g
  real(kind=8) :: t,tj,s,s2,s3
  real(kind=8) :: a,e
  !
  t=(tjj-tf1)/365250.d0
  tj=tjj-tf2
  s=tj/36525.d0
  s2=s*s
  s3=s2*s
  !
  !  arguments fondamentaux
  l=296.104608d0+13.0649924465d0*tj+0.9192d-2*s2+0.143d-4*s3
  l=dmod(l,360.d0)*dgrad
  p=358.475833d0+0.9856002669d0*tj-0.149d-3*s2-0.331d-5*s3
  p=dmod(p,360.d0)*dgrad
  f=11.250889d0+13.2293504490d0*tj-0.3211d-2*s2-0.341d-6*s3
  f=dmod(f,360.d0)*dgrad
  d=350.737681d0+12.1907491914d0*tj-0.1436d-2*s2+0.19d-5*s3
  d=dmod(d,360.d0)*dgrad
  g=259.183275d0-0.0529539222d0*tj+0.2078d-2*s2+0.2d-5*s3
  g=dmod(g,360.d0)*dgrad
  !
  !  nutation en longitude (20 terms)
  a=(-171996-1742*t)*dsin(g) + (2062+2*t)*dsin(2*g) + 46*dsin(-2*l+2*f+g)
  a=a + (-13187-16*t)*dsin(2*f-2*d+2*g) + (1426-34*t)*dsin(p) +             &
        (-517+12*t)*dsin(p+2*f-2*d+2*g) + (217-5*t)*dsin(-p+2*f-2*d+2*g) +  &
        (129+t)*dsin(2*f-2*d+g) + 48*dsin(2*l-2*d)
  a=a + (-2274-2*t)*dsin(2*f+2*g) + (712+t)*dsin(l) + (-386-4*t)*dsin(2*f+g)  &
      - 301*dsin(l+2*f+2*g) - 158*dsin(l-2*d) + 123*dsin(-l+2*f+2*g) +        &
        63*dsin(2*d) + (63+t)*dsin(l+g) + (-58-t)*dsin(-l+g) -                &
        59*dsin(-l+2*f+2*d+2*g) - 51*dsin(l+2*f+g)
  dpsi=a*sdrad/1.d4
  !
  !  nutation en obliquite (11 terms)
  e=(92025+89*t)*dcos(g) + (-895+5*t)*dcos(2*g)
  e=e + (5736-31*t)*dcos(2*f-2*d+2*g) + (54-t)*dcos(p) +                  &
        (224-6*t)*dcos(p+2*f-2*d+2*g) + (-95+3*t)*dcos(-p+2*f-2*d+2*g) -  &
        70*dcos(2*f-2*d+g)
  e=e + (977-5*t)*dcos(2*f+2*g) + 200*dcos(2*f+g) + (129-t)*dcos(l+2*f+2*g) -  &
        53*dcos(-l+2*f+2*g)
  deps=e*sdrad/1.d4
  return
end subroutine nuta
!
subroutine ctcheb (values,degree,coeff,error)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO -- Ephemeris Utility routine
  !
  !     Approximation d'une fonction par un developpement en polynomes de
  !     Tchebychev sur un intervalle de variation donne
  !  Loosely inspired from EPHAUT / BDL / J002 / 81-1
  !
  !  Modified 5 October 1985 - Michel Perault - POM Version 2.0
  !!
  !  Input :
  !	VALUES(0:DEGREE) function at Tchebychev abscissa
  !	DEGREE	degree of representation
  !  Output :
  !	COEFF(0:DEGREE)	coefficients of Tchebychev polynomes
  !	ERROR	logical, if improper value of DEGREE
  !  Notes :
  !	VALUES et COEFF sont exprimes dans la meme unite.
  !	Les abscisses de tchebychev sur l'intervalle (-1,+1) sont donnees
  !	par la relation suivante :  
  !                 Xk = cos((2*k+1)*pi/(2*(DEGREE+1))  pour k = 0,DEGREE+1  
  !	Les valeurs de la fonction aux abscisses de Tchebychev ne doivent
  !	pas presenter de discontinuite.
  !	Il est conseille de representer la fonction sur un intervalle ne
  !	contenant pas plus d'un extremum.
  !!
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: degree           !! degree of representation
  real(kind=8),intent(in) :: values(0:degree)     !! function at Tchebychev abscissa
  real(kind=8), intent(out) :: coeff(0:degree)    !! coefficients of Tchebychev polynomes
  logical, intent(out) :: error                   !! Logical error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.141592653589793d0
  integer(kind=4), parameter :: degmax=15  ! maximum degree of representation
  !
  ! Local ---
  real(kind=8) :: t(0:degmax,0:degmax)     ! polynomes at Tchebychev abscissa
  integer(kind=4) :: ncoeff                ! number of coefficients
  integer(kind=4) :: j,k                   ! indexes
  real(kind=8) :: y                        ! computation memory
  !
  !  Check parameters
  error = .true.
  if (degree.lt.0 .or. degree.gt.degmax) return
  !
  !  Start computations : Tchebychev polynomes at Tchebychev abscissa
  ncoeff = degree+1            ! number of coefficients
  do k = 0,degree              ! loop on abscissa
    t(0,k) = 1.d0              ! X = Tcheb. abscissa
    t(1,k) = cos (dble(2*k+1)*pi/dble(2*ncoeff))
    do j = 2,degree
      t(j,k) = 2.0d0 * t(1,k) * t(j-1,k) - t(j-2,k)
    enddo
  enddo
  !
  !  Coefficients, obtained by scalar product
  do j = 0,degree
    y = 0.d0                   ! initialize coefficient
    do k = 0,degree
      y = y + t(j,k) * values(k)
    enddo
    if (j.gt.0) y = 2.d0 * y   ! ### why ?
    coeff(j) = y / dble(ncoeff)
  enddo
  error = .false.
end subroutine ctcheb
!
subroutine ftcheb (degree,coeff,x,deriv,values,error)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! ASTRO -- Ephemeris Utility routine
  !
  !  Calcul d'une fonction et de ses derivees a partir de sa representation
  !  en developpement de polynomes de Tchebychev
  !  Loosely inspired from EPHAUT / BDL / J003 / 81-1
  !
  !  Modified 5 October 1985 - Michel Perault - POM Version 2.0
  !
  !	FTCHEB est exprimee dans la meme unite que les coefficients
  !  	Si dt est l'intervalle de representation exprime dans une unite donnee,
  !  	les derivees doivent etre multipliees par (2/dt)**DERIV
  !!
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: degree         !! degree of representation
  real(kind=8), intent(in)  :: coeff(0:degree)  !! coefficients of Tchebychev polynomes
  real(kind=8), intent(in)  :: x                !! abscissa (between -1.d0 and +1.d0)
  integer(kind=4), intent(in)  :: deriv         !! number of derivatives to compute
  real(kind=8), intent(out) :: values(0:deriv)  !! function and derivatives
  logical, intent(out) :: error                 !! Logical error flag
  !
  integer(kind=4), parameter :: degmax=15 ! maximum degree of representation
  integer(kind=4), parameter :: dermax=3  ! maximum derivative which can be computed
  !
  ! Local ---
  real(kind=8) :: t(0:degmax,0:dermax)    ! work array, maximum capacity
  integer(kind=4) :: j,k                  ! indexes
  real(kind=8) :: w                       ! 2*X coefficient of lower order polynome in recurrence
  integer(kind=4) :: c                    ! coefficient of lower order derivative in recurrence
  real(kind=8) :: y                       ! computation memory for function and derivatives
  !
  !  Check parameters
  error = .true.
  if (degree.lt.0 .or. degree.gt.degmax)  return
  if (deriv.lt.0 .or. deriv.gt.dermax)  return
  if (x.lt.-1.d0 .or. x.gt.+1.d0)  return
  !
  !  Compute Tchebychev polynomes and derivatives at X (recurrence)
  w = x+x
  do k = 0,deriv               ! loop on derivatives
    if (k.eq.0) then           ! init first values, J = 0 and 1
      t(0,k) = 1.d0
      t(1,k) = x
    elseif (k.eq.1) then
      t(0,k) = 0.d0
      t(1,k) = 1.d0
    else
      t(0,k) = 0.d0
      t(1,k) = 0.d0
    endif
    c = k+k
    do j = 2,degree
      t(j,k) = w * t(j-1,k) - t(j-2,k)
      if (k.gt.0) then
        t(j,k) = t(j,k) + c * t(j-1,k-1)
      endif
    enddo
  enddo
  !
  !  Compute function and derivatives
  do k = 0,deriv
    y = 0.d0
    do j = 0,degree
      y = y + t(j,k) * coeff(j)
    enddo
    values(k) = y
  enddo
  error = .false.
end subroutine ftcheb

subroutine uv_extract_comm(line, error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_extract_comm
  use gbl_message
  use clean_arrays
  !----------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Parsing for Command UV_EXTRACT  
  !   UV_EXTRACT /RANGE Min Max TYPE /FIELD Number
  !!
  !----------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out)            :: error !! Error flag
  !
  character(len=*), parameter  :: rname='UV_EXTRACT'
  integer, parameter           :: o_field=1   ! option /FIELDS
  integer, parameter           :: o_file=2    ! option for /FILE
  integer, parameter           :: o_range=3   ! option for /RANGE 
  real(8) :: drange(2)
  character(len=12) :: csort
  integer :: isort
  integer(kind=4), parameter :: msort=3
  character(len=12) :: types(msort),mysort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  character(len=filename_length) :: in_file, ou_file
  integer :: n
  type(gildas) :: hiuv, houv
  logical :: use_file
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  !
  integer(kind=4)             :: nvisi             ! Number of Vibilities
  integer(kind=4)             :: ncols             ! Number of columns in output
  integer :: nblock
  integer :: nc(2)
  logical :: err
  !
  ! Initialization
  if (sic_present(o_field,0)) then
    ! /FIELDS option is special
    if (sic_present(o_range,0)) then
      call map_message(seve%e,rname,'Option /FIELDS and /RANGE are exclusive')
      error = .true.
    else
      call uv_extract_fields(line,error)
    endif
    return
  endif
  !
  if (sic_present(o_range,0)) then
    ! /RANGE (for flexibility)
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,n,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs('READ',csort,mysort,isort,types,msort,error)
    if (error)  return
  else
    call map_message(seve%e,rname,'Missing /RANGE specification')
    error = .true.
    return
  endif
  !
  call gildas_null(hiuv,type='UVT')
  call gildas_null(houv,type='UVT')
  !
  if (sic_present(o_file,0)) then
    call sic_ch(line,o_file,1,in_file,n,.true.,error)
    if (error) return
    call sic_parse_file(in_file,' ','.uvt',hiuv%file)
    !
    ! Strip extension if present
    call sic_parsef(in_file,ou_file,' ','.uvt')
    ou_file = in_file
    !
    ! Line (continuum-Free) UV table
    if (sic_present(o_file,2)) then
      call sic_ch(line,o_file,2,ou_file,n,.true.,error)
    else
      ou_file = trim(in_file)//'-line'
    endif
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    !
    call gdf_read_header(hiuv,error)
    if (error) return
    !
    call gdf_copy_header(hiuv,houv,error)
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_GILDAS',hiuv,1)
    use_file = .true.
  else
    ! Work with Buffers
    if (huv%loca%size.eq.0) then
       call map_message(seve%e,rname,'No UV data loaded')
       error = .true.
       return
    endif
    !
    use_file = .false.
    call gdf_copy_header(huv,houv,error)
    call gdf_copy_header(huv,hiuv,error)
    !
  endif
  !
  ! Define the input range
  call out_range(rname,mysort,drange,nc,hiuv,error)
  if (error) return
  !  
  ! Adapt the output Header
  call uv_extract_header(houv, nc)
  !
  if (use_file) then
    !
    ! Create the output file
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    call gdf_create_image(houv,error)
    if (error) return
    ! Perform the extraction
    call uv_extract_sub(hiuv,houv,use_file,nblock,nc,error)
  else
    ! Define previous and destination buffers
    !
    nullify (duv_previous, duv_next)
    ncols = houv%gil%dim(1)
    nvisi = houv%gil%nvisi
    call uv_find_buffers (rname,ncols,nvisi,duv_previous, duv_next,error)
    if (error) then
       call map_message(seve%e,rname,'Cannot set buffer pointers')
       return
    endif
    !
    call gdf_copy_header(huv,hiuv,error)
    hiuv%r2d => duv_previous
    houv%r2d => duv_next
    nblock = 0
    ! Perform the extraction
    call uv_extract_sub(hiuv,houv,use_file,nblock,nc,error)
    !
    ! In Memory: Copy header back to HUV,  and handle buffers
    err = error   ! Save the error Status
    call gdf_copy_header (houv, huv, error)
    ! Reset proper pointers
    call uv_clean_buffers (duv_previous, duv_next,error)
    if (error) return
    ! Redefine SIC variables 
    call map_uvgildas ('UV',huv,error,duv)
    call uv_new_data(weight=.true., resample=.true.)
    if (err) error = .true. 
  endif
  !
end subroutine uv_extract_comm
!
subroutine uv_extract_fields(line,error)
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, except_this=>uv_extract_fields
  use gbl_message
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for Command  
  !   UV_EXTRACT /FIELDS NumberList
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(out)            :: error !! Error flag
  !
  ! Constants
  character(len=*), parameter  :: rname='UV_EXTRACT'
  integer, parameter           :: o_field=1   ! option /FIELDS
  integer, parameter           :: o_file=2    ! option for /FILE
  integer, parameter           :: o_range=3   ! option for /RANGE 
  real(8), parameter :: rad_to_sec=3600.d0*180d0/acos(-1.d0)
  !
  ! Local ---
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  !
  ! For /FIELD option
  character(len=120) :: chain
  integer :: nu, nv, mp, np
  integer :: ixoff, iyoff, idoff, ier
  real, pointer :: duv_in(:,:), duv_out(:,:)
  integer :: ifield, jfield, nfields! Field number & Number of fields
  real, allocatable :: doff(:,:)    ! Field offsets
  integer, allocatable :: ivoff(:)  ! Input Visibility pointers
  integer, allocatable :: jvoff(:)  ! Output Visibility pointers
  integer :: ivstart, ivend, kvstart, kvend
  logical :: sorted, shift
  real(8) :: new(3)
  real(4) :: uvmin, uvmax
  !
  logical :: err, found
  type(sic_descriptor_t) :: desc
  integer, allocatable :: fields(:)
  ! 
  ! Code ---
  !
  ! Special /FIELD case: extract the selected fields
  shift = .false.  ! Must be initialized
  !
  mp = abs(themap%nfields)
  if (mp.eq.0) then
    call map_message(seve%e,rname,'UV data is not a Mosaic')
    error = .true.
    return
  endif
  ! Select Fields first
  call sic_delvariable('FIELDS%N_SELECT',.false.,error)
  call sic_delvariable('FIELDS%SELECTED',.false.,error)
  error = .false.
  !
  call select_fields(rname,line,o_field,mp,np,fields,error)
  if (error) return
  !
  allocate(doff(2,mp),ivoff(mp+1),jvoff(mp+1),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi
  if (themap%nfields.gt.0) then
    ixoff = huv%gil%column_pointer(code_uvt_xoff)
    iyoff = huv%gil%column_pointer(code_uvt_yoff)
  else
    ixoff = huv%gil%column_pointer(code_uvt_loff)
    iyoff = huv%gil%column_pointer(code_uvt_moff)
  endif
  idoff = huv%gil%column_pointer(code_uvt_id)
  !
  ! This one would work only for Sorted Mosaics.
  !! call mosaic_loadfield (duv,nu,nv,ixoff,iyoff,mp,doff,ivoff,uvmax,uvmin)
  new = 0.d0
  call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
    & ixoff, iyoff, idoff, mp, doff,ivoff)
  !
  nv = 1
  do jfield=1,np 
    ifield = fields(jfield)
    jvoff(jfield) = nv
    nv = nv + ivoff(ifield+1)-ivoff(ifield)
    jvoff(jfield+1) = nv
  enddo
  nv = nv-1
  nfields = np  
  !
  ! Prepare appropriate array...
  nullify (duv_previous, duv_next)
  call uv_find_buffers (rname,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot set buffer pointers')
    return
  endif
  !
  do jfield=1,nfields
    ifield = fields(jfield)
    ! This looks tricky, but is working.
    ! It is used to extract an arbitrary subset of all fields
    ! In input Ifield
    ivstart = ivoff(ifield)      ! Starting Visibility of field
    ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
    ! In output Jfield
    kvstart = jvoff(jfield)      ! Starting Visibility of field
    kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
    write(chain,'(A,I0,4(1X,I0),2F10.2)') 'Processing field # ',ifield, &
      & ivstart,ivend, kvstart, kvend, doff(1,ifield)*rad_to_sec, doff(2,ifield)*rad_to_sec
    call map_message(seve%i,rname,chain)
    !
    ! Set the range
    duv_in => duv(:,ivstart:ivend)
    duv_out => duv_next(:,kvstart:kvend)
    !
    ! Copy...
    duv_out = duv_in
  enddo  
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  ! Redefine SIC variables 
  huv%gil%nvisi = nv
  huv%gil%dim(2) = nv
  !
  ! Delete variables that may have been affected
  err = .false.
  call sic_descriptor('UVS',desc,found)  
  if (found) call sic_delvariable('UVS',.false.,err)
  !
  call check_uvdata_type(rname,huv,duv,themap,error)
  call uv_new_data(weight=.true.)
  !
  deallocate(fields)
end subroutine uv_extract_fields
!
subroutine uv_extract_header(huv, nc)
  use image_def
  use gkernel_interfaces, only : gdf_range
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --
  !   Support for Command    UV_EXTRACT /RANGE     
  !
  !   Setup output header consistently
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huv    !! Header to be modified
  integer, intent(in) :: nc(2)          !! Desired channel range
  !
  ! Local ---
  integer :: local_nc(2), ier, nchan, icol, lshift
  integer :: nf, ns, istart, iend
  real(8), allocatable :: freqs(:)
  integer, allocatable :: stokes(:)
  !
  ! Code ----
  nchan = huv%gil%nchan
  local_nc = nc
  ier = gdf_range (local_nc, nchan)
  nchan = local_nc(2)-local_nc(1)+1
  huv%gil%ref(1) = huv%gil%ref(1)-local_nc(1)+1
  huv%gil%dim(1) = huv%gil%nlead+huv%gil%natom*huv%gil%nstokes*nchan
  !
  ! Shift trailing columns if needed
  if (huv%gil%ntrail.gt.0) then
    huv%gil%dim(1) = huv%gil%dim(1)+huv%gil%ntrail
    lshift = (huv%gil%nchan-nchan)*huv%gil%nstokes*huv%gil%natom
    do icol=1,code_uvt_last
      if (huv%gil%column_pointer(icol).gt.huv%gil%lcol) then
        !Print *,'Shifting ',l,' by ',-huvin%gil%lcol+huvou%gil%lcol
        huv%gil%column_pointer(icol) = huv%gil%column_pointer(icol) - lshift
      endif
    enddo
  endif 
  !
  huv%gil%nchan = nchan
  !
  ! Shift random frequency information if any
  if (huv%gil%nfreq.ne.0) then
    nf = huv%gil%nfreq
    ns = max(1,huv%gil%nstokes)
    allocate(freqs(nf),stokes(nf))
    freqs(:) =  huv%gil%freqs(:)
    stokes(:) = huv%gil%stokes(:)
    deallocate(huv%gil%freqs,huv%gil%stokes)
    !
    ! Each channel counts for NS Stokes 
    huv%gil%nfreq = nchan*ns
    allocate(huv%gil%freqs(huv%gil%nfreq),huv%gil%stokes(huv%gil%nfreq),stat=ier)
    istart = (local_nc(1)-1)*ns + 1
    iend   = local_nc(2)*ns
    huv%gil%freqs(:) = freqs(istart:iend)
    huv%gil%stokes(:) = stokes(istart:iend)
  endif
  !  
end subroutine uv_extract_header
!
subroutine uv_extract_sub(hiuv,houv,use_file,nblock,channels,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_extract_sub
  use gbl_message
  !----------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command UV_EXTRACT /RANGE 
  !
  !    Extract a range of channels from a UV table
  !!
  !----------------------------------------------------------
  type(gildas), intent(inout) :: hiuv     !! Input UV header
  type(gildas), intent(inout) :: houv     !! Extracted UV header
  logical, intent(in)         :: use_file !! File indicator
  integer, intent(in)         :: nblock   !! Blocking factor
  integer, intent(in) :: channels(2)      !! Limits for the new UV table in channels
  logical, intent(inout) :: error         !! Error flag
  !
  character(len=*), parameter :: rname='UV_EXTRACT'
  !
  ! Local ---
  character(len=80) :: mess
  integer(kind=index_length)  :: ib           ! Blocked visibility counter
  integer(kind=index_length)  :: mvisi        ! Number of blocked visibilities
  integer(kind=index_length)  :: nvisi        ! Number of visibilities
  integer(kind=index_length)  :: ivisi        ! Index for loop over visibilities
  integer(kind=index_length)  :: fcoli        ! First column of extractable data in UV buffer
  integer(kind=index_length)  :: lcoli        ! Last column of extractable data in UV buffer
  integer(kind=index_length)  :: fcolo        ! First column of data in temporary UV buffer
  integer(kind=index_length)  :: lcolo        ! Last column of data in temporary UV buffer
  integer :: ier
  !
  fcoli = hiuv%gil%nlead+1+(channels(1)-1)*hiuv%gil%nstokes*hiuv%gil%natom
  lcoli = hiuv%gil%nlead+channels(2)*hiuv%gil%nstokes*hiuv%gil%natom
  fcolo = houv%gil%nlead+1
  lcolo = houv%gil%dim(1)-houv%gil%ntrail
  !
  if (use_file) then
    !
    ! Data file case - Use blocking
    mvisi = nblock
    hiuv%blc = 0
    houv%blc = 0
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),houv%r2d(houv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    do ib=1,hiuv%gil%dim(2),mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
      call map_message(seve%i,rname,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      do ivisi=1, nvisi
        ! Copy first columns
        houv%r2d(1:houv%gil%nlead,ivisi) = hiuv%r2d(1:hiuv%gil%nlead,ivisi)
        ! Copy data
        houv%r2d(fcolo:lcolo,ivisi) = hiuv%r2d(fcoli:lcoli,ivisi)
        ! Copy trailing columns if any
        if (houv%gil%ntrail.gt.0) then
          houv%r2d(houv%gil%dim(1)-houv%gil%ntrail+1:houv%gil%dim(1),ivisi) = & 
            hiuv%r2d(hiuv%gil%dim(1)-hiuv%gil%ntrail+1:hiuv%gil%dim(1),ivisi)  
        endif
      enddo
      !
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,houv%r2d,error)
      if (error) return
    enddo
    !
    deallocate(hiuv%r2d,houv%r2d)  
    call gdf_close_image(hiuv,error)
    call gdf_close_image(houv,error)
    if (error) return
    !
    call map_message(seve%i,rname,'Created '//trim(houv%file))
    !
  else
    ! Memory version
    do ivisi=1, hiuv%gil%nvisi
      ! Copy first columns
      houv%r2d(1:houv%gil%nlead,ivisi) = hiuv%r2d(1:hiuv%gil%nlead,ivisi)
      ! Copy data
      houv%r2d(fcolo:lcolo,ivisi) = hiuv%r2d(fcoli:lcoli,ivisi)
      ! Copy trailing columns if any
      if (houv%gil%ntrail.gt.0) then
        houv%r2d(houv%gil%dim(1)-houv%gil%ntrail+1:houv%gil%dim(1),ivisi) = & 
          hiuv%r2d(hiuv%gil%dim(1)-hiuv%gil%ntrail+1:hiuv%gil%dim(1),ivisi)  
      endif
    enddo
  endif
  !
end subroutine uv_extract_sub

module use_continuum
  !TEST! logical :: debug=.false.
  integer, parameter :: code_hollow=1
  integer, parameter :: code_void=0 
  integer, parameter :: code_empty=-1
  integer, parameter :: code_ok=2
  integer, save :: i_the_method=1   !! Method
  real, save :: thremu=3.0      !! Rejection Threshold
  integer, save :: mcount=8     !! Maximum number of iterations
  real, save :: logwings=3.5    !! Gaussian threshold
  real, save :: clip_value=2.5  !! GLOBAL clipping value
  integer :: nhist              !! Histogram size
end module use_continuum
!
subroutine map_continuum(line,error)
  use use_continuum
  use image_def
  use clean_def
  use clean_default
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, except_this => map_continuum 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for MAP_CONTINUUM  /METHOD command
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! command line
  logical, intent(inout) :: error         !! Logical error flag
  !
  ! Constants 
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='MAP_CONTINUUM'
  integer, parameter :: o_the_method=1
  integer, parameter :: i_global=1
  integer, parameter :: i_gauss=2
  integer, parameter :: i_scm=3
  integer, parameter :: i_egm=4
  integer, parameter :: i_cscm=5
  integer :: i_hist=0
  integer, parameter :: mmeth=5
  character(len=8) :: vmeth(mmeth), cmeth
  data vmeth/'GLOBAL','GAUSS', 'SCM','EGM','C-SCM'/
  ! 
  ! Local ---
  integer :: imeth
  character(len=16) :: name
  character(len=80) :: chain
  integer :: n, nchan, ier, na
  integer(kind=index_length) :: dim(2), mhist
  type(gildas) :: hmap
  real, allocatable, target, save :: spectrum(:,:)
  real :: xsize, ysize, factor, cx, cy, rms
  real(8) :: funit
  integer :: imin,imax,jmin,jmax,i1,i2, box(4), nx,ny
  logical :: do_mask
  !
  ! Code ----
  call sic_delvariable('CONTINUUM',.false.,error)
  if (allocated(dcont)) deallocate(dcont)
  call sic_delvariable('CLIPPED',.false.,error)
  if (allocated(spectrum)) deallocate(spectrum)
  !
  error = .false.
  call gildas_null(hmap)
  call gildas_null(hcont)
  !
  name = 'CLEAN'
  call sic_ke(line,0,1,name,n,.false.,error)
  select case (name)
  case ('CLEAN')
    if (hclean%loca%size.eq.0) then
      call map_message(seve%e,rname,'No CLEAN data loaded')
      error = .true.
      return
    endif
    call gdf_copy_header(hclean,hmap,error)
    hmap%r3d => dclean
    ! Number of pixels per beam
    factor = abs(pi*hmap%gil%majo*hmap%gil%mino/hmap%gil%inc(1)/hmap%gil%inc(2))
  case ('SKY')
    if (hsky%loca%size.eq.0) then
      call map_message(seve%e,rname,'No SKY data loaded')
      error = .true.
      return
    endif
    call gdf_copy_header(hsky,hmap,error)
    hmap%r3d => dsky
    ! Number of pixels per beam
    factor = abs(pi*hmap%gil%majo*hmap%gil%mino/hmap%gil%inc(1)/hmap%gil%inc(2))
  case ('DIRTY')
    if (hdirty%loca%size.eq.0) then
      call map_message(seve%e,rname,'No DIRTY data loaded')
      error = .true.
      return
    endif
    call gdf_copy_header(hdirty,hmap,error)
    hmap%r3d => ddirty
    factor = 1.0
  case default
    call map_message(seve%e,rname,'Only work on CLEAN or DIRTY images')
    error = .true.
    return
  end select
  !
  if (sic_present(o_the_method,0)) then
    call sic_ke(line,o_the_method,1,name,na,.true.,error)
    if (error) return
    call sic_ambigs (rname,name,cmeth,imeth,vmeth,mmeth,error)
    if (error) return
    i_the_method = imeth
    call map_message(seve%w,rname,'Switching to the_method '//vmeth(i_the_method),3)
    select case(cmeth)
    case ('GLOBAL')
      ! /METHOD GLOBAL Clip Nhist
      clip_value = 2.5
      call sic_r4(line,o_the_method,2,clip_value,.false.,error)
      if (clip_value.lt.1.0 .or. clip_value.gt.5.0) then
        call map_message(seve%e,rname,'Clipping value outside of recommended [1-5] range')
        error = .true.
        return
      endif
      i_hist = 3  ! Size of histogram at end of argument list
    case ('GAUSS')
      ! /METHOD  GAUSS Clip Nhist Miter
      call sic_r4(line,o_the_method,2,logwings,.false.,error)
      if (error) return
      i_hist = 3
      call sic_i4(line,o_the_method,4,mcount,.false.,error)
      if (error) return
    case ('SCM','C-SCM')
      ! /METHOD SCM Clip Miter
      call sic_r4(line,o_the_method,2,thremu,.false.,error)
      if (error) return
      call sic_i4(line,o_the_method,3,mcount,.false.,error)
      if (error) return 
      i_hist = 5  ! No histogram needed.      
    case ('EGM')
      ! /METHOD EGM Clip Nhist Miter
      call map_message(seve%e,rname,'Method EGM not yet implemented',3)
      error = .true.
      return
    end select
  else  
    call map_message(seve%i,rname,'Using the_method '//vmeth(i_the_method))
  endif
  !
  ! Copy header to Continuum
  call gdf_copy_header(hmap,hcont,error)
  !
  ! Must have a conservative value of the noise, not just an arbitrary estimate
  rms = max(hmap%gil%noise, hmap%gil%rms)
  !
  ! Define continuum data
  hcont%gil%ndim = 2
  hcont%gil%dim(3) = 1
  allocate(dcont(hcont%gil%dim(1),hcont%gil%dim(2)), &
    &   spectrum(hmap%gil%dim(3),4),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  hcont%r2d => dcont
  !
  nchan = hmap%gil%dim(3)
  mhist = max(8,nint(sqrt(real(nchan))))
  mhist = min(mhist,32)
  mhist = max(8,mhist)
  nhist = mhist
  !
  call sic_i4(line,o_the_method,i_hist,nhist,.false.,error) 
  if (nchan.lt.32) then
    write(chain,'(A,I0,A)') 'Too few channels [',nchan,'], display only'
    call map_message(seve%w,rname,chain)
    nhist = 1
  else if (nhist.lt.8 .or. nhist.gt.max(8,nchan/8)) then
    write(chain,'(A,I0,A)') 'Histogram size out of allowed range [8-',nchan/8,']'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else if (nhist.gt.mhist)  then
    write(chain,'(A,I0,A)') 'Histogram size out of recommended range [8-',mhist,']'
    call map_message(seve%w,rname,chain)
  endif
  ! 
  ! We use the mechanics of MASK and SUPPORT as in the STATISTIC command
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  do_mask = the_method%do_mask  ! Bug before 25-Nov-2021
  !
  if (do_mask) then
    call copy_method(user_method,the_method)
    !
    if (.not.allocated(d_mask)) then
      allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Error getting support memory')
        error = .true.
        return
      endif
      the_method%do_mask = .true.
      the_method%nlist = 0
    endif
    box = [nx,ny,1,1] 
    the_method%box = [nx,ny,1,1] 
    call check_area(the_method,hmap,.true.) ! Needed !...
    call check_mask(the_method,hmap)
    box(1) = min(box(1),the_method%box(1))
    box(2) = min(box(2),the_method%box(2))
    box(3) = max(box(3),the_method%box(3))
    box(4) = max(box(4),the_method%box(4))
    call map_message(seve%i,rname,'Using current support')
    !
    if (i_the_method.eq.i_global) then
      call global_continuum(hmap,hcont,spectrum,error,box,d_mask)
    else
      call local_continuum(i_the_method,hmap,hcont,spectrum,error, &
      & rms,box,d_mask)
    endif
    if (error) return  
  else
    call get_size_factor(funit)
    !
    xsize = area_size(1)*funit
    ysize = area_size(2)*funit
    !
    if (xsize.eq.0. .and. ysize.eq.0.) then
      box = [1,1,nx,ny]
    else
      call map_message(seve%i,rname,'Using current SIZE')
      cx = area_center(1)*funit
      cy = area_center(2)*funit
      !
      i1 = (cx-0.5*xsize-hmap%gil%val(1))/hmap%gil%inc(1) + hmap%gil%ref(1)
      i2 = (cx+0.5*xsize-hmap%gil%val(1))/hmap%gil%inc(1) + hmap%gil%ref(1)
      imin = min(i1,i2)
      imax = max(i1,i2)
      Print *,'IMIN ',imin,' IMAX ',imax
      imin = max(1,imin)
      i1 = (cy-0.5*ysize-hmap%gil%val(2))/hmap%gil%inc(2) + hmap%gil%ref(2)
      i2 = (cy+0.5*ysize-hmap%gil%val(2))/hmap%gil%inc(2) + hmap%gil%ref(2)
      jmin = min(i1,i2)
      jmax = max(i1,i2)
      jmin = max(1,jmin)
      Print *,'JMIN ',jmin,' JMAX ',jmax
      !
      imin = min(imin,hmap%gil%dim(1))
      imax = min(imax,hmap%gil%dim(1))
      jmin = min(jmin,hmap%gil%dim(2))
      jmax = min(jmax,hmap%gil%dim(2))
      !
      box(1) = imin
      box(2) = jmin
      box(3) = imax
      box(4) = jmax
    endif
    !
    if (i_the_method.eq.i_global) then
      call global_continuum(hmap,hcont,spectrum,error,box)
    else
      call local_continuum(i_the_method,hmap,hcont,spectrum,error, &
        & rms,box)
    endif
    if (error) return  
  endif
  !
  hcont%loca%addr = locwrd(hcont%r2d) 
  hcont%loca%size = hcont%gil%dim(1) * hcont%gil%dim(2)
  call gdf_get_extrema (hcont,error)
  !
  call sic_mapgildas('CONTINUUM',hcont,error,dcont)
  dim(1) = hmap%gil%dim(3)
  dim(2) = 4
  !
  ! Scale to Jy if possible (CLEAN data)
  if (factor.eq.0) factor = 1
  spectrum(:,2) = spectrum(:,2)/factor
  spectrum(:,3) = spectrum(:,3)/factor
  where(spectrum(:,4).ne.0) 
    spectrum(:,4) = 1.0
  end where
  call sic_def_real('CLIPPED',spectrum,2,dim,.false.,error)
  !
  call exec_program('@ p_continuum')   
  !
end subroutine map_continuum
!
subroutine global_continuum(hmap,hcont,spectrum,error,box,mask)
  !$ use omp_lib
  use use_continuum
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => global_continuum
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  !   IMAGER -- Support for MAP_CONTINUUM
  !
  !   The method is to find a global set of windows (along 3rd axis)
  !   based on the mean spectrum in a selected region (defined by 
  !   a mask), and to compute the continuum as the average
  !   of the "line-free" channels outside of these windows.
  !
  !     The method uses a space-invariant spectral map. The error
  !   map of the derived continuum is thus constant. The method may
  !   fail to find weak continuum sources in fields which contain
  !   bright, spectrally confused, sources 
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hmap               !! Input line data cube
  type(gildas), intent(inout) :: hcont           !! Output continuum image
  real, intent(out) :: spectrum(:,:)             !! Output spectrum
  logical, intent(out) :: error                  !! Logical error flag
  integer(kind=4), intent(in) :: box(4)          !! Bounding box of mask
  logical, intent(in), optional :: mask(:,:)     !! Optional mask
  !
  character(len=*), parameter :: cname='MAP_CONTINUUM'
  !
  ! Local ---
  integer, allocatable :: mylines(:), oulines(:)
  real, pointer :: rmask(:,:)
  real :: blank, val
  integer :: nchan
  integer(kind=size_length) :: kxy,mhist, mchan
  integer :: nx,ny,ix,iy,ier,ic,kc,ib,nb,inb,iextent
  logical :: debug=.false.
  real(8) :: elapsed_s, elapsed_e, elapsed
  character(len=120) :: chain
  !
  ! Code ---
  elapsed_s = 0
  elapsed_e = 0
  error = .false.
  !
  nchan = hmap%gil%dim(3)
  mchan = nchan
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  mhist = nhist
  !
  allocate(mylines(nchan),oulines(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Memory allocation error')
    error = .true.
    return
  endif
  spectrum = 0.0
  do ic=1,nchan
    spectrum(ic,1) = (ic-hmap%gil%ref(3))*hmap%gil%vres + hmap%gil%voff
  enddo
  ! 
  if (hcont%gil%blan_words.ne.2 .or. hcont%gil%eval.lt.0) then
    !    
    ! We need to define a Blanking value outside of the range
    blank = minval(hmap%r3d)
    if (blank.gt.0) then
      hcont%gil%bval = -2.0*blank*nchan
      hcont%gil%eval = 0.0
    else if (blank.lt.0) then
      hcont%gil%bval = 3.0*blank*nchan
      hcont%gil%eval = 0.0
    else
      hcont%gil%bval = -1.0
      hcont%gil%eval = 0.0
    endif
  endif
  !
  ! Compute the mean spectrum
  !$ elapsed_s = omp_get_wtime()
  if (present(mask)) then
    !
    kxy = 0
    do iy=box(2),box(4)
      do ix=box(1),box(3)
        if (mask(ix,iy)) kxy = kxy+1
      enddo
    enddo
    !
    if (hmap%gil%eval.ge.0.0) then
      !$OMP PARALLEL DEFAULT(none)                 &
      !$OMP & SHARED(nchan,box,hmap,spectrum,mask) &
      !$OMP & PRIVATE(ix,iy,ic,val)
      !$OMP DO 
      do ic=1,nchan
        do iy=box(2),box(4)
          do ix=box(1),box(3)
            if (mask(ix,iy)) then
              val = hmap%r3d(ix,iy,ic)
              if (abs(val-hmap%gil%bval).gt.hmap%gil%eval) then
                spectrum(ic,2) = spectrum(ic,2) + val
              endif
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    else
      !$OMP PARALLEL DEFAULT(none)                 &
      !$OMP & SHARED(nchan,box,hmap,spectrum,mask) &
      !$OMP & PRIVATE(ix,iy,ic,val)
      !$OMP DO 
      do ic=1,nchan
        do iy=box(2),box(4)
          do ix=box(1),box(3)
            if (mask(ix,iy)) then
              val = hmap%r3d(ix,iy,ic)
              spectrum(ic,2) = spectrum(ic,2) + val
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    endif
  else
    if (all(box.eq.0)) then
      kxy = nx*ny
      ! This is in principle already parallelized
      do ic = 1,nchan
        call gr4_mean(hmap%r3d(:,:,ic),hmap%gil%dim(1)*hmap%gil%dim(2),  &
          & hmap%gil%bval,hmap%gil%eval,spectrum(ic,2)) 
      enddo
    else
      kxy = (box(4)-box(2)+1)*(box(3)-box(1)+1)
      !
      if (hmap%gil%eval.ge.0.0) then
        !$OMP PARALLEL DEFAULT(none)            &
        !$OMP & SHARED(nchan,box,hmap,spectrum) &
        !$OMP & PRIVATE(ix,iy,ic,val)
        !$OMP DO
        do ic=1,nchan
          do iy=box(2),box(4)
            do ix=box(1),box(3)
              val = hmap%r3d(ix,iy,ic)
              if (abs(val-hmap%gil%bval).gt.hmap%gil%eval) then
                spectrum(ic,2) = spectrum(ic,2) + val
              endif
            enddo
          enddo
        enddo
        !$OMP END DO
        !$OMP END PARALLEL
      else
        !$OMP PARALLEL DEFAULT(NONE)            &
        !$OMP & SHARED(nchan,box,hmap,spectrum) &
        !$OMP & PRIVATE(ix,iy,ic)
        !$OMP DO
        do ic=1,nchan
          do iy=box(2),box(4)
            do ix=box(1),box(3)
              spectrum(ic,2) = spectrum(ic,2) + hmap%r3d(ix,iy,ic)
            enddo
          enddo
        enddo
        !$OMP END DO
        !$OMP END PARALLEL
      endif
    endif
  endif
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  write(chain,'(a,f9.2,a)') 'Finished Building Spectrum ',elapsed
  !$  call map_message(seve%i,cname,chain)
  !
  spectrum(:,3) = spectrum(:,2)
  !
  if (nhist.gt.1) then
    !
    ! Find out the line free regions
    call clip_lineregions(cname,spectrum(:,3),mchan,mhist,  &
      & hcont%gil%bval,hcont%gil%eval,clip_value,debug,0.0,1.0)
    nb = 0
    call guess_lineregions(spectrum(:,3),mchan,       &
      & hcont%gil%bval,hcont%gil%eval,            &
      & mylines,nb)
    !
    ! Expand line regions by continuity
    inb = nb
    iextent = 8
    call clip_expand(hmap%gil%dim(3),mylines,inb,oulines,nb,iextent)
    !
    ! These are the line-contaminated channels
    do ib=1,nb
      spectrum(oulines(ib),4) = 1
    enddo
  endif
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  write(chain,'(a,f9.2,a)') 'Finished Defining Windows',elapsed
  !$  call map_message(seve%i,cname,chain)
  !
  ! Compute the continuum image 
  kc = 0
  do ic=1,nchan
    if (spectrum(ic,4).ne.0) cycle ! Skip the Line Contaminated channels
    kc = kc+1
    if (kc.eq.1) then
      hcont%r2d = hmap%r3d(:,:,ic)
    else
      rmask => hmap%r3d(:,:,ic)
      if (hmap%gil%eval.ge.0) then
        !$OMP PARALLEL SHARED(hcont,rmask,hmap) &
        !$OMP & PRIVATE(ix,iy)
        !$OMP DO COLLAPSE(2)
        do iy=1,hmap%gil%dim(2)
          do ix=1,hmap%gil%dim(1)
            if ((abs(rmask(ix,iy)-hmap%gil%bval).gt.hmap%gil%eval).and. &
            &   (abs(hcont%r2d(ix,iy)-hmap%gil%bval).gt.hmap%gil%eval) ) &
            & hcont%r2d(ix,iy) = hcont%r2d(ix,iy) + rmask(ix,iy)
          enddo
        enddo
        !$OMP END DO
        !$OMP END PARALLEL
      else
        !$OMP PARALLEL SHARED(hcont,rmask,hmap) &
        !$OMP & PRIVATE(ix,iy)
        !$OMP DO COLLAPSE(2)
        do iy=1,hmap%gil%dim(2)
          do ix=1,hmap%gil%dim(1)
            hcont%r2d(ix,iy) = hcont%r2d(ix,iy) + rmask(ix,iy)
          enddo
        enddo
        !$OMP END DO
        !$OMP END PARALLEL
      endif
    endif
  enddo
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  write(chain,'(a,f9.2,a)') 'Finished Computing Continuum',elapsed
  !$  call map_message(seve%i,cname,chain)
  !
  if (kc.ne.0) then
    where (abs(hcont%r2d-hcont%gil%bval).gt.hcont%gil%eval) hcont%r2d = hcont%r2d/kc
    hcont%gil%rms = hmap%gil%rms /sqrt(real(kc))
    hcont%gil%noise = hmap%gil%noise /sqrt(real(kc))
  endif
  !
  ! Return the number of pixels here. It will serve
  ! to normalize the spectrum after that.
  spectrum(:,4) = kxy*spectrum(:,4)
end subroutine global_continuum
!
subroutine local_continuum(i_code,hmap,hcont,spectrum,error,rms,box,mask)
  !$ use omp_lib
  use use_continuum
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => local_continuum
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  !   IMAGER --  Support for command  
  !     MAP_CONTINUUM /METHOD GAUSS|SCM|c-SCM [Threshold]
  !
  !     Support routine to derive the continuum image, pixel per pixel
  !   The noise is no longer space-invariant, but the the_method is able to
  !   identify weak continuum sources in the presence of strong, spectrally
  !   confused sources.
  !
  !
  !   Several methods are available:  
  !   -  A Gaussian fitting the_method   
  !     This method is a variant of the Sigma Clipping Median, 
  !   that works if there is no strong confusion. It avoids re-computing
  !   median (a slow operation) by taking into account that in this
  !   case, the mean value can be found by fitting a parabola 
  !   in the histogram of the channel values. The fit is made stable
  !   against outliers by adjusting the Min Max of the histogram
  !   so that the parabolic fit converges. 
  !     This is the the_method used in UV_PREVIEW
  !   
  !   -  SCM and c-SCM (corrected Sigma Clipping Median), as in 
  !      the CASA plugin STATCONT
  !
  !   -  That of Jordan Mollet et al 2018  
  !     Fit an Exponentially modified Gaussian function
  !     to the Histogram of intensity values for all channels. Still not
  !     implemented, though.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: i_code           !! Code of the_method
  type(gildas), intent(in) :: hmap        !! Input line data cube
  type(gildas), intent(inout) :: hcont    !! Output continuum image
  real, intent(out) :: spectrum(:,:)      !! Output spectrum
  logical, intent(out) :: error           !! Logical error flag
  real, intent(in) :: rms                 !! Expected RMS (from theoretical noise)
  integer(kind=4), intent(in) :: box(4)   !! Bounding box of mask
  logical, intent(in), optional :: mask(:,:)    !! Optional mask
  !
  ! Constants
  real, parameter :: sec_to_rad = acos(-1.0)/3600/180
  integer, parameter :: max_count=4 ! < 8 for sure
  integer, parameter :: i_gauss=2, i_scm=3, i_egm=4, i_cscm=5
  character(len=*), parameter :: rname='GAUSS'
  !
  ! Local ---
  real, allocatable :: array(:,:), noises(:,:)
  real, allocatable :: temp(:), tmp(:)
  real, allocatable :: hist(:,:), logv(:), logf(:)
  integer :: ier, nx,ny,nc,ix,jy,jc
  integer :: nchan
  integer(kind=index_length) :: mchan
  !
  integer :: mloc(2), count, mhist, i, nxy, kc, mxy, next, percentage_step
  real :: a,b,c,d, amin, amax, arms, amed, aoff, mu, peak, sigma, val
  character(len=64) :: ch, mess
  !
  real :: bval, eval, blank, brms, crms, noise, tnoise
  logical :: goon, outside_mask
  logical :: debug, corrected, do_mask, gbl_error, old_debug
  !
  integer :: jmin,jmax, imin,imax, code
  integer :: ihollow, iout, ilong, inone, ndata, npos, nneg
  integer :: ithreads, mthreads
  logical :: omp_nested = .false.
  !
  ! Code ----
  mcount = 8
  call sic_get_inte('COUNTS',mcount,error)
  logwings = 3.5
  call sic_get_real('WINGS',logwings,error)
  !
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)
  if ((i_code.eq.i_gauss).and.(.not.debug)) then
    call map_message(seve%w,rname,'Method GAUSS is still experimental, and may loop forever',1)
  endif
  !
  percentage_step = 10.
  nx = hmap%gil%dim(1)
  ny = hmap%gil%dim(2)
  nchan = hmap%gil%dim(3)
  mchan = nchan
  nc = hmap%gil%dim(3)
  !
  mhist = nhist 
  !
  allocate(array(nx,ny), noises(nx,ny), temp(nc), tmp(nc), hist(mhist,2), logv(mhist), logf(mhist), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  spectrum = 0.0
  do kc=1,nchan
    spectrum(kc,1) = (kc-hmap%gil%ref(3))*hmap%gil%vres + hmap%gil%voff
  enddo
  !
  ! RMS is the expected RMS noise
  ! We could check that it is actually reached outside of the
  ! area to be analyzed in a first pass..
  !
  imin = box(1)
  imax = box(3)
  jmin = box(2)
  jmax = box(4)
  !
  blank = hmap%gil%rmin
  if (blank.gt.0) then
    bval = -2.0*blank
    eval = blank
  else if (blank.lt.0) then
    bval = 3.0*blank
    eval = -blank
  else
    bval = -1.0
    eval = 0.0
  endif
  write(ch,'(A,1PG11.3,1X,1PG11.3)') '/BLANK ',bval,eval 
  !
  array = bval
  !
  i = 0
  nxy = 0
  ihollow = 0
  iout = 0
  ilong = 0
  inone = 0
  tnoise = 0.
  do_mask = present(mask)
  gbl_error = .false.
  mxy = (jmax-jmin+1)*(imax-imin+1)
  !
  next = imax-imin+1
  !$ mthreads = omp_get_max_threads()
  !$ ithreads = 1
  !$ call ompset_thread_nesting(rname, mthreads, ithreads, omp_nested)
  call progress_report('Computing',1,next,mxy,percentage_step)
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED (hmap,array,noises,mask, spectrum, percentage_step) &
  !$OMP & SHARED (jmin,jmax,imin,imax,do_mask,nchan,i_code,bval,eval,thremu,rms) &
  !$OMP & SHARED (logwings, debug, nhist, mhist, mcount, mchan, ch, i, next) & 
  !$OMP & SHARED (mxy, nxy, ihollow, iout, ilong, inone, tnoise, gbl_error) &
  !$OMP & PRIVATE(val,amin,amax,arms,aoff,amed,goon,count,corrected,code, error) &
  !$OMP & PRIVATE(ix,jy,outside_mask,kc,jc,a,b,c,d,mu,sigma,mloc,noise) &
  !$OMP & PRIVATE(npos, nneg, ndata, peak, brms, crms) &
  !$OMP & PRIVATE(temp,tmp,hist,logv,logf, old_debug)
  !$OMP DO COLLAPSE(2) REDUCTION(+:ihollow,iout,ilong,inone,tnoise) 
  do jy=jmin,jmax
    do ix=imin,imax
      !$OMP CRITICAL 
      if (debug) Print *,'Start IX IY ',ix,jy,' Error ',gbl_error
      !! if (gbl_error) cycle
      !$OMP END CRITICAL
      !
      ! Test if inside or outside the mask
      outside_mask = .false.
      if (do_mask) then
        outside_mask = .not.mask(ix,jy)
      endif
      !
      ! Ignore if outside
      if (outside_mask) cycle
      !
      error = .false. 
      !
      ! Get the spectrum
      if (debug) Print *,'Getting new NXY at ',ix,jy
      temp(:) = hmap%r3d(ix,jy,:)
      noise = 0
      !
      ! increment the integrated spectrum "On-the-Fly"
      !$OMP CRITICAL
      nxy = nxy+1
      !$OMP END CRITICAL
      if (debug) Print *,'Got NXY ',nxy
      do kc=1,nchan
        val = hmap%r3d(ix,jy,kc)
        if (abs(val-hmap%gil%bval).gt.hmap%gil%eval) then
          spectrum(kc,2) = spectrum(kc,2) + val     ! Worry in Parallel mode, see GLOBAL code
        endif
      enddo
      !
      amed = 0
      !
      select case(i_code)
      case (i_gauss)
        old_debug = .false.
        noise = 0
        call medgauss (temp,nchan,bval,eval,aoff, &
          & debug,code,ndata,noise, rms)
        if (old_debug.neqv.debug) then
          Print *,'Debug change at ',ix,jy
        endif
        !
        !!Print *,'Code OK ',code,code_ok,' Aoff ',aoff
        if (code.eq.code_hollow) then
          ihollow = ihollow+1
          ndata = 0
          noise = 0
        else if (code.eq.code_void) then
          ndata = 0
          noise = 0
          inone = inone+1
        else if (code.eq.code_empty) then
          noise = 0
          ilong = ilong+1
        else
          ! Correct for the Offset
          amed = amed+aoff
          !
        endif
        if (noise.ne.noise) Print *,'NXY ',nxy,' NDATA ',ndata,' Noise ',noise,' Amed ',amed,' IX JY ',ix,jy,' Code ',code
      case (i_scm,i_cscm)
        !
        ! Define the Histogram range around the median
        goon = .true.
        brms = rms
        crms = 0.1*rms
        count = 0
        amed = 0
        do while (goon)
          call median_filter (temp,mchan,bval,eval,aoff,amin,amax,arms,thremu)
          if (debug) print *,' Amin ',amin,', Amax ',amax,', Aoff ',aoff,' RMS ',rms, arms
          goon = (amin.lt.amax)     ! Protect against fully constant data (0 in models...)
          goon = goon .and. abs(arms-brms).gt.crms
          brms = arms
          crms = 0.1*brms
          count = count+1
          if (count.gt.mcount) then
            ilong = ilong+1
            goon = .false.
          endif
          amed = amed+aoff
        enddo
        !
        ! Evaluate the noise on the continuum - How many data points ?
        temp(:) = hmap%r3d(ix,jy,:) - amed
        tmp = 0
        where(temp.gt.amax) tmp = 1.0
        npos = sum(tmp)
        tmp = 0
        where (temp.lt.amin) tmp = 1.0
        nneg = sum(tmp)
        ndata = nchan-npos-nneg
        noise = arms/sqrt(max(ndata-1.0,1.0))
        !
        ! Debias by % of Positive or Negative outliers
        if (i_code.eq.i_cscm) then
          tmp = 0
          where(temp.gt.arms) tmp = 1.0
          npos = sum(tmp)
          !
          tmp = 0
          where(temp.lt.-arms) tmp = 1.0
          nneg = sum(tmp)
          !
          if ( & 
            & ( (nneg.gt.0.33*ndata) .and. (npos.le.0.33*ndata) .and. ((nneg-npos).gt.0.25*ndata) ).or. &
            & ( (nneg.gt.0.33*ndata) .and. (npos.gt.0.33*ndata) .and. ((nneg-npos).gt.0.25*ndata) ) &
            & ) then
            ! Case A, absorption dominated 
            amed = amed+noise
          else if ( &
            & ( (nneg.gt.0.33*ndata) .and. (npos.le.0.33*ndata) .and. ((nneg-npos).le.0.25*ndata) ) &
            & ) then
            ! Case B, slightly absorption dominated
            amed = amed+0.5*noise
          else if ( &
            & ( (npos.gt.0.33*ndata) .and. (nneg.le.0.33*ndata) .and. ((npos-nneg).le.0.25*ndata) ) &
            & ) then
            ! Case C, slightly emission dominated
            amed = amed-0.5*noise
          else if ( & 
            & ( (npos.gt.0.33*ndata) .and. (nneg.le.0.33*ndata) .and. ((npos-nneg).gt.0.25*ndata) ).or. &
            & ( (npos.gt.0.33*ndata) .and. (nneg.gt.0.33*ndata) .and. ((npos-nneg).gt.0.25*ndata) ) &
            & ) then
            ! Case D, emission dominated
            amed = amed-noise
          endif
        endif
      case (i_egm)
        error = .true.
        amed = 0
      end select
      ! OK, we got the Histogram, now we can analyze it
      ! hist(:,2) are the values of flux in the various channels
      ! hist(:,1) are the number of channels with these values
      !
      ! Now we can fit the distribution by some analytic function
      ! to find out the most likely value, i.e. the "continuum" flux
      !
      ! Depending on the SkewNess, this function can be a Gaussian
      ! or a much more complex one
      if (amed.ne.amed)  then
        Print *,'NaN at ',ix,jy
        amed = 0
      endif
      array(ix,jy) = amed
      if (noise.eq.noise) then
        noises(ix,jy) = noise
        tnoise = tnoise+noise
      else
        Print *,'Invalid noise ',noise,' at ',ix,jy
      endif
      !
      if (sic_ctrlc()) error = .true.
      if (error) gbl_error = .true.
      !$OMP CRITICAL
!TEST!      if (debug) print *,'NXY ',nxy,' Next ',next,' MXY ',mxy
      call progress_report(' ',nxy,next,mxy,percentage_step)
!TEST!      if (debug) print *,'End progress report '
      !$OMP END CRITICAL
      if (debug) Print *,'End IX ',ix
    enddo ! IX
  enddo ! JY
  !$OMP END DO
  !$OMP END PARALLEL
  write(6,'(A)') '...  Done.'
  !
  ! Interpolate blanked pixels ?
  error = .false.
  hcont%r2d = 0
  where(array.ne.bval) hcont%r2d  = array
  hcont%gil%blan_words = 2
  !
  spectrum(:,3) = spectrum(:,2)
  spectrum(:,4) = 0
  !
  if (ihollow.ne.0) then
    write(mess,'(A,I0,A)') 'Corrected ',ihollow,' Pixels with hollow histograms'
    call map_message(seve%w,rname,mess,3)
  endif
  if (iout.ne.0) then
    write(mess,'(A,I0,A)') 'Corrected ',iout,' Pixels with out of range solutions'
    call map_message(seve%w,rname,mess,3)
  endif
  if (ilong.ne.0) then
    write(mess,'(A,I0,A)') 'Found ',ilong,' Pixels with non converged median'
    call map_message(seve%w,rname,mess,3)
  endif
  if (inone.ne.0) then
    write(mess,'(A,I0,A)') 'Found ',inone,' Pixels with no data'
    call map_message(seve%w,rname,mess,3)
  endif
  !
  hcont%gil%noise = hcont%gil%noise /sqrt(nchan-1.0)
  if (nxy.ne.0) then
    tnoise = tnoise/nxy
    hcont%gil%rms = tnoise
  else
    hcont%gil%rms = 0
  endif
  !
end subroutine local_continuum
!  
subroutine comp_r4_shape_blank (x,n,mean,rms,skew,vblank4,eblank4)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private-mandatory 
  !*
  ! IMAGER --  Compute Mean, Rms and Skewness of an array  
  ! Protected against NaNs and Using Blanking Values. 
  !
  ! If Blanking is enabled, will return blanking value if no valid result. 
  ! If Blanking is not enabled, will return NaN if no valid result.
  !!
  !---------------------------------------------------------------------
  real(4),          intent(in)  :: x(*)  
  !! Input data values 
  integer(kind=size_length), intent(in)  :: n     
  !! Number of data values
  real(4),          intent(out) :: mean  
  !! Output mean value
  real(4),          intent(out) :: rms   
  !! Output root mean square
  real(4),          intent(out) :: skew  
  !! Output skewness 
  real(4),          intent(in)  :: vblank4 
  !! Blanking value
  real(4),          intent(in)  :: eblank4
  !! Blanking tolerance. If < 0, no blanking
  !
  ! Local
  integer(kind=size_length) :: i,count
  real(4) :: s0,s1,s2,y,z, num
  !
  !TEST!Print *,'N ',n,' Bval ',vblank4,eblank4
  mean = vblank4
  rms = 0.
  skew = 0.
  if (n.lt.1) return
  !
  s0 = 0.
  s1 = 0.
  s2 = 0.
  count = 0
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.ge.0) then
        if (abs(x(i)-vblank4).gt.eblank4) then
          s0 = s0+x(i)
          count = count+1
        endif
      else
        s0 = s0+x(i)
        count = count+1
      endif
    endif
  enddo
  if (count.gt.0) then
    s0 = s0/dble(count)
  else
    mean = vblank4
    return
  endif
  !
  ! Note philosophique: Count is the same in the 2 loops
  do i = 1,n
    if (x(i).eq.x(i)) then
      if (eblank4.lt.0) then
        y = x(i)-s0
        z = y*y
        s1 = s1 + z 
        s2 = s2 + z*y
      else
        if (abs(x(i)-vblank4).gt.eblank4) then
          y = x(i)-s0
          z = y*y
          s1 = s1 + z 
          s2 = s2 + z*y
        endif
      endif
    endif
  enddo
  num = real(count)
  s1 = s1/(num-1)
  rms = sqrt (s1)
  !
  s2 = s2/num
  ! Correct for sample size
  skew = s2/(rms*rms*rms)*sqrt(num*(num-1))/(num-2)
end subroutine comp_r4_shape_blank
!
function continuum_emg(x, amp, mu, sig, lamb)
  !! IMAGER -- Implementation of an Exponentially modified Gaussian function
  real(4) :: continuum_emg ! intent(out)
  real(4), intent(in) :: x
  ! Input value
  real(4), intent(in) :: amp 
  !! Amplitude of function
  real(4), intent(in) :: mu  
  !! Position
  real(4), intent(in) :: sig 
  !! Width
  real(4), intent(in) :: lamb 
  !! Exponential factor
  !
  continuum_emg = &
  & amp*exp(lamb*(2.*mu+lamb*sig*sig-2.*x)/2.)*(1.-erf((mu+lamb*sig*sig-x)/(sqrt(2.)*sig)))
end function continuum_emg
!
function continuum_gauss(x, amp, mu, sig)
  real(4) :: continuum_gauss ! intent(out)
  !! IMAGER -- Implementation of a Gaussian function 
  real(4), intent(in) :: x
  ! Input value
  real(4), intent(in) :: amp 
  !! Amplitude of function
  real(4), intent(in) :: mu  
  !! Position
  real(4), intent(in) :: sig 
  !! Width
  !
  continuum_gauss = amp*exp(-0.5*((x-mu)/sig)**2)
end function continuum_gauss
!
subroutine get_logv(logv,logwings,temp,nchan,hist,nhist,mcount,amin,amax,bval,eval)
  use gildas_def
  !-------------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command MAP_CONTINUUM 
  !
  !   Derive the histogram of the intensity distribution
  !   and make sure its logarithm is suitable for Gaussian fitting 
  !   (i.e. of parabolic shape)
  !!
  !-------------------------------------------------------------------------
  integer, intent(in) :: nchan  
  !! Number of data points
  integer, intent(in) :: nhist                    
  !! Number of histogram bins
  real, intent(out) :: logv(nhist)                
  !! Log of bin contents
  real, intent(in) :: logwings                    
  !! Truncation threshold
  real, intent(in) :: temp(nchan)                 
  !! Data points
  real, intent(out) :: hist(nhist,2)              
  !! Histogram
  real, intent(out) :: amin, amax                 
  !! Range of selected values
  real, intent(in) :: bval             
  !! Blanking value
  real, intent(in) :: eval                  
  !! Blanking tolerance
  integer, intent(in) :: mcount                   
  !! Maximum number of loops
  !
  integer :: code                  ! Operation code
  !
  ! Derive histogram
  call my_histo44(temp,nchan,hist,nhist,2,amin,amax,bval,eval)  
  !
  ! Verify its shape
  code = 0
  call check_logv(logv,logwings,temp,nchan,hist,nhist,amin,amax,bval,eval,mcount,code)
end subroutine get_logv
!
subroutine check_logv(logv,logwings,temp,nchan,hist,nhist,amin,amax,bval,eval,mcount,code)
  use gildas_def
  !-------------------------------------------------------------------------
  ! @ private
  !   IMAGER
  !     Support for command MAP_CONTINUUM 
  !
  !   Make sure its logarithm of the Intensity distribution histogram
  !   is suitable for Gaussian fitting  (i.e. of parabolic shape)
  !   Re-adjust range and (optionally) recompute histogram if needed.
  !-------------------------------------------------------------------------
  integer, intent(in) :: nchan  
  !! Number of data points
  integer, intent(in) :: nhist                    
  !! Number of histogram bins
  real, intent(out) :: logv(nhist)                
  !! Log of bin contents
  real, intent(in) :: logwings                    
  !! Truncation threshold
  real, intent(in) :: temp(nchan)                 
  !! Data points
  real, intent(out) :: hist(nhist,2)              
  !! Histogram
  real, intent(out) :: amin, amax                 
  !! Range of selected values
  real, intent(in) :: bval             
  !! Blanking value
  real, intent(in) :: eval                  
  !! Blanking tolerance
  integer, intent(in) :: mcount                   
  !! Maximum number of loops
  integer, intent(inout) :: code                  
  !! Operation code
  !
  ! Local ---
  integer :: jh,lh,kh,nh,mloc(2), jcount
  real :: logbase, val
  !
  ! Code ----
  ! Protect against empty Histogram
  if (sum(hist(:,1)).eq.0) then
    code = -1
    return
  endif
  !TEST!  if (code.eq.0)  Print *,'Histogram ',sum(hist(:,1)),hist(:,1)
  !
  ! Verify Histogram shape - Ignore outliers beyond the main peak
  ! Log of a Gaussian is a parabola
  logv(:) = log(hist(:,1)+1.0)           ! Bias by 1 to avoid Log(0)
  logbase = maxval(logv)-logwings        ! Truncate wings
  where (logv.lt.logbase) logv=0.0
  !
  jcount = 1
  !
  do while (jcount.lt.2)
    mloc = maxloc(logv,1) 
    nh = mloc(1)
    kh = 1
    do jh=nh,1,-1
      if (logv(jh).eq.0) then
        kh = jh+1
        exit
      endif
    enddo
    lh = nhist
    do jh=nh,nhist,1
      if (logv(jh).eq.0) then
        lh = jh-1
        exit
      endif
    enddo
    !
    if (code.eq.0) then
!TEST!      Print *,'LOGV ',jcount,' KH ',kh,' LH ',lh
      if ((kh.gt.1) .or. (lh.lt.nhist)) then
        ! Histogram is too peaked,
        !   Restrict range to avoid outliers
        amin = hist(kh,2)
        amax = hist(lh,2)
!TEST!        Print *,'New Amin ',amin,' Amax ',amax
        call my_histo44(temp,nchan,hist,nhist,2,amin,amax,bval,eval)  
!TEST!        Print *,'Histo New Amin ',amin,' Amax ',amax
        logv(:) = log(hist(:,1)+1.0)           ! Bias by 1 to avoid Log(0)
        logbase = maxval(logv)-logwings        ! Truncate wings
        where (logv.lt.logbase) logv=0.0
        jcount = jcount+1
        if (jcount.eq.mcount) then
          if (any(logv.eq.0)) code = -1
          exit
        endif
      else 
        exit    ! Converged histogram
      endif
    else 
      if ((kh.eq.1).or.(lh.eq.nhist)) then 
        ! Histogram is too flat - Just extend range to a symmetric interval
        val = max(-amin,amax)
        amin = -val
        amax = val
        code = -1
        exit
      endif
      jcount = jcount+1
    endif
  enddo
  !
  if (kh.eq.lh) then
    ! 
    ! Keep 5 bins
    code = -1 
    kh = max(1,kh-2)
    lh = min(kh+5,nhist)
    amin = hist(kh,1)
    amax = hist(lh,1)
    !TEST! Print *,'Histogram ',hist(:,1)
    !TEST! read(5,*) amin,amax
  endif
  !
end subroutine check_logv
!
subroutine debug_plot(ix,jy,nhist,hist,logv,logf,nchan,temp, i, ch)
  use gildas_def
  use gkernel_interfaces
  !-------------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Debug routine for command MAP_CONTINUUM 
  !
  !   Create a graphic display of spectra whose noise distribution
  !   cannot be well fit by a Gaussian.
  !-------------------------------------------------------------------------
  integer, intent(in) :: ix,jy
  integer, intent(in) :: nhist
  integer, intent(in) :: nchan
  real, intent(in) :: temp(nchan)
  real, intent(in) :: hist(nhist,2), logv(nhist), logf(nhist)
  integer, intent(inout) :: i
  character(len=*) :: ch
  !
  character(len=64) :: st
  real(4) :: spec(nchan)
  integer :: j
  !
  do j=1,nchan
    spec(j) = j
  enddo
  call gr_exec('CLEAR')
  !
  call gr4_give('X',nchan,spec)
  call gr4_give('Y',nchan,temp)
  call gr_exec('SET BOX  16 26 4 18')
  call gr_exec('LIMITS '//ch)
  call gr_exec('BOX')
  call gr_exec('HISTO')
  !
  call gr_exec('SET BOX 4 12 4 18')  
  write(st,'(A,I0,A,I0,A)') '"IX ',ix,'  IY ',jy,'"'
  call gr4_give('X',nhist,hist(:,2))
  call gr4_give('Y',nhist,logv)
  call gr_exec('LIMITS')
  call gr_exec('BOX')
  call gr_exec('HISTO')
  call gr4_give('Y',nhist,logf)
  call gr_exec('CONNECT')
  call gr_exec('DRAW TEXT 0 1 '//trim(st)//' /CHAR 8') 
  if (i.eq.0) then
    write(*,*) 'Enter an integer to continue (0 Question, 1 Ignore next, -1 abort'
    read(5,*) i
  endif
end subroutine debug_plot
!
subroutine my_histo44(a,na,b,nb,mb,min,max,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Build an histogram of values
  !
  !   Perform computations in a temporary integer array since float
  ! values can not be incremented by 1 beyond a given limit (16777216.
  ! for REAL*4). Use INTEGER*8 because number of values per bin can be
  ! larger than 2**31-1.
  !---------------------------------------------------------------------
  integer :: na   
  !! Number of values
  real*4 :: a(na)                   
  !! Values
  integer(kind=4) :: nb  
  !! Number of bins
  integer(kind=4) :: mb  
  !! Number of columns in Histogram 
  real(4) :: b(nb,mb)                
  !! Histogram array: Column 2 bin value, Column 1 number of elements
  real(4) :: min                     
  !! Minimum value
  real(4) :: max                     
  !! Maximum value
  real(4) :: bval                    
  !! Blanking value
  real(4) :: eval                    
  !! Blanking tolerance
  !
  ! Local
  real(4) :: step,v,hmin,hmax
  integer(kind=size_length) :: l,n
  integer(kind=8), allocatable :: ib(:) 
  !
  step=(max-min)/(nb-1)
  if (step.le.0) return ! Avoid big issues
  !
  allocate(ib(nb))
  ib = 0.
  hmin=min-step/2.0
  hmax=max+step/2.0
  !
  if (eval.lt.0.0) then
    do l = 1,na
      if (a(l).eq.a(l)) then
        if (a(l).ge.min .and. a(l).le.max) then
          v = (a(l)-hmin)/step
          n=int(v)+1
          ib(n) = ib(n)+1
        endif
      endif
    enddo
  else
    do l = 1,na
      if (a(l).eq.a(l) .and. (abs(a(l)-bval).gt.eval)) then
        if (a(l).ge.min .and. a(l).le.max) then
          v = (a(l)-hmin)/step
          n=int(v)+1
          ib(n) = ib(n)+1
        endif
      endif
    enddo
  endif
  !
  ! Now fill the histogram: counts and bin definitions
  do l=1,nb
    b(l,1) = ib(l)
    b(l,2) = min+(l-1)*step
  enddo
end subroutine my_histo44
!
subroutine medgauss (temp,nchan,bval,eval,aoff,debug,code,ndata,noise, rms)
  use use_continuum
  use gkernel_interfaces
  use imager_interfaces, except_this => medgauss
  ! @ private
  integer, intent(in) :: nchan        
  !! Number of channels
  real, intent(inout) :: temp(nchan)  
  !! Input spectrum
  real, intent(in) :: bval
  !! Blanking value
  real, intent(in) :: eval      
  !! Blanking tolerance
  real, intent(inout) :: aoff         
  !! Fitted value
  logical, intent(in) :: debug
  !! Debug control
  integer, intent(out) :: code        
  !! Return code
  integer, intent(out) :: ndata       
  !! Number of used data
  real, intent(out) :: noise          
  !! Noise estimate
  real, intent(in) :: rms             
  !! Initial guess of RMS
  !
  integer, parameter :: max_count=3
  !
  ! Local ---
  integer(kind=index_length) :: mchan
  integer :: count, mloc(2)
  real :: peak, sigma, mu
  real :: a,b,c,d
  real :: amed, amin,amax,arms
  logical :: corrected, goon, error
  integer :: i, lcode
  integer :: ix,jy ! Debug
  ! These are small automatic arrays
  real :: hist(nhist,2)
  real :: logv(nhist), logf(nhist)
  !
  ! Code ----
  code = code_ok
  count = 0
  error = .false.
  mchan = nchan
  !
  ! Define the Histogram range around the median
  call median_filter (temp,mchan,bval,eval,aoff,amin,amax,arms,thremu)
  if (debug) print *,'#1 Amin ',amin,', Amax ',amax,', Aoff ',aoff,' RMS ',rms, arms
  goon = (amin.lt.amax)     ! Protect against fully constant data (0 in models...)
  if (.not.goon) then
    aoff = amin
    arms = 0
    code = code_void !
    ndata = 0
    sigma = 0
    return
  endif
  !        
  if (rms.ne.0) then
    ! Protect against High S/N lines with both negative and positive features
    ! and against very inaccurate initial rms...
    if (arms.gt.3*rms) then
      amin = max(-3.0*sqrt(rms*arms),amin)
      amax = -amin
      if (debug) print *,'#2 Corrected amin amax ',amin,amax
    endif
  endif
  !
  amed = (amin+amax)/2.0
  sigma = arms    ! Get some initialization
  !
  ! Compute the histogram of channel values 
  !   Fit this histogram with a Gaussian
  !
  !   another way is to compute the histogram between the true Min and Max,
  ! and eliminate the values that contain less than about a few % of 
  ! the channels to recompute another Min - Max. In other words, ignore
  ! the first N % on one side, the last N % on the other side, by
  ! having the cumulative count, where N = 3-5 or so.
  !
  !   We combine here both the_methods, by ensuring that the histograms has no "holes" 
  ! before fitting. That helps to make the code more robust, and still fast.
  !
  corrected = .false.   ! Assume the the_method will work
  do while (goon) 
    if (debug) print *,'Count ',count
    !
    ! Make the histogram betweeen the current Min Max
    call my_histo44(temp,nchan,hist,nhist,2,amin,amax,bval,eval)  
    !TEST!    if (debug) print *,'#3 Done my_histo44 ',count
    ! Check it has no hole
    lcode = 0
    call check_logv(logv,logwings,temp,nchan,hist,nhist,amin,amax,bval,eval,mcount,lcode)
    if (debug) print *,'Done check_logv ',count
    if (lcode.ne.0) then
      amed = (amin+amax)/2   ! Cannot guess anything else
      if (debug) print *,'#4 Hollow Histogram ',count
      noise = 0
      code = code_hollow
      return
    endif
    !
    ! Apply Caruana algorithm : the Log of a Gaussian is a Parabola
    ! The small bias does not affect the result too much
    call fit_parabola(nhist,hist(1:nhist,2),logv,a,b,c,d)
    !TEST!    if (debug) print *,'#5 Done fit_parabola ',count
    !
    ! Now back to Gaussian characteristics
    if (c.ge.0) then
      if (debug) print *,'#5 A B C D ',a,b,c,d
      ! Means out of bound, either too small (flat histogram) or to broad  (1 pixel histogram)
      ! This should no longer happens, but play safe.
      !TEST!print *,' A B C D ',a,b,c,d,' at ',ix,jy
      !TEST!print *,minval(hist(:1:mhist,2)), maxval(hist(:1:mhist,2)),  amin, amax
      !TEST!print *,hist(1:mhist,2)
      if (d.gt.0) then    ! Histogram is too narrow, restrict range
        mloc = maxloc(hist,1)
        mu = hist(mloc(1),2)
        if (debug) Print *,'#6 Peaky histogram Pixel ',ix,jy,' Solution ',mu,' out of ',amin,amax
        !
        sigma = (amax-amin)/4.0
      else                ! Histogram is flat... Should either extend range of use value
        mu = hist(1,2)
        if (debug) Print *,'#7 Flat histogram  Pixel ',ix,jy,' Solution ',mu,' out of ',amin,amax
        sigma = -(amax-amin)/4.0
      endif
      d = 1.0   ! Force it "not converged"
      peak = 1. ! To have a value
    else
      ! There is a solution
      mu = -b/(2.0*c)             ! Position
      sigma = sqrt(-1.0/(2.0*c))  ! Sigma
      peak = exp(a-b**2/(4.0*c))  ! Intensity (biased)
      if (debug) print *,'#8 Normal mu ',mu,sigma,peak, d
      goon =.false.
    endif
    !
    ! Out of bound fit ...
    corrected = .false.
    if ((mu.gt.amax).or.(mu.lt.amin)) then
      goon = .true.
      corrected = .true.
      code = 1
      if (debug) Print *,'#9 Check LOGV ',mu,' Amin ',amin,' Amax ',amax
      if (debug) call debug_plot(ix,jy,nhist,hist,logv,logf,nchan,temp, i, ' ')
      call check_logv(logv,logwings,temp,nchan,hist,nhist,amin,amax,bval,eval,2,code)
      if (code.ne.1) then
        count = count+1     ! Was iout...
        if (debug) Print *,'#10 Min  Max reset to ',amin,amax,maxval(hist(1:nhist,2)), ' IX JY ',ix,jy
      endif
    endif
    !
    ! Treat the confusion case: the Gaussian  peak should be close to the maximum 
    ! of the Histogram - if not, this must be line contamination
    if (debug) Print *,'#11 Peak ',log(peak),' MaxVal ',maxval(logv),' D ',d
    !
    ! Now get the "continuum" value
    amed = mu                   ! Define the position of maximum 
    if (count.ge.max_count) then
      ! MAX_COUNT iterations, this is too much...
      goon = .false.      
      exit 
    else if (d.gt.0.25 .or. log(peak).lt.maxval(logv)-d) then
      if (debug) Print *,'#11 D ',d,' Logs ',log(peak),' > ', maxval(logv)-d
      ! If not converged, the Maximum can be wrong - iterate
      mloc = maxloc(hist,1)
      amed = hist(mloc(1),2)
      if (.not.corrected) then
        amin = amed-3.0*sigma  
        amax = amed+3.0*sigma
      endif
      if (debug) Print *,'#12 ', count,': Min ',amin,' Median ',aoff,' Max ',amax,' Rms ',sigma
      count = count+1
    else
      ! Converged, fitted...
      goon = .false.
    endif
    if (corrected.and.debug) then
      if (.not.goon) then
        logf(:) = a+b*hist(:,2)+c*hist(:,2)**2
        !TEST!Print *,'Calling DEBUG_PLOT ',ix,jy,nhist
        call debug_plot(ix,jy,nhist,hist,logv,logf,nchan,temp, i, ' ')
        if (i.eq.-1) then
          error = .true.
        endif
      endif
    endif
  enddo   ! GOON
  ! Evaluate the noise
  ndata = sum(hist(1:nhist,1))
  if (ndata.gt.1) then
    noise = sigma/sqrt(ndata-1.0)
    code = code_ok
  else
    noise = 0
    code = code_empty
  endif
  !
end subroutine medgauss

!
subroutine init_fields(huvl,print,error)
  use gkernel_interfaces
  use image_def
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, only : load_fields, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- Support routine for the Sault et al Mosaicking method
  !
  ! Define the associated MOSAIC Table and load the Field coordinates
  ! (Pointing and Phases)
  !  
  ! Sault et al Mosaicking method.  
  !   See Sault, Staveley-Smith and Brouw
  !   A&A Supp Ser 120, 375-384 (1995)
  !
  ! The principle of the Sault & al Mosaicking technique is
  ! to minimize spatial distortion and intermediate image
  ! sizes by
  !   - limiting each pointing field to about 2-3 primary beams
  !   - and accordingly, limiting each individual dirty beam
  !     in the same way
  !   - properly reprojecting each pointing to the common tangent
  !     plane
  !   - phasing each pointing to the nearest pixel as a Phase center
  !
  ! For proper use, it must carry along the individual Pixel shifts
  ! for each field, and the fractional offset centers.
  !
  ! The gain in size can be substantial for Large mosaics.
  ! E.g. for a NxN square mosaic, about (N/4)^2
  ! A similar gain occurs in computation, since FFTs scale 
  !   as M log(M)
  ! This also shows that there is no need for this method for
  ! "small" mosaics, as the gain only start for 16 pointings
  ! at least.
  !
  ! Unfortunately, the Gildas Data Format does not easily accomodate
  ! a "pixel offset" compared to some reference.  This information can 
  ! readily be retrieved from an absolute coordinate difference,
  ! but there is no simple way to have it in e.g. a 3-D data cube
  ! of different pointings.
  
  ! This handling is done in the code, through the %MOS allocatable
  ! structure, a "pseudo-table" attached to the UV data header.
  !   This is done by a modification of the (internal) Gildas Data Format
  !   similar to the "Telescope" section or "Frequencies" section, in
  !   a "Mosaic" section with the relevant information, but not stored
  !   in data file.
  !
  ! The %MOS% structure contains the number of fields and for each field 
  ! a sub-structure of type "field_par"
  ! type :: field_par
  !  sequence
  !  !! Field characteristics, Pointing centers and related issues
  !  real(8) :: apoint(2)       !! RA and Dec of Pointing Centers
  !  real(8) :: aphase(2)       !! RA and Dec of Phase Centers
  !  real(4) :: opoint(2)       !! Pointing Offsets
  !  real(4) :: ophase(2)       !! Phase Offsets
  !  integer :: jxy(2)          !! Pixel Offsets
  !  real(4) :: oxy(2)          !! Fractional Phase Offset
  !  integer :: nvisi           !! Number of visibilities
  !  real :: sigma              !! Noise level
  ! end type field_par
  ! Offsets are derived from the absolute values when imaging, with a 
  ! given Pixel size and Mosaic center. This is done by the 
  ! MOSAIC_SET_HEADER routine. 
  !  
  ! If some of these informations were saved on disk with the Gildas Header, 
  ! the Mosaicked Image could then have a different size than the 
  ! Primary & Dirty beams. 
  !
  !   The SHOW FIELDS tool could use directly this information, 
  ! if it contains some idea of the Primary beam size, that could 
  ! also serve as checking facts (e.g. pixel sizes, Mosaic center)
  !
  !   When using this imaging mode, the UV table is modified to
  ! have a field ID column, rather than either the Phase or 
  ! Pointing offsets columns. Note that this mode can even
  ! handle simultaneously Pointing and Phase offsets columns
  ! in case they would differ.
  !
  !   This structure is closer to the UVFITS handling convention
  ! (AIPS or CASA "Pointing" table)
  !
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: huvl  !! UV Header
  logical, intent(in) :: print         !! Printout field coordinates ?
  logical, intent(inout) :: error      !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='POINTING'
  !
  ! Local ---
  integer :: ier
  !
  ! Code ----
  call imager_tree('INIT_FIELDS',.false.)
  error = .false.
  if (.not.allocated(duvi)) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  !
  ! 1) Set the TABLE
  if (allocated(huvl%mos%fields)) then
    deallocate(huvl%mos%fields,stat=ier)
    if (ier.ne.0) then 
      call map_message(seve%e,rname,'Mosaic Header Deallocation error') 
      error = .true.
      return
    endif
  endif
  !
  huvl%r2d => duv ! Pointer must be associated
  call load_fields(rname,huvl,abs(themap%nfields),error)
  if (error) return
  !
  mosaic_mode = 'SAULT'
  call imager_tree('INIT_FIELDS',.true.)
  !
end subroutine init_fields
!
subroutine load_fields(rname,huvl,mfi,error)
  use gkernel_interfaces
  use gkernel_types
  use clean_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER --   
  !     Scan a Mosaic UV data to find out the number of fields
  !     and their positions, and replace the corresponding columns
  !     by Fields ID numbers. 
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname       !! Calling command
  type(gildas), intent(inout) :: huvl         !! UV header & data 
  integer, intent(in) :: mfi                  !! Number of fields
  logical, intent(inout) :: error             !! Logical error flag
  ! 
  ! Local ---
  integer :: np                   ! Size of a visibility
  integer :: nv                   ! Number of visibilities
  integer :: ixoff,iyoff          ! X,Y Pointing pointer
  integer :: iloff,imoff          ! L,M Phase pointer
  integer :: ioff,joff            ! Actual offset pointer
  integer :: idoff                ! ID pointer
  integer :: itele                ! Telescope pointer
  integer :: iv, ier, ip
  integer :: ifi, kfi, nfi
  real(4), allocatable :: doff(:,:)
  real(8), allocatable :: poff(:,:), pabs(:,:)
  integer, allocatable :: dvis(:), jtel(:)
  type(projection_t) :: proj
  !
  logical :: debug
  !
  ! Code ----
  debug = .false.
  call sic_get_logi('DEBUG_MOSAIC',debug,error)
  error = .false.
  !
  ixoff = huvl%gil%column_pointer(code_uvt_xoff)
  iyoff = huvl%gil%column_pointer(code_uvt_yoff)
  iloff = huvl%gil%column_pointer(code_uvt_loff)
  imoff = huvl%gil%column_pointer(code_uvt_moff)
  idoff = huvl%gil%column_pointer(code_uvt_id)
  itele = huvl%gil%column_pointer(code_uvt_tele)
  !
  if ((ixoff*iyoff).ne.0) then
    ! Usual Pointing Offsets Mosaic. A Common Phase center
    ioff = ixoff
    joff = iyoff
    if (debug) Print *,'Point offset mosaic'
  else if ((iloff*imoff).ne.0) then
    ! Phase Offsets Mosaic. Pointing & Phase centers match.
    ioff = iloff
    joff = imoff
    if (debug) Print *,'Phase offset mosaic'
  else   
    if (idoff.eq.0) then
      call map_message(seve%e,rname,'Data is not a Mosaic')
      error = .true.
    else if (allocated(huvl%mos%fields)) then
      ! More checks needed (Number of fields at least ?) 
      ip = maxval(huvl%r2d(idoff,:))
      if (ip.ne.mfi) then
        call map_message(seve%e,rname,'Mosaic and Mosaic Header mismatch')
        error = .true.
      else
        call map_message(seve%w,rname,'Mosaic already has an associated Mosaic Header')
      endif
    else
      call map_message(seve%e,rname,'Mosaic with no associated Mosaic Header')
      error = .true.
    endif
    return
  endif
  !
  ! Re-use Ioff column if no ID column
  if (debug) then 
    if (allocated(huvl%mos%fields)) Print *,'HMOS allocated'
    Print *,'IDOFF ',idoff, ixoff,iyoff, size(huvl%r2d,1)
  endif
  if (idoff.eq.0) idoff = ioff
  if (allocated(huvl%mos%fields)) deallocate(huvl%mos%fields)
  !
  np = huvl%gil%dim(1)   ! Size of a visibility
  nv = huvl%gil%nvisi    ! Number of visibilities
  allocate(doff(mfi,2),dvis(mfi),jtel(mfi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'Allocation status ',associated(huvl%r2d)
  !
  ! Scan how many fields
  nfi = 1  
  doff(1,1) = huvl%r2d(ioff,1)
  doff(1,2) = huvl%r2d(joff,1)
  huvl%r2d(idoff,1) = nfi
  dvis(1) = 1
  jtel = 1
  if (itele.ne.0) jtel(1) = huvl%r2d(itele,1)  
  !
  if (debug) Print *,'Starting LOOP MFI ',mfi
  do iv=2,nv
    kfi = 0
    do ifi=1,nfi
      if (huvl%r2d(ioff,iv).eq.doff(ifi,1) .and. &
      & huvl%r2d(joff,iv).eq.doff(ifi,2) ) then
        if (itele.eq.0) then
          kfi = ifi
          huvl%r2d(idoff,iv) = ifi
          dvis(ifi) = dvis(ifi)+1          
          exit
        else
          if (huvl%r2d(itele,iv).eq.jtel(ifi)) then
            kfi = ifi
            huvl%r2d(idoff,iv) = ifi
            dvis(ifi) = dvis(ifi)+1
            jtel(nfi) = huvl%r2d(itele,iv)
            exit
          endif
        endif
      endif
    enddo
    !
    ! New field
    if (kfi.eq.0) then
      nfi = nfi+1
      doff(nfi,1) = huvl%r2d(ioff,iv)
      doff(nfi,2) = huvl%r2d(joff,iv)
      if (itele.ne.0) jtel(nfi) = huvl%r2d(itele,iv)
      huvl%r2d(idoff,iv) = nfi
      dvis(nfi) = 1
    endif
  enddo
  if (nfi.eq.1) then
    call map_message(seve%w,rname,'Degenerate mosaic with 1 field only')
    return
  endif
  !
  if (nfi.ne.mfi) Print *,'I am in trouble ...', nfi, mfi
  allocate(huvl%mos%fields(nfi),pabs(nfi,2),poff(nfi,2),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Mosaic Header Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'NFI ',nfi
  !
  poff(:,:) = doff(1:nfi,:)
  !
  ! Define the projection about the Tangent point
  call gwcs_projec(huvl%gil%a0,huvl%gil%d0,huvl%gil%pang,huvl%gil%ptyp,proj,error)
  call rel_to_abs (proj,poff(:,1),poff(:,2),pabs(:,1),pabs(:,2),nfi)
  if (debug) Print *,'Done rel_to_abs'
  !
  ! Also set the huvl%mos Mosaic Sub-header
  if (allocated(huvl%mos%fields)) deallocate(huvl%mos%fields)
  allocate(huvl%mos%fields(nfi),stat=ier)
  huvl%mos%nfields = nfi
  ! Store
  if ((iloff*imoff).ne.0) then
    ! A Pointing & Phase Centers match
    if (debug) Print *,'Case 1'
    do ip=1,nfi
      !
      huvl%mos%fields(ip)%apoint(1:2) = pabs(ip,1:2)
      huvl%mos%fields(ip)%aphase(1:2) = pabs(ip,1:2)
      huvl%mos%fields(ip)%opoint(1:2) = poff(ip,1:2)
      huvl%mos%fields(ip)%ophase(1:2) = poff(ip,1:2)
      huvl%mos%fields(ip)%nvisi = dvis(ip)
      huvl%mos%fields(ip)%jteles = mod(jtel(ip),100)
    enddo
    if (huvl%gil%column_pointer(code_uvt_id).eq.0) then
      huvl%gil%column_pointer(code_uvt_loff) = 0
      huvl%gil%column_pointer(code_uvt_moff) = 0
      huvl%gil%column_size(code_uvt_loff) = 0
      huvl%gil%column_size(code_uvt_moff) = 0
      huvl%gil%column_pointer(code_uvt_id) = ioff
      huvl%mos%fields(ip)%jteles = mod(jtel(ip),100)
    endif
  else
    if (debug) Print *,'Case 2'
    ! Phase Center was common
    ! A Pointing & Phase Centers match
    do ip=1,nfi
      !
      huvl%mos%fields(ip)%apoint(1:2) = pabs(ip,1:2)
      huvl%mos%fields(ip)%aphase(1:2) = [huvl%gil%a0,huvl%gil%d0]
      huvl%mos%fields(ip)%opoint(1:2) = poff(ip,1:2)
      huvl%mos%fields(ip)%ophase(1:2) = 0.
      huvl%mos%fields(ip)%nvisi = dvis(ip)
      huvl%mos%fields(ip)%jteles = mod(jtel(ip),100)
    enddo
    if (huvl%gil%column_pointer(code_uvt_id).eq.0) then
      huvl%gil%column_pointer(code_uvt_xoff) = 0
      huvl%gil%column_pointer(code_uvt_yoff) = 0
      huvl%gil%column_size(code_uvt_xoff) = 0
      huvl%gil%column_size(code_uvt_yoff) = 0
      huvl%gil%column_pointer(code_uvt_id) = ioff
      huvl%mos%fields(ip)%jteles = mod(jtel(ip),100)
    endif
  endif
  if (debug) Print *,'Nullifying offsets '
  do ip=1,nfi
    huvl%mos%fields(ip)%jxy = 0
    huvl%mos%fields(ip)%oxy = 0
  enddo
  deallocate(poff,pabs,dvis,doff)
  if (debug) Print *,'Deallocated arrays'
  !
  huvl%gil%column_size(code_uvt_id) = 1
  call imager_tree('LOAD_FIELDS',.true.)
  !
end subroutine load_fields
!
subroutine change_fields(rname,nfi,hmos,newabs,error)
  use gkernel_interfaces
  use gkernel_types
  use clean_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Change the associated Mosaic Table to a new Reference center
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname         !! Calling command
  integer, intent(in) :: nfi                    !! Number of fields
  type(field_par), intent(inout) :: hmos(:)     !! Mosaic Header
  real(8), intent(in) :: newabs(3)              !! Coordinates of center
  logical, intent(inout) :: error               !! Error flag
  !
  ! Local ---
  type(projection_t) :: proj
  real(8) :: ra(nfi), dec(nfi), offx(nfi), offy(nfi) ! Automatic arrays
  !
  ! Code ----
  !  
  ! Define the projection about the Projection center
  call gwcs_projec(newabs(1),newabs(2),newabs(3),p_azimuthal,proj,error)
  if (error) return
  !
  ra = hmos(:)%apoint(1)
  dec = hmos(:)%apoint(2)
  call abs_to_rel (proj,ra,dec,offx,offy,nfi)
  hmos(:)%opoint(1) = offx
  hmos(:)%opoint(2) = offy
  !
  ra = hmos(:)%aphase(1)
  dec = hmos(:)%aphase(2)
  call abs_to_rel (proj,ra,dec,offx,offy,nfi)
  hmos(:)%ophase(1) = offx
  hmos(:)%ophase(2) = offy
  !
end subroutine change_fields
!
subroutine fraction_fields(rname,hmos,map,mx,my,nx,ny,error)
  use gkernel_interfaces
  use gkernel_types
  use clean_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Change the associated Mosaic Header to a new Reference
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name (UV_MAP or MX)
  type (uvmap_par), intent(in) :: map      !! Map parameters
  type(field_par), intent(inout) :: hmos(:)     !! Mosaic header
  integer, intent(in) :: mx,my,nx,ny       !! Image sizes
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  real(8), parameter :: sec=180D0*3600d0/acos(-1D0)
  !
  ! Local ---
  integer :: if, nfield, idx, jdx, idy, jdy
  real(8) :: rdx, rdy, xinc, yinc
  !
  ! Code ----
  if (any(map%xycell.eq.0)) then
    call map_message(seve%e,rname,'Map cell not initialized')
    error = .true.
    return
  endif
  !
  ! This could be different between Phase & Pointing offsets tables ?
  nfield = abs(map%nfields)
  xinc =  -dble(map%xycell(1))              ! Sign is reversed along X
  yinc =  dble(map%xycell(2))
  do if=1,nfield
    idx = idnint(hmos(if)%opoint(1)/xinc)   ! X Pixel of the center
    rdx = hmos(if)%opoint(1)-idx*xinc       ! Offset of phase center (< 1 pixel)
    jdx = (mx-nx)/2+idx                     ! Pixel shift
    !
    idy = idnint(hmos(if)%opoint(2)/yinc)   ! Y Pixel of the center
    rdy = hmos(if)%opoint(2)-idy*yinc       ! Offset of phase center (< 1 pixel)
    jdy = (my-ny)/2+idy                     ! Pixel shift
    !
    hmos(if)%jxy(1)  = jdx
    hmos(if)%jxy(2)  = jdy
    hmos(if)%oxy(1)  = rdx
    hmos(if)%oxy(2)  = rdy
  enddo
end subroutine fraction_fields
!
subroutine sault_uv_change(nu,nv,visi,ap,dp,a0,d0)  
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Support for Mosaicking in the Sault et al approach
  !
  ! Figure out  
  !     (u)        (u_p)  
  !     ( )  = R2T (  )  
  !     (v)  =     (v_p)  
  ! 
  ! the re-projection matrix that transforms the
  ! original (u_p,v_p) coordinates relative to the
  ! delay tracking center into the appropriate
  ! (u,v) coordinates relative to the final projection center
  !
  ! See Sault, Staveley-Smith and Brouw
  ! A&A Supp Ser 120, 375-384 (1995)
  !
  !---------------------------------------------------------------------
  integer, intent(in) :: nu             !! Visibility size
  integer, intent(in) :: nv             !! Number of visibilities
  real(4), intent(inout) :: visi(nu,nv) !! Visibilities
  real(8), intent(in) :: ap, dp         !! The original phase/pointing center
  real(8), intent(in) :: a0, d0         !! The common projection center
  !
  ! Local ---
  real(8) :: a11, a21, a12, a22, detn
  integer :: iv
  real(8) :: up, vp
  !
  ! Code ----
  !
  ! The R2T matrix elements are
  ! - Determinant
  detn = 1.d0/(sin(d0)*sin(dp) + cos(ap-a0)*cos(dp)*cos(d0))
  ! - Coefficients,
  ! Normalized to appropriate determinant
  a11 = (cos(ap-a0)*sin(dp)*sin(d0)+cos(dp)*cos(d0))*detn
  a21 = -sin(ap-a0)*sin(d0)*detn
  a12 = sin(ap-a0)*sin(dp)*detn
  a22 = cos(ap-a0)*detn
  !
  do iv=1,nv
    up = visi(1,iv)
    vp = visi(2,iv)
    visi(1,iv) = up*a11 + vp*a21
    visi(2,iv) = up*a12 + vp*a22
  enddo
end subroutine sault_uv_change

!
subroutine cct_write(file,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for command  
  !   WRITE CCT File [/RANGE Start End Kind]
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: file  
  !! Input file name
  logical, intent(out) :: error         
  !! Error return code
  !
  ! Local ---
  type (gildas) :: hout, htmp
  integer :: mclean,ier,i,j
  logical :: new
  !
  ! Code ----
  error = .false.
  !
  ! Define the Output image header
  call gildas_null (hout, type = 'IMAGE')
  call gdf_copy_header (hcct,hout, error)
  !
  ! Count the actual number of components
  hout%file = file
  mclean = hout%gil%dim(3)
  do i=1,hout%gil%dim(3)
    if (all(dcct(:,:,i).eq.0)) then
      mclean = i-1
      exit
    endif
  enddo
  !
  ! Write data
  hout%blc = 0
  hout%trc = 0
  hout%gil%dim(3) = max(mclean,1)  ! At least one (possibly empty) component
  hout%loca%size = product(hout%gil%dim(1:3))
  !
  new = .false.
  call sic_get_logi('CCT_NEW',new,error)
  if (.not.new) then
    call gdf_write_image(hout,dcct(:,:,1:mclean),error)
    return
  endif
  call map_message(seve%w,'WRITE CCT','Writing transposed version (CCT_NEW = YES)')
  !
  call gildas_null(htmp,type='IMAGE')
  call gdf_transpose_header(hout,htmp,'1324',error)
  htmp%file = file 
  htmp%gil%dim(1) = 4
  allocate(htmp%r3d(htmp%gil%dim(1),htmp%gil%dim(2),htmp%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'WRITE CCT','Memory allocation error')
    error = .true.
    return
  endif
  do i=1,htmp%gil%dim(2) 
    do j=1,htmp%gil%dim(3)
      htmp%r3d(1:3,i,j) = dcct(:,j,i)
    enddo
  enddo
  call gdf_write_image(htmp,htmp%r3d,error)
  deallocate(htmp%r3d)
  !
end subroutine cct_write

subroutine cct_append(file,data,head,mgap,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  ! IMAGER - Support routine for WRITE CCT /APPEND
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: file    
  !! File name
  type(gildas), intent(inout) :: head     
  !! Header of buffer
  real(kind=4), intent(in) :: data(:,:,:) 
  !! Data
  integer, intent(in) :: mgap             
  !! Max Gap size
  logical, intent(inout) :: error         
  !! Error return flag
  !
  ! Local ---
  type(gildas) :: hall
  integer :: i, ier, mclean, imin, imax, igap
  real, allocatable :: dinp(:,:,:), dout(:,:,:)
  integer :: inchan, inclean, onchan, onclean
  !
  ! Code ----
  error = .false.
  !
  if (head%loca%size.eq.0) then
    call map_message(seve%e,'WRITE','CCT data undefined ')
    error = .true.
    return
  endif
  !
  ! Read old file header
  call gildas_null(hall, type='IMAGE')
  hall%file = file
  call gdf_read_header(hall,error)
  if (error) return
  !
  ! Check match with specified input set
  call gdf_match_header(head,hall,mgap,imin,imax,igap,error)
  if (error) then
    call gdf_close_image(hall,error)
    return
  endif
  !
  inclean = hall%gil%dim(3) ! Current Number of input Clean Component
  mclean = head%gil%dim(3)
  do i=1,head%gil%dim(3)
    if (all(dcct(:,:,i).eq.0)) then
      mclean = i-1
      exit
    endif
  enddo
  onclean = max(inclean,mclean) ! Number of clean components
  onclean = max(1,onclean)      ! At least 1 (possibly empty) component
  !
  ! Resize array to new dimension
  onchan = imax+igap
  inchan = hall%gil%dim(2)      ! Current number of channels
  allocate(dout(3,onchan,onclean), & 
    & dinp(hall%gil%dim(1),hall%gil%dim(2),hall%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'WRITE','Memory allocation error')
    call gdf_close_image(hall,error)
    error = .true.
    return
  endif
  !
  ! Set everything to Zero
  dout = 0.0
  ! Put old one in place
  hall%blc= 0
  hall%trc= 0
  call gdf_read_data(hall,dinp,error)
  dout(1:3,1:inchan,1:inclean) = dinp(:,:,:)
  deallocate(dinp)
  ! Close image
  call gdf_close_image(hall,error)
  ! Put new one in place  
  dout(1:3,imin+igap:onchan,1:mclean) = data(:,:,1:mclean)
  !
  ! Write everything
  hall%gil%dim(1:3) = [3,onchan,onclean]
  hall%blc = 0
  hall%trc = 0
  call gdf_write_image(hall,dout(:,:,:),error)
end subroutine cct_append
!
subroutine gdf_match_header(hinp,hout,mgap,imin,imax,igap,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Support routine for WRITE /APPEND  
  ! Verify axis compatibility and return first new channel. 
  ! The routine is generic for CCT and Cubes.
  !-------------------------------------------------------
  type(gildas), intent(in) :: hinp    
  !! CCT or Cube to be appended
  type(gildas), intent(in) :: hout    
  !! Output CCT or Cube
  integer, intent(in) :: mgap         
  !! Allowed Gap in channels
  integer, intent(out) :: igap        
  !! Actual Gap in channels
  integer, intent(out) :: imin        
  !! Start channel 
  integer, intent(out) :: imax        
  !! End channel
  logical, intent(out) :: error       
  !! Logical Error flag
  !
  ! Constants
  real(8), parameter :: tolerance=2d-7
  real(8), parameter :: epsilon=1d-5
  character(len=*), parameter :: rname='WRITE /APPEND'
  !
  ! Local ---
  character(len=128) :: chain
  integer :: faxi,xaxi,yaxi
  integer :: itmp
  real(8) :: velo, rval
  !
  ! Code ----
  faxi = hinp%gil%faxi
  if (faxi.ne.hout%gil%faxi) then
    call map_message(seve%e,rname,'Data set ordering does not match')
    error = .true.
    return
  endif
  error = .false.
  xaxi = hinp%gil%xaxi
  yaxi = hinp%gil%yaxi
  !
  ! At this stage, verify the consistency check
  ! (spectral resolution, pixel sizes, gap size)
  if ( any(hout%gil%convert(:,xaxi).ne.hinp%gil%convert(:,xaxi)) .or. &
    any(hout%gil%convert(:,yaxi).ne.hinp%gil%convert(:,yaxi)) ) then
    call map_message(seve%e,rname,'Positions do not match')
    Print *,'Hinp ',hinp%gil%convert(:,1:3)
    Print *,'Hout ',hout%gil%convert(:,1:3)
    Print *,'X Difference ',hinp%gil%convert(:,xaxi)-hout%gil%convert(:,xaxi)
    Print *,'Y Difference ',hinp%gil%convert(:,yaxi)-hout%gil%convert(:,yaxi)
    error = .true.
  endif
  !
  if (abs (abs(hinp%gil%inc(faxi))-abs(hout%gil%inc(faxi))) & 
    & .ge.tolerance*abs(hout%gil%inc(faxi)) ) then
    call map_message(seve%e,rname,'Frequency resolution do not match')
    error = .true.
  endif
  if (error) return
  !
  ! Check which range in the file is needed - Match the velocities
  velo = (1.d0-hinp%gil%ref(faxi))*hinp%gil%inc(faxi) + hinp%gil%val(faxi)
  rval = (velo-hout%gil%val(faxi))/hout%gil%inc(faxi) + hout%gil%ref(faxi)
  imin = nint(rval)
  !
  if (abs(dble(imin)-rval).gt.epsilon*abs(hinp%gil%inc(faxi))) then
    call map_message(seve%e,rname,'Frequency axis does not match')
    error = .true.
  endif
  if (error) return
  !
  ! Compute channel alignment
  velo = (hinp%gil%dim(faxi)-hinp%gil%ref(faxi))*hinp%gil%inc(faxi) + hinp%gil%val(faxi)
  rval = (velo-hout%gil%val(faxi))/hout%gil%inc(faxi) + hout%gil%ref(faxi)
  imax = nint(rval)
  if (imin.gt.imax) then
    itmp = imin
    imin = imax
    imax = itmp
  endif
  !
  ! Tolerate a 1 channel error overlap, but no big gap
  igap = imin - hout%gil%dim(faxi)
  if (igap.ne.0 .and. igap.ne.1) then
    Print *,'Dimensions ',hinp%gil%dim(faxi), hinp%gil%dim(faxi)+1, imin, imax
    write(chain,'(A,A,I0,A,I0)') 'CCT',' is not contiguous, starts at ',imin, &
      & ' current end at ',hinp%gil%dim(faxi)
    if (igap.gt.0.and.igap.lt.mgap) then
      call map_message(seve%w,rname,chain)
      write(chain,'(A,I0,A)') 'Creating ',igap-1,' empty channels in between'
      call map_message(seve%w,rname,chain)
    else
      call map_message(seve%e,rname,chain)
      if (igap.ge.mgap) call map_message(seve%e,rname,'Gap size exceeded')
      error = .true.
      return
    endif
  else
    igap = 0 ! Even if 1 channel overlap
  endif
  !
end subroutine gdf_match_header
!
subroutine cct_read(nc,head,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_range, map_message
  use gbl_message
  use clean_arrays
  use clean_types
  !-------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for READ CCT [/RANGE Min Max Type]
  !
  ! Supports any type of CCT Table
  !!
  !-------------------------------------------------------
  integer, intent(in) :: nc(2)          
  !! Channel range
  type(gildas), intent(inout) :: head   
  !! CCT Header
  logical, intent(inout) :: error       
  !! Error flag
  !
  ! Local ---
  integer :: ier,i,j,ni
  type(gildas) :: htmp
  !
  ! Code ----
  save_data(code_save_cct) = .false.
  call sic_delvariable ('CCT',.false.,error)
  if (allocated(dcct)) deallocate(dcct,stat=ier)
  !
  if (head%char%code(2).ne."COMPONENT") then
    ! Conforming organization - Simple read, with a subset
    ! specified through call to "map_range"
    call gdf_copy_header(head,hcct,error)
    error = map_range(nc,head,hcct)
    if (error) return
    hcct%loca = head%loca
    allocate(dcct(hcct%gil%dim(1),hcct%gil%dim(2),   &
     &        hcct%gil%dim(3)),stat=ier)
    call gdf_read_data(head,dcct,error)
    if (error) return
    !
  else  
    ! Transposed organization - Contiguous read, and in memory
    ! transposition, as CCT Tables are small
    call gildas_null(htmp,type='IMAGE')
    call gdf_copy_header(head,htmp,error)
    error = map_range(nc,head,htmp)
    if (error) return
    allocate(htmp%r3d(htmp%gil%dim(1),htmp%gil%dim(2),htmp%gil%dim(3)), &
      & dcct(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,'READ CCT','Memory allocation error')
      error = .true.
      return
    endif
    call gdf_read_data(head,htmp%r3d,error)
    if (error) return
    !
    call gdf_transpose_header(htmp,hcct,'132',error)
    ni = min(hcct%gil%dim(1),htmp%gil%dim(1)) ! Ensure no overflow 
    do i=1,htmp%gil%dim(2) 
      do j=1,htmp%gil%dim(3)
        dcct(1:ni,j,i) = htmp%r3d(1:ni,i,j) 
      enddo
    enddo
    deallocate(htmp%r3d)
  endif
  !
  call sic_mapgildas ('CCT',hcct,error,dcct)
end subroutine cct_read

subroutine map_convolve_comm(line,error)
  use gildas_def
  use gbl_format
  use phys_const
  use image_def
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !       MAP_CONVOLVE In Out GAUSS  Major Minor PA  
  !       MAP_CONVOLVE In Out BOX  
  !       MAP_CONVOLVE In Out HANNING  
  !       MAP_CONVOLVE In Out KGAUSS Width  
  !       MAP_CONVOLVE In Out USER K_1 .. K_6  
  !       MAP_CONVOLVE In Out NOISE  Threshold Length  
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  !! Command line
  logical, intent(inout) :: error          !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname = 'MAP_CONVOLVE'
  logical, parameter :: new=.true.
  logical, parameter :: old=.false.
  integer, parameter :: mvoc=6
  character(len=12) :: vocab(mvoc)
  data vocab/'BOX','GAUSS','HANNING','KGAUSS','NOISE','USER'/
  !
  ! Local ---
  character(len=24) :: argum
  character(len=12) :: key, cunit
  character(len=filename_length) :: cinp, cout
  type(gildas) :: hinp, hout
  real(kind=8) :: bmaj,bmin,pa
  real(kind=4) :: bmaj4,bmin4,pa4,thre
  integer(kind=4) :: mpix, ikey
  integer(kind=4) :: i, k, l, n, nx, ny, nxy, ndim, dim(2), mx, my, ier, rank
  complex(kind=4), allocatable :: cdata(:,:)
  real(kind=4), allocatable :: work(:)
  real(kind=4), pointer :: rdata(:,:)
  real(kind=4), allocatable :: rwork(:,:)
  real(kind=4) :: width, weight(6), fact 
  character(len=message_length) :: mess
  type (sic_descriptor_t) :: desc
  logical :: found, inp_image, out_image
  !
  ! Code ----
  call sic_ke(line,0,3,argum,n,.true.,error)
  if (error) return
  call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
  if (error) return
  !
  call sic_ch(line,0,1,cout,n,.true.,error)
  if (error) return
  call sic_ch(line,0,2,cinp,n,.true.,error)
  if (error) return
  !
  ! Method of Smoothing
  select case (key)
  case ('GAUSS')
    key = 'GAUSS'
    !
    call sic_r8(line,0,4,bmaj,.true.,error)
    if (error) return
    bmin = bmaj
    call sic_r8(line,0,5,bmin,.false.,error)
    if (error) return
    pa = 0
    call sic_r8(line,0,6,pa,.false.,error)
    if (error) return
    !
    ! Bmaj & Bmin must be in User units
    !bmaj = bmaj*pi/180/3600
    !bmin = bmin*pi/180/3600
  case ('HANNING')
    weight(1) = 3.
    weight(2) = 2.
    weight(3) = 2.
    weight(4) = 1.
    weight(5) = 1.
    weight(6) = 1.
  case ('KGAUSS')
    call sic_r4(line,0,4,width,.true.,error)
    if (error) return
    fact=-(1.665109/width)**2
    weight(1) = 1.
    weight(2) = exp(fact)
    weight(3) = exp(2.*fact)
    weight(4) = exp(4.*fact)
    weight(5) = exp(5.*fact)
    weight(6) = exp(16.*fact)
  case ('BOX')
    weight(1:6) = 1.
  case ('USER')
    do i=1,6
      call sic_r4(line,0,i+3,weight(i),.true.,error)
      if (error) return
    enddo
  case ('NOISE')
    call sic_r4(line,0,4,thre,.true.,error)
    if (error) return
    call sic_i4(line,0,5,mpix,.true.,error)
    if (error) return
  end select
  !
  ! Now get the data arrays
  ! Input data
  fact = 1.0
  call gildas_null(hinp)
  call get_3d_from_name(rname,cinp,hinp,old,inp_image,error)
  if (error) return
  !
  ! Output data
  call gildas_null(hout)
  hout%gil%ndim = 3
  hout%gil%dim(1:3) = hinp%gil%dim(1:3)
  call get_3d_from_name(rname,cout,hout,new,out_image,error)
  if (error) return
  !
  ! Prepare the output header
  call gdf_copy_header(hinp,hout,error)
  hout%gil%extr_words = 0  ! Disable extrema section
  !
  if (key.eq.'GAUSS') then
    fact = 1.0
    !
    ! Resolution section if present
    if ((hinp%gil%reso_words.gt.0).and.(hinp%gil%majo.gt.0)) then
      if (bmaj.eq.bmin) then
        ! Assume we want to get to this resolution in fact
        call map_message(seve%i,rname,'Attempting to reach User specified resolution')
        if (hinp%gil%majo.gt.bmaj) then
          call map_message(seve%e,rname,'Desired resolution better than available')
          error = .true.
          return
        endif
        !
        ! Adjust the convolving Gaussian
        bmaj = sqrt(bmaj**2-hinp%gil%majo**2)
        bmin = sqrt(bmin**2-hinp%gil%mino**2)
        pa = hinp%gil%posa/rad_per_deg
      else
        call map_message(seve%i,rname,'Convolving by a User specified elliptical Gaussian')
      endif
      !
      ! Verify effective resolution
      bmaj4 = bmaj
      bmin4 = bmin
      pa4 = pa*rad_per_deg
      call gdf_gauss2d_convolution(hout,bmaj4,bmin4,pa4,error)
      if (error)  return
      write(mess,'(A,3(1PG14.7,A))')  &
        'Smoothed beam is ', &
        hout%gil%majo*sec_per_rad,' x ',  &
        hout%gil%mino*sec_per_rad,' sec (PA ', &
        hout%gil%posa*deg_per_rad,' deg)'
      call map_message(seve%i,rname,mess)
      !
      fact = hout%gil%majo*hout%gil%mino/(hinp%gil%majo*hinp%gil%mino)
      !
    else
      cunit = hout%char%unit
      call sic_upper(cunit)
      if (cunit.eq.'JY/BEAM'.or.cunit.eq.'K') then
        call map_message(seve%i,rname,'Convolving to a User specified elliptical Gaussian')
        ! If we start from a Brightness unit, specify spatial resolution
        hout%gil%reso_words = def_reso_words
        hout%gil%majo = bmaj
        hout%gil%mino = bmin
        hout%gil%posa = pa*rad_per_deg
      else
        ! If not, prefer the No Resolution case, as units can be anything
        call map_message(seve%i,rname,'Convolving by a User specified elliptical Gaussian')
        hout%gil%reso_words = 0  ! No valid angular resolution
      endif
    endif
  else
    hout%gil%reso_words = 0    ! No well defined angular resolution
  endif
  !
  ! Convert to a defined brightness unit if the smoothing does not 
  !   preserve a well defined angular resolution
  if (hout%gil%reso_words.eq.0) then
    !
    ! If unit is Jy/beam, convert to Jy/pixel
    cunit = hinp%char%unit
    call sic_upper(cunit)
    if (cunit.eq."JY/BEAM") then
      if (hinp%gil%reso_words.ne.0) & 
        & fact = abs(hinp%gil%inc(1)*hinp%gil%inc(2))/(pi*hinp%gil%majo*hinp%gil%mino)
      hout%char%code = "Jy/pixel"
    endif
  endif
  !
  ! Create output image only if using Block Mode (not yet coded)
  !  if (.not.out_image) then
  !    call gdf_create_image (hout,error)
  !    if (error) return
  !  endif
  !
  mx = hinp%gil%dim(1)
  my = hinp%gil%dim(2)
  !
  nx = 2*mx
  ny = 2*my
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  nxy = nx * ny 
  !
  select case(key)
  case ('GAUSS')
    allocate (work(2*max(nx,ny)), cdata(nx, ny), stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
    !
    call fourt_plan (cdata,dim,ndim,1,0)
    call fourt_plan (cdata,dim,ndim,-1,1)
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP & SHARED(hinp,hout,dim,ndim,nx,ny,bmin,bmaj,pa,mx,my,fact) &
    !$OMP & PRIVATE(rdata,cdata,work,i,k,l)
    !$OMP DO
    do i=1,hinp%gil%dim(3)
      if (hinp%gil%eval.ge.0) then
        rdata => hout%r3d(:,:,i)
        do k=1,my
          do l=1,mx
            if (abs(hinp%r3d(l,k,i)-hinp%gil%bval).le.hinp%gil%eval) then
              rdata(l,k) = 0.0
            else
              rdata(l,k) = hinp%r3d(l,k,i)
            endif
          enddo
        enddo
      else
        rdata => hinp%r3d(:,:,i)
      endif
      !
      call copyc (mx,my,rdata,nx,ny,cdata)
      call fourt (cdata,dim,ndim,1,0,work)
      call sm_mulgau(cdata,nx,ny,   &
     &        bmaj,bmin,pa,hinp%gil%inc(1),hinp%gil%inc(2))
      call fourt (cdata,dim,ndim,-1,+1,work)
      call copyn (nx,ny,cdata,mx,my,hout%r3d(:,:,i))
      if (fact.ne.1) hout%r3d(:,:,i) = fact*hout%r3d(:,:,i)
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  case ('NOISE')
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP & SHARED(hinp,hout,thre,mpix)  &
    !$OMP & PRIVATE(i)
    !$OMP DO
    do i=1,hinp%gil%dim(3)
        call smo002 (hinp%r3d(:,:,i),        &   ! Input image
   &        hinp%gil%dim(1),hinp%gil%dim(2), &   ! Size
   &        hout%r3d(:,:,i),                 &   ! Output image
   &        thre,                            &   ! Threshold
   &        mpix,      & ! Radius (in pixel) of smoothing disk
   &        hinp%gil%bval,hinp%gil%eval)     ! Blanking values
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  case default
    allocate(rwork(hinp%gil%dim(1),hinp%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      error = .true.
      return
    endif
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP & SHARED(hinp,hout,weight)  &
    !$OMP & PRIVATE(rwork,i)
    !$OMP DO
    do i=1,hinp%gil%dim(3)
      call smoo001 (hinp%r3d(:,:,i),          &   !Input image
   &        hinp%gil%dim(1),hinp%gil%dim(2),  &   !Size
   &        hout%r3d(:,:,i),                  &   !Output image
   &        hout%gil%bval,hout%gil%eval,      &   !Blanking values
   &        weight,   &              !Smoothing weights
   &        rwork)                   !Work space
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  end select
  !
  if (.not.out_image) then
    call gdf_write_image(hout,hout%r3d,error)
  else
    ! Update the original SIC variable header, including Extrema
    error = .false. 
    hout%loca%addr = locwrd(hout%r3d)   ! Define the address
    hout%loca%size = product(hout%gil%dim(1:3))
    call gdf_get_extrema (hout,error)
    call sic_upper(cout)
    call sic_descriptor(cout,desc,found)
    call gdf_copy_header(hout,desc%head,error)  
  endif
contains
!
subroutine copyc(mx,my,r,nx,ny,c)
  !---------------------------------------------------------------------
  !! IMAGER -- Utility routine  
  !!    Insert Real array R(NX,NY) into Complex array C(MX,MY)
  !!    Only a shift, and NaN set to zero.
  !---------------------------------------------------------------------
  integer :: mx                       !! X size of real array
  integer :: my                       !! Y size of real array
  real :: r(mx,my)                    !! Real array
  integer :: nx                       !! X size of complex array
  integer :: ny                       !! Y size of complex array
  complex :: c(nx,ny)                 !! Complex output array
  !
  ! Local
  integer :: i,j,i0,j0
  !
  c = 0.0
  !
  i0 = nx/2-mx/2
  j0 = ny/2-my/2
  !
  do j=1,my
    do i=1,mx
      ! Avoid NaN
      if (r(i,j).eq.r(i,j)) then
        c(i+i0,j+j0) = r(i,j)
      endif
    enddo
  enddo
end subroutine copyc
!
subroutine copyn(nx,ny,c,mx,my,r)
  !---------------------------------------------------------------------
  !! IMAGER -- Utility routine   
  !!     Extract Real array R(NX,NY) from Complex array C(MX,MY)  
  !!     and normalize it.
  !---------------------------------------------------------------------
  integer :: mx                       !! X size of real array
  integer :: my                       !! Y size of real array
  real :: r(mx,my)                    !! Real output array
  integer :: nx                       !! X size of complex array
  integer :: ny                       !! Y size of complex array
  complex :: c(nx,ny)                 !! Complex input array
  !
  ! Local
  integer :: i,j,i0,j0
  real :: w
  !
  i0 = nx/2-mx/2
  j0 = ny/2-my/2
  !
  w = 1.0/(nx*ny)
  do j=1,my
    do i=1,mx
      r(i,j) = real(c(i+i0,j+j0)) * w
    enddo
  enddo
end subroutine copyn
!
subroutine sm_mulgau(data,nx,ny,bmaj,bmin,pa,x_inc1,x_inc2)
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Utility routine
  !      Multiply the FT of an image by the FT of
  !       a convolving gaussian function. BMAJ and BMIN are the
  !       widths of the original gaussian. PA is the position angle of major
  !       axis (from north towards east)
  !!
  !---------------------------------------------------------------------
  integer :: nx                       !! X size of complex array
  integer :: ny                       !! Y size of complex array
  complex :: data(nx,ny)              !! Complex array
  real(8) :: bmaj                     !! Major axis
  real(8) :: bmin                     !! Minor axis
  real(8) :: pa                       !! Position angle
  real(8) :: x_inc1                   !! Increment along X
  real(8) :: x_inc2                   !! Increment along Y
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  real(4), parameter :: eps=1.e-7
  ! Local ---
  integer :: i,j,nx1,nx2
  real :: amaj,amin,fact,cx,cy,sx,sy
  logical :: norot,rot90
  real(8) :: rpa
  !
  ! Code ---
  norot = ( abs(mod(pa,180.d0)).le.eps)
  rot90 = ( abs(mod(pa,180.d0)-90.d0).le.eps)
  amaj = bmaj*pi/(2.*sqrt(log(2.)))
  amin = bmin*pi/(2.*sqrt(log(2.)))
  rpa = pa*pi/180.d0
  !
  cx = cos(rpa)/nx*amin
  cy = cos(rpa)/ny*amaj
  sx = sin(rpa)/nx*amaj
  sy = sin(rpa)/ny*amin
  !
  ! Convert map units to pixels
  cx = cx / x_inc1
  cy = cy / x_inc2
  sx = sx / x_inc1
  sy = sy / x_inc2
  nx2 = nx/2
  nx1 = nx2+1
  !
  ! Optimised code for Position Angle 0 degrees
  if (norot) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(j-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(j-ny-1)*cy)**2 + (float(i-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(j-ny-1)*cy)**2 + (float(i-nx-1)*cx)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! Optimised code for Position Angle 90 degrees
  elseif (rot90) then
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx)**2 +(float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx)**2 + (float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    !
    ! General case of a rotated elliptical gaussian
  else
    do j=1,ny/2
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-1)*cy)**2 +   &
     &          (-float(i-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx + float(j-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
    do j=ny/2+1,ny
      do i=1,nx2
        fact = (float(i-1)*sx + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
      do i=nx1,nx
        fact = (float(i-nx-1)*sx   &
     &          + float(j-ny-1)*cy)**2 +   &
     &          ( -float(i-nx-1)*cx + float(j-ny-1)*sy)**2
        if (fact.lt.80.) then
          fact = exp (-fact)
          data(i,j) = data(i,j)*fact
        else
          data(i,j) = 0.
        endif
      enddo
    enddo
  endif
end subroutine sm_mulgau
!!
subroutine smoo001(v,mi,mj,a,bval,eval,table,w)
  use gildas_def
  !---------------------------------------------------------------------
  !! IMAGER -- Utility routine  
  !! 	2-D Smoothing wit a kernel, handling blanking values
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: mi    !! First dimension
  integer(kind=index_length), intent(in) :: mj    !! Second dimension
  real, intent(in) :: v(mi,mj)                    !! Initial array
  real, intent(out) :: a(mi,mj)                   !! Smoothed array
  real, intent(in) :: bval                        !!  Blanking value
  real, intent(in) :: eval                        !! Blanking tolerance
  real, intent(in) :: table(6)                    !! Smoothing coefficient
  real, intent(inout) :: w(mi,mj)                 !! Work array
  !
  ! Local
  integer :: i,j
  real :: x,sum,s00,s10,s11,s20,s21,s22
  real :: a00,a10,a11,a20,a21,a22
  !
  ! Load smoothing coefficients
  s00 = table(1)
  s10 = table(2)
  s11 = table(3)
  s20 = table(4)
  s21 = table(5)
  s22 = table(6)
  a00 = abs(s00)
  a10 = abs(s10)
  a11 = abs(s11)
  a20 = abs(s20)
  a21 = abs(s21)
  a22 = abs(s22)
  sum = a00 + 4.0*(a10+a11+a20+2.0*a21+a22)
  !
  ! Initialise arrays
  do j=1,mj
    do i=1,mi
      a(i,j) = 0.0
      w(i,j) = 0.0
    enddo
  enddo
  !
  ! Check for blanking first
  if (eval.ge.0.0) then
    !
    ! Slow method for blanked maps
    do j=3,mj-2
      do i=3,mi-2
        x = v(i,j)
        if (abs(x-bval).gt.eval) then
          ! Central pixel
          a(i,j) = a(i,j) + s00*x
          w(i,j) = w(i,j) + a00
          ! Second pixels
          a(i-1,j-1) = a(i-1,j-1) + s11*x
          a(i-1,j  ) = a(i-1,j )  + s10*x
          a(i-1,j+1) = a(i-1,j+1) + s11*x
          a(i  ,j-1) = a(i  ,j-1) + s10*x
          a(i  ,j+1) = a(i  ,j+1) + s10*x
          a(i+1,j-1) = a(i+1,j-1) + s11*x
          a(i+1,j  ) = a(i+1,j  ) + s10*x
          a(i+1,j+1) = a(i+1,j+1) + s11*x
          ! and weights
          w(i-1,j-1) = w(i-1,j-1) + a11
          w(i-1,j  ) = w(i-1,j  ) + a10
          w(i-1,j+1) = w(i-1,j+1) + a11
          w(i  ,j-1) = w(i  ,j-1) + a10
          w(i  ,j+1) = w(i  ,j+1) + a10
          w(i+1,j-1) = w(i+1,j-1) + a11
          w(i+1,j  ) = w(i+1,j  ) + a10
          w(i+1,j+1) = w(i+1,j+1) + a11
          !
          ! Third pixels
          a(i-2,j-2) = a(i-2,j-2)  + s22*x
          a(i-2,j-1) = a(i-2,j-1)  + s21*x
          a(i-2,j  ) = a(i-2,j  )  + s20*x
          a(i-2,j+1) = a(i-2,j+1)  + s21*x
          a(i-2,j+2) = a(i-2,j+2)  + s22*x
          a(i-1,j-2) = a(i-1,j-2)  + s21*x
          a(i-1,j+2) = a(i-1,j+2)  + s21*x
          a(i  ,j-2) = a(i  ,j-2)  + s20*x
          a(i  ,j+2) = a(i  ,j+2)  + s20*x
          a(i+1,j-2) = a(i+1,j-2)  + s21*x
          a(i+1,j+2) = a(i+1,j+2)  + s21*x
          a(i+2,j-2) = a(i+2,j-2)  + s22*x
          a(i+2,j-1) = a(i+2,j-1)  + s21*x
          a(i+2,j  ) = a(i+2,j  )  + s20*x
          a(i+2,j+1) = a(i+2,j+1)  + s21*x
          a(i+2,j+2) = a(i+2,j+2)  + s22*x
          !
          ! and weights
          w(i-2,j-2) = w(i-2,j-2)  + a22
          w(i-2,j-1) = w(i-2,j-1)  + a21
          w(i-2,j  ) = w(i-2,j  )  + a20
          w(i-2,j+1) = w(i-2,j+1)  + a21
          w(i-2,j+2) = w(i-2,j+2)  + a22
          w(i-1,j-2) = w(i-1,j-2)  + a21
          w(i-1,j+2) = w(i-1,j+2)  + a21
          w(i  ,j-2) = w(i  ,j-2)  + a20
          w(i  ,j+2) = w(i  ,j+2)  + a20
          w(i+1,j-2) = w(i+1,j-2)  + a21
          w(i+1,j+2) = w(i+1,j+2)  + a21
          w(i+2,j-2) = w(i+2,j-2)  + a22
          w(i+2,j-1) = w(i+2,j-1)  + a21
          w(i+2,j  ) = w(i+2,j  )  + a20
          w(i+2,j+1) = w(i+2,j+1)  + a21
          w(i+2,j+2) = w(i+2,j+2)  + a22
        endif
      enddo
    enddo
    !
    ! Set blanked pixels
    do j=1,mj
      do i=1,mi
        if (w(i,j).eq.0.0) then
          a(i,j) = bval
        else
          a(i,j) = a(i,j)/w(i,j)
        endif
      enddo
    enddo
    !
    ! Optimise for no blanking
  else
    !
    do j=3,mj-2
      do i=3,mi-2
        a(i,j) =   &
     &          s00 * v(i,j)   &
     &          + s11 * (v(i-1,j+1)+v(i+1,j+1)+v(i+1,j-1)+v(i-1,j-1))   &
     &          + s10 * (v(i,j+1)+v(i+1,j)+v(i-1,j)+v(i,j-1))   &
     &          + s22 * (v(i-2,j+2)+v(i+2,j+2)+v(i-2,j-2)+v(i+2,j-2))   &
     &          + s21 * (v(i-1,j+2)+v(i+1,j+2)+v(i+2,j+1)+v(i+2,j-1)   &
     &          +v(i+1,j-2)+v(i-1,j-2)+v(i-2,j-1)+v(i-2,j+1))   &
     &          + s20 * (v(i,j+2)+v(i+2,j)+v(i,j-2)+v(i-2,j))
        a(i,j) = a(i,j)/sum
      enddo
    enddo
    !
  endif
end subroutine smoo001
!
subroutine smo002(imagein, ncolumns, nlines, imageout, flux,   &
     &    maxpoint, blank, eblank)
  use gildas_def
  !!
  !! IMAGER -- Utility routine 
  !!  "Noise" smoothing up to Maxpoint pixels and specified Flux
  !!
  integer(kind=index_length), intent(in) :: ncolumns  !! X size                  !
  integer(kind=index_length), intent(in) :: nlines    !! Y size
  real(4), intent(in) :: imagein(ncolumns,nlines)     !! Original image
  real(4), intent(out) :: imageout(ncolumns,nlines)   !! Smoothed image
  real(4), intent(in) :: flux       !! Flux limit to stop smoothing
  integer, intent(in) :: maxpoint   !! Maximum number of pixels included in smoothing
  real(4), intent(in) :: blank      !! Blanking value
  real(4), intent(in) :: eblank     !! Tolerance
  !                   !
  ! Local --
  integer :: iline,icolumn,k,np,ic,ic1,ic2,il,il1,il2
  real(4) :: x, xx
  !
  ! Code
  do iline=1,nlines
    do icolumn=1,ncolumns
      k=0
      x=imagein(icolumn,iline)
      if (abs(x-blank).le.eblank) then
        x = 0.
        np = 0
      else
        np = 1
      endif
      do while (x.lt.flux .and. k.lt.maxpoint)
        k=k+1
        il1=max(1,iline-k)
        il2=min(nlines,iline+k)
        ic1=max(icolumn-k,1)
        ic2=min(icolumn+k,ncolumns)
        do ic=ic1,ic2
          xx = imagein(ic,il1)
          if (abs(xx-blank).gt.eblank) then
            x = x + xx
            np= np+1
          endif
          xx = imagein(ic,il2)
          if (abs(xx-blank).gt.eblank) then
            x = x + xx
            np= np+1
          endif
        enddo
        il1=max(iline-k+1,1)
        il2=min(iline+k-1,nlines)
        do il=il1,il2
          xx = imagein(ic1,il)
          if (abs(xx-blank).gt.eblank) then
            x = x + xx
            np= np+1
          endif
          xx = imagein(ic2,il)
          if (abs(xx-blank).gt.eblank) then
            x = x + xx
            np= np+1
          endif
        enddo
      enddo
      if (np.ne.0) then
        imageout(icolumn,iline)=x/float(np)
      else
        imageout(icolumn,iline)=blank
      endif
    enddo
  enddo
end subroutine smo002
!
!<FF>
!
subroutine get_3d_from_name(rname,arg,head,new,is_image,error)
  use image_def
  use iso_c_binding
  use gkernel_interfaces
  use imager_interfaces, only : sub_readhead, map_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- GILDAS general routine
  !
  !   From a string, which can be a SIC variable or a Data file
  ! name, return the data array in the appropriate  3D Pointer 
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: rname  !! Caller name
  character(len=*), intent(in) :: arg    !! Input name (SIC variable or Filename)
  type(gildas), intent(inout) :: head    !! Gildas Header for entity
  logical, intent(in) :: new             !! Should it exist or not ?
  logical, intent(inout) :: is_image     !! Is it a SIC variable, or a file ?
  logical, intent(out) :: error          !! Logical error file
  !
  ! Local ---
  character(len=512) :: chain
  integer :: dims(3)
  logical :: rdonly
  type (c_ptr) :: cptr
  !
  ! Code ----
  is_image = index(arg,'.').eq.0
  dims = head%gil%dim(1:3)
  call gildas_null(head)
  error = .false.
  !
  if (new) then
    !
    ! It is an Output result
    if (is_image) then
      ! It must be an Image
      if (.not.sic_varexist(arg)) then
        !
        ! If not, create it - One would like to use directly the SIC routines
        !   call sic_define_image (name,filename,status,global,therank,error)
        ! here, with 
        !   filename = "*"
        !   name = trim(arg)//"[dim1,dim2,dim3]" 
        !   status = "READ"
        !   global = .true.
        !   therank = 3 (a variable, though)
        ! but it is a "private" routine
        !
        ! So we use a command line, but it may break the caller if its line
        ! parsing has not been completed.
        write(chain,'(A,I0,A,I0,A,I0,A)') 'DEFINE IMAGE '//trim(arg)//'[', &
          & dims(1),',',dims(2),',',dims(3),'] * REAL /GLOBAL'
        call exec_command(chain,error)
        if (error) return
      endif
      !
      rdonly = .false.
      call sub_readhead (rname,arg,head,is_image,error,rdonly,fmt_r4)
      if (error) return
      !
      ! If it exists, verify it matches the appropriate Header in size
      if (any(dims.ne.head%gil%dim(1:3))) then
        call map_message(seve%e,rname,'Output SIC variable does not match Input data shape')
        error = .true.
        return
      endif
      !
      ! Set the appropriate pointer to the data area
      call adtoad(head%loca%addr,cptr,1)
      call c_f_pointer(cptr,head%r3d,head%gil%dim(1:3))
      !
    else
      !
      ! It must be a Data File, create it with the appropriate size
      call gildas_null(head)
      head%file = arg
      head%gil%ndim = 3
      head%gil%dim(1:3) = dims
      allocate(head%r3d(dims(1),dims(2),dims(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Output Image allocation error')
        error = .true.
        return
      endif
    endif
  else
    !
    ! It is an input data set. Find it  
    call gildas_null(head)
    call sub_readhead (rname,arg,head,is_image,error,rdonly,fmt_r4)
    if (error) return
    !
    ! Trim it to 3-D
    rank=3
    call gdf_trim_header(head,rank,error)  
    if (error) return
    !
    if (is_image) then
      !
      ! Set the appropriate pointer to the data area
      call adtoad(head%loca%addr,cptr,1)
      call c_f_pointer(cptr,head%r3d,head%gil%dim(1:3))
    else
      dims = head%gil%dim(1:3)
      ! Allocate the appropriate pointer 
      allocate(head%r3d(dims(1),dims(2),dims(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Output Image allocation error')
        error = .true.
        return
      endif
      ! And read the data
      call gdf_read_data(head,head%r3d,error)
      if (error) return
      call gdf_close_image(head,error) ! not needed it anymore
    endif
  endif
end subroutine get_3d_from_name
!
end subroutine map_convolve_comm

*DECK DNLS1E
      SUBROUTINE DNLS1E (FCN, IOPT, M, N, X, FVEC, TOL, NPRINT, INFO,
     +   IW, WA, LWA)
C***BEGIN PROLOGUE  DNLS1E
C***PURPOSE  An easy-to-use code which minimizes the sum of the squares
C            of M nonlinear functions in N variables by a modification
C            of the Levenberg-Marquardt algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      DOUBLE PRECISION (SNLS1E-S, DNLS1E-D)
C***KEYWORDS  EASY-TO-USE, LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNLS1E is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  This is done by using the more
C       general least-squares solver DNLS1.  The user must provide a
C       subroutine which calculates the functions.  The user has the
C       option of how the Jacobian will be supplied.  The user can
C       supply the full Jacobian, or the rows of the Jacobian (to avoid
C       storing the full Jacobian), or let the code approximate the
C       Jacobian by forward-differencing.  This code is the combination
C       of the MINPACK codes (Argonne) LMDER1, LMDIF1, and LMSTR1.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNLS1E(FCN,IOPT,M,N,X,FVEC,TOL,NPRINT,
C      *                  INFO,IW,WA,LWA)
C       INTEGER IOPT,M,N,NPRINT,INFO,LWAC,IW(N)
C       DOUBLE PRECISION TOL,X(N),FVEC(M),WA(LWA)
C       EXTERNAL FCN
C
C
C 3. Parameters. ALL TYPE REAL parameters are DOUBLE PRECISION
C
C       Parameters designated as input parameters must be specified on
C       entry to DNLS1E and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNLS1E.
C
C      FCN is the name of the user-supplied subroutine which calculates
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         DOUBLE PRECISION X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored       , if IOPT=1.
C         DOUBLE PRECISION FJAC(LDFJAC,N)      , if IOPT=2.
C         DOUBLE PRECISION FJAC(N)             , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNLS1E.  In this case,
C         set IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       TOL is a non-negative input variable.  Termination occurs when
C         the algorithm estimates either that the relative error in the
C         sum of squares is at most TOL or that the relative error
C         between X and the solution is at most TOL.  Section 4 contains
C         more details about TOL.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls of FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C        execution, INFO is set to the (negative) value of IFLAG.  See
C        description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  algorithm estimates that the relative error in the
C                   sum of squares is at most TOL.
C
C         INFO = 2  algorithm estimates that the relative error between
C                   X and the solution is at most TOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  FVEC is orthogonal to the columns of the Jacobian to
C                   machine precision.
C
C         INFO = 5  number of calls to FCN has reached 100*(N+1)
C                   for IOPT=2 or 3 or 200*(N+1) for IOPT=1.
C
C         INFO = 6  TOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  TOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       IW is an INTEGER work array of length N.
C
C       WA is a work array of length LWA.
C
C       LWA is a positive integer input variable not less than
C         N*(M+5)+M for IOPT=1 and 2 or N*(N+5)+M for IOPT=3.
C
C***END PROLOGUE  DNLS1E
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER M,N,NPRINT,INFO,LWA,IOPT
      INTEGER INDEX,IW(*)
      DOUBLE PRECISION TOL
      DOUBLE PRECISION X(*),FVEC(*),WA(*)
      EXTERNAL FCN
      INTEGER MAXFEV,MODE,NFEV,NJEV
      DOUBLE PRECISION FACTOR,FTOL,GTOL,XTOL,ZERO,EPSFCN
      SAVE FACTOR, ZERO
      DATA FACTOR,ZERO /1.0D2,0.0D0/
C***FIRST EXECUTABLE STATEMENT  DNLS1E
      INFO = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 3 .OR.
     1    N .LE. 0 .OR. M .LT. N .OR. TOL .LT. ZERO
     2    .OR. LWA .LT. N*(N+5) + M) THEN
        Print *,'LWA ',lwa,' not < M*(N+5) ',M,N,' N*(M+5) ',n*(m+5)
        GO TO 10
      ENDIF
      IF (IOPT .LT. 3 .AND. LWA .LT. N*(M+5) + M) GO TO 10
C
C     CALL DNLS1.
C
      MAXFEV = 100*(N + 1)
      IF (IOPT .EQ. 1) MAXFEV = 2*MAXFEV
      FTOL = TOL
      XTOL = TOL
      GTOL = ZERO
      EPSFCN = ZERO
      MODE = 1
      INDEX = 5*N+M
      CALL DNLS1(FCN,IOPT,M,N,X,FVEC,WA(INDEX+1),M,FTOL,XTOL,GTOL,
     1           MAXFEV,EPSFCN,WA(1),MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
     2           IW,WA(N+1),WA(2*N+1),WA(3*N+1),WA(4*N+1),WA(5*N+1))
      IF (INFO .EQ. 8) INFO = 4
   10 CONTINUE
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'DNLS1E',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE DNLS1E.
C
      END

subroutine uv_resample_comm(line,comm,error)
  use gbl_message
  use gkernel_types
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_resample_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_RESAMPLE and similar operations
  !
  !   Resample in velocity UV Tables or compress them.
  !   Support for commands 
  !     UV_RESAMPLE NC [Ref Val Inc] [/FILE FileIn FileOut] [/LIKE Mold] 
  !     UV_COMPRESS NC [/CONTINUUM] [/FILE FileIn FileOut]  
  !     UV_HANNING     [/FILE FileIn FileOut]  
  !     UV_SMOOTH   NC [/ASYMMETRIC] [/FILE FileIn FileOut]  
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Calling command
  logical, intent(out) :: error           !! Logical Error flag
  !
  ! Constants
  integer, parameter :: o_asym=1
  !
  ! Local ---
  integer :: o_file   ! Value depends on COMM
  logical :: asym
  character(len=filename_length) :: in_file, ou_file
  character(len=120) :: mess
  integer :: n
  type(gildas) :: hiuv, houv
  integer :: nblock
  integer :: nu, nv, ni, nt, nchan, nc, ier
  integer(kind=index_length)  :: ib           ! Blocked visibility counter
  integer(kind=index_length)  :: mvisi        ! Number of blocked visibilities
  integer(kind=index_length)  :: nvisi        ! Number of visibilities
  !
  ! Code ----
  ! Option numbering depends on Command name
  if ((comm.eq.'UV_COMPRESS').or.(comm.eq.'UV_SMOOTH')) then
    o_file = 2
  else
    o_file = 1
  endif
  !
  if (.not.sic_present(o_file,0)) then
    call uv_resample_mem(line,comm,error)
  else
    !
    call sic_ch(line,o_file,1,in_file,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,2,ou_file,n,.true.,error)
    if (error) return
    !
    call gildas_null(hiuv,type='UVT')
    call gildas_null(houv,type='UVT')
    !
    call sic_parse_file(in_file,' ','.uvt',hiuv%file)
    call gdf_read_header(hiuv,error)
    if (error) return
    !
    call gdf_copy_header(hiuv,houv,error)
    !!Print *,'Input ',hiuv%gil%dim(1:2), hiuv%gil%ntrail
    call sic_parse_file(ou_file,' ','.uvt',houv%file)
    !
    call uv_resample_args(line,comm,hiuv,houv,error)
    if (error) return
    call gdf_create_image(houv,error)
    if (error) return
    !
    asym = sic_present(o_asym,0)
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',hiuv,1)
    mvisi = nblock
    !
    allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),houv%r2d(houv%gil%dim(1),mvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,comm,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! ! Print *,'Trailings ',hiuv%gil%ntrail, houv%gil%ntrail
    !
    do ib=1,hiuv%gil%dim(2),mvisi
      !
      ! Read the data
      write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
      call map_message(seve%i,comm,mess)
      hiuv%blc(2) = ib
      hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
      nvisi = hiuv%trc(2)-hiuv%blc(2)+1
      call gdf_read_data(hiuv,hiuv%r2d,error)
      if (error) return
      !
      ni = hiuv%gil%dim(1)
      nu = houv%gil%dim(1)
      nv = nvisi  ! Not houv%gil%dim(2)
      nt = houv%gil%ntrail
      nc = nint(real(hiuv%gil%nchan)/real(houv%gil%nchan))  ! Compression factor
      nchan = houv%gil%nchan
      !
      ! Now resample
      if (comm.eq.'UV_RESAMPLE') then
        call resample_uv (hiuv,houv,hiuv%r2d,houv%r2d,nvisi,nt)
      else if (comm.eq.'UV_COMPRESS') then
        call compress_uv (houv%r2d,nu,nv,nchan,hiuv%r2d,ni,nc,nt)
      else if (comm.eq.'UV_HANNING') then
        call hanning_uv (houv%r2d,nu,nvisi,nchan,hiuv%r2d,ni,nt)
      else if (comm.eq.'UV_SMOOTH') then
        call smooth_uv (houv%r2d,nu,nvisi,nchan,hiuv%r2d,nc,nt,asym)
      endif
      !
      ! Check channel boundaries, to flag the incomplete ones
      call uvflag_edges(hiuv,houv,nu,nv,houv%r2d)
      !
      ! Write in place
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,houv%r2d,error)
      if (error) return
    enddo
    !
    deallocate(hiuv%r2d,houv%r2d)  
    call gdf_close_image(hiuv,error)
    call gdf_close_image(houv,error)
    if (error) return
    !
    call map_message(seve%i,comm,'Created '//trim(houv%file))
    !        
  endif
end subroutine uv_resample_comm
!
subroutine uv_resample_args(line,comm,hiuv,houv,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use clean_def
  use clean_default
  use clean_types
  use imager_interfaces, except_this=>uv_resample_args
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_RESAMPLE and similar command
  !
  !   Parsing routine to recover the argument valuse for:  
  !     UV_RESAMPLE NC [Ref Val Inc] [/FILE FileIn FileOut] [/LIKE Mold]  
  !     UV_COMPRESS [NC] [/CONTINUUM] [/FILE FileIn FileOut]   
  !     UV_HANNING     [/FILE FileIn FileOut]  
  !     UV_SMOOTH   NC [/ASYMMETRIC] [/FILE FileIn FileOut]  
  !
  !   Decode the arguments and fill the output header accordingly
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Calling command
  type(gildas), intent(inout) :: hiuv     !! Input UV header
  type(gildas), intent(inout) :: houv     !! Output UV header
  logical, intent(out) :: error           !! Error flag
  !
  ! Constants
  integer, parameter :: o_cont_comp=2
  integer, parameter :: o_cont_file=1
  integer, parameter :: o_like=2
  integer, parameter :: o_asym=1
  !
  ! Local ---
  character(len=4) :: arg(4)
  real(8) :: convert(3), velo
  real(8) :: freqs
  real(4) :: velos, field
  integer :: nc, na, i
  character(len=128) :: mess
  character(len=filename_length) :: moldfile
  !
  ! Code ----
  if (hiuv%gil%nstokes.gt.1) then
    call map_message(seve%e,comm,'Only single polarization data supported')
    error = .true.
    return
  endif
  !
  select case (comm)
  case ('UV_RESAMPLE')
    nc = 0
    !
    if (sic_present(o_like,0)) then
      call sic_ch(line,o_like,1,moldfile,nc,.true.,error)
      if (error) return
      call gdf_copy_header(hiuv,houv,error)
      call uv_resample_like(houv,moldfile,convert,nc,error)
    else
      !    SIC__CH would complain if argument is too long, SIC_KE is silent
      call sic_ke(line,0,1,arg(1),na,.true.,error)
      error = .false.
      if (arg(1).ne.'*') call sic_i4(line,0,1,nc,.true.,error)
      if (error) return
      !
      ! Set default resampling in Velocity
      convert(1) = hiuv%gil%ref(1)
      convert(2) = hiuv%gil%voff
      convert(3) = hiuv%gil%vres
      ! Get new one
      do i=2,sic_narg(0)
        call sic_ke(line,0,i,arg(i),na,.false.,error)
        error = .false.
        if (arg(i).ne.'*') call sic_r8(line,0,i,convert(i-1),.false.,error)
        if (error) return
      enddo
      !
      ! Fill missing arguments
      if (nc.eq.0) then
        nc = nint(abs(hiuv%gil%nchan*hiuv%gil%vres/convert(3)))
        if (arg(2).eq.'*') then
          ! Keep the middle channel in the middle
          velo = (0.5d0*hiuv%gil%nchan-hiuv%gil%ref(1))*hiuv%gil%vres + hiuv%gil%voff
          convert(1) = 0.5d0*nc - (velo-convert(2))/convert(3)
        endif
      endif
    endif
    !
    ! NC Ref Val Inc
    write(mess,'(A,I0,X,3(F12.3))') 'Resampling to ',nc,convert(1:3)
    call map_message(seve%i,comm,mess)
    !
    ! First shift the Reference Velocity Frame to the new sampling
    freqs = houv%gil%freq
    velos = convert(2)
    call gdf_modify(houv,velos,freqs,error=error)
    !
    ! Then get the proper conversion formula
    call getuv_conversion(houv,nc,convert)
    !
  case ('UV_COMPRESS') 
    nc = 0
    call sic_i4(line,0,1,nc,.false.,error)
    if (error) return
    field = 0.
    call sic_r4(line,o_cont_comp,1,field,.false.,error)
    if (error) return
    call sub_cont_average(comm,hiuv,houv,nc,field,error)
    if (error) return
  case ('UV_HANNING')
    ! Drop the edge channels
    houv%gil%ref(1) = houv%gil%ref(1)-1 ! -1, not +1 
    houv%gil%nchan = houv%gil%nchan-2
  case ('UV_SMOOTH') 
    call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    if (sic_present(o_asym,0)) then
    ! Shift the reference pixel if NC is even ?
      if (mod(nc,2).eq.0) houv%gil%ref(1) = houv%gil%ref(1)+0.5
    endif
  case default
    call map_message(seve%e,comm,'Unrecognized choice '//comm)
    error = .true.
    return
  end select
  !
  ! Work with complete structure
  houv%gil%dim(1) = 3*houv%gil%nchan + 7 + houv%gil%ntrail ! and nothing more ...
  if (houv%gil%ntrail.ne.0) then
    do i=1,code_uvt_last
      if (houv%gil%column_pointer(i).gt.houv%gil%lcol)  &
        houv%gil%column_pointer(i) =  houv%gil%column_pointer(i) + houv%gil%dim(1) - hiuv%gil%dim(1)
    enddo
  endif
end subroutine uv_resample_args
!
subroutine uv_resample_mem(line,comm,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_resample_mem
  use gkernel_types
  use clean_def
  use clean_beams
  use clean_arrays
  use clean_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- Support routine for UV_RESAMPLE and similar actions
  !
  !   Resample in velocity the UV Table or compress it. This is
  !   the Memory only version, supporting commands:  
  !     UV_RESAMPLE NC [Ref Val Inc]   
  !     UV_COMPRESS [NC] [/CONTINUUM]  
  !     UV_HANNING   
  !     UV_SMOOTH NC   
  !!   
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Calling command
  logical, intent(out) :: error           !! Error flag
  !
  ! Constants
  integer, parameter :: o_cont_comp=1
  integer, parameter :: o_like=2
  integer, parameter :: o_asym=1
  !
  ! Local ---
  type(sic_descriptor_t) :: desc
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  character(len=4) :: arg(4)
  character(len=128) :: mess
  real(8) :: convert(3), velo
  integer :: nt, nc, nv, nchan, na, narg
  type (gildas) :: uvout
  integer :: nu, ni, i
  logical :: err, found, asym
  integer(kind=index_length)  :: nvisi        ! Number of visibilities
  character(len=filename_length) :: moldfile
  real :: field
  !
  ! Code ----
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,comm,'No UV data loaded')
    error = .true.
    return
  endif
  if (huv%gil%nstokes.gt.1) then
    call map_message(seve%e,comm,'Only single polarization data supported')
    error = .true.
    return
  endif
  !
  ! Channel range is no longer meaningful
  nbeam_ranges = -1
  call sic_delvariable ('BEAM_RANGES',.false.,error)
  call sic_delvariable ('DCHANFLAG',.false.,error)
  !
  error = .false.
  ! No argument: get back to the original UV data
  narg = sic_narg(0)
  if (narg.eq.0) then
    if (comm.eq.'UV_HANNING') then
      continue
    else if (comm.eq.'UV_COMPRESS'.and.sic_present(o_cont_comp,0)) then
      continue
    else if (comm.eq.'UV_RESAMPLE'.and.sic_present(o_like,0)) then
      call map_message(seve%w,comm,'/LIKE option not yet tested in this context')
    else
      ! 
      ! Return to previous (original) data - Caution: this suppress
      ! any Line/Continuum identification
      call sic_delvariable('UV',.false.,error)
      call uv_reset_buffer(comm)
      call uv_new_data(weight=.true.,resample=.false.)
      return
    endif
  endif
  !
  ! Compute the Frequency Conversion from the Velocity Conversion
  call gildas_null(uvout, type = 'UVT')
  call gdf_copy_header(huv,uvout,error)
  !
  if (comm.eq.'UV_RESAMPLE') then
    if (sic_narg(0).gt.0) then
      nc = 0
      !    SIC__CH would complain if argument is too long, SIC_KE is silent
      call sic_ke(line,0,1,arg(1),na,.true.,error)
      error = .false.
      if (arg(1).ne.'*') call sic_i4(line,0,1,nc,.true.,error)
      if (error) return
      !
      ! Set default resampling in Velocity
      convert(1) = huv%gil%ref(1)
      convert(2) = huv%gil%voff
      convert(3) = huv%gil%vres
      ! Get new one
      do i=2,sic_narg(0)
        call sic_ke(line,0,i,arg(i),na,.false.,error)
        error = .false.
        if (arg(i).ne.'*') call sic_r8(line,0,i,convert(i-1),.false.,error)
        if (error) return
      enddo
      !
      ! Fill missing arguments
      if (nc.eq.0) then
        nc = nint(abs(huv%gil%nchan*huv%gil%vres/convert(3)))
        if (arg(2).eq.'*') then
          ! Keep the middle channel in the middle
          velo = (0.5d0*huv%gil%nchan-huv%gil%ref(1))*huv%gil%vres + huv%gil%voff
          convert(1) = 0.5d0*nc - (velo-convert(2))/convert(3)
        endif
      endif
    else if (sic_present(o_like,0)) then
      !
      call sic_ch(line,o_like,1,moldfile,nc,.true.,error)
      if (error) return
      call gdf_copy_header(huv,uvout,error)
      call uv_resample_like(uvout,moldfile,convert,nc,error)
    else
      call map_message(seve%e,comm,'Should not be there ...')
      error = .true.
      return
    endif
    !
    call getuv_conversion(uvout,nc,convert)
    !
    ! NC Ref Val Inc
    write(mess,'(A,I0,X,3(F12.3))') 'Resampling to ',nc,convert(1:3)
    call map_message(seve%i,comm,mess) 
    !
  else if (comm.eq.'UV_COMPRESS') then
    nc = 0
    call sic_i4(line,0,1,nc,.false.,error)
    if (error) return
    !
    field = 0.
    call sic_r4(line,o_cont_comp,1,field,.false.,error)
    if (error) return
    !
    huv%r2d => duv
    call sub_cont_average(comm,huv,uvout,nc,field,error)
    if (error) return
    !
! Unused code ?
!    if (sic_narg(o_cont_comp).gt.0) then
!      call sic_let_inte('UV_COMPRESS',nc,error)
!      return
!    endif
  else if (comm.eq.'UV_HANNING') then
    ! Drop the edge channels
    uvout%gil%ref(1) = uvout%gil%ref(1)-1
    uvout%gil%nchan = uvout%gil%nchan-2
    continue
  else if (comm.eq.'UV_SMOOTH') then
    call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    huv%r2d => duv
    asym = sic_present(o_asym,0)
    if (asym) then
      ! Shift the reference pixel if NC is even 
      if (mod(nc,2).eq.0) uvout%gil%ref(1) = uvout%gil%ref(1)+0.5
    endif
  else
    call map_message(seve%e,comm,'Unrecognized choice '//comm)
    error = .true.
    return
  endif
  !
  ! Work with complete structure
  uvout%gil%dim(1) = 3*uvout%gil%nchan + 7 + uvout%gil%ntrail ! and nothing more ...
  if (uvout%gil%ntrail.ne.0) then
    do i=1,code_uvt_last
      if (uvout%gil%column_pointer(i).gt.uvout%gil%lcol) uvout%gil%column_pointer(i) =  &
        & uvout%gil%column_pointer(i) + uvout%gil%dim(1) - huv%gil%dim(1)
    enddo
  endif
  !
  ni = huv%gil%dim(1)
  nu = uvout%gil%dim(1)
  nv = uvout%gil%dim(2)
  nvisi = uvout%gil%nvisi
  nt = uvout%gil%ntrail
  nchan = uvout%gil%nchan
  !
  ! Prepare appropriate array...
  nullify (duv_previous, duv_next)
  call uv_find_buffers (comm,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,comm,'Cannot set buffer pointers')
    return
  endif
  !
  ! Now resample
  if (comm.eq.'UV_RESAMPLE') then
    nvisi = huv%gil%nvisi
    call resample_uv (huv,uvout,duv_previous,duv_next,nvisi,nt,dchanflag)
  else if (comm.eq.'UV_COMPRESS') then
    call compress_uv (duv_next,nu,nv,nchan,duv_previous,ni,nc,nt,dchanflag)
  else if (comm.eq.'UV_HANNING') then
    call hanning_uv (duv_next,nu,nvisi,nchan,duv_previous,ni,nt,dchanflag)
  else if (comm.eq.'UV_SMOOTH') then
    call smooth_uv (duv_next,nu,nvisi,nchan,duv_previous,nc,nt,asym,dchanflag)
  endif
  !
  ! Check channel boundaries, to flag the incomplete ones
  call uvflag_edges(huv,uvout,nu,nv,duv_next)
  !
  ! Set header back
  call gdf_copy_header(uvout,huv,error)
  !
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Delete variables that may have been affected
  err = .false.
  call sic_descriptor('UVS',desc,found)  
  if (found) call sic_delvariable('UVS',.false.,err)
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true., resample=.true.)
end subroutine uv_resample_mem
!
subroutine hanning_uv (duvout, nu, nv, nchan, duvin, ni, ntrail, filtered)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_HANNING 
  !    
  !   This is equivalent to UV_SMOOTH 2
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nu             !! Ouput Visibility size
  integer(kind=index_length), intent(in) :: nv !! Number of visibilities
  integer, intent(in) :: nchan          !! Number of ouput channels
  integer, intent(in) :: ntrail         !! Trailing columns
  integer, intent(in) :: ni             !! Input Visibility size
  real, intent(in) :: duvin(ni,nv)      !! Input visibilities
  real, intent(out) :: duvout(nu,nv)    !! Output visibilities
  integer, intent(in), optional :: filtered(:) !! List of filtered channels
  !
  ! Constants
  real, parameter :: w(3) = [0.5,1.0,0.5]
  !
  ! Local ---
  integer :: nlead, mc
  integer :: i,j,k,kk
  real :: a,b,c,r
  integer, allocatable :: filtre(:)
  !
  ! Code ----
  nlead = 7
  duvout = 0
  !
  if (present(filtered)) then
    mc = size(filtered)
    allocate(filtre(mc))
    filtre(:) = filtered
  else
    allocate(filtre(nchan))
    filtre = 1
  endif
  do j=1,nv
    duvout (1:nlead,j) =  duvin (1:nlead,j)  
    do i=1,nchan
      a = 0
      b = 0
      c = 0
      do k=1,3
        kk = nlead+3*(i+k-1)  ! i=1, k=1, ==> kk=10
        if ((duvin(kk,j).gt.0).and.(filtre(k).gt.0)) then
          r = duvin(kk,j)*w(k)
          a = a+duvin(kk-2,j)*r
          b = b+duvin(kk-1,j)*r
          c = c+r
        endif
      enddo
      kk = nlead+3*i-2  ! i=1 ==> kk=8
      if (c.ne.0) then
        duvout(kk,j) = a/c
        duvout(kk+1,j) = b/c
        duvout(kk+2,j) = c         ! time*band
      else
        duvout(kk,j) = 0
        duvout(kk+1,j) = 0
        duvout(kk+2,j) = 0
      endif
    enddo
    if (ntrail.gt.0) then
      duvout(nu-ntrail+1:nu,j) = duvin(ni-ntrail+1:ni,j)
    endif
  enddo
end subroutine hanning_uv
!
subroutine smooth_uv (duvout, nu, nv, nchan, duvin, mc, ntrail, asym, filtered)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_SMOOTH  Nc [/ASYMMETRIC]
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nu             !! Ouput Visibility size
  integer(kind=index_length), intent(in) :: nv    !! Number of visibilities
  integer, intent(in) :: nchan          !! Number of channels
  integer, intent(in) :: ntrail         !! Trailing columns
  integer, intent(in) :: mc             !! Smoothing factor
  real, intent(in) :: duvin(nu,nv)      !! Input visibilities
  real, intent(out) :: duvout(nu,nv)    !! Output visibilities
  logical, intent(in) :: asym           !! Asymmetric smoothing ?
  integer, intent(in), optional :: filtered(:)  !! List of filtered channels
  !
  ! Local ---
  integer :: nlead, nc
  integer :: j,k,kk
  integer :: ic,jm,jp,kc,lc
  integer, allocatable :: im(:),ip(:)
  real :: a,b,c,r
  logical :: odd
  integer, allocatable :: filtre(:)
  !
  ! Code ----
  nlead = 7
  if (present(filtered)) then
    nc = size(filtered)
    allocate(filtre(nc))
    filtre(:) = filtered
  else
    allocate(filtre(nu))  ! Too big, not an issue
    filtre = 1
  endif
  !
  kc = mc
  nc = kc/2
  odd = mod(kc,2).ne.0 
  kc = 2*nc+1
  allocate(im(nchan),ip(nchan))
  !
  ! Define method 
  do ic=1,nchan
    if (asym) then
      lc = (mc-1)/2
      jm = max(1,ic-lc)
      jp = min(nchan,ic+mc-lc-1)
    else
      ! We must ensure that the smoothing is symmetric, as we want to preserve the
      ! spectral sampling of the initial data.
      !
      ! This is a symmetric smoothing, but limited at edges by available data.
      jm = ic-nc
      jp = ic+kc-nc-1
      if (jm.lt.1) then
        lc = ic-1
        jm = 1
        jp = ic+lc
      else if (jp.gt.nchan) then
        lc = nchan-ic
        jm = ic-lc
        jp = ic+lc
      endif
    endif
    !
    im(ic) = jm
    ip(ic) = jp
  enddo
  !
  duvout = 0
  !
  ! Compress each visibility
  do j=1,nv
    duvout (1:nlead,j) =  duvin (1:nlead,j)  
    do ic=1,nchan
      a = 0
      b = 0
      c = 0
      if (asym.or.odd) then
        do k=im(ic),ip(ic)
          kk = nlead+3*k  ! k=1, ==> kk=10
          if ((duvin(kk,j).gt.0).and.(filtre(k).gt.0)) then
            r = duvin(kk,j)
            a = a+duvin(kk-2,j)*r
            b = b+duvin(kk-1,j)*r
            c = c+r
          endif
        enddo
      else
        do k=im(ic),ip(ic)
          kk = nlead+3*k  ! k=1, ==> kk=10
          if ((duvin(kk,j).gt.0).and.(filtre(k).gt.0)) then
            r = duvin(kk,j)
            if ((k.eq.im(ic)).or.(k.eq.ip(ic))) r = r/2
            a = a+duvin(kk-2,j)*r
            b = b+duvin(kk-1,j)*r
            c = c+r
          endif
        enddo
      endif
      !
      kk = nlead+3*ic-2  ! i=1 ==> kk=8
      if (c.ne.0) then
        duvout(kk,j) = a/c
        duvout(kk+1,j) = b/c
        duvout(kk+2,j) = c         ! time*band
      else
        duvout(kk,j) = 0
        duvout(kk+1,j) = 0
        duvout(kk+2,j) = 0
      endif
    enddo
    if (ntrail.gt.0) then
      duvout(nu-ntrail+1:nu,j) = duvin(nu-ntrail+1:nu,j)
    endif
  enddo
end subroutine smooth_uv
!
subroutine sub_cont_average(comm,hiuv,houv,usernc,field,error)
  use image_def
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => sub_cont_average
  !---------------------------------------------------------------------
  ! @ private
  !*   
  ! IMAGER  -- Support for command UV_COMPRESS [NC] [/CONTINUUM]  
  !
  ! Derive the compression factor NC and set the output Header
  ! properly. Also used by UV_SELF command
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm    !! Command name
  type(gildas), intent(inout) :: hiuv     !! Original UV data
  type(gildas), intent(inout) :: houv     !! Resampled UV data header
  integer, intent(inout) :: usernc        !! Compression factor
  real, intent(inout) :: field            !! Field of view
  logical, intent(out) :: error           !! Error flag
  !
  ! Constants
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  character(len=80) :: mess
  real :: uvmax, uvmin
  integer :: msize, nc
  type (uvmap_par) :: map
  real(8) :: freq
  !  
  ! Code ----
  error = .false.
  if (usernc.gt.0) then
    nc = usernc
  else if (usernc.eq.0) then
    msize = field
    if (msize.eq.0) msize = maxval(default_map%size)
    if (msize.eq.0) then
      map = default_map
      freq = gdf_uv_frequency(hiuv)
      call uvgmax (hiuv,hiuv%r2d,uvmax,uvmin)
      ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
      uvmax = uvmax*freq*f_to_k
      uvmin = uvmin*freq*f_to_k
      error = .false.
      call map_parameters(comm,map,hiuv,freq,uvmax,uvmin,error)
      if (error) return
      msize = maxval(map%size)
    endif
    ! The factor 2 is to account for the Cleaning area
    msize = msize/2
    nc = 0
    call t_channel_sampling (comm,hiuv,nc,msize)
  else
    write(mess,'(A,I6,A)') 'Invalid Averaging number ',usernc
    call map_message(seve%e,comm,mess)
    error = .true.
    return
  endif
  if (nc.gt.hiuv%gil%nchan) nc = hiuv%gil%nchan
  write(mess,'(A,I6,A)') 'Averaging by chunks of ',nc,' channels'
  call map_message(seve%i,comm,mess,3)
  !
  ! Set header
  houv%gil%inc(1) = houv%gil%inc(1)*nc
  houv%gil%ref(1) = (2.0d0*houv%gil%ref(1)+nc-1.0)/(2*nc)
  houv%gil%vres = nc*houv%gil%vres
  houv%gil%fres = nc*houv%gil%fres
  ! Change the number of channels
  houv%gil%nchan = houv%gil%nchan/nc
  if (usernc.gt.0) return
  !
  ! Return the derived number of channels if not already specified
  usernc = nc
  !
  ! and Round up  the number of channels to avoid losing sensitivity
  if (houv%gil%nchan*nc.ne.hiuv%gil%nchan) houv%gil%nchan = houv%gil%nchan+1
end subroutine sub_cont_average
!
subroutine uvflag_edges(huvin, huvout, nu, nv, duv)  
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !!
  ! IMAGER --- Support routine for UV Resampling:
  !
  ! flag edge channels if not fully covered in the operation
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: huvin    !! Input UV header
  type(gildas), intent(in) :: huvout   !! Output UV header
  integer, intent(in) :: nu, nv        !! Visibility array size
  real, intent(inout) :: duv(nu,nv)    !! Visibility array
  !
  ! Local ---
  integer :: ic,jc,imin,imax
  real :: vmin, vmax
  !
  ! Code ----
  if (huvin%gil%vres.gt.0) then
    vmin = (0.5-huvin%gil%ref(1))*huvin%gil%vres + huvin%gil%voff
    vmax = (huvin%gil%nchan+0.5-huvin%gil%ref(1))*huvin%gil%vres + huvin%gil%voff
  else
    vmin = (huvin%gil%nchan+0.5-huvin%gil%ref(1))*huvin%gil%vres + huvin%gil%voff
    vmax = (0.5-huvin%gil%ref(1))*huvin%gil%vres + huvin%gil%voff
  endif
  !
  if (huvout%gil%vres.gt.0) then
    imin = (vmin-huvout%gil%voff)/huvout%gil%vres + huvout%gil%ref(1)
    imax = (vmax-huvout%gil%voff)/huvout%gil%vres + huvout%gil%ref(1)
  else
    imin = (vmax-huvout%gil%voff)/huvout%gil%vres + huvout%gil%ref(1)
    imax = (vmin-huvout%gil%voff)/huvout%gil%vres + huvout%gil%ref(1)
  endif
  !
  if (imin.gt.0) then
    do ic=1,imin
      jc = 7+3*ic
      duv(jc,:) = 0.
    enddo
  endif
  if (imax.lt.huvout%gil%nchan) then
    do ic=imax,huvout%gil%nchan
      jc = 7+3*ic
      duv(jc,:) = 0.
    enddo
  endif
end subroutine uvflag_edges
!
subroutine uv_resample_like(houv,moldfile,convert,nc,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_RESAMPLE /LIKE MoldFile
  !
  !   Derive the conversion formula and numer of channels from MoldFile
  !   MoldFile can be Cube or UV data.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: houv       !! UV data header
  character(len=*), intent(in) :: moldfile  !! Template for velocity resampling
  real(8), intent(out) :: convert(3)        !! Conversion formula (Increment, Value, Reference)
  integer, intent(out) :: nc                !! Number of output channels
  logical, intent(out) :: error             !! Logical error flag
  !
  character(len=*), parameter :: comm='UV_RESAMPLE'
  !
  ! Local ---
  character(len=132) :: mess
  type(gildas) :: hmold
  logical :: do_mod
  real(8) :: freqs
  real(4) :: velos
  !
  ! Code ----
  call gildas_null(hmold,'UVT')
  call sic_parse_file(moldfile,' ','.uvt',hmold%file)
  call gdf_read_header(hmold,error)
  if (error) then
    call map_message(seve%e,comm,'Cannot open '//trim(hmold%file))
    return
  endif
  !
  ! Check that the Reference Frequencies and Velocities are the same also...
  ! use the SPECIFY method if needed to guarantee this is the case
  do_mod = .false.
  if (hmold%gil%freq .ne. houv%gil%freq) then
    write(mess,*) 'Different Frequencies Mold:',hmold%gil%freq,', Data: ',houv%gil%freq
    call map_message(seve%i,comm,mess)
  endif
  freqs = houv%gil%freq
  if (hmold%gil%voff .ne. houv%gil%voff) then
    write(mess,*) 'Different Velocities Mold:',hmold%gil%voff,', Data: ',houv%gil%voff
    call map_message(seve%w,comm,mess)
    do_mod = .true.
  endif
  velos = hmold%gil%voff  ! Will be done by the resampling
  if (do_mod) then
    call gdf_modify(houv,velos,freqs,error=error)
    if (error) return
  endif
  !
  ! Define number of channels
  if (abs(hmold%gil%type_gdf).eq.abs(code_gdf_uvt)) then
    nc = hmold%gil%nchan
  else
    nc = hmold%gil%dim(hmold%gil%faxi)
  endif
  !
  convert(1) = hmold%gil%ref(1)
  convert(2) = hmold%gil%voff
  convert(3) = hmold%gil%vres
end subroutine uv_resample_like

subroutine statistic (line,error)
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, except_this=>statistic
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use clean_support
  use gbl_message
  use iso_c_binding
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !   STATISTIC Image [PlaneStart PlaneEnd] [/EDGE Edge] [/FILE FileName]
  !     [/NOISE Variable] [/UPDATE [NOISE|EXTREMA]]
  !
  !     Compute Statistics on internal image, and optionally
  !   return the noise level in the specified Variable.
  !   Image is the name of one of the internal images (DIRTY, CLEAN,
  !   RESIDUAL, SKY, etc...), or any SIC Image variable, or
  !     If the /FILE option is given, the work is done from an output file
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(out) :: error           !! Logical error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: o_edge=1
  integer, parameter :: o_file=2
  integer, parameter :: o_noise=3
  integer, parameter :: o_update=4
  character(len=*), parameter :: rname = 'STATISTIC'
  character(len=8), parameter :: cnoise= 'NOISE   '
  character(len=8), parameter :: cextr = 'EXTREMA '
  !
  ! Local ---
  type (gildas), pointer :: hstat
  type (gildas), target :: htmp
  real, pointer :: dstat(:,:,:)
  integer ier, ipfirst, iplast, na, nx, ny, nz, nv
  character(len=12) argum,stype
  character(len=filename_length) :: file
  logical do_mask, do_whole, do_update
  real valmin, valmax, mean, rms, noise, beam, flux, sec, jyperk
  integer imin, imax, jmin, jmax, kmin, kmax, box(4), n, idx, i, j
  integer :: my_blc(2), my_trc(2)
  integer(kind=size_length) :: n_sup, n_off
  character(len=24) :: prefix, postfix
  character(len=3) :: fixpre
  character(len=64) :: var
  character(len=80) :: chain
  character(len=42) :: short
  character(len=12) :: uunit
  real :: scale, uscale, edge
  real, save :: stat_noise = 0.0
  !
  type(sic_descriptor_t) :: desc
  logical :: found, verbose, is_avar, rdonly , do_extrema, do_sky, do_noise
  !
  type(c_ptr) :: cptr
  real, pointer :: r
  real(8), pointer :: d
  real(4), pointer :: a_mask(:,:,:)
  real(4), target :: null_mask(1,1,1)
  logical :: old_fit, old_plot
  !
  ! Code ---
  sec = 180*3600/pi
  ! Save DO_MASK
  do_mask = the_method%do_mask
  verbose = .not.sic_present(o_noise,0)
  do_update = sic_present(o_update,0)
  if (do_update) then
    argum = 'NOISE'
    call sic_ke(line,o_update,1,argum,na,.false.,error)
    error = .true.
    if (na.le.8) then
      if (argum(1:na).eq.cnoise(1:na)) then
        do_extrema = .false.
        error = .false.
      else if (argum(1:na).eq.cextr(1:na)) then
        do_extrema = .true.
        error = .false.
      endif
    endif
    if (error) then
      call map_message(seve%e,rname,'Invalid keyword '//argum(1:na)//' for option /UPDATE')
      return
    endif
  else
    do_extrema = .false.
  endif
  do_sky = .false.
  !
  ! Type of image (default = last_shown)
  !
  argum = last_shown
  call sic_ke (line,0,1,argum,na,.false.,error)
  stype = argum
  !
  ! Plane
  ipfirst = 0
  call sic_get_inte ('FIRST',ipfirst,error)
  call sic_i4(line,0,2,ipfirst,.false.,error)
  if (error) return
  iplast = ipfirst
  call sic_i4(line,0,3,iplast,.false.,error)
  if (error) return  
  !
  do_noise = sic_present(o_noise,1)
  if (do_noise) then
    call sic_ke(line,o_noise,1,var,n,.true.,error)
    if (error) return
  endif
  !
  ! Avoid edges
  ! ! box = [nx/16,ny/16,15*nx/16,15*ny/16]
  edge = 1./16.
  call sic_r4(line,o_edge,1,edge,.false.,error)
  if ((edge.le.0).or.(edge.gt.1)) then
    call map_message(seve%e,rname,'Invalid Edge value, must be in [0,1[')
    error = .true.
    return
  endif
  !
  ! Allocate memory
  is_avar = .false.
  select case (stype)
  case ('CLEAN')
    if (.not.allocated(dclean)) then
      call map_message(seve%e,rname,'No Clean image')
      error = .true.
      return
    endif
    hstat => hclean
    dstat => dclean
  case ('DIRTY')
    if (.not.allocated(ddirty)) then
      call map_message(seve%e,rname,'No Dirty image')
      error = .true.
      return
    endif
    hstat => hdirty
    dstat => ddirty
  case ('RESIDUAL')
    if (.not.allocated(dresid)) then
      call map_message(seve%e,rname,'No Residual image')
      error = .true.
      return
    endif
    hstat => hresid
    dstat => dresid
  case ('SKY')
    if (.not.allocated(dsky)) then
      call map_message(seve%e,rname,'No Sky image')
      error = .true.
      return
    endif
    hstat => hsky
    dstat => dsky
    do_sky = .not.sic_present(o_noise,2)
  case ('CONTINUUM')
    if (.not.allocated(dcont)) then
      call map_message(seve%e,rname,'No Continuum image')
      error = .true.
      return
    endif
    hstat => hcont
    cptr = c_loc(dcont)
    hstat%gil%dim(3) = 1
    CALL C_F_POINTER(CPTR, DSTAT, hstat%gil%dim(1:3) )    
  case default
    if (sic_present(o_file,0)) then
      ! /FILE option
      call sic_ch(line,0,1,file,n,.true.,error)
      call gildas_null(htmp)
      call sic_parse_file (file,' ','.gdf',htmp%file)
      call gdf_read_header(htmp,error)
      if (error) return
      !
      if (htmp%gil%dim(4).gt.1) then
        call map_message(seve%e,rname,'/FILE option only valid for 2D or 3D data')
        error = .true.
        return
      endif
      htmp%blc(3) = max(1,min(ipfirst,htmp%gil%dim(3)))
      if (iplast.eq.0) then
        htmp%trc(3) = htmp%gil%dim(3)
      else
        htmp%trc(3) = min(htmp%gil%dim(3),iplast)
      endif
      if (htmp%blc(3).gt.htmp%trc(3)) then
        call map_message(seve%e,rname,'Invalid plane range')
        error = .true.
        return
      endif
      !
      hstat => htmp
      !
      allocate(dstat(hstat%gil%dim(1),hstat%gil%dim(2),hstat%gil%dim(3)),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'/FILE memory allocation failure')
        error = .true.
        return
      endif
      call gdf_read_data(htmp,dstat,error)
      !
      ipfirst = 0
      iplast  = 0
      hstat%blc = 0
      hstat%trc = 0
    else if (sic_varexist(stype)) then
      !
      ! Statistic on any SIC Image variable
      call get_gildas(rname,stype,desc,htmp,error)
      if (error) return
      hstat => htmp
      call i8toi8(desc%addr,cptr,1)
      CALL C_F_POINTER(CPTR, DSTAT, desc%dims(1:3) )
      !
      is_avar = associated(desc%head)
    else
      call map_message(seve%e,rname,'Unkown SIC image or Buffer '//trim(STYPE))
      error = .true.
      return
    endif
  end select
  !
  if (do_extrema) then
    hstat%loca%addr = locwrd(dstat)
    call gdf_get_extrema(hstat,error)
    return
  endif
  !
  ! Local support
  nx = hstat%gil%dim(1)
  ny = hstat%gil%dim(2)
  nz = max(1,hstat%gil%dim(3)) 
  !
  if (ipfirst.eq.0) ipfirst = 1
  ipfirst = min(nz,ipfirst)
  if (iplast.gt.0) then
    iplast = min(nz,iplast)
  else
    iplast = nz+iplast
  endif
  if (.not.sic_present(o_file,0)) then
    write(chain,'(A,I0,A,I0,A)') 'plane range [',ipfirst,'-',iplast,']'
    if (iplast.lt.ipfirst) then
      call map_message(seve%e,rname,'Invalid '//chain)
      error = .true.
      return
    endif
    if (sic_lire().eq.0) call map_message(seve%i,rname,'Using '//chain)
  else 
    if (sic_lire().eq.0) call map_message(seve%i,rname,'Using file '//file)
  endif
  !
  ! Avoid edges
  do_whole =.false.
  ! ! box = [nx/16,ny/16,15*nx/16,15*ny/16]
  edge = 1./16.
  call sic_r4(line,o_edge,1,edge,.false.,error)
  if (edge.eq.0) then
    do_whole = .true.
  else if (edge.gt.0 .and. edge.lt.1) then
    box(1) = nint(nx*edge)
    box(2) = nint(ny*edge)
    box(3) = nx-box(1)+1
    box(4) = ny-box(2)+1
  else
    call map_message(seve%e,rname,'Invalid Edge value, must be in [0,1[')
    error = .true.
    return
  endif
  !
  if (do_whole) then
    if (verbose) call map_message(seve%i,rname,'Using the whole image')
    a_mask => null_mask
    box = [1,1,nx,ny]    ! Must be initialized properly
  else if (support_type.eq.support_mask) then
    if (verbose) call map_message(seve%i,rname,'Using current Mask')
    a_mask => dmask
  else if (support_type.eq.support_poly) then
    if (verbose)  call map_message(seve%i,rname,'Using current Support')
    ! Mask evaluation from Polygon if any
    call check_mask(the_method,hstat)
    if (allocated(d_mask)) then
      allocate(a_mask(nx,ny,1),stat=ier)
      a_mask = 0
      where (d_mask) a_mask(:,:,1) = 1.
    else
      a_mask => null_mask
    endif
  else
    my_blc = user_method%blc
    my_trc = user_method%trc
    call check_box(nx,ny,my_blc,my_trc)
    if (verbose) then
      write(chain,'(A,X,I0,X,I0,A,X,I0,X,I0)') 'Using default Box: BLC', &
      & my_blc,'; TRC ',my_trc
      call map_message(seve%i,rname,chain)
    endif
    allocate(a_mask(nx,ny,1),stat=ier)
    a_mask = 0
    do j=my_blc(2),my_trc(2)
      do i=my_blc(1),my_trc(1)
        a_mask(i,j,1) = 1.0
      enddo
    enddo
  endif
  !
  ! Compute stat
  nv = iplast-ipfirst+1
  if (do_whole) then
    call compute_stat(nx,ny,nv,dstat(:,:,ipfirst:iplast), & ! memory(ipstat)
       &    box,valmin,imin,jmin,kmin,valmax,imax,jmax,kmax, & 
       &    mean,rms,noise, &
       &    n_sup,n_off,hstat%gil%bval,hstat%gil%eval)
  else
    call compute_stat(nx,ny,nv,dstat(:,:,ipfirst:iplast), & ! memory(ipstat)
       &    box,valmin,imin,jmin,kmin,valmax,imax,jmax,kmax, & 
       &    mean,rms,noise, &
       &    n_sup,n_off,hstat%gil%bval,hstat%gil%eval, &
       &    a_mask)
  endif
  !
  ! Clean up the local mask
  if (support_type.eq.support_mask) then
    nullify (a_mask)
  else if (associated(a_mask,null_mask)) then
    nullify (a_mask)
  else
    deallocate(a_mask,stat=ier)
  endif
  !
  ! Return values 
  if (do_update) then
    hstat%gil%rmax = valmax
    hstat%gil%rmin = valmin
    hstat%gil%minloc(1:3) = [imin,jmin,kmin+ipfirst-1]
    hstat%gil%maxloc(1:3) = [imax,jmax,kmax+ipfirst-1]
    hstat%gil%rms = noise
    !
    if (is_avar) then
      rdonly = desc%readonly
      desc%readonly = .false.
      call gdf_copy_header(hstat,desc%head,error)
      desc%readonly = rdonly
    endif
  endif
  !
  call sic_delvariable ('STAT_NOISE',.false.,error)
  stat_noise = noise
  call sic_def_real ('STAT_NOISE',stat_noise,0,0,.false.,error)  
  !
  ! Update STAT_NOISE if a SKY image is handled...
  if (do_sky) then
    old_plot = noise_plot
    old_fit = noise_fit
    noise_type = 0
    noise_plot = .false.
    noise_fit = .true.
    call exec_program('@ p_view_noise SKY stat_noise')
    noise_plot = old_plot
    noise_fit = old_fit
    noise = stat_noise
  endif
  !
  if (verbose) then
    write(*,101) 'Found ',n_sup,' pixels on, ',n_off,' off source'
    !
    ! Find the appropriate unit (Jy, mJy or microJy)
    if (noise.lt.1e-5) then
      scale = 1e6
      prefix = ' micro'//hstat%char%unit
    else if (noise.lt.0.01) then
      scale = 1e3
      prefix = ' m'//hstat%char%unit
    else
      scale = 1.0
      prefix = ' '//hstat%char%unit
    endif
    !
    ! Compute Total Flux if possible
    jyperk = 0
    uunit = hstat%char%unit
    call sic_upper(uunit)
    if (uunit.eq.'JY/BEAM') call get_jyperk(hstat,beam,jyperk)
    !
    if (jyperk.ne.0) then
      !
      beam = beam/abs(hstat%gil%convert(3,1)*hstat%gil%convert(3,2))
      !
      if (jyperk*scale.gt.1e3) then
        uscale = 1e-3
        fixpre = 'mK'
      else
        uscale = 1
        fixpre = ' K'
      endif
      !
      write(*,1002) ' Map minimum at (',imin,jmin,kmin,') : ',valmin*scale, &
        & prefix,valmin/jyperk*uscale,fixpre
      write(*,1002) ' Map maximum at (',imax,jmax,kmax,') : ',valmax*scale, &
        & prefix,valmax/jyperk*uscale,fixpre
      !
      write(*,1003) ' RMS:       On-source:                   ', rms*scale, &
        & trim(prefix),rms/jyperk*uscale,fixpre
      write(*,1003) ' RMS:      Off-source:                   ', noise*scale, &
        & trim(prefix), noise/jyperk*uscale,fixpre
      write(*,1003) ' RMS:         Thermal:                   ', hstat%gil%noise*scale, &
        & trim(prefix), hstat%gil%noise/jyperk*uscale,fixpre
      !
      write(*,'(A,F8.1,A,F8.1)') ' Dynamic range: ',valmax/noise,  &
        & ' -- ',-3.0*valmax/valmin
      write(*,105) ' Tb scale for '//trim(stype)//' map: 1 '//fixpre//' = ',   &
        &      jyperk*uscale*scale,trim(prefix)
      write(*,106) 'Clean Beam is ',   &
        &      hstat%gil%majo*sec,' x ',hstat%gil%mino*sec,   &
        &      ' sec at PA = ',hstat%gil%posa*180/pi,' deg'
      !
      flux = (mean*n_sup)/beam
      if (flux.gt.1) then
        scale = 1.0
        prefix = ' '//hstat%char%unit 
      endif
      idx = index(prefix,'/')
      if (idx.eq.0) then
        idx = len_trim(prefix)
      else
        idx = idx-1
      endif
      postfix = ' '
      if ((nv.gt.1).and.(hstat%gil%faxi.ne.0)) then
        scale = scale*abs(hstat%gil%inc(hstat%gil%faxi))
        if (hstat%char%code(hstat%gil%faxi).eq.'VELOCITY') then
          postfix = '.km/s'
        else if (hstat%char%code(hstat%gil%faxi).eq.'FREQUENCY') then
          postfix = '.MHz'
        endif
      endif
      write(*,104) 'Total flux in '//trim(stype)//' map: ',flux*scale,trim(prefix(1:idx))//postfix
      call sic_delvariable ('TOTAL_FLUX',.false.,error)
      call sic_def_real ('TOTAL_FLUX',flux,0,0,.false.,error)
      !
      ! Set the CLEAN rms to the Off source noise.
      hstat%gil%rms = noise
    else
      ! Figure out the expected intensity range
      if (valmax*scale.gt.1E5) then
        write(short,1002) ' Map minimum at (',imin,jmin,kmin,') : '
        write(*,*) short,valmin*scale, prefix
        write(short,1001) ' Map maximum at (',imax,jmax,kmax,') : '
        write(*,*) short,valmax*scale, prefix
        write(*,*) ' RMS:       On-source:                   ', rms*scale,trim(prefix)
        write(*,*) ' RMS:      Off-source:                   ', noise*scale,trim(prefix)
        write(*,*) ' RMS:         Thermal:                   ', hstat%gil%noise*scale,trim(prefix)
      else
        write(*,1002) ' Map minimum at (',imin,jmin,kmin,') : ',valmin*scale, prefix
        write(*,1002) ' Map maximum at (',imax,jmax,kmax,') : ',valmax*scale, prefix
        write(*,1003) ' RMS:       On-source:                   ', rms*scale,trim(prefix)
        write(*,1003) ' RMS:      Off-source:                   ', noise*scale,trim(prefix)
        write(*,1003) ' RMS:         Thermal:                   ', hstat%gil%noise*scale,trim(prefix)
      endif
      !
      if (stype.eq.'DIRTY') hstat%gil%rms = noise
    endif
    !
  else if (do_noise) then
    ! /NOISE option
    ! call sic_let_real(var,noise,error) !! That seems to work only for GLOBAL variables
    !
    call sic_descriptor(var,desc,found)  
    if (.not.found) then
      call map_message(seve%e,rname,'/NOISE variable does not exist')
      error = .true.
      return
    endif
    !
    if (desc%type.eq.fmt_r4) then
      call adtoad(desc%addr,cptr,1)
      call c_f_pointer(cptr,r)
      r = stat_noise
    else if (desc%type.eq.fmt_r8) then
      call adtoad(desc%addr,cptr,1)
      call c_f_pointer(cptr,d)
      d = stat_noise
    else
      call map_message(seve%e,rname,'/NOISE variable must be Real or Double')
      error = .true.
      return
    endif
    !
  endif
  !
  ! To be checked... What happens if working on a file ?
  !
  101   format (1x,a,i0,a,i0,a)
  104   format (1x,a,f10.4,a)
  105   format (1x,a,f9.4,a)
  106   format (1x,a,f7.3,a,f7.3,a,f5.0,a)
  1001  format (a,i6,',',i6,',',i6,a,f10.3,a,f10.3,a)
  1002  format (a,i6,',',i6,',',i6,a,f10.3,a,f10.3,a)
  1003  format (A,0PF10.3,A,0PF10.3,A) 
  !
end subroutine statistic
!
subroutine compute_stat(nx,ny,nv,amap,box, &
     &    vmin,ipmin,jpmin,kpmin,vmax,ipmax,jpmax,kpmax, &
     &    mean,rms,noise,np,nn, &
     &    bval,eval, support)
  use gildas_def
  !$ use omp_lib
  !--------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for command STATISTIC
  !
  !    Compute Statistics on image
  !!
  !--------------------------------------------------------------
  integer(kind=size_length), intent(out) :: np   !! Number of source data points
  integer(kind=size_length), intent(out) :: nn   !! Number of empty sky data points
  integer, intent(in) :: nx,ny,nv                !! Image size
  real, intent(in) :: amap(nx,ny,nv)             !! Input data cube
  integer, intent(out) :: ipmin, jpmin, kpmin    !! Position of Min
  integer, intent(out) :: ipmax, jpmax, kpmax    !! Position of Max
  integer, intent(in) ::  box(4)                 !! 2-D subset being considered 
  real, intent(out) :: vmin, vmax                !! Min Max
  real, intent(out) :: mean, rms, noise          !! Statistic values
  real, intent(in) :: bval, eval                 !! Blanking values
  real, intent(in), optional :: support(:,:,:)   !! 3-D support
  !
  integer(kind=size_length) :: i,j,k,l,nb
  real(8) :: val, mean1, mean2, meano
  real, allocatable :: valmin(:), valmax(:)
  integer, allocatable :: imin(:), jmin(:), kmin(:)
  integer, allocatable :: imax(:), jmax(:), kmax(:)
  integer :: nm,it,nt, jt(1)
  logical :: do_support
  !
  do_support = present(support)
  if (do_support) then
    nm = ubound(support,3)
  else
    nm = 0
  endif
  !
  nt = 1
  !$ nt = omp_get_max_threads()
  allocate(valmin(nt),valmax(nt),imin(nt),imax(nt), &
  & jmin(nt),jmax(nt),kmin(nt),kmax(nt))
  !
  valmin(:) = huge(0.)                ! Large enough
  valmax(:) = -valmin
  mean1 = 0.
  mean2 = 0.
  meano = 0.
  nn = 0
  np = 0
  nb = 0
  !
  it = 1
  !
  if (eval.lt.0.) then
    if (do_support) then
      !
      !$OMP PARALLEL DEFAULT(none)  &
      !$OMP & SHARED(nv,nm,box,amap,support)  &
      !$OMP & REDUCTION(+:np,nn,mean1,mean2,meano) &
      !$OMP & SHARED(valmin,imin,jmin,kmin,valmax,imax,jmax,kmax) &
      !$OMP & PRIVATE(it,i,j,k,l,val)
      !$ it = omp_get_thread_num()+1
      !$OMP DO COLLAPSE(3)
      do k = 1,nv
        do j = box(2),box(4)
          do i = box(1),box(3)
            l = min(nm,k)
            val = amap(i,j,k)
            if (support(i,j,l).ne.0) then
              np  = np+1
              mean1 = mean1+val
              mean2 = mean2+val*val
              if (valmax(it).lt.val) then
                valmax(it) = val
                imax(it) = i
                jmax(it) = j
                kmax(it) = k
              endif
              if (valmin(it).gt.val) then
                valmin(it) = val
                imin(it) = i
                jmin(it) = j
                kmin(it) = k
              endif
            else
              nn = nn+1
              meano = meano+val*val
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    else
      !$OMP PARALLEL DEFAULT(none)  &
      !$OMP & SHARED(nv,box,amap)   &
      !$OMP & REDUCTION(+:mean1,mean2)  &
      !$OMP & SHARED(valmin,imin,jmin,kmin,valmax,imax,jmax,kmax) &
      !$OMP & PRIVATE(it,i,j,k,val)
      !$ it = omp_get_thread_num()+1
      !$OMP DO COLLAPSE(3)
      do k = 1,nv
        do j = box(2),box(4)
          do i = box(1),box(3)
            val = amap(i,j,k)
            mean1 = mean1+val
            mean2 = mean2+val*val
            if (valmax(it).lt.val) then
              valmax(it) = val
              imax(it) = i
              jmax(it) = j
              kmax(it) = k
            endif
            if (valmin(it).gt.val) then
              valmin(it) = val
              imin(it) = i
              jmin(it) = j
              kmin(it) = k
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
      np  = (box(4)-box(2)+1)*(box(3)-box(1)+1)*nv
    endif
  else
    ! With Blanking
    if (do_support) then
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP & SHARED(nv,nm,box,amap,support,bval,eval) &
      !$OMP & REDUCTION(+:np, nn,nb,mean1,mean2,meano) &
      !$OMP & SHARED(valmin,imin,jmin,kmin,valmax,imax,jmax,kmax) &
      !$OMP & PRIVATE(it,i,j,k,l,val)
      !$ it = omp_get_thread_num()+1
      !$OMP DO COLLAPSE(3)
      do k=1,nv
        do j = box(2),box(4)
          do i = box(1),box(3)
            l = min(nm,k)
            val = amap(i,j,k)
            if (support(i,j,l).ne.0) then
              if (abs(val-bval).gt.eval) then
                np  = np+1
                mean1 = mean1+val
                mean2 = mean2+val*val
                if (valmax(it).lt.val) then
                  valmax(it) = val
                  imax(it) = i
                  jmax(it) = j
                  kmax(it) = k
                endif
                if (valmin(it).gt.val) then
                  valmin(it) = val
                  imin(it) = i
                  jmin(it) = j
                  kmin(it) = k
                endif
              else
                nb = nb+1
              endif ! Blanking
            else
              if (abs(val-bval).gt.eval) then
                nn = nn+1
                meano = meano+val*val
              else
                nb = nb+1
              endif
            endif ! Support
          enddo ! i
        enddo ! j 
      enddo ! k
      !$OMP END DO
      !$OMP END PARALLEL
    else
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP & SHARED(nv,box,amap,bval,eval) &
      !$OMP & REDUCTION(+:np,mean1,mean2,nb) &
      !$OMP & SHARED(valmin,imin,jmin,kmin,valmax,imax,jmax,kmax) &
      !$OMP & PRIVATE(it,i,j,k,val)
      !$ it = omp_get_thread_num()+1
      !$OMP DO COLLAPSE(3)
      do k=1,nv
        do j = box(2),box(4)
          do i = box(1),box(3)
            val = amap(i,j,k)
            if (abs(val-bval).gt.eval) then
              mean1 = mean1+val
              mean2 = mean2+val*val
              if (valmax(it).lt.val) then
                valmax(it) = val
                imax(it) = i
                jmax(it) = j
                kmax(it) = k
              endif
              if (valmin(it).gt.val) then
                valmin(it) = val
                imin(it) = i
                jmin(it) = j
                kmin(it) = k
              endif
              np = np+1
            else
              nb = nb+1
            endif
          enddo
        enddo
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    endif
  endif
  !
  ! Reduce the Min-Max now
  jt = minloc(valmin)
  it = jt(1)
  ipmin = imin(it)
  jpmin = jmin(it)
  kpmin = kmin(it)
  vmin = valmin(it)
  jt = maxloc(valmax)
  it = jt(1)
  ipmax = imax(it)
  jpmax = jmax(it)
  kpmax = kmax(it)
  vmax = valmax(it)
  !
  mean1 = mean1/real(np)
  mean2 = mean2/real(np)
  rms = sqrt(mean2-mean1*mean1)
  if (nn.ne.0) then
    noise = sqrt(meano/nn)
  else
    noise = rms
  endif
  mean = mean1
end subroutine compute_stat
!
subroutine get_jyperk(hstat,beam,jyperk)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine
  !
  !   Derive the Jy/beam conversion factor and Beam solid angle
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hstat  !! Data header
  real, intent(out) :: jyperk        !! Conversion from K to Jy
  real, intent(out) :: beam          !! Beam solid angle
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real :: lambda
  !
  if (hstat%gil%reso_words.eq.0) then
    jyperk = 0
    beam = 0
  else
    beam = pi*hstat%gil%majo*hstat%gil%mino/4./log(2.0)
    lambda = 2.99792458e8/hstat%gil%freq*1e-6
    jyperk = 2.0*1.38023e3*beam/lambda**2.
  endif
end subroutine get_jyperk

module catalog_data
  use gkernel_types
  character(len=filename_length) :: mofile  !! Catalog file name
  logical, save :: isastro          !! Type of catalog
  real, save :: eup_max=300         !! Energy threshold
  integer, save :: nlinedb          !! Number of LINEDB data bases
  ! For catalog lines
  integer, save :: mmol=-1          !! Size of arrays
  integer, save :: nmol             !! Number of lines in catalog
  real(8), allocatable :: molfreq(:)    !! Frequencies in MHz
  character(len=32), allocatable :: mollong(:)  !! Long names
  character(len=32), allocatable :: molplot(:)  !! Displayed names
  character(len=16), allocatable :: molshort(:) !! Short names
  ! As above, for selected lines
  integer, save :: nsel                 !! Number of selected lines
  integer, allocatable :: ip(:)         !! Pointers to catalog lines
  real(8), allocatable :: selfreq(:)    !! Selected line frequencies
  character(len=32), allocatable :: sellong(:)
  character(len=32), allocatable :: selplot(:)
  character(len=16), allocatable :: selshort(:)
end module catalog_data
!
subroutine catalog_init(imol,error)
  use gkernel_interfaces
  use catalog_data
  !
  !! IMAGER --  Initialize or Update catalog variables
  integer, intent(inout) :: imol  !! Number of molecules
  logical, intent(out) :: error   !! Logical error flag
  !
  error = .false.
  if (imol.eq.-1) then  
    call sic_def_real('LINEDB%ENERGY',eup_max,0,0,.false.,error)
    if (error) return
    call sic_def_logi('LINEDB%ASTRO',isastro,.true.,error)
    if (error) return
    imol = 0
  endif
  !
  ! Delete ASTRO catalog if any
  call sic_delvariable('CATALOG',.false.,error)
  nmol = 0
  ! Delete all other catalogs
  call sic_delvariable('LINES',.false.,error)
  error = .false.
  call sic_delvariable('LINEDB%DBIN',.false.,error)
  error = .false.
  nlinedb = 0
end subroutine catalog_init
! 
subroutine catalog_comm(line,quiet,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, catalog_readastro
  use catalog_data
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command CATALOG
  !
  !   List or define Spectral Line Data Base(s)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: quiet         !! Quiet flag (no message)
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='CATALOG'
  character(len=1), parameter :: question_mark='?'
  ! This duplicates the list in LINEDB Python code, but
  ! is unavoidable to check proper Data Base existence
  integer, parameter :: monline=4
  character*12 :: onlines(monline)
  data onlines /'voparis', 'cdms', 'jpl', 'splatalogue'/ !! cam-vamdc, cdms-vamdc
  !
  ! Local ---
  character(len=filename_length) :: line_comm = ' '
  character(len=filename_length) :: chain, file
  real(8) :: r
  logical :: found
  character(len=16) :: check
  integer :: lt,i,j,narg,nc, iform
  integer(kind=index_length) :: dim(4)
  !
  ! Code ----
  if (sic_present(1,0)) then
    call catalog_filter(line,quiet,error)
    return
  endif
  !
  error = .false.
  quiet = .true.
  !
  ! Normal code
  narg = sic_narg(0)
  chain = '?'
  call sic_ch(line,0,1,chain,nc,.false.,error)
  if (chain(1:1).eq.question_mark) then
    if (narg.gt.1) then
      call sic_ch(line,0,2,file,nc,.false.,error)
      call exec_program('@ catalog ? '//file)
    else
      call exec_program('@ catalog ? ')
    endif
    return
  endif
  !
  ! Ensure things are properly initialized
  call catalog_init(mmol, error)
  !
  ! Reset if asked for.
  check = chain
  call sic_upper(check)
  if (check.eq."NONE") return
  !
  ! Note the LowerCase for the "in" argument
  line_comm = "LINEDB\USE in "
  lt = 15
  !
  do i=1,narg
    call sic_ch(line,0,i,chain,nc,.false.,error)
    !
    check = chain
    call sic_lower(check)
    found = .false.
    do j=1,monline
      if (check.eq.onlines(j)) then
        found = .true.
        exit
      endif
    enddo
    !
    if (found) then
      line_comm(lt:) = check
      lt = lt+len_trim(check)+2
    else
      ! If it is not one of the on-line databases, 
      ! it can be a local file. Locate it
      found = sic_findfile(chain,file,' ','.linedb')
      !
      if (found) then
        !
        ! Verify if it can be an Astro catalog
        open(unit=1,file=file,status='OLD')               
        read(1,'(A)') check
        !
        if (check(1:7).eq.'SQLite ') then
          isastro = .false.
          iform = 1
        elseif (check(1:1).eq.'!') then
          isastro = .true.
          iform = 2
        else
          chain = 'partfunc.cat'
          inquire(file='parfunc.cat',exist=isastro)
          if (.not.isastro) inquire(file='partfunc.json',exist=isastro)
          if (isastro) then
            ! There is a partfunc file, so it could be Gildas JPL file format
            ! Gildas JPL file start by a Tag identifier followed by molecule NAME
            rewind(1)
            read(1,*) r
            if (nint(r).eq.r) then
              isastro = .false. ! Tag must be an integer
              iform = -1
            else
              ! Astro files would have frequencies in GHz instead, never integers,
              ! so they remain our best guess here...
              iform = 0
            endif
          else
            ! JPL data files format require "partfunc" file, so cannot be JPL
            isastro = .true.
            iform = 0
          endif
        endif
        close(unit=1)
        !
        if (isastro) then
          if (narg.eq.1) then
            ! Read the ASTRO catalog
            call catalog_readastro (file,error)
            if (error) then
              call map_message(seve%e,rname,'File '//trim(file)//' is not a Line catalog',1)              
              return
            endif
            call map_message(seve%i,rname,'File '//trim(file)//' is an Astro catalog',3)
            mofile = file
            dim(1) = 1
            call sic_def_charn('LINEDB%DBIN',mofile,1,1,.true.,error)
            isastro = .true.
            if (sic_varexist("all%catalog")) then
              line_comm = "LET all%catalog 'linedb%dbin'"
              call exec_command(line_comm,error)
            endif
            nlinedb = narg
            return
          else
            call map_message(seve%e,rname,'Astro catalogs are exclusive of any other',1)
            error = .true.
            return
          endif
        else if (iform.eq.1) then
          call map_message(seve%i,rname,'File '//trim(file)//' is a DBMS catalog')              
        else 
          call map_message(seve%w,rname,'File '//trim(file)//' may be a JPL data file',3)                      
        endif
        !
        chain  = '"'//trim(file)//'"'   ! Python "LINEDB\USE" does not parse anything else
        line_comm(lt:) = chain
        lt = lt+len_trim(chain)+2
      else
        call map_message(seve%w,rname,'No such line catalog '//trim(chain),3)
      endif
    endif
  enddo
  nlinedb = narg
  !
  ! Execute the "LINEDB\USE in" command if needed
  if (lt.gt.15) then
    call exec_command(line_comm,error)
    isastro = .false.
    quiet = .false.
    if (error) return
    !
    line_comm = "LET all%catalog 'linedb%dbin'"
  else
    line_comm = 'LET all%catalog "( none defined )"'
    call map_message(seve%w,rname,'No line catalog',3)
  endif
  ! Reset the all%catalog if needed
  if (sic_varexist("all%catalog")) call exec_command(line_comm,error)
  !
end subroutine catalog_comm    
!
subroutine catalog_find(line,error)
  use gildas_def
  use gkernel_interfaces
  use catalog_data
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command   
  !     FIND Fmin Fmax [/CHECK]  [/SPECIES Name]
  !
  ! Returns in the LINES% structure the frequencies and names of lines
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(inout) :: error         !! Logical Error Flag
  !
  integer, parameter :: o_check=1       ! Verbose mode...
  integer, parameter :: o_species=2
  ! Local ---
  character(len=128) :: cfmin, cfmax  ! Frequency ranges, formatted
  character(len=32) :: start_comm
  integer :: ni, nm, ns
  character(len=512) :: line_comm
  real(8) :: fmin,fmax
  integer :: k, i
  integer(kind=index_length) :: dim(4)
  integer :: i_spec, l
  character(len=32) :: c_spec
  character(len=8) :: c_enrg
  !
  ! Code ----
  call sic_delvariable('LINES',.false.,error)
  error = .false.
  if (nlinedb.eq.0) then
    call map_message(seve%w,'FIND','No line catalog(s)',3)
    return
  endif
  !
  i_spec = sic_narg(o_species)
  if (i_spec.eq.1) then
    call sic_ch(line,o_species,1,c_spec,l,.true.,error)
    if (error) return
  endif
  !
  if (nmol.eq.0) then
    ! LINEDB version
    !
    call sic_ch(line,0,1,cfmin,ni,.true.,error)
    if (error) return
    call sic_ch(line,0,2,cfmax,nm,.true.,error)
    if (error) return
    !
    if (sic_present(o_check,0)) then
      start_comm = "LINEDB\SELECT /FREQ "
    else
      start_comm = "LINEDB\SELECT /QUIET /FREQ "
    endif
    ns = len_trim(start_comm)+1
    !
    write(c_enrg,'(f6.0)') eup_max
    if (i_spec.eq.1) then
      line_comm = start_comm(1:ns)//cfmin(1:ni)//' '//cfmax(1:nm)// &
        & " /ENERGY "//c_enrg//" /SORT aij /SPECIES "//'"'//trim(c_spec)//'"'
    else
      line_comm = start_comm(1:ns)//cfmin(1:ni)//' '//cfmax(1:nm)// &
        & " /ENERGY "//c_enrg//" /SORT aij"
    endif
    !!Print *,trim(line_comm)
    call exec_program(line_comm)
    call exec_program('@ catalog_lines')
  else
    !
    ! ASTRO version - In memory Catalog frequencies are in MHz
    call sic_r8(line,0,1,fmin,.true.,error)
    if (error) return
    call sic_r8(line,0,2,fmax,.true.,error)
    if (error) return
    !
    ! LINES%N will contain the number of lines
    k = 0
    do i=1,nmol
      if (molfreq(i).ge.fmin .and. molfreq(i).le.fmax) then
        k = k+1
        ip(k) = i
      endif
    enddo
    nsel = k
    l = 0
    do k=1,nsel
      i = ip(k)
      if (i_spec.eq.1) then
        if (molshort(i).ne.c_spec) cycle 
      endif
      l=l+1
      selfreq(l) = molfreq(i)
      sellong(l) = mollong(i)
      selplot(l) = molplot(i)
      selshort(l) = molshort(i)
    enddo
    nsel = l
    !
    call sic_defstructure('LINES',.true.,error)
    if (nsel.ne.0) then
      dim(1) = nsel
      call sic_def_dble('LINES%FREQUENCY',selfreq,1,dim,.true.,error)
      call sic_def_charn('LINES%LINES',sellong,1,dim,.true.,error)
      call sic_def_charn('LINES%PLOT',selplot,1,dim,.true.,error)
      call sic_def_charn('LINES%SPECIES',selshort,1,dim,.true.,error)
      nsel = -nsel
    endif
    call sic_def_inte('LINES%N',nsel,0,0,.true.,error)
  endif 
end subroutine catalog_find
!
subroutine catalog_readastro (molfile,error)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  use catalog_data
  !---------------------------------------------------------------------
  ! @ private
  !*
  !    IMAGER -- Support for command CATALOG
  !
  !  Read an Astro catalog, or one of its CSV variants
  !  The Frequency unit can be specified in the first Line
  !  if it is a comment line.
  !    (recognized values are GHz, MHz, kHz and Hz only)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: molfile   !! Catalog name
  logical, intent(inout) :: error           !! Logical Error Flag
  !
  character(len=*), parameter :: rname='CATALOG'
  !
  ! Local ---
  character(len=256) :: chain
  character(len=32) :: aname,bname,aline
  real(kind=8) :: afreq
  integer(kind=4) :: i,k,lun,nv,ier,lt,ls
  integer(kind=4) :: icsv, iend, step, inext, ilast
  logical :: skip, worry
  character(len=16) :: varname
  real(8) :: fscale
  integer :: icase
  !
  ! Code ----
  error = .false.
  varname = 'CATALOG'
  !
  ! Open file
  nmol = 0
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call map_message(seve%e,rname,'Cannot allocate LUN')
    error = .true.
    return
  endif
  open(unit=lun,file=molfile(1:len_trim(molfile)), status='OLD',iostat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot open file: '//trim(molfile))
    call sic_frelun(lun)
    error = .true.
    return
  endif
  !
  ! Read file - Two pass to properly dimension the Number of molecules
  !
  ! Verify if strictly ASTRO conformant or not,
  ! and check the Frequency unit if specified
  read(lun,'(A)') chain
  worry = (chain(1:1).eq.'!').or.(chain(1:1).eq.';')
  if (worry) then
    if (index(chain,'Hz').ne.0) then
      icase = -6
      if (index(chain,'MHz').ne.0) icase = 0
      if (index(chain,'GHz').ne.0) icase = 3
      if (index(chain,'kHz').ne.0) icase = -3      
      fscale = 10.D0**icase
      select case (icase)
      case (-6)      
        call map_message(seve%i,rname,'Converting frequencies from Hz to MHz',3)
      case (-3)
        call map_message(seve%i,rname,'Converting frequencies from kHz to MHz',3)
      case (3)
        call map_message(seve%i,rname,'Converting frequencies from GHz to MHz',3)
      case (0)
        call map_message(seve%i,rname,'Frequencies are already specified in MHz')
      end select
      worry = .false.
    else
      fscale = 1D3        ! Default frequency unit is GHz
      call map_message(seve%w,rname,'Assuming Frequencies are in GHz')
    endif
  else
    fscale = 1D3          ! Default frequency unit is GHz
    worry = (index(chain,';').eq.0)
    call map_message(seve%w,rname,'Assuming Frequencies are in GHz')
  endif
  rewind(lun)
  !
  nmol = 0
  do step = 1,2
    do 
      read(lun,'(A)',iostat=ier) chain
      if (ier.lt.0) exit
      !
      if (ier.ne.0 .or. len_trim(chain).eq.0) cycle
      ! Comment line
      if (chain(1:1).eq.'!') cycle
      !
      icsv = index(chain,';')
      if (icsv.gt.1) then
        !Print *,"CHAIN ",chain
        ! Comma separated value
        read(chain(1:icsv-1),*,iostat=ier) afreq
        if (ier.ne.0) cycle
        inext = index(chain(icsv+1:),';')
        if (inext.ne.0) then
          aname = adjustl(chain(icsv+1:icsv+inext-1))
          !Print *,'ANAME ['//trim(aname)//']'
          ilast = index(chain(icsv+inext+2:),';')
          if (ilast.ne.0) then
            ilast = icsv+inext+ilast
          else
            ilast = len_trim(chain)
          endif
          aline = adjustl(chain(icsv+inext+2:ilast))
          !Print *,'ALINE ['//trim(aline)//']'
        else
          aname = adjustl(chain(icsv+1:))
          aline = ' '
        endif
      else if (icsv.eq.1) then
        ! CSV comment line
        cycle
      else
        ! Historical ASTRO format
        ! Note that since Fortran-90, quotes are no longer required to delimit strings 
        ! in List-Directed format. They are only required when spaces should be in the
        ! strings.
        read(chain,*,iostat=ier) afreq, aname, aline
        if (ier.ne.0) then
          aline = ' '
          read(chain,*,iostat=ier) afreq, aname
          if (ier.ne.0) cycle
        endif
        ! If not strictly conformant, ignore values that are integers, as
        ! the likelihood to have spectral line EXACTLY a number of GHz is tiny...
        if (worry) then
          if (nint(afreq).eq.afreq) cycle
        endif
        if (len_trim(aname).ne.0) then
          bname = aname
          iend = 0
        else
          aname = bname ! Inherit last molecule name if not specified
          iend = 1
        endif 
      endif
      nmol = nmol + 1
      ! First step: just count
      if (step.eq.1) cycle
      !
      ! Second Step: fill array
      molfreq(nmol) = afreq*fscale
      !
      lt = len_trim(aname)
      ls = index(aname(1:lt),' ')
      if (ls.ne.0) then
        aline = aname(ls+1:lt)//aline
        lt = ls
      else
        lt = lt+1
      endif
      molplot(nmol) = aname(1:lt)//aline
      !
      k = 0
      skip = .false.
      do i=1,lt
        if (skip) then
          if (aname(i:i).ne."\") skip = .false.
        else
          if (aname(i:i).eq."\") then
            skip = .true.
          else
            k = k+1
            aname(k:k) = aname(i:i)
          endif
        endif
      enddo
      molshort(nmol) = aname(1:k)
      mollong(nmol) = aname(1:k)//aline
      if (nmol.ge.mmol) exit
    enddo
    !
    if (step.eq.1) then
      if (nmol.gt.mmol) then
        write(chain,'(A,I0,A)') 'Allocating space for ',nmol,' spectral lines'
        call map_message(seve%i,rname,chain)
        if (mmol.ne.0) deallocate(molfreq,selfreq,mollong,molplot,molshort,sellong,selplot,selshort,ip)
        mmol = nmol
        allocate(molfreq(mmol),selfreq(mmol),mollong(mmol),molplot(mmol),molshort(mmol), &
        & sellong(mmol),selplot(mmol),selshort(mmol),ip(mmol))
      endif  
      rewind(lun)
      nmol = 0
    endif
  enddo
  !
  close(unit=lun)
  call sic_frelun(lun)
  !
  if (nmol.eq.0) then
    error = .true.
    return
  endif
  if (worry) call map_message(seve%w,rname,   &
    & 'Astro catalog should start with a comment line with Frequency unit, e.g. "! MHz"',1)
  !
  ! Create the SIC substructure 
  !
  call sic_defstructure(varname,.true.,error)
  if (error) return
  nv = len_trim(varname)
  call sic_def_inte(varname(1:nv)//'%N',nmol,0,0,.true.,error)
  call sic_def_dble(varname(1:nv)//'%FREQ',molfreq,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%NAME',mollong,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%SHORT',molshort,1,nmol,.true.,error)
  call sic_def_charn(varname(1:nv)//'%PLOT',molplot,1,nmol,.true.,error)
  if (error) return
  !
end subroutine catalog_readastro
!
subroutine catalog_filter(line,quiet,error)
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, catalog_readastro
  !---------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- Support for command  
  !   CATALOG InFile /SORT OutFile [precis]
  !
  !     Sort and order an Astro Catalog, only considering
  !   new Lines if they are more than PRECIS MHz apart 
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: quiet         !! Quiet flag (no message)
  logical, intent(inout) :: error       !! Logical error flag
  !
  character(len=*), parameter :: rname='CATALOG /SORT'
  !
  ! Local ---
  character(len=filename_length) :: fich, file, ofile
  real(8) :: r
  logical :: found, isastro
  character*16 :: check
  integer :: nc, iform, imol
  character(len=256) :: chain
  character(len=32) :: aname,bname,aline
  character(len=32), allocatable :: molname(:), molline(:)
  real(kind=8), allocatable :: molfreq(:)
  real(kind=8) :: afreq, dfreq
  integer, allocatable :: indx(:)
  integer :: nmol, mmol
  integer(kind=4) :: lun,ier
  integer(kind=4) :: icsv, iend, step
  logical :: worry
  character(len=16) :: varname
  real(8) :: fscale
  !
  ! Code ----
  nmol = 0
  error = .false.
  quiet = .true.
  !
  if (sic_narg(0).ne.1) then
    call map_message(seve%e,rname,'One and only one filename as argument required')
    error = .true.
    return
  endif
  !
  call sic_ch(line,1,1,fich,nc,.true.,error)
  if (error) return
  call sic_parsef(fich,ofile,' ','.lin')
  dfreq = 0.d0
  call sic_r8(line,1,2,dfreq,.false.,error)
  if (error) return
  !
  call sic_ch(line,0,1,fich,nc,.false.,error)
  ! If it is not one of the on-line databases, 
  ! it can be a local file. Locate it
  found = sic_findfile(fich,file,' ','.lin')
  if (.not.found) then
    call map_message(seve%e,rname,'No such catalog '//trim(file))
    error = .true.
    return
  endif
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call map_message(seve%e,rname,'Cannot allocate LUN')
    error = .true.
    return
  endif
  !
  ! Verify if it is an Astro catalog
  open(unit=lun,file=file,status='OLD')               
  read(lun,'(A)') check
  !
  if (check(1:7).eq.'SQLite ') then
    isastro = .false.
    iform = 1
  elseif (check(1:1).eq.'!') then
    isastro = .true.
    iform = 2
  else
    chain = 'partfunc.cat'
    inquire(file='parfunc.cat',exist=isastro)
    if (.not.isastro) inquire(file='partfunc.json',exist=isastro)
    if (isastro) then
      ! There is a partfunc file, so it could be Gildas JPL file format
      ! Gildas JPL file start by a Tag identifier followed by molecule NAME
      rewind(lun)
      read(lun,*) r
      if (nint(r).eq.r) then
        isastro = .false. ! Tag must be an integer
        iform = -1
      else
        ! Astro files would have frequencies in GHz instead, never integers,
        ! so they remain our best guess here...
        iform = 0
      endif
    else
      ! JPL data files format require "partfunc" file, so cannot be JPL
      isastro = .true.
      iform = 0
    endif
  endif
  !
  if (.not.isastro) then
    close(unit=lun)
    call map_message(seve%e,rname,'LINEDB catalogs or JPL files not supported in CATALOG /SORT')
    call sic_frelun(lun)
    error = .true.
    return
  endif
  !
  ! Now read the Catalog
  varname = 'CATALOG'
  fscale = 1D3          ! Default frequency unit is GHz
  !
  ! Open file and Check the Frequency units
  nmol = 0
  rewind(unit=lun)
  !
  ! Read file - Two pass to properly dimension the Number of molecules
  !
  ! Verify if strictly ASTRO conformant or not,
  ! and check the Frequency unit if specified
  read(lun,'(A)') aname
  worry = (aname(1:1).ne.'!') 
  if ((.not.worry).or.(aname(1:1).eq.';')) then
    if (index(aname,'Hz').ne.0) then
      fscale = 1D-6
      if (index(aname,'MHz').ne.0) fscale=1D0
      if (index(aname,'GHz').ne.0) fscale=1D3
      if (index(aname,'kHz').ne.0) fscale=1D-3
    endif
  else
    worry = (index(aname,';').eq.0)
  endif
  rewind(unit=lun)
  !
  nmol = 0
  do step = 1,2
    do 
      read(lun,'(A)',iostat=ier) chain
      if (ier.lt.0) exit
      !
      if (ier.ne.0 .or. len_trim(chain).eq.0) cycle
      ! Comment line
      if (chain(1:1).eq.'!') cycle
      !
      icsv = index(chain,';')
      if (icsv.gt.1) then
        !Print *,"CHAIN ",chain
        ! Comma separated value
        read(chain(1:icsv-1),*,iostat=ier) afreq
        if (ier.ne.0) cycle
        aname = adjustl(chain(icsv+1:))
        !Print *,"ANAME ",aname(1:30)
        iend = index(aname,';')
        aline = adjustl(aname(iend+1:))
        !Print *,"ALINE ",aline(1:30)
        aname(iend:) = ' '
        !Print *,"ANAME ",aname(1:30)
        iend = index(aline,';')
        if (iend.ne.0) aline(iend:) = ' '
      else if (icsv.eq.1) then
        ! CSV comment line
        cycle
      else
        ! Historical ASTRO format
        ! Note that since Fortran-90, quotes are no longer required to delimit strings 
        ! in List-Directed format. They are only required when spaces should be in the
        ! strings.
        read(chain,*,iostat=ier) afreq, aname, aline
        if (ier.ne.0) then
          aline = ' '
          read(chain,*,iostat=ier) afreq, aname
          if (ier.ne.0) cycle
        endif
        ! If not strictly conformant, ignore values that are integers, as
        ! the likelihood to have spectral line EXACTLY a number of GHz is tiny...
        if (worry) then
          if (nint(afreq).eq.afreq) cycle
        endif
        if (len_trim(aname).ne.0) then
          bname = aname
          iend = 0
        else
          aname = bname ! Inherit last molecule name if not specified
          iend = 1
        endif 
      endif
      nmol = nmol + 1
      ! First step: just count
      if (step.eq.1) cycle
      ! Second Step: fill array
      ! Store the Frequencies and Lines
      molfreq(nmol) = afreq*fscale
      molname(nmol) = aname
      molline(nmol) = aline
    enddo
    !
    if (step.eq.1) then
      if (nmol.eq.0) exit
      !
      write(chain,'(A,I0,A)') 'Allocating space for ',nmol,' spectral lines'
      call map_message(seve%i,rname,chain)
      mmol = nmol
      allocate(molfreq(mmol),molline(mmol),molname(nmol),indx(nmol),stat=ier)
      rewind(lun)
      nmol = 0
    endif
  enddo
  !
  close(unit=lun)
  !
  if (nmol.eq.0) then
    call map_message(seve%w,rname,'No molecules in catalog')
    call sic_frelun(lun)
    return
  endif
  !
  ! Sort by Frequencies
  call gr8_trie(molfreq,indx,nmol,error)
  if (error) then
    call sic_frelun(lun)
    return
  endif
  !
  ! Write Sorted result
  ier = sic_open(lun,ofile,'NEW',.false.)
  if (ier.ne.0) then
    call map_message(seve%r,rname,'Cannot create '//trim(ofile))
    call sic_frelun(lun)
    error = .true.
    return
  endif
  write(lun,'(A)') '! Astro CSV catalog format, unit MHz'
  !
  nmol = 0
  afreq = 0
  aname = ' '
  do imol=1,mmol
    if (abs(molfreq(imol)-afreq).gt.dfreq) then
      nmol = nmol+1
      write(lun,'(F14.6,A,A,A,A,A)') molfreq(imol),' ; ',molname(indx(imol)),' ; ',molline(indx(imol)),' ;'
      afreq = molfreq(imol)
      aname = molname(indx(imol))
    else if (molname(indx(imol)).ne.aname) then
      nmol = nmol+1
      write(lun,'(F14.6,A,A,A,A,A)') molfreq(imol),' ; ',molname(indx(imol)),' ; ',molline(indx(imol)),' ;'
      afreq = molfreq(imol)
      aname = molname(indx(imol))
    endif
  enddo
  close(unit=lun)
  write(chain,'(A,I0,A,I0)') 'Selected and Sorted ',nmol,' lines out of ',MMOL
  call map_message(seve%i,rname,chain,2)
  call sic_frelun(lun)
  error = .false.
end subroutine catalog_filter

subroutine uv_check_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => uv_check_comm
  use clean_types
  use clean_arrays
  use clean_beams
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER s-- Spport routine for command UV_CHECK
  !
  !     UV_CHECK [Beams|Flags|Integration|Nulls] [/FILE File]
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line   !! Command line
  logical, intent(out) :: error          !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_CHECK'
  integer, parameter :: o_file=1
  integer, parameter :: mmode=4
  character(len=12) :: smode(mmode)
  data smode /'BEAMS','FLAGS','INTEGRATION','NULLS'/
  !
  ! Local ---
  real, save :: inte(1000)
  real, save :: total=0.
  integer, save :: nant=0
  integer, save :: ni=0
  !
  integer(kind=index_length) :: dim(4), nvisi
  integer :: nu,nc,na,ncase, jcase, ier, i, iv, kv
  integer, allocatable :: cases(:), bad(:)
  real, allocatable :: weights(:)
  real(4) :: dtol, dmax
  character(len=12) :: argum,cmode
  character(len=filename_length) :: file
  type (gildas) :: uvin
  logical :: dofile, err
  integer :: ib, nblock, nf, wcol
  character(len=128) :: mess
  !
  ! Code ----
  argum = 'BEAMS'
  call sic_ke(line,0,1,argum,na,.false.,error)
  call sic_ambigs (rname,argum,cmode,na,smode,mmode,error)
  if (error) return
  !
  dofile = sic_present(o_file,0)
  ! 
  if (cmode.eq.'BEAMS') then
    call sic_r4(line,0,2,beam_tolerance,.false.,error)
    if (error) return
    if ((beam_tolerance.lt.1e-6).or.(beam_tolerance.gt.1.)) then
      call map_message(seve%e,rname,'BEAM_TOLERANCE out of range ]0,1]')
      error = .true.
      return
    endif
  endif
  !
  if (.not.dofile) then
    !
    !  Memory mode
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data loaded')
      error = .true.
      return
    endif
    nu = huv%gil%dim(1)
    nvisi = huv%gil%nvisi ! not %dim(2)
    nc = huv%gil%nchan
    !
    !
    select case (cmode)
    case('BEAMS')
      nbeam_ranges = -1
      call check_beams_mem(error)
    case ('FLAGS')
      wcol = 0
      call sic_i4(line,0,2,wcol,.false.,error)
      if (error) return
      if (wcol.eq.0)  wcol = (nc+2)/3
      wcol = max(1,min(wcol,nc))
      write(mess,'(A,I0)') 'Checking for flagged visibilities on Channel ',wcol
      call map_message(seve%i,rname,mess)
      allocate (bad(nvisi),stat=ier)
      kv = 0
      call sub_get_flags(duv,nvisi,nc,bad,kv,wcol)
      if (kv.ne.0) then
        !write(6,*) 'Flagged ',kv,' visibilities'
        !write(6,*) (bad(iv),iv=1,kv)
        write(mess,'(I0,A,I0)') kv,' flagged visibilities for Channel ',wcol
        call map_message(seve%w,rname,mess)
      else
        call map_message(seve%i,rname,'No flagged visibilities')
      endif
      deallocate (bad,stat=ier)
    case ('NULLS')
      call map_message(seve%i,rname,'Checking for unflagged null visibilities')
      allocate (bad(nvisi),stat=ier)
      kv = 0
      call sub_get_nulls(duv,nvisi,nc,bad,kv)
      if (kv.ne.0) then
        write(6,*) 'Flagged ',kv,' null visibilities'
        write(6,*) (bad(iv),iv=1,kv)
      else
        call map_message(seve%i,rname,'No null visibilities left unflagged')
      endif
      deallocate (bad,stat=ier)
      !
    case ('INTEGRATION')
      if (nant.eq.0) then
        call sic_def_inte('UV_NANT',nant,0,0,.true.,error)
        call sic_def_real('UV_TOTAL',total,0,0,.true.,error)
      endif
      !
      dmax = 300  ! Seconds
      call sic_r4(line,0,2,dmax,.false.,error)
      dtol = 0.05
      call sic_r4(line,0,3,dtol,.false.,error)
      if (error) return
      !
      ni = 0
      total = 0
      nant = 0
      call sub_get_inte(huv,duv,nvisi,dmax,dtol,inte,ni,total,nant,error)
      if (error) return
      !
      call sic_delvariable('UV_INTEGRATION',.false.,error)
      call sic_def_real('UV_INTEGRATION',inte,1,ni,.true.,error)
      write(6,'(A)') 'Possible integration times (seconds) '
      write(6,'((8(1X,F10.2)))') inte(1:ni)
    end select
  else
    call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
    !
    call sic_ch(line,o_file,1,file,nf,.true.,error)
    if (error)  return
    call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
    if (error) return
    !
    ! Define blocking factor, on largest data file, usually the input one
    ! but not always...
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',uvin,1)
    ! Allocate respective space for each file
    allocate (uvin%r2d(uvin%gil%dim(1),nblock),stat=ier)
    if (failed_allocate(rname,'UV input data',ier,error)) then
      call gdf_close_image(uvin,err)
      return
    endif
    !
    nu = uvin%gil%dim(1)
!    nv = uvin%gil%nvisi ! not %dim(2)
    nc = uvin%gil%nchan
    !
    ! Loop over line table
    uvin%blc = 0
    uvin%trc = 0
    !
    select case (cmode)
    case ('INTEGRATION')
      if (nant.eq.0) then
        call sic_def_inte('UV_NANT',nant,0,0,.true.,error)
        call sic_def_real('UV_TOTAL',total,0,0,.true.,error)
      endif
      !
      dmax = 300  ! Seconds
      call sic_r4(line,0,2,dmax,.false.,error)
      dtol = 0.05
      call sic_r4(line,0,3,dtol,.false.,error)
      if (error) return
      !
      ni = 0
      nant = 0
      total = 0.
      !
      do ib = 1,uvin%gil%dim(2),nblock
        write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
        call map_message(seve%i,rname,mess)
        uvin%blc(2) = ib
        uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
        call gdf_read_data(uvin,uvin%r2d,error)
        if (error) exit
        !
        nvisi = uvin%trc(2)-uvin%blc(2)+1
        !
        call sub_get_inte(uvin,uvin%r2d,nvisi,dmax,dtol,inte,ni,total,nant,error)
      enddo
      !
      call sic_delvariable('UV_INTEGRATION',.false.,error)
      call sic_def_real('UV_INTEGRATION',inte,1,ni,.true.,error)
      write(6,'(A)') 'Possible integration times (seconds) '
      write(6,'((8(1X,F10.2)))') inte(1:ni)
    case ('NULLS')
      call map_message(seve%i,rname,'Checking for null visibilities')
      allocate (bad(uvin%gil%nvisi),stat=ier)
      bad(0) = 0
      kv = 0
      !
      do ib = 1,uvin%gil%dim(2),nblock
        write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
        call map_message(seve%i,rname,mess)
        uvin%blc(2) = ib
        uvin%trc(2) = min(uvin%gil%nvisi,ib-1+nblock)
        call gdf_read_data(uvin,uvin%r2d,error)
        if (error) exit
        !
        nvisi = uvin%trc(2)-uvin%blc(2)+1
        !
        call sub_get_nulls(uvin%r2d,nvisi,nc,bad,kv)
      enddo
      if (kv.ne.0) then
        write(6,*) 'Flagged ',kv,' null visibilities'
        write(6,*) (bad(iv),iv=1,kv)
      else
        call map_message(seve%i,rname,'No null visibilities left unflagged')
      endif
      deallocate (bad,stat=ier)
    case ('BEAMS')
      call sic_delvariable ('BEAM_RANGES',.false.,error)
      allocate (cases(nc),weights(nc),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      !
      weights = 0.
      wcol = 0
      do ib = 1,uvin%gil%dim(2),nblock
        write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
        call map_message(seve%i,rname,mess)
        uvin%blc(2) = ib
        uvin%trc(2) = min(uvin%gil%nvisi,ib-1+nblock)
        call gdf_read_data(uvin,uvin%r2d,error)
        if (error) exit
        !
        nvisi = uvin%trc(2)-uvin%blc(2)+1
        !
        call sub_get_nbeams(uvin, uvin%r2d, nvisi, nc, weights, wcol)
      enddo
      call howmany_beams(weights, nc, cases, ncase, beam_tolerance) 
      !
      ! Write the result
      if (ncase.le.1) then
        call map_message(seve%i,rname,'Only one beam needed')
      else
        if (ncase.eq.nc) then
          call map_message(seve%w,rname,'Need one beam per channel')
        else
          call map_message(seve%w,rname,'Beams needed for the following channel ranges:')
          if (allocated(beam_ranges)) deallocate(beam_ranges)
          allocate(beam_ranges(3,ncase),stat=ier)
          cases(ncase+1) = nc+1
          jcase = 0
          do i=1, ncase
            write(6,'(a,i6,a,i6,a,1pg10.3)') '[',cases(i),'-',cases(i+1)-1,'] ', weights(cases(i))
            if (weights(cases(i)).ne.0) then
              jcase = jcase+1
              beam_ranges(1,jcase) = cases(i)
              beam_ranges(2,jcase) = cases(i+1)-1
              beam_ranges(3,jcase) = weights(cases(i))
            endif
          enddo
          dim = [3,jcase,0,0]
          call sic_def_real('BEAM_RANGES',beam_ranges,2,dim,.false.,error)
        endif
      endif
    case default
      call map_message(seve%e,rname,'/FILE option not yet implemented for '//cmode)
      error = .true.
    end select
    !
    deallocate(uvin%r2d,stat=ier)
    call gdf_close_image(uvin,err)
    error = err.or.error
  endif
end subroutine uv_check_comm
!
subroutine sub_get_inte(huvl,visi,nv,dmax,dtol,inte,kv,total,nant,error)
  use image_def
  use gkernel_interfaces, only : gr8_trie
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- support routine for command  
  !     UV_CHECK Integration [/FILE File]
  !
  ! Attempt to derive integration times, by differencing time stamps
  ! of consecutive visibvilities.  
  !  To be developpe: if an integration time column is present,
  ! Use the values from the that columns.
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(in) :: huvl  !! UV data header
  real, intent(in) :: visi(:,:)     !! UV data
  integer(kind=index_length), intent(in) :: nv  !! Number of visibilities
  real, intent(inout) :: dmax       !! Longest allowed time step
  real, intent(in) :: dtol          !! Time stamp tolerance
  real, intent(inout) :: inte(:)    !! Possible integration times
  integer, intent(inout) :: kv      !! Number of possible times
  real, intent(inout) :: total      !! Total integration time
  integer, intent(inout) :: nant    !! Number of antennas
  logical, intent(out) :: error     !! Error flag
  !
  ! Local --
  integer(kind=index_length), allocatable :: idx(:)
  real(8), allocatable :: times(:)
  real(4) :: dt
  logical :: found  !
  integer :: iv
  integer :: jv,ier
  !
  ! Code ----
  allocate(times(nv),idx(nv),stat=ier)
  !
  do iv=1,nv
    times(iv) = visi(4,iv)*86400d0 + visi(5,iv)
  enddo
  call gr8_trie(times,idx,nv,error)
  if (error) return
  !
  do iv=2,nv
    if (times(iv).ne.times(iv-1)) then
      dt = real(times(iv)-times(iv-1))
      if (dt.lt.dmax) then
        found = .false.
        do jv=1,kv
          if (abs(dt-inte(jv)).lt.dtol*dt) then
            found = .true.
            exit
          endif
        enddo
        if (.not.found) then
          kv = kv+1
          inte(kv) = dt 
        endif
        total = total+dt  ! Increment per-baseline total time
        nant = max(nant,int(visi(7,iv))) 
      endif
    endif
  enddo
  !
end subroutine sub_get_inte
!
subroutine sub_get_nulls(visi,nv,nc,bad,kv)
  use image_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  !     UV_CHECK Nulls [/FILE File]
  !
  !  Find out Null visibilities with non zero weights
  ! (occasionally happens with CASA data)
  !!
  !----------------------------------------------------------------------
  real, intent(inout) :: visi(:,:)       !! UV data
  integer(kind=index_length), intent(in) :: nv  !! Number of visibilities
  integer, intent(in) :: nc             !! Number of channels
  integer, intent(inout) :: bad(nv)     !! Bad visi list
  integer, intent(inout) :: kv          !! Current pointer in list
  !
  ! Local ---
  integer :: iv,ic
  !
  ! Code ----
  do iv=1,nv
    do ic=1,nc
      if (visi(7+3*ic,iv).gt.0) then
        if (visi(5+3*ic,iv).eq.0 .and. visi(6+3*ic,iv).eq.0) then
          ! Flag all channels - Something was wrong
          kv = kv+1
          bad(kv) = iv
          visi(8:7+3*nc,iv) = 0
          exit
        endif
      endif
    enddo
  enddo
end subroutine sub_get_nulls
!
subroutine sub_get_flags(visi,nv,nc,bad,kv,wc)
  use image_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER support routine for command  
  !     UV_CHECK Flags [Channel] [/FILE File]
  !
  !  Find out Flagged visibilities. 
  !  Returns the list of flagged visibilities, based on the specified
  !  weight channel. KV must be initialized outside, as the routine
  !  can be called by visbility blocks.
  !
  !----------------------------------------------------------------------
  real, intent(inout) :: visi(:,:)       !! UV data
  integer(kind=address_length), intent(in) :: nv  !! Number of visibilities
  integer, intent(in) :: nc             !! Number of channels
  integer, intent(inout) :: bad(nv)     !! Bad visi list
  integer, intent(inout) :: kv          !! Current pointer in list
  integer, intent(in) :: wc             !! Weight channel
  !
  ! Local ---
  integer :: iv
  !
  ! Code ----
  do iv=1,nv
    if (visi(7+3*wc,iv).le.0) then
      kv = kv+1
      bad(kv) = iv
    endif
  enddo
end subroutine sub_get_flags
!
!
subroutine sub_get_nbeams(uvin, visi, nvisi, nchan, weights, wcol)
  use image_def
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER support routine for command  
  !     UV_CHECK BEAM
  !
  ! Get the sum of weights for each channel.  
  ! Verify it is constant, or just a global scale factor from one channel to 
  ! another, so that the relative weights are all the same. Noise variations
  ! due to e.g. Tsys or slightly different bandwidths (not accounted for in
  ! the data information) are irrelevant in the imaging process as only 
  ! relative weights as a function of time matter. 
  !
  ! Used implicitely by UV_MAP if not called before.
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(in) :: uvin                  !! UV table header
  integer(kind=index_length), intent(in) :: nvisi   !! Number of visibilities
  integer, intent(in) :: nchan                      !! Number of channels 
  real, intent(in) :: visi(uvin%gil%dim(1),nvisi)    !! UV data
  real, intent(inout) :: weights(uvin%gil%nchan)    !! Cumulative weights
  integer, intent(inout) :: wcol                    !! non-null Weight Column
  !
  ! Local ---
  integer :: iv,ic,i
  real(8) :: dw, wmean, o_uv, o_ww, o_dw
  real(8) :: uvweigh(nchan), dweight(nchan), wscale(nchan), lweight(nchan)
  !
  if (nchan.eq.1) return
  !
  wscale(:) = 1.0
  ! Two passes with per-channel scaling factor.
  do i=1,2
    !
    lweight = 0
    uvweigh = 0
    dweight = 0
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP SHARED(nvisi, nchan, uvin, visi, wscale) &
    !$OMP PRIVATE(iv,ic,dw) &
    !$OMP REDUCTION(+:lweight,uvweigh,dweight)
    !$OMP DO
    do iv=1,nvisi
      do ic=1,nchan
        dw = visi(uvin%gil%fcol-1+3*ic,iv)*wscale(ic)
        if (dw.gt.0) then
          lweight(ic) = lweight(ic) + dw
          uvweigh(ic) = uvweigh(ic) + (visi(1,iv)**2+visi(2,iv)**2)*dw
          dweight(ic) = dweight(ic) + dw**2
        endif
      enddo
    enddo
    !$OMP ENDDO
    !$OMP END PARALLEL
    !
    ! It may just be a scale factor - Double check
    wmean = sum(lweight)/nchan
    ! !Print *,'Pass # ',i, wmean, lweight
    if (i.eq.1) then
      if (all(lweight.eq.wmean)) return   ! Could have a more relaxed tolerance
      if (all(abs(lweight-wmean).le.1d-6*wmean)) return
      !
      ! Make a 2nd pass with scaling factor to check other moments
      wscale = 1./lweight
    else
      ! Verify other moments are also equal
      o_ww = lweight(1)
      o_dw = uvweigh(1)
      o_uv = dweight(1)
      if (any(abs(lweight-wmean).gt.1d-4*wmean)) then
        uvweigh = uvweigh/wmean
        dweight = dweight/wmean**2
        write(6,'(A)') &
          & "     Channel   Relative Weight Estimator"
        do ic=1,nchan
          if (lweight(ic).ne.0) then
            if ( (abs(lweight(ic)-o_ww)/(lweight(ic)+o_ww).gt.1d-3) .or. &
              &  (abs(uvweigh(ic)-o_uv)/(uvweigh(ic)+o_uv).gt.1d-3) .or. &
              &  (abs(dweight(ic)-o_dw)/(dweight(ic)+o_dw).gt.1d-3) ) then
              if (o_ww.eq.0) wcol = ic
              write(6,'(I12,3(1PG13.3))') ic,uvweigh(ic),dweight(ic)
              o_ww = lweight(ic)
              o_uv = uvweigh(ic)
              o_dw = dweight(ic)
            endif
          endif
        enddo
        !
        wmean = sum(dweight)/nchan
        if (all(dweight.eq.wmean)) then
          weights = uvweigh
        else
          weights = dweight
        endif
      else
        weights = lweight
      endif
    endif
  enddo
  !
end subroutine sub_get_nbeams
!
subroutine howmany_beams(weights, nc, cases, ncase, tole) 
  use image_def
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support routine for command  
  !     UV_CHECK BEAM
  !
  ! Find out how many different sum of weights
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nc                         !! Number of channels
  real, intent(in) :: weights(nc)                   !! Weight array
  integer, intent(inout) :: cases(nc)               !! Possible cases for beams
  integer, intent(inout) :: ncase                   !! Number of cases
  real, intent(in) :: tole                          !! Tolerance
  !
  ! Local ---
  real :: wlast, wtole, wnext
  integer :: ic
  !
  ! Code ----
  wlast = 0
  ncase = 0
  !
  do ic = 1,nc
    wnext = weights(ic)
    wtole = tole*max(wlast,wnext)
    !
    if (abs(wnext-wlast).gt.wtole) then
      ncase = ncase+1
      cases(ncase) = ic ! Which channel
      wlast = weights(ic)
    endif
  enddo
end subroutine howmany_beams
!
subroutine check_beams_mem(error)
  use clean_beams
  use clean_arrays
  use clean_default
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  ! @ private
  !! IMAGER -- Support routine for command UV_CHECK
  logical, intent(inout) :: error     !! Error flag
  !
  character(len=*), parameter :: rname='UV_CHECK'
  !
  real, allocatable :: weights(:)
  integer :: wcol
  integer :: nc
  integer :: ncase, jcase, i, ier
  integer(kind=index_length) :: dim(4)
  integer, allocatable :: cases(:)
  !
  ! Return if already done
  if (nbeam_ranges.ne.-1) return
  !  
  nc = huv%gil%nchan
  !
  call sic_delvariable ('BEAM_RANGES',.false.,error)
  error = .false.
  allocate (cases(nc),weights(nc),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  weights = 0.
  wcol = 0
  call sub_get_nbeams(huv, duv, huv%gil%nvisi, nc, weights, wcol)
  !PRINT *,'WCOL set set to ',wcol
  call howmany_beams(weights, nc, cases, ncase, beam_tolerance) 
  !
  ! Write the result
  if (ncase.le.1) then
    call map_message(seve%i,rname,'Only one beam needed')
    nbeam_ranges = 0
  else
    if (ncase.eq.nc) then
      call map_message(seve%w,rname,'Need one beam per channel',3)
      nbeam_ranges = 0
    else
      call map_message(seve%w,rname,'Beams needed for the following channel ranges:',3)
      if (allocated(beam_ranges)) deallocate(beam_ranges)
      allocate(beam_ranges(3,ncase),stat=ier)
      cases(ncase+1) = nc+1
      jcase = 0
      do i=1, ncase
        if (weights(cases(i)).ne.0) then
          write(6,'(a,i6,a,i6,a,1pg10.3)') '[',cases(i),'-',cases(i+1)-1,']    Weight;', weights(cases(i))
          jcase = jcase+1
          beam_ranges(1,jcase) = cases(i)
          beam_ranges(2,jcase) = cases(i+1)-1
          beam_ranges(3,jcase) = weights(cases(i))
        endif
      enddo
      nbeam_ranges = jcase
      dim = [3,jcase,0,0]
      call sic_def_real('BEAM_RANGES',beam_ranges,2,dim,.false.,error)
    endif
  endif
end subroutine check_beams_mem

subroutine mx_uvmap_clean(task,line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>mx_uvmap_clean
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  !*
  ! "Historical" version of UV_MAP, deprecated in IMAGER,
  ! only used for debugging and comparison.
  !
  ! TASK  Compute a map from a CLIC UV Sorted Table
  ! by Gridding and Fast Fourier Transform, using adequate
  ! scratch space for optimisation. Will work for
  ! up to 128x128x128 cube data size, may be more...
  !
  ! Input : 
  !     a precessed UV table  
  ! Output :  
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))  
  !     a beam image or cube.   
  !     a LMV cube.  
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: task   !! Caller (MX or UV_MAP)
  character(len=*), intent(in) :: line   !! Command line
  logical, intent(out) :: error          !! Logical error flag
  !
  ! Constantes
  character(len=1), parameter :: question_mark='?'
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  real, allocatable :: res_uv(:,:)
  real(8) new(3)
  real(4) rmega,uvmax,uvmin,uvma
  integer wcol,mcol(2),nfft,sblock
  integer n,ier, nsizes(3)
  logical one, sorted, shift, abort
  character(len=24) ra_c,dec_c
  character(len=message_length) :: chain
  real cpu0, cpu1
  real(8) :: freq
  real, allocatable :: fft(:)
  integer nx,ny,nu,nv,nc,np,nb
  !
  character(len=4) :: argum
  logical limits, needed
  real ylimn,ylimp
  integer ipen, miter
  !
  integer :: mx_version
  type(channel_par) :: channels
  type(cct_lst) :: cct_list
  type(gridding) :: conv
  !
  ! Code ----
  call imager_tree('MX_UVMAP_CLEAN',.false.)
  !
  call map_prepare(task,huv,themap,error)
  if (error) return
  !
  ! Test the ? argument
  if (sic_narg(0).eq.1) then
    call sic_ch(line,0,1,argum,n,.false.,error)
    if (argum(1:1).eq.question_mark) then
      call exec_program("@ i_mx "//argum)
      return
    endif
  endif
  !
  if (themap%beam.ne.0) then
    call map_message(seve%e,task,'Only works of 1 beam in total (so far)')
    error = .true.
    return
  endif
  !
  call uvmap_cols(task,line,huv,channels,error)
  if (error) return 
  mcol = channels%bounds
  wcol = channels%weight
  !
  one = .true.
  !
  call sic_get_logi('UV_SHIFT',shift,error)
  if (shift) then
     call sic_get_char('MAP_RA',ra_c,n,error)
     call sic_get_char('MAP_DEC',dec_c,n,error)
     call sic_get_dble('MAP_ANGLE',new(3),error)
  else
     new = 0.d0
  endif
  !
  ! First sort the input UV Table, leaving UV Table in UV_*
  if (shift) then
     call sic_decode(ra_c,new(1),24,error)
     if (error) then
        write(chain,'(A)') 'Input conversion error on phase center'
        call map_message(seve%e,task,chain)
        return
     endif
     call sic_decode(dec_c,new(2),360,error)
     if (error) then
        write(chain,'(A)') 'Input conversion error on phase center'
        call map_message(seve%e,task,chain)
        return
     endif
     new(3) = new(3)*pi/180.0d0
  endif
  call gag_cpu(cpu0)
  needed = themap%uniform(2).ne.0
  call uv_sort (huv,duv,error,sorted,shift,new,uvmax,uvmin,needed)
  if (error) return
  if (.not.sorted) then
    ! Redefine SIC variables (mandatory)
    call map_uvgildas('UV',huv,error,duv)
  endif
  call gag_cpu(cpu1)
  write(chain,102) 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  call map_parameters(task,themap,huv,freq,uvmax,uvmin,error) ! huv%gil%majo)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  !
  nx = themap%size(1)
  ny = themap%size(2)
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi ! not %%dim(2)
  !
  ! Define the number of output channels
  nc = mcol(2)-mcol(1)+1
  !
  write(chain,'(A,I0,A,I0,A)') 'Imaging channel range [',mcol(1),',',mcol(2),']'
  call map_message(seve%i,task,chain)
  !
  ! Check if Weights have changed by MCOL choice
  if (any(saved_chan%bounds.ne.mcol)) do_weig = .true.
  saved_chan%bounds = mcol
  !
  !
  if (the_method%method.eq.'MX') do_weig = .true. ! Test
  if (do_weig) then
    call map_message(seve%i,task,'Computing weights ')
    if (allocated(g_weight)) deallocate(g_weight)
    if (allocated(g_v)) deallocate(g_v)
    allocate(g_weight(nv),g_v(nv),stat=ier)
    if (ier.ne.0) goto 98
  else
    call map_message(seve%d,task,'Re-using weight space')
  endif
  !
  rmega = 8.0
  ier = sic_ramlog('SPACE_MAPPING',rmega)
  sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  !
  ! New Beam place
  if (allocated(dbeam)) then
    call sic_delvariable ('BEAM',.false.,error)
    deallocate(dbeam)
  endif
  call gildas_null(hbeam)
  !
  ! New dirty image
  if (allocated(ddirty)) then
    call sic_delvariable ('DIRTY',.false.,error)
    deallocate(ddirty)
  endif
  allocate(ddirty(nx,ny,nc),stat=ier)
  !
  call gildas_null(hdirty)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1:3) = (/nx,ny,nc/)
  call sic_mapgildas('DIRTY',hdirty,error,ddirty)
  !
  hdirty%r3d => ddirty
  !
  ! Find out how many beams are required
  call map_beams(task,themap%beam,huv,nx,ny,nb,nc)
  !
  mx_version = 1
  call sic_get_inte('MX_VERSION',mx_version,error)
  !
  ! Process sorted UV Table according to the number of beams produced
  if (mx_version.eq.1) then
    ! This MX patch is temporary
    !
    ! Use old code only when explicitely requested
    hbeam%gil%ndim = 2
    hbeam%gil%dim(1:2)=(/nx,ny/)
    allocate(dbeam(nx,ny,1,1),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error on DBEAM')
      error =.true.
      return
    endif
    !
    nfft = 2*max(nx,ny)
    allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),fft(nfft),stat=ier)
    if (ier.ne.0) goto 98
    !
    hbeam%r3d => dbeam(:,:,:,1)
    call mx_beam (task,themap,   &
       &    huv, hbeam, hdirty,   &
       &    nx,ny,nu,nv, duv,   &
       &    w_mapu, w_mapv, w_grid, &
       &    g_weight, g_v, do_weig,  &
       &    wcol,mcol,fft,   &
       &    sblock,cpu0,error,uvma,conv)
    if (error) return
    !
    call sic_mapgildas('BEAM',hbeam,error,dbeam)
  else
    ! The MX part still needs debugging - because the W_GRID array
    ! is not there ...
    !
    hbeam%gil%ndim = 3
    hbeam%gil%dim(1:4)=[nx,ny,nb,1]
    if (nb.gt.1) then
      allocate(hbeam%r3d(nx,ny,nb),dbeam(nx,ny,1,nb),stat=ier)
    else
      allocate(dbeam(nx,ny,1,1),stat=ier)
      hbeam%r3d => dbeam(:,:,:,1)
    endif
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error on DBEAM')
      error =.true.
      return
    endif
    !
    call many_beams_para (task,themap,channels,   &
       &    huv, hbeam, hdirty,   &
       &    nx,ny,nu,nv, duv,   &
       &    g_weight, do_weig,  &
       &    sblock,cpu0,error,uvma,0,abort,0)
    if (abort) then
      call map_message(seve%w,task,'Aborted by user')
      error = .true.
      return
    endif
    !
    hdirty%loca%addr = locwrd(ddirty)
    call gdf_get_extrema (hdirty,error)
    !
    ! Re-shape the beam, and reset the 4-D pointer, 
    ! but show it as a 3-D array in SIC
    if (nb.gt.1) then
      dbeam(:,:,:,:) = reshape(hbeam%r3d,[nx,ny,1,nb])
      deallocate(hbeam%r3d)
    endif
    call sic_mapgildas('BEAM',hbeam,error,dbeam)
    !
    hbeam%r4d => dbeam
    hbeam%gil%dim(1:4)=[nx,ny,1,nb]
    hbeam%gil%ndim = 4
    !
    ! Transpose the header appropriately
    hbeam%gil%convert(:,4) = hbeam%gil%convert(:,3)
    hbeam%gil%faxi = 4
    hbeam%char%code(4) = 'VELOCITY' ! Frequency would be better...
    hbeam%gil%convert(:,3) = 1.d0
    hbeam%char%code(3) = 'FIELD'    ! Pseudo-mosaic
    hbeam%gil%ndim = 4
    !
    hbeam%loca%addr = locwrd(dbeam)
    call gdf_get_extrema (hbeam,error)
  endif
  save_data(code_save_beam) = .true.
  save_data(code_save_dirty) = .true.
  !
  call new_dirty_beam
  !
  ! Define Min Max
  d_max = hdirty%gil%rmax
  if (hdirty%gil%rmin.eq.0) then
     d_min = -0.03*hdirty%gil%rmax
  else
     d_min = hdirty%gil%rmin
  endif
  !
  ! Prepare MX part
  limits = sic_present(1,1)
  if (limits) then
    call sic_r4 (line,1,1,ylimn,.true.,error)
    if (error) return
    call sic_r4 (line,1,2,ylimp,.true.,error)
    if (error) return
  else
    ylimp = sqrt (float(the_method%m_iter+200) *   &
        &      log(float(the_method%m_iter+1)) ) * the_method%gain
    if (ylimp.eq.0.) ylimp = 1.0
    if (-hdirty%gil%rmin.gt.1.3*hdirty%gil%rmax) then
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = 0.0
    elseif (-1.3*hdirty%gil%rmin.gt.hdirty%gil%rmax) then
      ylimn = 0.0
      ylimp = ylimp*hdirty%gil%rmax
    else
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = ylimp*hdirty%gil%rmax
    endif
  endif
  np = max(1,hprim%gil%dim(1))
  !
  ! Data checkup
  call clean_data (error)
  if (error) return
  !
  ! Copy the UV Data (eh eh)
  allocate (res_uv(nu,nv),stat=ier)
  res_uv(:,:) = duv
  !
  ! Get the right pointers before starting...
  hclean%r3d => dclean
  hresid%r3d => dresid
  dresid(:,:,:) = ddirty
  hbeam%r4d => dbeam ! Also required for MX
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,the_method)
  the_method%method = 'MX'
  the_method%pflux = sic_present(1,0)
  the_method%pcycle = sic_present(2,0)
  the_method%qcycle = sic_present(3,0)
  the_method%pclean = .false.
  the_method%pmrc = .false.
  !
  call sic_get_inte('FIRST',the_method%first,error)
  call sic_get_inte('LAST',the_method%last,error)
  if (the_method%first.eq.0) the_method%first = 1
  if (the_method%last.eq.0) the_method%last = hdirty%gil%dim(3)
  the_method%first = max(1,min(the_method%first,hdirty%gil%dim(3)))
  the_method%last = max(the_method%first,min(the_method%last,hdirty%gil%dim(3)))
  !
  ! Other parameters
  if (the_method%patch(1).ne.0) then
    the_method%patch(1) = min(the_method%patch(1),nx)
  else
    the_method%patch(1) = min(nx,max(32,nx/4))
  endif
  if (the_method%patch(2).ne.0) then
    the_method%patch(2) = min(the_method%patch(2),nx)
  else
    the_method%patch(2) = min(nx,max(32,nx/4))
  endif
  the_method%bzone = (/1,1,nx,ny/)
  !
  call check_area(the_method,hdirty,.false.)
  call check_mask(the_method,hdirty)
  the_method%do_mask = the_method%do_mask
  !
  ! Clean Component Structure (once it is defined, i.e. after check)
  call cct_list%initialize()
  call cct_list%reallocate(the_method%m_iter)
  !
  ! Prepare the CCT data
  nsizes = [nx,ny,nc]
  call cct_prepare(line,nsizes,the_method,task,error)
  if (error) return
  !
  if (the_method%pflux) call init_flux90(the_method,hdirty,ylimn,ylimp,ipen)
  !
  if (the_method%pcycle) call init_plot(the_method,hdirty,dresid)
  !
  ! Perform the cleaning
  miter = the_method%m_iter
  if (the_method%m_iter.eq.0) the_method%m_iter = 2**30
  call mx_clean (themap,huv,res_uv,g_weight,g_v,       &
    &    the_method,hdirty,hbeam,hclean,hresid,hprim,   &
    &    w_grid,w_mapu,w_mapv,cct_list,dcct,d_mask,d_list,      &
    &    sblock, cpu0, uvma, conv)
  the_method%m_iter = miter
  !
  if (the_method%pflux) then
    call close_flux90(ipen,error)
  else
    call gr_execl('CHANGE DIRECTORY <GREG')
  endif
  !
  ! Reset extrema
  hresid%gil%extr_words = 0
  hclean%gil%extr_words = 0
  !
  ! Specify clean beam parameters
  hclean%gil%reso_words = 3
  hclean%gil%majo = the_method%major
  hclean%gil%mino = the_method%minor
  hclean%gil%posa = pi*the_method%angle/180.0
  ! Specify clean beam parameters
  hbeam%gil%reso_words = 3
  hbeam%gil%majo = the_method%major
  hbeam%gil%mino = the_method%minor
  hbeam%gil%posa = pi*the_method%angle/180.0
  save_data(code_save_clean) = .true.
  the_method%nlist = the_method%nlist
  !
  ! Defines the CCT variable
  call sic_mapgildas ('CCT',hcct,error,dcct)
  !
  ! Cleanup
  if (allocated(cct_list%cc)) deallocate(cct_list%cc)
  error = .false.
  !
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  if (allocated(fft)) deallocate(fft)
  call imager_tree('MX_UVMAP_CLEAN',.true.)
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
  !
102 format(a,f9.2)
end subroutine mx_uvmap_clean
!
subroutine mx_beam (rname,map,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    w_mapu, w_mapv, w_grid, w_weight, w_v, do_weig,    &
     &    wcol,mcol,wfft,sblock,cpu0,error,uvmax,conv)
  use gkernel_interfaces
  use imager_interfaces, except_this=>mx_beam
  use clean_def
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  - Old MX command  
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   one single beam for all channels.
  !
  ! Input : 
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  ! Output :  
  ! a beam image,
  ! a VLM cube
  !
  ! Work space : 
  ! a  VLM complex Fourier cube (first V value is for beam)
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Calling Task name
  type (uvmap_par), intent(inout) :: map    !! Mapping parameters
  type (gildas), intent(inout) :: huv       !! UV data set
  type (gildas), intent(inout) :: hbeam     !! Dirty beam data set
  type (gildas), intent(inout) :: hdirty    !! Dirty image data set
  integer, intent(in) :: nx     !! X size
  integer, intent(in) :: ny     !! Y size
  integer, intent(in) :: nu     !! Size of a visibilities
  integer, intent(in) :: nv     !! Number of visibilities
  real, intent(inout) :: uvdata(nu,nv)      !! UV data
  real, intent(inout) :: w_mapu(nx)         !! U grid coordinates
  real, intent(inout) :: w_mapv(ny)         !! V grid coordinates
  real, intent(inout) :: w_grid(nx,ny)      !! Gridding space
  real, intent(inout) :: w_weight(nv)       !! Weight of visibilities
  real, intent(inout) :: w_v(nv)            !! V values
  logical, intent(inout) :: do_weig         !! Should weight be computed ?
  real, intent(inout) :: wfft(*)            !! Work space
  real, intent(inout) :: cpu0               !! CPU counter
  real, intent(inout) :: uvmax              !! Maximum baseline
  integer, intent(inout) :: sblock          !! Blocking factor
  integer, intent(inout) :: wcol            !! Weight channel
  integer, intent(inout) :: mcol(2)         !! First and last channel
  logical, intent(inout) :: error           !! Logical error flag
  type(gridding), intent(inout) :: conv     !! Gridding function
  ! Global variables:
  !
  ! Constants
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  logical, parameter :: NEW=.true.  ! Test...
  !
  ! Local ---
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer ier
  real(kind=8) freq
  integer ctypx,ctypy
  integer icol,lcol,fcol,imi,ima,iv
  real rmi,rma,wall,cpu1
  real xparm(10),yparm(10)
  real vref,voff,vinc
  integer ndim, nn(2), i, lx, ly
  integer istart,iblock,nblock,kz,iz,kkz
  integer blc(4),trc(4)
  character(len=message_length) :: chain
  !
  real rms, null_taper(4)
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:)
  integer(kind=8) :: ilong
  !
  integer :: ithread, nthread
  !$ integer(kind = OMP_lock_kind) :: lck
  real(8) :: elapsed_s, elapsed_e, elapsed
  real :: local_wfft(2*max(nx,ny))
  !
  data blc/4*0/, trc/4*0/
  !------------------------------------------------------------------------
  !
  ! Code ----
  call imager_tree('MX_BEAM',.false.)
  !
  nd = nx*ny
  nc = huv%gil%nchan
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nc)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  freq = gdf_uv_frequency(huv, 0.5d0*dble(lcol+fcol) )
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Load V values and original Weights
  icol = 3*wcol + 7
  allocate(w_w(nv),stat=ier)
  call dovisi (nu,nv,uvdata,w_v,w_w,icol)
  !
  ! Compute weights
  if (do_weig) then
    call doweig (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    wcol,   &            ! Weight channel
       &    map%uniform(1),   &  ! Uniform UV cell size
       &    w_weight,   &        ! Weight array
       &    map%uniform(2),   &  ! Fraction of weight
       &    error)
    if (error)  return
    !
    ! Should also plug the TAPER here, rather than in DOFFT later  !
    call dotape (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    map%taper,  &        ! Taper
       &    w_weight)            ! Weight array
    do_weig = .false.
  else
    call map_message(seve%i,rname,'Reusing weights')
  endif
  null_taper = 0
  ! For test
  !  else
  !    null_taper = map%taper
  !  endif
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished weighting CPU ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  wall = 0
  do iv=1,nv
    if (w_w(iv).gt.0) wall = wall + w_w(iv)
  enddo
  if (wall.eq.0.0) then
    write(chain,101) 'Plane ',wcol,' has Zero weight'
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else
    !
    ! Noise definition
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Natural',wall,rms)
    !
    ! Re-normalize the weights and re-count the noise
    call scawei (nv,w_weight,w_w,wall)
    wall = 1e-3/sqrt(wall)
    call prnoise(rname,'Expected',wall,rms)
  endif
  deallocate(w_w)
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%w,rname,chain,3)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ! Optimize SBLOCK now, allowing some additional memory if NBLOCK small
  if (sblock.gt.0) then
    nblock = (nc+sblock-1)/sblock
    kz = mod(nc,sblock)
    if (kz.ne.0 .and. kz.lt.(sblock/(nblock+1))) then
      if (nblock.ne.1) nblock = nblock-1
    endif
    sblock = (nc+nblock-1)/nblock
    kz = min(sblock,nc)
  else
    kz = nc
    nblock = 1
  endif
  !
  ! Get FFTs work space
  write(chain,101) 'Using a blocking factor of ',sblock,' planes'
  call map_message(seve%i,rname,chain)
  allocate (tfgrid(kz+1,lx,ly),ftbeam(nx,ny),stat=ier)
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ftbeam,nn,ndim,-1,1)
  !
  ! Prepare grid correction,
  !
  allocate(w_xgrid(nx),w_ygrid(ny),stat=ier)
  call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
  call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call uvmap_headers(huv,nx,ny,1,nc,map,mcol,hbeam,hdirty,error)
  if (error) return
  !
  ! Loop over blocks
  !$ call omp_init_lock(lck)
  !
  kkz = kz
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP PRIVATE(iblock,istart,kz,blc,trc)  &
  !$OMP PRIVATE(tfgrid,ftbeam) &  ! Big arrays
  !$OMP SHARED(nblock, sblock, kkz, nu,nv,nx,ny,nc,nd,fcol,lx,ly, lck,nthread) &
  !$OMP SHARED(w_mapu,w_mapv,map,null_taper) &
  !$OMP SHARED(conv) &
  !$OMP SHARED(nn,ndim,hbeam,hdirty,rname) &
  !$OMP SHARED(w_grid,w_xgrid,w_ygrid,w_v,w_weight,uvdata, wfft) &
  !$OMP PRIVATE(rmi,rma,imi,ima,ilong,chain) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
  !
  !$OMP MASTER
  nthread = 1
  !$  nthread = omp_get_num_threads()
  if (nblock.lt.nthread) then
    nblock = min(nthread,nc)
    sblock = (nc+nblock-1)/nblock
    write(chain,'(A,I6,A,I8,A)') 'Reset ',nblock,' blocks of ',&
      & sblock,' channels for Threading'
    call map_message(seve%w,rname,chain)
    kkz = sblock
  endif
  !$OMP END MASTER
  !$OMP BARRIER
  !
  !$OMP DO
  do iblock = 1,nblock
    !$ elapsed_s = omp_get_wtime()
    !$ ithread = omp_get_thread_num()
    !$ if (iblock.eq.1) call omp_set_lock(lck)
    !
    istart = fcol+(iblock-1)*sblock
    blc(3) = (iblock-1)*kkz+1
    kz = min (sblock,nc-sblock*(iblock-1))
    trc(3) = blc(3)-1+kz
    !
    ! This is the power-hungry routine...
    call dofft (nu,nv,             &   ! Size of visibility array
         &        uvdata,          &   ! Visibilities
         &        1,2,             &   ! U, V pointers
         &        istart,          &   ! First channel to map
         &        kz,lx,ly,        &   ! Cube size
         &        tfgrid,          &   ! FFT cube
         &        w_mapu,w_mapv,   &   ! U and V grid coordinates
         &        map%support,map%uvcell,null_taper,   &    ! Gridding parameters
         &        w_weight,        &   ! Weight array
         &        conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
    !
    ! Should one beam per block be created, this test can be
    ! easily modified
    if (iblock.eq.1) then
      call map_message(seve%i,rname,'Creating beam ')
      !
      call extracs(kz+1,nx,ny,kz+1,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,wfft)
      call cmtore (ftbeam,hbeam%r3d(:,:,1),nx,ny)
      !
      ! Compute Grid correction and Free the Grid lock
      ! Normalization factor is applied to grid correction,
      ! for further use on beam and channel maps.
      call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,hbeam%r3d(:,:,1))
      !$ call omp_unset_lock(lck)
      !
      ! Normalize and Free beam
      call docorr (hbeam%r3d(:,:,1),w_grid,nd)
      rma = -1e38
      rmi = 1e38
      call domima (hbeam%r3d(:,:,1),rmi,rma,imi,ima,nd)
      hbeam%gil%extr_words = def_extr_words          ! extrema computed
      hbeam%gil%rmax = rma
      hbeam%gil%rmin = rmi
      ilong = imi
      call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%minloc)
      ilong = ima
      call gdf_index_to_where (ilong,hbeam%gil%ndim,hbeam%gil%dim,hbeam%gil%maxloc)
      !
      !$ elapsed_e = omp_get_wtime()
      elapsed = elapsed_e - elapsed_s
      write(chain,102) 'Finished Beam, Elapsed ',elapsed
      call map_message(seve%i,rname,chain)
      call map_message(seve%i,rname,'Creating map file ')
    endif
    !
    ! Wait for gridding correction to be computed
    !$  call omp_set_lock(lck)
    ! but free lock immediately, as no further waiting is needed.
    !$  call omp_unset_lock(lck)
    ! In general, the time spent here is negligible,
    ! so Parallel Nesting is not needed,
    ! but this is not always the case...
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & PRIVATE(i,iz,ftbeam,local_wfft) &
    !$OMP & SHARED(lck,nx,ny,nd,nn,ndim,lx,ly,iblock,kz,kkz) &
    !$OMP & SHARED(hdirty,w_grid,tfgrid)
    !$OMP DO
    do i=1,kz
      iz = i+(iblock-1)*kkz
      call extracs(kz+1,nx,ny,i,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,hdirty%r3d(:,:,iz),nx,ny)
      call docorr (hdirty%r3d(:,:,iz),w_grid,nd)
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End planes ',blc(3),trc(3),' Time ',elapsed &
      & ,' Block ',iblock,' Thread ',ithread
    call map_message(seve%i,rname,chain)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !$  call omp_destroy_lock(lck)
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished maps ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  hdirty%gil%extr_words = def_extr_words  ! extrema computed
  hdirty%gil%minloc = 1
  hdirty%gil%maxloc = 1
  hdirty%gil%minloc(1:3) = minloc(hdirty%r3d)
  hdirty%gil%maxloc(1:3) = maxloc(hdirty%r3d)
  rma = hdirty%r3d(hdirty%gil%maxloc(1),hdirty%gil%maxloc(2),hdirty%gil%maxloc(3))
  rmi = hdirty%r3d(hdirty%gil%minloc(1),hdirty%gil%minloc(2),hdirty%gil%minloc(3))
  hdirty%gil%rmax = rma
  hdirty%gil%rmin = rmi
  hdirty%gil%nois_words = 2
  hdirty%gil%noise = wall
  !  
  ! Delete scratch space
  error = .false.
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  call imager_tree('MX_BEAM',.true.)
  return
  !
101 format(a,i6,a)
102 format(a,f9.2)
103 format(a,i5,' to ',i5,a,f9.2,a,i2,a,i2)
end subroutine mx_beam
!
subroutine mx_clean (map,huv,uvdata,uvp,uvv,   &
     &    method,hdirty,hbeam,hclean,hresid,hprim,   &
     &    w_grid,w_mapu,w_mapv, cct_list, dcct, smask, slist,   &
     &    sblock, cpu0, uvmax, conv)
  use clean_def
  use image_def
  use gbl_message
  use imager_interfaces, except_this => mx_clean
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER -- 
  !   Implementation of MX CLEAN deconvolution algorithm.
  !----------------------------------------------------------------------
  type (clean_par), intent(inout) :: method !! Clean Method parameters
  type (uvmap_par), intent(inout) :: map    !! UV_MAP parameters
  type (gildas), intent(inout) :: huv       !! UV data
  type (gildas), intent(inout) :: hdirty    !! Dirty cube
  type (gildas), intent(inout) :: hbeam     !! Dirty beam
  type (gildas), intent(inout) :: hclean    !! Clean cube
  type (gildas), intent(inout) :: hresid    !! Residual cube
  type (gildas), intent(inout) :: hprim     !! Primary beams
  real, intent(inout) :: dcct(3,hclean%gil%dim(3),*)  !! Clean components
  logical, intent(inout) :: smask(:,:)      !! Source mask ?
  integer, intent(in) :: slist(*)           !! Search list
  integer, intent(in) :: sblock             !! Blocking factor
  real, intent(inout) :: uvdata(huv%gil%dim(1),huv%gil%dim(2))  !! UV data
  real, intent(in) :: uvp(:)          !!
  real, intent(in) :: uvv(:)          !! V values
  real, intent(inout) :: w_grid(:,:)  !! Gridded weights
  real, intent(inout) :: w_mapu(:)    !! U grid
  real, intent(inout) :: w_mapv(:)    !! V grid
  real, intent(in) :: cpu0            !! CPU counter
  real, intent(inout) :: uvmax        !! Maximum baseline
  type (cct_lst), intent(inout) :: cct_list   !! Clean component list
  type(gridding), intent(in) :: conv  !! Gridding convolution kernels.
  !
  character(len=*), parameter :: rname = 'MX'
  !
  ! Local ---
  logical :: error
  integer nx,ny,nz,nf, mc,nclean, i, nu,nv
  real fhat
  real, allocatable :: mapx(:), mapy(:)
  real, pointer :: p_resid(:,:)
  real, pointer :: p_clean(:,:)
  real, pointer :: p_beam(:,:,:)
  real, pointer :: p_prim(:,:,:)   ! Primary beam
  real, pointer :: p_atten(:,:,:) ! Mosaic weight
  type(cct_par), allocatable :: p_comp(:)      ! Clean values
  complex, allocatable :: p_work(:,:)
  real, allocatable :: p_tfbeam(:,:,:)
  integer, allocatable :: p_niter(:)
  real, allocatable :: w_fft(:)
  real, dimension(1,1,1), target ::dummy3d
  integer ier,iplane
  character(len=message_length) :: chain
  !
  ! Code ----
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  mc = method%m_iter
  !
  ! Get some memory
  allocate (p_work(nx,ny),p_tfbeam(nx,ny,1),stat=ier)
  nclean = nx*ny
  allocate (p_comp(nclean),stat=ier)
  allocate (mapx(nx),mapy(ny),stat=ier)
  allocate (w_fft(max(nx,ny)),stat=ier)
  !
  call loadxy (method,huv,hdirty,mapx,nx,mapy,ny)
  !
  ! Prepare beam parameters
  method%ibeam = 1             ! Test
  method%iplane = 1            ! Test
  error = .false.
  call get_clean (method,hbeam,hbeam%r3d,error)
  if (error) return
  call get_beam (method%ibeam,method%verbose, &
     &  method,hbeam,hresid,hprim,.false.,  &
     &  p_tfbeam,p_work,w_fft,fhat,error)
  if (error) return
  !
  ! Find components in all planes...
  nz = max(hdirty%gil%dim(3),1)
  allocate (p_niter(nz),stat=ier)
  nf = max(1,hprim%gil%dim(1))
  p_beam  => hbeam%r3d(:,:,1:1)
  if (method%mosaic) then
    p_prim => hprim%r3d
    p_atten=> method%atten
  else
    p_prim => dummy3d
    p_atten=> dummy3d
  endif
  !
  ! Loop here if needed
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi  ! not %dim(2)
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    write(chain,'(A,I6,I6)') 'Image & Beam planes ',   &
        &      method%iplane,method%ibeam
    !omp!$ chain = trim(chain)//cthread
    call map_message(seve%d,rname,chain)
    !
    method%iplane = iplane
    p_resid => hresid%r3d(:,:,iplane)
    p_clean => hclean%r3d(:,:,iplane)
    p_beam  => hbeam%r3d(:,:,method%ibeam:method%ibeam)
    !
    call get_clean (method, hbeam, p_beam, error)
    !
    call mx_major_cycle90 (map,uvdata,   &
     &      nu,nv,uvp,uvv,   &
     &      method,hdirty,   &
     &      p_clean,p_beam,p_resid,   &
     &      nx,ny,1,         &
     &      p_comp,nclean,   &
     &      cct_list, p_niter(iplane),   &
     &      slist, method%nlist,   &
     &      nf, p_prim, p_atten,   &
     &      w_grid, w_mapu, w_mapv, mapx, mapy,   &
     &      p_tfbeam, cpu0, uvmax, conv)
    !
    ! Add clean components to clean map
    write(chain,1001) 'Restoring plane ',iplane
    call map_message(seve%d,rname,chain)
    ! Could be replaced by CLEAN_MAKE90... to be checked...
    if (p_niter(iplane).ne.0) then
      !! Print *,'adding residual '
      call clean_make(method,hclean,p_clean,cct_list%cc)
      p_clean = p_clean+p_resid
    else
      p_clean = p_resid
    endif
!
    do i=1,method%n_iter
       dcct(1,iplane,i) = (dble(cct_list%cc(i)%ix) -   &
         &          hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
         &          hclean%gil%convert(2,1)
       dcct(2,iplane,i) = (dble(cct_list%cc(i)%iy) -   &
         &          hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
         &          hclean%gil%convert(2,2)
       dcct(3,iplane,i) = cct_list%cc(i)%value
    enddo
  enddo
  !
  ! Clean-up
  if (allocated(p_work)) deallocate(p_work)
  if (allocated(p_tfbeam)) deallocate(p_tfbeam)
  if (allocated(p_comp)) deallocate(p_comp)
  if (allocated(mapx)) deallocate(mapx)
  if (allocated(mapy)) deallocate(mapy)
  if (allocated(w_fft)) deallocate(w_fft)
  if (allocated(p_niter)) deallocate(p_niter)
  return
  !
  1001  format(a,i5,i5)
end subroutine mx_clean
!
subroutine loadxy (method,huv,head,mapx,nx,mapy,ny)
  use clean_def
  use image_def
  !--------------------------------------------------
  ! @ private
  !
  ! IMAGER -- MX utility -- Load x,y coordinates
  !--------------------------------------------------
  type (clean_par), intent(in) :: method  !! Clean parameters
  type (gildas), intent(in) :: huv    !! UV data header
  type (gildas), intent(in) :: head   !! Cube header
  integer, intent(in) :: nx           !! X size
  integer, intent(in) :: ny           !! Y size
  real, intent(out) :: mapx(nx)       !! X coordinates
  real, intent(out) :: mapy(ny)       !! Y coordinates
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  integer :: i
  real :: pidsur                  ! 2*pi*D/Lambda
  real(8) :: freq
  !
  ! Code ----
  freq = huv%gil%convert(2,1)+huv%gil%fres*   &
     &    ((method%first+method%last)*0.5-huv%gil%convert(1,1))
  pidsur = f_to_k * freq
  !
  do i=1,nx
    mapx(i) = pidsur*((i-head%gil%convert(1,1))*head%gil%convert(3,1)   &
     &      +head%gil%convert(2,1))
  enddo
  do i=1,ny
    mapy(i) = pidsur*((i-head%gil%convert(1,2))*head%gil%convert(3,2)   &
     &      +head%gil%convert(2,2))
  enddo
end subroutine loadxy

module viewer_interfaces_none
  interface
    subroutine viewer_pack_set(pack)
      use gpack_def
      !
      type(gpack_info_t), intent(out) :: pack
    end subroutine viewer_pack_set
  end interface
  !
  interface
    subroutine viewer_pack_init(gpack_id,error)
      use sic_def
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      integer :: gpack_id
      logical :: error
    end subroutine viewer_pack_init
  end interface
  !
  interface
    subroutine viewer_pack_on_exit(error)
      !----------------------------------------------------------------------
      !
      !----------------------------------------------------------------------
      logical :: error
    end subroutine viewer_pack_on_exit
  end interface
  !
end module viewer_interfaces_none

!! EXTREMA handling routines
subroutine t_setextrema(h,rmi,jmi,rma,jma)
  use gkernel_interfaces
  use gildas_def
  use image_def
  !------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Put extrema into the specified header
  !!
  !------------------------------------------------
  type (gildas), intent(inout), target :: h    !! Header
  real(kind=4), intent(in) :: rmi              !! Value of minimum
  integer(kind=size_length), intent(in) :: jmi !! Position of minimum
  real(kind=4), intent(in) :: rma              !! Value of maximum
  integer(kind=size_length), intent(in) :: jma !! Position of maximum
  !
  integer(kind=8) :: ilong 
  !
  h%gil%rmax = rma
  h%gil%rmin = rmi
  ilong = jmi
  call gdf_index_to_where (ilong,h%gil%ndim,h%gil%dim,h%gil%minloc)  
  ilong = jma
  call gdf_index_to_where (ilong,h%gil%ndim,h%gil%dim,h%gil%maxloc)  
  h%gil%extr_words = def_extr_words                ! extrema computed
end subroutine t_setextrema
!
subroutine cube_minmax(comm,hmap,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Compute the extrema of a data Cube
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm  !! Caller name
  type(gildas), intent(inout) :: hmap   !! Cube header
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Local ---
  integer(kind=size_length) :: good_size
  character(len=128) :: mess
  real :: rmi,rma
  !
  ! Code ----
  !
  ! Check properly the sizes and allocation status before
  if (.not.associated(hmap%r3d)) then
    call map_message(seve%e,comm,'3D pointer not associated')
    error = .true.
    return
  endif
  error = .false.
  good_size = hmap%gil%dim(1)*hmap%gil%dim(2)*hmap%gil%dim(3)
  if (hmap%loca%size.ne.good_size) then
    write(mess,'(A,I0,A,4(1X,I0))')  '3D size was incorrectly set', &
      & hmap%loca%size,', expected ',good_size, hmap%gil%dim(1:3)
    call map_message(seve%w,comm,mess)
    hmap%loca%size = good_size
  endif
  !
  if (hmap%gil%eval.lt.0) then
    hmap%gil%minloc = 1
    hmap%gil%maxloc = 1
    hmap%gil%minloc(1:3) = minloc(hmap%r3d)
    hmap%gil%maxloc(1:3) = maxloc(hmap%r3d)
    rma = hmap%r3d(hmap%gil%maxloc(1),hmap%gil%maxloc(2),hmap%gil%maxloc(3))
    rmi = hmap%r3d(hmap%gil%minloc(1),hmap%gil%minloc(2),hmap%gil%minloc(3))
    hmap%gil%rmax = rma
    hmap%gil%rmin = rmi
  else
    hmap%loca%addr = locwrd(hmap%r3d)
    call gdf_get_extrema (hmap,error)
  endif
  hmap%gil%extr_words = def_extr_words  ! extrema computed
end subroutine cube_minmax

module uvfit_options
  integer, parameter :: o_cont=1      ! /CONT
  integer, parameter :: o_index=2     ! /INDEX
  integer, parameter :: o_unit=3      ! /OUTPUT   
  integer, parameter :: o_quiet=4     ! /QUIET
  integer, parameter :: o_range=5     ! /RANGE
  integer, parameter :: o_result=6    ! /RESULT
  integer, parameter :: o_save=7      ! /SAVE
  integer, parameter :: o_uvrange=8   ! /UVRANGE
  integer, parameter :: o_widget=9    ! /WIDGET
end module uvfit_options
!
subroutine uvfit_comm(line,error)
  use uvfit_options
  use iso_fortran_env
  use gkernel_interfaces
  use gbl_message
  use clean_default
  use clean_arrays
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Support for command UV_FIT   
  !   UV_FIT [Func1 ... FuncN] [/QUIET] 
  !     [/WIDGET Nfunc] [/SAVE File] [/RESULT]
  !     [/UVRANGE Min [Max]]
  !     [/CONTINUUM [Field] [/INDEX Sp] [/RANGE Min Max TYPE]]
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(inout) :: error         !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_FIT'
  integer, parameter :: mf=4 ! Could be up to 10
  !
  character(len=32) :: chain,comm
  type(gildas) :: htmp
  integer :: nf, nline, in, nc
  logical :: verbose, do_insert, was_cont, err, re_use
  character(len=filename_length) :: fich
  character(len=2) :: code
  character(len=8) :: chnew
  integer :: io
  !
  integer :: my_unit, ier
  character(len=filename_length), save :: ofich, ofile
  data ofile/'uv_fit.res'/  
  !
  ! /RESULT option
  if (sic_present(o_result,0)) then
    do io=1,9
      if (io.ne.o_result) then
        if (sic_present(io,0)) then
          call map_message(seve%e,rname,'/RESULT Option conflicts with any other one')
          error = .true.
          return
        endif
      endif
    enddo
    call sub_uvfit_results(line,error)
    return
  endif
  do_insert = (sic_lire().eq.0)
  if (sic_present(o_save,0)) then
    do io=1,9
      if (io.ne.o_save) then
        if (sic_present(io,0)) then
          call map_message(seve%e,rname,'/SAVE Option conflicts with any other one')
          error = .true.
          return
        endif
      endif
    enddo
    call sic_ch(line,o_save,1,fich,nc,.true.,error)
    if (error) return
    call exec_program('@ s_uvfit '//fich(1:nc))
    if (do_insert) call sic_insert_log(line)
    return
  endif
  !
  verbose = .not.sic_present(o_quiet,0)
  my_unit = output_unit
  !
  was_cont = sic_present(o_cont,0)
  if (was_cont) then
    if (sic_present(o_widget,0)) then
      call map_message(seve%e,rname,'Option /WIDGET is not compatible with /CONTINUUM')
      error = .true.
      return
    endif
    if (huv%gil%nchan.le.1) then
      ! Only one channel, use as is
      was_cont = .false.
      call map_message(seve%w,rname,'Only one channel already')
    else
      call gildas_null(htmp,type='UVT')
      call uv_buffer_finduv(code)
      !
      ! Use (and Create if needed) the "Continuum" UV data set
      call map_message(seve%w,rname,'/CONTINUUM option still under test ')
      re_use = .true.
      if (sic_present(o_range,0).or.sic_present(o_index,0).or.(sic_narg(o_cont).ne.0)) re_use=.false.
      call switch_uvfit_cont(line,rname,re_use,code,htmp,error)
      if (error) return
    endif
  else
    if (sic_present(o_index,0).or.sic_present(o_range,0)) then
      call map_message(seve%e,rname,'Options /RANGE and /INDEX only valid with /CONTINUUM')
      error = .true.
      return
    endif
  endif
  !
  ! /OUTPUT [File]
  my_unit = output_unit  ! Default Fortran output
  if (sic_present(o_unit,0)) then
    my_unit = 1 !!TEST
    if (sic_present(o_unit,1)) then
      call sic_ch(line,o_unit,1,ofich,in,.true.,error)
      call sic_parse_file (ofich,' ','.res',ofile) 
      chnew = '  ' 
      call sic_ke(line,o_unit,2,chnew,in,.false.,error)
      if (chnew.eq.'NEW') then
        ier = sic_open(my_unit,ofile,chnew,.false.)
      else
        open(unit=my_unit,file=ofile,status='NEW',iostat=ier)
      endif
    else
      open(unit=my_unit,file=ofile,status='OLD',access='APPEND',iostat=ier)
    endif
    if (ier.ne.0) then
      call map_iostat(seve%e,rname,ier)
      error = .true.
      return
    endif
  endif
  !
  error =.false.
  do_insert = (sic_lire().eq.0)
  if (sic_present(o_widget,0)) then
    ! Create the Widget if option is mentionned
    in = index(line,'UV_FIT')+7
    chain = "@ x_uvfit "//line(in:)
    call sic_i4(line,o_widget,1,nf,.true.,error)
    if (error) return
    if (nf.lt.1 .or. nf.gt.mf) then
      write(chain,'(I0)') mf
      call map_message(seve%e,rname,'1 to '//trim(chain)//' functions possible')
      error = .true.
      return
    endif
    call exec_program(chain)
  else 
    if (sic_narg(0).ne.0) then
      nf = sic_narg(0)/8
      write(chain,'(A,I0)') "@ x_uvfit ",nf
      call exec_program(chain)
      comm = 'UV_FIT'
      nline = len_trim(line)
      call sic_analyse(comm,line,nline,error)
    endif
    huv%r2d => duv
    call uvfit_sub(line,huv,verbose,my_unit,error)
  endif
  !
  if (my_unit.ne.output_unit) close(my_unit)
  !
  if (was_cont) then
    ! Reset HUV buffer
    call uv_buffer_resetuv(code)
    call gdf_copy_header(htmp,huv,err)
  endif
  !
  if (error) return
  last_resid = 'UV_FIT'
  if (do_insert) call sic_insert_log(line)
end subroutine uvfit_comm
!
subroutine switch_uvfit_cont(line,comm,reuse,code,htmp,error)
  use uvfit_options
  use gildas_def
  use clean_default
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => switch_uvfit_cont
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_FIT /CONTINUUM
  !
  ! Temporarily point towards the "continuum" UV data
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   !! Command line
  character(len=*), intent(in)    :: comm   !! Command name
  character(len=2), intent(inout) :: code   !! UV buffer code
  type(gildas), intent(out) :: htmp         !! Re-usable Header
  logical, intent(in) :: reuse              !! Re-Use existing data
  logical, intent(inout) :: error
  !
  ! Local ---
  integer :: channels(3)
  integer :: ier
  real :: ofield(2), cfield
  !
  ! Code ----
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,comm,'No UV_DATA available')
    error = .true.
    return
  endif
  call gildas_null(htmp,type='UVT')
  call uv_buffer_finduv(code)           ! Get next UV buffer code
  call gdf_copy_header(huv,htmp,error)
  !
  ! Select the data set. Can be UV_DATA, UV_MODEL, or UV_RESIDUAL
  ! We may have an issue about data sorting here,
  ! as well as Weight re-computation
  call uvdata_select(comm,error)
  if (error) return
  !
  if (reuse.and.huvc%loca%size.ne.0) then
    call map_message(seve%w,comm,'Re-using available Continuum UV data',3)
  else
    if (huvc%loca%size.eq.0) then
      call map_message(seve%w,comm,'Computing Continuum UV data',3)
    else if (.not.reuse) then
      call map_message(seve%w,comm,'Re-Computing modified Continuum UV data',3)
    endif
    !
    ! Use default_map to specify the Field of view
    ofield = default_map%field
    if (sic_present(o_cont,1)) then  ! Overide default value by /CONT Field
      call sic_r4(line,o_cont,1,cfield,.false.,error)
      if (error) return
      default_map%field = cfield
    endif
    ! No /STEP option...
    call sub_uvcont_header(line,error,huvc,channels,-1,o_index,o_range)
    default_map%field = ofield ! Restore previous value
    if (error) return
    !
    if (allocated(duvc)) deallocate(duvc)
    allocate(duvc(huvc%gil%dim(1),huvc%gil%dim(2)),stat=ier)
    huvc%loca%size = huvc%gil%dim(1)*huvc%gil%dim(2)
    huvc%r2d => duvc
    huv%r2d => duv
    call sub_uvcont_data(line,huvc,huv,channels,dchanflag,o_index,error)
    if (error) return
    !
    ! Weights must be recomputed
    do_weig = .true.
    call sic_delvariable ('UVCONT',.false.,error)
    call sic_mapgildas('UVCONT',huvc,error,duvc)
  endif
  !
  ! Point to this UV data set
  call gdf_copy_header(huvc,huv,error)
  duv => duvc
  !
end subroutine switch_uvfit_cont
!
subroutine uvfit_sub(line,huvl,verbose,my_unit,error)
  use uvfit_options
  use iso_fortran_env
  use gkernel_interfaces
  use gkernel_types
  use image_def
  use gbl_format
  use gbl_message
  use uvfit_data
  use clean_def
  use clean_arrays
  use imager_interfaces, only : map_message, primary_atten, load_data, outfit
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_FIT 
  !
  !   The functions have been defined previously by uvfit_comm
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !!
  type(gildas), intent(inout)  :: huvl  !! Specified UV header
  logical, intent(in) :: verbose        !! Printout more
  integer, intent(in) :: my_unit        !! Output unit number
  logical, intent(inout) :: error       !! Error flag
  !
  ! Globals and Constants
  external :: fitfcn    ! Unfortunately, this is a compulsory name.
  character(len=*), parameter :: Version='Version 2.7  30-Oct-2023 S.Guilloteau'
  character(len=*), parameter :: rname='UV_FIT'
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: clight = 299792458.d-6   ! in meter.mhz
  integer, parameter :: mfunc=11+3
  integer, parameter :: mstart=1000
  character(len=12) :: cfunc(mfunc) 
  data cfunc/'POINT','E_GAUSS','C_GAUSS','C_DISK','RING','EXPO',   &
     &    'POWER-2','POWER-3','E_DISK','U_RING','E_RING', &
     &    'SPERGEL','E_SPERGEL', 'E_EXPO'/
  character(len=8) :: ccpar(mpin,mfunc)
  data ccpar/'R.A.','DEC.','FLUX','    ','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Diam.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','I.Diam.','O.Diam.','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','F.W.H.P.','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.',' ',   &
     &    'R.A.','Dec.','Flux','Radius','    ','    ',' ',   &
     &    'R.A.','Dec.','Flux','Outer','Inner','Pos.Ang.','Ratio', &
     &    'R.A.','Dec.','Flux','F.W.H.P.','nu','  ','   ',  &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.','nu', &
     &    'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.','  '/
  integer :: mpfunc(mfunc), rafunc(mfunc)
  data mpfunc /3,6,4,4,5,4,4,4,6,4,7,5,7,6/
  data rafunc /0,-4,0,0,0,0,0,0,-4,0,7,0,-4,-4/
  !
  ! Local ---
  real(8), allocatable :: fvec(:), r(:,:), fjac(:,:)
  real(8), allocatable :: wa1(:), wa2(:), wa3(:), wa4(:)
  real(8) :: ftol,xtol,gtol,epsfcn,facto
  integer :: mode, nfev, njev, ldfjac, maxfev
  integer, allocatable :: ipvt(:)
  real(8), allocatable :: qtf(:), diag(:)
  !
  integer :: sever
  logical :: warning, report
  !
  real(8) :: freq
  real(4) :: v, incli, cincli, dincli
  real(8) :: xx, yy, xa, xd
  integer :: j, js, jsmin, ldr
  integer :: np2, nc
  integer :: n1, l, js1, if1, nvpar, npstart, kstart, ndata,  kc
  integer :: iii, k, i, ki, ic(2), nch, ncol
  integer :: iopt, nprint, info
  real :: uv_min, uv_max, rtmp, fact, vit
  !
  real :: par0(mpar), range(mpar)
  integer :: irat(mpar)
  real(8) :: parin(mpar,mstart), par2(mpar,mstart), parstep(mpar)
  real(8) :: parout(mpar,mstart), fsumsq, cj(mpar), preerr(mpar)
  real(8) :: fsumin, epar(mpar), rms, tol, denorm, factor, fluxfactor
  integer :: nstartf(mf,mfunc)
  real :: parf(mf,mfunc), rangef(mf,mfunc)
  character(len=8) :: fluxunit
  character(len=12) :: cf, ccf
  character(len=20) :: ch, errmess
  character(len=20) :: cpar(mpar)
  character(len=80) :: resu, chpar, chain, chincli
  character(len=15) :: chpos1
  character(len=15) :: chpos2
  integer :: ier, nvs
  type(projection_t) :: phase_proj, point_proj
  ! Primary beam correction
  integer :: nr,ir
  real(8), allocatable :: profile(:,:)
  real(8) :: rmax, rdist, xp, yp
  real :: bsize, atten
  !
  ! Code ----
  ncall = 0
  call xsetf(0)
  call sic_get_inte('UVF%NF',nf,error)
  do j=1,nf
    write(ch,'(a,i0,a)') 'UVF%PAR',j,'%RESULTS'
    call sic_delvariable(ch,.false.,error)
    write(ch,'(a,i0,a)') 'UVF%PAR',j,'%ERRORS'
    call sic_delvariable(ch,.false.,error)
  enddo
  error = .false.
  warning = .false.
  !     Code:
  !
  jsmin = 1 
  js1 = 0
  !
  ! Decode the Initial parameter values from command line
  nf = sic_narg(0)
  if (nf.eq.0) then
    call sic_get_inte('UVF%NF',nf,error)
  else if (nf.ne.1) then
    ! NAME + 7 parameters for each source model
    do i=1,nf/8
      ! Function name
      write(ch,'(a,i0,a)') 'UVF%PAR',i,'%NAME'
      call sic_ke(line,0,8*i-7,cf,nch,.false.,error)
      if (.not.error) call sic_let_char(ch,cf,error)
      do j=1,mpin
        write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%PAR[',j,']'
        k = j-7+8*i
        call sic_r4(line,0,k,parf(j,i),.false.,error)
        if (error) then
          Print *,'Argument ',k,' is incorrect'
          return
        endif
        call sic_let_real(ch,parf(j,i),error)
      enddo
    enddo
    nf = nf/8
  else
    ch = 'UVF%PAR1%NAME'
    call sic_ke(line,0,1,cf,nch,.false.,error)
    if (error) return
    if (.not.sic_varexist('UVF%PAR1%NAME')) then
      call map_message(seve%e,rname,'Function '//trim(ch)//' requires 7 more parameters')
      error = .true.
      return
    endif
    call sic_let_char(ch,cf,error)
  endif
  !
  ! The limit 4 could be increased if needed up to 10
  if (nf.lt.1 .or. nf.gt.mf) then
    write(ch,'(I0)') mf
    call map_message(seve%e,rname,'1 to '//trim(ch)//' functions possible')
    error = .true.
    return
  endif
  !
  !     2 Additional parameters to use specific uv range.
  uv_min = 0
  uv_max = 0
  if (sic_present(o_uvrange,0)) then
    call sic_r4(line,o_uvrange,1,uv_min,.true.,error)
    if (error) return
    call sic_r4(line,o_uvrange,2,uv_max,.false.,error)
  endif
  call map_message(seve%i,rname,version)
  if (uv_min.ne.0 .or. uv_max.ne.0) then
    if (uv_max.eq.0) then
      write(chain,*) 'UV data from ',uv_min,   &
       &      ' to Infty m.'    
    else
      write(chain,*) 'UV data from ',uv_min,   &
       &      ' to ',uv_max,' m.'
    endif
    call map_message(seve%i,rname,chain,1)
  endif
  !
  k = 0
  !
  ! Scan all function parameters
  do i=1, nf
    write(ch,'(a,i0,a)') 'UVF%PAR',i,'%NAME'
    call sic_get_char(ch,cf,nch,error)
    if (error) then
      chain = 'No such variable '//trim(ch)  
      call map_message(seve%e,rname,chain)
      return
    endif
    !
    call sic_upper(cf)
    call sic_ambigs('FIT',cf,ccf,ifunc(i),cfunc,mfunc,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid function '//cf)
      return      
    endif
    !
    ! Parameters
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%PAR[',j,']'
      call sic_get_real(ch,parf(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Ranges
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%RANGE[',j,']'
      call sic_get_real(ch,rangef(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Number of starts
    !     start=-1 means fixed parameter.
    do j=1,mpin
      write(ch,'(a,i0,a,i0,a)') 'UVF%PAR',i,'%START[',j,']'
      call sic_get_inte(ch,nstartf(j,i),error)
      if (error) then
        chain = 'Error reading variable '//trim(ch)  
        call map_message(seve%e,rname,chain)
        return
      endif
    enddo
    !
    ! Put them in place
    npfunc(i) = mpfunc(ifunc(i))
    if (ifunc(i).eq.11) then 
      ! E_Ring
      if (parf(4,i).lt.parf(5,i)) then
        call map_message(seve%i,rname,'Swapping Inner and Outer')
        rtmp = parf(4,i)
        parf(4,i) = parf(5,i)
        parf(5,i) = rtmp
      endif
    endif
    do j=1, npfunc(i)
      k = k + 1
      par0(k) = parf(j,i)
      range(k) = rangef(j,i)
      nstart(k) = nstartf(j,i)
      cpar(k) = ccf//' '//ccpar(j,ifunc(i))
      irat(k) = rafunc(ifunc(i))  ! Inclination code
    enddo
    !
    !     Additional option used to subtract model functions.
    ! Should not be needed in this model, since UV_RESIDUAL
    ! can do the job afterwards
    write(ch,'(a,i0,a)') 'UVF%PAR',i,'%SUBTRACT'
    call sic_get_logi(ch,savef(i),error)
    if (error) then
      savef(i) = .false.
      error = .false.
    endif
    !
  enddo
  !
  npar = k
  resu = ' '
  !
  !     Create array of starting values
  npstart = 1
  do i=1, npar
    if (nstart(i).gt.1) then
      n1 = nstart(i)-1
      parstep(i) = range(i)/n1
      parin(i,1) = par0(i)-0.5*parstep(i)*n1
    else
      parin(i,1) = par0(i)
    endif
  enddo
  do i=1, npar
    if (nstart(i).gt.1) then
      kstart = npstart
      do j=1, nstart(i)-1
        if (k.gt.mstart) then
          write(chain,'(A,I0,A,I0)') 'Too many starting values. Max is ',mstart
          call map_message(seve%e,rname,chain)
          error = .true.
          return
        endif
        do k=kstart+1,kstart+npstart
          do l=1, npar
            parin(l,k)= parin(l,k-npstart)
          enddo
          parin(i,k) = parin(i,k-npstart)+parstep(i)
        enddo
        kstart = kstart+npstart
      enddo
      npstart = kstart
    endif
  enddo
  !
  !     Load input UV Table (HUV -- DUV)
  !
  if (huvl%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  !
  error = .true.
  !
  if (huvl%gil%nvisi.ge.1.1*2**30) then
    call map_message(seve%e,rname, & 
    & 'Does not support more than 2^30 visibilities')
    return
  endif
  ndata = huvl%gil%nvisi
  !
  ic = 0      ! Must be initialized
  ier = gdf_range(ic, huvl%gil%nchan)
  nc = huvl%gil%nchan
  !
  np2 = 2*ndata                ! max. data points
  ldfjac = max(np2,npar)       ! Jacobian 1st size 
  iopt = 2                     ! Supply full Jacobian
  !     iopt = 1  !! or only Function (test mode)
  tol = 1d-8
  nprint = 0
  maxfev = 100*(npar+1)
  ftol = tol
  xtol = tol
  gtol = 0.d0
  epsfcn = 0.D0
  mode = 1
  facto = 100.d0
  !
  ! For DNLS1 only
  ier = 0
  allocate (fjac(ldfjac,npar),ipvt(npar),diag(npar),qtf(npar),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FVEC allocation error')
    error = .true.
    return
  endif
  !
  ! For DCOV and DNLS1 
  allocate (fvec(np2),r(np2,npar), &
    & wa1(npar),wa2(npar),wa3(npar),wa4(np2),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'DCOV allocation error')
    error = .true.
    return
  endif
  !
  !     Create table of fitted results huvfit - duvfit
  call gildas_null (huvfit, type = 'TABLE')
  call gdf_copy_header(huvl,huvfit,error)
  huvfit%gil%bval = 0 ! Trial
  huvfit%gil%eval = 0 ! Trial
  !
  huvfit%char%code(2) = 'uv-fit'
  huvfit%char%code(1) = 'freq'
  huvfit%gil%dim(1) = nc
  huvfit%gil%dim(2) = 4 + nf*(3+2*mpin)
  huvfit%gil%val(2) = 0.
  !
  if (allocated(duvfit)) then
    deallocate(duvfit)
    call sic_delvariable('UV_FIT',.false.,error)
    error = .false.
  endif
  !
  allocate (duvfit(huvfit%gil%dim(1),huvfit%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Fit table')
    error = .true.
    return
  endif
  duvfit = 0.0
  !
  !     Loop on channels
  nvs = huvl%gil%dim(1)
  !
  if (allocated(uvriw)) then
    if (ndata.ne.ubound(uvriw,2)) then
      deallocate(uvriw,stat=ier)
      allocate (uvriw(5,ndata),stat=ier)
    else
      ier = 0
    endif
  else
    allocate (uvriw(5,ndata),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate UVRIW array')
    error = .true.
    return
  endif
  !
  report = .not.verbose
  report = report .and. ((ic(2)-ic(1)).gt.15)
  do kc = ic(1),ic(2)
    if (sic_ctrlc()) then
      call map_message(seve%w,rname,'Aborted by ^C')
      error = .true.
      return
    endif
    if (report) then
      if (kc.eq.ic(1)+(ic(2)-ic(1))/4) then
        call map_message(seve%i,rname,'25 % done ')
      else if (kc.eq.ic(1)+(ic(2)-ic(1))/2) then
        call map_message(seve%i,rname,'50 % done ')
      else if (kc.eq.ic(1)+(ic(2)-ic(1))*3/4) then
        call map_message(seve%i,rname,'75 % done ')
      endif
    endif
    !
    ! Load (U,V) in arcsec**-1, compute observing frequency for channel KC
    fact = gdf_uv_frequency(huvl,dble(kc)) / clight * pi/180.d0/3600d0
    call load_data(ndata,nvs,kc,fact,huv%r2d,npuvfit,uvriw,uv_min,uv_max)
    if (verbose) then
      if (npuvfit.eq.0) then
        write(chain,'(A,I0)') 'No data for channel ', kc
        call map_message(seve%w,rname,chain)
      else
        write(chain,'(I0,A,I0)') npuvfit,' data points for channel ', kc
        call map_message(seve%i,rname,chain)
      endif
    endif
    if (npuvfit.eq.0) cycle ! Ignore all flagged data
    !
    np2 = 2*npuvfit
    vit = huvl%gil%voff+(kc-huvl%gil%ref(1))*huvl%gil%vres
    !
    fsumin = 1d20
    fsumsq = 1d30
    !
    do js=1, npstart
      !     Get only variable parameters:
      nvpar = 0
      do i=1, npar
        if (nstart(i).ge.0) then
          nvpar = nvpar+1
          par2(nvpar,js)=parin(i,js)
        endif
        pars(i) = parin(i,js)
      enddo
      if (verbose) then
        if (nvpar.eq.0) then
          call map_message(seve%i,rname,'No free parameter, using input values')
          jsmin = 1
          exit
        endif
        write(*,'(a,5(1pg12.5))') 'I-UV_FIT, Starting from ',   &
       &        (par2(iii,js),iii=1, nvpar)
      endif
      !
! Only valid if LWA < 2^32
!      call dnls1e (fitfcn, iopt, np2, nvpar, par2(1,js),   &
!     &        fvec, tol, nprint, info,   &
!     &        ipvt, wa, lwa)
!
! Use the "not so easy to use" calling sequence, where the sizes are
! given separately.
      CALL DNLS1 (fitFCN, IOPT, np2, nvpar, par2(1,js), &
        & FVEC, FJAC, LDFJAC, FTOL, XTOL, GTOL, MAXFEV, EPSFCN, & 
        & DIAG, MODE, FACTO, NPRINT, INFO, &
        & NFEV, NJEV, IPVT, QTF, WA1, WA2, WA3, WA4)
      !
      !
      if (verbose) then
        sever = 0
        if (info.eq.0) then
          write(chain,'(A,I0)') 'Improper input parameters, info= ',   &
       &          info
          sever = seve%e
        elseif (info.eq.6 .or. info.eq.7) then
          write(chain,'(A,I0)') 'TOL too small, info= ',info
          sever = seve%e
        elseif (info.eq.5) then
          write(chain,'(A,I0)') 'Not converging, info= ',info
          sever = seve%e
        elseif (info.eq.4) then
          write(chain,'(A,I0)') 'FVEC orthog. to Jacob. col., info= ',   &
       &          info
          sever = seve%w
        endif
        if (sever.ne.0) then
          call map_message(sever,'DNLS1E',chain)
          warning = .true.
        endif
      else
        if (info.eq.0 .or. (info.ge.4.and.info.le.7)) warning = .true.
      endif
      fsumsq  = denorm(np2, fvec)
      !
      if (fsumsq.lt.fsumin) then
        fsumin = fsumsq
        jsmin = js
      endif
      js1 = js
    enddo
    !
    ! Fit if needed
    if (nvpar.gt.0) then
      if (jsmin.ne.js1) then
        nprint = 0
        !!Print *,'NP2 ',np2, 2_8**32
        CALL DNLS1 (fitFCN, IOPT, np2, nvpar, par2(1,js), &
          & FVEC, FJAC, LDFJAC, FTOL, XTOL, GTOL, MAXFEV, EPSFCN, & 
          & DIAG, MODE, FACTO, NPRINT, INFO, &
          & NFEV, NJEV, IPVT, QTF, WA1, WA2, WA3, WA4)
!        call dnls1e (fitfcn, iopt, np2, nvpar, par2(1,jsmin),   &
!       &        fvec, tol, nprint, info,   &
!       &        iw, wa, lwa)
        if (verbose) then
          sever = 0
          if (info.eq.0) then
            write(chain,'(A,I0)') 'Improper input parameters, info= ',   &
         &          info
            sever = seve%e
          elseif (info.eq.6 .or. info.eq.7) then
            write(chain,'(A,I0)') 'TOL too small, info= ',info
            sever = seve%e
          elseif (info.eq.5) then
            write(chain,'(A,I0)') 'Not converging, info= ',info
            sever = seve%e
          elseif (info.eq.4) then
            write(chain,'(A,I0)') 'FVEC orthog. to Jacob. col., info= ',   &
         &          info
            sever = seve%w
          endif
          if (sever.ne.0) then
            call map_message(sever,'DNLS1E',chain)
            warning = .true.
          endif
        else
          if (info.eq.0 .or. (info.ge.4.and.info.le.7)) warning = .true.
        endif
        fsumsq  = denorm(np2, fvec)
      endif
      ldr = np2
      call dcov (fitfcn, iopt, np2, nvpar, par2(1,jsmin),   &
       &      fvec, r, ldr, info,   &
       &      wa1, wa2, wa3, wa4)
      if (verbose) then
        if (info.eq.0) then
          write(chain,'(A,I0)') 'improper input parameters, info= ',info
          call map_message(seve%e,'DCOV',chain)
        elseif (info.eq.2) then
          write(chain,'(A,I0)') 'Jacobian singular, info= ',info
          call map_message(seve%w,'DCOV',chain)
          warning = .true.
        endif
      else
        if (info.eq.2) warning = .true.
      endif
      !
      !     extract the diagonal of r
      call diagonal(np2,nvpar,r,cj)
      rms = fsumsq*dsqrt(np2*1d0)
      if (verbose) then
        write(chain,'(a,f10.4,a)') ' r.m.s.= ',rms,' Jy.'
        call map_message(seve%i,rname,chain)
      endif
      if1 = info
    endif
    !
    ! Load results and Errors
    k = 0
    preerr(:) = sqrt(abs(cj(:)))
    do i=1, npar
      if (nstart(i).ge.0) then
        k = k+1
        parout(i,jsmin) = par2(k,jsmin)
        epar(i) = preerr(k)
      else
        parout(i,jsmin) = pars(i)
        epar(i) = 0.
      endif
    enddo
    !
    k = 1
    do j=1, nf
      call outpar(ifunc(j),npfunc(j),parout(k,jsmin),epar(k))
      k = k + npfunc(j)
    enddo
    k = 0
    ki = 0
    call gwcs_projec(huvl%gil%a0,huvl%gil%d0,huvl%gil%pang,huvl%gil%ptyp,phase_proj,error)
    call gwcs_projec(huvl%gil%ra,huvl%gil%dec,huvl%gil%pang,huvl%gil%ptyp,point_proj,error)
    !
    do j=1,nf      
      if (rafunc(ifunc(j)).gt.0)  then
        ! Bring the aspect ratio < 1 to have the proper size...
        if (parout(ki,jsmin).gt.1) then
          factor = parout(ki,jsmin) 
          call map_message(seve%i,rname,'Aspect ratio brought to < 1')
          parout(ki-3,jsmin) = parout(ki-3,jsmin)*factor
          parout(ki-2,jsmin) = parout(ki-2,jsmin)*factor
          epar(ki-3) = epar(ki-3)*factor
          epar(ki-2) = epar(ki-2)*factor 
          parout(ki-1,jsmin) = 90.+parout(ki-1,jsmin) ! PA of Major Axis         
          parout(ki,jsmin) = 1./factor
          epar(ki) = epar(ki)/factor**2
        endif
      endif
      !
    enddo
    !
    k = 0
    ki = 0
    if (verbose.or.my_unit.ne.output_unit) then
      !
      freq = gdf_uv_frequency(huvl,dble(kc))
      if (ic(2).gt.ic(1)) then
        v = (kc-huvl%gil%ref(1))*huvl%gil%vres + huvl%gil%voff
        write(chpar,'(a,F11.3,a,f8.2,a)') 'Frequency ',freq,& 
        & ' MHz, Velocity ',v,' km/s'
      else
        write(chpar,'(a,i8,a)') 'Frequency ',nint(freq),' MHz'
      endif
      write(my_unit,*) trim(chpar)
      !
      bsize = 0
      rmax = 0
      do j=1,nf
        do i=1, npfunc(j)
          ki = ki+1          
          xx = parout(ki+1,jsmin)
          yy = parout(ki+2,jsmin)
          rmax = max(xx**2+yy**2,rmax)
        enddo
      enddo
      rmax = sqrt(rmax)*pi/180D0/3600D0
      call primary_atten(bsize,huvl,freq,rmax,nr,profile,error)
      !
      ki = 0
      do j=1, nf
        cincli = 0.
        dincli = -1.0
        !
        ! Ra/Dec absolute coordinates (1st and 2nd parameters)
        xx = parout(ki+1,jsmin)*pi/180d0/3600d0
        yy = parout(ki+2,jsmin)*pi/180d0/3600d0
        call rel_to_abs(phase_proj,xx,yy,xa,xd,1)
        call rad2sexa(xa,24,chpos1)
        call rad2sexa(xd,360,chpos2)
        !
        ! Correct if Phase Center is not  Pointing center
        if (bsize.ne.0) then
          call abs_to_rel(point_proj,xa,xd,xp,yp,1)
          rdist = sqrt(xp**2+yp**2)
          if (nr.ne.0) then
            ! Interpolate from discrete beam profile if possible
            atten = 0
            do ir=2,nr
              if ((profile(ir,1).gt.rdist).or.(ir.eq.nr)) then
                atten  = (rdist-profile(ir-1,1))*profile(ir,2) + &
                  & (profile(ir,1)-rdist)*profile(ir-1,2)
                atten = atten/(profile(ir,1)-profile(ir-1,1))
                exit
              endif
            end do
          else
            ! Use simple Gaussian if not
            atten = exp(-(rdist/(bsize/2.0/sqrt(log(2.0))))**2)
          endif
        else
          atten = 1
        endif
        ! Flux in best units (3rd parameter)
        if (abs(parout(ki+3,jsmin)).ge.1.d0) then
          fluxfactor = 1.d0
          fluxunit = 'Jy'
        elseif (abs(parout(ki+3,jsmin)).ge.1.d-3) then
          fluxfactor = 1.d3
          fluxunit = 'milliJy'  ! or 'mJy' ?
        else
          fluxfactor = 1.d6
          fluxunit = 'microJy'  ! or 'uJy' ?
        endif
        do i=1, npfunc(j)
          ki = ki+1
          if (i.eq.3) then
            factor = fluxfactor
          else
            factor = 1.d0
          endif
          if (nstart(ki).ge.0) then
            k = k+1
!            epar(ki) = sqrt(abs(cj(k)))
            write(errmess,'(f0.5)',iostat=ier)  epar(ki)*factor ! Error can be larger than "999.99999"
            write(chpar,'(2a,f11.5,a,a,a)')  &
              cpar(ki), ' = ',parout(ki,jsmin)*factor,' (',adjustr(errmess(1:9)),')'
          else
!            epar(ki) = 0.
            write(chpar,'(2a,f11.5,a)')  &
              cpar(ki), ' = ', parout(ki,jsmin)*factor,' (  fixed  )'
          endif
          nch = len_trim(chpar)
          if (i.eq.1) then
            write(my_unit,*) chpar(1:nch)//'  '//chpos1
          elseif (i.eq.2) then
            write(my_unit,*) chpar(1:nch)//' '//chpos2
          elseif (i.eq.3) then
            write(my_unit,*) chpar(1:nch)//'  '//fluxunit
          else
            write(my_unit,*) chpar(1:nch)
          endif
          !
          ! Inclination if any
          if (abs(irat(ki)).eq.i)  then
            if (irat(ki).eq.-i) then
              cincli = parout(ki+1,jsmin)/parout(ki,jsmin)
              dincli = abs(epar(ki+1)/parout(ki+1,jsmin)) + &
                & abs(epar(ki)/parout(ki,jsmin))
            else if (irat(ki).eq.i) then
              cincli = parout(ki,jsmin)
              dincli = abs(epar(ki)/parout(ki,jsmin))
            endif
            incli = acos(cincli)*180/pi
            dincli = incli / sqrt(1.-cincli**2) * dincli
            write(chincli,'(A,F7.1,A,f5.1,A)') cpar(ki)(1:12)//' Incli   = ' & 
            & ,incli,'     (',dincli,') °'
          endif
          !
          ! Print out Primary beam corrected flux
          if ((i.eq.3).and.(atten.ne.1)) then
            write(errmess,'(f0.5)',iostat=ier)  epar(ki)*factor/atten ! Error can be larger than "999.99999"
            write(chpar,'(2a,f11.5,a,a,a)')  &
              cpar(ki), ' = ',parout(ki,jsmin)*factor/atten,' (',adjustr(errmess(1:9)),')'
            write(my_unit,*) chpar(1:nch)//'  '//fluxunit//' ! Primary beam corrected '
          endif
        enddo
        ! Print out Inclination if Elliptical model
        if (cincli.ne.0) write(my_unit,*) chincli
      enddo
    endif
    !
    ncol = huvfit%gil%dim(2)
    call outfit(nc,kc,ncol,duvfit,rms,vit,npar,parout(1,jsmin),epar)
    !
  enddo
  !
  ! Return results in UVF%PARi%RESULT and UVF%PARi%ERRORS if
  ! only one Channel
  if (nc.eq.1) then
    k = 0
    ki = 0
    do j=1,nf
      !
      do i=1, npfunc(j)
        ki = ki+1
        uvf_errors(i,j) = epar(ki)
        uvf_results(i,j) = parout(ki,jsmin)
      enddo
      !
      write(ch,'(a,i0,a)') 'UVF%PAR',j,'%RESULTS'
      if (sic_varexist(ch)) call sic_delvariable(ch,.false.,error)      
      call sic_def_real(ch,uvf_results(1,j),1,mpin,.true.,error)
      write(ch,'(a,i0,a)') 'UVF%PAR',j,'%ERRORS'
      if (sic_varexist(ch)) call sic_delvariable(ch,.false.,error)
      call sic_def_real(ch,uvf_errors(1,j),1,mpin,.true.,error)
    enddo
  endif
  !
  if (len_trim(resu).gt.0) then
    call sic_parsef(resu,huvfit%file,' ','.uvfit')
    call map_message(seve%i,rname,'Creating fit table '//   &
       &    trim(huvfit%file) )
    call gdf_write_image(huvfit,duvfit,error)
  endif
  if (warning) then
    call map_message(seve%w,rname,'Completed with possible errors',1)
  endif
  !
  call sic_mapgildas('UV_FIT',huvfit,error,duvfit)
end subroutine uvfit_sub
!
subroutine uvfit_residual_model(line,rname,iarg,error)
  use uvfit_options
  use clean_def
  use clean_default
  use clean_arrays
  use uvfit_data
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, model_data
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_RESIDUAL and MODEL   
  !   after a UV_FIT command operation
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: rname   !! Caller command
  integer, intent(in) :: iarg             !! Argument pointer
  logical, intent(inout) :: error         !! Error flag
  !!
  !
  ! Local ---
  type(gildas) :: huvl
  character(len=80) :: chain
  character(len=32) :: coper
  integer :: nvt, nvs, i, if, nc, ndata, ier, ic(2), narg, iv, jc
  logical :: subtract
  real, pointer :: duvres(:,:)
  !
  ! Code ----
  call gildas_null(huvl,type='UVT')
  call gdf_copy_header(huv,huvl,error)
  !
  subtract = rname.eq.'UV_RESIDUAL'
  if (subtract) then
    call map_message(seve%i,rname,'Subtracting UV_FIT model results')
  endif
  !
  error = .false.
  narg = sic_narg(0)
  if (narg.lt.iarg) then
    savef(1:nf) = .true.
  else
    savef(1:nf) = .false.
    do i=iarg,narg
      call sic_i4(line,0,i,if,.true.,error)
      if (error) return
      if (if.gt.0 .and. if.le.nf) then
        savef(if) = .true.
      else
        write(chain,'(A,I0,A,I0,A,I0)') 'Argument #',i,' (',if,') out of boud [0,',nf,']'
        call map_message(seve%e,rname,chain,1)
        error = .true.
      endif
    enddo
    if (.not.any(savef)) then
      call map_message(seve%w,rname,'Nothing to subtract',3)
      return
    endif
  endif
  !
  ! Use DUVF or DUVM as result array, depending on the
  ! triggering command (MODEL or UV_FIT)
  ic = [0,0]
  ier = gdf_range(ic, huvl%gil%nchan)    ! Channel range
  nc = huvfit%gil%dim(1)                 ! Number of fitted channels
  nvt = huvfit%gil%dim(2)                ! Number of fitted parameters
  ndata = huvl%gil%nvisi                 ! Number of visibilities
  nvs = huvl%gil%dim(1)                  ! Size of visibilities
  !
  ! For convenience, the header and data area are available
  ! in the clean_arrays module
  !
  if (subtract) then
    coper = 'Removing model with '
    call sic_delvariable('UV_RESIDUAL',.false.,error)
    ! Use DUVF  (Fit residuals)
    if (allocated(duvf)) deallocate(duvf)
    call gdf_copy_header(huvl,huvf,error)
    !
    allocate (duvf(huvf%gil%dim(1),huvf%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'UV Model allocation error')
      error = .true.
      return
    endif
    duvres => duvf
    duvf(:,:) = duv  ! Copy data 
    uv_resid_updated = .true. 
    call sic_mapgildas('UV_RESIDUAL',huvf,error,duvf)
  else
    coper = 'Adding model for'
    call sic_delvariable('UV_MODEL',.false.,error)
    ! Use DUVM  (Model values)
    if (allocated(duvm)) deallocate(duvm)
    call gdf_copy_header(huvl,huvm,error)
    !
    allocate (duvm(huvm%gil%dim(1),huvm%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'UV Model allocation error')
      error = .true.
      return
    endif
    duvres => duvm
    duvm(:,:) = duv  ! Copy data 
    ! Set visibilities to Zero for MODEL
    do iv=1,ndata
      do jc=ic(1),ic(2)
        duvres(5+3*jc:6+3*jc,iv) = 0.
      enddo
    enddo
    uv_model_updated = .true. 
    call sic_mapgildas('UV_MODEL',huvm,error,duvm)
  endif
  !
  ! Loop on functions for subtracting / creating model.
  ! This is memory inefficient, but multi-function fits are rare
  ! Will be optimized later if needed...
  do if = 1, nf
    if (savef(if)) then
      write (chain,'(a,a,i2.2,1X,I0,1X,I0)') trim(coper),' UVF%PAR',if,ndata,nc
      call map_message(seve%i,rname,chain)
      call model_data(huvl,ndata,nvs,nc,ic(1),ic(2),nvt,duvres,duvfit,if, &
      & subtract)
    endif
  enddo
  !
end subroutine uvfit_residual_model
!
subroutine  uvfit_model(ifunc,kfunc,uu,vv,x,y,dy)
  !---------------------------------------------------------------------
  !*
  ! IMAGER --  Support routine for UV_FIT
  !
  ! Compute a model function.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: ifunc       !! Fuction type
  integer, intent(in) :: kfunc       !! Number of parameters
  real(8), intent(in) :: uu          !! U coordinate in arcsec^-1
  real(8), intent(in) :: vv          !! V coordinate in arcsec^-1
  real(8), intent(in) :: x(kfunc)    !! Parameters
  real(8), intent(inout) :: y(2)        !! Function (real, imag.)
  real(8), intent(inout) :: dy(2,kfunc) !! Partial derivatives.
  !
  ! Global
  real(8), external :: z_exp
  real(8), parameter :: pi = 3.14159265358979323846d0
  real(8), parameter :: dpi=2d0*pi
  real(8), parameter :: cst=3.5597073312469d0  ! pi**2/4d0/log(2d0)
  real(8), parameter :: deg=pi/180d0
  ! Spergel approximation
  real(kind=8),parameter :: acnu = 2.4009610601053772
  real(kind=8),parameter :: bcnu = -0.22810144250066436
  real(kind=8),parameter :: ccnu = -0.40371257831497309
  real(kind=8),parameter :: cte = 3*pi**2/log(2d0)**2
  !
  ! Local ---
  integer :: i
  real(8) :: st, ct, q1, q2, arg, carg, sarg, darg1, darg2
  real(8) :: a, da(7), b, ksi, q, j0, j1, aa, dfac4, dfac5
  real(8) :: dadksi
  real(8) :: dbesj0, dbesj1, dbesk0, dbesk1
  real(8) :: a1, a2, fac, k0, k1, d, daa
  real(8) :: ii, oo, fi, fo, ff, dgo_do, dgi_do, dgi_di, dgo_di, dout2
  real(8) :: flux,dg_dmaj,dg_dmin,dg_dpa
  real(8) :: dg_douter,dg_dinner,dg_dratio,dg_drota
  real(8) ::  major, minor
  real(kind=8) :: cnu, dg_dnu, dg_dr0, repeat, nu, uvdist2, drepeat
  real(kind=8) :: dg_dr1, dg_dr2, uvdist1, dg_dtheta, sintheta, costheta, dfac
  !
  ! Code ----
  !-----------------------------------------------------------------------
  !
  ! The fitted function is of the form:
  !     F = flux * f(x-x0,y-y0)
  ! corresponding to a visibility model:
  !     G = flux * exp(-2i*pi(u*x0+v*y0)) * g(u,v)
  ! where g is the Fourier transform of f.
  !
  ! The first three parameters 1, 2, 3, are x0, y0, and flux.
  !
  ! First compute A = g(u,v), and DA(k) = dA/dx_k for k=4, ...
  ! depending on model.
  !
  select case (ifunc)
  !
  case (1)  ! Point source
    ! 1- Point source
    ! model = flux * delta(x-x0,y-y0)
    ! g(u,v) = 1
    ! 3 pars (x0, y0, flux)
    a = 1d0
    !
  case (2) ! Gaussian
    ! 2- Gaussian (2-dim)
    !     model = flux*4*ln2/(pi*b1*b2) * exp (-4*ln2*((r1/b1)**2+(r2/b2)**2)
    !     g(u,v) = exp(-pi**2/4/ln2*(b1*u1+b2*u2)**2)
    !       where u1 = u*sin(theta)+v*cos(theta)
    !             u2 = u*cos(theta)-v*sin(theta)
    !     6 pars (x0, y0, flux, theta, b1, b2)
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    a1 = -cst*q1**2
    a2 = -cst*q2**2
    a = z_exp(a1*x(4)**2+a2*x(5)**2)
    da(4) = 2*x(4)*a1*a
    da(5) = 2*x(5)*a2*a
    da(6) = -2d0*cst*q1*q2*(x(4)**2-x(5)**2)*deg*a
    !
  case(3)
    !
    ! 3- Gaussian (1-dim)
    !     model = flux*4*ln2/(pi*b**2) * exp (-4*ln2*(r/b)**2)
    !     g(u,v) = exp(- pi**2/4/ln(2)*(b*q)**2)
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q2 = uu**2+vv**2
    a1 = -cst*q2
    a = z_exp(a1*x(4)**2)
    da(4) = a1*x(4)*2d0*a
    !
  case (4) ! Disk
    ! 4- Disk
    !     model = flux*4/(pi*b**2)
    !     g(u,v) = J1(pi*b*q)/q
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      da(4) = 2d0*(j0-a)/x(4)
    endif
    !
  case (5) ! Ring
    !
    ! 5- Ring
    q = sqrt(uu**2+vv**2)
    a = 0
    da(4) = 0
    da(5) = 0
    if (x(4).ne.x(5)) then
      d = x(4)**2-x(5)**2
      fac = x(4)**2/d
      dfac4 =-2*x(5)**2*x(4)/d**2
      dfac5 =2*x(4)**2*x(5)/d**2
      ksi = pi*x(4)*q
      if (ksi.eq.0) then
        a = a + fac
        da(4) = da(4) + dfac4
        da(5) = da(5) + dfac5
      else
        j1 = dbesj1(ksi)
        j0 = dbesj0(ksi)
        aa = j1*2d0/ksi
        daa = 2d0*(j0-aa)/x(4)
        a = a + aa*fac
        da(4) = da(4) + daa*fac+aa*dfac4
        da(5) = da(5) + aa*dfac5
      endif
      ksi = pi*x(5)*q
      if (ksi.eq.0) then
        a = a+1d0-fac
        da(4) = da(4)-dfac4
        da(5) = da(5)-dfac5
      else
        j1 = dbesj1(ksi)
        j0 = dbesj0(ksi)
        aa = j1*2d0/ksi
        daa = 2d0*(j0-aa)/x(5)
        a = a + aa*(1d0-fac)
        da(4) = da(4) - aa*dfac4
        da(5) = da(5) + daa*(1d0-fac)-aa*dfac5
      endif
    endif
    !
  case(6) ! Exponential
    ! 6- exponential
    !     model = exp(- 2*ln2*r/b)
    !     g(u,v) = 1 / ( 1 + (q*b*pi/ln2)**2 )**(3/2)
    !
    q2 = uu**2+vv**2
    ksi = q2 * (x(4)*pi/log(2d0))**2
    b = 1d0+ksi
    a = 1d0/b**1.5
    da(4) = -3*a*ksi/b/x(4)
    !
  case(7) ! Power -2
    ! 7- Power -2
    !     model =
    !     g(u,v) =
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    k0 = dbesk0(ksi)
    k1 = dbesk1(ksi)
    a = k0
    da(4) = -ksi/x(4)*k1
    !
  case(8) ! Power -3
    !
    ! 8- Power -3
    !     model =
    !     g(u,v) = exp( -pi*q*b/sqrt(2**(1/3)-1) )
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*q*x(4)/sqrt(2.**(1./3)-1)
    a = z_exp(-ksi)
    da(4) = -a*ksi/x(4)
    !
  case(9) ! Elliptical disk
    ! 9- Elliptical Disk
    !     model = flux*4/(pi*(b1**2+b2**2)) (inside ellipse, 0 outside)
    !     g(u,v) = 2 J1 (ksi)  / ksi
    !     where u1 = u*sin(theta)+v*cos(theta)
    !           u2 = u*cos(theta)-v*sin(theta)
    !     ksi = pi*sqrt((b1*u1)**2+(b2*u2)**2)
    !     6 pars (x0, y0, flux, b1, b2, theta)
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    ksi = pi*sqrt((x(4)*q1)**2+(x(5)*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
      da(5) = 0
      da(6) = 0
    else
      j1 = dbesj1(ksi)
      a = j1*2d0/ksi
      j0 = dbesj0(ksi)
      dadksi = 2d0*(j0-a)/ksi
      da(4) = dadksi*pi**2*q1**2*x(4)/ksi
      da(5) = dadksi*pi**2*q2**2*x(5)/ksi
      da(6) = dadksi/ksi*pi**2*q1*q2*(x(4)**2-x(5)**2)*deg
    endif
    !
  case (10)  ! Unresolved ring
    !
    ! 10- Unresolved Ring
    !     model = flux/(2*pi*b)*delta(r-b)
    !     g(u,v) = J0(pi*b*q)
    !     where q**2 = u**2+v**2
    !     4 pars (x0, y0, flux, b)
    !
    q = sqrt(uu**2+vv**2)
    ksi = pi*x(4)*q
    if (ksi.eq.0d0) then
      a = 1
      da(4) = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j0
      da(4) = -j1 * pi*q
    endif
    !
  case(11) ! Elliptical Ring
    ! 11- Elliptical Ring
    !
    !     To be developped more...
    !
    !     7 pars (x0, y0, flux, outer, inner, pa, ratio)
    !
    !     Define a1 = outer
    !     Define a2 = outer*ratio
    !     Define b1 = inner
    !     Define b2 = inner*ratio
    !
    ! Sum of two elliptical disks.
    !     a) a = fa *4/(pi*outer^2*ratio) > 0
    !        ga(u,v) = fa * J1(pi*sqrt((a1*u1)**2+(a2*u2)**2)
    !     b) b = fb *4/(pi*inner^2*ratio) < 0
    !        gb(u,v) = fb * J1(pi*sqrt((b1*u1)**2+(b2*u2)**2)
    !     and
    !        fa + fb = flux
    !        fa / fb = -(outer/inner)^2
    !     where u1 = u*sin(theta)+v*cos(theta)
    !           u2 = u*cos(theta)-v*sin(theta)
    !*     so
    !        fa = flux * outer^2 / (outer^2-inner^2)
    !        fb = - flux * inner^2 / (outer^2-inner^2)
    !
    ! Derivative vs outer
    !
    !     d(fa)/d(out) * J1 + fa * d(J1)/d(out)
    !
    !
    st = sin(deg*x(6))
    ct = cos(deg*x(6))
    q1 = uu*st+vv*ct
    q2 = uu*ct-vv*st
    ii = x(5) ! Inner radius
    oo = x(4) ! Outer radius
    ff = x(7) ! cos (inclination)
    dout2 = (oo**2-ii**2)
    !
    ! First source
    a1 = x(4)
    a2 = x(4)*ff
    !
    ksi = pi*sqrt((a1*q1)**2+(a2*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      dg_dmaj = 0
      dg_dmin = 0
      dg_dpa = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      dadksi = 2d0*(j0-a)/ksi
      dg_dmaj = dadksi*pi**2*q1**2*a1/ksi    ! d(g)/d(major)
      dg_dmin = dadksi*pi**2*q2**2*a2/ksi    ! d(g)/d(minor)
      dg_dpa = dadksi/ksi*pi**2*q1*q2*(a1**2-a2**2)*deg
    endif
    !
    ! Now it gets a little more complex
    fo = oo**2 / dout2
    !
    dgo_do = 2 * oo * ii**2 / dout2 *  a    ! Strictly speaking
    dgo_do = dgo_do + fo * (dg_dmaj + ff * dg_dmin)
    dgo_di = 2 * oo**2 * ii / dout2 *  a
    !
    flux = a * fo
    dg_dratio = fo * a1 * dg_dmin
    dg_drota = fo * dg_dpa
    !
    ! Second source
    a1 = x(5)
    a2 = x(5)*ff
    !
    ksi = pi*sqrt((a1*q1)**2+(a2*q2)**2)
    if (ksi.eq.0d0) then
      a = 1
      dg_dmaj = 0
      dg_dmin = 0
      dg_dpa = 0
    else
      j1 = dbesj1(ksi)
      j0 = dbesj0(ksi)
      a = j1*2d0/ksi
      dadksi = 2d0*(j0-a)/ksi
      dg_dmaj = dadksi*pi**2*q1**2*a1/ksi    ! d(g)/d(major)
      dg_dmin = dadksi*pi**2*q2**2*a2/ksi    ! d(g)/d(minor)
      dg_dpa = dadksi/ksi*pi**2*q1*q2*(a1**2-a2**2)*deg
    endif
    !
    fi = ii**2 / dout2
    !
    dgi_di = 2 * ii * oo**2 / dout2 *  a    ! Strictly speaking
    dgi_di = dgo_di + fi * (dg_dmaj + ff * dg_dmin)
    dgi_do = 2 * ii**2 * oo / dout2 *  a
    !
    ! Add (or rather subtract...) to previous derivatives
    dg_dinner = dgo_di - dgi_di
    dg_douter  = dgo_do - dgi_do
    dg_dratio = dg_dratio - fi * a1 * dg_dmin
    dg_drota = dg_drota - fi * dg_dpa
    !
    ! and to flux (actually, relative visibility)
    flux = flux - a * fi
    !
    a = flux                     ! Normalized scaling factor now
    da(4) = dg_douter
    da(5) = dg_dinner
    da(6) = dg_drota
    da(7) = dg_dratio
    !
  case(12)
    ! SPERGEL
    !  'R.A.','Dec.','Flux','F.W.H.P.','nu'
    !
    ! Spergel 2010 profile (Elliptical galaxies)
    ! model = flux*(r/2)^2*(Knu(r)/(Gamma(nu+1))
    ! g(u,v) = 1/(2*pi*(1+(u^2+v^2)*(r0/cnu)^2))^(1+nu))
    !          1   2    3    4   5
    ! 5 pars (x0, y0, flux, r0, nu)
    ! 
    ! Approximation to cnu based on fit to tabulated cnu provided by Spergel 2010.
    ! 10% accuracy for nu < -0.6, for nu > -0.6 accuracy < 1%
    !
    nu = x(5)
    major = x(4)*2d0*cst
    cnu = acnu*log(nu+2d0)+bcnu*nu+ccnu
    uvdist2 = (uu**2+vv**2)
    repeat = (major)**2*2*uvdist2/cnu**2+1d0
    !
    a = 1d0/((repeat)**(1d0+nu))
    !
    dg_dnu = repeat**(-nu-1)/2/pi*(-(2*major**2*uvdist2*(-nu-1)*&
        (acnu/nu+ccnu))/(cnu**3*repeat)-log(repeat))
    !
    dg_dr0 = 2d0*cst*((-nu-1)*uvdist2*major*((uvdist2*major**2)/(cnu**2)+1)**(-nu-2))/(pi*cnu**2)
    !
    da(4) = dg_dr0
    da(5) = dg_dnu
    !
  case(13)
    ! E_SPERGEL
    !   'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.','nu'
    !
    ! Elliptical adaptation to Spergel 2010 profile (for galaxies)
    ! model = flux*(r/2)^2*(Knu(r)/(Gamma(nu+1))
    ! g(u,v) = 1/(2*pi*(1+(uvd1^2*r1^2+uvd2^2*r2^2)/cnu^2))^(1+nu))
    !          1   2    3    4   5   6      7
    ! 7 pars (x0, y0, flux, r1, r2, theta, nu)
    ! 
    ! Approximation to cnu based on fit to tabulated cnu provided by Spergel 2010.
    ! 10% accuracy for nu < -0.6, for nu > -0.6 accuracy < 1%
    !
    ! ZZZ is the aforementioned approximation to Cnu still valid for the elliptic case?
    !
    nu = x(7)
    !
    major = x(4)*2*cst
    minor = x(5)*2*cst
    cnu = acnu*log(nu+2)+bcnu*nu+ccnu
    sintheta = sin(deg*x(6))
    costheta = cos(deg*x(6))
    uvdist1 = uu*sintheta+vv*costheta
    uvdist2 = uu*costheta-vv*sintheta
    dfac = (major**2*uvdist1**2+minor**2*uvdist2**2)
    repeat = dfac/cnu**2+1
    drepeat = 2d0*cst*dfac/cnu**2+1
    !
    a = 1/((repeat)**(1+nu))
    !
    dg_dnu = a*(-(2*(-nu-1)*(acnu/(nu+2)+bcnu)*dfac)/(cnu**3*repeat)-log(repeat))
    !
    dg_dr1 = 2d0*cst*((-nu-1)*major*uvdist1**2*repeat**(-nu-2))/(pi*cnu**2)
    !
    dg_dr2 = 2d0*cst*((-nu-1)*minor*uvdist2**2*repeat**(-nu-2))/(pi*cnu**2)
    !
    dg_dtheta = ((-nu-1)*(2*major**2*uvdist1*uvdist2-minor**2*uvdist1*uvdist2) &
       &   *repeat**(-nu-2))/(pi*cnu**2)
    !
    da(4) = dg_dr1
    da(5) = dg_dr2
    da(6) = dg_dtheta
    da(7) = dg_dnu
    !
  case(14)
    ! E_EXPO
    ! 'R.A.','Dec.','Flux','Major','Minor','Pos.Ang.'
    !
    ! Elliptical Exponential
    ! model = exp(- 2*ln2*(r1/b1+r2/b2))
    ! g(u,v) = 1 / ( 1 + (uvd1^2*r1^2+uvd2^2*r2^2)*(pi/ln2)**2 )**(3/2)
    ! 6 pars (x0,y0,flux,size1,size2,theta)
    !
    sintheta = sin(deg*x(6))
    costheta = cos(deg*x(6))
    uvdist1 = uu*sintheta+vv*costheta
    uvdist2 = uu*costheta-vv*sintheta
    dfac = x(4)**2*uvdist1**2+x(5)**2*uvdist2**2
    !
    ksi = dfac*(pi/log(2d0))**2
    !
    a = 1d0/(1d0+ksi)**1.5
    !
    da(4) = -cte*x(4)*uvdist1**2/(1d0+ksi)**2.5
    da(5) = -cte*x(5)*uvdist2**2/(1d0+ksi)**2.5
    da(6) = -cte*(x(4)**2-x(5)**2)*uvdist1*uvdist2/(1d0+ksi)**2.5
    !
  case default
    a = 1.
    da = 0.
  end select
  !
  ! Compute the phase term exp(-2i*pi(u*x0+v*y0)) and its derivatives
  ! with respect to x_0 and y_0
  !
  ! Sign is correct for X positive towards East.
  darg1 = dpi*uu
  darg2 = dpi*vv
  arg = darg1*x(1)+darg2*x(2)
  carg = cos(arg)
  sarg = sin(arg)
  !
  ! Now compute the real and imaginary part of function.
  y(1) = x(3)*a*carg
  y(2) = x(3)*a*sarg
  !
  ! And its derivatives with respect to x0, y0, flux
  dy(1,1) = -y(2)*darg1
  dy(2,1) =  y(1)*darg1
  dy(1,2) = -y(2)*darg2
  dy(2,2) =  y(1)*darg2
  dy(1,3) = a*carg
  dy(2,3) = a*sarg
  ! And its derivatives with respect to parameters 4, 5, 6, 7
  if (kfunc.ge.4) then
    do i=4, kfunc
      dy(1,i) = x(3)*carg*da(i)
      dy(2,i) = x(3)*sarg*da(i)
    enddo
  endif
end subroutine uvfit_model
!
function z_exp(x)
  !---------------------------------------------------------------------
  ! protect again underflows in exp(x)
  !---------------------------------------------------------------------
  real(8) :: z_exp                   !! Underflowed Exponential
  real(8) :: x                       !! Argument    
  !
  ! Constants ---
  real(8) :: xmin, ymin
  logical :: first
  data first/.true./
  save xmin, ymin, first
  !
  if (first) then
    ymin = 2.d0*tiny(1.D0) !! d1mach(1)
    xmin = log(ymin)
    first = .false.
  endif
  if (x.lt.xmin) then
    z_exp = ymin
    return
  endif
  z_exp = exp(x)
end function z_exp
!
subroutine sub_uvfit_results(line,error)
  use uvfit_options
  use gkernel_interfaces
  use uvfit_data
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  !* 
  ! IMAGER --  Support for command 
  !     UV_FIT [Func1 ... FuncN] /RESULT
  !
  ! Only works for  
  !  - all functions  
  !  - 1 channel only  
  ! Test functionality only. May disappear at any time...
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Error flag
  !
  character(len=*), parameter :: rname='UV_FIT'
  !
  ! Local ---
  integer :: i,n,ier
  integer(kind=index_length) :: dim(2)
  real :: qmin, qmax, qstep
  real, allocatable, save :: uvri(:,:) 
  !
  ! Code ----
  if (nf.eq.0) then
    call map_message(seve%e,rname,'No UV_FIT available')
    error = .true.
    return
  endif
  call sic_delvariable ('UVF%PLOT',.false.,error)
  !
  ! Get Umin Umax Ustep to define the Sampling
  call sic_i4(line,o_result,1,n,.true.,error)
  call sic_r4(line,o_result,2,qmin,.true.,error)
  call sic_r4(line,o_result,3,qmax,.true.,error)
  qstep = (qmax-qmin)/(n-1)
  !
  if (allocated(uvri)) deallocate(uvri,stat=ier)
  allocate (uvri(n,4),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  do i=1,n
    uvri(i,1) = (i-1)*qstep+qmin
  enddo
  call get_uvfit_model(n,uvri(:,1),uvri(:,2),uvri(:,3),uvri(:,4),error)
  !
  dim = [n,4]
  call sic_def_real('UVF%PLOT',uvri,2,dim,.true.,error)
end subroutine sub_uvfit_results
!
subroutine get_uvfit_model(nvisi,uu,vv,rr,ii,error)
  use gkernel_interfaces
  use uvfit_data
  !$ use omp_lib
  !---------------------------------------------------------------------
  !* 
  ! IMAGER -- Support for command   
  !     UV_FIT [Func1 ... FuncN] /RESULT
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nvisi    !! Number of visibilities
  real, intent(in) :: uu(nvisi)   !! U coordinates
  real, intent(in) :: vv(nvisi)   !! V coordinates
  real, intent(out) :: rr(nvisi)  !! Real part
  real, intent(out) :: ii(nvisi)  !! Imaginary part
  logical, intent(inout) :: error !! Error flag
  !
  ! Local ---
  real :: fa,fb
  real(8) :: y(2),dy(2)
  integer :: iif, iv, if
  integer :: ithread,kpar
  !
  ! Code ----
  !$OMP PARALLEL DEFAULT(none)  &
  !$OMP & SHARED(uu,vv)   &  ! Input Visibility array
  !$OMP & SHARED(rr,ii)   &  ! Ouput arrays
  !$OMP & SHARED(nvisi,nf,npfunc,pars,kpar,ifunc) &
  !$OMP & PRIVATE(iv,if,iif)  &
  !$OMP & PRIVATE(ithread, y, dy, fa, fb)
  !
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  !$OMP DO
  do iv=1, nvisi
    !
    fa = 0.0
    fb = 0.0
    kpar = 1
    do if = 1, nf
      iif = ifunc(if)
      call uvfit_model(iif,npfunc(if),dble(uu(iv)),dble(vv(iv)),pars(kpar),y,dy)
      fa = fa + y(1)
      fb = fb + y(2)
      kpar = kpar + npfunc(if)
    enddo
    rr(iv) = fa
    ii(iv) = fb
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine get_uvfit_model
!
!subroutine primary_radial(line,bsize,head,nr,nt,profile,error)
subroutine primary_atten(bsize,head,freq,rmax,nr,profile,error)
  use gkernel_interfaces
  use image_def
  use imager_interfaces, except_this=>primary_atten
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER --  Support for command  PRIMARY [BeamSize] 
  !
  ! Compute primary beam radial profile
  !!
  !---------------------------------------------------------------------
  real(4), intent(inout) :: bsize      !! Force Beam Size if non zero
  type(gildas), intent(in) :: head     !! Header of UV data
  real(8), intent(in)  :: freq         !! Observing Frequency
  real(8), intent(in)  :: rmax         !! Maximum Angular Distance
  integer, intent(out) :: nr           !! Number of radial points
  real(8), allocatable, intent(out) :: profile(:,:) !! Radial profile
  logical, intent(out) :: error        !! Error flag
  ! 
  ! Constants
  character(len=*), parameter :: rname='UV_FIT'
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  integer :: ir, ier
  real(8) :: dr, uvmax
  real :: bsizes(10)
  character(len=80) :: mess  
  !
  ! Code ----
  ! Compute radial profile of primary beam beyond Map limits
  uvmax = head%gil%basemax * freq * f_to_k
  dr = 1./(2.*uvmax)
  !
  nr = max(ceiling(1.2*(rmax/dr)),2)
  allocate (profile(nr,2),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  do ir=1,nr
    profile(ir,1) = (ir-1)*dr    
  enddo
  profile(:,2) = 1.0
  !
  if (bsize.eq.0) then
    if (head%gil%nteles.ge.1) then
      if (head%gil%teles(1)%ctele.eq.'ALMA') then
        call map_message(seve%i,rname,'Using ALMA beam shape')
        call primary_alma(head,nr,profile) 
        bsize = -1.0    ! Non zero value
        return
      endif
    endif
  endif
  ! Get or Check beam size
  call get_bsize(head,' ',' ',bsizes,error)
  bsize = bsizes(1)
  !
  if (bsize.gt.0) then
    write(mess,'(a,f10.2,a)') 'Using a beam size of ',&
      & bsize/pi*180*3600,'"'
    call map_message(seve%i,rname,mess)
    call primary_gauss(bsize,nr,profile)
  endif
  !
end subroutine primary_atten
!

!!
!! Definitions used by UV_INVERT / UV_MAP
!!
module uvmap_def
  !! 
  type :: par_uvmap
    !! UV_MAP parameters (no longer used)
    real taper(4)              !! UV taper
    character(len=4) mode      !! Weighting mode
    real field(2)              !! Field of view
    integer size(2)            !! Image size
    real xycell(2)             !! Image cell
    real uniform(2)            !! Robust weighting parameter
    real support(2)            !! Support size in meters
    real uvcell(2)             !! Cell size in meters
    integer channels(3)        !! First, Last and Weight channels
    integer ctype              !! Convolution type
    integer beam               !! One beam every N channels
    logical shift              !! Shift phase center
    logical blocked            !! Use blocking factor, or not (Debug)
    character(len=16) ra_c
    character(len=16) dec_c
    real(kind=8) new(3)        !! New position and angle of shift/rotation
    real(kind=8) off(3)        !! Offset and angle of shift/rotation
    real(kind=8) xy(2)         !! Phase rotation !! R*4 for SortUV
    real(kind=8) cs(2)         !! Angle offsets  !! R*4 for LoadUV
    real(kind=8) freq          !! Frequency for U,V values
    integer uvcode             !! UVT or TUV order ?
  end type
  !!
  type :: gridding
    !! Gridding functions
    real ubias                 !! Bias of U coordinates
    real ubuff(4096)           !! Grid of values of the convolution
    real vbias                 !! Bias of V coordinates
    real vbuff(4096)           !! Grid of values of the convolution
  end type gridding
  integer, parameter :: code_uvt=1  !! This MUST NOT be changed
  integer, parameter :: code_tuv=2  !! This MUST NOT be changed
end module uvmap_def
!!
!! Used by IMAGER CLEAN tools
!!
module clean_def
  !! Definition of main IMAGER derived types
  type :: gridding
    !! Gridding function tables
    real ubias                 !! Bias of U coordinates
    real ubuff(4096)           !! Grid of values of the convolution
    real vbias                 !! Bias of V coordinates
    real vbuff(4096)           !! Grid of values of the convolution
  end type gridding
  !!
  type :: channel_par  
    !! Channel range and related information
    real(8) :: freq=0          !! Frequency channel
    integer :: bounds(2)=[0,0] !! Channel range
    integer :: weight=0        !! Weight channel
  end type
  !!
  type :: uvmap_par
    !! UV_MAP image construction control parameters
    real taper(4)              !! UV Taper
    integer size(2)            !! Map size
    real xycell(2)             !! Map cell
    real uvcell(2)             !! UV cell
    real uniform(2)            !! Weighting parameters
    integer wcol               !! Weighting channel
    integer ctype              !! Convolution mode
    real support(2)            !! Support of gridding function
    integer beam               !! One beam every N channels
    real field(2)              !! Field of view in arcsecond
    real precis                !! Precision at map edges
    real truncate              !! Truncation level in %
    character(len=8) mode      !! Weighting mode
    logical shift              !! Shift or rotate UV data
    character(len=16) ra_c     !! Right ascension
    character(len=16) dec_c    !! Declination
    real angle                 !! New position angle of UV data
    integer nfields            !! Number and type of fields (<0 = phase, >0 = pointing)
    integer, allocatable :: teles(:)      !! Telescope number for each field
    real, allocatable :: bsize(:)      !! Primary Beam size (for Mosaics)
    real, allocatable :: offxy(:,:)    !! Pointing or Phase offset values
    real(8), allocatable :: centers(:,:) !! Ra Dec absolute pointings
    !! real, pointer :: uvdata(:,:)       !! UV Data (not used)
  end type uvmap_par
  !!
  !!-----
  integer, parameter :: clean_mscale=5  !! Up to 5 scale sizes, including 0
  !!
  type :: clean_par
    !! CLEAN deconvolution control parameters
    sequence
    integer first,last         !! First & Last plane
    integer nlist              !! List size
    integer iplane             !! Current image plane
    integer ibeam              !! Current beam plane
    integer imask              !! Current mask plane 
    !!
    real thresh                !! Threshold for beam fit
    real gain                  !! Loop gain
    real fres                  !! Fractional residual
    real ares                  !! Absolute residual
    real ratio                 !! Smoothing ratio for MRC
    real spexp                 !! Speed up factor in Clark
    real phat                  !! Prussian hat
    real flux                  !! Cleaned Flux
    real search                !! Threshold for searching
    real restor                !!           for restoration
    real trunca                !! Beam truncation value
    real worry                 !! Worry factor in MultiScale
    integer ninflate           !! Component "inflation" factor
    integer ngoal              !! Maximum number of minor cycle components
    integer converge           !! Convergence criterium: 0 = Infty
    integer m_iter             !! Maximum number of iterations
    integer n_iter             !! Current number of iterations
    integer p_iter             !! Positive number of iterations
    integer n_major            !! Maximum number of major cycle
    !!
    !! MultiScale
    real smooth                !! Multi-Scale smoothing factor
    integer nker(clean_mscale) !! Kernel for Multi-Scale clean
    !! Multi Gaussian
    integer nscale             !! Number of Gaussian scales
    real gains(clean_mscale)   !! Clean gains
    real gsize(clean_mscale)   !! Gaussian smoothing widths
    !!
    real major                 !! Major axis
    real minor                 !! Minor axis
    real angle                 !! Clean beam angle
    real beam_min              !! Beam minimum
    real beam_max              !! Beam maximum
    real bgain                 !! Outer sidelobe
    !!
    integer blc(2)             !! Bottom Left Corner
    integer trc(2)             !! Top Right Corner
    integer box(4)             !! Cleaning Box
    integer beam0(2)           !! Beam center X,Y
    integer patch(2)           !! Beam patch sizes
    integer bzone(4)           !! Beam patch
    integer bshift(3)          !! Beam shift
    integer residual           !! Add back the residual ?
    integer restart            !! Restart Cleaning from CCT  !! (0,2,6)
    logical mosaic             !! Mosaic flag
    logical pflux              !! Flux display
    logical pcycle             !! Residual display in cycle
    logical pmrc               !! MRC display in cycle
    logical qcycle             !! Query mode
    logical pclean             !! Clean display in cycle
    logical do_mask            !! Re-compute the mask ?
    logical verbose            !! Lots of printout ?
    character(len=12) method   !! CLEAN Method
    !!
    real, pointer :: atten(:,:,:)   !! Mosaic weights (as function of freq)
  end type
  !-----
  type :: cct_par              !! Clean Component element definition
    !! Must be properly initialized, with VALUE to 0.
    real :: influx=0.          !! Current flux
    real :: value=0.           !! Component value
    integer :: ix=0            !! X pixel
    integer :: iy=0            !! Y pixel
    real :: size=0.            !! Component size (<0 = -kernel number)
  end type
  !!
  type :: cct_lst 
    !! Clean component list definition
    integer :: cur_size = 0
    integer :: max_size = 0
!    integer :: n_scales = 0   !! Number of scales
!    integer :: t_scales = 0   !! Type of scales (Currently, only Gaussian)
!    real :: scales(6)         !! Scale sizes
    !
    type(cct_par), allocatable :: cc(:) !! A list of clean component
    !
    contains
      procedure reallocate     !! List resize 
      procedure initialize     !! List initialization
  end type
  !!
  contains
    subroutine initialize(cct_list,usize)
      !!-------------------------------------------------------------------
      !! IMAGER
      !!   Initialize a Clean Component Table
      !!-------------------------------------------------------------------
      class(cct_lst), intent(inout) :: cct_list    !! Clean Component List
      integer, optional, intent(in) :: usize !! Specified minimum size
      !!
      integer :: ier
      !!
      if (allocated(cct_list%cc)) deallocate(cct_list%cc)
      cct_list%cur_size = 0
      cct_list%max_size = 0
!!      cct_list%n_scales = 0
!!      cct_list%scales = 0.0
      if (.not.present(usize)) return
      !!
      if (usize.le.0) return
      allocate(cct_list%cc(usize),stat=ier)
      if (ier.ne.0) return
      cct_list%max_size = usize
    end subroutine initialize
    !!
    subroutine reallocate(cct_list,usize) 
      !!-------------------------------------------------------------------
      !! IMAGER
      !!   Extend the size of a Clean Component Table
      !!-------------------------------------------------------------------
      class(cct_lst), intent(inout) :: cct_list    !! Clean Component List
      integer, optional, intent(in) :: usize !! Specified minimum size
      !!
      type(cct_par), allocatable :: tmp(:)
      integer(kind=4) :: nsize,ier
      character(len=80) :: mess
      !!
      ier = 0
      nsize = max(2*cct_list%max_size,500)
      if (present(usize)) then
        nsize = usize
        if (cct_list%max_size.ge.usize) return
      endif
      !!
      if (cct_list%max_size.ne.0) then
        !!
        if (cct_list%cur_size.ne.0) then
          allocate(tmp(cct_list%cur_size),stat=ier,errmsg=mess)
          if (ier.ne.0) then
            write(*,'(A,I0,A)') 'Memory TMP allocation error for CCT_LIS%CC ',nsize,trim(mess)
            return
          endif
          tmp = cct_list%cc(1:cct_list%cur_size)
          if (allocated(cct_list%cc)) then
            deallocate(cct_list%cc)
          else
            write(*,'(A,I0,A)') 'Unallocated CCT_LIST%CC with Cur size ',cct_list%cur_size
          endif
          allocate(cct_list%cc(nsize),stat=ier,errmsg=mess)
          if (ier.ne.0) then
            write(*,'(A,I0,A)') 'Memory re-allocation error for CCT_LIS%CC ',nsize,trim(mess)
            return
          endif
          cct_list%cc(1:cct_list%cur_size) = tmp
          !!write(*,'(A,I0,A,I0)') 'CCT_LIST Re-allocation with copy from ',cct_list%max_size,' to ',nsize
          deallocate(tmp)
        else
          if (allocated(cct_list%cc)) deallocate(cct_list%cc)
          allocate(cct_list%cc(nsize),stat=ier,errmsg=mess)
          if (ier.ne.0) then
            write(*,'(A,I0,A)') 'Memory re-allocation error for CCT_LIS%CC ',nsize,trim(mess)
            return
          endif
          !!write(*,'(A,I0,A,I0)') 'CCT_LIST Extension from ',cct_list%max_size,' to ',nsize
        endif
      else
        allocate(cct_list%cc(nsize),stat=ier,errmsg=mess)
        if (ier.ne.0) then
          write(*,'(A,I0,A)') 'Memory allocation error for CCT_LIST%CC ',nsize,trim(mess)
          return
        endif
        !!write(*,'(A,I0)') 'CCT_LIST Allocation to ',nsize
      endif
      cct_list%max_size = nsize
    end subroutine reallocate
  !!
end module clean_def
!
module mod_fitbeam
  !! Module to handle Fitting of the Dirty beam size
  integer :: nv                !! Number of values
  real :: par(6)               !! Fitted parameters
  real :: err(6)               !! Errorbars
  real :: spar(6)              !! Last fitted values
  real :: sigbas               !! rms on baseline
  real :: sigrai               !! rms on line
  integer :: kpar(6)           !! Code for parameter
  real, allocatable :: ip_values(:)    !! Values
  real, allocatable :: ip_coords(:,:)  !! Coordinates
end module mod_fitbeam
!
module short_def
  !! Define short_spacings, a structure to control the XY_SHORT
  !! command
  integer, parameter :: code_short_old=0    !! Old method: one file per field
  integer, parameter :: code_short_phase=1  !! Mosaic UV table with phase offsets
  integer, parameter :: code_short_point=2  !! Mosaic UV table with pointing offsets
  integer, parameter :: code_short_auto=3   !! Automatic derivation of UV table offsets type
  !!
  type :: short_spacings
    integer              :: mode=3
    real                 :: sd_factor=0.0  !! Single dish flux factor
    real                 :: minw=0.01      !! Minimum weight retained
    real                 :: ptole=0.0      !! Position tolerance
    real                 :: ftole=0.01     !! Frequency tolerance (in channel width)
    real                 :: uv_minr=0.     !! Minimum radius
    real                 :: uv_maxr=0.     !! Maximum radius
    real                 :: sd_weight=0.   !! Single dish weight factor
    integer              :: xcol=0         !! X column
    integer              :: ycol=0         !! Y column
    integer              :: wcol=0         !! Weight column
    integer              :: mcol(2)=[0,0]  !! Columns to be imaged
    real                 :: sd_beam(3)=[0.,0.,0.] !! Single dish beam values
    real                 :: sd_diam=0.     ! Single Dish diameter
    real                 :: ip_beam=0.     !! Array primary beam
    real                 :: ip_diam=0.     !! Array antennas diameter
    logical              :: do_single=.true.   !! Use single dish
    logical              :: do_primary=.true.  !! Correct for primary beam
    character(len=4)     :: weight_mode='NATU' !! Weighting mode
    character(len=16)    :: chra=' '       !! RA of phase center
    character(len=16)    :: chde=' '       !! Dec of phase center
    integer              :: nf=0           !! Number of fields
    real, allocatable    :: raoff(:)
    real, allocatable    :: deoff(:)
  end type 
  !!
end module short_def

subroutine uv_shift_header (new,ra,dec,ang,off,doit)
  use gkernel_interfaces
  use gkernel_types
  !-------------------------------------------------
  ! @ private
  !*
  ! IMAGER --   Compute position shift parameters
  !!
  !-------------------------------------------------
  real(kind=8), intent(inout) :: new(3)   !! New phase center and angle
  real(kind=8), intent(in) :: ra,dec,ang  !! Old center and angle
  real(kind=8), intent(out) :: off(3)     !! Required Offsets and Angle
  logical, intent(inout) :: doit          !! Is shift Required ? 
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=(pi/180d0/3600d0)
  type(projection_t) :: proj
  logical :: error
  !
  off = 0.d0
  if (.not.doit) return
  call imager_tree('UV_SHIFT_HEADER',.false.)
  !
  ! Check phase center agreement to 0.001" and angle to 1"
  ! These might be customizable in IMAGER to some level
  ! but there is a limit due to the machine precision
  ! which affects abs_to_rel and rel_to_abs.
  !
  if ( abs(new(1)-ra).lt.1d-3*sec_to_rad .and.   &
     &    abs(new(2)-dec).lt.1d-3*sec_to_rad .and.   &
     &    abs(new(3)-ang).lt.sec_to_rad ) then
    ! The change is too small: it cannot be applied
    ! But we must be sure the New center reflects the actual projection
    new(1) = ra
    new(2) = dec
    new(3) = ang
    doit  = .false.
    return
  endif
  !
  off(1) = ra
  off(2) = dec
  off(3) = ang               
  error = .false.
  call gwcs_projec(ra,dec,ang,3,proj,error)  ! Previous projection system
  call abs_to_rel (proj,new(1),new(2),off(1),off(2),1)  ! Offsets of new center
  off(3) = new(3)-ang          ! Additional rotation required
  if (abs(off(3)).lt.sec_to_rad) off(3) = 0.d0
  call imager_tree('UV_SHIFT_HEADER',.true.)
end subroutine uv_shift_header
!
subroutine shift_uvdata(hx,nu,nv,visi,cs,nc,xy)
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use clean_arrays 
  use gbl_message
  use imager_interfaces, only : map_message
  use phys_const
  !$ use omp_lib
  !-------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER  --   Support routine for commands UV_SHIFT and UV_MAP
  !
  !   Shift phase center and apply U,V coordinates rotation if needed
  !   Note that Offsets are not shifted, neither rotated by this
  !   subroutine
  !-------------------------------------------------------------------
  type(gildas), intent(inout) :: hx   !! Input UV header
  integer, intent(in) :: nu           !! Size of a visibility
  integer, intent(in) :: nv           !! Number of visibilities
  real, intent(inout) :: visi(nu,nv)  !! Visibilities
  real, intent(in) :: cs(2)           !! Cos/Sin of Rotation
  integer, intent(in) :: nc           !! Number of Channels
  real(8), intent(in) :: xy(2,nc)     !! Position Shift per channel
  !
  ! Local ---
  integer(kind=index_length) :: i
  integer :: ix, iu, iv, jc, loff, moff, idoff, ipoint
  real(8) :: phi, sphi, cphi, freq, x, y, xoff, yoff
  real(4) :: u, v, reel, imag
  real(8), allocatable :: lm_uv(:)
  !
  ! Code ----
  iu = hx%gil%column_pointer(code_uvt_u)
  iv = hx%gil%column_pointer(code_uvt_v)
  !
  ! If there is a Phase offset column, use it
  !  integer(kind=4), parameter :: code_uvt_loff = 10 ! Phase center Offset
  !  integer(kind=4), parameter :: code_uvt_moff = 11 ! Phase center Offset
  loff = hx%gil%column_pointer(code_uvt_loff)
  moff = hx%gil%column_pointer(code_uvt_moff)
  idoff = hx%gil%column_pointer(code_uvt_id)
  !
  if (loff.ne.0 .and. moff.ne.0) then
    !
    ! Shift and Rotation of a per-field phase center to a common one
    !
    allocate(lm_uv(nc))
    if (nc.eq.1) then
      freq = gdf_uv_frequency(hx)
      lm_uv(1) = freq * f_to_k
    else
      do i=1,hx%gil%nchan
        freq = gdf_uv_frequency(hx,dble(i))
        lm_uv(i) = freq * f_to_k
      enddo
    endif
    !
    cphi = 1.0
    sphi = 0.0
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(hx,nv,nc,cs,xy,loff,moff,lm_uv,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v,x,y,phi,jc,ix,reel,imag) &
    !$OMP FIRSTPRIVATE(cphi,sphi)    
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
      !
      if (nc.eq.1) then
        x = xy(1,1) + lm_uv(1) * visi(loff,i)
        y = xy(2,1) + lm_uv(1) * visi(moff,i)
        phi = x*u + y*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      !
      do jc=1,hx%gil%nchan
        ix = hx%gil%fcol+(jc-1)*hx%gil%natom
        if (nc.gt.1) then
          x = xy(1,jc) + lm_uv(jc) * visi(loff,i)
          y = xy(2,jc) + lm_uv(jc) * visi(moff,i)
          phi = x*u + y*v
          cphi = cos(phi)
          sphi = sin(phi)
        endif
        reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
        imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
        visi(ix,i) = reel
        visi(ix+1,i) = imag
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
  else if ((themap%nfields.ne.0).and.(idoff.ne.0)) then
    if (.not.allocated(hx%mos%fields)) then
      call map_message(seve%e,'SHIFT_UV','Programming error, no Mosaic Header',1)
      return
    else
      call map_message(seve%w,'SHIFT_UV','Mosaic UV Table with ID should not be shifted',1)
      ! return ?
    endif
    !
    ! Shift and Rotation of an arbitrary per-field phase center to a common one
    !
    allocate(lm_uv(nc))
    if (nc.eq.1) then
      freq = gdf_uv_frequency(hx)
      lm_uv(1) = freq * f_to_k
    else
      do i=1,hx%gil%nchan
        freq = gdf_uv_frequency(hx,dble(i))
        lm_uv(i) = freq * f_to_k
      enddo
    endif
    !
    cphi = 1.0
    sphi = 0.0
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(hx,nv,nc,cs,xy,idoff,loff,moff,lm_uv,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v,x,y,phi,jc,ix,reel,imag,xoff,yoff,ipoint) &
    !$OMP FIRSTPRIVATE(cphi,sphi)    
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
      !
      ipoint = nint(visi(idoff,i))
      xoff = hx%mos%fields(ipoint)%ophase(1)
      yoff = hx%mos%fields(ipoint)%ophase(2)
      if (nc.eq.1) then
        x = xy(1,1) + lm_uv(1) * xoff
        y = xy(2,1) + lm_uv(1) * yoff
        phi = x*u + y*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      !
      do jc=1,hx%gil%nchan
        ix = hx%gil%fcol+(jc-1)*hx%gil%natom
        if (nc.gt.1) then
          x = xy(1,jc) + lm_uv(jc) * xoff
          y = xy(2,jc) + lm_uv(jc) * yoff
          phi = x*u + y*v
          cphi = cos(phi)
          sphi = sin(phi)
        endif
        reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
        imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
        visi(ix,i) = reel
        visi(ix+1,i) = imag
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
  else if (xy(1,1).eq.0. .and. xy(2,1).eq.0.) then
    !
    ! No shift, only rotation of U,V coordinates
    !
    if (cs(1).eq.1.0) return  ! No rotation either
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(nv,cs,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v)
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else
    !
    ! Shift and rotation of a common phase center
    !
    cphi = 1.0
    sphi = 0.0
    !
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP SHARED(hx,nv,nc,cs,xy,visi,iu,iv) &
    !$OMP PRIVATE(i,u,v,x,y,phi,jc,ix,reel,imag) &
    !$OMP FIRSTPRIVATE(cphi,sphi) 
    !
    !$OMP DO
    do i = 1,nv
      u = visi(iu,i)
      v = visi(iv,i)
      visi(iu,i) = cs(1)*u - cs(2)*v
      visi(iv,i) = cs(2)*u + cs(1)*v
      !
      if (nc.eq.1) then
        phi = xy(1,1)*u + xy(2,1)*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      !
      do jc=1,hx%gil%nchan
        ix = hx%gil%fcol+(jc-1)*hx%gil%natom
        if (nc.gt.1) then
          phi = xy(1,jc)*u + xy(2,jc)*v
          cphi = cos(phi)
          sphi = sin(phi)
        endif
        reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
        imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
        visi(ix,i) = reel
        visi(ix+1,i) = imag
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine shift_uvdata

subroutine major_cycle90 (rname,method,head,   &
     &    beam,beam_nx,beam_ny,nx,ny,clean,resid,tfbeam,fcomp,   &
     &    wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, wfft, cct_list, list, nl, np, primary, weight,       &
     &    major_plot, next_flux)
  use imager_interfaces, except_this=>major_cycle90
  use clean_def
  use image_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for CLARK command  
  !   Major cycle loop according to B.Clark idea
  !!
  !----------------------------------------------------------------------
  external :: major_plot                        !! Major cycle Display
  external :: next_flux                         !! Cumulative flux display
  !
  character(len=*), intent(in) :: rname         !! Calling command
  type (clean_par), intent(inout) :: method     !! Method parameters
  type (gildas), intent(in)  :: head            !! Data header
  integer, intent(in) :: nx                     !! X size
  integer, intent(in) :: ny                     !! Y size
  integer, intent(in) :: beam_nx,beam_ny        !! Beam size
  integer, intent(in) :: np                     !! Number of pointings
  integer, intent(in) :: mcl                    !! Maximum number of clean components
  real, intent(inout) :: clean(nx,ny)           !! Clean map
  real, intent(inout) :: resid(nx,ny)           !! Residual map
  real, intent(in) ::    beam(beam_nx,beam_ny,np)         !! Dirty beams (per pointing)
  real, intent(in) ::    tfbeam(nx,ny,np)       !! FT. of dirty beams
  complex, intent(inout) :: fcomp(nx,ny)        !! FT. of components 
  real, intent(in) :: bgain                     !! Maximum sidelobe level
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: ixpatch, iypatch       !! Beam patch radius
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(inout) :: wfft(*)                !! Work space for FFT
  type(cct_lst), intent(inout) :: cct_list      !! Clean components array
  type(cct_par), intent(inout) :: wcl(mcl)      !! Work space for Clean components
  integer, intent(inout) :: list(nx*ny)         !! list of searchable pixels
  integer, intent(inout) :: nl                  !! Pixel list size
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight (nx,ny)            !! Flat field response
  !
  ! Local ---
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  real    lastabs              ! Check for oscillations
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real    clarkl               ! Clark worry limit
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer m_iter
  integer k, kcl
  character(len=message_length) :: chain
  !
  ! Code ----
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
  !
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !  method%n_iter= 0       ! This is now set in the Call Sequence to allow re-starting
  m_iter = method%m_iter
  if (method%m_iter.eq.0) then
    method%m_iter = 2**30  ! A Large enough number
  else
    method%m_iter = m_iter
  endif
  flux = 0.0
  !
  ! Major cycle
  k = 0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%i,rname,chain)
    limite = max(maxabs*bgain,0.8*borne)
    clarkl = maxabs*bgain
    !
    kcl = mcl
    !
    ! Select points of maximum strength and load them in
    call choice (            &
     &      resid,           & ! Current residuals
     &      nx,ny,           & ! image size
     &      list, nl,        & ! Search list
     &      limite,          & ! Detection threshold
     &      kcl,             & ! Maximum number of candidates
     &      wcl,             & ! CCT
     &      ncl,             & ! Selected Number of components
     &      maxabs, method%ngoal)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%i,rname,chain)
      !
      ! Make minor cycles   ! Starting iteration ?
      call minor_cycle90 (method,   &
     &        wcl,            &  ! CCT
     &        ncl,            &  ! Number of candidates
     &        beam,beam_nx,beam_ny,     &  ! Dirty beams and Size
     &        nx,ny,          &  ! Image size
     &        ixbeam,iybeam,  &  ! Beam center
     &        ixpatch,iypatch,&  ! Beam patch
     &        clarkl,limite,  &
     &        converge,       &  !
     &        cct_list,       &  ! Cumulated components
     &        np, primary, weight, method%trunca,   &
     &        flux,           &  ! Total Flux
     &        method%pflux, next_flux)
      !
      call compresswcl(wcl,ncl)
      !
      ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
      call remisajour (    &
     &        clean,       &    ! CLEAN map used as work space
     &        resid,       &    ! Updated residuals
     &        tfbeam,      &    ! Beam TF
     &        fcomp,       &    ! Work space for Component TF
     &        wcl,         &    ! CCT
     &        ncl,         &    ! Number of Clean Components
     &        nx,ny,       &    ! Map size
     &        wfft,        &    ! FFT work space
     &        np, primary, weight, method%trunca)
      write (chain,101)  'Cleaned ',flux,' Jy with ',method%n_iter,' clean components'
      call map_message(seve%i,rname,chain)
      !
      ! Find new extrema
      lastabs = maxabs
      call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      if (maxabs.gt.1.15*lastabs) then
        write(chain,'(a,1pg10.3,a,1pg10.3)') &
     &      'Detected beginning of oscillations',maxabs,' > ',lastabs
        call map_message(seve%w,rname,chain)
      endif
      !
      ! Check if converge
      fini = (maxabs.le.borne)   &
     &        .or. (method%m_iter.le.method%n_iter)   &
     &        .or. converge
    else
      ! No component found: finish...
      write(chain,101) 'No points selected above ',limite
      call map_message(seve%i,rname,chain)
      fini = .true.
    endif
    !
    ! Intermediate or final PLOT
    converge = fini
    call major_plot (method,head,              &
     &      converge,method%n_iter,nx,ny,np,   &
     &      cct_list%cc,clean,resid,weight)
    fini = converge
    !
    ! Limit number of major cycles...
    if (k.gt.method%n_major) fini = .true.
    !
  enddo
  method%m_iter = m_iter
  !
  ! End
  if (maxabs.le.borne) then
    call map_message(seve%i,rname,'Reached minimum flux density')
  elseif (method%m_iter.le.method%n_iter) then
    call map_message(seve%i,rname,'Reached maximum number of components')
  elseif (converge) then
    call map_message(seve%i,rname,'Reached minor cycle convergence')
  elseif (k.gt.method%n_major) then
    write(chain,'(I0)') method%n_major
    call map_message(seve%i,rname,'Reached maximum number of cycles '//chain)
  else
    call map_message(seve%i,rname,'End of transcendental causes')
  endif
  !
  100   format (a,i6,a,1pg10.3,a)
  101   format (a,1pg10.3,a,i7,a)
end subroutine major_cycle90
!
subroutine minor_cycle90 (method, wcl, ncl,           &
     &    beam,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,ixpatch,iypatch,   &
     &    clarkmin,limite,converge,   &
     &    cct_list, np, primary, weight, wtrun, cum, pflux, next_flux )
  use gkernel_interfaces
  use imager_interfaces, except_this=>minor_cycle90
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- CLARK Internal routine  
  !   B.Clark minor cycles.
  !   Deconvolve as in standard clean a list of NCL points
  !   selected in the map until the residuals is less than CLARKMIN
  !!
  !----------------------------------------------------------------------
  external :: next_flux                         !! Cumulative flux display
  type (clean_par), intent(inout) :: method     !! Method parameters
  integer, intent(in) :: np                     !! Number of fields in mosaic
  integer, intent(in) :: ncl                    !! Number of pixels selected
  integer, intent(in) :: beam_nx,beam_ny        !! Beam size
  integer, intent(in) :: nx,ny,ixbeam,iybeam    !! Size and cente pixel of beam
  integer, intent(in) :: ixpatch,iypatch        !! Used size of beam
  real, intent(in) :: beam(beam_nx,beam_ny,np)  !! Dirty beams
  type(cct_par), intent(inout) :: wcl(*)        !! Clean components
  real, intent(in) :: clarkmin                  !! Stopping criterium for minor cycles
  real, intent(in) :: limite                    !! Clean Stopping criterium
  logical, intent(out) :: converge              !! Convergence indicator
  type (cct_lst), intent(inout) :: cct_list     !! Effective clean components
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams of mosaics
  real, intent(in) :: weight(nx,ny)             !! Effective weights on sky
  real, intent(in) :: wtrun                     !! Threshold of primary beam
  real, intent(inout) :: cum                    !! Cumulative flux
  logical, intent(in) :: pflux                  !! Plot cumulative flux
  !
  ! Local ---
  real gain                    ! CLEAN gain 
  logical goon                 ! Continue after convergence
  integer kcl                  ! Current Clean component
  integer nomax, nomin         ! Clean component of Max and Min 
  real rmax, rmin, sign, cdif  ! current Max and Min 
  real worry, xfac             ! Conservative and speedup factor
  integer kiter
  integer :: dimcum            ! Flux convergence control
  real, allocatable :: oldcum(:)
  real f, bmax
  integer n,ier,i,jiter
  logical abor
  character(len=20) comm
  !
  ! Code ----
  dimcum = method%converge
  allocate(oldcum(max(1,dimcum)),stat=ier)
  if (ier.ne.0) then
    Print *,'Convergence array allocation error ',ier,dimcum
    return
  endif
  oldcum = cum
  !
  abor = .false.
  do i=1,ncl
    wcl(i)%value = 0.0
  enddo
  gain = method%gain
  !
  call maxcct (wcl,ncl,nomin,rmin,nomax,rmax)
  !
  ! Remember the sign if cumulative
  if (cum.gt.0) then
    sign = 1.0
  else if (cum.lt.0) then
    sign = -1.0
  else
    sign = 0.0
  endif
  !
  ! Identify the max, and set the sign if not already done
  if (method%n_iter.lt.method%p_iter) then
    kcl=nomax
    rmax=abs(rmax)
    sign = 1.0
  elseif (abs(rmin).gt.rmax) then
    kcl=nomin
    rmax=abs(rmin)
    if (sign.eq.0) sign = -1.0
  else
    kcl=nomax
    rmax=abs(rmax)
    if (sign.eq.0) sign = 1.0
  endif
  !
  converge = rmax.le.limite
  worry = 1.0
  xfac = (clarkmin/rmax)**method%spexp
  kiter = 0
  goon = (method%n_iter.lt.method%m_iter) .and. (.not.converge)
  bmax = beam(ixbeam,iybeam,1)
  !
  do while (goon)
    method%n_iter = method%n_iter + 1
    kiter = kiter + 1
    if (np.gt.1) then
      f = gain * wcl(kcl)%influx* weight(wcl(kcl)%ix,wcl(kcl)%iy)
    else
      f = gain / bmax * wcl(kcl)%influx
    endif
    !
    ! Store clean component list
    cum = cum+f
    if (pflux) call next_flux(method%n_iter,cum,0)
    !
    if (method%n_iter.ge.cct_list%max_size) call cct_list%reallocate()
    wcl(kcl)%value = wcl(kcl)%value + f
    cct_list%cc(method%n_iter)%value = f    ! Store as fractions of beam max
    cct_list%cc(method%n_iter)%ix = wcl(kcl)%ix
    cct_list%cc(method%n_iter)%iy = wcl(kcl)%iy
    cct_list%cc(method%n_iter)%size = 0.
    cct_list%cur_size = method%n_iter
    !
    ! Subtract from iterated values VCL
    call soustraire (wcl,ncl,           &
     &      beam,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,   &
     &      ixpatch,iypatch,kcl,gain,   &
     &      np,primary,weight,wtrun)
    !
    ! Find maximum again
    call maxcct (wcl,ncl,nomin,rmin,nomax,rmax)
    if (method%n_iter.lt.method%p_iter) then
      kcl=nomax
      rmax=abs(rmax)
    elseif (abs(rmin).gt.rmax) then
      kcl=nomin
      rmax=abs(rmin)
    else
      kcl=nomax
      rmax=abs(rmax)
    endif
    !
    ! B.CLARK Magic confidence factor
    worry = worry+xfac/float(kiter)
    !
    ! Check convergence
    abor = sic_ctrlc()
    goon = (rmax.gt.worry*clarkmin) .and. (rmax.gt.limite)   &
     &      .and. (method%n_iter.lt.method%m_iter)
    goon = goon .and. .not.abor
    if (dimcum.ne.0) then
      jiter = kiter-1 ! Not method%n_iter
      oldcum(mod(jiter,dimcum)+1) = cum
      if (jiter.ge.dimcum) then
        cdif = cum-oldcum(mod(jiter+1,dimcum)+1)
        converge = sign*cdif.lt.0.0
        goon = goon .and. .not.converge
      endif
    endif
  enddo
  !
  if (abor) then
    comm = ' '
    call sic_wprn('I-CLARK,  Enter last valid component ',comm,n)
    if (n.eq.0) return
    n = len_trim(comm)
    if (n.eq.0) return
    read(comm(1:n),*,iostat=ier) method%n_iter
    if (ier.ne.0) return
    converge = .true. ! It must be converged
    cct_list%cur_size = method%n_iter
  endif
end subroutine minor_cycle90
!
subroutine major_sdi90 (rname,method,head,clean,beam,resid,nx,ny,   &
     &    tfbeam,fcomp,wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, wfft, comp, list, nl, np, primary, weight, &
     &    major_plot )
  use imager_interfaces, except_this=>major_sdi90
  use clean_def
  use image_def
  use gbl_message
  use gkernel_interfaces, only : sic_ctrlc
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- CLEAN  Method SDI  
  ! Major cycle loop according to Steer Dewdney and Ito idea
  !!
  !----------------------------------------------------------------------
  external :: major_plot                        !! Plotting routine
  character(len=*), intent(in) :: rname         !! Caller name
  type (clean_par), intent(inout) :: method     !! Deconvolution method parameterss
  type (gildas), intent(in)  :: head            !! Data header
  integer, intent(in) :: np                     !! Number of fields
  integer, intent(in) :: nx                     !! X size
  integer, intent(in) :: ny                     !! Y size
  integer, intent(in) :: mcl                    !! Maximum number of clean components
  real, intent(inout) :: clean(nx,ny)           !! Clean map
  real, intent(inout) :: resid(nx,ny)           !! Residual map
  real, intent(in) ::    beam(nx,ny,np)         !! Dirty beams (per field)
  real, intent(in) ::    tfbeam(nx,ny,np)       !! FT. of beams
  complex, intent(inout) :: fcomp(nx,ny)        !! FT of component list
  type(cct_par), intent(inout) :: wcl(mcl)      !! Work space for Clean components
  real, intent(in) :: bgain                     !! Maximum sidelobe level
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: ixpatch, iypatch       !! Beam patch radius
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(inout) :: wfft(*)                !! Work space for FFT
  integer, intent(inout) :: list(nx*ny)         !! list of searchable pixels
  integer, intent(inout) :: nl                  !! List size
  real, intent(inout) :: comp(nx,ny)            !! Clean components array
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight (nx,ny)            !! Flat field array
  !
  ! Local ---
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer k
  real factor                  ! Scaling factor
  character(len=message_length) :: chain
  type (cct_par) :: tcc(1)     ! Dummy argument for Major_PLOT
  real :: sign, cdif
  integer :: dimcum, jiter
  real, allocatable :: oldcum(:)
  !
  ! Code ----
  dimcum = min(8,method%n_major/2)
  allocate (oldcum(dimcum))
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
  sign = 1
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
    sign = -1.0    
  else
    maxabs=abs(maxc)
  endif
  oldcum = 0
  !
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !   method%n_iter= 0      ! Set at Call sequence
  flux = 0.0
  !
  ! Initialize clean components
  comp = 0.0
  !
  ! Major cycle
  !
  converge = .false.
  k = 0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%i,rname,chain)
    limite = max(maxabs*bgain,0.8*borne)
    !
    ! Select points of maximum strength and load them in
    call choice (   &
     &      resid,       &      ! Current residuals
     &      nx,ny,       &      ! image size
     &      list, nl,    &      ! Search list
     &      limite,      &      ! Detection threshold
     &      mcl,         &      ! Maximum number of candidates
     &      wcl,         &      ! Selected candidate components
     &      ncl,         &      ! Selected Number of components
     &      maxabs, 0)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%i,rname,chain)
      !
      ! No minor cycles. Compute scaling factor
      call normal (   &
     &        fcomp,       &    ! Work space for Component TF
     &        tfbeam,      &    ! Beam TF
     &        nx,ny,       &    ! image size
     &        wcl,         &    ! Selected candidate components
     &        ncl,         &    ! Selected Number of components
     &        wfft,        &    ! FFT work space
     &        factor)
      ! !Print *,'Done NORMAL '
      !
      ! Compute Clean Components
      factor = method%gain*maxabs/factor
      call scalec (wcl,          &    ! Selected candidate components
     &        ncl,factor,flux,   &
     &        comp, nx, ny)
      ! !Print *,'Done SCALEC '
      method%n_iter = method%n_iter+ncl
      !
      ! Remove all components by FT : RESIDU = RESIDU - BEAM # WCL(*,4)
      call remisajour (    &
     &        clean,       &    ! CLEAN map used as work space
     &        resid,       &    ! Updated residuals
     &        tfbeam,      &    ! Beam TF
     &        fcomp,       &    ! Work space for Component TF
     &        wcl,         &    ! Clean components
     &        ncl,         &    ! Number of Clean Components
     &        nx,ny,       &    ! Map size
     &        wfft,        &    ! FFT work space
     &        np, primary, weight, method%trunca)
      ! !Print *,'Done REMISAJOUR '
      write (chain,101)  'Cleaned ',flux,' Jy with ',   &
     &        method%n_iter,' clean components'
      call map_message(seve%i,rname,chain)
      !
      ! Find new extrema
      call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      !
      if (dimcum.ne.0) then
        jiter = k   ! The Major Loop counter 
        oldcum(mod(jiter,dimcum)+1) = flux
        if (jiter.ge.dimcum) then
          cdif = flux-oldcum(mod(jiter+1,dimcum)+1)
          converge = sign*cdif.lt.0.0
          if (.not.converge) then
            if (abs(cdif/flux).lt.1E-3) converge = .true.
          endif
        endif
      endif
      ! Check if converge
      fini = (maxabs.le.borne)             &
     &        .or. (k.gt.method%n_major)   &
     &        .or. converge
    else
      write(chain,101) 'No point selected above ',limite
      fini = .true.
      call map_message(seve%i,rname,chain)
    endif
    !
    ! Intermediate or final PLOT
    converge = fini
    clean(:,:) = comp               ! Use CLEAN as work space to plot it
    ! !Print *,'Doing MAJOR_PLOT '
    call major_plot (method,head,              &
     &      converge,method%n_iter,nx,ny,np,   &
     &      tcc,clean,resid,weight)
    ! !Print *,'Done MAJOR_PLOT '
    fini = converge
    !
    if (sic_ctrlc()) exit
  enddo
  !
  ! End
  if (maxabs.le.borne) then
    write(chain,100) 'Reached minimum flux density '
  elseif (k.ge.method%n_major) then
    write(chain,100) 'Reached maximum number of cycles'
  elseif (converge) then
    write(chain,100) 'Reached flux convergence'
  else
    write(chain,100) 'End of transcendental causes'
  endif
  call map_message(seve%i,rname,chain)
  !
  ! Store the result
  clean(:,:) = comp
  !
  100   format (a,i0,a,1pg11.4,a)
  101   format (a,1pg11.4,a,i0,a)
end subroutine major_sdi90
!
subroutine normal (fcomp,tfbeam,nx,ny, wcl,ncl,wfft,factor)
  use gkernel_interfaces, only : fourt
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  --  CLEAN Method SDI  
  ! Subtract last major cycle components from residual map.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx               !! X size
  integer, intent(in) :: ny               !! Y size
  integer, intent(in) :: ncl              !! Number of clean components
  type(cct_par), intent(in) :: wcl(ncl)   !! Clean components
  real, intent(in) :: tfbeam(nx,ny)       !! FT. of beam
  complex, intent(out) :: fcomp(nx,ny)    !! FT. of clean components
  real, intent(inout) :: wfft(*)          !! Work array
  real, intent(out) :: factor             !! Max of clean
  !
  ! Local ---
  integer i,j,k,ndim,nn(2)
  !
  ! Code ----
  fcomp = 0.0
  do k=1,ncl
    fcomp(wcl(k)%ix,wcl(k)%iy) = cmplx(wcl(k)%influx,0.0)
  enddo
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fcomp = fcomp*tfbeam
  call fourt(fcomp,nn,ndim,1,1,wfft)
  factor = abs(real(fcomp(1,1)))
  do j=1,ny
    do i=1,nx
      factor = max(factor,abs(real(fcomp(i,j))))
    enddo
  enddo
end subroutine normal
!
subroutine scalec(wcl,ncl,f,s,compon,nx,ny)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- CLEAN Method SDI  
  ! Subtract last major cycle components from residual map.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx               !! X size
  integer, intent(in) :: ny               !! Y size
  integer, intent(in) :: ncl              !! Number of clean components
  type(cct_par), intent(inout) :: wcl(ncl)  !! Clean components
  real, intent(in) :: f                   !! Gain factor
  real, intent(inout) :: s                !! Cumulative flux
  real, intent(inout) :: compon(nx,ny)    !! Cumulative clean component
  !
  ! Local ---
  integer i
  !
  ! Code ----
  do i=1,ncl
    wcl(i)%value = wcl(i)%influx*f
    s = s+wcl(i)%value
    compon(wcl(i)%ix,wcl(i)%iy) = compon(wcl(i)%ix,wcl(i)%iy) + wcl(i)%value
  enddo
end subroutine scalec
!
subroutine hogbom_cycle90 (rname,pflux, beam,mx,my,resid,nx,ny,               &
     &    ixbeam,iybeam, box, fracres, absres, miter, piter, niter,          &
     &    gainloop, converge, cct_list, start_iter, msk, list, nl, np, primary, weight, wtrun, &
     &    cflux, jcode, next_flux)
  use gkernel_interfaces
  use imager_interfaces, except_this=>hogbom_cycle90
  use clean_def
  use clean_default
  use gbl_message
  use omp_control
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER  -- CLEAN Method HOGBOM  
  !     Deconvolve map into residual map and source list
  !-----------------------------------------------------------------------
  external :: next_flux                         !! Cumulative flux display
  character(len=*), intent(in) :: rname         !! Calling command
  logical, intent(in) :: pflux                  !! Plot cumulative flux ?
  integer, intent(in) :: mx                     !! X size of beam
  integer, intent(in) :: my                     !! Y size of beam
  integer, intent(in) :: nx                     !! X size of image
  integer, intent(in) :: ny                     !! Y size of image
  integer, intent(in) :: np                     !! Number of fields
  real, intent(in) :: beam(mx,my,np)            !! Primary beam(s)
  real, intent(inout) :: resid(nx,ny)           !! residual image
  real, intent(in) :: fracres                   !! Fractional residual
  real, intent(in) :: absres                    !! Absolute residual
  integer, intent(inout) :: miter               !! Maximum number of clean components
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(in) :: gainloop                  !! Clean loop gain
  integer, intent(in) :: converge               !! Convergence iteration number 
  integer, intent(out) :: niter                 !! Resulting number of Iterations
  integer, intent(in) :: piter                  !! Positive Iterations
  logical, intent(in) :: msk(nx,ny)             !! Mask for clean search
  integer, intent(in) :: nl                     !! Size of search list
  integer, intent(in) :: list(nl)               !! Search list
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight(nx,ny)             !! Weight function
  real, intent(in) :: wtrun                     !! Safety threshold on primary beams
  type(cct_lst), intent(inout) :: cct_list      !! Clean Component List
  integer, intent(in) :: start_iter             !! Starting Component Number
  integer, intent(out) :: jcode                 !! Stopping code
  real, intent(out) :: cflux                    !! Cleaned Flux
  !
  ! Local ---
  logical :: ok
  integer :: dimcum
  real, allocatable :: oldcum(:)
  real :: cum, conv, sign
  real :: valmax, valmin, f, vnew, borne, gain
  integer :: i, j, ix, iy, ip, imax, jmax, imin, jmin, k, l
  character(len=message_length) :: chain
  integer, allocatable :: imax_it(:), jmax_it(:)
  real, allocatable :: vnew_it(:)
  integer :: it, ier, nthread, mthread, ithread
  integer :: max_iter ! Maximum number of Clean Components
  !
  ! Code ----
  dimcum = converge
  allocate(oldcum(max(1,dimcum)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    return
  endif
  !
  oldcum = 0.0
  !
  ! Find highest point in region to be searched
  call maxlst (resid,nx,ny,list,nl,valmax,imax,jmax,   &
     &    valmin,imin,jmin)
  write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
    &   'Map max. ',valmax,' at ',imax,jmax,  &
    &   ', Min. ',valmin,' at ',imin,jmin
  call map_message(seve%i,rname,chain)
  !
  ! Subtract +ve and -ve peaks
  niter = 0
  if (niter.lt.piter) then
    vnew = valmax
    ix = imax
    iy = jmax
    sign = 1.0
  elseif (abs(valmin) .gt. abs(valmax)) then
    vnew = valmin
    ix = imin
    iy = jmin
    sign = -1.0
  else
    vnew = valmax
    ix = imax
    iy = jmax
    sign = 1.0
  endif
  !
  ! Setup Subtraction loop
  cum    = 0.
  niter  = 0
  conv   = 0.
  borne = max(absres,fracres*abs(vnew))
  if (np.le.1) then
    gain = gainloop / beam(ixbeam,iybeam,1)
  else
    gain = gainloop
  endif
  !
  ! Main subtraction loop
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !$  if (omp_in_parallel()) then
  !$    if (omp_get_nested()) then
  !$      ! Further optimisation requires to know the number of Outer Threads
  !$      mthread = omp_inner_thread
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' Inner ',omp_inner_thread
  !$    else
  !$      mthread = 1
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' No Inner threads'
  !$    endif
  !$  else
  !$    mthread = omp_inner_thread
  !$    if (omp_get_nested()) then
  !$      if (omp_debug) Print *,'Activating nesting ',omp_get_max_threads(),' possible, used ',mthread
  !$    else
  !$      if (omp_debug) Print *,'No parallel, and No nesting either, ',mthread
  !$    endif
  !$  endif
  allocate(vnew_it(mthread),imax_it(mthread),jmax_it(mthread),stat=ier)
  if (ier.ne.0) then
    write(chain,'(A,I4)') 'Memory allocation error for Mthread ',mthread
    call map_message(seve%e,rname,chain)
    return
  endif
  !
  if (miter.eq.0) then
    max_iter = 2**30  ! A Large  number
  else
    max_iter = miter
  endif
  !
  niter = start_iter-1 ! Could use the cct_list%cur_iter instead.
  ok = niter.lt.max_iter .and. abs(vnew).gt.borne
  !
  ! !Print *,'VNEW at start ',vnew
  do while (ok)
    !
    ! Get the component flux
    niter = niter+1
    f = vnew * gain
    if (np.gt.1) then
      f = f * weight(ix,iy)    ! Convert to Clean component
    endif
    if (niter.gt.cct_list%max_size) then
      ! !Print *,'Re-allocting CCT list  in HOGBOM_CYCLE'
      call cct_list%reallocate()
    endif
    !
    cct_list%cc(niter)%value = f       ! Store as fractions of beam max
    cct_list%cc(niter)%ix = ix
    cct_list%cc(niter)%iy = iy
    cct_list%cc(niter)%size = 0
    cct_list%cur_size = niter          ! That one was missing...
    ! !Print *,'Niter ',niter,cct_list%cc(niter)
    !
    cum = cum + f
    if (dimcum.ne.0) then
      !
      ! Keep last DIMCUM cumulative fluxes to test convergence
      oldcum(mod(niter,dimcum)+1) = cum
      conv = sign * (cum - oldcum(mod(niter+1,dimcum)+1))
    endif
    !
    ! Plot the new point
    if (pflux) call next_flux(niter,cum,0)
    !
    ! Subtract previous component from residual map
    nthread = 1
    !
    ! Parallel programming comment:
    ! Note that the gain is significant only in case of enough primary beams.
    ! It may slow down the method quite significantly otherwise, unless
    ! the number of inner threads has been properly evaluated.
    !
    !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
    !$OMP   &   SHARED(beam,resid,primary,weight,msk) &
    !$OMP   &   SHARED(nx,ny,mx,my,np,box,niter,piter,wtrun) &
    !$OMP   &   SHARED(vnew_it,imax_it,jmax_it) &
    !$OMP   &   SHARED(ixbeam,iybeam,f)  SHARED(ix,iy) &
    !$OMP   &   PRIVATE(j,l,i,k,ip,ithread) SHARED(nthread,omp_debug)
    !
    ithread = 1
    !$  nthread = omp_get_num_threads()
    !$  ithread = omp_get_thread_num()+1
    !$  if (omp_debug.and.niter.eq.1) Print *,'Inner Hogbom Nthread ',nthread,' Ithread ',ithread
    !
    vnew_it(ithread)  = 0
    !$OMP DO SCHEDULE(STATIC,1) 
    !$ ! The type of Scheduling does not seem to affect the timing
    !$ ! significantly.  DYNAMIC may be slightly better.
    do j=1,ny
      !
      ! Proceed Row by Row
      l = j-iy+iybeam
      if (l.ge.1 .and. l.le.my) then
        !
        ! Along that row, subtract clean component if in beam
        do i = 1,nx
          k = i-ix+ixbeam
          if (k.ge.1 .and. k.le.mx) then
            if (np.le.1) then
              resid(i,j) = resid(i,j) - f*beam(k,l,1)
            else
              if (resid(i,j).ne.0) then
                do ip = 1,np
                  !
                  ! Beware of truncating the primary beam.
                  if (primary(ip,i,j).gt.wtrun) then
                    resid(i,j) = resid(i,j) -   &
     &                      f*beam(k,l,ip)*primary(ip,i,j)   &
     &                      *primary(ip,ix,iy)*weight(i,j)
                  endif
                enddo
              endif
            endif
          endif
        enddo
      endif
      !
      ! Find new maximum inside cleaning box in residual map for this row
      if ((j.ge.box(2)).and.(j.le.box(4))) then
        if (niter.lt.piter) then
          ! Force positive components
          do i = box(1), box(3)
            if (msk(i,j)) then
              if (vnew_it(ithread).lt.resid(i,j)) then
                vnew_it(ithread)=resid(i,j)
                imax_it(ithread)=i
                jmax_it(ithread)=j
              endif
            endif
          enddo
        else
          ! Do not force positivity
          do i = box(1), box(3)
            if (msk(i,j)) then
              if (abs(vnew_it(ithread)).lt.abs(resid(i,j))) then
                vnew_it(ithread)=resid(i,j)
                imax_it(ithread)=i
                jmax_it(ithread)=j
              endif
            endif
          enddo
        endif
      endif
      !
      ! Loop for next row
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
    ! Compute VNEW and Position for next iteration
    vnew = vnew_it(1) 
    it = 1
    do i=2,nthread
      if (abs(vnew).lt.abs(vnew_it(i))) then
        it = i
        vnew = vnew_it(i)
      endif
    enddo
    vnew = vnew_it(it)
    ix = imax_it(it)
    iy = jmax_it(it)
    !
    ! !Print *,'Niter ',niter,' < ',max_iter,niter.lt.miter
    ! !Print *,'Converge ',converge, ' > 0',(converge.gt.0)
    ! !Print *,'Vnew = ',vnew,' > Borne = ',borne,abs(vnew).gt.borne
    !
    jcode = 0
    if (sic_ctrlc()) exit
    !
    if (niter.ge.max_iter) then
      jcode = 1
      exit
    endif
    if ((converge.gt.0).and.(conv.le.0)) then
      jcode = 2
      exit
    endif
    if (abs(vnew) .le. borne) then
      jcode = 3
      exit
    endif
  enddo
  !
  cflux = cum
  deallocate(vnew_it,imax_it,jmax_it,stat=ier)
end subroutine hogbom_cycle90

subroutine uv_trim_comm(line,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_trim_comm
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for command  
  !     UV_TRIM [Action] [/FILE File [FileOUT] 
  !
  ! Trim the current UV data or specified UV table for Trailing
  ! columns (Action = TRAIL) or flagged for all channels (Action = DATA),
  ! or flagged for any channel (Action = ANY) .
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_file=1
  character(len=*), parameter :: rname='UV_TRIM'
  integer, parameter :: mvoc=3
  character(len=8), parameter :: vocab(mvoc) = ['ANY     ','DATA    ', 'TRAIL   ']
  !
  ! Local ---
  character(len=filename_length) :: uvdata,uvtrim,original
  character(len=8) :: code
  integer :: wcol, ier, n
  logical :: in_place
  integer :: ikey
  character(len=8) :: argum, key
  !
  if (.not.sic_present(o_file,0)) then
    call map_message(seve%e,rname,'Trimming current UV data not yet implemented')
    error = .true.
    return
  endif
  !
  argum = 'DATA'
  call sic_ke(line,0,1,argum,n,.false.,error)
  call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
  if (error) return
  !
  code = key
  select case(key)
  case ('DATA')
    wcol = 0
  case ('ANY')
    wcol = -1
    code = 'DATA'
  end select
  !
  ! Find out the Input and Output files
  call sic_ch(line,o_file,1,uvdata,n,.true.,error)
  if (error) return
  !
  in_place = .not.sic_present(o_file,2)
  if (in_place) then
    uvtrim = uvdata
    call sic_parse_file(uvtrim,' ','.uvt',original)
    uvtrim = "tmp_"//uvtrim
  else
    call sic_ch(line,o_file,2,uvtrim,n,.false.,error)
  endif
  if (error) return
  !
  ! Do the job
  call uv_trim_sub(uvdata, uvtrim, code, wcol, error)
  if (error) return
  !
  ! Move temporary file to its final destination
  if (in_place) then
    n = len_trim(uvtrim)
    if (uvtrim(n-3:n).ne.".uvt") then
      ier = gag_filrename(trim(uvtrim)//".uvt",original)
    else
      ier = gag_filrename(trim(uvtrim),original)
    endif
  endif
end subroutine uv_trim_comm
!
subroutine uv_trim_sub (cuvin, cuvou, code, wcol, error)
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_trim_sub
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Support for command UV_TRIM 
  !
  !   Trim a UV table: remove the flagged data *or* trim trailing columns
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cuvin   !! Input UV table name
  character(len=*), intent(in) :: cuvou   !! Output UV table name
  character(len=*), intent(in) :: code    !! Operation code
  integer, intent(in) :: wcol             !! Weight column
  logical, intent(out) :: error           !! Logical error flag
  !
  character(len=*), parameter :: rname='UV_TRIM'
  !
  ! Local ---
  character(len=80)  :: mess
  type (gildas) :: uvin
  type (gildas) :: uvou
  integer :: ier, nblock, ib, invisi, ouvisi
  integer(index_length) :: mvis
  !
  ! Code ----
  ! Simple checks
  select case (code)
  case ('DATA','TRAIL')
    continue
  case default
    error =.true.
    call map_message(seve%e,rname,'Invalid code '//code)
    return
  end select
  !
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  !
  ! Here modify the header of the output UV table according
  ! to the desired goal
  !
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  if (code.eq.'TRAIL') then
    uvou%gil%ntrail = 0
    do ib=1,code_uvt_last
      if (uvou%gil%column_pointer(ib).gt.uvin%gil%fcol) then
        uvou%gil%column_pointer(ib) =  0
        uvou%gil%column_size(ib) = 0
      endif
    enddo
    uvou%gil%dim(1) = uvou%gil%lcol
    call gdf_setuv(uvou,error)
  endif
  !
  ! Define blocking factor, on largest data file
  nblock = space_nitems('SPACE_GILDAS',uvin,1)
  ! Allocate respective space for each file if needed
  if (code.eq.'TRAIL') then
    allocate (uvin%r2d(uvin%gil%dim(1),nblock), uvou%r2d(uvou%gil%dim(1),nblock), stat=ier)
  else
    allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  endif
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! create the image with smallest possible size
  uvou%gil%dim(2) = nblock
  uvou%gil%nvisi = 0
  call gdf_create_image(uvou,error)
  if (error) return
  !
  ! Loop over line table 
  uvin%blc = 0
  uvin%trc = 0
  uvou%blc = 0
  uvou%trc = 0
  uvou%blc(2) = 1  ! Get started
  !
  if (code.eq.'DATA') then
    do ib = 1,uvin%gil%nvisi,nblock
      write(mess,'(A,I0,A,I12,I12)') 'Reading ',ib,' / ',uvin%gil%nvisi,nblock
      call map_message(seve%i,rname,mess)
      uvin%blc(2) = ib
      uvin%trc(2) = min(uvin%gil%nvisi,ib-1+nblock)
      invisi = uvin%trc(2)-uvin%blc(2)+1
      call gdf_read_data(uvin,uvin%r2d,error)
      !
      call uv_trim_flag(uvin, invisi, uvou, ouvisi, wcol, error)
      if (error) return
      !
      if (ouvisi.gt.0) then
        uvou%trc(2) = uvou%blc(2)+ouvisi-1
        mvis = uvou%trc(2)
        !
        if (mvis.gt.uvou%gil%dim(2)) then
          write(mess,'(A,I0,A,I0)') 'Extending from ',uvou%gil%dim(2), ' to  ',mvis
          call map_message(seve%i,rname,mess)
          call gdf_close_image(uvou,error)
          call gdf_extend_image (uvou,mvis,error)
        endif
        call gdf_write_data (uvou,uvin%r2d,error)
        if (error) return
        uvou%blc(2) = uvou%trc(2)+1
      endif
    enddo
  else if (code.eq.'TRAIL') then
    do ib = 1,uvin%gil%nvisi,nblock
      write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
      call map_message(seve%d,rname,mess)
      uvin%blc(2) = ib
      uvin%trc(2) = min(uvin%gil%nvisi,ib-1+nblock)
      invisi = uvin%trc(2)-uvin%blc(2)+1
      call gdf_read_data(uvin,uvin%r2d,error)
      !
      ouvisi = invisi
      !
      if (ouvisi.gt.0) then
        uvou%r2d(:,1:invisi) = uvin%r2d(1:uvin%gil%lcol,1:invisi)
        uvou%trc(2) = uvou%blc(2)+ouvisi-1
        mvis = uvou%trc(2)
        !
        if (mvis.gt.uvou%gil%dim(2)) then
          Print *,'Extending from ',uvou%gil%dim(2), ' to  ',mvis
          call gdf_close_image(uvou,error)
          call gdf_extend_image (uvou,mvis,error)
        endif
        call gdf_write_data (uvou,uvou%r2d,error)
        if (error) return
        uvou%blc(2) = uvou%trc(2)+1
      endif
    enddo
  endif
  !
  ! Finalize the image
  uvou%gil%nvisi = uvou%trc(2)
  uvou%gil%dim(2) = uvou%trc(2)
  call gdf_update_header(uvou,error)
  if (error) return
  call gdf_close_image(uvou,error)
  if (error) return
  !
  call gdf_close_image(uvin,error)
end subroutine uv_trim_sub
!
subroutine uv_trim_flag(in,invis,out,outvis,wcol,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_TRIM
  !
  !       Trim an input UV table: get rid off all flagged visibilities
  !
  ! WCOL < 0    Trim if any channel is flagged  
  ! WCOL = 0    Trim if all channels are flagged  
  ! WCOL > 0    Trim if that channel is flagged  
  !!
  !----------------------------------------------------------------------
  type (gildas), intent(inout) :: in    !! Input UV header 
  !! Data area is in its %r2d pointer for re-use
  type (gildas), intent(inout) :: out   !! Output UV header
  integer, intent(in) :: invis          !! Number of input visibilities
  integer, intent(out) :: outvis        !! Number of output visibilities
  integer, intent(in) :: wcol           !! Weight column
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Local variables:
  integer(kind=index_length), allocatable :: ivis(:)
  integer :: ier, np, nclow, ncup, ic
  integer :: iv, im, mv
  logical :: trim_any
  !
  np = in%gil%dim(1)
  if (wcol.lt.0) then
    nclow = 1
    ncup = in%gil%nchan
    trim_any = .true.
  else if (wcol.eq.0) then
    nclow = (in%gil%nchan+2)/3
    ncup = nclow
    trim_any = .false.
  else
    ncup = min(wcol,in%gil%nchan)
    nclow = ncup
    trim_any = .false.
  endif
  allocate(ivis(invis),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ! First passs to identifiy all valid visibilities
  mv = 0
  if (trim_any) then
    do iv = 1,invis
      ! If a single channel is Bad, flag data
      im = 1
      do ic=nclow,ncup
        if (in%r2d(in%gil%fcol-1+3*ic,iv).le.0) then
          im = 0
          exit
        endif
      enddo
      if (im.ne.0) then
        mv = mv+1
        ivis(mv) = iv
      endif
    enddo
  else
    do iv = 1,invis
      ! If a single channel is Good, use data
      im = 0
      do ic=nclow,ncup
        if (in%r2d(in%gil%fcol-1+3*ic,iv).gt.0) then
          im = 1
          exit
        endif
      enddo
      if (im.ne.0) then
        mv = mv+1
        ivis(mv) = iv
      endif
    enddo
  endif
  !
  ! Second pass to keep the good visibilities only
  ! Memory saved by working in place, as the visibilities are ordered.
  do iv = 1,mv
    if (ivis(iv).gt.iv) in%r2d(:,iv) = in%r2d(:,ivis(iv))
  enddo
  outvis = mv
  deallocate(ivis)
  !
end subroutine uv_trim_flag

subroutine v_size_r4_2(name,array,nn,err)
  use imager_interfaces, only : map_message
  use gbl_message
  ! @ public-mandatory
  character(len=*) :: name
  real, intent(in) :: array(:,:)
  integer, intent(in) :: nn(2)
  logical, intent(inout) :: err
  !
  integer i
  character(len=120) :: mess
  !
  write(mess,*) name//' expected ',nn,' Got ',ubound(array)
  call map_message(seve%d,'SIZECHECK',mess)
  do i=1,2
    if (ubound(array,i).ne.nn(i)) then
      err =.true.
      Print *,name//' 2 size error ',i,' got ',ubound(array,i),' expected ',nn(i)
    endif
  enddo
end subroutine v_size_r4_2
subroutine v_size_l4_2(name,array,nn,err)
  use imager_interfaces, only : map_message
  use gbl_message
  ! @ public-mandatory
  character(len=*) :: name
  logical, intent(in) :: array(:,:)
  integer, intent(in) :: nn(2)
  logical, intent(inout) :: err
  !
  integer i
  character(len=120) :: mess
  !
  write(mess,*) name//' expected ',nn,' Got ',ubound(array)
  call map_message(seve%d,'SIZECHECK',mess)
  do i=1,2
    if (ubound(array,i).ne.nn(i)) then
      err =.true.
      Print *,name//' 2 size error ',i,' got ',ubound(array,i),' expected ',nn(i)
    endif
  enddo
end subroutine v_size_l4_2
subroutine v_size_r4_3(name,array,nn,err)
  use imager_interfaces, only : map_message
  use gbl_message
  ! @ public-mandatory
  character(len=*) :: name
  real, intent(in) :: array(:,:,:)
  integer, intent(in) :: nn(3)
  logical, intent(inout) :: err
  !
  integer i
  !
  character(len=120) :: mess
  !
  write(mess,*) name//' expected ',nn,' Got ',ubound(array)
  call map_message(seve%d,'SIZECHECK',mess)
  do i=1,3
    if (ubound(array,i).ne.nn(i)) then
      err =.true.
      Print *,name//' 3 size error ',i,' got ',ubound(array,i),' expected ',nn(i)
    endif
  enddo
end subroutine v_size_r4_3
  !
subroutine major_multi90 (rname,method,head,   &
     &    beam,nx,ny,mx,my,            &
     &    dirty,resid,mask,clean,      &
     &    cct_list,siter,miter,limit,niter, &
     &    smask, sresid, trans, cdata, sbeam, &
     &    tfbeam, wfft, mcct, nker, kernel, &
     &    np, primary, weight)    ! For mosaics
  use gbl_ansicodes
  use imager_interfaces, except_this=>major_multi90
  use gkernel_interfaces
  use image_def
  use gbl_message
  use clean_def
  use clean_default
  use omp_control
  !$  use omp_lib
  !-----------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER -- CLEAN Method MULTISCALE  
  !     Multi-Resolution CLEAN - with NS (parameter) scales
  !
  !     Algorithm  
  !     For each iteration, search at which scale the signal to noise
  !     is largest. Use the strongest S/N to determine the "component"
  !     intensity and shape at this iteration.
  !
  !     Restore the ("infinite" resolution) image from the list of location
  !     types, and intensities of the "components"
  !
  !     The noise level at each scale is computed from the Fourier transform
  !     of the smoothed dirty beams, since the FT is the weight distribution
  !     and the noise level is the inverse square root of the sum of the
  !     weights.
  !!
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller name
  type(clean_par), intent(inout) :: method  !! Clean method
  type(gildas), intent(inout) :: head       !! Unused, but here for consistency...
  real, intent(in)  :: beam(:,:,:)          !! Dirty beams
  integer, intent(in)  :: nx,ny             !! Beam sizes
  integer, intent(in)  :: mx,my             !! Image size
  integer, intent(in) :: np                 !! Number of Pointings
  integer, intent(in)  :: siter             !! Starting Iteration
  integer, intent(in)  :: miter             !! Maximum number of clean components
  integer, intent(out) :: niter             !! Number of found components
  real, intent(in)  :: dirty(:,:)           !! Dirty image
  real, intent(inout) :: resid(:,:)         !! Residual image (initialized to Dirty image)
  real, intent(inout) :: clean(:,:)         !! "CLEAN" image (not convolved yet)
  real, intent(in) :: weight(:,:)           !! Combined weights
  logical, intent(in)  :: mask(:,:)         !! Search area
  real, intent(in)  :: limit                !! Maximum residual
  real, intent(in)  :: tfbeam(:,:,:)        !! Real Beam FT. for final Clean restoration
  real, intent(inout) :: wfft(*)            !! Work space for FFT
  type(cct_lst), intent(inout) :: cct_list  !! Clean Component List
  integer, intent(out) :: nker(:)           !! Kernel sizes
  real, intent(out) :: kernel(:,:,:)        !! Smoothing kernel values
  real, intent(in) :: primary(np, mx, my)   !! Primary beams
  integer, intent(out) :: mcct              !! Number of separate Clean components
  real, intent(inout) ::  sbeam(:,:,:)      !! Smoothed beams workspace
  real, intent(inout) ::  sresid(:,:)       !! Smoothed residuals workspace
  real, intent(inout) ::  trans(:,:)        !! Translated beam workspace
  complex, intent(inout) ::  cdata(:,:)     !! Work array
  logical, intent(inout) ::  smask(:,:)     !! Smoothed mask workspace
  !
  ! Constants
  integer, parameter :: ms=3
  integer, parameter :: mk=11
  !
  ! Local ---
  integer :: dimcum, ncum, nchain
  integer :: nn(2), ndim, kx,ky
  integer :: is,i,j, oldis, goodis
  real, allocatable :: oldcum(:)
  real :: value, converge, sign, lastcum
  real :: maxa,flux,smooth,gain,maxsn,worry
  logical :: ok, plot, printout, interrupt
  character(len=message_length) :: chain
  character(len=24) :: string
  !
  ! Kernel related ones
  integer  :: ns                  ! Number of Kernels
  integer :: max_nker             ! Last kernel used
  real :: scale(ms)               ! Noise level for each beam - in ReadOnly
  real :: sn(ms)                  ! Signal / Noise - used in ReadOnly
  real :: gains(ms)               ! Gain per kernel 
  real :: fluxes(ms)              ! Cumulative flux per kernel
  real :: loss(ms)                ! Noise degradation factor...
  !
  integer :: ncase(ms)            ! Number of components per kernel case
  real :: bruit(ms)               ! Residual level for each kernel
  integer :: ix(ms),iy(ms)        ! Coordinates of each iteration maximum
  !
  integer :: nf                   ! Number of frequency planes (=1)
  integer :: ip                   ! Current pointing
  integer :: ic,nc                ! Current component and Number of components
  integer :: lx,ly                ! Current pixel and Offset from center
  real :: kcct(3,1,mk**2)         ! "Bulk" component decomposition
  real :: maxp                    ! Current Clean value
  integer :: counter
  integer :: clean_slow=0         ! Precision and Speed control code (for tests)
  integer :: step_iter            ! Printout every Step_Iter component
  logical :: error, detail
  logical :: debug=.false.
  logical :: err
  integer :: nnt(3)
  !
  integer :: fs,ls, ncount, mthread
  !
  ! Code ---
  !
  ! Verify array sizes
  nnt = [mx,my,1]
  err = .false.
  call v_size_r4_2('DIRTY',dirty,nnt,err)
  call v_size_r4_2('RESID',resid,nnt,err)
  call v_size_r4_2('CLEAN',clean,nnt,err)
  call v_size_r4_3('TFBEAM',tfbeam,nnt,err)
  call v_size_r4_2('SRESID',sresid,nnt,err)
  if (np.gt.1) call v_size_r4_2('WEIGHT',weight,nnt,err)
  call v_size_r4_2('TRANS',trans,nnt,err)
  call v_size_l4_2('SMASK',smask,nnt,err)
  nnt = [nx,ny,np]
  call v_size_r4_3('BEAM',beam,nnt,err)
  nnt = [nx,ny,3]
  call v_size_r4_3('SBEAM',sbeam,nnt,err)
  if (err) then
    call map_message(seve%e,rname,'Size error')
    error = .true.
    return
  endif
  !
  step_iter = multi_print
  if (multi_print.eq.0) step_iter = 1000
  !
  call sic_get_logi('DEBUG',debug,error)
  error = .false.
  call sic_get_inte('CLEAN_SLOW',clean_slow,error)
  clean_slow = min(clean_slow,3)
  if (clean_slow.lt.0) then
    call map_message(seve%w,rname,'Using approximate MultiScale method - Try CLEAN_SLOW = 0 for better result')
  else if (clean_slow.ne.0) then
    call map_message(seve%w,rname,"Speed set to CLEAN_SLOW "//char(clean_slow+ichar('0')))
  endif
  !
  dimcum = method%converge
  allocate(oldcum(max(1,dimcum)))
  !
  smooth = method%smooth
  gain = method%gain
  plot = method%pflux
  nker = method%nker
  printout = method%verbose  .or. debug ! Default behaviour
  gains = method%gains(1:ms)
  worry = method%worry
  !
  ! Initialize the kernel
  interrupt = .false.
  kernel = 0.0
  ns = 1
  nker(1) = 1
  kernel = 0.0
  kernel(1,1,1) = 1.0
  !
  nker = method%nker
  if (nker(2).gt.0) then
    call init_kernel(kernel(:,:,2),mk,nker(2),smooth)
    ns = 2
    if (nker(3).gt.0) then
      smooth = smooth**2
      call init_kernel(kernel(:,:,3),mk,nker(3),smooth)
      ns = 3
    endif
  endif
  max_nker = ns
  ncase(1:ms) = 0
  fluxes(:) = 0.0
  trans(:,:) = 0.0
  !
  ! Initialize smoothed beams & mask
  call smooth_mask (mask,smask,mx,my,nker(ns))
  !
  kx = nx/2+1
  ky = ny/2+1
  ! 
  ! Build an average dirty beam for mosaics
  sbeam(:,:,1) = beam(:,:,1)
  do ip=2,np
    sbeam(:,:,1) = sbeam(:,:,1) + beam(:,:,ip)
  enddo
  if (np.ne.1) sbeam(:,:,1) = sbeam(:,:,1)/np
  !
  ! Get the scale factors and sensitivity loss
  loss(1)  = 1.0
  scale(1) = 1.0
  ! 
  ! Use the average dirty beams to estimate these factors
  do is = 2,ns
    call smooth_kernel (sbeam(:,:,1),sbeam(:,:,is),nx,ny,mk,nker(is),kernel(:,:,is))
    value = 1.0/sbeam(kx,ky,is)
    loss(is) = sqrt(value)
    scale(is) = value
    sbeam(:,:,is) = sbeam(:,:,is)*value      ! Now normalized
    kernel(:,:,is) = kernel(:,:,is)*value    ! Corresponding Kernel
  enddo
  !
  write(chain,'(2(A,3(1X,F5.3)))') 'Scales ',scale,'; Noise loss ',loss
  call map_message(seve%i,rname,chain)
  !
  ! Main clean loop
  niter = siter-1      ! Start at siter
  ok = niter.lt.miter
  flux = 0.0
  !
  ! Initialize convergence test
  call amaxmask (resid,mask,mx,my,ix(1),iy(1))
  if (resid(ix(1),iy(1)).gt.0.0) then
    sign = 1.0
  else
    sign =-1.0
  endif
  ncum = 1
  converge = 0.0
  oldcum = 0.0
  oldis = 0
  goodis = 1   ! To prevent compiler warning only..
  maxsn = 0    ! Also
  sn =    0 ! Make sure they are all initialized
  !
  counter = 0
  ncount = 0
  if (clean_slow.lt.0) then
    ncount = -clean_slow ! Test
    clean_slow = -2
  endif
  !
  detail = .false.    ! Debug test message
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !$  if (omp_in_parallel()) then
  !$    if (omp_get_nested()) then
  !$      ! Further optimisation requires to know the number of Outer Threads
  !$      mthread = omp_inner_thread
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' Inner ',omp_inner_thread
  !$    else
  !$      mthread = 1
  !$      if (omp_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' No Inner threads'
  !$    endif
  !$  else
  !$    mthread = omp_inner_thread
  !$    if (omp_get_nested()) then
  !$      if (omp_debug) Print *,'Activating nesting ',omp_get_max_threads(),' possible, used ',mthread
  !$    else
  !$      if (omp_debug) Print *,'No parallel, and No nesting either, ',mthread
  !$    endif
  !$  endif
  !
  do           ! For ever...
    if (ncount.eq.0) then
      fs = 1
      ls = ns
    else if (mod(counter,ncount).eq.0) then
      fs = 1
      ls = max_nker
      oldis = 0 ! Ensure printout can happen
    else
      fs = oldis
      ls = oldis
    endif
    counter = counter+1
    !
    ! Locate the Clean Component - The Smoothed Beams do not intervene here,
    ! only the Normalized Kernel and Smoothed Mask
    maxa = -1.0
    do is = fs,ls
      if (is.eq.1) then
        call amaxmask (resid,mask,mx,my,ix(1),iy(1))
        bruit(1) = resid(ix(1),iy(1))
      else
        !
        ! Smooth within (smoothed) mask
        call smooth_masked(mx,my,sresid,resid,smask,mk,nker(is),kernel(:,:,is))
        !
        ! Use MASK or SMASK, more or less at will...
        call amaxmask (sresid,mask,mx,my,ix(is),iy(is))
        bruit(is) = sresid(ix(is),iy(is))
      endif
      !
      if (debug) print *,is, 'Bruit ',bruit(is),' Loss ',loss(is)
      sn(is) = abs(bruit(is)/loss(is))
      if (sn(is).gt.maxa) then
        maxa = sn(is)
        goodis = is
      endif
    enddo
    !
    if (debug) then
      Print *,'Good ',goodis,'Bruit ',bruit,' Loss ',loss,' S/N ',sn  !Debug
      if (counter.lt.10) then
        is = goodis
        Print *,Counter,is,' IX IY ',ix(is),iy(is),' Resid ',sresid(ix(is),iy(is)),bruit(is) !Debug
      endif
    endif
    !
    if (niter.lt.siter) then
      maxsn = sn(goodis)
    endif
    !
    ! Check criterium
    ok = niter.lt.miter
    ok = ok .and. abs(bruit(1)).ge.limit
    if (.not.ok) exit
    if (sn(goodis).gt.maxsn) then
      if (niter.gt.2) then
        ok = .false.  ! Stop if S/N has degraded
        exit
      else
        maxsn = sn(goodis)
      endif
    endif
    maxsn = worry*sn(goodis)+(1.0-worry)*maxsn  ! Propagate S/N estimate
    if (debug) Print *,'Counter ',counter,' Maxsn ',maxsn,goodis,sn(goodis)
    !
    niter = niter+1
    if (niter.ge.cct_list%max_size) call cct_list%reallocate()
    !
    value = gains(goodis)*bruit(goodis)
    if (np.gt.1) then
      value = value * weight(ix(goodis),iy(goodis))    ! Convert to Clean component
    endif
    cct_list%cc(niter)%value = value*scale(goodis)     ! Scale the flux  
    cct_list%cc(niter)%ix = ix(goodis)
    cct_list%cc(niter)%iy = iy(goodis)
    cct_list%cc(niter)%size = -goodis   ! Kernel number
    cct_list%cur_size = niter
    !
    ! Do not Scale component flux : See Note Later (#1)
    flux = flux + value*scale(goodis)
    !
    ! Check flux stability - Switch to the accurate method when
    ! approaching convergence 
    if (dimcum.ne.0) then
      ! Keep last DIMCUM cumulative fluxes to test convergence
      oldcum(mod(niter,dimcum)+1) = flux
      lastcum = oldcum(mod(niter+1,dimcum)+1)
      converge = sign * (flux - lastcum) 
      if (clean_slow.lt.0) then
        if (abs((flux-lastcum)/flux).lt.0.05) then
          clean_slow = 0
          call map_message(seve%i,rname,'Switching to precise mode') 
          max_nker = 1
          oldis = 0
        endif
      endif 
    endif
    !
    ! Plot the new point
    ! detail = weight(ix(goodis),iy(goodis)).gt.2 ! Test
    if ((printout.and.(goodis.ne.oldis)).or.(mod(niter,step_iter).eq.0)) then
      if (goodis.eq.1) then
        write(chain,101) niter,ix(goodis),iy(goodis),   &
     &            c_red,sn(1),c_clear,sn(2),sn(3),bruit(goodis)*loss(goodis) &
     &            ,weight(ix(goodis),iy(goodis))
      elseif (goodis.eq.2) then
        write(chain,102) niter,ix(goodis),iy(goodis),   &
     &            sn(1),c_green,sn(2),c_clear,sn(3),bruit(goodis)*loss(goodis) &
     &            ,weight(ix(goodis),iy(goodis))
      elseif (goodis.eq.3) then
        write(chain,103) niter,ix(goodis),iy(goodis),   &
     &            sn(1),sn(2),c_blue,sn(3),c_clear,bruit(goodis)*loss(goodis) &
     &            ,weight(ix(goodis),iy(goodis))
      endif
      call map_message(seve%i,rname,chain)
    endif
    ! In all cases
    oldis = goodis
    ncase(goodis) = ncase(goodis)+1
    ! Scale cumulative flux : See Note Later
    fluxes(goodis) = fluxes(goodis) + value*scale(goodis)
    if (plot) then
      is = goodis
      call next_flux90(niter,flux,is)
    endif
    !
    ! Subtract from residual
    !
    maxa = -value  ! This is the Clean Component to be subtracted #1
    !
    ! Pixel offset in small beam (not in large map)
    kx = ix(goodis)-nx/2-1 
    ky = iy(goodis)-ny/2-1
    lx = ix(goodis)
    ly = iy(goodis)
    !
    if (np.eq.1) then
      !
      ! Translate appropriate beam
      !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
      !$OMP   &   SHARED(resid,sbeam)  &
      !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxa,goodis) &
      !$OMP   &   PRIVATE(i,j)
      !$OMP DO COLLAPSE(2)
      do j=max(1,ky+1),min(my,ny+ky)
        do i=max(1,kx+1),min(mx,nx+kx)
          resid(i,j) = resid(i,j) + maxa * sbeam(i-kx,j-ky,goodis)
        enddo
      enddo
      !$OMP ENDDO
      !$OMP END PARALLEL
    else
      if (clean_slow.ge.0) then
        !
        ! The accurate approach is to expand the Clean Component
        ! by the kernel, attenuate each new component by the
        ! primary beam, and subtract the list of Clean Components
        ! using the un-smoothed dirty beam
        !
        nf = 1 ! Only one frequency
        nc = 0 ! No previous component in, many out
        if (nker(goodis).eq.0) then
          nc = 1
          kcct(1,1,1) = lx !! ix(goodis)
          kcct(2,1,1) = ly !! iy(goodis)
          kcct(3,1,1) = maxa 
        else
          ! Use Large Region
          call spread_kernel (mx,my,nf,nc,kcct,maxa,lx,ly, &
            &   nker(goodis),kernel(:,:,goodis))
        endif
        ! !Print *,'LX LY ',lx,ly, 'MX MY ',mx,my,nker(goodis)
        ! !Print *,'NC out ',nc,goodis,maxa
        !
        ! The following sections are memory access limited
        ! Parallelism is inefficient there.
        select case(clean_slow)
        case(0)
          ! Fastest way ...
          do ip=1,np
            !
            if (nc.eq.1) then
              lx = kcct(1,1,1)
              ly = kcct(2,1,1)
              kx = lx-nx/2-1
              ky = ly-ny/2-1
              ! 
              ! Attenuate by primary beam 
              maxp = kcct(3,1,1) * primary(ip,lx,ly)
              ! Translate the original dirty beam
              !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
              !$OMP   &   SHARED(resid,beam,primary,weight) &
              !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp) &
              !$OMP   &   PRIVATE(i,j)
              !$OMP DO COLLAPSE(2)
              do j=max(1,ky+1),min(my,ny+ky)
                do i=max(1,kx+1),min(mx,nx+kx)
                  resid(i,j) = resid(i,j) + & 
                  & maxp*beam(i-kx,j-ky,ip)*primary(ip,i,j)*weight(i,j)
                enddo
              enddo
              !$OMP ENDDO
              !$OMP END PARALLEL
              !
            else
              trans = 0.
              ! Translate the original dirty beam for each component
              do ic=1,nc
                lx = kcct(1,1,ic)
                ly = kcct(2,1,ic)
                kx = lx-nx/2-1
                ky = ly-ny/2-1
                ! Attenuate by primary beam 
                maxp = kcct(3,1,ic) * primary(ip,lx,ly)
                !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
                !$OMP   &   SHARED(trans,beam) &
                !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp) &
                !$OMP   &   PRIVATE(i,j)
                !$OMP DO COLLAPSE(2)
                do j=max(1,ky+1),min(my,ny+ky)
                  do i=max(1,kx+1),min(mx,nx+kx)
                    trans(i,j) = trans(i,j) + beam(i-kx,j-ky,ip)*maxp
                  enddo
                enddo
                !$OMP ENDDO
                !$OMP END PARALLEL
              enddo
              ! 
              ! Remove from residual
              !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
              !$OMP   &   SHARED(resid,trans,primary,weight) &
              !$OMP   &   SHARED(mx,my,ip) PRIVATE(i,j)
              !$OMP DO COLLAPSE(2)
              do j=1,my
                do i=1,mx
                  resid(i,j) = resid(i,j) + & 
                  & trans(i,j)*primary(ip,i,j)*weight(i,j)
                enddo
              enddo
              !$OMP ENDDO
              !$OMP END PARALLEL
            endif
          enddo
          !
        case(1)
          ! Slightly slower (ratio depends on number of point sources)
          do ip=1,np
            trans = 0.
            ! Translate the original dirty beam for each component
            do ic=1,nc
              lx = kcct(1,1,ic)
              ly = kcct(2,1,ic)
              kx = lx-nx/2-1
              ky = ly-ny/2-1
              if (detail) Print *,IP,'IC ',IC,' KCCT ',KCCT(1:3,1,IC)
              ! Attenuate by primary beam 
              maxp = kcct(3,1,ic) * primary(ip,lx,ly)
              !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
              !$OMP   &   SHARED(trans,beam) &
              !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp) &
              !$OMP   &   PRIVATE(i,j)
              !$OMP DO COLLAPSE(2)
              do j=max(1,ky+1),min(my,ny+ky)
                do i=max(1,kx+1),min(mx,nx+kx)
                  trans(i,j) = trans(i,j) + beam(i-kx,j-ky,ip)*maxp
                enddo
              enddo
              !$OMP ENDDO
              !$OMP END PARALLEL
            enddo
            ! 
            ! Remove from residual
            !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
            !$OMP   &   SHARED(trans,resid,primary,weight) &
            !$OMP   &   SHARED(mx,my,ip) PRIVATE(i,j)
            !$OMP DO COLLAPSE(2)
            do j=1,my
              do i=1,mx
                resid(i,j) = resid(i,j) + & 
                & trans(i,j)*primary(ip,i,j)*weight(i,j)
              enddo
            enddo
            !$OMP ENDDO
            !$OMP END PARALLEL
          enddo
        case(2)
          ! Slower
          do ic=1,nc
            lx = kcct(1,1,ic)
            ly = kcct(2,1,ic)
            kx = lx-nx/2-1
            ky = ly-ny/2-1
            do ip=1,np
              ! 
              ! Attenuate by primary beam 
              maxp = kcct(3,1,ic) * primary(ip,lx,ly)
              ! Translate the original dirty beam
              do j=max(1,ky+1),min(my,ny+ky)
                do i=max(1,kx+1),min(mx,nx+kx)
                  resid(i,j) = resid(i,j) + & 
                  & maxp*beam(i-kx,j-ky,ip)*primary(ip,i,j)*weight(i,j)
                enddo
              enddo
              ! 
            enddo
          enddo
          !        
        case (3)
          ! Really slow
          do ic=1,nc
            lx = kcct(1,1,ic)
            ly = kcct(2,1,ic)
            kx = lx-nx/2-1
            ky = ly-ny/2-1
            do ip=1,np
              trans = 0. !
              ! Translate the original dirty beam
              do j=max(1,ky+1),min(my,ny+ky)
                do i=max(1,kx+1),min(mx,nx+kx)
                  trans(i,j) = beam(i-kx,j-ky,ip) 
                enddo
              enddo
              ! 
              ! Attenuate by primary beam 
              maxp = kcct(3,1,ic) * primary(ip,lx,ly)
              ! 
              do j=1,my
                do i=1,mx
                  resid(i,j) = resid(i,j) + & 
                  & maxp*trans(i,j)*primary(ip,i,j)*weight(i,j)
                enddo
              enddo
            enddo
          enddo
          !
        end select
      else ! if (clean_slow.lt.0) then 
        !
        ! This code is incorrect for two reasons.
        !
        ! 1) Fundamental
        !   A smooth beam per pointing would not represent the properly attenuated
        !   Clean component list.
        !     It would only be an approximate solution, but which could work
        !   in a Minor / Major cycle, where the faster, but approximate
        !   solution is used in Minor Cycles, but the accurate version
        !   is used in Major Cycles by Fourier Transform.
        ! 2) Circumstancial (due to lazyness)
        !   We do not have a smoothed beam per pointing, but only one 
        !   so far.
        !
        ! Yet, it works surprisingly well by a combination of several reasons
        ! 1)  The code is correct for point sources
        ! 2)  The approximation is limited for Extended sources near a
        !     pointing center
        ! 3)  Dirty beams are reasonably similar from pointing to pointing
        !     so Smoothed beams too.
        ! 4)  The deconvolution method is self-correcting: improperly
        !     removed components are corrected later by components at
        !     a different scale ...
        ! 
        select case(clean_slow)
        !
        case (-2)
          ! Most efficient
          do ip=1,np
            ! 
            ! Globally attenuate by primary beam -- There is an issue here
            ! since normally each individual Clean Component should
            ! have a different attenuation
            !
            maxp = maxa * primary(ip,lx,ly)
            ! 
            !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
            !$OMP   &   SHARED(resid,sbeam,primary,weight) &
            !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp,goodis) &
            !$OMP   &   PRIVATE(i,j)
            !$OMP DO COLLAPSE(2)
            do j=max(1,ky+1),min(my,ny+ky)
              do i=max(1,kx+1),min(mx,nx+kx)
                resid(i,j) = resid(i,j) + & 
                & maxp*sbeam(i-kx,j-ky,goodis)*primary(ip,i,j)*weight(i,j)
              enddo
            enddo
            !$OMP ENDDO
            !$OMP END PARALLEL
          enddo
          !
        case (-1)
          ! Slightly slower
          do ip=1,np
            trans = 0. !
            ! Translate the appropriate smoothed dirty beam
            !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
            !$OMP   &   SHARED(trans,sbeam) &
            !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,goodis) &
            !$OMP   &   PRIVATE(i,j)
            !$OMP DO COLLAPSE(2)
            do j=max(1,ky+1),min(my,ny+ky)
              do i=max(1,kx+1),min(mx,nx+kx)
                trans(i,j) = sbeam(i-kx,j-ky,goodis) ! WRONG, should be IP dependent (one per pointing)
              enddo
            enddo
            !$OMP ENDDO
            !$OMP END PARALLEL
            ! 
            ! Globally attenuate by primary beam -- There is an issue here
            ! since normally each individual Clean Component should
            ! have a different attenuation
            !
            maxp = maxa * primary(ip,lx,ly)
            ! 
            !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
            !$OMP   &   SHARED(resid,trans,primary,weight) &
            !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp) &
            !$OMP   &   PRIVATE(i,j)
            !$OMP DO COLLAPSE(2)
            do j=1,my
              do i=1,mx
                resid(i,j) = resid(i,j) + & 
                & maxp*trans(i,j)*primary(ip,i,j)*weight(i,j)
              enddo
            enddo
            !$OMP ENDDO
            !$OMP END PARALLEL
          enddo
          !
        end select
      endif
    endif
!
    if (dimcum.gt.0) ok = ok.and.(converge.ge.0.0)
    if (.not.ok) exit
    if (sic_ctrlc()) then
      interrupt = .true.
      exit
    endif
  enddo
  !
  if (niter.eq.miter) then
    string = 'iteration limit'
  else if (sn(goodis).gt.maxsn) then
    string = 'signal to noise stability'
  else if (dimcum.gt.0.and.converge.lt.0.0) then
    string = 'flux convergence'
  else if (interrupt) then
    string = 'User ^C interrupt'
  else
    string = 'residual limit'
  endif
  write(chain,104) 'Stopped by ',trim(string),niter,bruit(1),limit
  call map_message(seve%i,rname,chain)
  nchain = 1
  do is=1,ns
    write(chain(nchain:),105) is,ncase(is),fluxes(is)
    nchain = len_trim(chain)+2
  enddo
  call map_message(seve%i,rname,chain)
  !
  ! Done: RESTORATION Process now
  clean = 0.0
  !
  ! If CCT component flux are not scaled, use the Kernel as they are
  ! If they are scaled,  normalize them to 1 back again...
  !
  ! Here they ARE scaled (see comment #1 Above)
  !
  mcct = 0
  do i=1,niter
    value = cct_list%cc(i)%value
    kx = cct_list%cc(i)%ix
    ky = cct_list%cc(i)%iy
    is =  -nint(cct_list%cc(i)%size)
    if (is.le.1) then         ! May have Type = 0 if restarted      
      clean (kx,ky) = clean(kx,ky) + value
      mcct = mcct+1
    else
      value = value/scale(is)
      call add_kernel (clean,mx,my,value,kx,ky,mk,nker(is),kernel(:,:,is))
      mcct = mcct+nker(is)**2 ! Maximum value
    endif
  enddo
  !
  ! Final residual
  !
  if (np.eq.1) then
    ! This is only valid for a single field. 
    cdata = cmplx(clean,0.0)
    ndim = 2
    nn(1) = mx
    nn(2) = my
    call fourt(cdata,nn,ndim,-1,1,wfft)
    cdata = cdata*tfbeam(:,:,1)            ! Complex by Real multiplication
    call fourt(cdata,nn,ndim,1,1,wfft)
    resid = dirty-real(cdata)
  else  
    ! For mosaic, use the Weight - We already have the Residual here...
    ! resid = dirty-real(cdata)*weight
  endif
  !
  ! Convolution with clean beam is done outside
  if (debug) print *,'Returning'
  return
  !
  101   format(i6,i5,i5,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  102   format(i6,i5,i5,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  103   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,'] = ',a,   &
     &    1pg11.4,1pg11.4)
  104   format(a,a,i6,1x,1pg11.4,1x,1pg11.4)
  105   format(('#',i0,' Ncct ',i0,' Flux ',1pg11.4))
  !
end subroutine major_multi90
!
subroutine expand_multi_cct(head,nker,kernel,nx,ny,ip,miter,flux,niter,tcc,dcct)
  use imager_interfaces, only : spread_kernel
  use gkernel_interfaces
  use image_def
  use clean_def
  !-----------------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER  -- CLEAN Method MULTISCALE  
  !   Expand the MultiScale Clean Component List
  !!
  !-----------------------------------------------------------------------------
  type (gildas), intent(inout) :: head           !! Clean header
  integer, intent(in) :: nker(:)                 !! Kernel sizes
  real, intent(in) :: kernel(:,:,:)              !! Smoothing kernel values
  integer, intent(in)  :: nx,ny                  !! Image size
  integer, intent(in)  :: ip                     !! Plane number 
  integer, intent(in)  :: miter                  !! Maximum number of clean components
  real, intent(out) :: flux                      !! Cleaned flux
  integer, intent(in)  :: niter                  !! Number of found components
  type (cct_par), intent(in) :: tcc(niter)       !! Clean component list
  real, intent(inout) :: dcct(:,:,:)             !! Clean component values
  !
  integer :: i,kx,ky,is,nc
  real :: value
  !
  nc = 0
  do i=1,niter
    kx = tcc(i)%ix
    ky = tcc(i)%iy
    value = tcc(i)%value
    is = -nint(tcc(i)%size)
    !
    call spread_kernel (nx,ny,ip,nc,dcct,value,kx,ky,nker(is),kernel(:,:,is))
  enddo
  !
  flux = 0.
  do i=1,nc
    dcct(1,ip,i) = (dcct(1,ip,i) -   &
     & head%gil%convert(1,1)) * head%gil%convert(3,1) + &
     & head%gil%convert(2,1)
    dcct(2,ip,i) = (dcct(2,ip,i) -   &
     & head%gil%convert(1,2)) * head%gil%convert(3,2) + &
     & head%gil%convert(2,2)
    flux = flux + dcct(3,ip,i)
  enddo
  !
end subroutine expand_multi_cct

subroutine uv_fibeam (name,freq,uv,nu,nvis,wcol,majo,mino,pa,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_fibeam
  use mod_fitbeam
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER -- Command FIT and support for CLEAN
  !
  !   Find beam parameters for deconvolution.
  !   Fit an elliptical gaussian clean beam to UV data weight
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name          !! Caller name
  real(8), intent(in) :: freq                   !! Observation frequency
  integer, intent(in) :: nu                     !! Visibility size 
  integer, intent(in) :: nvis                   !! Number of visibilities
  integer, intent(in) :: wcol                   !! Weight column  
  real, intent(in) :: uv(nu,nvis)               !! Visibilities
  real, intent(inout) :: majo                   !! Major axis
  real, intent(inout) :: mino                   !! Minor axis
  real, intent(inout) :: pa                     !! Position Angle
  logical, intent(inout) :: error               !! Error flag
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  ! Local ---
  character(len=80) :: mess
  integer :: ml,ier,nc,jcol
  real :: dmaj,dmin,minor,uvmax
  logical :: liter
  !
  ! Code ----
  error = .false.
  !
  nc = (nu-7)/3
  if (wcol.eq.0) then
    jcol = (nc+2)/3
  else
    jcol = min(wcol,nc)
  endif
  jcol = 7+3*jcol
  !  
  liter = .false.
  !
  ! Load data  into work array
  ml = nvis
  allocate (ip_values(ml), ip_coords(2,ml), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',ier
    call map_message(seve%e,name,mess)
    error = .true.
    return
  endif
  ip_coords(1:2,:) = uv(1:2,:)
  !
  ! Find initial guesses
  ip_values(:) = ip_coords(1,:)**2 + ip_coords(2,:)**2
  uvmax = sqrt(maxval(ip_values))
  ip_values(:) = uv(jcol,:)
  !
  ! Assume Half power size of Weight distribution is 1/3rd of uvmax
  !
  spar(2:3) = 0.0
  spar(1) = maxval(ip_values)
  spar(4) = uvmax/3.
  spar(5) = uvmax/5.
  spar(6) = 90.0
  par = spar
  err(1) = spar(1)/10.0 
  err(2:3) = 0
  err(2) = 0
  err(4) = spar(4)/5.0
  err(5) = err(4)
  err(6) = 50.0
  !
  Print *,'Par ',par
  Print *,'Err ',err
  !
  nv = nvis !!! 
  liter = .false.
  call fit2d (min2d,liter,error)
  !
  Print *,'Par ',par
  Print *,'Err ',err
  !
  spar = par
  liter = .true.
  call fit2d (min2d,liter,error)
  !
  Print *,'Par ',par
  Print *,'Err ',err
  !
  ! Go from UV distance to Beam sizes...
  if (par(4).le.par(5)) then
    majo = 1.0/(freq*f_to_k*par(4))
    mino = 1.0/(freq*f_to_k*par(5))
    dmaj = err(4)/par(4)*majo
    dmin = err(5)/par(5)*mino
    pa = 90.0-par(6) ! Pas clair...
  else
    majo = 1.0/(freq*f_to_k*par(5))
    mino = 1.0/(freq*f_to_k*par(4))
    dmaj = err(5)/par(5)*majo
    dmin = err(4)/par(4)*mino
    pa = -par(6)
  endif
  deallocate (ip_values, ip_coords, stat=ier)
  !
  if (name.eq.' ') return
  !
  minor = mino*3600*180/pi
  if (minor.gt.10.) then
    write(mess,100) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,101) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  else if (minor.gt.0.2) then
    write(mess,110) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,111) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  else
    write(mess,120) 'Beam is ',majo*3600*180/pi,mino*3600*180/pi,pa
    call map_message(seve%i,name,mess)
    write(mess,121) 'Errors (',dmaj*3600*180/pi,dmin*3600*180/pi,err(6)
    call map_message(seve%i,name,mess)
  endif
  !
  100   format (a,f8.2,'" by ',f8.1,'" at PA ',f8.1,' deg.')
  101   format (a,f8.2,')   (',f8.1,')      (',f8.1,')    ')
  110   format (a,f8.2,'" by ',f8.2,'" at PA ',f8.2,' deg.')
  111   format (a,f8.2,')   (',f8.2,')      (',f8.2,')    ')
  120   format (a,f8.2,'" by ',f8.3,'" at PA ',f8.3,' deg.')
  121   format (a,f8.2,')   (',f8.3,')      (',f8.3,')    ')
end subroutine uv_fibeam
!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine import_package(line,error)
  use sic_dependencies_interfaces
  use gpack_def
  use sic_interfaces, except_this=>import_package
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Internal routine
  !    Support routine for command SIC\IMPORT. Syntax is:
  !    IMPORT foo [/DEBUG]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=gpack_name_length) :: packname
  character(len=6) :: rname = 'IMPORT'
  integer :: pl,narg
  logical :: debug = .false.  ! Load library in debug mode?
  integer(kind=4) :: i, j, k, dir_nfile
  character(len=filename_length) :: filestring,tmpstring,dirstring
  character(len=filename_length), allocatable :: dir_file(:)
  character(len=12), allocatable :: packages(:)
  !
  narg = sic_narg(0)
  if (narg.ne.1) then
    call sic_message(seve%e,rname,'Command IMPORT needs 1 and only 1 argument')
    error = .true.
    return
  endif
  !
  ! Retrieve package name
  call sic_ch (line,0,1,packname,pl,.true.,error)
  if (error) return
  if (packname.eq."?") then
    dir_nfile = 0
    !
    filestring = 'py*.so'
    tmpstring = '$PYTHONPATH'
    call sic_parse_file(tmpstring,'','',dirstring)  ! Translate Sic logicals and others
    call gag_directory(dirstring,filestring,dir_file,dir_nfile,error)
    if (error) return
    if (dir_nfile.le.0) return
    !
    allocate(packages(dir_nfile))
    k = 0
    do i=1,dir_nfile
      j = index(dir_file(i),'.')-1
      k = k+1
      packages(k) = dir_file(i)(3:j)
      if (packages(k).eq."gildas") k=k-1
    enddo
    if (k.gt.0) then
      write(*,'(A)') 'I-IMPORT, Available packages : '
      write(*,*) packages(1:k)
    endif
  else
    call sic_lower(packname)
    debug = sic_present(1,0)
    call sic_let_char('SIC%IMPORT',packname,error)
    !
    ! Dynamic load the library
    call gpack_sic_import(packname,debug,error)
  endif
  !
end subroutine import_package
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine detect_comm(line,comm,error)
  use gkernel_interfaces
  use gbl_message
  use clean_default
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command  
  !   UV_DETECT Result [Data[.uvt] Model[.lmv-clean]]
  !
  ! Compute Frequency Cross-Correlation spectrum of a UV data set
  ! with that derived from the same UV coverage from a image data cube.
  !   This routine encapsulate the spectral resampling between the 
  ! image and the UV data and the derivation of the UV model before 
  ! calling UV_CORRELATE to perform the UV plane correlation.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name
  logical, intent(inout) :: error         !! Logical Error flag
  !
  ! Constants
  integer, parameter :: o_file=1
  !
  ! Local ---
  character(len=2) :: cb
  integer :: ip,jp,kp
  logical :: do_insert  
  !
  ! Code ----
  ip = sic_start(0,1)
  cb = line(ip:ip+1)
  if (cb.eq."?") then
    call exec_program('HELP UV_DETECT')
    return
  endif
  !
  ! Pass command to script
  do_insert = sic_lire().eq.0
  ImagerError = .true.
  !
  if (sic_narg(0).eq.0) then
    if (sic_present(o_file,0)) then
      jp = index(line,'/')
      kp = jp + index(line(jp:),' ')
      call exec_program('@ p_uv_detect gag_scratch:detect'//line(kp:) )
    else 
      call exec_program('@ p_uv_detect gag_scratch:detect')
    endif
  else if (sic_narg(0).eq.1) then
    if (sic_present(o_file,0)) then
      ip = index(line,' ')+1
      jp = index(line,'/')
      kp = jp + index(line(jp:),' ')
      call exec_program('@ p_uv_detect '//line(ip:jp-1)//line(kp:) )
    else
      ip = index(line,' ')+1
      call exec_program('@ p_uv_detect '//line(ip:))
    endif
  else
    call map_message(seve%e,comm,'Requires 0 or 1 argument')
    error = .true.
    return
  endif
  if (sic_ctrlc()) return
  ImagerError = .false.
  error = .false.
  !
  if (do_insert) call sic_insert_log(line)
end subroutine detect_comm
!
subroutine correlate_comm(line,comm,error)
  use gkernel_interfaces
  use image_def
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : uvcorrel, map_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !* 
  !   IMAGER -- Support for command  
  !   UV_CORRELATE Result [/FILE Data Model]
  !
  ! Compute Frequency Cross-Correlation spectrum of two UV data sets.
  ! This routine assumes proper velocity matching and Visibility
  ! matching between the UV data sets.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_CORRELATE'
  integer, parameter :: o_file=1
  !
  ! Code ---
  character(len=256) cmod,cuv 
  character(len=128) :: mess
  type (gildas) :: hmod,hdata,hspec
  !
  real, allocatable :: accum(:), accums(:,:), current(:), spe(:,:)
  real, allocatable :: normal(:,:), norm(:)  
  logical :: byfile, err
  integer :: it, iv, nspe, i, nthread, ithread, n
  integer :: ier, nblock, ib, nvisi, ospe, ic
  real :: weight, realt
  !
  ! Code ----
  error = .false.
  call gildas_null(hmod,type='UVT')
  call gildas_null(hdata,type='UVT')
  call gildas_null(hspec,type='UVT')
  !
  byfile = sic_present(o_file,0)
  if (.not.byfile) then
    if (huv%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV data')
      error = .true.
    endif
    call gdf_copy_header(huv,hdata,error)
    if (error) return
    if (huvm%loca%size.eq.0) then
      call map_message(seve%e,rname,'No UV model')
      error = .true.
    endif
    if (error) return
    call gdf_copy_header(huvm,hmod,error)
    if (error) return
  else
    call sic_ch(line,o_file,2,cmod,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,1,cuv,n,.true.,error)
    if (error) return
    !
    call sic_parse_file(cmod,' ','.uvt',hmod%file)
    call sic_parse_file(cuv,' ','.uvt',hdata%file)
    !
    call gdf_read_header(hmod,error)
    if (error) return
    call gdf_read_header(hdata,error)
    if (error) return
  endif
  !
  call sic_ch(line,0,1,cuv,n,.true.,error)
  if (error) return
  !
  ! Compare simply number of visibilities (assume they match)
  if (hmod%gil%nvisi.ne.hdata%gil%nvisi) then
    call map_message(seve%e,rname,'MODEL and UVDATA UV tables visibilities do not match')
    error = .true.
  endif
  ! Compare spectral resolution - Auto-resampling will be implemented later
  if (abs(hmod%gil%vres-hdata%gil%vres).gt.0.1*abs(hdata%gil%vres/hdata%gil%nchan)) then
    call map_message(seve%e,rname,'MODEL and UVDATA spectral resolution do not match')
    error = .true.
  endif
  if (error) return
  !
  ! This will be a Spectrum with Velocity,Frequency,Value
  nspe = hdata%gil%nchan   ! +/- half of kernel on each side ?...
  !
  ! !Print *,'Ready for kernel ',nker,' byfile ',byfile,' Dims ',nspe,3
  !
  nthread = 1
  !$ nthread = omp_get_max_threads()
  allocate(accum(nspe),accums(nspe,nthread),normal(nspe,nthread), &
    & norm(nspe),current(nspe),spe(nspe,3),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Allocation error')
    error =.true.
    return
  endif
  !
  accums = 0.0
  normal = 0.0
  !
  ! This is not obviously correct. 
  ! It may depend whether the Kernel is centered or not... How do we know ?...
  ! Also needs to be adjusted if the number of output channels is changed
  ospe = (hmod%gil%nchan+1)/2-hmod%gil%ref(1)  ! Sign verified
  do i=1,nspe
    spe(i,1) = (i-hdata%gil%ref(1)-ospe)*hdata%gil%vres + hdata%gil%voff
    spe(i,2) = (i-hdata%gil%ref(1)-ospe)*hdata%gil%fres + hdata%gil%freq
    spe(i,3) = 0.
  enddo
  !
  if (.not.byfile) then
    !
    ! !Print *,'SPEC Dim ',nspe,' Kernel size ',nker,' Channels ',hdata%gil%nchan
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP &  SHARED(hdata,hmod,duv,duvm,accums,normal,nspe) &
    !$OMP &  PRIVATE(iv,current,ithread,weight,norm,ic, err, realt)
    !
    err = .false.
    ithread = 1
    !$ ithread = omp_get_thread_num()+1
    !$OMP DO
    do iv = 1, hdata%gil%nvisi
      ! We use the weight of the Data
      ! weight = duvm(7+3*(hmod%gil%nchan/2),iv)   ! Kernel
      weight =  duv(7+3*(hdata%gil%nchan/3),iv)  ! Data 
      if (weight.le.0) cycle  ! Flagged visibility
      !
      call uvcorrel(duv(1:hdata%gil%dim(1),iv),hdata%gil%nchan, & 
        & duvm(1:hmod%gil%dim(1),iv),hmod%gil%nchan,norm,current,nspe) 
      !
      accums(:,ithread) = accums(:,ithread) + current
      normal(:,ithread) = normal(:,ithread) + norm    ! Accumulate the weight    
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
    !
  else
    !
    ! Define blocking factor, on largest data file usually.
    call gdf_nitems('SPACE_GILDAS',nblock,hdata%gil%dim(1)) ! Visibilities at once
    nblock = min(nblock,hdata%gil%dim(2))
    ! Allocate respective space for each file
    allocate (hdata%r2d(hdata%gil%dim(1),nblock), hmod%r2d(hmod%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error ',hdata%gil%dim(1), nblock
      call map_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    !
    ! Loop over line tables 
    hdata%blc = 0
    hdata%trc = 0
    hmod%blc = 0
    hmod%trc = 0
    do ib = 1,hdata%gil%dim(2),nblock
      write(mess,*) ib,' / ',hdata%gil%dim(2),nblock
      call map_message(seve%i,rname,mess)
      hdata%blc(2) = ib
      hdata%trc(2) = min(hdata%gil%dim(2),ib-1+nblock)
      hmod%blc(2) = ib
      hmod%trc(2) = hdata%trc(2)
      call gdf_read_data(hdata,hdata%r2d,error)
      if (error) exit
      call gdf_read_data(hmod,hmod%r2d,error)
      if (error) exit
      !
      ! Here do the job
      nvisi = hmod%trc(2)-hmod%blc(2)+1
      !
      !$OMP PARALLEL DEFAULT(NONE) &
      !$OMP &  SHARED(hdata,hmod,accums,nvisi,normal,nspe) &
      !$OMP &  PRIVATE(iv,current,ithread,weight,norm)
      !
      ithread = 1
      !$ ithread = omp_get_thread_num()+1
      !$OMP DO
      do iv = 1, nvisi
        ! We use the weight of the Data
        ! weight = hmod%r2d(7+3*(hmod%gil%nchan/2),iv)    ! Kernel
        weight = hdata%r2d(7+3*(hdata%gil%nchan/3),iv)  ! Data 
        if (weight.le.0) cycle  ! Flagged visibility
        !
        call uvcorrel(hdata%r2d(:,iv),hdata%gil%nchan, & 
          & hmod%r2d(:,iv),hmod%gil%nchan,norm,current,nspe)
        accums(:,ithread) = accums(:,ithread) + current
        normal(:,ithread) = normal(:,ithread) + norm    ! Accumulate the weight    
      enddo
      !$OMP END DO
      !$OMP END PARALLEL
    enddo
    !
    ! Finalize the image
    call gdf_close_image(hdata,err)
    call gdf_close_image(hmod,err)
    if (error) return
  endif
  !
  ! Accumulate the Thread results
  spe(:,3) = 0.0
  norm = 0.0
  do it = 1,nthread
    spe(:,3) = spe(:,3) + accums(:,it)
    norm(:) = norm + normal(:,it)
  enddo
  !
  where (norm.le.0) norm = 1.0
  ! Normalize to S/N ratio - ! Units are MHz by default
  ! Do we need the sqrt(2) factor ?
  spe(:,3) = spe(:,3)/sqrt(norm(:))*1E3 ! *sqrt(2.0)
  !
  ! Define the result as a SPECTRUM - Would be better to write
  ! it as a UV table with only the (0,0) spacing, since UV_PREVIEW
  ! could then be used on it directly 
  call sic_parse_file(cuv,' ','.dat',hspec%file)
  open(unit=2,file=hspec%file,status='unknown',iostat=ier)
  if (ier.ne.0) then
    call map_message(seve%w,rname,'Error opening '//trim(hspec%file))
    call putios('E-UV_CORRELATE,  ',ier)
  else
    rewind(2)
    do i=1,nspe
      write(2,*) spe(i,1), spe(i,2), spe(i,3)
    enddo
    close(unit=2)
  endif
  !
  ! Now save the result also as a Zero spacing UV table, for easy display
  call gdf_copy_header(hdata,hspec,error)
  call sic_parse_file(cuv,' ','.uvt',hspec%file)
  !
  hspec%gil%ref(1) = hdata%gil%ref(1)-ospe
  hspec%gil%nchan = nspe
  hspec%gil%dim(1) = 7+3*nspe
  hspec%gil%dim(2) = 1
  hspec%gil%nvisi = 1
  !
  weight = 1E-6 !! Normalized to 1 sigma, per MHz
  !
  call gdf_allocate(hspec,error)
  if (error) return
  hspec%r2d(1:7,1) = 0
  do i=1,nspe
    hspec%r2d(5+3*i,1) = spe(i,3)
    hspec%r2d(6+3*i,1) = 0.
    hspec%r2d(7+3*i,1) = weight ! Sum of initial weights
  enddo
  hspec%char%unit = 'Unknown'
  call gdf_write_image(hspec,hspec%r2d,error)
  !
end subroutine correlate_comm
!
subroutine uvcorrel(uvdata,nc,kernel,nk,norm,current,mc)
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command UV_CORRELATE
  !
  ! Compute complex cross-correlation of two visibilities
  !!
  !---------------------------------------------------------------------  
  real, intent(in) :: uvdata(:)     !! UV data to be matched
  real, intent(in) :: kernel(:)     !! Matching Kernel 
  integer, intent(in) :: nc         !! Number of channels of uvdata
  integer, intent(in) :: nk         !! Kernel size. 
  real, intent(out) :: norm(:)      !! Normalisation factor (per channel)
  real, intent(out) :: current(:)   !! Correlation spectrum
  integer, intent(in) :: mc         !! Size  of correlation spectrum
  !
  ! Local ---
  integer :: ik, ic, jc
  real(8) :: r2, rp
  real(4) :: r, red, imd, rek, imk, w
  !
!!
!! xc += np.correlate(data.VV[v], np.matmul(data.wgts[v]*R_inv, kernel[v]))
!!        # normalize the output such that real and imag noise powers are both 1 (hence factor of sqrt(2))
!!                kernel_noise_power += np.dot(kernel[v],np.matmul(data.wgts[v]*R_inv, kernel[v].conj()))
!!        xc = xc/np.sqrt(kernel_noise_power)*np.sqrt(2)  
!!
  ! Assume no correlation between channels
  do ic = 1,mc      ! Output channel
    r2 = 0.        
    rp = 0. ! Noise power
    !
    do jc=1,nc
      ik = jc-ic+(nk+1)/2
      !
      if (ik.lt.1) cycle
      if (ik.gt.nk) cycle
      w = uvdata(7+3*jc)
      if (w.gt.0) then
        red = uvdata(5+3*jc)
        imd = uvdata(6+3*jc)
        rek = kernel(5+3*ik)
        imk = kernel(6+3*ik) 
        r = (red*rek + imd*imk)
        r2 = r2 + r*w  ! Use the Weights
        r = (rek**2 + imk**2)
        rp = rp + r*w
      endif
    enddo
    current(ic) = r2
    norm (ic) = rp
  enddo
end subroutine uvcorrel

subroutine uv_check_mosaic
  use clean_def
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : sub_shift_mosaic, map_message
  use gkernel_interfaces
  !
  character(len=32) :: line
  character(len=16) :: comm
  integer :: nline
  logical :: error, do
  !
  if (themap%nfields.ge.0) return ! Single field or POINT Mosaic already
  do = .true.
  call sic_get_logi('READ_UVSHIFT',do,error)
  if (.not.do) return             ! Allows testing code without the patch below
  !
  ! Automatically convert to POINT Mosaic after READ if needed
  line = 'READ'
  nline = 4
  error = .false.
  call sic_analyse(comm,line,nline,error)
  huv%r2d => duv  ! Setup data pointer
  call sub_shift_mosaic(line,comm,huv,themap,error)
  call map_message(seve%w,comm,'Mosaic converted to POINTing format',1)
  !! call uv_shift_mosaic(line,comm,error)
end subroutine uv_check_mosaic
!    
subroutine uv_shift_mosaic(line,comm,error)
  use clean_def
  use clean_default
  use clean_arrays
  use imager_interfaces, only : sub_shift_mosaic
  !-------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !  IMAGER -- Support routine for command  
  !       UV_SHIFT  MAP_CENTER   
  !                 [Xpos Ypos UNIT] [ANGLE Angle]  
  !
  !   Phase shift a Mosaic or Single Dish UV Table to a new
  !   common phase center and orientation.  
  !     Offx OffY are offsets in Angle UNIT 
  !               (default 0,0)  
  !     Angle     is the final position angle from North in Degree
  !               (default: no change)
  !
  !   Also called implicitely (with no command line arguments, i.e.
  !   no change of Phase Center unless the UV Table is with Phase Offsets)
  !   by command UV_MAP for Mosaics
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name 
  logical error                           !! Logical error flag
  !
  character(len=*), parameter :: rname='UV_SHIFT'
  !
  huv%r2d => duv  ! Setup data pointer
  !
  call sub_shift_mosaic(line,comm,huv,themap,error)
  !
end subroutine uv_shift_mosaic
!
subroutine sub_shift_mosaic(line,comm,huvl,pmap,error)
  use clean_def
  use clean_default
  use phys_const
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => sub_shift_mosaic
  !-------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !  IMAGER -- Support routine for command  
  !       UV_SHIFT  MAP_CENTER   
  !                 [Xpos Ypos UNIT] [ANGLE Angle]  
  !
  !   Phase shift a Mosaic or Single Dish UV Table to a new
  !   common phase center and orientation.  
  !     Offx OffY are offsets in Angle UNIT 
  !               (default 0,0)  
  !     Angle     is the final position angle from North in Degree
  !               (default: no change)
  !
  !   Also called implicitely (with no command line arguments, i.e.
  !   no change of Phase Center unless the UV Table is with Phase Offsets)
  !   by command UV_MAP for Mosaics
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name 
  type(gildas), intent(inout)  :: huvl    !! Local UV header & data
  type(uvmap_par), intent(inout) :: pmap  !! UV_MAP parameters
  logical error                           !! Logical error flag
  !
  character(len=*), parameter :: rname='UV_SHIFT'
  ! Local ---
  real, pointer :: duv(:,:)
  !
  character(len=80) :: mess
  character(len=16) :: ctype
  type(projection_t) :: proj, old_proj, new_proj
  real(8) :: newoff(3), newabs(3), oldabs(3)
  real(4) :: cs(2), angold
  real(8), allocatable :: rpos(:,:)
  real(8) :: freq
  logical :: precise=.true.
  logical :: shift, doit, lshift
  integer :: nc,nu,nv,i,ier,loff,moff,xoff,yoff,idoff
  !
  real(8) :: old(2), new(2), tabs(2), off(2)
  integer :: iv,ip
  !
  ! Code ----
  !
  call imager_tree('SUB_SHIFT_MOSAIC',.false.)
  !
  loff = huvl%gil%column_pointer(code_uvt_loff)
  moff = huvl%gil%column_pointer(code_uvt_moff)
  xoff = huvl%gil%column_pointer(code_uvt_xoff)
  yoff = huvl%gil%column_pointer(code_uvt_yoff)
  idoff = huvl%gil%column_pointer(code_uvt_id)
  call uvdebug_pointers(comm,'Huv ',huvl)
  !
  oldabs = [huvl%gil%a0,huvl%gil%d0,huvl%gil%pang]   !!! Remember map_center
  newabs = oldabs
  newoff = 0.d0
  !
  shift = .false.
  if (pmap%nfields.eq.0) then
    call map_message(seve%i,rname,'UV data is a single field') 
  else
    if (idoff.ne.0) then
      ctype = 'ID column'
    else if (pmap%nfields.gt.0) then
      ctype = 'Pointing Offsets'
    else if (pmap%nfields.lt.0) then
      ctype = 'Phase Offsets    '
    endif
    write(mess,'(A,I0,A)') 'Mosaic UV data has ',abs(pmap%nfields),' fields in '//ctype
    call map_message(seve%i,rname,mess)
    if (idoff.ne.0) then
      if (pmap%nfields.gt.0) then
        call map_message(seve%i,rname,'Pointing ID Mosaics do not need shifting',3)
        return
      endif
    endif
    !
    if (pmap%nfields.lt.0) then
      !
      ! Compute the mean offset as phase center position
      if (allocated(huvl%mos%fields)) then
        newoff(1) = minval(huvl%mos%fields(:)%opoint(1)) + maxval(huvl%mos%fields(:)%opoint(1))
        newoff(2) = minval(huvl%mos%fields(:)%opoint(2)) + maxval(huvl%mos%fields(:)%opoint(2))
      else
        newoff(1) = minval(pmap%offxy(1,:)) + maxval(pmap%offxy(1,:))
        newoff(2) = minval(pmap%offxy(2,:)) + maxval(pmap%offxy(2,:))
      endif
      newoff = newoff*0.5d0
      !
      call gwcs_projec(huvl%gil%a0,huvl%gil%d0,huvl%gil%pang,huvl%gil%ptyp,proj,error)
      if (error)  return
      call rel_to_abs(proj,newoff(1),newoff(2),newabs(1),newabs(2),1)
      !
      shift = .true.
      call print_change_header('PHASE_TO_POINT',huvl,newabs,shift)
      !
      ! Set the new center so that the Offsets are relative to this one now
      huvl%gil%a0 = newabs(1)
      huvl%gil%d0 = newabs(2)
    endif
  endif 
  !                 
  ! Check for valid syntax
  if (comm.ne.'UV_MOSAIC') then
    if (.not.sic_present(0,2)) then
      if (sic_present(0,1).or.(pmap%nfields.eq.0)) then
        call map_message(seve%e,rname,'Missing or insufficient argument(s) to command '//comm)
        error = .true.
        return
      else
        call map_message(seve%w,rname,'Converting Mosaic to default phase center')
      endif
    endif
  endif  
  !
  ! Check if command line specifies another center and/or orientation
  if (line.ne.' ') then
    call map_center(line,rname,huvl,lshift,newabs,error)
    if (error) return
  else
    lshift = .false.
  endif
  !
  ! Restore the original Projection 
  huvl%gil%a0 = oldabs(1)
  huvl%gil%d0 = oldabs(2)
  huvl%gil%pang = oldabs(3)
  !
  ! Shifting is the Combination of Phase-->Pointing conversion
  ! and User requested shift through MAP_CENTER or command line arguments
  shift = shift .or. lshift 
  doit = .false.
  !
  duv => huvl%r2d
  !
  if (.not.shift) then
    call map_message(seve%w,rname,'No shift required')
  else
    if ((newabs(3).ne.0.0).and.(pmap%nfields.ne.0)) then
      call map_message(seve%w,rname,'Rotated UV Mosaic cannot be saved -- No convention adopted by IRAM',3)
    endif      
    !
    doit = .true.   ! Make absolutely sure we do the shift ...
    call uv_shift_header (newabs,huvl%gil%a0,huvl%gil%d0,huvl%gil%pang,newoff,doit)
    !
    ! But if a PHASE to POINTING convention is required, we MUST correct the phases
    if (pmap%nfields.lt.0) doit = .true.
    !
    if (.not.doit) then
      call map_message(seve%w,rname,'Shift is below possible precision')
      ! So, no change of Phase Center and Orientation, but the conversion
      ! from Phase to Pointing centers remains to be done.
      !
    else
      !
      ! Compute observing frequency, and new phase center in wavelengths
      !
      if (precise) then
        nc = huvl%gil%nchan
        allocate(rpos(2,nc),stat=ier)
        do i=1,huvl%gil%nchan
          freq = gdf_uv_frequency(huvl,dble(i))
          rpos(1:2,i) = - freq * f_to_k * newoff(1:2)
        enddo
      else
        nc = 1
        allocate(rpos(2,1),stat=ier)
        freq = gdf_uv_frequency(huvl)
        rpos(1:2,1) = - freq * f_to_k * newoff(1:2)
      endif
      !
      ! Define the rotation
      cs  = [1.0,0.0]
      angold = huvl%gil%pang
      huvl%gil%pang = newabs(3)
      cs(1)  =  cos(huvl%gil%pang-angold)
      cs(2)  = -sin(huvl%gil%pang-angold) !! This sign MAY BE WRONG
      !
      ! Recenter all channels, Loop over line table
      ! We work in place - We do not play with UV buffers
      !
      nu = huvl%gil%dim(1)
      nv = huvl%gil%nvisi
      !
      ! This rotates the U,V coordinates and Shift the Phases
      call shift_uvdata (huvl,nu,nv,duv,cs,nc,rpos)
      !
      ! Set the new Phase center and Orientation
      huvl%gil%a0 = newabs(1)
      huvl%gil%d0 = newabs(2)  
      huvl%gil%pang = newabs(3)
    endif
  endif
  !
  ! Done if Single Field (0) or already Pointing columns (>0)
  if (pmap%nfields.eq.0) return ! Single Field
  !
  ! Convert the LOFF - MOFF columns into Pointing columns if needed
  if (pmap%nfields.lt.0) then
    ! "Phase" columns
    huvl%gil%column_pointer(code_uvt_xoff) = loff
    huvl%gil%column_pointer(code_uvt_yoff) = moff
    huvl%gil%column_size(code_uvt_xoff) = 1
    huvl%gil%column_size(code_uvt_yoff) = 1
    !
    huvl%gil%column_pointer(code_uvt_loff) = 0
    huvl%gil%column_pointer(code_uvt_moff) = 0
    huvl%gil%column_size(code_uvt_loff) = 0
    huvl%gil%column_size(code_uvt_moff) = 0
    !
    pmap%nfields = abs(pmap%nfields)
    !
    ! In case there is a Pointing Table, update it
    if (huvl%mos%nfields.gt.1) then
      call change_fields(rname,pmap%nfields,huvl%mos%fields,newabs,error)
      huvl%mos%fields(:)%aphase(1) = huvl%gil%a0
      huvl%mos%fields(:)%aphase(2) = huvl%gil%d0
    endif
  endif
  !
  ! And now convert the Offset values to new Coordinate system
  ! 
  ! Before: it was Relative to "OLDABS"
  ! Now it is Relative to "NEWABS"
  !
  if (doit) then
    ! A common, modified, Phase center and "Pointing Offsets"
    !
    ! The whole question is whether the "Pointing Offsets" are
    ! relative to the "Pointing Center" (with no rotation Angle)
    ! or to the "Phase Center" (with a rotation Angle)
    !
    ! The code below assumes everything is relative to the Phase Center.
    !
    idoff = huvl%gil%column_pointer(code_uvt_id)
    call gwcs_projec(oldabs(1),oldabs(2),oldabs(3),huvl%gil%ptyp,old_proj,error)  ! Previous projection system
    call gwcs_projec(newabs(1),newabs(2),newabs(3),huvl%gil%ptyp,new_proj,error)  ! New projection system
    if (idoff.eq.0) then
      xoff = huvl%gil%column_pointer(code_uvt_xoff) 
      yoff = huvl%gil%column_pointer(code_uvt_yoff)
      !
      old(1) = duv(xoff,1)
      old(2) = duv(yoff,1)
      call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
      call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
      !
      do iv=1,nv
        off(1) = duv(xoff,iv)
        off(2) = duv(yoff,iv)
        if (any(off.ne.old)) then
          old(1) = duv(xoff,iv)
          old(2) = duv(yoff,iv)
          call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
          call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
        endif
        duv(xoff,iv) = new(1)
        duv(yoff,iv) = new(2)
      enddo
      !
      ! And we also correct the Pointing / Phase Offset values
      do ip=1,abs(pmap%nfields)
        off = pmap%offxy(:,ip)
        call rel_to_abs(old_proj,off(1),off(2),tabs(1),tabs(2),1)
        call abs_to_rel(new_proj,tabs(1),tabs(2),off(1),off(2),1)
        pmap%offxy(:,ip) = off
      enddo
      !
    else if (huvl%mos%nfields.gt.1) then
      !
      ! Just update the Offsets 
      do ip=1,abs(pmap%nfields)
        call abs_to_rel(new_proj,huvl%mos%fields(ip)%apoint(1),huvl%mos%fields(ip)%apoint(2),off(1),off(2),1)
        huvl%mos%fields(ip)%opoint = off
        call abs_to_rel(new_proj,huvl%mos%fields(ip)%aphase(1),huvl%mos%fields(ip)%aphase(2),off(1),off(2),1)
        huvl%mos%fields(ip)%ophase = off
      enddo
      !
    else
      call map_message(seve%e,rname,'ID column but not Mosaic header',1)
      error = .true.
    endif
    !
    ! And for convenience, to avoid any ambiguity, we set the
    ! (irrelevant) Pointing center equal to the Phase center
    !
    huvl%gil%ra = huvl%gil%a0
    huvl%gil%dec = huvl%gil%d0 
  endif
  !
  call imager_tree('SUB_SHIFT_MOSAIC',.true.)
end subroutine sub_shift_mosaic
!

subroutine gildas_fits_sub(iname,oname,style,nbits,overwrite,error)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gildas_fits_sub
  use gio_xy
  use gio_fitsdef
  use gbl_message
  !--------------------------------------------------------
  ! @ public
  ! FITS
  !     Convert a GDF file to a FITS file
  !--------------------------------------------------------
  character(len=*), intent(in)    :: iname      ! GILDAS file name
  character(len=*), intent(in)    :: oname      ! FITS file name
  character(len=*), intent(in)    :: style      ! FITS style
  integer(kind=4),  intent(in)    :: nbits      ! Number of bits
  logical,          intent(in)    :: overwrite  ! Overwrite existing file?
  logical,          intent(inout) :: error      ! Error flag
  ! Local
  character(len=filename_length) :: name
  integer, parameter :: mstyle=5
  character(len=20) :: styles(mstyle),argum,comm
  integer :: ncom
  logical :: err
  data styles/'STANDARD','UVFITS','AIPSFITS','SORTED_AIPSFITS','CASA_UVFITS'/
  !
  fd%snbit = nbits
  if (fd%snbit.ne.16 .and. fd%snbit.ne.32 .and. fd%snbit.ne.-32) then
    call gio_message(seve%e,'GILDAS_FITS','Invalid number of bits')
    error = .true.
    return
  endif
  !
  name = oname
  gdfname = iname
  argum = style
  !
  if (argum.eq.' ') then
    a_style = 0
  else
    call sic_upper(argum)
    call sic_ambigs('STYLE',argum,comm,ncom,styles,mstyle,error)
    if (error) then
      a_style = 0
      error = .false.
    else
      a_style = ncom-1
      sort = .false.
      if (a_style.eq.code_fits_sorted) then
        a_style = code_fits_aips
        sort = .true.
      endif
      if (a_style.eq.code_fits_casa) then
        a_style = code_fits_aips
      endif
    endif
  endif
  !
  question = .false.
  call gfits_open (name,'OUT',error,overwrite=overwrite)
  if (error) return
  call tofits(fits,.false.,error)
  if (error) then
    call gfits_close(err)
    return
  endif
  call gfits_close (error)
end subroutine gildas_fits_sub

!*
! Routines to manage the IMAGER package
!!
subroutine imager_pack_set(pack)
  use gpack_def
  use gkernel_interfaces
  !! Declare the IMAGER package
  type(gpack_info_t), intent(out) :: pack
  !
  external :: imager_pack_init
  external :: imager_pack_on_exit
  external :: greglib_pack_set    ! If not declared in gkernel_interfaces
  !
  pack%name='imager'
  pack%ext = '.ima'
  pack%depend(1:1) = (/ locwrd(greglib_pack_set) /)
  pack%init=locwrd(imager_pack_init)
  pack%on_exit=locwrd(imager_pack_on_exit)
  pack%authors="S.Guilloteau"
  !
end subroutine imager_pack_set
!
subroutine imager_pack_init(gpack_id,error)
  use gkernel_interfaces
  use sic_def
  !! Initialize the IMAGER program
  integer :: gpack_id   !! Package ID
  logical :: error      !! Logical error flag
  !
  ! Local ---
  integer(kind=4) :: ier
  character(len=filename_length) :: root, filename
  logical :: local
  !
  ! Code ----
  call init_clean
  !! Local language initialization
  !
  call map_message_set_id(gpack_id)  
  !! Set library ID (One time initialization)
  !
  call exec_program('SIC'//backslash//'SIC EXTENSION .ima .greg ')
  !! Set Procedure extensions
  call exec_program('SIC'//backslash//'SIC PRIORITY 1 ADVANCED BUNDLES CLEAN DISPLAY')
  !! Set Language priorities
  !
  ! Specific initializations
  !
  ! IMAGER ad-hoc patch: override symbol from kernel/etc/gag.dico.gbl.src
  ! which sets 'gag_help_clean' pointing to Mapping one.
  ier = sic_setlog('gag_help_clean','gag_doc:hlp/imager-help-clean.hlp')
  if (ier.eq.0) then
    error=.true.
    return
  endif
  ier = sic_setlog('gag_help_display','gag_doc:hlp/imager-help-display.hlp')
  ier = sic_setlog('gag_help_advanced','gag_doc:hlp/imager-help-advanced.hlp')
  ier = sic_setlog('gag_help_calibrate','gag_doc:hlp/imager-help-calibrate.hlp')
  ier = sic_setlog('gag_help_bundles','gag_doc:hlp/imager-help-bundles.hlp')
  ier = sic_setlog('gag_help_imager','gag_doc:hlp/imager-help-imager.hlp')
  !
  root = 'gag_doc:html/imager-html/'
  call sic_parse_file (root,' ',' ',filename)
  inquire(file=filename,exist=local)
  !
  if (local) then
    ! Use Local HTML file
    ier = sic_setlog('gag_html_clean:','gag_doc:html/imager-html/')
    ier = sic_setlog('gag_html_display:','gag_doc:html/imager-html/')
    ier = sic_setlog('gag_html_advanced:','gag_doc:html/imager-html/')
    ier = sic_setlog('gag_html_calibrate:','gag_doc:html/imager-html/')
    ier = sic_setlog('gag_html_bundles:','gag_doc:html/imager-html/')
    ier = sic_setlog('gag_html_imager:','gag_doc:html/imager-html/')
  else
    ! Try to access remote HTML help at OASU
    ier = sic_setlog('gag_html_clean:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
    ier = sic_setlog('gag_html_display:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
    ier = sic_setlog('gag_html_advanced:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
    ier = sic_setlog('gag_html_calibrate:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
    ier = sic_setlog('gag_html_bundles:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
    ier = sic_setlog('gag_html_imager:','https://imager.oasu.u-bordeaux.fr/wp-content/uploads/doc/html/')
  endif
  !
  call imager_version  !! Set imager version
end subroutine imager_pack_init
!
subroutine imager_pack_on_exit(error)
  !! Clean up buffers and exit
  logical :: error    !! Logical error flag
  !
  call save_result(error)
  !
end subroutine imager_pack_on_exit
!
!*
!
! The following routines are to use GreG Library WITHOUT the GREG3\ language
! or at least with this language in Library-Only mode.
!
!   They should be in the GreG package, with their proper interfaces.
! However, it seems to work properly here provided the "external" 
! declarations with the proper types.
!!
subroutine greglib_pack_set(pack)
  !use greg_dependencies_interfaces
  !use greg_interfaces, except_this=>greglib_pack_set
  use gpack_def
  !----------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !*
  ! Public GREG package definition routine.  
  ! It defines package methods and dependencies to other packages.
  !!
  !----------------------------------------------------------------------
  type(gpack_info_t), intent(out) :: pack   !! Package info structure
  !
  external :: sic_pack_set,greglib_pack_init,greg_pack_clean ! if no "use"
  integer(8), external :: locwrd    ! if no "use"
  !
  !TEST! Print *,'Using Local greglib_pack_set '
  pack%name='greg'
  pack%ext='.greg'
  pack%depend(1:1) = (/ locwrd(sic_pack_set) /)
  pack%init=locwrd(greglib_pack_init)
  pack%clean=locwrd(greg_pack_clean)
  pack%authors="J.Pety, S.Bardeau, S.Guilloteau, E.Reynier"
  !
end subroutine greglib_pack_set
!
subroutine greglib_pack_init(gpack_id,error)
  !use greg_dependencies_interfaces
  !use greg_interfaces, except_this=>greglib_pack_init
  !----------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !! Private routine to set the GREG environment.
  !----------------------------------------------------------------------
  integer :: gpack_id     !! Package ID
  logical :: error        !! Logical error flag
  !
  logical, external :: gmaster_hide_gui ! if no "use"
  logical, external :: gr_error         ! ff no "use"
  !
  ! Set all GreG libraries id's
  call gchar_message_set_id(gpack_id)
  call gcont_message_set_id(gpack_id)
  call gtv_message_set_id(gpack_id)
  call gtv_c_message_set_id(gpack_id)
  call greg_message_set_id(gpack_id)
  call gcore_c_message_set_id(gpack_id)
#ifdef GAG_USE_GTK
  call gui_c_message_set_id(gpack_id)
#endif
  !
  ! Local language
  call load_greg('INTERACTIVE')
  ! Do not load GREG3!  call load_greg('LIBRARY GREG3')
  !
  if (.not.gmaster_hide_gui()) then
     call gr_exec('DEVICE IMAGE WHITE')
     error = gr_error()
     if (error) return
  endif
  !
end subroutine greglib_pack_init

subroutine get_weightmode(task,mode,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Decode the weighting mode
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task    ! Caller name
  character(len=*), intent(inout) :: mode ! Weighting mode
  logical, intent(out) :: error           ! Error flag
  !
  integer i,n
  character(len=8) :: argum
  character(len=8) :: vweight(3)=(/'NATURAL ','UNIFORM ','ROBUST  '/)
  !
  argum = mode
  call sic_get_char('MAP_WEIGHT',argum,n,error)
  call sic_upper (argum)
  call sic_ambigs (task,argum,mode,i,vweight,3,error)
  if (error) then
    call map_message(seve%e,task,'Invalid weight mode '//argum)
  else
    call map_message(seve%i,task,'Using '//vweight(i)//' weighting')
  endif
end subroutine get_weightmode

subroutine imager_tree(caller,endcall)
  use gbl_message
  use clean_default 
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! IMAGER
  !*
  !   @ private
  ! Printout debug message for callers when asked for
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: caller    !! Caller name
  logical, intent(in) :: endcall            !! .TRUE. on return
  !
  if (.not.call_debug) return
  !
  if (endcall) then
    call map_message(seve%i,'CALL_TREE','Finished '//caller,6)
  else
    call map_message(seve%i,'CALL_TREE','Calling  '//caller,6)
  endif
end subroutine imager_tree
!

!
subroutine major_clark (rname,method,head,   &
     &    beam,beam_nx,beam_ny,nx,ny,clean,resid,tfbeam,fcomp,   &
     &    wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, wfft, cct_list, list, nl, np, primary, weight,       &
     &    major_plot, next_flux)
  use imager_interfaces, except_this=>major_clark
  use clean_def
  use image_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for CLARK command  
  !   Major cycle loop according to B.Clark idea
  !!
  !----------------------------------------------------------------------
  external :: major_plot                        !! Major cycle Display
  external :: next_flux                         !! Cumulative flux display
  !
  character(len=*), intent(in) :: rname         !! Calling command
  type (clean_par), intent(inout) :: method     !! Method parameters
  type (gildas), intent(in)  :: head            !! Data header
  integer, intent(in) :: nx                     !! X size
  integer, intent(in) :: ny                     !! Y size
  integer, intent(in) :: beam_nx,beam_ny        !! Beam size
  integer, intent(in) :: np                     !! Number of pointings
  integer, intent(in) :: mcl                    !! Maximum number of clean components
  real, intent(inout) :: clean(nx,ny)           !! Clean map
  real, intent(inout) :: resid(nx,ny)           !! Residual map
  real, intent(in) ::    beam(beam_nx,beam_ny,np)         !! Dirty beams (per pointing)
  real, intent(in) ::    tfbeam(nx,ny,np)       !! FT. of dirty beams
  complex, intent(inout) :: fcomp(nx,ny)        !! FT. of components 
  real, intent(in) :: bgain                     !! Maximum sidelobe level
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: ixpatch, iypatch       !! Beam patch radius
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(inout) :: wfft(*)                !! Work space for FFT
  type(cct_lst), intent(inout) :: cct_list      !! Clean components array
  type(cct_par), intent(inout) :: wcl(mcl)      !! Work space for Clean components
  integer, intent(inout) :: list(nx*ny)         !! list of searchable pixels
  integer, intent(inout) :: nl                  !! Pixel list size
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight (nx,ny)            !! Flat field response
  !
  ! Local ---
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  real    lastabs              ! Check for oscillations
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real    clarkl               ! Clark worry limit
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer m_iter
  integer k, kcl
  character(len=message_length) :: chain
  !
  ! Code ----
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
  !
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
  else
    maxabs=abs(maxc)
  endif
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !  method%n_iter= 0       ! This is now set in the Call Sequence to allow re-starting
  m_iter = method%m_iter
  if (method%m_iter.eq.0) then
    method%m_iter = 2**30  ! A Large enough number
  else
    method%m_iter = m_iter
  endif
  flux = 0.0
  !
  ! Major cycle
  k = 0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%d,rname,chain)
    limite = max(maxabs*bgain,0.8*borne)
    clarkl = maxabs*bgain
    !
    kcl = mcl
    !
    ! Select points of maximum strength and load them in
    call choice (            &
     &      resid,           & ! Current residuals
     &      nx,ny,           & ! image size
     &      list, nl,        & ! Search list
     &      limite,          & ! Detection threshold
     &      kcl,             & ! Maximum number of candidates
     &      wcl,             & ! CCT
     &      ncl,             & ! Selected Number of components
     &      maxabs, method%ngoal)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%d,rname,chain)
      !
      ! Make minor cycles   ! Starting iteration ?
      call clark_minor (method,   &
     &        wcl,            &  ! CCT
     &        ncl,            &  ! Number of candidates
     &        beam,beam_nx,beam_ny,     &  ! Dirty beams and Size
     &        nx,ny,          &  ! Image size
     &        ixbeam,iybeam,  &  ! Beam center
     &        ixpatch,iypatch,&  ! Beam patch
     &        clarkl,limite,  &
     &        converge,       &  !
     &        cct_list,       &  ! Cumulated components
     &        np, primary, weight, method%trunca,   &
     &        flux,           &  ! Total Flux
     &        method%pflux, next_flux)
      !
      call compresswcl(wcl,ncl)
      !
      ! Remove all components by FT : RESID = RESID - BEAM # WCL(*,4)
      call remisajour (    &
     &        clean,       &    ! CLEAN map used as work space
     &        resid,       &    ! Updated residuals
     &        tfbeam,      &    ! Beam TF
     &        fcomp,       &    ! Work space for Component TF
     &        wcl,         &    ! CCT
     &        ncl,         &    ! Number of Clean Components
     &        nx,ny,       &    ! Map size
     &        wfft,        &    ! FFT work space
     &        np, primary, weight, method%trunca)
      write (chain,101)  'Cleaned ',flux,' Jy with ',method%n_iter,' clean components'
      call map_message(seve%i,rname,chain)
      !
      ! Find new extrema
      lastabs = maxabs
      call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      if (maxabs.gt.1.15*lastabs) then
        write(chain,'(a,1pg10.3,a,1pg10.3)') &
     &      'Detected beginning of oscillations',maxabs,' > ',lastabs
        call map_message(seve%w,rname,chain)
      endif
      !
      ! Check if converge
      fini = (maxabs.le.borne)   &
     &        .or. (method%m_iter.le.method%n_iter)   &
     &        .or. converge
    else
      ! No component found: finish...
      write(chain,101) 'No points selected above ',limite
      call map_message(seve%i,rname,chain)
      fini = .true.
    endif
    !
    ! Intermediate or final PLOT
    converge = fini
    call major_plot (method,head,              &
     &      converge,method%n_iter,nx,ny,np,   &
     &      cct_list%cc,clean,resid,weight)
    fini = converge
    !
    ! Limit number of major cycles...
    if (k.gt.method%n_major) fini = .true.
    !
  enddo
  method%m_iter = m_iter
  !
  ! End
  if (maxabs.le.borne) then
    call map_message(seve%i,rname,'Reached minimum flux density')
  elseif (method%m_iter.le.method%n_iter) then
    call map_message(seve%i,rname,'Reached maximum number of components')
  elseif (converge) then
    call map_message(seve%i,rname,'Reached minor cycle convergence')
  elseif (k.gt.method%n_major) then
    write(chain,'(I0)') method%n_major
    call map_message(seve%i,rname,'Reached maximum number of cycles '//chain)
  else
    call map_message(seve%i,rname,'End of transcendental causes')
  endif
  !
  100   format (a,i6,a,1pg10.3,a)
  101   format (a,1pg10.3,a,i7,a)
end subroutine major_clark
!
subroutine clark_minor (method, wcl, ncl,           &
     &    beam,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,ixpatch,iypatch,   &
     &    clarkmin,limite,converge,   &
     &    cct_list, np, primary, weight, wtrun, cum, pflux, next_flux )
  use gkernel_interfaces
  use imager_interfaces, except_this=>clark_minor
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- CLARK Internal routine  
  !   B.Clark minor cycles.
  !   Deconvolve as in standard clean a list of NCL points
  !   selected in the map until the residuals is less than CLARKMIN
  !!
  !----------------------------------------------------------------------
  external :: next_flux                         !! Cumulative flux display
  type (clean_par), intent(inout) :: method     !! Method parameters
  integer, intent(in) :: np                     !! Number of fields in mosaic
  integer, intent(in) :: ncl                    !! Number of pixels selected
  integer, intent(in) :: beam_nx,beam_ny        !! Beam size
  integer, intent(in) :: nx,ny,ixbeam,iybeam    !! Size and cente pixel of beam
  integer, intent(in) :: ixpatch,iypatch        !! Used size of beam
  real, intent(in) :: beam(beam_nx,beam_ny,np)  !! Dirty beams
  type(cct_par), intent(inout) :: wcl(*)        !! Clean components
  real, intent(in) :: clarkmin                  !! Stopping criterium for minor cycles
  real, intent(in) :: limite                    !! Clean Stopping criterium
  logical, intent(out) :: converge              !! Convergence indicator
  type (cct_lst), intent(inout) :: cct_list     !! Effective clean components
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams of mosaics
  real, intent(in) :: weight(nx,ny)             !! Effective weights on sky
  real, intent(in) :: wtrun                     !! Threshold of primary beam
  real, intent(inout) :: cum                    !! Cumulative flux
  logical, intent(in) :: pflux                  !! Plot cumulative flux
  !
  ! Local ---
  real gain                    ! CLEAN gain 
  logical goon                 ! Continue after convergence
  integer kcl                  ! Current Clean component
  integer nomax, nomin         ! Clean component of Max and Min 
  real rmax, rmin, sign, cdif  ! current Max and Min 
  real worry, xfac             ! Conservative and speedup factor
  integer kiter
  integer :: dimcum            ! Flux convergence control
  real, allocatable :: oldcum(:)
  real f, bmax
  integer n,ier,i,jiter
  logical abor
  character(len=20) comm
  !
  ! Code ----
  dimcum = method%converge
  allocate(oldcum(max(1,dimcum)),stat=ier)
  if (ier.ne.0) then
    Print *,'Convergence array allocation error ',ier,dimcum
    return
  endif
  oldcum = cum
  !
  abor = .false.
  do i=1,ncl
    wcl(i)%value = 0.0
  enddo
  gain = method%gain
  !
  call maxcct (wcl,ncl,nomin,rmin,nomax,rmax)
  !
  ! Remember the sign if cumulative
  if (cum.gt.0) then
    sign = 1.0
  else if (cum.lt.0) then
    sign = -1.0
  else
    sign = 0.0
  endif
  !
  ! Identify the max, and set the sign if not already done
  if (method%n_iter.lt.method%p_iter) then
    kcl=nomax
    rmax=abs(rmax)
    sign = 1.0
  elseif (abs(rmin).gt.rmax) then
    kcl=nomin
    rmax=abs(rmin)
    if (sign.eq.0) sign = -1.0
  else
    kcl=nomax
    rmax=abs(rmax)
    if (sign.eq.0) sign = 1.0
  endif
  !
  converge = rmax.le.limite
  worry = 1.0
  xfac = (clarkmin/rmax)**method%spexp
  kiter = 0
  goon = (method%n_iter.lt.method%m_iter) .and. (.not.converge)
  bmax = beam(ixbeam,iybeam,1)
  !
  do while (goon)
    method%n_iter = method%n_iter + 1
    kiter = kiter + 1
    if (np.gt.1) then
      f = gain * wcl(kcl)%influx* weight(wcl(kcl)%ix,wcl(kcl)%iy)
    else
      f = gain / bmax * wcl(kcl)%influx
    endif
    !
    ! Store clean component list
    cum = cum+f
    if (pflux) call next_flux(method%n_iter,cum,0)
    !
    if (method%n_iter.ge.cct_list%max_size) call cct_list%reallocate()
    wcl(kcl)%value = wcl(kcl)%value + f
    cct_list%cc(method%n_iter)%value = f    ! Store as fractions of beam max
    cct_list%cc(method%n_iter)%ix = wcl(kcl)%ix
    cct_list%cc(method%n_iter)%iy = wcl(kcl)%iy
    cct_list%cc(method%n_iter)%size = 0.
    cct_list%cur_size = method%n_iter
    !
    ! Subtract from iterated values VCL
    call clark_soustraire (wcl,ncl,           &
     &      beam,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,   &
     &      ixpatch,iypatch,kcl,gain,   &
     &      np,primary,weight,wtrun)
    !
    ! Find maximum again
    call maxcct (wcl,ncl,nomin,rmin,nomax,rmax)
    if (method%n_iter.lt.method%p_iter) then
      kcl=nomax
      rmax=abs(rmax)
    elseif (abs(rmin).gt.rmax) then
      kcl=nomin
      rmax=abs(rmin)
    else
      kcl=nomax
      rmax=abs(rmax)
    endif
    !
    ! B.CLARK Magic confidence factor
    worry = worry+xfac/float(kiter)
    !
    ! Check convergence
    abor = sic_ctrlc()
    goon = (rmax.gt.worry*clarkmin) .and. (rmax.gt.limite)   &
     &      .and. (method%n_iter.lt.method%m_iter)
    goon = goon .and. .not.abor
    if (dimcum.ne.0) then
      jiter = kiter-1 ! Not method%n_iter
      oldcum(mod(jiter,dimcum)+1) = cum
      if (jiter.ge.dimcum) then
        cdif = cum-oldcum(mod(jiter+1,dimcum)+1)
        converge = sign*cdif.lt.0.0
        goon = goon .and. .not.converge
      endif
    endif
  enddo
  !
  if (abor) then
    comm = ' '
    call sic_wprn('I-CLARK,  Enter last valid component ',comm,n)
    if (n.eq.0) return
    n = len_trim(comm)
    if (n.eq.0) return
    read(comm(1:n),*,iostat=ier) method%n_iter
    if (ier.ne.0) return
    converge = .true. ! It must be converged
    cct_list%cur_size = method%n_iter
  endif
end subroutine clark_minor
!
subroutine clark_soustraire (wcl,ncl,        &
     &    dirty,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,   &
     &    ixpatch,iypatch,kcl,gain,    &
     &    nf, primary, weight, wtrun)
  use clean_def
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER  --  CLEAN   Internal routine
  !
  ! Subtract the clean component, convolved with dirty beam
  ! restricted to beam patch, from the list of selected points.
  ! Smaller beam patches yield faster speed, but somewhat larger errors and
  ! thus slower convergence.
  !
  ! Caution : points must be ordered according I and J. In the current
  !   IMAGER implementation, this is done by routine "choice"
  ! The code cannot be parallelized, since it uses explicitely the ordering
  ! of the I and J values to stop exploring beyond the beam patch.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nf                   !! Number of fields
  integer, intent(in) :: ncl                  !! nombre de points retenus
  integer, intent(in) :: beam_nx,beam_ny      !! dimension du beam
  integer, intent(in) :: ixbeam,iybeam        !! centre du beam
  integer, intent(in) :: nx,ny                !! dimension des images
  real, intent(in) :: dirty(beam_nx,beam_ny,nf)    !! Dirty Beam
  integer, intent(in) :: ixpatch,iypatch      !! Beam patcj size
  type(cct_par), intent(inout) :: wcl(ncl)    !! Clean component list
  integer, intent(in) :: kcl                  !! No de la composante introduite
  real, intent(in) :: gain                    !! gain de clean
  real, intent(in) :: primary (nf,nx,ny)      !! Primary beams
  real, intent(in) :: weight (nx,ny)          !! Effective weights on sky
  real, intent(in) :: wtrun                   !! Weight truncation
  !
  ! Local ---
  logical condi,condj,cond     ! pour les boucles de soustraction
  integer no                   ! No du point courrant
  real f                       ! coefficient a retrancher
  integer k,l
  ! dans la carte du beam translatee sur la composante
  integer i0,j0, i,j, if, fo, lo, up, st, iloop
  !
  ! Code ----
  !
  ! Subtract current component
  !
  ! In large map pixels
  i0 = wcl(kcl)%ix
  j0 = wcl(kcl)%iy
  !
  f = gain * wcl(kcl)%influx
  wcl(kcl)%influx = wcl(kcl)%influx - f      ! This property is always true
  if (nf.gt.1) then
    f = f * weight(i0,j0)      ! Convert to Clean Component
  else
    f = f / dirty(ixbeam,iybeam,1)
  endif
  !
  lo = kcl + 1
  fo = kcl - 1
  ! Loop CANNOT be parallelized
  do iloop = 1,2
    if (iloop.eq.1) then
      ! Subtract from current component to last valid.
      lo = kcl+1
      up = ncl
      st = 1
    else
      ! Now subtract from first valid to current component
      lo = kcl-1
      up = 1
      st = -1
    endif
    do no = lo,up,st
      i = wcl(no)%ix
      j = wcl(no)%iy
      k = i-i0
      l = j-j0
      condi = abs(k) .lt. ixpatch
      condj = abs(l) .lt. iypatch
      cond  = condi .or. condj
      if (.not.cond) exit
      !
      if (condi.and.condj) then
        k = k+ixbeam
        l = l+iybeam
        !
        if ( (k.gt.0 .and. k.le.nx)   &
         &  .and. (l.gt.0 .and. l.le.ny) ) then
          if (nf.gt.1) then
            do if = 1,nf
              if (primary(if,i,j).gt.wtrun) then
                wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,if)   &
         &              *primary(if,i0,j0)*primary(if,i,j)   &
         &              *weight(i,j)
              endif
            enddo
          else
            wcl(no)%influx = wcl(no)%influx - f*dirty(k,l,1)
          endif
        endif
      endif
    enddo
  enddo
  !
end subroutine clark_soustraire
!

!>
! This file contains all WRITE command related subroutines
!
! MOSAIC> writ beam toto /app
! E-WRITE /APPEND,  BEAM         is not contiguous, starts at 1
! E-WRITE,  failed to complete
!!
subroutine write_comm (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>write_comm
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !*
  !   Support routine for command
  !
  !   WRITE Type File [/RANGE Start End Kind] [/TRIM]
  !       [/APPEND] [/REPLACE]
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Error return code
  ! 
  ! Constants
  integer, parameter :: o_append=1
  integer, parameter :: o_range=2
  integer, parameter :: o_replace=3
  integer, parameter :: o_trim=4  
  character(len=*), parameter :: rname='WRITE'
  character(len=12) :: allowed(3)
  data allowed /'GILDAS','FITS','CSV'/
  !
  ! Local ---
  integer :: mgap
  integer ntype, nc(2), mc(2), larg, is, nk
  character(len=varname_length) argu,atype,crange
  character(len=filename_length) :: name
  real(8) :: drange(2)
  logical :: err
  character(len=12) :: key
  !
  ! Code ----
  call sic_ke (line,0,1,argu,larg,.true.,error)
  if (error) return
  if (argu.eq.'?') then
    call sic_ambigs_list(rname,seve%i,'Choices are:',vtype,vwrite)
    return
  elseif (argu.eq.'UV') then
    argu = 'UV_DATA'
  endif
  !
  write_format = write_default
  if (sic_present(0,3)) then
    call sic_ke(line,0,3,key,nk,.true.,error)
    if (error) return
    if (key(1:nk).eq.allowed(1)(1:nk)) then
      write_format = write_gildas
    else if (key(1:nk).eq.allowed(2)(1:nk)) then
      if (sic_present(o_append,0).or.sic_present(o_replace,0) ) then
        call map_message(seve%e,rname,'Option /REPLACE and /APPEND invalid for FITS format')
        error = .true.
      endif
      write_format = write_fits
    else if (key(1:nk).eq.allowed(3)(1:nk)) then
      write_format = write_csv
    else
      call map_message(seve%e,rname,'Unknown ouput data format, only FITS and GILDAS allowed')
      error = .true.
      return  
    endif
  endif
  !  
  call sic_ch (line,0,2,name,larg,.true.,error)
  if (error) return
  drange = 0.0
  crange  = 'NONE'
  nc = 0
  !
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,crange,larg,.true.,error)
    if (error) return
  endif
  !
  if (sic_present(o_replace,0)) then
    call sic_ambigs (rname,argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    if (atype.eq.'UV_DATA') then
      call map_message(seve%e,rname,'Replacing channels in UV data is not allowed')
      error = .true.
      return
    else
      call map_message(seve%e,rname,'Replacing channels in '//atype) 
      call sub_replace_image(name,ntype,nc,error)
    endif
  else if (sic_present(o_append,0)) then
    call sic_ambigs (rname,argu,atype,ntype,vtype,mtype,error)
    if (error) return
    !
    mgap = 1
    call sic_i4(line,o_append,1,mgap,.false.,error)
    if (error) return
    if (mgap.le.0 .or. mgap.gt.1000) then
      call map_message(seve%e,rname,'Maximum gap size out of [0,1000] range')
      error =.true.
      return
    endif
    call sub_append_image(name,ntype,nc,mgap,error)
    return
  else
    !
    if (argu.eq.'*') then
      if (crange.ne.'NONE') then
        call map_message(seve%e,rname, &
          & '/RANGE option not supported for WRITE *')
        error = .true.
        return
      endif
      do ntype=1,mtype
        if (save_data(ntype)) then
          if (vtype(ntype).eq.'UV_DATA') then
            call map_message(seve%w,rname,'Ignoring modified '//vtype(ntype))
          else
            call map_message(seve%i,rname,'saving '//vtype(ntype))
            mc = 0
            call sub_write_image(name,vtype(ntype),ntype,mc,.true.,err)
            error = error.or.err
          endif
        endif
      enddo
    else
      !
      ! Code for exact name matching
      atype = argu
      ntype = 0
      do is=1,mtype
        if (argu.eq.vtype(is)) then
          ntype = is
          atype = vtype(ntype)
          exit
        endif
      enddo
      !! call sic_ambigs (' ',argu,atype,ntype,vtype,mtype,error)
      !! if (error) then
      if (ntype.eq.0) then
        error = .false.
        atype = argu
        call map_message(seve%w,rname,'Attempting to write SIC image '//trim(atype))
      else
        atype = vtype(ntype)
      endif
      !
      if (atype.eq.'MOMENTS') then
        if (crange.ne.'NONE') then
          call map_message(seve%e,rname,'/RANGE option not supported for ' &
              & //' WRITE MOMENTS')
          error = .true.
          return
        endif
        !
        call sub_write_moments(name,error)
        return
      else if (atype.eq.'FLUX') then
        if (crange.ne.'NONE') then
          call map_message(seve%e,rname,'/RANGE option not supported for ' &
              & //' WRITE FLUX')
          error = .true.
          return
        endif
        !
        call sub_write_flux(name,error)
        return
      else if (atype.eq.'UV_DATA') then
        ! Find the range
        call out_range(rname,crange,drange,nc,huv,error)
        if (error) return
      else if (atype.eq.'MODEL_UV') then
        ! Find the range
        call out_range(rname,crange,drange,nc,huvm,error)
        if (error) return
      else if (crange.ne.'NONE') then
       !      if (atype.ne.'CLEAN') then
        call map_message(seve%e,rname,'/RANGE option not supported for ' &
            & //atype)
        error = .true.
        return
      endif
      !  endif
      !
      call sub_write_image(name,atype,ntype,nc,.false.,error)
    endif
  endif
  !
end subroutine write_comm
!
subroutine sub_write_image (name,atype,ntype,nc,quiet,error)
  use gkernel_interfaces, no_interface=>gdf_write_image
  use imager_interfaces, except_this=>sub_write_image
  use clean_def
  use clean_arrays
  use clean_default
  use clean_support
  use clean_types
  use uvfit_data
  use gkernel_types
  use gbl_format
  use gbl_message
  use iso_c_binding
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !*
  !   Support routine for command
  !
  !   WRITE Type File [/RANGE Start End Kind] [/TRIM]
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name    !! File name 
  character(len=*), intent(in) :: atype   !! TYPE of data
  integer, intent(in) :: nc(2)            !! Channel range
  integer, intent(in) :: ntype            !! Type of file
  logical, intent(in) :: quiet            !! Do not return error if set
  logical, intent(out) :: error           !! Error return code
  !
  ! Constants
  character(len=*), parameter :: rname='WRITE'
  integer, parameter :: o_trim=4    ! /TRIM option number
  !
  ! Local ---
  character(len=32) :: dtype
  type (gildas) :: hin
  logical subset, trim_uv, trim_uvany
  character(len=filename_length) :: file
  type(sic_descriptor_t) :: desc
  type(c_ptr) :: cptr
  real(4), pointer :: aptr(:)
  integer :: n
  !
  ! Code ----
  subset = .false.
  !
  ! WRITE SUPPORT or POLYGON
  if (atype.eq.'SUPPORT') then
    call greg_poly_write(rname,supportpol,name,error)
    return
  else if (atype.eq.'POLYGON') then
    call gr_exec('WRITE POLYGON '//trim(name))
    return
  endif
  !
  dtype = etype(ntype)
  if (ntype.ne.0) then
    dtype = etype(ntype)
  else
    dtype = '.gdf'
  endif
  call sic_parse_file (name,' ',dtype,file)
  !
  if (write_format.ge.write_fits) then
    n = len_trim(file)-len_trim(dtype)+1
    if (file(n:).eq.dtype) then
      if (atype.eq.'UV_DATA') then
        file(n:) = '.uvfits'
      else
        file(n:) = '.fits'
      endif
    endif
  endif
  !
  select case(atype)
  case ('UV_DATA')
    !
    trim_uv = sic_present(o_trim,0)
    trim_uvany = sic_present(o_trim,1)
    !
    select case (current_uvdata)
    case('DATA_UV')
      call sub_write_uvset(file, themap%nfields, nc, huv, duv, trim_uv, trim_uvany, error, dchanflag)
      if (error) return
      if (.not.trim_uv) then
        call sub_setmodif(file,optimize(code_save_uv),nc)
      endif
      save_data(code_save_uv) = .false.
    case ('RESIDUAL_UV')
      call sub_write_uvset(file, themap%nfields, nc, huvf, duvf, trim_uv, trim_uvany, error)
    case ('MODEL_UV')
      call sub_write_uvset(file, themap%nfields, nc, huvm, duvm, trim_uv, trim_uvany, error)
    end select
    return ! This is a special case
  case ('MODEL_UV')
    if (huvm%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Model UV data undefined ')
      error = .true.
      return
    endif
    call sub_write_uvset(file, themap%nfields, nc, huvm, duvm, trim_uv, trim_uvany, error)
  case ('CGAINS')
    if (hbgain%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Baseline Gains CGAINS undefined ')
      error = .true.
      return
    endif
    call sub_write_uvdata(file,nc,hbgain,duvbg,error)
  case ('SELFCAL')
    if (hagain%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Antenna Gains AGAINS undefined ')
      error = .true.
      return
    endif
    hagain%file = file
    call imager_write_data(hagain,dagain,error)
  case ('BEAM')
    if (hbeam%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'BEAM image undefined ')
      error = .true.
      return
    endif
    hbeam%file = file
    call imager_write_data(hbeam,dbeam,error)
  case ('DIRTY')
    if (hdirty%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'DIRTY image undefined ')
      error = .true.
      return
    endif
    hdirty%file = file
    call imager_write_data(hdirty,ddirty,error)
  case ('CLEAN')
    if (hclean%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'CLEAN image undefined ')
      error = .true.
      return
    endif
    hclean%file = file
    if (subset) then
      hclean%blc(3) = nc(1)
      hclean%trc(3) = nc(2)
      call gdf_update_image(hclean,dclean(1,1,nc(1)),error)
      hclean%blc(3) = 0
      hclean%trc(3) = 0
    else
      call imager_write_data(hclean,dclean,error)
    endif
  case ('RESIDUAL')
    if (hresid%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'RESIDUAL image undefined ')
      error = .true.
      return
    endif
    hresid%file = file
    call imager_write_data(hresid,dresid,error)
  case ('MASK')
    if (hmask%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'MASK image undefined ')
      error = .true.
      return
    endif
    hmask%file = file
    call imager_write_data(hmask,dmask,error)
  case ('CCT')
    if (hcct%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Clean Component Table (CCT) undefined ')
      error = .true.
      return
    endif
    call cct_write(file,error)
  case ('PRIMARY')
    if (hprim%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Primary BEAM image undefined ')
      error = .true.
      return
    endif
    hprim%file = file
    call imager_write_data(hprim,dprim,error)
  case ('SKY')
    if (hsky%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'SKY brightness image undefined ')
      error = .true.
      return
    endif
    hsky%file = file
    if (subset) then
      hsky%blc(3) = nc(1)
      hsky%trc(3) = nc(2)
      call gdf_update_image(hsky,dsky(1,1,nc(1)),error)
      hsky%blc(3) = 0
      hsky%trc(3) = 0
    else
      call imager_write_data(hsky,dsky,error)
    endif
  case ('FIELDS')
    call create_fields(error)
    if (hfields%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'Primary FIELDS image undefined ')
      error = .true.
      return
    endif
    hfields%file = file
    call imager_write_data(hfields,dfields,error)
  case ('UV_FIT') 
    if (huvfit%loca%size.eq.0) then
      if (quiet) return
      call map_message(seve%e,rname,'No UV_FIT table')
      error = .true.
      return
    endif
    huvfit%file = file
    call imager_write_data(huvfit,duvfit,error)
    return 
  case default
    ! Write any SIC Image variable
    call get_gildas(rname,atype,desc,hin,error)
    if (error) return
    !
    if (desc%size.eq.0) then
      call map_message(seve%e,rname,'Variable '//atype//' has no size')
      error = .true.
      return
    endif
    !
    call adtoad(desc%addr,cptr,1)
    call c_f_pointer(cptr,aptr,[desc%size])
    hin%file = file
    call imager_write_data(hin,aptr,error)
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_write_image
!
subroutine sub_setmodif (file,opti,nc)
  use gkernel_types
  use clean_types
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !*
  !   Utility routine for READ and WRITE
  !
  !   Update the Read / Write optimization status
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file  !
  ! Filename
  type(readop_t), intent(inout) :: opti 
  !! Status of corresponding buffer
  integer, intent(in) :: nc(2)          
  !! Channel Range to be read
  !
  logical :: error
  !
  if (any(nc.ne.0)) then
    !
    ! Subset write: the internal buffer is not the written file
    return
  else
    ! Whole write: the buffer and the written file match exactly
    ! so one can reset the corresponding "optimize" structure
    ! with this new file.  However, this does not guarantee a full
    ! read optimization here, as the input file and output file may
    ! have different names (but be identical).
    !
    call gag_filmodif(file,opti%modif,error)
  endif
end subroutine sub_setmodif
!
subroutine write_cct(file,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !*
  !   Support routine for command
  !
  !   WRITE CCT File [/RANGE Start End Kind]
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: file    !! Input file name
  logical, intent(out) :: error           !! Error return code
  !
  logical, parameter :: OLD=.false. ! Set to .true. to usee older code...
  !
  type (gildas) :: htcc
  integer :: mclean,i
  !
  ! Define the image header
  call gildas_null (htcc, type = 'IMAGE')
  !
  if (OLD) then
    call gdf_copy_header (hdirty,htcc, error)
    htcc%gil%ndim = 3
    htcc%char%unit = 'Jy'
    !
    htcc%gil%dim(1) = 3
    ! Keep the same axis description
    htcc%gil%xaxi = 1
    !
    htcc%gil%convert(:,2) = hdirty%gil%convert(:,3)
    htcc%gil%convert(:,3) = hdirty%gil%convert(:,2)
    htcc%gil%dim(2) = hdirty%gil%dim(3)
    htcc%char%code(2) = hdirty%char%code(3)
    htcc%gil%faxi = 2
    !
    htcc%gil%dim(3) = ubound(dcct,3)
    htcc%char%code(3) = 'COMPONENT'
    htcc%gil%yaxi = 3
    !
  else
    call gdf_copy_header (hcct,htcc, error)
  endif
  htcc%file = file
  mclean = htcc%gil%dim(3)
  do i=1,htcc%gil%dim(3)
    if (all(dcct(:,:,i).eq.0)) then
      mclean = i-1
      exit
    endif
  enddo
  !
  ! Initialize BLCs...
  htcc%blc = 0
  htcc%trc = 0
  htcc%gil%dim(3) = max(mclean,1)  ! At least one (possibly empty) component
  call gdf_write_image(htcc,dcct(:,:,1:mclean),error)
  !
end subroutine write_cct
!
subroutine sub_write_uvdata(file,nc,uvin,visi,error, mv, ivis, cflag)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, sub_extract_block
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !*
  !   Utility routine for WRITE command
  !
  !   Write a subset of the loaded UV data
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file    !! Input file name
  integer, intent(in) :: nc(2)            !! Channel range
  type(gildas), intent(in) :: uvin        !! UV data header
  real, intent(in) :: visi(:,:)           !! Visibilities
  logical, intent(out) :: error           !! Logical error flag
  integer, intent(in), optional :: mv     !! Number of visibilities
  integer, intent(in), optional :: ivis(:)    !! Visibility pointers 
  integer, intent(in), optional :: cflag(:)   !! Channel flags
  !
  ! Local ---
  type (gildas) :: uvou
  integer :: blc, trc, ib, iv, nblock, ier, i, ic
  integer(kind=index_length) :: nvisi
  logical :: all, do_zero
  character(len=80) :: mess
  !
  ! Code ----
  call gildas_null(uvou, type= 'UVT')
  call gdf_copy_header(uvin, uvou, error)
  if (error) return
  call sic_parse_file(file,' ','.uvt',uvou%file)
  !
  uvou%gil%ntrail = 0
  call gdf_setuv(uvou,error)
  !
  ! Flagged channels
  do_zero = .false.
  if (present(cflag)) then
    if (any(cflag.eq.0)) do_zero = .true.
  endif
  if (do_zero) call map_message(seve%i,'WRITE','Nullifying filtered channels')
  !
  ! Nullify the Blanking
  uvou%gil%blan_words = 0
  !
  uvou%gil%nchan = nc(2)-nc(1)+1
  uvou%gil%ref(1) = uvin%gil%ref(1)-nc(1)+1
  uvou%gil%dim(1) = uvou%gil%nlead + uvou%gil%nstokes*uvou%gil%natom*uvou%gil%nchan + uvou%gil%ntrail
  uvou%gil%lcol = uvou%gil%nlead + uvou%gil%nstokes*uvou%gil%natom*uvou%gil%nchan 
  !
  all = uvou%gil%nchan.eq.uvin%gil%nchan
  if ((all .and. .not.present(mv)).and..not.do_zero) then
    !
    call imager_write_data(uvou,visi,error)
  else
    ! Only write a subset, either by trimming or by channels, or by Zeroing
    ! channels, or any combination at once...
    !
    ! Define blocking factor
    if (present(mv)) then
      uvou%gil%nvisi = mv
      uvou%gil%dim(2) = mv
    endif
    call gdf_nitems('SPACE_GILDAS',nblock,uvou%gil%dim(1)) ! Visibilities at once
    nblock = min(nblock,uvou%gil%dim(2))
    ! Allocate space
    allocate (uvou%r2d(uvou%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error ',uvou%gil%dim(1), nblock
      call map_message(seve%e,'WRITE',mess)
      error = .true.
      return
    endif
    !
    ! Shift trailing columns if any
    if (uvou%gil%ntrail.ne.0) then
      do i=1,code_uvt_last
        if (uvou%gil%column_pointer(i).gt.uvou%gil%lcol) then
          uvou%gil%column_pointer(i) = uvou%gil%column_pointer(i)-uvin%gil%lcol+uvou%gil%lcol
        endif
      enddo
    endif    
    !
    call gdf_create_image(uvou,error)
    if (error) then
      deallocate(uvou%r2d,stat=ier)
      call gdf_close_image(uvou,error)
      error = .true.
      return
    endif
    ! Loop over UV table
    uvou%blc = 0
    uvou%trc = 0
    do ib = 1,uvou%gil%dim(2),nblock
      write(mess,*) ib,' to ',ib+nblock-1,' / ',uvou%gil%dim(2)
      call map_message(seve%i,'WRITE',mess)
      blc = ib
      trc = min(uvou%gil%dim(2),ib-1+nblock)
      uvou%blc(2) = blc
      uvou%trc(2) = trc
      nvisi = trc-blc+1
      !
      ! Here do the job
      if (present(mv)) then
        do iv=blc,trc
          if (all) then
            uvou%r2d(:,iv-blc+1) = visi(:,ivis(iv))
          else
            call sub_extract_block(uvou, uvou%r2d(:,iv-blc+1), uvin, &
              &   visi(:,ivis(iv)), nvisi, nc)
          endif
        enddo
      else
        call sub_extract_block(uvou, uvou%r2d, uvin, visi(:,blc:trc), &
          & nvisi, nc)
      endif
      !
      if (do_zero) then
        ! cflag  corresponds to the original Channels
        ! we have a subset shifted by NC(1)
        do iv=1,nvisi
          do ic=1,uvou%gil%nchan
            if (cflag(ic+nc(1)-1).eq.0) uvou%r2d(5+3*ic:7+3*ic,iv) = 0.
          enddo
        enddo
      endif
      !
      ! Write
      call gdf_write_data(uvou, uvou%r2d, error)
    enddo
    call gdf_close_image(uvou,error)
    deallocate(uvou%r2d,stat=ier)
  endif
  !
end subroutine sub_write_uvdata
!
subroutine sub_extract_block(out, dout, in, din, nvisi, nc)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- Utility routine for WRITE command
  !   
  !   Extract a subset block of UV data
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out                   !! Output UV header
  type(gildas), intent(in) :: in                    !! Input UV header
  integer(kind=index_length) :: nvisi               !! Number of visibilities
  real, intent(in) :: din(in%gil%dim(1),nvisi)      !! Input visibilities
  real, intent(out) :: dout(out%gil%dim(1),nvisi)   !! Output visibilities
  integer, intent(in) :: nc(2)                      !! Channel range
  !
  ! Local ---
  integer :: iv, icf, icl, jcf, jcl
  !
  ! Code ----
  icf = in%gil%nlead+(nc(1)-1)*in%gil%natom+1
  icl = in%gil%nlead+nc(2)*in%gil%natom
  jcf = out%gil%nlead+1
  jcl = out%gil%nlead+out%gil%nchan*out%gil%natom
  !
  do iv=1,nvisi
    dout(1:in%gil%nlead,iv) = din(1:in%gil%nlead,iv)
    dout(jcf:jcl,iv) = din(icf:icl,iv)
    if (out%gil%ntrail.gt.0) then
      dout(out%gil%dim(1)-out%gil%ntrail+1:out%gil%dim(1),iv) =   &
      &     din(in%gil%dim(1)-in%gil%ntrail+1:in%gil%dim(1),iv)
    endif
  enddo
end subroutine sub_extract_block
!
subroutine sub_replace_image (name,ntype,nc,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_replace_image
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- Support routine for command
  ! 
  !   WRITE Type File /REPLACE 
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name      !! Short file name
  integer, intent(in) :: nc(2)              !! Channel range
  integer, intent(in) :: ntype              !! Type of data
  logical, intent(out) :: error             !! Error return flag
  !
  character(len=*), parameter :: rname='WRITE /REPLACE'
  !
  ! Local ---
  character(len=12) atype
  character(len=filename_length) :: file
  !
  ! Code ----
  if (write_format.ge.write_fits) then
    call map_message(seve%e,'WRITE','FITS format not yet supported for /REPLACE')
    error = .true.
    return
  endif
  !
  atype = vtype(ntype)
  call sic_parse_file (name,' ',etype(ntype),file)
  !
  select case(atype)
  case ('BEAM')
    if (hbeam%gil%dim(3).ne.1) then
      if (hbeam%gil%dim(4).ne.1) then
        call map_message(seve%e,rname,'Multi-frequency beams not yet supported for mosaics')
        error = .true.
      else
        call sub_replace(atype,file,dbeam(:,:,:,1),hbeam,error)
      endif
    else
      call map_message(seve%w,rname,'Single beam plane only')
    endif  
  case ('DIRTY')
    call sub_replace(atype,file,ddirty,hdirty,error)
  case ('CLEAN')
    call sub_replace(atype,file,dclean,hclean,error)
  case ('RESIDUAL')
    call sub_replace(atype,file,dresid,hresid,error)
  case ('MASK')
    call sub_replace(atype,file,dmask,hmask,error)
  case ('CCT')      !! The structure is quite different here
    call map_message(seve%e,'WRITE','Type '//atype//' not yet supported for /REPLACE')
    error = .true.
    return
    ! to be done !    call sub_replace(atype,file,dcct,hcct,error)
  case ('SKY')
    call sub_replace(atype,file,dsky,hsky,error)
  case default
    call map_message(seve%e,'WRITE','Unsupported type '//atype//' for /REPLACE')
    error = .true.
    return
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_replace_image
!
subroutine sub_replace(name,file,data,head,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for WRITE /REPLACE
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: name      !! Name of buffer
  character(len=*), intent(in) :: file      !! File name
  type(gildas), intent(inout) :: head       !! Header of buffer
  real(kind=4), intent(in) :: data(:,:,:)   !! Data cube
  logical, intent(inout) :: error           !! Error return flag
  !
  ! Constants
  character(len=*), parameter :: rname='WRITE /REPLACE'
  real(8), parameter :: epsilon=1d-5
  !
  ! Local ---
  type(gildas) :: hall
  integer :: imin, imax, itmp
  real(8) :: rval, velo
  character(len=64) :: chain
  !
  ! Code ----
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,name//' image undefined ')
    error = .true.
    return
  endif
  !
  call gildas_null(hall)
  hall%file = file
  call gdf_read_header(hall,error)
  if (error) return
  !
  ! Basic checks of coordinates
  if ( any(head%gil%dim(1:2).ne.hall%gil%dim(1:2)) ) then
    call map_message(seve%e,rname,'Dimensions do not match')
    error = .true.
  endif
  if ( any(head%gil%convert(:,1:2).ne.hall%gil%convert(:,1:2)) ) then
    call map_message(seve%e,rname,'Positions do not match')
    Print *,'Head ',head%gil%convert(:,1:2)
    Print *,'Hout ',hall%gil%convert(:,1:2)
    Print *,'Difference ',head%gil%convert(:,1:2)-hall%gil%convert(:,1:2)
    error = .true.
  endif
  !
  if ( abs(head%gil%inc(3)).ne.abs(hall%gil%inc(3)) ) then
    call map_message(seve%e,rname,'Frequency resolution do not match')
    error = .true.
  endif
  if (error) return
  !
  ! Check which range in the file is needed - Match the velocities
  velo = (1.d0-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imin = nint(rval)
  !
  if (abs(dble(imin)-rval).gt.epsilon*abs(head%gil%inc(3))) then
    call map_message(seve%e,rname,'Frequency axis does not match')
    error = .true.
  endif
  if (error) return
  !
  velo = (head%gil%dim(3)-head%gil%ref(3))*head%gil%inc(3) + head%gil%val(3)
  rval = (velo-hall%gil%val(3))/hall%gil%inc(3) + hall%gil%ref(3)
  imax = nint(rval)
  !
  if (imin.gt.imax) then
    itmp = imin
    imin = imax
    imax = itmp
  endif
  !
  if (imin.lt.1 .or. imax.gt.hall%gil%dim(3)) then
    write(chain,'(A,A,I0,A,I0)') name,' falls in range ',imin,',',imax
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  endif
  !
  hall%blc(3) = imin
  hall%trc(3) = imax
  !
  call gdf_update_image(hall,data,error)
end subroutine sub_replace
!
subroutine sub_append_image (name,ntype,nc,mgap,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_append_image
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use gbl_format
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- Support outine for command
  !
  !   WRITE Type File /APPEND  [MaxGap]
  !
  ! Dispatch the writing operation to specific subroutines depending
  ! on the Type of data to be written
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: name      !! Short file name
  integer, intent(in) :: nc(2)              !! Channel range
  integer, intent(in) :: ntype              !! Type of buffer
  logical, intent(out) :: error             !! Error return flag
  integer, intent(in) :: mgap               !! Maximum Gap size 
  !! This is to avoid attempting to stitch together
  !! Cubes with very different 3rd axis, but still allow reasonable
  !! concatenation
  !
  ! Constants
  character(len=*), parameter :: rname='WRITE /REPLACE'
  !
  ! Local ---
  character(len=12) atype
  character(len=filename_length) :: file
  !
  ! Code ----
  atype = vtype(ntype)
  call sic_parse_file (name,' ',etype(ntype),file)
  !
  select case(atype)
  case ('BEAM')
    if (hbeam%gil%dim(3).ne.1) then
      if (hbeam%gil%dim(4).ne.1) then
        call map_message(seve%e,rname,'Multi-frequency beams not yet supported for mosaics')
        error = .true.
      else
        call sub_append(atype,file,dbeam(:,:,:,1),hbeam,mgap,error)
      endif
    else
      call map_message(seve%w,rname,'Single beam plane only')
    endif  
  case ('DIRTY')
    call sub_append(atype,file,ddirty,hdirty,mgap,error)
  case ('CLEAN')
    call sub_append(atype,file,dclean,hclean,mgap,error)
  case ('RESIDUAL')
    call sub_append(atype,file,dresid,hresid,mgap,error)
  case ('MASK')
    call sub_append(atype,file,dmask,hmask,mgap,error)
  case ('CCT')   !! The structure is quite different here
    call map_message(seve%w,'WRITE','Type '//atype//' not yet debugged for /APPEND',1)
    call cct_append(file,dcct,hcct,mgap,error)
    !no longer!    error = .true.
    !no longer!    return
  case ('SKY')
    call sub_append(atype,file,dsky,hsky,mgap,error)
  case default
    call map_message(seve%e,'WRITE','Unsupported type '//atype//' for /APPEND')
    error = .true.
    return
  end select
  !
  ! Set the Read/Write optimization and Save status
  call sub_setmodif(file,optimize(ntype),nc)
  save_data(ntype) = .false.
  !
end subroutine sub_append_image
!<FF>
subroutine sub_append(name,file,data,head,mgap,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, gdf_match_header
  !-------------------------------------------------------
  ! @ private
  !*
  !   Support routine for WRITE /APPEND
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: name      !! Name of buffer
  character(len=*), intent(in) :: file      !! File name
  type(gildas), intent(inout) :: head       !! Header of buffer
  real(kind=4), intent(in) :: data(:,:,:)   !! Data
  integer, intent(in) :: mgap               !! Max Gap size
  logical, intent(inout) :: error           !! Error return flag
  !
  ! Constants
  character(len=*), parameter :: rname='WRITE /APPEND'
  real(8), parameter :: epsilon=1d-5
  !
  ! Local ---
  type(gildas) :: hall
  integer :: imin, imax, igap, faxi
  logical :: err
  character(len=128) :: chain
  integer(kind=index_length) :: newdim  ! New value of last dimension
  integer(kind=index_length) :: olddim  ! New value of last dimension
  real, allocatable :: dnull(:,:,:)
  integer :: ier
  !
  ! Code ----
  if (head%loca%size.eq.0) then
    call map_message(seve%e,rname,name//' image undefined ')
    error = .true.
    return
  endif
  !
  call gildas_null(hall)
  hall%file = file
  call gdf_read_header(hall,error)
  if (error) return
  !
  call gdf_match_header(head,hall,mgap,imin,imax,igap,error)
  ! Close this image - Extend works on a new Slot because of size
  err = .false.
  call gdf_close_image(hall,err)
  if (error) return
  !
  newdim = imax + igap         ! Append channels
  faxi = hall%gil%faxi
  !
  ! Extend image - image is left open
  olddim = hall%gil%dim(faxi)
  write(chain,'(A,A,I0,A)') name,' extended to ',newdim, ' channels' 
  call map_message(seve%i,rname,chain)
  call gdf_extend_image (hall,newdim,error)
  if (error) then
    call map_message(seve%e,rname,'Extension failed')
    return
  endif
  !
  ! Write Gap if needed
  if (igap.gt.0) then
    hall%blc(faxi) = olddim+1
    hall%trc(faxi) = imin+igap
    allocate(dnull(hall%gil%dim(1),hall%gil%dim(2),igap-1),stat=ier)
    dnull = 0.
    call gdf_write_data(hall,dnull,err)
  endif
  !
  ! Write in place (will replace possible overlap here)
  hall%blc(faxi) = newdim-min(head%gil%dim(faxi),newdim-olddim)+1
  hall%trc(faxi) = newdim
  call gdf_write_data(hall,data,error)
  if (error) then
    call map_message(seve%e,rname,'Data writing failed after extension')
  endif
  ! Close image
  err = .false.
  call gdf_close_image (hall,err)
end subroutine sub_append
!
subroutine sub_write_moments(name,error)
  use gkernel_interfaces
  use moment_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for WRITE MOMENTS 
  !
  !   4 separate files are written in this case.
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: name  !! Short file name
  logical, intent(inout) :: error       !! Error return flag
  !
  character(len=*), parameter :: rname='WRITE MOMENTS'
  !
  error = .false.
  if (hmean%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_AREA buffer')
    error = .true.
  endif
  if (hpeak%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_PEAK buffer')
    error = .true.
  endif
  if (hvelo%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_VELO buffer')
    error = .true.
  endif
  if (hwidth%loca%size.eq.0) then
    call map_message(seve%e,rname,'No M_WIDTH buffer')
    error = .true.
  endif
  if (error) return
  !
  call sic_parse_file (name,' ','.area',hmean%file)
  call imager_write_data(hmean,dmean,error)
  call sic_parse_file (name,' ','.peak',hpeak%file)
  call imager_write_data(hpeak,dpeak,error)
  call sic_parse_file (name,' ','.velo',hvelo%file)
  call imager_write_data(hvelo,dvelo,error)
  call sic_parse_file (name,' ','.width',hwidth%file)
  call imager_write_data(hwidth,dwidth,error)
end subroutine sub_write_moments
! 
!
subroutine sub_write_flux(name,error)
  use gkernel_interfaces
  use moment_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for WRITE FLUX  
  !!
  !-------------------------------------------------------
  character(len=*), intent(in) :: name    !! Short file name
  logical, intent(inout) :: error         !! Error return flag
  !
  character(len=*), parameter :: rname='WRITE FLUX'
  !
  type(gildas) :: htab
  integer :: ier
  !
  if (flux_nf.eq.0) then
    call map_message(seve%e,rname,'No FLUX data, use command FLUX to create one')
    error = .true.
    return
  endif
  !
  call gildas_null(htab)
  call sic_parse_file (name,' ','.tab',htab%file)
  htab%gil%ndim = 2
  htab%gil%dim(1) = flux_nc
  htab%gil%dim(2) = flux_nf+2
  allocate (htab%r2d(htab%gil%dim(1),htab%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif  
  !
  htab%r2d(:,1) = flux_velo
  htab%r2d(:,2) = flux_freq  ! Loss of precision, but tolerable in most cases.
  htab%r2d(:,3:) = flux_values
  !
  call gdf_write_image(htab,htab%r2d,error)
  deallocate(htab%r2d)
end subroutine sub_write_flux
!
subroutine sub_write_uvset(file, nfields, nc, huvl, visi, trim_uv, trim_uvany, error, cflag)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message, sub_write_uvdata
  !---------------------------------------------------------------------
  ! @ private
  !
  !*
  !   IMAGER -- Support routine for WRITE UV
  !
  !   Write the Currently Selected UV data set
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: file          !! Output file name
  integer, intent(in) :: nc(2)                  !! Channel range
  type(gildas), intent(in) :: huvl              !! UV data header 
  real, intent(in) :: visi(:,:)                  !! UV data
  integer, intent(in) :: nfields                !! Number of fields
  logical, intent(in) :: trim_uv, trim_uvany    !! trimming options
  logical, intent(out) :: error                 !! Error return
  integer, intent(in), optional :: cflag(:)     !! Per Channel flags
  !
  character(len=*), parameter :: rname='WRITE UV'
  !
  ! Local ---
  integer(kind=index_length) :: iv,nv,im
  integer, allocatable :: ivis(:)
  integer :: ier, ic, nch, np, mv
  logical :: do_zero
  !
  ! Code ----
  error = .false.
  if (huvl%loca%size.eq.0) then
    call map_message(seve%e,rname,'UV data undefined ')
    error = .true.
    return
  endif
  !
  if (nfields.ne.0 .and. huvl%gil%pang.ne.0.0) then
    call map_message(seve%e,rname,'Cannot write rotated Mosaic UV data: no convention defined by IRAM')
    error = .true.
    return    
  endif
  !
  do_zero = .false.
  if (present(cflag)) then
    if (any(cflag.eq.0)) do_zero = .true.
  endif
  !
  ! Trim if needed
  if (trim_uv) then
    np = huvl%gil%dim(1)
    nv = huvl%gil%nvisi  !! not %dim(2)
    nch = huvl%gil%nchan * huvl%gil%nstokes
    allocate(ivis(nv),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation failure')
      error = .true.
      return
    endif
    !
    ! First passs to identify all valid visibilities
    ! Caution: assume default model here.
    ! This is guaranteed inside IMAGER, since we use gdf_read_uvdataset
    mv = 0
    do iv = 1,nv
      if (trim_uvany) then
        ! If a single channel is Bad, flag data
        im = 1
        do ic=1,nch
          if (visi(7+3*ic,iv).le.0) then
            im = 0
            exit
          endif
        enddo
      else
        ! If a single channel is Good, use data
        im = 0
        do ic=1,nch
          if (visi(7+3*ic,iv).gt.0) then
            im = 1
            exit
          endif
        enddo
      endif
      if (im.ne.0) then
        mv = mv+1
        ivis(mv) = iv
      endif
    enddo
    !
    ! Create output image
    if (do_zero) then
      call sub_write_uvdata(file,nc,huvl,visi,error, mv, ivis, cflag)
    else
      call sub_write_uvdata(file,nc,huvl,visi,error, mv, ivis)
    endif
  else
    ! Create output image
    if (do_zero) then
      call sub_write_uvdata(file,nc,huvl,visi,error,cflag=cflag)
    else
      call sub_write_uvdata(file,nc,huvl,visi,error)
    endif
  endif
end subroutine sub_write_uvset
!
subroutine imager_write_data(head,data,error)
  use image_def
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  use clean_types
  !*
  !   Utility routine to write a Data Set in various formats.
  ! Supported formats are GILDAS, FITS, and also CSV fro 2-D Tables
  !!
  type(gildas), intent(inout) :: head  !! Data header
  real, intent(in) :: data(*)          !! Data buffer - Contiguous array
  logical, intent(inout) :: error      !! Logical error flag
  !
  ! Local ---
  type(gildas) :: htmp
  logical :: overwrite=.true.
  integer :: nbits=-32
  character(len=4) :: style='  '
  !
  ! Code ----
  if (write_format.eq.write_csv) then
    if (head%gil%ndim.eq.2.and.head%gil%dim(2).lt.128) then
      call table_to_csv(head,data,error)
      return
    else
      call map_message(seve%w,'WRITE','CSV format not suited for this data, using GILDAS format')
    endif
  endif
  !
  if (write_format.ge.write_fits) then
    if ((write_format.eq.write_fits).or.(head%gil%faxi.eq.0)) then
      head%loca%addr = locwrd(data)
      call gildas_to_fits(head,head%file,style,nbits,overwrite,error)
    else
      call gildas_null(htmp)
      call gdf_copy_header(head,htmp,error)
      htmp%loca%addr = locwrd(data)
      if (write_format.eq.write_fits_velo) then
        htmp%gil%convert(2,htmp%gil%faxi) = htmp%gil%voff
        htmp%gil%convert(3,htmp%gil%faxi) = htmp%gil%vres
        htmp%char%code(htmp%gil%faxi) = 'VELOCITY'
      else
        htmp%gil%convert(2,htmp%gil%faxi) = htmp%gil%freq
        htmp%gil%convert(3,htmp%gil%faxi) = htmp%gil%fres
        htmp%char%code(htmp%gil%faxi) = 'FREQUENCY'
      endif
      call gildas_to_fits(htmp,head%file,style,nbits,overwrite,error)
    endif
  else
    call gdf_write_image(head,data,error)
  endif
end subroutine imager_write_data
!
subroutine table_to_csv(head,data,error)
  use image_def
  use gkernel_interfaces, only : locwrd
  use iso_c_binding
  !*
  !   Utility routine
  !
  ! Write GILDAS Table to CSV file. Supports Real(8) and
  ! Real(4) tables.
  !!
  type(gildas), intent(inout) :: head  !! Table Header
  real, intent(in) :: data(*)          !! Data buffer -- contiguous, no type checking
  logical, intent(inout) :: error
  !
  ! Local ---
  integer :: nx, ny
  type(c_ptr) :: cptr
  real(kind=8), pointer :: d2ptr(:,:)
  integer(kind=address_length) :: addr
  !
  ! Code ----
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  if (head%gil%form.eq.fmt_r4) then
    call table_to_csv4(nx,ny,head%file,data)
  else if (head%gil%form.eq.fmt_r8) then
    ! This creates a Warning for type mismatch on "data"
    !   call table_to_csv8(nx,ny,head%file,data)
    ! Circumvent the issue with standard Fortran C interface
    !   cptr = c_loc(data)    
    ! Would require "target" status to data, and thus an interface,and thus type checking on data...
    ! Use non-standard alternative
    addr = locwrd(data)
    call adtoad(addr,cptr,1)
    call c_f_pointer(cptr,d2ptr,head%gil%dim(1:2))    
    call table_to_csv8(nx,ny,head%file,d2ptr)
  endif
end subroutine table_to_csv
!
subroutine table_to_csv4(nx,ny,file,data)
  use gkernel_interfaces
  !*
  !   Utility routine
  !
  ! Write Real(4) 2-D array Table to CSV file. 
  !!
  integer, intent(in) :: nx   !! First dimension
  integer, intent(in) :: ny   !! Second dimension
  character(len=*), intent(inout) :: file !! File name
  real, intent(in) :: data(nx,ny)   !! Array
  !
  ! Local ---
  integer :: ier, lun, i,j
  !
  ! Code ----
  lun = 0
  ier = sic_open(lun,file,'NEW',.false.)
  do i=1,nx
    write(lun,*) (data(i,j),j=1,ny)
  enddo
  close(unit=lun)
  call sic_frelun(lun)
end subroutine table_to_csv4
!
subroutine table_to_csv8(nx,ny,file,data)
  use gkernel_interfaces
  !*
  !   Utility routine
  !
  ! Write Real(8) 2-D array Table to CSV file. 
  !!
  integer, intent(in) :: nx   !! First dimension
  integer, intent(in) :: ny   !! Second dimension
  character(len=*), intent(inout) :: file !! File name
  real(kind=8), intent(in) :: data(nx,ny) !! Array
  !
  ! Local ---
  integer :: ier, lun, i,j
  !
  ! Code ----
  lun = 0
  ier = sic_open(lun,file,'NEW',.false.)
  do i=1,nx
    write(lun,*) (data(i,j),j=1,ny)
  enddo
  close(unit=lun)
  call sic_frelun(lun)
end subroutine table_to_csv8

module language_versions
  character(len=20) :: v_display   ! Display
  character(len=20) :: v_clean     ! CLEAN
  character(len=20) :: v_cal       ! CALIBRATE
  character(len=20) :: v_advanced  ! ADVANCED
  character(len=20) :: v_bundles   ! BUNDLES
  character(len=20) :: v_imager    ! IMAGER
  character(len=20) :: v_simu      ! SIMULATE
  character(len=20) :: v_program   ! UV_SHORT improvement
  integer :: imager_versi=4600     ! Imager version
  integer :: imager_patch=4500     ! last distributed version
end module language_versions
!
subroutine load_display
  use gkernel_interfaces
  use language_versions
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER & VIEWER --  Load DISPLAY\ Language
  !!
  !----------------------------------------------------------------------
  external :: run_display
  integer, parameter :: mshow=37+1+1+1+1
  character(len=16) vshow(mshow) 
  data vshow / ' CATALOG', '/SORT', '*COLOR', ' COMPARE', '/DIRECTORY',    &
      & ' EXPLORE', '/DIRECTORY', '/ADD', '/NOPAUSE',             &
      & ' EXTRACT',                                               & 
      & ' FIND', '/CHECK', '/SPECIES',                         & ! Find lines in a given range
      & ' INSPECT_3D', '/DIRECTORY', &
      & ' LOAD', '/FREQUENCY', '/PLANES', '/RANGE',  & ! READ DATA command equivalent
      & ' POPUP', &
      & ' SET', '/DEFAULT',       &  ! The /DEFAULT option is for compatibility with GreG 
      & ' SHOW', '/DIRECTORY', '/OVERLAY', '/SIDE',         &
      & ' SLICE',                 & 
      & ' SPECTRUM', '/CORNER', '/MEAN', '/PLANES', '/SUM', & 
      & ' STATISTIC', '/EDGE', '/FILE', '/NOISE', '/UPDATE',  & ! Image statistic
      & ' VIEW', '/DIRECTORY', '/NOPAUSE', '/OVERLAY' /
  logical, save :: display_loaded=.false.
  logical, parameter :: old=.false.
  !
  if (display_loaded) return
  !
  ! DISPLAY\ Language versions  v_display
  if (old) then
  v_display = '1.0-00 21-Oct-2021' ! First DISPLAY\ Language
  v_display = '1.2-00 23-Oct-2021' ! Also move EXPLORE here
  v_display = '1.3-00 23-Oct-2021' ! Also move STATISTIC here
  v_display = '1.3-01 10-Nov-2021' ! Improve CATALOG command
  v_display = '1.4-00 18-Nov-2021' ! STATISTIC /UPDATE command
  v_display = '1.4-01 23-Nov-2021' ! Allow re-entrant calls for STATISTIC
  v_display = '1.5-00 10-Jan-2022' ! LOAD command
  v_display = '1.5-01 30-Jan-2022' ! Improve CATALOG command
  v_display = '1.5-06 16-May-2022' ! Ensure STATISTIC works correctly on big data
  v_display = '1.6-00 14-Oct-2022' ! Include the SPECTRUM command calling GreG code
  v_display = '1.6-01 15-Oct-2022' ! Include the POPUP command
  v_display = '1.6-02 04-Nov-2022' ! Include the SET command
  v_display = '1.6-03 07-Nov-2022' ! Add the /DEFAULT option to the SET command
  v_display = '1.7-00 08-Nov-2022' ! Move the EXTRACT and SLICE command here
  v_display = '1.7-01 05-Jan-2023' ! SHOW MOSAIC
  v_display = '1.8-00 23-Jan-2023' ! /DIRECTORY option of all effective Display commands
  v_display = '1.8-01 25-Jan-2023' ! SHOW UV-Like data
  v_display = '1.8-02 25-Jan-2023' ! SLICE can call the cursor if no arg.
  v_display = '1.9-00 25-Jan-2023' ! Add the COMPARE command
  v_display = '1.9-01 08-Mar-2023' ! EXTRACT was not handling ANGLE_UNIT correctly
  v_display = '1.9-02 02-Jun-2023' ! FIND /CHECK option
  v_display = '1.9-03 12-Jul-2023' ! CATALOG /SORT option
  v_display = '1.9-04 21-Jul-2023' ! Improved COMPARE command
  v_display = '1.9-05 25-Jul-2023' ! Improve STATISTIC command for Mosaics
  v_display = '1.9-06 25-Jul-2023' ! SHOW /OVERLAY command 
  v_display = '1.9-07 09-Jan-2024' ! Better SHOW & VIEW of non standard data cubes (scripts only)
  v_display = '1.9-08 05-Mar-2024' ! STATISTIC /FILE command
  v_display = '1.9-09 05-Apr-2024' ! SHOW COMPOSITE improvement
  v_display = '1.9-10 05-May-2024' ! LOAD File WRITE
  v_display = '1.9-11 05-Jul-2024' ! SET FORMAT command
  v_display = '1.9-11 18-Jul-2024' ! SHOW PV|NOISE Buffer 
  v_display = '1.9-11 10-Oct-2024' ! VIEW File /NOPAUSE bug correction
  v_display = '1.9-11 25-Jan-2025' ! COMPARE & SHOW behaviour improvements
  endif
  v_display = '1.9-12 15-Apr-2025' ! SHOW & VIEW STATISTIC commands
  !
  call sic_begin('DISPLAY','gag_doc:hlp/imager-help-display.hlp', mshow, vshow, &
    & v_display//'S.Guilloteau', run_display, gr_error)
  display_loaded = .true.
  !
end subroutine load_display
!
subroutine init_clean
  use gkernel_interfaces
  use language_versions
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER  --  Load the Imager Languages:  
  !   CLEAN\        Basic imaging and deconvolution  
  !   CALIBRATE\    Calibration tools  
  !   ADVANCED\     Advanced processing  
  !   BUNDLES\      Integrated commands  
  !   IMAGER\       Pipeline related commands  
  !   SIMULATE\     Array simulator
  !!
  !----------------------------------------------------------------------
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use preview_mod
  !
  external :: run_advanced, run_bundles, run_clean, run_imager, run_self, run_simu
  !
  ! vocabulaire de CLEAN
  integer, parameter :: mclean=147+2+2
  character(len=16) :: vclean(mclean) 
  data vclean /' DUMP',   &
       ' ALMA', '/FLUX', '/PLOT', '/QUERY', '/NOISE', '/METHOD', &
       ' BUFFERS', &
       ' CCT_CLEAN', ' CCT_CONVERT', ' CCT_MERGE', &
       ' CLEAN', '/FLUX', '/PLOT', '/QUERY', '/NITER', '/ARES', '/RESTART', &  !No conflict with ALMA command
       ' DISCARD',  & 
       ' FIT', '/JVM_FACTOR', '/THRESHOLD', &
       '*LOG', &
       ' MAP_CONVOLVE', &
       ' MAP_COMBINE', '/BLANKING', '/FACTOR', '/THRESHOLD',         &
       ' MAP_COMPRESS', ' MAP_INTEGRATE',                            &
       ' MAP_REPROJECT', '/BLANKING', '/LIKE','/PROJECTION', '/SYSTEM', '/X_AXIS', '/Y_AXIS', & 
       ' MAP_RESAMPLE', '/LIKE',          & 
       ' MAP_SMOOTH', '/ASYMMETRIC', &
       ' MOSAIC', &
       ' MX', '/FLUX', '/PLOT', '/QUERY', &
       ' PRIMARY', '/APPLY', '/COMPUTE', '/CORRECT', '/TRUNCATE', &
       ' READ', '/COMPACT', '/FREQUENCY', '/PLANES', '/RANGE',  '/NOTRAIL',  &
       ' SPECIFY', '/FOR', &
       ' SUPPORT', '/CURSOR', '/MASK', '/PLOT', '/RESET', '/THRESHOLD', '/VARIABLE', &
       ' UV_BASELINE', '/CHANNELS', '/FILE', '/FREQUENCY', '/RANGE', '/VELOCITY', '/WIDTH', &
       ' UV_CHECK', '/FILE', ' UV_CHOP', ' UV_COMPRESS', '/CONTINUUM', '/FILE', & 
       ' UV_CONTINUUM','/INDEX', '/RANGE', &
       ' UV_EXTRACT', '/FIELDS', '/FILE', '/RANGE', &
       ' UV_FLAG', '/ANTENNA', '/DATE', '/FILE', '/RESET', &
       ' UV_FIELDS', '/CENTER', '/FILE', &
       ' UV_FILTER', '/CHANNELS', '/FILE', '/FREQUENCY', '/RANGE', '/VELOCITY', '/WIDTH', '/RESET', '/ZERO', &
       ' UV_HANNING', '/FILE', &
       ' UV_MAP', '/TRUNCATE',  '/FIELDS', '/RANGE', '/CONTINUUM', '/INDEX', &
       ' UV_RESAMPLE', '/FILE', '/LIKE', & 
       ' UV_RESIDUAL', '/FIELDS', '/OUTPUT', ' UV_RESTORE', '/COPY', '/SPEED', &
       ' UV_REWEIGHT', '/FLAG', '/FILE', '/RANGE', &
       ' UV_SHIFT',  '/FILE', & 
       ' UV_SMOOTH', '/ASYMMETRIC', '/FILE', &
       ' UV_SPLIT', '/CHANNELS', '/FILE', '/FREQUENCY', '/RANGE', '/VELOCITY', '/WIDTH', &
       ' UV_STAT',  '/PLOT',  &
       ' UV_TIME', '/FILE', '/WEIGHT',      &
       ' UV_TRIM', '/FILE', ' UV_TRUNCATE', &
       ' UV_SUBTRACT', '/FILE', &
       ' WRITE', '/APPEND ', '/RANGE', '/REPLACE', '/TRIM'/
  !
  integer, parameter :: ncal=21+3
  character(len=16) vcal(ncal)
  data vcal/  & 
       ' AMPLITUDE', '/ANTENNAS', '/FILE', & ! Antenna Amplitude Calibration
       ' APPLY', '/FILE',  '/FLAG',      & ! Apply Self calibration
       ' COLLECT', '/FLAG',              & ! Gather Independent Calibrations
       ' DERIVE',                        & ! Antenna to Baseline gain
       ' MODEL', '/MINVAL',              & ! UV model from UV_FIT or CLEAN
                 '/OUTPUT', '/MODE',     & !  - /OUTPUT must be second option
       ' PLAIT',                         & ! PLAIT command
       ' SCALE_FLUX',                    & ! Verify day-to-day Flux consistency
       ' SOLVE', '/MODE',                & ! Solve for Amplitude and/or Phase
       ' TRANSFORM',                     & ! Image transformations
       ' UV_SELECT',                     & ! Select UV_DATA 
       ' UV_SELF', '/RANGE', '/RESTORE', & ! Image for Self-calibration
       ' UV_SORT', '/FILE'    /            ! Sort UV data
  !
  integer, parameter :: nadv=68+1
  character(len=16) vadv(nadv)
  data vadv/  & 
    & ' FEATHER', '/FILE', '/REPROJECT',                        &
    & '*FLUX', '/CCT', ' HOW_TO',                               &
    & ' MAP_POLAR', '/ANGLE', '/BACKGROUND', '/COMPUTE', '/STEP',       &
    & ' MAP_CONTINUUM', '/METHOD',  '*MASK', '/FROM', ' MFS',   &
    & ' MOMENTS', '/CUT', '/MASK', '/METHOD', '/RANGE', '/THRESHOLD',   &
    & ' PROPER_MOTION', '/FILE',                                &
    & ' STOKES', '/FILE',                                       & 
    & ' UV_ADD', '/FILE',                                       &
    & ' UV_CIRCLE', '/FIT', '/SAMPLING', '/ZERO',               & 
    & ' UV_CORRELATE', '/FILE',                                 &
    & ' UV_DEPROJECT', '/FIT',                                  &
    & '*UV_FIT', '/CONTINUUM', '/INDEX', '/OUTPUT', '/QUIET',   &
    &     '/RANGE', '/RESULT', '/SAVE', '/UVRANGE', '/WIDGET',  &
    & ' UV_GRID',                                               &
    & ' UV_LINEARIZE','/FILE',                                  &
    & ' UV_MERGE', '/FILES', '/IGNORE', '/MODE', '/SCALES', '/WEIGHTS', &
    & ' UV_MOSAIC',                                             &
    & '*UV_PREVIEW', '/BROWSE', '/FILE',                        &  
    & ' UV_RADIAL', '/FIT', '/SAMPLING', '/ZERO',               & 
    & ' UV_SHORT', '/CHECK', '/REMOVE', '/RESAMPLE',            & 
    & ' XY_SHORT', '/RESAMPLE'/
  ! 
  integer, parameter  :: ncomp=17
  character(len=16) vcomp(ncomp)
  data vcomp/ & 
    & ' COMBINE', '/BLANKING', '/FACTOR', '/THRESHOLD', '/RELATIVE',       &
    & ' KEPLER', '/HFS', '/MASK', '/RESET', '/VELOCITY',  '/VSYSTEM',  '/WIDGET', &
    & '*SPECTRAL_CLEAN',                                        &
    & '*SELFCAL', '/WIDGET',                                    &
    & ' UV_DETECT', '/FILE' /                                  
  !
  integer, parameter :: nimag=25
  character(len=16) vimag(nimag)
  data vimag/ &
    & ' CLARK', '/FLUX', &
    & ' GCLEAN', '/FLUX', '/RESTART', &
    & ' HOGBOM', '/FLUX', &
    & ' MRC', '/FLUX', &
    & ' MULTISCALE', '/FLUX', &
    & ' PIPELINE', '/MODE', '/WIDGET', &
    & ' REPORT', &
    & ' SIMULATE','/ARRAY','/CONFIG','/HOURS','/MODEL','/NOISE', &
    & ' SDI', '/FLUX', '/PLOT', &
    & ' TIPS' /
  !
  integer, parameter :: nsimu=13
  character(len=16) :: vsimu(nsimu)
  data vsimu/ &
    & ' ADD_NOISE', '/FILE', &
    & ' ARRAY', &
    & ' UV_TRACKS', '/FRAME', '/HORIZON', '/HOUR_ANGLE', '/INTEGRATION', &
    & '/OFFSET', '/SIZE', '/STATIONS', '/TABLE', '/WEIGHT'/
  ! 
  character(len=2), save :: ansi_crlf
  logical :: error
  integer :: iout
  logical, parameter :: old=.false.
  !
  ! Global IMAGER Version (matching Documentation)
  if (old) then
    v_program = '3.6-01  24-Nov-2022'   ! First release
    v_program = '3.6-02  13-Dec-2022'   ! MODEL works on Mosaic
    v_program = '3.7-00  05-Jan-2023'   ! UV_MAP with Sault method for Mosaics
    v_program = '3.7-02  25-Jan-2023'   ! /DIRECTORY option in DISPLAY commands
    v_program = '3.7-03  24-Feb-2023'   ! Full capabilities of COMBINE command
    v_program = '3.7-04  10-Jun-2023'   ! UV_SHORT, PRIMARY, PLAIT and MAP_POLAR commands
    v_program = '3.7-05  13-Jun-2023'   ! Debug MODEL 
    v_program = '3.8-01  25-Jun-2023'   ! SIMULATE\ language
    v_program = '3.8-02  05-Jul-2023'   ! SIMULATE command
    v_program = '3.8-04  O7-Jul-2023'   ! Bug corrections for Mosaics & UV_SHORT
    v_program = '3.8-05  21-Jul-2023'   ! Bug correction COMBINE - Improve COMPARE
    v_program = '3.9-01  25-Jul-2023'   ! SELFCAL for Mosaics+ SHOW /OVERLAY
    v_program = '3.9-02  29-Aug-2023'   ! UV_SHORT improvement
    v_program = '3.9-03  07-Sep-2023'   ! BEAM_GAP control and UV_RESTORE / COMBINE fixes
    v_program = '3.9-05  18-Sep-2023'   ! SIMULATE & CATALOG bug correction
    v_program = '3.9-06  05-Oct-2023'   ! CATALOG, UV_MERGE & UV_CORRELATE bugs correction
    v_program = '3.9-07  18-Oct-2023'   ! CCT_CONVERT & MASK corrections
    v_program = '3.9-08  20-Oct-2023'   ! CLEAN /RESTART bug correction - SHOW MOMENTS improved
    v_program = '3.9-08  13-Nov-2023'   ! SELFCAL issues, MAP_COMBINE INDEX and UV_FIT parameters bug correction
    v_program = '3.9-09  27-Nov-2023'   ! Installation scripts & Verification procedure
    v_program = '3.9-10  04-Dec-2023'   ! Display scripts on non-standard cubes
    v_program = '3.9-11  09-Jan-2024'   ! Protect for flagged data in Robust weighting & UV_STAT 
    v_program = '4.0-00  05-Mar-2024'   ! PIPELINE /MODE SURVEY bug correction
    v_program = '4.0-01  05-Mar-2024'   ! UV_PREVIEW bug correction
    v_program = '4.0-02  05-Apr-2024'   ! Update PIPELINE scripts
    v_program = '4.0-03  14-May-2024'   ! Better SPECIFY command & MOMENTS  SicVar optional argument
    v_program = '4.0-04  24-May-2024'   ! Use ICRF instead of FK5 for ALMA
    v_program = '4.1-00  13-Jun-2024'   ! Dynamic CCT_LIST use
    v_program = '4.1-01  14-Jun-2024'   ! Remove obsolete code as much as possible (only MX left)
    v_program = '4.2-00  03-Jul-2024'   ! GCLEAN command and GAUSS method for CLEAN
    v_program = '4.2-01  03-Jul-2024'   ! SET FORMAT command and associate WRITE keywords
    v_program = '4.2-02  16-Jul-2024'   ! Optimized and functional GCLEAN command 
    v_program = '4.2-03  18-Jul-2024'   ! PIPELINE improvements
    v_program = '4.2-04  22-Jul-2024'   ! UV_RESTORE for mosaics
    v_program = '4.2-05  24-Jul-2024'   ! UV_GRID command in ADVANCED\ language
    v_program = '4.2-06  29-Aug-2024'   ! AMPLITUDE command in CALIBRATE\ language
    v_program = '4.2-07  15-Sep-2024'   ! REPORT command in IMAGER\, UV_CHOP in CLEAN\ language
    v_program = '4.2-08  15-Oct-2024'   ! UV_STAT /PLOT, Improve PROPER_MOTION, VIEW bug correction
    v_program = '4.2-08  25-Oct-2024'   ! Bug correction in CLEAN /RESTART and READ UV for Stokes 
    v_program = '4.2-08  31-Oct-2024'   ! Bug correction in Polarization handling
    v_program = '4.2-08  05-Nov-2024'   ! MAP_POLAR improvement + casagildas() with no keepflags
    v_program = '4.3-00  15-Nov-2024'   ! UV_LINEAR + Version with no Python
    v_program = '4.4-00  25-Nov-2024'   ! Upgrade of the SELFCAL facility
    v_program = '4.4-01  30-Nov-2024'   ! Minor bug corrections in UV_MERGE, UV_LINEARIZE, UV_PREVIEW
    v_program = '4.4-02  09-Dec-2024'   ! UV_FIT /CONTINUUM first version
    v_program = '4.4-03  25-Jan-2025'   ! AMPLITUDE command operational, improved STATISTIC, and CLEAN bug correction
  endif
  v_program = '4.5-01  15-Apr-2025'   ! New major version
  ! Released above
  v_program = '4.5-02  15-May-2025'   ! New GIO based version
  v_program = '4.5-03  25-May-2025'   ! Major correction in PHASE Mosaics
  v_program = '4.5-04  28-May-2025'   ! Bug correction in CLEAN /RESTART 
  v_program = '4.5-05  05-Jul-2025'   ! UV_SUBTRACT command
  v_program = '4.6-00  15-Sep-2025'   ! Update Major version for easier bug tracking.
  v_program = '4.6-01  25-Sep-2025'   ! Bug correction in UV_MERGE 
  v_program = '4.6-02  15-Oct-2025'   ! Bis + UV_FIT /CONT FieldSize
  v_program = '4.6-03  30-Nov-2025'   ! Support for Hybrid Mosaics
  v_program = '4.6-04  [ Dec-2025 ]'   ! UV_PREVIEW issue
  !
  ! CLEAN Language versions   v_clean
  if (old) then
  v_clean = '4.0-01 08-Mar-2018' ! First IMAGER release with new Variable names (may still change)
  v_clean = '4.1-01 08-Mar-2018' ! IMAGER release with Self Calibration commands
  v_clean = '4.1-02 15-Mar-2018' ! Bug correction in Self Calibration commands
  v_clean = '4.1-02 02-May-2018' ! Split with CALIBRATE\ language 
  v_clean = '4.2-01 03-Jul-2018' ! Add /RANGE options to UV_FILTER and UV_BASELINE
  v_clean = '4.3-01 05-Sep-2018' ! Minor change in SHOW NOISE to identify properly Dirty and Clean data
  v_clean = '4.3-02 05-Nov-2018' ! Debug MX, improve MULTI and cleanup messages  
  v_clean = '4.3-03 14-Nov-2018' ! Add the UV_TRIM command, support READ CCT /RANGE
  v_clean = '4.4-01 14-Jan-2019' ! Add the UV_HANNING command
  v_clean = '4.4-02 17-Jan-2019' ! Add the UV_EXTRACT command
  v_clean = '4.4-03 04-Feb-2019' ! Add the /FILE option to UV_BASELINE,UV_FILTER, UV_SPLIT and UV_SORT
  v_clean = '4.4-04 07-Feb-2019' ! Bug correction in UV_MAP for Phase offset mosaics 
  v_clean = '4.4-05 08-Feb-2019' ! UV_TRIM /FILE syntax
  v_clean = '4.4-06 12-Feb-2019' ! Protect against incomplete UV data (Nvisi < dim(2))
  v_clean = '4.4-07 13-Feb-2019' ! Operational version of UV_SORT /FILE (still slow)
  v_clean = '4.4-08 14-Feb-2019' ! Operational version of UV_SORT /FILE (reasonable now) 
  v_clean = '4.4-09 15-Feb-2019' ! UV_TIME /FILE syntax
  v_clean = '4.4-10 25-Feb-2019' ! UV_RESAMPLE, UV_COMPRESS, UV_HANNING /FILE syntax
  v_clean = '4.5-01 27-Feb-2019' ! Move STOKES command to ADVANCED\ language
  v_clean = '4.5-02 14-Mar-2019' ! Improve the STATISTIC and SUPPORT commands behaviour 
  v_clean = '4.5-03 29-Mar-2019' ! Support for SHOW SOURCES
  v_clean = '5.0-01 05-Apr-2019' ! Remove CLARK, ..., SDI commands, leave only CLEAN
  v_clean = '5.0-02 05-Apr-2019' ! Move COLOR to CLEAN\
  v_clean = '5.0-03 29-Apr-2019' ! Option /CONT for UV_MAP
  v_clean = '5.0-04 02-May-2019' ! BUFFERS command
  v_clean = '5.0-05 06-May-2019' ! /NOPAUSE option to VIEW command
  v_clean = '5.0-06 07-May-2019' ! UV_STAT DEFAULT and associated variables
  v_clean = '5.0-07 25-May-2019' ! /INDEX option for UV_MAP
  v_clean = '5.1-01 05-Jun-2019' ! Command UV_REWEIGHT re-written
  v_clean = '5.1-02 15-Jun-2019' ! UV_EXTRACT /FIELDS
  v_clean = '5.1-03 25-Jun-2019' ! UV_FIELDS command 
  v_clean = '5.1-04 03-Jul-2019' ! UV_COMPRESS /CONTINUUM option
  v_clean = '5.1-05 04-Jul-2019' ! Remove obsolete /SELF option of UV_MAP & UV_RESTORE
  v_clean = '5.2-01 03-Sep-2019' ! Move STATISTIC command out of this language
  v_clean = '5.2-02 13-Sep-2019' ! Move UV_SORT command out of this language
  v_clean = '5.2-03 25-Sep-2019' ! UV_FLAG bug correction
  v_clean = '5.2-04 07-Oct-2019' ! UV_MAP 'Map_Center' bug correction (header not updated)
  v_clean = '5.2-05 10-Oct-2019' ! WRITE does not accept ambiguities
  v_clean = '5.2-06 10-Oct-2019' ! VIEW with no argument just re-displays
  v_clean = '5.3-01 10-Oct-2019' ! Support for the CONTINUUM image
  v_clean = '5.3-02 11-Oct-2019' ! MAP_REPROJECT, MAP_COMBINE commands (+syntax MAP_RESAMPLE)
  v_clean = '5.3-03 13-Oct-2019' ! SHOW /NOPAUSE and VIEW /OVERLAY commands
  v_clean = '5.3-04 16-Oct-2019' ! SHOW /SIDE instead of /NOPAUSE and new MASK THRESHOLD command
  v_clean = '5.3-05 06-Nov-2019' ! /FILE option of UV_CHECK
  v_clean = '5.3-06 20-Nov-2019' ! /FILE option of UV_SHIFT
  v_clean = '5.3-07 06-Feb-2020' ! Bug correction for MAP_COMPRESS syntax
  v_clean = '5.3-08 20-Feb-2020' ! Size computation for Large data set may exceed 2GBytes
  v_clean = '5.3-09 21-Feb-2020' ! Bug correction for Mosaic in Robust weighting 
  v_clean = '5.3-10 24-Feb-2020' ! /LIKE option of MAP_RESAMPLE
  v_clean = '5.3-11 05-Mar-2020' ! Bug correction in MULTI
  v_clean = '5.3-12 05-Mar-2020' ! Bug correction about buffers selected by UV_SELECT and/or UV_MAP /CONT
  v_clean = '5.3-13 11-Mar-2020' ! Bug correction in MAP_RESAMPLE (overflow of channel ranges)
  v_clean = '5.3-14 25-Mar-2020' ! Remove a restriction in MAP_RESAMPLE (overflow of channel ranges)
  v_clean = '5.3-15 25-Mar-2020' ! Improve the /FLUX display in CLEAN command
  v_clean = '5.3-16 13-May-2020' ! Improve the WRITE MODEL command 
  v_clean = '5.4-01 21-May-2020' ! /FOR option of SPECIFY
  v_clean = '5.4-02 09-Jul-2020' ! Command DISCARD
  v_clean = '5.4-03 01-Sep-2020' ! Option /THRESHOLD for command FIT
  v_clean = '5.4-04 03-Sep-2020' ! Improve UV_TIME command : more consistent defaults
  v_clean = '5.4-05 11-Sep-2020' ! Bug correction in MASK APPLY (Blanking was not updated)
  v_clean = '5.4-06 15-Sep-2020' ! Optimize MAP_RESAMPLE if no resampling needed
  v_clean = '5.5-01 26-Oct-2020' ! Command UV_SMOOTH
  v_clean = '5.6-01 07-Dec-2020' ! Command CCT_MERGE and CCT_CONVERT
  v_clean = '5.6-02 14-Dec-2020' ! STATISTIC /EDGE option
  v_clean = '5.6-03 14-Dec-2020' ! /ARES Argument must be Real array
  v_clean = '5.6-04 14-Jan-2021' ! Debug VIEW and SHOW 4-D Beams
  v_clean = '5.6-05 19-Jan-2021' ! Make sure UV_MAP works on Mosaics even in Memory limited conditions
  v_clean = '5.7-01 31-Jan-2021' ! Command CCT_CLEAN
  v_clean = '5.7-02 31-Mar-2021' ! FIT command make one fit per pointing
  v_clean = '5.7-03 01-Apr-2021' ! MULTISCALE is now operational for Mosaics
  v_clean = '5.7-04 01-Jun-2021' ! Bug correction for MULTISCALE in 4-D Beams
  v_clean = '5.7-05 01-Jun-2021' ! More flexible FIT command
  v_clean = '5.8-01 17-Jun-2021' ! SPECIFY FREQUENCIES command for VLA data
  v_clean = '5.8-02 28-Jun-2021' ! UV_SHIFT bug correction for "false" mosaics (ID and MOFF columns)
  v_clean = '5.8-03 28-Jun-2021' ! UV_SORT bug correction for /FILE option
  v_clean = '6.0-00 21-Oct-2021' ! Split Language CLEAN\ into CLEAN\ and DISPLAY\ (no \at end please...)
  v_clean = '6.0-01 09-Nov-2021' ! Bug correction in READ UV: undefine PREVIEW%, avoid write UV data in WRITE *
  v_clean = '6.1-00 17-Nov-2021' ! Add /JVM option to command FIT
  v_clean = '6.1-01 17-Nov-2021' ! CLEAN Variable ? syntax
  v_clean = '6.1-02 17-Nov-2021' ! UV_MAP Variable ? syntax
  v_clean = '6.1-03 19-Nov-2021' ! UV_REWEIGHT syntax bug correction
  v_clean = '6.1-04 23-Nov-2021' ! Use the BEAM_JVM value in UV_RESTORE - (Defaults to 1 if not available)
  v_clean = '6.2-00 02-Dec-2021' ! Add the /LIKE option to UV_RESAMPLE 
  v_clean = '6.2-01 16-Dec-2021' ! Optimize parallel processing
  v_clean = '6.2-02 17-Dec-2021' ! Debug MAP_BEAM_STEP = 1 mode
  v_clean = '6.2-03 17-Dec-2021' ! UV_CHECK beam works better
  v_clean = '6.2-04 18-Dec-2021' ! UV_TIME now works for UV tables with per-channel weights
  v_clean = '6.2-05 20-Dec-2021' ! UV_RESAMPLE must reset BEAM_RANGES variable
  v_clean = '6.3-00 21-Dec-2021' ! Use new way of defining Dirty Beams number and properties.
  v_clean = '6.3-01 03-Jan-2021' ! Parallel programming optimization for CLEAN
  v_clean = '6.3-02 06-Jan-2022' ! Allow direct READ of FITS data cubes.
  v_clean = '6.3-03 07-Jan-2022' ! READ /PLANES option now works as expected
  v_clean = '6.3-04 11-Jan-2022' ! UV_FIELD bug correction 
  v_clean = '6.3-05 18-Jan-2022' ! READ SINGLE bug correction
  v_clean = '6.3-06 20-Jan-2022' ! READ  with FITS format improvement
  v_clean = '6.3-07 08-Feb-2022' ! Allow to use Fixed beamsize in UV_RESTORE
  v_clean = '6.3-08 08-Feb-2022' ! CLEAN_STOP syntax in CLEAN
  v_clean = '6.3-09 07-Mar-2022' ! Allow WRITE BEAM /APPEND in all cases
  v_clean = '6.3-10 07-Mar-2022' ! Bug correction in beam derivation if ANGLE is specified
  v_clean = '6.3-11 09-Mar-2022' ! Bug correction in CCT_MERGE : Concatenation was improper
  v_clean = '6.4-00 18-Mar-2022' ! Implement the /RESTART option of CLEAN
  v_clean = '6.4-01 22-Mar-2022' ! Flag out of band channels in UV_RESAMPLE
  v_clean = '6.4-02 03-May-2022' ! /RESET option of UV_FILTER
  v_clean = '6.4-03 10-May-2022' ! Bug correction in UV_SHIFT and PROPER_MOTION
  v_clean = '6.4-04 02-Jun-2022' ! Make SPECIFY TELESCOPE work on Images too
  v_clean = '6.4-05 09-Jun-2022' ! Debug UV_FLAG command
  v_clean = '6.4-06 29-Jun-2022' ! Make UV_EXTRACT work with Random Frequency Axis
  v_clean = '6.4-07 29-Jun-2022' ! Make READ handle properly Random Frequency Axis in UVFITS format
  v_clean = '6.5-00 05-Sep-2022' ! Add the /ASYMMETRIC option of MAP_SMOOTH and UV_SMOOTH
  v_clean = '6.5-01 27-Sep-2022' ! Add the UNIT specifier to MAP_REPROJECT
  v_clean = '6.5-02 07-Oct-2022' ! Bug correction in Beam Consistency checking
  v_clean = '6.5-03 10-Oct-2022' ! Use a Channel mask array to hide line-emitting parts of the spectrum
  v_clean = '6.5-04 07-Nov-2022' ! Make sure MAP_CENTER is also used for Mosaics
  v_clean = '6.5-05 14-Nov-2022' ! Bug in UV_SHIFT: Pointing center was incorrectly reset in /FILE option for single fields
  v_clean = '6.5-06 14-Nov-2022' ! Bug in UV_MOSAIC: Wrong identification of arguments
  v_clean = '6.5-07 14-Nov-2022' ! Make sure MAP_CENTER is never forgotten (Mosaic stills needs checking)
  v_clean = '6.5-08 15-Nov-2022' ! UV_TIME crashed on Mosaics
  v_clean = '6.6-00 19-Dec-2022' ! Prepare UV_MAP with Sault Method for Mosaics, using the MOSAIC command
  v_clean = '6.6-01 05-Jan-2023' ! Working version of UV_MAP with Sault Method for Mosaics, using the MOSAIC command
  v_clean = '6.6-02 05-Jan-2023' ! all "TRUNCATE" values are now in [0,1] (instead of % in some options before)
  v_clean = '6.6-03 20-Feb-2023' ! MAP_CONVOLVE now preserves flux when possible. MAP_RESAMPLE handles blanking.
  v_clean = '6.6-04 23-Feb-2023' ! UV_STAT better handles Recommended vs User specified sizes
  v_clean = '6.6-05 03-Mar-2023' ! UV_CHECK uses BEAM_TOLERANCE
  v_clean = '6.6-06 03-Mar-2023' ! Bug correction in UV_SHIFT for degenerate 1 field Mosaic
  v_clean = '6.6-07 08-Mar-2023' ! Bug correction in READ for FITS files (file left open in optimized case)
  v_clean = '6.6-08 08-Mar-2023' ! UV_CHECK BEAM uses an improved method (ignore per-channel scale factors)
  v_clean = '6.6-09 15-May-2023' ! PRIMARY command syntax improved, backward compatible
  v_clean = '6.6-10 25-May-2023' ! UV_REWEIGHT bug correction
  v_clean = '6.7-00 06-Jun-2023' ! LOG command
  v_clean = '6.7-01 10-Jun-2023' ! Bug correction for UV_RESTORE in Mosaics.
  v_clean = '6.7-02 07-Jul-2023' ! READ UV in UVFITS format was broken on Mosaics.
  v_clean = '6.7-03 07-Jul-2023' ! SPECIFY /FOR was not working
  v_clean = '6.7-04 13-Jul-2023' ! Improvements and Bug corrections in UV_STAT
  v_clean = '6.7-05 13-Jul-2023' ! READ Item FileFilter opens a file search window
  v_clean = '6.7-06 28-Aug-2023' ! SPECIFY command syntax: BLANKING, FREQUENCY and SPECUNIT
  v_clean = '6.7-07 04-Sep-2023' ! Introduce BEAM_GAP and verify Weight channel more clearly
  v_clean = '6.7-08 06-Sep-2023' ! DUMP MEM command and IMAGER_RAM variable
  v_clean = '6.7-09 07-Sep-2023' ! Proper handling of Memory limit in UV_RESTORE and UV_RESIDUAL - Sault Mosaic to be done
  v_clean = '6.7-10 04-Oct-2023' ! UV_CHECK improvements and UV_CONTINUUM using the Code_uvt_IF flag
  v_clean = '6.7-11 18-Oct-2023' ! CCT_CONVERT flux scale correction
  v_clean = '6.7-12 20-Oct-2023' ! CLEAN /RESTART bug correction
  v_clean = '6.7-13 13-Nov-2023' ! MAP_COMBINE INDEX bug correction
  v_clean = '6.7-14 09-Jan-2024' ! Ensure flagged data are not used in Robust weighting estimate
  v_clean = '6.8-00 05-Mar-2024' ! Improved PRIMARY command, WRITE CCT /APPEND support
  v_clean = '6.8-01 08-Mar-2024' ! Debug UV_PREVIEW for Confused spectra
  v_clean = '6.8-02 10-Mar-2024' ! Update fits-to-uvt.ima and debug UV_REWEIGHT /FILE
  v_clean = '6.8-03 07-May-2024' ! Make SPECIFY /FOR obsolete
  v_clean = '6.8-04 24-May-2024' ! Use ICRF for ALMA data (READ and UV_MAP minor changes)
  v_clean = '6.8-05 13-Jun-2024' ! Dynamic CCT_LIST use
  v_clean = '6.9-00 03-Jul-2024' ! GAUSS Method for CLEAN
  v_clean = '6.9-02 22-Jul-2024' ! UV_RESTORE for Mosaics and GAUSS method
  v_clean = '6.9-03 09-Sep-2024' ! UV_MAP for small mosaics (and READ modificatioons)
  v_clean = '6.9-04 09-Sep-2024' ! UV_CHOP command
  v_clean = '6.9-05 01-Oct-2024' ! /PLOT option to UV_STAT
  v_clean = '6.9-06 25-Oct-2024' ! Bug correction in CLEAN /RESTART & READ for Stokes 
  v_clean = '7.0-01 22-Nov-2024' ! Upgrade of SELFCAL facility
  v_clean = '7.0-02 09-Jan-2025' ! Improved STATISTIC command, for use with 3-D Masks.
  v_clean = '7.0-03 09-Jan-2025' ! Improved READ command, with warning for Multi-Arrays in UVFITS files.
  v_clean = '7.0-04 13-Jan-2025' ! Bug correction - CLEAN would occasionally SegFault in parallel mode.
  v_clean = '7.1-01 15-Apr-2025' ! READ command engines re-written for Mosaics
  v_clean = '7.1-02 20-Apr-2025' ! Properly handle PHASE Mosaics by conversion to POINTING ones.
  endif
  v_clean = '7.2-01 01-Jul-2025' ! Properly handle PHASE Mosaics by conversion to POINTING ones.
  v_clean = '7.2-02 01-Sep-2025' ! UV_SUBTRACT command added
  v_clean = '7.2-03 08-Sep-2025' ! UV_CONTINUUM baseline extrema bug correction
  v_clean = '7.3-01 27-Nov-2025' ! UV_MOSAIC et al for more than 1 telescope
  !
  ! ADVANCED\ Language versions   v_advanced
  if (old) then
  v_advanced = '1.0-01 01-Dec-2017' ! Command UV_PREVIEW 
  v_advanced = '1.0-02 08-Mar-2018' ! Commands UV_DEPROJECT  and UV_RADIAL
  v_advanced = '1.1-02 08-Mar-2018' ! Commands MODEL, SOLVE /MODE, CALIBRATE and UV_MAP /SELF 
  v_advanced = '1.2-01 10-Apr-2018' ! Template for Command UV_SHORT
  v_advanced = '1.2-02 26-Apr-2018' ! Operational Command UV_SHORT - Still problems with repetitions.
  v_advanced = '1.3-01 03-Jul-2018' ! Rename CALIBRATE into APPLY -- Split with CALIBRATE\ language
  v_advanced = '1.3-02 26-Sep-2018' ! Add SLICE and EXTRACT commands
  v_advanced = '1.3-03 26-Sep-2018' ! allow support for VIEW (or SHOW) AnySicImage
  v_advanced = '1.3-04 26-Sep-2018' ! UV_PREVIEW bug correction
  v_advanced = '1.4-01 23-Nov-2018' ! Rename language to ADVANCED, and insert SELFCAL command
  v_advanced = '1.4-02 26-Nov-2018' ! Add UV_FIT command 
  v_advanced = '1.4-03 28-Nov-2018' ! Add MOMENTS command 
  v_advanced = '1.4-04 28-Nov-2018' ! Add CATALOG command 
  v_advanced = '1.4-05 15-Jan-2019' ! Better version of the CATALOG command - Drives a script
  v_advanced = '1.4-06 23-Jan-2019' ! Correction of a bug in UV_PREVIEW
  v_advanced = '1.5-01 24-Jan-2019' ! Add the ADVANCED\MASK command
  v_advanced = '1.5-02 04-Feb-2019' ! Debug the UV_FIT command -- Add the /FILE option for UV_PREVIEW
  v_advanced = '1.6-01 26-Feb-2019' ! Add the UV_ADD command (similar to UV_DOPPLER in ASTRO)
  v_advanced = '1.6-02 27-Feb-2019' ! Move the STOKES command from the Clean\ language
  v_advanced = '1.6-03 19-Mar-2019' ! Add the UV_MERGE command (simpler than the task...)
  v_advanced = '1.6-04 20-Mar-2019' ! Add the COLOR and FLUX commands  
  v_advanced = '1.6-05 28-Mar-2019' ! /SAVE option of UV_FIT 
  v_advanced = '1.6-06 14-May-2019' ! HOW_TO command
  v_advanced = '1.7-01 19-May-2019' ! FEATHER command
  v_advanced = '1.7-02 24-May-2019' ! XY_SHORT command
  v_advanced = '1.8-01 20-Jul-2019' ! UV_CIRCLE command
  v_advanced = '1.8-02 22-Jul-2019' ! /RESULT option of UV_FIT command
  v_advanced = '1.8-03 31-Jul-2019' ! PROPER_MOTION command
  v_advanced = '1.8-04 23-Sep-2019' ! Improved UV_FIT command
  v_advanced = '1.8-05 16-Oct-2019' ! COMBINE command
  v_advanced = '1.8-06 17-Oct-2019' ! FLUX and MAP_CONTINUUM commands bug correction
  v_advanced = '1.9-00 29-Nov-2019' ! Move the COMBINE and SELFCAL to the BUNDLES\ language
  v_advanced = '1.9-01 20-Jan-2020' ! Speed-up (considerably) UV_PREVIEW
  v_advanced = '1.9-02 20-Jan-2020' ! Add the UV_CORRELATE command
  v_advanced = '1.9-03 06-Feb-2020' ! Change name of SLICE buffer to SLICED for Python
  v_advanced = '1.9-04 12-Feb-2020' ! Allow UV_MERGE to merge Line tables in CONTINUUM mode
  v_advanced = '1.9-05 17-Feb-2020' ! UV_PREVIEW bug correction. Also affects MAP_CONTINUUM
  v_advanced = '1.9-06 18-Feb-2020' ! Improved STATISTIC command
  v_advanced = '2.0-00 19-Feb-2020' ! MOMENTS /CUTS option and improved SHOW MOMENTS
  v_advanced = '2.0-01 20-Feb-2020' ! UV_SHORT ? proper support
  v_advanced = '2.0-02 20-Feb-2020' ! UV_SHORT with non-circular Short-Spacing beam
  v_advanced = '2.0-03 26-Feb-2020' ! UV_SHORT /CHECK option
  v_advanced = '2.1-00 27-Feb-2020' ! UV_SHORT with minimum baseline and single-fields
  v_advanced = '2.1-01 29-Mar-2020' ! Improvements in MOMENTS
  v_advanced = '2.1-02 13-May-2020' ! Improvements in UV_CORRELATE
  v_advanced = '2.1-03 14-May-2020' ! Bug correction in UV_PREVIEW and UV_CORRELATE
  v_advanced = '2.1-04 28-May-2020' ! UV_PREVIEW /BROWSE command
  v_advanced = '2.1-05 10-Jun-2020' ! UV_PREVIEW /FILE Fich [Drop] command
  v_advanced = '2.1-07 26-Oct-2020' ! Debug completely UV_MERGE command (or 2021 ?)
  v_advanced = '2.2-00 26-Oct-2021' ! Move CATALOG and FIND to DISPLAY\ Language
  v_advanced = '2.2-01 18-Nov-2021' ! UV_SHORT V 3.9 syntax and Help improvement
  v_advanced = '2.3-00 26-Nov-2021' ! MAP_CONTINUUM /METHOD option
  v_advanced = '2.4-00 02-Dec-2021' ! UV_MOSAIC command
  v_advanced = '2.4-01 19-Dec-2021' ! UV_MERGE /MODE CONCATENATE command
  v_advanced = '2.4-02 19-Dec-2021' ! EXTRACT and SLICE syntax improvements.
  v_advanced = '2.4-03 19-Dec-2021' ! EXTRACT now allows expansion
  v_advanced = '2.4-04 08-Feb-2022' ! UV_FIT prints primary beam corrected flux
  v_advanced = '2.4-05 17-Apr-2022' ! STOKES can now work on internal buffer
  v_advanced = '2.4-06 22-Apr-2022' ! UV_PREVIEW syntax change & improvement
  v_advanced = '2.4-07 25-May-2022' ! MOMENTS SMOOTH keyword
  v_advanced = '2.4-08 07-Jun-2022' ! UV_FIT /UVRANGE Min Max
  v_advanced = '2.4-09 29-Jun-2022' ! STOKES: Correct derivation from H-V polarization
  v_advanced = '2.5-00 05-Jul-2022' ! First operational version of MAP_POLAR
  v_advanced = '2.5-01 08-Sep-2022' ! Bug correction in EXTRACT command
  v_advanced = '2.5-02 13-Oct-2022' ! Allow adding columns in UV_ADD /FILE
  v_advanced = '2.6-00 08-Nov-2022' ! Move EXTRACT and SLICE to DISPLAY\ language
  v_advanced = '2.6-01 24-Nov-2022' ! Reload the MASK after a user specified modification if in use
  v_advanced = '2.6-02 24-Jan-2023' ! SOLVE uses the SELF_GAIN convergence factor
  v_advanced = '2.6-03 08-Mar-2023' ! MASK works again on 2-D data cubes (p_mask.ima)
  v_advanced = '2.6-04 27-Mar-2023' ! MAP_CONTINUUM  SIZE and CENTER units correction
  v_advanced = '2.6-05 02-Jun-2023' ! MAP_POLAR /ANGLE option
  v_advanced = '2.6-06 07-Jul-2023' ! UV_SHORT bug corrections
  v_advanced = '2.6-06 29-Aug-2023' ! UV_SHORT command improvement (handle BLANKING and resampling)
  v_advanced = '2.6-07 07-Sep-2023' ! Fixed COMBINE memory leak
  v_advanced = '2.6-07 18-Sep-2023' ! Bug correction in frequency units in CATALOG
  v_advanced = '2.6-08 26-Sep-2023' ! Bug correction in CSV CATALOG line names
  v_advanced = '2.6-09 03-Oct-2023' ! UV_MERGE, UV_CORRELATE & UV_DETECT bugs correction
  v_advanced = '2.6-10 18-Oct-2023' ! MASK LABEL command
  v_advanced = '2.7-00 20-Oct-2023' ! MASK Improvement and UV_FIT /SAVE modification
  v_advanced = '2.7-09 13-Nov-2023' ! Correct UV_FIT for many parameters
  v_advanced = '2.7-10 14-May-2024' ! MOMENTS  SicVar  optional argument
  v_advanced = '2.7-11 17-Jul-2024' ! UV_PREVIEW after UV_CHECK BEAM bug correction
  v_advanced = '2.8-01 24-Jul-2024' ! UV_GRID command
  v_advanced = '2.8-02 12-Oct-2024' ! UV_MERGE /IGNORE option
  v_advanced = '2.8-03 05-Nov-2024' ! MAP_POLAR improvement
  v_advanced = '2.9-01 04-Nov-2024' ! UV_LINEARIZE and UV_MERGE with STITCH
  v_advanced = '2.9-02 30-Nov-2024' ! Minor bug corrections in UV_MERGE, UV_LINEARIZE, UV_PREVIEW
  v_advanced = '2.9-03 09-Dec-2024' ! UV_FIT /CONTINUUM
  endif
  v_advanced = '2.9-04 15-May-2025' ! UV_FIT protection against improper input parameters
  v_advanced = '2.9-05 17-Sep-2025' ! MASK THRESHOLD REGION improvement
  v_advanced = '2.9-06 21-Sep-2025' ! UV_MERGE /CONT Index Frequency bug correction
  v_advanced = '2.9-07 14-Oct-2025' ! UV_FIT /CONT FieldSize + UV_MERGE /CONT bug correction
  v_advanced = '2.9-08 01-Dec-2025' ! Bug correction in UV_PREVIEW /FILE (array overflow)
  !
  ! CALIBRATE\ Language versions  v_cal
  if (old) then
  v_cal = '1.0-01 03-Jul-2018' ! Split with CALIBRATE\ language 
  v_cal = '1.1-01 07-Jul-2018' ! /MINVAL option instead of /MINFLUX for MODEL 
  v_cal = '1.2-01 20-Mar-2019' ! Rename command FLUX_SCALE into SCALE_FLUX 
  v_cal = '1.3-01 16-Jul-2019' ! Command COLLECT 
  v_cal = '1.3-02 16-Jul-2019' ! Command DERIVE  
  v_cal = '1.4-01 03-Sep-2019' ! Move STATISTIC command to this language
  v_cal = '1.4-02 06-Sep-2019' ! Implement UV_SELECT selection command
  v_cal = '1.4-03 13-Sep-2019' ! Move UV_SORT command to this language
  v_cal = '1.4-04 26-Sep-2019' ! APPLY command modification ((weights and flags, r1.11)
  v_cal = '1.5-01 08-Nov-2019' ! COLLECT /FLAG option and bug correction
  v_cal = '1.6-01 17-Jan-2020' ! FIND Fmin Fmax command
  v_cal = '1.7-01 19-Mar-2020' ! MODEL /MODE IMAGE  implemented. 
  v_cal = '1.7-04 13-May-2020' ! MODEL command defines UV_MODEL
  v_cal = '1.7-05 26-May-2020' ! Finish MODEL /MODE IMAGE implementation
  v_cal = '1.7-06 15-Sep-2020' ! Add time tolerance in command APPLY
  v_cal = '1.8-00 28-Oct-2021' ! Move STATISTIC command to DISPLAY\ language
  v_cal = '1.8-01 11-Jan-2022' ! Protect MODEL against undefined data units.
  v_cal = '1.8-02 17-Jan-2022' ! Add the Frequency keyword to MODEL /MODE 
  v_cal = '1.8-03 13-Dec-2022' ! Make MODEL works on Mosaics
  v_cal = '1.8-04 15-Dec-2022' ! Make UV_MAP /FIELD works for Mosaics
  v_cal = '1.9-00 03-May-2023' ! Add PLAIT command
  v_cal = '1.9-02 24-Jul-2023' ! UV_SELF supports Mosaics now
  v_cal = '1.9-03 03-Oct-2023' ! UV_SELF no longer works on "pseudo-continuum" data
  v_cal = '1.9-04 09-Nov-2023' ! UV_SELF should force weight recomputation when starting.
  v_cal = '2.0-00 04-Sep-2024' ! AMPLITUDE command
  v_cal = '2.0-01 09-Jan-2025' ! AMPLITUDE command now functional.
  endif
  v_cal = '2.1-01 15-Apr-2025' ! New MODEL engine
  !
  ! BUNDLES\  Language versions  v_bundles
  if (old) then
  v_bundles = '1.0-00 29-Nov-2019' ! Move the COMBINE and SELFCAL to the BUNDLES\ language
  v_bundles = '1.1-00 11-Mar-2020' ! Add the EXPLORE tool
  v_bundles = '1.2-00 25-Mar-2020' ! Add the KEPLER tool
  v_bundles = '1.2-01 29-Mar-2020' ! Add the KEPLER_VELO variable
  v_bundles = '1.2-02 13-May-2020' ! Add the KEPLER /RESET option
  v_bundles = '1.3-01 22-May-2020' ! Add the UV_DETECT /COMPRESS command
  v_bundles = '1.3-02 26-May-2020' ! Better UV_DETECT command
  v_bundles = '1.3-03 30-May-2020' ! First correct UV_DETECT command
  v_bundles = '1.3-04 10-Jun-2020' ! Handle KEPLER_X0 and KEPLER_Y0 properly
  v_bundles = '1.3-05 09-Jun-2020' ! Re-size CONTINUUM data if needed in UV_RESTORE
  v_bundles = '1.4-01 30-Jul-2020' ! /VDISK option for KEPLER
  v_bundles = '1.4-02 01-Sep-2020' ! /VELOCITY option for KEPLER
  v_bundles = '1.4-03 09-Sep-2020' ! /MASK option for KEPLER
  v_bundles = '1.4-04 11-Sep-2020' ! /VDISK renamed to /VSYSTEM in KEPLER
  v_bundles = '1.5-05 14-Dec-2020' ! SPECTRAL_CLEAN command
  v_bundles = '1.5-06 14-Dec-2020' ! /HFS option to KEPLER SHOW
  v_bundles = '1.6-00 28-Oct-2021' ! Move command EXPLORE to DISPLAY\  Language
  v_bundles = '1.6-01 18-Nov-2021' ! Finish moving command EXPLORE to DISPLAY\  Language
  v_bundles = '1.6-02 29-Sep-2022' ! /WIDGET option to KEPLER
  v_bundles = '1.6-03 17-Feb-2023' ! COMBINE now support automatic spatial and spectral resampling
  v_bundles = '1.6-04 25-Jun-2023' ! COMBINE /RELATIVE to ignore absolute position
  v_bundles = '1.6-05 11-Jul-2023' ! COMBINE bug correction when spectral resampling 
  endif
  v_bundles = '1.6-06 24-Jul-2023' ! SELFCAL supports Mosaic
  v_bundles = '1.6-07 31-Aug-2023' ! SELFCAL temporary file handling changes
  !
  ! IMAGER\ Language version v_imager
  v_imager =  '1.0-00 23-Mar-2022' ! First built-in release of IMAGER\ language
  v_imager =  '1.0-01 10-May-2022' ! Insert the PIPELINE command in stack
  v_imager =  '1.0-02 30-May-2022' ! Add the /PLOT option to SDI
  v_imager =  '1.1-00 17-Oct-2022' ! Move the POPUP command to DISPLAY\
  v_imager =  '1.1-01 02-Nov-2022' ! Add the /MODE option to PIPELINE
  v_imager =  '1.2-00 22-Jun-2023' ! Add the SIMULATE command
  v_imager =  '1.2-01 05-Jul-2023' ! SIMULATE FIDELITY and SHOW command
  v_imager =  '1.2-02 13-Jul-2023' ! PIPELINE EXPLORE action
  v_imager =  '1.3-01 05-Jul-2024' ! GCLEAN command
  v_imager =  '1.3-02 17-Jul-2024' ! PIPELINE improvements (UV_PREVIEW, Resampling and line filtering behaviours)
  v_imager =  '1.4-00 04-Sep-2024' ! REPORT command
  !
  ! SIMULATE\ Language version v_simu
  v_simu   =  '1.0-02 07-Jul-2023' ! SIMULATE\ language - ADD_NOISE command
  v_simu   =  '1.0-03 29-Aug-2023' ! Small bug correction in UV_TRACK initialization
  v_simu   =  '1.0-04 14-Sep-2023' ! Bug in the NOISE handling 
  v_simu   =  '1.0-05 05-Sep-2025' ! Better messages in UV_TRACK + better noise guess
  !
  call load_display                ! Load DISPLAY\ language
  !
  ! Load the other languages
  call sic_begin('CLEAN','gag_doc:hlp/imager-help-clean.hlp',mclean, vclean, v_clean//'S.Guilloteau', run_clean, gr_error)
  call sic_begin('CALIBRATE','gag_doc:hlp/imager-help-calib.hlp',ncal, vcal, v_cal//'S.Guilloteau', run_self, gr_error)
  call sic_begin('ADVANCED','gag_doc:hlp/imager-help-news.hlp',nadv, vadv, v_advanced//'S.Guilloteau', run_advanced, gr_error)
  call sic_begin('BUNDLES','gag_doc:hlp/imager-help-bundles.hlp',ncomp, vcomp, v_bundles//'S.Guilloteau', run_bundles, gr_error)
  call sic_begin('IMAGER','gag_doc:hlp/imager-help-imager.hlp',nimag,vimag,v_imager//'S.Guilloteau', run_imager, gr_error)
  call sic_begin('SIMULATE','gag_doc:hlp/imager-help-simu.hlp',nsimu,vsimu,v_simu//'S.Guilloteau', run_simu, gr_error)
  !
  call setup_display  ! Setup the DISPLAY\ language
  !
  call sic_def_inte('IMAGER%VERSION',imager_versi,0,0,.true.,error)
  call sic_def_inte('IMAGER%PATCH',imager_patch,0,0,.true.,error)
  ! 
  call omp_setup      ! Setup Open-MP context
  !
  call sic_def_logi('CALL_TREE',call_debug,.false.,error)
  !
  user_method%do_mask = .true.  ! Unclear why ...
  call sic_def_logi('METHOD_DOMASK',user_method%do_mask,.false.,error) ! To check
  nullify(duvr)
  nullify(duvs)
  call define_imager_vars(error)
  !
  call sic_def_inte('MAP_VERSION',map_version,0,0,.false.,error)
  call sic_def_real('MAP_ROUNDING',map_rounding,0,0,.false.,error)
  call sic_def_inte('MAP_POWER   ',map_power,0,0,.false.,error)
  call gi4_round_forfft(64,iout,error,map_rounding,map_power)
  call sic_def_logi('CLEAN_DYNAMIC',cct_dynamic,.false.,error)
  !
  save_data = .false.  ! Nothing to save at start
  call sic_def_login('SAVE_DATA',save_data,1,mtype,.false.,error)
  call gprompt_set('IMAGER')
  !
  call sic_get_inte('SIC%RAMSIZE',sys_ramsize,error)
  call sic_def_inte('IMAGER_RAM',sys_ramsize,0,0,.false.,error)
  call feather_comm(' ',error) ! Initialize
  !
  call sic_def_inte('BROWSE_LAST',browse_last,0,0,.false.,error)
  !
  ansi_crlf = char(13)//char(10)
  call sic_def_char('ANSI%CRLF',ansi_crlf,.true.,error)
  !
end subroutine init_clean
!
subroutine imager_version
  use gbl_ansicodes
  use language_versions
  use gkernel_types
  use gkernel_interfaces, only : gagout, sic_findfile, sic_getlog, sic_setlog
  !
  !! IMAGER -- Test last IMAGER usage
  !
  character(len=filename_length) :: chain,file,fich
  character(len=20) :: v
  logical :: exist
  integer :: ier
  !
  call gagout(' ')
  call gagout(c_blue//c_bold//'I-IMAGER,  Program version is '//v_program//c_clear)
  call gagout(' ')
  !
  chain = '.imager_last'
  exist = sic_findfile(chain,file,'$HOME/',' ')
  if (exist) then
    open(unit=1,file=file,action='READWRITE')
    read(1,'(A)')
    read(1,'(A)') v
    if (v.ne.v_display) Call gagout(c_red//'W-IMAGER,  DISPLAY\ Language version now '//v_display &
      & //' (last version used '//v//')'//c_clear)
    read(1,'(A)') v
    if (v.ne.v_clean) Call gagout(c_red//'W-IMAGER,  CLEAN\ Language version now '//v_clean &
      & //' (last version used '//v//')'//c_clear)
    read(1,'(A)') v
    if (v.ne.v_cal) Call gagout(c_red//'W-IMAGER,  CALIBRATE\ Language version now '//v_cal &
      & //' (last version used '//v//')'//c_clear)
    read(1,'(A)') v
    if (v.ne.v_advanced) Call gagout(c_red//'W-IMAGER,  ADVANCED\ Language version now '//v_advanced &
      & //' (last version used '//v//')'//c_clear)
    read(1,'(A)') v
    if (v.ne.v_bundles) Call gagout(c_red//'W-IMAGER,  BUNDLES\ Language version now '//v_bundles &
      & //' (last version used '//v//')'//c_clear)
    read(1,'(A)',iostat=ier) v
    if (ier.ne.0) then
      if (v.ne.v_bundles) Call gagout(c_red//'W-IMAGER,  IMAGER\ Language version now '//v_bundles &
        & //' (last version used '//v//')'//c_clear)
    endif
    read(1,'(A)',iostat=ier) 
    if (ier.ne.0) then
      if (v.ne.v_program) Call gagout(c_red//'W-IMAGER,  Main Program version changed, now '//v_program &
        & //' (last version used '//v//')'//c_clear)
    endif
    rewind(1)
  else
    open(unit=1,file=file,status='NEW')  
  endif
  write(1,'(A)') ' '
  write(1,'(A)') v_display
  write(1,'(A)') v_clean
  write(1,'(A)') v_cal
  write(1,'(A)') v_advanced
  write(1,'(A)') v_bundles
  write(1,'(A)') v_imager
  write(1,'(A)') v_program
  close(unit=1)
  !
  write(fich,'(A,I4)') '$HOME/.imager/v',imager_patch
  exist = sic_findfile(fich,file,' ',' ')
  if (exist) then
    ier = sic_getlog('MACRO#DIR:',chain)
    if (chain(1:3).eq.'./;') then
      chain = chain(1:3)//trim(fich)//'/;'//trim(chain(4:))
    else
      chain = trim(fich)//'/;'//trim(chain)
    endif
    ier = sic_setlog('MACRO#DIR:',chain)
    call gagout(c_red//'W-IMAGER,  Using updated procedures from '//trim(file)//c_clear)
  endif
end subroutine imager_version
!

subroutine get_cols(nchan,ucol,fcol,lcol,wcol)
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine  
  !     Define Channel range and Weight channel
  !!
  !------------------------------------------------------------------------
  integer, intent(in) :: ucol(2)        !! User input channel range
  integer, intent(inout) :: nchan       !! Number of channels
  integer, intent(out) :: fcol          !! First channel
  integer, intent(out) :: lcol          !! Last channel
  integer, intent(out) :: wcol          !! Default weight channel
  !
  ! Local ---
  integer :: mcol(2)
  !
  ! Code ----
  mcol = ucol
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nchan))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nchan
  else
    mcol(2) = max(1,min(mcol(2),nchan))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  if (wcol.eq.0) then
    wcol = (fcol+lcol)/3
  endif
  wcol = max(1,wcol)
  wcol = min(wcol,nchan)
  nchan = lcol-fcol+1
end subroutine get_cols
!
subroutine sub_uv_residual(comm,line,iarg,duv_a,duv_b, &
  & do_clean,do_resi,subtract,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uv_residual
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for routine UV_RESIDUAL & MODEL
  !
  !   Remove all Clean Components from a UV Table  
  !   [CLEAN\]UV_RESIDUAL CLEAN [Niter] [/FIELDS List]   
  !   -- or --
  !   [CALIBRATE\]MODEL [Niter] [/MINVAL Value]
  ! 
  ! Input :  
  !     a precessed UV table  
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)  
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :  
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: comm              !! Calling Command
  character(len=*), intent(inout) :: line           !! Command line
  integer, intent(in) :: iarg                       !! First useful argument
  real, intent(in) , target :: duv_a(:,:)           !! Input buffer
  real, intent(inout), target :: duv_b(:,:)         !! May not be defined here
  logical, intent(in) :: do_clean                   !! Re-image ?
  logical, intent(in) :: do_resi                    !! Evaluate UV residual ?
  logical, intent(in) :: subtract                   !! Subtract model ?
  logical, intent(out) :: error                     !! Error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: o_field=1
  integer, parameter :: o_minval=1
  ! Minimum number of Visibilities to activate the FFT mode
  integer, parameter :: fft_mode=20000 
  !
  ! Local ---
  character(len=24) :: task
  real(8) :: freq
  character(len=message_length) :: chain
  real :: cpu0, cpu1
  integer :: ier,nu,nv,mv,nchan
  !
  real, pointer :: duv_in(:,:), duv_out(:,:)
  real, allocatable, target :: ccou(:,:,:)
  real, pointer :: fcou(:,:,:)
  real, pointer :: fctmp(:,:,:)
  real, allocatable :: duv_tmp(:,:)
  real, allocatable :: dmap(:,:,:)          ! Storage for GAUSS method in Mosaics.
  integer, allocatable :: omic(:), nmic(:)
  integer :: maxic, ic,lc, icmax, oic, olc, iv
  integer :: nthread, ithread, np
  logical :: fft, debug
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  ! For mosaics
  logical :: do_mosaic
  type(clean_par) :: my_method
  type(projection_t) :: proj
  real(8) :: pos(2)
  real(4) :: bsize(10), beamsize, save_major
  integer :: ifield, jfield, nfields! Field number & Number of fields
  real, allocatable :: doff(:,:)    ! Field offsets
  integer, allocatable :: ivoff(:)  ! Input Visibility pointers
  integer, allocatable :: jvoff(:)  ! Output Visibility pointers
  integer :: ivstart, ivend, kvstart, kvend, ibeam
  logical :: sorted, shift
  real(8) :: new(3)
  real(4) :: uvmin, uvmax
  logical :: omp_nested
  integer :: outer_threads, inner_threads, jc, kc, j3, j4
  !
  integer :: fcol, lcol, wcol, cctsize
  integer :: chunk, mx, my
  integer :: itrail
  real :: bstep ! Words per image pixel
  logical :: compact ! Test logical for code development
  integer, allocatable :: teles(:)
  !
  ! Code ---
  !
  ! Change Message header 
  if (comm.eq.'MOSAIC_RESTORE') then
    task = 'MOSAIC_RESIDUAL'
  else
    task = comm
  endif
  call map_message(seve%d,task,'Calling SUB_UV_RESIDUAL',3)
  !
  ! Subtract all Clean Components
  if (.not.associated(duv)) then
    call map_message(seve%e,task,'DUV is NOT allocated')
    error = .true.
    return
  endif
  if (.not.allocated(dcct)) then
    call map_message(seve%e,task,'DCCT is NOT allocated')
    error = .true.
    return
  endif
  !
  if (allocated(doff)) then
    Print *,'DOFF is still allocated '
    deallocate(doff)
  endif
  if (allocated(ivoff)) then
    Print *,'IVOFF is still allocated '
    deallocate(ivoff)
  endif
  !
  ! Basic initializations
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi    ! not %dim(2)
  nchan = huv%gil%nchan ! Default value 
  !
  ! That only works for UV_RESTORE, not for UV_RESIDUAL
  call get_cols(nchan,saved_chan%bounds,fcol,lcol,wcol)
  !TEST!Print *,'Done GET_COLS ',fcol,lcol, ' NCHAN ',nchan
  !
  ithread = 1
  nthread = 1
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)
  error = .false.
  !
  ! Verify number of channels match
  if (hcct%gil%dim(2).ne.huv%gil%nchan) then
    if (hcct%gil%dim(2).eq.1) then
      call map_message(seve%w,task,'Subtracting a Continuum CCT from a Line data set')
    else
      write(chain,'(A,I0,A,I0,A)') 'Number of channels in CCT [', &
      & hcct%gil%dim(2),'] and in UV [',huv%gil%nchan,'] do not match'
      if (debug) Print *,'SAVED_MCOL ',saved_chan%bounds 
      call map_message(seve%w,task,chain)
!      error = .true.
!      return
    endif
  endif  
  !
  maxic = hcct%gil%dim(3)
  if (iarg.gt.0) then
    call sic_i4(line,0,iarg,maxic,.false.,error)
    if (error) return
    if (maxic.lt.0) maxic = hcct%gil%dim(3)
    maxic = min(hcct%gil%dim(3),maxic)
    if (maxic.eq.0) return ! Nothing to do then...
  endif
  !
  allocate (omic(nchan),nmic(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Compact the Clean components first
  ic = fcol
  lc = lcol
  hcct%r3d => dcct
  call uv_clean_sizes(hcct,hcct%r3d,omic,ic-fcol+1,lc-fcol+1)
  icmax = maxval(omic)
  if (debug) Print *,'Max number of clean components ',icmax
  !
  ! Nothing to do if no Clean component
  if (icmax.eq.0) then
    call map_message(seve%w,task,'No valid Clean Component')
    return
  endif  
  !
  call gag_cpu(cpu0)
  do_mosaic = (themap%nfields.ne.0).and.(abs(themap%nfields).ne.1)
  !
  bsize = 0.
  if (do_mosaic) then
    !
    ! Get primary beam size
    !!Print *,'SUB_UVRESIDUAL get_bsize ',bsize
    call get_bsize(huv,task,' ',bsize,error)
    if (debug) Print *,'Primary beam size ',bsize/sec_to_rad,' " '
    !
  endif
  !
  if (do_resi) then
    if (do_mosaic) then
      !
      ! True Mosaic case
      nfields = abs(themap%nfields)
      allocate(doff(2,nfields),ivoff(nfields+1),jvoff(nfields+1), &
      &	teles(nfields),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,task,'Memory allocation error')
        error = .true.
        return
      endif
      shift = .false.
      sorted = .false.
      error = .false.
      if (debug) Print *,'Sorting Mosaic ',themap%nfields, &
        & huv%gil%column_pointer(code_uvt_xoff), &
        & huv%gil%column_pointer(code_uvt_yoff), &
        & nfields
      !
      new = 0.D0 ! No change of Phase center
      !
      call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
        & huv%gil%column_pointer(code_uvt_xoff), &
        & huv%gil%column_pointer(code_uvt_yoff), &
        & huv%gil%column_pointer(code_uvt_id), &
        & nfields,doff,ivoff)
      if (error) return
      teles(1:nfields) = huv%mos%fields(:)%jteles
      if (debug) Print *,'Nfields ',nfields
      !
      ! Shift offset coordinates to Phase center 
      call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
      if (debug) Print *,'Posangle ',huv%gil%pang
      ! POS is here the Offset of the Pointing center relative to the Phase center
      call abs_to_rel (proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
      if (debug) Print *,'POS ',pos
      do ifield=1,nfields
        doff(:,ifield) = doff(:,ifield)+pos
        if (debug) Print *,doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
      enddo
      !
      ! For tests per field - not useable in production
      if (task.eq.'UV_RESIDUAL'.and.sic_present(o_field,0)) then
        call select_fields(task,line,o_field,nfields,np,selected_fields,error)
        if (error) return
        selected_fieldsize = np
      endif
      !
      if (selected_fieldsize.ne.0) then
        if (.not.allocated(selected_fields)) then
          call map_message(seve%f,task, &
            & 'Programming error, Selected_Fields not allocated')
          error = .true.
          return
        endif
        if (debug) Print *,'Selected Fields ',selected_fields(1:selected_fieldsize) !!
        nv = 1
        mv = 0
        do jfield=1,selected_fieldsize
          ifield = selected_fields(jfield)
          jvoff(jfield) = nv
          mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
          nv = nv + ivoff(ifield+1)-ivoff(ifield)
          jvoff(jfield+1) = nv
        enddo
        nv = nv-1
        nfields = selected_fieldsize
      else
        jvoff(:) = ivoff
        mv = 0
        do ifield=1,nfields
          mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
        enddo
      endif
    else
      nfields = 1
      mv = nv
      allocate(doff(2,1),ivoff(2),jvoff(2),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,task,'Memory allocation error')
        error = .true.
        return
      endif
      doff = 0.0
      bsize = 0.
      ivoff(1) = 1
      ivoff(2) = nv+1
      jvoff(:) = ivoff
      !
      if (debug) Print *,'Single Field case'
    endif 
    !
    ! Select the FFT or DIRECT mode by default, according to the
    ! problem size. This may need to be tested in more details
    if (mv.lt.fft_mode) then
      fft = .false.
    else
      fft = .true.
      !
      ! Define the Chunk size
    endif
    if (debug) Print *,'Default FFT ',fft, mv
    call sic_get_logi('FAST',fft,error)
    if (debug) Print *,'User set FFT ',fft, error
    error = .false.
  endif ! DO_RESI
  beamsize = maxval(bsize)
  !
  ! Redo that by block - At this stage NFIELDS is the actual number of selected fields.
  !
  oic = ic    ! This must be FCOL
  olc = lc    ! This must be LCOL
  if (debug) Print *,'IC ',ic,' LC ',lc
  !
  ! Spatially compress the Clean Component List
  cctsize = hcct%gil%dim(1)
  if ((cctsize.eq.4).and.(nfields.gt.1)) fft = .true.    ! For mosaics only
  !
  allocate(ccou(cctsize,icmax,nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'CCOU Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'uv_squeeze_clean ',nchan,omic,ic,lc, ' FCOL ',fcol
  call uv_squeeze_clean(nchan,hcct%r3d, ccou, omic,ic-fcol+1,lc-fcol+1)
  if (debug) Print *,'Done uv_squeeze_clean' 
  ! 
  ! Remember the Full Clean Component List size
  nmic(:) = omic
  !
  if ((beamsize.ne.0).and.(cctsize.ne.4)) then
    maxic = maxval(omic)
    write(chain,'(A,I0,A,I0,A)') 'Compressing CCT from ',icmax,' to ',maxic,' components'
    call map_message(seve%i,task,chain)
    allocate(fcou(cctsize,maxic,nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
  else
    fcou => ccou
  endif
  freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
  !
  itrail = -huv%gil%lcol + huv%gil%dim(1) 
  !
  if (debug) Print *,'LCOL ',huv%gil%lcol,' and DIM ',huv%gil%dim(1)
  !
  ! Simple sequential stuff - parallelism is inside the
  !   uv_remove_...  subroutines to avoid memory issues
  ! Unfortunately, this parallelism is only efficient if
  ! the number of visibilities is sufficient.
  !
  ! So a mode with per-field parallelism would be good.
  ! But one has to be careful about IC and LC
  !
  if (debug) Print *,'IC LC ',ic,lc,' OIC OLC ',oic,olc
  !
  !
  if (do_resi) then
    bstep = 0.1            ! Small memory imprint
    if (fft) bstep = 2     ! 1 complex word
    mx = (hcct%gil%convert(1,1)-1)*2   ! Reference pixel is at Mx/2+1
    my = (hcct%gil%convert(1,3)-1)*2
    call uv_get_block(fft,mx,my,huv%gil%nchan,1,bstep,chunk)
    !
    if ((cctsize.eq.4).and.(nfields.gt.1)) then
      allocate(dmap(mx,my,nchan),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,task,'DMAP Memory allocation error')
        error = .true.
        return
      endif
    endif
    !
    omp_nested = .true.
    !$ inner_threads = omp_get_max_threads()
    !$ outer_threads = 1 ! Should be nfields if Outer parallel mode is activated
    !$ call ompset_thread_nesting(task, outer_threads, inner_threads, omp_nested)
    !
    do jfield=1,nfields
      !
      if (sic_ctrlc()) then
        call map_message(seve%w,task,'Aborted by user ^C')
        error = .true.
        return
      endif
      !
      ifield = jfield
      if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)
      if (debug) Print *,'Field ',ifield,jfield
      !
      ! This looks tricky, but is working.
      ! It used to extract an arbitrary subset of all fields
      ! In input Ifield
      ivstart = ivoff(ifield)      ! Starting Visibility of field
      ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
      ! In output Jfield
      kvstart = jvoff(jfield)      ! Starting Visibility of field
      kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
      if (nfields.gt.1) then
        write(chain,'(A,I0,4(1X,I0),2F10.2)') 'Processing field # ',ifield, &
          & ivstart,ivend, kvstart, kvend, doff(1,ifield)/sec_to_rad, doff(2,ifield)/sec_to_rad
        call map_message(seve%i,task,chain)
      endif
      !
      nv = ivend-ivstart+1
      if (ivend.gt.ubound(duv,2)) then
        Print *,'Programming error IVEND',kvend,' > Bound ',ubound(duv,2)
      endif
      !OLD!      duv_in => duv_a(:,ivstart:ivend) ! We now start from DUV_PREVIOUS
      !TEST!Print *,'Size DUV_PREVIOUS ',size(duv_a,1)
      !TEST!Print *,'Size DUV',size(duv,1)
      ! We should now start from DUV, not DUV_PREVIOUS
      ! It is not clear why, as normally DUV_PREVIOUS was pointing towards DUV before
      ! but it seems needed to Mosaic... To be elucidated
      duv_in => duv_a(:,ivstart:ivend)    !! DUV_A should be used, DUV associated outside if needed
      if (kvend.gt.ubound(duv_b,2)) then   
        Print *,'Programming error KVEND',kvend,' > Bound ',ubound(duv_b,2)
      endif
      duv_out => duv_b(:,kvstart:kvend)    ! We put in DUV_B
      if (fft) then
        allocate(duv_tmp(7+3*chunk+itrail,kvend-kvstart+1),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,comm,'FFT memory allocation error')
          error = .true.
          return
        endif
      endif
      !
      if ((cctsize.eq.3).or.(beamsize.eq.0)) then
        if (beamsize.ne.0) then
          omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
          call attenuate_clean(nchan,ccou,doff(:,ifield), & 
          &	bsize(teles(ifield)),fcou,omic)
        endif
        !
        if (.not.fft) then
          if (debug) Print *,'Slow case IC ',ic,' LC ',lc,' OMIC ',omic,' IFIELD ',ifield
          call uv_removes_clean(nv,duv_in,duv_out,lc-ic+1,omic, &
            & fcou,freq,ic,lc, subtract)
        else
          if (debug) Print *,'Fast case IC ',ic,' LC ',lc,' OMIC ',omic, ' IFIELD ',ifield
          !
          ! By channel chunks
          do oic=ic,lc,chunk
            olc = min(lc,oic+chunk-1)
            duv_tmp = 0.
            !
            ! Offset in OMIC but Also in FCOU
            fctmp => fcou(:,:,oic-ic+1:)
            call uv_removef_clean(hcct,duv_in,duv_tmp,olc-oic+1,omic(oic:olc), &
              & fctmp,freq, oic, olc, subtract)
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
        endif
      else    ! GCLEAN on Mosaic
        ! Compute the Clean Component Map, but unsmoothed by the Clean beam
        ! Set the beam size to Zero for this
        save_major = the_method%major
        the_method%major = 0.
        !
        compact = .true.
        call sic_get_logi('RESTORE_COMPACT',compact,error)
        error = .false.
        if (debug) Print *,'User set RESTORE_COMPACT ',compact, error
        !
        if (.not.compact) then
          !
          ! Do by Fields, using FFT
          omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
          ! By channel chunks
          do oic=ic,lc,chunk
            olc = min(lc,oic+chunk-1)
            duv_tmp = 0.
            !
            ! Offset in OMIC but Also in FCOU
            fctmp => fcou(:,:,oic-ic+1:)
            ! Loop over channels to compute the Clean Component Cube
            do jc=oic,olc
              kc = jc-oic+1
              call clean_make_cct(the_method,hclean,dmap(:,:,kc:kc),fctmp(:,:,kc:kc),the_method%gsize)
            enddo
            !
            ! This is approximate
            jc = (oic+olc)/2
            ibeam = beam_for_channel(jc,hdirty,hbeam)
            if (hbeam%gil%faxi.eq.3) then
              j3 = ibeam
              j4 = ifield
            else
              j3 = ifield
              j4 = ibeam
            endif
            !
            call uv_removeg_clean(hcct,duv_in,duv_tmp,olc-oic+1,omic(oic:olc), &
              & dmap,freq, oic, olc, hbeam%r4d(:,:,j3,j4), subtract)
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
        else
          if (ifield.eq.1) call map_message(seve%w,task,'Using REMOVEH for GCLEAN on Mosaic')
          ! Do by Fields, using FFT
          omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
          ! By channel chunks
          do oic=ic,lc,chunk
            olc = min(lc,oic+chunk-1)
            duv_tmp = 0.
            fctmp => fcou(:,:,oic-ic+1:)
            !
            call uv_removeh_clean(the_method,hbeam,hclean, &
            & hcct,duv_in,duv_tmp,olc-oic+1,omic,fctmp,freq,oic,olc,ifield,subtract) !
            !
            do iv=1,nv
              duv_out(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
            enddo
          enddo
        endif
        the_method%major = save_major
      endif
      !
      ! Add leading and trailing data if any
      if (debug) Print *,'NV ',nv,' Bounds ',ubound(duv_in,2),ubound(duv_out,2)
      if (huv%gil%lcol.lt.huv%gil%dim(1)) then
        do iv=1,nv
          duv_out(1:7,iv) = duv_in(1:7,iv)
          duv_out(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
            & duv_in(huv%gil%lcol+1:huv%gil%dim(1),iv)  
        enddo
      else
        if (debug) Print *,'WARNING no trailing column'
        do iv=1,nv
          duv_out(1:7,iv) = duv_in(1:7,iv)
        enddo
      endif
      !
      if (allocated(duv_tmp)) deallocate (duv_tmp)
    enddo ! Fields
    !
  endif ! DO_RESI
  !
  ! Compute the CLEAN image
  if (do_clean) then
    call copy_method(the_method,my_method)
    my_method%method = 'UV_RESTORE'
    my_method%bshift = 0      ! This looks uninitialized
    if (debug) Print *,'Calling GENERATE_CLEAN ',my_method%method,my_method%bshift
    ! We need a Clean Beam size    
    !
    call mosaic_set_beam(task,my_method)
    !
    ! Use the Full Clean Component list size
    call generate_clean(my_method,hsky,1,lc-ic+1,ccou,nmic)
  endif
  !
  call gag_cpu(cpu1)
  if (elapsed.eq.0) then
    write(chain,102) 'Finished Residual CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished Residual Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,task,chain)
  !
  if (associated(fcou)) then
    if (.not.associated(fcou,ccou)) deallocate(fcou)
  endif
  if (allocated(ccou)) deallocate(ccou)
  !
  call map_message(seve%d,task,'Finished SUB_UV_RESIDUAL',3)
  !
102 format(a,f9.2,a,f9.2)
end subroutine sub_uv_residual
!
subroutine uv_clean_size(hcct,ccin, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for UV_RESTORE  
  !   Compute the actual number of components
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))  !! CCT data set
  integer, intent(out) :: mic         !! Last valid component
  !
  ! Local ---
  integer :: nc, ic, i, ni, ki, mi
  !
  ! Code ----
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mi = 0
  do ic=1,nc
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        ki = i-1
        exit
      endif
    enddo
    if (ki.ne.0) then
      mi = max(mi,ki)
    endif
  enddo
  if (mi.eq.0) mi = ni
  mic = mi
end subroutine uv_clean_size
!
subroutine generate_clean(amethod,hmap,first,last,ccou,mic)
  !$ use omp_lib
  use clean_def
  use image_def
  use imager_interfaces, only : clean_make
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESTORE
  !
  !   Generate the Clean image (without residuals) from the 
  !   (compressed or not) list of Clean components, over
  !   the specified range of channels
  !!
  !---------------------------------------------------------------------
  type(clean_par), intent(in) :: amethod  !! Clean Method
  type(gildas), intent(inout) :: hmap     !! Clean Header
  integer, intent(in) :: first            !! First channel
  integer, intent(in) :: last             !! Last channel
  real, intent(in) :: ccou(:,:,:)         !!  (x,y,Value),Component,Plane
  integer, intent(in) :: mic(:)           !! Niter per plane
  !
  ! Local ---
  type (cct_par), allocatable :: p_cct(:)
  type (clean_par) :: my_method 
  integer :: iplane, jplane, niter, miter, i, ier, nthread
  !
  ! Code ----
  miter = max(1,maxval(mic))
  allocate (p_cct(miter),stat=ier)
  !$ nthread = omp_get_max_threads()
  !  !$ Print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(),
  !$ nthread = min(nthread,last-first+1)
  !$OMP PARALLEL DEFAULT(NONE) NUM_THREADS(nthread) &
  !$OMP & SHARED(amethod, first, last, hmap, mic, ccou, nthread) &
  !$OMP & PRIVATE(my_method, iplane, jplane, p_cct, niter, i) 
  !
  !$OMP DO
  do iplane = first, last
    my_method = amethod
    !
    my_method%iplane = iplane
    !
    ! Recover the component list in pixels
    jplane = iplane-first+1
    niter = mic(jplane) 
    do i=1,niter
      if (ccou(3,i,jplane).eq.0) then
        p_cct(i)%value = 0 ! Required
        niter = i-1
        exit
      else
        !
        ! The NINT is required because of rounding errors
        p_cct(i)%ix = nint( (ccou(1,i,jplane)-hmap%gil%convert(2,1)) /  &
            &        hmap%gil%convert(3,1) + hmap%gil%convert(1,1))
        p_cct(i)%iy = nint( (ccou(2,i,jplane)-hmap%gil%convert(2,2)) /  &
            &        hmap%gil%convert(3,2) + hmap%gil%convert(1,2))
        p_cct(i)%value = ccou(3,i,jplane)
      endif
    enddo
    ! Stupid test
    if (niter.gt.0) then
      my_method%n_iter = niter
      call clean_make(my_method,hmap, hmap%r3d(:,:,iplane),p_cct)
    else
      hmap%r3d(:,:,iplane) = 0
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  deallocate(p_cct)
end subroutine generate_clean
!
subroutine attenuate_clean(nchan,ccou,doff,bsize,fcou,mic,dpha)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for UV_RESIDUAL
  !
  !   Apply primary beam attenuation to Clean Components
  ! at specified offset. Compress Clean component based on position
  ! while doing so.
  !
  ! If a Phase Offset argument DPHA is present, shift the Clean
  ! Component positions to this new phase center.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nchan          !! Number of channels
  real, intent(in) :: ccou(:,:,:)       !! Shape (3,Ncomp,Nplane)
  real, intent(out) :: fcou(:,:,:)      !! Same shape, but different sizes 
  real, intent(in) :: doff(2)           !! Offset value
  real, intent(in) :: bsize             !! Beam size
  integer, intent(inout) :: mic(nchan)  !! Effective number of Clean components
  real(8), intent(in), optional :: dpha(2)  !! Phase offsets if any
  !
  ! Local ---
  real :: beam_e, b2, fact
  integer :: ic,jc,kc
  logical :: do_shift
  !
  ! Code ----
  do_shift = present(dpha)
  if (do_shift) then
    if ((dpha(1).eq.0).and.(dpha(2).eq.0)) then
      do_shift = .false.
    endif
  endif
  !
  beam_e = bsize/(2.*sqrt(log(2.0)))
  b2 = (1.0/beam_e)**2
  !
  ! The attenuation here is currently purely Gaussian
  ! We MUST use the beam profile mechanism to do better.
  do ic=1,nchan
    kc = 0
    do jc=1,mic(ic)
      fact = ((ccou(1,jc,ic)-doff(1))**2+(ccou(2,jc,ic)-doff(2))**2)*b2
      if (fact.lt.32) then
        kc = kc+1
        fcou(3,kc,ic) = ccou(3,jc,ic)*exp(-fact)
        if (do_shift) then
          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)-dpha(1:2)
        else
          fcou(1:2,kc,ic) = ccou(1:2,jc,ic)
        endif
      endif
    enddo
    mic(ic) = kc
  enddo
  !
end subroutine attenuate_clean
!
subroutine mosaic_set_beam(task,my_method)
  use gkernel_interfaces
  use imager_interfaces, only : fibeam, map_message
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Define the Mosaic Clean Beam
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task        !! Caller name
  type(clean_par), intent(inout) :: my_method !! Clean parameters 
  !! to be completed by Clean beam
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_to_rad=pi/3600.d0/180d0
  !
  ! Local ---
  character(len=80) :: mess
  integer :: nx,ny
  logical :: error
  !
  ! Code ----
  if (hsky%gil%majo.eq.0) then
    if (beam_defined) then
      my_method%major = beam_fitted(1) * sec_to_rad
      my_method%minor = beam_fitted(2) * sec_to_rad
      my_method%angle = beam_fitted(3)   ! Keep it Degree...
    else
      my_method%major = 0
      my_method%minor = 0
      my_method%angle = 0
      nx = hbeam%gil%dim(1)
      ny = hbeam%gil%dim(2)
      error = .false.
      call fibeam (task,dbeam,nx,ny,   &
       &    my_method%patch(1),my_method%patch(2),my_method%thresh,   &
       &    my_method%major,my_method%minor,my_method%angle,   &
       &    hbeam%gil%convert,error)
    endif
    !
    hsky%gil%majo = my_method%major
    hsky%gil%mino = my_method%minor
    hsky%gil%posa = my_method%angle*pi/180.
    hsky%gil%reso_words = 3
  else
    write(mess,'(A,F8.2)') 'Spatial Resolution was already defined ', &
      & hsky%gil%majo*180*3600/pi
    call map_message(seve%w,task,mess)
  endif
end subroutine mosaic_set_beam

subroutine comm_proper_motion(line,comm,error)
  use gkernel_interfaces
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, only : proper_motion, proper_motion_file, uv_new_data
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command 
  !     PROPER_MOTION PmRa PmDec [Epoch] [/FILE In Out]
  !
  !   Apply specified proper motion to current or specified UV Table
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name
  logical, intent(inout) :: error         !! Error flag
  !
  integer, parameter :: o_file=1
  !
  character(len=filename_length) :: input,output
  character(len=16) :: ch
  integer :: n,i
  integer :: jepoch,j2000
  real(8) :: yepoch
  logical :: keep(3)
  real(8) :: proper(3) ! In mas/yr and Year
  integer :: nvisi
  !
  ! Input parameters
  proper = 0
  do i=1,2
    call sic_ch(line,0,i,ch,n,.true.,error)
    if (error) return
    if (ch.eq.'*') then
      keep(i) = .true.
    else
      call sic_r8(line,0,i,proper(i),.true.,error)
      if (error) return
      keep(i) = .false.
    endif
  enddo
  if (sic_present(0,3)) then
    call sic_ke(line,0,3,ch,n,.true.,error)
    if (ch.eq.'*') then
      keep(3) = .true.
    else
      if (index(ch,'-').ne.0) then
        call gag_fromdate(ch,jepoch,error)
        if (error) return
        ch = '01-JAN-2000'
        call gag_fromdate(ch,j2000,error)
        yepoch = (jepoch-j2000)/365.25d0 + 2000.0d0 ! Corresponding Epoch in Years
      else
        call sic_r8(line,0,3,yepoch,.true.,error)
        if (error) return
      endif
      keep(3) = .false.
      proper(3) = yepoch
    endif
  else
    keep(3) = .true.
  endif
  !
  if (sic_present(o_file,0)) then
    ! Not yet prepared -- Need more work...
    call sic_ch(line,o_file,2,output,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,1,input,n,.true.,error)
    if (error) return
    call proper_motion_file (comm,input, output, proper, keep, error)
  else
    if (.not.associated(duv)) then
      call map_message(seve%e,comm,'No UV data loaded')
      error = .true.
      return
    endif
    nvisi = huv%gil%nvisi
    if (keep(3).and.huv%gil%astr_words.eq.0)  proper(3)=2000.d0 ! In case nothing
    call proper_motion (proper,keep,huv,nvisi,duv)
    !
    ! Define the Proper Motion section
    huv%gil%epoc = proper(3)
    huv%gil%astr_words = def_astr_words ! 3
    huv%gil%mura = proper(1)
    huv%gil%mudec = proper(2)
    huv%gil%parallax = 0.0 
    ! Force reading if needed (no Buffer used)
    optimize(code_save_uv)%change = 2
!    call sic_delvariable('UV',.false.,error)
!    call uv_new_data(weight=.false.)
  endif
end subroutine comm_proper_motion
!
subroutine proper_motion_file (rname, cuvin, cuvou, proper, keep, error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : proper_motion, map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command PROPER_MOTION
  !
  !      Apply specified proper motion to an input UV Table
  !   and write it on an output UV table. Version working on files.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname   !! Caller name
  character(len=*), intent(in) :: cuvin   !! Input file name
  character(len=*), intent(in) :: cuvou   !! Output fiel name
  real(8), intent(inout) :: proper(3)     !! muRA muDec Epoch
  logical, intent(in) :: keep(3)          !! Keep previous values
  logical, intent(out) :: error           !! Error flag
  !
  ! Local ---
  character(len=80)  :: mess
  type (gildas) :: uvin
  type (gildas) :: uvou
  integer :: ier, nblock, ib, nvisi
  !
  ! Code ----
  error = len_trim(cuvin).eq.0
  if (error) then
    call map_message(seve%e,rname,'No input UV table name')
    return
  endif
  !
  call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_read_gildas (uvin, cuvin, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table')
    return
  endif
  if (keep(3).and.uvin%gil%astr_words.eq.0)  proper(3)=2000.d0 ! In case nothing
  !
  ! Modify the header of the output UV table according to the desired goal
  call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
  call gdf_copy_header(uvin,uvou,error)
  call sic_parse_file(cuvou,' ','.uvt',uvou%file)
  !
  uvou%gil%astr_words = def_astr_words ! 3
  uvou%gil%mura = proper(1)
  uvou%gil%mudec = proper(2)
  uvou%gil%parallax = 0.0
  uvou%gil%epoc = proper(3)
  !
  ! create the image
  call gdf_create_image(uvou,error)
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,uvin%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvin%gil%dim(2))
  ! Allocate respective space for each file
  allocate (uvin%r2d(uvin%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvin%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  uvin%blc = 0
  uvin%trc = 0
  uvou%blc = 0
  uvou%trc = 0
  do ib = 1,uvin%gil%dim(2),nblock
    write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
    call map_message(seve%i,rname,mess)
    uvin%blc(2) = ib
    uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
    uvou%blc(2) = ib
    uvou%trc(2) = uvin%trc(2)
    call gdf_read_data(uvin,uvin%r2d,error)
    !
    ! Here do the job
    nvisi = uvou%trc(2)-uvou%blc(2)+1
    !
    ! Note that we use UVIN to have the old proper motion & Epoch...
    call proper_motion (proper,keep,uvin,nvisi,uvin%r2d)
    !
    call gdf_write_data (uvou,uvin%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize the image
  call gdf_close_image(uvin,error)
  call gdf_close_image(uvou,error)
  !
end subroutine proper_motion_file
!
subroutine proper_motion (mu,keep,huv,nvisi,visi)
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for command PROPER_MOTION
  !
  !   Apply specified proper motion to a GILDAS UV data set in Memory.
  !!
  !---------------------------------------------------------------------
  real(8), intent(inout) :: mu(3)       !! Proper motion mas/yr & Year
  logical, intent(in) :: keep(3)        !! Keep previous values
  type (gildas), intent(in) :: huv      !! UV Header
  integer, intent(in) :: nvisi          !! Number of visibilities
  real(4), intent(inout) :: visi(huv%gil%dim(1),nvisi)  !! Visibility array
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  real, parameter :: rad_to_sec=180.0*3600.0/pi
  integer, parameter :: md=100 ! This is a dammn lot of observing time !
  !
  ! Local ---
  real(8) :: mudif(3),muold(3),pos(2),freq,dpos(2)
  character(len=11) :: cdate
  integer :: i, ix, iu, iv, id, zerold
  real(4) :: reel, imag
  real(8) :: uu, vv, phi, sphi, cphi, d, dyear
  real(4) :: dayold, dold
  logical :: error, uv8
  !
  integer :: jd,nd
  integer :: aday(md)
  real :: apos(2,md)
  logical :: missing
  !
  !   Old PM in mas/yr & Epoch in days
  muold = [huv%gil%mura,huv%gil%mudec,huv%gil%epoc]
  if (huv%gil%astr_words.eq.0) muold(3) = mu(3)     ! No epoch, use specified one
  if (keep(1)) mu(1) = muold(1)
  if (keep(2)) mu(2) = muold(2)
  if (keep(3)) mu(3) = muold(3)
  !
  zerold = int(muold(3))
  write(cdate,'(A,I4)') '01-JAN-',zerold
  call gag_fromdate(cdate,id,error)
  dayold = id + 365.25*(muold(3)-zerold)
  !
  mudif = mu-muold       ! Difference
  !
  ! Get proper motion in Rad/year
  mudif(1:2) = mudif(1:2)*1d-3*pi/180D0/3600d0 ! Radians / year
  muold(1:2) = muold(1:2)*1d-3*pi/180D0/3600d0 ! Radians / year
  !
  ! Global displacement between epochs
  if (keep(3)) then
    dpos = 0.d0
  else
    ! Simple linear offsets...
    dpos = muold(1:2)*mudif(3)
  endif
  !Print *,'DPOS ',dpos(1)*rad_to_sec,dpos(2)*rad_to_sec
  !
  ! Get observing frequency
  freq = gdf_uv_frequency(huv)
  !
  uv8 = huv%gil%column_size(code_uvt_u).ne.1
  !
  iu = huv%gil%column_pointer(code_uvt_u)
  iv = huv%gil%column_pointer(code_uvt_v)
  id = huv%gil%column_pointer(code_uvt_date)
  if (uv8) print *,'UV8 ',uv8,iu,iv,id
  !
  dold = 0
  nd = 0
  !Print *,' Visi       Date     Jzero      Dyear      Pos(1:2)'
  do i = 1,nvisi
    if (uv8) then
      call r4tor4 (visi(iu,i),uu,2)   ! Avoid r8tor8 for alignment problems
      call r4tor4 (visi(iv,i),vv,2)
    else
      uu = visi(iu,i)                 ! Implicit Real(4) -> Real(8) conversion
      vv = visi(iv,i)
    endif
    !
    ! Get date in CLASS Days
    d = visi(id,i)
    ! Get time increment in Days / Days per year
    dyear = (d-dayold)/365.25
    ! Get moving Position at this date
    pos = mudif(1:2)*dyear
    ! Shift the Phases to the new Epoch 
    pos = pos - dpos
    ! Collect per day position changes for printing
    if (d.ne.dold) then
      missing = .true.
      do jd=1,nd
        if (d.eq.aday(jd)) then
          missing = .false.
          exit
        endif
      enddo
      !
      if (missing) then
        nd = nd+1
        aday(nd) = d
        apos(:,nd) = pos*rad_to_sec
      endif
      dold = d
    endif
    !
    ! compute new phase center in wavelengths
    pos = - freq * f_to_k * pos
    phi = pos(1)*uu + pos(2)*vv
    cphi = cos(phi)
    sphi = sin(phi)
    do ix = huv%gil%fcol, huv%gil%lcol, huv%gil%natom
      reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
      imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
      visi(ix,i) = reel
      visi(ix+1,i) = imag
    enddo
  enddo
  !
  ! Print per day positoin changes
  write(*,'(A)') '   Date      d(alpha)   d(beta)'
  do jd=1,nd
    call gag_todate(aday(jd),cdate,error)
    write(*,'(A,F9.3,F9.3)') cdate,apos(1,jd),apos(2,jd)
  enddo
  !
end subroutine proper_motion

subroutine spectral_comm(line,comm,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --  Support routine for  
  !   SPECTRAL_CLEAN Method Control
  !
  ! Drive a multi-spectral Clean deconvolution on a Data Cube
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name
  logical, intent(inout) :: error         !! Logical error flag
  !
  ! Local ---
  character(len=12) :: arg
  integer :: n, iarg
  !
  ! Code ----
  arg = '?'
  call sic_ke(line,0,1,arg,n,.false.,error)
  if (error) return
  !
  select case (arg)
  case ('?')
    call exec_program('@ spectral-clean ?')
  case ('MULTI')
    call spectral_multi(line,error)
  case default
    iarg = sic_start(0,1)
    call exec_program('@ spectral-clean '//line(iarg:))
  end select
end subroutine spectral_comm
!
subroutine spectral_multi(line,error)
  use image_def
  use clean_def
  use clean_arrays
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for  
  !   SPECTRAL MULTI  Na Nb .. Nc [1]
  !
  !   Clean at various spectral resolutions
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  logical, intent(out) :: error             !! Logical error flag
  !
  character(len=*), parameter :: rname='SPECTRAL'
  !
  ! Local ---
  character(len=80) :: chain
  integer :: narg, i, ier
  integer, allocatable :: smooth(:)
  type(gildas) :: horig
  !
  ! Code ----
  if (hdirty%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty image')
    error = .true.
  endif
  if (hbeam%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty beam')
    error = .true.
  endif
  if (error) return
  !
  ! Recover the Smoothing parameters
  narg = sic_narg(0)
  if (narg.le.1) then
    call map_message(seve%e,rname,'No smoothing lengths given')
    error = .true.
    return
  endif
  !
  allocate(smooth(narg))
  !
  do i=2,narg
    call sic_i4(line,0,i,smooth(i-1),.true.,error)
    if (error) return
  enddo
  if (smooth(narg-1).ne.1) then
    smooth(narg) = 1
  else
    narg = narg-1
  endif
  !
  if (narg.le.1) then
    call map_message(seve%e,rname,'No significant smoothing length')
    error = .true.
    return
  endif
  !
  ! OK. Now save the DIRTY image
  call gildas_null(horig)
  call gdf_copy_header(hdirty,horig,error)
  allocate(horig%r3d(horig%gil%dim(1),horig%gil%dim(2),horig%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  horig%r3d = ddirty ! Copy
  !
  do i=1,narg
    if (smooth(i).gt.1) then
      write(chain,'(A,I0,A)') "Smoothing by ",smooth(i)," channels"
      call map_message(seve%i,rname,chain,1)
      write(chain,'(A,I0)') 'CLEAN\MAP_SMOOTH DIRTY ',smooth(i)
      call exec_program(chain)
    endif
    if (i.eq.1) then
      call exec_program('CLEAN\CLEAN')
    else
      call exec_program('CLEAN\CLEAN /RESTART')
    endif
    if (smooth(i).ne.1) then
      write(chain,'(A,I0,A)') "restoring dirty after Smoothing by ",smooth(i)," channels"
      call map_message(seve%i,rname,chain,1)
      ddirty = horig%r3d ! Restore original Dirty
    endif
  enddo
  deallocate(horig%r3d)
end subroutine spectral_multi
!
subroutine transform_comm(line,error)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --Support routine for  
  !   TRANSFORM Operation In Out [Keys ...]
  !
  ! Transform a data cube along the Frequency axis, by several methods
  !   - Wavelet
  !   - Fourier
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Logical error flag
  !
  character(len=*), parameter :: rname='TRANSFORM'
  !
  ! Local ---
  character(len=12) :: ckey
  integer :: n
  !
  ! Code ----
  call sic_ke(line,0,1,ckey,n,.true.,error)
  !
  select case(ckey)
  case ('WAVE')
    call wavelet_compute(line,error)
  case ('FFT')
    call fft_compute(line,error) 
  case default
    call map_message(seve%e,rname,'Unknown case '//ckey)
    error = .true.
  end select
  !
contains
!
subroutine wavelet_compute(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for   
  !   TRANSFORM WAVE In Out Direction [MODE]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Logical error flag
  !
  ! Local ---
  character*256 name1,name2
  integer :: direction, n, mode
  !
  ! Code ----
  error = .false.
  call sic_ch(line,0,2,name1,n,.true.,error)
  if (error) return
  call sic_ch(line,0,3,name2,n,.true.,error)
  if (error) return
  call sic_i4(line,0,4,direction,.true.,error)
  if (error) return
  mode = 0
  call sic_i4(line,0,5,mode,.false.,error)
  if (error) return
  !
  call t_wavelet(name1,name2,direction,mode,error)
  if (error) return
  !
end subroutine wavelet_compute
!
subroutine t_wavelet(name1,name2,direction,mode,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use gbl_message
  !$ use omp_lib
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --  Support routine for   
  !   TRANSFORM WAVE In Out Direction [MODE]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: name1,name2 !! Input names
  integer, intent(in) ::  direction   !! Direction 
  integer, intent(in) ::  mode        !! Mode of transformation
  logical, intent(out) :: error       !! Logical Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='WAVELET'
  integer, parameter :: nsup=5
  integer :: sup(nsup)
  data sup/0,4,8,12,16/
  !
  ! Local ---
  type(gildas) :: hdata
  integer :: nf, faxi
  real :: tolerance
  integer :: lf, mf, ier, k, i
  character(len=80) :: chain
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  ! Code ----
  k = 0
  do i=1,nsup
    if (mode.eq.sup(i)) then
      k = 1
      exit
    endif
  enddo
  if (k.eq.0) then
    call map_message(seve%e,rname,'Supported mode only 0, 4, 8, 12 or 16')
    error = .true.
    return
  endif
  !
  ! Read Header 
  call gildas_null(hdata)
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  !$ elapsed_s = omp_get_wtime()
  !
  error = .false.
  if (direction.eq.0) then
    call sic_parse_file (name1,' ','.lmv,',hdata%file)
  else if (direction.gt.0) then
    call sic_parse_file (name1,' ','.wave,',hdata%file)
  else
    call map_message(seve%e,rname,'Invalid direction')
    error = .true.
    return
  endif
  call gdf_read_header (hdata,error)
  if (error) return
  !
  faxi = hdata%gil%faxi
  nf = hdata%gil%dim(faxi)
  if (direction.gt.nf) then
    write(chain,'(A,I0,A,I0,A,I0)') 'Direction ',direction,' exceeds Frequency axis size ',nf
    call map_message(seve%e,rname,chain)
    error = .true.
    return
  else if (direction.ne.0) then
    write(chain,'(A,I0,A,I0,A,I0)') 'Extracting ',direction,' channels out of ',nf
    call map_message(seve%i,rname,chain,3)  
  endif
  tolerance = 0.5/float(nf-1)
  call gi4_round_forfft(nf,mf,error,tolerance,0) 
  !
  if (nf.ne.mf) then
    call gi4_round_forfft(nf,lf,error,0.3,0)
    write(chain,'(A,I0,A,I0,A,I0)') 'Frequency axis size ',nf,' is not 2^n; Nearest values ',lf,' - ',mf
    error = .true.
  else
    write(chain,'(A,I0,A,I0,A,I0)') 'Frequency axis size ',nf,' is 2^n'
  endif
  if (error) then
    call map_message(seve%w,rname,chain,3)
    write(chain,'(A,I0,1X,I0)') 'Extending axis size to ',mf, faxi
    call map_message(seve%w,rname,chain,3)
    if (faxi.ne.3) return
    !
    error = .false.
  else
    call map_message(seve%i,rname,chain)    
  endif
  if (error) return
  !
  ! Could be done by block on the Transposed (VLM) order, not 
  ! simply on the LMV one...
  if (faxi.eq.3) then
    allocate(hdata%r3d(hdata%gil%dim(1),hdata%gil%dim(2),mf),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call gdf_read_data (hdata,hdata%r3d,error)
    if (error) return
    if (nf.ne.mf) hdata%r3d(:,:,nf+1:mf) = 0
    hdata%gil%dim(3) = mf
  else if (faxi.eq.1) then
    if (mf.ne.nf) return ! See comment below 
    !
    allocate(hdata%r3d(mf,hdata%gil%dim(2),hdata%gil%dim(3)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! Reading by block would be needed to do the job if NF # MF
    call gdf_read_data (hdata,hdata%r3d,error)
    if (error) return
  endif
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  elapsed_s = elapsed_e
  write(chain,'(a,a,f9.2,a)') 'Finished reading data','  - Elapsed time ',elapsed,' sec'
  call map_message(seve%i,rname,chain)
  !
  call s_wavelet(hdata,direction,mode,error)
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  elapsed_s = elapsed_e
  write(chain,'(a,a,f9.2,a)') 'Finished Wavelet transform','  - Elapsed time ',elapsed,' sec'
  call map_message(seve%i,rname,chain)
  !
  if (direction.le.0) then
    call sic_parse_file (name2,' ','.lmv,',hdata%file)
  else
    call sic_parse_file (name2,' ','.wave',hdata%file)
  endif
  !
  ! Truncate output result if needed (Could be done inside s_wavelet)
  if (direction.ne.0) then
    if (faxi.eq.3) hdata%gil%dim(3) = direction
  endif
  !
  call gdf_write_image(hdata,hdata%r3d,error)
  !$  elapsed_e = omp_get_wtime()
  !$  elapsed = elapsed_e - elapsed_s
  !$  elapsed_s = elapsed_e
  write(chain,'(a,a,f9.2,a)') 'Finished writing data','  - Elapsed time ',elapsed,' sec'
  call map_message(seve%i,rname,chain)
  !
end subroutine t_wavelet
!
subroutine s_wavelet(hdata,direction,mode,error)
  !$ use omp_lib
  use image_def
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for   
  !   TRANSFORM WAVE In Out Direction Mode
  !
  ! Simple in-place wavelet transform for 3-D data cubes
  !!
  !---------------------------------------------------------------------
  !
  integer, intent(in) ::  direction     !! Direction
  type(gildas), intent(inout) :: hdata  !! Header of cube
  integer, intent(in) :: mode           !! Mode of transform
  logical, intent(out) :: error         !! Error flag
  !
  character(len=*), parameter :: rname='WAVELET'
  !
  ! Local ---
  integer :: nf, i, j, faxi
  real, allocatable :: array(:)
  !
  ! Code ----
  error = .false.
  faxi = hdata%gil%faxi
  nf = hdata%gil%dim(faxi)
  !
  !
  if (faxi.eq.1) then
    ! VLM order is simple
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP &  SHARED(hdata, nf, direction, mode) &
    !$OMP &  PRIVATE(i,j) 
    !$OMP DO COLLAPSE (2)
    do j=1,hdata%gil%dim(3)
      do i=1,hdata%gil%dim(2)
        call wavelet(hdata%r3d(:,i,j),nf,direction,mode)
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else if (faxi.eq.3) then
    ! LMV order requires an intermediate array and implicit transposition
    allocate (array(nf))
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP &  SHARED(hdata, nf, direction, mode) &
    !$OMP &  PRIVATE(i,j, array) 
    !$OMP DO COLLAPSE (2)
    do j=1,hdata%gil%dim(1)
      do i=1,hdata%gil%dim(2)
        array(:) = hdata%r3d(i,j,:)
        call wavelet(array,nf,direction,mode)
        hdata%r3d(i,j,:) = array(:)
      enddo
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
  !
end subroutine s_wavelet
!
subroutine wavelet (x,n,direction,mode)
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for  
  !   TRANSFORM WAVE In Out Direction
  !
  ! Simple in-plave wavelet transform on a 1-D array  
  !   Mode = 0    Haar transform  
  !   Mode = 2 - 2*n    Daubechies order Mode   
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: n          !! n is length of x, power of two
  integer, intent(in) :: direction  !!  = 0 Direct, > 0 Inverse
  real, intent(inout) :: x(n)       !! Array        
  integer, intent(in) :: mode       !! Mode of Wavelet
  !
  ! Local ---
  real, allocatable :: y(:)         ! y() is permutation buffer
  real(kind=8), allocatable :: dy(:), dx(:) ! Daubechies are Real(8)
  integer m, i
  !
  !
  select case(mode)
  case (0)      ! Haar transform
    allocate (y(n))
    if (direction .eq. 0) then
      ! DIRECT
      ! POWER OF 2 PASSES, EACH HALF AS LONG
      m = n
      do
        do i=1,m,2
          y(i) = (x(i) + x(i+1)) / 2
          y(i+1) = (x(i) - x(i+1)) / 2
        enddo
        ! Permutation 
        m = m / 2
        do i=1,m
          x(i) = y(i+i-1)
          x(m+i) = y(i+i)
        enddo
        if (m .eq. 1) exit
      enddo
      !
    else
      ! INVERSE
      ! POWER OF 2 PASSES, EACH TWICE AS LONG
      m = 1
      do
        do i=1,m
          y(i+i-1) = x(i)
          y(i+i) = x(m+i)
        enddo
        m = m + m
        !                BUTTERFLY
        do i=1,m,2
          x(i) = (y(i) + y(i+1))
          x(i+1) = (y(i) - y(i+1))
        enddo
        if (m .eq. n) exit
      enddo
    endif
  case(4)   ! Daubechies 4 
    allocate (dx(n),dy(n))
    if (direction.eq.0) then
      dx(1:n) = x(1:n)
      call daub4_transform ( n, dx, dy )
      x(1:n) = dy(1:n)
    else
      dy(1:n) = x(1:n)
      call daub4_transform_inverse ( n, dy, dx )
      x(1:n) = dx(1:n)
    endif
  case(8)   ! Daubechies 8 
    allocate (dx(n),dy(n))
    if (direction.eq.0) then
      dx(1:n) = x(1:n)
      call daub8_transform ( n, dx, dy )
      x(1:n) = dy(1:n)
    else
      dy(1:n) = x(1:n)
      call daub8_transform_inverse ( n, dy, dx )
      x(1:n) = dx(1:n)
    endif
  case(12)   ! Daubechies 12
    allocate (dx(n),dy(n))
    if (direction.eq.0) then
      dx(1:n) = x(1:n)
      call daub12_transform ( n, dx, dy )
      x(1:n) = dy(1:n)
    else
      dy(1:n) = x(1:n)
      call daub12_transform_inverse ( n, dy, dx )
      x(1:n) = dx(1:n)
    endif
  case(16)   ! Daubechies 16
    allocate (dx(n),dy(n))
    if (direction.eq.0) then
      dx(1:n) = x(1:n)
      call daub16_transform ( n, dx, dy )
      x(1:n) = dy(1:n)
    else
      dy(1:n) = x(1:n)
      call daub16_transform_inverse ( n, dy, dx )
      x(1:n) = dx(1:n)
    endif
  case default
    Print *,'No such transform mode ',Mode
  end select
end subroutine wavelet
!
subroutine fft_compute(line,error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for   
  !   TRANSFORM FFT In Out 
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Logical error flag
  !
  ! Local ---
  character*256 name1,name2
  integer :: direction, n
  !
  ! Code ----
  error = .false.
  call sic_ch(line,0,2,name1,n,.true.,error)
  if (error) return
  call sic_ch(line,0,3,name2,n,.true.,error)
  if (error) return
  direction = 0
  call sic_i4 (line,0,4,direction,.false.,error)
  !
  call t_fft(name1,name2,direction,error)
  if (error) return
  !
end subroutine fft_compute
!
subroutine t_fft(name1,name2,direction,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for   
  !   TRANSFORM FFT In Out 
  !
  ! The shape of In decides in which direction the FFT must be
  ! done. 
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: name1,name2 !! Names of variables
  integer, intent(in) ::  direction   !! direction
  logical, intent(out) :: error       !! Error flag
  !
  character(len=*), parameter :: rname='FFT'
  type(gildas) :: hin, hout, htmp
  integer :: nf, faxi, ier
  complex, allocatable :: cdata(:)
  integer :: lf,mf
  real :: tolerance
  integer, parameter :: exponent=2
  character(len=80) :: chain
  logical :: err
  !
  ! Read Header 
  call gildas_null(hin)
  call gildas_null(hout)
  !
  call sic_parse_file (name1,' ','.lmv,',hin%file)
  call gdf_read_header (hin,error)
  if (error) return
  !
  faxi = hin%gil%faxi
  nf = hin%gil%dim(faxi)
  !
  tolerance = 1.0/float(nf-1)
  call gi4_round_forfft(nf,mf,error,tolerance,exponent)
  !
  if (nf.ne.mf) then
    call gi4_round_forfft(nf,lf,error,0.3,exponent)
    write(chain,'(A,I0,A,I0,A,I0)') 'Frequency axis size ',nf,' is not 2^n 3^p 5^q; Nearest values ',lf,' - ',mf
    error = .true.
  else
    write(chain,'(A,I0,A,I0,A,I0)') 'Frequency axis size ',nf,' is 2^n 3^p 5^q'
  endif
  !
  if (hin%gil%ndim.eq.3) then
    !
    ! Input is Real - it must be a Data Cube
    if (error) then
      call map_message(seve%w,rname,chain,3)
      write(chain,'(A,I0,1X,I0)') 'Rounding axis size to ',mf, faxi
      call map_message(seve%w,rname,chain,3)
      if (faxi.ne.3) return
      !
      error = .false.
    else
      call map_message(seve%i,rname,chain,3)    
    endif
    !
    !     call gdf_allocate (hin,error)
    allocate(hin%r3d(hin%gil%dim(1),hin%gil%dim(2),mf),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error =.true.
    endif
    !
    if (error) return
    call gdf_read_data (hin,hin%r3d,error)
    if (error) return
    !
    ! Zero fill the possible extension of the data, and resize it
    if (mf.gt.nf) then
      if (faxi.eq.3) then
        hin%r3d(:,:,nf+1:mf) = 0.
        hin%gil%dim(faxi) = mf
      else  
        error = .true.
        return
      endif
    endif
    !
    call gildas_null(htmp)
    call gdf_copy_header(hin,htmp,error)
    if (error) return
    !
    htmp%gil%dim(faxi) = mf !
    !
    htmp%gil%ndim = 4
    htmp%gil%dim(4) = 2
    htmp%gil%convert(:,4) = 1
    htmp%char%code(4) = 'COMPLEX'
    !
    if (faxi.eq.1) then
      call gdf_transpose_header(htmp,hout,'2341',error)
    else
      call gdf_transpose_header(htmp,hout,'1243',error)
    endif
    !
    allocate ( cdata(hout%gil%dim(4)) &
      & ,hout%r4d(hout%gil%dim(1),hout%gil%dim(2),hout%gil%dim(3),hout%gil%dim(4)) &
      & ,stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call wave_fft_direct(hin,hout%r4d,cdata,error)
    !
    call sic_parse_file (name2,' ','.wave',hout%file)
    call gdf_write_image(hout,hout%r4d,error)
    !
  else if (hin%gil%ndim.eq.4) then  
    ! 
    ! Input is complex - It must be a Fourier Transform
    !
    ! In this direction, it must have been already of appropriate size
    if (error) then
      call map_message(seve%e,rname,chain,3)
      return
    else
      call map_message(seve%i,rname,chain,3)    
    endif    
    !
    if (error) return
    call gdf_allocate(hin,error)
    if (error) return
    call gdf_read_data (hin,hin%r4d,error)
    if (error) return
    !
    call gildas_null(htmp)
    call gdf_copy_header(hin,htmp,error)
    if (error) return
    call gdf_transpose_header(htmp,hout,'1243',error)
    hout%gil%ndim = 3
    hout%gil%dim(4) = 1
    !
    allocate ( cdata(hin%gil%dim(4)) &
      & ,hout%r3d(hout%gil%dim(1),hout%gil%dim(2),hout%gil%dim(3)) &
      & ,stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    call wave_fft_inverse(hout,hin%r4d,cdata,error)
    call sic_parse_file (name2,' ','.lmv',hout%file)
    !
    ! Truncate output result if needed (Could be done inside wave_fft_inverse)
    if (direction.ne.0) then
      if (hout%gil%faxi.eq.3) hout%gil%dim(3) = direction
    endif  
    call gdf_write_image(hout,hout%r3d,error)
    !
  endif
  call gdf_close_image(hin,err)
  !    
end subroutine t_fft
!
subroutine wave_fft_direct(hreal,cresult,cdata,error)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! Compute Spectral Fourier Transform of a Data Cube.
  !   Input data cube can be in VLM or LMV order.
  !   Output SFT is always in LMCV order with C=(real,imag).
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: hreal             !! Header of Data cube
  real(kind=4), intent(out) :: cresult(:,:,:,:) !! 4-D result
  complex(kind=4), intent(inout) :: cdata(:)    !! Intermediate array
  logical,         intent(inout) :: error       !! Error flag
  !
  integer, parameter :: direction=-1  ! Direct
  logical, parameter :: simple=.true.
  !
  ! Local ---
  integer(kind=4) :: i,j,k,kk,dims(1),nchan,faxi,ndim
  real(kind=4), allocatable :: work(:,:) 
  real :: scale
  !
  ! Code ----
  if (hreal%gil%form.ne.fmt_r4) then
    error = .true.
    return
  endif
  !
  ! Compute Direct Fourier transform
  faxi  = hreal%gil%faxi
  nchan = hreal%gil%dim(faxi)
  dims(1) = nchan
  ndim = 1
  allocate(work(nchan,2))
  work = 0
  scale =1.0/sqrt(real(nchan))
  !
  call fourt_plan(cdata,dims,ndim,direction,1)
  !
  if (faxi.eq.1) then
    ! VLM order, no transposition of input data
    do j=1,hreal%gil%dim(3)
      do i=1,hreal%gil%dim(2)
        if (simple) then
          cdata = cmplx(hreal%r3d(:,i,j),0.0)
        else
          do k=1,nchan
            kk = mod(k+nchan/2-1,nchan)+1
            cdata(kk) = cmplx(hreal%r3d(k,i,j),0.0)
          enddo
        endif
        call fourt(cdata,dims,ndim,direction,1,work)
        cresult(i,j,1,:) = real(cdata)*scale
        cresult(i,j,2,:) = imag(cdata)*scale
      enddo
    enddo
  else if (faxi.eq.3) then
    do j=1,hreal%gil%dim(2)
      do i=1,hreal%gil%dim(1)
        if (simple) then
          cdata = cmplx(hreal%r3d(i,j,:),0.0)
        else
          do k=1,nchan
            kk = mod(k+nchan/2-1,nchan)+1
            cdata(kk) = cmplx(hreal%r3d(i,j,k),0.0)
          enddo
        endif
        call fourt(cdata,dims,ndim,direction,1,work)
        cresult(i,j,1,:) = real(cdata)*scale
        cresult(i,j,2,:) = imag(cdata)*scale
      enddo
    enddo
  endif
  !
end subroutine wave_fft_direct
!
subroutine wave_fft_inverse(hout,cresult,cdata,error)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! Compute Data Cube from its Spectral Fourier Transform. 
  !   Input SFT is always in LMCV order with C=(real,imag).
  !   Output data cube can be in VLM or LMV order.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: hout          !! Header of Data Cube
  real(kind=4), intent(in) :: cresult(:,:,:,:) !! Input 4-D array
  complex(kind=4), intent(inout) :: cdata(:)   !! Intermediate array
  logical,         intent(inout) :: error      !! Error flag
  !
  integer, parameter :: direction=1
  logical, parameter :: simple=.true.
  !
  ! Local ---
  integer(kind=4) :: i,j,k,mx,dims(1),nchan,faxi,ndim
  real(kind=4), allocatable :: work(:,:) 
  real :: scale
  !
  ! Code ----
  ! Compute Direct Fourier transform
  faxi = hout%gil%faxi
  nchan = hout%gil%dim(faxi)
  dims(1) = nchan
  ndim = 1
  allocate(work(nchan,2))
  work = 0
  scale =1.0/sqrt(real(nchan))
  !
  error = .false.
  mx = nchan/2
  call fourt_plan(cdata,dims,ndim,direction,1)
  !
  if (faxi.eq.1) then
    do j=1,hout%gil%dim(3)
      do i=1,hout%gil%dim(2)
        do k=1,nchan
          cdata(k) = cmplx(cresult(i,j,1,k),cresult(i,j,2,k))
        enddo
        call fourt(cdata,dims,ndim,direction,1,work)
        if (simple) then
          hout%r3d(:,i,j) = real(cdata)*scale
        else
          do k=1,mx
            hout%r3d(k+mx,i,j) = real(cdata(k))*scale 
          enddo
          do k=1,mx
            hout%r3d(k,i,j) = real(cdata(k+mx))*scale
          enddo
        endif
      enddo
    enddo
  else if (faxi.eq.3) then
    do j=1,hout%gil%dim(2)
      do i=1,hout%gil%dim(1)
        do k=1,nchan
          cdata(k) = cmplx(cresult(i,j,1,k),cresult(i,j,2,k))
        enddo
        call fourt(cdata,dims,ndim,direction,1,work)
        if (simple) then
          hout%r3d(i,j,:) = real(cdata)*scale
        else
          do k=1,mx
            hout%r3d(i,j,k+mx) = real(cdata(k))*scale 
          enddo
          do k=1,mx
            hout%r3d(i,j,k) = real(cdata(k+mx))*scale
          enddo
        endif
      enddo
    enddo
  else
    error = .true.
  endif
  !
end subroutine wave_fft_inverse
!
end subroutine transform_comm

subroutine display_check_uv(comm,chain,error)
  use clean_def
  use clean_arrays
  use clean_default
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use iso_c_binding
  use imager_interfaces, only : map_message, uv_tri
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for commands SHOW UV and UV_FLAG
  !
  !   TIME-BASE sort the UV table before displaying it
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: comm     !! Command name 
  character(len=*), intent(inout) :: chain !! Arguments to be parsed
  logical, intent(out) :: error            !! Logical error flag
  !
  ! Local ---
  character(len=64) :: nname
  character(len=64), save :: oname
  logical :: do_tri
  type(gildas) :: hin
  type(sic_descriptor_t) :: desc
  type(c_ptr) :: cptr
  real(4), pointer :: r2ptr(:,:)
  integer(kind=4) :: ib
  !
  ! Code ----
  ib = index(chain,' ')
  if (ib.eq.0) ib = len_trim(chain)
  nname = chain(1:ib)
  call map_message(seve%d,comm,'Requesting sort on '//trim(nname))
  ! Check data presence in buffer - NOT APPROPRIATE AT THIS STAGE ...
  select case (nname)
  case ('UV','DATA_UV','RESIDUAL_UV','MODEL_UV')
    if (.not.associated(duv)) then
      call map_message(seve%e,comm,'No UV data')
      error = .true.
      return
    endif
    chain = 'UV'
  end select
  !
  ! Sort buffer (TIME-BASE) when needed and create the associated SIC buffer
  if (nname.eq.'MODEL_UV') then
    do_tri = uv_model_updated
    uv_model_updated = .false.
  else if (nname.eq.'RESIDUAL_UV') then
    do_tri = uv_resid_updated
    uv_resid_updated = .false.
  else    
    do_tri = .false.
  endif
  !
  if (.not.allocated(duvt)) then
    do_tri = .true.
  else if (oname.ne.nname) then
    do_tri = .true.
  endif
  !
  if (do_tri) then
    if (chain.eq.'UV') then
      call uv_tri(2,huv,duv,error)
    else
      call gildas_null(hin,type='UVT')
      call get_gildas(comm,nname,desc,hin,error)
      if (error) return
      call gdf_copy_header(desc%head,hin,error)
      if (error) return
      call adtoad(desc%addr,cptr,1)
      call c_f_pointer(cptr,r2ptr,hin%gil%dim(1:2))
      call uv_tri(2,hin,r2ptr,error)
    endif
  else
    call map_message(seve%d,comm,trim(nname)//' is already sorted')
  endif
  oname = nname
  !
end subroutine display_check_uv
!
subroutine uv_select_comm(line,comm,error)
  use gkernel_interfaces
  use clean_default
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! IMAGER
  !*
  ! @ private --  Support for command UV_SELECT [NewOne]
  !
  !   Select the UV_DATA to be Imaged (and Plotted ?)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  character(len=*), intent(in) :: comm    !! Command name
  logical, intent(inout) :: error
  !
  ! Constants
  integer, parameter :: mcase=6
  character(len=12) :: uvcase(mcase)
  data uvcase /'DATA_UV','MODEL_UV','RESIDUAL_UV','UV_DATA','UV_MODEL','UV_RESIDUAL'/
  !
  ! Local ---
  character(len=12) :: old_uvdata, argum, ccase
  integer :: icase,jcase,n
  !
  ! Code ----
  if (sic_narg(0).eq.0) then
    call map_message(seve%i,comm,'Current UV data is '//current_uvdata)
    return
  endif
  !
  call sic_ke(line,0,1,argum,n,.true.,error)
  call sic_ambigs (comm,argum,ccase,icase,uvcase,mcase,error)
  if (error) return
  !
  old_uvdata = current_uvdata
  jcase = mod(icase-1,3)+1
  current_uvdata = uvcase(jcase) ! Use only the first 3 names.
  !
  if (old_uvdata.ne.current_uvdata) then
    huvc%loca%size = 0
    ! Note that subroutine uv_new_data should NOT be called here.
    ! We just select some data set, we do not modify it.
    !
    ! However, weight may have changed
    do_weig = .true.  
    ! This will not be the case in most cases, but can happen
    ! in the following circumstances
    ! 1) Reading directly by a READ MODEL command some data set 
    !    that may be inconsistent with the READ UV command
    ! 2) UV_RESIDUAL /FIELD  command
    !     To optimize this, a new information should be stored 
    !   which would say whether the weights of a MODEL or RESIDUAL
    !   UV data are just copies of that of the UV_DATA itself.
    !   It is easy to do in the MODEL and UV_RESIDUAL commands,
    !   but then any UV_RESAMPLE, UV_FLAG or what not would
    !   change this information too.
  endif
end subroutine uv_select_comm
!
subroutine uvdata_select(comm,error)
  use clean_arrays
  use clean_default
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------
  ! @ private
  !! IMAGER -- Display currently active UV Data name
  !----------------------------------------------------------------
  character(len=*), intent(in):: comm   !! Command name
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Code ----
  if (current_uvdata.eq.'DATA_UV') then
    if (huvi%loca%size.eq.0) then
      call map_message(seve%e,comm,'No UV_DATA available')
      error = .true.
      return
    endif
    call map_message(seve%i,comm,'Selecting UV data UV_DATA')
    continue
  else if (current_uvdata.eq.'MODEL_UV') then   
    if (huvm%loca%size.eq.0) then
      call map_message(seve%e,comm,'No UV_MODEL available')
      error = .true.
      return
    endif
    call gdf_copy_header(huvm,huv,error)
    duv => duvm
    call map_message(seve%i,comm,'Selecting UV data UV_MODEL')
  else if (current_uvdata.eq.'RESIDUAL_UV') then            
    if (huvf%loca%size.eq.0) then
      call map_message(seve%e,comm,'No UV_RESIDUAL available')
      error = .true.
      return
    endif
    call gdf_copy_header(huvf,huv,error)
    duv => duvf
    call map_message(seve%i,comm,'Selecting UV data UV_RESIDUAL')
  else
    call map_message(seve%w,comm,'Unknown UV_DATA '//current_uvdata)
    return
  endif
end subroutine uvdata_select
!
subroutine display_uv(chain,line,error)
  use clean_def
  use clean_arrays
  use gkernel_interfaces
  use imager_interfaces, only : display_check_uv
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command
  !     SHOW UV
  !   Display current uv data as requested.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: chain   !! Argument
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_dir=1 ! /DIRECTORY option number
  !
  ! Local ---
  character(len=32) :: string, keyw, cval
  character(len=256) :: exec_chain
  integer :: n
  !
  ! Check data presence in buffer
  string = chain
  call display_check_uv('SHOW',string,error)
  if (error) return
  if (sic_narg(0).gt.1) then
    call sic_ke(line,0,2,keyw,n,.true.,error)
    cval = ' '
    call sic_ch(line,0,3,cval,n,.false.,error)
    exec_chain = '@ p_uvshow_sub '//string//keyw//cval
  else
    exec_chain = '@ p_uvshow_sub '//string
  endif
  !
  call get_topdir(line,o_dir)
  call exec_program(exec_chain)
end subroutine display_uv
!

program regression
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for finding best linear combination
  !		X(i,j) = A*Y(i,j) + B
  ! Subroutines
  !	REG001
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: name
  logical :: error
  real :: a,b, r, the
  real :: xm,ym,x2m,y2m,xym, x0,y0
  real :: xmean,ymean,x2mean,y2mean,xymean
  integer(kind=index_length) :: xmin,xmax,ymin,ymax
  integer(kind=size_length) :: np
  type(gildas) :: x
  !
  call gildas_open
  call gildas_char('IN$',name)
  call gildas_real('THRESHOLD$',the,1)
  call gildas_close
  !
  call gildas_null(x)
  x%gil%ndim = 2
  call gdf_read_gildas(x,name,'.gdf',error)
  if (error) call sysexi(fatale)
  !
  xmin = 1
  xmax = x%gil%dim(1)
  ymin = 1
  ymax = x%gil%dim(2)
  call reg001(x%r2d,x%gil%dim(1),x%gil%dim(2),the,  &
              xmin,xmax,ymin,ymax,                  &
              xm,x2m,ym,y2m,xym,np)
  if (np.eq.0) then
    call gagout ('W-REGRESSION,  No data points')
    call sysexi (fatale)
  endif
  !
  y0 = x%gil%val(2) - x%gil%ref(2)*x%gil%inc(2)
  ymean = ym*x%gil%inc(2) + y0
  y2mean = y2m*x%gil%inc(2)**2 + 2.*x%gil%inc(2)*y0*ym + y0**2
  !
  x0 = x%gil%val(1) - x%gil%ref(1)*x%gil%inc(1)
  xmean = xm*x%gil%inc(1) + x0
  x2mean = x2m*x%gil%inc(1)**2 + 2.*x%gil%inc(1)*x0*xm + x0**2
  !
  xymean = xym*x%gil%inc(1)*x%gil%inc(2) + &
           xm*x%gil%inc(1)*y0 + ym*x%gil%inc(2)*x0 + x0*y0
  !
  r = y2mean - ymean**2
  a = (xymean - xmean*ymean) / r
  b = (xmean*y2mean - ymean*xymean) / r
  write(6,*) ' X = ',a,' * Y + ',b
  r = x2mean - xmean**2
  a = (xymean - xmean*ymean) / r
  b = (ymean*x2mean - xmean*xymean) / r
  write(6,*) ' Y = ',a,' * X + ',b
  call gagout ('I-REGRESSION,  Successfull completion')
  call sysexi (1)
  !
end program regression
!
subroutine reg001(x,nx,ny,the,imin,imax,jmin,jmax,xm,x2m,ym,y2m,xym,np)
  use gildas_def
  !---------------------------------------------------------------------
  ! GDF	Internal routine
  !	Given the cross histogram of two images, find the best linear
  !	combination of images.
  !	X = A*Y + B
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)  :: nx        !
  integer(kind=index_length), intent(in)  :: ny        !
  real(kind=4),               intent(in)  :: x(nx,ny)  ! Cross Histogram
  real(kind=4),               intent(in)  :: the       ! Threshold in number of points
  integer(kind=index_length), intent(in)  :: imin      ! X range
  integer(kind=index_length), intent(in)  :: imax      !
  integer(kind=index_length), intent(in)  :: jmin      ! Y range
  integer(kind=index_length), intent(in)  :: jmax      !
  real(kind=4),               intent(out) :: xm        ! Mean of X values (in pixels)
  real(kind=4),               intent(out) :: x2m       ! Mean of X**2 values (in pixels)
  real(kind=4),               intent(out) :: ym        ! Mean of Y values
  real(kind=4),               intent(out) :: y2m       ! Mean of Y**2 values
  real(kind=4),               intent(out) :: xym       ! Mean of X*Y
  integer(kind=size_length),  intent(out) :: np        ! Number of pixels in correlation
  ! Local
  integer(kind=index_length) :: i,j
  !
  np = 0
  xm = 0.
  ym = 0.
  xym = 0.
  y2m = 0.
  x2m = 0.
  do j=jmin,jmax
    do i=imin,imax
      if (x(i,j).gt.the) then
        xm = xm + x(i,j)*i
        ym = ym + x(i,j)*j
        y2m = y2m + x(i,j)*float(j)*float(j)
        xym = xym + x(i,j)*float(i)*float(j)
        x2m = x2m + x(i,j)*float(i)*float(i)
        np = np+nint(x(i,j))
      endif
    enddo
  enddo
  if (np.ne.0) then
    xm = xm / np
    ym = ym / np
    x2m = x2m / np
    y2m = y2m / np
    xym = xym / np
  endif
end subroutine reg001

module imager_interfaces_public
  interface
    subroutine clean_comm(line,error)
      use gbl_message
      use clean_arrays
      use clean_default
      !----------------------------------------------------------------------
      ! @ public
      !*  IMAGER --  Support for command CLEAN & GCLEAN  
      !   Call appropriate subroutine according to METHOD%METHOD
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine clean_comm
  end interface
  !
  interface
    subroutine uv_fibeam (name,freq,uv,nu,nvis,wcol,majo,mino,pa,error)
      use gildas_def
      use mod_fitbeam
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Command FIT and support for CLEAN
      !
      !   Find beam parameters for deconvolution.
      !   Fit an elliptical gaussian clean beam to UV data weight
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name          !! Caller name
      real(8), intent(in) :: freq                   !! Observation frequency
      integer, intent(in) :: nu                     !! Visibility size 
      integer, intent(in) :: nvis                   !! Number of visibilities
      integer, intent(in) :: wcol                   !! Weight column  
      real, intent(in) :: uv(nu,nvis)               !! Visibilities
      real, intent(inout) :: majo                   !! Major axis
      real, intent(inout) :: mino                   !! Minor axis
      real, intent(inout) :: pa                     !! Position Angle
      logical, intent(inout) :: error               !! Error flag
    end subroutine uv_fibeam
  end interface
  !
  interface
    subroutine sub_uvcal(ncol,nvis,data,ndc,cal, &
         &    index,times,do_flag,flagged,nvg,gain,indg,timesg,   &
         &    ampli_gain,phase_gain,ampli_seuil,phase_seuil,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support routine for command APPLY
      !
      !   Apply phase and/or amplitude calibration to
      !   the "raw" UV data.   Phase and Amplitudes are stored in
      !   the "gain" UV table, and usually come from a previous
      !   use of Task uv_gain.    This subroutine allows to apply the
      !   corrections to a spectral line table, whatever the way the gains
      !   were computed before.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: ncol              !! Visibility size
      integer, intent(in) :: nvis              !! Number of visibilities
      real, intent(in) :: data(ncol,nvis)      !! Visibility array
      integer, intent(in) :: ndc               !! Number of channels
      real, intent(out) :: cal(ncol,nvis)      !! Calibrated visibilities
      integer, intent(inout) :: index(nvis)    !! Visibility Index
      real(8), intent(inout) :: times(nvis)    !! Visibility Time stamp
      logical, intent(in) :: do_flag           !! Flag data with no solution
      integer, intent(inout) :: flagged(nvis)  !! Flag work array
      integer, intent(in) :: nvg               !! Number of gains
      real, intent(in) :: gain(10,nvg)         !! Gain array
      integer, intent(out) :: indg(nvg)        !! Index in gains
      real(8), intent(out) :: timesg(nvg)      !! Gain time stamp
      real(8), intent(in) :: ampli_gain        !! Amplitude gain
      real(8), intent(in) :: phase_gain        !! Phase gain
      real(8), intent(in) :: ampli_seuil       !! Amplitude threshold for flag
      real(8), intent(in) :: phase_seuil       !! Phase threshold for flag
      logical, intent(out) :: error            !! Logical Error Flag
    end subroutine sub_uvcal
  end interface
  !
  interface
    subroutine rmask_to_list(rmask,m,list,n)
      !---------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -- public routine  
      !   Get list of positions from a Real mask (1-D index)
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: m           !! Number of entries
      real, intent(in) :: rmask(m)       !! Mask values
      integer, intent(out) :: n          !! Number of POSITIVE values
      integer, intent(out) :: list(m)    !! Position of entries 
    end subroutine rmask_to_list
  end interface
  !
  interface
    subroutine lmask_to_list(lmask,m,list,n)
      !---------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -- public routine  
      !   Get list of positions from a Logical mask (1-D index)
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: m           !! Size of mask 
      logical, intent(in) :: lmask(m)    !! Mask values
      integer, intent(out) :: n          !! Number of TRUE values
      integer, intent(out) :: list(m)    !! Position of entries 
    end subroutine lmask_to_list
  end interface
  !
  interface
    subroutine get_listsize (mask,m,n)
      !---------------------------------------------------------------------
      ! @ public
      !!* 
      !   IMAGER public routine  
      !   Count number of TRUE values (Rank 1 arrays)
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: m        !! Number of entries
      integer, intent(out) :: n       !! Number of TRUE values
      logical, intent(in) :: mask(m)  !! Mask values
    end subroutine get_listsize
  end interface
  !
  interface
    subroutine compute_atten (nx,ny,np,atten,primary,mask,   &
         &    wsear,wrest,wmin)
      !---------------------------------------------------------------------
      ! @ public
      !* 
      !   IMAGER -- Support for MOSAICs  
      !   Set the mosaic weights 
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nx                 !! X size
      integer, intent(in) :: ny                 !! Y size 
      integer, intent(in) :: np                 !! Number of pointings
      real, intent(out) ::  atten(nx,ny)        !! Weight map
      real, intent(in) ::  primary(np,nx,ny)    !! Primary beams
      real, intent(in) ::  wsear                !! Search threshold
      real, intent(in) ::  wrest                !! Restore threshold   
      real, intent(in) ::  wmin                 !! Minimum real value  
      logical, intent(inout) ::  mask(nx,ny)    !! Search mask
    end subroutine compute_atten
  end interface
  !
  interface
    subroutine check_box(nx,ny,blc,trc)
      !---------------------------------------------------------------------
      ! @ public
      !* 
      !   IMAGER -- support routine  
      !   Define the search box corners. 
      !   The default is the inner quarter of the image
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nx,ny           !! Size of image
      integer, intent(inout) :: blc(2)       !! Bottom left corner
      integer, intent(inout) :: trc(2)       !! Top right corner
    end subroutine check_box
  end interface
  !
  interface
    subroutine clark_soustraire (wcl,ncl,        &
         &    dirty,beam_nx,beam_ny,nx,ny,ixbeam,iybeam,   &
         &    ixpatch,iypatch,kcl,gain,    &
         &    nf, primary, weight, wtrun)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER  --  CLEAN   Internal routine
      !
      ! Subtract the clean component, convolved with dirty beam
      ! restricted to beam patch, from the list of selected points.
      ! Smaller beam patches yield faster speed, but somewhat larger errors and
      ! thus slower convergence.
      !
      ! Caution : points must be ordered according I and J. In the current
      !   IMAGER implementation, this is done by routine "choice"
      ! The code cannot be parallelized, since it uses explicitely the ordering
      ! of the I and J values to stop exploring beyond the beam patch.
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nf                   !! Number of fields
      integer, intent(in) :: ncl                  !! nombre de points retenus
      integer, intent(in) :: beam_nx,beam_ny      !! dimension du beam
      integer, intent(in) :: ixbeam,iybeam        !! centre du beam
      integer, intent(in) :: nx,ny                !! dimension des images
      real, intent(in) :: dirty(beam_nx,beam_ny,nf)    !! Dirty Beam
      integer, intent(in) :: ixpatch,iypatch      !! Beam patcj size
      type(cct_par), intent(inout) :: wcl(ncl)    !! Clean component list
      integer, intent(in) :: kcl                  !! No de la composante introduite
      real, intent(in) :: gain                    !! gain de clean
      real, intent(in) :: primary (nf,nx,ny)      !! Primary beams
      real, intent(in) :: weight (nx,ny)          !! Effective weights on sky
      real, intent(in) :: wtrun                   !! Weight truncation
    end subroutine clark_soustraire
  end interface
  !
  interface
    subroutine v_size_r4_2(name,array,nn,err)
      use gbl_message
      ! @ public-mandatory
      character(len=*) :: name
      real, intent(in) :: array(:,:)
      integer, intent(in) :: nn(2)
      logical, intent(inout) :: err
    end subroutine v_size_r4_2
  end interface
  !
  interface
    subroutine v_size_l4_2(name,array,nn,err)
      use gbl_message
      ! @ public-mandatory
      character(len=*) :: name
      logical, intent(in) :: array(:,:)
      integer, intent(in) :: nn(2)
      logical, intent(inout) :: err
    end subroutine v_size_l4_2
  end interface
  !
  interface
    subroutine v_size_r4_3(name,array,nn,err)
      use gbl_message
      ! @ public-mandatory
      character(len=*) :: name
      real, intent(in) :: array(:,:,:)
      integer, intent(in) :: nn(3)
      logical, intent(inout) :: err
    end subroutine v_size_r4_3
  end interface
  !
  interface
    subroutine major_multi90 (rname,method,head,   &
         &    beam,nx,ny,mx,my,            &
         &    dirty,resid,mask,clean,      &
         &    cct_list,siter,miter,limit,niter, &
         &    smask, sresid, trans, cdata, sbeam, &
         &    tfbeam, wfft, mcct, nker, kernel, &
         &    np, primary, weight)    ! For mosaics
      use gbl_ansicodes
      use image_def
      use gbl_message
      use clean_def
      use clean_default
      use omp_control
      !$  use omp_lib
      !-----------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER -- CLEAN Method MULTISCALE  
      !     Multi-Resolution CLEAN - with NS (parameter) scales
      !
      !     Algorithm  
      !     For each iteration, search at which scale the signal to noise
      !     is largest. Use the strongest S/N to determine the "component"
      !     intensity and shape at this iteration.
      !
      !     Restore the ("infinite" resolution) image from the list of location
      !     types, and intensities of the "components"
      !
      !     The noise level at each scale is computed from the Fourier transform
      !     of the smoothed dirty beams, since the FT is the weight distribution
      !     and the noise level is the inverse square root of the sum of the
      !     weights.
      !!
      !-----------------------------------------------------------------------
      character(len=*), intent(in) :: rname     !! Caller name
      type(clean_par), intent(inout) :: method  !! Clean method
      type(gildas), intent(inout) :: head       !! Unused, but here for consistency...
      real, intent(in)  :: beam(:,:,:)          !! Dirty beams
      integer, intent(in)  :: nx,ny             !! Beam sizes
      integer, intent(in)  :: mx,my             !! Image size
      integer, intent(in) :: np                 !! Number of Pointings
      integer, intent(in)  :: siter             !! Starting Iteration
      integer, intent(in)  :: miter             !! Maximum number of clean components
      integer, intent(out) :: niter             !! Number of found components
      real, intent(in)  :: dirty(:,:)           !! Dirty image
      real, intent(inout) :: resid(:,:)         !! Residual image (initialized to Dirty image)
      real, intent(inout) :: clean(:,:)         !! "CLEAN" image (not convolved yet)
      real, intent(in) :: weight(:,:)           !! Combined weights
      logical, intent(in)  :: mask(:,:)         !! Search area
      real, intent(in)  :: limit                !! Maximum residual
      real, intent(in)  :: tfbeam(:,:,:)        !! Real Beam FT. for final Clean restoration
      real, intent(inout) :: wfft(*)            !! Work space for FFT
      type(cct_lst), intent(inout) :: cct_list  !! Clean Component List
      integer, intent(out) :: nker(:)           !! Kernel sizes
      real, intent(out) :: kernel(:,:,:)        !! Smoothing kernel values
      real, intent(in) :: primary(np, mx, my)   !! Primary beams
      integer, intent(out) :: mcct              !! Number of separate Clean components
      real, intent(inout) ::  sbeam(:,:,:)      !! Smoothed beams workspace
      real, intent(inout) ::  sresid(:,:)       !! Smoothed residuals workspace
      real, intent(inout) ::  trans(:,:)        !! Translated beam workspace
      complex, intent(inout) ::  cdata(:,:)     !! Work array
      logical, intent(inout) ::  smask(:,:)     !! Smoothed mask workspace
    end subroutine major_multi90
  end interface
  !
  interface
    subroutine expand_multi_cct(head,nker,kernel,nx,ny,ip,miter,flux,niter,tcc,dcct)
      use image_def
      use clean_def
      !-----------------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER  -- CLEAN Method MULTISCALE  
      !   Expand the MultiScale Clean Component List
      !!
      !-----------------------------------------------------------------------------
      type (gildas), intent(inout) :: head           !! Clean header
      integer, intent(in) :: nker(:)                 !! Kernel sizes
      real, intent(in) :: kernel(:,:,:)              !! Smoothing kernel values
      integer, intent(in)  :: nx,ny                  !! Image size
      integer, intent(in)  :: ip                     !! Plane number 
      integer, intent(in)  :: miter                  !! Maximum number of clean components
      real, intent(out) :: flux                      !! Cleaned flux
      integer, intent(in)  :: niter                  !! Number of found components
      type (cct_par), intent(in) :: tcc(niter)       !! Clean component list
      real, intent(inout) :: dcct(:,:,:)             !! Clean component values
    end subroutine expand_multi_cct
  end interface
  !
  interface
    subroutine map_message(mkind,procname,message,colour)
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER -- Message Utility
      !
      !   Messaging facility for the current library. Calls the low-level
      !   (internal) messaging routine with its own identifier.
      ! This is a variant of the GILDAS message, with color options added.
      !!
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind       !! Message kind
      character(len=*), intent(in) :: procname    !! Name of calling procedure
      character(len=*), intent(in) :: message     !! Message string
      integer, intent(in), optional :: colour     !! Colour of message 
    end subroutine map_message
  end interface
  !
  interface
    subroutine map_iostat(mkind,procname,ier)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Message utility - IO error 
      !
      !   Output system message corresponding to IO error code IER, and
      !   using the Message facility
      !!
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind       !! Message severity
      character(len=*), intent(in) :: procname    !! Calling routine name
      integer,          intent(in) :: ier         !! IO error number
    end subroutine map_iostat
  end interface
  !
  interface
    subroutine message_colour(colour)
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public
      !
      !! IMAGER --  Message Utility: Change the colour of the next message
      !---------------------------------------------------------------------
      integer, intent(in) :: colour  !! Desired colour index
    end subroutine message_colour
  end interface
  !
  interface
    subroutine map_operation(comm,mapout,dout,mapin,din,mrange,dv)
      use gkernel_types
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      !   IMAGER  -- Support for commands MAP_COMPRESS, MAP_INTEGRATE and MAP_RESAMPLE
      !
      !   Apply the specified Command to Mapin,Din to update Mapout,Dout.
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: comm      !! Operation
      type(gildas), intent(in) :: mapin         !! Input cube header
      type(gildas), intent(inout) :: mapout     !! Output cube header 
      real, intent(in) :: din(mapin%gil%dim(1),mapin%gil%dim(2),mapin%gil%dim(3))  
      !! Input data cube
      real, intent(out) :: dout(mapout%gil%dim(1),mapout%gil%dim(2),mapout%gil%dim(3))  
      !! Output data cube
      integer(kind=index_length), intent(in) :: mrange(2)     !! Range of channels
      real, intent(in) :: dv                    !! Scale factor
    end subroutine map_operation
  end interface
  !
  interface
    subroutine maxcct (x,n,nomin,rmin,nomax,rmax)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER --  Utility routine 
      ! 	Compute position and values of Min and Max of Clean Component List 
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: n                !! Array size
      type(cct_par), intent(in) :: x(n)       !! Clean components 
      integer, intent(out) :: nomin,nomax     !! Location of Min and Max 
      real, intent(out) :: rmin,rmax          !! Values of min and max
    end subroutine maxcct
  end interface
  !
  interface
    subroutine maxvec (x,n,nomin,rmin,nomax,rmax)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine  
      ! 	Compute position and values of Min and Max of array X
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: n                !! Array size
      real, intent(in) :: x(n)                !! Array values
      integer, intent(out) :: nomin,nomax     !! Location of Min and Max 
      real, intent(out) :: rmin,rmax          !! Values of min and max
    end subroutine maxvec
  end interface
  !
  interface
    subroutine maxmap(ary,nx,ny,box,amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine  
      !	  Find max and min in specified region of 2-D real array
      !!
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny           !! X,Y size
      real, intent(in) :: ary(nx,ny)          !! Array of values
      integer, intent(in) :: box(4)           !! Search box [Imin, Jmin, Imax, Jmax]
      integer, intent(out) :: imax, jmax      !! Position of Max
      integer, intent(out) :: imin, jmin      !! Position of Min
      real, intent(out) :: amax, amin         !! Max and Min
    end subroutine maxmap
  end interface
  !
  interface
    subroutine maxmsk(ary,nx,ny,msk,box,   &
         &    amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine  
      !	  Find max and min in specified region of 2-D real array,
      !   with a 2-D mask.
      !!
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny           !! X,Y size
      real, intent(in) :: ary(nx,ny)          !! Array of values
      logical, intent(in) ::  msk(nx,ny)      !! Search mask
      integer, intent(in) :: box(4)           !! Search box [Imin, Jmin, Imax, Jmax]
      integer, intent(out) :: imax, jmax      !! Position of Max
      integer, intent(out) :: imin, jmin      !! Position of Min
      real, intent(out) :: amax, amin         !! Max and Min
    end subroutine maxmsk
  end interface
  !
  interface
    subroutine maxlst(ary,nx,ny,list,nl,   &
         &    amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine  
      !	  Find max and min in 2-D real array, using a search list
      !!
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny           !! X,Y size
      real, intent(in) :: ary(nx*ny)          !! Array of values
      integer, intent(in) :: nl               !! List size
      integer, intent(in) :: list(nl)         !! Search list 
      integer, intent(out) :: imax, jmax      !! Position of Max
      integer, intent(out) :: imin, jmin      !! Position of Min
      real, intent(out) :: amax, amin         !! Max and Min
    end subroutine maxlst
  end interface
  !
  interface
    subroutine get_gildas(rname,cinp,desc,hin,error)
      use gkernel_types
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- GILDAS tool  
      !   General tool to incarnate the SIC variable into a Gildas 
      !   derived type Fortran variable
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname           !! Input caller name
      character(len=*), intent(in) :: cinp            !! Input variable name
      type(sic_descriptor_t), intent(out) :: desc     !! Descriptor
      type(gildas), intent(inout) :: hin              !! Gildas header 
      logical, intent(inout) :: error                 !! Error flag 
    end subroutine get_gildas
  end interface
  !
  interface
    subroutine mulgau(data,nx,ny,bmaj,bmin,pa,scale,xinc,yinc,isign,smax)
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER  -- Utility routine
      !
      ! 	Multiply or Divide (according to isign) the TF of an image by the 
      ! TF of a convolving gaussian function. BMAJ and BMIN are the
      !	widths of the original gaussian. PA is the position angle of major
      !	axis (from north towards east), in Degrees
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny      !! X,Y size
      real, intent(in) :: bmaj          !! Major axis in Radian
      real, intent(in) :: bmin          !! Minor axis in Radian 
      real, intent(in) :: pa            !! Position Angle in Degree
      real, intent(in) :: scale         !! Flux scale factor
      real, intent(in) :: xinc          !! X pixel size
      real, intent(in) :: yinc          !! Y pixel size
      complex, intent(inout) :: data(nx,ny) !! FT of Data to be smoothed
      integer, intent(in) :: isign      !! Multiply (< 0) or Divide (>0)
      real, intent(in), optional :: smax    !! Maximum distance for correction
    end subroutine mulgau
  end interface
  !
  interface
    subroutine check_view(n,argu)
      ! @ public-mandatory
      !*
      ! IMAGER -- VIEWER -- Support for VIEW command
      !
      ! Declare that all buffers specificied in argu(n) must be
      ! reloaded by VIEW.
      !!
      integer, intent(in) :: n                !! Number of buffers to be checked
      character(len=*), intent(in) :: argu(n) !! Buffer name
    end subroutine check_view
  end interface
  !
  interface
    subroutine get_jyperk(hstat,beam,jyperk)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !   Derive the Jy/beam conversion factor and Beam solid angle
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hstat  !! Data header
      real, intent(out) :: jyperk        !! Conversion from K to Jy
      real, intent(out) :: beam          !! Beam solid angle
    end subroutine get_jyperk
  end interface
  !
  interface
    subroutine convolve (image,dirty,nx,ny,fbeam,fcomp,wfft)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !	  Convolve an image by a beam through Fourier Transform
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny            !! Problem size
      complex, intent(in) :: fbeam(nx,ny)     !! Beam Fourier Transform
      complex, intent(inout) :: fcomp(nx,ny)  !! FT workspace
      real, intent(in) :: image(nx,ny)        !! Input image
      real, intent(out) :: dirty(nx,ny)       !! Convolved image
      real, intent(inout) :: wfft(*)          !! Work area
    end subroutine convolve
  end interface
  !
  interface
    subroutine compress(nx,ny,large,wl,mx,my,small,ws,wfft)
      !----------------------------------------------------------------------
      !	@ public
      ! 
      ! IMAGER -- Utility routine
      !
      !   Compress an image through TF truncation
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny         !! Large image size
      integer, intent(in) :: mx,my         !! Small image size
      real, intent(in) :: large(nx,ny)     !! Large image
      complex, intent(inout) :: wl(nx,ny)  !! Workspace for large FT
      real, intent(out) :: small(mx,my)    !! Small image
      complex, intent(inout) :: ws(mx,my)  !! Workspace for small FT
      real, intent(inout) :: wfft(*)       !! FFT workspace
    end subroutine compress
  end interface
  !
  interface
    subroutine expand (nx,ny,large,wl,mx,my,small,ws,wfft)
      !----------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -- Utility routine
      !
      !	  Expand an image through TF zero extension
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny        !! Large image size
      integer, intent(in) :: mx,my        !! Small image size
      real, intent(out) :: large(nx,ny)   !! Large image
      complex, intent(inout) :: wl(nx,ny) !! Workspace for large FT
      real, intent(in) :: small(mx,my)    !! Small image
      complex, intent(inout) :: ws(mx,my) !! Workspace for small FT
      real, intent(inout) :: wfft(*)      !! FFT workspace
    end subroutine expand
  end interface
  !
  interface
    function beam_for_channel(iplane,hdirty,hbeam)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Support routine for CLEAN
      !
      !   Find out the appropriate beam channel for an image channel
      !!
      !---------------------------------------------------------------------  
      integer :: beam_for_channel !! intent(out)    !! Beam channel
      type(gildas), intent(in) :: hdirty            !! Dirty header
      type(gildas), intent(in) :: hbeam             !! Beam header
      integer, intent(in) :: iplane                 !! Dirty channel number
    end function beam_for_channel
  end interface
  !
  interface
    subroutine histos (r,nx,ny, list, nl, hx,nh,hmin,hstep)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !	Computes the cumulative histogram of part of an image
      !
      !----------------------------------------------------------------------
      integer, intent(in) :: nx          !! X size
      integer, intent(in) :: ny          !! Y size
      real, intent(in)  :: r(nx*ny)      !! Input array 
      integer, intent(in) :: nl          !! List size
      integer, intent(in) :: list(nl)    !! List of values
      integer, intent(in) :: nh          !! Histogram size
      integer, intent(out) :: hx(nh)     !! Histogram
      real, intent(in) :: hmin           !! Min bin
      real, intent(in) :: hstep          !! Bin size
    end subroutine histos
  end interface
  !
  interface
    subroutine choice (r,nx,ny,list,nl,limite,   &
         &    mcl,wcl,ncl,rmax,ngoal)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      !  IMAGER -- CLEAN 	Internal routine
      !
      !	Select possible clean components in residual map.
      !	Components are returned ordered in increasing I and J.
      ! 
      ! Search list is built if ngoal>0, re-used otherwise.
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx            !! X size
      integer, intent(in) :: ny            !! Y size
      integer, intent(in) :: nl            !! List size
      integer, intent(in) :: mcl           !! Maximum number of components
      integer, intent(out) :: ncl          !! Number of components found
      real, intent(in) :: r(nx*ny)         !! Input array
      type(cct_par), intent(out) :: wcl(mcl)        !! Components
      integer, intent(in) :: list(nl)      !! List of pixels 
      real, intent(inout) ::  limite       !! selection threshold
      real, intent(in) :: rmax             !! Maximum value
      integer, intent(in) :: ngoal         !! Intended number   
    end subroutine choice
  end interface
  !
  interface
    subroutine find_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- CLEAN	Internal routine
      !
      !	Find the maximum sidelobe outside the beam patch defined
      !	by the beam center (I0,J0) and patch size (NXP,NYP)
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         !! X size
      integer, intent(in) :: ny         !! Y size
      real, intent(in) :: beam(nx,ny)   !! Input beam
      integer, intent(in) :: i0         !! X beam center
      integer, intent(in) :: j0         !! Y beam center
      integer, intent(in) :: nxp        !! X beam patch
      integer, intent(in) :: nyp        !! Y beam patch
      real, intent(out) :: bgain        !! Maximum sidelobe
    end subroutine find_sidelobe
  end interface
  !
  interface
    subroutine mos_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain,nf)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- CLEAN	Internal routine
      !
      !	Find the maximum sidelobe outside the beam patch defined
      !	by the beam center (I0,J0) and patch size (NXP,NYP).
      ! Version adapted for Mosaic
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         !! X size
      integer, intent(in) :: ny         !! Y size
      integer, intent(in) :: nf         !! Number of fields
      real, intent(in) :: beam(nx,ny,nf)   !! Input beam
      integer, intent(in) :: i0         !! X beam center
      integer, intent(in) :: j0         !! Y beam center
      integer, intent(in) :: nxp        !! X beam patch
      integer, intent(in) :: nyp        !! Y beam patch
      real, intent(out) :: bgain        !! Maximum sidelobe
    end subroutine mos_sidelobe
  end interface
  !
  interface
    subroutine t_setextrema(h,rmi,jmi,rma,jma)
      use gildas_def
      use image_def
      !------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Put extrema into the specified header
      !!
      !------------------------------------------------
      type (gildas), intent(inout), target :: h    !! Header
      real(kind=4), intent(in) :: rmi              !! Value of minimum
      integer(kind=size_length), intent(in) :: jmi !! Position of minimum
      real(kind=4), intent(in) :: rma              !! Value of maximum
      integer(kind=size_length), intent(in) :: jma !! Position of maximum
    end subroutine t_setextrema
  end interface
  !
  interface
    subroutine fibeam (name,dirty,nx,ny,nbx,nby,thre,majo,mino,pa,convert,error)
      use gildas_def
      use mod_fitbeam
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for FIT and CLEAN commands
      !
      !   Find beam parameters for deconvolution. 
      !   Fit an elliptical gaussian clean beam to main beam
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name            !! Caller name
      integer, intent(in) :: nx                       !! X size
      integer, intent(in) :: ny                       !! Y size
      real, intent(in) :: dirty(nx,ny)                !! Dirty beam
      integer, intent(in) :: nbx                      !! X patch
      integer, intent(in) :: nby                      !! Y patch
      real, intent(inout) :: thre                     !! Threshold
      real, intent(inout) :: majo                     !! Major axis
      real, intent(inout) :: mino                     !! Minor axis
      real, intent(inout) :: pa                       !! Position Angle
      real(8), intent(in) :: convert(3,2)             !! Axis Conversion formula
      logical, intent(inout) :: error                 !! Logical error flag
    end subroutine fibeam
  end interface
  !
  interface
    subroutine dofft (np,nv,visi,jx,jy,jo   &
         &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we  &
         &    ,ubias,vbias,ubuff,vbuff,ctype)
      use gildas_def
      use clean_default
      !$ use omp_lib
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  --   Support for UV_MAP and UV_RESTORE
      !
      !   Compute FFT of image by gridding UV data
      !   Select basic routine according to OMP_MAP%GRID
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nv                   !! number of values
      integer, intent(in) :: np                   !! Number of "visibilities", normally 7+3*nc
      real, intent(in) :: visi(np,nv)             !! values
      integer, intent(in) :: nc                   !! number of channels
      integer, intent(in) :: jx                   !! X coord location in VISI
      integer, intent(in) :: jy                   !! Y coord location in VISI
      integer, intent(in) :: jo                   !! first channel to map
      integer, intent(in) :: nx                   !! X map size
      integer, intent(in) :: ny                   !! Y map size
      complex, intent(out) :: map(nc+1,nx,ny)     !! gridded visibilities
      real, intent(in) :: mapx(nx)                !! X Coordinates of grid
      real, intent(in) :: mapy(ny)                !! Y Coordinates of grid
      real, intent(in) :: sup(2)                  !! Support of convolving function in Meters
      real, intent(in) :: cell(2)                 !! cell size in Meters
      real, intent(in) :: taper(4)                !! 1/e taper in Meters + Angle in Radians
      real, intent(in) :: we(nv)                  !! Weight array
      real, intent(in) :: ubias                   !! U gridding offset
      real, intent(in) :: vbias                   !! V gridding offset
      real, intent(in) :: ubuff(4096)             !! U gridding buffer
      real, intent(in) :: vbuff(4096)             !! V gridding buffer
      integer, intent(in) :: ctype                !! type of gridding
    end subroutine dofft
  end interface
  !
  interface
    subroutine remisajour (clean,resid,tfbeam,fcomp,   &
         &    wcl,ncl,nx,ny,wfft,   &
         &    np,primary,weight,wtrun)
      use clean_def
      use clean_default
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  CLEAN   Internal routine
      !
      !   Subtract last major cycle components from residual map.
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny    !! Problem size
      integer, intent(in) :: ncl      !! Number of clean components
      integer, intent(in) :: np       !! Number of primary beams
      type(cct_par), intent(in) :: wcl(ncl)   !! Clean component list
      real, intent(in) :: tfbeam(nx,ny,np)    !! TF of dirty beams
      complex, intent(inout) :: fcomp(nx,ny)  !! Work area
      real, intent(inout) :: clean(nx,ny)     !! Clean map
      real, intent(inout) :: resid(nx,ny)     !! Residual map
      real, intent(in) :: primary(np,nx,ny)   !! Primary beams
      real, intent(in) :: weight(nx,ny)       !! Flat field weights
      real, intent(in) :: wtrun               !! Truncation of mosaic
      real, intent(in) :: wfft(*)             !! work fft area
    end subroutine remisajour
  end interface
  !
  interface
    subroutine domima(a,rmi,rma,imi,ima,n)
      !----------------------------------------------------------
      ! @ public
      !!*
      ! IMAGER  --  Utility
      !
      !   Compute minmax and location
      !!
      !----------------------------------------------------------
      integer, intent(in) :: n        !! Problem size
      integer, intent(out) :: ima,imi !! Min Max positions
      real, intent(in) ::  a(n)       ! Values
      real, intent(inout) :: rmi,rma  ! Min Max values
    end subroutine domima
  end interface
  !
  interface
    subroutine progress_report(action,iv,nv,mv,percentage_step)
      !--------------------------------------------------------------
      ! @ public
      !
      !!   IMAGER  -- Utility: Printout progress report
      !--------------------------------------------------------------
      character(len=*), intent(in) :: action !! Action name
      integer, intent(in) :: iv    !! Current index
      integer, intent(in) :: nv    !! Number of values per block
      integer, intent(in) :: mv    !! Total number of values
      integer, intent(in) :: percentage_step !! Frequency of report
    end subroutine progress_report
  end interface
  !
  interface
    subroutine mosaic_loadfield (visi,np,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER  --  MOSAIC routines
      !
      !     Load field coordinates into work arrays after sorting.
      !!
      !----------------------------------------------------------------------
      integer, intent(in)  :: np              !! Size of a visibility
      integer, intent(in)  :: nv              !! Number of visibilities
      real, intent(in) :: visi(np,nv)         !! Input visibilities
      integer, intent(in)  :: ixoff           !! X pointer
      integer, intent(in)  :: iyoff           !! Y pointer
      integer, intent(out) :: nf              !! Number of fields
      real(kind=4), intent(out) :: doff(:,:)  !! Fields offsets
      integer, intent(out) :: voff(:)         !! Fields visibility offsets
      real, intent(inout) :: uvmax            !! Maximum length
      real, intent(inout) :: uvmin            !! Minimum baseline
    end subroutine mosaic_loadfield
  end interface
  !
  interface
    subroutine mosaic_getfields (visi,np,nv,ixoff,iyoff,itele,nf,doff,jtele)
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER  --   MOSAIC routines
      !
      !     Count number of fields and Get their coordinates
      !   	and telescope IDs
      !!
      !----------------------------------------------------------------------
      integer, intent(in)  :: np                   !! Size of a visibility
      integer, intent(in)  :: nv                   !! Number of visibilities
      real, intent(inout)  :: visi(np,nv)          !! Input visibilities
      integer, intent(in)  :: ixoff                !! X pointer
      integer, intent(in)  :: iyoff                !! Y pointer
      integer, intent(in)  :: itele                !! Telescope pointer
      integer, intent(out) :: nf                   !! Number of fields
      real, intent(out), allocatable :: doff(:,:)  !! Field offsets
      integer, intent(out), allocatable :: jtele(:) !! Telescope number
    end subroutine mosaic_getfields
  end interface
  !
  interface
    subroutine init_kernel(ker,mk,nk,smooth)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  Support for MULTISCALE clean
      !
      !   Initialize a smoothing Kernel by a Gaussian shape
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: mk            !! Kernel size
      integer, intent(in) :: nk            !! Kernel size
      real(4), intent(inout) :: ker(mk,mk) !! Kernel, centered on (NK+1)/2
      real(4), intent(in) :: smooth        !! Smoothing factor
    end subroutine init_kernel
  end interface
  !
  interface
    subroutine smooth_mask (mask,smask,nx,ny,nk)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  Support for MULTISCALE clean
      !
      !   Enlarge a mask using a kernel, based only on kernel size
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !! X size
      integer, intent(in) :: ny             !! Y size
      logical, intent(in) :: mask(nx,ny)    !! Input array
      logical, intent(out) :: smask(nx,ny)  !! Smoothed array
      integer, intent(in) :: nk             !! kernel size
    end subroutine smooth_mask
  end interface
  !
  interface
    subroutine smooth_kernel (array,sarray,nx,ny,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  Support for MULTISCALE clean
      !
      !   Smooth an array using a kernel.
      ! Parallel programming is useful here
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !! X size
      integer, intent(in) :: ny             !! Y size
      real, intent(in) :: array(nx,ny)      !! Input array
      real, intent(out) :: sarray(nx,ny)    !! Smoothed array
      integer, intent(in) :: nk             !! Actual Kernel size
      integer, intent(in) :: mk             !! Kernel dimensions
      real, intent(in) :: ker(mk,mk)        !! Smoothing kernel, centered on (nk+1)/2
    end subroutine smooth_kernel
  end interface
  !
  interface
    subroutine smooth_masked (nx,ny,sarray,array,mask,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for MULTISCALE
      !
      !   Smooth an array using a kernel, but only in a mask.
      ! Parallel programming is useful here
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !! X size
      integer, intent(in) :: ny             !! Y size
      real, intent(in) :: array(nx,ny)      !! Input array
      real, intent(out) :: sarray(nx,ny)    !! Smoothed array
      logical, intent(in) :: mask(nx,ny)    !! Valid area
      integer, intent(in) :: mk             !! Kernel array size
      integer, intent(in) :: nk             !! Kernel actual size
      real, intent(in) :: ker(mk,mk)        !! Smoothing kernel, centered on (nk+1)/2
    end subroutine smooth_masked
  end interface
  !
  interface
    subroutine add_kernel (clean,nx,ny,value,kx,ky,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Support for MULTISCALE Clean
      !
      !   Spread a value using a Kernel and add it to result
      ! 
      !   Parallel programming does not help here, as the Kernel is small
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           !! X Image size
      integer, intent(in) :: ny           !! Y Image size
      real, intent(inout) :: clean(nx,ny) !! Summed output array
      real, intent(in) :: value           !! Input value
      integer, intent(in) :: kx           !! X Center of value
      integer, intent(in) :: ky           !! Y Center of value
      integer, intent(in) :: mk           !! Kernel  array size
      integer, intent(in) :: nk           !! Kernel actual size
      real, intent(in) :: ker(mk,mk)      !! Smoothing kernel, centered on (nk+1)/2
    end subroutine add_kernel
  end interface
  !
  interface
    subroutine amaxmask (a,mask,nx,ny,ix,iy)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for deconvolution
      !
      !     Search the absolute maximum, in a masked region
      !
      ! Parallel programming does not help  here.
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           !! X size
      integer, intent(in) :: ny           !! Y size
      real, intent(in) :: a(nx,ny)        !! Values
      logical, intent(in) :: mask(nx,ny)  !! Mask
      integer, intent(out) :: ix          !! X position of max
      integer, intent(out) :: iy          !! Y position of max
    end subroutine amaxmask
  end interface
  !
  interface
    subroutine spread_kernel (nx,ny,ip,nc,dcct,value,kx,ky,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER -- Support for MULTISCALE Clean
      !
      !   Spread a value using a Kernel and add it to result
      !!
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           !! X Image size
      integer, intent(in) :: ny           !! Y Image size
      integer, intent(in) :: ip           !! Plane number 
      integer, intent(inout) :: nc        !! Number of clean components
      real, intent(out) :: dcct(:,:,:)    !! Expanded Clean Components 
      real, intent(in) :: value           !! Input value
      integer, intent(in) :: kx           !! X Center of value
      integer, intent(in) :: ky           !! Y Center of value
      integer, intent(in) :: nk           !! Actual Kernel size
      real, intent(in) :: ker(:,:)        !! Smoothing kernel, centered on (nk+1)/2
    end subroutine spread_kernel
  end interface
  !
  interface
    subroutine telescope_beam(rname,bsize,head)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      !! IMAGER --  Get telescope beamsize for the frequency of a GILDAS data set
      !---------------------------------------------------------------------  
      character(len=*), intent(in) :: rname !! Caller name
      real, intent(inout) :: bsize(:)       !! Primary beam size
      type(gildas), intent(in) :: head      !! Gildas header
    end subroutine telescope_beam
  end interface
  !
  interface
    subroutine no_major_plot (method,head   &
         &    ,conv,niter,nx,ny,np,tcc  &
         &    ,clean,resid,poids)
      use clean_def
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !!
      ! IMAGER  -- Support for CLEAN
      !
      !   Dummy replacement of "major_plot". 
      !   Do not Plot result of Major Cycle
      !!
      !---------------------------------------------------------------------
      type (clean_par), intent(inout) :: method
      type (gildas), intent(in) :: head
      !
      logical, intent(in) ::  conv          !! Convergence status
      integer, intent(in) ::  niter         !! Number of iterations
      integer, intent(in) ::  nx            !! X size
      integer, intent(in) ::  ny            !! Y size
      integer, intent(in) ::  np            !! Number of planes
      real, intent(in) :: clean(nx,ny)      !! Clean image
      real, intent(in) :: resid(nx,ny)      !! Residuals
      real, intent(in) :: poids(nx,ny)      !! Weight image
      type (cct_par), intent(in) :: tcc(niter)
    end subroutine no_major_plot
  end interface
  !
  interface
    subroutine no_next_flux(niter,cum,is)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for Clean 
      !
      !   Dummy replacement of "next_flux". 
      !   Do not draw in the <FLUX window
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: niter
      real, intent(in) :: cum
      integer :: is
    end subroutine no_next_flux
  end interface
  !
  interface
    subroutine no_remask(method,head,nl,error)
      use clean_def
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Support for Clean 
      !
      ! Dummy replacement of "remask"
      !!
      !---------------------------------------------------------------------
      type (clean_par), intent(in) :: method
      type (gildas), intent(in) :: head
      integer, intent(in) :: nl
      logical, intent(in) :: error
    end subroutine no_remask
  end interface
  !
  interface
    subroutine get_rlist (rmsk,nx,ny,box,list,nl)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !     Return a List of selected pixels from a (0 - non zero) real mask, 
      ! and also computes its boundaries
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nx                       !! X size
      integer, intent(in) :: ny                       !! Y size
      real(kind=4), intent(in) :: rmsk(nx,ny)         !! Real mask
      integer, intent(out) :: box(4)                  !! Mask Boundary
      integer, intent(out) :: list(nx*ny)             !! List of pixels in mask
      integer, intent(out) :: nl          !! Number of selected pixels in list
    end subroutine get_rlist
  end interface
  !
  interface
    subroutine gr4_slmsk (rmsk,lmsk,nx,ny,box)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !     Return a LOGICAL mask from the a (0 - non zero) mask, and also
      !       computes its boundaries
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nx                  !! X size
      integer, intent(in) :: ny                  !! Y size
      real(kind=4), intent(in) :: rmsk(nx,ny)    !! Real mask
      logical, intent(out) :: lmsk(nx,ny)        !! Logical mask
      integer, intent(out) :: box(4)             !! Mask boundary (xblc,yblc,xtrc,ytrc)
    end subroutine gr4_slmsk
  end interface
  !
  interface
    subroutine get_lmask(hmask,rmask,hmap,lmask,box)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support routine for Mask operations
      !
      !     Return a LOGICAL mask from the a (0 - non zero) possibly 3-D mask, 
      !   and also computes its boundaries.
      !     The initial mask (=0 or #0) does not need to match the data: pixel
      !   correspondances is derived from relative coordinates (not absolute).
      !   The LOGICAL mask matches the data pixel per pixel, and is a 2-D mask
      !   resulting from collapsing of the initial 3-D mask 
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hmask          !! Mask header
      type(gildas), intent(in) :: hmap           !! Map header  
      real(kind=4), intent(in) :: rmask(:,:,:)   !! Real mask
      logical, intent(out) :: lmask(:,:)         !! Logical mask
      integer, intent(out) :: box(4)             !! Mask boundary (xblc,yblc,xtrc,ytrc)
    end subroutine get_lmask
  end interface
  !
  interface
    subroutine getuv_conversion(uvout,nc,convert)
      use gildas_def
      use image_def
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine for Velocity resampling
      !
      !   Derive the frequency axis corresponding to a specified
      !   Velocity sampling.
      !!
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: uvout   !! Output UV table header
      integer, intent(in) :: nc               !! Number of desired channels
      real(8), intent(inout) :: convert(3)    !! Velocity conversion formula
    end subroutine getuv_conversion
  end interface
  !
  interface
    subroutine resample_uv (uvint,uvout,uvint_data,uvout_data,nv,nt,filtered)
      use image_def
      !------------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --   Support for commands UV_RESAMPLE and UV_MERGE
      !
      !   Resample (in memory) a UV data set
      !------------------------------------------------------------------------
      type (gildas), intent(in) :: uvint  !! Input UV header
      type (gildas), intent(in) :: uvout  !! Output UV header
      real(4), intent(in) :: uvint_data(uvint%gil%dim(1),uvint%gil%dim(2))
      real(4), intent(out) :: uvout_data(uvout%gil%dim(1),uvout%gil%dim(2))
      integer(kind=index_length), intent(in) :: nv  !! Actual number of visibilities
      integer, intent(in) :: nt           !! Number of trailing informations
      integer, intent(in), optional :: filtered(:)  !! Filtered channels
    end subroutine resample_uv
  end interface
  !
  interface
    subroutine interpolate_axis(xdim,xinc,xref,xval, ydim,yinc,yref,yval, &
      & jmin,jmax,wmin,wmax)
      !-----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER   Support for UV_RESAMPLE and UV_MERGE
      !
      ! Performs the linear interpolation/integration for visibilities
      !
      ! 1) if actual interpolation (XINC <= YINC)  
      !     this is a 2-point linear interpolation formula.
      !     the data is untouched if the resolution is unchanged and the shift
      !     is an integer number of channels.
      !
      ! 2) if not (XINC > YINC)  
      !     boxcar convolution (width xinc-yinc) followed by linear interpolation
      !!
      !-----------------------------------------------------------------------------
      integer, intent(in) :: ydim             !! Input axis size
      integer, intent(in) :: xdim             !! Output axis size
      real(8), intent(in) :: yref,yval,yinc   !! Input conversion formula
      real(8), intent(in) :: xref,xval,xinc   !! Output conversion formula
      integer, intent(out) :: jmin(xdim)      !! Min pixel in current output one
      integer, intent(out) :: jmax(xdim)      !! Max pixel in current output one
      real, intent(out) :: wmin(xdim)         !! Weight of jmin()
      real, intent(out) :: wmax(xdim)         !! Weight of jmax()
    end subroutine interpolate_axis
  end interface
  !
  interface
    subroutine average_uv (out,nx,nv,inp,ny,nc,num,nt)
      !------------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for tasks UV_AVERAGE    -- Unused by IMAGER
      !   Average (in memory) a series of channels of a UV data set
      !------------------------------------------------------------------------
      integer, intent(in) :: num        ! Number of selected channels
      integer, intent(in) :: nx         ! Output Visibility size
      integer, intent(in) :: nv         ! Number of visibilities
      real, intent(out) :: out(nx,nv)   ! Output Visibilities
      integer, intent(in) :: ny         ! Input visibility size
      real, intent(in) :: inp(ny,nv)    ! Input visibilities
      integer, intent(in) :: nc(num)    ! Selected Channels, first & last pairs
      integer, intent(in) :: nt         ! Number of trailing informations
    end subroutine average_uv
  end interface
  !
  interface
    subroutine compress_uv(out,nx,nv,mx,inp,ny,nc,nt, filtered)
      !------------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Support for command UV_COMPRESS
      !   Compress (in memory) by NC channels a UV data set
      !------------------------------------------------------------------------
      integer, intent(in) :: nx         ! Output Visibility size
      integer, intent(in) :: nv         ! Number of visibilities
      integer, intent(in) :: mx         ! Number of Output Channels
      real, intent(out) :: out(nx,nv)   ! Output Visibilities
      integer, intent(in) :: ny         ! Input visibility size
      real, intent(in) :: inp(ny,nv)    ! Input visibilities
      integer, intent(in) :: nc         ! Number of Channels to average
      integer, intent(in) :: nt         ! Number of trailing informations
      integer, intent(in), optional :: filtered(:) 
    end subroutine compress_uv
  end interface
  !
  interface
    subroutine doself (model,resul,itype,self,weight)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV Tools
      !
      !   Compute self calibration factor
      !!
      !---------------------------------------------------------------------
      complex, intent(in) :: model   !! Model visibility
      complex, intent(in) :: resul   !! Actual observation
      integer, intent(in) :: itype   !! Type of self calibration
      complex, intent(out) :: self   !! Self calibration factor
      real, intent(out) :: weight    !! Weight scaling factor
    end subroutine doself
  end interface
  !
  interface
    subroutine doscal (nc,visi,cosi,sinu,sreel,simag,weight)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV Tools
      !
      !	  Apply the self-calibration factor to the current visibility
      !	  Set weight to zero if no self-cal factor
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !!  Number of channels
      real, intent(inout) :: visi(*)      !!  Visibility
      real, intent(in) :: sreel           !!  Real part to subtract
      real, intent(in) :: simag           !!  Imaginary part to subtract
      real, intent(in) :: cosi            !!  Phase rotation cos
      real, intent(in) :: sinu            !!  Phase rotation sin
      real, intent(in) :: weight          !!  Scaling factor of weight
    end subroutine doscal
  end interface
  !
  interface
    subroutine dosubt (nc,visi,sreel,simag)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  UV Tools  
      !   Subtract a continuum value from a line visibility
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !!  Number of channels
      real, intent(inout) :: visi(*)      !!  Visibility
      real, intent(in) :: sreel           !!  Real part
      real, intent(in) :: simag           !!  Imaginary part
    end subroutine dosubt
  end interface
  !
  interface
    subroutine doflag (nc,visi)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  UV Tools
      !   Flag (by zero) a line visibility
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !!  Number of channels
      real, intent(inout) :: visi(*)      !!  Visibility
    end subroutine doflag
  end interface
  !
  interface
    subroutine getiba (visi,stime,time,base,uv)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  UV Tools  
      !   Get baseline and time information
      !!
      !---------------------------------------------------------------------
      real, intent(in)  :: visi(*)                   !! Visibility
      real(8), intent(in) :: stime                   !! Reference time
      real(8), intent(out) :: time                   !! Time offset
      real, intent(out)  :: base(2)                  !! First and Last antenna
      real, intent(out)  :: uv(2)                    !! U and V
    end subroutine getiba
  end interface
  !
  interface
    subroutine dotime (mv,nv,visi,wtime,it,stime)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV Tools 
      !	  Compute the observing times of the data, 
      !	  sort it and return sorting index
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           !! Size of visibility
      integer, intent(in) :: nv           !! Number of visibilities
      real, intent(in) :: visi(mv,nv)     !! Visibilities
      real(8), intent(out) :: wtime(nv)   !! Sorted times
      integer, intent(inout) :: it(nv)    !! Sorting index
      real(8), intent(out) :: stime       !! Reference time
    end subroutine dotime
  end interface
  !
  interface
    subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,rbase,complx,uv)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV Tools  
      !	  Compute the Observed Visibility of the "model source"
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           !! Size of visibility
      integer, intent(in) :: nv           !! Number of visibilities
      real, intent(in) :: visi(mv,nv)     !! Visibilities
      real(8), intent(out) :: wtime(nv)   !! Sorted times
      integer, intent(in) :: iw(2)        !! First and Last channel
      real(8), intent(in) :: time         !! Time of observation
      real(8), intent(in) :: ftime        !! Tolerance on time +/-
      integer, intent(in) :: it(nv)       !! Ordering of visibilities
      real, intent(in) :: rbase(2)        !! Antennas
      real, intent(in) :: uv(2)           !! U and V
      complex, intent(out) :: complx      !! Result
    end subroutine geself
  end interface
  !
  interface
    subroutine findr (np,x,xlim,nlim)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  UV Tools  
      !	  Find NLIM such as **X(NLIM-1) < XLIM <= X(NLIM)**
      !	  for input data ordered.
      !	  Use a dichotomic search for that
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: np          !! Number of data points
      real(8), intent(in) :: x(np)       !! Data values
      real(8), intent(in) :: xlim        !! Value to be localized
      integer, intent(out) :: nlim       !! Found position
    end subroutine findr
  end interface
  !
  interface
    subroutine uvsort_uv (np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV handling routine
      !
      !     Rotate, Shift and Sort a UV table for map making
      !     Differential precession should have been applied before.
      !     Single Field case
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: np        !! Size of a visibility
      integer, intent(in) :: nv        !! Number of visibilities
      integer, intent(in) :: ntrail    !! Number of trailing daps
      real, intent(in) :: vin(np,nv)   !! Input visibilities
      real, intent(out) :: vout(np,nv) !! Output visibilities
      real, intent(in) :: xy(2)        !! Phase shift
      real, intent(in) :: cs(2)        !! Frame Rotation
      real, intent(out) :: uvmax       !! Max UV value
      real, intent(out) :: uvmin       !! Min UV value
      logical, intent(out) :: error    !! Error flag
    end subroutine uvsort_uv
  end interface
  !
  interface
    subroutine loaduv (visi,np,nv,cs,u,v,s,uvmax,uvmin)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  --   UV_SORT routines
      !
      !     Load new U,V coordinates and sign indicator into work arrays
      !     for sorting.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: np       !! Size of a visibility
      integer, intent(in) :: nv       !! Number of visibilities
      real, intent(in) :: visi(np,nv) !! Input visibilities
      real, intent(in) :: cs(2)       !! Rotation parameter
      real, intent(out) :: u(nv)      !! Output U and V coordinates
      real, intent(out) :: v(nv)      !! Output U and V coordinates
      logical, intent(out) :: s(nv)   !! V Sign indicator
      real, intent(inout) :: uvmax    !! Maximum length
      real, intent(inout) :: uvmin    !! Minimum baseline
    end subroutine loaduv
  end interface
  !
  interface
    subroutine chksuv (nv,v,it,sorted)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV_SORT routines
      !
      !   Check if visibilities are sorted
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nv      !! Number of visibilities
      real, intent(in) :: v(nv)      !! Visibilities
      integer, intent(out) :: it(nv) !! Sorting pointer
      logical, intent(out) :: sorted !! short cut
    end subroutine chksuv
  end interface
  !
  interface
    subroutine sub_sortuv (vin,vout,np,nv,ntrail,xy,nf,id,u,v,s,it)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  --  UV_SORT routines
      !
      !     Sort an input UV table into an output one.
      !     The output UV table is a rotated, phase shifted copy of
      !     the input one, with all V negative and increasing
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: np         !! Size of a visibility
      integer, intent(in) :: nv         !! Number of visibilities
      integer, intent(in) :: ntrail     !! Number of trailing daps
      real, intent(in) :: vin(np,nv)    !! Input visibilities
      real, intent(out) :: vout(np,nv)  !! Output visibilities
      integer, intent(in) :: nf         !! Number of fields
      integer, intent(in) :: id         !! Fields ID column
      real, intent(in) :: xy(2,nf)      !! Phase shifting factors
      real, intent(in) :: u(nv)         !! New U coordinates
      real, intent(in) :: v(nv)         !! New V coordinates
      logical, intent(in) :: s(nv)      !! Sign of new visibility
      integer, intent(in) :: it(nv)     !! Pointer to old visibility
    end subroutine sub_sortuv
  end interface
  !
  interface
    subroutine extracs (np,nx,ny,ip,in,out,lx,ly)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER - Utility routine
      !
      !     Extract a Fourier plane from the FFT cube.
      !     Plane and Cube may have different X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  !! Number of planes
      integer,intent(in) :: nx  !! output FFT X plane size
      integer,intent(in) :: ny  !! output FFT Y plane size
      integer,intent(in) :: ip  !! Plane to be extracted
      integer,intent(in) :: lx  !! input FFT cube X plane size
      integer,intent(in) :: ly  !! input FFT cube Y plane size
      complex,intent(in) :: in(np,lx,ly) !! Input FFT cube
      complex,intent(out) :: out(nx,ny)  !! Output 2-D FFT
    end subroutine extracs
  end interface
  !
  interface
    subroutine extrac (np,nx,ny,ip,in,out)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !     Extract a Fourier plane from an FFT cube
      !     Plane and Cube must have same X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  !! Number of planes
      integer,intent(in) :: nx  !! FFT X plane size
      integer,intent(in) :: ny  !! FFT Y plane size
      integer,intent(in) :: ip  !! Plane to be extracted
      complex,intent(in) :: in(np,nx,ny) !! Input FFT cube
      complex,intent(out) :: out(nx,ny)  !! Output 2-D FFT
    end subroutine extrac
  end interface
  !
  interface
    subroutine dovisi (np,nv,visi,vv,ww,jw)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Visibility handling routine
      !
      !   Extract V coordinate and Weight value
      !
      !----------------------------------------------------------------------
      integer, intent(in) :: np        !! Size of visibilities
      integer, intent(in) :: nv        !! Number of visibilities
      real, intent(in) :: visi(np,nv)  !! Visibilities
      real, intent(out) :: vv(nv)      !! V values
      real, intent(out) :: ww(nv)      !! Weight values
      integer, intent(in) :: jw        !! Weight column
    end subroutine dovisi
  end interface
  !
  interface
    subroutine dogrid (corr,corx,cory,nx,ny,beam)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Gridding routine
      !
      !   Compute grid correction array, with normalisation
      !   of beam to 1.0 at maximum pixel
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         !! X size
      integer, intent(in) :: ny         !! Y size
      real, intent(in) :: beam(nx,ny)   !! Denormalized beam
      real, intent(in) :: corx(nx)      !! X grid correction
      real, intent(in) :: cory(ny)      !! Y Grid correction
      real, intent(out) :: corr(nx,ny)  !! Final grid correction and beam normalization
    end subroutine dogrid
  end interface
  !
  interface
    subroutine docorr (map,corr,nd)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER - Gridding routine
      !
      !   Apply grid correction to map
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nd         !! Number of data
      real, intent(inout) :: map(nd)    !! Data
      real, intent(in) :: corr(nd)      !! Correction
    end subroutine docorr
  end interface
  !
  interface
    subroutine docoor (n,xinc,x)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Grdding routine
      !
      !   Compute FFT grid coordinates in U or V
      !!
      !----------------------------------------------------------------------
      integer,intent(in) :: n     !! Number of values
      real, intent(out) :: x(n)   !! Values
      real, intent(in) :: xinc    !! Increment
    end subroutine docoor
  end interface
  !
  interface
    subroutine findp (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  Utility routine
      !
      !   Find NLIM such that  
      !   XX(NLIM-1) < XLIM < XX(NLIM)  
      !   for input data ordered, retrieved from memory. It 
      !   assumes NLIM already preset so that XX(NLIM-1) < XLIM
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       !! Number of values
      integer, intent(inout) :: nlim  !! Preset Position
      real, intent(in) :: xx(nv)      !! Input order value
      real, intent(in) :: xlim        !! Value to be located
    end subroutine findp
  end interface
  !
  interface
    subroutine findm (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine 
      !
      !   Find NLIM such that   
      !     XX(NLIM-1) < XLIM < XX(NLIM)  
      !   for input data ordered, retrieved from memory. It
      !   assumes NLIM already preset so that XLIM < XX(NLIM)
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nv        !! Number of values
      integer, intent(inout) :: nlim   !! Preset Position
      real, intent(in) :: xx(nv)       !! Input order value
      real, intent(in) :: xlim         !! Value to be located
    end subroutine findm
  end interface
  !
  interface
    subroutine grdtab (n, buff, bias, corr)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !   Compute fourier transform of gridding function
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: n     !! Number of pixels, assuming center on N/2+1
      real, intent(in) :: buff(*)  !! Gridding function, tabulated every 1/100 cell
      real, intent(in) :: bias     !! Center of gridding function
      real, intent(out) :: corr(n) !! Gridding correction FT
    end subroutine grdtab
  end interface
  !
  interface
    subroutine retocm(r,z,nx,ny)
      !------------------------------------------------------------------------
      ! @  public
      !
      ! IMAGER -- FFT support routine
      !
      !   Convert real to complex, with Shifting in corners for FFT
      !!
      !------------------------------------------------------------------------
      integer, intent(in) :: nx, ny         !! Problem size
      real, intent(in) :: r(nx,ny)          !! Real values
      complex, intent(out) :: z(nx, ny)     !! Complex shifted values
    end subroutine retocm
  end interface
  !
  interface
    subroutine cmtore (in,out,nx,ny)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- FFT support routine
      !
      !   Extract Real image from Fourier Transform of its complex FFT
      !   with appropriate recentering
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         !! Size of map
      integer, intent(in) :: ny         !! Size of map
      complex, intent(in) :: in(nx,ny)  !! Complex FFT
      real, intent(out) :: out(nx,ny)   !! Extracted real image
    end subroutine cmtore
  end interface
  !
  interface
    subroutine convfn (ctype, parm, buffer, bias)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER -- Gridding routine
      !
      !   CONVFN computes the convolving functions and stores them in
      !   the supplied buffer. Values are tabulated every 1/100 cell.
      !!
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctype     !! Convolution type
      real(4), intent(inout) :: parm(10)  !! Convolution parameters
      real(4), intent(out)   :: buffer(:) !! Sampled values
      real(4), intent(out)   :: bias      !! Center of samples
    end subroutine convfn
  end interface
  !
  interface
    subroutine grdflt (ctypx, ctypy, xparm, yparm)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Gridding function
      !
      !     GRDFLT determines default parameters for the convolution functions
      !     If no convolving type is chosen, an Spheroidal is picked.
      !     Otherwise any unspecified values ( = 0.0) will be set to some
      !     value.
      ! Arguments:
      !     CTYPX,CTYPY           I  Convolution types for X and Y direction
      !                                1 = pill box
      !                                2 = exponential
      !                                3 = sinc
      !                                4 = expontntial * sinc
      !                                5 = spheroidal function
      !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
      !                                (1) = support radius (cells)
      !
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctypx,ctypy !! Function type
      real(4), intent(inout) :: xparm(10)   !! X function parameters
      real(4), intent(inout) :: yparm(10)   !! Y function parameters
    end subroutine grdflt
  end interface
  !
  interface
    subroutine uvgmax(huv,visi,uvmax,uvmin)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for UV_MAP
      !
      !       Get the Min Max of UV distances
      !!
      !----------------------------------------------------------------------
      type (gildas), intent(inout) :: huv   !! UV data header
      real, intent(in) ::  visi(:,:)        !! Visibilities
      real, intent(out) :: uvmax            !! Max baseline
      real, intent(out) :: uvmin            !! Min baseline
    end subroutine uvgmax
  end interface
  !
  interface
    function sump(n,a)
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --  Support for UV_MAP
      !
      !       Return the sum of positive values in array
      !!
      !----------------------------------------------------------------------
      real :: sump               !! Return value, intent(out)
      integer, intent(in) :: n   !! Number of values
      real, intent(in) :: a(n)   !! Values
    end function sump
  end interface
  !
  interface
    subroutine doweig_grid (jc,nv,visi,jx,jy,jw,unif,we,error,code)
      use gildas_def
      use grid_control
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV_MAP Weight handling routine
      !
      !     Compute weights of the visibility points.
      !      Pure Gridded method
      !
      !   Pass 1:   Natural Gridding of the weights  
      !   Pass 2:   Smoothing of the Grid   
      !   Pass 3:   Correction of initial weights by Smoothed values
      !!
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          !! number of visibilities
      integer, intent(in) ::  jc          !! Size of a visibilities
      integer, intent(in) ::  jx          !! X coord location in VISI
      integer, intent(in) ::  jy          !! Y coord location in VISI
      integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    !! Visibilities
      real, intent(in) ::  unif           !! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      !! Weight array
      logical, intent(inout) :: error     !! Error code
      integer, intent(in), optional :: code  !! Number of sub-cells per UV uniform cell size
    end subroutine doweig_grid
  end interface
  !
  interface
    subroutine dotape (jc,nv,visi,jx,jy,taper,we)
      use gildas_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- UV_MAP Weight handling routine
      !
      !     Apply taper to the weights of the visibility points.
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nv          !! number of values
      integer, intent(in) :: jc          !! Size of a visibility
      integer, intent(in) :: jx          !! X coord location in VISI
      integer, intent(in) :: jy          !! Y coord location in VISI
      real, intent(in) :: visi(jc,nv)    !! Visibilities
      real, intent(in) :: taper(4)       !! Taper definition
      real, intent(inout) :: we(nv)      !! Weights
    end subroutine dotape
  end interface
  !
  interface
    subroutine doweig (jc,nv,visi,jx,jy,iw,unif,we,wm,error,code)
      !$ use omp_lib
      use gildas_def
      use grid_control
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER  -- Support for UV_MAP
      !
      !     Compute weights of the visibility points.
      !!
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          !! number of values
      integer, intent(in) ::  jc          !! Number of "visibilities"
      integer, intent(in) ::  jx          !! X coord location in VISI
      integer, intent(in) ::  jy          !! Y coord location in VISI
      integer, intent(in) ::  iw          !! Weight channel. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    !! Visibilities
      real, intent(in) ::  unif           !! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      !! Weight array
      real, intent(in) ::  wm             !! on input: % of uniformity
      logical, intent(inout) :: error     !! Logical error flag
      integer, intent(in), optional :: code   !! Code controlling the method
    end subroutine doweig
  end interface
  !
  interface
    subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER  -- Support for UV_MAP
      !
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          !! number of values
      integer, intent(in) ::  jc          !! Number of "visibilities"
      integer, intent(in) ::  jx          !! X coord location in VISI
      integer, intent(in) ::  jy          !! Y coord location in VISI
      integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    !! Visibilities
      real, intent(in) ::  unif           !! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      !! Weight array
      logical, intent(inout) :: error
      integer, intent(in), optional :: code  !! Number of sub-cells per UV uniform cell size
    end subroutine doweig_sph
  end interface
  !
  interface
    subroutine scawei (nv,uni,ori,wall)
      !---------------------------------------------------------
      ! @ public
      !
      !! IMAGER --  Scale the visibility weights
      !---------------------------------------------------------
      integer, intent(in) :: nv     !! Number of visibilities
      real, intent(out) :: uni(nv)  !! Re-weighted weights
      real, intent(in)  :: ori(nv)  !! Original weights
      real, intent(out) :: wall     !! Sum of weights
    end subroutine scawei
  end interface
  !
  interface
    subroutine sub_get_nbeams(uvin, visi, nvisi, nchan, weights, wcol)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER support routine for command  
      !     UV_CHECK BEAM
      !
      ! Get the sum of weights for each channel.  
      ! Verify it is constant, or just a global scale factor from one channel to 
      ! another, so that the relative weights are all the same. Noise variations
      ! due to e.g. Tsys or slightly different bandwidths (not accounted for in
      ! the data information) are irrelevant in the imaging process as only 
      ! relative weights as a function of time matter. 
      !
      ! Used implicitely by UV_MAP if not called before.
      !!
      !----------------------------------------------------------------------
      type(gildas), intent(in) :: uvin                  !! UV table header
      integer(kind=index_length), intent(in) :: nvisi   !! Number of visibilities
      integer, intent(in) :: nchan                      !! Number of channels 
      real, intent(in) :: visi(uvin%gil%dim(1),nvisi)    !! UV data
      real, intent(inout) :: weights(uvin%gil%nchan)    !! Cumulative weights
      integer, intent(inout) :: wcol                    !! non-null Weight Column
    end subroutine sub_get_nbeams
  end interface
  !
  interface
    subroutine howmany_beams(weights, nc, cases, ncase, tole) 
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support routine for command  
      !     UV_CHECK BEAM
      !
      ! Find out how many different sum of weights
      !!
      !----------------------------------------------------------------------
      integer, intent(in) :: nc                         !! Number of channels
      real, intent(in) :: weights(nc)                   !! Weight array
      integer, intent(inout) :: cases(nc)               !! Possible cases for beams
      integer, intent(inout) :: ncase                   !! Number of cases
      real, intent(in) :: tole                          !! Tolerance
    end subroutine howmany_beams
  end interface
  !
  interface
    subroutine t_continuum(hluv,hcuv,channels,chflag,uvcode,error,spindex,ofreq)
      use gildas_def
      use image_def
      use uvmap_def
      use gbl_message
      !$ use omp_lib
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER
      !   Support routine for UV_CONTINUUM 
      !
      !   Create a continuum UV table from a Line one
      !---------------------------------------------------------------------
      !
      type (gildas), intent(in) :: hluv       !! Line UV header
      type (gildas), intent(inout) :: hcuv    !! Continuum UV header
      integer, intent(in) :: channels(3)      !! Channel selection
      integer, intent(in) :: chflag(:)        !! Channel Flags
      integer, intent(in) :: uvcode           !! Type of UV data
      logical, intent(out) :: error           !! Logical error flag
      real, intent(in), optional :: spindex   !! Spectral index
      real(8), intent(in), optional :: ofreq  !! Reference Frequency
    end subroutine t_continuum
  end interface
  !
  interface
    subroutine t_channel_sampling(rname,huv,nident,msize)
      use image_def
      use clean_default
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER -- Support routine for continuum data
      !
      !   Check how many channels can share the same beam with a user
      !   specified accuracy
      !*
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname      !! Caller name
      type(gildas), intent(in) :: huv            !! UV data header
      integer, intent(out) :: nident             !! returned step
      integer, intent(in) :: msize               !! Current map_size
    end subroutine t_channel_sampling
  end interface
  !
  interface
    subroutine time_compress(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, fast, error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --- Support for UV_TIME
      !
      !   Time compress a UV table.
      !   Compute visibilities for a single output time
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out               !! Output UV header
      integer, intent(in) :: nd                     !! Visibility size
      real, intent(in) :: invisi(:,:)               !! Input visibilities
      integer, intent(in) :: wcol                   !! Weight column
      real, intent(inout) :: ovisi(:,:)             !! Output visibilities
      integer, intent(in) :: first, last            !! First and last input visibilities
      integer, intent(inout) :: jv                  !! Current output visibility number
      integer, intent(in) :: mvisi                  !! Maximum number of visibilities
      logical, intent(in) :: fast                   !! Fast parallel mode
      logical, intent(out) :: error                 !! Error flag
    end subroutine time_compress
  end interface
  !
  interface
    subroutine time_compress_fast(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER --- Support for UV_TIME
      !
      !   Time compress a UV table.
      !   Compute visibilities for a single output time
      !
      ! Parallelized version (does not gain much, though)
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out               !! Output UV header
      integer, intent(in) :: nd                     !! Visibility size
      real, intent(in) :: invisi(:,:)               !! Input visibilities
      integer, intent(in) :: wcol                   !! Weight column
      real, intent(inout) :: ovisi(:,:)             !! Output visibilities
      integer, intent(in) :: first, last            !! First and last input visibilities
      integer, intent(inout) :: jv                  !! Current output visibility number
      integer, intent(in) :: mvisi                  !! Maximum number of visibilities
      logical, intent(out) :: error                 !! Error flag
    end subroutine time_compress_fast
  end interface
  !
  interface
    subroutine time_compress_slow(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for UV_TIME
      !
      !   Time compress a UV table. 
      !   Compute visibilities for a single output time
      !
      ! Simple, "slow" version
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out               !! Output UV header
      integer, intent(in) :: nd                     !! Visibility size
      real, intent(in) :: invisi(:,:)               !! Input visibilities
      integer, intent(in) :: wcol                   !! Weight column
      real, intent(inout) :: ovisi(:,:)             !! Output visibilities
      integer, intent(in) :: first, last            !! First and last input visibilities
      integer, intent(inout) :: jv                  !! Current output visibility number
      integer, intent(in) :: mvisi                  !! Maximum number of visibilities
      logical, intent(out) :: error                 !! Error flag
    end subroutine time_compress_slow
  end interface
  !
  interface
    subroutine time_integrate(rname,huv,mytime,wcol,nu,nv,vin,vout,nvout,fast,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !! IMAGER -- Time-Average a UV data set
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname  !! Calling routine
      type(gildas), intent(in) :: huv        !! UV Header
      real(4), intent(in) :: mytime          !! Integration time
      integer, intent(in) :: wcol            !! Weight column
      integer, intent(in) :: nu              !! Size of a visibility
      integer, intent(in) :: nv              !! Number of input visibilities
      real, intent(in) :: vin(:,:)           !! input visibilities
      real, intent(inout) :: vout(:,:)       !! output visibilities
      integer, intent(out) :: nvout          !! Number of output visibilities
      logical, intent(in) :: fast            !! Parallel flag
      logical, intent(out) :: error          !! Error flag
    end subroutine time_integrate
  end interface
  !
  interface
    subroutine fit_parabola(n,x,y,a,b,c,d)
      !---------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -- generic tool
      !
      ! Find the characteristics of a parabola.
      ! Parabola definition y = a + b.x + c.x^2
      !---------------------------------------------------------------------
      integer, intent(in) :: n    !! Number of values
      real, intent(in) :: x(n)    !! X coordinates
      real, intent(in) :: y(n)    !! Y values
      real, intent(inout) :: a    !! Constant term
      real, intent(inout) :: b    !! Linear term
      real, intent(inout) :: c    !! Second order term
      real, intent(inout) :: d    !! rms of fit
    end subroutine fit_parabola
  end interface
  !
  interface
    subroutine clip_lineregions(rname,data,nchan,nhist,bval,eval,clip, &
      & debug,rms,noise_ratio)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -  Support for command UV_PREVIEW
      !
      !   Clip the possible "spectral line" regions, i.e. those
      ! that deviate from the median by a sufficient amount
      !!
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname             !! Caller name
      integer(kind=index_length), intent(in) :: nchan   !! Data size
      integer(kind=index_length), intent(in) :: nhist   !! Histogram size
      real, intent(inout) :: data(nchan)                !! Data to be clipped
      real, intent(in) :: bval, eval                    !! Blanking values to be used
      real, intent(in) :: clip                          !! Clipping level in Sigma
      logical, intent(in) :: debug                      !! Debug printout
      real, intent(in) :: rms                           !! Expected rms noise
      real, intent(in) :: noise_ratio                   !! Noise scaling factor
    end subroutine clip_lineregions
  end interface
  !
  interface
    subroutine guess_lineregions(data,nchan,bval,eval,mylines,nb)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      !     IMAGER  -- Support for UV_PREVIEW
      !
      !   Identify the edges of regions which consecutive channels
      ! that have been clipped (i.e. Blanked)
      !!
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: nchan   !! Data size
      real, intent(in) :: data(nchan)                   !! Blanked data 
      real, intent(in) :: bval, eval                    !! Blanking values to be used
      integer, intent(inout) :: mylines(nchan)          !! Line channel list
      integer, intent(inout) :: nb                      !! Number of line channels
    end subroutine guess_lineregions
  end interface
  !
  interface
    subroutine median_filter(temp,nchan,bval,eval,amed,amin,amax,arms,mu)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      !     IMAGER  -- Utility routine
      !
      !   Median filtering, returning Median, symmetric Min, Max and Rms 
      !!
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in) :: nchan !! Array size
      real, intent(inout) :: temp(nchan)    !! Data array  
      real, intent(in) :: bval              !! Blanking value
      real, intent(in) :: eval              !! Blanking tolerance
      real, intent(out) :: amed             !! Median
      real, intent(out) :: amin             !! Min
      real, intent(out) :: amax             !! Max
      real, intent(out) :: arms             !! Rms
      real, intent(in) :: mu                !! Rejection threshold
    end subroutine median_filter
  end interface
  !
  interface
    subroutine global_continuum(hmap,hcont,spectrum,error,box,mask)
      !$ use omp_lib
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      !   IMAGER -- Support for MAP_CONTINUUM
      !
      !   The method is to find a global set of windows (along 3rd axis)
      !   based on the mean spectrum in a selected region (defined by 
      !   a mask), and to compute the continuum as the average
      !   of the "line-free" channels outside of these windows.
      !
      !     The method uses a space-invariant spectral map. The error
      !   map of the derived continuum is thus constant. The method may
      !   fail to find weak continuum sources in fields which contain
      !   bright, spectrally confused, sources 
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hmap               !! Input line data cube
      type(gildas), intent(inout) :: hcont           !! Output continuum image
      real, intent(out) :: spectrum(:,:)             !! Output spectrum
      logical, intent(out) :: error                  !! Logical error flag
      integer(kind=4), intent(in) :: box(4)          !! Bounding box of mask
      logical, intent(in), optional :: mask(:,:)     !! Optional mask
    end subroutine global_continuum
  end interface
  !
  interface
    subroutine local_continuum(i_code,hmap,hcont,spectrum,error,rms,box,mask)
      !$ use omp_lib
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      !   IMAGER --  Support for command  
      !     MAP_CONTINUUM /METHOD GAUSS|SCM|c-SCM [Threshold]
      !
      !     Support routine to derive the continuum image, pixel per pixel
      !   The noise is no longer space-invariant, but the the_method is able to
      !   identify weak continuum sources in the presence of strong, spectrally
      !   confused sources.
      !
      !
      !   Several methods are available:  
      !   -  A Gaussian fitting the_method   
      !     This method is a variant of the Sigma Clipping Median, 
      !   that works if there is no strong confusion. It avoids re-computing
      !   median (a slow operation) by taking into account that in this
      !   case, the mean value can be found by fitting a parabola 
      !   in the histogram of the channel values. The fit is made stable
      !   against outliers by adjusting the Min Max of the histogram
      !   so that the parabolic fit converges. 
      !     This is the the_method used in UV_PREVIEW
      !   
      !   -  SCM and c-SCM (corrected Sigma Clipping Median), as in 
      !      the CASA plugin STATCONT
      !
      !   -  That of Jordan Mollet et al 2018  
      !     Fit an Exponentially modified Gaussian function
      !     to the Histogram of intensity values for all channels. Still not
      !     implemented, though.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: i_code           !! Code of the_method
      type(gildas), intent(in) :: hmap        !! Input line data cube
      type(gildas), intent(inout) :: hcont    !! Output continuum image
      real, intent(out) :: spectrum(:,:)      !! Output spectrum
      logical, intent(out) :: error           !! Logical error flag
      real, intent(in) :: rms                 !! Expected RMS (from theoretical noise)
      integer(kind=4), intent(in) :: box(4)   !! Bounding box of mask
      logical, intent(in), optional :: mask(:,:)    !! Optional mask
    end subroutine local_continuum
  end interface
  !
  interface
    subroutine uv_steps(visx, n1, nvx, q, nq, eff_dim,   &
         &    array,meter,flag,nsize)
      !------------------------------------------------------------------
      ! @ public 
      !* 
      ! IMAGER -- Utility routine
      !
      ! Define sampling steps for a UV Circular average 
      !------------------------------------------------------------------
      integer, intent(in) :: n1              !! Size of a visibility
      integer, intent(in) :: nvx             !! Number of a visibilities
      real, intent(in) :: visx(n1,nvx)       !! Visibilities
      integer, intent(in) :: nq              !! Number of radii
      real, intent(in) :: q(nq+1)            !! Radii
      integer, intent(out) :: eff_dim        !! Actual size of radial array
      integer, intent(in) :: nsize           !! Size of radial array
      integer, intent(out) :: array(nsize)   !! Cell value
      real, intent(inout) :: meter(nsize)    !! Cell position
      integer, intent(out) :: flag(nsize)    !! Is there any data ?
    end subroutine uv_steps
  end interface
  !
  interface
    subroutine uv_circle_average(n1, nvx, nc, visx, nq, visy, q, eff_dim,   &
         &    array, meter, nsize)
      !------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command UV_RADIAL
      !
      ! Compute the circular average of visibilities on the given sampling
      !!
      !------------------------------------------------------------------
      integer, intent(in) :: n1              !! Size of a visibility
      integer, intent(in) :: nvx             !! Number of a visibilities
      integer, intent(in) :: nc              !! Number of channels
      real, intent(in) :: visx(n1,nvx)       !! Visibilities
      integer, intent(in) :: nq              !! Number of radii
      real, intent(in) :: q(nq+1)            !! Radii
      integer, intent(in) :: eff_dim         !! Actual size of radial array
      real, intent(out) :: visy(n1, eff_dim) !! Output visibilities        !
      integer, intent(in) :: nsize           !! Size of radial array
      integer, intent(in) :: array(nsize)    !! Cell value
      real, intent(inout) :: meter(nsize)    !! Cell position
    end subroutine uv_circle_average
  end interface
  !
  interface
    subroutine shift_and_squeeze_uv(hin,hou,nvisi,xy,cs,cosi)
      use image_def
      !------------------------------------------------------------------
      ! @ public 
      !*
      ! IMAGER -- Support for UV_RADIAL
      !
      ! Apply a Phase shift to the data (in the previous frame)
      ! then rotate the frame (u,v) coordinates.
      !!
      !------------------------------------------------------------------
      type(gildas), intent(in)  :: hin    !! Input UV data 
      type(gildas), intent(inout) :: hou  !! Output UV data
      integer, intent(in) :: nvisi        !! Number of visibilities
      real, intent(in) :: xy(2)           !! Phase Shift
      real, intent(in) :: cs(2)           !! Cos/Sin of Rotation
      real, intent(in) :: cosi            !! Cos of inclination
    end subroutine shift_and_squeeze_uv
  end interface
  !
  interface
    subroutine do_apply_cal(ncol,nch,nvis,data,cal,gain,flag,index)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command SOLVE
      !
      !     Apply Gain Table to input UV data set
      !
      ! Index is the ordering of the gain. Gain(i) applies to Visi(Index(i))
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: ncol                     !! Visibility size
      integer, intent(in) :: nvis                     !! Number of visibilities
      integer, intent(in) :: nch                      !! Number of channels
      real, intent(in) :: data(ncol,nvis)             !! Raw data
      real, intent(out) :: cal(ncol,nvis)             !! Calibrated data
      real, intent(in) :: gain(10,nvis)               !! Gain array
      logical, intent(inout) :: flag                  !! Flag data with no solution
      integer, intent(in) :: index(nvis)              !! Visibility order
    end subroutine do_apply_cal
  end interface
  !
  interface
    subroutine do_ante_gain(do_amp,do_pha,nvis,times,tinteg,snr, &
      & basegain,antegain,refant,ntimes,nantes,smin,scal,flag,ilun,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command SOLVE
      !
      !   Compute complex gains (antenna-based solution) from a set
      !   of initial Antenna gains, smoothing in time as needed.
      !
      !   The initial Antenna gains must be sorted by increasing time
      !
      !     S.Guilloteau & V.Pietu, derived from R.Lucas CLIC code
      !!
      !---------------------------------------------------------------------
      logical, intent(in)  :: do_amp                !! Calibrate amplitude ?
      logical, intent(in)  :: do_pha                !! Calibrate phase ?
      integer, intent(in)  :: nvis                  !! Number of visibilities
      real(8), intent(in)  :: times(nvis)           !! Times of visibilities
      real, intent(in)  :: tinteg                   !! Integration time
      real, intent(in)  :: snr                      !! requested Signal to Noise 
      real, intent(in)  :: basegain(10,nvis)        !! Input baseline gain array
      real, intent(inout)  :: antegain(10,nvis)     !! Output antenna gain array
      integer, intent(in) :: refant                 !! Reference antenna
      integer, intent(out) :: ntimes                !! Number of time steps
      integer, intent(out) :: nantes                !! Number of antennas
      real, intent(in) :: smin                      !! Min SNR for de-biasing
      real, intent(in) :: scal                      !! Scale factor for SNR de-biasing 
      logical, intent(in) :: flag                   !! Flag wrong solutions ?
      integer, intent(in) :: ilun                   !! Logical Unit Number
      logical, intent(out) :: error                 !! In case nothing left ...
    end subroutine do_ante_gain
  end interface
  !
  interface
    subroutine do_base_gain(do_amp,do_pha,nvis,ncol,nchan,mchan,times, &
         &  index,data,model,gain)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command SOLVE
      !
      !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code  
      !     S.Guilloteau Nov-2024   Implement calibration from a Line UV table
      !
      !   Compute the Baseline-Based Gain by comparing the Data
      !   to the Model, retaining either Amplitude or Phase
      !   (or both, but this is not used by the calling routines so far)
      ! 
      !   This version applies to all available channels.
      !
      !   Model can be a Line data set, but Gain is a single-channel UV table.
      !
      !   Gain will contain the observed baseline gains, in an increasing 
      !   time order.
      !   Times is a Real(8) array to sort out date/time.
      !   Index is an integer array yielding the ordering
      !     gain(i) = data/model(Index(i))
      !!
      !---------------------------------------------------------------------
      logical, intent(in) :: do_amp                   !! Calibrate amplitude
      logical, intent(in) :: do_pha                   !! Calibrate phase
      integer, intent(in) :: nvis                     !! Number of visibilities
      integer, intent(in) :: ncol                     !! Size of a visibility
      integer, intent(in) :: nchan                    !! Number of data channels
      integer, intent(in) :: mchan                    !! Number of model channels  
      real(8), intent(out) :: times(nvis)             !! Time stamps of visibilities
      integer, intent(out) :: index(nvis)             !! Index of visibilities
      real, intent(in) :: data(ncol,nvis)             !! Raw visibilities
      real, intent(in) :: model(:,:)                  !! Modeled visibilities
      real, intent(out) :: gain(10,nvis)              !! Gain solution
    end subroutine do_base_gain
  end interface
  !
  interface
    subroutine gain_ant(iy,nbas,iant,jant,iref,nant,y,w,wk2,wk3,ss,c,wc,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command SOLVE
      !
      !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
      !
      !     computes a weighted least-squares approximation
      !     to the antenna amplitudes or phases
      !     for an arbitrary set of baseline data points.
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: iy                  !! 1 for log(amplitude), 2 for phase
      integer, intent(in) :: nbas                !! Number of baselines
      integer, intent(in) :: iant(nbas)          !! start antenna for each baseline
      integer, intent(in) :: jant(nbas)          !! end  antenna for each baseline
      integer, intent(in) :: iref                !! Reference antenna for phases
      integer, intent(in) :: nant                !! Number of antennas
      real(8), intent(in) :: y(nbas)             !! the data values
      real(8), intent(in) :: w(nbas)             !! weights
      real(8), intent(inout) :: wk2(nant,nant)   !! work space
      real(8), intent(inout) :: wk3(nant)        !! work space
      real(8), intent(out) :: ss(nbas)           !! rms of fit for each baseline
      real(8), intent(out) :: c(nant)            !! the antenna gains
      real(8), intent(out) :: wc(nant)           !! the weights
      logical, intent(out) :: error              !! Logical error flag
    end subroutine gain_ant
  end interface
  !
  interface
    subroutine do_get_cgain(ntimes,nantes,hsol,again,refant,scale_gain,ilun,error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !* 
      ! IMAGER -- Support for Command SOLVE
      !
      ! Prepare the Solution Table: Amplitude & Phase correction per antenna.
      !
      ! Convert the formatted temporary files to a Gildas Table
      !---------------------------------------------------------------------
      integer, intent(in) :: ntimes     !! Number of times
      integer, intent(in) :: nantes     !! Maximum number of antennas
      integer, intent(in) :: refant     !! Reference antenna
      type(gildas), intent(inout) :: hsol           !! Antenna Solution table
      real, allocatable, intent(out) :: again(:,:)  !! Antenna Solution array
      real, intent(out) :: scale_gain   !! Scaling Amplitude factor
      integer, intent(in) :: ilun       !! Logical Unit Number
      logical, intent(inout) :: error   !! Error flag
    end subroutine do_get_cgain
  end interface
  !
  interface
    subroutine do_uvmodel (visi,nt,nv,a,nx,ny,nf,   &
         &    freq,xinc,yinc,factor)
      !$ use omp_lib
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command MODEL    
      ! Compute the MODEL UV data set from the current CCT table
      !
      !     Uses an intermediate FFT with further interpolation for
      !     better speed than UV_CCT
      ! CAUTION  
      !     Frequency (and hence Lambda/D) is assumed constant 
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: nt                       !! Size of visibility
      integer, intent(in) :: nv                       !! Number of visibilities
      real, intent(inout) :: visi(nt,nv)              !! Visibilities
      integer, intent(in) :: nx                       !! X Size of image
      integer, intent(in) :: ny                       !! Y Size of image
      integer, intent(in) :: nf                       !! Number of frequencies
      complex, intent(in) :: a(nx,ny,nf)              !! Clean Component Image
      real(8), intent(in) :: freq                     !! Reference frequency
      real(8), intent(in) :: xinc                     !! X Pixel increment
      real(8), intent(in) :: yinc                     !! Y Pixel increment
      real, intent(in) :: factor                      !! Flux scale factor
    end subroutine do_uvmodel
  end interface
  !
  interface
    subroutine copyuv (nco,nv,out,nci,in)
      !---------------------------------------------------------------------
      ! @ public
      !
      !! IMAGER --  Copy structure of UV data, but not the (Real,Imag) columns
      !---------------------------------------------------------------------
      integer, intent(in)  :: nco                      !! Size of output visi.
      integer, intent(in)  :: nv                       !! Number of visibilities
      real, intent(out)  :: out(nco,nv)                !! Output Visibilities
      integer, intent(in) :: nci                       !! Size of input visi.
      real, intent(in)  :: in(nci,nv)                  !! Input visibilities
    end subroutine copyuv
  end interface
  !
  interface
    subroutine uvshort_trim_short(rname,huvl,duvl,change)
      use image_def
      use clean_arrays
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER -- Support for UV_SHORT
      !
      !     Remove all short spacing visibilities
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname     !! Caller name
      type(gildas), intent(inout) :: huvl       !! Visibility header
      real, intent(inout), target :: duvl(:,:)  !! Visibilities
      logical, intent(out) :: change            !! Data has changed
    end subroutine uvshort_trim_short
  end interface
  !
  interface
    subroutine do_sliceb(in, nx, ny, nc, x, y, out, np, blank, eblank)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support routine for command SLICE
      !
      !   Arbitrary slice in a 3-D data set, using bilinear interpolation
      !   Compute the slice, with blanking
      !!
      !---------------------------------------------------------------------  
      integer(kind=index_length), intent(in) :: nx    !! Number of X pixels
      integer(kind=index_length), intent(in) :: ny    !! Number of Y pixels
      integer(kind=index_length), intent(in) :: nc    !! Number of channels
      real, intent(in) :: in(nx,ny,nc)                !! Input cube
      integer :: np                                   !! Number of points
      real, intent(in) :: x(np)                       !! X coordinates
      real, intent(in) :: y(np)                       !! Y coordinates
      real, intent(out) :: out(np,nc)                 !! Output slice
      real, intent(in) :: blank                       !! Blanking
      real, intent(in) :: eblank                      !! and tolerance
    end subroutine do_sliceb
  end interface
  !
  interface
    subroutine parabola_3pt(x,y,aa,bb,cc) 
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine   
      !	Solve for Y = aa*x^2 + bb*x + cc with 3 points input data
      !!
      !----------------------------------------------------------------------
      real, intent(in) :: x(3)       !! X coordinates
      real, intent(in) :: y(3)       !! Y values
      real, intent(out) :: cc,bb,aa  !! Parabola coefficients
    end subroutine parabola_3pt
  end interface
  !
  interface
    subroutine resize_real_array(array,osize,nsize)
      !
      ! @ public-mandatory
      !! IMAGER - Utility routine to extend a REAL array
      !
      real, allocatable, intent(inout) :: array(:) !! Array to be resized
      integer, intent(in) :: osize    !! Old size
      integer, intent(in) :: nsize    !! New size
    end subroutine resize_real_array
  end interface
  !
  interface
    subroutine resize_inte_array(array,osize,nsize)
      !
      ! @ public-mandatory
      !! IMAGER - Utility routine to extend a INTEGER array
      !
      integer, allocatable, intent(inout) :: array(:) !! Array to be resized
      integer, intent(in) :: osize    !! Old size
      integer, intent(in) :: nsize    !! New size
    end subroutine resize_inte_array
  end interface
  !
  interface
    subroutine resize_dble_array(array,osize,nsize)
      !
      ! @ public-mandatory
      !! IMAGER - Utility routine to extend a DBLE array
      !
      real(8), allocatable, intent(inout) :: array(:) !! Array to be resized
      integer, intent(in) :: osize    !! Old size
      integer, intent(in) :: nsize    !! New size
    end subroutine resize_dble_array
  end interface
  !
  interface
    subroutine gdf_uvmatch_codes(a,b,code,ignore)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! GIO     Compare layout of UV tables for description columns  
      ! Code = 0    Same layout  
      ! Code = -1   Different layout  
      ! Code = 3    Similar layout, except that Col.3 is SCAN in one,
      !             and W in the other.
      !!
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: a       !! Input Header
      type(gildas), intent(in) :: b       !! Input Header
      integer, intent(out)     :: code    !! Returned code
      integer, intent(in) :: ignore       !! Which code_uvt is ignored ?
    end subroutine gdf_uvmatch_codes
  end interface
  !
  interface
    subroutine gdf_uvcolumn_codes(h,column_codes)
      use image_def
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! GIO     Return the column codes and sizes of the Leading and Trailing
      !         columns
      !!
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: h                !! Input header
      integer, intent(inout) :: column_codes(:,:)   !! Column codes
    end subroutine gdf_uvcolumn_codes
  end interface
  !
  interface
    subroutine s_uv_consistency(high,low,error,ier)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !* 
      ! IMAGER -- Support routine for command FEATHER
      !
      ! Verify data cube spatial consistencies
      !!
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: high          !! High resolution image
      type (gildas), intent(in) :: low           !! Low resolution image
      logical, intent(out) :: error              !! Logical Error flag
      integer, intent(out) :: ier                !! Error code number
    end subroutine s_uv_consistency
  end interface
  !
  interface
    subroutine s_uv_hybrid(high,low,all,uvradius,ratio,exponent,range,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Support for command FEATHER  
      !  Perform the feathering using the classical method.
      !
      !   Take HIGH map (high resolution map)  
      !   Take LOW  map (map with shortest spacings)  
      !   Make oversampled Fourier Transform of boths  
      !   Compute the truncation function f(r)  
      !   Make the Truncated compact Fourier Transform, f(r) x T(LOW)  
      !   Make the complement long baseline Fourier Transform, (1-f(r)) x T(HIGH)  
      !   Sum them T(ALL) = f(r) x T(LOW) + (1-f(r)) x T(HIGH)  
      !   Make the inverse Fourier Transform  
      !   Truncate the resulting image to original size and Mask  
      !!
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: high          !! High resolution image
      type (gildas), intent(in) :: low           !! Low resolution image
      type (gildas), intent(inout) :: all        !! Combined image
      real, intent(in) ::  uvradius              !! Transition radius (m)
      real, intent(in) ::  ratio                 !! Scale factor LOW / HIGH
      real, intent(in) ::  exponent              !! Sharpness of transition                
      real, intent(in) ::  range(2)              !! Range of overlap (m) 
      logical, intent(out) :: error              !! Logical Error flag
    end subroutine s_uv_hybrid
  end interface
  !
  interface
    subroutine setup_display
      use clean_def
      use clean_arrays
      use clean_default
      use clean_types
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Initialize the DISPLAY\ language associated variables
      !!
      !----------------------------------------------------------------------
      !
    end subroutine setup_display
  end interface
  !
  interface
    subroutine run_self (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Dispatching routine for Language CALIBRATE\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_self
  end interface
  !
  interface
    subroutine run_clean (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      use gkernel_types
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER   -- Dispatching routine for Language CLEAN\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_clean
  end interface
  !
  interface
    subroutine run_display (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      use gkernel_types
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER   -- Dispatching routine for Language DISPLAY\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_display
  end interface
  !
  interface
    subroutine run_advanced(line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Dispatching routine for Language ADVANCED\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_advanced
  end interface
  !
  interface
    subroutine run_bundles(line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Dispatching routine for Language BUNDLES\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_bundles
  end interface
  !
  interface
    subroutine run_imager (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      use gkernel_types
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Dispatching routine for Language IMAGER\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_imager
  end interface
  !
  interface
    subroutine run_simu (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      use gkernel_types
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  -- Dispatching routine for Language SIMULATE\
      !!
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line    !! Command line
      character(len=*), intent(in)    :: comm    !! Command name
      logical,          intent(out)   :: error   !! Logical error flag
    end subroutine run_simu
  end interface
  !
  interface
    subroutine load_display
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER & VIEWER --  Load DISPLAY\ Language
      !!
      !----------------------------------------------------------------------
    end subroutine load_display
  end interface
  !
  interface
    subroutine init_clean
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER  --  Load the Imager Languages:  
      !   CLEAN\        Basic imaging and deconvolution  
      !   CALIBRATE\    Calibration tools  
      !   ADVANCED\     Advanced processing  
      !   BUNDLES\      Integrated commands  
      !   IMAGER\       Pipeline related commands  
      !   SIMULATE\     Array simulator
      !!
      !----------------------------------------------------------------------
      use clean_def
      use clean_arrays
      use clean_default
      use clean_types
      use preview_mod
      !
    end subroutine init_clean
  end interface
  !
  interface
    subroutine greglib_pack_set(pack)
      !use greg_dependencies_interfaces
      !use greg_interfaces, except_this=>greglib_pack_set
      use gpack_def
      !----------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !*
      ! Public GREG package definition routine.  
      ! It defines package methods and dependencies to other packages.
      !!
      !----------------------------------------------------------------------
      type(gpack_info_t), intent(out) :: pack   !! Package info structure
    end subroutine greglib_pack_set
  end interface
  !
  interface
    subroutine do_object(coord,equinox,lambda,beta,s_2,s_3,dop,lsr,svec,x_0,  &
      parang,error)
      use gbl_message
      use ast_astro
      use ast_constant
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! ASTRO
      !
      !  Reduce coordinates of a fixed object
      !!
      !---------------------------------------------------------------------
      character(len=2), intent(in)    :: coord      !! Coordinate system
      real(kind=4),     intent(in)    :: equinox    !! Equinox (ignored if not EQ)
      real(kind=8),     intent(in)    :: lambda     !! Longitude like coordinate in Radian
      real(kind=8),     intent(in)    :: beta       !! Latitude like coordinate in Radian
      real(kind=8),     intent(out)   :: s_2(2)     !! Specified coordinates in Degree
      real(kind=8),     intent(out)   :: s_3(3)     !! ra, dec & distance of Sun at current epoch
      real(kind=8),     intent(out)   :: dop        !! Doppler velocity
      real(kind=8),     intent(out)   :: lsr        !! LSR velocity
      real(kind=8),     intent(out)   :: svec(3)    !! Direction vector
      real(kind=8),     intent(out)   :: x_0(3)   
      !!
      real(kind=8),     intent(out)   :: parang     !! Parallactic angle
      logical,          intent(inout) :: error      !! Logical error flag
    end subroutine do_object
  end interface
  !
  interface
    subroutine jjdate (tjj,date)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! ASTRO
      !
      !  Conversion d'une date julienne en date du calendrier gregorien
      !  from EPHAUT / BDL / ? / 82-1
      !
      !  modified 29 november 1984 by Michel Perault  
      !  en entree : TJJ date julienne (jours juliens)  
      !  en sortie : DATE date gregorienne (year, month, day, hour, minute, second)  
      !
      !  remarque  : le calcul couvre la periode julienne de l'an  
      !              4713 avant notre ere a l'an 3267 de notre ere.  
      !              les annees sont comptees en millesimes astronomiques  
      !              l'annee qui precede l'an 1 de notre ere est l'an 0  
      !              ex : l'an 80 avant notre ere a le millesime -79.  
      !  rappel    : la periode du 5 octobre 1582 0h au 14 octobre 1582  
      !              24 h n'existe pas
      !!
      !---------------------------------------------------------------------
      real(kind=8), intent(in) :: tjj  !! Julian Date (days)
      integer(kind=4), intent(out) :: date(7)  !! Gregorian date 
    end subroutine jjdate
  end interface
  !
  interface
    subroutine datejj (date,tjj)
      !---------------------------------------------------------------------
      ! @ public
      ! ASTRO
      !*
      !  ASTRO - Utility routine 
      !
      !  conversion d'une date du calendrier gregorien en date julienne
      !  from EPHAUT / BDL / ? / 82-1
      !
      !  modified 29 november 1984 by Michel Perault
      !
      !  en entree : DATE date gregorienne (year, month, day, hour, minute, second
      !		, millisecond)  
      !  en sortie : TJJ date julienne (jours juliens)
      !!
      !---------------------------------------------------------------------
      integer(kind=4), intent(in) :: date(7)        !! Gregorian date 
      !! D(year, month, day, hour, minute, second) 
      real(kind=8), intent(out) :: tjj              !! Julian Date (days)
    end subroutine datejj
  end interface
  !
  interface
    subroutine do_astro_time(jutc,jut1,jtdt,error)
      use gbl_message
      use ast_astro
      use ast_constant
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! ASTRO -- Ephemeris routine
      !
      !  Compute Earth rotation parameters and related quantities giving  
      !  - orientation of Earth rotation axis in space (i.e. precession and nutation)   
      !  - position angle around this axis (i.e. sidereal time)  
      !  - orientation of the CIO (Conventional International Origin) with respect  
      !	to the Celestial Ephemeris frame (i.e. pole motion)
      !
      !	Earth rotation velocity (J2000.0) = 7.2921151467e-5 rd/s
      !	see Aoki et al. (1982) or Astron. Almanach Suppl. (1984)
      !	if considered constant : error 1.e-8 (i.e. 0.01" after 24 hours)
      !!
      !---------------------------------------------------------------------
      real(kind=8), intent(in) :: jutc              !
      real(kind=8), intent(in) :: jut1              !
      real(kind=8), intent(in) :: jtdt              !
      logical, intent(inout) :: error               !
    end subroutine do_astro_time
  end interface
  !
  interface
    subroutine ephini(error)
      use gildas_def
      use gbl_format
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! ASTRO
      !
      ! Open direct access file of VSOP87 ephemeris.
      !
      !author: R. Lucas 29-apr-1994
      !!
      !---------------------------------------------------------------------
      logical, intent(out) :: error       !! Logical error flag
    end subroutine ephini
  end interface
  !
  interface
    subroutine ephclose(error)
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! ASTRO
      !
      ! Close the ephemeris file and free its logical unit
      !!
      !---------------------------------------------------------------------
      logical, intent(inout) :: error     !! Logical error flag
    end subroutine ephclose
  end interface
  !
  interface
    subroutine loadfiuv_id (visi,np,nv,dtr,it,sorted,idoff,rpv,nf,doff)
      use clean_arrays
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER    UV_MAP -- Mosaic SAULT sorting routines  
      !     Load field numbers into work arrays for sorting.
      !!
      !---------------------------------------------------------------------
      integer, intent(in)  :: np                     !! Size of a visibility
      integer, intent(in)  :: nv                     !! Number of visibilities
      real, intent(in) :: visi(np,nv)                !! Input visibilities
      real(8), intent(out) :: dtr(nv)                !! Output field number
      integer, intent(out) :: it(nv)                 !! Indexes
      logical, intent(out) :: sorted                 !! Is data sorted by Fields ?
      integer, intent(in)  :: idoff                  !! ID pointer
      real(4), intent(in)  :: rpv(nv)                !! V Values
      integer, intent(inout) :: nf                   !! Number of fields
      real(kind=4), intent(out) :: doff(:,:)         !! Fields offsets
    end subroutine loadfiuv_id
  end interface
  !
  interface
    function space_nitems(name,head,last)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !*
      ! IMAGER -- Utility routine
      !
      !   Returns the number of blocks in the last dimension
      !   according to the NAME logical name
      !!
      !--------------------------------------------------------------------- 
      character(len=*), intent(in) :: name  !! Caller name
      integer ::space_nitems           !! intent(out) function value
      type(gildas), intent(in) :: head !! Input Gildas header
      integer, intent(in) :: last      !! Last blocked dimension
    end function space_nitems
  end interface
  !
  interface
    subroutine get_i4list_fromsic(rname,line,opt,nf,list,error)
      use iso_c_binding
      use gkernel_types
      use gbl_message
      use gbl_format
      !
      ! @ public-mandatory
      !*
      !   SIC -- Utility routine
      !
      ! Return in the allocatable array the content of the 1-D
      ! SIC variable given as (first and only) argument of Option # opt.
      ! Return the size of the array in NF.
      ! If NF is non zero on entry, the size must match and the
      ! array is pre-allocated.
      !!
      character(len=*), intent(in) :: rname  !! Caller name
      character(len=*), intent(in) :: line   !! Command line
      integer, intent(in) :: opt             !! Option number
      integer, intent(inout) :: nf           !! Size of array. 
      !! If Zero on entry, automatic. If non zero, must match variable size.
      integer, allocatable, intent(inout) :: list(:)  !! List 
      logical, intent(out) :: error          !! Logical error flag
    end subroutine get_i4list_fromsic
  end interface
  !
  interface
    subroutine get_r4list_fromsic(rname,line,opt,nf,list,error)
      use iso_c_binding
      use gkernel_types
      use gbl_message
      use gbl_format
      !
      ! @ public-mandatory
      !*
      !   SIC -- Utility routine
      !
      ! Return in the allocatable array the content of the 1-D
      ! SIC variable given as (first and only) argument of Option # opt.
      ! Return the size of the array in NF.
      ! If NF is non zero on entry, the size must match and the
      ! array is pre-allocated.
      !!
      character(len=*), intent(in) :: rname  !! Caller name
      character(len=*), intent(in) :: line   !! Command line
      integer, intent(in) :: opt             !! Option number
      integer, intent(inout) :: nf           !! Size of array. 
      !! If Zero on entry, automatic. If non zero, must match variable size.
      real(kind=4), allocatable, intent(inout) :: list(:)  !! List 
      logical, intent(out) :: error  !! Logical error flag
    end subroutine get_r4list_fromsic
  end interface
  !
  interface
    subroutine gclean_major (rname,method,head,   &
         &    beam,nx,ny,mx,my,            &
         &    dirty,resid,mask,clean,      &
         &    cct_list,siter,miter,limit,niter, &
         &    ms, gauss, cc_scales, tfbeam, wfft,  &
         &    np, primary, weight, othread, iplane)    ! For mosaics
      use gbl_ansicodes
      use image_def
      use gbl_message
      use clean_def
      use clean_default
      use gclean_mod
      use omp_control
      !$  use omp_lib
      !-----------------------------------------------------------------------
      ! @ public-mandatory
      !*
      ! IMAGER -- CLEAN Method GAUSS  -- GCLEAN command  
      !     Multi-Resolution CLEAN - with NS (parameter) scales
      !
      !     Algorithm  
      !     For each iteration, search at which scale the signal to noise
      !     is largest. Use the strongest S/N to determine the "component"
      !     intensity and shape at this iteration.
      !
      !     Restore the ("infinite" resolution) image from the list of location
      !     types, and intensities of the "components"
      !
      !     The noise level at each scale is computed from the Fourier transform
      !     of the smoothed dirty beams, since the FT is the weight distribution
      !     and the noise level is the inverse square root of the sum of the
      !     weights.
      !!
      !-----------------------------------------------------------------------
      character(len=*), intent(in) :: rname     !! Caller name
      type(clean_par), intent(inout) :: method  !! Clean Method parameters
      type(gildas), intent(inout) :: head       !! Unused, but here for consistency...
      real, intent(in)  :: beam(:,:,:)          !! Dirty beams
      integer, intent(in)  :: nx,ny             !! Beam sizes
      integer, intent(in)  :: mx,my             !! Image size
      integer, intent(in) :: np                 !! Number of Pointings
      integer, intent(in)  :: siter             !! Starting Iteration
      integer, intent(in)  :: miter             !! Maximum number of clean components
      integer, intent(out) :: niter             !! Number of found components
      real, intent(in)  :: dirty(:,:)           !! Dirty image
      real, intent(inout) :: resid(:,:)         !! Residual image (initialized to Dirty image)
      real, intent(inout) :: clean(:,:)         !! "CLEAN" image (not convolved yet)
      real, intent(in) :: weight(:,:)           !! Combined weights
      integer, intent(in) :: ms                 !! Number of size scales
      real, intent(in) :: gauss(ms)             !! Size scales
      real, intent(out) :: cc_scales(ms)        !! Flux scaling factor ?
      logical, intent(in)  :: mask(:,:)         !! Search area
      real, intent(in)  :: limit                !! Maximum residual
      real, intent(in)  :: tfbeam(:,:,:)        !! Real Beam FT for final Clean restoration
      real, intent(inout) :: wfft(*)            !! Work space for FFT
      type(cct_lst), intent(inout) :: cct_list  !! Clean Component List
      real, intent(in) :: primary(np, mx, my)   !! Primary beams
      integer, intent(in) :: othread            !! Thread number (for messages and debugging)
      integer, intent(in) :: iplane             !! Current plane number (for messages and debugging)
    end subroutine gclean_major
  end interface
  !
  interface
    subroutine sub_uvamp(ncol,nvis,ndc,cal, gain, nant, iant, gains)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !*
      !   IMAGER -- Support routine for command AMPLITUDE
      !
      !   Apply Amplitude calibration factor to the "raw" UV data,
      !   for all or a list of antennas. 
      !!
      !---------------------------------------------------------------------
      integer, intent(in) :: ncol  !! Visibility size
      integer, intent(in) :: nvis  !! Number of visibilities
      integer, intent(in) :: ndc   !! Number of channels
      real, intent(inout) :: cal(ncol,nvis)  !! Calibrated visibilities
      real, intent(in) :: gain     !! Common gain
      integer, intent(in) :: nant  !! Number of specified antennas
      integer, intent(in) :: iant(:)  !! Antenna numbers
      real(4), intent(in) :: gains(:) !! Gains per antenna
    end subroutine sub_uvamp
  end interface
  !
end module imager_interfaces_public

module gcont_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GCONT interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gcont_interfaces_public
  use gcont_interfaces_private
  !
end module gcont_interfaces
!
module gcont_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GCONT dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
end module gcont_dependencies_interfaces

subroutine douvext(jc,nv,visi,jx,jy,umin,umax,vmin,vmax)
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Utility routine
  !
  !   Compute extrema of UV coverage. No assumption,
  !   but may return 0 if all Negative or all Positive
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: jc         !! Size of a visibility
  integer, intent(in) :: nv         !! Number of visibilities
  integer, intent(in) :: jx         !! X coordinate pointer
  integer, intent(in) :: jy         !! Y coordinate pointer
  real, intent(in) :: visi(jc,nv)   !! Visibilities
  real, intent(out) :: umin,umax    !! U extrema
  real, intent(out) :: vmin,vmax    !! V extrema
  !
  ! Local ---
  integer :: i
  !
  ! Code ----
  vmin = 0
  vmax = 0 
  umin = 0.0
  umax = 0.0
  do i=1,nv
    if (visi(jx,i).lt.umin) then
      umin = visi(jx,i)
    elseif  (visi(jx,i).gt.umax) then
      umax = visi(jx,i)
    endif
    if (visi(jy,i).lt.vmin) then
      vmin = visi(jy,i)
    elseif  (visi(jy,i).gt.vmax) then
      vmax = visi(jy,i)
    endif
  enddo
  if (-vmin.gt.vmax) then
    vmax = -vmin
  else
    vmin = -vmax
  endif
end subroutine douvext
!
subroutine uv_listheader(huv,visi,mt,tf,nt,freq)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, except_this => uv_listheader
  !-----------------------------------------------------
  ! @ private
  !*
  ! IMAGER - Utility routine
  !
  ! Give a brief summary of the content of an UV Table
  !!
  !-----------------------------------------------------
  type(gildas), intent(in) :: huv     !! UV header
  integer, intent(in) :: mt           !! Maximum number of dates
  integer, intent(out) :: nt          !! Number of dates
  integer, intent(out) :: tf(mt)      !! Dates (in Gildas code)
  real(4), intent(in) :: visi(huv%gil%dim(1),huv%gil%dim(2))   !! Visibilities
  real(8), intent(in) :: freq         !! Observing frequency
  !
  ! Local ---
  character(len=14) :: ch
  logical error
  integer jt,ti,i,j
  integer(kind=index_length) :: iv
  integer count(mt)
  real :: mintim(mt), maxtim(mt)
  real bmin(mt), bmax(mt), base, scale
  character(len=message_length) :: chain
  real(8) :: rti
  integer(4) :: iant, jant, ia, ja, nant
  integer(4) :: ka(-1:256),la(-1:256)
  !
  ! Code ----
  call map_message(seve%r,'HEADER','Summary of observations')
  scale = freq/299792458.d-6*1e-3
  write(chain,'(I6,A,I2,A,A,F13.3,A)') huv%gil%nchan,' Channels, ', &
    &   huv%gil%nstokes,' Stokes, ','  Rest Frequency ',freq,' MHz'
  call map_message(seve%r,'HEADER',chain)
  !
  nt = 0
  tf(:) = 0
  bmin(:) = 1E20
  bmax(:) = 0
  iant = 257
  jant = 0
  nant = 0
  ka = 0
  la = 0
  !
  do iv=1,huv%gil%nvisi
    rti = dble(visi(4,iv))+dble(visi(5,iv))/86400.0d0
    if (rti.ge.0) then
      ti = int(rti)
    else
      ti = int(rti)-1
    endif
    !
    jt = 0
    do j=1,nt
      if (ti.eq.tf(j)) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      if (nt.gt.mt) return
      nt = nt+1
      tf(nt) = ti
      count(nt) = 1
      mintim(nt) = rti-ti
      maxtim(nt) = rti-ti
      jt = nt
    else
      count(jt) = count(jt)+1
      mintim(jt) = min(rti-ti,mintim(jt))
      maxtim(nt) = max(rti-ti,maxtim(jt))
    endif
    !
    ! Build the antenna pointer list
    ia = nint(visi(6,iv))
    if (ia.ne.0) then
      if (la(ia).eq.0) then
      nant = nant+1
      la(ia) = nant
      ka(nant) = ia
      endif
    endif
    ja = nint(visi(7,iv))
    if (ja.ne.0) then
      if (la(ja).eq.0) then
        nant = nant+1
        la(ja) = nant
        ka(nant) = ja
      endif
    endif
    if (ia.ne.0 .and. ja.ne.0) then
      iant = min(iant,ia,ja)
      jant = max(jant,ia,ja)
      !
      ! Valid antenna : compute baseline length
      base = visi(1,iv)**2+visi(2,iv)**2
      bmin(jt) = min(base,bmin(jt))
      bmax(jt) = max(base,bmax(jt))
    endif
  enddo
  !
  ! Go to baseline
  bmin = sqrt(bmin)
  bmax = sqrt(bmax)
  !
  mintim(1:nt) = mintim(1:nt)*24.0
  maxtim(1:nt) = maxtim(1:nt)*24.0
  !
  if (huv%gil%version_uv .ge. code_version_uvt_syst) then
    call map_message(seve%r,'HEADER','Has fine Doppler correction')
  else if (huv%gil%version_uv .eq. code_version_uvt_freq) then
    call map_message(seve%r,'HEADER','Has no Doppler information')
  else if (huv%gil%version_uv .eq. code_version_uvt_dopp) then
    call map_message(seve%r,'HEADER','Has coarse Doppler information')
  endif
  call map_message(seve%r,'HEADER', &
       & '   Dates -       Times     Visibilities      Minimun    & Maximum Baselines')
  call map_message(seve%r,'HEADER', &
       & '                  (hr)                       (m)  (kWave)    (m)    (kWave)')
  do i=1,nt
    call gag_todate(tf(i),ch,error)
    write(chain,100) ch,mintim(i),maxtim(i),count(i),bmin(i),bmin(i)*scale,bmax(i),bmax(i)*scale
    call map_message(seve%r,'HEADER',chain)
  enddo
  write(chain,'(I4,A,I4,I4)') nant, ' Antennas,  in range ',iant,jant
  call map_message(seve%r,'HEADER',chain)
  write(*,'(20I4)') ka(1:nant)
100 format (1X,A,F6.2,F6.2,I12,3X,F7.1,1x,F7.1,2X,F8.1,1X,F7.1)
end subroutine uv_listheader
!
!<FF>
subroutine uniform_beam (uv_taper,map_size,map_cell,   &
        &    uniform,wcol,mcol,error,mode,                 &
        &    beams,mbeam,start,step,uvmax,result,huvl,duvl)
  use imager_interfaces, except_this=>uniform_beam
  use gildas_def
  use image_def
  use clean_def
  use gbl_message
  use gkernel_interfaces
  use omp_control
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for command UV_STAT 
  !
  !     Compute dirty beams from a UV Table by Gridding and Fast Fourier 
  !   Transform, with one single beam for all channels.
  !!
  !------------------------------------------------------------------------
  type(gildas), intent(in) :: huvl                !! UV Table Header
  real, intent(inout) :: duvl(:,:)                !! Visibility Array
  character(len=*), intent(in) :: mode            !! Mode of statistics
  real, intent(in) :: uv_taper(3)                 !! UV Taper
  integer, intent(in) :: map_size(2)              !! Number of pixels
  real, intent(in) :: map_cell(2)                 !! Pixel size
  real, intent(in) :: uniform(2)                  !! Robust parameter
  integer, intent(inout) :: wcol                  !! Weight column
  integer, intent(inout) :: mcol(2)               !! Channel range
  integer, intent(in) :: mbeam                    !! Number of beams
  logical :: error                    !! Logical Error flag
  real, intent(out) :: beams(map_size(1),map_size(2),mbeam)  !! Beam array
  real, intent(inout) :: start        !! Starting value for range
  real, intent(inout) :: step         !! Step for range
  real, intent(in) :: uvmax           !! Max UV distance
  real, intent(out) :: result(:,:)    !! Resulting beam characteristics
  !
  ! Constants
  character(len=7) :: rname = 'UV_STAT'
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: clight=299792458d-6  ! Frequency in MHz
  integer, parameter :: muni=18   ! Do not change
  !
  ! Local ---
  integer :: inner_threads, kthread
  logical :: omp_nested
  type (gridding) :: conv
  integer ctype               ! Convolution mode, local value
  real(8) freq,convert(6)
  integer nx,ny,nc,nd,lx,ly,nu,nv
  integer ctypx,ctypy,fcol
  real uv_cell(2)
  real xparm(10),yparm(10),support(2)
  real vref,voff,vinc,lambda
  integer ndim, nn(2), i, j
  real, allocatable :: ipxc(:), ipyc(:)
  real, allocatable :: ipw(:,:), ipv(:), ipg(:)
  complex, allocatable :: ipf(:)
  complex, allocatable :: ipft(:)
  real, allocatable :: wfft(:)
  integer :: ier
  !
  integer :: nuni
  real wnat, noise, mn, vunif
  integer ix_patch, iy_patch, icol, ib
  real(4) major_axis(muni), minor_axis(muni), pos_angle(muni), knoise(muni)
  real(4) sidelobe(2,muni), utaper(muni), unif(muni), wuni(muni), ouni(muni)
  integer :: idx(muni)
  real(4) sec,zero(3),thre,rms,rmk
  character(len=8) chain(muni)
  character(len=32) unit
  character(len=10) jyunit
  character(len=16) kunit
  character(len=message_length) string
  !
  real cpu0,cpu1,pixel_per_beam,bmax
  !
  data zero/3*0/
  data pixel_per_beam /2.0/
  !
  ! Code ---
  call gag_cpu(cpu0)
  xparm(1:10) = 0
  yparm(1:10) = 0
  !
  select case (mode)
  case ('TAPER') 
    if (step.eq.0.0) step = sqrt(2.0)
    if (start.eq.0.0) start = 50.0
  case ('WEIGHT','ROBUST')
    if (step.eq.0.0) step = 10.0**0.25
    if (start.eq.0.0) start = 1.0/step**4
  case ('CELL' ) 
    if (step.eq.0.0) step = sqrt(2.0)
    if (start.eq.0.0) start = uniform(1)/step**4
    if (start.eq.0.0) start = 7.5/step**4 ! NOEMA default    
  case ('BRIGGS') 
    continue
  case default
    string = 'Unsupported mode '//mode
    call map_message(seve%e,rname,string)
    error = .true.
    return
  end select
  !
  nx = map_size(1)
  ny = map_size(2)
  nd = nx*ny
  nu = huvl%gil%dim(1)
  nv = huvl%gil%nvisi   !! NOT huvl%gil%dim(2)
  if (nv.ne.huvl%gil%nvisi) then
    call map_message(seve%e,rname,'more than 2^32 visibilities')
    error = .true.
    return
  endif
  !
  ! This must be a patch for some old stuff
  if (huvl%gil%dim(1).ne.3) then
    nc = huvl%gil%nchan
  else
    nc = 1
  endif
  if (nv.gt.10E6) then
    write(string,'(A,F12.6,A,I0,A)') 'Found ',nv*1D-6, ' Mega-Visibilities, ',nc,' channels'
  else if (nv.gt.10E3) then
    write(string,'(A,F9.3,A,I0,A)') 'Found ',nv*1D-3, ' kilo-Visibilities, ',nc,' channels'
  else
    write(string,'(A,I0,A,I0,A)') 'Found ',nv,' Visibilities, ',nc,' channels'
  endif
  call map_message(seve%i,rname,string)
  if (nv.eq.0) return ! Just in case
  !
  ! Get work space at once, for memory contiguity reasons.
  !
  nuni = 10
  if (mode.eq.'WEIGHT') nuni = muni
  !
  allocate (ipxc(nx),ipyc(ny),ipw(nv,nuni),ipg(nd),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  vref = huvl%gil%convert(1,1)
  voff = huvl%gil%voff
  vinc = huvl%gil%vres
  !
  call uv_get_cols(rname,huvl,duvl,nc,mcol,wcol, fcol, freq, error)
  if (error) return
  !
  icol = fcol*3+7 ! Convert Channel number to Column pointer
  !
  ! Compute gridding function
  ctype = 1                    ! Force it for the FAST gridding.
  ctypx = ctype
  ctypy = ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  uv_cell(1) = clight/freq/(map_cell(1)*map_size(1))
  uv_cell(2) = clight/freq/(map_cell(2)*map_size(2))
  support(1) = xparm(1)*uv_cell(1) ! In meters
  support(2) = yparm(1)*uv_cell(2)
  !
  lx = (uvmax+support(1))/uv_cell(1) + 2
  ly = (uvmax+support(2))/uv_cell(2) + 2
  lx = 2*lx
  ly = 2*ly
  call docoor (lx,-uv_cell(1),ipxc) 
  call docoor (ly,uv_cell(2),ipyc) 
  !
  if (wcol.ge.0) call dodate (nu,nv,duvl,4,5)
  !
  call gag_cpu(cpu1)
  write(string,102) 'Start Weighting ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! This is a non-Parallel Section, set Outer Thread Nesting to (1)
  ! and inner to (Max)
  !$ kthread = 1      
  !$ inner_threads = omp_get_max_threads()
  !$ call ompset_thread_nesting(rname, kthread, inner_threads, omp_nested)
  !
  ! Compute weights
  wuni = 0.
  select case(mode)
  case ('TAPER')
    wuni(1) = uniform(2)
    utaper(1) = start
    do i=2,nuni-1
      utaper(i) = utaper(i-1)*step
    enddo
    utaper(nuni) = 0.0
    call do3weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat)
     ouni(1:nuni) = utaper(1:nuni)
  case ('ROBUST')
    unif(1) = start
    unif(nuni) = 0.0
    do i = 2,nuni-1
      unif(i) = unif(i-1)*step
    enddo
    wuni(1:nuni) = unif(1:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat)
     ouni(1:nuni) = unif(1:nuni)
  case ('BRIGGS')
    do i = 1,nuni
      unif(i) = -4.0+(i-1)*0.50 !! nuni)/(nuni-1)
    enddo
    unif(nuni) = 0.0
    wuni(1:nuni) = unif(1:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat)
     ouni(1:nuni) = unif(1:nuni)
  case ('WEIGHT')
    nuni = 10
    unif(1) = start
    do i = 2,nuni-1
      unif(i) = unif(i-1)*step
    enddo
    unif(nuni) = 0.0
    wuni(1:nuni) = unif(1:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat)
    !
    do i = nuni+1,muni
      unif(i) = -(muni-i+1)*0.50 
    enddo
    !
    vunif = 2*uniform(1) ! This is the convention
    wuni(nuni+1:muni) = unif(nuni+1:muni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      vunif,        &    ! Uniform UV cell size
     &      ipw(:,nuni+1:muni),             &    ! Weight array
     &      wuni(nuni+1:muni),muni-nuni,    &    ! Fraction of weight
     &      utaper,wnat)
     !
     nuni = muni
  case ('CELL')
    if (uniform(2).eq.0) then
      call map_message(seve%e,rname,'Null MAP_ROBUST factor, cannot use MAP_UVCELL')
      error = .true.
      return
    endif
    unif(1) = start
    do i = 2,nuni
      unif(i) = unif(i-1)*step
    enddo
    wuni(1) = uniform(2)
    wuni(2:nuni) = unif(2:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do4weig (nu,nv,  &
     &      duvl,         &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      unif,         &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat)
     ouni(1:nuni) = unif(1:nuni)
  case default 
    call map_message(seve%e,rname,'Invalid mode '//mode)
    error = .true.
    return
  end select
  call gag_cpu(cpu1)
  write(string,102) 'Finished Weighting ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  if (wnat.eq.0.0) then
    write(string,101) 'Plane ',fcol,' has Zero weight'
    call map_message(seve%e,rname,string)
    deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
    error = .true.
    return
  endif
  !
  noise = 1e-3/sqrt(wnat)
  call prnoise(rname,'Natural',noise,rms)
  !
  ! Get FFTs work space
  allocate (ipft(lx*ly*nuni),ipf(nx*ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
    error = .true.
    return
  endif
  !
  ! Compute FFTs
  call do2fft (nu,nv,   &      ! Size of visibility array
     &    duvl,         &      ! Visibilities
     &    1,2,          &      ! U, V pointers
     &    lx,ly,nuni,   &      ! Cube size
     &    ipft,         &      ! FFT cube
     &    ipxc, ipyc,   &      ! U and V grid coordinates
     &    ipw)                 ! Weight array 
  call gag_cpu(cpu1)
  write(string,102) 'Finished Gridding ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! Make beam, not normalized
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ipf,nn,ndim,-1,1)
  deallocate(ipf)
  !
  convert = (/dble(nx/2+1),0.d0,-dble(map_cell(1)),   &
     &    dble(ny/2+1),0.d0,dble(map_cell(2))/)
  !
  ! No grid correction 
  !
  !NOGRID!  call grdtab (ny, conv%vbuff, conv%vbias, ipxc)
  !NOGRID!  call grdtab (nx, conv%ubuff, conv%ubias, ipyc)
  !
  ! Loop on Uniform parameters
  ipw(:,:) = max(0.0,ipw) ! Flagged data have negative weights
  !
  !$OMP PARALLEL if (mbeam.ge.nuni) DEFAULT(NONE) &
  !$OMP SHARED(nv,nuni,mbeam,nx,ny,lx,ly,nn,ndim, ipft,ipw, beams,wuni,sidelobe) &
  !$OMP SHARED(major_axis, minor_axis, pos_angle, ix_patch, iy_patch, convert) &
  !$OMP PRIVATE(i,ib,bmax, ier,ipf,wfft, thre,error)
  allocate(ipf(nx*ny),wfft(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    Print *,'F-UV_STAT, Memory allocation failure in thread '
    read(*,*) ier
  endif
  !$OMP DO
  do i = 1,nuni
    ib = min(i,mbeam)
    call extracs(nuni,nx,ny,i,ipft,ipf,lx,ly)
    call fourt  (ipf,nn,ndim,-1,1,wfft)
    call cmtore (ipf,beams(1,1,ib),nx,ny)
    !NOGRID!    call dogrid (ipg,ipxc,ipyc,nx,ny,beams(1,1,ib))
    !
    ! Normalize and Free beam
    !NOGRID!    call docorr (beams(1,1,ib),ipg,nd)
    bmax = beams(nx/2+1,ny/2+1,ib)
    beams(:,:,ib) = beams(:,:,ib)/bmax
    !
    ! Get noise & Sidelobes
    wuni(i) = sum(ipw(1:nv,i))
    sidelobe(1,i) = minval(beams(:,:,ib)) !! minimum(nd,beams(1,1,ib))
    thre = max(min(abs(-1.5*sidelobe(1,i)),0.7),0.3)
    !
    ! Fit beam
    ix_patch = nx/2
    iy_patch = ny/2
    major_axis(i) = 0.
    minor_axis(i) = 0.
    pos_angle(i) = 0.
    !$OMP CRITICAL
    ! FIBEAM is not easily re-entrant, so No parallelism here
    ! Print *,'Calling FIBEAM'
    call fibeam (' ',beams(1,1,ib),nx,ny,   &
     &      ix_patch,iy_patch,thre,   &
     &      major_axis(i),minor_axis(i),pos_angle(i),   &
     &      convert,error)
    !$OMP END CRITICAL
    !
    ! Subtract main beam
    ! Print *,'Calling SIDELO'
    call sidelo (beams(1,1,ib),nx,ny,sidelobe(1,i),   &
     &      major_axis(i),minor_axis(i),pos_angle(i),   &
     &      convert)
    !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  call gag_cpu(cpu1)
  write(string,102) 'Finished FFTs ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! Delete scratch space
  deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
  deallocate (ipf,ipft,stat=ier)
  !
  ! Printout results
  sec = 180.*3600./pi
  lambda =  clight/freq
  call gagout(' ')
  ! Define the unit for Flux density
  if (rms.le.2.0) then
    jyunit = '(Jy)      '
  else if (rms.le.2e3) then
    jyunit = '(mJy)     '
  else
    jyunit = '(microJy) '
  endif
  rms = rms*1e-3 ! As frequencies are in MHz
  !
  ! Define the scale factor for
  knoise(1:nuni) = sqrt(1.0/wuni(1:nuni))*lambda**2*4*log(2.0)*1e-3/ &
     &      (2.0*1.38e3*major_axis(1:nuni)*minor_axis(1:nuni)*pi)
  rmk = sqrt(minval(knoise(1:nuni))*maxval(knoise(1:nuni)))
  !
  if (rmk.gt.0.05) then
    rmk = 1
    kunit = ' (K)        % '
  elseif (rmk.gt.0.1e-3) then
    rmk = 1e3
    kunit = '(mK)        % '
  else
    rmk = 1e6
    kunit = '(microK)    % '
  endif
  unit = jyunit//kunit
  !
  if (mode.eq.'TAPER') then
    call gagout('  Taper      Major    Minor     PA            Noise      Sidelobe')
    call gagout('   (m)        (")      (")     (deg)     '//unit)
    do i=1,nuni-1
      write(chain(i),'(F8.1)') utaper(i)
    enddo
    chain(nuni) = '  None'
  elseif  (mode.eq.'CELL') then
    call gagout('  Cell       Major    Minor     PA            Noise      Sidelobe')
    call gagout('   (m)        (")      (")     (deg)     '//unit)
    chain(1) = ' None 0.'
    do i=2,nuni
      write(chain(i),106) unif(i)
    enddo
  elseif  ((mode.eq.'WEIGHT').or.(mode.eq.'ROBUST')) then
    call gagout(' Robust      Major    Minor     PA            Noise      Sidelobe')
    call gagout('              (")      (")     (deg)     '//unit)
    do i=1,nuni
      write(chain(i),106) unif(i)
      if (unif(i).eq.0) chain(i) = ' None 0.'
    enddo
  elseif  (mode.eq.'BRIGGS') then
    call gagout(' Briggs      Major    Minor     PA            Noise      Sidelobe')
    call gagout('              (")      (")     (deg)      '//unit)
    do i=1,nuni-1
      write(chain(i),106) unif(i)
    enddo
    chain(nuni) = ' None 0.'
  endif
  !
  ! Sort by increasing values of unif()
  do i=1,nuni
    idx(i) = i
  enddo
  if (nuni.eq.muni) then
    do i=1,muni
      if (unif(i).gt.0) then
        ouni(i) = 1./unif(i)
      else
        ouni(i) = unif(i)
      endif
    enddo
    call gr4_trie(ouni,idx,nuni,error)
  else
    unif(1:nuni) = ouni(1:nuni)
  endif
  !
  do j=1,nuni
    i = idx(j)
    write(string,105) chain(i),major_axis(i)*sec,minor_axis(i)*sec   &
     &      ,pos_angle(i),sqrt(1.0/wuni(i))*rms,knoise(i)*rmk &
     &      ,sidelobe(1,i)*100.0,sidelobe(2,i)*100.0
    call gagout(string)
    result(j,1) = unif(i)
    result(j,2) = major_axis(i)*sec
    result(j,3) = minor_axis(i)*sec
    result(j,4) = pos_angle(i)
    result(j,5) = sqrt(1.0/wuni(i))*1e-3
    result(j,6) = knoise(i)
    result(j,7) = sidelobe(1,i)*100.0
    result(j,8) = sidelobe(2,i)*100.0
    result(i,9) = j
  enddo
  call gagout(' ')
  !
  ! Recommend pixel size
  mn = minor_axis(1)
  do i=2,nuni
    mn = min(mn,minor_axis(i))
  enddo
  if (mn.ge.0.1*sec) then
    mn = 0.02*nint(50.0*mn*sec/pixel_per_beam)
  else
    mn = 0.002*nint(500.0*mn*sec/pixel_per_beam)
  endif
  write(string,107) map_cell(1)*sec, mn
  call map_message(seve%i,rname,string)
  error = .false.
  return
  !
  101   format(a,i6,a)
  102   format(a,f9.3,a)
  105   format(a,1x,f9.3,f9.3,f9.1,1x,f9.2,f9.2,1x,f6.1,f6.1)
  106   format(f8.2)
  107   format('Recommended pixel size is ',f6.3,' - ',f6.3,'"')
end subroutine uniform_beam
!
subroutine do2weig (jc,nv,visi,jx,jy,iw,unif,we,wm,nw,taper,s)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => do2weig
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_STAT
  !
  !   Compute weights of the visibility points.
  !   Explore here the robust parameters.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: jc    !! Size of a visibility
  integer, intent(in) :: nv    !! Number of visibilities
  integer, intent(in) :: jx    !! X coordinate pointer
  integer, intent(in) :: jy    !! Y coordinate pointer
  integer, intent(in) :: iw    !! Weight pointer
  integer, intent(in) :: nw    !! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)    !! Visibilities
  real, intent(in) :: unif           !! Cell size in meters
  real, intent(out) :: we(nv,nw)     !! Weight arrays
  real, intent(inout) :: wm(nw)      !! on input: robust factors
  real, intent(in) :: taper(3)       !! Taper
  real, intent(out) :: s             !! Sum of weights (natural noise)
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='DO2WEIG'
  !
  ! Local ---
  real ss(nw),s2(nw),uw(nw)       ! Small automatic arrays
  integer i,kw
  real u,v
  real cx,sx,cy,sy,staper
  real ww,st,u2
  logical do_taper, briggs
  real umin,umax,vmin,vmax
  real wfact
  !
  ! GILDAS robust parameter ranges from [0,infty] (in practice 10)
  briggs = wm(1).lt.0   ! Briggs parameters range from [-4,0] 
  ! re-mapped to true Briggs by shifting in the [-2,2] range
  !
  ! Natural weights
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,nw) = visi(iw,i)
      s = s+we(i,nw)
    else
      we(i,nw) = 0.0
    endif
  enddo
  if (s.eq.0) return
  !
  ! Define taper
  staper = taper(3)*pi/180.0
  do_taper = .false.
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
    do_taper = .true.
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
    do_taper = .true.
  else
    cy = 0.0
    sx = 0.0
  endif
  !
  ! 1) Compute VMIN, VMAX, UMIN, UMAX
  call douvext(jc,nv,visi,jx,jy,umin,umax,vmin,vmax)
  !
  call do0weig(jc,nv,visi,jx,jy,iw,unif,we(1,nw))
  !
  ! Define robustness - generic
  call dowfact (nv,we(:,nw),wfact)
  !
  ! Apply robustness
  do kw=1,nw-1
    ss(kw) = 0.0
    s2(kw) = 0.0
  enddo
  ss(nw) = 1.0
  s2(nw) = 1.0
  !
  if (briggs) then
    ! s = 5*10^(-Briggs)  with (typically) -2 < Briggs < 2
    ! Here we use an input range [-4,0] so shift by 2
    do kw=1,nw-1
      u2  = 5*10**(-(2+wm(kw)))    ! s
      u2 = u2*u2                   ! s^2
      uw(kw) = u2/wfact
    enddo
  else
    do kw=1,nw-1
      uw(kw) = wm(kw)*wfact
    enddo
  endif
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP SHARED(nv,do_taper,briggs,cx,cy,sx,sy, jx,jy,iw,nw) &
  !$OMP SHARED(we, visi, uw) REDUCTION(+:ss,s2) &
  !$OMP PRIVATE(i, kw, ww,staper,st, u,v)
  !$OMP DO
  do i=1,nv
    ww = we(i,nw)
    if (do_taper) then
      v = visi(jy,i)
      u = visi(jx,i)
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    else
      staper = 1.0
    endif
    !
    ! Get the natural weighting correct now
    if (ww.le.0.0) then
      we(i,1:nw) = 0.0
    else
      we(i,nw) = staper*visi(iw,i)
      !
      ! Compute the new weights
      if (briggs) then
        ! Briggs way
        do kw=1,nw-1
          !
          st = staper/(uw(kw)*ww+1.0)
          we(i,kw) = visi(iw,i)*st
          ss(kw) = ss(kw) + we(i,kw)
          s2(kw) = s2(kw) + we(i,kw)*st
        enddo
      else
        ! GILDAS way
        do kw=1,nw-1
          if (ww.gt.uw(kw)) then
            st = staper/ww*uw(kw)
          else
            st = staper
          endif
          we(i,kw) = visi(iw,i)*st
          ss(kw) = ss(kw) + we(i,kw)
          s2(kw) = s2(kw) + we(i,kw)*st
        enddo
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Renormalize weights to get proper noise
  do kw=1,nw-1
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st*we(i,kw)
    enddo
  enddo
end subroutine do2weig
!
subroutine do3weig (jc,nv,visi,jx,jy,iw,cunif,we,cwm,nw,taper,s)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => do3weig
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_STAT 
  !
  !   Compute weights of the visibility points.
  !   TAPER mode
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: jc    !! Size of a visibility
  integer, intent(in) :: nv    !! Number of visibilities
  integer, intent(in) :: jx    !! X coordinate pointer
  integer, intent(in) :: jy    !! Y coordinate pointer
  integer, intent(in) :: iw    !! Weight pointer
  integer, intent(in) :: nw    !! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)    !! Visibilities
  real, intent(in) :: cunif(1)       !! Cell size in meters
  real, intent(out) :: we(nv,nw)     !! Weight arrays
  real, intent(in) :: cwm(1)         !! on input: robust factors
  real, intent(in) :: taper(nw)      !! Tapers
  real, intent(out) :: s             !! Sum of weights (natural noise)
  !
  character(len=*), parameter :: rname='DO3WEIG'
  !
  ! Local ---
  integer i,kw
  real u,v,weight,wfact,unif,wm
  real staper
  real ss(10),s2(10),ww,st
  !
  ! Code ----
  !
  ! Natural weights
  unif = cunif(1)
  wm = cwm(1)
  !
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,nw) = visi(iw,i)
      s = s+we(i,nw)
    else
      we(i,nw) = 0.0
    endif
  enddo
  if (s.eq.0) return
  !
  if (unif*wm.ne.0.0) then
    !
    call do0weig (jc,nv,visi,jx,jy,iw,unif,we(1,nw))
    !
    ! Define robustness
    call dowfact(nv,we(:,nw),wfact)
    weight = wm*sqrt(wfact)
  else
    weight = 0.0
    do i=1,nv
      weight = max(weight,we(i,nw))
    enddo
  endif
  !
  ! Apply robustness
  ss = 0.
  s2 = 0.
  !
  do i=1,nv
    v = visi(jy,i)
    u = visi(jx,i)
    do kw=1,nw
      if (kw.eq.nw) then
        staper = 1.0
      else
        staper = (u**2+v**2)/taper(kw)**2
        if (staper.gt.64.0) then
          staper = 0.0
        else
          staper = exp(-staper)
        endif
      endif
      ww = we(i,nw)
      if (ww.gt.weight) then
        st = staper/ww*weight
        we(i,kw) = visi(iw,i)*st
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*st
      elseif (ww.gt.0.0) then
        we(i,kw) = visi(iw,i)*staper
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*staper
      else
        we(i,kw) = 0.0
      endif
    enddo
  enddo
  !
  ! Renormalize weights to get proper noise
  do kw=1,nw
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st * we(i,kw)
    enddo
  enddo
end subroutine do3weig
!
subroutine dodate(nc,nv,visi,id,it)
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !-----------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command UV_STAT 
  !
  !   List the dates
  !!
  !-----------------------------------------------------
  integer, intent(in) :: id       !! Date pointer
  integer, intent(in) :: it       !! Time pointer
  integer, intent(in) :: nc       !! Size of a visibility
  integer, intent(in) :: nv       !! Number of visibilities
  real, intent(in) :: visi(nc,nv) !! Visibilities
  !
  character(len=*), parameter :: rname='DODATE'
  integer, parameter :: maxt=100
  !
  ! Local ---
  character(len=78) ch
  logical error
  integer nt
  integer ti,tf(maxt),i,j,k,jt
  real(8) :: rti
  !
  nt = 0
  do i=1,nv
    rti = dble(visi(id,i))+dble(visi(it,i))/86400.0d0
    if (rti.ge.0) then
      ti = int(rti)
    else
      ti = int(rti)-1
    endif
    !
    jt = 0
    do j=1,nt
      if (ti.eq.tf(j)) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      if (nt.gt.maxt) return
      nt = nt+1
      tf(nt) = ti
      jt = nt
    endif
  enddo
  !
  ! Simple sort
  do j = nt-1,1,-1
    k = j
    do i = j+1,nt
      if (tf(j).le.tf(i)) exit
      k = i
    enddo
    if (k.ne.j) then
      ti = tf(j)
      do i = j+1,k
        tf(i-1) = tf(i)
      enddo
      tf(k) = ti
    endif
  enddo
  !
  call map_message(seve%i,rname,'Observing dates are:')
  k = 5
  ch = ' '
  do i=1,nt
    call gag_todate(tf(i),ch(k:),error)
    k = k+20
    if (k.gt.80) then
      call gagout(ch)
      k = 5
    endif
  enddo
  if (k.gt.5) call gagout(ch)
end subroutine dodate
!
subroutine do4weig (jc,nv,visi,jx,jy,iw,unif,we,wm,nw,taper,s)
  use gkernel_interfaces
  use gbl_message
  use grid_control
  use imager_interfaces, except_this => do4weig
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for UV_STAT
  !
  !   Compute weights of the visibility points.  CELL mode
  !
  !----------------------------------------------------------------------
  integer, intent(in) :: jc    !! Size of a visibility
  integer, intent(in) :: nv    !! Number of visibilities
  integer, intent(in) :: jx    !! X coordinate pointer
  integer, intent(in) :: jy    !! Y coordinate pointer
  integer, intent(in) :: iw    !! Weight pointer
  integer, intent(in) :: nw    !! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)    !! Visibilities
  real, intent(in) :: unif(nw)       !! Cell size in meters
  real, intent(out) :: we(nv,nw)     !! Weight arrays
  real, intent(inout) :: wm(nw)      !! on input: robust factors
  real, intent(in) :: taper(3)       !! Tapers
  real, intent(out) :: s             !! Sum of weights (natural noise)
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='DO4WEIG'
  !
  ! Local ---
  integer i,kw,jold
  real u,v,wmax,wmin
  real cx,sx,cy,sy,staper
  real ss(10),s2(10),ww,st
  !
  real, allocatable :: suu(:), svv(:), sww(:), swe(:), wt(:)
  real :: umin, umax, vmin, vmax
  real :: sizecell
  integer :: ier, mv, nbv, ivmin, icode
  logical :: error
  !
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,1) = visi(iw,i)
    else
      we(i,1) = 0.0
    endif
    s = s+we(i,1)
  enddo
  if (s.eq.0) return
  !
  ! Natural weights & Compute VMIN, VMAX, UMIN, UMAX
  call douvext(jc,nv,visi,jx,jy,umin,umax,vmin,vmax)
  !
  ! Define taper
  staper = taper(3)*pi/180.0
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
  else
    cy = 0.0
    sx = 0.0
  endif
  !
  ! Uniform weights next
  jold = 0
  !
  ! First compute the taper
  allocate(wt(nv),stat=ier)
  do i=1,nv
    if (visi(iw,i).le.0.0) then
      wt(i) = 0.0
    else
      v = visi(jy,i)
      u = visi(jx,i)
      staper = (u*cx + v*sy)**2 +(-u*sx + v*cy)**2
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
      wt(i) = staper
    endif
  enddo
  !
  ! Then apply robustness
  !
  ivmin = 1
  mv = 2*nv-ivmin+1
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),stat=ier)
  if (ier.ne.0) then
    Print *,'Major failure in DO4WEI -- Allocation error MV ',mv
    return
  endif
  !
  suu(1:nv) = visi(jx,:)
  svv(1:nv) = visi(jy,:)
  sww(1:nv) = max(0.0,visi(iw,:))
  !
  ! Apply symmetry
  nbv = nv
  do i=ivmin,nv
    if (visi(iw,i).gt.0) then
      nbv = nbv+1
      suu(nbv) = -visi(jx,i)
      svv(nbv) = -visi(jy,i)
      sww(nbv) = visi(iw,i)
    endif
  enddo
  !
  we(:,1) = sww(1:nv) * wt(1:nv)
  !
  do kw=nw,2,-1
    !
    swe(:) = 0
    if (nbv.lt.grid_bigvisi) then
      icode = 0
      call dowei_icode(umax,umin,vmax,vmin,unif(kw),nbv,icode)
      sizecell = unif(kw)/icode
      call gridless_density(nbv,sizecell,unif(kw),suu,svv,sww,swe, &
        &  umin,umax,vmin,vmax,error)   
      if (error) return
    else
      call doweig_grid (jc,nv,visi,jx,jy,iw,unif(kw),swe,error) 
      if (error) return    
    endif
    !
    we(:,kw) = swe(1:nv) * wt(1:nv)  ! Apply taper
  enddo
  !
  ! Define Robust parameter & Apply Robustness
  ss(2:nw) = 0.0
  s2(2:nw) = 0.0
  ss(1) = 1.0
  s2(1) = 1.0
  !
  do kw = 2,nw
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      if (we(i,kw).ne.0.0) then
        wmin = min(we(i,kw),wmin)
        wmax = max(we(i,kw),wmax)
      endif
    enddo
    wm(kw) = wm(1)*sqrt(wmin*wmax)
    !
    do i=1,nv
      staper = wt(i)
      ww = we(i,kw)
      if (ww.gt.wm(kw)) then
        st = staper/ww*wm(kw)
        we(i,kw) = visi(iw,i)*st ! On peut optimiser en utilisant sww(i)
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*st
      elseif (we(i,kw).gt.0.0) then
        we(i,kw) = visi(iw,i)*staper
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*staper
      else
        we(i,kw) = 0.0
      endif
    enddo
    !
    ! Re-normalize weight to compute noise
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st * we(i,kw)
    enddo
  enddo
end subroutine do4weig
!
subroutine sidelo (map,nx,ny,thre,majo,mino,pa,convert)
  !------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support for UV_STAT 
  !
  !   Compute sidelobes level
  !!
  !------------------------------------------------------------
  integer, intent(in) :: nx,ny          !! X,Y sizes
  real, intent(in) :: map(nx,ny)        !! Beam map
  real, intent(in) :: majo              !! Major axis
  real, intent(in) :: mino              !! Minor axis
  real, intent(in) :: pa                !! PA
  real, intent(out) :: thre(2)          !! Positive and Negative sidelobe
  real(8), intent(in) :: convert(3,2)   !! Axis Conversion formula
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(4), parameter :: sln2 = 2.0*sqrt(log(2.0))
  !
  ! Local ---
  real pang,oang,ca,sa,ma,mi,xs,ys,d,g
  integer i,j
  !
  ! Code ----
  pang = pa-90.0
  oang = pi*pang/180.0
  ca = cos(oang)
  sa = sin(oang)
  ma = majo/convert(3,1)/sln2
  mi = mino/convert(3,2)/sln2
  !
  thre(1) = 0.0
  thre(2) = 0.0
  !
  do j=ny/4+1,3*ny/4
    ys = j-convert(1,2)
    do i=nx/4+1,3*nx/4
      xs = i-convert(1,1)
      g = ((ca*xs + sa*ys)/ma)**2 + ((-sa*xs+ca*ys)/mi)**2
      d = map(i,j)
      thre(1) = min(thre(1),d)
      if (g.le.40.) then
        d = map(i,j)-exp(-g)
      endif
      thre(2) = max(thre(2),d)
    enddo
  enddo
end subroutine sidelo
!
subroutine do0weig (jc,nv,visi,jx,jy,jw,unif,we)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  use grid_control
  use imager_interfaces, only : doweig_sph 
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --   Support for UV_STAT
  !
  !   Compute weights of the visibility points.
  !   Use gridded or non-gridded version according to 
  !   grid_bigvisi, i.e. Gridding%Big
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: jc    !! Size of a visibility
  integer, intent(in) :: nv    !! Number of visibilities
  integer, intent(in) :: jx    !! X coordinate pointer
  integer, intent(in) :: jy    !! Y coordinate pointer
  integer, intent(in) :: jw    !! Weight pointer
  real, intent(in) :: visi(jc,nv)    !! Visibilities
  real, intent(in) :: unif           !! Cell size in meters
  real, intent(out) :: we(nv)        !! Weight arrays
  !
  ! Local ---
  integer icode
  logical error
  !
  ! Code ----
  icode = 0
  error = .false.
  error = .false.
  if (nv.gt.grid_bigvisi) then
    ! Gridded version 
    call doweig_grid (jc,nv,visi,jx,jy,jw,unif,we,error)
  else
    call doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,error,icode)
  endif
end subroutine do0weig
!
!
subroutine do2fft (np,nv,visi,jx,jy,nx,ny,nw,map,mapx,mapy,we) 
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_STAT
  !
  !   Compute FFT of image by gridding UV data for several weights
  !   at once. Uses simple in-cell gridding
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                     !! number of visibilities
  integer, intent(in) :: np                     !! Size of a visibility, normally => 7+3*nc
  integer, intent(in) :: nw                     !! number of weight schemes
  integer, intent(in) :: nx,ny                  !! map size
  integer, intent(in) :: jx,jy                  !! X coord, Y coord location in VISI
  real, intent(in) :: visi(np,nv)               !! visibilities
  complex, intent(out) :: map(nw,nx,ny)         !! gridded visibilities
  real, intent(in) :: mapx(nx),mapy(ny)         !! Coordinates of grid
  real, intent(in) :: we(nv,nw)                 !! Weight array
  !
  ! Local ---
  integer :: ix,iy,iw,i,my,ky,kx
  real :: u,v
  real(8) :: xinc,xref,yinc,yref
  !
  ! Code ----
  map = 0.0
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  my = ny/2+1
  !
  ! Start with loop on observed visibilities
  !! Print *,'Filling Negative side '
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (v.gt.0) then
      u = -u
      v = -v
    endif
    !
    ! Define map cell
    ix = nint(u/xinc+xref)
    iy = nint(v/yinc+yref)
    do iw=1,nw
      map (iw,ix,iy) = map (iw,ix,iy) + we(i,iw)
    enddo
    !
    ix = nint(-u/xinc+xref)
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
	  !! Print *,'Intrinsic symmetry at MY ',my,ny,i,visi(1:2,i)
      do iw=1,nw
        map (iw,ix,iy) = map (iw,ix,iy) + we(i,iw)
      enddo
    endif
  enddo
  !! Print *,'Finished 1 side -- applying symmetry'
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      do iw=1,nw
        map(iw,ix,iy) = map(iw,kx,ky)
      enddo
    enddo
  enddo
end subroutine do2fft
!
subroutine prnoise(prog,which,noise,rms)
  use gbl_message
  use imager_interfaces, only : map_message
  !--------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Printout the estimated noise value
  !!
  !--------------------------------------------------
  character(len=*), intent(in) :: prog    !! Caller name
  character(len=*), intent(in) :: which   !! Type of image
  real, intent(in) :: noise               !! Noise value
  real, intent(out) :: rms                !! Scale factor for noise
  !
  ! Local ---
  character(len=message_length) :: string
  character(len=16) :: unit
  !
  ! It comes in Jy/beam
  if (noise.gt.0.05) then
    rms = 1
    unit = ' Jy/beam'
  elseif (noise.gt.0.1e-3) then
    rms = 1e3
    unit = ' mJy/beam'
  else
    rms = 1e6
    unit = ' microJy/beam'
  endif
  write(string,'(a,a,f9.3,a)')  which,' rms noise ', rms*noise, unit
  call map_message(seve%i,prog,string)
end subroutine prnoise
!
subroutine doqfft (np,nv,visi,jx,jy,jw   &
     &    ,nx,ny,map,weight,uvcell)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_STAT    
  !
  ! (Quick Gridding)  
  !   Compute FFT of beam by gridding UV data for Natural
  !   weighting only. Uses simple in-cell gridding for speed
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                     !! number of visibilities
  integer, intent(in) :: np                     !! Size of a visibility, normally 7+3*nc
  integer, intent(in) :: nx,ny                  !! map size
  integer, intent(in) :: jx,jy,jw               !! X coord, Y coord & Weight location in VISI
  real, intent(in) :: visi(np,nv)               !! visibilities
  complex, intent(out) :: map(nx,ny)            !! gridded visibilities
  real, intent(in) :: weight(nv)                !! Weights
  real, intent(in) :: uvcell                    !! UV cell size 
  !
  ! Local ---
  integer :: ix,iy,iv,my,ky,kx
  real :: u,v
  real(8) :: xinc,xref,yinc,yref
  !
  ! Initialize
  map = 0.0
  xinc = -uvcell 
  xref = nx/2+1
  yinc =  uvcell 
  yref = ny/2+1
  my = ny/2+1
  !
  ! Start with loop on observed visibilities
  do iv=1,nv
    u = visi(jx,iv)
    v = visi(jy,iv)
    ! Make sure V is < 0
    if (v.gt.0) then
      u = -u
      v = -v
    endif
    !
    ! Define map cell
    ix = nint(u/xinc+xref)
    iy = nint(v/yinc+yref)
    map (ix,iy) = map (ix,iy) + weight(iv) 
    !
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
      ix = nint(-u/xinc+xref)
      map (ix,iy) = map (ix,iy) + weight(iv) 
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      map(ix,iy) = map(kx,ky)
    enddo
  enddo
end subroutine doqfft
!
subroutine uv_get_cols(rname,huvin,visi,nc,mcol,wcol, fcol, freq, error)
  use image_def
  use imager_interfaces, only : map_message
  use gkernel_interfaces
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --   Support for UV_STAT (and others if needed)
  !
  !     Find a suitable Weight channel and setup the reference frequency
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: rname   !! Calling command
  type(gildas), intent(in) :: huvin       !! UV Header
  real, intent(in) :: visi(:,:)           !! UV data
  integer, intent(inout) :: mcol(2)       !! Channel range (intent OUT ?)
  integer, intent(in) :: nc               !! Number of channels
  integer, intent(in) :: wcol             !! Weight channel (0 == Automatic)
  integer, intent(out) :: fcol            !! Selected Weight channel
  real(8), intent(out) :: freq            !! Observing frequency
  logical, intent(out) :: error           !! Error flag
  !
  ! Local ---
  integer(kind=8) :: iv,nv
  integer :: lcol,icol,jcol,kcol
  real(8) :: rcol
  real(8) :: ww
  !
  ! Code ----
  nv = huvin%gil%nvisi
  error = .false.
  !
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  !
  ! Compute observing sky frequency for U,V cell size
  rcol = 0.5*(fcol+lcol)
  freq = gdf_uv_frequency(huvin,rcol)
  !
  if (wcol.eq.0) then
    ! Automatic choice of Weight channel
    icol = min(max(1,mcol(1)),nc)  ! First channel
    fcol = min(mcol(2),nc)         ! Last channel
    if (fcol.eq.0) fcol = nc
    !
    jcol = (icol+fcol)/3           ! Avoid middle channel
    ! Ensure this is a valid Weight channel
    jcol = max(1,jcol)
    ww = 0 
    kcol = 7+3*jcol
    do iv=1,nv
      ww = ww+max(0.,visi(kcol,iv))
    enddo
    ! If not, scan for at least one...
    if (ww.eq.0) then
      if (nc.eq.1) then
        call map_message(seve%e,rname,'All channels are flagged')
        error = .true.
        return
      endif
      do jcol=1,nc,max(1,nc/10)
        kcol = 7+3*jcol
        do iv=1,nv
          ww = ww+max(0.,visi(kcol,iv))
        enddo
        if (ww.ne.0) exit
      enddo
      if (ww.eq.0) jcol = (icol+fcol)/2+1
      do while (ww.eq.0)
        jcol = jcol-1
        if (jcol.lt.1) exit
        kcol = 7+3*jcol
        do iv=1,nv
          ww = ww+max(0.,visi(kcol,iv))
        enddo
      enddo
      if (ww.eq.0) jcol = (icol+fcol)/2
      do while (ww.eq.0)
        jcol = jcol+1
        if (jcol.gt.nc) then
          call map_message(seve%e,rname,'All channels are flagged')
          error = .true.
          return
        endif
        kcol = 7+3*jcol
        do iv=1,nv
          ww = ww+max(0.,visi(kcol,iv))
        enddo
      enddo
    endif
    fcol = jcol
    !
  else
    ! User specified choice of Weight channel
    fcol = abs(wcol) ! WCOL negative is used to avoid examining the Dates
    fcol = min(fcol,nc)
    fcol = max(1,fcol)
    !
    ww = 0
    kcol = 7+3*fcol
    do iv=1,nv
      ww = ww+max(0.,visi(kcol,iv))
    enddo
    if (ww.eq.0) then
      call map_message(seve%e,rname,'Weight channel specified by WCOL is flagged')
      error = .true.
      return
    endif
  endif
end subroutine uv_get_cols

module gwcs_interfaces_public
  interface
    subroutine gwcs_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gwcs_message_set_id
  end interface
  !
  interface
    subroutine modify_frame_velocity(new_velo,rchan,freq,fres,old_velo,vres,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      ! Change Frame Velocity
      ! All updated values are intent(inout) because they are not modified
      ! if there is nothing to be done.
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: new_velo  ! Desired velocity
      real(kind=8), intent(inout) :: rchan     ! Reference channel
      real(kind=8), intent(in)    :: freq      ! Frequency at ref. channel
      real(kind=8), intent(inout) :: fres      ! Frequency resolution
      real(kind=4), intent(inout) :: old_velo  ! Velocity at ref. channel
      real(kind=4), intent(inout) :: vres      ! Velocity resolution
      logical,      intent(inout) :: error     ! Logical error flag
    end subroutine modify_frame_velocity
  end interface
  !
  interface
    subroutine modify_rest_frequency(new_freq,rchan,old_freq,image,fres,vres,error)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      ! Change Rest Frequency
      ! All updated values are intent(inout) because they are not modified
      ! if there is nothing to be done.
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: new_freq  ! Desired frequency
      real(kind=8), intent(inout) :: rchan     ! Reference channel
      real(kind=8), intent(inout) :: old_freq  ! Frequency at ref. channel
      real(kind=8), intent(inout) :: image     ! Image frequency at ref. channel
      real(kind=8), intent(inout) :: fres      ! Frequency resolution
      real(kind=4), intent(inout) :: vres      ! Velocity resolution
      logical,      intent(inout) :: error     ! Logical error flag
    end subroutine modify_rest_frequency
  end interface
  !
  interface
    subroutine equ_to_gal(ra,dec,raoff,decoff,equinox,l,b,loff,boff,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Convert 1 position + 1 offset from Equatorial+Equinox to Galactic
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: ra       !
      real(kind=8), intent(in)    :: dec      !
      real(kind=4), intent(in)    :: raoff    !
      real(kind=4), intent(in)    :: decoff   !
      real(kind=4), intent(in)    :: equinox  !
      real(kind=8), intent(out)   :: l        !
      real(kind=8), intent(out)   :: b        !
      real(kind=4), intent(out)   :: loff     !
      real(kind=4), intent(out)   :: boff     !
      logical,      intent(inout) :: error    !
    end subroutine equ_to_gal
  end interface
  !
  interface
    subroutine gal_to_equ(l,b,loff,boff,ra,dec,raoff,decoff,equinox,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Convert 1 position + 1 offset from Galactic to Equatorial+Equinox
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: l        !
      real(kind=8), intent(in)    :: b        !
      real(kind=4), intent(in)    :: loff     !
      real(kind=4), intent(in)    :: boff     !
      real(kind=8), intent(out)   :: ra       !
      real(kind=8), intent(out)   :: dec      !
      real(kind=4), intent(out)   :: raoff    !
      real(kind=4), intent(out)   :: decoff   !
      real(kind=4), intent(in)    :: equinox  !
      logical,      intent(inout) :: error    !
    end subroutine gal_to_equ
  end interface
  !
  interface
    subroutine equ_to_equ(inra,indec,inroff,indoff,inequinox,ra,dec,  &
      raoff,decoff,equinox,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Convert 1 position + 1 offset from Equatorial+Equinox to
      ! Equatorial+Equinox
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: inra       !
      real(kind=8), intent(in)    :: indec      !
      real(kind=4), intent(in)    :: inroff     !
      real(kind=4), intent(in)    :: indoff     !
      real(kind=4), intent(in)    :: inequinox  !
      real(kind=8), intent(out)   :: ra         !
      real(kind=8), intent(out)   :: dec        !
      real(kind=4), intent(out)   :: raoff      !
      real(kind=4), intent(out)   :: decoff     !
      real(kind=4), intent(in)    :: equinox    !
      logical,      intent(inout) :: error      !
    end subroutine equ_to_equ
  end interface
  !
  interface
    subroutine chgcoo(oldtyp,newtyp,oldepo,newepo,matrix)
      !---------------------------------------------------------------------
      ! @ public
      !  Change Coordinate system
      !------------------------------------------------------------------------
      character(len=2), intent(in)  :: oldtyp        ! Coordinate input type
      character(len=2), intent(in)  :: newtyp        ! Coordinate output type
      real(kind=4),     intent(in)  :: oldepo        ! Coordinate input epoch (if 'EQ')
      real(kind=4),     intent(in)  :: newepo        ! Coordinate output epoch (if 'EQ')
      real(kind=8),     intent(out) :: matrix(3,3)   ! Rotation Matrix
    end subroutine chgcoo
  end interface
  !
  interface
    subroutine qprec (ti,tf,angles)
      !---------------------------------------------------------------------
      ! @ public
      !  precession entre deux epoques selon Lieske et al (1977)
      !  from EPHAUT / BDL / C002 / 81-1
      !  modified 29 november 1984 by Michel Perault
      !  calcul de quantites liees aux deplacements precessionnels de
      !  l'equateur et de l'ecliptique entre deux epoques donnees
      !  en entree : TI epoque initiale (jours juliens)
      !              TF epoque finale (jours juliens)
      !  en sortie : ANGLES(1-3) quantites liees au deplacement precessionnel
      !              de l'equateur entre TI et TF (radian)
      !              ANGLES(4-6) quantites liees au deplacement precessionnel
      !              de l'ecliptique entre TI et TF (radian)
      !  notations : ANGLES(1) = DZETA
      !              ANGLES(2) = Z
      !              ANGLES(3) = TETA
      !              ANGLES(4) = petit PI
      !              ANGLES(5) = grand PI
      !              ANGLES(6) = P (precession generale en longitude)
      !  remarque  : les temps sont mesures en siecle julien a partir de
      !              l'epoque J2000.0 (JJ2451545)
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: ti         !
      real(kind=8), intent(in)  :: tf         !
      real(kind=8), intent(out) :: angles(6)  !
    end subroutine qprec
  end interface
  !
  interface
    subroutine b1950_to_j2000(obs_epoch,alpha,delta)
      !---------------------------------------------------------------------
      ! @ public
      ! Convert Besselian coordinates to J2000, assuming zero proper motion,
      ! parallax, and radial velocity. Calls the general implementation of
      ! the formulas from Aoki et al AA 128, 263 (1983)
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: obs_epoch  !
      real(kind=8), intent(inout) :: alpha      !
      real(kind=8), intent(inout) :: delta      !
    end subroutine b1950_to_j2000
  end interface
  !
  interface
    subroutine do_precess(epoch, new_epoch, lambda, beta)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      real(kind=4), intent(inout) :: epoch      !
      real(kind=4), intent(in)    :: new_epoch  !
      real(kind=8), intent(inout) :: lambda     !
      real(kind=8), intent(inout) :: beta       !
    end subroutine do_precess
  end interface
  !
  interface
    subroutine spher (x, a)
      !---------------------------------------------------------------------
      ! @ public
      !       CARTESIAN TO SPHERICAL COORDINATE CONVERSION
      !------------------------------------------------------------------------
      real(kind=8), intent(in)  :: x(3)  ! Cartesian coordinates
      real(kind=8), intent(out) :: a(2)  ! Spherical coordinates
    end subroutine spher
  end interface
  !
  interface
    subroutine rect (a, x)
      !---------------------------------------------------------------------
      ! @ public
      !       SPHERICAL TO CARTESIAN COORDINATES CONVERSION
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: a(2)  ! Spherical coordinates
      real(kind=8), intent(out) :: x(3)  ! Cartesian coordinates
    end subroutine rect
  end interface
  !
  interface equ_equ
    subroutine equ_equ_0d(ra1,dec1,equinox1,ra2,dec2,equinox2,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_equ
      !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
      !  Scalar version
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: ra1       !
      real(kind=8),    intent(in)    :: dec1      !
      real(kind=4),    intent(in)    :: equinox1  !
      real(kind=8),    intent(out)   :: ra2       !
      real(kind=8),    intent(out)   :: dec2      !
      real(kind=4),    intent(in)    :: equinox2  !
      logical,         intent(inout) :: error     !
    end subroutine equ_equ_0d
    subroutine equ_equ_1d(ra1,dec1,equinox1,ra2,dec2,equinox2,n,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_equ
      !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
      !  1D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         !
      real(kind=8),    intent(in)    :: ra1(n)    !
      real(kind=8),    intent(in)    :: dec1(n)   !
      real(kind=4),    intent(in)    :: equinox1  !
      real(kind=8),    intent(out)   :: ra2(n)    !
      real(kind=8),    intent(out)   :: dec2(n)   !
      real(kind=4),    intent(in)    :: equinox2  !
      logical,         intent(inout) :: error     !
    end subroutine equ_equ_1d
    subroutine equ_equ_2d(ra1,dec1,equinox1,ra2,dec2,equinox2,n,m,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_equ
      !  Convert 1 position from Equatorial+Equinox to Equatorial+Equinox
      !  2D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n,m        !
      real(kind=8),    intent(in)    :: ra1(n,m)   !
      real(kind=8),    intent(in)    :: dec1(n,m)  !
      real(kind=4),    intent(in)    :: equinox1   !
      real(kind=8),    intent(out)   :: ra2(n,m)   !
      real(kind=8),    intent(out)   :: dec2(n,m)  !
      real(kind=4),    intent(in)    :: equinox2   !
      logical,         intent(inout) :: error      !
    end subroutine equ_equ_2d
  end interface equ_equ
  !
  interface equ_gal
    subroutine equ_gal_0d(ra,dec,equinox,l,b,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_gal
      !  Convert 1 position from Equatorial+Equinox to Galactic
      !  Scalar version
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: ra       !
      real(kind=8),    intent(in)    :: dec      !
      real(kind=4),    intent(in)    :: equinox  !
      real(kind=8),    intent(out)   :: l        !
      real(kind=8),    intent(out)   :: b        !
      logical,         intent(inout) :: error    !
    end subroutine equ_gal_0d
    subroutine equ_gal_1d(ra,dec,equinox,l,b,n,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_gal
      !  Convert 1 position from Equatorial+Equinox to Galactic
      !  1D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         !
      real(kind=8),    intent(in)    :: ra(n)     !
      real(kind=8),    intent(in)    :: dec(n)    !
      real(kind=4),    intent(in)    :: equinox   !
      real(kind=8),    intent(out)   :: l(n)      !
      real(kind=8),    intent(out)   :: b(n)      !
      logical,         intent(inout) :: error     !
    end subroutine equ_gal_1d
    subroutine equ_gal_2d(ra,dec,equinox,l,b,n,m,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic equ_gal
      !  Convert 1 position from Equatorial+Equinox to Galactic
      !  2D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n,m       !
      real(kind=8),    intent(in)    :: ra(n,m)   !
      real(kind=8),    intent(in)    :: dec(n,m)  !
      real(kind=4),    intent(in)    :: equinox   !
      real(kind=8),    intent(out)   :: l(n,m)    !
      real(kind=8),    intent(out)   :: b(n,m)    !
      logical,         intent(inout) :: error     !
    end subroutine equ_gal_2d
  end interface equ_gal
  !
  interface gal_equ
    subroutine gal_equ_0d(l,b,ra,dec,equinox,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gal_equ
      !  Convert 1 position from Galactic to Equatorial+Equinox
      !  Scalar version
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)    :: l        !
      real(kind=8),    intent(in)    :: b        !
      real(kind=8),    intent(out)   :: ra       !
      real(kind=8),    intent(out)   :: dec      !
      real(kind=4),    intent(in)    :: equinox  !
      logical,         intent(inout) :: error    !
    end subroutine gal_equ_0d
    subroutine gal_equ_1d(l,b,ra,dec,equinox,n,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gal_equ
      !  Convert 1 position from Galactic to Equatorial+Equinox
      !  1D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n        !
      real(kind=8),    intent(in)    :: l(n)     !
      real(kind=8),    intent(in)    :: b(n)     !
      real(kind=8),    intent(out)   :: ra(n)    !
      real(kind=8),    intent(out)   :: dec(n)   !
      real(kind=4),    intent(in)    :: equinox  !
      logical,         intent(inout) :: error    !
    end subroutine gal_equ_1d
    subroutine gal_equ_2d(l,b,ra,dec,equinox,n,m,error)
      use gbl_constant
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gal_equ
      !  Convert 1 position from Galactic to Equatorial+Equinox
      !  1D-array version
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n,m       !
      real(kind=8),    intent(in)    :: l(n,m)    !
      real(kind=8),    intent(in)    :: b(n,m)    !
      real(kind=8),    intent(out)   :: ra(n,m)   !
      real(kind=8),    intent(out)   :: dec(n,m)  !
      real(kind=4),    intent(in)    :: equinox   !
      logical,         intent(inout) :: error     !
    end subroutine gal_equ_2d
  end interface gal_equ
  !
  interface
    subroutine eq1950_gal(a,d,lii,bii,n)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !  Converts (A,D) (1950.0) in LII,BII
      !  Units are radians
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)  :: a(*)    !
      real(kind=8),    intent(in)  :: d(*)    !
      real(kind=8),    intent(out) :: lii(*)  !
      real(kind=8),    intent(out) :: bii(*)  !
      integer(kind=4), intent(in)  :: n       !
    end subroutine eq1950_gal
  end interface
  !
  interface
    subroutine gal_eq1950(lii,bii,a,d,n)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      !   Converts Lii,Bii to (A,D) (1950.0)
      !   Units are radians
      !---------------------------------------------------------------------
      real(kind=8),    intent(in)  :: lii(*)  !
      real(kind=8),    intent(in)  :: bii(*)  !
      real(kind=8),    intent(out) :: a(*)    !
      real(kind=8),    intent(out) :: d(*)    !
      integer(kind=4), intent(in)  :: n       !
    end subroutine gal_eq1950
  end interface
  !
  interface
    subroutine gwcs_projec(a0,d0,pangle,ptype,proj,error)
      use phys_const
      use gbl_constant
      use gbl_message
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public
      !       Define a projection
      !---------------------------------------------------------------------
      real(kind=8),       intent(in)    :: a0      !
      real(kind=8),       intent(in)    :: d0      !
      real(kind=8),       intent(in)    :: pangle  !
      integer(kind=4),    intent(in)    :: ptype   !
      type(projection_t), intent(out)   :: proj    !
      logical,            intent(inout) :: error   !
    end subroutine gwcs_projec
  end interface
  !
  interface
    subroutine abs_add_distance(lon1,lat1,off,angl,lon2,lat2)
      !---------------------------------------------------------------------
      ! @ public
      !   Add a distance to absolute spherical coordinates and return the
      ! resulting absolute spherical coordinates.
      !  This is basically an inverse Haversine formula.
      !  Angle:
      !    North   0
      !    East   90 (with longitude increasing towards East)
      !    South 180
      !    West  270
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  ::  lon1  ! [rad] Longitude of input coordinates
      real(kind=8), intent(in)  ::  lat1  ! [rad] Latitude of input coordinates
      real(kind=8), intent(in)  ::  off   ! [rad] Offset/distance to be added
      real(kind=8), intent(in)  ::  angl  ! [rad] Angle of offset
      real(kind=8), intent(out) ::  lon2  ! [rad] Longitude of output coordinates
      real(kind=8), intent(out) ::  lat2  ! [rad] Latitude of output coordinates
    end subroutine abs_add_distance
  end interface
  !
  interface abs_to_rel
    subroutine abs_to_rel_0d(proj,a,d,x,y,n)
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic abs_to_rel
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for scalar values
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: a     ! R.A. (radians)
      real(kind=8),       intent(in)  :: d     ! Declinations
      real(kind=8),       intent(out) :: x     ! Offset in X
      real(kind=8),       intent(out) :: y     ! Offset in Y
      integer(kind=4),    intent(in)  :: n     ! Useless, assumed 1
    end subroutine abs_to_rel_0d
    subroutine abs_to_rel_1dn4(proj,a,d,x,y,n)
      use phys_const
      use gbl_constant
      use gbl_message
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic abs_to_rel
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for 1D arrays, size as I*4
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
      real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
      integer(kind=4),    intent(in)  :: n     ! Size of arrays
    end subroutine abs_to_rel_1dn4
    subroutine abs_to_rel_1dn8(proj,a,d,x,y,n)
      use phys_const
      use gbl_constant
      use gbl_message
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic abs_to_rel
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for 1D arrays, size as I*8
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
      real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
      integer(kind=8),    intent(in)  :: n     ! Size of arrays
    end subroutine abs_to_rel_1dn8
  end interface abs_to_rel
  !
  interface rel_to_abs
    subroutine rel_to_abs_0d(proj,x,y,a,d,n)
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic rel_to_abs
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for scalar values
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: x     ! Offset in X
      real(kind=8),       intent(in)  :: y     ! Offset in Y
      real(kind=8),       intent(out) :: a     ! R.A. (radians)
      real(kind=8),       intent(out) :: d     ! Declinations
      integer(kind=4),    intent(in)  :: n     ! Useless, assumed 1
    end subroutine rel_to_abs_0d
    subroutine rel_to_abs_1dn4(proj,x,y,a,d,n)
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic rel_to_abs
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for 1D arrays, size as I*4
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
      real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(out) :: d(*)  ! Array of declinations
      integer(kind=4),    intent(in)  :: n     ! Size of arrays
    end subroutine rel_to_abs_1dn4
    subroutine rel_to_abs_1dn8(proj,x,y,a,d,n)
      use phys_const
      use gbl_constant
      use gbl_message
      use gwcs_types
      !---------------------------------------------------------------------
      ! @ public-generic rel_to_abs
      !  Convert a set of plane position to spherical coordinates according
      ! to the current projection formulae
      ! ---
      ! This version for 1D arrays, size as I*8
      !---------------------------------------------------------------------
      type(projection_t), intent(in)  :: proj  ! Description of projection
      real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
      real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
      real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
      real(kind=8),       intent(out) :: d(*)  ! Array of declinations
      integer(kind=8),    intent(in)  :: n     ! Size of arrays
    end subroutine rel_to_abs_1dn8
  end interface rel_to_abs
  !
  interface
    function projnam(iproj)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Return the projection name as a character string
      ! ---
      !  The purpose of this function is to avoid declaring a static
      ! character string array containing the projection names: there are
      ! difficulties to share such kind of data between libraries under
      ! several systems (MSWIN, MINGW, ...)
      !---------------------------------------------------------------------
      character(len=13) :: projnam  ! Function value on return
      integer(kind=4), intent(in) :: iproj  ! The projection number
    end function projnam
  end interface
  !
  interface
    subroutine projnam_list(list)
      use gbl_constant
      !---------------------------------------------------------------------
      ! @ public
      ! Return the list of projections in a string array
      !---------------------------------------------------------------------
      character(len=*), intent(out) :: list(0:mproj)  !
    end subroutine projnam_list
  end interface
  !
  interface
    function gwcs_observatory_exists(arg)
      !---------------------------------------------------------------------
      ! @ public
      ! Function evaluates as true if the named observatory is known here
      !---------------------------------------------------------------------
      logical :: gwcs_observatory_exists
      character(len=*), intent(in) :: arg ! Telescope name
    end function gwcs_observatory_exists
  end interface
  !
  interface
    subroutine gwcs_print_telescope(teles,line)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      ! Build a one-line description of a type 'telesco'. This line is well
      ! suited for command V\HEADER.
      !---------------------------------------------------------------------
      type(telesco),    intent(in)  :: teles
      character(len=*), intent(out) :: line
    end subroutine gwcs_print_telescope
  end interface
  !
  interface
    subroutine gwcs_sexa(line,value,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Decode a sexagesimal notation
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: line   !
      real(kind=8),     intent(out)   :: value  !
      logical,          intent(inout) :: error  !
    end subroutine gwcs_sexa
  end interface
  !
  interface
    subroutine gwcs_geo2lonlat(xyz,clon,clat,alt)
      !----------------------------------------------------
      ! @ public
      !   GWCS
      !   Convert XYZ to Longitude, Latitude, Altitude
      !----------------------------------------------------
      real(8), intent(in) :: xyz(3)
      character(len=*), intent(out) :: clon  ! In degree, sexagesimal
      character(len=*), intent(out) :: clat  ! In degree, sexagesimal
      real(8), intent(out) :: alt
    end subroutine gwcs_geo2lonlat
  end interface
  !
  interface
    subroutine gwcs_lonlat2geo(clon,clat,alt,xyz)
      !----------------------------------------------------
      ! @ public
      !
      !----------------------------------------------------
      real(8), intent(out) :: xyz(3)
      real(8), intent(in) :: clon  ! Degree
      real(8), intent(in) :: clat  ! Degree
      real(8), intent(in) :: alt   ! km
    end subroutine gwcs_lonlat2geo
  end interface
  !
  interface
    subroutine gwcs_xyz2lla(xyz, plh, a, fl)
      !------------------------------------------------------------
      ! @ public
      !
      ! Convert XYZ to Longitude, Latitude, Altitude
      ! for a given ellipsoid specified by A and FL
      !
      ! Longitude is East of Greenwich
      !
      ! References:
      ! Borkowski, K. M. (1989).  "Accurate algorithms to transform geocentric
      ! to geodetic coordinates", *Bulletin Geodesique*, v. 63, pp. 50-56.
      ! Borkowski, K. M. (1987).  "Transformation of geocentric to geodetic
      ! coordinates without approximations", *Astrophysics and Space Science*,
      ! v. 139, n. 1, pp. 1-4.  Correction in (1988), v. 146, n. 1, p. 201.
      !
      ! An equivalent formulation is recommended in the IERS Standards
      ! (1995), draft.
      !-------------------------------------------------------------------------
      real(8), intent(in) :: xyz(3)  ! XYZ coordinates (in units of distance)
      real(8), intent(out) :: plh(3) ! Longitude, Latitude (in radians) and height (in unit of distance)
      real(8), intent(in) :: a       ! semi-major axis of ellipsoid (in units are of distance)
      real(8), intent(in) :: fl      ! flattening of ellipsoid [unitless]
    end subroutine gwcs_xyz2lla
  end interface
  !
  interface
    subroutine gwcs_lla2xyz (plh, xyz, A, FL)
      !---------------------------------------------------------------------
      ! @ public
      ! Converts elliptic Longitude, Latitude and Height to geocentric X,Y,Z
      !
      ! references:
      ! Escobal, "Methods of Orbit Determination", 1965, Wiley & Sons, Inc.,
      ! pp. 27-29.
      !---------------------------------------------------------------------
      real(8), intent(in) :: plh(3)  ! Longitude, Latitude (in radians) and height (in unit of distance)
      real(8), intent(out) :: xyz(3) ! XYZ coordinates (in units of distance)
      real(8), intent(in) :: a       ! semi-major axis of ellipsoid (in units are of distance)
      real(8), intent(in) :: fl      ! flattening of ellipsoid [unitless]
    end subroutine gwcs_lla2xyz
  end interface
  !
  interface
    subroutine gwcs_azel2pa(lat,az,el,parang)
      !---------------------------------------------------------------------
      ! @ public
      ! Compute the parallactic angle from az/el and latitude of
      ! observation. Azimuth convention must be South at 180 degrees.
      ! If using azimuth South at 0 degrees, sinAz and cosAz sign should be
      ! swapped.
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: lat     ! [rad]
      real(kind=8), intent(in)  :: az,el   ! [rad]
      real(kind=8), intent(out) :: parang  ! [rad]
    end subroutine gwcs_azel2pa
  end interface
  !
  interface gwcs_observatory
    subroutine gwcs_observatory_parameters(arg,lonlat,altitude,slimit,diam,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gwcs_observatory
      !  Return the observatory parameters given its name, raise an error
      ! if not found
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: arg        ! Telescope name
      real(kind=8),     intent(inout) :: lonlat(2)  !
      real(kind=8),     intent(inout) :: altitude   !
      real(kind=8),     intent(inout) :: slimit     !
      real(kind=4),     intent(inout) :: diam       !
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine gwcs_observatory_parameters
    subroutine gwcs_observatory_telesco(arg,telescope,error)
      use gbl_message
      use image_def
      !---------------------------------------------------------------------
      ! @ public-generic gwcs_observatory
      !  Return the observatory parameters in the 'telesco' structure given
      ! its name.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: arg        ! Telescope name
      type(telesco),    intent(out)   :: telescope  ! Telescope structure
      logical,          intent(inout) :: error      ! Logical error flag
    end subroutine gwcs_observatory_telesco
  end interface gwcs_observatory
  !
end module gwcs_interfaces_public

subroutine mosaic_uvmap_gueth(task,line,error)
  !$ use omp_lib
  use gkernel_interfaces
  use imager_interfaces, except_this=>mosaic_uvmap_gueth
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- 
  !     Support for command UV_MAP, Mosaic case, Gueth method
  !
  !   Compute a Mosaic from a UV Table with pointing offset information.
  !   "Historical" version using the same Tangent point and Image size
  !   for every field. 
  !
  ! Input quantities :  
  !     a UV table with pointing offset information.
  !   It will be sorted by Field number (and V values, but that no longer matters)
  !
  ! Now, we obtain
  !   HDirty      a 3-d cube containing the uniform noise
  !              combined mosaic, i.e. the sum of the product
  !               of the fields by the primary beam. (NX,NY,NC)
  !   HBeam       a 4-d cube where each cube contains the synthesised
  !               beam for one field (NX,NY,NB,NP)
  !   HPrim       the primary beams pseudo-cube (NP,NX,NY,NB)
  !
  !   lweight     the sum of the square of the primary beams (NX,NY,NB)
  !               only for NB=1 (local Weight array, actually unused)
  !
  ! All images have the same X,Y sizes
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task   !! Caller (MOSAIC)
  character(len=*), intent(in) :: line   !! Command line
  logical, intent(out) :: error          !! Logical error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  character(len=*), parameter :: rname='MOSAIC_GUETH'
  !
  ! Local ---
  type(channel_par) :: channels
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  real(8) :: newabs(3)
  real(4) :: rmega,uvmax,uvmin,uvma
  integer :: wcol,mcol(2),nfft,sblock,ier
  logical :: one, sorted, shift
  character(len=message_length) :: chain
  real :: cpu0, cpu1
  real(8) :: freq
  real, allocatable :: fft(:)
  real, allocatable :: noises(:)
  integer :: nx,ny,nu,nv,nc,np,mp
  !
  logical :: debug, abort
  type(gildas) :: htmp, pdirty, pbeam
  real :: btrunc, bsize(10), beamsize ! To be initialized
  !
  real, allocatable, target :: dmap(:,:,:), dtmp(:,:,:,:)
  ! real, allocatable, target :: lweight(:,:,:)   !! Only for "old" code
  real, allocatable :: dtrunc(:,:)
  real, allocatable :: doff(:,:)
  integer, allocatable :: teles(:)
  real, pointer :: my_dirty(:,:,:)
  !
  integer, allocatable :: voff(:)
  real :: xm, xp, off_range(2)
  integer :: ifield, jfield, ic, fstart, fend
  integer :: ib, nb, old_ib
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  type(projection_t) :: proj
  real(8) :: pos(2)
  !
  logical :: per_field
  integer(kind=8) :: ram_map, ram_uv, ram_beam
  integer :: nthread, othread, ithread
  logical :: omp_nested
  logical :: do_jvm
  logical :: do_cct
  real :: jvm_factor
  !
  integer :: ndim, nn(2)
  integer(kind=index_length) :: dim(4)
  complex, allocatable :: comp(:,:)
  !
  ! Code ----
  error = .false.
  call imager_tree('MOSAIC_UVMAP_GUETH',.false.)
  !
  wcol = 0
  debug = .false.
  abort = .false.
  call sic_get_logi('DEBUG',debug,error)
  !
  do_cct = task.eq.'MOSAIC_RESTORE'
  do_jvm = do_cct .and. beam_defined
  !
  ! Get beam size from data or command line
  call sic_get_real('MAP_TRUNCATE',btrunc,error)
  if (error) return
  write(chain,'(A,F4.2,1X,F4.2)') 'Truncation level ',default_map%truncate, btrunc
  call map_message(seve%i,task,chain,3)
  bsize = 0  ! Must be initialized
  if (sic_present(o_trunc,0)) then
    call get_bsize(huv,rname,line,bsize,error,OTRUNC=o_trunc,BTRUNC=btrunc)
  else
    call get_bsize(huv,rname,line,bsize,error,BTRUNC=btrunc)
  endif
  if (error) return
  beamsize = maxval(bsize)
  write(chain,'(a,(f10.2),a,f6.0,a)') 'Correcting for a beam size of ',&
    & beamsize/pi*180*3600,'" down to ',100*btrunc,'% '
  call map_message(seve%i,rname,chain)
  !
  call map_prepare(task,huv,themap,error)
  if (error) return
  !
  one = .true.  
  call uvmap_cols(rname,line,huv,channels,error)
  if (error) return 
  mcol = channels%bounds
  wcol = channels%weight
  !
  ! Select Fields first
  mp = abs(themap%nfields)
  if (.not.do_cct) then
    call sic_delvariable('FIELDS%N_SELECT',.false.,error)
    call sic_delvariable('FIELDS%SELECTED',.false.,error)
    error = .false.
    !
    ! Get the field lists from the /FIELDS option if any
    if (allocated(selected_fields)) deallocate(selected_fields)
    selected_fieldsize = 0
    if (sic_present(o_field,0)) then
      call select_fields(rname,line,o_field,mp,np,selected_fields,error)
      if (error) return
      selected_fieldsize = np
      call sic_def_inte('FIELDS%N_SELECT',selected_fieldsize,0,0,.true.,error)
      dim(1) = selected_fieldsize
      call sic_def_inte('FIELDS%SELECTED',selected_fields,1,dim,.true.,error) 
    endif
  else if (selected_fieldsize.ne.0) then
    np = selected_fieldsize
    write(chain,'(A,I0,A,20(1X,I0))') 'Restoring only ',selected_fieldsize, &
    & ' Fields: ',selected_fields(1:min(20,selected_fieldsize))
    call map_message(seve%i,rname,chain,3)
  else 
    np = mp
  endif
  !
  if (selected_fieldsize.eq.0)  then
    np = mp
    if (allocated(selected_fields)) deallocate(selected_fields)
    allocate(selected_fields(mp),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation on Selected Fields')
    endif
    do jfield=1,np
      selected_fields(jfield) = jfield
    enddo
  endif
  !
  call gag_cpu(cpu0)
  !
  ! Shifting to Phase center Offsets has been done by calling UV_SHIFT_MOSAIC before
  newabs = [huv%gil%a0,huv%gil%d0,huv%gil%pang]
  shift = .false. 
  !
  ! Note: the sorting should have FIELD ID as primary (slowest varying) key
  !
  if (allocated(teles)) deallocate(teles)
  if (allocated(doff)) deallocate(doff)
  if (allocated(voff)) deallocate(voff)
  allocate(doff(2,mp),voff(mp+1),teles(mp),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  call mosaic_sort (error,sorted,shift,newabs,uvmax,uvmin, &
    & huv%gil%column_pointer(code_uvt_xoff), &
    & huv%gil%column_pointer(code_uvt_yoff), &
    & huv%gil%column_pointer(code_uvt_id), &
    & mp,doff,voff)
  if (sic_ctrlc()) then
    call map_message(seve%e,rname,'Aborted by user')
    error = .true.
  endif
  if (error) return 
  !
  teles(1:mp) = huv%mos%fields(:)%jteles 
  !
  xm = minval(doff(1,1:mp))
  xp = maxval(doff(1,1:mp))
  off_range(1) = xp-xm
  xm = minval(doff(2,1:mp))
  xp = maxval(doff(2,1:mp))
  off_range(2) = xp-xm
  !
  if (.not.sorted) then
    Print *,'Done mosaic_sort UV range ',uvmin,uvmax,' sorted ',sorted
    call uv_dump_buffers('UV_MOSAIC')
    ! Redefine SIC variables (mandatory)
    ! Caution: this overrides command line pointers
    call map_uvgildas ('UV',huv,error,duv) 
  else
    Print *,'Mosaic was sorted ',uvmin,uvmax,' sorted ',sorted
  endif
    call uv_dump_buffers('UV_MOSAIC - SORT')
  !
  call gag_cpu(cpu1)
  write(chain,'(A,F9.2)') 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Get map parameters
  call map_parameters(task,themap,huv,freq,uvmax,uvmin,error)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, before mapping first image, for memory contiguity reasons.
  !
  nx = themap%size(1)
  ny = themap%size(2)
  nu = huv%gil%dim(1)  
  nv = huv%gil%nvisi     ! not huv%gil%dim(2)
  nc = mcol(2)-mcol(1)+1 ! not huv%gil%nchan
  !
  allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Gridding allocation error')
    goto 98
  endif
  !
  do_weig = .true.
  if (do_weig) then
    call map_message(seve%i,task,'Computing weights (Mosaic)')
    if (allocated(g_weight)) deallocate(g_weight)
    if (allocated(g_v)) deallocate(g_v)
    allocate(g_weight(nv),g_v(nv),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Weight allocation error')
      goto 98
    endif
  else
    call map_message(seve%i,task,'Re-using weights')
  endif
  nfft = 2*max(nx,ny)
  allocate(fft(nfft),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'FFT allocation error')
    goto 98
  endif
  !
  rmega = 8.0
  ier = sic_ramlog('SPACE_IMAGER',rmega)
  sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  !
  ! New Beam place
  if (allocated(dbeam)) then
    call sic_delvariable ('BEAM',.false.,error)
    deallocate(dbeam)
  endif
  call gildas_null(hbeam)
  !
  ! New dirty image
  allocate(dmap(nx,ny,nc),dtrunc(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Map allocation error')
    goto 98
  endif
  !
  if (.not.do_cct) then
    if (allocated(ddirty)) then
      call sic_delvariable ('DIRTY',.false.,error)
      deallocate(ddirty)
    endif
    allocate(ddirty(nx,ny,nc),stat=ier)
    my_dirty => ddirty
  else
    if (allocated(dresid)) then
      call sic_delvariable ('RESIDUAL',.false.,error)
      deallocate(dresid)
    endif
    allocate(dresid(nx,ny,nc),stat=ier)
    my_dirty => dresid
  endif
  if (ier.ne.0) then
    call map_message(seve%e,task,'Map allocation error')
    goto 98
  endif
  !
  call gildas_null(hdirty)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1:3) = (/nx,ny,nc/)
  !
  ! Compute the primary beams and weight image
  call gildas_null(hprim)
  if (allocated(dprim)) then
    call sic_delvariable ('PRIMARY',.false.,error)
    deallocate(dprim)
  endif
  if (allocated(dfields)) then
    deallocate(dfields)
  endif
  !
  ! !Print *,'Done MAP_BEAMS ',themap%beam,nb
  !
  ! Find out how many beams are required
  call define_beams(rname,themap%beam,nx,ny,huv,mcol,nb,error)
  if (error) return
  ! Define the map characteristics
  call mosaic_headers (rname,themap,huv,hbeam,hdirty,hprim,nb,np,mcol)
  !
  write(chain,'(A,I0,A,I0,A)') 'Imaging channel range [',mcol(1),',',mcol(2),']'
  call map_message(seve%i,task,chain)
  !
  ! Check if Weights have changed by MCOL choice
  if (any(saved_chan%bounds.ne.mcol)) do_weig = .true. ! Useless ???? NEW
  saved_chan%bounds = mcol
  !
  ! Define the projection about the Phase center
  call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
  !
  ! POS is here the Offset of the Pointing center relative to the Phase center
  ! (This may be Zero in most cases) 
  call abs_to_rel (proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
  !
  ! Code ready and now tested for several channels per Beam
  hbeam%gil%ndim = 4
  hbeam%gil%dim(1:4)=(/nx,ny,nb,np/)
  !
  !
  allocate (dtmp(nx,ny,nb,1), dbeam(nx,ny,np,nb), dprim(np,nx,ny,nb), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'NB>1 Primary beam allocation error')
    goto 98
  endif
  !
  hprim%r4d => dprim
  call primary_mosaic(line,np,hprim,hdirty,selected_fields,& 
	& selected_fieldsize,doff,pos,teles,bsize,error)
  if (error) return
  call map_message(seve%i,rname,'Done Primary Beams')
  !
  ! Loop on fields for imaging
  ! Use Dtmp and Dmap as work arrays for beam and image
  hbeam%r3d => dtmp(:,:,:,1)
  hbeam%gil%dim(4) = 1
  !
  ! IN Parallel part, DMAP will be copied per Thread
  ! So we have to verify that the Parallel mode actually fits into Memory
  !
  othread = 1  
  !$ othread = omp_get_max_threads()
  !
  ! Verify memory requirements
  ram_uv = huv%gil%dim(1)*huv%gil%dim(2)/512/512
  ram_map = 2*hdirty%gil%dim(1)*hdirty%gil%dim(2)*hdirty%gil%dim(3)/512/512
  ram_beam = 2*hbeam%gil%dim(1)*hbeam%gil%dim(2)*hbeam%gil%dim(3)*hbeam%gil%dim(4)/512/512
!    Print *,'   RAM Map ',ram_map,hdirty%gil%dim(1:4)    Print *,'   RAM Beam ',ram_beam,hbeam%gil%dim(1:4)
  ram_map = ram_map+ram_beam
  !
  nthread = min(othread,np)
  if (ram_map*nthread.gt.sys_ramsize) nthread = nint(real(sys_ramsize)/real(ram_map))
  nthread = max(nthread,1) ! Just in case
  !
  ram_map = ram_map * min(nthread, np)
  if (ram_map.gt.0.2*sys_ramsize) then
    write(chain,'(A,F8.1,A,F8.1,A,F8.1,A)') 'Data size (UV ',1d-3*ram_uv,& 
      & 'GB + Map ',1D-3*ram_map, &
      & 'GB), available RAM (',1d-3*sys_ramsize,' GB)'
    call map_message(seve%w,rname,chain,3)
    if (ram_map.gt.sys_ramsize) then
      call map_message(seve%e,'Data size exceeds RAM',chain,3)
      error = .true.
      return
    endif
  endif
  !
  !$ call ompset_thread_nesting(rname, nthread, othread, omp_nested)    
  !$ nthread = ompget_outer_threads()
  if (nthread.gt.1) then
    per_field = .true.    
    write(chain,'(A,I0,A,I0,A)') 'Using per-field parallel mode. - Threads ',nthread,' Fields ',np
    call map_message(seve%i,rname,chain,3)
  endif
  !
  hdirty%r3d => dmap
  !
  my_dirty = 0
  dbeam = 0
  allocate(noises(np))  ! To remember the noise
  abort = .false.
  if (sic_ctrlc()) then
    error = .true.
    call map_message(seve%e,rname,'Aborted by user')
    return
  endif
  !
  if (per_field) then
    write(chain,'(A,I0,A,I0,A)') 'Starting per-field parallel loop on channel range [', &
      & mcol(1),'-',mcol(2),']'
    call map_message(seve%i,rname,chain)
  else
    call map_message(seve%i,rname,'Using per-Plane parallelism')
  endif
  !
  ! FFTW plan
  ndim = 2
  nn(1) = hdirty%gil%dim(1)
  nn(2) = hdirty%gil%dim(2)
  allocate(comp(nx,ny),stat=ier)
  call fourt_plan(comp,nn,ndim,-1,1)
  !
  !
  !$OMP PARALLEL DEFAULT(none) if (per_field) NUM_THREADS (nthread) &
  !$OMP   & SHARED(np,debug,task,themap,huv,dprim,dbeam,my_dirty) & 
  !$OMP   & PRIVATE(pdirty,pbeam) &
  !$OMP   & SHARED(hdirty,hbeam) &
  !$OMP   & SHARED(voff, selected_fields, noises, nthread) &
  !$OMP   & SHARED(nx,ny,nu,nc,duv,channels,sblock,cpu0,uvma,btrunc,abort) &
  !$OMP   & SHARED(g_weight) PRIVATE(ifield,jfield) &
  !$OMP   & PRIVATE(fstart,fend,nv,do_weig,error,chain) &
  !$OMP   & PRIVATE(old_ib,ic,ib,dtrunc,dmap,dtmp, ithread) &
  !$OMP   & SHARED(beams_param,do_jvm,do_cct) PRIVATE(jvm_factor)
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  call gildas_null(pdirty)
  call gildas_null(pbeam)
  call gdf_copy_header(hdirty,pdirty,error)
  call gdf_copy_header(hbeam,pbeam,error)
  !$OMP DO
  do jfield = 1,np
    if (sic_ctrlc()) then
      abort = .true.
    endif
    if (abort) cycle ! Quick jump if Abort (EXIT not allowed in Parallel mode)
    !
    ifield = selected_fields(jfield)
    ! Pour le mode parallele
    pdirty%r3d => dmap
    pbeam%r3d => dtmp(:,:,:,1)
    !
    do_weig = .true.
    if (do_cct) then             ! Visibilities have been extracted
      fstart = voff(jfield)      ! Starting Visibility of field
      fend   = voff(jfield+1)-1  ! Ending Visibility of field
    else
      fstart = voff(ifield)      ! Starting Visibility of field
      fend   = voff(ifield+1)-1  ! Ending Visibility of field
    endif
    nv = fend-fstart+1
    if (debug) then
      Print *,'Ifield ',ifield,fstart,fend
      Print *,'Cols ',channels%freq,channels%bounds,channels%weight
      Print *,'Sizes ',nx,ny,nu,nv,np,nc
      Print *,'Calling many_beams_para with SBLOCK ',sblock
    endif
    write(chain,'(A,I0,A,I0)') 'Field ',ifield,' Visi ',nv
    call map_message(seve%d,task,chain)
    ! We could write the Thread or Field number in "task" argument...
    call many_beams_para (task,themap, channels, huv, pbeam, pdirty,   &
       &    nx,ny,nu,nv,duv(:,fstart:fend),   &
       &    g_weight(fstart:fend), do_weig,  &
       &    sblock,cpu0,error,uvma,ifield,abort,ithread)
    !
    noises(jfield) = pdirty%gil%noise   ! Remember the noise
    if (abort) cycle                    ! Cannot Return
    !
    old_ib = 0
    !
    do ic=1,nc
      ib = beam_for_channel(ic,pdirty,pbeam)
      if (do_jvm) then
        jvm_factor = beams_param(4,ib,jfield)
        if (jvm_factor.eq.0.) jvm_factor = 1.
        write(chain,'(A,I0,A,I0,A,F7.3,A,I0)')  &
          & 'Field ',jfield,', Beam ',ib,', JvM factor ',jvm_factor,'; Thread ',ithread
        call map_message(seve%i,task,chain)
      else
        jvm_factor = 1.
      endif
      if (debug) Print *,'Selected beam ',ib, jvm_factor
      ! Add it to the "mosaic dirty" image, by multiplying by
      ! the truncated primary beam
      if (ib.ne.old_ib) then
        dtrunc(:,:) = dprim(jfield,:,:,ib)
        if (debug) Print *,'Set DTRUNC ',ib,' # ',old_ib
        where (dtrunc.lt.btrunc) dtrunc = 0
        old_ib = ib
      endif
      !$OMP CRITICAL
      ! We use here the JvM factor for the Residual image 
      my_dirty(:,:,ic) = my_dirty(:,:,ic) + dmap(:,:,ic)*dtrunc(:,:)*jvm_factor
      !$OMP END CRITICAL
    enddo
    !
    ! Save the beam - Transposition could be done here if needed
    !! dbeam(:,:,:,jfield) = dtmp(:,:,:,1)
    dbeam(:,:,jfield,:) = dtmp(:,:,:,1) ! Transpose      
    if (.not.do_jvm) then
      write(chain,'(A,I0,A,I0)') 'Ending Field ',ifield,' Thread ',ithread
      call map_message(seve%i,task,chain)
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (per_field) then
    !$  call omp_set_nested(omp_nested)
    !$  call omp_set_num_threads(othread)
  endif
  if (abort) then
    call map_message(seve%w,task,'Aborted by user')
    error = .true.
    return
  endif
  hdirty%gil%noise = sum(noises)/np
  !
  ! Set the BEAM header 
  call gildas_null(htmp)
  call gdf_copy_header(hbeam,htmp,error)
  htmp%gil%ndim = 4
  call gdf_transpose_header(htmp,hbeam,'1243',error)
  if (error) return
  hbeam%r4d => dbeam  
  hbeam%gil%dim(1:4)=(/nx,ny,np,nb/)
  hbeam%gil%ndim = 4
  !! if (nb.eq.1) hbeam%gil%ndim = 3
  call sic_mapgildas('BEAM',hbeam,error,dbeam)
  !
  ! OK we are done (apart from details like Extrema)
  !
  hprim%gil%inc(1) = btrunc  ! Convention to store the truncation level
  call sic_mapgildas('PRIMARY',hprim,error,dprim)
  !
  ! Reset the Dirty pointer
  hdirty%r3d => my_dirty
  hdirty%loca%addr = locwrd(my_dirty)
  !
  ! Nullify Filtered channels and Compute Dirty extrema 
  call cube_flag_extrema(huv%gil%nchan,'DIRTY',mcol,hdirty)
  !
  ! Correct the noise for the approximate gain at mosaic center
  ! for HWHM hexagonal spacing (normally it is sqrt(1+6/4)) 
  hdirty%gil%noise = hdirty%gil%noise/sqrt(2.5)
  if (.not.do_cct) then 
    call sic_mapgildas('DIRTY',hdirty,error,ddirty)
    !
    save_data(code_save_beam) = .true.
    save_data(code_save_dirty) = .true.
    save_data(code_save_primary) = .true.
    save_data(code_save_fields) = .true.
    !
    call new_dirty_beam
    !
    ! Define Min Max
    call cube_minmax('DIRTY',hdirty,error)
    !
    d_max = hdirty%gil%rmax
    if (hdirty%gil%rmin.eq.0) then
      d_min = -0.03*hdirty%gil%rmax
    else
      d_min = hdirty%gil%rmin
    endif
  else
    ! Restore the DIRTY image pointer
    hdirty%r3d => ddirty
    call cube_minmax('DIRTY',hdirty,error)
    ! And define the RESIDUAL
    call gdf_copy_header(hdirty,hresid,error)
    hresid%r3d => dresid
    call cube_minmax('RESIDUAL',hresid,error)
    call sic_mapgildas('RESIDUAL',hresid,error,dresid)
  endif
  !
  error = .false.
  !
  ! Backward compatibility with previous methods
  user_method%trunca = btrunc     ! By convention
  hprim%gil%convert(3,4) = beamsize  ! Primary beam size convention
  call sub_mosaic('ON',error)
  !
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  if (allocated(fft)) deallocate(fft)
  call imager_tree('MOSAIC_UVMAP_GUETH',.false.)
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
end subroutine mosaic_uvmap_gueth
!

module sic_interfaces_none
  interface
    subroutine sic_build
      use ieee_arithmetic
      use gbl_message
      use sic_dictionaries
      use sic_interactions
      use sic_structures
      !---------------------------------------------------------------------
      ! SIC   External routine
      !       Initialize SIC
      !---------------------------------------------------------------------
      ! Local
    end subroutine sic_build
  end interface
  !
  interface
    subroutine sic_nolog
    end subroutine sic_nolog
  end interface
  !
  interface
    subroutine tmp_print(iarray,n)
      integer(kind=8) n
      integer iarray(n)
    end subroutine tmp_print
  end interface
  !
  interface
    subroutine sub_table_density(table,cols,image,dims,output,percent,error)
      use image_def
      use gbl_message
      !
      character(len=*), intent(inout) :: table, image, output
      integer(kind=4), intent(in) :: cols(2),dims(2)
      real, intent(in) :: percent
      logical, intent(out) :: error
    end subroutine sub_table_density
  end interface
  !
end module sic_interfaces_none

!
subroutine cct_integrate(rname,hcct,dcct,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for commands SHOW and VIEW CCT 
  !
  !   Compute the cumulative flux in Clean Components, and give access
  !   to it through the CCT_NCOMP and CCT_FLUX arrays.
  !!
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: rname     !! Command name
  type(gildas), intent(in) :: hcct          !! Header
  real, intent(in) :: dcct(:,:,:)           !! CCT array
  logical, intent(inout) :: error           !! Logical Error flag
  !
  ! Local ---
  real, allocatable, save :: fcct(:,:)
  integer, allocatable, save :: mcomp(:)
  integer, allocatable, save :: ftyp(:,:)
  real :: csize(20) ! Ample storage for Component sizes
  integer :: ic,jc,ncomp,nchan,ier
  integer :: is,js,ns
  integer(kind=index_length) :: dim(2)
  logical :: do_size
  !
  ! Code ----
  call sic_delvariable('CCT_NCOMP',.false.,error)
  call sic_delvariable('CCT_TYPE',.false.,error)    
  call sic_delvariable('CCT_FLUX',.false.,error)    
  if (allocated(fcct)) then
    deallocate(fcct,mcomp)
    if (allocated(ftyp)) deallocate(ftyp)
  endif
  !
  ! The FCCT array has a dummy Clean component number 0
  ! to start from Null flux value
  ncomp = hcct%gil%dim(3)+1
  nchan = hcct%gil%dim(2)
  !
  do_size = hcct%gil%dim(1) .eq.4    ! Check size of Component if needed
  if (do_size) then
    allocate(fcct(ncomp,nchan),mcomp(nchan),ftyp(ncomp,nchan),stat=ier)
    ns = 1
    csize = 0.0
    ftyp = 0
  else
    allocate(fcct(ncomp,nchan),mcomp(nchan),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  fcct = 0.0  ! Initialize
  do ic=1,nchan
    fcct(1,ic) = 0 
    mcomp(ic) = ncomp
    do jc=1,ncomp-1           ! Stop at the number of components !...
      if (dcct(3,ic,jc).eq.0) then
        mcomp(ic) = jc
        exit
      else
        fcct(jc+1,ic) = dcct(3,ic,jc) + fcct(jc,ic)
        if (do_size) then
          js = 0
          do is = 1,ns
            if (dcct(4,ic,jc).eq.csize(is)) then
              js = is
              exit
            endif
          enddo
          if (js.eq.0) then
            ns = ns+1
            csize(ns) = dcct(4,ic,jc)
            js = ns
          endif
          ftyp(jc+1,ic) = js 
        endif
      endif
    enddo
    if (do_size) fcct(1,ic) = fcct(2,ic)
  enddo
  !
  dim(1) = ncomp
  dim(2) = nchan
  call sic_def_real('CCT_FLUX',fcct,2,dim,.true.,error)
  if (do_size) then
    call sic_def_inte('CCT_TYPE',ftyp,2,dim,.true.,error)
  endif
  dim(1) = nchan
  call sic_def_inte('CCT_NCOMP',mcomp,1,dim,.true.,error)
end subroutine cct_integrate
!
subroutine cct_remove_start(head,iplane,resid,tfbeam,dcct,tcc, &
  & nfields,primary,weight,wtrun,next_iter,start_flux)
  use image_def
  use clean_def
  use imager_interfaces, only : map_message, mulgau
  use gbl_message
  use omp_lib
  !----------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for command CLEAN /RESTART
  !
  !   Subtract a Starting List of Clean Components.
  !!
  !----------------------------------------------------------
  type(gildas), intent(in) :: head          !! Imager Header
  integer, intent(in) :: iplane             !! Current plane number
  real, intent(inout) :: resid(:,:)         !! Current residual
  real, intent(in) :: dcct(:,:,:)           !! Clean Component List (from READ CCT)
  real, intent(in) :: tfbeam(:,:,:)         !! Dirty Beam FT (Gridded UV coverage)
  type(cct_par), intent(inout) :: tcc(:)    !! Clean Component Table
  integer, intent(in) :: nfields            !! Number of fields
  real, intent(in) :: primary(:,:,:)        !! Primary beams
  real, intent(in) :: weight(:,:)           !! Mosaic weights
  real, intent(in) :: wtrun                 !! Mosaic primary beam truncation
  integer, intent(out) :: next_iter         !! Next available CC
  real, intent(out) :: start_flux           !! Cumulative flux in Starting list
  !
  ! Local ---
  integer :: isc  ! Component number
  integer :: isx, isy ! Pixel of Clean Component
  integer :: ksp  ! Plane number of Clean Component
  integer :: nx, ny   ! Image size
  integer :: np   ! Number of channels in Clean Components
  integer :: nc   ! Number of Clean Components
  integer :: ier
  integer :: i,j,k,ip ! For mosaics
  integer :: nn(2), ndim
  complex, allocatable :: fcomp(:,:)
  real, allocatable :: clean(:,:)
  real, allocatable :: wfft(:)
  logical :: do_size
  real :: sizes(20)
  integer :: n_size, is, js
  real :: fact, xinc, yinc
  integer :: ithread
  character(len=80) :: chain
  !
  ! Code ----
  ithread = 0
  !$ ithread = omp_get_thread_num()+1
  write(chain,'(A,I0,A,I0)') 'Entering CCT_REMOVE_START plane ',iplane,' thread ',ithread
  call map_message(seve%t,'CLEAN /RESTART',chain)
  nx = head%gil%dim(1) 
  ny = head%gil%dim(2)
  do_size = ubound(dcct,1).eq.4   ! Variable size Components
  np = ubound(dcct,2)   ! Number of planes in CCT
  nc = ubound(dcct,3)   ! Maximum number of Clean Components in CCT
  if (nfields.le.1) then
    isx = 1
    isy = 1
  else
    isx = nx
    isy = ny
  endif
  allocate(fcomp(nx,ny),clean(isx,isy),wfft(2*max(nx,ny)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,'CLEAN /RESTART','Memory allocation error in CCT_REMOVE_START')
    return
  endif
  !
  next_iter = nc+1 
  start_flux = 0
  n_size = 1 ! By default, only Point sources
  sizes = 0.0
  !
  do isc=1,nc
    ksp = min(np, iplane)  ! Plane number
    isx = nint( (dcct(1,ksp,isc)-head%gil%val(1)) / head%gil%inc(1) + head%gil%ref(1) )
    isy = nint( (dcct(2,ksp,isc)-head%gil%val(2)) / head%gil%inc(2) + head%gil%ref(2) )
    tcc(isc)%value = dcct(3,ksp,isc)
    tcc(isc)%size = 0
    if (tcc(isc)%value.eq.0) then
      next_iter = isc
      exit
    endif
    tcc(isc)%ix = isx
    tcc(isc)%iy = isy
    tcc(isc)%size = 0
    if (do_size) then
      js = 0
      do is=1,n_size
        if (sizes(is).eq.dcct(4,ksp,isc)) then
          js = is
          exit
        endif
      enddo
      if ((js.eq.0).and.(n_size.le.20)) then
        n_size = n_size+1
        sizes(n_size) = dcct(4,ksp,isc)
        js = n_size
      endif
      if (js.eq.0) js = n_size
      tcc(isc)%size = sizes(js)
    endif
    !
    start_flux = start_flux+tcc(isc)%value
  enddo
  tcc(next_iter)%ix = 0
  tcc(next_iter)%iy = 0
  tcc(next_iter)%value = 0
  tcc(next_iter)%size = 0
  !
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  if (n_size.eq.1) then
    !
    if (nfields.le.1) then
      fcomp = 0.0   ! Initialize
      do isc=1,next_iter-1
        fcomp(tcc(isc)%ix,tcc(isc)%iy) = fcomp(tcc(isc)%ix,tcc(isc)%iy) + cmplx(tcc(isc)%value,0.0)
      enddo
      !
      ! Remove this by Convolution with Dirty Beam
      call fourt(fcomp,nn,ndim,-1,0,wfft)
      fcomp(:,:) = fcomp*tfbeam(:,:,1)
      call fourt(fcomp,nn,ndim,1,1,wfft)
      resid = resid-real(fcomp)
    else
      ! Optimized by using CLEAN to store sum of components before multiplying
      ! by the weights to subtract from the Residuals
      clean = 0.0
      do ip=1,nfields
        fcomp = 0.0
        do k=1,next_iter-1
          fcomp(tcc(k)%ix,tcc(k)%iy) = tcc(k)%value   &
       &          * primary(ip,tcc(k)%ix,tcc(k)%iy)
        enddo
        call fourt(fcomp,nn,ndim,-1,0,wfft)
        fcomp(:,:) = fcomp*tfbeam(:,:,ip)
        call fourt(fcomp,nn,ndim,1,1,wfft)
        do j=1,ny
          do i=1,nx
            if (primary(ip,i,j).gt.wtrun) then
              clean(i,j) = clean(i,j) + real(fcomp(i,j))   &
       &              *primary(ip,i,j)
            endif
          enddo
        enddo
      enddo
      resid = resid - clean*weight
    endif
  else
    if (nfields.gt.1) call map_message(seve%w,'CLEAN /RESTART', &
      & 'Restarting from GCLEAN component list under debug for Mosaics')
    !
    fact = 1.0 ! or 1.0/(nx*ny) ! or 1 ?
    xinc = head%gil%inc(1)
    yinc = head%gil%inc(2)
    !
    do is=1,n_size
      if (nfields.le.1) then
        fcomp = 0.0   ! Initialize
        do isc=1,next_iter-1
          if (tcc(isc)%size.eq.sizes(is)) fcomp(tcc(isc)%ix,tcc(isc)%iy) = &
            & fcomp(tcc(isc)%ix,tcc(isc)%iy) + cmplx(tcc(isc)%value,0.0)
        enddo
        !
        ! Remove this by Convolution with Dirty Beam
        call fourt(fcomp,nn,ndim,-1,0,wfft)
        fcomp(:,:) = fcomp*tfbeam(:,:,1)
        ! Smooth by the Gaussian
        if (sizes(is).ne.0) then
          call mulgau(fcomp,nx,ny,   &
             &    sizes(is),sizes(is),0.0,  &
             &    fact,xinc,yinc,-1)
        endif
        call fourt(fcomp,nn,ndim,1,1,wfft)
        resid = resid-real(fcomp)
      else
        ! Optimized by using CLEAN to store sum of components before multiplying
        ! by the weights to subtract from the Residuals
        clean = 0.0
        do ip=1,nfields
          fcomp = 0.0
          do k=1,next_iter-1
            if (tcc(k)%size.eq.sizes(is)) fcomp(tcc(k)%ix,tcc(k)%iy) = tcc(k)%value   &
         &          * primary(ip,tcc(k)%ix,tcc(k)%iy)
          enddo
          call fourt(fcomp,nn,ndim,-1,0,wfft)
          fcomp(:,:) = fcomp*tfbeam(:,:,ip)
          ! Smooth by the Gaussian - WARNING - The convolution should have been done before
          ! the Primary beam attenuation in strict theory...
          if (sizes(is).ne.0) then
            call mulgau(fcomp,nx,ny,   &
               &    sizes(is),sizes(is),0.0,  &
               &    fact,xinc,yinc,-1)
          endif
          call fourt(fcomp,nn,ndim,1,1,wfft)
          do j=1,ny
            do i=1,nx
              if (primary(ip,i,j).gt.wtrun) then
                clean(i,j) = clean(i,j) + real(fcomp(i,j))   &
         &              *primary(ip,i,j)
              endif
            enddo
          enddo
        enddo
        resid = resid - clean*weight
      endif
    enddo
    !
  endif
  deallocate(fcomp,clean,wfft,stat=ier)
  !
end subroutine cct_remove_start
!
subroutine uv_compact_clean(hcct,ccin,occt,ccou, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Support for command UV_RESTORE
  !
  !   Compact the component list by summing up all values at the
  !   same position
  !!
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct    !! header of Input CCT data set
  type(gildas), intent(in) :: occt    !! header of output CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  !! Input CCT data set
  real, intent(out) :: ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3))
  !! Output CCT data set
  integer, intent(inout) :: mic       !! Last valid component
  !
  ! Local ---
  integer nc
  integer ni
  integer :: ii,jj,ic
  integer :: ki, mi     ! Number of different components per channel
  logical :: doit, do_size
  integer :: scc
  !
  ! Code ----
  nc = hcct%gil%dim(2)
  ni = mic              ! no longer equal to hcct%gil%dim(3)
  scc = hcct%gil%dim(1) ! Size of a Clean Component (3 or 4)
  do_size = scc.eq.4    ! Check size if needed
  !
  mi = 0
  ccou = 0
  !
  do ic=1,nc
    ki = 0
    do ii=1,ni
      if (ccin(3,ic,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,ic,jj).eq.ccin(1,ic,ii)) then
            if (ccou(2,ic,jj).eq.ccin(2,ic,ii)) then
              if (do_size) then
                if (ccou(4,ic,jj).eq.ccin(4,ic,ii)) then
                  doit = .false.
                  ccou(3,ic,jj) = ccou(3,ic,jj) + ccin(3,ic,ii)
                  exit
                endif
              else
                doit = .false.
                !TEST! Print *,'Component ',ii,' relocated at ',jj
                ccou(3,ic,jj) = ccou(3,ic,jj) + ccin(3,ic,ii)
                exit
              endif
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          !TEST! Print *,'Component ',ii,' new at ',ki
          ccou(1:scc,ic,ki) = ccin(1:scc,ic,ii)
        endif
      endif
    enddo
    if (ki.ne.0) mi = max(mi,ki)
  enddo
  !
  mic = mi
end subroutine uv_compact_clean
!
subroutine cct_prepare(line,nsizes,a_method,task,error)
  use gkernel_interfaces
  use imager_interfaces, only : get_i4list_fromsic, get_r4list_fromsic, & 
    & map_message, sub_read_image, reallocate_cct
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !---------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command CLEAN 
  !
  !   Prepare the Clean Component Table for further use
  !!
  !---------------------------------------------------
  character(len=*), intent(in) :: line      !! Command line
  integer, intent(in) :: nsizes(3)          !! Cube Size
  type(clean_par), intent(in) :: a_method   !! Input method
  character(len=*), intent(in) :: task      !! Caller name
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Constants
  integer, parameter :: opt_ares=5   ! /ARES 
  integer, parameter :: opt_range=10 ! No /RANGE option there
  integer, parameter :: cct_type=10
  integer, parameter :: opt_iter=4
  !
  ! Local ---
  integer :: nc                 ! Number of channels
  character(len=filename_length) :: name
  character(len=120) :: mess
  integer(kind=4) :: ier,x_iter,ns,i,n
  real, allocatable :: tcct(:,:,:)
  logical :: restart
  real(8) :: drange(2)          ! Range to be read (0,0)
  character(len=12) :: crange  ! Type of range
  logical :: compact
  integer :: cctsize
  integer :: opt_start
  !
  ! Code ----
  nc = nsizes(3)
  error = .false.
  x_iter = a_method%m_iter
  !
  ! Use up to nc = hdirty%gil%dim(3)
  if (sic_present(opt_iter,0)) then
    niter_listsize = hdirty%gil%dim(3)
    if (allocated(niter_list)) deallocate(niter_list)
    allocate(niter_list(niter_listsize),stat=ier)
    call get_i4list_fromsic(task,line,opt_iter,niter_listsize, &
      & niter_list,error)
    if (error) return
    ! 
    x_iter = maxval(niter_list)
  endif
  !
  if (sic_present(opt_ares,0)) then
    ares_listsize = hdirty%gil%dim(3)
    if (allocated(ares_list)) deallocate(ares_list)
    allocate(ares_list(ares_listsize),stat=ier)
    call get_r4list_fromsic(task,line,opt_ares,ares_listsize, &
      & ares_list,error)
    if (error) return
  endif
  !
  ! /RESTART [FileName]  option
  if (a_method%restart.ne.0) then 
    opt_start = a_method%restart
    !
    if (sic_present(opt_start,1)) then 
      !
      ! Load new CCT table if specified
      call sic_ch(line,opt_start,1,name,n,.true.,error)
      if (error) return
      !
      ! Read specified data file as Clean Component Table
      drange = 0.d0
      crange = 'CHANNEL'
      compact = .false.
      call sub_read_image (name,cct_type,drange,crange,compact,opt_range,error)
      if (error) return  
    else
      ! 
      ! Use Current CCT as Start Model
      if (.not.allocated(dcct)) then
        call map_message(seve%e,task,'No starting Clean Component table')
        error = .true.
        return
      endif
    endif
    x_iter = hcct%gil%dim(3)    ! Required in all cases: number of clean components.
    ns = ubound(dcct,2)         ! and number of channels.
    !
    ! Must match the number of channels, or be one...
    ! This may be incompatible with the FIRST and LAST stuff...
    if ((ns.ne.nc).and.(ns.ne.1)) then
      call map_message(seve%e,task,'Number of channels do not match ')
      error = .true.
      return
    endif
    !
    ! Here, save the available CCT as Start Model.
    restart = .true.
    write(mess,'(A,I0,A)') 'Re-using ',ns,' channels from previous Clean Component Table'
    call map_message(seve%i,task,mess,3)
  else 
    restart = .false.
  endif
  !
  if (a_method%method.eq.'MULTI') then
    x_iter = a_method%ninflate*x_iter
    x_iter = min(x_iter,nsizes(1)*nsizes(2))
    !!print *,'CCT-Prepare, Method MULTI ',a_method%m_iter,x_iter
  endif
  !print *,'CCT-Prepare, FIRST ',a_method%first,' LAST ',a_method%last
  call sic_delvariable('CCT',.false.,error)
  error = .false.  ! Not an error if no such variable
  !
  cctsize = 3
  x_iter = max(1,x_iter)
  if (.not.restart) then
    if (a_method%method.eq.'GAUSS') cctsize = 4
    call reallocate_cct(cctsize,nc,x_iter,dcct,error)
    if (error)  return
    ! Nullify the channels to be used: a 0 flux component indicates 
    ! the last valid one.
    dcct(:,a_method%first:a_method%last,1) = 0.  
  else
    cctsize = size(dcct,1)
    if (a_method%n_iter.ne.0) then
      if (x_iter.lt.hcct%gil%dim(3)) then
        write(mess,'(A,I0,A,I0,A)') 'More components in start model (',hcct%gil%dim(3), &
          & ' than allowed total (',x_iter,')'
        call map_message(seve%w,task,mess)
        x_iter = 2*hcct%gil%dim(3)    ! TEST
      endif
    endif
    !
    if (ns.ne.nc) then
      ! Continuum + Line case: restart from continuum
      allocate(tcct(cctsize,1,hcct%gil%dim(3)),stat=ier)
      tcct(:,:,:) = dcct
      call reallocate_cct(cctsize,nc,x_iter,dcct,error)
      do i=1,nc
        dcct(:,i,1:hcct%gil%dim(3)) = tcct(:,1,:)
      enddo
      !
      ! Nullify the next Clean Component
      if (x_iter.gt.hcct%gil%dim(3)) then
        dcct(:,:,hcct%gil%dim(3)+1:x_iter) = 0
      endif
    else
      ! Reallocate_cct does the job properly
      call reallocate_cct(cctsize,nc,x_iter,dcct,error)
      if (error)  return
    endif
  endif
  !
  ! Define the image header
  call gildas_null(hcct)
  call gdf_copy_header (hdirty,hcct,error)
  hcct%gil%ndim = 3
  hcct%char%unit = 'Jy'
  !
  hcct%gil%dim(1) = cctsize
  ! Keep the same axis description
  hcct%gil%xaxi = 1
  !
  hcct%gil%convert(:,2) = hdirty%gil%convert(:,3)
  hcct%gil%convert(:,3) = hdirty%gil%convert(:,2)
  hcct%gil%dim(2) = hdirty%gil%dim(3)
  hcct%char%code(2) = hdirty%char%code(3)
  hcct%gil%faxi = 2
  hcct%gil%dim(3) = x_iter
  hcct%char%code(3) = 'COMPONENT'
  hcct%gil%yaxi = 3
  hcct%loca%size = hcct%gil%dim(1)*hcct%gil%dim(2)*hcct%gil%dim(3)
  !
  ! Initialize BLCs...
  hcct%blc = 0
  hcct%trc = 0
  !
end subroutine cct_prepare
!
subroutine reallocate_cct(n1,n2,n3,array,error)
  use gbl_message
  use gkernel_interfaces, only : failed_allocate
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Basic utility 
  ! 
  ! (re)allocate the CCT allocatable array.
  ! If only the last dimension is enlarged, the previous contents are
  ! kept. Otherwise, the data is initialized to 0.
  !!
  !-------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: n1,n2,n3        !! New dimensions
  real(kind=4), allocatable, intent(inout) :: array(:,:,:)    !! Array to be re-allocated
  logical,                   intent(inout) :: error           !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: task='CCT'
  ! Local ---
  character(len=message_length) :: mess
  logical :: keep, quiet, old
  integer(kind=4) :: ier,oldn1,oldn2,oldn3
  real(kind=4), allocatable :: tmp(:,:,:)
  !
  ! Code ----
  if (n1.le.0 .or. n2.le.0 .or. n3.le.0) then
    write(mess,'(A,3(I0,A))')  &
      'CCT size can not be zero nor negative (got n1 x n2 x n3 = ',  &
      n1,'x',n2,'x',n3,')'
    call map_message(seve%e,task,mess)
    error = .true.
    return
  endif
  !
  keep = .false.
  quiet = error
  error = .false.
  old = allocated(array)
  !
  if (old) then
    oldn1 = ubound(array,1)
    oldn2 = ubound(array,2)
    oldn3 = ubound(array,3)
    if (oldn1.eq.n1 .and.  &  ! Strict equality
        oldn2.eq.n2 .and.  &  ! Strict equality
        oldn3.ge.n3) then     ! Greater or equal
      if (quiet) return
      write(mess,'(a,i0,a,i0,a,i0,a)')  &
        'Re-using CCT table of size [',oldn1,',',oldn2,',',oldn3,']'
      call map_message(seve%i,task,mess)
      return
    endif
    !
    if (oldn1.eq.n1 .and.  &  ! Strict equality
        oldn2.eq.n2) then     ! Strict equality
      ! The 2 first dimensions are not modified, only the third is enlarged.
      ! Data will be kept.
      keep = .true.
      call move_alloc(from=array,to=tmp)    ! 'array' is now deallocated
    else
      deallocate(array)
    endif
  endif
  !
  ! Allocation
  allocate(array(n1,n2,n3),stat=ier)
  if (failed_allocate(task,'ARRAY',ier,error))  return
  !
  if (.not.quiet) then
    if (old) then
      write(mess,'(a,i0,a,i0,a,i0,a,i0,a,i0,a,i0,a)')  &
        'Extended CCT table size from [',oldn1,',',oldn2,',',oldn3,'], to [' &
        & ,n1,',',n2,',',n3,']'
      if (keep) mess = trim(mess)//' with copy'
    else
      write(mess,'(a,i0,a,i0,a,i0,a)')  &
      'Allocated new CCT table of size [',n1,',',n2,',',n3,']'
    endif
    call map_message(seve%i,task,mess)
  endif
  !
  ! Back copy
  if (keep) then
    array(:,:,1:oldn3) = tmp(:,:,1:oldn3)
    array(:,:,oldn3+1:n3) = 0.
    deallocate(tmp)
  else
    array(:,:,1) = 0.
  endif
  !
end subroutine reallocate_cct

module sic_interfaces_private_c
  !---------------------------------------------------------------------
  ! @ private
  ! Private interfaces to C routines (hand made)
  !---------------------------------------------------------------------
  !
  interface
    function gpy_callfuncs(nargs,indx,strides,nwords,memory,a)
    use gildas_def
    integer(kind=4) :: gpy_callfuncs
    integer(kind=4),              intent(in)  :: nargs       !
    integer(kind=address_length), intent(in)  :: indx        ! a C size_t integer
    integer(kind=4),              intent(in)  :: strides(*)  !
    integer(kind=address_length), intent(in)  :: nwords(*)   ! a C size_t integer
    integer(kind=4),              intent(in)  :: memory(*)   ! The usual 'memory' array
    real(kind=4),                 intent(out) :: a           !
    end function gpy_callfuncs
  end interface
  !
  interface
    function gpy_callfuncd(nargs,indx,strides,nwords,memory,a)
    use gildas_def
    integer(kind=4) :: gpy_callfuncd
    integer(kind=4),              intent(in)  :: nargs       !
    integer(kind=address_length), intent(in)  :: indx        ! a C size_t integer
    integer(kind=4),              intent(in)  :: strides(*)  !
    integer(kind=address_length), intent(in)  :: nwords(*)   ! a C size_t integer
    integer(kind=4),              intent(in)  :: memory(*)   ! The usual 'memory' array
    real(kind=8),                 intent(out) :: a           !
    end function gpy_callfuncd
  end interface
  !
end module sic_interfaces_private_c
!
module sic_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use sic_interfaces_public
  use sic_interfaces_private
  use sic_interfaces_private_c
  !
end module sic_interfaces
!
module sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! SIC dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use ginc_interfaces_public
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gmath_interfaces_public
  use gwcs_interfaces_public
  use gfits_interfaces_public
  use gio_interfaces_public
  use ggui_interfaces_public_c
  !
end module sic_dependencies_interfaces

module gmath_interfaces_public
  interface
    function gag_bessel_in(n,x)
      !-----------------------------------------------------------------------
      ! @ public
      ! This subroutine calculates the first kind modified Bessel function
      ! of integer order N, for any REAL X. We use here the classical
      ! recursion formula, when X > N. For X < N, the Miller's algorithm
      ! is used to avoid overflows.
      !
      !     REFERENCE:
      !     C.W.CLENSHAW, CHEBYSHEV SERIES FOR MATHEMATICAL FUNCTIONS,
      !     MATHEMATICAL TABLES, VOL.5, 1962.
      !-----------------------------------------------------------------------
      real(kind=8) :: gag_bessel_in
      integer(kind=4), intent(in) :: n
      real(kind=8),    intent(in) :: x
    end function gag_bessel_in
  end interface
  !
  interface
    function gag_bessel_i0(x)
      !---------------------------------------------------------------------
      ! @ public
      ! Bessel functions for N=0
      !---------------------------------------------------------------------
      real(kind=8) :: gag_bessel_i0
      real(kind=8), intent(in) :: x
    end function gag_bessel_i0
  end interface
  !
  interface
    function gag_bessel_i1(x)
      !---------------------------------------------------------------------
      ! @ public
      ! Bessel functions for N=1
      !---------------------------------------------------------------------
      real(kind=8) :: gag_bessel_i1
      real(kind=8), intent(in) :: x
    end function gag_bessel_i1
  end interface
  !
  interface gag_diff_elem
    subroutine gag_diff_char(caller,secname,secwarned,elemname,a,b)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_diff_elem
      ! Returns a message if the two elements a and b differ.
      ! If the elements are part of a larger section (name section), a
      ! warning about the section is also issued if not yet done.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: secname
      logical,          intent(inout) :: secwarned
      character(len=*), intent(in)    :: elemname
      character(len=*), intent(in)    :: a,b
    end subroutine gag_diff_char
    subroutine gag_diff_inte(caller,secname,secwarned,elemname,a,b)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_diff_elem
      ! Returns a message if the two elements a and b differ.
      ! If the elements are part of a larger section (name section), a
      ! warning about the section is also issued if not yet done.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: secname
      logical,          intent(inout) :: secwarned
      character(len=*), intent(in)    :: elemname
      integer(kind=4),  intent(in)    :: a,b
    end subroutine gag_diff_inte
    subroutine gag_diff_long(caller,secname,secwarned,elemname,a,b)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_diff_elem
      ! Returns a message if the two elements a and b differ.
      ! If the elements are part of a larger section (name section), a
      ! warning about the section is also issued if not yet done.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: secname
      logical,          intent(inout) :: secwarned
      character(len=*), intent(in)    :: elemname
      integer(kind=8),  intent(in)    :: a,b
    end subroutine gag_diff_long
    subroutine gag_diff_real(caller,secname,secwarned,elemname,a,b)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_diff_elem
      ! Returns a message if the two elements a and b differ (with some
      ! machine tolerance).
      ! If the elements are part of a larger section (name section), a
      ! warning about the section is also issued if not yet done.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: secname
      logical,          intent(inout) :: secwarned
      character(len=*), intent(in)    :: elemname
      real(kind=4),     intent(in)    :: a,b
    end subroutine gag_diff_real
    subroutine gag_diff_dble(caller,secname,secwarned,elemname,a,b)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gag_diff_elem
      ! Returns a message if the two elements a and b differ (with some
      ! machine tolerance).
      ! If the elements are part of a larger section (name section), a
      ! warning about the section is also issued if not yet done.
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: caller
      character(len=*), intent(in)    :: secname
      logical,          intent(inout) :: secwarned
      character(len=*), intent(in)    :: elemname
      real(kind=8),     intent(in)    :: a,b
    end subroutine gag_diff_dble
  end interface gag_diff_elem
  !
  interface nearly_equal
    function nearly_equal_r4_0d(a,b,eps)
      !---------------------------------------------------------------------
      ! @ public-generic nearly_equal
      !---------------------------------------------------------------------
      logical :: nearly_equal_r4_0d
      real(kind=4), intent(in) :: a,b
      real(kind=4), intent(in) :: eps  ! Acceptable relative difference
    end function nearly_equal_r4_0d
    function nearly_equal_r8_0d(a,b,eps)
      !---------------------------------------------------------------------
      ! @ public-generic nearly_equal
      !---------------------------------------------------------------------
      logical :: nearly_equal_r8_0d
      real(kind=8), intent(in) :: a,b
      real(kind=8), intent(in) :: eps  ! Acceptable relative difference
    end function nearly_equal_r8_0d
    function nearly_equal_r4_1d(a,b,ndata,eps)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-generic nearly_equal
      !---------------------------------------------------------------------
      logical :: nearly_equal_r4_1d
      integer(kind=size_length), intent(in) :: ndata
      real(kind=4),              intent(in) :: a(ndata),b(ndata)
      real(kind=4),              intent(in) :: eps  ! Acceptable relative difference
    end function nearly_equal_r4_1d
  end interface nearly_equal
  !
  interface
    function eclass_inte_eq(a,b)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two integers
      !---------------------------------------------------------------------
      logical :: eclass_inte_eq
      integer(kind=4), intent(in) :: a
      integer(kind=4), intent(in) :: b
    end function eclass_inte_eq
  end interface
  !
  interface
    function eclass_2inte_eq(i1,i2,j1,j2)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two pairs of integers
      !---------------------------------------------------------------------
      logical :: eclass_2inte_eq
      integer(kind=4), intent(in) :: i1,i2
      integer(kind=4), intent(in) :: j1,j2
    end function eclass_2inte_eq
  end interface
  !
  interface
    function eclass_2inte1char_eq(i1,i2,j1,j2,k1,k2)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two pairs of integers + 1 pair of chars
      !---------------------------------------------------------------------
      logical :: eclass_2inte1char_eq
      integer(kind=4),  intent(in) :: i1,i2
      integer(kind=4),  intent(in) :: j1,j2
      character(len=*), intent(in) :: k1,k2
    end function eclass_2inte1char_eq
  end interface
  !
  interface
    function eclass_2inte2char_eq(i1,i2,j1,j2,k1,k2,l1,l2)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two pairs of integers + 2 pairs of chars
      !---------------------------------------------------------------------
      logical :: eclass_2inte2char_eq
      integer(kind=4),  intent(in) :: i1,i2
      integer(kind=4),  intent(in) :: j1,j2
      character(len=*), intent(in) :: k1,k2
      character(len=*), intent(in) :: l1,l2
    end function eclass_2inte2char_eq
  end interface
  !
  interface
    function eclass_dble_eq(a,b)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two real*8
      ! WARNING: there is no tolerance here, because we assume we compare
      ! values which we know must be equal
      !---------------------------------------------------------------------
      logical :: eclass_dble_eq
      real(kind=8), intent(in) :: a
      real(kind=8), intent(in) :: b
    end function eclass_dble_eq
  end interface
  !
  interface
    function eclass_2dble_eq(x1,x2,y1,y2)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two pairs of real*8 (e.g. coordinates)
      ! WARNING: there is no tolerance here, because we assume we compare
      ! values which we know must be equal
      !---------------------------------------------------------------------
      logical :: eclass_2dble_eq
      real(kind=8), intent(in) :: x1,x2
      real(kind=8), intent(in) :: y1,y2
    end function eclass_2dble_eq
  end interface
  !
  interface
    function eclass_2dble3inte_eq(x1,x2,y1,y2,i1,i2,j1,j2,k1,k2)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two pairs of real*8 and two triplets of
      ! integer*4
      !---------------------------------------------------------------------
      logical :: eclass_2dble3inte_eq
      real(kind=8),    intent(in) :: x1,x2
      real(kind=8),    intent(in) :: y1,y2
      integer(kind=4), intent(in) :: i1,i2
      integer(kind=4), intent(in) :: j1,j2
      integer(kind=4), intent(in) :: k1,k2
    end function eclass_2dble3inte_eq
  end interface
  !
  interface
    function eclass_char_eq(a,b)
      !---------------------------------------------------------------------
      ! @ public
      ! Equality routine between two characters
      !---------------------------------------------------------------------
      logical :: eclass_char_eq
      character(len=*), intent(in) :: a
      character(len=*), intent(in) :: b
    end function eclass_char_eq
  end interface
  !
  interface
    subroutine eclass_inte(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,             external      :: equiv   ! l = equiv(i1,i2)
      type(eclass_inte_t), intent(inout) :: eclass  !
    end subroutine eclass_inte
  end interface
  !
  interface
    subroutine eclass_2inte(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,              external      :: equiv   !
      type(eclass_2inte_t), intent(inout) :: eclass  !
    end subroutine eclass_2inte
  end interface
  !
  interface
    subroutine eclass_2inte1char(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,                   external      :: equiv   !
      type(eclass_2inte1char_t), intent(inout) :: eclass  !
    end subroutine eclass_2inte1char
  end interface
  !
  interface
    subroutine eclass_2inte2char(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,                   external      :: equiv   !
      type(eclass_2inte2char_t), intent(inout) :: eclass  !
    end subroutine eclass_2inte2char
  end interface
  !
  interface
    subroutine eclass_dble(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,             external      :: equiv   !
      type(eclass_dble_t), intent(inout) :: eclass  !
    end subroutine eclass_dble
  end interface
  !
  interface
    subroutine eclass_2dble(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,              external      :: equiv   !
      type(eclass_2dble_t), intent(inout) :: eclass  !
    end subroutine eclass_2dble
  end interface
  !
  interface
    subroutine eclass_2dble1char(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,                   external      :: equiv   !
      type(eclass_2dble1char_t), intent(inout) :: eclass  !
    end subroutine eclass_2dble1char
  end interface
  !
  interface
    subroutine eclass_2dble3inte(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,                   external      :: equiv   !
      type(eclass_2dble3inte_t), intent(inout) :: eclass  !
    end subroutine eclass_2dble3inte
  end interface
  !
  interface
    subroutine eclass_char(equiv,eclass)
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      logical,             external      :: equiv   ! l = equiv(c1,c2)
      type(eclass_char_t), intent(inout) :: eclass  !
    end subroutine eclass_char
  end interface
  !
  interface
    subroutine reallocate_eclass_inte(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_inte_t), intent(inout) :: eclass
      integer(kind=4),     intent(in)    :: nval
      logical,             intent(inout) :: error
    end subroutine reallocate_eclass_inte
  end interface
  !
  interface
    subroutine reallocate_eclass_2inte(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte_t), intent(inout) :: eclass
      integer(kind=4),      intent(in)    :: nval
      logical,              intent(inout) :: error
    end subroutine reallocate_eclass_2inte
  end interface
  !
  interface
    subroutine reallocate_eclass_2inte1char(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte1char_t), intent(inout) :: eclass
      integer(kind=4),           intent(in)    :: nval
      logical,                   intent(inout) :: error
    end subroutine reallocate_eclass_2inte1char
  end interface
  !
  interface
    subroutine reallocate_eclass_2inte2char(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte2char_t), intent(inout) :: eclass
      integer(kind=4),           intent(in)    :: nval
      logical,                   intent(inout) :: error
    end subroutine reallocate_eclass_2inte2char
  end interface
  !
  interface
    subroutine reallocate_eclass_dble(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_dble_t), intent(inout) :: eclass
      integer(kind=4),     intent(in)    :: nval
      logical,             intent(inout) :: error
    end subroutine reallocate_eclass_dble
  end interface
  !
  interface
    subroutine reallocate_eclass_2dble(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble_t), intent(inout) :: eclass
      integer(kind=4),      intent(in)    :: nval
      logical,              intent(inout) :: error
    end subroutine reallocate_eclass_2dble
  end interface
  !
  interface
    subroutine reallocate_eclass_2dble1char(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble1char_t), intent(inout) :: eclass
      integer(kind=4),           intent(in)    :: nval
      logical,                   intent(inout) :: error
    end subroutine reallocate_eclass_2dble1char
  end interface
  !
  interface
    subroutine reallocate_eclass_2dble3inte(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble3inte_t), intent(inout) :: eclass
      integer(kind=4),           intent(in)    :: nval
      logical,                   intent(inout) :: error
    end subroutine reallocate_eclass_2dble3inte
  end interface
  !
  interface
    subroutine reallocate_eclass_char(eclass,nval,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_char_t), intent(inout) :: eclass
      integer(kind=4),     intent(in)    :: nval
      logical,             intent(inout) :: error
    end subroutine reallocate_eclass_char
  end interface
  !
  interface
    subroutine free_eclass_inte(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_inte_t), intent(inout) :: eclass
      logical,             intent(inout) :: error
    end subroutine free_eclass_inte
  end interface
  !
  interface
    subroutine free_eclass_2inte(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte_t), intent(inout) :: eclass
      logical,              intent(inout) :: error
    end subroutine free_eclass_2inte
  end interface
  !
  interface
    subroutine free_eclass_2inte1char(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte1char_t), intent(inout) :: eclass
      logical,                   intent(inout) :: error
    end subroutine free_eclass_2inte1char
  end interface
  !
  interface
    subroutine free_eclass_2inte2char(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2inte2char_t), intent(inout) :: eclass
      logical,                   intent(inout) :: error
    end subroutine free_eclass_2inte2char
  end interface
  !
  interface
    subroutine free_eclass_dble(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_dble_t), intent(inout) :: eclass
      logical,             intent(inout) :: error
    end subroutine free_eclass_dble
  end interface
  !
  interface
    subroutine free_eclass_2dble(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble_t), intent(inout) :: eclass
      logical,              intent(inout) :: error
    end subroutine free_eclass_2dble
  end interface
  !
  interface
    subroutine free_eclass_2dble1char(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble1char_t), intent(inout) :: eclass
      logical,                   intent(inout) :: error
    end subroutine free_eclass_2dble1char
  end interface
  !
  interface
    subroutine free_eclass_2dble3inte(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_2dble3inte_t), intent(inout) :: eclass
      logical,                   intent(inout) :: error
    end subroutine free_eclass_2dble3inte
  end interface
  !
  interface
    subroutine free_eclass_char(eclass,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      type(eclass_char_t), intent(inout) :: eclass
      logical,             intent(inout) :: error
    end subroutine free_eclass_char
  end interface
  !
  interface
    subroutine eclass_getnext(eclass,iclass,ielem,found,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !  Utility routine: get the index of the next element which is in the
      ! iclass-th class.
      !---------------------------------------------------------------------
      class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
      integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
      integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be 0) and next (output) value found
      logical,                intent(out)   :: found   ! Found a new element?
      logical,                intent(inout) :: error   ! Logical error flag
    end subroutine eclass_getnext
  end interface
  !
  interface
    subroutine eclass_getprev(eclass,iclass,ielem,found,error)
      use gbl_message
      use eclass_types
      !---------------------------------------------------------------------
      ! @ public
      !  Utility routine: get the index of the previous element which is in
      ! the iclass-th class.
      !---------------------------------------------------------------------
      class(eclass_common_t), intent(in)    :: eclass  ! The equivalence classes
      integer(kind=4),        intent(in)    :: iclass  ! The ith equivalence class we search into
      integer(kind=4),        intent(inout) :: ielem   ! Starting point (can be N+1) and previous (output) value found
      logical,                intent(out)   :: found   ! Found a new element?
      logical,                intent(inout) :: error   ! Logical error flag
    end subroutine eclass_getprev
  end interface
  !
  interface
    function gag_erfinv(x0)
      use phys_const
      !-----------------------------------------------------------------------
      ! @ public
      ! This subroutine calculates the inverse error function.
      !-----------------------------------------------------------------------
      real(kind=8) :: gag_erfinv
      real(kind=8), intent(in) :: x0
    end function gag_erfinv
  end interface
  !
  interface
    function gag_erfcinv(x)
      !-----------------------------------------------------------------------
      ! @ public
      ! This subroutine calculates the inverse complementary error function.
      !-----------------------------------------------------------------------
      real(kind=8) :: gag_erfcinv
      real(kind=8), intent(in) :: x
    end function gag_erfcinv
  end interface
  !
  interface
    subroutine gr4_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
      use gildas_def
      use gbl_message
      !$ use omp_lib
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is renamed elsewhere)
      ! Find extrema of a (Real*4) array.
      ! +/- Infinity are considered as valid extrema is this routine
      ! See GR4_MINMAX for a version which ignores Infinity
      !
      !     Ignore NaNs and all "blanked" values.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nxy     ! Number of values
      real(kind=4),              intent(in)    :: z(nxy)  ! Values
      real(kind=4),              intent(in)    :: bval    ! Blanking
      real(kind=4),              intent(in)    :: eval    ! Tolerance
      real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
      real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
      integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
      integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
    end subroutine gr4_extrema
  end interface
  !
  interface
    subroutine gr8_extrema (nxy,z,bval,eval,zmin,zmax,nmin,nmax)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is renamed elsewhere)
      ! Find extrema of a (Real*8) array
      ! +/- Infinity are considered as valid extrema is this routine
      ! See GR8_MINMAX for a version which ignores Infinity
      !!
      !     Ignore NaNs and all "blanked" values.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: nxy     ! Number of values
      real(kind=8),              intent(in)    :: z(nxy)  ! Values
      real(kind=4),              intent(in)    :: bval    ! Blanking
      real(kind=4),              intent(in)    :: eval    ! Tolerance
      real(kind=4),              intent(inout) :: zmin    ! Unchanged if no valid value
      real(kind=4),              intent(inout) :: zmax    ! Unchanged if no valid value
      integer(kind=size_length), intent(out)   :: nmin    ! Set to 0 if no valid value
      integer(kind=size_length), intent(out)   :: nmax    ! Set to 0 if no valid value
    end subroutine gr8_extrema
  end interface
  !
  interface
    subroutine gr4_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! Protect against NaN and INFs even without blanking
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: nxy     !
      real(kind=4),              intent(in)  :: z(nxy)  !
      real(kind=4),              intent(in)  :: bval    !
      real(kind=4),              intent(in)  :: eval    !
      real(kind=4),              intent(out) :: zmin    !
      real(kind=4),              intent(out) :: zmax    !
      integer(kind=size_length), intent(out) :: nmin    !
      integer(kind=size_length), intent(out) :: nmax    !
    end subroutine gr4_minmax
  end interface
  !
  interface
    subroutine gr8_minmax(nxy,z,bval,eval,zmin,zmax,nmin,nmax)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! Protect against NaN and INFs even without blanking
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: nxy     !
      real(kind=8),              intent(in)  :: z(nxy)  !
      real(kind=8),              intent(in)  :: bval    !
      real(kind=8),              intent(in)  :: eval    !
      real(kind=8),              intent(out) :: zmin    !
      real(kind=8),              intent(out) :: zmax    !
      integer(kind=size_length), intent(out) :: nmin    !
      integer(kind=size_length), intent(out) :: nmax    !
    end subroutine gr8_minmax
  end interface
  !
  interface
    subroutine gr4_median(data,ndata,bval,eval,median,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: ndata        ! Array size
      real(kind=4),              intent(in)    :: data(ndata)  ! Data
      real(kind=4),              intent(in)    :: bval         ! Blanking value
      real(kind=4),              intent(in)    :: eval         ! Tolerance
      real(kind=4),              intent(inout) :: median       ! Median of input array
      logical,                   intent(inout) :: error        ! Logical error flag
    end subroutine gr4_median
  end interface
  !
  interface
    subroutine gr8_median(data,ndata,bval,eval,median,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: ndata        ! Array size
      real(kind=8),              intent(in)    :: data(ndata)  ! Data
      real(kind=8),              intent(in)    :: bval         ! Blanking value
      real(kind=8),              intent(in)    :: eval         ! Tolerance
      real(kind=8),              intent(inout) :: median       ! Median of input array
      logical,                   intent(inout) :: error        ! Logical error flag
    end subroutine gr8_median
  end interface
  !
  interface
    subroutine gr4_dicho(np,x,xval,ival)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: np     ! Number of input points
      real(kind=4),              intent(in)  :: x(np)  ! Input ordered Values
      real(kind=4),              intent(in)  :: xval   ! The value we search for
      integer(kind=size_length), intent(out) :: ival   ! Position in the array
    end subroutine gr4_dicho
  end interface
  !
  interface
    subroutine gr8_dicho(np,x,xval,ceil,ival,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: np     ! Number of input points
      real(kind=8),              intent(in)    :: x(np)  ! Input ordered Values
      real(kind=8),              intent(in)    :: xval   ! The value we search for
      logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
      integer(kind=size_length), intent(out)   :: ival   ! Position in the array
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine gr8_dicho
  end interface
  !
  interface
    subroutine gi4_dicho(np,x,xval,ceil,ival,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: np     ! Number of input points
      integer(kind=4),           intent(in)    :: x(np)  ! Input ordered Values
      integer(kind=4),           intent(in)    :: xval   ! The value we search for
      logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
      integer(kind=size_length), intent(out)   :: ival   ! Position in the array
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine gi4_dicho
  end interface
  !
  interface
    subroutine gi8_dicho(np,x,xval,ceil,ival,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)    :: np     ! Number of input points
      integer(kind=8),           intent(in)    :: x(np)  ! Input ordered Values
      integer(kind=8),           intent(in)    :: xval   ! The value we search for
      logical,                   intent(in)    :: ceil   ! Ceiling or floor mode?
      integer(kind=size_length), intent(out)   :: ival   ! Position in the array
      logical,                   intent(inout) :: error  ! Logical error flag
    end subroutine gi8_dicho
  end interface
  !
  interface
    subroutine gr4_mean(x,nelem,bval,eval,out)
      !$ use omp_lib
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !   Protected against NaNs and Using Blanking Values. If Blanking
      ! enabled, will return blanking value if no valid result. If Blanking
      ! is not enabled, will return NaN if no valid result.
      !   R*4 version.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
      real(kind=4),              intent(in)  :: x(nelem)  ! Data values to compute
      real(kind=4),              intent(in)  :: bval      ! Blanking value
      real(kind=4),              intent(in)  :: eval      ! Blanking tolerance
      real(kind=4),              intent(out) :: out       ! Output scalar value
    end subroutine gr4_mean
  end interface
  !
  interface
    subroutine gr8_mean(x,nelem,bval,eval,out)
      !$ use omp_lib
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !   Protected against NaNs and Using Blanking Values. If Blanking
      ! enabled, will return blanking value if no valid result. If Blanking
      ! is not enabled, will return NaN if no valid result.
      !   R*8 version.
      !---------------------------------------------------------------------
      integer(kind=size_length), intent(in)  :: nelem     ! Number of data values
      real(kind=8),              intent(in)  :: x(nelem)  ! Data values to compute
      real(kind=8),              intent(in)  :: bval      ! Blanking value
      real(kind=8),              intent(in)  :: eval      ! Blanking tolerance
      real(kind=8),              intent(out) :: out       ! Output scalar value
    end subroutine gr8_mean
  end interface
  !
  interface gi0_dicho_with_user_ltgt
    subroutine gi4_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi0_dicho_with_user_ltgt
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: np     ! Number of elements in array
      logical,         intent(in)    :: ceil   ! Ceiling mode?
      integer(kind=4), intent(out)   :: ival   ! Deduced position in the array
      logical,         external      :: ult    ! User lower than
      logical,         external      :: ugt    ! User greater than
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine gi4_dicho_with_user_ltgt
    subroutine gi8_dicho_with_user_ltgt(np,ceil,ival,ult,ugt,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi0_dicho_with_user_ltgt
      !  Find ival such as
      !    X(ival-1) < xval <= X(ival)     (ceiling mode)
      !  or
      !    X(ival) <= xval < X(ival+1)     (floor mode)
      ! for input data ordered. Use a dichotomic search for that.
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: np     ! Number of elements in array
      logical,         intent(in)    :: ceil   ! Ceiling mode?
      integer(kind=8), intent(out)   :: ival   ! Deduced position in the array
      logical,         external      :: ult    ! User lower than
      logical,         external      :: ugt    ! User greater than
      logical,         intent(inout) :: error  ! Logical error flag
    end subroutine gi8_dicho_with_user_ltgt
  end interface gi0_dicho_with_user_ltgt
  !
  interface
    subroutine extoin(fit,pint)
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Transforms the external parameter values X  to internal
      !      values in the dense array PINT.   Function PINTF is used.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit      !
      real(kind=8),       intent(out)   :: pint(2)  ! Dense array
    end subroutine extoin
  end interface
  !
  interface
    subroutine hesse(fit,fcn)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Calculates the full second-derivative matrix of FCN
      !      by taking finite differences.   Includes some safeguards
      !      against non-positive-definite matrices, and it may set
      !       off-diagonal elements to zero in attempt to force
      !      positiveness.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit  !
      external                          :: fcn  ! Function to minimise
    end subroutine hesse
  end interface
  !
  interface
    subroutine intoex(fit,pint)
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Transforms from internal coordinates (PINT) to external
      !      parameters (U).   The minimizing routines which work in
      !      internal coordinates call this routine before calling FCN.
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit      !
      real(kind=8),       intent(in)    :: pint(2)  ! Dense array
    end subroutine intoex
  end interface
  !
  interface
    subroutine migrad(fit,fcn,ier)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Performs a local function minimization using basically the
      !      method of DAVIDON-FLETCHER-POWELL as modified by FLETCHER
      !      Ref. -- FLETCHER, COMP.J. 13,317 (1970)   "Switching method"
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit  !
      external                          :: fcn  ! Function to minimise
      integer(kind=4),    intent(out)   :: ier  ! Error condition flag for HESSE
    end subroutine migrad
  end interface
  !
  interface
    function pintf(fit,pexti,i)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Calculates the internal parameter value PINTF corresponding
      !      to the external value PEXTI for parameter I.
      !----------------------------------------------------------------------
      real(kind=8) :: pintf  ! Function value on return
      type(fit_minuit_t), intent(inout) :: fit    !
      real(kind=8),       intent(inout) :: pexti  ! External value
      integer(kind=4),    intent(in)    :: i      ! Parameter number
    end function pintf
  end interface
  !
  interface
    subroutine simplx(fit,fcn,ier)
      use gbl_message
      use fit_minuit
      !----------------------------------------------------------------------
      ! @ public
      !      Performs a minimization using the SIMPLEX method of NELDER
      !      and MEAD (REF. -- COMP. J. 7,308 (1965)).
      !----------------------------------------------------------------------
      type(fit_minuit_t), intent(inout) :: fit  !
      external                          :: fcn  ! Function to minimize
      integer(kind=4),    intent(out)   :: ier  ! Error condition flag
    end subroutine simplx
  end interface
  !
  interface
    subroutine fourt_set_usage(status)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Toggle the use of FFTW and its Debug mode, and
      !   return the previous status
      !---------------------------------------------------------------------
      logical, intent(inout) :: status(2)  !  Use and Debug FFTW code ?
    end subroutine fourt_set_usage
  end interface
  !
  interface
    subroutine fourt_get_usage(status) 
      !---------------------------------------------------------------------
      ! @ public
      !   Toggle the use of FFTW and its Debug mode, and
      !   return the previous status 
      !---------------------------------------------------------------------
      logical, intent(out) :: status(2)    !  Use and Debug FFTW code ?
    end subroutine fourt_get_usage
  end interface
  !
  interface
    subroutine fourt_plan(data,nn,ndim,isign,iform)
      !$ use omp_lib
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is renamed elsewhere)
      ! Fast Fourier Transform Planner
      !
      ! If the data is of type Real (IFORM=0), the imaginary part should be
      ! set to 0. WORK should be dimensionned to twice the largest dimension.
      !
      ! NOTES:
      !     Calls FFTW when available, if FFTW_USE is set.
      !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
      !         based on near-optimal Split-Radix method of P.Duhamel.
      !     Calls the Cooley-Tukey FOURTCT in other cases.
      !---------------------------------------------------------------------
      complex(kind=4) :: data(*)  ! Complex array of data             Input/Output
      integer(kind=4) :: nn(*)    ! Dimensions of data array          Input
      integer(kind=4) :: ndim     ! Number of dimensions              Input
      integer(kind=4) :: isign    ! Sign of FT (-1 Direct, 1 Inverse) Input
      integer(kind=4) :: iform    ! Type of data (0 Real, 1 Complex)  (Unused)
    end subroutine fourt_plan
  end interface
  !
  interface
    subroutine fourt(data,nn,ndim,isign,iform,work)
      !$ use omp_lib
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is renamed elsewhere)
      ! Fast Fourier Transform
      !
      ! If the data is of type Real (IFORM=0), the imaginary part should be
      ! set to 0. WORK should be dimensioned to twice the largest dimension.
      !
      ! NOTES:
      !  For COMPLEX (IFORM=1) transforms
      !     Calls FFTW when available
      !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2,
      !         based on near-optimal Split-Radix method of P.Duhamel.
      !     Calls the Cooley-Tukey FOURTCT in other cases.
      !  For REAL (IFORM=0) transforms
      !     Calls FFTW when available, but in COMPLEX mode only
      !     Calls specialized procedures for 1-D and 2-D FFT with powers of 2.
      !     Calls the Cooley-Tukey FOURTCT in other cases.
      !  data(*) is declared as "complex (*)" here for the interface,
      !     but passed to subroutines treating it as "real (2,*)"
      !---------------------------------------------------------------------
      complex(kind=4), intent(inout) :: data(*)  ! Complex array of data
      integer(kind=4), intent(in)    :: nn(*)    ! Dimensions of data array
      integer(kind=4), intent(in)    :: ndim     ! Number of dimensions
      integer(kind=4), intent(in)    :: isign    ! Sign of FT (-1 Direct, 1 Inverse)
      integer(kind=4), intent(in)    :: iform    ! Type of data (0 Real, 1 Complex)
      real(kind=4)                   :: work(*)  ! Work space
    end subroutine fourt
  end interface
  !
  interface
    function power_of_two(dim)
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      integer(kind=4) :: power_of_two     ! Value on return
      integer(kind=4), intent(in) :: dim  !
    end function power_of_two
  end interface
  !
  interface
    subroutine gi4_round_forfft(isize,osize,error,tolerance,exponent)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      !  Find the nearest number in the form 2^n 3^p 5^q with p and q
      ! smaller than Exponent (can be 0, then only powers of two are
      ! returned.)
      !
      !  Round to near if within Tolerance. Use Ceiling if not.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)           :: isize      ! Input size
      integer(kind=4), intent(out)          :: osize      ! Output size
      real(kind=4),    intent(in), optional :: tolerance  ! Tolerance
      integer(kind=4), intent(in), optional :: exponent   ! Max exponent
      logical,         intent(inout)        :: error      !
    end subroutine gi4_round_forfft
  end interface
  !
  interface
    function s_gaussian1d(x,xcent,fwhm)
      !---------------------------------------------------------------------
      ! @ public
      ! Compute gaussian value at X, peaks at 1 (single precision)
      !---------------------------------------------------------------------
      real(kind=4) :: s_gaussian1d
      real(kind=4), intent(in) :: x
      real(kind=4), intent(in) :: xcent
      real(kind=4), intent(in) :: fwhm
    end function s_gaussian1d
  end interface
  !
  interface
    function d_gaussian1d(x,xcent,fwhm)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      ! Compute gaussian value at X, peaks at 1 (double precision)
      !---------------------------------------------------------------------
      real(kind=8) :: d_gaussian1d
      real(kind=8), intent(in) :: x
      real(kind=8), intent(in) :: xcent
      real(kind=8), intent(in) :: fwhm
    end function d_gaussian1d
  end interface
  !
  interface
    function s_normal1d(x,xcent,sigma)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      ! Compute normal distribution value at X, area is 1 (single precision)
      !---------------------------------------------------------------------
      real(kind=4) :: s_normal1d
      real(kind=4), intent(in) :: x
      real(kind=4), intent(in) :: xcent
      real(kind=4), intent(in) :: sigma
    end function s_normal1d
  end interface
  !
  interface
    function d_normal1d(x,xcent,sigma)
      use phys_const
      !---------------------------------------------------------------------
      ! @ public
      ! Compute normal distribution value at X, area is 1 (double precision)
      !---------------------------------------------------------------------
      real(kind=8) :: d_normal1d
      real(kind=8), intent(in) :: x
      real(kind=8), intent(in) :: xcent
      real(kind=8), intent(in) :: sigma
    end function d_normal1d
  end interface
  !
  interface
    subroutine gauss2d_convolution(a1,b1,t1,a2,b2,t2,a3,b3,t3,error)
      !---------------------------------------------------------------------
      ! @ public
      ! Compute the parameters of the 2D gaussian resulting from the
      ! convolution of 2 2D gaussians:
      !   1 * 2 => 3
      ! Knowing 1 and 2 find 3.
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
      real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
      real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
      real(kind=4), intent(in)    :: a2    ! [same] Second gaussian major axis
      real(kind=4), intent(in)    :: b2    ! [same] Second gaussian minor axis
      real(kind=4), intent(in)    :: t2    ! [rad]  Second gaussian position angle
      real(kind=4), intent(out)   :: a3    ! [same] Result major axis
      real(kind=4), intent(out)   :: b3    ! [same] Result minor axis
      real(kind=4), intent(out)   :: t3    ! [rad]  Result position angle
      logical,      intent(inout) :: error ! Logical error flag
    end subroutine gauss2d_convolution
  end interface
  !
  interface
    subroutine gauss2d_deconvolution(a1,b1,t1,a3,b3,t3,a2,b2,t2,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Compute the parameters of the 2D gaussian resulting from the
      ! deconvolution of 2 2D gaussians:
      !   1 * 2 => 3
      ! Knowing 1 and 3 find 2.
      !---------------------------------------------------------------------
      real(kind=4), intent(in)    :: a1    ! [same] First gaussian major axis
      real(kind=4), intent(in)    :: b1    ! [same] First gaussian minor axis
      real(kind=4), intent(in)    :: t1    ! [rad]  First gaussian position angle
      real(kind=4), intent(in)    :: a3    ! [same] Result major axis
      real(kind=4), intent(in)    :: b3    ! [same] Result minor axis
      real(kind=4), intent(in)    :: t3    ! [rad]  Result position angle
      real(kind=4), intent(out)   :: a2    ! [same] Second gaussian major axis
      real(kind=4), intent(out)   :: b2    ! [same] Second gaussian minor axis
      real(kind=4), intent(out)   :: t2    ! [rad]  Second gaussian position angle
      logical,      intent(inout) :: error ! Logical error flag
    end subroutine gauss2d_deconvolution
  end interface
  !
  interface
    subroutine gmath_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gmath_message_set_id
  end interface
  !
  interface
    subroutine eulmat (psi,the,phi,mat)
      !---------------------------------------------------------------------
      ! @ public
      !  from Didier Despois 1980
      !  modified 30 november 1984 by Michel Perault
      !  matrice de changement de coordonnees pour une rotation d'angles d'Euler
      !  PSI, THE et PHI, given in radians.
      !  Multiplication of the euclidian coordinates of a vector in the original base
      !  by this matrix gives the coordinates in the rotated base.
      !  For example, the transformation from galactic II coordinates to equatorial
      !  1950 coordinates is obtained with PSI=33., THETA=-62.6, PHI=-282.25 degrees.
      !  The reverse transformation with PSI=282.25, THETA=62.5, PHI=-33 degrees.
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: psi       ! Euler angles (radians)
      real(kind=8), intent(in)  :: the       ! Euler angles (radians)
      real(kind=8), intent(in)  :: phi       ! Euler angles (radians)
      real(kind=8), intent(out) :: mat(3,3)  ! transformation matrix
    end subroutine eulmat
  end interface
  !
  interface
    subroutine mulmat (mat1,mat2,mat)
      !---------------------------------------------------------------------
      ! @ public
      !  multiplication of two 3 by 3 matrices
      !  Michel Perault - 1 december 1984.
      !  this routine computes MAT = MAT2 x MAT1
      !  it could be a little faster, but also less compact
      !  take care that MAT ought to be different from MAT1 and MAT2
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: mat1(3,3)  !
      real(kind=8), intent(in)  :: mat2(3,3)  !
      real(kind=8), intent(out) :: mat(3,3)   !
    end subroutine mulmat
  end interface
  !
  interface
    subroutine matvec (mat1,mat2,mat)
      !---------------------------------------------------------------------
      ! @ public
      !  multiplication of 1 3-D vector by a 3x3 matrix
      !  Michel Perault - 1 december 1984.
      !  this routine computes MAT = MAT2 x MAT1
      !  take care that MAT must be different from MAT1 and MAT2
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: mat1(3)    !
      real(kind=8), intent(in)  :: mat2(3,3)  !
      real(kind=8), intent(out) :: mat(3)     !
    end subroutine matvec
  end interface
  !
  interface
    subroutine transp (mat1,mat2)
      !---------------------------------------------------------------------
      ! @ public
      !  Transposee d'une matrice 3x3
      !  20 Septembre 1985 - Michel Perault - POM Version 2.0
      !  Appel : call TRANSP (MAT1,MAT2)  result in MAT2 = transp (MAT1)
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: mat1(9)  !
      real(kind=8), intent(out) :: mat2(9)  !
    end subroutine transp
  end interface
  !
  interface
    subroutine matinv3(a,b)
      !---------------------------------------------------------------------
      ! @ public
      ! Performs a direct calculation of the inverse of a 3x3 matrix.
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: A(3,3)  ! Matrix
      real(kind=8), intent(out) :: B(3,3)  ! Inverse matrix
    end subroutine matinv3
  end interface
  !
  interface
    subroutine gr8_sort(x,xwork,key,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Reorder a real*8 array by increasing order using the sorted indexes
      ! computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         ! Length of arrays
      real(kind=8),    intent(inout) :: x(n)      ! Unsorted array
      real(kind=8)                   :: xwork(n)  ! Working buffer
      integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
    end subroutine gr8_sort
  end interface
  !
  interface
    subroutine gr4_sort(x,xwork,key,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Reorder a real*4 array by increasing order using the sorted indexes
      ! computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         !
      real(kind=4),    intent(inout) :: x(n)      !
      real(kind=4)                   :: xwork(n)  ! Working buffer
      integer(kind=4), intent(in)    :: key(n)    !
    end subroutine gr4_sort
  end interface
  !
  interface
    subroutine gi4_sort(x,xwork,key,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Reorder an integer*4 array by increasing order using the sorted
      ! indexes computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         ! Length of arrays
      integer(kind=4), intent(inout) :: x(n)      ! Unsorted array
      integer(kind=4)                :: xwork(n)  ! Working buffer
      integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
    end subroutine gi4_sort
  end interface
  !
  interface
    subroutine gi8_sort(x,xwork,key,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Reorder an integer*8 array by increasing order using the sorted
      ! indexes computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         ! Length of arrays
      integer(kind=8), intent(inout) :: x(n)      ! Unsorted array
      integer(kind=8)                :: xwork(n)  ! Working buffer
      integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
    end subroutine gi8_sort
  end interface
  !
  interface
    subroutine gch_sort(x,xwork,key,nc,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !   Reorder a character array by increasing order using the sorted
      ! indexes computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4),   intent(in)    :: nc        ! Size of strings
      character(len=nc), intent(inout) :: x(*)      ! The array
      character(len=nc)                :: xwork(*)  ! Work buffer
      integer(kind=4),   intent(in)    :: key(*)    ! Integer array of sorted indexes
      integer(kind=4),   intent(in)    :: n         ! Length of arrays
    end subroutine gch_sort
  end interface
  !
  interface
    subroutine gl_sort(x,xwork,key,n)
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !  Reorder a logical*4 array by increasing order using the sorted
      ! indexes computed by a G*_TRIE subroutine
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n         ! Length of arrays
      logical,         intent(inout) :: x(n)      ! Unsorted array
      logical                        :: xwork(n)  ! Working buffer
      integer(kind=4), intent(in)    :: key(n)    ! Integer array of sorted indexes
    end subroutine gl_sort
  end interface
  !
  interface
    function gr8_in (x0,y0,ngon,gons,bound)
      !---------------------------------------------------------------------
      ! @ public
      ! Find if a point is within a n-gon.
      !
      ! This uses the Ray casting algorithm, counting how many times a ray
      ! starting from the point crosses the polygon boundaries. Note that
      ! there are critical conditions to be taken into account when the
      ! point is on a vertex or on a boundary or when the ray strikes
      ! through a vertex.
      ! References:
      !  https://en.wikipedia.org/wiki/Point_in_polygon
      !  https://rosettacode.org/wiki/Ray-casting_algorithm
      !---------------------------------------------------------------------
      logical :: gr8_in  ! Function value on return
      real(kind=8),    intent(in) :: x0,y0      ! Coordinate of point to test
      integer(kind=4), intent(in) :: ngon       ! Current number of summits
      real(kind=8),    intent(in) :: gons(:,:)  ! Description of polygon
      real(kind=8),    intent(in) :: bound(5)   ! Polygon boundary
    end function gr8_in
  end interface
  !
  interface gch_trie
    subroutine gch_trie_i4(x,it,n,nc,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gch_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of CHARACTER(len=*) values. Also returns
      ! an array of indexes sorted for increasing order of X which can used
      ! in GCH_SORT to reorder other arrays
      ! ---
      !  This version for I*4 indices
      !---------------------------------------------------------------------
      integer(kind=4),   intent(in)    :: n      ! Length of arrays
      integer(kind=4),   intent(in)    :: nc     ! Size of strings
      character(len=nc), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=4),   intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,           intent(out)   :: error  ! Error flag
    end subroutine gch_trie_i4
    subroutine gch_trie_i8(x,it,n,nc,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gch_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of CHARACTER(len=*) values. Also returns
      ! an array of indexes sorted for increasing order of X which can used
      ! in GCH_SORT to reorder other arrays
      ! ---
      !  This version for I*8 indices
      !---------------------------------------------------------------------
      integer(kind=8),   intent(in)    :: n      ! Length of arrays
      integer(kind=4),   intent(in)    :: nc     ! Size of strings
      character(len=nc), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=8),   intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,           intent(out)   :: error  ! Error flag
    end subroutine gch_trie_i8
  end interface gch_trie
  !
  interface gi0_quicksort_index_with_user_gtge
    subroutine gi4_quicksort_index_with_user_gtge(x,n,ugt,uge,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi0_quicksort_index_with_user_gtge
      ! Sort an integer*4 index array according to an external comparison
      ! criteria. The index array can then be used by gi4_quicksort_array
      ! to sort an associated array.
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Length of index array
      integer(kind=4), intent(inout) :: x(n)   ! Index array to be sorted
      logical,         external      :: ugt    ! User greater than
      logical,         external      :: uge    ! User greater than or equal
      logical,         intent(out)   :: error  ! Error status
    end subroutine gi4_quicksort_index_with_user_gtge
    subroutine gi8_quicksort_index_with_user_gtge(x,n,ugt,uge,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi0_quicksort_index_with_user_gtge
      ! Sort an integer*8 index array according to an external comparison
      ! criteria. The index array can then be used by gi4_quicksort_array
      ! to sort an associated array.
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: n      ! Length of index array
      integer(kind=8), intent(inout) :: x(n)   ! Index array to be sorted
      logical,         external      :: ugt    ! User greater than
      logical,         external      :: uge    ! User greater than or equal
      logical,         intent(out)   :: error  ! Error status
    end subroutine gi8_quicksort_index_with_user_gtge
  end interface gi0_quicksort_index_with_user_gtge
  !
  interface gi4_trie
    subroutine gi4_trie_i4(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi4_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of integer*4 values. Also returns an
      ! array of indexes sorted for increasing order of X which can used in
      ! GI4_SORT to reorder other arrays
      ! ---
      !  This version for I*4 indices
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Length of arrays
      integer(kind=4), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gi4_trie_i4
    subroutine gi4_trie_i8(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi4_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of integer*4 values. Also returns an
      ! array of indexes sorted for increasing order of X which can used in
      ! GI4_SORT to reorder other arrays
      ! ---
      !  This version for I*8 indices
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: n      ! Length of arrays
      integer(kind=4), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gi4_trie_i8
  end interface gi4_trie
  !
  interface gi8_trie
    subroutine gi8_trie_i4(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi8_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of integer*8 values. Also returns an
      ! array of indexes sorted for increasing order of X which can used in
      ! GI8_SORT to reorder other arrays
      ! ---
      !  This version for I*4 indices
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Length of arrays
      integer(kind=8), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gi8_trie_i4
    subroutine gi8_trie_i8(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gi8_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of integer*8 values. Also returns an
      ! array of indexes sorted for increasing order of X which can used in
      ! GI8_SORT to reorder other arrays
      ! ---
      !  This version for I*8 indices
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: n      ! Length of arrays
      integer(kind=8), intent(inout) :: x(n)   ! Unsorted array
      integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gi8_trie_i8
  end interface gi8_trie
  !
  interface gr4_trie
    subroutine gr4_trie_i4(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gr4_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of real*4 values. Also returns an array
      ! of indexes sorted for increasing order of X which can used in
      ! GR4_SORT to reorder other arrays
      ! ---
      !  This version for I*4 indices
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      !
      real(kind=4),    intent(inout) :: x(n)   !
      integer(kind=4), intent(out)   :: it(n)  !
      logical,         intent(out)   :: error  !
    end subroutine gr4_trie_i4
    subroutine gr4_trie_i8(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gr4_trie
      !  Sorting program that uses a quicksort algorithm.
      !  Applies for an input array of real*4 values. Also returns an array
      ! of indexes sorted for increasing order of X which can used in
      ! GR4_SORT to reorder other arrays
      ! ---
      !  This version for I*8 indices
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: n      !
      real(kind=4),    intent(inout) :: x(n)   !
      integer(kind=8), intent(out)   :: it(n)  !
      logical,         intent(out)   :: error  !
    end subroutine gr4_trie_i8
  end interface gr4_trie
  !
  interface gr8_trie
    subroutine gr8_trie_i4(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gr8_trie
      !  Sorting program that uses a quicksort algorithm.
      ! Applies for an input array of real*8 values. Also returns an array
      ! of indexes sorted for increasing order of X which can used in
      ! GR8_SORT to reorder other arrays
      ! ---
      !  This version for I*4 indices
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: n      ! Length of arrays
      real(kind=8),    intent(inout) :: x(n)   ! Unsorted array
      integer(kind=4), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gr8_trie_i4
    subroutine gr8_trie_i8(x,it,n,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-generic gr8_trie
      !  Sorting program that uses a quicksort algorithm.
      ! Applies for an input array of real*8 values. Also returns an array
      ! of indexes sorted for increasing order of X which can used in
      ! GR8_SORT to reorder other arrays
      ! ---
      !  This version for I*8 indices
      !---------------------------------------------------------------------
      integer(kind=8), intent(in)    :: n      ! Length of arrays
      real(kind=8),    intent(inout) :: x(n)   ! Unsorted array
      integer(kind=8), intent(out)   :: it(n)  ! Integer array of sorted indexes
      logical,         intent(out)   :: error  ! Error flag
    end subroutine gr8_trie_i8
  end interface gr8_trie
  !
  interface
    subroutine gmath_random_seed_init(error)
      !---------------------------------------------------------------------
      ! @ public
      !  Initialize the Fortran random seed. Should be called by interactive
      ! programs or tasks
      !  NB: the Fortran standard does not promise that calling
      ! RANDOM_SEED() without argument will reuse again and again the same
      ! seed. We use our own default, which is a random seed based on date
      ! and time
      !---------------------------------------------------------------------
      logical, intent(inout) :: error
    end subroutine gmath_random_seed_init
  end interface
  !
  interface
    subroutine gmath_random_seed_set(argum,error)
      !---------------------------------------------------------------------
      ! @ public
      ! (Re)set the Fortran random seed, based on the input argument:
      !  - "DATETIME": based on current date and time
      !  - "URANDOM":  based on the OS /dev/urandom, if any
      !  - "Value":    caller choice
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: argum  !
      logical,          intent(inout) :: error  !
    end subroutine gmath_random_seed_set
  end interface
  !
  interface
    function rangau(sigma)
      !---------------------------------------------------------------------
      ! @ public
      ! Normal gaussian distribution with R.M.S. equal to sigma
      ! Version 1.1 8-jun-83
      ! Algorithm from Handbook of mathematical functions
      ! Ed. Abramowitz M. and Stegun I. A. , 26.2.23 (page 933)
      !---------------------------------------------------------------------
      real(kind=4) :: rangau  !
      real(kind=4), intent(in) :: sigma  !
    end function rangau
  end interface
  !
  interface
    function gag_random()
      !---------------------------------------------------------------------
      ! @ public
      !---------------------------------------------------------------------
      real(kind=4) :: gag_random              !
    end function gag_random
  end interface
  !
  interface
    function d_noise(a)
      !---------------------------------------------------------------------
      ! @ public
      ! Double precision version
      !---------------------------------------------------------------------
      real(kind=8) :: d_noise                 !
      real(kind=8), intent(in) :: a           !
    end function d_noise
  end interface
  !
  interface
    function d_random(a)
      !---------------------------------------------------------------------
      ! @ public
      ! Double precision version
      !---------------------------------------------------------------------
      real(kind=8) :: d_random                !
      real(kind=8), intent(in) :: a           !
    end function d_random
  end interface
  !
  interface
    function s_noise(a)
      !---------------------------------------------------------------------
      ! @ public
      ! Single precision version
      !---------------------------------------------------------------------
      real(kind=4) :: s_noise                 !
      real(kind=4), intent(in) :: a           !
    end function s_noise
  end interface
  !
  interface
    function s_random(a)
      !---------------------------------------------------------------------
      ! @ public
      ! Single precision version
      !---------------------------------------------------------------------
      real(kind=4) :: s_random                !
      real(kind=4), intent(in) :: a           !
    end function s_random
  end interface
  !
  interface
    subroutine transpose_getcode(strin,strout,code,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Convert a dimension string into a transposition code, e.g.
      !   'VLM' transposed to 'LMV'  <=>  transposition code '231'
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: strin   !
      character(len=*), intent(in)    :: strout  !
      character(len=*), intent(out)   :: code    !
      logical,          intent(inout) :: error   !
    end subroutine transpose_getcode
  end interface
  !
  interface
    subroutine transpose_getorder(code,itr,mdims,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Decode transposition code into an index of axis orders
      !---------------------------------------------------------------------
      character(len=*), intent(in)    :: code        ! Transposition code
      integer(kind=4),  intent(in)    :: mdims       ! Maximum number of dimensions
      integer(kind=4),  intent(out)   :: itr(mdims)  ! Transposition index array
      logical,          intent(inout) :: error       ! Error flag
    end subroutine transpose_getorder
  end interface
  !
  interface
    subroutine transpose_getblock(idim,ndims,code,block,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !  Repack the transposition order into a general case of the following form:
      !      unchanged, swap1,  unchanged, swap2,   unchanged
      !      Nelems,    Nfirst, Nmiddle,   Nsecond, Nlast
      !---------------------------------------------------------------------
      integer(kind=4),            intent(in)    :: ndims        ! Effective or maximum number of dimensions
      integer(kind=index_length), intent(in)    :: idim(ndims)  ! Array dimensions
      character(len=*),           intent(in)    :: code         ! Transposition code
      integer(kind=index_length), intent(out)   :: block(5)     ! Resulting transposition pack
      logical,                    intent(inout) :: error        ! Error flag
    end subroutine transpose_getblock
  end interface
  !
  interface
    subroutine trans4all(x,y,nb,n1,nm,n2,nl)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! Swap the 2nd and 4th dimension among the 5 ones.
      ! This version for 4-bytes words.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nb                 !
      integer(kind=index_length), intent(in)  :: n1                 !
      integer(kind=index_length), intent(in)  :: nm                 !
      integer(kind=index_length), intent(in)  :: n2                 !
      integer(kind=index_length), intent(in)  :: nl                 !
      real(kind=4),               intent(out) :: x(nb,n2,nm,n1,nl)  !
      real(kind=4),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
    end subroutine trans4all
  end interface
  !
  interface
    subroutine trans4(in,ou,nelems,nx,nm,ny)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Swap the 2nd and 4th dimension among the 4 ones.
      ! This version for 4-bytes words.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nelems               !
      integer(kind=index_length), intent(in)  :: nx                   !
      integer(kind=index_length), intent(in)  :: nm                   !
      integer(kind=index_length), intent(in)  :: ny                   !
      real(kind=4),               intent(in)  :: in(nelems,nx,nm,ny)  !
      real(kind=4),               intent(out) :: ou(nelems,ny,nm,nx)  !
    end subroutine trans4
  end interface
  !
  interface
    subroutine trans4slice(nelems,nfirst,nmiddl,nsecon,in,kin,lin,ou,kou,lou)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      ! Swap the 2nd and 4th dimension among the 4 ones, for the slices
      ! [kin:lin] in 'nsecon' and [kou:lou] in 'nfirst'.
      ! This version for 4-bytes words.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nelems                      !
      integer(kind=index_length), intent(in)  :: nfirst                      !
      integer(kind=index_length), intent(in)  :: nmiddl                      !
      integer(kind=index_length), intent(in)  :: nsecon                      !
      integer(kind=index_length), intent(in)  :: kin,lin                     !
      integer(kind=index_length), intent(in)  :: kou,lou                     !
      real(kind=4),               intent(in)  :: in(nelems,nfirst,nmiddl,*)  !
      real(kind=4),               intent(out) :: ou(nelems,nsecon,nmiddl,*)  !
    end subroutine trans4slice
  end interface
  !
  interface
    subroutine trans8all(x,y,nb,n1,nm,n2,nl)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      ! Swap the 2nd and 4th dimension among the 5 ones.
      ! This version for 8-bytes words.
      !---------------------------------------------------------------------
      integer(kind=index_length), intent(in)  :: nb                 !
      integer(kind=index_length), intent(in)  :: n1                 !
      integer(kind=index_length), intent(in)  :: nm                 !
      integer(kind=index_length), intent(in)  :: n2                 !
      integer(kind=index_length), intent(in)  :: nl                 !
      real(kind=8),               intent(out) :: x(nb,n2,nm,n1,nl)  !
      real(kind=8),               intent(in)  :: y(nb,n1,nm,n2,nl)  !
    end subroutine trans8all
  end interface
  !
  interface
    subroutine gwavelet_subtract(iorder,wavelets,vec,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Subtract the ith order when asked
      !---------------------------------------------------------------------
      integer(kind=4), intent(in)    :: iorder 
      real(kind=4),    intent(in)    :: wavelets(:,:)
      real(kind=4),    intent(inout) :: vec(:)
      logical,         intent(inout) :: error
    end subroutine gwavelet_subtract
  end interface
  !
  interface
    subroutine gwavelet_gaps(vec1,wavelets1,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Compute the wavelets for an input 1D data
      ! Take care of edge effects by mirroring the vector at each edge
      ! On return the input 'wavelets' array has been allocated and filled
      !---------------------------------------------------------------------
      real(kind=4),              intent(in)    :: vec1(:)        ! Data
      real(kind=4), allocatable, intent(inout) :: wavelets1(:,:) ! Results
      logical,                   intent(inout) :: error          ! Logical error flag
    end subroutine gwavelet_gaps
  end interface
  !
end module gmath_interfaces_public

subroutine uv_merge_comm(line,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use imager_interfaces, only : map_message, sub_uv_merge_block
  use iso_c_binding
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command
  !
  ! UV_MERGE OutFile /FILES In1 In2 ... Inn  
  !   /WEIGHTS W1 ... Wn /SCALES F1 ... Fn  
  !   /MODE STACK|CONTINUUM|CONCATENATE|INTERSECT|LINE|STITCH  
  !   [Index [Frequency]]  
  !   /IGNORE  TRAIL|POSITION|PROPER  
  !
  ! Merge many UV data files, with calibration factor and weight factors
  ! and spectral resampling as in the first  one.
  !
  ! With /CONTINUUM option, merge continuum UV Tables. A spectral index
  ! can then be automatically applied to the scales and weights.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line !! Command line
  logical, intent(out) :: error           !! Error flag
  !
  ! Constants
  integer, parameter :: o_files=1, o_no=2, o_mode=3, o_factor=4, o_weight=5 
  character(len=*), parameter :: rname='UV_MERGE'
  real(8), parameter :: clight_kms=229792.458d0
  integer, parameter :: mmode=6
  character(len=12) :: vmode(mmode)
  data vmode/'CONCATENATE','CONTINUUM','INTERSECT','LINE','STACKING','STITCHING'/
  !
  ! Local ---
  character(len=12)  :: cmode, argum
  type(c_ptr) :: cptr
  real(4), pointer :: r1ptr(:)
  real(8), pointer :: d1ptr(:)
  integer(kind=address_length) :: addr
  character(len=varname_length) :: listname
  character(len=filename_length) :: table_out
  character(len=filename_length), allocatable :: table_in(:)
  type(sic_descriptor_t) :: desc
  real, allocatable :: weight(:), factor(:)
  integer :: mode, i, n, nt, ier, ignore
  character(len=80) :: mess
  real :: sw
  real :: spindex   ! Spectral index
  real :: freqref   ! Reference Frequency
  logical :: err, found, notrail
  !
  ! Code ----
  error = .true.
  nt = sic_narg(o_files)
  notrail = sic_present(o_no,0)
  !
  if (nt.lt.2) then
    ! This may be a character array handling the file names
    call sic_ch(line,o_files,1,listname,n,.true.,error)
    if (error) return
    !
    call sic_descriptor(listname,desc,found)
    if (.not.found) then
      nt = 1
    else
      !
      ! Check the Descriptor: it must be a character array
      if (desc%type.lt.1 .or. desc%ndim.ne.1) then
        call map_message(seve%e,rname,trim(listname)//' is not a character array')
        error = .true.
        return
      endif
      nt = desc%dims(1)
    endif
  endif
  !
  if (nt.lt.2) then
    if (sic_present(o_mode,0)) then
      call sic_ke(line,o_mode,1,argum,n,.false.,error)
      call sic_ambigs(rname,argum,cmode,i,vmode,mmode,error)
      if (error) return
      select case(cmode)
      case ('STITCHING')
        continue
      case default
        call map_message(seve%e,rname,'Require at least 2 input tables')
        error = .true.
        return
      end select
    else
      call map_message(seve%e,rname,'Require at least 2 input tables')
      return
    endif
  endif
  !
  allocate(table_in(nt),weight(nt),factor(nt),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    return
  endif
  !
  freqref = 0.0             ! Must be initialized in all cases
  weight = 1.0              !
  factor = 1.0              ! 
  !
  if (sic_present(o_weight,0)) then
    if (sic_narg(o_weight).ne.nt) then
      if (sic_narg(o_weight).eq.1) then
        ! Should be a SIC array variable in this case
        call sic_ch(line,o_weight,1,listname,n,.true.,err)
        if (err) return
        !
        call sic_descriptor(listname,desc,found)
        if (.not.found) then
          call map_message(seve%e,rname,'Number of Files and Weights mismatch')
          return
        else
          !
          ! Check the Descriptor and copy if possible
          if ( (desc%ndim.ne.1).or.(desc%dims(1).ne.nt) ) then
            call map_message(seve%e,rname,'Number of Files and Weights mismatch')
            return
          endif
          if (desc%type.eq.fmt_r4) then
            call adtoad(desc%addr,cptr,1)
            call c_f_pointer(cptr,r1ptr,[nt])
            weight(:) = r1ptr
          else if (desc%type.eq.fmt_r8) then
            call adtoad(desc%addr,cptr,1)
            call c_f_pointer(cptr,d1ptr,[nt])
            weight(:) = d1ptr
          else
            call map_message(seve%e,rname,trim(listname)//' is not a real array')
            error = .true.
            return
          endif
        endif
      else
        call map_message(seve%e,rname,'Number of Files and Weights mismatch')
        return
      endif
    else
      do i=1,nt
        call sic_r4(line,o_weight,i,weight(i),.true.,err)
        if (err) return
      enddo
      if (any(weight.le.0.)) then
        call map_message(seve%e,rname,'Weights must be positive')
        return
      endif
    endif
    !
    ! Normalize the Weights
    sw = sum(weight(1:nt))
    weight = weight/sw
  endif
  !
  if (sic_present(o_factor,0)) then
    if (sic_narg(o_factor).ne.nt) then
      if (sic_narg(o_weight).eq.1) then
        ! Should be a SIC array variable in this case
        call sic_ch(line,o_factor,1,listname,n,.true.,err)
        if (err) return
        !
        call sic_descriptor(listname,desc,found)
        if (.not.found) then
          call map_message(seve%e,rname,'Number of Files and Factors mismatch')
          return
        else
          ! Check the Descriptor and copy if possible
          if ( (desc%ndim.ne.1).or.(desc%dims(1).ne.nt) ) then
            call map_message(seve%e,rname,'Number of Files and Factors mismatch')
            return
          endif
          if (desc%type.eq.fmt_r4) then
            call adtoad(desc%addr,cptr,1)
            call c_f_pointer(cptr,r1ptr,[nt])
            factor(:) = r1ptr
          else if (desc%type.eq.fmt_r8) then
            call adtoad(desc%addr,cptr,1)
            call c_f_pointer(cptr,d1ptr,[nt])
            factor(:) = d1ptr
          else
            call map_message(seve%e,rname,trim(listname)//' is not a real array')
            error = .true.
            return
          endif
        endif
      else
        call map_message(seve%e,rname,'Number of Files and Factors mismatch')
        return
      endif
    else
      do i=1,nt
        call sic_r4(line,o_factor,i,factor(i),.true.,err)
        if (err) return
      enddo
      if (any(factor.le.0.)) then
        call map_message(seve%e,rname,'factors must be positive')
        return
      endif
    endif
  endif  
  !
  if (sic_narg(o_files).eq.1) then
    ! This may be a character array handling the file names
    call sic_ch(line,o_files,1,listname,n,.true.,error)
    if (error) return
    call sic_descriptor(listname,desc,found)    
    ! Names from Character array
    addr = desc%addr
    do i=1,nt
      call destoc(desc%type,addr,table_in(i))
      addr = addr + desc%type
    enddo
  else
    ! Names from Command line
    do i=1,nt
      call sic_ch(line,o_files,i,table_in(i),n,.true.,err)
      if (err) return
    enddo
  endif
  error = .false.
  !
  call sic_ch(line,0,1,table_out,n,.true.,error)
  if (error) return
  !
  mode = 0    ! Simple line merge
  ignore = 0  ! Check all Leading & Trailing columns
  if (sic_present(o_mode,0)) then
    call sic_ke(line,o_mode,1,argum,n,.false.,error)
    call sic_ambigs(rname,argum,cmode,i,vmode,mmode,error) 
    if (error) return   
    select case(cmode)
    case ('CONTINUUM')   ! For CONTinuum
      ! Continuum mode
      spindex = 0.
      call sic_r4(line,o_mode,2,spindex,.false.,error)
      freqref = 0.
      call sic_r4(line,o_mode,3,freqref,.false.,error)
      mode = 1
      write(mess,'(A,F6.2,A,F8.0,A)') 'Selected continuum mode, Spectral index ', &
        & spindex,' Reference frequency ',freqref,' MHz'
      ignore = code_uvt_if
      call map_message(seve%i,rname,mess)
    case ('STACKING')   ! For STACking  
      ! Line-Stacking mode
      call map_message(seve%w,rname,'Selected Line Stacking mode',3)
      mode = 2
    case ('CONCATENATE') 
      ! Simple concatenat
      call map_message(seve%w,rname,'Selected Line Concatenation mode',3)
      mode = -1  ! Use full bandwidth
    case ('LINE')
      mode = 0
    case ('INTERSECT')
      call map_message(seve%i,rname,'Selected Line Intersection mode',3)
      mode = -3
    case ('STITCHING')
      mode = -2
      call map_message(seve%w,rname,'Mode STITCHING under test '//cmode)
      call sub_uv_stitch(nt, table_in, table_out, &
        & weight, factor, mode, spindex, freqref, error)
      return
    case default
      call map_message(seve%e,rname,'No such mode '//cmode)
      error = .true.
      return
    end select
  endif    
  !
  call sub_uv_merge_block(nt, table_in, table_out, &
    & weight, factor, mode, spindex, freqref, error, & 
    & ignore, notrail)
  return
  !
end subroutine uv_merge_comm
!
subroutine sub_uv_merge_block(n_in, table_in, table_out, &
     weight, factor, mode, spindex, freqref, error, & 
     ignore, notrail)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  use clean_def
  use clean_default
  use imager_interfaces, except_this => sub_uv_merge_block
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- Merge an arbitray number of UV tables;
  !
  ! with the first one used as a reference, and all other resampled
  ! accordingly. Calibration and weight factors are applied to all
  ! data, as well as a UV scaling factor when reference frequencies
  ! are modified.
  !
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: n_in           !! Number of input tables
  character(len=*), intent(in) :: table_out   !! Output Table name
  character(len=*), intent(in) :: table_in(*) !! Other tables names
  real, intent(in)  :: weight(*)        !! Weight factors   
  real, intent(in)  :: factor(*)        !! Scale factors
  integer, intent(in)  :: mode          !! Selected mode
  logical, intent(out) :: error         !! Error flag
  real, intent(in) :: spindex           !! Spectral index
  real, intent(in) :: freqref           !! Reference Frequency
  integer, intent(in) :: ignore         !! /IGNORE option
  logical, intent(in) :: notrail        !! Ignore trailing columns
  !
  ! Constants
  real(8), parameter :: clight_kms=229792.458d0
  character(len=*), parameter :: rname='UV_MERGE'
  integer, parameter :: code_line=0
  integer, parameter :: code_cont=1
  integer, parameter :: code_stack=2
  integer, parameter :: code_concat=-1
  integer, parameter :: code_stitch=-2
  integer, parameter :: code_inter=-3
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  ! Local ---
  character(len=256) :: table_ref   ! Reference Table name
  type(gildas) :: in,inref,out,hraw,htmp
  integer, allocatable :: iwork(:,:)
  real(4), allocatable :: rwork(:,:)
  real :: scale_uv(3), noscale_uv(3)
  real(8) :: rfreq
  real :: fact, weig
  integer :: nblock, i, ier, im
  character(len=80) :: mess
  character(len=40) :: cmes
  integer :: code
  integer(kind=size_length) :: in_gil_dim1,in_gil_dim2, nvisi
  integer, allocatable :: chflag(:)
  integer, allocatable :: channels(:,:) ! Channel range for each Table
  !
  real(4) :: velos
  real(8) :: freqs
  character(len=12) :: cline
  real(8) :: ctol=0.1
  real(8) :: freq, vinf, vsup, vmin, vmax, vres, cfreq
  integer :: im_first
  real :: uvmax, uvmin, basemin, basemax
  integer :: msize, multiplier, iv, ic, sever
  type (uvmap_par) :: map
  integer, allocatable :: multis(:)    ! Each file has its own multiplier
  logical, allocatable :: resample(:)  ! and its own resampling
  logical :: new=.true.
  !
  ! Code ----
  error = .true.
  if (n_in.eq.0) return
  if (len_trim(table_out).eq.0) return
  !
  table_ref = table_in(1)
  if (len_trim(table_ref).eq.0) return
  error = .false.
  !
  ! Input file TABLE_REF  (INREF) is the reference one
  call gildas_null(inref, type = 'UVT')
  call gildas_null(in, type = 'UVT')
  call gildas_null(out, type = 'UVT')
  call gildas_null(hraw, type = 'UVT')
  !     
  multiplier = 1 ! Number of output visibilities per input one
  scale_uv = 1.0 ! UV scale by default
  allocate(resample(n_in),multis(n_in),channels(3,n_in),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  resample = .false.
  multis(:) = 1
  !
  basemin = 1E38
  basemax = 0.0
  !
  ! Dummy initialization to avoid messages
  in_gil_dim1 = 1
  in_gil_dim2 = 1
  rfreq = 1.d0
  cfreq = 0.d0
  !
  if (mode.eq.code_stitch) then
    !
    ! Pure Stitching -
    ! All UV tables must have the same Time-Baseline ordering
    !   Channels are "glued" together, using a Random Frequency axis
    !
    im_first = 0
  else if ((mode.eq.code_concat).or.(mode.eq.code_inter)) then
    !
    ! Figure out the Central frequency
    cfreq = 0d0
    do im=1,n_in    ! This loop must execute sequentially
      call gdf_read_gildas (hraw, table_in(im), '.uvt', error, data=.false.)
      if (error) then
        write(mess,'(A,I0)') 'Cannot read input UV table #',im
        call map_message(seve%e,rname,mess)
        return
      endif
      call gdf_close_image(hraw,error)
      cfreq = cfreq+hraw%gil%freq
    enddo
    cfreq = cfreq/n_in
    write(mess,'(A,F10.3,A)') 'Using center frequency ',cfreq,' MHz'
    call map_message(seve%i,rname,mess)
    !
    ! Figure out the Frequency / Velocity span
    if (mode.eq.code_concat) then
      vinf = 3E9    ! Faster than light...
      vsup = -3E9
    else
      vinf = -3E9
      vsup =  3E9
    endif
    vres = 3E9
    do im=1,n_in    ! This loop must execute sequentially
      call gdf_read_gildas (hraw, table_in(im), '.uvt', error, data=.false.)
      call gdf_close_image (hraw,error)
      ! Reset the common Frequency scale
      call gdf_modify(hraw,hraw%gil%voff,cfreq,error=error)
      !
      call gdf_copy_header(hraw,in,error)
      if (in%gil%vres .gt. 0) then
        vmin = (1-in%gil%ref(1))*in%gil%vres  + in%gil%voff
        vmax = (in%gil%nchan-in%gil%ref(1))*in%gil%vres  + in%gil%voff
        vres = min(vres,in%gil%vres)
      else
        vmin = (in%gil%nchan-in%gil%ref(1))*in%gil%vres  + in%gil%voff
        vmax = (1-in%gil%ref(1))*in%gil%vres  + in%gil%voff
        vres = min(vres,-in%gil%vres)
      endif
      !
      if (mode.eq.code_concat) then
        vinf = min(vmin,vinf)
        vsup = max(vmax,vsup)
      else
        vinf = max(vmin,vinf)
        vsup = min(vmax,vsup)
      endif
    enddo
    !
    ! Setup the Outer UV table
    call gdf_copy_header(in,inref,error)
    !
    ! Compute the number of channels
    inref%gil%nchan = int(vsup-vinf)/vres + 1
    ! vinf = (1-ref)*vinc + voff ==>  ref = (voff-vinf)/vinc + 1.
    inref%gil%vres = vres
    inref%gil%voff = in%gil%voff
    inref%gil%ref(1) = (in%gil%voff - vinf)/vres + 1.d0
    inref%gil%fres = -vres * in%gil%val(1) / 299792.458d0
    resample(:) = .true.
    !
    inref%gil%dim(1) = in%gil%dim(1) + 3*(inref%gil%nchan-in%gil%nchan)
    !
    in_gil_dim1 = inref%gil%dim(1)  ! Must be the HRAW one
    in_gil_dim2 = inref%gil%dim(2)  ! idem
    !
    im_first = 0
    ! Do not forget trailing columns
    call gdf_uv_shift_columns(in,inref)
    call gdf_setuv (inref, error)
    call gdf_copy_header (inref, out, error)
    call sic_parse_file(table_out,' ','.uvt',out%file)
    !
    if (cfreq.eq.0) then
      !!Print *,'Setting RFREQ for ',im,' From Header ',inref%gil%freq
      rfreq = inref%gil%freq
    else
      !!Print *,'Setting RFREQ for ',im,' From Reference ',freqref
      rfreq = cfreq
    endif
    out%gil%freq = rfreq
    out%gil%dim(2) = 0 ! To get started
    !
    !!call gdf_print_header(out)
    !!read(5,*) idum
    !!if (idum.lt.0) then
    !!  error = .true.
    !!  return
    !!endif
    cmes = ' on the concatenated spectral axis'
  else if (mode.eq.code_cont) then
    if (freqref.eq.0) then
      ! Figure out the Central frequency
      cfreq = 0d0
      do im=1,n_in    ! This loop must execute sequentially
        call gdf_read_gildas (hraw, table_in(im), '.uvt', error, data=.false.)
        if (error) then
          write(mess,'(A,I0)') 'Cannot read input UV table #',im
          call map_message(seve%e,rname,mess)
          return
        endif
        call gdf_close_image(hraw,error)
        cfreq = cfreq+hraw%gil%freq
      enddo
      cfreq = cfreq/n_in
      write(mess,'(A,F10.3,A)') 'Using center frequency ',cfreq,' MHz'
      call map_message(seve%i,rname,mess,3)
    else
      cfreq = freqref
    endif
    im_first = 1
  else
    cmes = ' on the spectral axis  of first UV table'
    im_first = 1
  endif
  !
  ! Loop over tables to be merged
  do im=1,n_in    ! This loop must execute sequentially
    call gdf_read_gildas (hraw, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,'(A,I0)') 'Cannot read input UV table # ',im
      call map_message(seve%e,rname,mess)
      return
    endif
    call gdf_close_image(hraw,error)
    !
    ! Verify Baseline lengths are present
    if (hraw%gil%basemax.le.hraw%gil%basemin) then
      call map_message(seve%e,rname,'Missing baseline lengths range in file '//trim(table_in(im)))
      call map_message(seve%i,rname,'Use command HEADER '//trim(table_in(im))//' /EXTREMA to set them')
      error = .true.
      return
    endif
    !
    call gdf_copy_header(hraw,in,error)
    !
    if (mode.eq.code_cont) then
      if (in%gil%nchan.ne.1) then
        channels(1:3,im) = 0
        !
        msize = maxval(default_map%size)
        if (msize.eq.0) then
          map = default_map
          freq = gdf_uv_frequency(in)
          uvmax = in%gil%basemax
          uvmin = in%gil%basemin
          !            call uvgmax (huv,duv,uvmax,uvmin)
          ! Now transform UVMAX in kiloWavelength (including 2 pi factor)
          uvmax = uvmax*freq*f_to_k
          uvmin = uvmin*freq*f_to_k
          error = .false.
          call map_parameters(rname,map,in,freq,uvmax,uvmin,error)
          if (error) return
          msize = maxval(map%size)
        endif
        channels(1,im) = 1
        channels(2,im) = in%gil%nchan
        call t_channel_sampling (rname,in,channels(3,im),msize)
        !
        call map_message(seve%w,rname,'Converting UV Table into CONTINUUM mode')
        !
        ! Compute the corresponding Continuum Header that we put at "in"
        call uv_cont_header(rname,hraw,in,channels(1:3,im),multis(im),error)
        multis(im) = max(in%gil%nvisi/hraw%gil%nvisi,multis(im))
      endif
    endif
    !
    if (im.eq.im_first) then
      ! Prepare output table: compute number of visibilities
      call gdf_copy_header (in, inref, error)
      !
      call gdf_copy_header (inref, out, error)
      call sic_parse_file(table_out,' ','.uvt',out%file)
      !
      in_gil_dim1 = hraw%gil%dim(1)  ! Must be the HRAW one
      in_gil_dim2 = hraw%gil%dim(2)  ! idem
      !
      if (cfreq.eq.0) then
        !!Print *,'Setting RFREQ for ',im,' From Header ',inref%gil%freq
        rfreq = inref%gil%freq
      else
        !!Print *,'Setting RFREQ for ',im,' From Reference ',freqref
        rfreq = cfreq
      endif
      ! Reset frequency and Reference channel
      if (mode.eq.code_cont) then
        rfreq  = rfreq / (1.d0+in%gil%dopp - in%gil%voff/clight_kms)
        call gdf_modify(out,out%gil%voff,rfreq,error=error)
        out%gil%ref(1) = 1.d0
      endif
    else
      !
      ! Verify Proper Motion & Epoch match
      if ((in%gil%mura.ne.out%gil%mura).or.(in%gil%mudec.ne.out%gil%mudec)) then
        call map_message(seve%e,rname,'Proper Motions do not match')
        error = .true.
      else if ((in%gil%mura.ne.0.).or.(in%gil%mudec.ne.0.)) then
        if (in%gil%epoc.ne.out%gil%epoc) then
          call map_message(seve%e,rname,'Proper Motions match, but Epochs do not match')
          error = .true.
        endif
      endif
      if (error) return
      !
      out%gil%dim(2) = in%gil%dim(2) + out%gil%dim(2)
      out%gil%nvisi = out%gil%dim(2)  ! Set the number of visibilities
      in_gil_dim1 = max(in_gil_dim1,hraw%gil%dim(1))
      in_gil_dim2 = max(in_gil_dim2,hraw%gil%dim(2))
      !
      ! Verify if trailing columns do match
      call gdf_uvmatch_codes(inref,in,code,ignore)
      if (code.eq.3) then
        ! Column # 3 has a mismatch - Make sure the Ref is now SCAN
        inref%gil%column_pointer(code_uvt_w) = 0
        inref%gil%column_size(code_uvt_w) = 0
        inref%gil%column_pointer(code_uvt_scan) = 3
        inref%gil%column_size(code_uvt_scan) = 1
      else if (code.lt.0) then
        if (notrail) then
          sever = seve%w
          error = .false.
        else
          sever = seve%e
          error = .true. 
        endif
        if (code.eq.-1) then
          call map_message(sever,rname,'Leading columns do not match')
        else if (code.eq.-2) then
          call map_message(sever,rname,'Trailing columns do not match')
        else
          call map_message(sever,rname,'Leading columns do not match')
        endif
        call gdf_print_header(inref)
        call gdf_print_header(in)
        if (error) return
      endif
      !
      !
      if (mode.ne.code_cont) then
        ! LINE or STACK modes: verify compliant spectral axes
        !
        if (mode.eq.code_line) then
          if (abs(out%gil%freq-in%gil%freq).gt.0.01*abs(out%gil%fres)) then
            write (mess,'(A,I0,A)') 'UV table ',im,' does not align in Frequency with first UV table'
            call map_message(seve%w,rname,mess,3)
            !
            ! Modify the OUT Reference frequency & Velocities to get the same values
            freqs = in%gil%freq
            velos = in%gil%voff
            cline = in%char%line
            call gdf_modify(out,velos,freqs,error=error)
            out%char%line = cline
          endif
        endif
        !
        call shouldresample( rname, &
          & out%gil%nchan, out%gil%ref(1), dble(out%gil%voff), dble(out%gil%vres), &
          & in%gil%nchan, in%gil%ref(1), dble(in%gil%voff), dble(in%gil%vres),    &
          & ctol,resample(im),error)
        !
        if (resample(im)) then
          if (error) then
            write (mess,'(A,I0,A)') 'UV table ',im,' does not overlap with first UV table'
            call map_message(seve%w,rname,mess,3)
            return
          else
            write (mess,'(A,I0,A)') 'Resampling UV table ',im,cmes
            call map_message(seve%i,rname,mess,3)
          endif
        else
          write (mess,'(A,I0,A)') 'Adding UV table ',im,' without resampling'
          call map_message(seve%i,rname,mess)
        endif
      endif
    endif
    !
    ! Update baseline lengths
    if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
      scale_uv = in%gil%freq / rfreq
    else if  (mode.eq.code_cont) then
      scale_uv = in%gil%freq / rfreq
    else if  (mode.eq.code_stack) then
      scale_uv = in%gil%freq / inref%gil%freq
    else
      scale_uv = 1.0
    endif
    ! Do not scale the SCAN numbers...
    if (inref%gil%column_pointer(code_uvt_scan).eq.3) scale_uv(3) = 1.0
    !
    basemin = min(basemin,in%gil%basemin*scale_uv(1))
    basemax = max(basemax,in%gil%basemax*scale_uv(1))
    !
  enddo
  !
  ! Update Baselines
  out%gil%basemin = basemin
  out%gil%basemax = basemax
  !
  if (mode.eq.code_cont .and. out%gil%nchan.ne.1) then
    call map_message(seve%w,rname,'CONTINUUM mode is only valid for 1 channel')
    error = .true.
    return
  endif
  !
  ! Finished preparatory work, and create the OUT table
  call map_message(seve%i,rname,'Creating UV table '//trim(out%file))
  call gdf_create_image(out, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create output UV table')
    return
  endif
  !
  ! Define blocking factor on input file
  call gdf_nitems('SPACE_GILDAS',nblock,in_gil_dim1) ! Visibilities at once
  nblock = min(nblock,in_gil_dim2)
  multiplier = maxval(multis)
  allocate (out%r2d(out%gil%dim(1),nblock*multiplier), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error OUT ',out%gil%dim(1), nblock, multiplier
    call map_message(seve%e,rname,mess)
    call gdf_close_image(out, error)
    error = .true.
    return
  endif
  !
  if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
    call map_message(seve%i,rname,'Merging continuum tables')
  else if (mode.eq.code_cont) then
    call map_message(seve%i,rname,'Merging line tables in continuum mode')  
  else 
    allocate (iwork(2,out%gil%nchan), rwork(4,out%gil%nchan), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error WORK ',6,out%gil%nchan
      call map_message(seve%e,rname,mess)
      call gdf_close_image(out, error)
      error = .true.
      return
    endif
    call map_message(seve%i,rname,'Merging line tables')
  endif
  !
  ! Append INs to OUT with resampling and rescaling when needed
  out%blc(2) = 0    ! Get started
  call gildas_null(htmp,type='UVT')
  call gdf_copy_header(out,htmp,error)
  !
  do im = 1,n_in
    mess = 'Reading '//trim(table_in(im))
    call map_message(seve%i,rname,mess)
    call gdf_read_gildas (in, table_in(im), '.uvt', error, data=.false.)
    if (error) then
      write(mess,*) 'Cannot read input UV table #',im
      call map_message(seve%e,rname,mess)
      goto 98
    endif
    !
    allocate (in%r2d(in%gil%dim(1),nblock), stat=ier)
    if (ier.ne.0) then
      write(mess,*) 'Memory allocation error IN ',in%gil%dim(1), nblock
      call map_message(seve%e,rname,mess)
      goto 98
    endif
    !
    if (mode.eq.code_concat) call gdf_modify(in,in%gil%voff,cfreq,error=error)
    !
    if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
      scale_uv = in%gil%freq / rfreq
      !!Print *,'1 CHANNEL Frequencies ',in%gil%freq,rfreq,' Scale ',scale_uv
    else if (mode.eq.code_cont) then
      !
      ! Compute the output header
      call uv_cont_header(rname,in,hraw,channels(1:3,im),multis(im),error)
      !
      ! Allocate the appropriate work-space
      allocate (hraw%r2d(hraw%gil%dim(1),nblock*multiplier),chflag(in%gil%nchan),stat=ier)
      if (ier.ne.0) then
        write(mess,*) 'Memory allocation error IN ',in%gil%dim(1), nblock
        call map_message(seve%e,rname,mess)
        goto 98
      endif
      scale_uv = in%gil%freq / rfreq
      chflag = 1
      !!Print *,'CONTINUUM Frequencies ',in%gil%freq,rfreq,' Scale ',scale_uv
    else
      if (mode.eq.code_stack) then
        !   In Stacking Mode, Lambda/D is conserved, so the UV length
        ! must be scaled by FreqIn/ FreqRef
        scale_uv = in%gil%freq / inref%gil%freq
        !!Print *,'STACK Frequencies ',in%gil%freq,rfreq,' Scale ',scale_uv
      else
        scale_uv = 1.0
      endif
    endif
    fact = factor(im)
    weig = weight(im)
    if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
      if (spindex.ne.0) then
        fact = factor(im) / (scale_uv(1))**spindex
        weig = weight(im) * (scale_uv(1))**(2*spindex)
      endif
    endif    
    ! Do not scale the SCAN numbers...
    if (inref%gil%column_pointer(code_uvt_scan).eq.3) scale_uv(3) = 1.0
    write(mess,'(A,F8.2,A,F8.2,A,F8.4)') 'Factors: Flux ',fact, &
      & ', Weight ',weig,' UV ',scale_uv(1)
    call map_message(seve%i,rname,mess)
    !
    out%blc(2) = out%trc(2)+1
    !
    in%blc = 0
    in%trc = 0
    !
    ! Block loop on current input file
    do i=1,in%gil%dim(2),nblock
      if (sic_ctrlc()) goto 98
      !
      write(mess,*) i,' / ',in%gil%dim(2),min(100,nint((i+nblock-1)*100./in%gil%dim(2))),' %'
      call map_message(seve%i,rname,mess)
      in%blc(2) = i
      in%trc(2) = min(in%gil%dim(2),i-1+nblock)
      call gdf_read_data(in,in%r2d,error)
      if (error) goto 98
      !
      if (out%gil%nchan.eq.1 .and. in%gil%nchan.eq.1) then
        !
        ! Simple continuum mode
        nvisi = in%trc(2)-in%blc(2)+1
        out%trc(2) = out%blc(2)+nvisi-1
        call uvmergec (nvisi, out%gil%dim(1), out%r2d,  &
       &       in%gil%dim(1),in%r2d,weig,fact,      &
       &       scale_uv)
      else if (mode.eq.code_cont) then
        !
        ! Put the data into "hraw" as a working buffer now...
        nvisi = in%gil%nvisi
        in%gil%nvisi = in%trc(2)-in%blc(2)+1
        in%trc = 0  !
        in%blc = 0  ! Use everything in the block
        call t_continuum(in,hraw,channels(1:3,im),chflag,1,error,spindex,rfreq)
        if (error) goto 98
        in%gil%nvisi = nvisi
        nvisi = hraw%gil%nvisi 
        out%trc(2) = out%blc(2)+nvisi-1
        noscale_uv = [1.0,1.0,1.0]
        call uvmergec (nvisi, out%gil%dim(1), out%r2d,  &
       &       hraw%gil%dim(1),hraw%r2d,weig,fact,noscale_uv)
      else
        !      
        ! Line mode
        nvisi = in%trc(2)-in%blc(2)+1
        out%trc(2) = out%blc(2)+nvisi-1
        !
        if (new) then
          ! No scaling factor so far...
          if (resample(im)) then
            call resample_uv(in,htmp,in%r2d,out%r2d,nvisi,out%gil%ntrail) 
          else
            out%r2d(:,:) = in%r2d(:,:)
          endif
          !
          ! Apply scaling factors
          if (any(scale_uv.ne.1) .or. weig.ne.1 .or. fact.ne.1) then
            do iv=1,nvisi
              out%r2d(1:3,iv) = scale_uv * out%r2d(1:3,iv)
              if (weig.ne.1 .or. fact.ne.1) then
                do ic=1,out%gil%nchan
                  out%r2d(5+3*ic:6+3*ic,iv) = fact*out%r2d(5+3*ic:6+3*ic,iv)
                  out%r2d(7+3*ic,iv) = weig*out%r2d(7+3*ic,iv)
                enddo
              endif
            enddo
          endif
        else
          ! Bugged code, non parallel also
          !		Print *,'Line mode ',nvisi, out%trc
          !		Print *,'Nchan ',out%gil%nchan
          call uvmergel (nvisi, out%gil%nchan, out%r2d,    &
         &       in%gil%nchan,in%r2d,weig,fact, scale_uv,  &
         &       iwork, rwork, &
         &       out%gil%ref(1), dble(out%gil%voff), dble(out%gil%vres), &
         &       in%gil%ref(1), dble(in%gil%voff), dble(in%gil%vres),    &
         &       resample(im))
        endif
        !
      endif
      call gdf_write_data(out,out%r2d,error)
      if (error) goto 98
      out%blc(2) = out%trc(2)+1
    enddo     ! Block loop
    !
    call gdf_close_image(in,error)
    deallocate (in%r2d,stat=ier)
    if (associated(hraw%r2d)) deallocate (hraw%r2d,stat=ier)
    if (allocated(chflag)) deallocate (chflag)
  enddo       ! File loop
  !
  call gdf_close_image(out,error)
  deallocate(out%r2d)
  return
  !
  ! Error handling
98      continue
  call gdf_close_image(out, error)
  call gdf_close_image(in, error)
  error = .true.
  return
end subroutine sub_uv_merge_block
!
subroutine old_uvmergel (nv,ncx,x,ncz,z,weight,factor,scaleuv,iwork,rwork &
  & ,xref,xval,xinc,zref,zval,zinc)
  use gildas_def
  !------------------------------------------------------------------------
  ! @ private
  !
  ! Merge two line data sets:  Append them after interpolation (if needed)
  !------------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
  integer, intent(in) :: ncx                    !! Number of channels
  real, intent(inout) :: x(:,:)                 !! Merged UV table
  integer, intent(in) :: ncz                    !! Number of channels
  real, intent(in) :: z(:,:)                    !! Input UV table
  real, intent(in) :: weight                    !! Weight scale factor
  real, intent(in) :: factor                    !! Intensity scale factor
  real, intent(in) :: scaleuv                   !! UV scale factor
  integer, intent(inout) :: iwork(2,*)          !! Work array
  real, intent(inout) :: rwork(4,*)             !! Work array
  real(8), intent(in) :: xref,xval,xinc         !! Input velocity sampling
  real(8), intent(in) :: zref,zval,zinc         !! Output velocity sampling
  !------------------------------------------------------------------------
  !
  ! Local ---
  integer :: i, j, k, iv
  real :: poids
  !
  ! iwork = imin,imax
  ! rwork = rmin_1, rmin, rmax, rmax_1
  !
  integer imax,imin, ix,iy, jxmin, jymin, jxmax, jymax
  integer :: mcx, mcz, lcx, lcz, mtrail
  real(8) minpix, maxpix, pix, val, expand
  real rmin_1, rmin, rmax_1, rmax, smin, smax
  real scale
  !------------------------------------------------------------------------
  ! Code ----
  !
  mcx = ubound(x,1)
  mcz = ubound(z,1)
  lcx = 3*ncx+7
  lcz = 3*ncz+7
  mtrail = mcx-lcx
  ! Setup interpolation scheme
  ! Interpolate first (Z) Table on X grid
  !
  expand = abs(xinc/zinc)
  scale  = factor/expand
  !
  ! Initialize workspace
  iwork(:,1:ncx) = 0
  rwork(:,1:ncx) = 0.0
  do i = 1, ncx
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-zval)/zinc + zref
    maxpix = pix + 0.5d0*expand
    minpix = pix - 0.5d0*expand
    imin = int(minpix+1.0d0)
    imax = int(maxpix)
    iwork(1,i) = imin
    iwork(2,i) = imax
    if (imax.eq.imin .and. expand.eq.1.0) then
      ! Shifted grid or not actually
      rwork(1,i) = (imin-pix)
      rwork(2,i) = 1.0-rwork(1,i)
    else if (imax.ge.imin) then
      ! Lower end
      if (imin.gt.1) then
        !
        ! ZMIN = Z(IMIN-1)*(IMIN-MINPIX)+Z(IMIN)*(MINPIX-IMIN+1)
        !     and
        ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(ZMIN+Z(IMIN)) )
        !
        !     RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)     ! Coefficient de IMIN-1
        !     RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)   ! Coefficient de IMIN
        !
        smin = imin-minpix
        rwork(1,i) = 0.5*smin*smin
        rwork(2,i) = smin-rwork(1,i)
      else
        !     RMIN   = (IMIN-MINPIX)                          ! Coefficient de IMIN
        !     RMIN_1 = 0                                      ! Coefficient de IMIN-1
        rwork(1,i) = 0.0
        rwork(2,i) = imin-minpix
      endif
      ! Upper end
      if (imax.lt.ncz) then
        smax = maxpix-imax
        rwork(4,i) = 0.5*smax*smax
        rwork(3,i) = smax-rwork(4,i)
      else
        rwork(3,i) = maxpix-imax
        rwork(4,i) = 0.0
      endif
      if (imax.eq.imin) then
        ! 3 Point Case
        rwork(2,i) = rwork(2,i)+rwork(3,i)
        rwork(3,i) = 0.0
      else
        ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate channels
        rwork(2,i) = rwork(2,i)+0.5
        rwork(3,i) = rwork(3,i)+0.5
      endif
    else
      if (imin.gt.1) then
        rwork(1,i) = (imin-pix)
        rwork(2,i) = 1.0-rwork(1,i)
      else
        rwork(1,i) = 0.0
        rwork(2,i) = 1.0
      endif
    endif
  enddo
  Print *,'IWORK 1 ',iwork(1,1:NCX)
  Print *,'RWORK 1 ',rwork(1,1:NCX)
  Print *,'IWORK 2 ',iwork(2,1:NCX)
  Print *,'RWORK 2 ',rwork(2,1:NCX)
  !
  ! OK, now do it for all visibilities
  do iv=1,nv
    !
    ! Coordinates
    do j=1, 3
      x(j,iv) = z(j,iv)*scaleuv
    enddo
    do j=4, 7
      x(j,iv) = z(j,iv)
    enddo
    !
    ! Channels
    do i=1,ncx
      imin = iwork(1,i)
      imax = iwork(2,i)
      jxmin = 5+3*imin
      jymin = jxmin+1
      jxmax = 5+3*imax
      jymax = jxmax+1
      rmin_1 = rwork(1,i)
      rmin   = rwork(2,i)
      rmax   = rwork(3,i)
      rmax_1 = rwork(4,i)
      ix = 5+3*i
      iy = ix+1
      !
      if (imax.ge.imin) then
        ! Print *,'IMAX ',imax,' => ',imin,' IMIN, NCZ ',ncz
        ! General Trapezium integration
        if (imin.gt.1) then
          x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
          x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
        else
          x(ix,iv) = z(jxmin,iv)*rmin
          x(iy,iv) = z(jymin,iv)*rmin
        endif
        if (imax.gt.imin) then
          do k = 5+3*(imin+1),5+3*(imax-1),3
            x(ix,iv) = x(ix,iv) + z(k,iv)
            x(iy,iv) = x(iy,iv) + z(k+1,iv)
          enddo
        endif
        x(ix,iv) = x(ix,iv) + z(jxmax,iv)*rmax
        x(iy,iv) = x(iy,iv) + z(jymax,iv)*rmax
        if (imax.lt.ncz) then
          x(ix,iv) = x(ix,iv) + z(jxmax+3,iv)*rmax_1
          x(iy,iv) = x(iy,iv) + z(jymax+3,iv)*rmax_1
        endif
        x(ix,iv) = x(ix,iv)*scale
        x(iy,iv) = x(iy,iv)*scale
      else
        !
        ! Interpolation
        if (imin.gt.1) then
          x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
          x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
        else
          x(ix,iv) = z(jxmin,iv)
          x(iy,iv) = z(jymin,iv)
        endif
        x(ix,iv) = x(ix,iv)*factor
        x(iy,iv) = x(iy,iv)*factor
      endif
    enddo
    !
    ! Weight
    ! Same weight for all channels.. One should do better here.
    !
    poids = z(10+3*(ncz/2),iv)*weight
    if (poids.eq.0) then  ! May happen with Widex spectra
      poids = z(10+3*(ncz/3),iv)*weight
    endif
    do j=10, 3*ncx+7, 3
      x(j,iv) = poids
    enddo
    !
    ! Trailing columns if any
    do j=1,mtrail
      x(lcx+j,iv) = z(lcz+j,iv)
    enddo
  enddo
end subroutine old_uvmergel
!
subroutine uvmergec (nv,ndx,x,ndz,z,weight,factor,scaleuv)
  use gildas_def
  !------------------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for Continuum handling
  !
  ! Append a Continuum Data set
  !!
  !------------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
  integer(kind=size_length), intent(in) :: ndx  !!                  !!
  real, intent(inout) :: x(ndx,nv)              !! Merged UV table
  integer(kind=size_length), intent(in) :: ndz  !!
  real, intent(in) :: z(ndz,nv)                 !! Input UV table
  real, intent(in) :: weight                    !! Weight scale factor
  real, intent(in) :: factor                    !! Intensity scale factor
  real, intent(in) :: scaleuv(3)                !! Baseline length scale
  !
  ! Local ---
  integer :: j, iv, n
  !
  ! Code ----
  n = min(ndx,ndz)
  do iv=1,nv
    !
    ! Coordinates
    x(1:3,iv) = scaleuv*z(1:3,iv)
    do j=4, 7
      x(j,iv) = z(j,iv)
    enddo
    !
    ! Visibilities
    x(8,iv) = z(8,iv)*factor
    x(9,iv) = z(9,iv)*factor
    ! Weight
    x(10,iv) = z(10,iv)*weight
    ! Other (if any)
    do j=11,n
      x(j,iv) = z(j,iv)
    enddo
  enddo
end subroutine uvmergec
!
subroutine uvmergef (nv,ndx,x,ndz,z,weight,factor,w1,w2,error)
  use gildas_def
  !------------------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for Continuum handling
  !
  ! Merge two Continuum Data Set: Average visibilities
  !!
  !------------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
  integer(kind=size_length), intent(in) :: ndx  !!
  real, intent(inout) :: x(ndx,nv)              !! Merged UV table
  integer(kind=size_length), intent(in) :: ndz  !!
  real, intent(in) :: z(ndz,nv)                 !! Input UV table
  real, intent(in) :: weight                    !! Weight scale factor
  real, intent(in) :: factor                    !! Intensity scale factor
  real(8), intent(out) :: w1,w2                 !! Relative weights
  logical, intent(out) :: error                 !! Error flag
  !
  ! Local ---
  integer :: iv, n, j
  real :: ww
  !
  ! Code ----
  error = .false.
  n = min(ndx,ndz)
  w1 = 0.d0
  w2 = 0.d0
  ! OK, now do it for all visibilities
  do iv=1,nv
    !
    ! U and V Coordinates
    if (x(1,iv).ne.z(1,iv)) then
      print *,'U iv ',iv,x(1,iv),z(1,iv), x(10,iv), z(10,iv)
      print *,'Out ',z(1:10,iv)
      error = .true.
      return
    endif
    if (x(2,iv).ne.z(2,iv)) then
      print *,'V iv ',iv,x(2,iv),z(2,iv), x(10,iv), z(10,iv)
      error = .true.
      return
    endif
    !
    ! Visibilities
    ww = x(10,iv)
    if (x(10,iv).gt.0) w1 = w1+x(10,iv)
    !
    if (z(10,iv).gt.0) then
      w2 = w2+z(10,iv)
      if (x(10,iv).gt.0) then
        ww = x(10,iv)+weight*z(10,iv)
        x(8,iv) = (x(8,iv)*x(10,iv) + z(8,iv)*z(10,iv)*weight*factor ) / ww
        x(9,iv) = (x(9,iv)*x(10,iv) + z(9,iv)*z(10,iv)*weight*factor ) / ww
      else
        ww = weight*z(10,iv)
        x(8,iv) = z(8,iv)*factor
        x(9,iv) = z(9,iv)*factor
      endif
    endif
    ! Weight
    x(10,iv) = ww
    ! Trailing columns if any
    do j=11,n
      x(j,iv) = z(j,iv)
    enddo
  enddo
end subroutine uvmergef
!
!
subroutine uvmergel (nv,ncx,x,ncz,z,weight,factor,scaleuv,iwork,rwork &
  & ,xref,xval,xinc,zref,zval,zinc,resample)
  use gildas_def
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_MERGE
  !
  ! Merge two Line Data Set: Average visibilities
  !!
  !------------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nv   !! Number of visibilities
  integer, intent(in) :: ncx                    !! Number of channels
  real, intent(inout) :: x(:,:)                 !! Merged UV table
  integer, intent(in) :: ncz                    !! Number of channels
  real, intent(in) :: z(:,:)                    !! Input UV table
  real, intent(in) :: weight                    !! Weight scale factor
  real, intent(in) :: factor                    !! Intensity scale factor
  real, intent(in) :: scaleuv(3)                !! Baseline Scale factor
  integer, intent(inout) :: iwork(2,*)          !! Work array
  real, intent(inout) :: rwork(4,*)             !! Work array
  real(8), intent(in) :: xref,xval,xinc         !! Input velocity sampling
  real(8), intent(in) :: zref,zval,zinc         !! Output velocity sampling
  logical, intent(in) :: resample
  !
  ! Constant
  real(kind=8),parameter      :: ctol = 0.1     ! Spectral tolerance over all spectrum
  character(len=*), parameter :: rname='UV_MERGE'
  !
  ! Local ---
  integer :: i, j, k, iv
  real :: poids
  !
  ! iwork = imin,imax
  ! rwork = rmin_1, rmin, rmax, rmax_1
  !
  integer imax,imin, ix,iy, jxmin, jymin, jxmax, jymax
  integer :: mcx, mcz, lcx, lcz, mtrail
  real(8) minpix, maxpix, pix, val, expand
  real rmin_1, rmin, rmax_1, rmax, smin, smax
  real scale
  !
  ! Code ----
  if (.not.resample) then
    do iv=1,nv   
      x(1:3,iv) = scaleuv*z(1:3,iv)
      x(4:,iv)  = z(4:,iv)
    end do
  else
    !
    ! Interpolate first (Z) Table on X grid
    !
    mcx = ubound(x,1)
    mcz = ubound(z,1)
    lcx = 3*ncx+7
    lcz = 3*ncz+7
    mtrail = mcx-lcx
    ! Setup interpolation scheme
    !
    expand = abs(xinc/zinc)
    scale  = factor/expand
    !! Print *,'NCX ',ncx,' NCZ ',ncz,' Expand ',expand
    !
    ! Initialize workspace
    iwork(:,1:ncx) = 0
    rwork(:,1:ncx) = 0.0
    do i = 1, ncx
      !
      ! Compute interval
      val = xval + (i-xref)*xinc
      pix = (val-zval)/zinc + zref
      maxpix = pix + 0.5d0*expand
      minpix = pix - 0.5d0*expand
      imin = int(minpix+1.0d0)
      imax = int(maxpix)
      iwork(1,i) = imin
      iwork(2,i) = imax
      !
      ! Test out of bound conditions
      if (imax.lt.0) then
        !! Print *,'Out of bound MAX ',imax, iwork(:,i)
        iwork(:,i) = 1
        rwork(:,i) = 0. ! Nothing to be added
      else if (imin.gt.ncz) then
        !! Print *,'Out of bound MIN ',imax, iwork(:,i)
        iwork(:,i) = 1
        rwork(:,i) = 0. ! Nothing to be added
      else if (imax.eq.imin .and. expand.eq.1.0) then
        ! Shifted grid or not actually
        rwork(1,i) = (imin-pix)
        rwork(2,i) = 1.0-rwork(1,i)
      else if (imax.ge.imin) then
        ! Lower end
        if (imin.gt.1) then
          !
          ! ZMIN = Z(IMIN-1)*(IMIN-MINPIX)+Z(IMIN)*(MINPIX-IMIN+1)
          !     and
          ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(ZMIN+Z(IMIN)) )
          !
          !     RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)     ! Coefficient de IMIN-1
          !     RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)   ! Coefficient de IMIN
          !
          smin = imin-minpix
          rwork(1,i) = 0.5*smin*smin
          rwork(2,i) = smin-rwork(1,i)
        else
          !     RMIN   = (IMIN-MINPIX)                          ! Coefficient de IMIN
          !     RMIN_1 = 0                                      ! Coefficient de IMIN-1
          rwork(1,i) = 0.0
          rwork(2,i) = imin-minpix
        endif
        ! Upper end
        if (imax.lt.ncz) then
          smax = maxpix-imax
          rwork(4,i) = 0.5*smax*smax
          rwork(3,i) = smax-rwork(4,i)
        else
          rwork(3,i) = maxpix-imax
          rwork(4,i) = 0.0
        endif
        if (imax.eq.imin) then
          ! 3 Point Case
          rwork(2,i) = rwork(2,i)+rwork(3,i)
          rwork(3,i) = 0.0
        else
          ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate channels
          rwork(2,i) = rwork(2,i)+0.5
          rwork(3,i) = rwork(3,i)+0.5
        endif
      else
        if (imin.gt.1) then
          rwork(1,i) = (imin-pix)
          rwork(2,i) = 1.0-rwork(1,i)
        else
          rwork(1,i) = 0.0
          rwork(2,i) = 1.0
        endif
      endif
    enddo
    ! Test
    !do i=1,ncx
    !  Print *,i,'IWORK ',iwork(:,i),' RWORK ',rwork(:,i)
    !enddo
    !
    ! OK, now do it for all visibilities
    do iv=1,nv
      !
      ! Coordinates                
      do j=1, 3
        x(j,iv) = z(j,iv)*scaleuv(j)
      enddo
      do j=4, 7
        x(j,iv) = z(j,iv)
      enddo
      !
      ! Channels
      do i=1,ncx
        imin = iwork(1,i)
        imax = iwork(2,i)
        jxmin = 5+3*imin
        jymin = jxmin+1
        jxmax = 5+3*imax
        jymax = jxmax+1
        rmin_1 = rwork(1,i)
        rmin   = rwork(2,i)
        rmax   = rwork(3,i)
        rmax_1 = rwork(4,i)
        ix = 5+3*i
        iy = ix+1
        !
        if (imax.ge.imin) then
          ! General Trapezium integration
          if (imin.gt.1) then
            x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
            x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
          else
            x(ix,iv) = z(jxmin,iv)*rmin
            x(iy,iv) = z(jymin,iv)*rmin
          endif
          if (imax.gt.imin) then
            do k = 5+3*(imin+1),5+3*(imax-1),3
              x(ix,iv) = x(ix,iv) + z(k,iv)
              x(iy,iv) = x(iy,iv) + z(k+1,iv)
            enddo
          endif
          x(ix,iv) = x(ix,iv) + z(jxmax,iv)*rmax
          x(iy,iv) = x(iy,iv) + z(jymax,iv)*rmax
          if (imax.lt.ncz) then
            x(ix,iv) = x(ix,iv) + z(jxmax+3,iv)*rmax_1
            x(iy,iv) = x(iy,iv) + z(jymax+3,iv)*rmax_1
          endif
          x(ix,iv) = x(ix,iv)*scale
          x(iy,iv) = x(iy,iv)*scale
        else
          !
          ! Interpolation
          if (imin.gt.1) then
            x(ix,iv) = z(jxmin-3,iv)*rmin_1+z(jxmin,iv)*rmin
            x(iy,iv) = z(jymin-3,iv)*rmin_1+z(jymin,iv)*rmin
          else
            x(ix,iv) = z(jxmin,iv)
            x(iy,iv) = z(jymin,iv)
          endif
          x(ix,iv) = x(ix,iv)*factor
          x(iy,iv) = x(iy,iv)*factor
        endif
      enddo
      !
      ! Weight
      ! Same weight for all channels...
      !
      poids = z(10+3*(ncz/2),iv)*weight
      if (poids.eq.0) then  ! May happen with Widex spectra
         poids = z(10+3*(ncz/3),iv)*weight
      endif
      do j=10, 3*ncx+7, 3
         x(j,iv) = poids
      enddo
      !
      ! Trailing columns if any
      do j=1,mtrail
         x(lcx+j,iv) = z(lcz+j,iv)
      enddo
    enddo
  endif
end subroutine uvmergel
!
subroutine shouldresample(rname,xnc,xref,xval,xinc, &
  & znc,zref,zval,zinc,ctol, resample,error)
  !
  use gbl_message
  use imager_interfaces, only : map_message
  !------------------------------------------------------------------------
  !*
  ! IMAGER -- Support routine for UV_MERGE
  !
  ! Merge two Line Data Set: Average visibilities
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname   !! Command name
  integer(kind=4),intent(in) :: xnc       !! Size of X velocity axis
  real(kind=8),   intent(in) :: xref      !! X reference channel
  real(kind=8),   intent(in) :: xval      !! X Value at reference
  real(kind=8),   intent(in) :: xinc      !! X increment
  integer(kind=4),intent(in) :: znc       !! Size of Z velocity axis
  real(kind=8),   intent(in) :: zref      !! Z reference channel
  real(kind=8),   intent(in) :: zval      !! Z Value at reference
  real(kind=8),   intent(in) :: zinc      !! Z increment
  real(kind=8),   intent(in) :: ctol      !! Match tolerancs
  logical, intent(out) :: resample        !! Should we resample ?
  logical, intent(out) :: error           !! Error flag
  !
  ! Local ---
  real(kind=8) :: xleft,xright,zleft,zright,vtol
  character(len=64) :: mess
  !
  ! Code ----
  vtol = abs(zinc*ctol)
  !
  resample = .false.
  error = .false.
  if (xnc.ne.znc) then
    mess = 'Different channel numbers '
    resample = .true.
  else if (xinc*zinc.lt.0.d0) then
    resample = .true.
    mess = 'Different sign of increment '
  else
    xleft  = (0.5-xref)*xinc+xval    
    xright = (xnc+0.5-xref)*xinc+xval 
    zleft  = (0.5-zref)*zinc+zval    
    zright = (znc+0.5-zref)*zinc+zval
    !
    if (abs(xleft-zleft).gt.vtol) then
      mess = 'Channel mismatch on left side'
      resample = .true.
    else if (abs(xright-zright).gt.vtol) then
      mess = 'Channel mismatch on right side'
      resample = .true.
    endif
    xleft = (zleft-xval)/xinc+xref
    xright = (zright-xval)/xinc+xref
    if ((xleft.gt.znc).or.(xright.lt.1)) then
      mess = 'Axes do not overlap'
      error = .true.
      call map_message(seve%e,rname,mess)
      return
    endif
    !Print *,'XLEFT ',xleft,' XRIGHT ',xright,' NC', xnc, znc
    !Print *,'ZLEFT ',zleft,' ZRIGHT' ,xright---
  endif
  if (resample) call map_message(seve%w,rname,mess)
  !
end subroutine shouldresample
!
! Others
subroutine gdf_uvmatch_codes(a,b,code,ignore)
  use image_def
  use imager_interfaces, only : gdf_uvcolumn_codes
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! GIO     Compare layout of UV tables for description columns  
  ! Code = 0    Same layout  
  ! Code = -1   Different layout  
  ! Code = 3    Similar layout, except that Col.3 is SCAN in one,
  !             and W in the other.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: a       !! Input Header
  type(gildas), intent(in) :: b       !! Input Header
  integer, intent(out)     :: code    !! Returned code
  integer, intent(in) :: ignore       !! Which code_uvt is ignored ?
  !
  ! Local ---
  integer :: k, nlt, ier, tole, ka, kb
  integer, allocatable :: a_codes(:,:), b_codes(:,:)
  !
  ! Code ----
  code = -1
  ! If # number of leading : no match
  if (a%gil%nlead.ne.b%gil%nlead) return
  !
  ! If # number of trailing : no match, except if Ignore == 0
  code = -2
  if (ignore.eq.0) then
    tole = 0
  else
    tole = 1
  endif
  if (abs(a%gil%ntrail-b%gil%ntrail).gt.tole) return
  !
  ! Else, compare columns, but make a specific provision
  ! for SCAN and W (both of which may happen in Col 3)
  ! and for the "ignore" code
  !
  nlt = a%gil%nlead + max(a%gil%ntrail,b%gil%ntrail)
  allocate(a_codes(2,nlt),b_codes(2,nlt),stat=ier)
  call gdf_uvcolumn_codes(a,a_codes)
  call gdf_uvcolumn_codes(b,b_codes)
  !
  code = 0
  if (ignore.eq.0) then
    do k = 1,nlt
      if (a_codes(1,k).ne.b_codes(1,k)) then
        if (code.eq.0 .and. k.eq.3) then
          code = 3
          if (a_codes(1,k).eq.code_uvt_scan .and. b_codes(1,k).eq.code_uvt_w) cycle
          if (b_codes(1,k).eq.code_uvt_scan .and. a_codes(1,k).eq.code_uvt_w) cycle
        endif
        code = -3
      else if (a_codes(2,k).ne.b_codes(2,k)) then
        Print *,'Code length mismatch at Col. ',k, a_codes(1:2,k), b_codes(1:2,k), ' Ntrail ',nlt
      endif
    enddo
  else
    ka = 1
    kb = 1
    !
    do k = 1,nlt
      if (a_codes(1,ka).eq.0 .or. a_codes(1,ka).eq.ignore) ka = ka+1
      if (b_codes(1,kb).eq.0 .or. b_codes(1,kb).eq.ignore) kb = kb+1
      if (ka.gt.nlt) exit
      if (kb.gt.nlt) exit
      !
      if (a_codes(1,ka).ne.b_codes(1,kb)) then
        if (code.eq.0 .and. ka.eq.3) then
          code = 3
          if (a_codes(1,ka).eq.code_uvt_scan .and. b_codes(1,kb).eq.code_uvt_w) cycle
          if (b_codes(1,ka).eq.code_uvt_scan .and. a_codes(1,kb).eq.code_uvt_w) cycle
        endif
        code = -3
      else if (a_codes(2,ka).ne.b_codes(2,kb)) then
        Print *,'Code length mismatch at Col. ',k, a_codes(1:2,k), b_codes(1:2,k), ' Ntrail ',nlt
      endif
    enddo
  endif
end subroutine gdf_uvmatch_codes
!
subroutine gdf_uvcolumn_codes(h,column_codes)
  use image_def
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! GIO     Return the column codes and sizes of the Leading and Trailing
  !         columns
  !!
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: h                !! Input header
  integer, intent(inout) :: column_codes(:,:)   !! Column codes
  !
  integer :: nlt, i, j, itrail
  !
  nlt = h%gil%nlead + h%gil%ntrail
  !
  do j = 1,nlt
    do i = 1, code_uvt_last
      if (h%gil%column_pointer(i).lt.h%gil%fcol) then
        if (h%gil%column_pointer(i).eq.j) then
          column_codes(1,j) = i
          column_codes(2,j) = h%gil%column_size(i)
          exit
        endif
      else if (h%gil%column_pointer(i).gt.h%gil%lcol) then
         ! A little more vicious if > nlead
        itrail = h%gil%column_pointer(i)-h%gil%lcol+h%gil%nlead
        !! Print *,'Trail ',j,i,itrail
        if (itrail.eq.j) then
          column_codes(1,j) = i
          column_codes(2,j) = h%gil%column_size(i)
          exit
        endif
      else
        Print *,'Inconsistent Column Pointer #',i,' = ', h%gil%column_pointer(i), &
        &   ' in data range',h%gil%fcol,h%gil%lcol
      endif
    enddo
  enddo
end subroutine gdf_uvcolumn_codes
!

subroutine gdf_stbl(stbl,error)
  use gio_interfaces, only : gio_message
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF set STarting BLOcks default
  !     temporary routine to change the number of header blocks
  !---------------------------------------------------------------------
  integer, intent(in)  :: stbl      ! Number of starting blocks
  logical, intent(out) :: error     ! Error flag
  ! Local
  character(len=60) :: chain
  !
  if (stbl.lt.1 .or. stbl.gt.10) then
    call gio_message(seve%e,'GDF_STBL','Invalid starting block number')
    error = .true.
    return
  endif
  write(chain,'(A,I0,A)') 'Setting ',stbl,' starting blocks'
  call gio_message(seve%d,'GDF_STBL',chain)
  startbl = stbl
  error = .false.
end subroutine gdf_stbl
!
function gdf_stbl_get()
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! Return the STarting BLOcks default
  !     temporary routine to change the number of header blocks
  !---------------------------------------------------------------------
  integer(kind=4) :: gdf_stbl_get
  gdf_stbl_get = startbl
end function gdf_stbl_get
!
subroutine gio_geis (is,error)
  use gio_interfaces, only : gio_message
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF GEt Image Slot
  !     Only used by SIC
  !---------------------------------------------------------------------
  integer, intent(out) :: is        ! Image slot
  logical, intent(out) :: error     ! Error flag
  ! Local
  integer :: i
  !
  error = .true.
  do i=1,mis
    if (islot(i).eq.code_gio_empty) then
      error = .false.
      islot(i) = code_gio_full
      is = i
      istbl(i) = startbl  ! A default value...
      imblock(i) = 0
      irblock(i) = 0
      iwblock(i) = 0      
      return
    endif
  enddo
  is = 0
  call gio_message(seve%e,'GDF_GEIS','Too many images')
end subroutine gio_geis
!
subroutine gio_fris (is,error)
  use gio_interfaces, only : gio_message, gio_frms, gdf_deis
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF FRee Image Slot
  !   Only used by SIC
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: is     ! Image slot
  logical, intent(inout) :: error  ! Error flag
  ! Local
  integer :: i
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,'FRIS','Image slot is empty')
    error = .true.
    return
  endif
  !
  ! Free all associated memory slot
  if (islot(is).ne.code_gio_full) then
    do i=1,mms
      if (mslot(i).eq.is) then
        call gio_frms(i,error)
      endif
    enddo
    call gdf_deis(is,error)
  endif
  ichan(is) = 0
  islot(is) = code_gio_empty 
end subroutine gio_fris
!
subroutine gio_clis (is,error)
  use gio_interfaces, only : gio_message, gio_frms, gdf_deis
  use gio_image
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  ! GDF CLose Image Slot
  !   Only used by SIC
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !----------------------------------------------------------------------
  integer, intent(in)    :: is     ! Image slot
  logical, intent(inout) :: error  ! Error flag
  ! Local
  integer :: i
  !
  if (islot(is).eq.code_gio_empty) then
    call gio_message(seve%e,'CLIS','Image slot is empty')
    error = .true.
    return
  endif
  !
  ! Free all associated memory slot
  if (islot(is).ne.code_gio_full) then
    do i=1,mms
      if (mslot(i).eq.is) then
        call gio_frms(i,error)
      endif
    enddo
    call gdf_deis(is,error)
  endif
  ichan(is) = 0
  islot(is) = code_gio_full 
end subroutine gio_clis
!
subroutine gdf_deis (is,error)
  use gio_dependencies_interfaces
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  ! GDF DElete Image Slot
  !             whatever the consequences...
  !             Close the unit, and free it
  !
  ! In case of success, error flag (T/F) is preserved on return. Code is
  ! insensitive to error=T on input.
  !---------------------------------------------------------------------
  integer, intent(in)    :: is     ! Image slot
  logical, intent(inout) :: error  ! Error flag
  !
  ! Close file
  close (unit=iunit(is))            ! Just in case
  call sic_frelun (iunit(is))
  iunit(is) = 0
end subroutine gdf_deis
!
function gdf_stis (is)
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! GDF STatus of Image Slot
  !             return slot status (-1 if not available)
  !---------------------------------------------------------------------
  integer :: gdf_stis               ! intent(out)
  integer, intent(in) :: is         ! Image slot
  if (is.le.0 .or. is.gt.mis) then
    gdf_stis = -1              ! No such slot
  else
    gdf_stis = islot(is)
  endif
end function gdf_stis
!
function gio_chis (is,rdonly)
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! Change READ Status to allow or avoid rewriting buffers...
  !     Only used by SIC
  !---------------------------------------------------------------------
  integer :: gio_chis               ! intent(out)
  integer, intent(in) :: is         ! Image slot
  logical, intent(in) :: rdonly     ! ReadOnly Status
  if (is.le.0 .or. is.gt.mis) then
    gio_chis = -1
  else
    gio_chis = islot(is)
    if (rdonly) then
      if (islot(is).eq.code_gio_write) islot(is) = code_gio_reado
    else
      if (islot(is).eq.code_gio_reado) islot(is) = code_gio_write
    endif
  endif
end function gio_chis
!
subroutine gio_lsis (chain,error)
  use gio_interfaces, only : gio_message, gio_dump_header
  use gildas_def
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF LiSt Image Slot
  !             A debugging routine only used by SIC
  ! It will prompt for user input if CHAIN is not empty.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: chain
  logical, intent(out) :: error     ! Error flag
  ! Local
  character(len=*), parameter :: rname='GIO_LSIS'
  integer :: i, ic, j
  character(len=filename_length) :: file
  logical :: status, query
  character(len=message_length) :: mess
  !
  query = len_trim(chain).gt.0
  if (query) print *,trim(chain)
  error = .false.
  ic = 0
  do i=1,mis
    if (islot(i).ne.code_gio_empty) then
      if (iunit(i).ne.0) then
        inquire(unit=iunit(i),opened=status)
        if (status) then
          inquire(unit=iunit(i),name=file)
          write(mess,*) 'Slot ',i,'Opened on ',iunit(i),' on '
          call gio_message(seve%i,rname,trim(mess)//' '//file)
        else
          write(mess,*) 'Slot ',i,'closed on ',iunit(i)
          call gio_message(seve%i,rname,mess)
        endif
      else
        write(mess,*) 'Slot ',i,'allocated, no unit'
        call gio_message(seve%i,rname,mess)
      endif
      if (query) then
        call gdf_print_header (gheads(i))
        write(*,*) 'Enter a number to continue '
        read(*,*) j
      endif
      ic = ic+1
    else
      if (iunit(i).ne.0) then
        write(mess,*) 'Empty Slot ',i,' with allocated unit'
        call gio_message(seve%i,rname,mess)
      endif  
    endif
  enddo
  if (ic.eq.0) call gio_message(seve%i,rname,'No allocated image in GIO library')
end subroutine gio_lsis

!
subroutine major_sdi (rname,method,head,clean,beam,resid,nx,ny,   &
     &    tfbeam,fcomp,wcl,mcl,ixbeam,iybeam,ixpatch,iypatch,bgain,   &
     &    box, wfft, comp, list, nl, np, primary, weight, &
     &    major_plot )
  use imager_interfaces, except_this=>major_sdi
  use clean_def
  use image_def
  use gbl_message
  use gkernel_interfaces, only : sic_ctrlc
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- CLEAN  Method SDI  
  ! Major cycle loop according to Steer Dewdney and Ito idea
  !!
  !----------------------------------------------------------------------
  external :: major_plot                        !! Plotting routine
  character(len=*), intent(in) :: rname         !! Caller name
  type (clean_par), intent(inout) :: method     !! Deconvolution method parameterss
  type (gildas), intent(in)  :: head            !! Data header
  integer, intent(in) :: np                     !! Number of fields
  integer, intent(in) :: nx                     !! X size
  integer, intent(in) :: ny                     !! Y size
  integer, intent(in) :: mcl                    !! Maximum number of clean components
  real, intent(inout) :: clean(nx,ny)           !! Clean map
  real, intent(inout) :: resid(nx,ny)           !! Residual map
  real, intent(in) ::    beam(nx,ny,np)         !! Dirty beams (per field)
  real, intent(in) ::    tfbeam(nx,ny,np)       !! FT. of beams
  complex, intent(inout) :: fcomp(nx,ny)        !! FT of component list
  type(cct_par), intent(inout) :: wcl(mcl)      !! Work space for Clean components
  real, intent(in) :: bgain                     !! Maximum sidelobe level
  integer, intent(in) :: ixbeam, iybeam         !! Beam maximum position
  integer, intent(in) :: ixpatch, iypatch       !! Beam patch radius
  integer, intent(in) :: box(4)                 !! Cleaning box
  real, intent(inout) :: wfft(*)                !! Work space for FFT
  integer, intent(inout) :: list(nx*ny)         !! list of searchable pixels
  integer, intent(inout) :: nl                  !! List size
  real, intent(inout) :: comp(nx,ny)            !! Clean components array
  real, intent(in) :: primary(np,nx,ny)         !! Primary beams
  real, intent(in) :: weight (nx,ny)            !! Flat field array
  !
  ! Local ---
  real    maxc,minc,maxabs     ! max and min of data, absolute max value
  integer imax,jmax,imin,jmin  ! coordinates of the Max and Min pixels
  real    borne                ! Fraction of initial data
  real    limite               ! Minimal intensity retained
  real flux                    ! Total clean flux density
  integer ncl                  ! Number of selected data points
  logical fini                 ! Stopping criterium 
  logical converge             ! Stop by flux convergence
  integer k
  real factor                  ! Scaling factor
  character(len=message_length) :: chain
  type (cct_par) :: tcc(1)     ! Dummy argument for Major_PLOT
  real :: sign, cdif
  integer :: dimcum, jiter
  real, allocatable :: oldcum(:)
  !
  ! Code ----
  dimcum = min(8,method%n_major/2)
  allocate (oldcum(dimcum))
  !
  ! Find maximum residual
  call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
  sign = 1
  if (method%n_iter.lt.method%p_iter) then
    maxabs=abs(maxc)
  elseif ( abs(maxc).lt.abs(minc) ) then
    maxabs=abs(minc)
    sign = -1.0    
  else
    maxabs=abs(maxc)
  endif
  oldcum = 0
  !
  borne= max(method%fres*maxabs,method%ares)
  fini = maxabs.lt.borne
  !   method%n_iter= 0      ! Set at Call sequence
  flux = 0.0
  !
  ! Initialize clean components
  comp = 0.0
  !
  ! Major cycle
  !
  converge = .false.
  k = 0
  do while (.not.fini)
    !
    ! Define minor cycle limit
    k = k+1
    write(chain,100) 'Major cycle ',k,' loop gain ',method%gain
    call map_message(seve%d,rname,chain)
    limite = max(maxabs*bgain,0.8*borne)
    !
    ! Select points of maximum strength and load them in
    call choice (   &
     &      resid,       &      ! Current residuals
     &      nx,ny,       &      ! image size
     &      list, nl,    &      ! Search list
     &      limite,      &      ! Detection threshold
     &      mcl,         &      ! Maximum number of candidates
     &      wcl,         &      ! Selected candidate components
     &      ncl,         &      ! Selected Number of components
     &      maxabs, 0)
    !
    if (ncl.gt.0) then
      write(chain,100) 'Selected ',ncl,' points above ',limite
      call map_message(seve%d,rname,chain)
      !
      ! No minor cycles. Compute scaling factor
      call sdi_normal (    &
     &        fcomp,       &    ! Work space for Component TF
     &        tfbeam,      &    ! Beam TF
     &        nx,ny,       &    ! image size
     &        wcl,         &    ! Selected candidate components
     &        ncl,         &    ! Selected Number of components
     &        wfft,        &    ! FFT work space
     &        factor)
      ! !Print *,'Done NORMAL '
      !
      ! Compute Clean Components
      factor = method%gain*maxabs/factor
      call sdi_scalec (wcl,      &    ! Selected candidate components
     &        ncl,factor,flux,   &
     &        comp, nx, ny)
      ! !Print *,'Done SCALEC '
      method%n_iter = method%n_iter+ncl
      !
      ! Remove all components by FT : RESIDU = RESIDU - BEAM # WCL(*,4)
      call remisajour (    &
     &        clean,       &    ! CLEAN map used as work space
     &        resid,       &    ! Updated residuals
     &        tfbeam,      &    ! Beam TF
     &        fcomp,       &    ! Work space for Component TF
     &        wcl,         &    ! Clean components
     &        ncl,         &    ! Number of Clean Components
     &        nx,ny,       &    ! Map size
     &        wfft,        &    ! FFT work space
     &        np, primary, weight, method%trunca)
      ! !Print *,'Done REMISAJOUR '
      write (chain,101)  'Cleaned ',flux,' Jy with ',   &
     &        method%n_iter,' clean components'
      call map_message(seve%i,rname,chain)
      !
      ! Find new extrema
      call maxlst (resid,nx,ny,list,nl, maxc,imax,jmax,minc,imin,jmin)
      if (method%n_iter.lt.method%p_iter) then
        maxabs=abs(maxc)
      elseif ( abs(maxc).lt.abs(minc) ) then
        maxabs=abs(minc)
      else
        maxabs=abs(maxc)
      endif
      !
      if (dimcum.ne.0) then
        jiter = k   ! The Major Loop counter 
        oldcum(mod(jiter,dimcum)+1) = flux
        if (jiter.ge.dimcum) then
          cdif = flux-oldcum(mod(jiter+1,dimcum)+1)
          converge = sign*cdif.lt.0.0
          if (.not.converge) then
            if (abs(cdif/flux).lt.1E-3) converge = .true.
          endif
        endif
      endif
      ! Check if converge
      fini = (maxabs.le.borne)             &
     &        .or. (k.gt.method%n_major)   &
     &        .or. converge
    else
      write(chain,101) 'No point selected above ',limite
      fini = .true.
      call map_message(seve%i,rname,chain)
    endif
    !
    ! Intermediate or final PLOT
    converge = fini
    clean(:,:) = comp               ! Use CLEAN as work space to plot it
    ! !Print *,'Doing MAJOR_PLOT '
    call major_plot (method,head,              &
     &      converge,method%n_iter,nx,ny,np,   &
     &      tcc,clean,resid,weight)
    ! !Print *,'Done MAJOR_PLOT '
    fini = converge
    !
    if (sic_ctrlc()) exit
  enddo
  !
  ! End
  if (maxabs.le.borne) then
    write(chain,100) 'Reached minimum flux density '
  elseif (k.ge.method%n_major) then
    write(chain,100) 'Reached maximum number of cycles'
  elseif (converge) then
    write(chain,100) 'Reached flux convergence'
  else
    write(chain,100) 'End of transcendental causes'
  endif
  call map_message(seve%i,rname,chain)
  !
  ! Store the result
  clean(:,:) = comp
  !
  100   format (a,i0,a,1pg11.4,a)
  101   format (a,1pg11.4,a,i0,a)
end subroutine major_sdi
!
subroutine sdi_normal (fcomp,tfbeam,nx,ny, wcl,ncl,wfft,factor)
  use gkernel_interfaces, only : fourt
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  --  CLEAN Method SDI  
  ! Subtract last major cycle components from residual map.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx               !! X size
  integer, intent(in) :: ny               !! Y size
  integer, intent(in) :: ncl              !! Number of clean components
  type(cct_par), intent(in) :: wcl(ncl)   !! Clean components
  real, intent(in) :: tfbeam(nx,ny)       !! FT. of beam
  complex, intent(out) :: fcomp(nx,ny)    !! FT. of clean components
  real, intent(inout) :: wfft(*)          !! Work array
  real, intent(out) :: factor             !! Max of clean
  !
  ! Local ---
  integer i,j,k,ndim,nn(2)
  !
  ! Code ----
  fcomp = 0.0
  do k=1,ncl
    fcomp(wcl(k)%ix,wcl(k)%iy) = cmplx(wcl(k)%influx,0.0)
  enddo
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fcomp = fcomp*tfbeam
  call fourt(fcomp,nn,ndim,1,1,wfft)
  factor = abs(real(fcomp(1,1)))
  do j=1,ny
    do i=1,nx
      factor = max(factor,abs(real(fcomp(i,j))))
    enddo
  enddo
end subroutine sdi_normal
!
subroutine sdi_scalec(wcl,ncl,f,s,compon,nx,ny)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- CLEAN Method SDI  
  ! Subtract last major cycle components from residual map.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx               !! X size
  integer, intent(in) :: ny               !! Y size
  integer, intent(in) :: ncl              !! Number of clean components
  type(cct_par), intent(inout) :: wcl(ncl)  !! Clean components
  real, intent(in) :: f                   !! Gain factor
  real, intent(inout) :: s                !! Cumulative flux
  real, intent(inout) :: compon(nx,ny)    !! Cumulative clean component
  !
  ! Local ---
  integer i
  !
  ! Code ----
  do i=1,ncl
    wcl(i)%value = wcl(i)%influx*f
    s = s+wcl(i)%value
    compon(wcl(i)%ix,wcl(i)%iy) = compon(wcl(i)%ix,wcl(i)%iy) + wcl(i)%value
  enddo
end subroutine sdi_scalec

subroutine sic_desc (line,iopt,iarg,desc,default,present,error)
  use sic_interfaces, except_this=>sic_desc
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Retrieves the IARG-th argument of the IOPT-th option
  !       and returns a SIC descriptor pointing to the appropriate
  !       variable.
  !
  ! Arguments:
  !       LINE    C*(*)   Command line                    Input
  !       IOPT    I       Option number (0=command)       Input
  !       IARG    I       Argument number (0=command)     Input
  !       PRESENT L       Must the argument be present ?  Input
  !---------------------------------------------------------------------
  character(len=*)                      :: line     !
  integer                               :: iopt     !
  integer                               :: iarg     !
  type(sic_descriptor_t), intent(out)   :: desc     ! Descriptor
  type(sic_descriptor_t), intent(in)    :: default  ! Default descriptor
  logical                               :: present  !
  logical,                intent(inout) :: error    ! Error return
  !
  call sic_desc_inca (line,iopt,iarg,desc,default,present,error,1)
end subroutine sic_desc
!
subroutine sic_inca (line,iopt,iarg,desc,default,present,error)
  use sic_interfaces, except_this=>sic_inca
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !       Retrieves the IARG-th argument of the IOPT-th option
  !       and returns a SIC incarnation of the result.
  !
  ! Arguments:
  !       LINE    C*(*)   Command line                    Input
  !       IOPT    I       Option number (0=command)       Input
  !       IARG    I       Argument number (0=command)     Input
  !       PRESENT L       Must the argument be present ?  Input
  !---------------------------------------------------------------------
  character(len=*)                      :: line     !
  integer                               :: iopt     !
  integer                               :: iarg     !
  type(sic_descriptor_t), intent(out)   :: desc     ! Descriptor
  type(sic_descriptor_t), intent(in)    :: default  ! Default descriptor
  logical                               :: present  !
  logical,                intent(inout) :: error    ! Error return
  !
  call sic_desc_inca (line,iopt,iarg,desc,default,present,error,2)
end subroutine sic_inca
!
subroutine sic_desc_inca (line,iopt,iarg,desc,default,present,error,code)
  use gildas_def
  use gbl_message
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_desc_inca
  use sic_structures
  use sic_dictionaries
  use sic_interactions
  use sic_expressions
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   External routine
  !       Retrieves the IARG-th argument of the IOPT-th option
  !       and returns a SIC descriptor pointing to the appropriate
  !       variable.
  !
  ! Arguments:
  !       LINE    C*(*)   Command line                    Input
  !       IOPT    I       Option number (0=command)       Input
  !       IARG    I       Argument number (0=command)     Input
  !       PRESENT L       Must the argument be present ?  Input
  !       ERROR   L       Error return
  !       CODE    I       1 <=> Descriptor,  2 <=> Incarnation Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  character(len=*) :: line                    !
  integer :: iopt                             !
  integer :: iarg                             !
  type(sic_descriptor_t), intent(out) :: desc     ! Descriptor
  type(sic_descriptor_t), intent(in)  :: default  ! Default descriptor
  logical :: present                          !
  logical :: error                            !
  integer :: code                             !
  ! Local
  character(len=*), parameter :: rname='DECODE'
  type(sic_descriptor_t) :: tmp
  integer :: argtyp,ifirst,ilast,parg,thetyp
  logical :: found,l
  real(kind=4) :: r4
  real(kind=8) :: r8
  integer(kind=4) :: i4
  integer(kind=8) :: i8
  character(len=1) :: quote
  character(len=1024) :: argum,var
  character(len=message_length) :: mess
  ! Data
  data quote /"'"/
  !
  ! Get default descriptor
  desc = default
  argtyp = default%type
  !
  if (argtyp.lt.0) then
    thetyp = 2
  else
    thetyp = 0
  endif
  !
  ! Check if argument is present
  error = .true.
  if (iopt.gt.maxopt .or. iopt.lt.0 .or. iarg.lt.0) then
    write(mess,104) iopt,iarg
    call sic_message(seve%e,rname,mess)
    return
  endif
  if (locstr(line).ne.ccomm%aline) then
    call sic_message(seve%e,rname,'You have overwritten the command line pointers.')
    call sic_message(seve%e,rname,'The following command line can not be parsed anymore:')
    call sic_message(seve%e,rname,line)
    call sic_message(seve%e,rname,'because the command '//trim(ccomm%command)//  &
      ' was executed in the meantime.')
    return
  endif
  if (iarg.le.ccomm%narg(iopt)) then
    parg = ccomm%popt(iopt)+iarg
    if (parg.gt.mword) then
      write(mess,104) iopt,iarg
      call sic_message(seve%e,rname,mess)
      return
    endif
    ifirst = ccomm%ibeg(parg)
    ilast  = ccomm%iend(parg)
  else
    if (present) then
      if (iopt.eq.0) then
        write(mess,101) iarg,trim(ccomm%lang),char(92),vocab(ccomm%icom)(2:)
      else
        write(mess,102) iarg,vocab(ccomm%icom+iopt)(2:)
      endif
      call sic_message(seve%e,rname,mess)
      return
    endif
    error = .false.
    return
  endif
  error = .false.
  !
  ! If *, return the default
  if (line(ifirst:ilast).eq.'*') return
  !
  ! Undefined type: check argument type and return automatic incarnation
  if (argtyp.eq.0) then
    ! Only valid for Incarnation
    if (code.eq.1) then
      call sic_message(seve%e,rname,'Programming error ')
      call sic_message(seve%e,rname,'Undefined variable type in call to '//  &
      'SIC_DESC')
      error = .true.
      return
    endif
    !
    ! Character string
    if (line(ifirst:ifirst).eq.'"') then
      call sic_expand(argum,line,ifirst,ilast,parg,error)
      if (error) return
      next_st = next_st+1
      argu_st(next_st) = argum(1:parg)
      desc%type = parg
      desc%readonly = .false.
      desc%addr = locstr(argu_st(next_st))
      desc%ndim = 0
      desc%size = (desc%type+3)/4
      !
      ! Implicit formatting
    elseif  (line(ifirst:ifirst).eq.quote) then
      call sic_expand(argum,line,ifirst,ilast,parg,error)
      if (error) return
      next_st = next_st+1
      argu_st(next_st) = argum(1:parg)
      desc%type = parg
      desc%readonly = .false.
      desc%addr = locstr(argu_st(next_st))
      desc%ndim = 0
      desc%size = (desc%type+3)/4
      !
      ! Variable or expression
    else
      var = line(ifirst:ilast)
      parg = ilast-ifirst+1
      call sic_upcase (var,parg)
      ! call sic_descriptor (var,desc,found)  ! Under check, this is not obvious
      call sic_materialize (var,desc,found)    ! most likely allow transposition ?
      !
      ! Variable
      if (found) then
        return
      else
        !
        ! Scalar expression
        if (sicprecis.eq.fmt_r8) then
          call sic_math_dble (var,ilast-ifirst+1,r8,error)
          if (error) return
          next_arg = next_arg + 1
          desc%type = fmt_r8
          desc%readonly = .false.
          argu_r8(next_arg) = r8
          desc%addr = locwrd(argu_r8(next_arg))
          desc%size = 2
          !
        elseif (sicprecis.eq.fmt_r4) then
          call sic_math_real (var,ilast-ifirst+1,r4,error)
          if (error) return
          next_arg = next_arg + 1
          desc%type = fmt_r4
          desc%readonly = .false.
          argu_r4(next_arg) = r4
          desc%addr = locwrd(argu_r4(next_arg))
          desc%size = 1
          !
        elseif (sicprecis.eq.fmt_i8) then
          call sic_math_long (var,ilast-ifirst+1,i8,error)
          if (error) return
          next_arg = next_arg + 1
          desc%type = fmt_i8
          desc%readonly = .false.
          argu_i8(next_arg) = i8
          desc%addr = locwrd(argu_i8(next_arg))
          desc%size = 2
          !
        else
          call sic_message(seve%e,rname,'Internal error: unsupported precision')
          error = .true.
          return
        endif
        desc%ndim = 0            ! Scalar
        desc%dims(:) = 0
        desc%status = program_defined
      endif
    endif
    !
    ! Logical arrays or scalar
  elseif  (argtyp.eq.fmt_l) then
    if (line(ifirst:ifirst).eq.'"') then
      !
      ! "..." is a Character String
      call sic_message(seve%e,rname,'Argument mismatch')
      error = .true.
      return
    elseif  (line(ifirst:ifirst).eq.quote) then
      !
      ! '...' is a scalar expression
      ifirst = ifirst+1
      ilast = ilast-1
      var = line(ifirst:ilast)
      parg = ilast-ifirst+1
      call sic_upcase (var,parg)
      call sic_math_logi (var,parg,l,error)
      if (error) return
      next_arg = next_arg + 1
      argu_l4(next_arg) = l
      desc%type = argtyp
      desc%readonly = .false.
      desc%addr = locwrd(argu_l4(next_arg))
      desc%ndim = 0              ! Scalar
      desc%dims(:) = 0
      desc%size = 1
      desc%status = program_defined
    else
      !
      ! Try a logical variable
      var = line(ifirst:ilast)
      parg = ilast-ifirst+1
      call sic_upcase (var,parg)
      ! call sic_descriptor (var,desc,found)  ! Under check, this is not obvious
      call sic_materialize (var,desc,found)    ! most likely allow transposition ?
      if (found) then
        if (desc%type.ne.fmt_l) then
          call sic_message(seve%e,rname,'Variable type mismatch')
          error = .true.
          return
        endif
      else
        !
        ! Try a logical expression (scalar)
        call sic_math_logi (var,parg,l,error)
        if (error) return
        next_arg = next_arg + 1
        argu_l4(next_arg) = l
        desc%type = argtyp
        desc%readonly = .false.
        desc%addr = locwrd(argu_l4(next_arg))
        desc%ndim = 0            ! Scalar
        desc%dims(:) = 0
        desc%size = 1
        desc%status = program_defined
      endif
    endif
    ! Real arrays or scalar
  elseif  (argtyp.lt.0) then
    if (line(ifirst:ifirst).eq.'"') then
      !
      ! "..." is a Character String
      call sic_message(seve%e,rname,'Argument mismatch')
      error = .true.
      return
    elseif  (line(ifirst:ifirst).eq.quote) then
      !
      ! '...' is a scalar expression
      ifirst = ifirst+1
      ilast = ilast-1
      desc%type = argtyp
      desc%readonly = .false.
      if (desc%type.eq.fmt_r8) then
        call sic_math_dble (line(ifirst:ilast),ilast-ifirst+1,r8,error)
        if (error) return
        next_arg = next_arg + 1
        argu_r8(next_arg) = r8
        desc%addr = locwrd(argu_r8(next_arg))
        desc%size = 2
      elseif (desc%type.eq.fmt_r4) then
        call sic_math_real (line(ifirst:ilast),ilast-ifirst+1,r4,error)
        if (error) return
        next_arg = next_arg + 1
        argu_r4(next_arg) = r4
        desc%addr = locwrd(argu_r4(next_arg))
        desc%size = 1
      elseif (desc%type.eq.fmt_i4) then
        call sic_math_inte (line(ifirst:ilast),ilast-ifirst+1,i4,error)
        if (error) return
        next_arg = next_arg + 1
        argu_i4(next_arg) = i4
        desc%addr = locwrd(argu_i4(next_arg))
        desc%size = 1
      elseif (desc%type.eq.fmt_i8) then
        call sic_math_long (line(ifirst:ilast),ilast-ifirst+1,i8,error)
        if (error) return
        next_arg = next_arg + 1
        argu_i8(next_arg) = i8
        desc%addr = locwrd(argu_i8(next_arg))
        desc%size = 2
      else
        call sic_message(seve%e,rname,'Argument type mismatch')
        error = .true.
        return
      endif
      desc%ndim = 0              ! Scalar
      desc%dims(:) = 0
      desc%status = program_defined
    else
      var = line(ifirst:ilast)
      ! call sic_descriptor (var,tmp,found)  ! Under check, this is not obvious
      call sic_materialize (var,tmp,found) ! most likely allow transposition ?
      !
      ! Variable
      if (found) then
        ! Check variable type for CODE = 1
        if (code.eq.1) then
          if (tmp%type.ne.argtyp) then
            call sic_message(seve%e,rname,'Variable type mismatch')
            error = .true.
            return
          else
            desc = tmp
          endif
        else
          ! Else incarnate
          call sic_incarnate(argtyp,tmp,desc,error)
          ! And free temporary variable (if any, due to transposition) if incarnation differ
          if (tmp%type.ne.argtyp) call sic_volatile(tmp)
          if (error) then
            call sic_message(seve%e,rname,'Variable type mismatch')
            return
          endif
        endif
      elseif  (code.ne.1) then
        !
        ! Scalar expression, valid only for Incarnation
        desc%type = argtyp
        desc%readonly = .false.
        if (argtyp.eq.fmt_r8) then
          call sic_math_dble (line(ifirst:ilast),ilast-ifirst+1,r8,error)
          if (error) return
          next_arg = next_arg + 1
          argu_r8(next_arg) = r8
          desc%addr = locwrd(argu_r8(next_arg))
          desc%size = 2
        elseif (argtyp.eq.fmt_r4) then
          call sic_math_real (line(ifirst:ilast),ilast-ifirst+1,r4,error)
          if (error) return
          next_arg = next_arg + 1
          argu_r4(next_arg) = r4
          desc%addr = locwrd(argu_r4(next_arg))
          desc%size = 1
        elseif (argtyp.eq.fmt_i4) then
          call sic_math_inte (line(ifirst:ilast),ilast-ifirst+1,i4,error)
          if (error) return
          next_arg = next_arg + 1
          argu_i4(next_arg) = i4
          desc%addr = locwrd(argu_i4(next_arg))
          desc%size = 1
        elseif (argtyp.eq.fmt_i8) then
          call sic_math_long (line(ifirst:ilast),ilast-ifirst+1,i8,error)
          if (error) return
          next_arg = next_arg + 1
          argu_i8(next_arg) = i8
          desc%addr = locwrd(argu_i8(next_arg))
          desc%size = 2
        else
          call sic_message(seve%e,rname,'Argument type mismatch')
          error = .true.
          return
        endif
        desc%ndim = 0            ! Scalar
        desc%dims(:) = 0
        desc%status = program_defined
      else
        ! Cannot return a descriptor for an expression
        call sic_message(seve%e,rname,'No such variable '//var(1:10)//'...')
        error = .true.
      endif
    endif
    !
    ! Characters
  else
    !
    ! Characters with no expand ("As Is")
    if (line(ifirst:ifirst).eq.'"') then
      !            CALL SIC_SHAPE(ARGUM,LINE,IFIRST,ILAST,PARG,ERROR)
      if (code.eq.1) then
        var = line(ifirst:ilast)
        call sic_message(seve%e,rname,'No such variable '//var(1:16)//'...')
        error = .true.
        return
      else
        call sic_expand(argum,line,ifirst,ilast,parg,error)
        if (error) return
        next_st = next_st+1
        argu_st(next_st) = argum(1:parg)
        desc%type = parg
        desc%readonly = .false.
        desc%addr = locstr(argu_st(next_st))
        desc%ndim = 0
        desc%size = (desc%type+3)/4
      endif
      !
      ! Implicit formatting ('...')
    elseif  (line(ifirst:ifirst).eq.quote) then
      if (code.eq.1) then
        var = line(ifirst:ilast)
        call sic_message(seve%e,rname,'No such variable '//var(1:16)//'...')
        error = .true.
        return
      else
        call sic_expand(argum,line,ifirst,ilast,parg,error)
        if (error) return
        next_st = next_st+1
        argu_st(next_st) = argum(1:parg)
        desc%type = parg
        desc%readonly = .false.
        desc%addr = locstr(argu_st(next_st))
        desc%ndim = 0
        desc%size = (desc%type+3)/4
      endif
      !
      ! Else, must be a character variable
    else
      var = line(ifirst:ilast)
      parg = ilast-ifirst+1
      call sic_descriptor (var,desc,found) ! Checked: do not transpose
      if (found) then
        if (desc%type.le.0) then
          call sic_message(seve%e,rname,'Argument type mismatch')
          error = .true.
          return
        endif
      else
        call sic_message(seve%e,rname,'No such variable '//var(1:16)//'...')
        error = .true.
        return
      endif
    endif
  endif
  !
101 format('Missing argument number ',i3,' of Command ',a,a,a)
102 format('Missing argument number ',i3,' of Option ',a)
104 format('Option ',i3,' or argument ',i3,' out of bounds')
end subroutine sic_desc_inca

program flow_main
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	A dedicated routine to produce bipolar outflow maps
  !	Input : a VLM cube (N by NX by NY)
  !	Output : a cube (3 by NX by NY) containing the maps of the
  !		width and of the red and blue lobes
  !	Method :
  !		For each spectrum, determines the peak channel,
  !	then determines on each side of this channel the velocity
  !	at a given threshold. From this velocity, integrates out
  !	to a second threshold. The area found is the contribution
  !	to the blue (or red) lobe of the flow.
  ! S.Guilloteau 12-Nov-1986
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  real(kind=4) :: ratio,threshold
  real(kind=8) :: vinc
  integer(kind=4) :: n
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('IN$',namey)
  call gildas_char('OUT$',namex)
  call gildas_real('RATIO$',ratio,1)
  call gildas_real('THRESHOLD$',threshold,1)
  call gildas_close
  !
  ! Open first input map, the one to be placed in Y place
  n = lenc(namey)
  if (n.eq.0) goto 100
  call gildas_null(y)
  call gdf_read_gildas(y, namey, '.vlm', error)
  if (error) then
    write(6,*) 'F-FLOW,  Cannot read input file'
    goto 100
  endif
  !
  ! Same as above for X image
  n = lenc(namex)
  if (n.eq.0) goto 100
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  !
  ! Modify the requested part of the X Header
  x%gil%dim(1) = y%gil%dim(2)
  x%gil%dim(2) = y%gil%dim(3)
  x%gil%dim(3) = 3
  x%gil%convert(:,1) =   y%gil%convert(:,2)
  x%gil%convert(:,2) =   y%gil%convert(:,3)
  x%gil%convert(:,3) =   1
  vinc = y%gil%convert(3,1) 
  if (x%gil%proj_words.ne.0) then
    x%gil%xaxi = x%gil%xaxi-1
    x%gil%yaxi = x%gil%yaxi-1
  endif
  !
  ! Create the image (with write access of course)
  call gdf_create_image (x,error)
  if (error) then
    write(6,*) 'F-FLOW,  Cannot create output image'
    goto 100
  endif
  call gdf_allocate(x,error)
  if (error) goto 100
  !
  ! Do some useful job
  call sub_flow(x%r3d,            &  ! Address of the X image
                x%r3d(:,:,2),     &
                x%r3d(:,:,3),     &
                y%r3d,            &  ! Address of the Z image
                x%gil%dim(1),     &  ! Dimension of images
                x%gil%dim(2),     &
                y%gil%dim(1),     &
                vinc,             &
                ratio,threshold,  &
                x%gil%bval,x%gil%eval)
  !
  call gdf_write_data (x,x%r3d,error)
  if (error) goto 100
  !
  call gagout('S-FLOW,  Successful completion')
  call sysexi(1)
  !
  ! and exit with an error status
100 call sysexi (fatale)

contains
!
subroutine sub_flow(width,blue,red,vlm,nx,ny,nv,vinc,ratio,threshold,bval,eval)
  integer(kind=index_length), intent(in)  :: nx             !
  integer(kind=index_length), intent(in)  :: ny             !
  real(kind=4),               intent(out) :: width(nx,ny)   !
  real(kind=4),               intent(out) :: blue(nx,ny)    !
  real(kind=4),               intent(out) :: red(nx,ny)     !
  integer(kind=index_length), intent(in)  :: nv             !
  real(kind=4),               intent(in)  :: vlm(nv,nx,ny)  !
  real(kind=8),               intent(in)  :: vinc           !
  real(kind=4),               intent(in)  :: ratio          !
  real(kind=4),               intent(in)  :: threshold      !
  real(kind=4),               intent(in)  :: bval           !
  real(kind=4),               intent(in)  :: eval           !
  ! Local
  integer(kind=index_length) :: j,k,nvm
  !
  ! Loop over all spectra
  nvm = nv/2
  do k=1,ny
    do j=1,nx
      if (abs(vlm(nvm,j,k)-bval).gt.eval) then
        call spectre(nv,vlm(:,j,k),blue(j,k),red(j,k),   &
                     ratio,threshold,width(j,k),vinc)
      else
        blue(j,k) = bval
        red(j,k) = bval
        width(j,k) = bval
      endif
    enddo
  enddo
end subroutine sub_flow
!
subroutine spectre(nv,array,blue,red,ratio,threshold,width,vinc)
  integer(kind=index_length), intent(in)  :: nv         !
  real(kind=4),               intent(in)  :: array(nv)  !
  real(kind=4),               intent(out) :: blue       !
  real(kind=4),               intent(out) :: red        !
  real(kind=4),               intent(in)  :: ratio      !
  real(kind=4),               intent(in)  :: threshold  !
  real(kind=4),               intent(out) :: width      !
  real(kind=8),               intent(in)  :: vinc       !
  ! Local
  integer(kind=index_length) :: i,imin,imax
  real(kind=4) :: rmax
  !
  imax = 1
  rmax = array(1)
  do i=2,nv
    if (array(i).gt.rmax) then
      imax = i
      rmax = array(i)
    endif
  enddo
  !
  blue = 0.0
  red  = 0.0
  if (ratio*rmax.le.threshold) return
  i = imax
  do while (i.gt.1 .and. array(i).gt.ratio*rmax)
    i = i-1
  enddo
  do while (i.gt.1 .and. array(i).ge.threshold)
    blue = blue+array(i)
    i = i-1
  enddo
  imin = i
  i = imax
  do while (i.lt.nv .and. array(i).gt.ratio*rmax)
    i = i+1
  enddo
  do while (i.lt.nv .and. array(i).ge.threshold)
    red = red+array(i)
    i = i+1
  enddo
  imax = i
  width = (imax-imin+1)*vinc
  if (width.ge.0.0) return
  rmax = blue
  blue = red
  red = rmax
  width = -width
end subroutine spectre
!
end program flow_main

subroutine rgimag(line,optrgdata,dosubset,optsubset,error)
  use gildas_def
  use gbl_format
  use gbl_constant
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>rgimag
  use sic_types
  use greg_image
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for subset of commands
  !   RGDATA  Name
  !     /VARIABLE
  !     [/SUBSET]
  ! and
  !   LIMITS /RGDATA  Name
  ! Load RG data from variable name
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Command line
  integer(kind=4),  intent(in)    :: optrgdata  ! RG data option
  logical,          intent(in)    :: dosubset   ! Subset option present?
  integer(kind=4),  intent(in)    :: optsubset  ! Subset option number, if relevant
  logical,          intent(inout) :: error      ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  character(len=80) :: chain,varia,name
  logical :: header
  real(kind=8) :: conv(6)
  integer(kind=4) :: lc,form,nc
  integer(kind=index_length) :: ix,iy
  type(sic_descriptor_t) :: descr,dconv
  integer(kind=address_length) :: ipd
  integer(kind=4) :: nx1,ny1,nx2,ny2
  !
  save dconv,conv
  !
  call sic_ch (line,optrgdata,1,name,nc,.true.,error)
  if (error) return
  call sic_upper(name)
  !
  ! Option /SUBSET
  if (dosubset) then
    call sic_i4 (line,optsubset,1,nx1,.false.,error)
    if (error) return
    call sic_i4 (line,optsubset,2,ny1,.false.,error)
    if (error) return
    call sic_i4 (line,optsubset,3,nx2,.false.,error)
    if (error) return
    call sic_i4 (line,optsubset,4,ny2,.false.,error)
    if (error) return
    ninfx = min(nx1,nx2)
    ninfy = min(ny1,ny2)
    nsupx = max(nx1,nx2)
    nsupy = max(ny1,ny2)
  endif
  !
  varia = name
  error = .true.
  call sic_materialize(varia,descr,error)
  error = .not.error
  if (error) then
    call greg_message(seve%e,rname,'Variable '//trim(varia)//' not found')
    return
  endif
  !
  ! Try A%DATA if a structure has been specified
  if (descr%dims(1).eq.0 .and. descr%status.lt.0) then
    varia = trim(name)//'%DATA'
    call sic_materialize(varia,descr,error)
    error = .not.error
    if (error) then
      call greg_message(seve%e,rname,'Variable '//trim(varia)//' not found')
      return
    endif
    varia = name
  endif
  !
  ! Support User Coordinates if defined by header
  chain = name
  lc = index(chain,'[')
  if (lc.eq.0) lc = len_trim(chain)+1
  ! Skip the %DATA name if it was specified
  if (lc.ge.6 .and. chain(lc-5:lc-1).eq.'%DATA') then
    lc = lc-5
  endif
  chain(lc:) = '%CONVERT'
  header = .false.
  call sic_descriptor(chain,dconv,header)
  if (header) then
    ipd = gag_pointer(dconv%addr,memory)
    call r8tor8(memory(ipd),conv,6)
  else
    conv(1:6) = 1.d0
  endif
  ix = descr%dims(1)
  iy = descr%dims(2)
  !
  if (dosubset) then
    if (ninfx.lt.1 .or. nsupx.gt.ix .or. ninfy.lt.1 .or. nsupy.gt.iy) then
      call greg_message(seve%e,rname,'Subset is outside variable dimensions')
      call sic_volatile(descr)
      error=.true.
      return
    endif
  endif
  !
  form = descr%type
  if (ix.lt.1) then
    call greg_message(seve%e,rname,'First Dimension is too low')
    error = .true.
  else if (iy.lt.1) then
    call greg_message(seve%e,rname,'Second Dimension is too low')
    error = .true.
    !
  else if (form.eq.fmt_r4) then
    ipd = gag_pointer(descr%addr,memory)
    if (dosubset) then
      call gr4_rgivesub(ix,iy,conv,memory(ipd),ninfx,nsupx,ninfy,nsupy)
    elseif (sic_level(varia).ne.0) then
      call gr4_tgive(ix,iy,conv,memory(ipd))
    else
      call gr4_rgive(ix,iy,conv,memory(ipd))
    endif
    !
  else if (form.eq.fmt_r8) then
    ipd = gag_pointer(descr%addr,memory)
    if (dosubset) then
      call gr8_tgivesub(ix,iy,conv,memory(ipd),ninfx,nsupx,ninfy,nsupy)
    else
      call gr8_tgive(ix,iy,conv,memory(ipd))
    endif
    !
  else if (form.eq.fmt_i4) then
    ipd = gag_pointer(descr%addr,memory)
    if (dosubset) then
      call greg_message(seve%e,rname,'/SUBSET not implemented for I*4 arrays')
      error = .true.
      return
    else
      call gi4_tgive(ix,iy,conv,memory(ipd))
    endif
    !
  else if (form.eq.fmt_i8) then
    ipd = gag_pointer(descr%addr,memory)
    if (dosubset) then
      call greg_message(seve%e,rname,'/SUBSET not implemented for I*8 arrays')
      error = .true.
      return
    else
      call gi8_tgive(ix,iy,conv,memory(ipd))
    endif
    !
  else
    call greg_message(seve%e,rname,'Unsupported format')
    error = .true.
  endif
  if (error) then
    call sic_volatile(descr)
    return
  endif
  !
  ! Put also projection information if needed
  if (header) then
    chain(lc:) = '%PTYPE'
    call sic_get_inte(chain,rg%imag%gil%ptyp,error)
    if (error) then
      !
      ! Do nothing, inherit from current conversion
      error = .false.
    elseif (rg%imag%gil%ptyp.eq.p_none) then
      call greg_projec(p_none,rg%imag%gil%a0)
    else
      !
      ! Define projection characteristics
      chain(lc:) = '%X_AXIS'
      call sic_get_inte(chain,rg%imag%gil%xaxi,error)
      chain(lc:) = '%Y_AXIS'
      call sic_get_inte(chain,rg%imag%gil%yaxi,error)
      if (rg%imag%gil%xaxi.eq.0.and.rg%imag%gil%yaxi.eq.0) then
        rg%imag%gil%xaxi = 1
        rg%imag%gil%yaxi = 2
      endif
      chain(lc:) = '%A0'
      call sic_get_dble(chain,rg%imag%gil%a0,error)
      chain(lc:) = '%D0'
      call sic_get_dble(chain,rg%imag%gil%d0,error)
      chain(lc:) = '%ANGLE'
      call sic_get_dble(chain,rg%imag%gil%pang,error)
      if (rg%imag%gil%xaxi.eq.1.and.rg%imag%gil%yaxi.eq.2) then
        call greg_projec(rg%imag%gil%ptyp,rg%imag%gil%a0)
      elseif (rg%imag%gil%xaxi.eq.2.and.rg%imag%gil%yaxi.eq.1) then
        call greg_projec(rg%imag%gil%ptyp,rg%imag%gil%a0)
      else
        call greg_projec(p_none,rg%imag%gil%a0)
      endif
    endif
    chain(lc:) = '%BLANK[1]'
    call sic_get_real(chain,rg%imag%gil%bval,error)
    chain(lc:) = '%BLANK[2]'
    call sic_get_real(chain,rg%imag%gil%eval,error)
    call gr8_blanking(dble(rg%imag%gil%bval),dble(rg%imag%gil%eval))
    !
    chain(lc:) = '%SYSTEM'
    nc = len(rg%imag%char%syst)
    call sic_get_char(chain,rg%imag%char%syst,nc,error)
    !
    if (error) then
      !
      ! Error = .true. means no system is defined in the variable
      ! Do nothing in such a case: use current system
      error = .false.
    else
      !
      ! Define system if more information is present
      if (rg%imag%char%syst(1:nc).eq.'ICRS') then
        call gr8_system(type_ic,error)
      elseif (rg%imag%char%syst(1:nc).eq.'EQUATORIAL') then
        chain(lc:) = '%EQUINOX'
        call sic_get_real(chain,rg%imag%gil%epoc,error)
        call gr8_system(type_eq,error,rg%imag%gil%epoc)
      elseif (rg%imag%char%syst(1:nc).eq.'GALACTIC') then
        call gr8_system(type_ga,error)
      elseif (rg%imag%char%syst(1:nc).eq.'HORIZONTAL') then
        call gr8_system(type_ho,error)
      else
        call gr8_system(type_un,error)
      endif
      if (error)  return
    endif
  endif                        ! End HEADER
  error = .false.
end subroutine rgimag
!
subroutine rgrsd(line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces, no_interface=>gr8_minmax
  use greg_interfaces, except_this=>rgrsd
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! Subroutine for Regularly Spaced Data, possibly uncompletely sampled,
  ! in column (XYZ or other variables) "format".
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  character(len=message_length) :: string
  integer(kind=size_length) :: ixy,nmin,nmax
  integer :: form,narg,nfx,nfy
  type(sic_descriptor_t) :: xinca,yinca,zinca
  integer(kind=address_length) :: xaddr,yaddr,zaddr
  real(8) :: incx,incy
  real(8) :: xmin,xmax,ymin,ymax
  real(8) :: conv(6)
  real(4) :: blank
  !
  save xinca,yinca,zinca
  !
  ! We need a Blanking value
  if (eblank.ge.0.0d0) then
    blank = cblank
    call sic_r4 (line,5,1,blank,.false.,error)
    if (error) return
  else
    call sic_r4 (line,5,1,blank,.true.,error)
    if (error) then
      call greg_message(seve%e,rname,'Please Set or Specify a blanking value')
      return
    endif
  endif
  ! 3 arguments or None: we have a Regularly Spaced Data either in
  ! [already existing] variables X Y and Z, or in 3 Arrays (in both cases
  ! the /VAR option is superfluous)
  narg=sic_narg(0)
  form = fmt_r8
  !
  call get_incarnation('RGDATA',line,form,ixy,xinca,yinca,error)
  if (error) return
  xaddr = gag_pointer(xinca%addr,memory)
  yaddr = gag_pointer(yinca%addr,memory)
  if (narg.gt.0) then
    call get_same_inca ('RGDATA',line,0,3,form,ixy,zinca,error)
  else
    call get_greg_inca ('RGDATA','Z',form,ixy,zinca,error)
  endif
  if (error) then
    call sic_volatile(xinca)
    call sic_volatile(yinca)
    return
  endif
  zaddr = gag_pointer(zinca%addr,memory)
  !
  if (sic_present(4,0)) then
    call sic_r8 (line,4,1,incx,.false.,error)
    call sic_r8 (line,4,2,incy,.false.,error)
    if (error) then
      call sic_volatile(xinca)
      call sic_volatile(yinca)
      call sic_volatile(zinca)
      return
    endif
    call gr8_minmax(ixy,memory(xaddr),cblank,eblank,xmin,xmax,nmin,nmax)
    call gr8_minmax(ixy,memory(yaddr),cblank,eblank,ymin,ymax,nmin,nmax)
  else
    call find_inc8(memory(xaddr),ixy,xmin,xmax,incx,eblank,cblank)
    call find_inc8(memory(yaddr),ixy,ymin,ymax,incy,eblank,cblank)
  endif
  ! Find Map size
  nfx  = nint((xmax-xmin)/abs(incx))+1
  nfy  = nint((ymax-ymin)/abs(incy))+1
  if (nfx.le.1 .or. nfy.le.1 .or. int(nfx,8)*int(nfy,8).gt.4096*4096) then
    write(string,'(A,I12,A,I12)') 'Unsupported cube dimensions, ',nfx,  &
                                  ' times ',nfy
    call greg_message(seve%e,rname,string)
    call greg_message(seve%e,rname,'Specify more adequate Increments')
    error = .true.
    call sic_volatile(xinca)
    call sic_volatile(yinca)
    call sic_volatile(zinca)
    return
  endif
  ! Axis conversion semigroup
  conv(1)=1.0d0
  conv(2)=xmin
  conv(3)=abs(incx)
  conv(4)=1.0d0
  conv(5)=ymin
  conv(6)=abs(incy)
  ! Get virtual memory if needed. Flush Incarnation before releasing VM,
  ! and call back incarnation After.
  if (rg%status.eq.code_pointer_null       .or.                  &
      rg%status.eq.code_pointer_associated .or.                  &
      (rg%status.eq.code_pointer_allocated .and.                 &
       (ubound(rg%data,1).ne.nfx .or. ubound(rg%data,2).ne.nfy))) then
    ! Reallocation neeeded
    call sic_volatile(xinca)
    call sic_volatile(yinca)
    call sic_volatile(zinca)
    !
    call reallocate_rgdata(nfx,nfy,error)
    if (error)  return
    !
    ! Reallocates VM AFTER the VM for RGDATA
    call get_incarnation('RGDATA',line,form,ixy,xinca,yinca,error)
    if (error) return
    xaddr = gag_pointer(xinca%addr,memory)
    yaddr = gag_pointer(yinca%addr,memory)
    if (narg.gt.0) then
      call get_same_inca ('RGDATA',line,0,3,form,ixy,zinca,error)
    else
      call get_greg_inca ('RGDATA','Z',form,ixy,zinca,error)
    endif
    if (error) then
      call sic_volatile(xinca)
      call sic_volatile(yinca)
      return
    endif
    zaddr = gag_pointer(zinca%addr,memory)
  endif
  !
  ! Computes RGDATA and update several CONPLOT common values
  call rgfromxyz(rg%data,nfx,nfy,memory(xaddr),memory(yaddr),  &
    memory(zaddr),ixy,conv,eblank,cblank,blank,error)
  if (error)  continue  ! Need to clean the temporary variables
  rg%xref = conv(1)
  rg%xval = conv(2)
  rg%xinc = conv(3)
  rg%yref = conv(4)
  rg%yval = conv(5)
  rg%yinc = conv(6)
  ! give back VM
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  call sic_volatile(zinca)
  !
  ! set limit of plot region if requested ???
  !      CALL FLIMIT
end subroutine rgrsd
!
subroutine rgfromxyz(rg,nx,ny,x,y,z,n,conv,eb,cb,b,error)
  use gildas_def
  use gbl_message
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Puts Z=F(X,Y) if X and Y are not in a blanked interval;
  !   Z=B where no X,Y
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: nx         ! X grid size
  integer(kind=4),           intent(in)    :: ny         ! Y grid size
  real(kind=4),              intent(out)   :: rg(nx,ny)  ! Gridded values
  integer(kind=size_length), intent(in)    :: n          ! Number of points
  real(kind=8),              intent(in)    :: x(n)       !
  real(kind=8),              intent(in)    :: y(n)       !
  real(kind=8),              intent(in)    :: z(n)       !
  real(kind=8),              intent(in)    :: conv(6)    ! Conversion formula
  real(kind=8),              intent(in)    :: eb         ! Blanking tolerance
  real(kind=8),              intent(in)    :: cb         ! Blanking
  real(kind=4),              intent(in)    :: b          ! Default value
  logical,                   intent(inout) :: error      !
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  integer(kind=4) :: i,j
  integer(kind=size_length) :: k
  real(kind=8) :: l1,l2
  integer(kind=size_length) :: backp(nx,ny)  ! Automatic array
  character(len=message_length) :: mess
  !
  rg(:,:) = b
  backp(:,:) = 0
  !
  if (eb.lt.0.0d0)then
    do k=1,n
      l1=(x(k)-conv(2))/conv(3) + conv(1)
      i=nint(l1)
      l2=(y(k)-conv(5))/conv(6) + conv(4)
      j=nint(l2)
      if (backp(i,j).gt.0)  goto 10
      rg(i,j)=z(k)
      backp(i,j) = k
    enddo
  else
    do k=1,n
      if (abs(x(k)-cb).gt.eb.or.abs(y(k)-cb).gt.eb) then
        l1=(x(k)-conv(2))/conv(3) + conv(1)
        i=nint(l1)
        l2=(y(k)-conv(5))/conv(6) + conv(4)
        j=nint(l2)
        if (backp(i,j).gt.0)  goto 10
        rg(i,j)=z(k)
        backp(i,j) = k
      endif
    enddo
  endif
  return
  !
  ! Error
10 continue
  write(mess,'(5(A,I0))')  'Pixel at position (',i,',',j,  &
    ') is defined several times at indices ',backp(i,j),' and ',k
  call greg_message(seve%e,rname,mess)
  error = .true.
  return
  !
end subroutine rgfromxyz
!
subroutine greg_rgdata(line,error)
  use gildas_def
  use gbl_constant
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_rgdata
  use greg_image
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !  RGDATA Name
  !   [/SUBSET Imin Jmin Imax Jmax]
  !   [/VARIABLE]
  !   [/FORMAT fmt_code]
  !  Read a RGDATA file into the Regular grid array
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  integer(kind=4) :: nx1,ny1,nx2,ny2,nfx,nfy,lc
  logical :: all,noproblem,dosubset
  character(len=40), save :: fmt
  character(len=80) :: chain,string
  character(len=filename_length) :: namfile
  integer(kind=4) :: nc,ier,code,narg
  integer(kind=4), parameter :: optsubs=1
  integer(kind=4), parameter :: optvari=2
  integer(kind=4), parameter :: optform=3
  integer(kind=4), parameter :: optincr=4
  integer(kind=4), parameter :: optblan=5
  ! Data
  data fmt /' '/
  !
  narg = sic_narg(0)
  if (narg.eq.3 .or. narg.eq.0) then
    ! 3 arguments or None: we have a Regularly Spaced Data either in [already
    ! existing] variables X Y and Z, or in 3 Arrays
    if (sic_present(optvari,0)) then
      if (narg.eq.0) then
        call greg_message(seve%e,rname,  &
          'Invalid option /VARIABLE when no argument is passed to command')
      else
        call greg_message(seve%e,rname,  &
          'Option /VARIABLE conflicts with the 3 X Y Z arrays passed to command')
      endif
      error = .true.
      return
    endif
    call rgrsd(line,error)
    return
  elseif (narg.eq.1) then
    call sic_ch(line,0,1,chain,nc,.true.,error)
    if (error) return
  else
    call greg_message(seve%e,rname,'Zero, One or Three arguments please')
    error = .true.
    return
  endif
  !
  ! /VARIABLE option
  if (sic_present(optvari,0)) then
    ! Variable name is taken from argument to command i.e. RGDATA Name /VARIABLE
    dosubset = sic_present(optsubs,0)
    if (dosubset .and. .not.sic_present(optsubs,4)) then
      call greg_message(seve%e,rname,'Map subset must be defined by 4 integers')
      error = .true.
      return
    endif
    ! Now read the variable
    call rgimag(line,0,dosubset,optsubs,error)
    return
  endif
  !
  ! Find the file name and open the file
  code=fmt_r4
  call sic_parsef (chain,namfile,' ','.dat')
  ier = sic_open(jtmp,namfile,'OLD',.true.)
  if (ier.ne.0) then
    string = 'Cannot open file '//namfile
    call greg_message(seve%e,rname,string)
    call putios('E-RGDATA,  ',ier)
    error = .true.
    return
  endif
  !
  ! Read header
  call rghead(error)
  if (error) goto 30
  !
  all = .not.sic_present(optsubs,0)
  noproblem = .not.sic_present(optform,0)
  ! Option /SUBSET
  if (all) then
    nfx = fnx
    nfy = fny
    ninfx = 1
    ninfy = 1
    nsupx = nfx
    nsupy = nfy
    if (nfx*nfy.gt.512*512)  &
      call greg_message(seve%w,rname,'Map is very large, contouring '//  &
      'may be slow')
  else
    if (.not.sic_present(optsubs,4)) then
      call greg_message(seve%e,rname,'Map subset must be defined by 4 integers')
      error = .true.
      goto 30
    endif
    call sic_i4 (line,optsubs,1,nx1,.false.,error)
    if (error) goto 30
    call sic_i4 (line,optsubs,2,ny1,.false.,error)
    if (error) goto 30
    call sic_i4 (line,optsubs,3,nx2,.false.,error)
    if (error) goto 30
    call sic_i4 (line,optsubs,4,ny2,.false.,error)
    if (error) goto 30
    ninfx = min(nx1,nx2)
    ninfy = min(ny1,ny2)
    nsupx = max(nx1,nx2)
    nsupy = max(ny1,ny2)
    if (ninfx.lt.1 .or. nsupx.gt.fnx .or. ninfy.lt.1 .or. nsupy.gt.fny) then
      call greg_message(seve%e,rname,'Map subset does not lie in the map')
      error = .true.
      goto 30
    endif
    nfx = nsupx-ninfx+1
    nfy = nsupy-ninfy+1
  endif
  !
  ! /FORMAT option
  if (sic_present(optform,0)) then
    call sic_ch (line,optform,1,chain,lc,.true.,error)
    if (error) goto 30
    if (lc.gt.len(fmt)-2) then
      call greg_message(seve%e,rname,'Format is too long')
      error = .true.
      goto 30
    endif
    fmt = '('//chain(1:lc)//')'
    noproblem=.true.
    if (sic_present(optform,2)) then
      call sic_ke (line,optform,2,chain,nc,.true.,error)
      if (error) goto 30
      noproblem=.false.
      if (chain(1:2).eq.'R4') then
        code=fmt_r4
        noproblem=.true.
      elseif (chain(1:2).eq.'R8') then
        code=fmt_r8
      elseif (chain(1:2).eq.'I4') then
        code=fmt_i4
      elseif (chain(1:2).eq.'I2') then
        code=fmt_i2
      elseif (chain(1:2).eq.'BY') then
        code=fmt_by
      else
        call greg_message(seve%e,rname,'Unsupported data type'//chain(1:2))
        error = .true.
        goto 30
      endif
    endif
  endif
  !
  ! Get virtual memory if needed
  call reallocate_rgdata(nfx,nfy,error)
  if (error)  goto 30
  !
  ! Load it
  if (noproblem) then
    call rgread(rg%data,all,nfx,nfy,fmt,error)
  else
    call rgread_all(rg%data,nfx,nfy,fmt,code,error)
  endif
  if (error) goto 30
  !
  ! Set limits of Plot region if requested
  call flimit
30 close (unit=jtmp)
  !
end subroutine greg_rgdata
!
subroutine rghead (error)
  use greg_interfaces, except_this=>rghead
  use greg_kernel
  use greg_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	This subroutine reads a map header and retrieves the following
  ! 	information for later use by GREG
  !		XREF, NX, XVAL, XINC, XUNIT
  !		YREF, NY, YVAL, YINC, YUNIT
  ! Arguments :
  !	NX	I	Number of X pixels		Output
  !	NY	I	Number of Y pixels		Output
  !	*	*	Alternate error return		Input
  ! No subroutine referenced
  ! Commons	GRUNIT, FITS
  !---------------------------------------------------------------------
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  character(len=80) :: xtype,ytype,chain
  !
  read(jtmp,*,err=100) fnx,fxref,fxval,fxinc
  read(jtmp,'(A)') xtype
  read(jtmp,*,err=100) fny,fyref,fyval,fyinc
  read(jtmp,'(A)') ytype
  xunit='UNKNOWN'
  yunit='UNKNOWN'
  !
  chain = 'X axis comment: '//xtype
  call greg_message(seve%i,rname,chain)
  chain = 'Y axis comment: '//ytype
  call greg_message(seve%i,rname,chain)
  call greg_message(seve%i,rname,'File header read successfully')
  return
  !
100 call greg_message(seve%e,rname,'Input conversion error in header')
  error = .true.
end subroutine rghead
!
subroutine rgread(regmap,all,nfx,nfy,fmt,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>rgread
  use greg_kernel
  use greg_image
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG 	Internal routine
  !	  Read the data in a RGDATA file
  !   An optional format can be specified. Default is 10Z8.8
  !---------------------------------------------------------------------
  integer, intent(in) :: nfx                    ! X grid size
  integer, intent(in) :: nfy                    ! Y grid size
  real(4), intent(out):: regmap(nfx*nfy)        ! Grid values
  logical, intent(in) :: all                    ! Read all map ?
  character(len=*), intent(in) :: fmt           ! Format for reading
  logical, intent(out) :: error                 !
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  real(4) :: zbuf(20)
  integer(4) :: ibuf(20)
  integer(4) :: ndata,nout,k,l,n,i,i1,j1,ier
  character(len=80) :: chain
  equivalence (ibuf,zbuf)
  !
  ! From the header, we have FNX*FNY integer pixel values to read
  ! in format FMT or 10Z8.8. Unpack the data in unit of 80 bytes.
  !
  ndata=fnx*fny
  nout =nfx*nfy
  k = 0
  !
  ! Start of data conversion loop.
  if (all) then
    !
    ! Quick retrieval of complete Map
    if (fmt.eq.' ') then
      call rgsread(jtmp,regmap,fmt,nout,ier)
    elseif (index(fmt,'Z').ne.0) then
      call rgsread(jtmp,regmap,fmt,nout,ier)
    else
      read(jtmp,fmt,iostat=ier) regmap
    endif
    if (ier.ne.0) then
      call putios('E-RGDATA,  ',ier)
      error = .true.
      return
    endif
    rg%xref = fxref
    rg%yref = fyref
    !
    ! Retrieve only a Subset of the map. For optimisation reasons,
    ! the test for a run time format is done outside the main loop.
    !
    ! This part of the code will usually complain if the file is
    ! not appropriately padded.
  else
    !
    ! Default 10Z8.8 format
    if (fmt.eq.' ') then
      l=0
      i1=0
      j1=1
      !
20    read(jtmp,'(10Z8.8)',iostat=ier)  ibuf
      n = 80
      if (ier.ne.0) then
        call putios('E-RGDATA,  ',ier)
        error = .true.
        return
      endif
      n=n/4
      n=min(ndata-l,n)
      !
      ! Fill the array
      do i=1,n
        l=l+1
        i1=i1+1
        if (i1.gt.fnx) then
          i1=1
          j1=j1+1
        endif
        if (j1.lt.ninfy) cycle ! I
        if (j1.gt.nsupy) cycle ! I
        if (i1.lt.ninfx) cycle ! I
        if (i1.gt.nsupx) cycle ! I
        k = k+1
        regmap(k) = zbuf(i)
      enddo
      if (l.lt.ndata .and. k.lt.nout) goto 20
      ! Run time format
    else
      l=0
      i1=0
      j1=1
      ! Will crash at end of file, unless the last line has been padded....
40    continue
      if (index(fmt,'Z').eq.0) then
        read(jtmp,fmt,iostat=ier) zbuf
      else
        read(jtmp,fmt,iostat=ier) ibuf
      endif
      if (ier.ne.0) then
        call putios('E-RGDATA,  ',ier)
        error = .true.
        return
      endif
      n = 20
      n = min(ndata-l,n)
      !
      ! Fill the array
      do i=1,n
        l=l+1
        i1=i1+1
        if (i1.gt.fnx) then
          i1=1
          j1=j1+1
        endif
        if (j1.lt.ninfy) cycle ! I
        if (j1.gt.nsupy) cycle ! I
        if (i1.lt.ninfx) cycle ! I
        if (i1.gt.nsupx) cycle ! I
        k = k+1
        regmap(k) = zbuf(i)
      enddo
      if (l.lt.ndata .and. k.lt.nout) goto 40
    endif
    !
    ! Update reference pixel
    rg%xref = fxref + 1. - ninfx
    rg%yref = fyref + 1. - ninfy
  endif
  !
  ! Other initialisations
  rg%nx = nfx
  rg%ny = nfy
  rg%xval = fxval
  rg%yval = fyval
  rg%xinc = fxinc
  rg%yinc = fyinc
  call greg_message(seve%i,rname,'Data read successfully')
  write(chain,1004) rg%nx,rg%ny
  call greg_message(seve%i,rname,chain)
  write(chain,1003)
  call greg_message(seve%i,rname,chain)
  write(chain,1002) 'X',rg%xref,rg%xval,rg%xinc
  call greg_message(seve%i,rname,chain)
  write(chain,1002) 'Y',rg%yref,rg%yval,rg%yinc
  call greg_message(seve%i,rname,chain)
  error = .false.
  return
  !
1002 format(t5,a,t12,1pg11.4,t30,1pg13.6,t50,1pg11.4)
1004 format('Map size is ',i3,' by ',i3)
1003 format('   Axis',t12,'Reference pixel',t33,'Value',t50,'Increment')
end subroutine rgread
!
subroutine rgread_all(regmap,nfx,nfy,fmt,code,error)
  use gbl_format
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>rgread_all
  use greg_kernel
  use greg_image
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG 	Internal routine
  !	Read the data in a RGDATA file
  ! Arguments :
  !     REGMAP	R*4 (*)	Regular grid array to be filled		Output
  !     NFX	I*4	First map dimension			Output
  !     NFY	I*4	Second map dimension			Output
  !     FMT	C*(*)	Data file format			Input
  !     CODE      I*4     Input data type                         Input
  !     ERROR	L	Error return			        Output
  !---------------------------------------------------------------------
  integer, intent(in) :: nfx                    ! X grid size
  integer, intent(in) :: nfy                    ! Y grid size
  real(4), intent(out):: regmap(nfx*nfy)        ! Grid values
  character(len=*), intent(in) :: fmt           ! Format for reading
  integer, intent(in) :: code                   ! Type of data
  logical, intent(out) :: error                 !
  !    
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  integer :: atom,kk,ier
  integer(4) :: ndata,k,l,n,i,i1,j1
  character(len=256) :: longue
  integer(kind=1) :: bbuf(256)
  integer(2):: i2buf(128)
  integer(4) :: i4buf(64)
  real(4) :: r4buf(64)
  real(8) :: r8buf(32)
  equivalence(bbuf,i2buf)
  equivalence(bbuf,i4buf)
  equivalence(bbuf,r4buf)
  equivalence(bbuf,r8buf)
  character(len=80) :: chain
  !
  ndata=fnx*fny
  k = 0
  if (code.eq.fmt_r8) then
    atom = 16
  elseif (code.eq.fmt_r4) then
    atom = 8
  elseif (code.eq.fmt_i4) then
    atom = 8
  elseif (code.eq.fmt_i2) then
    atom = 4
  elseif (code.eq.fmt_by) then
    atom = 2
  endif
  if (index(fmt,'A').ne.0) atom=atom/2
  !
  ! Start of data conversion loop.
  rg%xref = fxref
  rg%yref = fyref
  l=0
  i1=0
  j1=1
  !
40 read(jtmp,'(A)',iostat=ier) longue
  if (ier.ne.0) then
    call putios('E-RGDATA,  ',ier)
    error = .true.
    return
  endif
  n = len_trim(longue)
  if (n.eq.0) goto 40
  n = n/atom
  n = min(ndata-l,n)
  !
  ! Read
  if (code.eq.fmt_r8) then
    read(longue,fmt,iostat=ier) (r8buf(kk),kk=1,n)
  elseif (code.eq.fmt_r4) then
    read(longue,fmt,iostat=ier) (r4buf(kk),kk=1,n)
  elseif (code.eq.fmt_i4) then
    read(longue,fmt,iostat=ier) (i4buf(kk),kk=1,n)
  elseif (code.eq.fmt_i2) then
    read(longue,fmt,iostat=ier) (i2buf(kk),kk=1,n)
  elseif (code.eq.fmt_by) then
    read(longue,fmt,iostat=ier) (bbuf(kk),kk=1,n)
  endif
  if (ier.ne.0) then
    call putios('E-RGDATA,  ',ier)
    error = .true.
    return
  endif
  !
  ! Fill the array
  do i=1,n
    l  = l+1
    i1 = i1+1
    if (i1.gt.fnx) then
      i1=1
      j1=j1+1
    endif
    if (j1.lt.ninfy) cycle     ! I
    if (j1.gt.nsupy) cycle     ! I
    if (i1.lt.ninfx) cycle     ! I
    if (i1.gt.nsupx) cycle     ! I
    k = k+1
    if (code.eq.fmt_r8) then
      regmap(k) = r8buf(i)
    elseif (code.eq.fmt_r4) then
      regmap(k) = r4buf(i)
    elseif (code.eq.fmt_i4) then
      regmap(k) = i4buf(i)
    elseif (code.eq.fmt_i2) then
      regmap(k) = i2buf(i)
    elseif (code.eq.fmt_by) then
      regmap(k) = bbuf(i)
    endif
  enddo
  if (l.lt.ndata) goto 40
  !
  ! Bytes have to be unsigned
  if (code.eq.fmt_by) then
    do k=1,nfx*nfy
      if (regmap(k).lt.0) regmap(k)=regmap(k)+256
    enddo
  endif
  !
  ! Update reference pixel
  rg%xref = fxref + 1. - ninfx
  rg%yref = fyref + 1. - ninfy
  !
  ! Other initialisations
  rg%nx = nfx
  rg%ny = nfy
  rg%xval = fxval
  rg%yval = fyval
  rg%xinc = fxinc
  rg%yinc = fyinc
  call greg_message(seve%i,rname,'Data read successfully')
  write(chain,1004) rg%nx,rg%ny
  call greg_message(seve%i,rname,chain)
  write(chain,1003)
  call greg_message(seve%i,rname,chain)
  write(chain,1002) 'X',rg%xref,rg%xval,rg%xinc
  call greg_message(seve%i,rname,chain)
  write(chain,1002) 'Y',rg%yref,rg%yval,rg%yinc
  call greg_message(seve%i,rname,chain)
  return
  !
1002 format(t5,a,t12,1pg11.4,t30,1pg13.6,t50,1pg11.4)
1004 format('Map size is ',i3,' by ',i3)
1003 format('   Axis',t12,'Reference pixel',t33,'Value',t50,'Increment')
end subroutine rgread_all
!
subroutine rgsread(jtmp,r,fmt,n,ier)
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer :: jtmp                   !
  integer :: n                      !
  integer :: r(n)                   !
  character(len=*) :: fmt           !
  integer :: ier                    !
  !
  if (fmt.eq.' ') then
    read(jtmp,'(10Z8.8)',iostat=ier) r
  else
    read(jtmp,fmt,iostat=ier) r
  endif
end subroutine rgsread
!
subroutine find_inc8 (input,ixy,xmin,xmax,xinc,eblank,cblank)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Find the increment from X,Y values which are regularly sampled
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: ixy  ! Number of values
  real(8), intent(in) :: input(ixy)             ! Values
  real(8), intent(out) :: xmin                  ! Minimum
  real(8), intent(out)  :: xmax                 ! Maximum
  real(8), intent(out)  :: xinc                 ! Step
  real(8), intent(in) :: eblank                 ! Blanking tolerance
  real(8), intent(in) :: cblank                 ! Blanking
  ! Local
  real(8), allocatable :: value(:) 
  integer(kind=size_length) :: nval,i,j,nmin,nmax
  integer :: ier
  real(8) :: l1,l2
  logical :: found
  !
  nval = 1
  allocate (value(ixy), stat=ier)
  value(1) = input(1)
  !
  do i=2,ixy
    found = .false.
    do j=1,nval
      if (input(i).eq.value(j)) then
        found = .true.
        exit
      endif
    enddo
    if (.not.found) then
      nval  = nval+1
      value(nval) = input(i)
    endif
  enddo
  !
  call gr8_minmax(nval,value,cblank,eblank,xmin,xmax,nmin,nmax)
  !
  xinc = xmax-xmin
  if (eblank.lt.0.0d0) then
    do i=1,nval-1
      l1=value(i)
      do j=i+1,nval
        l2 = value(j)
        xinc = min(xinc,abs(l1-l2))
      enddo
    enddo
  else
    do i=1,nval-1
      l1=value(i)
      if (abs(l1-cblank).gt.eblank) then
        do j=i+1,nval
          l2 = value(j)
          if (abs(l2-cblank).gt.eblank) then
            xinc = min(xinc,abs(l1-l2))
          endif
        enddo
      endif
    enddo
  endif
  deallocate (value)
end subroutine find_inc8
!
! Obsolete Routines
!
subroutine find_mapchar8(x,y,n,xinc,yinc,xmin,ymin,xmax,ymax,eb,cb)
  use greg_interfaces, except_this=>find_mapchar8
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: n                      !
  real(8) :: x(n)                    !
  real(8) :: y(n)                    !
  real(8) :: xinc                    !
  real(8) :: yinc                    !
  real(8) :: xmin                    !
  real(8) :: ymin                    !
  real(8) :: xmax                    !
  real(8) :: ymax                    !
  real(8) :: eb                      !
  real(8) :: cb                      !
  ! Local
  real(8) :: l1,m1,l2,m2,val,d1,d2
  integer :: i,j
  !
  call find_siz8(x,y,n,xmin,xmax,ymin,ymax,eb,cb)
  !
  ! This algorithm is stupid: it compares all values two by two, so is of order N by N
  !
  ! The good trick is to build an histogram of values, which are presumably much less numerous
  ! (of order sqrt(N)) than N, since we build a regular grid.
  d1=xmax-xmin
  d2=ymax-ymin
  if (eb.lt.0.0d0) then
    do i=1,n-1
      l1=x(i)
      do j=i+1,n
        l2 = x(j)
        val = abs(l1-l2)
        if (val.ne.0d0) d1 = min(d1,val)
      enddo
    enddo
    do i=1,n-1
      m1=y(i)
      do j=i+1,n
        m2 = y(j)
        val = abs(m1-m2)
        if (val.ne.0d0) d2 = min(d2,val)
      enddo
    enddo
  else
    do i=1,n-1
      l1=x(i)
      if (abs(l1-cb).gt.eb) then
        do j=i+1,n
          l2 = x(j)
          if (abs(l2-cb).gt.eb) then
            val = abs(l1-l2)
            if (val.ne.0d0)  d1 = min(d1,val)
          endif
        enddo
      endif
    enddo
    do i=1,n-1
      m1=y(i)
      if (abs(m1-cb).gt.eb) then
        do j=i+1,n
          m2 = y(j)
          if (abs(m2-cb).gt.eb) then
            val = abs(m1-m2)
            if (val.ne.0d0)  d2 = min(d2,val)
          endif
        enddo
      endif
    enddo
  endif
  xinc=d1
  yinc=d2
  return
end subroutine find_mapchar8
!
subroutine find_siz8(x,y,n,xmin,xmax,ymin,ymax,eb,cb)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer :: n                      !
  real(8) :: x(n)                    !
  real(8) :: y(n)                    !
  real(8) :: xmin                    !
  real(8) :: xmax                    !
  real(8) :: ymin                    !
  real(8) :: ymax                    !
  real(8) :: eb                      !
  real(8) :: cb                      !
  ! Local
  real(8) :: l1,m1,l2,m2
  integer :: i
  !
  if(eb.lt.0.0d0)then
    l1=x(1)
    m1=y(1)
    l2=l1
    m2=m1
    do i=2,n
      l1=min(l1,x(i))
      l2=max(l2,x(i))
      m1=min(m1,y(i))
      m2=max(m2,y(i))
    enddo
  else
    l1=cb
    i=0
    do while(abs(l1-cb).le.eb.and.i.lt.n)
      i=i+1
      l1=x(i)
    enddo
    m1=cb
    i=0
    do while(abs(m1-cb).le.eb.and.i.lt.n)
      i=i+1
      m1=y(i)
    enddo
    l2=l1
    m2=m1
    do i=1,n
      if (abs(x(i)-cb).gt.eb)then
        l1=min(l1,x(i))
        l2=max(l2,x(i))
      endif
      if (abs(y(i)-cb).gt.eb) then
        m1=min(m1,y(i))
        m2=max(m2,y(i))
      endif
    enddo
  endif
  xmin=l1
  ymin=m1
  xmax=l2
  ymax=m2
  return
end subroutine find_siz8
!
subroutine reallocate_rgdata(mx,my,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>reallocate_rgdata
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)allocate the RG buffer, taking care of its previous allocation
  ! status.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: mx     !
  integer(kind=4), intent(in)    :: my     !
  logical,         intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  character(len=message_length) :: mess
  integer(kind=4) :: ier
  logical :: alloc,error2
  integer(kind=index_length) :: dims(4)
  !
  if (mx.le.0 .or. my.le.0) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Can not allocate null or negative size (got ',mx,' x ',my,')'
    call greg_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  alloc = .true.
  if (rg%status.eq.code_pointer_allocated) then
    if (ubound(rg%data,1).eq.mx .and. ubound(rg%data,2).eq.my) then
      alloc = .false.
    else
      deallocate(rg%data)
      rg%status = code_pointer_null
    endif
  elseif (rg%status.eq.code_pointer_associated) then
    rg%data => null()
    rg%status = code_pointer_null
  endif
  !
  if (alloc) then
    error2 = .false.
    call sic_delvariable('RG',.false.,error2)
    call sic_delvariable('NXRG',.false.,error2)
    call sic_delvariable('NYRG',.false.,error2)
    !
    allocate(rg%data(mx,my),stat=ier)
    if (failed_allocate(rname,'RGDATA',ier,error))  return
    rg%status = code_pointer_allocated
    !
    dims(1) = mx
    dims(2) = my
    call sic_def_real('RG',rg%data,2,dims,.false.,error)
    call sic_def_inte('NXRG',rg%nx,0,dims,.true.,error)
    call sic_def_inte('NYRG',rg%ny,0,dims,.true.,error)
  endif
  rg%nx = mx
  rg%ny = my
  !
  ! Always forget the previous min/max values, data is probably being
  ! changed
  rg%minmax = .false.
  !
end subroutine reallocate_rgdata
!
subroutine reassociate_rgdata(rgbuf,mx,my,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>reassociate_rgdata
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)associate the RG buffer, taking care of its previous allocation
  ! status.
  ! ---
  !  Bug fix. Using an explicit-shape dummy argument
  !     real(kind=4), intent(in), target :: rgbuf(mx,my)
  ! and pointing to it:
  !     rg%data => rgbuf
  ! is processor-dependent according to the Fortran. See Fortran 2003
  ! Section 12.4.1.2:
  !  "If the dummy argument has the TARGET attribute and is an
  ! explicit-shape array or is an assumed-size array, and the corresponding
  ! actual argument has the TARGET attribute but is not an array section
  ! with a vector subscript then:
  !   1) [...]
  !   2) when execution of the procedure completes, the pointer association
  !      status of any pointer that is pointer associated with the dummy
  !      argument is processor dependent."
  ! In other words, when sending the data array to the subroutine, the
  ! caller may send a copy of the actual argument, so that the dummy
  ! argument is contiguous and satisfies the explicit-shape declaration.
  !
  !   Ifort 9.0 to 14.0.1 (at least): seems indeed affected by this. The
  ! association status "seems" correct in return, but according to the
  ! standard the pointer association status is undefined (i.e. not
  ! reliable). In practice, a subsequent deallocation of the pointer
  ! fails if the allocation has been stealed to the target in the
  ! context:
  !  pointer :: a,b
  !  allocate(a)
  !  b => a
  !  deallocate(b)
  ! This is done in some cases.
  !
  !  On the other hand, one can use an assumed-shape dummy argument:
  !    real(kind=4), intent(in), target :: rgbuf(:,:)
  ! In this case, the caller knows the interface and can send the actual
  ! array (maybe with strides and boundaries specific to the call), so
  ! that it is not a problem to associate a pointer.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)         :: mx          !
  integer(kind=4), intent(in)         :: my          !
  real(kind=4),    intent(in), target :: rgbuf(:,:)  !
  logical,         intent(inout)      :: error       !
  ! Local
  character(len=*), parameter :: rname='RGDATA'
  character(len=message_length) :: mess
  logical :: error2
  integer(kind=index_length) :: dims(4)
  !
  if (mx.le.0 .or. my.le.0) then
    write(mess,'(A,I0,A,I0,A)')  &
      'Can not associate to null or negative size (got ',mx,' x ',my,')'
    call greg_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  error2 = .false.
  call sic_delvariable('RG',.false.,error2)
  call sic_delvariable('NXRG',.false.,error2)
  call sic_delvariable('NYRG',.false.,error2)
  !
  if (rg%status.eq.code_pointer_allocated)  deallocate(rg%data)
  !
  rg%data => rgbuf
  rg%status = code_pointer_associated
  !
  dims(1) = mx
  dims(2) = my
  call sic_def_real('RG',rg%data,2,dims,.false.,error)
  call sic_def_inte('NXRG',rg%nx,0,dims,.true.,error)
  call sic_def_inte('NYRG',rg%ny,0,dims,.true.,error)
  !
  rg%nx = mx
  rg%ny = my
  !
  ! Always forget the previous min/max values, data is probably being
  ! changed
  rg%minmax = .false.
  !
end subroutine reassociate_rgdata
!
subroutine deallocate_rgdata(error)
  use gildas_def
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>deallocate_rgdata
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  !  Deallocate the RG buffer, taking care of its previous allocation
  ! status.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  logical :: error2
  !
  error2 = .false.
  call sic_delvariable('RG',.false.,error2)
  call sic_delvariable('NXRG',.false.,error2)
  call sic_delvariable('NYRG',.false.,error2)
  !
  if (rg%status.eq.code_pointer_allocated) then
    deallocate(rg%data)
    rg%status = code_pointer_null
  elseif (rg%status.eq.code_pointer_associated) then
    rg%data => null()
    rg%status = code_pointer_null
  endif
  !
  rg%nx = 0
  rg%ny = 0
  !
  rg%minmax = .false.
  !
end subroutine deallocate_rgdata

program sum
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! GDF	Main program for linear combination of images
  !		X(i,j) = X(i,j) + Z(i,j)
  !		Y(i,j) = Y(i,j) + 1
  ! Subroutines
  !	SUM001, SUM002
  !---------------------------------------------------------------------
  character(len=*), parameter :: pname = 'SUM'
  ! Local
  character(len=filename_length) :: namex,namey,namez
  logical :: start,error
  real :: fact
  integer :: i, j, ier
  type(gildas) :: x,y,z
  !
  call gildas_open
  call gildas_logi('START$',start,1)
  call gildas_char('Z_NAME$',namez)
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('WEIGHT$',fact,1)
  call gildas_close
  !
  call gildas_null(z)
  call gdf_read_gildas(z,namez,'.gdf',error,data=.false.)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot read input file'
    goto 100
  endif
  !
  call gildas_null(y)
  if (start) then
    call gdf_copy_header(z,y,error)
    call sic_parsef(namey,y%file,' ','.gdf')
    y%gil%eval = -1
    call gdf_create_image(y,error)
    if (error) then
      write(6,*) 'F-'//pname//',  Cannot create weight file'
      goto 100
    endif
  else
    call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
    if (error) then
      write(6,*) 'F-'//pname//',  Cannot read weight file'
      goto 100
    endif
  endif
  !
  call gildas_null(x)
  if (start) then
    call gdf_copy_header(y,x,error)
    call sic_parsef(namex,x%file,' ','.gdf')
    call gdf_create_image(x,error)
    if (error) then
      write(6,*) 'F-'//pname//',  Cannot create accumulation image'
      goto 100
    endif
  else
    call sic_parsef(namex,x%file,' ','.gdf')
    call gdf_read_gildas(x,namex,'.gdf',error,data=.false.)
    if (error) then
      write(6,*) 'F-'//pname//',  Cannot read accumulation image'
      goto 100
    endif
  endif
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)), &
      & y%r2d(y%gil%dim(1),y%gil%dim(2)), &
      & z%r2d(z%gil%dim(1),z%gil%dim(2)), stat=ier)
  if (ier.ne.0) then
    write(6,*) 'F-'//pname//',  Cannot read accumulation image'
    goto 100
  endif      
  !
  if (z%gil%eval.ge.0) z%gil%eval = max(abs(z%gil%bval*1e-7),z%gil%eval)
  do j=1,x%gil%dim(4)
    x%blc(4) = j 
    x%trc(4) = j
    do i=1,x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      z%blc = x%blc
      z%trc = x%trc
      call gdf_read_data(z,z%r2d,error)
      if (start) then
        call sum001(z%r2d, y%r2d, x%r2d,  &
     &          x%gil%dim(1)*x%gil%dim(2),z%gil%bval,z%gil%eval,fact)
      else
        call gdf_read_data(y,y%r2d,error)
        call sum002(z%r2d, y%r2d, x%r2d,  &
     &          x%gil%dim(1)*x%gil%dim(2),z%gil%bval,z%gil%eval,fact)
      endif
      call gdf_write_data (x,x%r2d,error)
    enddo
  enddo
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program sum
!
subroutine sum002(z,y,x,n,bval,eval,fact)
  use gildas_def
  !---------------------------------------------------------------------
  !     GDF	Internal routine
  !     Linear combination of input arrays
  !     X = X + FACT*Z
  !     Y = Y + FACT
  !---------------------------------------------------------------------
  integer(index_length), intent(in) :: n          ! Array size
  real(4), intent(in) :: z(n)       ! Array to be added
  real(4), intent(inout) :: y(n)    ! Weight array
  real(4), intent(inout) :: x(n)    ! Accumulation array
  real(4), intent(in) :: bval       ! Blanking value
  real(4), intent(in) :: eval       ! Blanking tolerance
  real(4), intent(in) :: fact       ! Scale factor
  ! Local
  integer :: i
  !
  if (eval.lt.0.0) then
    do i=1,n
      x(i) = x(i) + fact*z(i)
      y(i) = y(i) + fact
    enddo
  else
    do i=1,n
      if (abs(z(i)-bval).gt.eval) then
        x(i) = x(i) + fact*z(i)
        y(i) = y(i) + fact
      endif
    enddo
  endif
end subroutine sum002
!
subroutine sum001(z,y,x,n,bval,eval,fact)
  use gildas_def
  !---------------------------------------------------------------------
  !     GDF	Internal routine
  !     Linear combination of input arrays: initialization
  !     X = Z
  !     Y = 1
  !---------------------------------------------------------------------
  integer(index_length), intent(in) :: n          ! Array size
  real(4), intent(in) :: z(n)       ! Array to be added
  real(4), intent(out) :: y(n)      ! Weight array
  real(4), intent(out) :: x(n)      ! Accumulation array
  real(4), intent(in) :: bval       ! Blanking value
  real(4), intent(in) :: eval       ! Blanking tolerance
  real(4), intent(in) :: fact       ! Scale factor
  ! Local
  integer :: i
  !
  if (eval.lt.0.0) then
    do i=1,n
      x(i) = fact*z(i)
      y(i) = fact
    enddo
  else
    do i=1,n
      if (abs(z(i)-bval).gt.eval) then
        x(i) = fact*z(i)
        y(i) = fact
      else
        y(i) = 0.0
        x(i) = 0.0
      endif
    enddo
  endif
end subroutine sum001

subroutine uv_time_comm(line,error)
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_time_comm
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !
  ! UV_TIME Time /Weight Wcol [/FILE FileIn FileOut]
  !
  ! Time-Average UV Tables, either on the "current" UV data set
  ! or on files  (useful for ALMA data, which may be big)
  !
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Error flag
  !
  character(len=*), parameter :: rname='UV_TIME'
  integer, parameter :: opt_file=1
  integer, parameter :: opt_wcol=2
  !
  ! Local ---
  character(len=filename_length) :: nami,namo
  character(len=32) :: mytime ! Integration time
  real :: myuv   ! Maximum UV distance
  integer :: wcol
  integer :: n
  logical :: required
  !
  ! Code ----
  if (sic_present(opt_file,0)) then
    !call map_message(seve%w,rname,'/FILE option not yet fully coded')
    call sic_ch(line,0,1,mytime,n,.true.,error)
    if (error) return
    myuv = 1E10 ! m, bigger than Earth...
    call sic_r4(line,0,2,myuv,.false.,error)
    wcol = 0
    call sic_i4(line,opt_wcol,1,wcol,.false.,error)
    if (error) return
    call sic_ch(line,opt_file,1,nami,n,.true.,error)
    if (error) return
    required = mytime.ne.'?'
    call sic_ch(line,opt_file,2,namo,n,required,error)
    if (error) return
    !
    call uvtime_disk_pre (nami,namo,mytime,myuv,wcol,error)
  else
    call uv_time_mem(line,error)
  endif
end subroutine uv_time_comm
!  
subroutine uv_time_mem(line,error)
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_time_mem
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Support for command UV_TIME Time /Weight Wcol
  !
  ! Time-Average the UV Table.   
  ! Works on the "current" UV data set: Uses UVS or UVR as needed.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line    !! Command line
  logical, intent(out) :: error           !! Error flag
  !
  character(len=*), parameter :: rname='UV_TIME_AVERAGE'
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: opt_file=1
  integer, parameter :: opt_wcol=2
  !
  ! Local ---
  real(4), save :: mytime
  integer(4) :: wcol
  character(len=80) :: mess
  real(8), allocatable :: times(:), ttime(:)
  real(4), allocatable ::  btime(:)
  integer, allocatable :: ip(:), ftime(:), ltime(:)
  integer :: ntime, mtime, first_time, last_time, nbtime
  real(8) :: old_time, t0
  integer :: iv, jv, kv, lv, it, ier, mvisi, maxant
  integer :: nu, nv, mv
  real :: rmax
  type (gildas) :: hcuv
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  real, allocatable :: din(:,:)
  character(len=64) :: mychain
  integer :: nc, first, fstart, fend
  integer :: ifield, np, nvout, ixoff, iyoff, idoff
  real(4), allocatable :: doff(:,:)
  integer, allocatable :: voff(:)
  logical :: shift, sorted, hasarg, fast
  real :: uvmax, uvmin
  real(8) :: new(3)
  real :: eps, retime
  !
  ! Code ----
  ! The UV table is available in HUV%
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  !
  fast = .false.
  ! Not yet Ready as of Feb-2025  !$ fast = .true.
  call sic_get_logi('UV_TIME_FAST',fast,error)
  !
  shift = .false.
  new = 0.d0
  eps = 0.01
  call sic_get_real('TIME_LOSS',eps,error)
  error = .false.
  !
  mychain = '?'
  call sic_ch(line,0,1,mychain,nc,.false.,error)
  retime = 86400  ! Some sufficiently large value (1 day here...)
  call get_nyquist_time(rname,huv,duv,retime,eps,error)
  hasarg = sic_present(0,1)
  if ((.not.hasarg).or.mychain.eq.'?') then
    !
    if (error) return
    mytime = retime
    if (hasarg) then
      write(mychain,'(A,I0,A)') 'Can smooth up to UV_TIME = ',nint(mytime),' s'
    else
      write(mychain,'(A,I0,A)') 'Smoothing to ',nint(mytime),' s'
    endif
    call map_message(seve%i,rname,mychain)
    call sic_let_real('UV_TIME',mytime,error)
    if (hasarg) return
  else
    call sic_r4(line,0,1,mytime,.true.,error)
    if (error) return
    if (mytime.le.0) then
      call map_message(seve%e,rname,'Smoothing time must be positive')
      error = .true.
      return
    else if (retime.lt.mytime) then
      write(mychain,'(A,I0,A,I0,A)') 'Smoothing time (',nint(mytime), &
        & ' s) longer than recommended value (', nint(retime),' s)'
      call map_message(seve%w,rname,mychain,3)
    endif    
  endif
  !
  wcol = 0
  call sic_i4(line,opt_wcol,1,wcol,.false.,error)
  if (error) return
  !
  nu = huv%gil%dim(1)
  nv = huv%gil%dim(2)
  !
  if (themap%nfields.eq.0) then
    !
    ! Read the Time Baseline information, and verify it is sorted
    allocate (times(nv), ip(nv), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    t0 = duv(4,1) ! First date
    maxant = 0
    do iv = 1, nv
      times(iv) = (duv(4,iv)-t0)*86400.d0+duv(5,iv)-duv(5,1)
      rmax = max(duv(6,iv),duv(7,iv))
      maxant = max(maxant,nint(rmax))
    enddo
    !
    ! So here is the maximum number of visibilities per time range
    mvisi = (maxant*(maxant-1))/2
    !
    ! Sort the time array
    call gr8_trie(times,ip,nv,error)
    !
    ! Figure out how many output times
    old_time = -1d10
    ntime = 0
    do iv = 1, nv
      if ((times(iv)-old_time).ge.mytime) then
        old_time = times(iv)
        ntime = ntime+1
      endif
    enddo
    mtime = ntime
    !
    allocate (ttime(mtime), ftime(mtime), ltime(mtime), btime(mtime), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! Find out the time boundaries
    jv = 0
    ntime = 0
    old_time = -1d10
    do iv = 1, nv
      if ((times(iv)-old_time).ge.mytime) then
        if (ntime.gt.0) ltime(ntime) = iv-1
        old_time = times(iv)
        ntime = ntime+1
        ftime(ntime) = iv
        ttime(ntime) = times(iv)
      endif
    enddo
    ltime(ntime) = nv   ! The last is a time change
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    mvisi = ntime*mvisi     
    hcuv%gil%dim(2) = mvisi
    hcuv%gil%nvisi = mvisi     ! For the time being...
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,mvisi,duv_previous,duv_next,error)
    if (error) return
    !
    ! Setup the Weight column
    if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
    !
    ! Now do the job
    old_time = ttime(1)
    jv = 1  ! Initialize here
    nbtime = 0
    do it=1,ntime
      !
      first_time = ftime(it)
      last_time = ltime(it)
      ! Some useless debugging...
      !write(mess,*) 'Time ',old_time,' range ',first_time,last_time, ' / ',nv
      !call map_message(seve%i,rname,mess)
      mv = last_time-first_time+1
      allocate (din(nu,mv),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      kv = 0
      do lv = first_time,last_time
        kv = kv+1
        din(:,kv) = duv(:,ip(lv))
      enddo
      if (mv.ne.kv) Print *,'Missing antennas on time ',it,kv,mv
      kv = jv
      call time_compress(din,nu,1,mv, &
          wcol, hcuv, duv_next, jv, mvisi, fast, error)
      if (error) then
        write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
        call map_message(seve%e,rname,mess)
        return
      endif
      if (jv.lt.kv) then
        nbtime = nbtime+1
        btime(nbtime) = old_time
!        write(mess,*) 'No valid averaged visibility for ',old_time
!        call map_message(seve%w,rname,mess)
      endif
      jv = jv+1     ! Point to next one, then...
      old_time = ttime(it)
      deallocate (din)
    enddo
    !
    ! Finalize the UV Table with the right numbers
    hcuv%gil%nvisi = jv-1
    if (nbtime.ne.0) then
      if (nbtime.eq.1) then
        mess = 'No valid averaged visibility for the following time'
      else
        write(mess,'(A,I0,A)') 'No valid averaged visibility for the ',nbtime,' following times'
      endif
      call map_message(seve%w,rname,mess)
      write(*,*) btime(1:nbtime)
    endif
  else
    if (allocated(doff)) deallocate(doff)
    if (allocated(voff)) deallocate(voff)
    np = abs(themap%nfields)
    allocate(doff(2,np),voff(np+1),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! Make sure the UV table has been sorted by fields first
    call map_message(seve%w,rname,'Sorting mosaic UV table')
    ixoff = huv%gil%column_pointer(code_uvt_xoff)
    iyoff = huv%gil%column_pointer(code_uvt_yoff)
    if (ixoff.eq.0) then
      ixoff = huvi%gil%column_pointer(code_uvt_loff)
      iyoff = huvi%gil%column_pointer(code_uvt_moff)
    endif
    idoff = huv%gil%column_pointer(code_uvt_id)
    call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
      & ixoff,iyoff,idoff,np,doff,voff)
    if (error) return
    !
    ! Prepare header and allocate buffers
    call gildas_null(hcuv,type='UVT')
    call gdf_copy_header(huv,hcuv,error)
    nullify (duv_previous, duv_next)
    call uv_find_buffers (rname,nu,nv,duv_previous,duv_next,error)
    if (error) return
    !
    if (wcol.eq.0) wcol = max(3,huv%gil%nchan)/3
    !
    ! Loop over fields to sort each data
    first = 1
    ! This loop cannot be parallelized ...
    do ifield = 1,np
      !
      fstart = voff(ifield)       ! Starting Visibility of field
      fend   = voff(ifield+1)-1   ! Ending Visibility of field
      !
      call time_integrate(rname,huv,mytime,wcol,nu,fend-fstart+1, &
        & duv(:,fstart:fend),duv_next(:,first:),nvout,fast,error)
        if (error) return
      Print *,'Field ',ifield,nvout, ' Visibilities from range ',fstart,fend
      first = first+nvout
    enddo
    !
    hcuv%gil%dim(2)= first-1 ! Is this allowed ?...
    hcuv%gil%nvisi = first-1
  endif
  !
  if (hcuv%gil%nvisi.eq.0) then
    call map_message(seve%e,rname,'No valid visibility after time compression')
    error = .true.
    hcuv%gil%dim(2)= 1 ! To avoid crashes
    return
  endif
  !
  hcuv%gil%dim(2)= hcuv%gil%nvisi    
  write(mess,'(i12,a,i12,a)') hcuv%gil%nvisi,' Visibilities created (', &
    & huv%gil%nvisi,' before)'
  call map_message(seve%i,rname,mess)
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  ! Copy back to UV data set
  call gdf_copy_header(hcuv,huv,error)
  !
  ! Indicate UV data has changed, and weight must be computed
  call uv_new_data(weight=.true.)
end subroutine uv_time_mem
!
subroutine time_compress(invisi,nd,first,last,wcol, out, ovisi, jv, &
  & mvisi, fast, error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this => time_compress
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --- Support for UV_TIME
  !
  !   Time compress a UV table.
  !   Compute visibilities for a single output time
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out               !! Output UV header
  integer, intent(in) :: nd                     !! Visibility size
  real, intent(in) :: invisi(:,:)               !! Input visibilities
  integer, intent(in) :: wcol                   !! Weight column
  real, intent(inout) :: ovisi(:,:)             !! Output visibilities
  integer, intent(in) :: first, last            !! First and last input visibilities
  integer, intent(inout) :: jv                  !! Current output visibility number
  integer, intent(in) :: mvisi                  !! Maximum number of visibilities
  logical, intent(in) :: fast                   !! Fast parallel mode
  logical, intent(out) :: error                 !! Error flag
  !
  if (fast) then  
    call time_compress_fast(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, error)
  else
    call time_compress_slow(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, error)
  endif
end subroutine time_compress
!
subroutine time_compress_fast(invisi,nd,first,last,wcol, out, ovisi, jv, &
  & mvisi, error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this => time_compress_fast
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --- Support for UV_TIME
  !
  !   Time compress a UV table.
  !   Compute visibilities for a single output time
  !
  ! Parallelized version (does not gain much, though)
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out               !! Output UV header
  integer, intent(in) :: nd                     !! Visibility size
  real, intent(in) :: invisi(:,:)               !! Input visibilities
  integer, intent(in) :: wcol                   !! Weight column
  real, intent(inout) :: ovisi(:,:)             !! Output visibilities
  integer, intent(in) :: first, last            !! First and last input visibilities
  integer, intent(inout) :: jv                  !! Current output visibility number
  integer, intent(in) :: mvisi                  !! Maximum number of visibilities
  logical, intent(out) :: error                 !! Error flag
  !
  character(len=*), parameter :: rname='TIME_COMPRESS'
  !
  ! Local ---
  real, allocatable, target :: avisi(:,:), bvisi(:,:)
  real, pointer :: my_visi(:,:)
  integer, allocatable :: tb(:), indx(:)
  integer :: vmax, iant, jant
  integer :: iv, kv, nvisi, ier, icol, ic, ig
  logical :: sorted
  real :: sw
  integer, allocatable :: ranges(:,:)
  integer :: krange, irange
  !
  ! Code ----
  error = .false.
  !
  ! Extract the relevant - A copy is needed in all cases...
  nvisi = last-first+1
  allocate (avisi(nd,nvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  avisi(1:nd,1:nvisi) = invisi(:,first:last)
  !
  ! Sort it by BASELINE.
  ! We do not care about time here, since we are time averaging
  !
  ! Check the order
  allocate (tb(nvisi),stat=ier)
  do iv=1,nvisi
    ! Use the baseline number code as major driver
    if (avisi(7,iv).lt.avisi(6,iv)) then
      tb(iv) = (256*avisi(6,iv)+avisi(7,iv))
    else if (avisi(7,iv).gt.avisi(6,iv)) then
      tb(iv) = (256*avisi(7,iv)+avisi(6,iv))
    else
      ! No Baseline code for Short spacings which have Iant = Jant
      tb(iv) = 0
    endif
  enddo
  sorted = .true.
  vmax = tb(1)
  do iv = 1,nvisi
    if (tb(iv).lt.vmax) then
      sorted = .false.
      exit
    endif
    vmax = tb(iv)
  enddo
  !
  ! Sort it if needed
  if (.not.sorted) then
    allocate(indx(nvisi),bvisi(nd,nvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do iv = 1,nvisi
      indx(iv) = iv
    enddo
    call gi4_trie(tb,indx,nvisi,error)
    if (error) then
      call map_message(seve%e,rname,'Sorting error')
      return
    endif
    do iv=1,nvisi
      kv = indx(iv)
      bvisi(:,iv) = avisi(:,kv)
    enddo
    my_visi => bvisi
  else
    my_visi => avisi
  endif
  !
  !Print *,'Nstokes ',out%gil%nstokes
  !Print *,'Fcol    ',out%gil%fcol
  !Print *,'Lcol    ',out%gil%lcol
  !Print *,'Nchan   ',out%gil%nchan
  ! 
  ! Now do the real work for each baseline
  icol = out%gil%nlead+out%gil%natom*wcol
  !
  !Print *,'Entering at JV ',jv
  kv = jv ! Output visibility pointer
  ovisi(:,jv) = 0      ! Current visibility
  sw = 0.0             ! Current running weight
  iant = my_visi(6,1)  ! First antenna
  jant = my_visi(7,1)  ! Last antenna
  !
  allocate(ranges(5,nvisi),stat=ier)
  ranges = 0
  !
  ! First pass, find ranges
  ig = 0
  krange = 1
  ranges(1,krange) = 1
  ranges(3,krange) = kv
  do iv=1,nvisi
    if (iant.eq.my_visi(6,iv) .and. jant.eq.my_visi(7,iv)) then
      ! Same antennas... Continue adding 
      ! ... unless it is a Short spacing stuff...
      if (iant.eq.-1 .and. ig.ne.0) kv = kv+1
      ig = ig+1
    else if (iant.eq.my_visi(7,iv) .and. jant.eq.my_visi(6,iv)) then
      ! Same antennas, but reversed order...
      ig = ig+1
    else
      ! Different antennas
      ranges(5,krange) = ig
      ranges(4,krange) = kv
      ranges(2,krange) = iv-1
      kv = kv+1
      krange = krange+1
      ranges(3,krange) = kv
      ranges(1,krange) = iv
      ! Move to new antenna pair
      iant = my_visi(6,iv)
      jant = my_visi(7,iv)
      ig = 0
    endif
  enddo
  if (ranges(2,krange).eq.0) then
    ranges(2,krange) = nvisi
    ranges(4,krange) = kv
  else if (ranges(4,krange).eq.0) then
    Print *,'Missing end range AT END'
    ranges(4,krange) = kv-1
  endif
  !Print *,'End krange ',krange,' Nvisi ',nvisi,' RANGES ',ranges(1:5,krange)
  !
  ! Second pass, compute average per baseline
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP & PRIVATE(irange,sw,iant,jant,iv,kv,ic, error) &
  !$OMP & SHARED(krange,ranges,mvisi,out,ovisi,my_visi) &
  !$OMP & SHARED(first,jv)
  !
  !$OMP DO
  do irange=1,krange
    !! Print *,'Range ',irange,krange,ranges(1:4,irange)
    kv = ranges(3,irange)
    iant = my_visi(6,ranges(1,irange))  ! First antenna
    jant = my_visi(7,ranges(1,irange))  ! Last antenna
    sw = 0.
    !
    do iv=ranges(1,irange),ranges(2,irange)
      if (iant.eq.my_visi(6,iv) .and. jant.eq.my_visi(7,iv)) then
        ! Same antennas... Continue adding 
        ! ... unless it is a Short spacing stuff...
        if (iant.eq.-1 .and. sw.ne.0.0) then
          call mean_visiw(out,ovisi(:,kv),sw)
          kv = kv+1
          if (kv.gt.mvisi) then  ! Test for overflow (normally none...)
            Print *,'MVISI ',mvisi,' First ',first, ' Overflow ...'
            Print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
        & ' to ',my_visi(6,iv),my_visi(7,iv)
            error = .true.
            exit
          endif
        endif
      else if (iant.eq.my_visi(7,iv) .and. jant.eq.my_visi(6,iv)) then
        ! Same antennas, but reversed order...
        !
        ! We take care of reversed visibilities, which could happen
        ! when V is close to zero, and the UV table has been already
        ! sorted. This can be done by changing the Imaginary part of
        ! my_visi as well as u,v (and w in principle...)
        ! Print *,iv,' Reversed ',my_visi(1:7,iv)
        my_visi(1,iv) = -my_visi(1,iv)
        my_visi(2,iv) = -my_visi(2,iv)
        my_visi(6,iv) = iant
        my_visi(7,iv) = jant
        do ic=out%gil%fcol+1,out%gil%lcol,3
          my_visi(ic,iv) = -my_visi(ic,iv)
        enddo
      else
        ! Different antennas
        ! At this stage this should no longer happen
        Print *,'Error at end of range ',kv,ranges(4,irange)
        Read(5,*) jv
      endif
      !
      ! Once done, Add to Current visibility - 
      call add_visiw(out,ovisi(:,kv),my_visi(:,iv),sw)
    enddo
    !
    ! Normalize result
    !    Print *,'KV ',kv,sw
    if (sw.ne.0.0) call mean_visiw(out,ovisi(:,kv),sw)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  jv = ranges(4,krange)
  !
end subroutine time_compress_fast
!
!
subroutine time_compress_slow(invisi,nd,first,last,wcol, out, ovisi, jv, &
  & mvisi, error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this => time_compress_slow
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for UV_TIME
  !
  !   Time compress a UV table. 
  !   Compute visibilities for a single output time
  !
  ! Simple, "slow" version
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out               !! Output UV header
  integer, intent(in) :: nd                     !! Visibility size
  real, intent(in) :: invisi(:,:)               !! Input visibilities
  integer, intent(in) :: wcol                   !! Weight column
  real, intent(inout) :: ovisi(:,:)             !! Output visibilities
  integer, intent(in) :: first, last            !! First and last input visibilities
  integer, intent(inout) :: jv                  !! Current output visibility number
  integer, intent(in) :: mvisi                  !! Maximum number of visibilities
  logical, intent(out) :: error                 !! Error flag
  !
  character(len=*), parameter :: rname='TIME_COMPRESS'
  real, allocatable, target :: avisi(:,:), bvisi(:,:)
  real, pointer :: my_visi(:,:)
  integer, allocatable :: tb(:), indx(:)
  integer :: vmax, iant, jant
  integer :: iv, kv, nvisi, ier, icol, ic
  logical :: sorted
  real :: sw
  !
  error = .false.
  !
  ! Extract the relevant - A copy is needed in all cases...
  nvisi = last-first+1
  allocate (avisi(nd,nvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  avisi(1:nd,1:nvisi) = invisi(:,first:last)
  !
  ! Sort it by BASELINE.
  ! We do not care about time here, since we are time averaging
  !
  ! Check the order
  allocate (tb(nvisi),stat=ier)
  do iv=1,nvisi
    ! Use the baseline number code as major driver
    if (avisi(7,iv).lt.avisi(6,iv)) then
      tb(iv) = (256*avisi(6,iv)+avisi(7,iv))
    else if (avisi(7,iv).gt.avisi(6,iv)) then
      tb(iv) = (256*avisi(7,iv)+avisi(6,iv))
    else
      ! No Baseline code for Short spacings which have Iant = Jant
      tb(iv) = 0
    endif
  enddo
  sorted = .true.
  vmax = tb(1)
  do iv = 1,nvisi
    if (tb(iv).lt.vmax) then
      sorted = .false.
      exit
    endif
    vmax = tb(iv)
  enddo
  !
  ! Sort it if needed
  if (.not.sorted) then
    allocate(indx(nvisi),bvisi(nd,nvisi),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    do iv = 1,nvisi
      indx(iv) = iv
    enddo
    call gi4_trie(tb,indx,nvisi,error)
    if (error) then
      call map_message(seve%e,rname,'Sorting error')
      return
    endif
    do iv=1,nvisi
      kv = indx(iv)
      bvisi(:,iv) = avisi(:,kv)
    enddo
    my_visi => bvisi
  else
    my_visi => avisi
  endif
  !
  !Print *,'Nstokes ',out%gil%nstokes
  !Print *,'Fcol    ',out%gil%fcol
  !Print *,'Lcol    ',out%gil%lcol
  !Print *,'Nchan   ',out%gil%nchan
  ! 
  ! Now do the real work for each baseline
  icol = out%gil%nlead+out%gil%natom*wcol
  !
  kv = jv ! Output visibility pointer
  ovisi(:,jv) = 0      ! Current visibility
  sw = 0.0             ! Current running weight
  iant = my_visi(6,1)  ! First antenna
  jant = my_visi(7,1)  ! Last antenna
  
  do iv=1,nvisi
    if (iant.eq.my_visi(6,iv) .and. jant.eq.my_visi(7,iv)) then
      ! Same antennas... Continue adding 
      ! ... unless it is a Short spacing stuff...
      if (iant.eq.-1 .and. sw.ne.0.0) then
        call mean_visiw(out,ovisi(:,kv),sw)
        kv = kv+1
        if (kv.gt.mvisi) then  ! Test for overflow (normally none...)
          Print *,'MVISI ',mvisi,' First ',first, ' Overflow ...'
          Print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
      & ' to ',my_visi(6,iv),my_visi(7,iv)
          error = .true.
          return
        endif
      endif
    else if (iant.eq.my_visi(7,iv) .and. jant.eq.my_visi(6,iv)) then
      ! Same antennas, but reversed order...
      !
      ! We take care of reversed visibilities, which could happen
      ! when V is close to zero, and the UV table has been already
      ! sorted. This can be done by changing the Imaginary part of
      ! my_visi as well as u,v (and w in principle...)
      ! Print *,iv,' Reversed ',my_visi(1:7,iv)
      my_visi(1,iv) = -my_visi(1,iv)
      my_visi(2,iv) = -my_visi(2,iv)
      my_visi(6,iv) = iant
      my_visi(7,iv) = jant
      do ic=out%gil%fcol+1,out%gil%lcol,3
        my_visi(ic,iv) = -my_visi(ic,iv)
      enddo
    else
      ! Different antennas
      !   Stop accumulating the current visibility  
!     Print *,'KV ',kv, ' -- Visi ',iv,' changing from ',iant,jant, &
!     & ' to ',my_visi(6,iv),my_visi(7,iv)
      if (sw.ne.0.0) then
        ! Normalize it and write it if it is not empty
        call mean_visiw(out,ovisi(:,kv),sw)
        kv = kv+1
        if (kv.gt.mvisi) then
          Print *,'MVISI ',mvisi,' First ',first
          Print *,'KV ',kv, ' -- Visi ',iv+first-1,' changing from ',iant,jant, &
      & ' to ',my_visi(6,iv),my_visi(7,iv)
          error = .true.
          return
        endif
        ovisi(:,kv) = 0.0
      endif
      ! Move to new antenna pair
      iant = my_visi(6,iv)
      jant = my_visi(7,iv)
      sw = 0.0
    endif
    !
    ! Once done, Add to Current visibility - 
    call add_visiw(out,ovisi(:,kv),my_visi(:,iv),sw)
  enddo
  !
  if (sw.ne.0.0) then
    jv = kv
    call mean_visiw(out,ovisi(:,kv),sw)
  else
    jv = kv-1
  endif
  !
end subroutine time_compress_slow
!
subroutine add_visiw(out,ovisi,avisi,sw)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- Support for command UV_TIME
  !
  !   Add a visibility to current output one.
  !   Per-channel weights are used, and the mean u,v coordinates
  !   are weighted according to the sum of weights on channels
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out   !! Input image header
  real, intent(inout) :: ovisi(:)   !! Output visibilities
  real, intent(inout) :: avisi(:)   !! Input visibilities
  real, intent(inout) :: sw         !! Output weight
  !
  real :: uv2max=12.0**2 ! Oops, not adequate fo NOEMA
  !
  ! Local ---
  integer i
  real :: bw, cw
  real :: uv2
  !
  !  if (aw.le.0) return
  !
  ! This is a patch for old files which have been incorrectly
  ! sorted, without the antennas being swapped...
  if (sw.gt.0) then
    uv2 = (ovisi(1)/sw-avisi(1))**2 + (ovisi(2)/sw-avisi(2))**2
    if (uv2.gt.uv2max) then
      if (ovisi(1)*avisi(1).lt.0) then
        Print *,'Continuity problem',sqrt(uv2), &
        & '(Bad Antenna order ?), Patching data'
        Print *,'Last Mean UV is ',ovisi(1:2)/sw,' while UV to be added ',avisi(1:2)
        Print *,'Last    ',ovisi(5:out%gil%nlead), ovisi(out%gil%nlead+1:out%gil%nlead+2)/sw
        Print *,'Current ',avisi(5:out%gil%nlead+2)
        avisi(1) = -avisi(1)
        avisi(2) = -avisi(2)
        do i = out%gil%nlead+2,out%gil%nstokes*out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
          avisi(i) = -avisi(i)
        enddo
      endif
    endif
  endif
  !
  cw = 0
  do i = out%gil%nlead+1,out%gil%nstokes*out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
    bw = avisi(i+2)     ! was   aw before
    if (bw.gt.0) then
      ovisi(i) = ovisi(i) + bw*avisi(i)
      ovisi(i+1) = ovisi(i+1) + bw*avisi(i+1)
      ovisi(i+2) = ovisi(i+2) + avisi(i+2)   ! Sum the weights
      cw = cw+bw
    endif
  enddo
  ovisi(1:3) = ovisi(1:3)+cw*avisi(1:3)
  ovisi(4:out%gil%nlead) = avisi(4:out%gil%nlead)
  do i=out%gil%lcol+1,out%gil%dim(1)
    ovisi(i) = avisi(i)
  enddo
  sw = sw+cw
end subroutine add_visiw
!
subroutine mean_visiw(out,ovisi,sw)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --  Support for command UV_TIME
  !
  !   Normalize the final visibility
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: out   !! Input image header
  real, intent(inout) :: ovisi(:)   !! Output visibilities
  real, intent(inout) :: sw         !! Output weight
  !
  ! Local ---
  integer :: i
  real :: bw
  !
  ! Code ----
  if (sw.le.0) return
  !
  ovisi(1:3) = ovisi(1:3)/sw
  do i = out%gil%nlead+1,out%gil%nstokes*out%gil%natom*out%gil%nchan+out%gil%nlead,out%gil%natom
    bw = ovisi(i+2)       ! Was sw before
    if (bw.gt.0) then
      ovisi(i) = ovisi(i)/bw
      ovisi(i+1) = ovisi(i+1)/bw
    endif
  enddo
end subroutine mean_visiw

subroutine time_integrate(rname,huv,mytime,wcol,nu,nv,vin,vout,nvout,fast,error)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message, time_compress
  !---------------------------------------------------------------------
  ! @ public
  !! IMAGER -- Time-Average a UV data set
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  !! Calling routine
  type(gildas), intent(in) :: huv        !! UV Header
  real(4), intent(in) :: mytime          !! Integration time
  integer, intent(in) :: wcol            !! Weight column
  integer, intent(in) :: nu              !! Size of a visibility
  integer, intent(in) :: nv              !! Number of input visibilities
  real, intent(in) :: vin(:,:)           !! input visibilities
  real, intent(inout) :: vout(:,:)       !! output visibilities
  integer, intent(out) :: nvout          !! Number of output visibilities
  logical, intent(in) :: fast            !! Parallel flag
  logical, intent(out) :: error          !! Error flag
  !
  ! Local ---
  character(len=80) :: mess
  real(8), allocatable :: times(:), ttime(:)
  integer, allocatable :: ip(:), ftime(:), ltime(:)
  real, allocatable :: din(:,:)
  integer :: ier, ntime, mtime
  real(8) :: t0, old_time
  integer :: first_time, last_time
  integer :: it,iv,jv,kv,lv,mv
  integer :: mvisi
  !
  ! Code ----
  allocate (times(nv), ip(nv), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  mvisi = ubound(vout,2)
  !
  ! Read the Time Baseline information, and verify it is sorted
  t0 = vin(4,1) ! First date
  do iv = 1, nv
    times(iv) = (vin(4,iv)-t0)*86400.d0+vin(5,iv)-vin(5,1)
  enddo
  !
  ! Sort the time array
  call gr8_trie(times,ip,nv,error)
  !
  ! Figure out how many output times
  old_time = -1d10
  ntime = 0
  do iv = 1, nv
    if ((times(iv)-old_time).ge.mytime) then
      old_time = times(iv)
      ntime = ntime+1
    endif
  enddo
  mtime = ntime
  !
  allocate (ttime(mtime), ftime(mtime), ltime(mtime), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Find out the time boundaries
  jv = 0
  ntime = 0
  old_time = -1d10
  do iv = 1, nv
    if ((times(iv)-old_time).ge.mytime) then
      if (ntime.gt.0) ltime(ntime) = iv-1
      old_time = times(iv)
      ntime = ntime+1
      ftime(ntime) = iv
      ttime(ntime) = times(iv)
    endif
  enddo
  ltime(ntime) = nv   ! The last is a time change
  !
  ! Now do the job
  old_time = ttime(1)
  jv = 1  ! Initialize here
  do it=1,ntime
    !
    first_time = ftime(it)
    last_time = ltime(it)
    ! Some useless debugging...
    !Print *,'Time ',old_time,' range ',first_time,last_time, ' / ',nv
    mv = last_time-first_time+1
    allocate (din(nu,mv),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    kv = 0
    do lv = first_time,last_time
      kv = kv+1
      din(:,kv) = vin(:,ip(lv))
    enddo
    if (mv.ne.kv) Print *,'Missing antennas on time ',it,kv,mv
    kv = jv
    call time_compress(din,nu,1,mv, wcol, huv, vout, jv, mvisi, fast, error)
    if (error) then
      write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
      call map_message(seve%e,rname,mess)
      return
    endif
    if (jv.lt.kv) then
      write(mess,*) 'No valid averaged visibility for ',old_time
      call map_message(seve%w,rname,mess)
    endif
    jv = jv+1     ! Point to next one, then...
    old_time = ttime(it)
    deallocate (din)
  enddo
  !
  nvout = jv-1
end subroutine time_integrate
!
subroutine uvtime_disk_otf(line,error)
  use clean_arrays
  use clean_types
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command
  !
  ! UV_TIME Time /FILE FileIn FileOut [/WEIGHT Wcol]
  ! 
  ! Time-Average the UV Table found in FileIn and put it
  ! into FileOut. Very useful for ALMA data which can 
  ! have very small integration times.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='UV_TIME_AVERAGE'
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  ! Disk time compression
  !
  ! Verify UV table is already time sorted 
  ! This verification can be made "on the fly", or by reading
  ! only the date/time information first.
  ! 
  ! The difficulty is then, while working with blocks, to make
  ! sure the integration does not go over the block boundary. 
  !
  ! The simplest way is to re-read the last time sequence, i.e.
  ! when  time(last_visi)-time(last_treated+1) < integration_time,
  ! to restart at last_treated+1, where last_treated is the
  ! latest visibility which has been integrated.  
  call map_message(seve%e,rname,'UVTIME_DISK_OTF not yet coded')
  error = .true.
end subroutine uvtime_disk_otf
!
subroutine uvtime_disk_pre (nami,namo,arg,myuv,wcol,error)
  use image_def
  use gkernel_interfaces
  use imager_interfaces, except_this => uvtime_disk_pre
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER
  !
  ! UV_TIME Time /FILE FileIn FileOut [/WEIGHT Wcol]
  ! 
  ! Time-Average the UV Table found in FileIn and put it
  ! into FileOut. Very useful for ALMA data which can 
  ! have very small integration times.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: nami  !! Input file name
  character(len=*), intent(inout) :: namo  !! Output file name
  character(len=*), intent(in) :: arg      !! Desired Integration Time
  real(4), intent(in) :: myuv              !! Maximum UV length change
  integer, intent(inout) :: wcol           !! Weight channel
  logical, intent(out) :: error            !! Error flag
  !
  ! Disk time compression
  !
  ! Verify UV table is already time sorted - 
  ! This verification is made by reading
  ! only the date/time information first.
  !
  ! Then, with pre-defined time boundaries, the work can be
  ! done by using an adequate buffer, for every time range 
  !
  ! This version does not yet handle the Mosaic case, contrary
  ! to the Memory version
  !
  character(len=*), parameter :: rname='UV_TIME'
  !
  ! Local ---
  character(len=256) :: mess
  type (gildas) :: hin, hout
  real :: mytime
  real(kind=4), allocatable, target :: din(:,:), dout(:,:)
  integer, allocatable :: the_times(:), ftime(:), ltime(:)
  real(8), allocatable :: times(:), ttime(:)
  integer :: nvis, iv, ntime, first_time, last_time
  real(8) :: old_time, t0
  integer :: mv, nv, jv, it, ier, mvisi, maxant
  integer :: codes(6)
  real :: rmax
  real :: eps
  logical :: fast
  !
  ! Code ----
  fast = .false.  
  !     !$ fast = .true.    ! Not yet, there are bugs...
  call sic_get_logi('UV_TIME_FAST',fast,error)
  !
  eps = 0.01
  call sic_get_real('TIME_LOSS',eps,error)
  error = .false.
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  if ( ( (hin%gil%column_size(code_uvt_xoff).ne.0) .and. &
    & (hin%gil%column_size(code_uvt_yoff).ne.0) ).or. &
    & ( (hin%gil%column_size(code_uvt_loff).ne.0) .and. &
    & (hin%gil%column_size(code_uvt_moff).ne.0) ) ) then
    call map_message(seve%e,rname,'Mosaic UV tables not yet supported in /FILE mode')
    error = .true.
    return
  endif
  !
  ! Read the Time Baseline information, and verify it is sorted
  nvis = hin%gil%nvisi
  allocate (din(6,nvis),stat=ier)
  codes(1:6) = [code_uvt_u,code_uvt_v,code_uvt_date, code_uvt_time, code_uvt_anti, code_uvt_antj]
  call gdf_read_uvonly_codes(hin, din, codes, 6, error)
  !
  ! Check the Nyquist time if needed
  if (arg.eq.'?' .or. arg.eq.' ') then
    call get_nyquist_time(rname,hin,din,mytime,eps,error)
    if (error) return
    if (arg.eq.'?') then
      write(mess,*) 'Can smooth up to UV_TIME = ',mytime
      call map_message(seve%i,rname,mess)
      return
    else
      write(mess,*) 'Smoothing to ',mytime
      call map_message(seve%i,rname,mess)
    endif
  else
    read(arg,*,iostat=ier) mytime
    if ((ier.ne.0).or.(mytime.lt.0)) then
      call map_message(seve%e,rname,'Invalid time argument '//trim(arg))
      error = .true.
      return
    endif
  endif
  !
  allocate (times(nvis), the_times(nvis), ttime(nvis), ftime(nvis), &
     & ltime(nvis), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Get the chronological order:
  old_time = -1d10
  ntime = 0
  t0 = din(1,1)
  maxant = 0
  do iv = 1, nvis
    times(iv) = (din(3,iv)-t0)*86400.d0+din(4,iv)
    rmax = max(din(5,iv),din(6,iv))
    maxant = max(maxant,nint(rmax))
    if (times(iv).lt.old_time) then
      Print *,'IV ',iv,' T0 ',t0,' Times ',times(iv),din(3,iv),din(4,iv)
      call map_message(seve%e,rname,'UV table is not Time-Baseline sorted')
      error = .true.
      return
    elseif (times(iv).gt.old_time) then
      if (ntime.gt.0) ltime(ntime) = iv-1
      old_time = times(iv)
      ntime = ntime+1
      ftime(ntime) = iv
      ttime(ntime) = times(iv)
    endif
  enddo
  ltime(ntime) = nvis
  deallocate(din)
  ! ftime is the starting number
  ! ltime is the ending number
  !
  ! So here is the maximum number of visibilities per time range
  mvisi = (maxant*(maxant-1))/2
  write(mess,'(A,I0,A,I0)') 'Found ',maxant,' antennas, # baselines ',mvisi
  call map_message(seve%i,rname,mess)
!  do it=1,ntime
!    mvisi = max(ltime(it)-ftime(it)+1,mvisi)  ! Add one...
!  enddo
!  mvisi = mvisi+1
  allocate (dout(hin%gil%dim(1),mvisi), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Prepare output UV Table
  call gildas_null(hout, type='UVT')
  call gdf_copy_header (hin, hout, error)
  !! call gdf_setuv (hout, error)
  !
  ! Find out how many output visibilities there may be
  old_time = ttime(1)
  first_time = ftime(1)
  last_time = ltime(1)
  !
  jv = 0  ! Initialize properly
  do it=1,ntime-1
    if ((ttime(it)-old_time).gt.mytime) then
      jv = jv+mvisi  ! Count all time changes
    endif
  enddo
  jv = jv+mvisi ! Last time is a time change...
  !
  ! Allocate a suitable output UV Table
  hout%gil%dim(2) = jv
  hout%gil%nvisi = jv
  call sic_parsef (namo,hout%file,' ','.uvt')
  call gdf_create_image(hout,error)
  if (error) return
  !
  ! Now do the job
  old_time = ttime(1)
  first_time = ftime(1)
  last_time = ltime(1)
  jv = 1
  !
  if (wcol.eq.0) wcol = max(3,hin%gil%nchan)/3
  hin%blc = 0
  hin%trc = 0
  hout%trc = 0
  hout%blc = 0
  hout%blc(2) = 1
  mv = hin%gil%dim(1)
  nv = hin%gil%nvisi
  !
  do it=1,ntime
    !
    if ((ttime(it)-old_time).gt.mytime .or. it.eq.ntime) then
      !
      ! write(mess,*) it,' Time ',old_time,' range ',first_time,last_time
      ! call map_message(seve%d,rname,mess)
      call progress_report('Processed',first_time,last_time-first_time+1,nv,10)
      !
      hin%blc(2) = first_time
      hin%trc(2) = last_time
      allocate (din(mv,last_time-first_time+1),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error')
        error = .true.
        return
      endif
      call gdf_read_data(hin,din,error)
      if (error) return
      jv = 1 ! Initialize...
      call time_compress(din,mv,1,last_time-first_time+1, &
          wcol, hout, dout, jv, mvisi, fast, error)
      if (error) then
        write(mess,*) it,' Time ',old_time,' range ',first_time,last_time, ' / ',nv
        call map_message(seve%e,rname,mess)
        write(mess,*) 'Programming error or strange UV table ',jv,' > ',mvisi
        call map_message(seve%e,rname,mess)
        return
      endif
      if (jv.gt.0) then
        hout%trc(2) = hout%blc(2)+jv-1
        call gdf_write_data(hout,dout,error)
        if (error) return
        hout%blc(2) = hout%trc(2)+1
      else
        write(mess,*) 'No valid averaged visibility for ',old_time
        call map_message(seve%w,rname,mess)
      endif
      first_time = ftime(it)
      old_time = ttime(it)
      deallocate (din)
    endif
    last_time = ltime(it)
  enddo
  write(*,'(A)') '  ... Done '
  !
  ! Finalize the UV Table with the right numbers
  hout%gil%dim(2)= max(1,hout%trc(2))   ! Play safe
  hout%gil%nvisi = hout%trc(2)
  call gdf_update_header(hout, error)
  call gdf_close_image(hout, error)
  !
end subroutine uvtime_disk_pre
!
subroutine get_nyquist_time(rname,huvl,visi,mytime,eps,error)
  use image_def
  use gbl_message
  use clean_default
  use gkernel_interfaces, only : sic_get_real, gdf_uv_frequency
  use imager_interfaces, except_this => get_nyquist_time
  !---------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER -- Support for UV_TIME
  !
  !     Get Maximum Smoothing time given Field of view,
  !     longest UV baseline and Required Precision
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname !! Caller name
  type(gildas), intent(inout) :: huvl   !! UV Header
  real, intent(in) :: visi(:,:)         !! UV data
  real, intent(inout) :: mytime         !! Time estimate
  real, intent(in) :: eps               !! Required precision
  logical, intent(inout) :: error       !! Error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=256) :: mess
  !
  ! Local ---
  real :: diam, cdiam    ! Map UV cell size
  real :: cfield         ! Field of view
  real(8) :: freq, wave  ! Frequency, Wevlength
  real :: uvmin, uvmax   ! UV coverage limit
  real :: duvmax         ! Max smoothing length in UV plane
  integer :: time_100, time_10, time_nyquist, csize
  !
  ! Code ----
  call uvgmax(huvl,visi,uvmax,uvmin)
  if (huvl%gil%nteles.ne.0) then
    diam = huvl%gil%teles(1)%diam/2.0
  else
    diam = 0.
  endif
  !
  freq = gdf_uv_frequency(huvl)
  wave = 299792458d0/freq/1d6  ! Wavelength in m
  !
  cfield = 0
  error = .false.
  call sic_get_real('MAP_FIELD[1]',cfield,error)
  if (cfield.eq.0) then
    !
    ! Fall back to pixel size & map_size if non zero
    call sic_get_real('MAP_CELL[1]',cfield,error)
    call sic_get_inte('MAP_SIZE[1]',csize,error)
    cfield = csize*cfield
  endif
  if (cfield.ne.0) then
    !
    ! duvmax = sqrt(6*eps)/pi*lambda/cfield
    cfield = cfield*pi/180/3600     ! Field of view in Radians
    diam = 1.22 * wave / 2. /cfield
  endif
  !
  ! If all Zero, fall back to UV cell size
  call sic_get_real('MAP_UVCELL',cdiam,error)
  if (cdiam.eq.0) then
    cdiam = diam
  else if (cdiam.lt.0) then
    call map_message(seve%e,rname,'Negative MAP_UVCELL')
    error = .true.
    return
  else if (diam.eq.0) then
    diam = cdiam    ! Set a default DIAM to get a F.o.V.
  else if (cdiam.gt.diam) then
    call map_message(seve%w,rname,'Super-uniform weighting, MAP_UVCELL[1] > Diameter/2')
  endif
  !
  if (diam.eq.0) then
    call map_message(seve%e,rname,'Please specify MAP_FIELD  (or MAP_SIZE and MAP_CELL), or MAP_UVCELL or Telescope diameter')
    error = .true.
    return
  else if (cfield.eq.0) then
    cfield = 1.22 * wave / diam / 2 ! Default field of view
    write(mess,'(A,F8.1)') 'Default field of view ',cfield*180*3600/pi
    call map_message(seve%i,rname,mess)
  endif
  !
  ! Derive maximum UV change from Field of View: B.Cotton limit
  duvmax = sqrt(6*eps)*wave/cfield/pi
  time_100 = nint(duvmax/(2*pi*uvmax)*86400)
  !
  ! GILDAS Imiss Rule
  ! Time_10     0.1 Theta_s/Omega_earth/uvmax
  time_10 = default_map%precis*1.22*(wave/uvmax)/cfield*86400/(2*pi)
  !
  !  
  ! This is the Nyquist sampling time, for the specified field size
  time_nyquist = nint(cdiam/(4*pi*uvmax)*86400)
  write(mess,'(A,F6.2,A,I0,A,F4.2,A,I0,A,I0,A)' )  &
    & 'Time for ',100*eps,' % loss: ',time_100, &
    & ' s;  for ',default_map%precis,' precision: ',time_10, &
    & ' s;  Nyquist: ',time_nyquist,' s'
  call map_message(seve%i,rname,mess)
  !
  mytime = min(time_10,time_nyquist)
  !
end subroutine get_nyquist_time

module gtv_svg
  !---------------------------------------------------------------------
  ! Variables and parameters for SVG support
  !---------------------------------------------------------------------
  !
  integer(kind=4), parameter :: svgmap_size = 65536  ! i.e. the most we
    ! can encode in integers of KIND=BITMAP_DEPTH == 2
  integer(kind=4), parameter :: svgmap_offset = -32768  ! i.e. encode the
    ! 65536 colors from -32768 to 32767 == same as PNG because we save
    ! images as embeded PNG
  !
  integer(kind=4), parameter :: strlen=80
  integer(kind=4) :: strpos
  character(len=strlen) :: strbuf
  !
  integer(kind=4) :: olun
  logical :: firstsvg
  !
  ! Current SVG group description. Group factorizes description of
  ! stroke pen colour and fill mode. Other attributes (e.g. dash pattern)
  ! are not factorized
  logical :: newgrp
  character(len=7) :: svgpen_hexacode
  real(kind=4) :: mysvg_pattern(4),mysvg_weight
  logical :: mysvg_dashed,mysvg_fill
  !
end module gtv_svg
!
subroutine svg_open(output,error,dir)
  use gtv_interfaces, except_this=>svg_open
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display),   intent(inout)        :: output  ! Output instance
  logical,            intent(inout)        :: error   !
  type(gt_directory), intent(in), optional :: dir     ! The directory to display
  !
  if (output%svg%cropped .and. present(dir)) then
    ! Crop the area viewed by the PNG instance
    call gt_hardcopy_crop(output,dir,error)
    if (error)  return
  endif
  !
  call svg_zopen(output%file,output%iunit,  &
    output%px1,output%px2,                  &
    output%py1,output%py2,                  &
    error)
  !
end subroutine svg_open
!
subroutine svg_zopen(fich,iunit,px1,px2,py1,py2,error)
  use gildas_def
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>svg_zopen
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: fich   !
  integer(kind=4),  intent(in)    :: iunit  !
  integer(kind=4),  intent(in)    :: px1    ! First pixel in X
  integer(kind=4),  intent(in)    :: px2    ! Last  pixel in X
  integer(kind=4),  intent(in)    :: py1    ! First pixel in Y
  integer(kind=4),  intent(in)    :: py2    ! Last  pixel in Y
  logical,          intent(inout) :: error  !
  ! Local
  integer(kind=4) :: wx,wy
  integer(kind=4) :: ier
  !
  ! Sanity
  if (iunit.ne.6 .and. fich.eq.'') then
    call gtv_message(seve%e,'SVG','Missing file name')
    error = .true.
    return
  endif
  !
  olun = iunit  ! Should work...?
  if (iunit.ne.6) then
    open(unit=olun,file=fich,status='UNKNOWN',iostat=ier)
    if (ier.ne.0) then
      error = .true.
      call putios ('E-SVG,  ',ier)
      return
    endif
  endif
  !
  strpos = -1
  newgrp = .true.
  !
  wx = abs(px2-px1)+1
  if (wx.lt.32) wx = 32
  wy = abs(py2-py1)+1
  if (wy.lt.32) wy = 32
  !
  firstsvg = .true.
  write (olun,'(A,A,A,I0,A,I0,A)')                  &
    '<svg xmlns="http://www.w3.org/2000/svg"',      &
    ' xmlns:xlink="http://www.w3.org/1999/xlink"',  &
    ' width="',wx,'" height="',wy,                  &
    '">'
  ! Add this attribute if you want to avoid line antialiasing
  !    shape-rendering="crispEdges"
  ! Found no solution to avoid bitmap smoothing.
  !
end subroutine svg_zopen
!
subroutine svg_pen_rgb(r,g,b)
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  ! Set the current pen color from the R G B values (0-255)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: r,g,b
  ! Local
  character(len=7) :: newcode
  !
  write(newcode,'(A1,3(Z2.2))') '#',r,g,b
  if (newcode.ne.svgpen_hexacode) then
    call svg_group_close
    svgpen_hexacode = newcode
  endif
end subroutine svg_pen_rgb
!
subroutine svg_setfill(fill)
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !  Set the polygon filling status
  !---------------------------------------------------------------------
  logical, intent(in) :: fill
  !
  if (fill.neqv.mysvg_fill) then
    call svg_group_close
    mysvg_fill = fill
  endif
  !
end subroutine svg_setfill
!
subroutine svg_dash(out,dashed,pattern)
  use gtv_interfaces, except_this=>svg_dash
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  logical,          intent(in) :: dashed
  real(kind=4),     intent(in) :: pattern(4)
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: gsclx,gscly,opattern(4)
  !
  opattern(:) = mysvg_pattern(:)
  !
  if (dashed) then
    call get_scale_awd(out,gsclx,gscly)
    do i=1,4
      mysvg_pattern(i) = pattern(i)*gsclx
    enddo
  endif
  !
  if (mysvg_dashed.neqv.dashed) then  ! Active vs inactive
    call svg_group_close
  elseif (dashed) then  ! Old and new are active. Same pattern?
    if (any(opattern.ne.mysvg_pattern))  call svg_group_close
  endif
  !
  mysvg_dashed = dashed
  !
end subroutine svg_dash
!
subroutine svg_weigh(out,width)
  use gtv_interfaces, except_this=>svg_weigh
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  real(kind=4),     intent(in) :: width
  ! Local
  real(kind=4) :: gsclx,gscly,newwei
  !
  call get_scale_awd(out,gsclx,gscly)
  ! Line width is at least 0.7 pixel so that PEN /WEIGHT 1 gives a
  ! nice result on screen. Going below makes the default weight too
  ! light.
  newwei = max(width*gsclx,0.7)
  if (newwei.ne.mysvg_weight) then
    call svg_group_close
    mysvg_weight = newwei
  endif
  !
end subroutine svg_weigh
!
subroutine svg_group_open
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !  Open a new group containing the next graphical elements.
  !---------------------------------------------------------------------
  !
  strpos = 1
  !
  ! Stroking pen
  write(strbuf(strpos:),'(3A)') '<g stroke="',svgpen_hexacode,'"'
  strpos = len_trim(strbuf)
  !
  ! Dash pattern
  if (mysvg_dashed) then
    write(strbuf(strpos+2:),'(A,4(F0.2,A1))') 'stroke-dasharray="',  &
                                              mysvg_pattern(1),',',  &
                                              mysvg_pattern(2),',',  &
                                              mysvg_pattern(3),',',  &
                                              mysvg_pattern(4),'"'
    strpos = len_trim(strbuf)
  endif
  !
  ! Pen weight
  if (strpos.ge.strlen-20) then
    write(olun,'(A)') strbuf(1:strpos)
    strpos = -1
  endif
  ! Always set; when stroke-width is not defined, the resulting width is something
  ! in between PEN /WEIGHT 1 and 3.
  write(strbuf(strpos+2:),'(A,F0.2,A)') 'stroke-width="',mysvg_weight,'"'
  strpos = len_trim(strbuf)
  !
  ! Filling colour
  if (strpos.ge.strlen-15) then
    write(olun,'(A)') strbuf(1:strpos)
    strpos = -1
  endif
  if (mysvg_fill) then
    write(strbuf(strpos+2:),'(3A)') 'fill="',svgpen_hexacode,'"'
  else
    write(strbuf(strpos+2:),'(A)') 'fill="none"'
  endif
  strpos = len_trim(strbuf)
  !
  strpos = strpos+1
  write(strbuf(strpos:strpos),'(A)') '>'
  !
  ! Flush
  write(olun,'(A)') strbuf(1:strpos)
  strpos = 0
  !
  newgrp = .false.  ! No new group needed until something changes
  !
end subroutine svg_group_open
!
subroutine svg_group_close
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !  Close the current group
  !---------------------------------------------------------------------
  !
  if (.not.firstsvg)  call svg_stroke
  if (newgrp)  return
  !
  write(olun,'(A)') '</g>'
  strpos = 0
  !
  newgrp = .true.  ! New group needed next time a new element is drawn
  !
end subroutine svg_group_close
!
subroutine svg_moveto(out,x,y,fill)
  use gtv_interfaces, except_this=>svg_moveto
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  real(kind=4),     intent(in) :: x,y
  logical,          intent(in) :: fill  ! Start a filled polygon?
  !
  if (.not.firstsvg)  call svg_stroke
  call svg_setfill(fill)
  if (newgrp)  call svg_group_open
  !
  ! Open line
  strpos = 1
  ! write(strbuf(strpos:),'(3A)') '<polyline stroke="',svgpen_hexacode,'"'
  write(strbuf(strpos:),'(A)') '<polyline'
  strpos = len_trim(strbuf)
  !
  ! Now the list of points
  write(strbuf(strpos+2:),'(A)') 'points='
  strpos = len_trim(strbuf)
  if (strpos.ge.strlen-16) then
    ! No room for first pair of "xxx,yyy": split line
    write(olun,'(A)') strbuf(1:strpos)
    strpos = 0
  endif
  write(strbuf(strpos+1:strpos+1),'(A)') '"'
  ! Do not increment strpos: see svg_lineto
  !
  call svg_lineto(out,x,y)
  firstsvg=.false.
  !
end subroutine svg_moveto
!
subroutine svg_lineto(out,x,y)
  use gtv_interfaces, except_this=>svg_lineto
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  real(kind=4),     intent(in) :: x,y
  ! Local
  real(kind=4) :: xend,yend
  !
  if (strpos.ge.strlen-16) then
    write(olun,'(A)') strbuf(1:strpos)
    strpos = -1
  endif
  !
  call world_to_pixel(out,x,y,xend,yend)
  !
  ! ---------------------
  !  BOUNDARY conditions
  !
  ! The way the scale is defined (see details in subroutine get_scale_awd) for
  ! cropped SVG, there must be one (poly)line summit which starts exactly at the
  ! left of the device, i.e. left of first pixel, i.e. coordinate 0.0 (SVG pixels
  ! run e.g. in the range ]0:1] for pixel #1). We want (for N+1 pixels, numbered
  ! from 0 to N):
  !  Left  boundary =    0.0 -> pixel #0
  !  Right boundary =  N+1.0 -> pixel #N
  !
  if (xend.le.out%px1)    xend = out%px1 + 0.01  ! .le. because boundary is excluded, need epsilon above
  if (xend.gt.out%px2+1)  xend = out%px2 + 1.0
  if (yend.le.out%py2)    yend = out%py2 + 0.01  ! Same. Note also py2<py1 with SVG
  if (yend.gt.out%py1+1)  yend = out%py1 + 1.0
  ! ---------------------
  !
  write(strbuf(strpos+2:),'(F0.2,A,F0.2)')  xend,',',yend
  strpos = len_trim(strbuf)
  !
end subroutine svg_lineto
!
subroutine svg_close
  use gtv_interfaces, except_this=>svg_close
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  !
  ! Close current line
  if (.not.firstsvg)  call svg_stroke
  if (.not.newgrp)  call svg_group_close
  !
  write(olun,'(A)') '</svg>'
  !
  if (olun.ne.6)  close(olun)
  !
end subroutine svg_close
!
subroutine svg_stroke
  use gtv_interfaces, except_this=>svg_stroke
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  !
  if (strpos.ge.1) then
    write(olun,'(2A)') strbuf(1:strpos),'"/>'
    strpos = -1
  endif
  !
  firstsvg = .true.
  !
end subroutine svg_stroke
!
subroutine svg_fill(out,n,x,y)
  use gtv_interfaces, except_this=>svg_fill
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  integer(kind=4),  intent(in) :: n
  real(kind=4),     intent(in) :: x(n)
  real(kind=4),     intent(in) :: y(n)
  ! Local
  integer(kind=4) :: i
  !
  call svg_moveto(out,x(1),y(1),.true.)
  do i=2,n
    call svg_lineto(out,x(i),y(i))
  enddo
  !
end subroutine svg_fill
!
subroutine svg_points(out,n,xr,yr)
  use gtv_interfaces, except_this=>svg_points
  use gtv_types
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out
  integer(kind=4),  intent(in) :: n
  real(kind=4),     intent(in) :: xr(n)
  real(kind=4),     intent(in) :: yr(n)
  ! Local
  integer(kind=4) :: i
  real(kind=4) :: xp,yp
  !
  if (n.le.0) return
  !
  ! Close the group used for polylines, we will create a new one after
  call svg_group_close()
  !
  if (n.eq.1) then
    call world_to_pixel(out,xr(1),yr(1),xp,yp)
    write(olun,'(2(A,F0.2),3A)')  &
      '<circle cx="',xp,'" cy="',yp,'" r=".4" stroke="',svgpen_hexacode,'"/>'
    !
  else
    ! More than 1 point: create a group, factorizing the stroke attribute
    write(olun,'(3A)')  '<g stroke="',svgpen_hexacode,'">'
    !
    do i=1,n
      call world_to_pixel(out,xr(i),yr(i),xp,yp)
      write(olun,'(2(A,F0.2),3A)')  &
        '<circle cx="',xp,'" cy="',yp,'" r=".4"/>'
    enddo
    !
    ! End of group
    write(olun,'(A)') '</g>'
  endif
  !
end subroutine svg_points
!
subroutine svg_image_inquire(map_size,map_offset,map_color,map_static)
  use gtv_interfaces, except_this=>svg_image_inquire
  use gtv_svg
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: map_size    !
  integer(kind=4), intent(out) :: map_offset  !
  logical,         intent(out) :: map_color   !
  logical,         intent(out) :: map_static  !
  !
  map_size = svgmap_size
  map_offset = svgmap_offset
  map_color = .true.
  map_static = .false.  ! SVG filler is not able to provide one LUT per
                        ! image of the plot.
  !
end subroutine svg_image_inquire
!
subroutine gti_svgimage(svgoutput,image,error)
  use gildas_def
  use gbl_message
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gti_svgimage
  use gtv_bitmap
  use gtv_buffers
  use gtv_svg
  use gtv_tree
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  ! Specifique au protocole SVG
  !---------------------------------------------------------------------
  type(gt_display), intent(inout) :: svgoutput  ! The whole SVG output description
  type(gt_image),   intent(in)    :: image      ! Image instance
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='SVG'
  real(kind=4) :: clip(4),trans(4),desc(4),resfact
  integer(kind=4) :: window(4),ier
  type(gt_lut), pointer :: lut
  type(gt_bitmap) :: bitmap
  logical :: visible
  type(gt_display) :: pngoutput
  !
  ! Set up a dedicated PNG output instance
  pngoutput%tofile = .false.  ! i.e. do not write to a file but to a memory buffer
  pngoutput%file = ''
  pngoutput%iunit = svgoutput%iunit
  pngoutput%dev => svgoutput%dev  ! ZZZ incorrect
  pngoutput%gx1 = image%position(1)
  pngoutput%gx2 = image%position(2)
  pngoutput%gy1 = image%position(3)
  pngoutput%gy2 = image%position(4)
  ! The native image size is reused at clipping time; this allows for 1-to-1
  ! pixel hardcopy if possible.
  pngoutput%px1 = 1
  pngoutput%px2 = image%r%taille(1)
  pngoutput%py1 = 1
  pngoutput%py2 = image%r%taille(2)
  pngoutput%color            = svgoutput%color
  pngoutput%background       = 1  ! White
  pngoutput%png%transparency = .false.
  pngoutput%png%cropped      = .false.  ! Computed by hand below
  pngoutput%png%noblank      = .false.
  !
  ! Check the clipping box
  ! Resampling is needed if the image has to be cut (in particular if we clip
  ! in the middle of a pixel). Since PNG can not represent fractional pixels,
  ! we have to oversample the output image is smaller pixels, hoping that they
  ! will be small enough to align near the clipping line. On the other hand,
  ! we do not want to oversample too much because the file weight will explode.
  ! Note that the same happens on screen with a huge number of tiny pixels.
  ! Knowing this, the resampling factor is set as a function of native pixels.
  ! Typically:
  !  100 resampling pixels per native pixel if 1 native pixel,
  !   10 resampling pixels per native pixel if 10 native pixels,
  !    1 resampling pixel  per native pixel if 100 native pixels or more
  resfact = maxval( (/ 100./image%r%taille(1),  &
                       100./image%r%taille(2),  &
                       1.  /) )
  ! To be improved:
  !  1) there should be no resampling if the image is clipped at any pixel
  !     boundary (just extraction of the proper subset)
  !  2) resampling should be a function of the clipped image, not the total
  !     native image.
  !
  call clip_image(pngoutput, &
    image%r%taille(1),       &
    image%r%taille(2),       &
    image%conv,              &
    image%position,          &
    image%limits,            &
    .false.,                 &  ! Do not resample if possible
    resfact,                 &  ! No extra resampling factor if resampling
    visible,clip,window,trans)
  if (.not.visible)  return
  !
  ! Trick post-clipping: whatever the size of the SVG device, the PNG is a
  ! subset of this device (which is not aware of its host) and must match
  ! the clipped dimensions, from 1 to N in each dimension. In PNG full
  ! hardcopies, the image fills only a subset of the PNG output. In this case
  ! its not.
  pngoutput%px1 = 1
  pngoutput%px2 = window(1)
  pngoutput%py1 = 1
  pngoutput%py2 = window(2)
  window(3) = 1  ! Consistently
  window(4) = 1
  !
  call png_open(pngoutput,error)
  if (error)  return
  !
  if (.not.image%isrgb) then
    ! Image is indexed: which LUT use?
    if (associated(image%lut)) then
      lut => image%lut  ! Custom LUT
      ! ZZZ
      call gti_lut(svgoutput,lut)  ! Load this LUT, in case it is not yet
    else
      lut => gbl_colormap  ! Global LUT
    endif
  endif
  !
  ! Allocate the new resampled image
  bitmap%size(1) = window(1)
  bitmap%size(2) = window(2)
  bitmap%position(1) = window(3)
  bitmap%position(2) = window(4)
  bitmap%trans = trans
  if (image%isrgb) then
    allocate(bitmap%irvalues(window(1),window(2)),  &
             bitmap%igvalues(window(1),window(2)),  &
             bitmap%ibvalues(window(1),window(2)),stat=ier)
  else
    allocate(bitmap%irvalues(window(1),window(2)),stat=ier)
    bitmap%igvalues => null()
    bitmap%ibvalues => null()
  endif
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Memory allocation failure')
    return
  endif
  !
  call svg_image_open(svgoutput,image%position,desc)
  call gti_pngmap(image,pngoutput,bitmap,lut)
  call png_close(pngoutput,desc)
  !
  if (associated(bitmap%irvalues))  deallocate(bitmap%irvalues)
  if (associated(bitmap%igvalues))  deallocate(bitmap%igvalues)
  if (associated(bitmap%ibvalues))  deallocate(bitmap%ibvalues)
  !
end subroutine gti_svgimage
!
subroutine svg_image_open(svgout,svgpos,desc)
  use gtv_interfaces, except_this=>svg_image_open
  use gtv_svg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_display), intent(in)  :: svgout
  real(kind=4),     intent(in)  :: svgpos(4)  ! Image position in the SVG device
  real(kind=4),     intent(out) :: desc(4)    ! Image description (reference position, size)
  ! Local
  real(kind=4) :: wx,wy
  !
  if (.not.firstsvg)  call svg_stroke
  !
  ! Position (in device units). Beware that the reference position
  ! is given from the top-left corner in SVG
  call world_to_pixel(svgout,svgpos(1),svgpos(4),desc(1),desc(2))
  !
  ! Size (in device units)
  wx = svgpos(2)-svgpos(1)
  wy = svgpos(4)-svgpos(3)
  call world_to_pixel_size(svgout,wx,wy,desc(3),desc(4))
  !
end subroutine svg_image_open

program smooth
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  ! Local
  character(len=*), parameter :: pname = 'SMOOTH'
  character(len=12) :: method
  character(len=filename_length) :: namex,namey
  logical :: error
  integer :: i ,j, ier
  real :: width,fact,weight(6),arr(2)
  real, allocatable :: work(:,:)
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('BLANKING$',arr,2)
  !
  ! Initialise the table
  call gildas_char('METHOD$',method)
  if (method.eq.'HANNING') then
    weight(1) = 3.
    weight(2) = 2.
    weight(3) = 2.
    weight(4) = 1.
    weight(5) = 1.
    weight(6) = 1.
  elseif (method.eq.'GAUSS') then
    call gildas_real('WIDTH$',width,1)
    fact=-(1.665109/width)**2
    weight(1) = 1.
    weight(2) = exp(fact)
    weight(3) = exp(2.*fact)
    weight(4) = exp(4.*fact)
    weight(5) = exp(5.*fact)
    weight(6) = exp(16.*fact)
  elseif (method.eq.'BOX') then
    weight(1) = 1.
    weight(2) = 1.
    weight(3) = 1.
    weight(4) = 1.
    weight(5) = 1.
    weight(6) = 1.
  elseif (method.eq.'USER') then
    call gildas_real('WEIGHT$',weight,6)
  else
    write(6,*) 'E-'//pname//', Unknown method '//method
    goto 100
  endif
  call gildas_close
  !
  call gildas_null(y)
  call gdf_read_gildas(y,namey,'.gdf',error,data=.false.)
  if (error) then
    call gagout ('F-'//pname//',  Cannot read input file')
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  if (x%gil%blan_words.eq.0) then
    x%gil%blan_words = 2
    x%gil%bval = arr(1)
    x%gil%eval = arr(2)
  else
    if (x%gil%eval.ge.0.0) x%gil%eval = max(abs(x%gil%bval*1e-7),x%gil%eval)
  endif
  !
  ! Create output image
  call sic_parsef(namex,x%file,' ','.gdf')
  call gdf_create_image (x,error)
  if (error) then
    write(6,*) 'F-'//pname//',  Cannot create output image'
    goto 100
  endif
  !
  allocate ( work(x%gil%dim(1),x%gil%dim(2)), &
    &   x%r2d(x%gil%dim(1),x%gil%dim(2)), &
    &   y%r2d(x%gil%dim(1),x%gil%dim(2)), stat=ier)
  if (ier.ne.0) goto 100
  !
  do j=1,y%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i=1,y%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      call smoo001 (y%r2d,   &                !Input image
     &        x%gil%dim(1),x%gil%dim(2),  &   !Size
     &        x%r2d,   &                      !Output image
     &        x%gil%bval,x%gil%eval,   &      !Blanking values
     &        weight,   &                     !Smoothing weights
     &        work)                           !Work space
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  call gagout ('S-'//pname//',  Successful completion')
  call sysexi (1)
  !
100 call sysexi (fatale)
end program smooth
!
subroutine smoo001(v,mi,mj,a,bval,eval,table,w)
  use gildas_def
  !---------------------------------------------------------------------
  ! 	Smoothing routine with blanking values
  ! Arguments
  !	A	R*4(*)	Smoothed array			Output
  !	MI	I	First dimension of arrays	Input
  !	MJ	I	Second dimension of arrays	Input
  !	V	R*4(*)	Original array			Input
  !	BVAL	R*4	Blanking value			Input
  !	EVAL	R*4	Tolerance on blanking		Input
  !	TABLE	R*4(6)	Smoothing coefficients		Input
  !	W	R*4(*)	Work array			*
  !---------------------------------------------------------------------
  integer(kind=index_length) :: mi                     !
  integer(kind=index_length) :: mj                     !
  real :: v(mi,mj)                  !
  real :: a(mi,mj)                  !
  real :: bval                      !
  real :: eval                      !
  real :: table(6)                  !
  real :: w(mi,mj)                  !
  ! Local
  integer :: i,j
  real :: x,sum,s00,s10,s11,s20,s21,s22
  real :: a00,a10,a11,a20,a21,a22
  !
  ! Load smoothing coefficients
  s00 = table(1)
  s10 = table(2)
  s11 = table(3)
  s20 = table(4)
  s21 = table(5)
  s22 = table(6)
  a00 = abs(s00)
  a10 = abs(s10)
  a11 = abs(s11)
  a20 = abs(s20)
  a21 = abs(s21)
  a22 = abs(s22)
  sum = a00 + 4.0*(a10+a11+a20+2.0*a21+a22)
  !
  ! Initialise arrays
  do j=1,mj
    do i=1,mi
      a(i,j) = 0.0
      w(i,j) = 0.0
    enddo
  enddo
  !
  ! Check for blanking first
  if (eval.ge.0.0) then
    !
    ! Slow method for blanked maps
    do j=3,mj-2
      do i=3,mi-2
        x = v(i,j)
        if (abs(x-bval).gt.eval) then
          ! Central pixel
          a(i,j) = a(i,j) + s00*x
          w(i,j) = w(i,j) + a00
          ! Second pixels
          a(i-1,j-1) = a(i-1,j-1) + s11*x
          a(i-1,j  ) = a(i-1,j )  + s10*x
          a(i-1,j+1) = a(i-1,j+1) + s11*x
          a(i  ,j-1) = a(i  ,j-1) + s10*x
          a(i  ,j+1) = a(i  ,j+1) + s10*x
          a(i+1,j-1) = a(i+1,j-1) + s11*x
          a(i+1,j  ) = a(i+1,j  ) + s10*x
          a(i+1,j+1) = a(i+1,j+1) + s11*x
          ! and weights
          w(i-1,j-1) = w(i-1,j-1) + a11
          w(i-1,j  ) = w(i-1,j  ) + a10
          w(i-1,j+1) = w(i-1,j+1) + a11
          w(i  ,j-1) = w(i  ,j-1) + a10
          w(i  ,j+1) = w(i  ,j+1) + a10
          w(i+1,j-1) = w(i+1,j-1) + a11
          w(i+1,j  ) = w(i+1,j  ) + a10
          w(i+1,j+1) = w(i+1,j+1) + a11
          !
          ! Third pixels
          a(i-2,j-2) = a(i-2,j-2)  + s22*x
          a(i-2,j-1) = a(i-2,j-1)  + s21*x
          a(i-2,j  ) = a(i-2,j  )  + s20*x
          a(i-2,j+1) = a(i-2,j+1)  + s21*x
          a(i-2,j+2) = a(i-2,j+2)  + s22*x
          a(i-1,j-2) = a(i-1,j-2)  + s21*x
          a(i-1,j+2) = a(i-1,j+2)  + s21*x
          a(i  ,j-2) = a(i  ,j-2)  + s20*x
          a(i  ,j+2) = a(i  ,j+2)  + s20*x
          a(i+1,j-2) = a(i+1,j-2)  + s21*x
          a(i+1,j+2) = a(i+1,j+2)  + s21*x
          a(i+2,j-2) = a(i+2,j-2)  + s22*x
          a(i+2,j-1) = a(i+2,j-1)  + s21*x
          a(i+2,j  ) = a(i+2,j  )  + s20*x
          a(i+2,j+1) = a(i+2,j+1)  + s21*x
          a(i+2,j+2) = a(i+2,j+2)  + s22*x
          !
          ! and weights
          w(i-2,j-2) = w(i-2,j-2)  + a22
          w(i-2,j-1) = w(i-2,j-1)  + a21
          w(i-2,j  ) = w(i-2,j  )  + a20
          w(i-2,j+1) = w(i-2,j+1)  + a21
          w(i-2,j+2) = w(i-2,j+2)  + a22
          w(i-1,j-2) = w(i-1,j-2)  + a21
          w(i-1,j+2) = w(i-1,j+2)  + a21
          w(i  ,j-2) = w(i  ,j-2)  + a20
          w(i  ,j+2) = w(i  ,j+2)  + a20
          w(i+1,j-2) = w(i+1,j-2)  + a21
          w(i+1,j+2) = w(i+1,j+2)  + a21
          w(i+2,j-2) = w(i+2,j-2)  + a22
          w(i+2,j-1) = w(i+2,j-1)  + a21
          w(i+2,j  ) = w(i+2,j  )  + a20
          w(i+2,j+1) = w(i+2,j+1)  + a21
          w(i+2,j+2) = w(i+2,j+2)  + a22
        endif
      enddo
    enddo
    !
    ! Set blanked pixels
    do j=1,mj
      do i=1,mi
        if (w(i,j).eq.0.0) then
          a(i,j) = bval
        else
          a(i,j) = a(i,j)/w(i,j)
        endif
      enddo
    enddo
    !
    ! Optimise for no blanking
  else
    !
    do j=3,mj-2
      do i=3,mi-2
        a(i,j) =   &
     &          s00 * v(i,j)   &
     &          + s11 * (v(i-1,j+1)+v(i+1,j+1)+v(i+1,j-1)+v(i-1,j-1))   &
     &          + s10 * (v(i,j+1)+v(i+1,j)+v(i-1,j)+v(i,j-1))   &
     &          + s22 * (v(i-2,j+2)+v(i+2,j+2)+v(i-2,j-2)+v(i+2,j-2))   &
     &          + s21 * (v(i-1,j+2)+v(i+1,j+2)+v(i+2,j+1)+v(i+2,j-1)   &
     &          +v(i+1,j-2)+v(i-1,j-2)+v(i-2,j-1)+v(i-2,j+1))   &
     &          + s20 * (v(i,j+2)+v(i+2,j)+v(i,j-2)+v(i-2,j))
        a(i,j) = a(i,j)/sum
      enddo
    enddo
    !
  endif
end subroutine smoo001

module gfits_blanking
  !
  ! Blanking value definitions
  !
#if defined(VAX)
  real(4) :: r4bval=1.23456e+38
  real(8) :: r8bval=1.23456d+38
#endif
#if defined(IEEE)
  integer(2) :: r4bval(2)=0
  integer(2) :: r8bval(4)=0
#endif
#if defined(EEEI)
  integer(4) :: r4bval=0
  integer(4) :: r8bval(2)=0
#endif
end module gfits_blanking
!
subroutine iei4ei (inpu,oupu,ni)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 4-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=4) :: ni             ! Number of items
  integer(kind=1) :: inpu(4,ni)     ! Input array
  integer(kind=1) :: oupu(4,ni)     ! Output array
  ! Local
  integer(kind=4) :: i
  integer(kind=1) :: tmp(4), abyt(4)
  !
entry eii4ie (inpu,oupu,ni)
entry vai4ei (inpu,oupu,ni)
entry eii4va (inpu,oupu,ni)
entry eir4ie (inpu,oupu,ni)
entry ier4ei (inpu,oupu,ni)
  !
  do i=1,ni
    tmp = inpu(1:4,i)
    abyt(1) = tmp(4)
    abyt(2) = tmp(3)
    abyt(3) = tmp(2)
    abyt(4) = tmp(1)
    oupu(1:4,i) = abyt
  enddo
end subroutine iei4ei
!
subroutine vai4ie (inpu,oupu,ni)
  !---------------------------------------------------------------------
  ! @ private
  ! Simple copy: vax and swapped IEEE I4 are identical. Provided for
  ! generality
  !---------------------------------------------------------------------
  integer(kind=4) :: ni        ! Number of items
  integer(kind=4) :: inpu(ni)  ! Input array
  integer(kind=4) :: oupu(ni)  ! Output array
  ! Local
  integer(kind=4) :: i
  !
entry iei4va (inpu,oupu,ni)
  do i=1,ni
    oupu(i) = inpu(i)
  enddo
end subroutine vai4ie
!
subroutine iei2ei (inpu,oupu,ni)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 2-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=4) :: ni          ! Number of items
  integer(kind=1) :: inpu(2,ni)  ! Output array
  integer(kind=1) :: oupu(2,ni)  ! Input array
  ! Local
  integer(kind=4) :: i
  integer(kind=1) :: tmp(2),abyt(2)
  !
entry eii2ie (inpu,oupu,ni)
entry vai2ei (inpu,oupu,ni)
entry eii2va (inpu,oupu,ni)
  !
  do i=1,ni
    tmp = inpu(1:2,i)
    abyt(1) = tmp(2)
    abyt(2) = tmp(1)
    oupu(1:2,i) = abyt
  enddo
end subroutine iei2ei
!
subroutine eir8ie (in,out,ni)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 8-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=4) :: ni         ! Number of items
  integer(kind=1) :: in(8,ni)   ! Input array
  integer(kind=1) :: out(8,ni)  ! Output array
  ! Local
  integer(kind=4) :: i
  integer(kind=1) :: tmp(8), abyt(8)
  !
entry iei8ei (in,out,ni)
entry eii8ie (in,out,ni)
entry ier8ei (in,out,ni)
  !
  do i=1,ni
    tmp = in(1:8,i)
    abyt(1) = tmp(8)
    abyt(2) = tmp(7)
    abyt(3) = tmp(6)
    abyt(4) = tmp(5)
    abyt(5) = tmp(4)
    abyt(6) = tmp(3)
    abyt(7) = tmp(2)
    abyt(8) = tmp(1)
    out(1:8,i) = abyt
  enddo
end subroutine eir8ie
!
#if defined(VAX)
!
subroutine ier4va (ieee,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 32-bit items
  integer(2) :: ieee(2,ni)           ! Input array
  real(4) :: real(ni)                ! Output array
  ! Local
  integer(4) :: entier,expo
  integer(4), parameter :: ieee_expm=Z'00007F80'
  integer(2) :: int2(2)
  integer(kind=1) :: octet(4)
  integer :: i
  real(4) :: reel
  equivalence (entier,int2)
  equivalence (entier,octet)
  equivalence (entier,reel)
  ! Code
  do i=1,ni
    int2 (2) = ieee(1,i)
    int2 (1) = ieee(2,i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(i) = r4bval
    elseif (expo.eq.0) then
      real(i) = 0.0
    elseif (octet(2).ge.127) then
      real(i) = r4bval
    else
      real(i) = 4.0*reel
    endif
  enddo
end subroutine ier4va
!
subroutine eir4va (eeei,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(4) :: ni                  ! Number of 32-bit items
  integer(kind=1) :: eeei (4,ni)    ! Input array
  real(4) :: real(ni)               ! Output array
  ! Local
  integer(4) :: entier,expo
  integer(kind=1) :: octet(4)
  integer :: i
  real(4) :: reel
  equivalence (entier,octet)
  equivalence (entier,reel)
  integer(4), parameter :: ieee_expm=Z'00007F80'
  !
  do i=1,ni
    octet(2) = eeei(1,i)
    octet(1) = eeei(2,i)
    octet(4) = eeei(3,i)
    octet(3) = eeei(4,i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(i) = r4bval
    elseif (expo.eq.0) then
      real(i) = 0.0
    elseif (octet(2).ge.127) then
      real(i) = r4bval
    else
      real(i) = 4.0*reel
    endif
  enddo
end subroutine eir4va
!
subroutine var4ie (real,ieee,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  real(4) :: real(ni)               ! Input array
  integer(2) :: ieee(2,ni)          ! Output array
  ! Local
  integer :: i
  real(4) :: reel
  integer(2) :: int2(2)
  equivalence (int2,reel)
  !
  do i=1,ni
    reel = 0.25*real(i)
    ieee(1,i) = int2(2)
    ieee(2,i) = int2(1)
  enddo
end subroutine var4ie
!
subroutine var4ei (real,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  real(4) :: real(ni)               ! Input array
  integer(kind=1) :: eeei(4,ni)     ! Output array
  ! Local
  integer :: i
  real(4) :: reel
  integer(kind=1) :: octet(4)
  equivalence (octet,reel)
  !
  do i=1,ni
    reel = 0.25*real(i)
    eeei(1,i) = octet(2)
    eeei(2,i) = octet(1)
    eeei(3,i) = octet(4)
    eeei(4,i) = octet(3)
  enddo
end subroutine var4ei
!
subroutine eir8va (eeei,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 64-bit items
  integer(kind=1) :: eeei(8,ni)      ! Input array
  real(8) :: real(ni)                ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(kind=1) :: octet(8)
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (octet,tmp4)
  equivalence (tmp2,tmp4)
  integer(2) :: ou(4),mant
  equivalence (ou,reel)
  !
  do i=1,ni
    octet(8) = eeei(1,i)
    octet(7) = eeei(2,i)
    octet(6) = eeei(3,i)
    octet(5) = eeei(4,i)
    octet(4) = eeei(5,i)
    octet(3) = eeei(6,i)
    octet(2) = eeei(7,i)
    octet(1) = eeei(8,i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm)   ! Exponent
      sign = iand(tmp2(4),ieee_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)    ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(i) = 0.0d0
    elseif (expo.gt.125) then  ! Check exponent overflow
      real(i) = r8bval
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
      ou(1) = tmp2(4)          ! Reverse 16 bit words
      ou(2) = tmp2(3)
      ou(3) = tmp2(2)
      ou(4) = tmp2(1)
      real(i) = 4.d0*reel
    endif
  enddo
end subroutine eir8va
!
subroutine ier8va (ieee,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 64-bit items
  integer(4) :: ieee(2,ni)           ! Input array
  real(8) :: real(ni)                ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  integer(2) :: ou(4),mant
  equivalence (ou,reel)
  !
  do i=1,ni
    tmp4(1) = ieee(1,i)
    tmp4(2) = ieee(2,i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm)   ! Exponent
      sign = iand(tmp2(4),ieee_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)    ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(i) = 0.0d0
    elseif (expo.gt.125) then  ! Check exponent overflow
      real(i) = r8bval
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
      ou(1) = tmp2(4)          ! Reverse words
      ou(2) = tmp2(3)
      ou(3) = tmp2(2)
      ou(4) = tmp2(1)
      real(i) = 4.d0*reel
    endif
  enddo
end subroutine ier8va
!
subroutine var8ie (real,ieee,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  real(8) :: real(ni)                ! Input array
  integer(4) :: ieee(2,ni)           ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'x
  integer(2), parameter :: vaxd_mant=Z'007F'x
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  integer(2) :: in(4),mant
  equivalence (in,reel)
  !
  do i=1,ni
    ! Divide by 4.0
    if (real(i).eq.0.0d0) then
      ieee(1,i) = 0
      ieee(2,i) = 0
      cycle                    ! I
    endif
    reel = 0.25d0*real(i)
    tmp2(1) = in(4)            ! Swap 16-bit words
    tmp2(2) = in(3)
    tmp2(3) = in(2)
    tmp2(4) = in(1)
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm)   ! Exponent
      sign = iand(tmp2(4),vaxd_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)    ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    ieee(1,i) = tmp4(1)        ! Move 32-bit words
    ieee(2,i) = tmp4(2)
  enddo
end subroutine var8ie
!
subroutine var8ei (real,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  real(8) :: real(ni)                ! Input array
  integer(kind=1) :: eeei(8,ni)     ! Output array
  ! Local
  integer :: i,j
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'
  integer(2), parameter :: vaxd_mant=Z'007F'
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(kind=1) :: octet(8)
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (octet,tmp4)
  equivalence (tmp2,tmp4)
  integer(2) :: in(4),mant
  equivalence (in,reel)
  !
  do i=1,ni
    ! Divide by 4.0
    if (real(i).eq.0.0d0) then
      do j=1,8
        eeei(j,i) = 0
      enddo
      cycle                    ! I
    endif
    reel = 0.25d0*real(i)
    tmp2(1) = in(4)            ! Swap 16-bit words
    tmp2(2) = in(3)
    tmp2(3) = in(2)
    tmp2(4) = in(1)
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm)   ! Exponent
      sign = iand(tmp2(4),vaxd_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)    ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    eeei(1,i) = octet(8)       ! Swap Bytes
    eeei(2,i) = octet(7)
    eeei(3,i) = octet(6)
    eeei(4,i) = octet(5)
    eeei(5,i) = octet(4)
    eeei(6,i) = octet(3)
    eeei(7,i) = octet(2)
    eeei(8,i) = octet(1)
  enddo
end subroutine var8ei
!
#endif
!
#if defined(IEEE)
subroutine ier4va (ieee32,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines, and most likely correct...
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 32-bit items
  real(4) :: ieee32(ni)              ! Input array
  integer(2) :: real(2,ni)           ! Output array
  ! Local
  integer(4), parameter :: ieee_expm=Z'7F800000'
  integer(4) :: entier,expo
  integer(2) :: int2(2)
  integer(kind=1) :: octet(4)
  integer :: i
  real(4) :: reel
  equivalence (entier,int2)
  equivalence (entier,octet)
  equivalence (entier,reel)
  !
  do i=1,ni
    reel = ieee32(i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(1,i) = r4bval(1)
      real(2,i) = r4bval(2)
    elseif (expo.eq.0) then
      real(1,i) = 0
      real(2,i) = 0
    elseif (int2(1).eq.32256) then
      real(1,i) = r4bval(1)
      real(2,i) = r4bval(2)
    else
      reel = 4.0*reel
      real(1,i) = int2 (2)
      real(2,i) = int2 (1)
    endif
  enddo
end subroutine ier4va
!
subroutine var4ie (real,ieee32,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  integer(2) :: real(2,ni)           ! Input array
  real(4) :: ieee32(ni)              ! Output array
  ! Local
  integer :: i
  real(4) :: reel
  integer(2) :: int2(2)
  equivalence (int2,reel)
  !
  do i=1,ni
    int2(2) = real(1,i)
    int2(1) = real(2,i)
    ieee32(i) = 0.25*reel
  enddo
end subroutine var4ie
!
subroutine ier8va (ieee64,real,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 64-bit items
  real(8) :: ieee64(ni)              ! Input array
  integer(2) :: real(4,ni)           ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    reel = 4.0d0*ieee64(i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm) ! Exponent
      sign = iand(tmp2(4),ieee_sign) ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)  ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(1,i) = 0
      real(2,i) = 0
      real(3,i) = 0
      real(4,i) = 0
    elseif (expo.ge.127) then
      real(1,i) = r8bval(1)
      real(2,i) = r8bval(2)
      real(3,i) = r8bval(3)
      real(4,i) = r8bval(4)
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))    ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))    ! Set sign
      real(1,i) = tmp2(4)      ! Reverse words
      real(2,i) = tmp2(3)
      real(3,i) = tmp2(2)
      real(4,i) = tmp2(1)
    endif
  enddo
end subroutine ier8va
!
subroutine var8ie (real,ieee64,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  integer(2) :: real(4,ni)           ! Input array
  real(8) :: ieee64(ni)              ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'
  integer(2), parameter :: vaxd_mant=Z'007F'
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    tmp2(4) = real(1,i)        ! Swap 16-bit words
    tmp2(3) = real(2,i)
    tmp2(2) = real(3,i)
    tmp2(1) = real(4,i)
    if (tmp4(1).eq.0 .and. tmp4(2).eq.0) then
      ieee64(i) = 0.0d0
      cycle                    ! I
    endif
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm) ! Exponent
      sign = iand(tmp2(4),vaxd_sign) ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)  ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))    ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))    ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    ieee64(i) = 0.25d0*reel
  enddo
end subroutine var8ie
!
subroutine eir4va (eeei,real,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(4) :: ni                 ! Number of 32-bit items
  integer(4) :: eeei(ni)           ! Input array
  integer(4) :: real(ni)           ! Output array
  call eir4ie(eeei,eeei,ni)
  call ier4va(eeei,real,ni)
end subroutine eir4va
!
subroutine var4ei (real,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 32-bit items
  integer(4) :: real(ni)             ! Input array
  integer(4) :: eeei(ni)             ! Output array
  call var4ie(real,eeei,ni)
  call ier4ei(eeei,eeei,ni)
end subroutine var4ei
!
subroutine eir8va (eeei,real,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(4) :: ni                 ! Number of 64-bit items
  real(8) :: eeei(ni)           ! Input array
  real(8) :: real(ni)           ! Output array
  call eir8ie(eeei,eeei,ni)
  call ier8va(eeei,real,ni)
end subroutine eir8va
!
subroutine var8ei (real,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(4) :: ni                 ! Number of 64-bit items
  real(8) :: real(ni)           ! Input array
  real(8) :: eeei(ni)           ! Output array
  call var8ie(real,eeei,ni)
  call ier8ei(eeei,eeei,ni)
end subroutine var8ei
#endif
!
#if defined(EEEI)
subroutine eir4va (eeei,vaxr,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for EEEI machines.
  !---------------------------------------------------------------------
  integer(4) :: ni                   ! Number of 32-bit items
  integer(4) :: eeei(ni)             ! Input array
  integer(4) :: vaxr(ni)             ! Output array
  ! Local
  integer(4), parameter :: eeei_expm=Z'7F800000'
  integer(4) :: reelin,reelou,expo
  integer(2) :: int2(2)
  integer(kind=1) :: tmpin(4),tmpou(4)
  integer :: i
  real(4) :: reel
  equivalence (reelin,reel)
  equivalence (reelin,tmpin)
  equivalence (reelou,tmpou)
  equivalence (int2,expo)
  !
  do i=1,ni
    ! Convert to swapped VAX reals
    reelin = eeei(i)
    ! Check special cases.
    expo = iand(reelin,eeei_expm)
    if (expo.eq.eeei_expm) then
      vaxr(i) = r4bval
    elseif (expo.eq.0) then
      vaxr(i) = 0
    elseif (int2(1).eq.32256) then
      vaxr(i) = r4bval
    else
      ! Swap to VAX reals (1234 --> 2143).
      ! Equivalent to
      !      unless (tmpin(1)==(126,127,-2,-1,0))
      !      tmpou(2) = tmpin(1)+1     ! Exponent field
      !      tmpou(1) = tmpin(2)
      !      tmpou(3) = tmpin(4)
      !      tmpou(4) = tmpin(3)
      !
      reel = 4.0*reel
      tmpou(2) = tmpin(1)
      tmpou(1) = tmpin(2)
      tmpou(4) = tmpin(3)
      tmpou(3) = tmpin(4)
      vaxr(i) = reelou
    endif
  enddo
end subroutine eir4va
!
subroutine var8ei (vaxr,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !     Convert NI VAX reals to NI EEEI reals
  !     This version is for EEEI machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 64-bit items
  integer(kind=1) :: vaxr(8,ni)     ! Input array
  real(8) :: eeei(ni)               ! Output array
  ! Local
  integer :: i
  integer(2), parameter :: vxdsig=Z'8000'
  integer(2), parameter :: vxdexp=Z'7F80'
  integer(2), parameter :: vxdman=Z'007F'
  integer, parameter :: vxgbt3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  integer(kind=1) :: tmp1(8)
  equivalence (tmp1,tmp2)
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    tmp1 (2) = vaxr (1,i)
    tmp1 (1) = vaxr (2,i)
    tmp1 (4) = vaxr (3,i)
    tmp1 (3) = vaxr (4,i)
    tmp1 (6) = vaxr (5,i)
    tmp1 (5) = vaxr (6,i)
    tmp1 (8) = vaxr (7,i)
    tmp1 (7) = vaxr (8,i)
    if (tmp4(1).eq.0 .and. tmp4(2).eq.0) then
      eeei(i) = 0.0d0
      cycle                    ! I
    endif
    !
    if (tmp4(1).ne.0) then
      expo = iand( tmp2(1),vxdexp )
      sign = iand( tmp2(1),vxdsig )
      tmp2(1) = iand( tmp2(1),vxdman )
      tmp4(1) = ishftc(tmp4(1),29,32)
      hbit3 = iand ( tmp4(1),vxgbt3 )
      tmp4(1) = tmp4(1)-hbit3
      expo = expo/128
      expo = expo-128
      expo = expo+1024
      expo = expo*16
      tmp2(1) = ior( expo,tmp2(1) )
      tmp2(1) = ior( sign,tmp2(1) )
    else
      tmp2(1) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(2).ne.0) then
      tmp4(2) = ishftc(tmp4(2),29,32)
      lbit3 = iand ( tmp4(2),vxgbt3 )
      tmp4(2) = tmp4(2)-lbit3
    endif
    tmp4(2) = ior ( tmp4(2),hbit3 )
    eeei(i) = 0.25d0*reel
  enddo
end subroutine var8ei
!
subroutine eir8va (eeei,vaxr,ni)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !     Convert NI EEEI reals to NI VAX reals
  !     This version is for EEEI machines
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 64-bit items
  real(8) :: eeei(ni)               ! Input array
  integer :: vaxr(2,ni)             ! Output array
  ! Local
  integer :: i
  integer(2) :: tmp2(4),expo,sign
  integer(2), parameter :: eeei_sign=Z'8000'
  integer(2), parameter :: eeei_mant=Z'000F'
  integer(2), parameter :: eeei_expm=Z'7FF0'
  integer :: tmp4(2),lbit3,reelou(2)
  real(8) :: reel
  integer(kind=1) :: tmp1(8),tmpou(8)
  equivalence (tmp1,tmp2)
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  equivalence (reelou,tmpou)
  !
  ! Order is Sign, Exponent, Mantissa
  do i=1,ni
    reel = 4.0d0*eeei(i)
    if (tmp4(1).ne.0) then
      expo = iand(tmp2(1),eeei_expm)
      sign = iand(tmp2(1),eeei_sign)
      tmp2(1) = iand(tmp2(1),eeei_mant)
      expo = expo/16
      expo = expo-1024
    else
      expo = -1024
    endif
    if (tmp4(2).ne.0) then
      tmp4(2) = ishftc(tmp4(2),3,32)
      lbit3 = iand(tmp4(2),7)
      tmp4(2) = tmp4(2)-lbit3
      tmp4(1) = 8*tmp4(1)+lbit3
    elseif (tmp4(1).ne.0) then
      tmp4(1) = 8*tmp4(1)
    endif
    ! Special cases
    if (expo.lt.-128) then
      vaxr(1,i) = 0
      vaxr(2,i) = 0
    elseif (expo.ge.127) then
      vaxr(1,i) = r8bval(1)
      vaxr(2,i) = r8bval(2)
    else
      expo = expo+128
      expo = expo*128
      tmp2(1) = ior(expo,tmp2(1))
      tmp2(1) = ior(sign,tmp2(1))
      tmpou(2) = tmp1(1)
      tmpou(1) = tmp1(2)
      tmpou(4) = tmp1(3)
      tmpou(3) = tmp1(4)
      tmpou(6) = tmp1(5)
      tmpou(5) = tmp1(6)
      tmpou(8) = tmp1(7)
      tmpou(7) = tmp1(8)
      vaxr(1,i) = reelou(1)
      vaxr(2,i) = reelou(2)
    endif
  enddo
end subroutine eir8va
!
subroutine var8ie (in,ou,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer :: ni                     ! Number of 64-bit items
  call var8ei (in,ou,ni)
  call eir8ie (ou,ou,ni)
end subroutine var8ie
!
subroutine ier8va (in,ou,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer :: ni                     ! Number of 64-bit items
  call ier8ei (in,ou,ni)
  call eir8va (ou,ou,ni)
end subroutine ier8va
!
subroutine var4ie (in,ou,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer :: ni                     ! Number of 32-bit items
  call var4ei (in,ou,ni)
  call eir4ie (ou,ou,ni)
end subroutine var4ie
!
subroutine ier4va (in,ou,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer :: ni                     ! Number of 32-bit items
  call ier4ei (in,ou,ni)
  call eir4va (ou,ou,ni)
end subroutine ier4va
!
subroutine var4ei (vaxr,eeei,ni)
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for EEEI machines.
  !---------------------------------------------------------------------
  integer :: ni                     ! Number of 32-bit items
  integer(kind=1) :: vaxr(4,ni)     ! Input array
  real(4) :: eeei(ni)               ! Output array
  ! Local
  integer :: i
  real(4) :: reel
  integer(kind=1) :: int1(4)
  equivalence (int1,reel)
  !
  do i=1,ni
    int1(2) = vaxr(1,i)
    int1(1) = vaxr(2,i)
    int1(4) = vaxr(3,i)
    int1(3) = vaxr(4,i)
    eeei(i)  = 0.25*reel
  enddo
end subroutine var4ei
#endif
!
!-----------------------------------------------------------------------
! Duplicate of previous subroutines, but using an
! integer(kind=size_length) for the number of values to be converted
!-----------------------------------------------------------------------
subroutine iei4ei_sl(inpu,oupu,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 4-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni             ! Number of items
  integer(kind=1) :: inpu(4,ni)     ! Input array
  integer(kind=1) :: oupu(4,ni)     ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(kind=1) :: tmp(4), abyt(4)
  !
entry eii4ie_sl (inpu,oupu,ni)
entry vai4ei_sl (inpu,oupu,ni)
entry eii4va_sl (inpu,oupu,ni)
entry eir4ie_sl (inpu,oupu,ni)
entry ier4ei_sl (inpu,oupu,ni)
  !
  do i=1,ni
    tmp = inpu(1:4,i)
    abyt(1) = tmp(4)
    abyt(2) = tmp(3)
    abyt(3) = tmp(2)
    abyt(4) = tmp(1)
    oupu(1:4,i) = abyt
  enddo
end subroutine iei4ei_sl
!
subroutine vai4ie_sl (inpu,oupu,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Simple copy: vax and swapped IEEE I4 are identical. Provided for
  ! generality
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni        ! Number of items
  integer(kind=4) :: inpu(ni)  ! Input array
  integer(kind=4) :: oupu(ni)  ! Output array
  ! Local
  integer(kind=size_length) :: i
  !
entry iei4va_sl (inpu,oupu,ni)
  do i=1,ni
    oupu(i) = inpu(i)
  enddo
end subroutine vai4ie_sl
!
subroutine iei2ei_sl (inpu,oupu,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 2-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni          ! Number of items
  integer(kind=1) :: inpu(2,ni)  ! Output array
  integer(kind=1) :: oupu(2,ni)  ! Input array
  ! Local
  integer(kind=size_length) :: i
  integer(kind=1) :: tmp(2),abyt(2)
  !
entry eii2ie_sl (inpu,oupu,ni)
entry vai2ei_sl (inpu,oupu,ni)
entry eii2va_sl (inpu,oupu,ni)
  !
  do i=1,ni
    tmp = inpu(1:2,i)
    abyt(1) = tmp(2)
    abyt(2) = tmp(1)
    oupu(1:2,i) = abyt
  enddo
end subroutine iei2ei_sl
!
subroutine eir8ie_sl (in,out,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Byte swapping function for 8-bytes words
  ! Aliased input and output arrays are supported
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni         ! Number of items
  integer(kind=1) :: in(8,ni)   ! Input array
  integer(kind=1) :: out(8,ni)  ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(kind=1) :: tmp(8), abyt(8)
  !
entry iei8ei_sl (in,out,ni)
entry eii8ie_sl (in,out,ni)
entry ier8ei_sl (in,out,ni)
  !
  do i=1,ni
    tmp = in(1:8,i)
    abyt(1) = tmp(8)
    abyt(2) = tmp(7)
    abyt(3) = tmp(6)
    abyt(4) = tmp(5)
    abyt(5) = tmp(4)
    abyt(6) = tmp(3)
    abyt(7) = tmp(2)
    abyt(8) = tmp(1)
    out(1:8,i) = abyt
  enddo
end subroutine eir8ie_sl
!
#if defined(VAX)
!
subroutine ier4va_sl (ieee,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 32-bit items
  integer(2) :: ieee(2,ni)           ! Input array
  real(4) :: real(ni)                ! Output array
  ! Local
  integer(4) :: entier,expo
  integer(4), parameter :: ieee_expm=Z'00007F80'
  integer(2) :: int2(2)
  integer(kind=1) :: octet(4)
  integer(kind=size_length) :: i
  real(4) :: reel
  equivalence (entier,int2)
  equivalence (entier,octet)
  equivalence (entier,reel)
  ! Code
  do i=1,ni
    int2 (2) = ieee(1,i)
    int2 (1) = ieee(2,i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(i) = r4bval
    elseif (expo.eq.0) then
      real(i) = 0.0
    elseif (octet(2).ge.127) then
      real(i) = r4bval
    else
      real(i) = 4.0*reel
    endif
  enddo
end subroutine ier4va_sl
!
subroutine eir4va_sl (eeei,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                  ! Number of 32-bit items
  integer(kind=1) :: eeei (4,ni)    ! Input array
  real(4) :: real(ni)               ! Output array
  ! Local
  integer(4) :: entier,expo
  integer(kind=1) :: octet(4)
  integer(kind=size_length) :: i
  real(4) :: reel
  equivalence (entier,octet)
  equivalence (entier,reel)
  integer(4), parameter :: ieee_expm=Z'00007F80'
  !
  do i=1,ni
    octet(2) = eeei(1,i)
    octet(1) = eeei(2,i)
    octet(4) = eeei(3,i)
    octet(3) = eeei(4,i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(i) = r4bval
    elseif (expo.eq.0) then
      real(i) = 0.0
    elseif (octet(2).ge.127) then
      real(i) = r4bval
    else
      real(i) = 4.0*reel
    endif
  enddo
end subroutine eir4va_sl
!
subroutine var4ie_sl (real,ieee,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  real(4) :: real(ni)               ! Input array
  integer(2) :: ieee(2,ni)          ! Output array
  ! Local
  integer(kind=size_length) :: i
  real(4) :: reel
  integer(2) :: int2(2)
  equivalence (int2,reel)
  !
  do i=1,ni
    reel = 0.25*real(i)
    ieee(1,i) = int2(2)
    ieee(2,i) = int2(1)
  enddo
end subroutine var4ie_sl
!
subroutine var4ei_sl (real,eeei,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  real(4) :: real(ni)               ! Input array
  integer(kind=1) :: eeei(4,ni)     ! Output array
  ! Local
  integer(kind=size_length) :: i
  real(4) :: reel
  integer(kind=1) :: octet(4)
  equivalence (octet,reel)
  !
  do i=1,ni
    reel = 0.25*real(i)
    eeei(1,i) = octet(2)
    eeei(2,i) = octet(1)
    eeei(3,i) = octet(4)
    eeei(4,i) = octet(3)
  enddo
end subroutine var4ei_sl
!
subroutine eir8va_sl (eeei,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 64-bit items
  integer(kind=1) :: eeei(8,ni)      ! Input array
  real(8) :: real(ni)                ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(kind=1) :: octet(8)
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (octet,tmp4)
  equivalence (tmp2,tmp4)
  integer(2) :: ou(4),mant
  equivalence (ou,reel)
  !
  do i=1,ni
    octet(8) = eeei(1,i)
    octet(7) = eeei(2,i)
    octet(6) = eeei(3,i)
    octet(5) = eeei(4,i)
    octet(4) = eeei(5,i)
    octet(3) = eeei(6,i)
    octet(2) = eeei(7,i)
    octet(1) = eeei(8,i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm)   ! Exponent
      sign = iand(tmp2(4),ieee_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)    ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(i) = 0.0d0
    elseif (expo.gt.125) then  ! Check exponent overflow
      real(i) = r8bval
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
      ou(1) = tmp2(4)          ! Reverse 16 bit words
      ou(2) = tmp2(3)
      ou(3) = tmp2(2)
      ou(4) = tmp2(1)
      real(i) = 4.d0*reel
    endif
  enddo
end subroutine eir8va_sl
!
subroutine ier8va_sl (ieee,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 64-bit items
  integer(4) :: ieee(2,ni)           ! Input array
  real(8) :: real(ni)                ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  integer(2) :: ou(4),mant
  equivalence (ou,reel)
  !
  do i=1,ni
    tmp4(1) = ieee(1,i)
    tmp4(2) = ieee(2,i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm)   ! Exponent
      sign = iand(tmp2(4),ieee_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)    ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(i) = 0.0d0
    elseif (expo.gt.125) then  ! Check exponent overflow
      real(i) = r8bval
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
      ou(1) = tmp2(4)          ! Reverse words
      ou(2) = tmp2(3)
      ou(3) = tmp2(2)
      ou(4) = tmp2(1)
      real(i) = 4.d0*reel
    endif
  enddo
end subroutine ier8va_sl
!
subroutine var8ie_sl (real,ieee,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  real(8) :: real(ni)                ! Input array
  integer(4) :: ieee(2,ni)           ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'x
  integer(2), parameter :: vaxd_mant=Z'007F'x
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  integer(2) :: in(4),mant
  equivalence (in,reel)
  !
  do i=1,ni
    ! Divide by 4.0
    if (real(i).eq.0.0d0) then
      ieee(1,i) = 0
      ieee(2,i) = 0
      cycle                    ! I
    endif
    reel = 0.25d0*real(i)
    tmp2(1) = in(4)            ! Swap 16-bit words
    tmp2(2) = in(3)
    tmp2(3) = in(2)
    tmp2(4) = in(1)
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm)   ! Exponent
      sign = iand(tmp2(4),vaxd_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)    ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    ieee(1,i) = tmp4(1)        ! Move 32-bit words
    ieee(2,i) = tmp4(2)
  enddo
end subroutine var8ie_sl
!
subroutine var8ei_sl (real,eeei,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for VAX machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  real(8) :: real(ni)                ! Input array
  integer(kind=1) :: eeei(8,ni)     ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(kind=4) :: j
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'
  integer(2), parameter :: vaxd_mant=Z'007F'
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(kind=1) :: octet(8)
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (octet,tmp4)
  equivalence (tmp2,tmp4)
  integer(2) :: in(4),mant
  equivalence (in,reel)
  !
  do i=1,ni
    ! Divide by 4.0
    if (real(i).eq.0.0d0) then
      do j=1,8
        eeei(j,i) = 0
      enddo
      cycle                    ! I
    endif
    reel = 0.25d0*real(i)
    tmp2(1) = in(4)            ! Swap 16-bit words
    tmp2(2) = in(3)
    tmp2(3) = in(2)
    tmp2(4) = in(1)
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm)   ! Exponent
      sign = iand(tmp2(4),vaxd_sign)   ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)    ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))  ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))  ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    eeei(1,i) = octet(8)       ! Swap Bytes
    eeei(2,i) = octet(7)
    eeei(3,i) = octet(6)
    eeei(4,i) = octet(5)
    eeei(5,i) = octet(4)
    eeei(6,i) = octet(3)
    eeei(7,i) = octet(2)
    eeei(8,i) = octet(1)
  enddo
end subroutine var8ei_sl
!
#endif
!
#if defined(IEEE)
subroutine ier4va_sl (ieee32,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines, and most likely correct...
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 32-bit items
  real(4) :: ieee32(ni)              ! Input array
  integer(2) :: real(2,ni)           ! Output array
  ! Local
  integer(4), parameter :: ieee_expm=Z'7F800000'
  integer(4) :: entier,expo
  integer(2) :: int2(2)
  integer(kind=1) :: octet(4)
  integer(kind=size_length) :: i
  real(4) :: reel
  equivalence (entier,int2)
  equivalence (entier,octet)
  equivalence (entier,reel)
  !
  do i=1,ni
    reel = ieee32(i)
    expo = iand(entier,ieee_expm)
    if (expo.eq.ieee_expm) then
      real(1,i) = r4bval(1)
      real(2,i) = r4bval(2)
    elseif (expo.eq.0) then
      real(1,i) = 0
      real(2,i) = 0
    elseif (int2(1).eq.32256) then
      real(1,i) = r4bval(1)
      real(2,i) = r4bval(2)
    else
      reel = 4.0*reel
      real(1,i) = int2 (2)
      real(2,i) = int2 (1)
    endif
  enddo
end subroutine ier4va_sl
!
subroutine var4ie_sl (real,ieee32,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  integer(2) :: real(2,ni)           ! Input array
  real(4) :: ieee32(ni)              ! Output array
  ! Local
  integer(kind=size_length) :: i
  real(4) :: reel
  integer(2) :: int2(2)
  equivalence (int2,reel)
  !
  do i=1,ni
    int2(2) = real(1,i)
    int2(1) = real(2,i)
    ieee32(i) = 0.25*reel
  enddo
end subroutine var4ie_sl
!
subroutine ier8va_sl (ieee64,real,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 64-bit items
  real(8) :: ieee64(ni)              ! Input array
  integer(2) :: real(4,ni)           ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: ieee_sign=Z'8000'
  integer(2), parameter :: ieee_expm=Z'7FF0'
  integer(2), parameter :: ieee_mant=Z'000F'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),bit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    reel = 4.0d0*ieee64(i)
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),ieee_expm) ! Exponent
      sign = iand(tmp2(4),ieee_sign) ! Sign
      tmp2(4) = iand(tmp2(4),ieee_mant)  ! Mantissa, first part
      expo = expo/16           ! Shift by 4 bits
      expo = expo-1024         ! Subtract G_Float exponent bias
    else
      expo = -1024
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),3,32)   ! Shift right 3 position, circul
      bit3 = iand(tmp4(1),7)   ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-bit3   ! Mask lowest 3 bits in mantissa
      tmp4(2) = 8*tmp4(2)+bit3 ! Push bits as appropriate
    elseif (tmp4(2).ne.0) then
      tmp4(2) = 8*tmp4(2)
    endif
    !
    ! Check for special cases
    if (expo.lt.-128) then
      real(1,i) = 0
      real(2,i) = 0
      real(3,i) = 0
      real(4,i) = 0
    elseif (expo.ge.127) then
      real(1,i) = r8bval(1)
      real(2,i) = r8bval(2)
      real(3,i) = r8bval(3)
      real(4,i) = r8bval(4)
    else
      expo = expo+128          ! Add D_float exponent bias
      expo = expo*128          ! Shift by 7 bits
      tmp2(4) = ior(expo,tmp2(4))    ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))    ! Set sign
      real(1,i) = tmp2(4)      ! Reverse words
      real(2,i) = tmp2(3)
      real(3,i) = tmp2(2)
      real(4,i) = tmp2(1)
    endif
  enddo
end subroutine ier8va_sl
!
subroutine var8ie_sl (real,ieee64,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for IEEE machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  integer(2) :: real(4,ni)           ! Input array
  real(8) :: ieee64(ni)              ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: vaxd_sign=Z'8000'
  integer(2), parameter :: vaxd_expm=Z'7F80'
  integer(2), parameter :: vaxd_mant=Z'007F'
  integer(4), parameter :: vaxg_bit3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer(4) :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    tmp2(4) = real(1,i)        ! Swap 16-bit words
    tmp2(3) = real(2,i)
    tmp2(2) = real(3,i)
    tmp2(1) = real(4,i)
    if (tmp4(1).eq.0 .and. tmp4(2).eq.0) then
      ieee64(i) = 0.0d0
      cycle                    ! I
    endif
    !
    ! Now bytes and bits are in the right order ...
    if (tmp4(2).ne.0) then
      expo = iand(tmp2(4),vaxd_expm) ! Exponent
      sign = iand(tmp2(4),vaxd_sign) ! Sign
      tmp2(4) = iand(tmp2(4),vaxd_mant)  ! Mantissa, first part
      tmp4(2) = ishftc(tmp4(2),29,32)  ! Shift left 3 position, circula
      hbit3 = iand(tmp4(2),vaxg_bit3)  ! Keep highest 3 bits
      tmp4(2) = tmp4(2)-hbit3  ! Mask highest 3 bits
      expo = expo/128          ! Shift by 7 bits
      expo = expo-128          ! Subtract D_Float exponent bias
      expo = expo+1024         ! Add G_float exponent bias
      expo = expo*16           ! Shift by 3 bits
      tmp2(4) = ior(expo,tmp2(4))    ! Set exponent
      tmp2(4) = ior(sign,tmp2(4))    ! Set sign
    else                       ! Avoid special case for 0
      tmp2(4) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(1).ne.0) then
      tmp4(1) = ishftc(tmp4(1),29,32)  ! Shift left 3 position, circula
      lbit3 = iand(tmp4(1),vaxg_bit3)  ! Extract highest 3 bits
      tmp4(1) = tmp4(1)-lbit3  ! Mask highest 3 bits in mantissa
    endif
    tmp4(1) = ior(tmp4(1),hbit3)   ! Transfer 3 bits from 1st mantissa
    ieee64(i) = 0.25d0*reel
  enddo
end subroutine var8ie_sl
!
subroutine eir4va_sl (eeei,real,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                 ! Number of 32-bit items
  integer(4) :: eeei(ni)           ! Input array
  integer(4) :: real(ni)           ! Output array
  call eir4ie_sl(eeei,eeei,ni)
  call ier4va_sl(eeei,real,ni)
end subroutine eir4va_sl
!
subroutine var4ei_sl (real,eeei,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 32-bit items
  integer(4) :: real(ni)             ! Input array
  integer(4) :: eeei(ni)             ! Output array
  call var4ie_sl(real,eeei,ni)
  call ier4ei_sl(eeei,eeei,ni)
end subroutine var4ei_sl
!
subroutine eir8va_sl (eeei,real,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                 ! Number of 64-bit items
  real(8) :: eeei(ni)           ! Input array
  real(8) :: real(ni)           ! Output array
  call eir8ie_sl(eeei,eeei,ni)
  call ier8va_sl(eeei,real,ni)
end subroutine eir8va_sl
!
subroutine var8ei_sl (real,eeei,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                 ! Number of 64-bit items
  real(8) :: real(ni)           ! Input array
  real(8) :: eeei(ni)           ! Output array
  call var8ie_sl(real,eeei,ni)
  call ier8ei_sl(eeei,eeei,ni)
end subroutine var8ei_sl
#endif
!
#if defined(EEEI)
subroutine eir4va_sl (eeei,vaxr,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for EEEI machines.
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                   ! Number of 32-bit items
  integer(4) :: eeei(ni)             ! Input array
  integer(4) :: vaxr(ni)             ! Output array
  ! Local
  integer(4), parameter :: eeei_expm=Z'7F800000'
  integer(4) :: reelin,reelou,expo
  integer(2) :: int2(2)
  integer(kind=1) :: tmpin(4),tmpou(4)
  integer(kind=size_length) :: i
  real(4) :: reel
  equivalence (reelin,reel)
  equivalence (reelin,tmpin)
  equivalence (reelou,tmpou)
  equivalence (int2,expo)
  !
  do i=1,ni
    ! Convert to swapped VAX reals
    reelin = eeei(i)
    ! Check special cases.
    expo = iand(reelin,eeei_expm)
    if (expo.eq.eeei_expm) then
      vaxr(i) = r4bval
    elseif (expo.eq.0) then
      vaxr(i) = 0
    elseif (int2(1).eq.32256) then
      vaxr(i) = r4bval
    else
      ! Swap to VAX reals (1234 --> 2143).
      ! Equivalent to
      !      unless (tmpin(1)==(126,127,-2,-1,0))
      !      tmpou(2) = tmpin(1)+1     ! Exponent field
      !      tmpou(1) = tmpin(2)
      !      tmpou(3) = tmpin(4)
      !      tmpou(4) = tmpin(3)
      !
      reel = 4.0*reel
      tmpou(2) = tmpin(1)
      tmpou(1) = tmpin(2)
      tmpou(4) = tmpin(3)
      tmpou(3) = tmpin(4)
      vaxr(i) = reelou
    endif
  enddo
end subroutine eir4va_sl
!
subroutine var8ei_sl (vaxr,eeei,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !     Convert NI VAX reals to NI EEEI reals
  !     This version is for EEEI machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 64-bit items
  integer(kind=1) :: vaxr(8,ni)     ! Input array
  real(8) :: eeei(ni)               ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2), parameter :: vxdsig=Z'8000'
  integer(2), parameter :: vxdexp=Z'7F80'
  integer(2), parameter :: vxdman=Z'007F'
  integer, parameter :: vxgbt3=Z'E0000000'
  integer(2) :: tmp2(4),expo,sign
  integer :: tmp4(2),lbit3,hbit3
  real(8) :: reel
  integer(kind=1) :: tmp1(8)
  equivalence (tmp1,tmp2)
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  !
  do i=1,ni
    tmp1 (2) = vaxr (1,i)
    tmp1 (1) = vaxr (2,i)
    tmp1 (4) = vaxr (3,i)
    tmp1 (3) = vaxr (4,i)
    tmp1 (6) = vaxr (5,i)
    tmp1 (5) = vaxr (6,i)
    tmp1 (8) = vaxr (7,i)
    tmp1 (7) = vaxr (8,i)
    if (tmp4(1).eq.0 .and. tmp4(2).eq.0) then
      eeei(i) = 0.0d0
      cycle                    ! I
    endif
    !
    if (tmp4(1).ne.0) then
      expo = iand( tmp2(1),vxdexp )
      sign = iand( tmp2(1),vxdsig )
      tmp2(1) = iand( tmp2(1),vxdman )
      tmp4(1) = ishftc(tmp4(1),29,32)
      hbit3 = iand ( tmp4(1),vxgbt3 )
      tmp4(1) = tmp4(1)-hbit3
      expo = expo/128
      expo = expo-128
      expo = expo+1024
      expo = expo*16
      tmp2(1) = ior( expo,tmp2(1) )
      tmp2(1) = ior( sign,tmp2(1) )
    else
      tmp2(1) = 16*(1024-128)
      hbit3 = 0
    endif
    if (tmp4(2).ne.0) then
      tmp4(2) = ishftc(tmp4(2),29,32)
      lbit3 = iand ( tmp4(2),vxgbt3 )
      tmp4(2) = tmp4(2)-lbit3
    endif
    tmp4(2) = ior ( tmp4(2),hbit3 )
    eeei(i) = 0.25d0*reel
  enddo
end subroutine var8ei_sl
!
subroutine eir8va_sl (eeei,vaxr,ni)
  use gildas_def
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !     Convert NI EEEI reals to NI VAX reals
  !     This version is for EEEI machines
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 64-bit items
  real(8) :: eeei(ni)               ! Input array
  integer :: vaxr(2,ni)             ! Output array
  ! Local
  integer(kind=size_length) :: i
  integer(2) :: tmp2(4),expo,sign
  integer(2), parameter :: eeei_sign=Z'8000'
  integer(2), parameter :: eeei_mant=Z'000F'
  integer(2), parameter :: eeei_expm=Z'7FF0'
  integer :: tmp4(2),lbit3,reelou(2)
  real(8) :: reel
  integer(kind=1) :: tmp1(8),tmpou(8)
  equivalence (tmp1,tmp2)
  equivalence (tmp2,tmp4)
  equivalence (tmp2,reel)
  equivalence (reelou,tmpou)
  !
  ! Order is Sign, Exponent, Mantissa
  do i=1,ni
    reel = 4.0d0*eeei(i)
    if (tmp4(1).ne.0) then
      expo = iand(tmp2(1),eeei_expm)
      sign = iand(tmp2(1),eeei_sign)
      tmp2(1) = iand(tmp2(1),eeei_mant)
      expo = expo/16
      expo = expo-1024
    else
      expo = -1024
    endif
    if (tmp4(2).ne.0) then
      tmp4(2) = ishftc(tmp4(2),3,32)
      lbit3 = iand(tmp4(2),7)
      tmp4(2) = tmp4(2)-lbit3
      tmp4(1) = 8*tmp4(1)+lbit3
    elseif (tmp4(1).ne.0) then
      tmp4(1) = 8*tmp4(1)
    endif
    ! Special cases
    if (expo.lt.-128) then
      vaxr(1,i) = 0
      vaxr(2,i) = 0
    elseif (expo.ge.127) then
      vaxr(1,i) = r8bval(1)
      vaxr(2,i) = r8bval(2)
    else
      expo = expo+128
      expo = expo*128
      tmp2(1) = ior(expo,tmp2(1))
      tmp2(1) = ior(sign,tmp2(1))
      tmpou(2) = tmp1(1)
      tmpou(1) = tmp1(2)
      tmpou(4) = tmp1(3)
      tmpou(3) = tmp1(4)
      tmpou(6) = tmp1(5)
      tmpou(5) = tmp1(6)
      tmpou(8) = tmp1(7)
      tmpou(7) = tmp1(8)
      vaxr(1,i) = reelou(1)
      vaxr(2,i) = reelou(2)
    endif
  enddo
end subroutine eir8va_sl
!
subroutine var8ie_sl (in,ou,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer(kind=size_length) :: ni                     ! Number of 64-bit items
  call var8ei_sl (in,ou,ni)
  call eir8ie_sl (ou,ou,ni)
end subroutine var8ie_sl
!
subroutine ier8va_sl (in,ou,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer(kind=size_length) :: ni                     ! Number of 64-bit items
  call ier8ei_sl (in,ou,ni)
  call eir8va_sl (ou,ou,ni)
end subroutine ier8va_sl
!
subroutine var4ie_sl (in,ou,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  call var4ei_sl (in,ou,ni)
  call eir4ie_sl (ou,ou,ni)
end subroutine var4ie_sl
!
subroutine ier4va_sl (in,ou,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  !---------------------------------------------------------------------
  integer :: in(*)                  ! Input array
  integer :: ou(*)                  ! Output array
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  call ier4ei_sl (in,ou,ni)
  call eir4va_sl (ou,ou,ni)
end subroutine ier4va_sl
!
subroutine var4ei_sl (vaxr,eeei,ni)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (multiple definition because of preprocessing)
  ! This version is for EEEI machines.
  !---------------------------------------------------------------------
  integer(kind=size_length) :: ni                     ! Number of 32-bit items
  integer(kind=1) :: vaxr(4,ni)     ! Input array
  real(4) :: eeei(ni)               ! Output array
  ! Local
  integer(kind=size_length) :: i
  real(4) :: reel
  integer(kind=1) :: int1(4)
  equivalence (int1,reel)
  !
  do i=1,ni
    int1(2) = vaxr(1,i)
    int1(1) = vaxr(2,i)
    int1(4) = vaxr(3,i)
    int1(3) = vaxr(4,i)
    eeei(i)  = 0.25*reel
  enddo
end subroutine var4ei_sl
#endif
!
#if defined(VAX)
subroutine gdf_setblnk4(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ public
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  real(4), intent(in) :: bval
  r4bval = bval
end subroutine gdf_setblnk4
!
subroutine gdf_setblnk8(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ public
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  real(8), intent(in) :: bval
  ! Code
  r8bval = bval
end subroutine gdf_setblnk8
#endif
!
#if defined(IEEE)
subroutine gdf_setblnk4(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch under IEEE)
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  integer(2), intent(in) :: bval(2)
  r4bval(1) = bval(1)
  r4bval(2) = bval(2)
end subroutine gdf_setblnk4
!
subroutine gdf_setblnk8(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch under IEEE)
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  integer(2), intent(in) :: bval(4)
  ! Code
  r8bval(1) = bval(1)
  r8bval(2) = bval(2)
  r8bval(3) = bval(3)
  r8bval(4) = bval(4)
end subroutine gdf_setblnk8
#endif
!
#if defined(EEEI)
subroutine gdf_setblnk4(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ public
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  real(4), intent(in) :: bval
  r4bval = bval
end subroutine gdf_setblnk4
!
subroutine gdf_setblnk8(bval)
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch under EEEI)
  !   Set the blanking for automatic conversions
  !---------------------------------------------------------------------
  integer(4), intent(in) :: bval(2)
  ! Code
  r8bval(1) = bval(1)
  r8bval(2) = bval(2)
end subroutine gdf_setblnk8
#endif
!
subroutine gdf_rsetblnk
  use gfits_blanking
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  integer :: i
#if defined(VAX)
  r4bval = 1.23456e38
  r8bval = 1.23456d38
#endif
#if defined(IEEE)
  !
  do i=1,2
    r4bval(i) = 0
  enddo
  do i=1,4
    r8bval(i) = 0
  enddo
#endif
#if defined(EEEI)
  !
  r4bval = 0
  do i=1,2
    r8bval(i) = 0
  enddo
#endif
end subroutine gdf_rsetblnk

module gio_fitsdef
  use gfits_types
  !--------------------------------------------------------------------
  ! GIO global variable used to define FITS or UV FITS files
  !--------------------------------------------------------------------
  !
  ! Constants
  integer(kind=4), parameter :: code_fits_standard=0
  integer(kind=4), parameter :: code_fits_uvfits=1
  integer(kind=4), parameter :: code_fits_aips=2
  integer(kind=4), parameter :: code_fits_sorted=3
  integer(kind=4), parameter :: code_fits_casa=4
  !
  ! Variables
  character(len=256) :: gdfname  ! Image name
  integer(kind=4) :: a_style     ! Style of processed FITS-tape
  logical :: question            ! Prompt when unrecognized axis type ?
  logical :: sort                ! Sort aips++ fits file ?
  !
  type(gfits_hdesc_t) :: fd
  !
  ! Variables for UV fits file
  real(kind=4) ::  cscal,czero                  ! Complex visibilities scale
  real(kind=4) ::  uscal,uzero                  ! U       scale
  real(kind=4) ::  vscal,vzero                  ! V        and
  real(kind=4) ::  wscal,wzero                  ! W       zero
  real(kind=4) ::  tscal,tzero                  ! Time scale and zero
  real(kind=4) ::  dscal,dzero                  ! Date scale and zero
  real(kind=4) ::  wps                          ! Weight scaling factor
  integer(kind=4) :: luu,lvv,lww,lbase,ldate,ltime,lsour,linte,lfreq,lpara
  integer(kind=4), parameter :: mcount=9    ! Must handle all cases of 1 digit
  real(kind=4) ::  pscal(mcount),pzero(mcount)  ! Scale and Zero for Pgroup
  real(kind=8) :: crval(mcount),cdelt(mcount),crpix(mcount)  ! Axis conversion
  character(len=8) :: ptype(mcount), ctype(mcount)
  !
end module gio_fitsdef

program map_inter
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	Compress OR Interpolate a data cube along its 3rd dimension
  !---------------------------------------------------------------------
  ! Local
  !
  character(len=filename_length) :: mapin, mapout
  integer :: n,new_size, ier
  integer(kind=index_length) :: ipix1,ipixn
  integer, allocatable :: ipi(:,:)
  real, allocatable :: ipr (:,:)
  real(8) :: new_val,new_ref,new_inc
  real :: pix1,pixn
  logical :: error
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('INPUT_MAP$',mapin)
  call gildas_char('OUTPUT_MAP$',mapout)
  call gildas_inte('NX$',new_size,1)
  call gildas_dble('REFERENCE$',new_ref,1)
  call gildas_dble('VALUE$',new_val,1)
  call gildas_dble('INCREMENT$',new_inc,1)
  call gildas_close
  !
  n = len_trim(mapin)
  if (n.eq.0) goto 100
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,mapin,'.lmv',error)
  if (error) then
     write(6,*) 'F-MAP_INTER,  Cannot read input file'
     goto 100
  endif
  !
  ! Create Output file
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(mapout,x%file,' ','.lmv')
  x%gil%blan_words = 2
  x%gil%dim(3) = new_size
  x%gil%inc(3) = new_inc
  x%gil%ref(3) = new_ref
  x%gil%val(3) = new_val
  !
  call gdf_create_image(x,error)
  if (error) then
     write(6,*) 'F-MAP_INTER,  Cannot create output image'
     goto 100
  endif
  !
  ! Check limits
  pix1 = x%gil%ref(3) + (y%gil%val(3) + (1-y%gil%ref(3))*y%gil%inc(3) - x%gil%val(3))/x%gil%inc(3)
  pixn = x%gil%ref(3) + (y%gil%val(3) + (y%gil%dim(3)-y%gil%ref(3))*y%gil%inc(3) - x%gil%val(3))/x%gil%inc(3)
  if (pix1.lt.pixn) then
     ipix1 = int(pix1)
     if (ipix1.ne.pix1) ipix1 = ipix1+1
     ipix1 = max(ipix1,1)
     ipixn = min(int(pixn),x%gil%dim(3))
  else
     ipixn = min(int(pix1),x%gil%dim(3))
     ipix1 = int(pixn)
     if (ipix1.ne.pixn) ipix1 = ipix1+1
     ipix1 = max(ipix1,1)
  endif
  !
  allocate (ipi(2,x%gil%dim(3)), ipr(4,x%gil%dim(3)), stat=ier)
  !
  allocate (x%r3d(x%gil%dim(1),x%gil%dim(2),x%gil%dim(3)) ,stat=ier)
  call all_inter(x%gil%dim(1)*x%gil%dim(2),ipix1,ipixn, x%r3d,x%gil%dim(3) &
       &,x%gil%inc(3),x%gil%ref(3),x%gil%val(3), y%r3d,y%gil%dim(3),y%gil%inc(3),y%gil%ref(3),y%gil%val(3),&
       & ipi, ipr) 
  !
  call gdf_write_data(x,x%r3d,error)  
  !
  call gagout('S-MAP_INTER,  Successful completion')
  call sysexi(1)
100 call sysexi(fatale)
!!end program map_inter
contains
!
subroutine all_inter (n,ic1,icn,x,xdim,xinc,xref,xval,y,ydim,yinc,yref,yval,iwork,rwork)
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Performs the linear interpolation/integration
  ! Arguments:
  !	X	R*4(*)	Output spectrum
  !	N	I*4	Map size
  !	XDIM	I*4	Output pixel number
  !	XINC	R*8	Output first axis increment
  !	XREF	R*8	Output first axis reference pixel
  !	XVAL	R*8	Output first axis value at reference pixel
  ! 	Y	R*4(*)	Input spectrum
  !---------------------------------------------------------------------
  integer(kind=index_length) :: n                      !
  integer(kind=index_length) :: ic1                    !
  integer(kind=index_length) :: icn                    !
  integer(kind=index_length) :: xdim                   !
  real :: x(n,xdim)                 !
  real*8 :: xinc                    !
  real*8 :: xref                    !
  real*8 :: xval                    !
  integer(kind=index_length) :: ydim                   !
  real :: y(n,ydim)                 !
  real*8 :: yinc                    !
  real*8 :: yref                    !
  real*8 :: yval                    !
  integer :: iwork(2,xdim)          !
  real :: rwork(4,xdim)             !
  !	iwork = imin,imax
  !	rwork = rmin_1, rmin, rmax, rmax_1
  !
  integer i,imax,imin, j, k
  real*8 minpix, maxpix, pix, val, expand
  real rmin_1, rmin, rmax_1, rmax, smin, smax
  real scale
  !
  ! Special case: output axis = input axis
  if ((xdim.eq.ydim).and.(xref.eq.yref).and.(xval.eq.yval).and.(xinc.eq.yinc)) then
     x = y
     return
  endif
  !
  x = 0
  !
  expand = abs(xinc/yinc)
  scale  = 1.d0/expand
  do i = ic1, icn
     ! Compute interval
     val = xval + (i-xref)*xinc
     pix = (val-yval)/yinc + yref
     maxpix = pix + 0.5d0*expand
     minpix = pix - 0.5d0*expand
     imin = int(minpix+1.0d0)
     imax = int(maxpix)
     iwork(1,i) = imin
     iwork(2,i) = imax
     if (imax.ge.imin) then
        if (imin.gt.1) then
           ! Lower end
           !
           ! YMIN = Y(IMIN-1)*(IMIN-MINPIX)+Y(IMIN)*(MINPIX-IMIN+1)
           !     and
           ! X(I) = X(I) + 0.5 * ( (IMIN-MINPIX)*(YMIN+Y(IMIN)) )
           !   
           ! Coefficient de IMIN-1: RMIN_1 = 0.5 * (IMIN-MINPIX)*(IMIN-MINPIX)
           ! Coefficient de IMIN:   RMIN   = 0.5 * (MINPIX-IMIN+2)*(IMIN-MINPIX)
           !
           smin = imin-minpix
           rwork(1,i) = 0.5*smin*smin
           rwork(2,i) = smin-rwork(1,i)
        else
           ! Coefficient de IMIN:      RMIN   = (IMIN-MINPIX)
           ! Coefficient de IMIN-1:    RMIN_1 = 0
           rwork(1,i) = 0.0
           rwork(2,i) = imin-minpix
        endif
        if (imax.lt.ydim) then
           ! Upper end
           smax = maxpix-imax
           rwork(4,i) = 0.5*smax*smax
           rwork(3,i) = smax-rwork(4,i)
        else
           rwork(3,i) = maxpix-imax
           rwork(4,i) = 0.0
        endif
        if (imax.eq.imin) then
           ! Point Case
           rwork(2,i) = rwork(2,i)+rwork(3,i)
           rwork(3,i) = 0.0
        else
           ! General Case: Add 1/2 of IMIN & IMAX + 1 of all intermediate
           ! channels
           rwork(2,i) = rwork(2,i)+0.5
           rwork(3,i) = rwork(3,i)+0.5
        endif
     else
        if (imin.gt.1) then
           rwork(1,i) = (imin-pix)
           rwork(2,i) = (pix+1-imin)
        else
           rwork(1,i) = 0.0
           rwork(2,i) = 1.0
        endif
     endif
  enddo
  !
  ! OK, now do it...
  do i = ic1, icn
     imin = iwork(1,i)
     imax = iwork(2,i)
     rmin_1 = rwork(1,i)
     rmin   = rwork(2,i)
     rmax   = rwork(3,i)
     rmax_1 = rwork(4,i)
     !
     if (imax.ge.imin) then
        ! General Trapezium integration
        if (imin.gt.1) then
           do j=1,n
              x(j,i) = y(j,imin-1)*rmin_1
           enddo
           do j=1,n
              x(j,i) = x(j,i) + y(j,imin)*rmin
           enddo
        else
           do j=1,n
              x(j,i) = y(j,imin)*rmin
           enddo
        endif
        if (imax.gt.imin) then
           do k = imin+1,imax-1
              do j=1,n
                 x(j,i) = x(j,i) + y(j,k)
              enddo
           enddo
           do j=1,n
              x(j,i) = x(j,i) + y(j,imax)*rmax
           enddo
        endif
        if (imax.lt.ydim) then
           do j=1,n
              x(j,i) = x(j,i) + y(j,imax+1)*rmax_1
           enddo
        endif
        ! Normalise
        do j=1,n
           x(j,i) = x(j,i)*scale
        enddo
     else
        ! Interpolation
        if (imin.gt.1) then
           do j=1,n
              x(j,i) = y(j,imin-1)*rmin_1
           enddo
           do j=1,n
              x(j,i) = x(j,i) + y(j,imin)*rmin
           enddo
        else
           do j=1,n
              x(j,i) = y(j,imin)
           enddo
        endif
     endif
  enddo
  !
end subroutine all_inter
!
end program map_inter

  subroutine uv_select_buffer(rname,nu,nv,error)
!-----------------------------------------------------------------------
!*
! The use of UV buffers in IMAGER
!
! IMAGER has three virtual UV buffers, named
! "UVI" (Initial), "UVS" (Sorted) and "UVR" (Resampled).
! UVR and UVS are used indifferently, depending on which one is
! available, rather than using UVS only for sorting and UVR only
! for Resampling. Only one of those two is allocated at any time
! (except temporarily when using one as input and the other as output).
!
! UVR and UVS may point to UVI, as sorting is not always needed.
!
! Command READ uses UVI, and nullifies or deallocate UVR and UVS.
!
! Commands UV_MAP, UV_CONT, UV_TIME, UV_RESIDUAL, UV_COMPRESS
! and UV_RESAMPLE use the UVR and UVS buffers.
!   A little tricky logic allows to select UVS or UVR
! for the output, depending on which one is busy as input,
! allocating on demand as needed.
!
! Through the use of a pointer, "UV" (actually a header
! HUV and a pointer to the data DUV), the so-called "current UV data"
! points towards one of them, depending on the last issued commands.
!
! Other commands like UV_BASELINE, UV_FILTER, UV_REWEIGHT or UV_FLAG
! work on the "current UV data". UV_FLAG is partially reversible.
!
! Finally, UV_SORT does not affect the "current UV data", but produces
! a transposed copy of it (which thus cannot be written by WRITE UV),
! called UVT.
!
! The whole thing is a little complex and perhaps should be changed.
!
! In addition to the buffer use, the code must account for the
! weight computation optimization.
!
! NOTE: In an earlier version, commands UV_COMPRESS and UV_RESAMPLE 
! only worked with UVI as input. This makes little sense, as a 
! combination of UV_TIME - UV_COMPRESS did not give the same as 
! UV_COMPRESS - UV_TIME for example. The only "nice" feature of 
! this behaviour was to allow the spectral resampling to start 
! from the full resolution data.
!
! The original data can always be recovered through a READ, which
! is optimized by proper caching if no modification has been done
! to the data.
!!
!-----------------------------------------------------------------------
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Select the next available UV buffer (UVR or UVS) for
  ! commands using them.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name
  integer, intent(in) :: nu                !! Visibility size
  integer, intent(in) :: nv                !! Number of visibilities
  logical, intent(out) :: error            !! Error flag
  !
  ! Local ---
  integer :: ier
  !
  ! Code ----
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVS')
      return
    endif
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else if (associated(duvr)) then
      deallocate (duvr)     ! Free the old one
    endif
    duv => duvs             ! Point to new one
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname,'Memory allocation failure on UVR')
      return
    endif
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else if (associated(duvs)) then
      deallocate (duvs)      ! Free the old one
    endif
    duv => duvr               ! Point to new one
  endif
  optimize(code_save_uv)%change = optimize(code_save_uv)%change+1
  error = .false.
end subroutine uv_select_buffer
!
subroutine uv_reset_buffer(rname)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_beams
  use clean_types
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Reset pointers to UV datasets (back to UVI). Deallocate
  ! UVR or UVS if needed, as well as the "transposed" buffer UVT
  !---------------------------------------------------------------------
  character(len=*) :: rname  !! Caller name
  !
  ! Local ---
  logical :: error
  !
  ! Code ---
  !
  ! What happens when no compressed data is defined ?
  ! well we have to set the same pointers DUV and DUVR as in READ...
  !
  if (allocated(duvt)) deallocate (duvt)        ! UV data not plotted
  !
  if (.not.allocated(duvi)) then
    call map_message(seve%w,rname,'No UV data (DUVI not allocated)')
    return
  endif
  !
  ! Find out which one DUVI is pointing about
  if (associated(duvr,duvi)) then
    ! !Print *,'DUVR was pointing towards DUVI'
    nullify(duvr)
  else if (associated(duvr)) then
    ! !Print *,'DUVR was allocated '
    deallocate (duvr)     ! Free the old one
  else
    ! !Print *,'DUVR not allocated '
  endif
  if (associated(duvs,duvi)) then
    ! !Print *,'DUVS was pointing towards DUVI'
    nullify(duvs)
  else if (associated(duvs)) then
    ! !Print *,'DUVS was allocated '
    deallocate (duvs)     ! Free the old one
  else
    ! !Print *,'DUVS not allocated '
  endif
  !
  ! Copy back the UV header and re-define the file name
  call gdf_copy_header(huvi,huv, error)
  huv%file = huvi%file
  !
  duvr => duvi     ! As in READ
  !
  ! This means we were already pointing to the previous UV data set
  if (associated(duv,duvi)) return
  !
  ! Here we point back...
  if (optimize(code_save_uv)%change.gt.1) then
    optimize(code_save_uv)%change = optimize(code_save_uv)%change - 1
    call map_message(seve%i,rname,'Returning to previous UV data set')
  else
    optimize(code_save_uv)%change = 0
    call map_message(seve%i,rname,'Returning to original UV data set')
    ! Delete the BEAM_RANGES array if any
    nbeam_ranges = -1    ! Beam ranges unchecked
    call sic_delvariable ('BEAM_RANGES',.false.,error)
  endif
  duv => duvi
  do_weig = .true. ! Recompute weight
  call sic_delvariable ('UV',.false.,error)
  call sic_delvariable ('UVS',.false.,error)
  !
end subroutine uv_reset_buffer
!
subroutine uv_dump_buffers(rname)
  use clean_def
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Utility routine
  !
  !   Dump the allocation status of the UV buffers. (Debugging only)
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname    !! Caller name
  !
  ! Local ---
  integer(kind=index_length) :: udim(2)
  logical :: error
  !
  ! Code ----
  if (associated(duvr)) then
    if (associated(duvr,duvi)) then
      call map_message(seve%w,rname,'DUVR associated to DUVI')
    else
      call map_message(seve%w,rname,'DUVR allocated')
    endif
    !
    ! Redefine SIC variables
    udim(1) = ubound(duvr,1)
    udim(2) = ubound(duvr,2)
    call sic_delvariable ('UVR',.false.,error)
    call sic_def_real ('UVR',duvr,2,udim,.false.,error)
  else
    call map_message(seve%w,rname,'no DUVR ...')
  endif
  !
  if (associated(duvs)) then
    if (associated(duvs,duvi)) then
      call map_message(seve%w,rname,'DUVS associated to DUVI')
    else
      call map_message(seve%w,rname,'DUVS allocated')
    endif
    ! Redefine SIC variables
    udim(1) = ubound(duvs,1)
    udim(2) = ubound(duvs,2)
    call sic_delvariable ('UVS',.false.,error)
    call sic_def_real ('UVS',duvs,2,udim,.false.,error)
  else
    call map_message(seve%w,rname,'no DUVS ...')
  endif
  !
  if (allocated(duvt)) call map_message(seve%w,rname,'Transposed buffer allocated.')
  !
  if (associated(duv,duvi)) then
    call map_message(seve%w,rname,'DUV associated to DUVI')
  else if (associated(duv,duvr)) then
    call map_message(seve%w,rname,'DUV associated to DUVR')
  else if (associated(duv,duvs)) then
    call map_message(seve%w,rname,'DUV associated to DUVS')
  else if (associated(duv,duvm)) then
    call map_message(seve%w,rname,'DUV associated to DUVM (Model)')
  else if (associated(duv,duvf)) then
    call map_message(seve%w,rname,'DUV associated to DUVF (Fit residual)')
  else if (associated(duv,duvself)) then
    call map_message(seve%w,rname,'DUV associated to DUVSELF (Self cal)')
  else if (associated(duv,duvraw)) then
    call map_message(seve%w,rname,'DUV associated to DUVRAW (Raw for self-cal)')
  else if (associated(duv)) then
    call map_message(seve%w,rname,'DUV is associated to some other buffer (neither DUVI, DUVR nor DUVS)')
  else
    call map_message(seve%w,rname,'DUV is undefined')
  endif
  !
end subroutine uv_dump_buffers
!
subroutine uv_free_buffers
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  !*
  ! IMAGER -- Utility routine
  !
  !   Deallocate all UV buffers.
  !!
  !---------------------------------------------------------------------
  integer :: ier
  !
  ! Free the previous zone
  ! ! Print *,'Into uv_free_buffers'
  if (associated(duvr)) then
    if (associated(duvr,duvi)) then
      nullify(duvr)
      ! !print *,'Nullify duvr'
    else
      ! !print *,'Deallocate duvr'
      deallocate(duvr,stat=ier)
    endif
  endif
  if (associated(duvs)) then
    if (associated(duvs,duvi)) then
      ! !print *,'Nullify duvs'
      nullify(duvs)
    else
      ! !print *,'Deallocate duvs'
      deallocate(duvs,stat=ier)
    endif
  endif
  if (allocated(duvi)) deallocate(duvi,stat=ier)
  if (allocated(duvt)) deallocate(duvt,stat=ier)
  if (allocated(dchanflag)) deallocate(dchanflag,stat=ier)
  ! !Print *,'Done uv_free_buffers'
end subroutine uv_free_buffers
!
subroutine uv_find_buffers (rname,nu,nv,duv_previous, duv_next,error)
  use clean_arrays
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Utility routine
  !
  !   Find the next available UV buffer (UVR or UVS).
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname       !! Caller name
  integer, intent(in) :: nu                   !! Size of a visiblity
  integer, intent(in) :: nv                   !! Number of visibilities
  real, pointer, intent(out) :: duv_previous(:,:)  !! Pointer to previous buffer
  real, pointer, intent(out) :: duv_next(:,:) !! Pointer to next available buffer
  logical, intent(out) :: error               !! Logical error flag
  !       
  ! Local ---
  integer :: ier
  !
  ! Code ----
  if (associated(duvr)) then
    allocate (duvs(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVS')
      return
    endif
    call map_message(seve%d,rname,'Storing in DUVS')
    duv_previous => duvr
    duv_next => duvs
  else
    allocate (duvr(nu,nv),stat=ier)
    if (ier.ne.0) then
      error = .true.
      call map_message(seve%f,rname, &
      & 'UV_FIND_BUFFERS: Memory allocation failure on UVR')
      return
    endif
    call map_message(seve%d,rname,'Storing in DUVR')
    duv_previous => duvs
    duv_next => duvr
  endif
  error = .false.
end subroutine uv_find_buffers
!
subroutine uv_clean_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Utility routine
  !
  !   Take care of freeing the unused UV buffer, and set UV to point to
  ! the new one.
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:) !! Previous buffer
  real, pointer, intent(inout) :: duv_next(:,:)     !! Next buffer
  logical, intent(in) :: error  !! Logical error flag
  !
  if (associated(duv_previous,duvr)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free the old one
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_previous,duvs)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free the old one
    endif
    duv => duvr             ! Point to new one
  endif
end subroutine uv_clean_buffers
!
subroutine uv_discard_buffers(duv_previous,duv_next,error)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER -- Utility routine
  !
  !   Take care of freeing the last used UV buffer, and reset 
  !   UV to point to the previous one.
  !!
  !---------------------------------------------------------------------
  real, pointer, intent(inout) :: duv_previous(:,:) !! Previous buffer
  real, pointer, intent(inout) :: duv_next(:,:)     !! Next buffer
  logical, intent(in) :: error  !! Logical error flag
  !
  if (associated(duv_next,duvr)) then
    if (error) then
      deallocate(duvr)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvr,duvi)) then
      nullify(duvr)
    else
      deallocate (duvr)      ! Free it 
    endif
    duv => duvs              ! Point to new one
  else if (associated(duv_next,duvs)) then
    if (error) then
      deallocate(duvs)
      nullify (duv_previous, duv_next)
      return
    endif
    !
    if (associated(duvs,duvi)) then
      nullify(duvs)
    else
      deallocate (duvs)     ! Free it
    endif
    duv => duvr             ! Point to new one
  endif
end subroutine uv_discard_buffers
!<FF>
subroutine uv_buffer_finduv(code) 
  use clean_arrays
  !! IMAGER -- Find code of current buffer 
  character(len=1), intent(out) :: code
  !! Code (i,r,s or space) of current buffer
  !
  ! Order matters a lot here ...
  if (associated(duv,duvi)) then
    code = 'i'
  else if (associated(duv,duvr)) then
    code = 'r'
  else if (associated(duv,duvs)) then
    code = 's'
  else
    code = ' '
  endif
end subroutine uv_buffer_finduv
!
subroutine uv_buffer_resetuv(code) 
  use clean_arrays
  !! IMAGER -- Reset current buffer to the specified code
  character(len=1), intent(in) :: code  !! Code (i,r,s or space) of current buffer
  !
  if (code.eq.'r') then
    duv => duvr
  else if (code.eq.'s') then
    duv => duvs
  else if (code.eq.'i') then
    duv => duvi
  else
    nullify(duv)
  endif
end subroutine uv_buffer_resetuv
!
subroutine uv_new_data (weight,resample)
  use gkernel_interfaces
  use clean_arrays
  use clean_types
  use imager_interfaces, only : map_uvgildas
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Internal routine
  !
  ! Declare that the UV data has been modified 
  ! so that   
  ! - the sorting must be redone (no longer needed)  
  ! - the transposed UV data is no longer consistent  
  ! - Data should be read again when asked by the user  
  ! - (optionally) Weights should be re-computed by UV_MAP  
  ! - and SIC variables must be re-defined  
  ! - The "uvself" data set must be discarded  
  !!
  !---------------------------------------------------------------------
  logical, intent(in), optional :: weight    !! Should Weight be discarded
  logical, intent(in), optional :: resample  !! Has resampling be performed 
  !
  logical :: error, increase
  integer :: ier
  !
  error = .false.
  increase = .true.
  if (present(resample)) increase = resample
  if (present(weight)) do_weig = weight
  !
  ! Increase the Optimization level if not going back
  if (increase) then
    optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
    save_data(code_save_uv) = .true.
  endif
  ! Redefine SIC variables (mandatory)
  ! !Print *,'Address in UV_NEW_DATA before ',locwrd(duv), huv%loca%addr
  huv%file = ' '  ! Reset associated file name
  call map_uvgildas ('UV',huv,error,duv)
  ! !Print *,'Address in UV_NEW_DATA after ',locwrd(duv), huv%loca%addr
  !
  ! Discard the transposed, sorted equivalent
  if (allocated(duvt)) deallocate(duvt)
  !
  ! Set the Channel Flags to 1 (good)
  if (present(resample)) then
    if (allocated(dchanflag)) deallocate(dchanflag)
    allocate(dchanflag(huv%gil%nchan),stat=ier)
    dchanflag = 1
    call sic_def_inte('DCHANFLAG',dchanflag,1,huv%gil%nchan,.false.,error)
  endif
  !
  hself%loca%size =0 ! Discard the "uvself" data
end subroutine uv_new_data
!
subroutine map_uvgildas(name,uvh,error,duv)
  use image_def
  use gkernel_types
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  !   IMAGER  -- This should be in GILDAS kernel
  !
  !   (re-)Define the NAME% SIC header variable and corresponding
  !   NAME data area for UV-like data.
  !
  !   Also define additional variables in the NAME% SIC variable
  !   to handle the pointers towards extra columns for UV data.
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name               !! SIC variable name
  type(gildas), intent(inout), target :: uvh         !! Header
  logical, intent(inout) :: error                    !! Logical Error flag
  real, intent(in), target :: duv(:,:)               !! Data area
  !
  ! Local ---
  integer :: i, ier
  logical :: found
  integer(kind=address_length) :: dim(2)
  !
  integer :: iname, jname(code_uvt_last)
  character(len=12) :: lower
  character(len=12), allocatable, save :: enames(:)
  integer, allocatable, save :: ecols(:)
  !
  ! Code ---
  call sic_delvariable(name,.false.,error)
  error = .false.
  !
  call sic_mapgildas (name,uvh,error,duv)
  if (error) return
  !
  if (uvh%gil%uvda_words.eq.0) return
  !
  ! Here print the UV data layout if non standard
  ! This code should normally be in SIC
  if (name.ne.'UV') return    ! For the time being, we only need this for UV%
  !                           ! in the Imager Scripts.
  !
  found = .false.
  iname = 0
  !
  do i=code_uvt_scan,code_uvt_last
    if (uvh%gil%column_pointer(i).gt.0) then
      iname = iname+1
      jname(iname) = i
    endif
  enddo
  if (iname.eq.0) return
  !
  !
  if (allocated(ecols)) deallocate(ecols,enames)
  allocate(ecols(iname),enames(iname),stat=ier)
  !
  dim(1) = iname
  call sic_def_inte('UV%EXTRA_COLUMNS',ecols,1,dim,.false.,error)
  call sic_def_charn('UV%EXTRA_NAMES',enames,1,dim,.false.,error)
  do i=1,iname
    lower = uv_column_name(jname(i))
    call sic_lower(lower)
    enames(i) = lower
    ecols(i) = uvh%gil%column_pointer(jname(i))
  enddo
  !
end subroutine map_uvgildas  
!
!<FF>
!
subroutine discard_uvdata(error)
  use clean_def
  use clean_arrays
  use clean_default
  use clean_types
  use gkernel_interfaces, only : sic_delvariable, gildas_null
  !! IMAGER -- Discard all UV data
  logical, intent(inout) :: error
  !
  ! Local ---
  integer :: atype, ier
  logical :: err
  !
  ! Free the previous zone
  error = .false.
  !
  call uv_free_buffers
  nullify(duv)
  if (allocated(duvi)) deallocate(duvi,stat=ier)
  !
  save_data(code_save_uv) = .false.
  call gildas_null(huv, type='UVT')
  ! No UV_PREVIEW done, then...
  err = .false.
  call sic_delvariable ('PREVIEW',.false.,err)
  call sic_delvariable ('UV',.false.,err)
  call sic_delvariable ('UVS',.false.,err) 
  if (allocated(drobust)) then
    deallocate(drobust)
    call sic_delvariable ('ROBUST_BEAMS',.false.,err)
  endif
  !
  ! Unset optimization (this seems done automatically on other buffers ?)
  atype = 2
!    Print *,'Optimize status ',optimize(atype)%change, optimize(atype)%lastnc, ' change ',optimize(atype)%modif%modif 
!    Print *,'         file ',trim(optimize(atype)%modif%file)
!    
!  type mfile_t
!    character(len=filename_length) :: file=''  ! File name
!    ! Last modification time (to the file system granularity)
!    integer(kind=8) :: mtime
!    ! Last time a modification was probed (to the OS granularity)
!    integer(kind=8) :: ptime
!    ! Was the file modified before last evaluation?
!    logical         :: modif
!  end type mfile_t
!
  optimize(atype)%change = 2          ! Make sure it has changed
  optimize(atype)%modif%file = ' '    ! Reset the filename
  !
  mosaic_mode = 'NONE'
  call sic_delvariable ('FIELDS',.false.,err)
  call reset_fields(themap)
  !
  ! Undo the Weights buffers also
  if (allocated(g_weight)) deallocate(g_weight)
  if (allocated(g_v)) deallocate(g_v)
  do_weig = .true.
end subroutine discard_uvdata
!
subroutine set_buffer_modified(bufnam)
  use clean_types
  !! IMAGER -- Indicate the named buffer has been modified
  character(len=*), intent(in) :: bufnam  !! Buffer name 
  !!  It must be among the known list
  !
  ! Local ---
  integer :: i, atype
  !
  ! Code ----
  do i=1,mtype
    if (bufnam.eq.vtype(i)) then
      atype = i
      optimize(atype)%change = 10 ! Has been modified
      exit
    endif
  enddo
end subroutine set_buffer_modified

subroutine sexfor(xa,ya)
  use phys_const
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>sexfor
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  Makes a nice format for projection information
  !
  !  Coordinates are displayed with 0.1 milliarcsecond precision
  !  (prec=2.78e-8 degrees), namely:
  !  a) log10(360/(24*3600*prec)) = 5.2 digits fractional part for 24
  !     div/turn sexagesimal notation (Right Ascension)
  !  b) log10(360/(360*3600*prec)) = 4 digits fractional part for 360
  !     div/turn sexagesimal notation (Declination)
  !  c) log10(360/(360*prec)) = 7.6 digits fractional part for 360
  !     div/turn decimal notation (Latitude/Longitude)
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: xa  ! X position
  real(kind=8), intent(in) :: ya  ! Y position
  ! Local
  character(len=*), parameter :: rname='SEXFOR'
  real(kind=8) :: xabs,yabs,xalt,yalt
  character(len=15) :: chra  ! 5 digits fractional part (see rad2sexa)
  character(len=15) :: chde  ! 4 digits fractional part (see rad2sexa)
  character(len=message_length) :: chain
  logical :: error
  !
  error = .false.
  chain = ' '
  call rel_to_abs (gproj,xa,ya,xabs,yabs,1)
  !
  select case (i_system)
  case (type_un)
    write (chain,100) xabs*deg_per_rad,yabs*deg_per_rad
    call greg_message(seve%r,rname,chain)
    !
  case (type_ic)
    ! Display native ICRS coordinates, alternate galactic not implemented
    call rad2sexa(xabs,24,chra)
    call rad2sexa(yabs,360,chde)
    write(chain,105)  chra,chde
    call greg_message(seve%r,rname,chain)
    !
    write(chain,103)
    call greg_message(seve%r,rname,chain)
    !
  case (type_eq)
    ! Display native equatorial coordinates + alternate galactic
    call rad2sexa(xabs,24,chra)
    call rad2sexa(yabs,360,chde)
    if (i_equinox.eq.equinox_null) then
      write(chain,104)  chra,chde
    else
      write(chain,102)  chra,chde,i_equinox
    endif
    call greg_message(seve%r,rname,chain)
    !
    if (i_equinox.eq.equinox_null) then
      write(chain,103)
    else
      call equ_gal(xabs,yabs,i_equinox,xalt,yalt,error)
      if (error)  return
      write(chain,101)  xalt*deg_per_rad,yalt*deg_per_rad
    endif
    call greg_message(seve%r,rname,chain)
    !
  case (type_ga)
    ! Display native galactic coordinates + alternate equatorial (use
    ! an arbitrary equinox)
    call gal_equ(xabs,yabs,xalt,yalt,i_equinox_def,error)
    if (error)  return
    call rad2sexa(xalt,24,chra)
    call rad2sexa(yalt,360,chde)
    write(chain,101)  xabs*deg_per_rad,yabs*deg_per_rad
    call greg_message(seve%r,rname,chain)
    write(chain,102)  chra,chde,i_equinox_def
    call greg_message(seve%r,rname,chain)
    !
  case default
    call greg_message(seve%w,rname,'System not supported')
    !
  end select
  !
100 format('Absolute position ',f13.8,1x,f13.8,' degrees')
101 format('    Lii ',f13.8,t35,'Bii ',f13.8)
102 format('    Ra  ',a    ,t35,'Dec ',a,' (Eq. ',f0.1,')')
103 format('    Lii  N/A'  ,t35,'Bii   N/A')
104 format('    Ra  ',a    ,t35,'Dec ',a,' (Eq. unknown)')
105 format('    Ra  ',a    ,t35,'Dec ',a,' (ICRS)')
end subroutine sexfor

module gmath_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GMATH interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gmath_interfaces_public
  use gmath_interfaces_private
  !
end module gmath_interfaces
!
module gmath_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GMATH dependencies public interfaces. Do not use out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  !
end module gmath_dependencies_interfaces

subroutine explore_comm(line,comm,error)
  use gkernel_interfaces
  use gkernel_types
  use clean_default
  use imager_interfaces, only : map_message
  use gbl_message
  !---------------------------------------------------------------------
  !*
  ! VIEWER -- Support for command  
  ! EXPLORE [DataCube] [/ADD Ux Uy [Ibox]] [/NOWAIT]
  !
  !    Call the "explore" scripts that allow to display from a data cube:  
  ! - a 2-D image (channel or integrated area)  
  ! - spectra at selected positions around it  
  !
  ! The display is organized in a Keypad layout  
  !     7 8 9  
  !     4 5 6  
  !     1 2 3  
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  character(len=*), intent(in) :: comm  !! Command name
  logical, intent(out) :: error  !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_dir=1
  integer, parameter :: o_add=2
  integer, parameter :: o_nowait=3
  integer :: o_args
  !
  ! Local ---
  logical :: found
  character(len=24) :: cx,cy,cb
  character(len=256) :: chain
  character(len=256) :: argu
  character(len=256), save :: file
  type(sic_descriptor_t) :: descr
  integer :: nx,ny,nb
  integer, save :: nc=0
  !
  ! Code ----
  cb = ' '
  call sic_ch(line,0,1,cb,nb,.false.,error)
  if (cb.eq.'?') then
    call exec_program('@ i_explore')
    return
  endif
  !
  ! /ADD option
  if (sic_present(o_add,0)) then
    if (nc.eq.0) then
      call map_message(seve%e,comm,'No map to explore, use "EXPLORE Argument" first')
      error = .true.
      return
    endif
    !
    call sic_ch(line,o_add,1,cx,nx,.true.,error)
    if (error) return
    call sic_ch(line,o_add,2,cy,ny,.true.,error)
    if (error) return
    call sic_ch(line,o_add,3,cb,nb,.false.,error)
    if (error) return
    nb = nb+1
    call exec_program('@ add_spectrum '//cx(1:nx)//' '//cy(1:ny)//' '//cb(1:nb))
    return
  endif
  !
  ! Fall back to last Displayed item if no Argument is given
  o_args = 0
  if (.not.sic_present(o_args,1)) then
    if (len_trim(last_shown).eq.0) then
      call map_message(seve%e,comm,'No data to re-EXPLORE yet')
      error = .true.
      return
    endif
    file = last_shown
    nc = len_trim(file)
  else
    !
    call sic_ch(line,o_args,1,argu,nc,.true.,error)
    if (error) return
    !
    call sic_descriptor (argu,descr,found)    ! Checked
    if (.not.found) then
      call sic_ch(line,0,1,argu,nc,.true.,error)
      found = sic_findfile(argu,file,' ',' ')
      if (found) then
        chain = 'DISPLAY\LOAD '//trim(file)
        call exec_command(chain,error)
        if (error) return
        file = 'DATA'
        nc = 4
        call check_view(1,file) ! Force VIEW re-computation
      else
        call map_message(seve%e,comm, &
        'Cannot '//trim(comm)//' '//trim(file)//' (no such file or SIC variable)')
        error = .true.
        nc = 0
        return
      endif
    else
      file = argu
    endif
  endif
  !
  call get_topdir(line,o_dir)
  if (sic_present(o_nowait,0)) then
    call exec_program('@ p_explore '//file(1:nc)//' nowait')
  else
    call exec_program('@ p_explore '//file(1:nc))
  endif
  last_shown = file(1:nc)
  call sic_let_logi('IVIEW%FIRST',.true.,error)
  !
end subroutine explore_comm

subroutine blank_fill(oct,long)
  !---------------------------------------------------------------------
  ! @ private
  ! Blank the input string along its 'long' first chars. Work with
  ! integer*1 values instead of characters.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: long       ! Length of string
  integer(kind=1), intent(out) :: oct(long)  ! String retrieved as a I*1 array
  ! Local
  integer(kind=4) :: i
  !
  do i=1,long
    oct(i) = ichar(' ')
  enddo
end subroutine blank_fill
!
subroutine ctodes(string,nc,addr)
  use gsys_interfaces, except_this=>ctodes
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Copy at address the value of 'string'. nc is the maximum length
  ! (number of bytes) of the string to copy.
  !---------------------------------------------------------------------
  character(len=*),             intent(in) :: string  !
  integer(kind=4),              intent(in) :: nc      !
  integer(kind=address_length), intent(in) :: addr    ! Address is not modified
  ! Local
  integer(kind=1) :: membyt(1)
  integer(kind=address_length) :: ipnt,jpnt,opnt
  integer(kind=4) :: length
  !
  jpnt = addr
  opnt = bytpnt(jpnt,membyt)
  ipnt = bytpnt(locstr(string),membyt)
  call blank_fill(membyt(opnt),nc)    ! Could be shortened
  length = min(nc,len(string))
  call bytoby(membyt(ipnt),membyt(opnt),length)
end subroutine ctodes
!
subroutine destoc(nc,addr,string)
  use gildas_def
  use gsys_interfaces, except_this=>destoc
  !---------------------------------------------------------------------
  ! @ public
  ! Copy in 'string' the value referenced at address 'addr'. nc
  ! is the maximum length (number of bytes) of the string to copy.
  !---------------------------------------------------------------------
  integer(kind=4),              intent(in)  :: nc      !
  integer(kind=address_length), intent(in)  :: addr    !
  character(len=*),             intent(out) :: string  !
  ! Local
  integer(kind=1) :: membyt(1)
  integer(kind=address_length) :: ipnt,jpnt,opnt
  integer(kind=4) :: length
  !
  string = ' '
  jpnt = addr
  ipnt = bytpnt(jpnt,membyt)
  opnt = bytpnt(locstr(string),membyt)
  length = min(nc,len(string))
  call bytoby(membyt(ipnt),membyt(opnt),length)
end subroutine destoc
!
function match_string(string,pattern)
  !---------------------------------------------------------------------
  ! @ public
  ! Basic function for regular expression matching. Only '*' is
  ! currently recognized as a special character.
  !  * : matches 0 or more characters
  ! By construction, tolerate contiguous stars e.g. 'AB***CD'. Matching
  ! is case-sensitive.
  !---------------------------------------------------------------------
  logical                      :: match_string  ! Return value
  character(len=*), intent(in) :: string        ! String to test
  character(len=*), intent(in) :: pattern       ! Pattern to match
  ! Local
  integer(kind=4) :: ppos,spos,p1,p2,s1
  logical :: start
  !
  ! Now extensive tests
  match_string = .false.
  p1 = 1
  s1 = 1
  start = .true.
  do while (.true.)
     !
     ! 1st return case: no more pattern to match
     if (pattern(p1:).eq.'')  return  ! Each piece has matched something
     !
     spos = index(pattern(p1:),'*')  ! Star position
     !
     if (spos.eq.0) then
       ! 2nd return case: no (more) stars
       p2 = len_trim(pattern)
       ppos = index(string(s1:),pattern(p1:p2),.true.)  ! Backward search
       if (ppos.eq.0) then
         match_string = .false.
       elseif (start) then
         match_string = string(s1:).eq.pattern(p1:p2)
       else
         ! Here end of strings must match
         match_string = (ppos+p2-p1).eq.len_trim(string(s1:))
       endif
       return
     !
     elseif (spos.eq.1) then
       ! Found a '*' at left position
       p1 = p1+1
       if (start) then
         start=.false.
         match_string = .true.  ! Revert the default on return
       endif
       cycle
     !
     else
       p2 = p1+spos-2
     endif
     !
     ! Pattern position
     ppos = index(string(s1:),pattern(p1:p2))
     !
     ! 3rd return case: no match
     if (ppos.eq.0) then
        match_string = .false.
        return
     endif
     !
     ! Special left boundary condition
     if (start .and. spos.gt.1) then
        match_string = ppos.eq.1
        if (.not.match_string)  return
     endif
     !
     ! Prepare next loop
     s1 = s1+ppos+p2-p1
     p1 = p1+spos
     if (start)  start=.false.
     !
  enddo
  !
end function match_string

      DOUBLE PRECISION FUNCTION DLAMC3( A, B )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      DOUBLE PRECISION   A, B
*     ..
*
*  Purpose
*  =======
*
*  DLAMC3  is intended to force  A  and  B  to be stored prior to doing
*  the addition of  A  and  B ,  for use in situations where optimizers
*  might hold one of these in a register.
*
*  Arguments
*  =========
*
*  A, B    (input) DOUBLE PRECISION
*          The values A and B.
*
* =====================================================================
*
*     .. Executable Statements ..
*
      DLAMC3 = A + B
*
      RETURN
*
*     End of DLAMC3
*
      END
*
************************************************************************
*

* DECK ztbcon.f
      SUBROUTINE ZTBCON( NORM, UPLO, DIAG, N, KD, AB, LDAB, RCOND, WORK,
     $                   RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            INFO, KD, LDAB, N
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         AB( LDAB, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTBCON estimates the reciprocal of the condition number of a
*  triangular band matrix A, in either the 1-norm or the infinity-norm.
*
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals or subdiagonals of the
*          triangular band matrix A.  KD >= 0.
*
*  AB      (input) COMPLEX*16 array, dimension (LDAB,N)
*          The upper or lower triangular band matrix A, stored in the
*          first kd+1 rows of the array. The j-th column of A is stored
*          in the j-th column of the array AB as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, ONENRM, UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      DOUBLE PRECISION   AINVNM, ANORM, SCALE, SMLNUM, XNORM
      COMPLEX*16         ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH, ZLANTB
      EXTERNAL           LSAME, IZAMAX, DLAMCH, ZLANTB
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDRSCL, ZLACON, ZLATBS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KD.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTBCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      END IF
*
      RCOND = ZERO
      SMLNUM = DLAMCH( 'Safe minimum' )*DBLE( MAX( N, 1 ) )
*
*     Compute the 1-norm of the triangular matrix A or A'.
*
      ANORM = ZLANTB( NORM, UPLO, DIAG, N, KD, AB, LDAB, RWORK )
*
*     Continue only if ANORM > 0.
*
      IF( ANORM.GT.ZERO ) THEN
*
*        Estimate the 1-norm of the inverse of A.
*
         AINVNM = ZERO
         NORMIN = 'N'
         IF( ONENRM ) THEN
            KASE1 = 1
         ELSE
            KASE1 = 2
         END IF
         KASE = 0
   10    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.KASE1 ) THEN
*
*              Multiply by inv(A).
*
               CALL ZLATBS( UPLO, 'No transpose', DIAG, NORMIN, N, KD,
     $                      AB, LDAB, WORK, SCALE, RWORK, INFO )
            ELSE
*
*              Multiply by inv(A').
*
               CALL ZLATBS( UPLO, 'Conjugate transpose', DIAG, NORMIN,
     $                      N, KD, AB, LDAB, WORK, SCALE, RWORK, INFO )
            END IF
            NORMIN = 'Y'
*
*           Multiply by 1/SCALE if doing so will not cause overflow.
*
            IF( SCALE.NE.ONE ) THEN
               IX = IZAMAX( N, WORK, 1 )
               XNORM = CABS1( WORK( IX ) )
               IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $            GO TO 20
               CALL ZDRSCL( N, SCALE, WORK, 1 )
            END IF
            GO TO 10
         END IF
*
*        Compute the estimate of the reciprocal condition number.
*
         IF( AINVNM.NE.ZERO )
     $      RCOND = ( ONE / ANORM ) / AINVNM
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of ZTBCON
*
      END
* DECK ztbrfs.f
      SUBROUTINE ZTBRFS( UPLO, TRANS, DIAG, N, KD, NRHS, AB, LDAB, B,
     $                   LDB, X, LDX, FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, KD, LDAB, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         AB( LDAB, * ), B( LDB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTBRFS provides error bounds and backward error estimates for the
*  solution to a system of linear equations with a triangular band
*  coefficient matrix.
*
*  The solution matrix X must be computed by ZTBTRS or some other
*  means before entering this routine.  ZTBRFS does not do iterative
*  refinement because doing so cannot improve the backward error.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals or subdiagonals of the
*          triangular band matrix A.  KD >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AB      (input) COMPLEX*16 array, dimension (LDAB,N)
*          The upper or lower triangular band matrix A, stored in the
*          first kd+1 rows of the array. The j-th column of A is stored
*          in the j-th column of the array AB as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input) COMPLEX*16 array, dimension (LDX,NRHS)
*          The solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN, NOUNIT, UPPER
      CHARACTER          TRANSN, TRANST
      INTEGER            I, J, K, KASE, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
      COMPLEX*16         ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZLACON, ZTBMV, ZTBSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX, MIN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOTRAN = LSAME( TRANS, 'N' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KD.LT.0 ) THEN
         INFO = -5
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -8
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -10
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -12
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTBRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANSN = 'N'
         TRANST = 'C'
      ELSE
         TRANSN = 'C'
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = KD + 2
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 250 J = 1, NRHS
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL ZCOPY( N, X( 1, J ), 1, WORK, 1 )
         CALL ZTBMV( UPLO, TRANS, DIAG, N, KD, AB, LDAB, WORK, 1 )
         CALL ZAXPY( N, -ONE, B( 1, J ), 1, WORK, 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 20 I = 1, N
            RWORK( I ) = CABS1( B( I, J ) )
   20    CONTINUE
*
         IF( NOTRAN ) THEN
*
*           Compute abs(A)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               IF( NOUNIT ) THEN
                  DO 40 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 30 I = MAX( 1, K-KD ), K
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AB( KD+1+I-K, K ) )*XK
   30                CONTINUE
   40             CONTINUE
               ELSE
                  DO 60 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 50 I = MAX( 1, K-KD ), K - 1
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AB( KD+1+I-K, K ) )*XK
   50                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
   60             CONTINUE
               END IF
            ELSE
               IF( NOUNIT ) THEN
                  DO 80 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 70 I = K, MIN( N, K+KD )
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AB( 1+I-K, K ) )*XK
   70                CONTINUE
   80             CONTINUE
               ELSE
                  DO 100 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 90 I = K + 1, MIN( N, K+KD )
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AB( 1+I-K, K ) )*XK
   90                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
  100             CONTINUE
               END IF
            END IF
         ELSE
*
*           Compute abs(A**H)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               IF( NOUNIT ) THEN
                  DO 120 K = 1, N
                     S = ZERO
                     DO 110 I = MAX( 1, K-KD ), K
                        S = S + CABS1( AB( KD+1+I-K, K ) )*
     $                      CABS1( X( I, J ) )
  110                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  120             CONTINUE
               ELSE
                  DO 140 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 130 I = MAX( 1, K-KD ), K - 1
                        S = S + CABS1( AB( KD+1+I-K, K ) )*
     $                      CABS1( X( I, J ) )
  130                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  140             CONTINUE
               END IF
            ELSE
               IF( NOUNIT ) THEN
                  DO 160 K = 1, N
                     S = ZERO
                     DO 150 I = K, MIN( N, K+KD )
                        S = S + CABS1( AB( 1+I-K, K ) )*
     $                      CABS1( X( I, J ) )
  150                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  160             CONTINUE
               ELSE
                  DO 180 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 170 I = K + 1, MIN( N, K+KD )
                        S = S + CABS1( AB( 1+I-K, K ) )*
     $                      CABS1( X( I, J ) )
  170                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  180             CONTINUE
               END IF
            END IF
         END IF
         S = ZERO
         DO 190 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
  190    CONTINUE
         BERR( J ) = S
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use ZLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 200 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
  200    CONTINUE
*
         KASE = 0
  210    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**H).
*
               CALL ZTBSV( UPLO, TRANST, DIAG, N, KD, AB, LDAB, WORK,
     $                     1 )
               DO 220 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  220          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 230 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  230          CONTINUE
               CALL ZTBSV( UPLO, TRANSN, DIAG, N, KD, AB, LDAB, WORK,
     $                     1 )
            END IF
            GO TO 210
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 240 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  240    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  250 CONTINUE
*
      RETURN
*
*     End of ZTBRFS
*
      END
* DECK ztbtrs.f
      SUBROUTINE ZTBTRS( UPLO, TRANS, DIAG, N, KD, NRHS, AB, LDAB, B,
     $                   LDB, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, KD, LDAB, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AB( LDAB, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTBTRS solves a triangular system of the form
*
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*
*  where A is a triangular band matrix of order N, and B is an
*  N-by-NRHS matrix.  A check is made to verify that A is nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  KD      (input) INTEGER
*          The number of superdiagonals or subdiagonals of the
*          triangular band matrix A.  KD >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AB      (input) COMPLEX*16 array, dimension (LDAB,N)
*          The upper or lower triangular band matrix A, stored in the
*          first kd+1 rows of AB.  The j-th column of A is stored
*          in the j-th column of the array AB as follows:
*          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
*          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  LDAB    (input) INTEGER
*          The leading dimension of the array AB.  LDAB >= KD+1.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element of A is zero,
*                indicating that the matrix is singular and the
*                solutions X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTBSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOUNIT = LSAME( DIAG, 'N' )
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( KD.LT.0 ) THEN
         INFO = -5
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDAB.LT.KD+1 ) THEN
         INFO = -8
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTBTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            DO 10 INFO = 1, N
               IF( AB( KD+1, INFO ).EQ.ZERO )
     $            RETURN
   10       CONTINUE
         ELSE
            DO 20 INFO = 1, N
               IF( AB( 1, INFO ).EQ.ZERO )
     $            RETURN
   20       CONTINUE
         END IF
      END IF
      INFO = 0
*
*     Solve A * X = B,  A**T * X = B,  or  A**H * X = B.
*
      DO 30 J = 1, NRHS
         CALL ZTBSV( UPLO, TRANS, DIAG, N, KD, AB, LDAB, B( 1, J ), 1 )
   30 CONTINUE
*
      RETURN
*
*     End of ZTBTRS
*
      END
* DECK ztgevc.f
      SUBROUTINE ZTGEVC( SIDE, HOWMNY, SELECT, N, A, LDA, B, LDB, VL,
     $                   LDVL, VR, LDVR, MM, M, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDA, LDB, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), VL( LDVL, * ),
     $                   VR( LDVR, * ), WORK( * )
*     ..
* *
*  Purpose
*  =======
*
*  ZTGEVC computes some or all of the right and/or left generalized
*  eigenvectors of a pair of complex upper triangular matrices (A,B).
*
*  The right generalized eigenvector x and the left generalized
*  eigenvector y of (A,B) corresponding to a generalized eigenvalue
*  w are defined by:
*
*          (A - wB) * x = 0  and  y**H * (A - wB) = 0
*
*  where y**H denotes the conjugate tranpose of y.
*
*  If an eigenvalue w is determined by zero diagonal elements of both A
*  and B, a unit vector is returned as the corresponding eigenvector.
*
*  If all eigenvectors are requested, the routine may either return
*  the matrices X and/or Y of right or left eigenvectors of (A,B), or
*  the products Z*X and/or Q*Y, where Z and Q are input unitary
*  matrices.  If (A,B) was obtained from the generalized Schur
*  factorization of an original pair of matrices
*     (A0,B0) = (Q*A*Z**H,Q*B*Z**H),
*  then Z*X and Q*Y are the matrices of right or left eigenvectors of
*  A.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R': compute right eigenvectors only;
*          = 'L': compute left eigenvectors only;
*          = 'B': compute both right and left eigenvectors.
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute all right and/or left eigenvectors;
*          = 'B': compute all right and/or left eigenvectors, and
*                 backtransform them using the input matrices supplied
*                 in VR and/or VL;
*          = 'S': compute selected right and/or left eigenvectors,
*                 specified by the logical array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY='S', SELECT specifies the eigenvectors to be
*          computed.
*          If HOWMNY='A' or 'B', SELECT is not referenced.
*          To select the eigenvector corresponding to the j-th
*          eigenvalue, SELECT(j) must be set to .TRUE..
*
*  N       (input) INTEGER
*          The order of the matrices A and B.  N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The upper triangular matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of array A.  LDA >= max(1,N).
*
*  B       (input) COMPLEX*16 array, dimension (LDB,N)
*          The upper triangular matrix B.  B must have real diagonal
*          elements.
*
*  LDB     (input) INTEGER
*          The leading dimension of array B.  LDB >= max(1,N).
*
*  VL      (input/output) COMPLEX*16 array, dimension (LDVL,MM)
*          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*          contain an N-by-N matrix Q (usually the unitary matrix Q
*          of left Schur vectors returned by ZHGEQZ).
*          On exit, if SIDE = 'L' or 'B', VL contains:
*          if HOWMNY = 'A', the matrix Y of left eigenvectors of (A,B);
*          if HOWMNY = 'B', the matrix Q*Y;
*          if HOWMNY = 'S', the left eigenvectors of (A,B) specified by
*                      SELECT, stored consecutively in the columns of
*                      VL, in the same order as their eigenvalues.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of array VL.
*          LDVL >= max(1,N) if SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) COMPLEX*16 array, dimension (LDVR,MM)
*          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*          contain an N-by-N matrix Q (usually the unitary matrix Z
*          of right Schur vectors returned by ZHGEQZ).
*          On exit, if SIDE = 'R' or 'B', VR contains:
*          if HOWMNY = 'A', the matrix X of right eigenvectors of (A,B);
*          if HOWMNY = 'B', the matrix Z*X;
*          if HOWMNY = 'S', the right eigenvectors of (A,B) specified by
*                      SELECT, stored consecutively in the columns of
*                      VR, in the same order as their eigenvalues.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR actually
*          used to store the eigenvectors.  If HOWMNY = 'A' or 'B', M
*          is set to N.  Each selected eigenvector occupies one column.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (2*N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit.
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            COMPL, COMPR, ILALL, ILBACK, ILBBAD, ILCOMP,
     $                   LSA, LSB
      INTEGER            I, IBEG, IEIG, IEND, IHWMNY, IM, ISIDE, ISRC,
     $                   J, JE, JR
      DOUBLE PRECISION   ACOEFA, ACOEFF, ANORM, ASCALE, BCOEFA, BIG,
     $                   BIGNUM, BNORM, BSCALE, DMIN, SAFMIN, SBETA,
     $                   SCALE, SMALL, TEMP, ULP, XMAX
      COMPLEX*16         BCOEFF, CA, CB, D, SALPHA, SUM, SUMA, SUMB, X
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, XERBLA, ZGEMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, MAX, MIN
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   ABS1
*     ..
*     .. Statement Function definitions ..
      ABS1( X ) = ABS( DBLE( X ) ) + ABS( DIMAG( X ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and Test the input parameters
*
      IF( LSAME( HOWMNY, 'A' ) ) THEN
         IHWMNY = 1
         ILALL = .TRUE.
         ILBACK = .FALSE.
      ELSE IF( LSAME( HOWMNY, 'S' ) ) THEN
         IHWMNY = 2
         ILALL = .FALSE.
         ILBACK = .FALSE.
      ELSE IF( LSAME( HOWMNY, 'B' ) .OR. LSAME( HOWMNY, 'T' ) ) THEN
         IHWMNY = 3
         ILALL = .TRUE.
         ILBACK = .TRUE.
      ELSE
         IHWMNY = -1
      END IF
*
      IF( LSAME( SIDE, 'R' ) ) THEN
         ISIDE = 1
         COMPL = .FALSE.
         COMPR = .TRUE.
      ELSE IF( LSAME( SIDE, 'L' ) ) THEN
         ISIDE = 2
         COMPL = .TRUE.
         COMPR = .FALSE.
      ELSE IF( LSAME( SIDE, 'B' ) ) THEN
         ISIDE = 3
         COMPL = .TRUE.
         COMPR = .TRUE.
      ELSE
         ISIDE = -1
      END IF
*
*     Count the number of eigenvectors
*
      IF( .NOT.ILALL ) THEN
         IM = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         IM = IM + 1
   10    CONTINUE
      ELSE
         IM = N
      END IF
*
*     Check diagonal of B
*
      ILBBAD = .FALSE.
      DO 20 J = 1, N
         IF( DIMAG( B( J, J ) ).NE.ZERO )
     $      ILBBAD = .TRUE.
   20 CONTINUE
*
      INFO = 0
      IF( ISIDE.LT.0 ) THEN
         INFO = -1
      ELSE IF( IHWMNY.LT.0 ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( ILBBAD ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( COMPL .AND. LDVL.LT.N .OR. LDVL.LT.1 ) THEN
         INFO = -10
      ELSE IF( COMPR .AND. LDVR.LT.N .OR. LDVR.LT.1 ) THEN
         INFO = -12
      ELSE IF( MM.LT.IM ) THEN
         INFO = -13
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTGEVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      M = IM
      IF( N.EQ.0 )
     $   RETURN
*
*     Machine Constants
*
      SAFMIN = DLAMCH( 'Safe minimum' )
      BIG = ONE / SAFMIN
      CALL DLABAD( SAFMIN, BIG )
      ULP = DLAMCH( 'Epsilon' )*DLAMCH( 'Base' )
      SMALL = SAFMIN*N / ULP
      BIG = ONE / SMALL
      BIGNUM = ONE / ( SAFMIN*N )
*
*     Compute the 1-norm of each column of the strictly upper triangular
*     part of A and B to check for possible overflow in the triangular
*     solver.
*
      ANORM = ABS1( A( 1, 1 ) )
      BNORM = ABS1( B( 1, 1 ) )
      RWORK( 1 ) = ZERO
      RWORK( N+1 ) = ZERO
      DO 40 J = 2, N
         RWORK( J ) = ZERO
         RWORK( N+J ) = ZERO
         DO 30 I = 1, J - 1
            RWORK( J ) = RWORK( J ) + ABS1( A( I, J ) )
            RWORK( N+J ) = RWORK( N+J ) + ABS1( B( I, J ) )
   30    CONTINUE
         ANORM = MAX( ANORM, RWORK( J )+ABS1( A( J, J ) ) )
         BNORM = MAX( BNORM, RWORK( N+J )+ABS1( B( J, J ) ) )
   40 CONTINUE
*
      ASCALE = ONE / MAX( ANORM, SAFMIN )
      BSCALE = ONE / MAX( BNORM, SAFMIN )
*
*     Left eigenvectors
*
      IF( COMPL ) THEN
         IEIG = 0
*
*        Main loop over eigenvalues
*
         DO 140 JE = 1, N
            IF( ILALL ) THEN
               ILCOMP = .TRUE.
            ELSE
               ILCOMP = SELECT( JE )
            END IF
            IF( ILCOMP ) THEN
               IEIG = IEIG + 1
*
               IF( ABS1( A( JE, JE ) ).LE.SAFMIN .AND.
     $             ABS( DBLE( B( JE, JE ) ) ).LE.SAFMIN ) THEN
*
*                 Singular matrix pencil -- return unit eigenvector
*
                  DO 50 JR = 1, N
                     VL( JR, IEIG ) = CZERO
   50             CONTINUE
                  VL( IEIG, IEIG ) = CONE
                  GO TO 140
               END IF
*
*              Non-singular eigenvalue:
*              Compute coefficients  a  and  b  in
*                   H
*                 y  ( a A - b B ) = 0
*
               TEMP = ONE / MAX( ABS1( A( JE, JE ) )*ASCALE,
     $                ABS( DBLE( B( JE, JE ) ) )*BSCALE, SAFMIN )
               SALPHA = ( TEMP*A( JE, JE ) )*ASCALE
               SBETA = ( TEMP*DBLE( B( JE, JE ) ) )*BSCALE
               ACOEFF = SBETA*ASCALE
               BCOEFF = SALPHA*BSCALE
*
*              Scale to avoid underflow
*
               LSA = ABS( SBETA ).GE.SAFMIN .AND. ABS( ACOEFF ).LT.SMALL
               LSB = ABS1( SALPHA ).GE.SAFMIN .AND. ABS1( BCOEFF ).LT.
     $               SMALL
*
               SCALE = ONE
               IF( LSA )
     $            SCALE = ( SMALL / ABS( SBETA ) )*MIN( ANORM, BIG )
               IF( LSB )
     $            SCALE = MAX( SCALE, ( SMALL / ABS1( SALPHA ) )*
     $                    MIN( BNORM, BIG ) )
               IF( LSA .OR. LSB ) THEN
                  SCALE = MIN( SCALE, ONE /
     $                    ( SAFMIN*MAX( ONE, ABS( ACOEFF ),
     $                    ABS1( BCOEFF ) ) ) )
                  IF( LSA ) THEN
                     ACOEFF = ASCALE*( SCALE*SBETA )
                  ELSE
                     ACOEFF = SCALE*ACOEFF
                  END IF
                  IF( LSB ) THEN
                     BCOEFF = BSCALE*( SCALE*SALPHA )
                  ELSE
                     BCOEFF = SCALE*BCOEFF
                  END IF
               END IF
*
               ACOEFA = ABS( ACOEFF )
               BCOEFA = ABS1( BCOEFF )
               XMAX = ONE
               DO 60 JR = 1, N
                  WORK( JR ) = CZERO
   60          CONTINUE
               WORK( JE ) = CONE
               DMIN = MAX( ULP*ACOEFA*ANORM, ULP*BCOEFA*BNORM, SAFMIN )
*
*                                              H
*              Triangular solve of  (a A - b B)  y = 0
*
*                                      H
*              (rowwise in  (a A - b B) , or columnwise in a A - b B)
*
               DO 100 J = JE + 1, N
*
*                 Compute
*                       j-1
*                 SUM = sum  conjg( a*A(k,j) - b*B(k,j) )*x(k)
*                       k=je
*                 (Scale if necessary)
*
                  TEMP = ONE / XMAX
                  IF( ACOEFA*RWORK( J )+BCOEFA*RWORK( N+J ).GT.BIGNUM*
     $                TEMP ) THEN
                     DO 70 JR = JE, J - 1
                        WORK( JR ) = TEMP*WORK( JR )
   70                CONTINUE
                     XMAX = ONE
                  END IF
                  SUMA = CZERO
                  SUMB = CZERO
*
                  DO 80 JR = JE, J - 1
                     SUMA = SUMA + DCONJG( A( JR, J ) )*WORK( JR )
                     SUMB = SUMB + DCONJG( B( JR, J ) )*WORK( JR )
   80             CONTINUE
                  SUM = ACOEFF*SUMA - DCONJG( BCOEFF )*SUMB
*
*                 Form x(j) = - SUM / conjg( a*A(j,j) - b*B(j,j) )
*
*                 with scaling and perturbation of the denominator
*
                  D = DCONJG( ACOEFF*A( J, J )-BCOEFF*B( J, J ) )
                  IF( ABS1( D ).LE.DMIN )
     $               D = DCMPLX( DMIN )
*
                  IF( ABS1( D ).LT.ONE ) THEN
                     IF( ABS1( SUM ).GE.BIGNUM*ABS1( D ) ) THEN
                        TEMP = ONE / ABS1( SUM )
                        DO 90 JR = JE, J - 1
                           WORK( JR ) = TEMP*WORK( JR )
   90                   CONTINUE
                        XMAX = TEMP*XMAX
                        SUM = TEMP*SUM
                     END IF
                  END IF
                  WORK( J ) = -SUM / D
                  XMAX = MAX( XMAX, ABS1( WORK( J ) ) )
  100          CONTINUE
*
*              Back transform eigenvector if HOWMNY='B'.
*
               IF( ILBACK ) THEN
                  CALL ZGEMV( 'N', N, N+1-JE, CONE, VL( 1, JE ), LDVL,
     $                        WORK( JE ), 1, CZERO, WORK( N+1 ), 1 )
                  ISRC = 2
                  IBEG = 1
               ELSE
                  ISRC = 1
                  IBEG = JE
               END IF
*
*              Copy and scale eigenvector into column of VL
*
               XMAX = ZERO
               DO 110 JR = IBEG, N
                  XMAX = MAX( XMAX, ABS1( WORK( ( ISRC-1 )*N+JR ) ) )
  110          CONTINUE
*
               IF( XMAX.GT.SAFMIN ) THEN
                  TEMP = ONE / XMAX
                  DO 120 JR = IBEG, N
                     VL( JR, IEIG ) = TEMP*WORK( ( ISRC-1 )*N+JR )
  120             CONTINUE
               ELSE
                  IBEG = N + 1
               END IF
*
               DO 130 JR = 1, IBEG - 1
                  VL( JR, IEIG ) = CZERO
  130          CONTINUE
*
            END IF
  140    CONTINUE
      END IF
*
*     Right eigenvectors
*
      IF( COMPR ) THEN
         IEIG = IM + 1
*
*        Main loop over eigenvalues
*
         DO 250 JE = N, 1, -1
            IF( ILALL ) THEN
               ILCOMP = .TRUE.
            ELSE
               ILCOMP = SELECT( JE )
            END IF
            IF( ILCOMP ) THEN
               IEIG = IEIG - 1
*
               IF( ABS1( A( JE, JE ) ).LE.SAFMIN .AND.
     $             ABS( DBLE( B( JE, JE ) ) ).LE.SAFMIN ) THEN
*
*                 Singular matrix pencil -- return unit eigenvector
*
                  DO 150 JR = 1, N
                     VR( JR, IEIG ) = CZERO
  150             CONTINUE
                  VR( IEIG, IEIG ) = CONE
                  GO TO 250
               END IF
*
*              Non-singular eigenvalue:
*              Compute coefficients  a  and  b  in
*
*              ( a A - b B ) x  = 0
*
               TEMP = ONE / MAX( ABS1( A( JE, JE ) )*ASCALE,
     $                ABS( DBLE( B( JE, JE ) ) )*BSCALE, SAFMIN )
               SALPHA = ( TEMP*A( JE, JE ) )*ASCALE
               SBETA = ( TEMP*DBLE( B( JE, JE ) ) )*BSCALE
               ACOEFF = SBETA*ASCALE
               BCOEFF = SALPHA*BSCALE
*
*              Scale to avoid underflow
*
               LSA = ABS( SBETA ).GE.SAFMIN .AND. ABS( ACOEFF ).LT.SMALL
               LSB = ABS1( SALPHA ).GE.SAFMIN .AND. ABS1( BCOEFF ).LT.
     $               SMALL
*
               SCALE = ONE
               IF( LSA )
     $            SCALE = ( SMALL / ABS( SBETA ) )*MIN( ANORM, BIG )
               IF( LSB )
     $            SCALE = MAX( SCALE, ( SMALL / ABS1( SALPHA ) )*
     $                    MIN( BNORM, BIG ) )
               IF( LSA .OR. LSB ) THEN
                  SCALE = MIN( SCALE, ONE /
     $                    ( SAFMIN*MAX( ONE, ABS( ACOEFF ),
     $                    ABS1( BCOEFF ) ) ) )
                  IF( LSA ) THEN
                     ACOEFF = ASCALE*( SCALE*SBETA )
                  ELSE
                     ACOEFF = SCALE*ACOEFF
                  END IF
                  IF( LSB ) THEN
                     BCOEFF = BSCALE*( SCALE*SALPHA )
                  ELSE
                     BCOEFF = SCALE*BCOEFF
                  END IF
               END IF
*
               ACOEFA = ABS( ACOEFF )
               BCOEFA = ABS1( BCOEFF )
               XMAX = ONE
               DO 160 JR = 1, N
                  WORK( JR ) = CZERO
  160          CONTINUE
               WORK( JE ) = CONE
               DMIN = MAX( ULP*ACOEFA*ANORM, ULP*BCOEFA*BNORM, SAFMIN )
*
*              Triangular solve of  (a A - b B) x = 0  (columnwise)
*
*              WORK(1:j-1) contains sums w,
*              WORK(j+1:JE) contains x
*
               DO 170 JR = 1, JE - 1
                  WORK( JR ) = ACOEFF*A( JR, JE ) - BCOEFF*B( JR, JE )
  170          CONTINUE
               WORK( JE ) = CONE
*
               DO 210 J = JE - 1, 1, -1
*
*                 Form x(j) := - w(j) / d
*                 with scaling and perturbation of the denominator
*
                  D = ACOEFF*A( J, J ) - BCOEFF*B( J, J )
                  IF( ABS1( D ).LE.DMIN )
     $               D = DCMPLX( DMIN )
*
                  IF( ABS1( D ).LT.ONE ) THEN
                     IF( ABS1( WORK( J ) ).GE.BIGNUM*ABS1( D ) ) THEN
                        TEMP = ONE / ABS1( WORK( J ) )
                        DO 180 JR = 1, JE
                           WORK( JR ) = TEMP*WORK( JR )
  180                   CONTINUE
                     END IF
                  END IF
*
                  WORK( J ) = -WORK( J ) / D
*
                  IF( J.GT.1 ) THEN
*
*                    w = w + x(j)*(a A(*,j) - b B(*,j) ) with scaling
*
                     IF( ABS1( WORK( J ) ).GT.ONE ) THEN
                        TEMP = ONE / ABS1( WORK( J ) )
                        IF( ACOEFA*RWORK( J )+BCOEFA*RWORK( N+J ).GE.
     $                      BIGNUM*TEMP ) THEN
                           DO 190 JR = 1, JE
                              WORK( JR ) = TEMP*WORK( JR )
  190                      CONTINUE
                        END IF
                     END IF
*
                     CA = ACOEFF*WORK( J )
                     CB = BCOEFF*WORK( J )
                     DO 200 JR = 1, J - 1
                        WORK( JR ) = WORK( JR ) + CA*A( JR, J ) -
     $                               CB*B( JR, J )
  200                CONTINUE
                  END IF
  210          CONTINUE
*
*              Back transform eigenvector if HOWMNY='B'.
*
               IF( ILBACK ) THEN
                  CALL ZGEMV( 'N', N, JE, CONE, VR, LDVR, WORK, 1,
     $                        CZERO, WORK( N+1 ), 1 )
                  ISRC = 2
                  IEND = N
               ELSE
                  ISRC = 1
                  IEND = JE
               END IF
*
*              Copy and scale eigenvector into column of VR
*
               XMAX = ZERO
               DO 220 JR = 1, IEND
                  XMAX = MAX( XMAX, ABS1( WORK( ( ISRC-1 )*N+JR ) ) )
  220          CONTINUE
*
               IF( XMAX.GT.SAFMIN ) THEN
                  TEMP = ONE / XMAX
                  DO 230 JR = 1, IEND
                     VR( JR, IEIG ) = TEMP*WORK( ( ISRC-1 )*N+JR )
  230             CONTINUE
               ELSE
                  IEND = 0
               END IF
*
               DO 240 JR = IEND + 1, N
                  VR( JR, IEIG ) = CZERO
  240          CONTINUE
*
            END IF
  250    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTGEVC
*
      END
* DECK ztgsja.f
      SUBROUTINE ZTGSJA( JOBU, JOBV, JOBQ, M, P, N, K, L, A, LDA, B,
     $                   LDB, TOLA, TOLB, ALPHA, BETA, U, LDU, V, LDV,
     $                   Q, LDQ, WORK, NCYCLE, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          JOBQ, JOBU, JOBV
      INTEGER            INFO, K, L, LDA, LDB, LDQ, LDU, LDV, M, N,
     $                   NCYCLE, P
      DOUBLE PRECISION   TOLA, TOLB
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   ALPHA( * ), BETA( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), Q( LDQ, * ),
     $                   U( LDU, * ), V( LDV, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTGSJA computes the generalized singular value decomposition (GSVD)
*  of two complex upper triangular (or trapezoidal) matrices A and B.
*
*  On entry, it is assumed that matrices A and B have the following
*  forms, which may be obtained by the preprocessing subroutine ZGGSVP
*  from a general M-by-N matrix A and P-by-N matrix B:
*
*               N-K-L  K    L
*     A =    K ( 0    A12  A13 ) if M-K-L >= 0;
*            L ( 0     0   A23 )
*        M-K-L ( 0     0    0  )
*
*             N-K-L  K    L
*     A =  K ( 0    A12  A13 ) if M-K-L < 0;
*        M-K ( 0     0   A23 )
*
*             N-K-L  K    L
*     B =  L ( 0     0   B13 )
*        P-L ( 0     0    0  )
*
*  where the K-by-K matrix A12 and L-by-L matrix B13 are nonsingular
*  upper triangular; A23 is L-by-L upper triangular if M-K-L >= 0,
*  otherwise A23 is (M-K)-by-L upper trapezoidal.
*
*  On exit,
*
*         U'*A*Q = D1*( 0 R ),    V'*B*Q = D2*( 0 R ),
*
*  where U, V and Q are unitary matrices, Z' denotes the conjugate
*  transpose of Z, R is a nonsingular upper triangular matrix, and D1
*  and D2 are ``diagonal'' matrices, which are of the following
*  structures:
*
*  If M-K-L >= 0,
*
*                      K  L
*         D1 =     K ( I  0 )
*                  L ( 0  C )
*              M-K-L ( 0  0 )
*
*                     K  L
*         D2 = L   ( 0  S )
*              P-L ( 0  0 )
*
*                 N-K-L  K    L
*    ( 0 R ) = K (  0   R11  R12 ) K
*              L (  0    0   R22 ) L
*
*  where
*
*    C = diag( ALPHA(K+1), ... , ALPHA(K+L) ),
*    S = diag( BETA(K+1),  ... , BETA(K+L) ),
*    C**2 + S**2 = I.
*
*    R is stored in A(1:K+L,N-K-L+1:N) on exit.
*
*  If M-K-L < 0,
*
*                 K M-K K+L-M
*      D1 =   K ( I  0    0   )
*           M-K ( 0  C    0   )
*
*                   K M-K K+L-M
*      D2 =   M-K ( 0  S    0   )
*           K+L-M ( 0  0    I   )
*             P-L ( 0  0    0   )
*
*                 N-K-L  K   M-K  K+L-M
* ( 0 R ) =    K ( 0    R11  R12  R13  )
*            M-K ( 0     0   R22  R23  )
*          K+L-M ( 0     0    0   R33  )
*
*  where
*  C = diag( ALPHA(K+1), ... , ALPHA(M) ),
*  S = diag( BETA(K+1),  ... , BETA(M) ),
*  C**2 + S**2 = I.
*
*  R = ( R11 R12 R13 ) is stored in A(1:M, N-K-L+1:N) and R33 is stored
*      (  0  R22 R23 )
*  in B(M-K+1:L,N+M-K-L+1:N) on exit.
*
*  The computation of the unitary transformation matrices U, V or Q
*  is optional.  These matrices may either be formed explicitly, or they
*  may be postmultiplied into input matrices U1, V1, or Q1.
*
*  Arguments
*  =========
*
*  JOBU    (input) CHARACTER*1
*          = 'U':  U must contain a unitary matrix U1 on entry, and
*                  the product U1*U is returned;
*          = 'I':  U is initialized to the unit matrix, and the
*                  unitary matrix U is returned;
*          = 'N':  U is not computed.
*
*  JOBV    (input) CHARACTER*1
*          = 'V':  V must contain a unitary matrix V1 on entry, and
*                  the product V1*V is returned;
*          = 'I':  V is initialized to the unit matrix, and the
*                  unitary matrix V is returned;
*          = 'N':  V is not computed.
*
*  JOBQ    (input) CHARACTER*1
*          = 'Q':  Q must contain a unitary matrix Q1 on entry, and
*                  the product Q1*Q is returned;
*          = 'I':  Q is initialized to the unit matrix, and the
*                  unitary matrix Q is returned;
*          = 'N':  Q is not computed.
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  P       (input) INTEGER
*          The number of rows of the matrix B.  P >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrices A and B.  N >= 0.
*
*  K       (input) INTEGER
*  L       (input) INTEGER
*          K and L specify the subblocks in the input matrices A and B:
*          A23 = A(K+1:MIN(K+L,M),N-L+1:N) and B13 = B(1:L,,N-L+1:N)
*          of A and B, whose GSVD is going to be computed by ZTGSJA.
*          See Further details.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the M-by-N matrix A.
*          On exit, A(N-K+1:N,1:MIN(K+L,M) ) contains the triangular
*          matrix R or part of R.  See Purpose for details.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,N)
*          On entry, the P-by-N matrix B.
*          On exit, if necessary, B(M-K+1:L,N+M-K-L+1:N) contains
*          a part of R.  See Purpose for details.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,P).
*
*  TOLA    (input) DOUBLE PRECISION
*  TOLB    (input) DOUBLE PRECISION
*          TOLA and TOLB are the convergence criteria for the Jacobi-
*          Kogbetliantz iteration procedure. Generally, they are the
*          same as used in the preprocessing step, say
*              TOLA = MAX(M,N)*norm(A)*MAZHEPS,
*              TOLB = MAX(P,N)*norm(B)*MAZHEPS.
*
*  ALPHA   (output) DOUBLE PRECISION array, dimension (N)
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          On exit, ALPHA and BETA contain the generalized singular
*          value pairs of A and B;
*            ALPHA(1:K) = 1,
*            BETA(1:K)  = 0,
*          and if M-K-L >= 0,
*            ALPHA(K+1:K+L) = diag(C),
*            BETA(K+1:K+L)  = diag(S),
*          or if M-K-L < 0,
*            ALPHA(K+1:M)= C, ALPHA(M+1:K+L)= 0
*            BETA(K+1:M) = S, BETA(M+1:K+L) = 1.
*          Furthermore, if K+L < N,
*            ALPHA(K+L+1:N) = 0
*            BETA(K+L+1:N)  = 0.
*
*  U       (input/output) COMPLEX*16 array, dimension (LDU,M)
*          On entry, if JOBU = 'U', U must contain a matrix U1 (usually
*          the unitary matrix returned by ZGGSVP).
*          On exit,
*          if JOBU = 'I', U contains the unitary matrix U;
*          if JOBU = 'U', U contains the product U1*U.
*          If JOBU = 'N', U is not referenced.
*
*  LDU     (input) INTEGER
*          The leading dimension of the array U. LDU >= max(1,M) if
*          JOBU = 'U'; LDU >= 1 otherwise.
*
*  V       (input/output) COMPLEX*16 array, dimension (LDV,P)
*          On entry, if JOBV = 'V', V must contain a matrix V1 (usually
*          the unitary matrix returned by ZGGSVP).
*          On exit,
*          if JOBV = 'I', V contains the unitary matrix V;
*          if JOBV = 'V', V contains the product V1*V.
*          If JOBV = 'N', V is not referenced.
*
*  LDV     (input) INTEGER
*          The leading dimension of the array V. LDV >= max(1,P) if
*          JOBV = 'V'; LDV >= 1 otherwise.
*
*  Q       (input/output) COMPLEX*16 array, dimension (LDQ,N)
*          On entry, if JOBQ = 'Q', Q must contain a matrix Q1 (usually
*          the unitary matrix returned by ZGGSVP).
*          On exit,
*          if JOBQ = 'I', Q contains the unitary matrix Q;
*          if JOBQ = 'Q', Q contains the product Q1*Q.
*          If JOBQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q. LDQ >= max(1,N) if
*          JOBQ = 'Q'; LDQ >= 1 otherwise.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  NCYCLE  (output) INTEGER
*          The number of cycles required for convergence.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value.
*          = 1:  the procedure does not converge after MAXIT cycles.
*
*  Internal Parameters
*  ===================
*
*  MAXIT   INTEGER
*          MAXIT specifies the total loops that the iterative procedure
*          may take. If after MAXIT cycles, the routine fails to
*          converge, we return INFO = 1.
*
*  Further Details
*  ===============
*
*  ZTGSJA essentially uses a variant of Kogbetliantz algorithm to reduce
*  min(L,M-K)-by-L triangular (or trapezoidal) matrix A23 and L-by-L
*  matrix B13 to the form:
*
*           U1'*A13*Q1 = C1*R1; V1'*B13*Q1 = S1*R1,
*
*  where U1, V1 and Q1 are unitary matrix, and Z' is the conjugate
*  transpose of Z.  C1 and S1 are diagonal matrices satisfying
*
*                C1**2 + S1**2 = I,
*
*  and R1 is an L-by-L nonsingular upper triangular matrix.
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            MAXIT
      PARAMETER          ( MAXIT = 40 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
*
      LOGICAL            INITQ, INITU, INITV, UPPER, WANTQ, WANTU, WANTV
      INTEGER            I, J, KCYCLE
      DOUBLE PRECISION   A1, A3, B1, B3, CSQ, CSU, CSV, ERROR, GAMMA,
     $                   RWK, SSMIN
      COMPLEX*16         A2, B2, SNQ, SNU, SNV
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLARTG, XERBLA, ZCOPY, ZDSCAL, ZLAGS2, ZLAPLL,
     $                   ZLASET, ZROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCONJG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      INITU = LSAME( JOBU, 'I' )
      WANTU = INITU .OR. LSAME( JOBU, 'U' )
*
      INITV = LSAME( JOBV, 'I' )
      WANTV = INITV .OR. LSAME( JOBV, 'V' )
*
      INITQ = LSAME( JOBQ, 'I' )
      WANTQ = INITQ .OR. LSAME( JOBQ, 'Q' )
*
      INFO = 0
      IF( .NOT.( INITU .OR. WANTU .OR. LSAME( JOBU, 'N' ) ) ) THEN
         INFO = -1
      ELSE IF( .NOT.( INITV .OR. WANTV .OR. LSAME( JOBV, 'N' ) ) ) THEN
         INFO = -2
      ELSE IF( .NOT.( INITQ .OR. WANTQ .OR. LSAME( JOBQ, 'N' ) ) ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( P.LT.0 ) THEN
         INFO = -5
      ELSE IF( N.LT.0 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -10
      ELSE IF( LDB.LT.MAX( 1, P ) ) THEN
         INFO = -12
      ELSE IF( LDU.LT.1 .OR. ( WANTU .AND. LDU.LT.M ) ) THEN
         INFO = -18
      ELSE IF( LDV.LT.1 .OR. ( WANTV .AND. LDV.LT.P ) ) THEN
         INFO = -20
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -22
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTGSJA', -INFO )
         RETURN
      END IF
*
*     Initialize U, V and Q, if necessary
*
      IF( INITU )
     $   CALL ZLASET( 'Full', M, M, CZERO, CONE, U, LDU )
      IF( INITV )
     $   CALL ZLASET( 'Full', P, P, CZERO, CONE, V, LDV )
      IF( INITQ )
     $   CALL ZLASET( 'Full', N, N, CZERO, CONE, Q, LDQ )
*
*     Loop until convergence
*
      UPPER = .FALSE.
      DO 40 KCYCLE = 1, MAXIT
*
         UPPER = .NOT.UPPER
*
         DO 20 I = 1, L - 1
            DO 10 J = I + 1, L
*
               A1 = ZERO
               A2 = CZERO
               A3 = ZERO
               IF( K+I.LE.M )
     $            A1 = A( K+I, N-L+I )
               IF( K+J.LE.M )
     $            A3 = A( K+J, N-L+J )
*
               B1 = B( I, N-L+I )
               B3 = B( J, N-L+J )
*
               IF( UPPER ) THEN
                  IF( K+I.LE.M )
     $               A2 = A( K+I, N-L+J )
                  B2 = B( I, N-L+J )
               ELSE
                  IF( K+J.LE.M )
     $               A2 = A( K+J, N-L+I )
                  B2 = B( J, N-L+I )
               END IF
*
               CALL ZLAGS2( UPPER, A1, A2, A3, B1, B2, B3, CSU, SNU,
     $                      CSV, SNV, CSQ, SNQ )
*
*              Update (K+I)-th and (K+J)-th rows of matrix A: U'*A
*
               IF( K+J.LE.M )
     $            CALL ZROT( L, A( K+J, N-L+1 ), LDA, A( K+I, N-L+1 ),
     $                       LDA, CSU, DCONJG( SNU ) )
*
*              Update I-th and J-th rows of matrix B: V'*B
*
               CALL ZROT( L, B( J, N-L+1 ), LDB, B( I, N-L+1 ), LDB,
     $                    CSV, DCONJG( SNV ) )
*
*              Update (N-L+I)-th and (N-L+J)-th columns of matrices
*              A and B: A*Q and B*Q
*
               CALL ZROT( MIN( K+L, M ), A( 1, N-L+J ), 1,
     $                    A( 1, N-L+I ), 1, CSQ, SNQ )
*
               CALL ZROT( L, B( 1, N-L+J ), 1, B( 1, N-L+I ), 1, CSQ,
     $                    SNQ )
*
               IF( UPPER ) THEN
                  IF( K+I.LE.M )
     $               A( K+I, N-L+J ) = CZERO
                  B( I, N-L+J ) = CZERO
               ELSE
                  IF( K+J.LE.M )
     $               A( K+J, N-L+I ) = CZERO
                  B( J, N-L+I ) = CZERO
               END IF
*
*              Ensure that the diagonal elements of A and B are real.
*
               IF( K+I.LE.M )
     $            A( K+I, N-L+I ) = DBLE( A( K+I, N-L+I ) )
               IF( K+J.LE.M )
     $            A( K+J, N-L+J ) = DBLE( A( K+J, N-L+J ) )
               B( I, N-L+I ) = DBLE( B( I, N-L+I ) )
               B( J, N-L+J ) = DBLE( B( J, N-L+J ) )
*
*              Update unitary matrices U, V, Q, if desired.
*
               IF( WANTU .AND. K+J.LE.M )
     $            CALL ZROT( M, U( 1, K+J ), 1, U( 1, K+I ), 1, CSU,
     $                       SNU )
*
               IF( WANTV )
     $            CALL ZROT( P, V( 1, J ), 1, V( 1, I ), 1, CSV, SNV )
*
               IF( WANTQ )
     $            CALL ZROT( N, Q( 1, N-L+J ), 1, Q( 1, N-L+I ), 1, CSQ,
     $                       SNQ )
*
   10       CONTINUE
   20    CONTINUE
*
         IF( .NOT.UPPER ) THEN
*
*           The matrices A13 and B13 were lower triangular at the start
*           of the cycle, and are now upper triangular.
*
*           Convergence test: test the parallelism of the corresponding
*           rows of A and B.
*
            ERROR = ZERO
            DO 30 I = 1, MIN( L, M-K )
               CALL ZCOPY( L-I+1, A( K+I, N-L+I ), LDA, WORK, 1 )
               CALL ZCOPY( L-I+1, B( I, N-L+I ), LDB, WORK( L+1 ), 1 )
               CALL ZLAPLL( L-I+1, WORK, 1, WORK( L+1 ), 1, SSMIN )
               ERROR = MAX( ERROR, SSMIN )
   30       CONTINUE
*
            IF( ABS( ERROR ).LE.DBLE( N )*MIN( TOLA, TOLB ) )
     $         GO TO 50
         END IF
*
*        End of cycle loop
*
   40 CONTINUE
*
*     The algorithm has not converged after MAXIT cycles.
*
      INFO = 1
      GO TO 100
*
   50 CONTINUE
*
*     If ERROR <= N*MIN(TOLA,TOLB), then the algorithm has converged.
*     Compute the generalized singular value pairs (ALPHA, BETA), and
*     set the triangular matrix R to array A.
*
      DO 60 I = 1, K
         ALPHA( I ) = ONE
         BETA( I ) = ZERO
   60 CONTINUE
*
      DO 70 I = 1, MIN( L, M-K )
*
         A1 = A( K+I, N-L+I )
         B1 = B( I, N-L+I )
*
         IF( A1.NE.ZERO ) THEN
            GAMMA = B1 / A1
*
            IF( GAMMA.LT.ZERO ) THEN
               CALL ZDSCAL( L-I+1, -ONE, B( I, N-L+I ), LDB )
               IF( WANTV )
     $            CALL ZDSCAL( P, -ONE, V( 1, I ), 1 )
            END IF
*
            CALL DLARTG( ABS( GAMMA ), ONE, BETA( K+I ), ALPHA( K+I ),
     $                   RWK )
*
            IF( ALPHA( K+I ).GE.BETA( K+I ) ) THEN
               CALL ZDSCAL( L-I+1, ONE / ALPHA( K+I ), A( K+I, N-L+I ),
     $                      LDA )
            ELSE
               CALL ZDSCAL( L-I+1, ONE / BETA( K+I ), B( I, N-L+I ),
     $                      LDB )
               CALL ZCOPY( L-I+1, B( I, N-L+I ), LDB, A( K+I, N-L+I ),
     $                     LDA )
            END IF
*
         ELSE
            ALPHA( K+I ) = ZERO
            BETA( K+I ) = ONE
            CALL ZCOPY( L-I+1, B( I, N-L+I ), LDB, A( K+I, N-L+I ),
     $                  LDA )
         END IF
   70 CONTINUE
*
*     Post-assignment
*
      DO 80 I = M + 1, K + L
         ALPHA( I ) = ZERO
         BETA( I ) = ONE
   80 CONTINUE
*
      IF( K+L.LT.N ) THEN
         DO 90 I = K + L + 1, N
            ALPHA( I ) = ZERO
            BETA( I ) = ZERO
   90    CONTINUE
      END IF
*
  100 CONTINUE
      NCYCLE = KCYCLE
*
      RETURN
*
*     End of ZTGSJA
*
      END
* DECK ztpcon.f
      SUBROUTINE ZTPCON( NORM, UPLO, DIAG, N, AP, RCOND, WORK, RWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            INFO, N
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         AP( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTPCON estimates the reciprocal of the condition number of a packed
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangular matrix A, packed columnwise in
*          a linear array.  The j-th column of A is stored in the array
*          AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, ONENRM, UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      DOUBLE PRECISION   AINVNM, ANORM, SCALE, SMLNUM, XNORM
      COMPLEX*16         ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH, ZLANTP
      EXTERNAL           LSAME, IZAMAX, DLAMCH, ZLANTP
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDRSCL, ZLACON, ZLATPS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTPCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      END IF
*
      RCOND = ZERO
      SMLNUM = DLAMCH( 'Safe minimum' )*DBLE( MAX( 1, N ) )
*
*     Compute the norm of the triangular matrix A.
*
      ANORM = ZLANTP( NORM, UPLO, DIAG, N, AP, RWORK )
*
*     Continue only if ANORM > 0.
*
      IF( ANORM.GT.ZERO ) THEN
*
*        Estimate the norm of the inverse of A.
*
         AINVNM = ZERO
         NORMIN = 'N'
         IF( ONENRM ) THEN
            KASE1 = 1
         ELSE
            KASE1 = 2
         END IF
         KASE = 0
   10    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.KASE1 ) THEN
*
*              Multiply by inv(A).
*
               CALL ZLATPS( UPLO, 'No transpose', DIAG, NORMIN, N, AP,
     $                      WORK, SCALE, RWORK, INFO )
            ELSE
*
*              Multiply by inv(A').
*
               CALL ZLATPS( UPLO, 'Conjugate transpose', DIAG, NORMIN,
     $                      N, AP, WORK, SCALE, RWORK, INFO )
            END IF
            NORMIN = 'Y'
*
*           Multiply by 1/SCALE if doing so will not cause overflow.
*
            IF( SCALE.NE.ONE ) THEN
               IX = IZAMAX( N, WORK, 1 )
               XNORM = CABS1( WORK( IX ) )
               IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $            GO TO 20
               CALL ZDRSCL( N, SCALE, WORK, 1 )
            END IF
            GO TO 10
         END IF
*
*        Compute the estimate of the reciprocal condition number.
*
         IF( AINVNM.NE.ZERO )
     $      RCOND = ( ONE / ANORM ) / AINVNM
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of ZTPCON
*
      END
* DECK ztprfs.f
      SUBROUTINE ZTPRFS( UPLO, TRANS, DIAG, N, NRHS, AP, B, LDB, X, LDX,
     $                   FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         AP( * ), B( LDB, * ), WORK( * ), X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTPRFS provides error bounds and backward error estimates for the
*  solution to a system of linear equations with a triangular packed
*  coefficient matrix.
*
*  The solution matrix X must be computed by ZTPTRS or some other
*  means before entering this routine.  ZTPRFS does not do iterative
*  refinement because doing so cannot improve the backward error.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangular matrix A, packed columnwise in
*          a linear array.  The j-th column of A is stored in the array
*          AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2n-j)/2) = A(i,j) for j<=i<=n.
*          If DIAG = 'U', the diagonal elements of A are not referenced
*          and are assumed to be 1.
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input) COMPLEX*16 array, dimension (LDX,NRHS)
*          The solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN, NOUNIT, UPPER
      CHARACTER          TRANSN, TRANST
      INTEGER            I, J, K, KASE, KC, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
      COMPLEX*16         ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZLACON, ZTPMV, ZTPSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOTRAN = LSAME( TRANS, 'N' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTPRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANSN = 'N'
         TRANST = 'C'
      ELSE
         TRANSN = 'C'
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 250 J = 1, NRHS
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL ZCOPY( N, X( 1, J ), 1, WORK, 1 )
         CALL ZTPMV( UPLO, TRANS, DIAG, N, AP, WORK, 1 )
         CALL ZAXPY( N, -ONE, B( 1, J ), 1, WORK, 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 20 I = 1, N
            RWORK( I ) = CABS1( B( I, J ) )
   20    CONTINUE
*
         IF( NOTRAN ) THEN
*
*           Compute abs(A)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               KC = 1
               IF( NOUNIT ) THEN
                  DO 40 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 30 I = 1, K
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AP( KC+I-1 ) )*XK
   30                CONTINUE
                     KC = KC + K
   40             CONTINUE
               ELSE
                  DO 60 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 50 I = 1, K - 1
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AP( KC+I-1 ) )*XK
   50                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
                     KC = KC + K
   60             CONTINUE
               END IF
            ELSE
               KC = 1
               IF( NOUNIT ) THEN
                  DO 80 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 70 I = K, N
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AP( KC+I-K ) )*XK
   70                CONTINUE
                     KC = KC + N - K + 1
   80             CONTINUE
               ELSE
                  DO 100 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 90 I = K + 1, N
                        RWORK( I ) = RWORK( I ) +
     $                               CABS1( AP( KC+I-K ) )*XK
   90                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
                     KC = KC + N - K + 1
  100             CONTINUE
               END IF
            END IF
         ELSE
*
*           Compute abs(A**H)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               KC = 1
               IF( NOUNIT ) THEN
                  DO 120 K = 1, N
                     S = ZERO
                     DO 110 I = 1, K
                        S = S + CABS1( AP( KC+I-1 ) )*CABS1( X( I, J ) )
  110                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
                     KC = KC + K
  120             CONTINUE
               ELSE
                  DO 140 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 130 I = 1, K - 1
                        S = S + CABS1( AP( KC+I-1 ) )*CABS1( X( I, J ) )
  130                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
                     KC = KC + K
  140             CONTINUE
               END IF
            ELSE
               KC = 1
               IF( NOUNIT ) THEN
                  DO 160 K = 1, N
                     S = ZERO
                     DO 150 I = K, N
                        S = S + CABS1( AP( KC+I-K ) )*CABS1( X( I, J ) )
  150                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
                     KC = KC + N - K + 1
  160             CONTINUE
               ELSE
                  DO 180 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 170 I = K + 1, N
                        S = S + CABS1( AP( KC+I-K ) )*CABS1( X( I, J ) )
  170                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
                     KC = KC + N - K + 1
  180             CONTINUE
               END IF
            END IF
         END IF
         S = ZERO
         DO 190 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
  190    CONTINUE
         BERR( J ) = S
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use ZLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 200 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
  200    CONTINUE
*
         KASE = 0
  210    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**H).
*
               CALL ZTPSV( UPLO, TRANST, DIAG, N, AP, WORK, 1 )
               DO 220 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  220          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 230 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  230          CONTINUE
               CALL ZTPSV( UPLO, TRANSN, DIAG, N, AP, WORK, 1 )
            END IF
            GO TO 210
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 240 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  240    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  250 CONTINUE
*
      RETURN
*
*     End of ZTPRFS
*
      END
* DECK ztptri.f
      SUBROUTINE ZTPTRI( UPLO, DIAG, N, AP, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTPTRI computes the inverse of a complex upper or lower triangular
*  matrix A stored in packed format.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  AP      (input/output) COMPLEX*16 array, dimension (N*(N+1)/2)
*          On entry, the upper or lower triangular matrix A, stored
*          columnwise in a linear array.  The j-th column of A is stored
*          in the array AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*((2*n-j)/2) = A(i,j) for j<=i<=n.
*          See below for further details.
*          On exit, the (triangular) inverse of the original matrix, in
*          the same packed storage format.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, A(i,i) is exactly zero.  The triangular
*                matrix is singular and its inverse can not be computed.
*
*  Further Details
*  ===============
*
*  A triangular matrix A can be transferred to packed storage using one
*  of the following program segments:
*
*  UPLO = 'U':                      UPLO = 'L':
*
*        JC = 1                           JC = 1
*        DO 2 J = 1, N                    DO 2 J = 1, N
*           DO 1 I = 1, J                    DO 1 I = J, N
*              AP(JC+I-1) = A(I,J)              AP(JC+I-J) = A(I,J)
*      1    CONTINUE                    1    CONTINUE
*           JC = JC + J                      JC = JC + N - J + 1
*      2 CONTINUE                       2 CONTINUE
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JC, JCLAST, JJ
      COMPLEX*16         AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZSCAL, ZTPMV
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTPTRI', -INFO )
         RETURN
      END IF
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            JJ = 0
            DO 10 INFO = 1, N
               JJ = JJ + INFO
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
   10       CONTINUE
         ELSE
            JJ = 1
            DO 20 INFO = 1, N
               IF( AP( JJ ).EQ.ZERO )
     $            RETURN
               JJ = JJ + N - INFO + 1
   20       CONTINUE
         END IF
         INFO = 0
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         JC = 1
         DO 30 J = 1, N
            IF( NOUNIT ) THEN
               AP( JC+J-1 ) = ONE / AP( JC+J-1 )
               AJJ = -AP( JC+J-1 )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL ZTPMV( 'Upper', 'No transpose', DIAG, J-1, AP,
     $                  AP( JC ), 1 )
            CALL ZSCAL( J-1, AJJ, AP( JC ), 1 )
            JC = JC + J
   30    CONTINUE
*
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         JC = N*( N+1 ) / 2
         DO 40 J = N, 1, -1
            IF( NOUNIT ) THEN
               AP( JC ) = ONE / AP( JC )
               AJJ = -AP( JC )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL ZTPMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     AP( JCLAST ), AP( JC+1 ), 1 )
               CALL ZSCAL( N-J, AJJ, AP( JC+1 ), 1 )
            END IF
            JCLAST = JC
            JC = JC - N + J - 2
   40    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTPTRI
*
      END
* DECK ztptrs.f
      SUBROUTINE ZTPTRS( UPLO, TRANS, DIAG, N, NRHS, AP, B, LDB, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         AP( * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTPTRS solves a triangular system of the form
*
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*
*  where A is a triangular matrix of order N stored in packed format,
*  and B is an N-by-NRHS matrix.  A check is made to verify that A is
*  nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  AP      (input) COMPLEX*16 array, dimension (N*(N+1)/2)
*          The upper or lower triangular matrix A, packed columnwise in
*          a linear array.  The j-th column of A is stored in the array
*          AP as follows:
*          if UPLO = 'U', AP(i + (j-1)*j/2) = A(i,j) for 1<=i<=j;
*          if UPLO = 'L', AP(i + (j-1)*(2*n-j)/2) = A(i,j) for j<=i<=n.
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, the i-th diagonal element of A is zero,
*                indicating that the matrix is singular and the
*                solutions X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JC
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTPSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTPTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         IF( UPPER ) THEN
            JC = 1
            DO 10 INFO = 1, N
               IF( AP( JC+INFO-1 ).EQ.ZERO )
     $            RETURN
               JC = JC + INFO
   10       CONTINUE
         ELSE
            JC = 1
            DO 20 INFO = 1, N
               IF( AP( JC ).EQ.ZERO )
     $            RETURN
               JC = JC + N - INFO + 1
   20       CONTINUE
         END IF
      END IF
      INFO = 0
*
*     Solve  A * x = b,  A**T * x = b,  or  A**H * x = b.
*
      DO 30 J = 1, NRHS
         CALL ZTPSV( UPLO, TRANS, DIAG, N, AP, B( 1, J ), 1 )
   30 CONTINUE
*
      RETURN
*
*     End of ZTPTRS
*
      END
* DECK ztrcon.f
      SUBROUTINE ZTRCON( NORM, UPLO, DIAG, N, A, LDA, RCOND, WORK,
     $                   RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, NORM, UPLO
      INTEGER            INFO, LDA, N
      DOUBLE PRECISION   RCOND
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         A( LDA, * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRCON estimates the reciprocal of the condition number of a
*  triangular matrix A, in either the 1-norm or the infinity-norm.
*
*  The norm of A is computed and an estimate is obtained for
*  norm(inv(A)), then the reciprocal of the condition number is
*  computed as
*     RCOND = 1 / ( norm(A) * norm(inv(A)) ).
*
*  Arguments
*  =========
*
*  NORM    (input) CHARACTER*1
*          Specifies whether the 1-norm condition number or the
*          infinity-norm condition number is required:
*          = '1' or 'O':  1-norm;
*          = 'I':         Infinity-norm.
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The triangular matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of the array A contains the upper
*          triangular matrix, and the strictly lower triangular part of
*          A is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of the array A contains the lower triangular
*          matrix, and the strictly upper triangular part of A is not
*          referenced.  If DIAG = 'U', the diagonal elements of A are
*          also not referenced and are assumed to be 1.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  RCOND   (output) DOUBLE PRECISION
*          The reciprocal of the condition number of the matrix A,
*          computed as RCOND = 1/(norm(A) * norm(inv(A))).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, ONENRM, UPPER
      CHARACTER          NORMIN
      INTEGER            IX, KASE, KASE1
      DOUBLE PRECISION   AINVNM, ANORM, SCALE, SMLNUM, XNORM
      COMPLEX*16         ZDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH, ZLANTR
      EXTERNAL           LSAME, IZAMAX, DLAMCH, ZLANTR
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZDRSCL, ZLACON, ZLATRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      ONENRM = NORM.EQ.'1' .OR. LSAME( NORM, 'O' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.ONENRM .AND. .NOT.LSAME( NORM, 'I' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -6
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRCON', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         RCOND = ONE
         RETURN
      END IF
*
      RCOND = ZERO
      SMLNUM = DLAMCH( 'Safe minimum' )*DBLE( MAX( 1, N ) )
*
*     Compute the norm of the triangular matrix A.
*
      ANORM = ZLANTR( NORM, UPLO, DIAG, N, N, A, LDA, RWORK )
*
*     Continue only if ANORM > 0.
*
      IF( ANORM.GT.ZERO ) THEN
*
*        Estimate the norm of the inverse of A.
*
         AINVNM = ZERO
         NORMIN = 'N'
         IF( ONENRM ) THEN
            KASE1 = 1
         ELSE
            KASE1 = 2
         END IF
         KASE = 0
   10    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, AINVNM, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.KASE1 ) THEN
*
*              Multiply by inv(A).
*
               CALL ZLATRS( UPLO, 'No transpose', DIAG, NORMIN, N, A,
     $                      LDA, WORK, SCALE, RWORK, INFO )
            ELSE
*
*              Multiply by inv(A').
*
               CALL ZLATRS( UPLO, 'Conjugate transpose', DIAG, NORMIN,
     $                      N, A, LDA, WORK, SCALE, RWORK, INFO )
            END IF
            NORMIN = 'Y'
*
*           Multiply by 1/SCALE if doing so will not cause overflow.
*
            IF( SCALE.NE.ONE ) THEN
               IX = IZAMAX( N, WORK, 1 )
               XNORM = CABS1( WORK( IX ) )
               IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $            GO TO 20
               CALL ZDRSCL( N, SCALE, WORK, 1 )
            END IF
            GO TO 10
         END IF
*
*        Compute the estimate of the reciprocal condition number.
*
         IF( AINVNM.NE.ZERO )
     $      RCOND = ( ONE / ANORM ) / AINVNM
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of ZTRCON
*
      END
* DECK ztrevc.f
      SUBROUTINE ZTREVC( SIDE, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, MM, M, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, SIDE
      INTEGER            INFO, LDT, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   RWORK( * )
      COMPLEX*16         T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTREVC computes some or all of the right and/or left eigenvectors of
*  a complex upper triangular matrix T.
*
*  The right eigenvector x and the left eigenvector y of T corresponding
*  to an eigenvalue w are defined by:
*
*               T*x = w*x,     y'*T = w*y'
*
*  where y' denotes the conjugate transpose of the vector y.
*
*  If all eigenvectors are requested, the routine may either return the
*  matrices X and/or Y of right or left eigenvectors of T, or the
*  products Q*X and/or Q*Y, where Q is an input unitary
*  matrix. If T was obtained from the Schur factorization of an
*  original matrix A = Q*T*Q', then Q*X and Q*Y are the matrices of
*  right or left eigenvectors of A.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R':  compute right eigenvectors only;
*          = 'L':  compute left eigenvectors only;
*          = 'B':  compute both right and left eigenvectors.
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A':  compute all right and/or left eigenvectors;
*          = 'B':  compute all right and/or left eigenvectors,
*                  and backtransform them using the input matrices
*                  supplied in VR and/or VL;
*          = 'S':  compute selected right and/or left eigenvectors,
*                  specified by the logical array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenvectors to be
*          computed.
*          If HOWMNY = 'A' or 'B', SELECT is not referenced.
*          To select the eigenvector corresponding to the j-th
*          eigenvalue, SELECT(j) must be set to .TRUE..
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) COMPLEX*16 array, dimension (LDT,N)
*          The upper triangular matrix T.  T is modified, but restored
*          on exit.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input/output) COMPLEX*16 array, dimension (LDVL,MM)
*          On entry, if SIDE = 'L' or 'B' and HOWMNY = 'B', VL must
*          contain an N-by-N matrix Q (usually the unitary matrix Q of
*          Schur vectors returned by ZHSEQR).
*          On exit, if SIDE = 'L' or 'B', VL contains:
*          if HOWMNY = 'A', the matrix Y of left eigenvectors of T;
*          if HOWMNY = 'B', the matrix Q*Y;
*          if HOWMNY = 'S', the left eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VL, in the same order as their
*                           eigenvalues.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.  LDVL >= max(1,N) if
*          SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) COMPLEX*16 array, dimension (LDVR,MM)
*          On entry, if SIDE = 'R' or 'B' and HOWMNY = 'B', VR must
*          contain an N-by-N matrix Q (usually the unitary matrix Q of
*          Schur vectors returned by ZHSEQR).
*          On exit, if SIDE = 'R' or 'B', VR contains:
*          if HOWMNY = 'A', the matrix X of right eigenvectors of T;
*          if HOWMNY = 'B', the matrix Q*X;
*          if HOWMNY = 'S', the right eigenvectors of T specified by
*                           SELECT, stored consecutively in the columns
*                           of VR, in the same order as their
*                           eigenvalues.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.  LDVR >= max(1,N) if
*           SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR actually
*          used to store the eigenvectors.  If HOWMNY = 'A' or 'B', M
*          is set to N.  Each selected eigenvector occupies one
*          column.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The algorithm used in this program is basically backward (forward)
*  substitution, with scaling to make the the code robust against
*  possible overflow.
*
*  Each eigenvector is normalized so that the element of largest
*  magnitude has magnitude 1; here the magnitude of a complex number
*  (x,y) is taken to be |x| + |y|.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CMZERO, CMONE
      PARAMETER          ( CMZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CMONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            ALLV, BOTHV, LEFTV, OVER, RIGHTV, SOMEV
      INTEGER            I, II, IS, J, K, KI
      DOUBLE PRECISION   OVFL, REMAX, SCALE, SMIN, SMLNUM, ULP, UNFL
      COMPLEX*16         CDUM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH, DZASUM
      EXTERNAL           LSAME, IZAMAX, DLAMCH, DZASUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, XERBLA, ZCOPY, ZDSCAL, ZGEMV, ZLATRS
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( DBLE( CDUM ) ) + ABS( DIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      ALLV = LSAME( HOWMNY, 'A' )
      OVER = LSAME( HOWMNY, 'B' ) .OR. LSAME( HOWMNY, 'O' )
      SOMEV = LSAME( HOWMNY, 'S' )
*
*     Set M to the number of columns required to store the selected
*     eigenvectors.
*
      IF( SOMEV ) THEN
         M = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         M = M + 1
   10    CONTINUE
      ELSE
         M = N
      END IF
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.ALLV .AND. .NOT.OVER .AND. .NOT.SOMEV ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE IF( MM.LT.M ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTREVC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set the constants to control overflow.
*
      UNFL = DLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL DLABAD( UNFL, OVFL )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
*
*     Store the diagonal elements of T in working array WORK.
*
      DO 20 I = 1, N
         WORK( I+N ) = T( I, I )
   20 CONTINUE
*
*     Compute 1-norm of each column of strictly upper triangular
*     part of T to control overflow in triangular solver.
*
      RWORK( 1 ) = ZERO
      DO 30 J = 2, N
         RWORK( J ) = DZASUM( J-1, T( 1, J ), 1 )
   30 CONTINUE
*
      IF( RIGHTV ) THEN
*
*        Compute right eigenvectors.
*
         IS = M
         DO 80 KI = N, 1, -1
*
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 80
            END IF
            SMIN = MAX( ULP*( CABS1( T( KI, KI ) ) ), SMLNUM )
*
            WORK( 1 ) = CMONE
*
*           Form right-hand side.
*
            DO 40 K = 1, KI - 1
               WORK( K ) = -T( K, KI )
   40       CONTINUE
*
*           Solve the triangular system:
*              (T(1:KI-1,1:KI-1) - T(KI,KI))*X = SCALE*WORK.
*
            DO 50 K = 1, KI - 1
               T( K, K ) = T( K, K ) - T( KI, KI )
               IF( CABS1( T( K, K ) ).LT.SMIN )
     $            T( K, K ) = SMIN
   50       CONTINUE
*
            IF( KI.GT.1 ) THEN
               CALL ZLATRS( 'Upper', 'No transpose', 'Non-unit', 'Y',
     $                      KI-1, T, LDT, WORK( 1 ), SCALE, RWORK,
     $                      INFO )
               WORK( KI ) = SCALE
            END IF
*
*           Copy the vector x or Q*x to VR and normalize.
*
            IF( .NOT.OVER ) THEN
               CALL ZCOPY( KI, WORK( 1 ), 1, VR( 1, IS ), 1 )
*
               II = IZAMAX( KI, VR( 1, IS ), 1 )
               REMAX = ONE / CABS1( VR( II, IS ) )
               CALL ZDSCAL( KI, REMAX, VR( 1, IS ), 1 )
*
               DO 60 K = KI + 1, N
                  VR( K, IS ) = CMZERO
   60          CONTINUE
            ELSE
               IF( KI.GT.1 )
     $            CALL ZGEMV( 'N', N, KI-1, CMONE, VR, LDVR, WORK( 1 ),
     $                        1, DCMPLX( SCALE ), VR( 1, KI ), 1 )
*
               II = IZAMAX( N, VR( 1, KI ), 1 )
               REMAX = ONE / CABS1( VR( II, KI ) )
               CALL ZDSCAL( N, REMAX, VR( 1, KI ), 1 )
            END IF
*
*           Set back the original diagonal elements of T.
*
            DO 70 K = 1, KI - 1
               T( K, K ) = WORK( K+N )
   70       CONTINUE
*
            IS = IS - 1
   80    CONTINUE
      END IF
*
      IF( LEFTV ) THEN
*
*        Compute left eigenvectors.
*
         IS = 1
         DO 130 KI = 1, N
*
            IF( SOMEV ) THEN
               IF( .NOT.SELECT( KI ) )
     $            GO TO 130
            END IF
            SMIN = MAX( ULP*( CABS1( T( KI, KI ) ) ), SMLNUM )
*
            WORK( N ) = CMONE
*
*           Form right-hand side.
*
            DO 90 K = KI + 1, N
               WORK( K ) = -DCONJG( T( KI, K ) )
   90       CONTINUE
*
*           Solve the triangular system:
*              (T(KI+1:N,KI+1:N) - T(KI,KI))'*X = SCALE*WORK.
*
            DO 100 K = KI + 1, N
               T( K, K ) = T( K, K ) - T( KI, KI )
               IF( CABS1( T( K, K ) ).LT.SMIN )
     $            T( K, K ) = SMIN
  100       CONTINUE
*
            IF( KI.LT.N ) THEN
               CALL ZLATRS( 'Upper', 'Conjugate transpose', 'Non-unit',
     $                      'Y', N-KI, T( KI+1, KI+1 ), LDT,
     $                      WORK( KI+1 ), SCALE, RWORK, INFO )
               WORK( KI ) = SCALE
            END IF
*
*           Copy the vector x or Q*x to VL and normalize.
*
            IF( .NOT.OVER ) THEN
               CALL ZCOPY( N-KI+1, WORK( KI ), 1, VL( KI, IS ), 1 )
*
               II = IZAMAX( N-KI+1, VL( KI, IS ), 1 ) + KI - 1
               REMAX = ONE / CABS1( VL( II, IS ) )
               CALL ZDSCAL( N-KI+1, REMAX, VL( KI, IS ), 1 )
*
               DO 110 K = 1, KI - 1
                  VL( K, IS ) = CMZERO
  110          CONTINUE
            ELSE
               IF( KI.LT.N )
     $            CALL ZGEMV( 'N', N, N-KI, CMONE, VL( 1, KI+1 ), LDVL,
     $                        WORK( KI+1 ), 1, DCMPLX( SCALE ),
     $                        VL( 1, KI ), 1 )
*
               II = IZAMAX( N, VL( 1, KI ), 1 )
               REMAX = ONE / CABS1( VL( II, KI ) )
               CALL ZDSCAL( N, REMAX, VL( 1, KI ), 1 )
            END IF
*
*           Set back the original diagonal elements of T.
*
            DO 120 K = KI + 1, N
               T( K, K ) = WORK( K+N )
  120       CONTINUE
*
            IS = IS + 1
  130    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTREVC
*
      END
* DECK ztrexc.f
      SUBROUTINE ZTREXC( COMPQ, N, T, LDT, Q, LDQ, IFST, ILST, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ
      INTEGER            IFST, ILST, INFO, LDQ, LDT, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         Q( LDQ, * ), T( LDT, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTREXC reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that the diagonal element of T with row index IFST
*  is moved to row ILST.
*
*  The Schur form T is reordered by a unitary similarity transformation
*  Z**H*T*Z, and optionally the matrix Q of Schur vectors is updated by
*  postmultplying it with Z.
*
*  Arguments
*  =========
*
*  COMPQ   (input) CHARACTER*1
*          = 'V':  update the matrix Q of Schur vectors;
*          = 'N':  do not update Q.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) COMPLEX*16 array, dimension (LDT,N)
*          On entry, the upper triangular matrix T.
*          On exit, the reordered upper triangular matrix.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) COMPLEX*16 array, dimension (LDQ,N)
*          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*          unitary transformation matrix Z which reorders T.
*          If COMPQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= max(1,N).
*
*  IFST    (input) INTEGER
*  ILST    (input) INTEGER
*          Specify the reordering of the diagonal elements of T:
*          The element with row index IFST is moved to row ILST by a
*          sequence of transpositions between adjacent elements.
*          1 <= IFST <= N; 1 <= ILST <= N.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            WANTQ
      INTEGER            K, M1, M2, M3
      DOUBLE PRECISION   CS
      COMPLEX*16         SN, T11, T22, TEMP
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLARTG, ZROT
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      INFO = 0
      WANTQ = LSAME( COMPQ, 'V' )
      IF( .NOT.LSAME( COMPQ, 'N' ) .AND. .NOT.WANTQ ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.MAX( 1, N ) ) ) THEN
         INFO = -6
      ELSE IF( IFST.LT.1 .OR. IFST.GT.N ) THEN
         INFO = -7
      ELSE IF( ILST.LT.1 .OR. ILST.GT.N ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTREXC', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.1 .OR. IFST.EQ.ILST )
     $   RETURN
*
      IF( IFST.LT.ILST ) THEN
*
*        Move the IFST-th diagonal element forward down the diagonal.
*
         M1 = 0
         M2 = -1
         M3 = 1
      ELSE
*
*        Move the IFST-th diagonal element backward up the diagonal.
*
         M1 = -1
         M2 = 0
         M3 = -1
      END IF
*
      DO 10 K = IFST + M1, ILST + M2, M3
*
*        Interchange the k-th and (k+1)-th diagonal elements.
*
         T11 = T( K, K )
         T22 = T( K+1, K+1 )
*
*        Determine the transformation to perform the interchange.
*
         CALL ZLARTG( T( K, K+1 ), T22-T11, CS, SN, TEMP )
*
*        Apply transformation to the matrix T.
*
         IF( K+2.LE.N )
     $      CALL ZROT( N-K-1, T( K, K+2 ), LDT, T( K+1, K+2 ), LDT, CS,
     $                 SN )
         CALL ZROT( K-1, T( 1, K ), 1, T( 1, K+1 ), 1, CS,
     $              DCONJG( SN ) )
*
         T( K, K ) = T22
         T( K+1, K+1 ) = T11
*
         IF( WANTQ ) THEN
*
*           Accumulate transformation in the matrix Q.
*
            CALL ZROT( N, Q( 1, K ), 1, Q( 1, K+1 ), 1, CS,
     $                 DCONJG( SN ) )
         END IF
*
   10 CONTINUE
*
      RETURN
*
*     End of ZTREXC
*
      END
* DECK ztrrfs.f
      SUBROUTINE ZTRRFS( UPLO, TRANS, DIAG, N, NRHS, A, LDA, B, LDB, X,
     $                   LDX, FERR, BERR, WORK, RWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDA, LDB, LDX, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   BERR( * ), FERR( * ), RWORK( * )
      COMPLEX*16         A( LDA, * ), B( LDB, * ), WORK( * ),
     $                   X( LDX, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRRFS provides error bounds and backward error estimates for the
*  solution to a system of linear equations with a triangular
*  coefficient matrix.
*
*  The solution matrix X must be computed by ZTRTRS or some other
*  means before entering this routine.  ZTRRFS does not do iterative
*  refinement because doing so cannot improve the backward error.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrices B and X.  NRHS >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The triangular matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of the array A contains the upper
*          triangular matrix, and the strictly lower triangular part of
*          A is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of the array A contains the lower triangular
*          matrix, and the strictly upper triangular part of A is not
*          referenced.  If DIAG = 'U', the diagonal elements of A are
*          also not referenced and are assumed to be 1.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input) COMPLEX*16 array, dimension (LDB,NRHS)
*          The right hand side matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  X       (input) COMPLEX*16 array, dimension (LDX,NRHS)
*          The solution matrix X.
*
*  LDX     (input) INTEGER
*          The leading dimension of the array X.  LDX >= max(1,N).
*
*  FERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The estimated forward error bound for each solution vector
*          X(j) (the j-th column of the solution matrix X).
*          If XTRUE is the true solution corresponding to X(j), FERR(j)
*          is an estimated upper bound for the magnitude of the largest
*          element in (X(j) - XTRUE) divided by the magnitude of the
*          largest element in X(j).  The estimate is as reliable as
*          the estimate for RCOND, and is almost always a slight
*          overestimate of the true error.
*
*  BERR    (output) DOUBLE PRECISION array, dimension (NRHS)
*          The componentwise relative backward error of each solution
*          vector X(j) (i.e., the smallest relative change in
*          any element of A or B that makes X(j) an exact solution).
*
*  WORK    (workspace) COMPLEX*16 array, dimension (2*N)
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN, NOUNIT, UPPER
      CHARACTER          TRANSN, TRANST
      INTEGER            I, J, K, KASE, NZ
      DOUBLE PRECISION   EPS, LSTRES, S, SAFE1, SAFE2, SAFMIN, XK
      COMPLEX*16         ZDUM
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZLACON, ZTRMV, ZTRSV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH
      EXTERNAL           LSAME, DLAMCH
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( ZDUM ) = ABS( DBLE( ZDUM ) ) + ABS( DIMAG( ZDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOTRAN = LSAME( TRANS, 'N' )
      NOUNIT = LSAME( DIAG, 'N' )
*
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $         LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDX.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRRFS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 ) THEN
         DO 10 J = 1, NRHS
            FERR( J ) = ZERO
            BERR( J ) = ZERO
   10    CONTINUE
         RETURN
      END IF
*
      IF( NOTRAN ) THEN
         TRANSN = 'N'
         TRANST = 'C'
      ELSE
         TRANSN = 'C'
         TRANST = 'N'
      END IF
*
*     NZ = maximum number of nonzero elements in each row of A, plus 1
*
      NZ = N + 1
      EPS = DLAMCH( 'Epsilon' )
      SAFMIN = DLAMCH( 'Safe minimum' )
      SAFE1 = NZ*SAFMIN
      SAFE2 = SAFE1 / EPS
*
*     Do for each right hand side
*
      DO 250 J = 1, NRHS
*
*        Compute residual R = B - op(A) * X,
*        where op(A) = A, A**T, or A**H, depending on TRANS.
*
         CALL ZCOPY( N, X( 1, J ), 1, WORK, 1 )
         CALL ZTRMV( UPLO, TRANS, DIAG, N, A, LDA, WORK, 1 )
         CALL ZAXPY( N, -ONE, B( 1, J ), 1, WORK, 1 )
*
*        Compute componentwise relative backward error from formula
*
*        max(i) ( abs(R(i)) / ( abs(op(A))*abs(X) + abs(B) )(i) )
*
*        where abs(Z) is the componentwise absolute value of the matrix
*        or vector Z.  If the i-th component of the denominator is less
*        than SAFE2, then SAFE1 is added to the i-th components of the
*        numerator and denominator before dividing.
*
         DO 20 I = 1, N
            RWORK( I ) = CABS1( B( I, J ) )
   20    CONTINUE
*
         IF( NOTRAN ) THEN
*
*           Compute abs(A)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               IF( NOUNIT ) THEN
                  DO 40 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 30 I = 1, K
                        RWORK( I ) = RWORK( I ) + CABS1( A( I, K ) )*XK
   30                CONTINUE
   40             CONTINUE
               ELSE
                  DO 60 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 50 I = 1, K - 1
                        RWORK( I ) = RWORK( I ) + CABS1( A( I, K ) )*XK
   50                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
   60             CONTINUE
               END IF
            ELSE
               IF( NOUNIT ) THEN
                  DO 80 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 70 I = K, N
                        RWORK( I ) = RWORK( I ) + CABS1( A( I, K ) )*XK
   70                CONTINUE
   80             CONTINUE
               ELSE
                  DO 100 K = 1, N
                     XK = CABS1( X( K, J ) )
                     DO 90 I = K + 1, N
                        RWORK( I ) = RWORK( I ) + CABS1( A( I, K ) )*XK
   90                CONTINUE
                     RWORK( K ) = RWORK( K ) + XK
  100             CONTINUE
               END IF
            END IF
         ELSE
*
*           Compute abs(A**H)*abs(X) + abs(B).
*
            IF( UPPER ) THEN
               IF( NOUNIT ) THEN
                  DO 120 K = 1, N
                     S = ZERO
                     DO 110 I = 1, K
                        S = S + CABS1( A( I, K ) )*CABS1( X( I, J ) )
  110                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  120             CONTINUE
               ELSE
                  DO 140 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 130 I = 1, K - 1
                        S = S + CABS1( A( I, K ) )*CABS1( X( I, J ) )
  130                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  140             CONTINUE
               END IF
            ELSE
               IF( NOUNIT ) THEN
                  DO 160 K = 1, N
                     S = ZERO
                     DO 150 I = K, N
                        S = S + CABS1( A( I, K ) )*CABS1( X( I, J ) )
  150                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  160             CONTINUE
               ELSE
                  DO 180 K = 1, N
                     S = CABS1( X( K, J ) )
                     DO 170 I = K + 1, N
                        S = S + CABS1( A( I, K ) )*CABS1( X( I, J ) )
  170                CONTINUE
                     RWORK( K ) = RWORK( K ) + S
  180             CONTINUE
               END IF
            END IF
         END IF
         S = ZERO
         DO 190 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               S = MAX( S, CABS1( WORK( I ) ) / RWORK( I ) )
            ELSE
               S = MAX( S, ( CABS1( WORK( I ) )+SAFE1 ) /
     $             ( RWORK( I )+SAFE1 ) )
            END IF
  190    CONTINUE
         BERR( J ) = S
*
*        Bound error from formula
*
*        norm(X - XTRUE) / norm(X) .le. FERR =
*        norm( abs(inv(op(A)))*
*           ( abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) ))) / norm(X)
*
*        where
*          norm(Z) is the magnitude of the largest component of Z
*          inv(op(A)) is the inverse of op(A)
*          abs(Z) is the componentwise absolute value of the matrix or
*             vector Z
*          NZ is the maximum number of nonzeros in any row of A, plus 1
*          EPS is machine epsilon
*
*        The i-th component of abs(R)+NZ*EPS*(abs(op(A))*abs(X)+abs(B))
*        is incremented by SAFE1 if the i-th component of
*        abs(op(A))*abs(X) + abs(B) is less than SAFE2.
*
*        Use ZLACON to estimate the infinity-norm of the matrix
*           inv(op(A)) * diag(W),
*        where W = abs(R) + NZ*EPS*( abs(op(A))*abs(X)+abs(B) )))
*
         DO 200 I = 1, N
            IF( RWORK( I ).GT.SAFE2 ) THEN
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I )
            ELSE
               RWORK( I ) = CABS1( WORK( I ) ) + NZ*EPS*RWORK( I ) +
     $                      SAFE1
            END IF
  200    CONTINUE
*
         KASE = 0
  210    CONTINUE
         CALL ZLACON( N, WORK( N+1 ), WORK, FERR( J ), KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Multiply by diag(W)*inv(op(A)**H).
*
               CALL ZTRSV( UPLO, TRANST, DIAG, N, A, LDA, WORK, 1 )
               DO 220 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  220          CONTINUE
            ELSE
*
*              Multiply by inv(op(A))*diag(W).
*
               DO 230 I = 1, N
                  WORK( I ) = RWORK( I )*WORK( I )
  230          CONTINUE
               CALL ZTRSV( UPLO, TRANSN, DIAG, N, A, LDA, WORK, 1 )
            END IF
            GO TO 210
         END IF
*
*        Normalize error.
*
         LSTRES = ZERO
         DO 240 I = 1, N
            LSTRES = MAX( LSTRES, CABS1( X( I, J ) ) )
  240    CONTINUE
         IF( LSTRES.NE.ZERO )
     $      FERR( J ) = FERR( J ) / LSTRES
*
  250 CONTINUE
*
      RETURN
*
*     End of ZTRRFS
*
      END
* DECK ztrsen.f
      SUBROUTINE ZTRSEN( JOB, COMPQ, SELECT, N, T, LDT, Q, LDQ, W, M, S,
     $                   SEP, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, JOB
      INTEGER            INFO, LDQ, LDT, LWORK, M, N
      DOUBLE PRECISION   S, SEP
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      COMPLEX*16         Q( LDQ, * ), T( LDT, * ), W( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRSEN reorders the Schur factorization of a complex matrix
*  A = Q*T*Q**H, so that a selected cluster of eigenvalues appears in
*  the leading positions on the diagonal of the upper triangular matrix
*  T, and the leading columns of Q form an orthonormal basis of the
*  corresponding right invariant subspace.
*
*  Optionally the routine computes the reciprocal condition numbers of
*  the cluster of eigenvalues and/or the invariant subspace.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for the
*          cluster of eigenvalues (S) or the invariant subspace (SEP):
*          = 'N': none;
*          = 'E': for eigenvalues only (S);
*          = 'V': for invariant subspace only (SEP);
*          = 'B': for both eigenvalues and invariant subspace (S and
*                 SEP).
*
*  COMPQ   (input) CHARACTER*1
*          = 'V': update the matrix Q of Schur vectors;
*          = 'N': do not update Q.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          SELECT specifies the eigenvalues in the selected cluster. To
*          select the j-th eigenvalue, SELECT(j) must be set to .TRUE..
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input/output) COMPLEX*16 array, dimension (LDT,N)
*          On entry, the upper triangular matrix T.
*          On exit, T is overwritten by the reordered matrix T, with the
*          selected eigenvalues as the leading diagonal elements.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  Q       (input/output) COMPLEX*16 array, dimension (LDQ,N)
*          On entry, if COMPQ = 'V', the matrix Q of Schur vectors.
*          On exit, if COMPQ = 'V', Q has been postmultiplied by the
*          unitary transformation matrix which reorders T; the leading M
*          columns of Q form an orthonormal basis for the specified
*          invariant subspace.
*          If COMPQ = 'N', Q is not referenced.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.
*          LDQ >= 1; and if COMPQ = 'V', LDQ >= N.
*
*  W       (output) COMPLEX*16
*          The reordered eigenvalues of T, in the same order as they
*          appear on the diagonal of T.
*
*  M       (output) INTEGER
*          The dimension of the specified invariant subspace.
*          0 <= M <= N.
*
*  S       (output) DOUBLE PRECISION
*          If JOB = 'E' or 'B', S is a lower bound on the reciprocal
*          condition number for the selected cluster of eigenvalues.
*          S cannot underestimate the true reciprocal condition number
*          by more than a factor of sqrt(N). If M = 0 or N, S = 1.
*          If JOB = 'N' or 'V', S is not referenced.
*
*  SEP     (output) DOUBLE PRECISION
*          If JOB = 'V' or 'B', SEP is the estimated reciprocal
*          condition number of the specified invariant subspace. If
*          M = 0 or N, SEP = norm(T).
*          If JOB = 'N' or 'E', SEP is not referenced.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (LWORK)
*          If JOB = 'N', WORK is not referenced.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.
*          If JOB = 'N', LWORK >= 1;
*          if JOB = 'E', LWORK = M*(N-M);
*          if JOB = 'V' or 'B', LWORK >= 2*M*(N-M).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  ZTRSEN first collects the selected eigenvalues by computing a unitary
*  transformation Z to move them to the top left corner of T. In other
*  words, the selected eigenvalues are the eigenvalues of T11 in:
*
*                Z'*T*Z = ( T11 T12 ) n1
*                         (  0  T22 ) n2
*                            n1  n2
*
*  where N = n1+n2 and Z' means the conjugate transpose of Z. The first
*  n1 columns of Z span the specified invariant subspace of T.
*
*  If T has been obtained from the Schur factorization of a matrix
*  A = Q*T*Q', then the reordered Schur factorization of A is given by
*  A = (Q*Z)*(Z'*T*Z)*(Q*Z)', and the first n1 columns of Q*Z span the
*  corresponding invariant subspace of A.
*
*  The reciprocal condition number of the average of the eigenvalues of
*  T11 may be returned in S. S lies between 0 (very badly conditioned)
*  and 1 (very well conditioned). It is computed as follows. First we
*  compute R so that
*
*                         P = ( I  R ) n1
*                             ( 0  0 ) n2
*                               n1 n2
*
*  is the projector on the invariant subspace associated with T11.
*  R is the solution of the Sylvester equation:
*
*                        T11*R - R*T22 = T12.
*
*  Let F-norm(M) denote the Frobenius-norm of M and 2-norm(M) denote
*  the two-norm of M. Then S is computed as the lower bound
*
*                      (1 + F-norm(R)**2)**(-1/2)
*
*  on the reciprocal of 2-norm(P), the true reciprocal condition number.
*  S cannot underestimate 1 / 2-norm(P) by more than a factor of
*  sqrt(N).
*
*  An approximate error bound for the computed average of the
*  eigenvalues of T11 is
*
*                         EPS * norm(T) / S
*
*  where EPS is the machine precision.
*
*  The reciprocal condition number of the right invariant subspace
*  spanned by the first n1 columns of Z (or of Q*Z) is returned in SEP.
*  SEP is defined as the separation of T11 and T22:
*
*                     sep( T11, T22 ) = sigma-min( C )
*
*  where sigma-min(C) is the smallest singular value of the
*  n1*n2-by-n1*n2 matrix
*
*     C  = kprod( I(n2), T11 ) - kprod( transpose(T22), I(n1) )
*
*  I(m) is an m by m identity matrix, and kprod denotes the Kronecker
*  product. We estimate sigma-min(C) by the reciprocal of an estimate of
*  the 1-norm of inverse(C). The true reciprocal 1-norm of inverse(C)
*  cannot differ from sigma-min(C) by more than a factor of sqrt(n1*n2).
*
*  When SEP is small, small changes in T can cause large changes in
*  the invariant subspace. An approximate bound on the maximum angular
*  error in the computed right invariant subspace is
*
*                      EPS * norm(T) / SEP
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            WANTBH, WANTQ, WANTS, WANTSP
      INTEGER            IERR, K, KASE, KS, N1, N2, NN
      DOUBLE PRECISION   EST, RNORM, SCALE
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   RWORK( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   ZLANGE
      EXTERNAL           LSAME, ZLANGE
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZLACON, ZLACPY, ZTREXC, ZTRSYL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTSP = LSAME( JOB, 'V' ) .OR. WANTBH
      WANTQ = LSAME( COMPQ, 'V' )
*
*     Set M to the number of selected eigenvalues.
*
      M = 0
      DO 10 K = 1, N
         IF( SELECT( K ) )
     $      M = M + 1
   10 CONTINUE
*
      N1 = M
      N2 = N - M
      NN = N1*N2
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'N' ) .AND. .NOT.WANTS .AND. .NOT.WANTSP )
     $     THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPQ, 'N' ) .AND. .NOT.WANTQ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDQ.LT.1 .OR. ( WANTQ .AND. LDQ.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LWORK.LT.1 .OR. ( ( WANTS .AND. .NOT.WANTSP ) .AND.
     $         LWORK.LT.NN ) .OR. ( WANTSP .AND. LWORK.LT.2*NN ) ) THEN
         INFO = -14
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRSEN', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.N .OR. M.EQ.0 ) THEN
         IF( WANTS )
     $      S = ONE
         IF( WANTSP )
     $      SEP = ZLANGE( '1', N, N, T, LDT, RWORK )
         GO TO 40
      END IF
*
*     Collect the selected eigenvalues at the top left corner of T.
*
      KS = 0
      DO 20 K = 1, N
         IF( SELECT( K ) ) THEN
            KS = KS + 1
*
*           Swap the K-th eigenvalue to position KS.
*
            IF( K.NE.KS )
     $         CALL ZTREXC( COMPQ, N, T, LDT, Q, LDQ, K, KS, IERR )
         END IF
   20 CONTINUE
*
      IF( WANTS ) THEN
*
*        Solve the Sylvester equation for R:
*
*           T11*R - R*T22 = scale*T12
*
         CALL ZLACPY( 'F', N1, N2, T( 1, N1+1 ), LDT, WORK, N1 )
         CALL ZTRSYL( 'N', 'N', -1, N1, N2, T, LDT, T( N1+1, N1+1 ),
     $                LDT, WORK, N1, SCALE, IERR )
*
*        Estimate the reciprocal of the condition number of the cluster
*        of eigenvalues.
*
         RNORM = ZLANGE( 'F', N1, N2, WORK, N1, RWORK )
         IF( RNORM.EQ.ZERO ) THEN
            S = ONE
         ELSE
            S = SCALE / ( SQRT( SCALE*SCALE / RNORM+RNORM )*
     $          SQRT( RNORM ) )
         END IF
      END IF
*
      IF( WANTSP ) THEN
*
*        Estimate sep(T11,T22).
*
         EST = ZERO
         KASE = 0
   30    CONTINUE
         CALL ZLACON( NN, WORK( NN+1 ), WORK, EST, KASE )
         IF( KASE.NE.0 ) THEN
            IF( KASE.EQ.1 ) THEN
*
*              Solve T11*R - R*T22 = scale*X.
*
               CALL ZTRSYL( 'N', 'N', -1, N1, N2, T, LDT,
     $                      T( N1+1, N1+1 ), LDT, WORK, N1, SCALE,
     $                      IERR )
            ELSE
*
*              Solve T11'*R - R*T22' = scale*X.
*
               CALL ZTRSYL( 'C', 'C', -1, N1, N2, T, LDT,
     $                      T( N1+1, N1+1 ), LDT, WORK, N1, SCALE,
     $                      IERR )
            END IF
            GO TO 30
         END IF
*
         SEP = SCALE / EST
      END IF
*
   40 CONTINUE
*
*     Copy reordered eigenvalues to W.
*
      DO 50 K = 1, N
         W( K ) = T( K, K )
   50 CONTINUE
      RETURN
*
*     End of ZTRSEN
*
      END
* DECK ztrsna.f
      SUBROUTINE ZTRSNA( JOB, HOWMNY, SELECT, N, T, LDT, VL, LDVL, VR,
     $                   LDVR, S, SEP, MM, M, WORK, LDWORK, RWORK,
     $                   INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          HOWMNY, JOB
      INTEGER            INFO, LDT, LDVL, LDVR, LDWORK, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      DOUBLE PRECISION   RWORK( * ), S( * ), SEP( * )
      COMPLEX*16         T( LDT, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WORK( LDWORK, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRSNA estimates reciprocal condition numbers for specified
*  eigenvalues and/or right eigenvectors of a complex upper triangular
*  matrix T (or of any matrix Q*T*Q**H with Q unitary).
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          Specifies whether condition numbers are required for
*          eigenvalues (S) or eigenvectors (SEP):
*          = 'E': for eigenvalues only (S);
*          = 'V': for eigenvectors only (SEP);
*          = 'B': for both eigenvalues and eigenvectors (S and SEP).
*
*  HOWMNY  (input) CHARACTER*1
*          = 'A': compute condition numbers for all eigenpairs;
*          = 'S': compute condition numbers for selected eigenpairs
*                 specified by the array SELECT.
*
*  SELECT  (input) LOGICAL array, dimension (N)
*          If HOWMNY = 'S', SELECT specifies the eigenpairs for which
*          condition numbers are required. To select condition numbers
*          for the j-th eigenpair, SELECT(j) must be set to .TRUE..
*          If HOWMNY = 'A', SELECT is not referenced.
*
*  N       (input) INTEGER
*          The order of the matrix T. N >= 0.
*
*  T       (input) COMPLEX*16 array, dimension (LDT,N)
*          The upper triangular matrix T.
*
*  LDT     (input) INTEGER
*          The leading dimension of the array T. LDT >= max(1,N).
*
*  VL      (input) COMPLEX*16 array, dimension (LDVL,M)
*          If JOB = 'E' or 'B', VL must contain left eigenvectors of T
*          (or of any Q*T*Q**H with Q unitary), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VL, as returned by
*          ZHSEIN or ZTREVC.
*          If JOB = 'V', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.
*          LDVL >= 1; and if JOB = 'E' or 'B', LDVL >= N.
*
*  VR      (input) COMPLEX*16 array, dimension (LDVR,M)
*          If JOB = 'E' or 'B', VR must contain right eigenvectors of T
*          (or of any Q*T*Q**H with Q unitary), corresponding to the
*          eigenpairs specified by HOWMNY and SELECT. The eigenvectors
*          must be stored in consecutive columns of VR, as returned by
*          ZHSEIN or ZTREVC.
*          If JOB = 'V', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= 1; and if JOB = 'E' or 'B', LDVR >= N.
*
*  S       (output) DOUBLE PRECISION array, dimension (MM)
*          If JOB = 'E' or 'B', the reciprocal condition numbers of the
*          selected eigenvalues, stored in consecutive elements of the
*          array. Thus S(j), SEP(j), and the j-th columns of VL and VR
*          all correspond to the same eigenpair (but not in general the
*          j-th eigenpair, unless all eigenpairs are selected).
*          If JOB = 'V', S is not referenced.
*
*  SEP     (output) DOUBLE PRECISION array, dimension (MM)
*          If JOB = 'V' or 'B', the estimated reciprocal condition
*          numbers of the selected eigenvectors, stored in consecutive
*          elements of the array.
*          If JOB = 'E', SEP is not referenced.
*
*  MM      (input) INTEGER
*          The number of elements in the arrays S (if JOB = 'E' or 'B')
*           and/or SEP (if JOB = 'V' or 'B'). MM >= M.
*
*  M       (output) INTEGER
*          The number of elements of the arrays S and/or SEP actually
*          used to store the estimated condition numbers.
*          If HOWMNY = 'A', M is set to N.
*
*  WORK    (workspace) COMPLEX*16 array, dimension (LDWORK,N+1)
*          If JOB = 'E', WORK is not referenced.
*
*  LDWORK  (input) INTEGER
*          The leading dimension of the array WORK.
*          LDWORK >= 1; and if JOB = 'V' or 'B', LDWORK >= N.
*
*  RWORK   (workspace) DOUBLE PRECISION array, dimension (N)
*          If JOB = 'E', RWORK is not referenced.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The reciprocal of the condition number of an eigenvalue lambda is
*  defined as
*
*          S(lambda) = |v'*u| / (norm(u)*norm(v))
*
*  where u and v are the right and left eigenvectors of T corresponding
*  to lambda; v' denotes the conjugate transpose of v, and norm(u)
*  denotes the Euclidean norm. These reciprocal condition numbers always
*  lie between zero (very badly conditioned) and one (very well
*  conditioned). If n = 1, S(lambda) is defined to be 1.
*
*  An approximate error bound for a computed eigenvalue W(i) is given by
*
*                      EPS * norm(T) / S(i)
*
*  where EPS is the machine precision.
*
*  The reciprocal of the condition number of the right eigenvector u
*  corresponding to lambda is defined as follows. Suppose
*
*              T = ( lambda  c  )
*                  (   0    T22 )
*
*  Then the reciprocal condition number is
*
*          SEP( lambda, T22 ) = sigma-min( T22 - lambda*I )
*
*  where sigma-min denotes the smallest singular value. We approximate
*  the smallest singular value by the reciprocal of an estimate of the
*  one-norm of the inverse of T22 - lambda*I. If n = 1, SEP(1) is
*  defined to be abs(T(1,1)).
*
*  An approximate error bound for a computed right eigenvector VR(i)
*  is given by
*
*                      EPS * norm(T) / SEP(i)
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D0+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            SOMCON, WANTBH, WANTS, WANTSP
      CHARACTER          NORMIN
      INTEGER            I, IERR, IX, J, K, KASE, KS
      DOUBLE PRECISION   BIGNUM, EPS, EST, LNRM, RNRM, SCALE, SMLNUM,
     $                   XNORM
      COMPLEX*16         CDUM, PROD
*     ..
*     .. Local Arrays ..
      COMPLEX*16         DUMMY( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IZAMAX
      DOUBLE PRECISION   DLAMCH, DZNRM2
      COMPLEX*16         ZDOTC
      EXTERNAL           LSAME, IZAMAX, DLAMCH, DZNRM2, ZDOTC
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, XERBLA, ZDRSCL, ZLACON, ZLACPY, ZLATRS,
     $                   ZTREXC
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DIMAG, MAX
*     ..
*     .. Statement Functions ..
      DOUBLE PRECISION   CABS1
*     ..
*     .. Statement Function definitions ..
      CABS1( CDUM ) = ABS( DBLE( CDUM ) ) + ABS( DIMAG( CDUM ) )
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTBH = LSAME( JOB, 'B' )
      WANTS = LSAME( JOB, 'E' ) .OR. WANTBH
      WANTSP = LSAME( JOB, 'V' ) .OR. WANTBH
*
      SOMCON = LSAME( HOWMNY, 'S' )
*
*     Set M to the number of eigenpairs for which condition numbers are
*     to be computed.
*
      IF( SOMCON ) THEN
         M = 0
         DO 10 J = 1, N
            IF( SELECT( J ) )
     $         M = M + 1
   10    CONTINUE
      ELSE
         M = N
      END IF
*
      INFO = 0
      IF( .NOT.WANTS .AND. .NOT.WANTSP ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( HOWMNY, 'A' ) .AND. .NOT.SOMCON ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( LDT.LT.MAX( 1, N ) ) THEN
         INFO = -6
      ELSE IF( LDVL.LT.1 .OR. ( WANTS .AND. LDVL.LT.N ) ) THEN
         INFO = -8
      ELSE IF( LDVR.LT.1 .OR. ( WANTS .AND. LDVR.LT.N ) ) THEN
         INFO = -10
      ELSE IF( MM.LT.M ) THEN
         INFO = -13
      ELSE IF( LDWORK.LT.1 .OR. ( WANTSP .AND. LDWORK.LT.N ) ) THEN
         INFO = -16
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRSNA', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( N.EQ.1 ) THEN
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( 1 ) )
     $         RETURN
         END IF
         IF( WANTS )
     $      S( 1 ) = ONE
         IF( WANTSP )
     $      SEP( 1 ) = ABS( T( 1, 1 ) )
         RETURN
      END IF
*
*     Get machine constants
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' ) / EPS
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
*
      KS = 1
      DO 50 K = 1, N
*
         IF( SOMCON ) THEN
            IF( .NOT.SELECT( K ) )
     $         GO TO 50
         END IF
*
         IF( WANTS ) THEN
*
*           Compute the reciprocal condition number of the k-th
*           eigenvalue.
*
            PROD = ZDOTC( N, VR( 1, KS ), 1, VL( 1, KS ), 1 )
            RNRM = DZNRM2( N, VR( 1, KS ), 1 )
            LNRM = DZNRM2( N, VL( 1, KS ), 1 )
            S( KS ) = ABS( PROD ) / ( RNRM*LNRM )
*
         END IF
*
         IF( WANTSP ) THEN
*
*           Estimate the reciprocal condition number of the k-th
*           eigenvector.
*
*           Copy the matrix T to the array WORK and swap the k-th
*           diagonal element to the (1,1) position.
*
            CALL ZLACPY( 'Full', N, N, T, LDT, WORK, LDWORK )
            CALL ZTREXC( 'No Q', N, WORK, LDWORK, DUMMY, 1, K, 1, IERR )
*
*           Form  C = T22 - lambda*I in WORK(2:N,2:N).
*
            DO 20 I = 2, N
               WORK( I, I ) = WORK( I, I ) - WORK( 1, 1 )
   20       CONTINUE
*
*           Estimate a lower bound for the 1-norm of inv(C'). The 1st
*           and (N+1)th columns of WORK are used to store work vectors.
*
            SEP( KS ) = ZERO
            EST = ZERO
            KASE = 0
            NORMIN = 'N'
   30       CONTINUE
            CALL ZLACON( N-1, WORK( 1, N+1 ), WORK, EST, KASE )
*
            IF( KASE.NE.0 ) THEN
               IF( KASE.EQ.1 ) THEN
*
*                 Solve C'*x = scale*b
*
                  CALL ZLATRS( 'Upper', 'Conjugate transpose',
     $                         'Nonunit', NORMIN, N-1, WORK( 2, 2 ),
     $                         LDWORK, WORK, SCALE, RWORK, IERR )
               ELSE
*
*                 Solve C*x = scale*b
*
                  CALL ZLATRS( 'Upper', 'No transpose', 'Nonunit',
     $                         NORMIN, N-1, WORK( 2, 2 ), LDWORK, WORK,
     $                         SCALE, RWORK, IERR )
               END IF
               NORMIN = 'Y'
               IF( SCALE.NE.ONE ) THEN
*
*                 Multiply by 1/SCALE if doing so will not cause
*                 overflow.
*
                  IX = IZAMAX( N-1, WORK, 1 )
                  XNORM = CABS1( WORK( IX, 1 ) )
                  IF( SCALE.LT.XNORM*SMLNUM .OR. SCALE.EQ.ZERO )
     $               GO TO 40
                  CALL ZDRSCL( N, SCALE, WORK, 1 )
               END IF
               GO TO 30
            END IF
*
            SEP( KS ) = ONE / MAX( EST, SMLNUM )
         END IF
*
   40    CONTINUE
         KS = KS + 1
   50 CONTINUE
      RETURN
*
*     End of ZTRSNA
*
      END
* DECK ztrsyl.f
      SUBROUTINE ZTRSYL( TRANA, TRANB, ISGN, M, N, A, LDA, B, LDB, C,
     $                   LDC, SCALE, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          TRANA, TRANB
      INTEGER            INFO, ISGN, LDA, LDB, LDC, M, N
      DOUBLE PRECISION   SCALE
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRSYL solves the complex Sylvester matrix equation:
*
*     op(A)*X + X*op(B) = scale*C or
*     op(A)*X - X*op(B) = scale*C,
*
*  where op(A) = A or A**H, and A and B are both upper triangular. A is
*  M-by-M and B is N-by-N; the right hand side C and the solution X are
*  M-by-N; and scale is an output scale factor, set <= 1 to avoid
*  overflow in X.
*
*  Arguments
*  =========
*
*  TRANA   (input) CHARACTER*1
*          Specifies the option op(A):
*          = 'N': op(A) = A    (No transpose)
*          = 'C': op(A) = A**H (Conjugate transpose)
*
*  TRANB   (input) CHARACTER*1
*          Specifies the option op(B):
*          = 'N': op(B) = B    (No transpose)
*          = 'C': op(B) = B**H (Conjugate transpose)
*
*  ISGN    (input) INTEGER
*          Specifies the sign in the equation:
*          = +1: solve op(A)*X + X*op(B) = scale*C
*          = -1: solve op(A)*X - X*op(B) = scale*C
*
*  M       (input) INTEGER
*          The order of the matrix A, and the number of rows in the
*          matrices X and C. M >= 0.
*
*  N       (input) INTEGER
*          The order of the matrix B, and the number of columns in the
*          matrices X and C. N >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,M)
*          The upper triangular matrix A.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= max(1,M).
*
*  B       (input) COMPLEX*16 array, dimension (LDB,N)
*          The upper triangular matrix B.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B. LDB >= max(1,N).
*
*  C       (input/output) COMPLEX*16 array, dimension (LDC,N)
*          On entry, the M-by-N right hand side matrix C.
*          On exit, C is overwritten by the solution matrix X.
*
*  LDC     (input) INTEGER
*          The leading dimension of the array C. LDC >= max(1,M)
*
*  SCALE   (output) DOUBLE PRECISION
*          The scale factor, scale, set <= 1 to avoid overflow in X.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1: A and B have common or very close eigenvalues; perturbed
*               values were used to solve the equation (but the matrices
*               A and B are unchanged).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRNA, NOTRNB
      INTEGER            J, K, L
      DOUBLE PRECISION   BIGNUM, DA11, DB, EPS, SCALOC, SGN, SMIN,
     $                   SMLNUM
      COMPLEX*16         A11, SUML, SUMR, VEC, X11
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   DUM( 1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, ZLANGE
      COMPLEX*16         ZDOTC, ZDOTU
      EXTERNAL           LSAME, DLAMCH, ZLANGE, ZDOTC, ZDOTU
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLABAD, XERBLA, ZDSCAL
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, DCONJG, DIMAG, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and Test input parameters
*
      NOTRNA = LSAME( TRANA, 'N' )
      NOTRNB = LSAME( TRANB, 'N' )
*
      INFO = 0
      IF( .NOT.NOTRNA .AND. .NOT.LSAME( TRANA, 'T' ) .AND. .NOT.
     $    LSAME( TRANA, 'C' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOTRNB .AND. .NOT.LSAME( TRANB, 'T' ) .AND. .NOT.
     $         LSAME( TRANB, 'C' ) ) THEN
         INFO = -2
      ELSE IF( ISGN.NE.1 .AND. ISGN.NE.-1 ) THEN
         INFO = -3
      ELSE IF( M.LT.0 ) THEN
         INFO = -4
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      ELSE IF( LDC.LT.MAX( 1, M ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRSYL', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Set constants to control overflow
*
      EPS = DLAMCH( 'P' )
      SMLNUM = DLAMCH( 'S' )
      BIGNUM = ONE / SMLNUM
      CALL DLABAD( SMLNUM, BIGNUM )
      SMLNUM = SMLNUM*DBLE( M*N ) / EPS
      BIGNUM = ONE / SMLNUM
      SMIN = MAX( SMLNUM, EPS*ZLANGE( 'M', M, M, A, LDA, DUM ),
     $       EPS*ZLANGE( 'M', N, N, B, LDB, DUM ) )
      SCALE = ONE
      SGN = ISGN
*
      IF( NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-left corner column by column by
*
*            A(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    M                        L-1
*          R(K,L) = SUM [A(K,I)*X(I,L)] +ISGN*SUM [X(K,J)*B(J,L)].
*                  I=K+1                      J=1
*
         DO 30 L = 1, N
            DO 20 K = M, 1, -1
*
               SUML = ZDOTU( M-K, A( K, MIN( K+1, M ) ), LDA,
     $                C( MIN( K+1, M ), L ), 1 )
               SUMR = ZDOTU( L-1, C( K, 1 ), LDC, B( 1, L ), 1 )
               VEC = C( K, L ) - ( SUML+SGN*SUMR )
*
               SCALOC = ONE
               A11 = A( K, K ) + SGN*B( L, L )
               DA11 = ABS( DBLE( A11 ) ) + ABS( DIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( DBLE( VEC ) ) + ABS( DIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
               X11 = ( VEC*DCMPLX( SCALOC ) ) / A11
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 10 J = 1, N
                     CALL ZDSCAL( M, SCALOC, C( 1, J ), 1 )
   10             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   20       CONTINUE
   30    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. NOTRNB ) THEN
*
*        Solve    A' *X + ISGN*X*B = scale*C.
*
*        The (K,L)th block of X is determined starting from
*        upper-left corner column by column by
*
*            A'(K,K)*X(K,L) + ISGN*X(K,L)*B(L,L) = C(K,L) - R(K,L)
*
*        Where
*                   K-1                         L-1
*          R(K,L) = SUM [A'(I,K)*X(I,L)] + ISGN*SUM [X(K,J)*B(J,L)]
*                   I=1                         J=1
*
         DO 60 L = 1, N
            DO 50 K = 1, M
*
               SUML = ZDOTC( K-1, A( 1, K ), 1, C( 1, L ), 1 )
               SUMR = ZDOTU( L-1, C( K, 1 ), LDC, B( 1, L ), 1 )
               VEC = C( K, L ) - ( SUML+SGN*SUMR )
*
               SCALOC = ONE
               A11 = DCONJG( A( K, K ) ) + SGN*B( L, L )
               DA11 = ABS( DBLE( A11 ) ) + ABS( DIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( DBLE( VEC ) ) + ABS( DIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = ( VEC*DCMPLX( SCALOC ) ) / A11
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 40 J = 1, N
                     CALL ZDSCAL( M, SCALOC, C( 1, J ), 1 )
   40             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   50       CONTINUE
   60    CONTINUE
*
      ELSE IF( .NOT.NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A'*X + ISGN*X*B' = C.
*
*        The (K,L)th block of X is determined starting from
*        upper-right corner column by column by
*
*            A'(K,K)*X(K,L) + ISGN*X(K,L)*B'(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    K-1
*           R(K,L) = SUM [A'(I,K)*X(I,L)] +
*                    I=1
*                           N
*                     ISGN*SUM [X(K,J)*B'(L,J)].
*                          J=L+1
*
         DO 90 L = N, 1, -1
            DO 80 K = 1, M
*
               SUML = ZDOTC( K-1, A( 1, K ), 1, C( 1, L ), 1 )
               SUMR = ZDOTC( N-L, C( K, MIN( L+1, N ) ), LDC,
     $                B( L, MIN( L+1, N ) ), LDB )
               VEC = C( K, L ) - ( SUML+SGN*DCONJG( SUMR ) )
*
               SCALOC = ONE
               A11 = DCONJG( A( K, K )+SGN*B( L, L ) )
               DA11 = ABS( DBLE( A11 ) ) + ABS( DIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( DBLE( VEC ) ) + ABS( DIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = ( VEC*DCMPLX( SCALOC ) ) / A11
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 70 J = 1, N
                     CALL ZDSCAL( M, SCALOC, C( 1, J ), 1 )
   70             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
   80       CONTINUE
   90    CONTINUE
*
      ELSE IF( NOTRNA .AND. .NOT.NOTRNB ) THEN
*
*        Solve    A*X + ISGN*X*B' = C.
*
*        The (K,L)th block of X is determined starting from
*        bottom-left corner column by column by
*
*           A(K,K)*X(K,L) + ISGN*X(K,L)*B'(L,L) = C(K,L) - R(K,L)
*
*        Where
*                    M                          N
*          R(K,L) = SUM [A(K,I)*X(I,L)] + ISGN*SUM [X(K,J)*B'(L,J)]
*                  I=K+1                      J=L+1
*
         DO 120 L = N, 1, -1
            DO 110 K = M, 1, -1
*
               SUML = ZDOTU( M-K, A( K, MIN( K+1, M ) ), LDA,
     $                C( MIN( K+1, M ), L ), 1 )
               SUMR = ZDOTC( N-L, C( K, MIN( L+1, N ) ), LDC,
     $                B( L, MIN( L+1, N ) ), LDB )
               VEC = C( K, L ) - ( SUML+SGN*DCONJG( SUMR ) )
*
               SCALOC = ONE
               A11 = A( K, K ) + SGN*DCONJG( B( L, L ) )
               DA11 = ABS( DBLE( A11 ) ) + ABS( DIMAG( A11 ) )
               IF( DA11.LE.SMIN ) THEN
                  A11 = SMIN
                  DA11 = SMIN
                  INFO = 1
               END IF
               DB = ABS( DBLE( VEC ) ) + ABS( DIMAG( VEC ) )
               IF( DA11.LT.ONE .AND. DB.GT.ONE ) THEN
                  IF( DB.GT.BIGNUM*DA11 )
     $               SCALOC = ONE / DB
               END IF
*
               X11 = ( VEC*DCMPLX( SCALOC ) ) / A11
*
               IF( SCALOC.NE.ONE ) THEN
                  DO 100 J = 1, N
                     CALL ZDSCAL( M, SCALOC, C( 1, J ), 1 )
  100             CONTINUE
                  SCALE = SCALE*SCALOC
               END IF
               C( K, L ) = X11
*
  110       CONTINUE
  120    CONTINUE
*
      END IF
*
      RETURN
*
*     End of ZTRSYL
*
      END
* DECK ztrti2.f
      SUBROUTINE ZTRTI2( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRTI2 computes the inverse of a complex upper or lower triangular
*  matrix.
*
*  This is the Level 2 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the matrix A is upper or lower triangular.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  DIAG    (input) CHARACTER*1
*          Specifies whether or not the matrix A is unit triangular.
*          = 'N':  Non-unit triangular
*          = 'U':  Unit triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the triangular matrix A.  If UPLO = 'U', the
*          leading n by n upper triangular part of the array A contains
*          the upper triangular matrix, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n by n lower triangular part of the array A contains
*          the lower triangular matrix, and the strictly upper
*          triangular part of A is not referenced.  If DIAG = 'U', the
*          diagonal elements of A are also not referenced and are
*          assumed to be 1.
*
*          On exit, the (triangular) inverse of the original matrix, in
*          the same storage format.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J
      COMPLEX*16         AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZSCAL, ZTRMV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRTI2', -INFO )
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Compute inverse of upper triangular matrix.
*
         DO 10 J = 1, N
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
*
*           Compute elements 1:j-1 of j-th column.
*
            CALL ZTRMV( 'Upper', 'No transpose', DIAG, J-1, A, LDA,
     $                  A( 1, J ), 1 )
            CALL ZSCAL( J-1, AJJ, A( 1, J ), 1 )
   10    CONTINUE
      ELSE
*
*        Compute inverse of lower triangular matrix.
*
         DO 20 J = N, 1, -1
            IF( NOUNIT ) THEN
               A( J, J ) = ONE / A( J, J )
               AJJ = -A( J, J )
            ELSE
               AJJ = -ONE
            END IF
            IF( J.LT.N ) THEN
*
*              Compute elements j+1:n of j-th column.
*
               CALL ZTRMV( 'Lower', 'No transpose', DIAG, N-J,
     $                     A( J+1, J+1 ), LDA, A( J+1, J ), 1 )
               CALL ZSCAL( N-J, AJJ, A( J+1, J ), 1 )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTRTI2
*
      END
* DECK ztrtri.f
      SUBROUTINE ZTRTRI( UPLO, DIAG, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRTRI computes the inverse of a complex upper or lower triangular
*  matrix A.
*
*  This is the Level 3 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the triangular matrix A.  If UPLO = 'U', the
*          leading N-by-N upper triangular part of the array A contains
*          the upper triangular matrix, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading N-by-N lower triangular part of the array A contains
*          the lower triangular matrix, and the strictly upper
*          triangular part of A is not referenced.  If DIAG = 'U', the
*          diagonal elements of A are also not referenced and are
*          assumed to be 1.
*          On exit, the (triangular) inverse of the original matrix, in
*          the same storage format.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, A(i,i) is exactly zero.  The triangular
*               matrix is singular and its inverse can not be computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ONE, ZERO
      PARAMETER          ( ONE = ( 1.0D+0, 0.0D+0 ),
     $                   ZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT, UPPER
      INTEGER            J, JB, NB, NN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTRMM, ZTRSM, ZTRTI2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRTRI', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity if non-unit.
*
      IF( NOUNIT ) THEN
         DO 10 INFO = 1, N
            IF( A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
         INFO = 0
      END IF
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'ZTRTRI', UPLO // DIAG, N, -1, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.N ) THEN
*
*        Use unblocked code
*
         CALL ZTRTI2( UPLO, DIAG, N, A, LDA, INFO )
      ELSE
*
*        Use blocked code
*
         IF( UPPER ) THEN
*
*           Compute inverse of upper triangular matrix
*
            DO 20 J = 1, N, NB
               JB = MIN( NB, N-J+1 )
*
*              Compute rows 1:j-1 of current block column
*
               CALL ZTRMM( 'Left', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, ONE, A, LDA, A( 1, J ), LDA )
               CALL ZTRSM( 'Right', 'Upper', 'No transpose', DIAG, J-1,
     $                     JB, -ONE, A( J, J ), LDA, A( 1, J ), LDA )
*
*              Compute inverse of current diagonal block
*
               CALL ZTRTI2( 'Upper', DIAG, JB, A( J, J ), LDA, INFO )
   20       CONTINUE
         ELSE
*
*           Compute inverse of lower triangular matrix
*
            NN = ( ( N-1 ) / NB )*NB + 1
            DO 30 J = NN, 1, -NB
               JB = MIN( NB, N-J+1 )
               IF( J+JB.LE.N ) THEN
*
*                 Compute rows j+jb:n of current block column
*
                  CALL ZTRMM( 'Left', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, ONE, A( J+JB, J+JB ), LDA,
     $                        A( J+JB, J ), LDA )
                  CALL ZTRSM( 'Right', 'Lower', 'No transpose', DIAG,
     $                        N-J-JB+1, JB, -ONE, A( J, J ), LDA,
     $                        A( J+JB, J ), LDA )
               END IF
*
*              Compute inverse of current diagonal block
*
               CALL ZTRTI2( 'Lower', DIAG, JB, A( J, J ), LDA, INFO )
   30       CONTINUE
         END IF
      END IF
*
      RETURN
*
*     End of ZTRTRI
*
      END
* DECK ztrtrs.f
      SUBROUTINE ZTRTRS( UPLO, TRANS, DIAG, N, NRHS, A, LDA, B, LDB,
     $                   INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          DIAG, TRANS, UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  ZTRTRS solves a triangular system of the form
*
*     A * X = B,  A**T * X = B,  or  A**H * X = B,
*
*  where A is a triangular matrix of order N, and B is an N-by-NRHS
*  matrix.  A check is made to verify that A is nonsingular.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U':  A is upper triangular;
*          = 'L':  A is lower triangular.
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B     (No transpose)
*          = 'T':  A**T * X = B  (Transpose)
*          = 'C':  A**H * X = B  (Conjugate transpose)
*
*  DIAG    (input) CHARACTER*1
*          = 'N':  A is non-unit triangular;
*          = 'U':  A is unit triangular.
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input) COMPLEX*16 array, dimension (LDA,N)
*          The triangular matrix A.  If UPLO = 'U', the leading N-by-N
*          upper triangular part of the array A contains the upper
*          triangular matrix, and the strictly lower triangular part of
*          A is not referenced.  If UPLO = 'L', the leading N-by-N lower
*          triangular part of the array A contains the lower triangular
*          matrix, and the strictly upper triangular part of A is not
*          referenced.  If DIAG = 'U', the diagonal elements of A are
*          also not referenced and are assumed to be 1.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  B       (input/output) COMPLEX*16 array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, if INFO = 0, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          > 0: if INFO = i, the i-th diagonal element of A is zero,
*               indicating that the matrix is singular and the solutions
*               X have not been computed.
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOUNIT
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZTRSM
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOUNIT = LSAME( DIAG, 'N' )
      IF( .NOT.LSAME( UPLO, 'U' ) .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( TRANS, 'N' ) .AND. .NOT.
     $         LSAME( TRANS, 'T' ) .AND. .NOT.LSAME( TRANS, 'C' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOUNIT .AND. .NOT.LSAME( DIAG, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -9
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTRTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Check for singularity.
*
      IF( NOUNIT ) THEN
         DO 10 INFO = 1, N
            IF( A( INFO, INFO ).EQ.ZERO )
     $         RETURN
   10    CONTINUE
      END IF
      INFO = 0
*
*     Solve A * x = b,  A**T * x = b,  or  A**H * x = b.
*
      CALL ZTRSM( 'Left', UPLO, TRANS, DIAG, N, NRHS, ONE, A, LDA, B,
     $            LDB )
*
      RETURN
*
*     End of ZTRTRS
*
      END
* DECK ztzrqf.f
      SUBROUTINE ZTZRQF( M, N, A, LDA, TAU, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * )
*     ..
*
*  Purpose
*  =======
*
*  ZTZRQF reduces the M-by-N ( M<=N ) complex upper trapezoidal matrix A
*  to upper triangular form by means of unitary transformations.
*
*  The upper trapezoidal matrix A is factored as
*
*     A = ( R  0 ) * Z,
*
*  where Z is an N-by-N unitary matrix and R is an M-by-M upper
*  triangular matrix.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= M.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the leading M-by-N upper trapezoidal part of the
*          array A must contain the matrix to be factorized.
*          On exit, the leading M-by-M upper triangular part of A
*          contains the upper triangular matrix R, and elements M+1 to
*          N of the first M rows of A, with the array TAU, represent the
*          unitary matrix Z as a product of M elementary reflectors.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  TAU     (output) COMPLEX*16 array, dimension (M)
*          The scalar factors of the elementary reflectors.
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*
*  Further Details
*  ===============
*
*  The  factorization is obtained by Householder's method.  The kth
*  transformation matrix, Z( k ), whose conjugate transpose is used to
*  introduce zeros into the (m - k + 1)th row of A, is given in the form
*
*     Z( k ) = ( I     0   ),
*              ( 0  T( k ) )
*
*  where
*
*     T( k ) = I - tau*u( k )*u( k )',   u( k ) = (   1    ),
*                                                 (   0    )
*                                                 ( z( k ) )
*
*  tau is a scalar and z( k ) is an ( n - m ) element vector.
*  tau and z( k ) are chosen to annihilate the elements of the kth row
*  of X.
*
*  The scalar tau is returned in the kth element of TAU and the vector
*  u( k ) in the kth row of A, such that the elements of z( k ) are
*  in  a( k, m + 1 ), ..., a( k, n ). The elements of R are returned in
*  the upper triangular part of A.
*
*  Z is given by
*
*     Z =  Z( 1 ) * Z( 2 ) * ... * Z( m ).
*
* =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         CONE, CZERO
      PARAMETER          ( CONE = ( 1.0D+0, 0.0D+0 ),
     $                   CZERO = ( 0.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      INTEGER            I, K, M1
      COMPLEX*16         ALPHA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DCONJG, MAX, MIN
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZAXPY, ZCOPY, ZGEMV, ZGERC, ZLACGV,
     $                   ZLARFG
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.M ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZTZRQF', -INFO )
         RETURN
      END IF
*
*     Perform the factorization.
*
      IF( M.EQ.0 )
     $   RETURN
      IF( M.EQ.N ) THEN
         DO 10 I = 1, N
            TAU( I ) = CZERO
   10    CONTINUE
      ELSE
         M1 = MIN( M+1, N )
         DO 20 K = M, 1, -1
*
*           Use a Householder reflection to zero the kth row of A.
*           First set up the reflection.
*
            A( K, K ) = DCONJG( A( K, K ) )
            CALL ZLACGV( N-M, A( K, M1 ), LDA )
            ALPHA = A( K, K )
            CALL ZLARFG( N-M+1, ALPHA, A( K, M1 ), LDA, TAU( K ) )
            A( K, K ) = ALPHA
            TAU( K ) = DCONJG( TAU( K ) )
*
            IF( TAU( K ).NE.CZERO .AND. K.GT.1 ) THEN
*
*              We now perform the operation  A := A*P( k )'.
*
*              Use the first ( k - 1 ) elements of TAU to store  a( k ),
*              where  a( k ) consists of the first ( k - 1 ) elements of
*              the  kth column  of  A.  Also  let  B  denote  the  first
*              ( k - 1 ) rows of the last ( n - m ) columns of A.
*
               CALL ZCOPY( K-1, A( 1, K ), 1, TAU, 1 )
*
*              Form   w = a( k ) + B*z( k )  in TAU.
*
               CALL ZGEMV( 'No transpose', K-1, N-M, CONE, A( 1, M1 ),
     $                     LDA, A( K, M1 ), LDA, CONE, TAU, 1 )
*
*              Now form  a( k ) := a( k ) - conjg(tau)*w
*              and       B      := B      - conjg(tau)*w*z( k )'.
*
               CALL ZAXPY( K-1, -DCONJG( TAU( K ) ), TAU, 1, A( 1, K ),
     $                     1 )
               CALL ZGERC( K-1, N-M, -DCONJG( TAU( K ) ), TAU, 1,
     $                     A( K, M1 ), LDA, A( 1, M1 ), LDA )
            END IF
   20    CONTINUE
      END IF
*
      RETURN
*
*     End of ZTZRQF
*
      END

module nan
  !---------------------------------------------------------------------
  ! Return the value of NaN
  ! Single Precision
  !---------------------------------------------------------------------
  real(4) :: s_nan
  integer(4) :: j_nan
  equivalence (j_nan,s_nan)
  real(4) :: s_pinf
  integer(4) :: j_pinf
  equivalence (j_pinf,s_pinf)
  real(4) :: s_minf
  integer(4) :: j_minf
  equivalence (j_minf,s_minf)
  !
  ! Double Precision constant
  real(8) :: d_nan
  integer(4) :: i_nan(2)
  equivalence (i_nan,d_nan)
  real(8) :: d_pinf
  integer(4) :: i_pinf(2)
  equivalence (i_pinf,d_pinf)
  real(8) :: d_minf
  integer(4) :: i_minf(2)
  equivalence (i_minf,d_minf)
#if defined(EEEI)
  ! Working
  data j_nan /z'7FA00000'/
  data j_pinf /z'7F800000'/
  data j_minf /z'FF800000'/
  ! Not checked yet...
  data i_nan /z'7FF40000',0/
  data i_pinf /z'7FF00000',0/
  data i_minf /z'FFF00000',0/
#endif
#if defined(IEEE)
  ! Working
  data j_nan /z'FFC00000'/
  data j_pinf /z'7F800000'/
  data j_minf /z'FF800000'/
  data i_nan /0,z'7FF40000'/
  data i_pinf /0,z'7FF00000'/
  data i_minf /0,z'FFF00000'/
#endif
#if defined(VAX)
  data s_nan /-1e38/           ! Not supported by VAX, so arbitrary
  data d_nan /-1d38/           ! Not supported by VAX, so arbitrary
  data d_pinf /1d38/
  data d_minf /-1d38/
#endif
end module   nan
!<FF>
function gag_isreal (anum)
  !---------------------------------------------------------------------
  ! Return 0 if the number is a Real number,
  ! 1 if +Inf, 2 if -Inf, 3 if NaN
  !---------------------------------------------------------------------
  integer*4 :: gag_isreal           !
  integer*4 :: anum                 !
  ! Local
  integer*4 :: pinf,minf,nan,expo
  ! Data
#if defined(EEEI)
  data nan /z'7FA00000'/
#endif
#if defined(IEEE)
  data nan /z'FFC00000'/
#endif
  data pinf /z'7F800000'/
  data minf /z'FF800000'/
  !
  gag_isreal = 0
  if (anum.eq.pinf) then
    gag_isreal = 1
  elseif (anum.eq.minf) then
    gag_isreal = 2
  else
    expo = iand(anum,nan)
    if (expo.eq.nan) then
      gag_isreal = 3
    else
      gag_isreal = 0
    endif
  endif
end
!<FF>
function gag_isdble (anum)
  !---------------------------------------------------------------------
  ! Return 0 if the number is a Dble number,
  ! 1 if +Inf, 2 if -Inf, 3 if NaN
  !---------------------------------------------------------------------
  integer*4 :: gag_isdble           !
  integer*4 :: anum(2)              !
  ! Local
  integer*4 :: pinf(2),minf(2),nan,expo,imant
  !
  ! Note: Fortran-95 norm says a BOZ constant is an INTEGER*8,
  ! and only valid in a data statement for an integer, but
  ! INTEGER*8 is not supported by every compiler/system...
#if defined(EEEI)
  ! HP-Like TO BE TESTED
  data nan /z'7FF00000'/       ! not 7FF4000, at least on IEEE
  data imant /1/
  data pinf /z'7FF00000',0/
  data minf /z'FFF00000',0/
#endif
#if defined(IEEE)
  ! Intel-Like FULLY FUNCTIONAL (like PCs)
  data nan /z'7FF00000'/       ! not 7FF4000 ...
  data imant /2/
  data pinf /0,z'7FF00000'/
  data minf /0,z'FFF00000'/
#endif
  !
  if (anum(1).eq.pinf(1).and.anum(2).eq.pinf(2)) then
    gag_isdble = 1
  elseif (anum(1).eq.minf(1).and.anum(2).eq.minf(2)) then
    gag_isdble = 2
  else
    expo = iand(anum(imant),nan)
    !!         write(6,'(1x,Z8.8,1x,Z8.8)') expo,nan
    if (expo.eq.nan) then
      gag_isdble = 3
    else
      gag_isdble = 0
    endif
  endif
end
!
program test
  use nan
  ! Global
  integer :: gag_isreal,gag_isdble
  ! Local
  real(4) :: a,c
  real(8) :: b
  integer :: ia,ib(2)
  equivalence (a,ia),(b,ib)
  ! REAL
  c = 0.
  a = 1./c
  print *,"Should be +Inf   1   +Inf"
  print *,a,gag_isreal(a),s_pinf
  print '(Z8.8)',ia
  !
  a = -1./c
  print *,"Should be -Inf   2   -Inf"
  print *,a,gag_isreal(a),s_minf
  print '(Z8.8)',ia
  !
  c = -1
  a = sqrt(c)
  print *,"Should be Nan 3 Nan "
  print *,a,gag_isreal(a),s_nan
  print '(Z8.8)',ia
  !
  ! Now DBLE
  c = 0.
  b = 1./c
  print *,"Should be +Inf   1   +Inf"
  print *,b,gag_isdble(b),d_pinf
  print '(Z8.8,Z8.8)',ib
  !
  b = -1./c
  print *,"Should be -Inf   2   -Inf"
  print *,b,gag_isdble(b),d_minf
  print '(Z8.8,Z8.8)',ib
  !
  c = -1
  b = sqrt(c)
  print *,"Should be Nan 3 Nan "
  print *,b,gag_isdble(b),d_nan
  print '(Z8.8,Z8.8)',ib
  !
end program test

program correlate
  use gildas_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS  Computes the cross correlation of two data cubes.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: in_name1,in_name2,out_name
  logical :: error,corr
  integer(kind=4) :: dim(2)
  integer(kind=4) :: i, j, n
  type(gildas) :: x,y,z
  integer(kind=4), allocatable :: work(:,:)
  integer(kind=4) :: ier
  !
  call gildas_open
  call gildas_char('IN_NAME1$',in_name1)
  call gildas_char('IN_NAME2$',in_name2)
  call gildas_char('OUT_NAME$',out_name)
  call gildas_inte('OUT_SIZE$',dim,2)
  call gildas_logi('MODE$',corr,1)
  call gildas_close
  !
  call gildas_null(z)
  z%gil%ndim = 3
  call gdf_read_gildas(z,in_name1,'.gdf',error,data=.false.)
  if (error) call sysexi(fatale)
  !
  call gildas_null(y)
  y%gil%ndim = 3
  call gdf_read_gildas(y,in_name2,'.gdf',error,data=.false.)
  if (error) call sysexi(fatale)
  !
  do i=3,4
    if (y%gil%dim(i).ne.z%gil%dim(i)) then
      call gagout('F-CORRELATE,  Input cubes have different'//   &
     &        ' channel numbers')
      goto 100
    endif
  enddo
  !
  error = .false.
  ! Check 3rd axis
  if (y%gil%dim(3).gt.1) then
    call do_check('Ref3',y%gil%ref(3),z%gil%ref(3),error)
    if (error)  goto 100
    call do_check('Val3',y%gil%val(3),z%gil%val(3),error)
    if (error)  goto 100
    call do_check('Inc3',y%gil%inc(3),z%gil%inc(3),error)
    if (error)  goto 100
  endif
  !
  ! Check 4th axis
  if (y%gil%dim(4).gt.1) then
    call do_check('Ref4',y%gil%ref(4),z%gil%ref(4),error)
    if (error)  goto 100
    call do_check('Val4',y%gil%val(4),z%gil%val(4),error)
    if (error)  goto 100
    call do_check('Inc4',y%gil%inc(4),z%gil%inc(4),error)
    if (error)  goto 100
  endif
  !
  error = .false.
  if (z%gil%inc(1).ne.y%gil%inc(1).or.z%gil%inc(2).ne.y%gil%inc(2)) then
    error = .true.
  elseif  (y%gil%dim(3).gt.1 .and. z%gil%inc(3).ne.y%gil%inc(3)) then
    error = .true.
  elseif  (y%gil%dim(4).gt.1 .and. z%gil%inc(4).ne.y%gil%inc(4)) then
    error = .true.
  endif
  if (error) then
    call gagout('F-CORRELATE,  Pixel sizes do not match')
    write(6,*) z%gil%inc(1), y%gil%inc(1)
    write(6,*) z%gil%inc(2), y%gil%inc(2)
    write(6,*) z%gil%inc(3), y%gil%inc(3)
    write(6,*) z%gil%inc(4), y%gil%inc(4)
    goto 100
  endif
  !
  call gildas_null(x)
  call gdf_copy_header (y,x,error)
  n = lenc(out_name)
  if (n.eq.0) goto 100
  call sic_parsef(out_name(1:n),x%file,' ','.gdf')
  !
  x%gil%extr_words = 0
  x%gil%blan_words = 2
  if (corr) then
    x%gil%bval = 0.0
    x%gil%eval = 0.0
  else
    x%gil%bval = 1.0
    x%gil%eval = 0.0
  endif

  ! Determine size of correlation cube
  x%gil%dim(1) = z%gil%dim(1) + y%gil%dim(1) - 1
  if (dim(1).gt.0) x%gil%dim(1) = min(dim(1),x%gil%dim(1))
  x%gil%dim(2) = z%gil%dim(2) + y%gil%dim(2) - 1
  if (dim(2).gt.0) x%gil%dim(2) = min(dim(2),x%gil%dim(2))
  x%gil%dim(3) = y%gil%dim(3)
  x%gil%dim(4) = y%gil%dim(4)
  x%gil%val(1) = z%gil%val(1)-y%gil%val(1)
  x%gil%val(2) = z%gil%val(2)-y%gil%val(2)
  x%gil%ref(1) = z%gil%ref(1)-y%gil%ref(1)+x%gil%dim(1)/2
  x%gil%ref(2) = z%gil%ref(2)-y%gil%ref(2)+x%gil%dim(2)/2
  x%loca%size = 1
  do i = 1, 4
    x%loca%size = x%loca%size*x%gil%dim(i)
  enddo
  !
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-CORRELATE,  Cannot create image') 
    goto 100
  endif
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)) , &
            work(x%gil%dim(1),x%gil%dim(2)),   &
            y%r2d(y%gil%dim(1),y%gil%dim(2)),  &
            z%r2d(z%gil%dim(1),z%gil%dim(2)), stat=ier)
  if (ier.ne.0) then
    call gagout('F-CORRELATE,  Cannot allocate work space')
    goto 100
  endif
  !
  do j = 1, x%gil%dim(4)
    x%blc(4) = j
    x%trc(4) = j
    do i = 1, x%gil%dim(3)
      x%blc(3) = i
      x%trc(3) = i
      if (error) goto 100
      y%blc = x%blc
      y%trc = x%trc
      call gdf_read_data(y,y%r2d,error)
      if (error) goto 100
      z%blc = x%blc
      z%trc = x%trc
      call gdf_read_data(z,z%r2d,error)
      if (error) goto 100
      !
      if (corr) then
        call do_correl(  &
          z%r2d,z%gil%dim(1),z%gil%dim(2),z%gil%bval,z%gil%eval,  &
          y%r2d,y%gil%dim(1),y%gil%dim(2),y%gil%bval,y%gil%eval,  &
          x%r2d,x%gil%dim(1),x%gil%dim(2),                        &
          work)
      else
        call do_square(  &
          z%r2d,z%gil%dim(1),z%gil%dim(2),z%gil%bval,z%gil%eval,  &
          y%r2d,y%gil%dim(1),y%gil%dim(2),y%gil%bval,y%gil%eval,  &
          x%r2d,x%gil%dim(1),x%gil%dim(2),                        &
          work)
      endif
      call gdf_write_data(x,x%r2d,error)
    enddo
  enddo
  !
  deallocate(x%r2d,work,y%r2d,z%r2d)
  !
  call gagout('S-CORRELATE,  Successful completion')
  goto 101
  !
100 call sysexi (fatale)
101 continue
end program correlate
!
subroutine do_check(axis,yval,zval,error)
  use gkernel_interfaces
  character(len=*), intent(in)    :: axis   ! Axis name
  real(kind=8),     intent(inout) :: yval   !
  real(kind=8),     intent(in)    :: zval   !
  logical,          intent(inout) :: error  ! Logical error flag
  !
  if ((yval-zval).gt.1d-37) then
    if (yval.eq.0.d0) yval = 1d-38
    if (abs((yval-zval)/yval).gt.1d-15) then
      call gagout('F-CORRELATE,  Input cubes have '//  &
        'incompatible conversion formula on 3rd or 4th axis:')
      write(6,*) axis, yval, zval
      error = .true.
      return
    endif
  endif
  !
end subroutine do_check
!
subroutine do_correl(in1,nxin1,nyin1,bval1,eval1,  &
                     in2,nxin2,nyin2,bval2,eval2,  &
                     out,nxout,nyout,work)
  use gildas_def
  integer(kind=index_length), intent(in)  :: nxin1              !
  integer(kind=index_length), intent(in)  :: nyin1              !
  real(kind=4),               intent(in)  :: in1(nxin1,nyin1)   !
  real(kind=4),               intent(in)  :: bval1              !
  real(kind=4),               intent(in)  :: eval1              !
  integer(kind=index_length), intent(in)  :: nxin2              !
  integer(kind=index_length), intent(in)  :: nyin2              !
  real(kind=4),               intent(in)  :: in2(nxin2,nyin2)   !
  real(kind=4),               intent(in)  :: bval2              !
  real(kind=4),               intent(in)  :: eval2              !
  integer(kind=index_length), intent(in)  :: nxout              !
  integer(kind=index_length), intent(in)  :: nyout              !
  real(kind=4),               intent(out) :: out(nxout,nyout)   !
  integer(kind=4),            intent(out) :: work(nxout,nyout)  !
  ! Local
  integer(kind=index_length) :: i1,j1,i2,j2,i,j,in,jn
  !
  ! Reset cross correlation to zero
  do j=1,nyout
    do i=1,nxout
      out(i,j) = 0.
    enddo
  enddo
  do j=1,nyout
    do i=1,nxout
      work(i,j) = 0
    enddo
  enddo
  !
  ! Compute
  in = nxout/2
  jn = nyout/2
  do j1 = 1, nyin1
    do i1 = 1, nxin1
      if (abs(in1(i1,j1)-bval1).gt.eval1) then
        do j2 = 1, nyin2
          j = j1-j2+jn
          if (j.ge.1 .and. j.le.nyout) then
            do i2 = 1, nxin2
              i = i1-i2+in
              if (i.ge.1 .and. i.le.nxout) then
                if (abs(in2(i2,j2)-bval2).gt.eval2) then
                  out(i,j) = out(i,j) +   &
                             in1(i1,j1)*in2(i2,j2)
                  work(i,j) = work(i,j)+1
                endif
              endif
            enddo
          endif
        enddo
      endif
    enddo
  enddo
  !
  ! Normalise
  do j=1,nyout
    do i=1,nxout
      if (work(i,j).ne.0) out(i,j) = out(i,j)/work(i,j)
    enddo
  enddo
end subroutine do_correl
!
subroutine do_square(in1,nxin1,nyin1,bval1,eval1,  &
                     in2,nxin2,nyin2,bval2,eval2,  &
                     out,nxout,nyout,work)
  use gildas_def
  integer(kind=index_length), intent(in)  :: nxin1              !
  integer(kind=index_length), intent(in)  :: nyin1              !
  real(kind=4),               intent(in)  :: in1(nxin1,nyin1)   !
  real(kind=4),               intent(in)  :: bval1              !
  real(kind=4),               intent(in)  :: eval1              !
  integer(kind=index_length), intent(in)  :: nxin2              !
  integer(kind=index_length), intent(in)  :: nyin2              !
  real(kind=4),               intent(in)  :: in2(nxin2,nyin2)   !
  real(kind=4),               intent(in)  :: bval2              !
  real(kind=4),               intent(in)  :: eval2              !
  integer(kind=index_length), intent(in)  :: nxout              !
  integer(kind=index_length), intent(in)  :: nyout              !
  real(kind=4),               intent(out) :: out(nxout,nyout)   !
  integer(kind=4),            intent(out) :: work(nxout,nyout)  !
  ! Local
  integer(kind=index_length) :: i1,j1,i2,j2,i,j,in,jn
  !
  ! Reset cross correlation to zero
  do j=1,nyout
    do i=1,nxout
      out(i,j) = 0.
    enddo
  enddo
  do j=1,nyout
    do i=1,nxout
      work(i,j) = 0
    enddo
  enddo
  !
  in = nxout/2
  jn = nyout/2
  do j1 = 1, nyin1
    do i1 = 1, nxin1
      if (abs(in1(i1,j1)-bval1).gt.eval1) then
        do j2 = 1, nyin2
          j = j1-j2+jn
          if (j.ge.1 .and. j.le.nyout) then
            do i2 = 1, nxin2
              i = i1-i2+in
              if (i.ge.1 .and. i.le.nxout) then
                if (abs(in2(i2,j2)-bval2).gt.eval2) then
                  out(i,j) = out(i,j) -   &
                            (in1(i1,j1)-in2(i2,j2))**2
                  work(i,j) = work(i,j)+1
                endif
              endif
            enddo
          endif
        enddo
      endif
    enddo
  enddo
  !
  ! Normalise
  do j=1,nyout
    do i=1,nxout
      if (work(i,j).ne.0) then
        out(i,j) = out(i,j)/work(i,j)
      else
        out(i,j) = 1.0
      endif
    enddo
  enddo
end subroutine do_square

subroutine gio_syscod (sycode)
  !---------------------------------------------------------------------
  ! @ private
  !   Return the GILDAS "System" code, '-', '_', or '.'
  !---------------------------------------------------------------------
  character(len=1), intent(out) :: sycode   ! Returned code
#if defined(VAX)
  sycode = '_'
#endif
#if defined(IEEE)
  sycode = '-'
#endif
#if defined(EEEI)
  sycode = '.'
#endif
end subroutine gio_syscod
!
subroutine gdf_getcod (csyst)
  !---------------------------------------------------------------------
  ! @ public
  !   Return the "System" code in a comprehensible string. 
  !---------------------------------------------------------------------
  character(len=4), intent(out) :: csyst  ! Code
#if defined(VAX)
  csyst = 'VAX_'
#endif
#if defined(EEEI)
  csyst = 'EEEI'
#endif
#if defined(IEEE)
  csyst = 'IEEE'
#endif
end subroutine gdf_getcod
!
subroutine gdf_convcod (cfile,csyst,conver)
  use gio_interfaces, only : gio_message
  use gio_convert
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !   Determine the conversion code to be applied
  !   between cfile (the data file) and csyst (the current OS code)
  !   Return 0 if no conversion
  !---------------------------------------------------------------------
  character(len=4), intent(in) :: cfile         ! File Gildas system code
  character(len=4), intent(in) :: csyst         ! Operating system Gildas code
  integer, intent(out) :: conver                ! Conversion code
  !
  conver = unknown
  if (cfile.eq.csyst) then
    conver = 0
  else
    if (cfile.eq.'VAX_') then
      if (csyst.eq.'IEEE') then
        conver = vax_to_ieee
      elseif (csyst.eq.'EEEI') then
        conver = vax_to_eeei
      endif
    elseif (cfile.eq.'IEEE') then
      if (csyst.eq.'VAX_') then
        conver = ieee_to_vax
      elseif (csyst.eq.'EEEI') then
        conver = ieee_to_eeei
      endif
    elseif (cfile.eq.'EEEI') then
      if (csyst.eq.'VAX_') then
        conver = eeei_to_vax
      elseif (csyst.eq.'IEEE') then
        conver = eeei_to_ieee
      endif
    endif
    call gio_message(seve%i,'GDF','Converting from '//cfile//' to '//csyst)
  endif
end subroutine gdf_convcod
!
subroutine gdf_conversion(code,conver)
  use gio_convert
  !---------------------------------------------------------------------
  ! @ public
  !   Translate a Gildas conversion code into a human readable string. 
  !---------------------------------------------------------------------
  integer, intent(in) :: code                   ! Conversion code
  character(len=*), intent(out) :: conver       ! Name of conversion
  ! Local
  character(len=20) :: conversion (0:mconve)
  data conversion /' [Native]',          &
    ' [VAX to IEEE]', ' [IEEE to VAX]',  &
    ' [VAX to EEEI]', ' [EEEI to VAX]',  &
    ' [IEEE to EEEI]',' [EEEI to IEEE]'/
  !
  if (code.ge.0 .and. code.le.mconve) then
    conver = conversion(code)
  else
    conver = '[Unknown]'
  endif
end subroutine gdf_conversion
!
function gdf_conv (in,ou,n,oufmt,infmt)
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Perform automatic format conversion for a Buffer
  !---------------------------------------------------------------------
  integer(kind=4) :: gdf_conv       ! Return code (1 Success, 0 Error)
  integer, intent(in) :: n          ! Number of 32-bit Words
  integer, intent(in) :: in(n)      ! Input buffer
  integer, intent(out) :: ou(n)     ! Output buffer
  integer, intent(in) :: oufmt      ! Output format
  integer, intent(in) :: infmt      ! Input format
  gdf_conv = 1
  !
  if (oufmt.eq.iee_r4) then
    if (infmt.eq.vax_r4) then
      call var4ie (in,ou,n)
    elseif (infmt.eq.eei_r4) then
      call eir4ie (in,ou,n)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.iee_r8) then
    if (infmt.eq.vax_r8) then
      call var8ie (in,ou,n/2)
    elseif (infmt.eq.eei_r8) then
      call eir8ie (in,ou,n/2)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.iee_c4) then
    if (infmt.eq.eei_c4) then
      call eir4ie (in,ou,n)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.eei_r4) then
    if (infmt.eq.iee_r4) then
      call ier4ei (in,ou,n)
    elseif (infmt.eq.vax_r4) then
      call var4ei (in,ou,n)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.eei_r8) then
    if (infmt.eq.iee_r8) then
      call ier8ei(in,ou,n/2)
    elseif (infmt.eq.vax_r8) then
      call var8ei (in,ou,n/2)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.eei_c4) then
    if (infmt.eq.iee_c4) then
      call ier4ei (in,ou,n)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.vax_r4) then
    if (infmt.eq.iee_r4) then
      call ier4va (in,ou,n)
    elseif (infmt.eq.eei_r4) then
      call eir4va (in,ou,n)
    elseif (infmt.eq.fmt_i4) then
      call i4tor4 (in,ou,n)
      !         elseif (infmt.eq.vax_r8) then
      !            call r8tor4 (in,ou,n)
    else
      gdf_conv = 0
    endif
  elseif (oufmt.eq.vax_r8) then
    if (infmt.eq.iee_r8) then
      call ier8va (in,ou,n/2)
    elseif (infmt.eq.eei_r8) then
      call eir8va (in,ou,n/2)
      !         elseif (infmt.eq.fmt_i4) then
      !            call i4tor8 (in,ou,n)
      !         elseif (infmt.eq.vax_r4) then
      !            call r4tor8 (in,ou,n)
    else
      gdf_conv = 0
    endif
  else
    gdf_conv = 0
  endif
end function gdf_conv

*DECK SUDS
      SUBROUTINE SUDS (A, X, B, NEQ, NUK, NRDA, IFLAG, MLSO, WORK,
     +   IWORK)
C***BEGIN PROLOGUE  SUDS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SUDS-S, DSUDS-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     SUDS solves the underdetermined system of linear equations A Z = B
C     where A is NEQ by NUK and NEQ .LE. NUK. In particular, if rank A
C     equals IRA, a vector X and a matrix U are determined such that
C     X is the UNIQUE solution of smallest length, satisfying A X = B,
C     and the columns of U form an orthonormal basis for the null
C     space of A, satisfying A U = 0 . Then all solutions Z are
C     given by
C              Z = X + C(1)*U(1) + ..... + C(NUK-IRA)*U(NUK-IRA)
C     where U(J) represents the J-th column of U and the C(J) are
C     arbitrary constants.
C     If the system of equations are not compatible, only the least
C     squares solution of minimal length is computed.
C     SUDS is an interfacing routine which calls subroutine LSSUDS
C     for the solution. LSSUDS in turn calls subroutine ORTHOR and
C     possibly subroutine OHTROL for the decomposition of A by
C     orthogonal transformations. In the process, ORTHOR calls upon
C     subroutine CSCALE for scaling.
C
C **********************************************************************
C   INPUT
C **********************************************************************
C
C     A -- Contains the matrix of NEQ equations in NUK unknowns and must
C          be dimensioned NRDA by NUK. The original A is destroyed.
C     X -- Solution array of length at least NUK
C     B -- Given constant vector of length NEQ, B is destroyed
C     NEQ -- Number of equations, NEQ greater or equal to 1
C     NUK -- Number of columns in the matrix (which is also the number
C            of unknowns), NUK not smaller than NEQ
C     NRDA -- Row dimension of A, NRDA greater or equal to NEQ
C     IFLAG -- Status indicator
C           =0  For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is treated as exact
C           =-K For the first call (and for each new problem defined by
C               a new matrix A) when the matrix data is assumed to be
C               accurate to about K digits
C           =1  For subsequent calls whenever the matrix A has already
C               been decomposed (problems with new vectors B but
C               same matrix A can be handled efficiently)
C     MLSO -- =0 If only the minimal length solution is wanted
C             =1 If the complete solution is wanted, includes the
C                linear space defined by the matrix U in the abstract
C     WORK(*),IWORK(*) -- Arrays for storage of internal information,
C                WORK must be dimensioned at least
C                       NUK + 3*NEQ + MLSO*NUK*(NUK-rank A)
C                where it is possible for   0 .LE. rank A .LE. NEQ
C                IWORK must be dimensioned at least   3 + NEQ
C     IWORK(2) -- Scaling indicator
C                 =-1 If the matrix is to be pre-scaled by
C                 columns when appropriate
C                 If the scaling indicator is not equal to -1
C                 no scaling will be attempted
C              For most problems scaling will probably not be necessary
C
C **********************************************************************
C   OUTPUT
C **********************************************************************
C
C     IFLAG -- Status indicator
C            =1 If solution was obtained
C            =2 If improper input is detected
C            =3 If rank of matrix is less than NEQ
C               To continue simply reset IFLAG=1 and call SUDS again
C            =4 If the system of equations appears to be inconsistent.
C               However, the least squares solution of minimal length
C               was obtained.
C     X -- Minimal length least squares solution of  A X = B
C     A -- Contains the strictly upper triangular part of the reduced
C           matrix and transformation information
C     WORK(*),IWORK(*) -- Contains information needed on subsequent
C                         calls (IFLAG=1 case on input) which must not
C                         be altered.
C                         The matrix U described in the abstract is
C                         stored in the  NUK*(NUK-rank A) elements of
C                         the work array beginning at WORK(1+NUK+3*NEQ).
C                         However U is not defined when MLSO=0 or
C                         IFLAG=4.
C                         IWORK(1) Contains the numerically determined
C                         rank of the matrix A
C
C **********************************************************************
C
C***SEE ALSO  BVSUP
C***REFERENCES  H. A. Watts, Solving linear least squares problems
C                 using SODS/SUDS/CODS, Sandia Report SAND77-0683,
C                 Sandia Laboratories, 1977.
C***ROUTINES CALLED  LSSUDS
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910408  Updated the AUTHOR and REFERENCES sections.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SUDS
      DIMENSION A(NRDA,*),X(*),B(*),WORK(*),IWORK(*)
C
C***FIRST EXECUTABLE STATEMENT  SUDS
      IS=2
      IP=3
      IL=IP+NEQ
      KV=1+NEQ
      KT=KV+NEQ
      KS=KT+NEQ
      KU=KS+NUK
C
      CALL LSSUDS(A,X,B,NEQ,NUK,NRDA,WORK(KU),NUK,IFLAG,MLSO,IWORK(1),
     1            IWORK(IS),A,WORK(1),IWORK(IP),B,WORK(KV),WORK(KT),
     2            IWORK(IL),WORK(KS))
C
      RETURN
      END
*DECK SVCO
      SUBROUTINE SVCO (RSAV, ISAV)
C***BEGIN PROLOGUE  SVCO
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DEBDF
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SVCO-S, DSVCO-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   SVCO transfers data from a common block to arrays within the
C   integrator package DEBDF.
C
C***SEE ALSO  DEBDF
C***ROUTINES CALLED  (NONE)
C***COMMON BLOCKS    DEBDF1
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SVCO
C
C
C-----------------------------------------------------------------------
C THIS ROUTINE STORES IN RSAV AND ISAV THE CONTENTS OF COMMON BLOCK
C DEBDF1  , WHICH IS USED INTERNALLY IN THE DEBDF PACKAGE.
C
C RSAV = REAL ARRAY OF LENGTH 218 OR MORE.
C ISAV = INTEGER ARRAY OF LENGTH 33 OR MORE.
C-----------------------------------------------------------------------
      INTEGER ISAV, I,      ILS, LENILS, LENRLS
      REAL RSAV, RLS
      DIMENSION RSAV(*), ISAV(*)
      COMMON /DEBDF1/ RLS(218), ILS(33)
      SAVE LENRLS, LENILS
      DATA LENRLS/218/, LENILS/33/
C
C***FIRST EXECUTABLE STATEMENT  SVCO
      DO 10 I = 1,LENRLS
 10     RSAV(I) = RLS(I)
      DO 20 I = 1,LENILS
 20     ISAV(I) = ILS(I)
      RETURN
C----------------------- END OF SUBROUTINE SVCO -----------------------
      END
*DECK SVD
      SUBROUTINE SVD (NM, M, N, A, W, MATU, U, MATV, V, IERR, RV1)
C***BEGIN PROLOGUE  SVD
C***SUBSIDIARY
C***PURPOSE  Perform the singular value decomposition of a rectangular
C            matrix.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SVD-S)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine is a translation of the ALGOL procedure SVD,
C     NUM. MATH. 14, 403-420(1970) by Golub and Reinsch.
C     HANDBOOK FOR AUTO. COMP., VOL II-LINEAR ALGEBRA, 134-151(1971).
C
C     This subroutine determines the singular value decomposition
C          T
C     A=USV  of a REAL M by N rectangular matrix.  Householder
C     bidiagonalization and a variant of the QR algorithm are used.
C
C     On Input
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, A, U and V, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C          Note that NM must be at least as large as the maximum
C          of M and N.
C
C        M is the number of rows of A and U.
C
C        N is the number of columns of A and U and the order of V.
C
C        A contains the rectangular input matrix to be decomposed.  A is
C          a two-dimensional REAL array, dimensioned A(NM,N).
C
C        MATU should be set to .TRUE. if the U matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C          MATU is a LOGICAL variable.
C
C        MATV should be set to .TRUE. if the V matrix in the
C          decomposition is desired, and to .FALSE. otherwise.
C          MATV is a LOGICAL variable.
C
C     On Output
C
C        A is unaltered (unless overwritten by U or V).
C
C        W contains the N (non-negative) singular values of A (the
C          diagonal elements of S).  They are unordered.  If an
C          error exit is made, the singular values should be correct
C          for indices IERR+1, IERR+2, ..., N.  W is a one-dimensional
C          REAL array, dimensioned W(N).
C
C        U contains the matrix U (orthogonal column vectors) of the
C          decomposition if MATU has been set to .TRUE.  Otherwise,
C          U is used as a temporary array.  U may coincide with A.
C          If an error exit is made, the columns of U corresponding
C          to indices of correct singular values should be correct.
C          U is a two-dimensional REAL array, dimensioned U(NM,N).
C
C        V contains the matrix V (orthogonal) of the decomposition if
C          MATV has been set to .TRUE.  Otherwise, V is not referenced.
C          V may also coincide with A if U does not.  If an error
C          exit is made, the columns of V corresponding to indices of
C          correct singular values should be correct.  V is a two-
C          dimensional REAL array, dimensioned V(NM,N).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          K          if the K-th singular value has not been
C                     determined after 30 iterations.
C
C        RV1 is a one-dimensional REAL array used for temporary storage,
C          dimensioned RV1(N).
C
C     CALLS PYTHAG(A,B) for sqrt(A**2 + B**2).
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***SEE ALSO  EISDOC
C***ROUTINES CALLED  PYTHAG
C***REVISION HISTORY  (YYMMDD)
C   811101  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C***END PROLOGUE  SVD
C
      INTEGER I,J,K,L,M,N,II,I1,KK,K1,LL,L1,MN,NM,ITS,IERR
      REAL A(NM,*),W(*),U(NM,*),V(NM,*),RV1(*)
      REAL C,F,G,H,S,X,Y,Z,SCALE,S1
      REAL PYTHAG
      LOGICAL MATU,MATV
C
C***FIRST EXECUTABLE STATEMENT  SVD
      IERR = 0
C
      DO 100 I = 1, M
C
         DO 100 J = 1, N
            U(I,J) = A(I,J)
  100 CONTINUE
C     .......... HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM ..........
      G = 0.0E0
      SCALE = 0.0E0
      S1 = 0.0E0
C
      DO 300 I = 1, N
         L = I + 1
         RV1(I) = SCALE * G
         G = 0.0E0
         S = 0.0E0
         SCALE = 0.0E0
         IF (I .GT. M) GO TO 210
C
         DO 120 K = I, M
  120    SCALE = SCALE + ABS(U(K,I))
C
         IF (SCALE .EQ. 0.0E0) GO TO 210
C
         DO 130 K = I, M
            U(K,I) = U(K,I) / SCALE
            S = S + U(K,I)**2
  130    CONTINUE
C
         F = U(I,I)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,I) = F - G
         IF (I .EQ. N) GO TO 190
C
         DO 150 J = L, N
            S = 0.0E0
C
            DO 140 K = I, M
  140       S = S + U(K,I) * U(K,J)
C
            F = S / H
C
            DO 150 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  150    CONTINUE
C
  190    DO 200 K = I, M
  200    U(K,I) = SCALE * U(K,I)
C
  210    W(I) = SCALE * G
         G = 0.0E0
         S = 0.0E0
         SCALE = 0.0E0
         IF (I .GT. M .OR. I .EQ. N) GO TO 290
C
         DO 220 K = L, N
  220    SCALE = SCALE + ABS(U(I,K))
C
         IF (SCALE .EQ. 0.0E0) GO TO 290
C
         DO 230 K = L, N
            U(I,K) = U(I,K) / SCALE
            S = S + U(I,K)**2
  230    CONTINUE
C
         F = U(I,L)
         G = -SIGN(SQRT(S),F)
         H = F * G - S
         U(I,L) = F - G
C
         DO 240 K = L, N
  240    RV1(K) = U(I,K) / H
C
         IF (I .EQ. M) GO TO 270
C
         DO 260 J = L, M
            S = 0.0E0
C
            DO 250 K = L, N
  250       S = S + U(J,K) * U(I,K)
C
            DO 260 K = L, N
               U(J,K) = U(J,K) + S * RV1(K)
  260    CONTINUE
C
  270    DO 280 K = L, N
  280    U(I,K) = SCALE * U(I,K)
C
  290    S1 = MAX(S1,ABS(W(I))+ABS(RV1(I)))
  300 CONTINUE
C     .......... ACCUMULATION OF RIGHT-HAND TRANSFORMATIONS ..........
      IF (.NOT. MATV) GO TO 410
C     .......... FOR I=N STEP -1 UNTIL 1 DO -- ..........
      DO 400 II = 1, N
         I = N + 1 - II
         IF (I .EQ. N) GO TO 390
         IF (G .EQ. 0.0E0) GO TO 360
C
         DO 320 J = L, N
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
  320    V(J,I) = (U(I,J) / U(I,L)) / G
C
         DO 350 J = L, N
            S = 0.0E0
C
            DO 340 K = L, N
  340       S = S + U(I,K) * V(K,J)
C
            DO 350 K = L, N
               V(K,J) = V(K,J) + S * V(K,I)
  350    CONTINUE
C
  360    DO 380 J = L, N
            V(I,J) = 0.0E0
            V(J,I) = 0.0E0
  380    CONTINUE
C
  390    V(I,I) = 1.0E0
         G = RV1(I)
         L = I
  400 CONTINUE
C     .......... ACCUMULATION OF LEFT-HAND TRANSFORMATIONS ..........
  410 IF (.NOT. MATU) GO TO 510
C     ..........FOR I=MIN(M,N) STEP -1 UNTIL 1 DO -- ..........
      MN = N
      IF (M .LT. N) MN = M
C
      DO 500 II = 1, MN
         I = MN + 1 - II
         L = I + 1
         G = W(I)
         IF (I .EQ. N) GO TO 430
C
         DO 420 J = L, N
  420    U(I,J) = 0.0E0
C
  430    IF (G .EQ. 0.0E0) GO TO 475
         IF (I .EQ. MN) GO TO 460
C
         DO 450 J = L, N
            S = 0.0E0
C
            DO 440 K = L, M
  440       S = S + U(K,I) * U(K,J)
C     .......... DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW ..........
            F = (S / U(I,I)) / G
C
            DO 450 K = I, M
               U(K,J) = U(K,J) + F * U(K,I)
  450    CONTINUE
C
  460    DO 470 J = I, M
  470    U(J,I) = U(J,I) / G
C
         GO TO 490
C
  475    DO 480 J = I, M
  480    U(J,I) = 0.0E0
C
  490    U(I,I) = U(I,I) + 1.0E0
  500 CONTINUE
C     .......... DIAGONALIZATION OF THE BIDIAGONAL FORM ..........
  510 CONTINUE
C     .......... FOR K=N STEP -1 UNTIL 1 DO -- ..........
      DO 700 KK = 1, N
         K1 = N - KK
         K = K1 + 1
         ITS = 0
C     .......... TEST FOR SPLITTING.
C                FOR L=K STEP -1 UNTIL 1 DO -- ..........
  520    DO 530 LL = 1, K
            L1 = K - LL
            L = L1 + 1
            IF (S1 + ABS(RV1(L)) .EQ. S1) GO TO 565
C     .......... RV1(1) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP ..........
            IF (S1 + ABS(W(L1)) .EQ. S1) GO TO 540
  530    CONTINUE
C     .......... CANCELLATION OF RV1(L) IF L GREATER THAN 1 ..........
  540    C = 0.0E0
         S = 1.0E0
C
         DO 560 I = L, K
            F = S * RV1(I)
            RV1(I) = C * RV1(I)
            IF (S1 + ABS(F) .EQ. S1) GO TO 565
            G = W(I)
            H = PYTHAG(F,G)
            W(I) = H
            C = G / H
            S = -F / H
            IF (.NOT. MATU) GO TO 560
C
            DO 550 J = 1, M
               Y = U(J,L1)
               Z = U(J,I)
               U(J,L1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  550       CONTINUE
C
  560    CONTINUE
C     .......... TEST FOR CONVERGENCE ..........
  565    Z = W(K)
         IF (L .EQ. K) GO TO 650
C     .......... SHIFT FROM BOTTOM 2 BY 2 MINOR ..........
         IF (ITS .EQ. 30) GO TO 1000
         ITS = ITS + 1
         X = W(L)
         Y = W(K1)
         G = RV1(K1)
         H = RV1(K)
         F = 0.5E0 * (((G + Z) / H) * ((G - Z) / Y) + Y / H - H / Y)
         G = PYTHAG(F,1.0E0)
         F = X - (Z / X) * Z + (H / X) * (Y / (F + SIGN(G,F)) - H)
C     .......... NEXT QR TRANSFORMATION ..........
         C = 1.0E0
         S = 1.0E0
C
         DO 600 I1 = L, K1
            I = I1 + 1
            G = RV1(I)
            Y = W(I)
            H = S * G
            G = C * G
            Z = PYTHAG(F,H)
            RV1(I1) = Z
            C = F / Z
            S = H / Z
            F = X * C + G * S
            G = -X * S + G * C
            H = Y * S
            Y = Y * C
            IF (.NOT. MATV) GO TO 575
C
            DO 570 J = 1, N
               X = V(J,I1)
               Z = V(J,I)
               V(J,I1) = X * C + Z * S
               V(J,I) = -X * S + Z * C
  570       CONTINUE
C
  575       Z = PYTHAG(F,H)
            W(I1) = Z
C     .......... ROTATION CAN BE ARBITRARY IF Z IS ZERO ..........
            IF (Z .EQ. 0.0E0) GO TO 580
            C = F / Z
            S = H / Z
  580       F = C * G + S * Y
            X = -S * G + C * Y
            IF (.NOT. MATU) GO TO 600
C
            DO 590 J = 1, M
               Y = U(J,I1)
               Z = U(J,I)
               U(J,I1) = Y * C + Z * S
               U(J,I) = -Y * S + Z * C
  590       CONTINUE
C
  600    CONTINUE
C
         RV1(L) = 0.0E0
         RV1(K) = F
         W(K) = X
         GO TO 520
C     .......... CONVERGENCE ..........
  650    IF (Z .GE. 0.0E0) GO TO 700
C     .......... W(K) IS MADE NON-NEGATIVE ..........
         W(K) = -Z
         IF (.NOT. MATV) GO TO 700
C
         DO 690 J = 1, N
  690    V(J,K) = -V(J,K)
C
  700 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- NO CONVERGENCE TO A
C                SINGULAR VALUE AFTER 30 ITERATIONS ..........
 1000 IERR = K
 1001 RETURN
      END
*DECK SVECS
      SUBROUTINE SVECS (NCOMP, LNFC, YHP, WORK, IWORK, INHOMO, IFLAG)
C***BEGIN PROLOGUE  SVECS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to BVSUP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SVECS-S, DVECS-D)
C***AUTHOR  Watts, H. A., (SNLA)
C***DESCRIPTION
C
C  This subroutine is used for the special structure of complex valued
C  problems. MGSBV is called upon to obtain LNFC vectors from an
C  original set of 2*LNFC independent vectors so that the resulting
C  LNFC vectors together with their imaginary product or mate vectors
C  form an independent set.
C
C***SEE ALSO  BVSUP
C***ROUTINES CALLED  MGSBV
C***COMMON BLOCKS    ML18JR
C***REVISION HISTORY  (YYMMDD)
C   750601  DATE WRITTEN
C   890921  Realigned order of variables in certain COMMON blocks.
C           (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   910722  Updated AUTHOR section.  (ALS)
C***END PROLOGUE  SVECS
C
      DIMENSION YHP(NCOMP,*),WORK(*),IWORK(*)
      COMMON /ML18JR/ AE,RE,TOL,NXPTS,NIC,NOPG,MXNON,NDISK,NTAPE,NEQ,
     1                INDPVT,INTEG,NPS,NTP,NEQIVP,NUMORT,LNFCC,
     2                ICOCO
C***FIRST EXECUTABLE STATEMENT  SVECS
      IF (LNFC .EQ. 1) GO TO 5
      NIV=LNFC
      LNFC=2*LNFC
      LNFCC=2*LNFCC
      KP=LNFC+2+LNFCC
      IDP=INDPVT
      INDPVT=0
      CALL MGSBV(NCOMP,LNFC,YHP,NCOMP,NIV,IFLAG,WORK(1),WORK(KP),
     1         IWORK(1),INHOMO,YHP(1,LNFC+1),WORK(LNFC+2),DUM)
      LNFC=LNFC/2
      LNFCC=LNFCC/2
      INDPVT=IDP
      IF (IFLAG .EQ. 0  .AND.  NIV .EQ. LNFC) GO TO 5
      IFLAG=99
      RETURN
    5 DO 6 K=1,NCOMP
    6 YHP(K,LNFC+1)=YHP(K,LNFCC+1)
      IFLAG=1
      RETURN
      END
*DECK SVOUT
      SUBROUTINE SVOUT (N, SX, IFMT, IDIGIT)
C***BEGIN PROLOGUE  SVOUT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SVOUT-S, DVOUT-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     SINGLE PRECISION VECTOR OUTPUT ROUTINE.
C
C  INPUT..
C
C  N,SX(*) PRINT THE SINGLE PRECISION ARRAY SX(I),I=1,...,N, ON
C          OUTPUT UNIT LOUT. THE HEADING IN THE FORTRAN FORMAT
C          STATEMENT IFMT(*), DESCRIBED BELOW, IS PRINTED AS A FIRST
C          STEP. THE COMPONENTS SX(I) ARE INDEXED, ON OUTPUT,
C          IN A PLEASANT FORMAT.
C  IFMT(*) A FORTRAN FORMAT STATEMENT. THIS IS PRINTED ON OUTPUT
C          UNIT LOUT WITH THE VARIABLE FORMAT FORTRAN STATEMENT
C                WRITE(LOUT,IFMT)
C  IDIGIT  PRINT AT LEAST ABS(IDIGIT) DECIMAL DIGITS PER NUMBER.
C          THE SUBPROGRAM WILL CHOOSE THAT INTEGER 4,6,10 OR 14
C          WHICH WILL PRINT AT LEAST ABS(IDIGIT) NUMBER OF
C          PLACES.  IF IDIGIT.LT.0, 72 PRINTING COLUMNS ARE UTILIZED
C          TO WRITE EACH LINE OF OUTPUT OF THE ARRAY SX(*). (THIS
C          CAN BE USED ON MOST TIME-SHARING TERMINALS). IF
C          IDIGIT.GE.0, 133 PRINTING COLUMNS ARE UTILIZED. (THIS CAN
C          BE USED ON MOST LINE PRINTERS).
C
C  EXAMPLE..
C
C  PRINT AN ARRAY CALLED (COSTS OF PURCHASES) OF LENGTH 100 SHOWING
C  6 DECIMAL DIGITS PER NUMBER. THE USER IS RUNNING ON A TIME-SHARING
C  SYSTEM WITH A 72 COLUMN OUTPUT DEVICE.
C
C     DIMENSION COSTS(100)
C     N = 100
C     IDIGIT = -6
C     CALL SVOUT(N,COSTS,'(''1COSTS OF PURCHASES'')',IDIGIT)
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  I1MACH
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   891107  Added comma after 1P edit descriptor in FORMAT
C           statements.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  SVOUT
      DIMENSION SX(*)
      CHARACTER IFMT*(*)
C
C     GET THE UNIT NUMBER WHERE OUTPUT WILL BE WRITTEN.
C***FIRST EXECUTABLE STATEMENT  SVOUT
      J=2
      LOUT=I1MACH(J)
      WRITE(LOUT,IFMT)
      IF(N.LE.0) RETURN
      NDIGIT = IDIGIT
      IF(IDIGIT.EQ.0) NDIGIT = 4
      IF(IDIGIT.GE.0) GO TO 80
C
      NDIGIT = -IDIGIT
      IF(NDIGIT.GT.4) GO TO 20
C
      DO 10 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1000) K1,K2,(SX(I),I=K1,K2)
   10 CONTINUE
      RETURN
C
   20 CONTINUE
      IF(NDIGIT.GT.6) GO TO 40
C
      DO 30 K1=1,N,4
      K2 = MIN(N,K1+3)
      WRITE(LOUT,1001) K1,K2,(SX(I),I=K1,K2)
   30 CONTINUE
      RETURN
C
   40 CONTINUE
      IF(NDIGIT.GT.10) GO TO 60
C
      DO 50 K1=1,N,3
      K2=MIN(N,K1+2)
      WRITE(LOUT,1002) K1,K2,(SX(I),I=K1,K2)
   50 CONTINUE
      RETURN
C
   60 CONTINUE
      DO 70 K1=1,N,2
      K2 = MIN(N,K1+1)
      WRITE(LOUT,1003) K1,K2,(SX(I),I=K1,K2)
   70 CONTINUE
      RETURN
C
   80 CONTINUE
      IF(NDIGIT.GT.4) GO TO 100
C
      DO 90 K1=1,N,10
      K2 = MIN(N,K1+9)
      WRITE(LOUT,1000) K1,K2,(SX(I),I=K1,K2)
   90 CONTINUE
      RETURN
C
  100 CONTINUE
      IF(NDIGIT.GT.6) GO TO 120
C
      DO 110 K1=1,N,8
      K2 = MIN(N,K1+7)
      WRITE(LOUT,1001) K1,K2,(SX(I),I=K1,K2)
  110 CONTINUE
      RETURN
C
  120 CONTINUE
      IF(NDIGIT.GT.10) GO TO 140
C
      DO 130 K1=1,N,6
      K2 = MIN(N,K1+5)
      WRITE(LOUT,1002) K1,K2,(SX(I),I=K1,K2)
  130 CONTINUE
      RETURN
C
  140 CONTINUE
      DO 150 K1=1,N,5
      K2 = MIN(N,K1+4)
      WRITE(LOUT,1003) K1,K2,(SX(I),I=K1,K2)
  150 CONTINUE
      RETURN
 1000 FORMAT(1X,I4,' - ',I4,1P,10E12.3)
 1001 FORMAT(1X,I4,' - ',I4,1X,1P,8E14.5)
 1002 FORMAT(1X,I4,' - ',I4,1X,1P,6E18.9)
 1003 FORMAT(1X,I4,' - ',I4,1X,1P,5E24.13)
      END
*DECK SWRITP
      SUBROUTINE SWRITP (IPAGE, LIST, RLIST, LPAGE, IREC)
C***BEGIN PROLOGUE  SWRITP
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SWRITP-S, DWRITP-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     WRITE RECORD NUMBER IRECN, OF LENGTH LPG, FROM STORAGE
C     ARRAY LIST(*) ONTO UNIT NUMBER IPAGEF.
C     WRITE RECORD NUMBER IRECN+1, OF LENGTH LPG, ONTO UNIT
C     NUMBER IPAGEF FROM THE STORAGE ARRAY RLIST(*).
C
C     TO CHANGE THIS PROGRAM UNIT TO DOUBLE PRECISION CHANGE
C     /REAL (12 BLANKS)/ TO /DOUBLE PRECISION/.
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   890605  Corrected references to XERRWV.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  SWRITP
      INTEGER LIST(*)
      REAL             RLIST(*)
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  SWRITP
      IPAGEF=IPAGE
      LPG   =LPAGE
      IRECN =IREC
      WRITE(IPAGEF,REC=IRECN,ERR=100)(LIST(I),I=1,LPG)
      WRITE(IPAGEF,REC=IRECN+1,ERR=100)(RLIST(I),I=1,LPG)
      RETURN
C
  100 WRITE (XERN1, '(I8)') LPG
      WRITE (XERN2, '(I8)') IRECN
      CALL XERMSG ('SLATEC', 'SWRITP', 'IN SPLP, LGP = ' // XERN1 //
     *   ' IRECN = ' // XERN2, 100, 1)
      RETURN
      END
*DECK SXLCAL
      SUBROUTINE SXLCAL (N, LGMR, X, XL, ZL, HES, MAXLP1, Q, V, R0NRM,
     +   WK, SZ, JSCAL, JPRE, MSOLVE, NMSL, RPAR, IPAR, NELT, IA, JA, A,
     +   ISYM)
C***BEGIN PROLOGUE  SXLCAL
C***SUBSIDIARY
C***PURPOSE  Internal routine for SGMRES.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SXLCAL-S, DXLCAL-D)
C***KEYWORDS  GENERALIZED MINIMUM RESIDUAL, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Brown, Peter, (LLNL), pnbrown@llnl.gov
C           Hindmarsh, Alan, (LLNL), alanh@llnl.gov
C           Seager, Mark K., (LLNL), seager@llnl.gov
C             Lawrence Livermore National Laboratory
C             PO Box 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C***DESCRIPTION
C        This  routine computes the solution  XL,  the current SGMRES
C        iterate, given the  V(I)'s and  the  QR factorization of the
C        Hessenberg  matrix HES.   This routine  is  only called when
C        ITOL=11.
C
C *Usage:
C      INTEGER N, LGMR, MAXLP1, JSCAL, JPRE, NMSL, IPAR(USER DEFINED)
C      INTEGER NELT, IA(NELT), JA(NELT), ISYM
C      REAL X(N), XL(N), ZL(N), HES(MAXLP1,MAXL), Q(2*MAXL),
C     $     V(N,MAXLP1), R0NRM, WK(N), SZ(N), RPAR(USER DEFINED),
C     $     A(NELT)
C      EXTERNAL MSOLVE
C
C      CALL SXLCAL(N, LGMR, X, XL, ZL, HES, MAXLP1, Q, V, R0NRM,
C     $     WK, SZ, JSCAL, JPRE, MSOLVE, NMSL, RPAR, IPAR,
C     $     NELT, IA, JA, A, ISYM)
C
C *Arguments:
C N      :IN       Integer
C         The order of the matrix A, and the lengths
C         of the vectors SR, SZ, R0 and Z.
C LGMR   :IN       Integer
C         The number of iterations performed and
C         the current order of the upper Hessenberg
C         matrix HES.
C X      :IN       Real X(N)
C         The current approximate solution as of the last restart.
C XL     :OUT      Real XL(N)
C         An array of length N used to hold the approximate
C         solution X(L).
C         Warning: XL and ZL are the same array in the calling routine.
C ZL     :IN       Real ZL(N)
C         An array of length N used to hold the approximate
C         solution Z(L).
C HES    :IN       Real HES(MAXLP1,MAXL)
C         The upper triangular factor of the QR decomposition
C         of the (LGMR+1) by LGMR upper Hessenberg matrix whose
C         entries are the scaled inner-products of A*V(*,i) and V(*,k).
C MAXLP1 :IN       Integer
C         MAXLP1 = MAXL + 1, used for dynamic dimensioning of HES.
C         MAXL is the maximum allowable order of the matrix HES.
C Q      :IN       Real Q(2*MAXL)
C         A real array of length 2*MAXL containing the components
C         of the Givens rotations used in the QR decomposition
C         of HES.  It is loaded in SHEQR.
C V      :IN       Real V(N,MAXLP1)
C         The N by(LGMR+1) array containing the LGMR
C         orthogonal vectors V(*,1) to V(*,LGMR).
C R0NRM  :IN       Real
C         The scaled norm of the initial residual for the
C         current call to SPIGMR.
C WK     :IN       Real WK(N)
C         A real work array of length N.
C SZ     :IN       Real SZ(N)
C         A vector of length N containing the non-zero
C         elements of the diagonal scaling matrix for Z.
C JSCAL  :IN       Integer
C         A flag indicating whether arrays SR and SZ are used.
C         JSCAL=0 means SR and SZ are not used and the
C                 algorithm will perform as if all
C                 SR(i) = 1 and SZ(i) = 1.
C         JSCAL=1 means only SZ is used, and the algorithm
C                 performs as if all SR(i) = 1.
C         JSCAL=2 means only SR is used, and the algorithm
C                 performs as if all SZ(i) = 1.
C         JSCAL=3 means both SR and SZ are used.
C JPRE   :IN       Integer
C         The preconditioner type flag.
C MSOLVE :EXT      External.
C         Name of the routine which solves a linear system Mz = r for
C         z given r with the preconditioning matrix M (M is supplied via
C         RPAR and IPAR arrays.  The name of the MSOLVE routine must
C         be declared external in the calling program.  The calling
C         sequence to MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RPAR, IPAR)
C         Where N is the number of unknowns, R is the right-hand side
C         vector and Z is the solution upon return.  NELT, IA, JA, A and
C         ISYM are defined as below.  RPAR is a real array that can be
C         used to pass necessary preconditioning information and/or
C         workspace to MSOLVE.  IPAR is an integer work array for the
C         same purpose as RPAR.
C NMSL   :IN       Integer
C         The number of calls to MSOLVE.
C RPAR   :IN       Real RPAR(USER DEFINED)
C         Real workspace passed directly to the MSOLVE routine.
C IPAR   :IN       Integer IPAR(USER DEFINED)
C         Integer workspace passed directly to the MSOLVE routine.
C NELT   :IN       Integer
C         The length of arrays IA, JA and A.
C IA     :IN       Integer IA(NELT)
C         An integer array of length NELT containing matrix data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C JA     :IN       Integer JA(NELT)
C         An integer array of length NELT containing matrix data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C A      :IN       Real A(NELT)
C         A real array of length NELT containing matrix data.
C         It is passed directly to the MATVEC and MSOLVE routines.
C ISYM   :IN       Integer
C         A flag to indicate symmetric matrix storage.
C         If ISYM=0, all non-zero entries of the matrix are
C         stored.  If ISYM=1, the matrix is symmetric and
C         only the upper or lower triangular part is stored.
C
C***SEE ALSO  SGMRES
C***ROUTINES CALLED  SAXPY, SCOPY, SHELS
C***REVISION HISTORY  (YYMMDD)
C   871001  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MSOLVE from ROUTINES CALLED list.  (FNF)
C   910506  Made subsidiary to SGMRES.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C***END PROLOGUE  SXLCAL
C         The following is for optimized compilation on LLNL/LTSS Crays.
CLLL. OPTIMIZE
C     .. Scalar Arguments ..
      REAL R0NRM
      INTEGER ISYM, JPRE, JSCAL, LGMR, MAXLP1, N, NELT, NMSL
C     .. Array Arguments ..
      REAL A(NELT), HES(MAXLP1,*), Q(*), RPAR(*), SZ(*), V(N,*), WK(N),
     +     X(N), XL(N), ZL(N)
      INTEGER IA(NELT), IPAR(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MSOLVE
C     .. Local Scalars ..
      INTEGER I, K, LL, LLP1
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY, SHELS
C***FIRST EXECUTABLE STATEMENT  SXLCAL
      LL = LGMR
      LLP1 = LL + 1
      DO 10 K = 1,LLP1
         WK(K) = 0
 10   CONTINUE
      WK(1) = R0NRM
      CALL SHELS(HES, MAXLP1, LL, Q, WK)
      DO 20 K = 1,N
         ZL(K) = 0
 20   CONTINUE
      DO 30 I = 1,LL
         CALL SAXPY(N, WK(I), V(1,I), 1, ZL, 1)
 30   CONTINUE
      IF ((JSCAL .EQ. 1) .OR.(JSCAL .EQ. 3)) THEN
         DO 40 K = 1,N
            ZL(K) = ZL(K)/SZ(K)
 40      CONTINUE
      ENDIF
      IF (JPRE .GT. 0) THEN
         CALL SCOPY(N, ZL, 1, WK, 1)
         CALL MSOLVE(N, WK, ZL, NELT, IA, JA, A, ISYM, RPAR, IPAR)
         NMSL = NMSL + 1
      ENDIF
C         calculate XL from X and ZL.
      DO 50 K = 1,N
         XL(K) = X(K) + ZL(K)
 50   CONTINUE
      RETURN
C------------- LAST LINE OF SXLCAL FOLLOWS ----------------------------
      END

subroutine sic_accept(line,error)
  use gildas_def
  use gbl_message
  use gbl_format
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! SIC Support routine for command
  !   ACCEPT Var1 [Var2 [...]]
  !    3     [/COLUMN Filename [Separ]]
  !    4     [/FORMAT Form]
  !    5     [/LINE l1 l2]
  ! or
  !   ACCEPT Var1
  !    1 [/ARRAY  Filename]
  !    4 [/FORMAT Form]
  !    5 [/LINE l1 l2]
  ! or
  !   ACCEPT Var1
  !    2 [/BINARY Filename Offset]
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   !
  logical,          intent(out) :: error  !
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  integer(kind=4):: line1,line2,lun,iopt,ier,nc,nbyt
  integer(kind=index_length) :: i
  character(len=filename_length) :: datafile,chain
  !
  ! File name
  if (sic_present(1,0)) then
    ! /ARRAY option
    iopt = 1
    if (sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options /ARRAY and /COLUMN')
      error = .true.
      return
    elseif (sic_present(2,0)) then
      call sic_message(seve%e,rname,'Incompatible options /ARRAY and /BINARY')
      error = .true.
      return
    endif
  elseif (sic_present(2,0)) then
    ! /BINARY
    if (sic_present(3,0)) then
      call sic_message(seve%e,rname,'Incompatible options /BINARY and /COLUMN')
      error = .true.
      return
    else
      if (sic_present(4,0))  &
        call sic_message(seve%w,rname,'/FORMAT Option ignored with /BINARY')
      if (sic_present(5,0))  &
        call sic_message(seve%w,rname,'/LINE Option ignored with /BINARY')
    endif
    iopt = 2
  elseif (sic_present(3,0)) then
    ! /COLUMN
    iopt = 3
  else
    call sic_message(seve%e,rname,'Missing option /ARRAY, /BINARY or /COLUMN')
    error = .true.
    return
  endif
  call sic_ch (line,iopt,1,chain,nc,.true.,error)
  if (error) return
  call sic_parse_file (chain,' ','.dat',datafile)
  !
  ! Binary case
  if (iopt.eq.2) then
    ! Use Portable Code ?
    call gag_fillook (lun,datafile)
    if (lun.eq.-1) then
      error = .true.
      return
    endif
    nbyt = 0
    call sic_i4 (line,iopt,2,nbyt,.false.,error)
    if (error) goto 99
    if (nbyt.gt.0) then
      ier = gag_filseek (lun,nbyt)
      if (ier.eq.-1) then
        call gag_filclose (lun)
        call sic_message(seve%e,rname,'Skip error on binary file')
        error = .true.
        return
      endif
    endif
  else
    !
    ! Other cases
    ier = sic_getlun(lun)
    if (mod(ier,2).eq.0) then
      error = .true.
      return
    endif
    ier = sic_open(lun,datafile,'OLD',.true.)
    if (ier.ne.0) then
      call sic_message(seve%e,rname,'Error opening '//datafile)
      call putios('E-ACCEPT,  ',ier)
      close (unit=lun)
      call sic_frelun (lun)
      error = .true.
      return
    endif
    !
    ! Set up Lines
    error = .true.
    line1 = 1
    line2 = 0
    if (sic_present(5,0)) then
      call sic_i4 (line,5,1,line1,.false.,error)
      if (error) goto 99
      call sic_i4 (line,5,2,line2,.false.,error)
      if (error) goto 99
    endif
    if (line2.ne.0) line2 = line2-line1+1
    !
    ! Skip beginning of file
    do i=1,line1-1
      read(lun,'(A)',iostat=ier)
      if (ier.ne.0) then
        call sic_message(seve%e,rname,'Error skipping lines')
        call putios('E-ACCEPT,  ',ier)
        goto 99
      endif
    enddo
  endif
  !
  ! Now do the work
  select case (iopt)
  case (1)
    call sic_accept_array(line,lun,error)
  case (2)
    call sic_accept_binary(line,lun,error)
  case (3)
    call sic_accept_column(line,lun,line1,line2,error)
  end select
  if (error)  continue  ! Need to close the files anyway
  !
99 continue
  if (iopt.eq.2) then
    call gag_filclose(lun)
  else
    close (unit=lun)
    call sic_frelun(lun)
  endif
  return
end subroutine sic_accept
!
subroutine sic_accept_array(line,lun,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_interfaces, except_this=>sic_accept_array
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ACCEPT /ARRAY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line      ! Input command line
  integer(kind=4),  intent(in)    :: lun       !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  character(len=128) :: format
  integer(kind=4) :: ier,type,nf
  integer(kind=address_length) :: ip
  integer(kind=size_length) :: size
  character(len=8196) :: local_line
  logical :: opt_format
  !
  if (sic_narg(0).ne.1) then
    call sic_message(seve%e,rname,'Only one variable accepted with /ARRAY')
    error = .true.
    return
  endif
  !
  call sic_accept_getvar(line,1,sic_maxdims,type,ip,size,error)
  if (error)  return
  !
  call sic_accept_getformat(line,opt_format,format,nf,error)
  if (error)  return
  !
  if (type.eq.fmt_r4) then
    call read_one_r4 (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.eq.fmt_r8) then
    call read_one_r8 (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.eq.fmt_i4) then
    call read_one_i4 (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.eq.fmt_i8) then
    call read_one_i8 (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.eq.fmt_i2) then
    call read_one_i2 (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.eq.fmt_by) then
    call read_one_by (lun,opt_format,format(1:nf),ier,memory(ip),size)
  elseif (type.gt.0) then   ! write array (RO case rejected)
    size = type*size  ! Total number of characters to read
    ! Normally, Nobody will find the correct format, since the character
    ! array appears as one single line. ah well.
    call read_one_ch (lun,opt_format,format(1:nf),ier,local_line,size)
    call chtoby(local_line,membyt(ip),size)
  else
    call sic_message(seve%e,rname,'Unsupported variable type')
  endif
  !
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Error reading file')
    call putios('E-ACCEPT,  ',ier)
    error = .true.
  endif
  !
end subroutine sic_accept_array
!
subroutine sic_accept_binary(line,lun,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_binary
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ACCEPT /BINARY
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line      ! Input command line
  integer(kind=4),  intent(in)    :: lun       !
  logical,          intent(inout) :: error     ! Logical error flag
  ! Global
  integer(kind=4) :: gag_filread
  include 'gbl_memory.inc'
  ! Local
  character(len=8), parameter :: rname='ACCEPT'
  integer(kind=4) :: type,nbytin,nbytou
  integer(kind=address_length) :: ip
  integer(kind=size_length) :: size
  !
  if (sic_narg(0).ne.1) then
    call sic_message(seve%e,rname,'Only one variable accepted with /BINARY')
    error = .true.
    return
  endif
  !
  call sic_accept_getvar(line,1,sic_maxdims,type,ip,size,error)
  if (error)  return
  !
  ! The following works for Character Arrays...
  if (type.eq.fmt_r8 .or. type.eq.fmt_i8) then
    nbytin = 8*size
  elseif (type.eq.fmt_i2) then
    nbytin = 2*size
  elseif ((type.ne.fmt_by).and.(type.lt.0)) then
    nbytin = 4*size
  elseif (type.gt.0) then
    nbytin = type*size  ! Total number of characters==bytes in the array
  endif
  if (type.gt.0) then
    nbytou = gag_filread(lun,membyt(ip),nbytin)
  else
    nbytou = gag_filread(lun,memory(ip),nbytin)
  endif
  if (nbytou.ne.nbytin) then
    call sic_message(seve%e,rname,'End of file during read')
    error = .true.
  endif
  !
end subroutine sic_accept_binary
!
subroutine sic_accept_column(line,lun,line1,line2,error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_column
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ACCEPT /COLUMN
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line    ! Input command line
  integer(kind=4),  intent(in)    :: lun     ! Logical unit
  integer(kind=4),  intent(in)    :: line1   !
  integer(kind=4),  intent(in)    :: line2   !
  logical,          intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=8), parameter :: rname='ACCEPT'
  integer(kind=4), parameter :: marg=99
  integer(kind=4) :: fmt(marg),iarg,narg
  integer(kind=address_length) :: ip(marg)
  integer(kind=size_length) :: is(marg)
  !
  ! More than 1 variable : column like format
  narg = sic_narg(0)
  do iarg=1,narg
    call sic_accept_getvar(line,iarg,1,fmt(iarg),ip(iarg),is(iarg),error)
    if (error)  return
  enddo  ! iarg
  !
  ! Either we have a Format list, in which case we use the old, hard way to
  ! read variables, we cannot read more than 1 char array, etc..
  if (sic_present(4,0)) then  ! /FORMAT
    call sic_accept_column_format(line,lun,line1,narg,fmt,ip,is,error)
  else
    call sic_accept_column_noformat(line,lun,line1,line2,narg,fmt,ip,is,error)
  endif
  if (error)  return
  !
end subroutine sic_accept_column
!
subroutine sic_accept_column_noformat(line,lun,line1,line2,narg,fmt,ip,is,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_column_noformat
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ACCEPT /COLUMN (no /FORMAT)
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: line       ! Input command line
  integer(kind=4),              intent(in)    :: lun        !
  integer(kind=4),              intent(in)    :: line1      !
  integer(kind=4),              intent(in)    :: line2      !
  integer(kind=4),              intent(in)    :: narg       !
  integer(kind=4),              intent(in)    :: fmt(narg)  !
  integer(kind=address_length), intent(in)    :: ip(narg)   !
  integer(kind=size_length),    intent(in)    :: is(narg)   !
  logical,                      intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  integer(kind=4) :: j,ier,ilin,nl,ns
  character(len=8196) :: local_line
  integer(kind=address_length) :: val(narg)
  integer(kind=4), parameter :: dummy=1  ! Value must conform with subroutine sic_accept_getvar
  character(len=1) :: separ
  integer(kind=size_length) :: iwritten,maxsize
  character(len=80) :: errchain
  !
  separ = char(0)
  call sic_ch(line,3,2,separ,ns,.false.,error)
  if (error)  return
  !
  ! Here we do not have a format, and we read user-separated columns.
  val(1:narg) = ip(1:narg)  ! Initialise pointer list (modified on the fly hereafter)
  ier = 0
  ilin = 0
  iwritten = 0
  !
  ! Read lines, decode and update pointer list
  maxsize = maxval(is(1:narg))
  do while (iwritten.lt.maxsize)
    ilin = ilin+1
    read (lun,'(A)',end=98,iostat=ier) local_line
    if (ier.ne.0)  goto 98
    nl=len_trim(local_line)
    if (local_line(1:1).eq.'!')  &  ! Ignore comments
      cycle
    call sic_blanc(local_line,nl)   ! Suppress everything after a '!'
    if (nl.eq.0)  &                 ! Ignore empty lines after SIC_BLANC
      cycle
    !
    call sic_accept_oneline(separ,local_line,narg,fmt,val,error)
    if (error)  goto 98
    iwritten = iwritten+1
    !
    do j=1,narg
      if (iwritten.ge.is(j)) then
        val(j) = dummy  ! No more to be written!
      elseif (fmt(j).gt.0) then
        val(j)=val(j)+gag_sizeof(fmt(j))  ! Offset in memory in chars
      else
        val(j)=val(j)+gag_sizeof(fmt(j))/gag_sizeof(fmt_i4)  ! Offset in memory in I4
      endif
    enddo
    if (line2.ne.0 .and. ilin.ge.line2) exit ! Enough lines read
  enddo  ! while (iwritten.le.maxsize)
  !
98 continue
  if (error .or. ier.ne.0) then
    if (ilin.gt.0) then
      write (errchain,'(A,I0)') 'Error During Read line #',ilin+line1-1
      call sic_message(seve%e,rname,errchain)
    else
      call sic_message(seve%e,rname,'Error reading file')
    endif
    if (ier.ne.0)  call putios('E-ACCEPT,  ',ier)
    error = .true.
  endif
  !
end subroutine sic_accept_column_noformat
!
subroutine sic_accept_column_format(line,lun,line1,narg,fmt,ip,is,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_column_format
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   ACCEPT /COLUMN /FORMAT
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: line       ! Input command line
  integer(kind=4),              intent(in)    :: lun        !
  integer(kind=4),              intent(in)    :: line1      !
  integer(kind=4),              intent(in)    :: narg       !
  integer(kind=4),              intent(in)    :: fmt(narg)  !
  integer(kind=address_length), intent(inout) :: ip(narg)   !
  integer(kind=size_length),    intent(in)    :: is(narg)   !
  logical,                      intent(inout) :: error      ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  integer(kind=size_length) :: maxsize
  integer(kind=4) :: ier,ilin,nf
  integer(kind=size_length) :: i,size
  character(len=8196) :: local_line
  real(kind=8) :: work(narg)
  integer(kind=address_length) :: ipline
  character(len=80) :: errchain
  character(len=128) :: format
  logical :: opt_format
  !
  maxsize = maxval(is(1:narg))
  !
  ! Here variables must be scalar or 1D of the same size.
  if (any(is(1:narg).ne.maxsize .and. is(1:narg).gt.1)) then
    call sic_message(seve%e,rname,'Variables in list have different sizes')
    error = .true.
    return
  endif
  !
  call sic_accept_getformat(line,opt_format,format,nf,error)
  if (error)  return
  !
  if (any(fmt(1:narg).gt.0)) then  ! At least 1 character variable is present
    !
    if (any(fmt(1:narg).le.0)) then  ! ... and a numeric also. Rejected.
      call sic_message(seve%e,rname,  &
        'Mixing Character and Numeric variables in a FORMAT-specified way is NOT available')
      call sic_message(seve%e,rname,'Try to read variables separately')
      error = .true.
      return
    endif
    !
    ! Do not yet read several char arrays...
    if (narg.gt.1) then
      call sic_message(seve%e,rname,'Only One (1) Character variable '//  &
        'may be read by this command if a FORMAT option is present')
      call sic_message(seve%e,rname,'Try to read variables separately')
      error = .true.
      return
    endif
    ipline = bytpnt(locstr(local_line),membyt)
    !     the following is true IF one char array only
    size = fmt(1)
    do i=1,maxsize
      call read_one_ch(lun,opt_format,format(1:nf),ier,local_line,size)
      if (ier.ne.0) then
        ilin = i
        goto 98
      endif
      call bytoby(membyt(ipline),membyt(ip(1)),fmt(1))
      ip(1) = ip(1)+fmt(1)
    enddo
  else
    if (error)  return
    call read_all_var(lun,opt_format,format(1:nf),ier,ilin,ip,is,fmt,maxsize,  &
      narg,memory,work,error)
    if (error)  return
  endif
  !
98 continue
  if (ier.ne.0) then
    if (ilin.gt.0) then
      write (errchain,'(A,I8)') 'Error During Read line #',ilin+line1-1
      call sic_message(seve%e,rname,errchain)
    else
      call sic_message(seve%e,rname,'Error reading file')
    endif
    call putios('E-ACCEPT,  ',ier)
    error = .true.
  else
    error = .false.
  endif
end subroutine sic_accept_column_format
!
subroutine sic_accept_getvar(line,iarg,maxdims,type,ip,siz,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_getvar
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Return the some elements describing the variable, and make some
  ! checks
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: line     ! Input command line
  integer(kind=4),              intent(in)    :: iarg     ! Argument position
  integer(kind=4),              intent(in)    :: maxdims  ! Maximum dimension allowed
  integer(kind=4),              intent(out)   :: type     ! Variable type
  integer(kind=address_length), intent(out)   :: ip       ! Data address
  integer(kind=size_length),    intent(out)   :: siz      ! Number of elements
  logical,                      intent(inout) :: error    ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  character(len=80) :: name
  integer(kind=4) :: nc
  type(sic_descriptor_t) :: desc
  logical :: found
  integer(kind=4), parameter :: dummy=1
  character(len=message_length) :: mess
  !
  call sic_ke(line,0,iarg,name,nc,.true.,error)
  if (error)  return
  !
  if (name.eq.'*') then
    type = fmt_r4
    ip = dummy  ! Set relative offset to 1 (memory(1))
    siz = 1     ! At most one word
    return
  endif
  !
  found = .true.
  call sic_descriptor(name,desc,found)
  !
  if (.not.found) then
    call sic_message(seve%e,rname,'No such variable '//name)
    error = .true.
  elseif (desc%readonly) then
    call sic_message(seve%e,rname,'ReadOnly variable cannot be read')
    error = .true.
  elseif (desc%ndim.gt.maxdims) then
    write(mess,'(A,I0,A,A)')  'Variable must be at most ',maxdims,'-D: ',name
    call sic_message(seve%e,rname,mess)
    error = .true.
  endif
  if (error)  return
  !
  type = desc%type
  !
  siz = desc_nelem(desc)
  !
  if (type.gt.0) then
    ip = bytpnt(desc%addr,membyt)
  else
    ip = gag_pointer(desc%addr,memory)
  endif
  !
end subroutine sic_accept_getvar
!
subroutine sic_accept_getformat(line,opt_form,format,nf,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_accept_getformat
  !---------------------------------------------------------------------
  ! @ private
  ! Parse the command line for the /FORMAT arguments
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line       ! Input command line
  logical,          intent(out)   :: opt_form   ! /FORMAT is present?
  character(len=*), intent(out)   :: format     ! Argument
  integer(kind=4),  intent(out)   :: nf         ! Length of format
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  character(len=128) :: chain
  integer(kind=4) :: nc
  !
  opt_form = sic_present(4,0)
  if (opt_form) then
    if (sic_narg(4).gt.1) then
      call sic_message(seve%e,rname,'Invalid /FORMAT argument')
      call sic_message(seve%e,rname,'Format must be a single string e.g. "F8.2" or "F5.3,5(2X,I4)"')
      error = .true.
      return
    endif
    !
    call sic_ch(line,4,1,chain,nc,.true.,error)
    if (error)  return
    if (chain(1:1).ne.'(') then
      format = '('//trim(chain)//')'
    else
      format = chain
    endif
  else
    format = ''  ! or '*' maybe?
  endif
  nf = len_trim(format)
  !
end subroutine sic_accept_getformat
!
subroutine read_one_r4(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  real(kind=4),              intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_r4
!
subroutine read_one_r8(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  real(kind=8),              intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_r8
!
subroutine read_one_i4(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  integer(kind=4),           intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_i4
!
subroutine read_one_i8(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  integer(kind=8),           intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_i8
!
subroutine read_one_i2(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  integer(kind=2),           intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_i2
!
subroutine read_one_by(lun,form,format,ier,array,size)
  use sic_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun          !
  logical,                   intent(in)  :: form         !
  character(len=*),          intent(in)  :: format       !
  integer(kind=4),           intent(out) :: ier          !
  integer(kind=size_length), intent(in)  :: size         !
  integer(kind=1),           intent(out) :: array(size)  !
  !
  if (form) then
    read(lun,format,iostat=ier) array
  else
    read(lun,*,iostat=ier) array
  endif
end subroutine read_one_by
!
subroutine read_one_ch(lun,form,format,ier,array,size)
  use gildas_def
  use sic_interfaces, except_this=>read_one_ch
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: lun     !
  logical,                   intent(in)  :: form    !
  character(len=*),          intent(in)  :: format  !
  integer(kind=4),           intent(out) :: ier     !
  character(len=*),          intent(out) :: array   !
  integer(kind=size_length), intent(in)  :: size    !
  !
  if (form) then
    read(lun,format,iostat=ier) array(1:size)
  else
    read(lun,*,iostat=ier) array(1:size)
  endif
end subroutine read_one_ch
!
subroutine read_all_var(lun,form,format,ier,ilin,ip,is,fmt,size,narg,memory,  &
  work,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_interfaces, except_this=>read_all_var
  !---------------------------------------------------------------------
  ! @ private
  ! This assumes that any kind of values can be stored in double
  ! precision floats, which is false for long integers.
  !---------------------------------------------------------------------
  integer(kind=4),              intent(in)    :: lun         !
  logical,                      intent(in)    :: form        !
  character(len=*),             intent(in)    :: format      !
  integer(kind=4),              intent(out)   :: ier         !
  integer(kind=4),              intent(out)   :: ilin        !
  integer(kind=4),              intent(in)    :: narg        !
  integer(kind=address_length), intent(inout) :: ip(narg)    !
  integer(kind=size_length),    intent(in)    :: is(narg)    !
  integer(kind=4),              intent(in)    :: fmt(narg)   !
  integer(kind=size_length),    intent(in)    :: size        !
  integer(kind=4)                             :: memory(*)   !
  real(kind=8)                                :: work(narg)  ! Working array
  logical,                      intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  integer(kind=size_length) :: i
  integer(kind=4) :: j,inte,ipos,ichara
  logical :: yes,no
  data yes/.true./, no/.false./
  !
  if (form) then
    ! The Fortran read() statement below will read the string into the real
    ! 'work' array. The standard forbids reading strings into floats using
    ! integer edit descriptors (gfortran raises an error, ifort returns
    ! incorrect value). Trap this:
    ipos = index(format,'I')
    if (ipos.gt.0) then
      ! Format contains a I edit descriptor. Check a bit more:
      ichara = ichar(format(ipos+1:ipos+1))-ichar('0')
      if (ichara.ge.0 .and. ichara.le.9) then
        call sic_message(seve%e,rname,'Integer edit descriptors (e.g. I4) can not be used in this context')
        call sic_message(seve%e,rname,'Use float edit descriptors instead (e.g. F4.0)')
        error = .true.
        return
      endif
    endif
  endif
  !
  do i=1,size
    if (form) then
      read(lun,format,iostat=ier) work
    else
      read(lun,*,iostat=ier) work
    endif
    if (ier.ne.0) then
      ilin = i
      return
    endif
    do j=1,narg
      if (fmt(j).eq.fmt_r4) then
        call r8tor4(work(j),memory(ip(j)),1)
      elseif (fmt(j).eq.fmt_r8) then
        call r8tor8(work(j),memory(ip(j)),1)
      elseif (fmt(j).eq.fmt_i4) then
        call r8toi4(work(j),memory(ip(j)),1)
      elseif (fmt(j).eq.fmt_i8) then
        call r8toi8(work(j),memory(ip(j)),1)
      elseif (fmt(j).eq.fmt_l) then
        call r8toi4(work(j),inte,1)
        if (inte.eq.0) then
          call l4tol4(no,memory(ip(j)),1)
        else
          call l4tol4(yes,memory(ip(j)),1)
        endif
      endif
      if (is(j).gt.1) then
        if (fmt(j).eq.fmt_r8 .or. fmt(j).eq.fmt_i8) then
          ip(j) = ip(j)+2
        else
          ip(j) = ip(j)+1
        endif
      endif
    enddo
  enddo
end subroutine read_all_var
!
subroutine sic_accept_oneline(separ,line,nvar,vtype,val,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_accept_oneline
  use gildas_def
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! Read the input line and fill the variables thanks to their type
  ! and pointer to their value.
  !---------------------------------------------------------------------
  character(len=*),             intent(in)    :: separ     ! Separator
  character(len=*),             intent(in)    :: line      ! Valid input line to read
  integer(kind=4),              intent(in)    :: nvar      ! Number of variables to fill
  integer(kind=4)                             :: vtype(*)  ! Variable types
  integer(kind=address_length), intent(in)    :: val(*)    ! Pointers to variables
  logical,                      intent(inout) :: error     ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ACCEPT'
  real(kind=4) :: r4
  real(kind=8) :: r8
  integer(kind=4) :: i4
  integer(kind=8) :: i8
  integer(kind=4) :: i,npar,lpar,nmax,ich
  character(len=256) :: par
  character(len=128) :: errorline
  integer(kind=address_length) :: ipar,jpar
  character(len=1), parameter :: blank = ' '
  integer(kind=4), parameter :: dummy=1  ! Value must conform with subroutine sic_accept_getvar
  !
  npar=1
  do i=1,nvar
    ! char(0) means a "normal" list-directed read, or so...
    call sic_separ(separ,line(npar:),par,lpar,npar)
    if (lpar.le.0) then
      write(errorline,'(a,i6)') 'Missing parameter in column ',i
      call sic_message(seve%e,rname,errorline)
      call sic_message(seve%i,rname,line)
      error = .true.
      return
    endif
    !
    ! Check if it is a true argument
    if (val(i).eq.dummy)  cycle  ! Just skip the column
    !
    if (vtype(i).gt.0) then
      nmax=min(lpar,vtype(i))
      if (nmax.gt.0) then
        ipar = locstr(par)
        jpar = bytpnt(ipar,membyt)
        call bytoby(membyt(jpar),membyt(val(i)),nmax)
      endif
      do ich=nmax+1,vtype(i)  ! Blank the end of the string
        call bytoby(blank,membyt(val(i)+ich-1),1)
      enddo
    else
      if (vtype(i).eq.fmt_r4) then
        call sic_math_real(par,lpar,r4,error)
        if (.not.error)  call r4tor4(r4,memory(val(i)),1)
      elseif (vtype(i).eq.fmt_r8) then
        call sic_math_dble(par,lpar,r8,error)
        if (.not.error)  call r8tor8(r8,memory(val(i)),1)
      elseif (vtype(i).eq.fmt_i4) then
        call sic_math_inte(par,lpar,i4,error)
        if (.not.error)  call i4toi4(i4,memory(val(i)),1)
      elseif (vtype(i).eq.fmt_i8) then
        call sic_math_long(par,lpar,i8,error)
        if (.not.error)  call i8toi8(i8,memory(val(i)),1)
      endif
      if (error) then
        call sic_message(seve%e,rname,'Decoding error at '//par(1:lpar))
        return
      endif
    endif
  enddo
  !
end subroutine sic_accept_oneline

subroutine concal (xd,yd,zd,nt,ipt,nl,ipl,pdd,iti,xii,yii,zii,itpv)
  use gcont_gridder
  !---------------------------------------------------------------------
  ! @ public
  ! 	This subroutine performs punctual interpolation or extrapolation
  ! 	i.e., determines the Z value at a point.
  ! Arguments :
  !	XD	R*4 (*)	Array of X coordinates			Input
  !	YD	R*4 (*)	Array of Y coordinates			Input
  !	ZD	R*4 (*) Array of values				Input
  !	NT	I	Number of triangles			Input
  !	IPT	I (*)	Array containing the point numbers of
  !			the vertexes of the triangles		Input
  !	NL	I	Number of border line segments		Input
  !	IPL	I (*)	Array containing the point numbers of
  !			the end points of the border line
  !			segments and their respective triangle
  !			numbers					Input
  !	PDD	R*4 (*)	Array containing the partial derivatives
  !			at the data points			Input
  !	ITI	I	triangle number of the triangle in which
  !			lies the point for which interpolation
  !			is to be performed			Input
  !	XII	R*4	X coordinate of the point for which
  !			interpolation is to be performed.	Input
  !	YII	R*4	Y coordinate of this point		Input
  !	ZII	R*4	Interpolated Z value			Output
  ! No subroutine referenced
  !---------------------------------------------------------------------
  real :: xd(*)                     !
  real :: yd(*)                     !
  real :: zd(*)                     !
  integer :: nt                     !
  integer :: ipt(*)                 !
  integer :: nl                     !
  integer :: ipl(*)                 !
  real :: pdd(*)                    !
  integer :: iti                    !
  real :: xii                       !
  real :: yii                       !
  real :: zii                       !
  integer :: itpv                   !
  ! Local
  real :: x(3), y(3), z(3), pd(15)
  !
  real :: zu(3), zv(3), zuu(3), zuv(3), zvv(3)
  real :: lu, lv
  !
  integer :: it0, ntl, il1, il2, jipt, jpd, i, idp, jpdd, kpd
  real :: x0, y0, a, b, c, d, ad, bc, dlt, ap, bp, cp, dp
  real :: aa, act2, cc, ab, adbc, cd, bb, bdt2, dd
  real :: p0, p1, p2, p3, p4, p5
  real :: p00, p10, p20, p30, p40, p50
  real :: p01, p02, p03, p04, p05
  real :: p11, p21, p31, p41, p12, p13, p14, p22, p23, p32
  real :: h1, h2, h3, g1, g2
  real :: thxu, thuv, csuv, thus, thsv, ac, dx, dy, u, v
  integer :: jipl
  equivalence     (p5,p50)
  !
  ! need SAVE ...
  save x0, y0, a, b, c, d
  save ad, bc, dlt, ap, bp, cp, dp
  save p00, p10, p20, p30, p40, p50
  save p01, p02, p03, p04, p05
  save p11, p21, p31, p41, p12, p13, p14, p22, p23, p32
  !
  ! Preliminary processing
  !
  it0 = iti
  ntl = nt+nl
  if (it0 .le. ntl) go to  100
  !
  ! Patch for not extrapolating	S.Guilloteau
  il1 = it0/ntl
  il2 = it0-il1*ntl
  if (il1 .eq. il2) then
    if (.not.lextrp) then
      zii = rblank
      return
    endif
    goto 150
  endif
  if (.not.lextrp) then
    zii = rblank
    return
  endif
  go to  200
  ! End patch
  !
  ! Calculation of ZII by interpolation.
  ! Checks if the necessary coefficients have been calculated.
  !
100 if (it0 .eq. itpv) go to  140
  !
  ! Loads coordinate and partial derivative values at the
  ! IPI 102 vertexes.
  ! IPI 103
  !
  jipt = 3*(it0-1)
  jpd = 0
  do i=1,3
    jipt = jipt+1
    idp = ipt(jipt)
    x(i) = xd(idp)
    y(i) = yd(idp)
    z(i) = zd(idp)
    jpdd = 5*(idp-1)
    do kpd=1,5
      jpd = jpd+1
      jpdd = jpdd+1
      pd(jpd) = pdd(jpdd)
    enddo
  enddo
  !
  ! Determines the coefficients for the coordinate system
  ! transformation from the X-Y system to the U-V system
  ! and vice versa.
  !
  x0 = x(1)
  y0 = y(1)
  a = x(2)-x0
  b = x(3)-x0
  c = y(2)-y0
  d = y(3)-y0
  ad = a*d
  bc = b*c
  dlt = ad-bc
  ap = d/dlt
  bp = -b/dlt
  cp = -c/dlt
  dp = a/dlt
  !
  ! Converts the partial derivatives at the vertexes of the
  ! triangle for the U-V coordinate system.
  !
  aa = a*a
  act2 = 2.0*a*c
  cc = c*c
  ab = a*b
  adbc = ad+bc
  cd = c*d
  bb = b*b
  bdt2 = 2.0*b*d
  dd = d*d
  do i=1,3
    jpd = 5*i
    zu(i) = a*pd(jpd-4)+c*pd(jpd-3)
    zv(i) = b*pd(jpd-4)+d*pd(jpd-3)
    zuu(i) = aa*pd(jpd-2)+act2*pd(jpd-1)+cc*pd(jpd)
    zuv(i) = ab*pd(jpd-2)+adbc*pd(jpd-1)+cd*pd(jpd)
    zvv(i) = bb*pd(jpd-2)+bdt2*pd(jpd-1)+dd*pd(jpd)
  enddo
  !
  ! Calculates the coefficients of the polynomial.
  !
  p00 = z(1)
  p10 = zu(1)
  p01 = zv(1)
  p20 = 0.5*zuu(1)
  p11 = zuv(1)
  p02 = 0.5*zvv(1)
  h1 = z(2)-p00-p10-p20
  h2 = zu(2)-p10-zuu(1)
  h3 = zuu(2)-zuu(1)
  p30 = 10.0*h1-4.0*h2+0.5*h3
  p40 = -15.0*h1+7.0*h2-h3
  p50 = 6.0*h1-3.0*h2+0.5*h3
  h1 = z(3)-p00-p01-p02
  h2 = zv(3)-p01-zvv(1)
  h3 = zvv(3)-zvv(1)
  p03 = 10.0*h1-4.0*h2+0.5*h3
  p04 = -15.0*h1+7.0*h2-h3
  p05 = 6.0*h1-3.0*h2+0.5*h3
  lu = sqrt(aa+cc)
  lv = sqrt(bb+dd)
  thxu = atan2(c,a)
  thuv = atan2(d,b)-thxu
  csuv = cos(thuv)
  p41 = 5.0*lv*csuv/lu*p50
  p14 = 5.0*lu*csuv/lv*p05
  h1 = zv(2)-p01-p11-p41
  h2 = zuv(2)-p11-4.0*p41
  p21 = 3.0*h1-h2
  p31 = -2.0*h1+h2
  h1 = zu(3)-p10-p11-p14
  h2 = zuv(3)-p11-4.0*p14
  p12 = 3.0*h1-h2
  p13 = -2.0*h1+h2
  thus = atan2(d-c,b-a)-thxu
  thsv = thuv-thus
  aa = sin(thsv)/lu
  bb = -cos(thsv)/lu
  cc = sin(thus)/lv
  dd = cos(thus)/lv
  ac = aa*cc
  ad = aa*dd
  bc = bb*cc
  g1 = aa*ac*(3.0*bc+2.0*ad)
  g2 = cc*ac*(3.0*ad+2.0*bc)
  h1 = -aa*aa*aa*(5.0*aa*bb*p50+(4.0*bc+ad)*p41) - &
        cc*cc*cc*(5.0*cc*dd*p05+(4.0*ad+bc)*p14)
  h2 = 0.5*zvv(2)-p02-p12
  h3 = 0.5*zuu(3)-p20-p21
  p22 = (g1*h2+g2*h3-h1)/(g1+g2)
  p32 = h2-p22
  p23 = h3-p22
  itpv = it0
  !
  ! Converts XII and YII to U-V system.
  !
140 dx = xii-x0
  dy = yii-y0
  u = ap*dx+bp*dy
  v = cp*dx+dp*dy
  !
  ! Evaluates the polynomial.
  !
  p0 = p00+v*(p01+v*(p02+v*(p03+v*(p04+v*p05))))
  p1 = p10+v*(p11+v*(p12+v*(p13+v*p14)))
  p2 = p20+v*(p21+v*(p22+v*p23))
  p3 = p30+v*(p31+v*p32)
  p4 = p40+v*p41
  zii = p0+u*(p1+u*(p2+u*(p3+u*(p4+u*p5))))
  return
  !
  ! Calculation of ZII by extraterpolation in the rectangle.
  ! Checks if the necessary coefficients have been calculated.
  !
150 if (it0 .eq. itpv) go to  190
  !
  ! Loads coordinate and partial derivative values at the end
  ! points of the border line segment.
  !
  jipl = 3*(il1-1)
  jpd = 0
  do i=1,2
    jipl = jipl+1
    idp = ipl(jipl)
    x(i) = xd(idp)
    y(i) = yd(idp)
    z(i) = zd(idp)
    jpdd = 5*(idp-1)
    do kpd=1,5
      jpd = jpd+1
      jpdd = jpdd+1
      pd(jpd) = pdd(jpdd)
    enddo
  enddo
  !
  ! Determines the coefficients for the coordinate system
  ! transformation from the X-Y system to the U-V system
  ! and vice versa.
  !
  x0 = x(1)
  y0 = y(1)
  a = y(2)-y(1)
  b = x(2)-x(1)
  c = -b
  d = a
  ad = a*d
  bc = b*c
  dlt = ad-bc
  ap = d/dlt
  bp = -b/dlt
  cp = -bp
  dp = ap
  !
  ! Converts the partial derivatives at the end points of the
  ! border line segment for the U-V coordinate system.
  !
  aa = a*a
  act2 = 2.0*a*c
  cc = c*c
  ab = a*b
  adbc = ad+bc
  cd = c*d
  bb = b*b
  bdt2 = 2.0*b*d
  dd = d*d
  do i=1,2
    jpd = 5*i
    zu(i) = a*pd(jpd-4)+c*pd(jpd-3)
    zv(i) = b*pd(jpd-4)+d*pd(jpd-3)
    zuu(i) = aa*pd(jpd-2)+act2*pd(jpd-1)+cc*pd(jpd)
    zuv(i) = ab*pd(jpd-2)+adbc*pd(jpd-1)+cd*pd(jpd)
    zvv(i) = bb*pd(jpd-2)+bdt2*pd(jpd-1)+dd*pd(jpd)
  enddo
  !
  ! Calculates the coefficients of the polynomial.
  !
  p00 = z(1)
  p10 = zu(1)
  p01 = zv(1)
  p20 = 0.5*zuu(1)
  p11 = zuv(1)
  p02 = 0.5*zvv(1)
  h1 = z(2)-p00-p01-p02
  h2 = zv(2)-p01-zvv(1)
  h3 = zvv(2)-zvv(1)
  p03 = 10.0*h1-4.0*h2+0.5*h3
  p04 = -15.0*h1+7.0*h2-h3
  p05 = 6.0*h1-3.0*h2+0.5*h3
  h1 = zu(2)-p10-p11
  h2 = zuv(2)-p11
  p12 = 3.0*h1-h2
  p13 = -2.0*h1+h2
  p21 = 0.0
  p23 = -zuu(2)+zuu(1)
  p22 = -1.5*p23
  itpv = it0
  !
  ! Converts XII and YII to U-V system.
  !
190 dx = xii-x0
  dy = yii-y0
  u = ap*dx+bp*dy
  v = cp*dx+dp*dy
  !
  ! Evaluates the polynomial.
  !
  p0 = p00+v*(p01+v*(p02+v*(p03+v*(p04+v*p05))))
  p1 = p10+v*(p11+v*(p12+v*p13))
  p2 = p20+v*(p21+v*(p22+v*p23))
  zii = p0+u*(p1+u*p2)
  return
  !
  ! Calculation of ZII by extraterpolation in the triangle.
  ! Checks if the necessary coefficients have been calculated.
  !
200 if (it0 .eq. itpv) go to  220
  !
  ! Loads coordinate and partial derivative values at the vertex
  ! of the triangle.
  !
  jipl = 3*il2-2
  idp = ipl(jipl)
  x(1) = xd(idp)
  y(1) = yd(idp)
  z(1) = zd(idp)
  jpdd = 5*(idp-1)
  do kpd=1,5
    jpdd = jpdd+1
    pd(kpd) = pdd(jpdd)
  enddo
  !
  ! Calculates the coefficients of the polynomial.
  !
  p00 = z(1)
  p10 = pd(1)
  p01 = pd(2)
  p20 = 0.5*pd(3)
  p11 = pd(4)
  p02 = 0.5*pd(5)
  itpv = it0
  !
  ! Converts XII and YII to U-V system.
  !
220 u = xii-x(1)
  v = yii-y(1)
  !
  ! Evaluates the polynomial.
  !
  p0 = p00+v*(p01+v*p02)
  p1 = p10+v*p11
  zii = p0+u*(p1+u*p20)
  return
end subroutine concal

!
subroutine amplitude_comm(line,error)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => amplitude_comm
  use gbl_message
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support routine for 
  !     CALIBRATE\AMPLITUDE Factor [/ANTENNA Number]
  !         [/FILE UvIN [UvOut]] 
  ! 
  ! Scale the gain of (all or) the specified Antenna by the
  ! given Factor. 
  ! Work on current UV data if no /FILE option.
  ! Work in place if /FILE is specified, and no UvOut argument is given
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Global --
  character(len=*), parameter :: rname='AMPLITUDE'
  real(8), parameter :: pi=3.141592653589793d0
  integer, parameter :: o_ant=1, o_file=2
  !
  ! Local ---
  character(len=80) :: mess
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  integer(4) :: nvis, ncol, nvg, ndc, ier
  real(4) :: gain
  real(4), allocatable :: gains(:)
  integer(4), allocatable :: iant(:)
  real(4), allocatable :: luv(:,:)
  character(len=filename_length) :: file
  type (gildas) :: uvin, uvou
  logical :: dofile, err
  integer :: nblock, ib, nf, narg, nant, ngain, i, j
  !
  ! Code ----
  error = .false.
  err = .false.
  !
  nant = sic_narg(o_ant)
  ngain = max(sic_narg(0),1)
  if (nant.gt.0) then
    allocate(iant(nant),gains(nant),stat=ier)
    do i=1,nant
      call sic_i4(line,o_ant,i,iant(i),.false.,error)
      if (error) return
      j = min(i,ngain)
      call sic_r4(line,0,i,gains(j),.true.,error)
      if (error) return    
    enddo
  else
    call sic_r4(line,0,1,gain,.true.,error)
    if (error) return
    write(mess,'(A,1PG11.3)') 'Scaling all visibilities by ',gain
    call map_message(seve%i,rname,mess)
  endif
  !
  ! Now do the job
  !
  dofile = sic_present(o_file,0)
  if (dofile) then
    narg = sic_narg(o_file)
    if (narg.lt.1 .or. narg.gt.2) then
      call map_message(seve%e,rname,'/FILE option requires 1 or 2 arguments')
      error = .true.
      return
    endif
    !
    ! Layout for a by-block operation, used by the /FILE option
    !
    call gildas_null (uvin, type = 'UVT')     ! Define a UVTable gildas header
    call gildas_null (uvou, type = 'UVT')     ! Define a UVTable gildas header
    !
    call sic_ch(line,o_file,1,file,nf,.true.,error)
    if (error)  return
    call gdf_read_gildas (uvin, file, '.uvt', error, data=.false.)
    if (error) return
    call gdf_copy_header(uvin,uvou,error)
    !
    if (narg.eq.2) then
      call sic_ch(line,o_file,2,file,nf,.true.,error)
      if (error) return
      call sic_parse_file(file,' ','.uvt',uvou%file)
      if (error) return
      call gdf_create_image(uvou,error)
      if (error) then
        call gdf_close_image(uvin,err)
        return    
      endif
    endif
    !
    ! Define blocking factor on data file
    !
    ! Set the Blocking Factor
    nblock = space_nitems('SPACE_IMAGER',uvin,1)
    ! Allocate respective space for each file
    ncol = uvin%gil%dim(1)
    ndc =  uvin%gil%nchan
    allocate (luv(ncol,nblock), stat=ier)
    if (failed_allocate(rname,'UV input data',ier,error)) then
      call gdf_close_image(uvin,err)
      if (narg.eq.2) call gdf_close_image(uvou,err)
      return
    endif
    !
    ! Loop over line table
    uvin%blc = 0
    uvin%trc = 0
    !
    do ib = 1,uvin%gil%dim(2),nblock
      write(mess,*) ib,' / ',uvin%gil%dim(2),nblock
      call map_message(seve%i,rname,mess)
      uvin%blc(2) = ib
      uvin%trc(2) = min(uvin%gil%dim(2),ib-1+nblock)
      call gdf_read_data(uvin,luv,error)
      if (error) exit
      !
      nvis = uvin%trc(2)-uvin%blc(2)+1
      !
      ! Here do the job 
      call sub_uvamp(ncol,nvis, ndc, luv, gain, nant, iant, gains)
      !
      if (sic_ctrlc()) then
        error = .true.
        call map_message(seve%e,rname,'Aborted by ^C')
      else
        call gdf_write_data(uvou,luv,error)
      endif
      if (error) exit
    enddo
    !
    deallocate(luv,stat=ier)
    call gdf_close_image(uvin,err)
    error = err.or.error
    if (narg.eq.2) then
      call gdf_close_image(uvou,err)
      error = err.or.error
    endif
    !
  else
    !
    ! In memory version
    nvis = huv%gil%nvisi ! not %dim(2)
    ncol = huv%gil%dim(1)
    ndc =  huv%gil%nchan
    !
    nullify (duv_previous, duv_next)  
    call uv_find_buffers (rname,ncol,nvis,duv_previous, duv_next,error)
    if (error) return
    !
    duv_next(:,:) = duv_previous(:,:)
    !
    nvg = hbgain%gil%dim(2)
    call sub_uvamp(ncol,nvis, ndc, duv_next, gain, nant, iant, gains)
    if (error) return
    !
    call uv_clean_buffers (duv_previous, duv_next,error)
    !
    ! Signal the change in UV data - Amplitude Calibration also affects Weights
    call uv_new_data (weight=.true.)
  endif
end subroutine amplitude_comm
!
subroutine sub_uvamp(ncol,nvis,ndc,cal, gain, nant, iant, gains)
  use imager_interfaces, only : map_message
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ public
  !*
  !   IMAGER -- Support routine for command AMPLITUDE
  !
  !   Apply Amplitude calibration factor to the "raw" UV data,
  !   for all or a list of antennas. 
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol  !! Visibility size
  integer, intent(in) :: nvis  !! Number of visibilities
  integer, intent(in) :: ndc   !! Number of channels
  real, intent(inout) :: cal(ncol,nvis)  !! Calibrated visibilities
  real, intent(in) :: gain     !! Common gain
  integer, intent(in) :: nant  !! Number of specified antennas
  integer, intent(in) :: iant(:)  !! Antenna numbers
  real(4), intent(in) :: gains(:) !! Gains per antenna
  !
  ! Global --
  character(len=*), parameter :: rname='AMPLITUDE'
  integer, parameter :: mant=256  ! ALMA maximum, after renumbering
  !
  ! Local ---
  integer :: ia,jv,k, ncold
  real :: gg, wg
  !
  ! Code ----
  ncold = 7+3*ndc   ! Last data column
  !
  ! Gain in both cases - Explained in the HELP
  if (nant.le.0) then
    !
    ! All antennas are modified, so the Gain is global
    gg = gain
    wg = 1.0/gg**2
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(cal,nvis,ncol,ncold,gg,wg) &
    !$OMP & PRIVATE(jv,k)
    !$OMP DO
    do jv=1,nvis
      do k=8, ncold, 3
        cal(k,jv) = cal(k,jv)*gg
        cal(k+1,jv) = cal(k+1,jv)*gg
        cal(k+2,jv) = cal(k+2,jv)*wg
      enddo
    enddo
    !$OMP ENDDO
    !$OMP END PARALLEL
  else
    !$OMP PARALLEL DEFAULT(none) &
    !$OMP & SHARED(cal,nvis,ncol,ncold) &
    !$OMP & SHARED(iant,gains,nant) & 
    !$OMP & PRIVATE(jv,k,gg,wg,ia)
    !$OMP DO
    do jv=1,nvis
      gg = 1.0
      wg = 1.0
      do ia=1,nant
        if (iant(ia).eq.cal(6,jv).or.iant(ia).eq.cal(7,jv)) then
          gg = gg*gains(ia)          
          wg = wg/gains(ia)**2
        endif
      enddo
      !
      if (gg.ne.1.0) then
        do k=8, ncold, 3
          cal(k,jv) = cal(k,jv)*gg
          cal(k+1,jv) = cal(k+1,jv)*gg
          cal(k+2,jv) = cal(k+2,jv)*wg
        enddo
      endif
    enddo
    !$OMP ENDDO
    !$OMP END PARALLEL
  endif
  !
end subroutine sub_uvamp
!

subroutine feather_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use clean_arrays
  use imager_interfaces, except_this => feather_comm
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  ! FEATHER [/FILE FileMerge FileHigh FileLow] [/REPROJECT]
  !
  !   Uses  FEATHER_RADIUS
  !         FEATHER_SCALE
  !         FEATHER_RANGE[2]
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  integer, parameter :: o_file=1
  integer, parameter :: o_reproject=2
  character(len=1), parameter :: question_mark='?'
  character(len=*), parameter :: rname='FEATHER'
  !
  ! Memory -
  type(gildas), save :: hall
  real, save :: feather_radius=15.0
  real, save :: feather_ratio=1.0
  real, save :: feather_expo=8.0
  real, save :: feather_range(2)=[0.,0.]
  logical, save :: feather_init=.true.
  ! Local ---
  real :: actual_range(2)
  logical :: auto
  character(len=filename_length) :: nameh,namel,name_out
  character(len=60) :: argum
  integer :: narg
  integer :: n, ier
  !
  ! Code ----
  error = .false.
  !
  if (feather_init) then
    ! At first call, just initialize and do nothing else
    call sic_def_real('FEATHER_RADIUS',feather_radius,0,0,.false.,error)  
    call sic_def_real('FEATHER_RATIO', feather_ratio,0,0,.false.,error)  
    call sic_def_real('FEATHER_EXPO', feather_expo,0,0,.false.,error)  
    call sic_def_real('FEATHER_RANGE', feather_range,1,2,.false.,error)  
    feather_init = .false.
    return
  endif
  !
  narg = sic_narg(0)
  if (narg.eq.1) then
    call sic_ch(line,0,1,argum,n,.true.,error)
    if (argum(1:1).eq.question_mark) then
      if (argum.eq."?" .or. argum.eq."??" .or. argum.eq."???") then
        call exec_program('@ i_feather')
        return
      endif
    endif
  endif
  !
  if (narg.ne.0) then
    call map_message(seve%e,rname,'FEATHER accepts no argument (except ?)')
    error = .true.
    return
  endif
  !
  ! Set current range
  actual_range = feather_range
  if (feather_range(1).eq.0) actual_range(1) = feather_radius/1.15
  if (feather_range(2).eq.0) actual_range(2) = feather_radius*1.15
  !
  ! Auto reproject
  auto = sic_present(o_reproject,0)
  !
  if (sic_present(o_file,0)) then
    ! File version
    call sic_ch(line,o_file,3,namel,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,1,name_out,n,.true.,error)
    call sic_ch(line,o_file,2,nameh,n,.true.,error)
    !
    call t_uv_feather(nameh,namel,name_out, &
      & feather_radius,feather_ratio,feather_expo,actual_range,auto,error)
  else 
    ! Default buffer version
    ! Ideally, one would like to specify any buffer, but
    ! we do not know how to set a pointer to a Memory region,
    ! except using Fortran 2008 (which is marginally accepted yet ?)
    if (.not.allocated(dsky)) then
      call map_message(seve%e,rname,'SKY image is not defined')
      error = .true.
    else
      hsky%r3d => dsky
    endif
    if (.not.associated(hshort%r3d)) then
      call map_message(seve%e,rname,'SHORT image is not defined')
      error = .true.
    endif
    if (error) return
    !
    if (associated(hall%r3d)) deallocate(hall%r3d)
    call sic_delvariable ('FEATHERED',.false.,error)
    !
    call gildas_null(hall)
    call gdf_copy_header(hsky,hall,error)
    call gdf_allocate(hall,error)
    if (error) return
    !
    ! Do the job
    call c_uv_feather(hall,hsky,hshort, &
      & feather_radius,feather_ratio,feather_expo,actual_range,auto,error)
    if (error) then
      deallocate(hall%r3d,stat=ier)
      return
    endif
    call sic_mapgildas('FEATHERED',hall,error,hall%r3d)
  endif
end subroutine feather_comm
!
subroutine t_uv_feather(nameh,namel,name_out,uvradius,scale,expo,range, &
  & auto,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => t_uv_feather
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  ! FEATHER /FILE FileMerge FileHigh FileLow [/REPROJECT]
  !
  !   Uses  FEATHER_RADIUS
  !         FEATHER_SCALE
  !         FEATHER_RANGE[2]  
  ! "Feather" (in the UV plane) two data cubes from data files
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: nameh      !! HIGHres file name
  character(len=*), intent(in) :: namel      !! LOWres file name
  character(len=*), intent(in) :: name_out   !! Merged file name
  real, intent(in) ::  uvradius              !! Transition radius (m)
  real, intent(in) ::  scale                 !! Scale factor LOW / HIGH
  real, intent(in) ::  expo                  !! Sharpness of transition
  real, intent(in) ::  range(2)              !! Range of overlap (m) 
  logical, intent(in) :: auto                !! Auto reproject
  logical, intent(out) :: error              !! Logical Error flag
  !
  character(len=*), parameter :: rname='FEATHER'
  ! Local ---
  type(gildas) :: high, low, all, htmp
  real :: ratio
  integer :: ier
  integer :: sys_code
  logical :: auto_space
  logical :: err
  !
  ! Code ----
  error = .false.
  ratio = scale
  auto_space = auto
  !
  if (uvradius.eq.0) error = .true.
  if (ratio.eq.0) ratio = 1.0
  if (range(2).le.range(1)) error = .true.
  if (error) then
    call map_message(seve%e,rname,'Invalid FEATHER_* input values')
    return
  endif
  !
  ! Read Headers Model & Image 
  call gildas_null(high)
  call gildas_null(low)
  call gildas_null(all)
  !
  call sic_parse_file (nameh,' ','.lmv-sky',high%file)
  call gdf_read_header (high,error)
  if (error) return
  call sic_parse_file (namel,' ','.lmv-sky',low%file)
  call gdf_read_header (low,error)
  if (error) return
  !
  ier = 0
  call s_uv_consistency (high,low,error,ier)
  !
  if (error) then
    if (ier.eq.0) return ! Spectro error or Swapping error
    !
    ! Space error : reproject LOW on HIGH if requested
    if (auto_space) then
      call map_message(seve%w,rname,'Images do not match, resampling LOWres one')
      continue
    else
      call gdf_close_image(high,err)
      call gdf_close_image(low,err)
      call map_message(seve%e,rname,'Images do not match')
      return
    endif
  else
    auto_space = .false.
  endif
  !
  if (auto_space) then
    call gdf_close_image(low,err)
    call gildas_null(htmp)
    htmp%file = low%file
    call gdf_read_header (htmp,error)
    if (error) return
    call s_reproject_init (htmp,high,low,sys_code,error)
    if (error) return
    call gdf_allocate(low,error)
    if (error) return
    call gdf_allocate(htmp,error)
    if (error) return
    call gdf_read_data(htmp,htmp%r3d,error)
    if (error) return
    call s_reproject_do(htmp,htmp%r3d,low,low%r3d,sys_code,error)
    if (error) return
    call gdf_close_image(htmp,err)
  else
    call gdf_allocate (low,error)
    if (error) return
    call gdf_read_data (low,low%r3d,error)
    if (error) return
    call gdf_close_image(low,err)
  endif
  !
  ! Allocate and Read data - Rank 3 at this stage already...
  call gdf_allocate (high,error)
  if (error) return
  call gdf_read_data (high,high%r3d,error)
  if (error) return
  !
  ! Define output image. Comes from the High Resolution one...
  call gdf_copy_header(high,all,error)
  if (error) return
  call gdf_allocate(all,error)
  if (error) return
  !
  call s_uv_hybrid (high,low,all,uvradius,ratio,expo,range,error)
  if (error) return
  !
  call sic_parse_file (name_out,' ','.lmv-sky',all%file)
  call gdf_write_image(all,all%r3d,error)
  !
  call gdf_close_image(high,err)
  !! Not needed with gdf_write_image call gdf_close_image(all,err)
  !
end subroutine t_uv_feather
!
subroutine c_uv_feather(all,high,low,uvradius,scale,expo,range, &
  & auto,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => c_uv_feather
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  ! FEATHER [/REPROJECT]
  !
  !   Uses  FEATHER_RADIUS
  !         FEATHER_SCALE
  !         FEATHER_RANGE[2]
  !
  ! "Feather" (in the UV plane) two internal data cubes (usually the SKY 
  ! and SHORT buffers) and put the result in the FEATHERED buffer.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: high           !! HIGHres Gildas header
  type(gildas), intent(in) :: low            !! LOWres Gildas header
  type(gildas), intent(inout) :: all         !! Combined Gildas header
  real, intent(in) ::  uvradius              !! Transition radius (m)
  real, intent(in) ::  scale                 !! Scale factor LOW / HIGH
  real, intent(in) ::  expo                  !! Sharpness of transition
  real, intent(in) ::  range(2)              !! Range of overlap (m) 
  logical, intent(in) :: auto                !! Auto reproject
  logical, intent(out) :: error              !! Logical Error flag
  !
  character(len=*), parameter :: rname='FEATHER'
  !
  ! Local ---
  type(gildas) :: htmp
  real :: ratio
  integer :: ier
  integer :: sys_code
  logical :: auto_space
  !
  ! Code ----
  error = .false.
  ratio = scale
  auto_space = auto
  !
  if (uvradius.eq.0) error = .true.
  if (ratio.eq.0) ratio = 1.0
  if (range(2).le.range(1)) error = .true.
  if (error) then
    call map_message(seve%e,rname,'Invalid FEATHER_* input values')
    return
  endif
  !
  ier = 0
  call s_uv_consistency (high,low,error,ier)
  !
  if (error) then
    if (ier.eq.0) return ! Spectro error or Swapping error
    !
    ! Space error : reproject LOW on HIGH if requested
    if (auto_space) then
      call map_message(seve%w,rname,'Images do not match, resampling LOWres one')
      continue
    else
      call map_message(seve%e,rname,'Images do not match')
      return
    endif
  else
    auto_space = .false.
  endif
  !
  if (auto_space) then
    call gildas_null(htmp)
    call gdf_copy_header(low,htmp,error)
    if (error) return
    call s_reproject_init (low,high,htmp,sys_code,error)
    if (error) return
    call gdf_allocate(htmp,error)
    if (error) return    
    call s_reproject_do (low,low%r3d,htmp,htmp%r3d,sys_code,error)
    if (error) return
    call s_uv_hybrid (high,htmp,all,uvradius,ratio,expo,range,error)
    if (error) return
  else
    call s_uv_hybrid (high,low,all,uvradius,ratio,expo,range,error)
  endif
  !
end subroutine c_uv_feather
!
subroutine s_uv_consistency(high,low,error,ier)
  use image_def
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this => s_uv_consistency
  !---------------------------------------------------------------------
  ! @ public
  !* 
  ! IMAGER -- Support routine for command FEATHER
  !
  ! Verify data cube spatial consistencies
  !!
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: high          !! High resolution image
  type (gildas), intent(in) :: low           !! Low resolution image
  logical, intent(out) :: error              !! Logical Error flag
  integer, intent(out) :: ier                !! Error code number
  !
  character(len=*), parameter :: rname='FEATHER'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  !
  character(len=160) :: chain
  real :: tole=1e-4
  logical :: equal
  real(8), dimension(2) :: bhigh, blow, bhinc, blinc
  real(4) :: rhigh, rlow
  !
  integer :: jer
  !
  ! Check spectroscopic consistency
  error = .false.
  !
  ier = 0
  call spectrum_consistency(rname,high,low,tole,error)
  if (error) return
  !
  jer = 0
  !
  ! Test that the HIGH image is the largest one and has the smallest beam
  call gdf_compare_shape (high,low,equal)
  if (.not.equal) then
    call map_message(seve%w,rname,'Images do not match')
    bhinc = abs(high%gil%inc(1:2))*180*3600/pi
    blinc = abs(low%gil%inc(1:2))*180*3600/pi
    bhigh = bhinc * high%gil%dim(1:2)
    blow  = blinc * low%gil%dim(1:2)
    if (any(bhigh.ne.blow)) then
      call map_message(seve%i,rname,'Image                Field (")              Pixel (")             Size')
      write(chain,'(A10,2(2X,F10.3,A,F10.3),I8,A,I7)') 'HIGHres ',bhigh(1),' x',bhigh(2) &
        & ,bhinc(1),' x',bhinc(2),high%gil%dim(1),' x',high%gil%dim(2)
      call map_message(seve%i,rname,chain)
      write(chain,'(A10,2(2X,F10.3,A,F10.3),I8,A,I7)') 'LOWres ',blow(1),' x',blow(2) &
        & ,blinc(1),' x',blinc(2),low%gil%dim(1),' x',low%gil%dim(2)
      call map_message(seve%i,rname,chain)
      jer = 1
    endif
  endif
  rhigh = sqrt(high%gil%majo*high%gil%mino)
  rlow  = sqrt(low%gil%majo*low%gil%mino)
  if (rhigh.ge.rlow) jer = jer+2
  if (jer.ne.0) then
    ier = 0
    if (mod(jer,2).ne.0) then
      call map_message(seve%w,rname,'Field of view of "HIGHres" and "LOWres" images differ')
      ier = 1
      jer = jer/2
    endif
    if (jer.ne.0) then
      call map_message(seve%e,rname,'Resolution of "LOWres" image is better than that of "HIGHres" image')
      call map_message(seve%e,rname,'Consider swapping images !...')
    endif
    error = .true.
  endif
end subroutine s_uv_consistency
!
subroutine s_uv_hybrid(high,low,all,uvradius,ratio,exponent,range,error)
  use image_def
  use gbl_message
  use gkernel_interfaces, no_interface=>fourt
  use imager_interfaces, except_this => expand, and_this=> s_uv_hybrid
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Support for command FEATHER  
  !  Perform the feathering using the classical method.
  !
  !   Take HIGH map (high resolution map)  
  !   Take LOW  map (map with shortest spacings)  
  !   Make oversampled Fourier Transform of boths  
  !   Compute the truncation function f(r)  
  !   Make the Truncated compact Fourier Transform, f(r) x T(LOW)  
  !   Make the complement long baseline Fourier Transform, (1-f(r)) x T(HIGH)  
  !   Sum them T(ALL) = f(r) x T(LOW) + (1-f(r)) x T(HIGH)  
  !   Make the inverse Fourier Transform  
  !   Truncate the resulting image to original size and Mask  
  !!
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: high          !! High resolution image
  type (gildas), intent(in) :: low           !! Low resolution image
  type (gildas), intent(inout) :: all        !! Combined image
  real, intent(in) ::  uvradius              !! Transition radius (m)
  real, intent(in) ::  ratio                 !! Scale factor LOW / HIGH
  real, intent(in) ::  exponent              !! Sharpness of transition                
  real, intent(in) ::  range(2)              !! Range of overlap (m) 
  logical, intent(out) :: error              !! Logical Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='FEATHER'
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  !
  ! Local ---
  character(len=80) :: chain
  real, pointer :: dhigh(:,:,:),dlow(:,:,:)
  real, pointer :: dout(:,:,:)
  real, allocatable :: f(:,:), x(:), y(:)
  complex, allocatable :: chigh(:,:), cout(:,:)
  complex, allocatable, target :: clow(:,:)
  complex, pointer :: cbig(:,:)
  real, allocatable :: rmask(:,:), wfft(:)
  !
  integer :: nx,ny,nc,ic,nn,dim(2),ier,mx,my,i,j, expand, no
  real(8) :: lambda
  real :: uinc, vinc, scale
  real :: threshold, expo
  real, allocatable :: flux_ratio(:), flux2(:)
  real :: umin2, umax2, xx, ww
  !
  ! Code ----
  nx = high%gil%dim(1)
  ny = high%gil%dim(2)
  nc = high%gil%dim(3)
  !
  mx = low%gil%dim(1)
  my = low%gil%dim(2)
  !
  dout => all%r3d
  !
  ! Skip blanking - Set it to zero, although this  will unavoidably
  ! cause some ringing issues if there is such a blanking.
  ! A better procedure would be to interpolate to Zero with a scale
  ! length larger than the (HIGHres) Beam size
  if (high%gil%eval.ge.0) then
    allocate(dhigh(high%gil%dim(1),high%gil%dim(2),high%gil%dim(3)), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    dhigh = high%r3d  ! Copy 
    where (abs(dhigh-high%gil%bval).le.high%gil%eval) dhigh = 0.0
  else
    dhigh => high%r3d ! Pointer
  endif
  if (low%gil%eval.ge.0) then
    allocate(dlow(low%gil%dim(1),low%gil%dim(2),low%gil%dim(3)), stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error')
      error = .true.
      return
    endif
    dlow = low%r3d
    where (abs(dlow-low%gil%bval).le.low%gil%eval) dlow = 0.0
  else
    dlow => low%r3d
  endif
  ! 
  ! Allocate Fourier space
  allocate (chigh(nx,ny), clow(mx,my), cout(nx,ny), stat=ier) 
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  allocate (f(nx,ny), x(nx), y(ny), wfft(2*max(nx,ny)), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  nn = 2
  dim = (/nx,ny/)
  !
  ! Get the user units in "m". This is the wavelength !
  lambda = 299792458.d-6/all%gil%freq
  ! Compute the combination factor F
  uinc = lambda / (all%gil%inc(1) * nx) 
  vinc = lambda / (all%gil%inc(2) * ny) 
  write(chain,'(A,F8.2,F8.2,A,F8.2)') 'UV Cell size ',uinc,vinc, &
    & ' transition radius ',uvradius
  call map_message(seve%i,rname,chain)
  !
  uinc = uinc / uvradius
  do i=1,nx/2
    x(i) = (i-1)*uinc
  enddo
  do i=nx/2+1,nx
    x(i) = (i-nx-1)*uinc
  enddo
  x = x**2
  !
  vinc = vinc / uvradius
  do i=1,ny/2
    y(i) = (i-1)*vinc
  enddo
  do i=ny/2+1,ny
    y(i) = (i-ny-1)*vinc
  enddo
  y = y**2
  !	
  ! We apply here a sharp truncation, by a exp(-r^(2*expo)) function
  !
  ! The "natural" combination for Single-Dish plus Interferometer data
  ! would be to use as the combination function the Fourier transform 
  ! of the single-dish Beam. But this does not necessarily apply to
  ! arbitrary images that we handle here...
  !
  ! In particular, the initial images may already include the Short
  ! spacings in some way. 
  !
  expo = exponent
  if (expo.eq.0) expo = 4.0
  threshold = log(huge(1.0))**(1.0/expo)
  write(chain,'(A,F6.2,A,F6.2)') 'Threshold ',threshold,' Exponent ',expo
  call map_message(seve%i,rname,chain)
  !
  do j=1,ny
    do i=1,nx
      f(i,j) = x(i) + y(j)            ! This is r^2
      if (f(i,j).lt.threshold) then   ! It falls to Zero at Threshold   
        f(i,j) = exp(-(f(i,j)**expo)) 
      else
        f(i,j) = 0.0
      endif
    enddo
  enddo
  !
  ! Get space for the Flux scale ratio fit, and compute the mask
  umin2 = (range(1)/uvradius)**2
  umax2 = (range(2)/uvradius)**2
  allocate(flux_ratio(nc),flux2(nc),rmask(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  no = 0
  do j=1,ny
    do i=1,nx
      rmask(i,j) = x(i) + y(j)            ! This is r^2
      if (rmask(i,j).gt.umin2 .and. rmask(i,j).lt.umax2) then     
        rmask(i,j) = 1.0
        no = no+1
      else
        rmask(i,j) = 0.0 ! Not f(i,j)
      endif
    enddo
  enddo
  !
  expand = (nx*ny)/(mx*my)
  if (expand.ne.1) then
    allocate(cbig(nx,ny),stat=ier)  
  endif
  !
  ! Get the beams and rescale the data accordingly
  !! Print *,'Computed F, Expand ',expand
  !
  scale = (high%gil%majo*high%gil%mino)/(low%gil%majo*low%gil%mino)
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(nc, dhigh,dlow,dout, high,low, f, rmask, flux_ratio, flux2)   &
  !$OMP & SHARED(nx,ny, mx,my, scale, ratio, expand) &
  !$OMP & PRIVATE(ic, chigh,clow,cbig,cout, dim,wfft, i,j)
  !
  !$OMP DO
  do ic = 1,nc
    !! Print *,'IC ',ic
    chigh(:,:) = cmplx(dhigh(:,:,ic),0.0)
    clow(:,:) = cmplx(dlow(:,:,ic),0.0)
    dim = (/nx,ny/)
    call fourt (chigh,dim,2,1,1,wfft)
    !
    ! LOWres
    dim = (/mx,my/)
    call fourt (clow,dim,2,1,1,wfft)
    !
    ! Multiply by the other beam
    call mulgau(clow,mx,my, &
    high%gil%majo,high%gil%mino,high%gil%posa*180.0/real(pi), &
    1.0,real(low%gil%inc(1)),real(low%gil%inc(2)),-1) 
    !
    ! Divide by its own beam - order matters...
    call mulgau(clow,mx,my, &
    low%gil%majo,low%gil%mino,low%gil%posa*180.0/real(pi), &
    1.0,real(low%gil%inc(1)),real(low%gil%inc(2)),1) 
    !
    clow = clow * scale * ratio
    !
    ! Expansion part
    if (expand.ne.1) then
      cbig = 0
      ! Load inner quarter
      do j=1,my/2
        cbig(1:mx,j) = clow(1:mx,j)
        cbig(1+nx-mx/2:nx,j) = clow(mx/2+1:mx,j)
      enddo
      do j=my/2+1,my
        cbig(1:mx,j+ny-my) = clow(1:mx,j)
        cbig(1+nx-mx/2:nx,j+ny-my) = clow(mx/2+1:mx,j)
      enddo
      cbig = cbig*expand ! rescale to appropriate units
    else
      cbig => clow
    endif
    !
    ! At this stage, we have cbig & chigh in same units.
    ! We can compare their relative intensities in the same
    ! UV Plane region by masking both of them by the overlap
    ! region, and fitting a scale factor.
    !
    ! It does not seem to work well, though, on the Demo example
    ! May be one should use f and 1-f to define the weights, rather
    ! than a simple mask...
    call scale_factor(nx,ny,cbig,chigh,rmask,flux_ratio(ic),flux2(ic))
    !
    cout(:,:) = f * cbig + (1.0-f) * chigh
    !
    ! Back transform
    dim = (/nx,ny/) 
    call fourt (cout,dim,2,-1,1,wfft)
    dout(:,:,ic) = real(cout)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  xx = 0
  ww = 0
  do ic=1,nc
    xx = xx + flux_ratio(ic)*flux2(ic)
    ww = ww + flux2(ic)
  enddo
  if (ww.gt.0) then
    xx = xx/ww
  else
    xx = sum(flux_ratio)/nc
  endif
  write(chain,'(A,F10.3)') 'Weighted flux factor (HIGHres / LOWres) ',xx
  call map_message(seve%i,rname,chain)
  !TEST! Print *,'           actors   ',flux_ratio(1:nc)
  !
  dout = dout / (nx*ny)
  !
  ! Reset the Blanking where the HIGHres had one
  if (high%gil%eval.ge.0) then
    where (abs(high%r3d-high%gil%bval).le.high%gil%eval) dout = all%gil%bval
  endif
  !
  ! Reset the Extrema
  all%loca%size = all%gil%dim(1)*all%gil%dim(2)*all%gil%dim(3)
  call cube_minmax('HYBRID',all,error)
  !
  deallocate (chigh,clow,cout,wfft,f)
end subroutine s_uv_hybrid
!
subroutine extract_real (c,mx,my,r,nx,ny)  
  !-----------------------------------------------------------------
  !!     Extract a Real array from a larger Complex array
  !! while shuffling the quarters 
  !-----------------------------------------------------------------
  integer nx,ny                        !! size of input array
  real r(nx,ny)                        !! input real array
  integer mx,my                        !! size of output array
  complex c(mx,my)                     !! output complex array
  !
  integer kx,ky,lx,ly
  integer i,j
  !
  kx = nx/2+1
  lx = mx/2+1
  ky = ny/2+1
  ly = my/2+1
  !
  do j=1,ny
    do i=1,nx
      r(i,j) = real(c(i-kx+lx,j-ky+ly)) 
    enddo
  enddo
end subroutine extract_real
!
subroutine spectrum_consistency(rname,ima,imb,tole,error)
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command UV_SHORT & FEATHER 
  !   Verify spectral axis consistency
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: rname  !! Command name
  type(gildas), intent(in) :: ima        !! First header
  type(gildas), intent(in) :: imb        !! Second header
  real, intent(in) :: tole               !! Spectral tolerance
  logical, intent(out) :: error          !! Logical error flag
  !
  integer :: na, nb, fa, fb
  real :: va, vb
  character(len=message_length) :: mess
  !
  error = .false.
  fa = ima%gil%faxi
  fb = imb%gil%faxi
  !
  ! Number of channels
  na = ima%gil%dim(fa)
  nb = ima%gil%dim(fb)
  !
  if (na.ne.nb) then
    write(mess,*) 'Mismatch in number of channels ',na,nb
    call map_message(seve%w,rname,mess)
    error = .true.
  endif
  !
  ! Do not check spectral axis if only 1 channel
  if (na.eq.1 .and. nb.eq.1) return
  !
  ! Check here the spectral axis mismatch
  if (abs(ima%gil%vres-imb%gil%vres).gt.abs(imb%gil%vres*tole)) then
    write(mess,*) 'Mismatch in spectral resolution ',ima%gil%vres,imb%gil%vres
    call map_message(seve%w,rname,mess)
    error = .true.
  endif
  if (abs(ima%gil%freq-imb%gil%freq).gt.abs(imb%gil%fres*tole)) then
    write(mess,*) 'Mismatch in frequency axis ',ima%gil%freq,imb%gil%freq
    call map_message(seve%w,rname,mess)
    error = .true.
  endif
  !
  ! Velocity should be checked too
  va = (1.d0-ima%gil%ref(fa))*ima%gil%vres + ima%gil%voff
  vb = (1.d0-imb%gil%ref(fb))*imb%gil%vres + imb%gil%voff
  if (abs(va-vb).gt.abs(imb%gil%vres*tole)) then
    write(mess,*) 'Mismatch in velocity axis ',va, vb 
    call map_message(seve%w,rname,mess)
    error = .true.
  endif
end subroutine spectrum_consistency
!
subroutine scale_factor(nx,ny,cbig,chigh,rmask,fscale,flux) 
  !*
  !  Compute best fit scaling factor for overlapping regions
  ! of visibilities.
  !
  integer, intent(in) :: nx,ny
  !! FFT of image size
  complex, intent(in) :: cbig(nx,ny)
  !! First FFT
  complex, intent(in) :: chigh(nx,ny)
  !! Second FFT
  real, intent(in) :: rmask(nx,ny)
  !! Masked regions
  real, intent(out) :: fscale
  !! Scale factor
  real, intent(out) :: flux
  !! Weight of scale factor
  !
  ! Local ---
  integer :: ix,iy
  real(kind=8) :: xx, xy, dx, dy
  !
  ! Code ----
  !
  !  Linear fit of flux scale factor - Unweighted - Makes no sense
  ! on noisy data...
  !
  ! A = Sum (X Y / sigma^2) / Sum (X^2/Sigma^2)
  ! A = Sum (X Y W) / Sum (X X W)
  !
  xx = 0
  xy = 0
  !
  do iy=1,ny
    do ix=1,nx
      if (rmask(ix,iy).ne.0.) then
        ! Real part
        dx = real(cbig(ix,iy))**2 + imag(cbig(ix,iy))**2
        dy = real(chigh(ix,iy))*real(cbig(ix,iy)) + imag(chigh(ix,iy))*imag(cbig(ix,iy)) 
        !
        ! Compare only where there is a chance to have a significant signal, i.e.
        ! when the DY is close enough to DX - Assume scale is reasonable to first order
        if (dy.gt.0 .and. abs(dy/dx).gt.0.5*dx) then
          xx = xx + dx
          xy = xy + dy
        endif
        !
        ! Imaginary parts
        dx = 2*real(cbig(ix,iy))*imag(cbig(ix,iy))
        dy = real(chigh(ix,iy))*imag(cbig(ix,iy)) + imag(chigh(ix,iy))*real(cbig(ix,iy)) 
        if (dx.gt.0) then
          if (dy.gt.0 .and. abs(dy/dx).gt.0.5*dx) then
            xx = xx + dx
            xy = xy + dy
          endif
        else
          if (dy.lt.0 .and. abs(dy/dx).gt.0.5*dx) then
            xx = xx - dx
            xy = xy - dy
          endif
        endif
      endif
    enddo
  enddo
  ! ! Print *,'Fscale ',xy,' Flux ',xx,' Ratio ',xy/xx
  if (xx.ne.0.) then
    fscale = xy/xx
    flux   = xx
  else
    fscale = 1.
    flux = 0.
  endif
end subroutine scale_factor

!-----------------------------------------------------------------------
! Miscellaneous system dependent routines. Some are written in Fortran
! (module sysfor.for), others in C (module sysc.c)
!-----------------------------------------------------------------------
subroutine sic_terminal(name)
  !---------------------------------------------------------------------
  ! @ public
  !  Returns the name of the terminal.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: name  ! Terminal name
  name = '/dev/tty'
  !  Alternate code (calls ctermid through a buffer C routine)
  !
  !       INTEGER BUFSIZ
  !       PARAMETER (BUFSIZ=80)   ! Should be long enough for a physical name...
  !       INTEGER(KIND=1) BUFFER(BUFSIZ)
  !       INTEGER I
  !*
  !       CALL TERMC(BUFFER)      ! Calls ctermid
  !       DO I=1,MIN(LEN(NAME),BUFSIZ)
  !           NAME(I:I) = CHAR(BUFFER(I))
  !       ENDDO
end subroutine sic_terminal
!
subroutine sysexi(code)
  use gsys_interfaces, except_this=>sysexi
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: code  ! Input terminating code
  ! Local
  character(len=message_length) :: mess
  !
#if defined(FORTRAN2003)
  logical :: error
#endif
  !
  if (mod(code,2).eq.0) then
    write (mess,100) code
    call gsys_message(seve%f,'SYSTEM',mess)
#if defined(FORTRAN2003)
    ! Flush the message file, this can help after a crash...
    error = .false.
    call gmessage_flush(error)
    ! Flush the STDOUT, this can help after a task crash...
    call flush(6)
#endif
    !
    call gag_crash
  endif
  stop ' '
100 format ('Exit code ',i12,' from call to SYSEXI')
end subroutine sysexi
!
subroutine gag_os(os)
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: os  !
#if defined(WIN32)
  os = 'WIN32'
#else
  os = 'LINUX'
#endif
end subroutine gag_os
!
subroutine gag_mkdir(dir,error)
  use gsys_interfaces, except_this=>gag_mkdir
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: dir    !
  logical,          intent(out) :: error  !
  ! Local
  character(len=*), parameter :: rname='GAG_MKDIR'
  ! Local
  integer(kind=4) :: ier
  character(len=filename_length) :: chain,dire
  !
  dire = dir
  ier = sic_getlog(dire)
#ifdef MINGW
  chain = 'mkdir '//dire
#else
  chain = 'mkdir -p '//dire
#endif
  ier = gag_system(chain)
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Could not create directory '//dire)
    error = .true.
  else
    error = .false.
  endif
end subroutine gag_mkdir
!
subroutine gag_directory_num(dirstring,num,error)
  use gbl_message
  use gsys_interfaces, except_this=>gag_directory_num
  !---------------------------------------------------------------------
  ! @ public
  !  Return the number of standard files in a directory. Nice to be
  ! called before 'gag_directory' so that the filename(:) array can be
  ! allocated to an appropriate size.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: dirstring  !
  integer(kind=4),  intent(out)   :: num        ! Number of standard files
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GAG_DIRECTORY_NUM'
  character(len=filename_length) :: dstring
  integer(kind=4) :: ier
  !
  call sic_resolve_env(dirstring,dstring)  ! Resolve ~ and other environment vars
  call sic_resolve_log(dstring)            ! Resolve sic logicals
  !
  if (gag_inquire(dstring,len_trim(dstring)).ne.0) then
    num = 0
    call gsys_message(seve%e,rname,'No such directory '//dstring)
    error = .true.
    return
  endif
  !
  ier = gag_directory_num_C(dstring,num)
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Error counting files in '//dirstring)
    error = .true.
    return
  endif
  !
end subroutine gag_directory_num
!
subroutine gag_directory(dirstring,filestring,filename,nfile,error)
  use gildas_def
  use gbl_message
  use gsys_interfaces, except_this=>gag_directory
  !---------------------------------------------------------------------
  ! @ public
  !   Return the actual files that match a given string (with *'s)
  ! inside a given directory (no *'s). Note that nothing forbids the
  ! file pattern to ask for subdirectories (e.g. */foo*.dat). The short
  ! filenames are returned (without directory path).
  !   In return, the list of files is stored in an array provided by the
  ! caller. This array MUST be allocatable. The subroutine will
  ! reallocate it to the appropriate size.
  !---------------------------------------------------------------------
  character(len=*), intent(in)               :: dirstring    ! input directory
  character(len=*), intent(in)               :: filestring   ! input file string
  character(len=*), intent(out), allocatable :: filename(:)  ! char array filled in
  integer(kind=4),  intent(out)              :: nfile        ! number of files
  logical,          intent(inout)            :: error        !
  ! Local
  character(len=*), parameter :: rname='GAG_DIRECTORY'
  integer(kind=4) :: lun,ier,ic,ld
  character(len=filename_length) :: com,tmp,tmpname,dstring
  character(len=1) :: insep,ousep,cdir
  logical :: doalloc
#if defined(WIN32)
  integer(kind=4) :: i, nbrack, nclose, idot, nt
  character(len=filename_length) :: tmpstring
  character(len=4) :: addstring
  character(len=32) :: extension
#endif
  !
  ier = 0
  nfile = 0
  ld = lenc(dirstring)
  dstring = dirstring(1:ld)
  ! add directory separator if needed
  call gag_separ(insep,ousep,cdir)
  !
  ! If a directory is specified,check that it exists
  if (ld.gt.0) then
    if (gag_isdir(dstring(1:ld)).ne.0) then
      call gsys_message(seve%w,rname,'No such directory '//dstring(1:ld))
      return
    else if(dstring(ld:ld).ne.cdir) then
      ld = ld+1
      dstring(ld:ld)=cdir
    endif
  endif
  !
  tmp = 'files.dat'
  call sic_parsef(tmp,tmpname,'GAG_SCRATCH:','.dat')
#if defined(WIN32)
  tmpstring = filestring
  nbrack =  index(tmpstring,'[')
  if (nbrack.ne.0) then
    nclose = index(tmpstring,']')
    addstring = tmpstring(nbrack+1:nclose-1)
    !
    ! Supported syntax is ONLY [a-b], no more
    if (len_trim(addstring).ne.3.or.addstring(2:2).ne.'-' &
      & .or.ichar(addstring(1:1)).gt.ichar(addstring(3:3))) then
      call gsys_message(seve%e,rname,'Invalid syntax '//tmpstring(nbrack:nclose))
      nfile = -1
    else
      tmpstring(nbrack:) = addstring(1:1)//filestring(nclose+1:)
      if (ld.eq.0) then
        com = 'dir /B /O:N '//trim(tmpstring)//' > '//tmpname
      else
        com = 'dir /B /O:N '//trim(dstring)//trim(tmpstring)//' > '//tmpname
      endif
      ier = gag_system(com)
      do i = ichar(addstring(1:1))+1, ichar(addstring(3:3))
        tmpstring(nbrack:) = char(i)//filestring(nclose+1:)
        if (ld.eq.0) then
          com = 'dir /B /O:N '//trim(tmpstring)//' >> '//tmpname
        else
          com = 'dir /B /O:N '//trim(dstring)//trim(tmpstring)//' >> '//tmpname
        endif
        ier = gag_system(com)
      enddo
    endif
  else
    if (ld.eq.0) then
      com = 'dir /B /O:N '//trim(filestring)//' > '//tmpname
    else
      com = 'dir /B /O:N '//trim(dstring)//trim(filestring)//' > '//tmpname
    endif
    ier = gag_system(com)
  endif
  !
  ! Check if any wildcard beyond the extension separator
  nt = len_trim(filestring)
  idot = 0
  do i= nt,1,-1
    if (filestring(i:i).eq.'*') then
      exit
    else if (filestring(i:i).eq.'.') then
      extension = filestring(i:nt)
      idot = nt-i+1
    endif
  enddo
#else
  if (len_trim(filestring).eq.0) then
    ! Empty file pattern: list everything, but avoid "-d" which lists "."
    ! (current directory) if current directory is empty.
    if (ld.eq.0) then
      com = ' 2>/dev/null ls -t1  > '//tmpname
    else
      com = ' 2>/dev/null cd '//trim(dstring)//'; 2>/dev/null ls -t1 '//  &
      trim(filestring)//' > '//tmpname
    endif
  else
    if (ld.eq.0) then
      com = ' 2>/dev/null ls -t1 -d '//trim(filestring)//' > '//tmpname
    else
      com = ' 2>/dev/null cd '//trim(dstring)//'; 2>/dev/null ls -t1 -d '//  &
      trim(filestring)//' > '//tmpname
    endif
  endif
  ier = gag_system(com)
#endif
  ! Can not trap this error: 'ls' raises an error if 0 files are found...
  ! if (ier.ne.0) then
  !   call gsys_message(seve%e,rname,'Could not list directory')
  !   error = .true.
  !   return
  ! endif
  !
  ! Number of files found?
  call gag_fillines(tmpname,.false.,nfile,error)
  if (error)  return
  doalloc = .false.
  if (allocated(filename)) then
    if (size(filename).ne.nfile) then
      deallocate(filename)
      doalloc = .true.
    endif
  else
    doalloc = .true.
  endif
  if (doalloc) then
    allocate(filename(nfile),stat=ier)
    if (failed_allocate('SIC','file list',ier,error))  return
  endif
  !
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    call gag_filrm(tmpname)
    return
  endif
  ier = sic_open (lun,tmpname,'OLD',.true.)
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Cannot open '//tmpname)
    call putios('E-'//trim(rname)//', ',ier)
    call gag_filrm(tmpname)
    nfile = -1
    return
  endif
  !
  nfile = 0
  do
    read(lun,'(a)',end=100) com
    tmp = com
    ic = lenc(tmp)
#if defined(WIN32)
    !
    ! Special case for Windows because of the UGLY BUG of 8.3 short names
    !  Windows will consider short names in the search process. The
    !  problem is that the extension is purely truncated to 3 characters
    !  in such a search, so a search of  toto*.lmv would also return the
    !  toto*.lmv-clean files for example. The result is just next to be
    !  unpredictable when you have a mixture of files with and without
    !  short names, which can happen because the creation of 8.3 names
    !  is a dynamical attribute of the file system, but not their use !...
    !  Without this patch, on a directory containing (among other things)
    !     date.f90    date.f90-1
    !    sic find date.f90   would return only date.f90
    !  but
    !    sic find *.f90     would return both files.
    !  Exercice: try to figure out why given the above rules...
    !  Hints: there several possible solutions
    if (idot.ne.0) then
      if (tmp(ic-idot+1:ic).ne.extension(1:idot)) ic = 0
    endif
    !
#endif
    if (ic.ne.0) then
      nfile = nfile+1
      filename(nfile) = tmp(1:ic)
    endif
  enddo
100 close(lun)
  call gag_filrm(tmpname)
  call sic_frelun(lun)
end subroutine gag_directory
!
subroutine sic_username(name)
  use gsys_interfaces, except_this=>sic_username
  !---------------------------------------------------------------------
  ! @ public
  ! Return user name from:
  ! 1) $USER environment variable, else
  ! 2) $LOGNAME environment variable, else
  ! 3) use string "Gildas"
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: name  ! Output string
  !
  name = ' '
  call sic_getenv('USER',name)                       ! $USER
  if (name.eq.' ') call sic_getenv('LOGNAME',name)   ! $LOGNAME
  if (name.eq.' ') name = 'Gildas'                   ! Default...
end subroutine sic_username
!
subroutine sic_hostname(node)
  use gsys_interfaces, except_this=>sic_hostname
  !---------------------------------------------------------------------
  ! @ public
  ! Return host name from:
  ! 1) $HOST environment variable, else
  ! 2) $HOSTNAME environment variable, else
  ! 3) non-standard subroutine HOSTNM (standard alternative could be
  !    execute_command_line("hostname",node), else
  ! 4) blank string
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: node  ! Output string
  !
  node = ' '
  call sic_getenv('HOST',node)                       ! $HOST
  if (node.eq.' ') call sic_getenv('HOSTNAME',node)  ! $HOSTNAME
#if defined(GAG_USE_UNDERSCORE)
  ! Disabled if no underscore as ifort can not find its own subroutine
  ! in this case...
  if (node.eq.' ') call hostnm(node)
#endif
end subroutine sic_hostname
!
subroutine sic_setdir(direc,nc,error)
  use gsys_interfaces, except_this=>sic_setdir
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! SIC   Machine specific routine that changes and/or returns the
  !       default directory.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: direc  ! Name of default directory
  integer(kind=4),  intent(inout) :: nc     ! Length of directory name
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  character(len=filename_length) :: diro
  integer(kind=4) :: ier
  character(len=1), parameter :: backslash=char(92)
  !
  ! Get input name (if any)
  if (nc.gt.0) then
    call sic_parse_file(direc(1:nc),'','',diro)
    nc = len_trim(diro)
    if (diro(nc:nc).eq.'/' .or. diro(nc:nc).eq.backslash) nc = nc-1
    !
    ! Check if directory exists
    if (gag_inquire(diro,nc).ne.0) then
      call gsys_message(seve%e,'SETDIR','No such directory '//diro)
      diro = ''
      error = .true.
      ! Do not return, we still have to return the current working directory.
    endif
  else
    diro = ''
  endif
  !
  ! Set a new directory if non-null, and get current working directory
  ier = set_dir(diro)
  !
  if (ier.ne.0) then
    ! Error when changing it
    error = .true.
    call putmsg('E-SETDIR,  ',ier)
    !
    ! Get cwd anyhow
    diro = ''
    ier = set_dir(diro)
  endif
  !
  ! Return cwd
  direc = diro
  nc = len_trim(diro)
end subroutine sic_setdir
!
subroutine gag_cpu(arg)
  !---------------------------------------------------------------------
  ! @ public
  ! All compilers are assumed to be Fortran 1995 compatible now
  !---------------------------------------------------------------------
  real(kind=4), intent(out) :: arg  !
  call cpu_time(arg)
end subroutine gag_cpu
!
subroutine gag_delete(fich)
  use gildas_def
  use gbl_message
  use gsys_interfaces, except_this=>gag_delete
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: fich  !
  ! Local
  integer(kind=4) :: ier
  character(len=filename_length) :: chain
  !
#if defined(WIN32)
  chain = 'DEL '//fich
#else
  chain = 'rm -f '//fich
#endif
  ier = gag_system(chain)
  if (ier.ne.0)  &
    call gsys_message(seve%e,'DELETE','Could not delete file '//fich)
end subroutine gag_delete
!
function gag_which(name,dirlist,full)
  use gildas_def
  use gsys_interfaces, except_this=>gag_which
  !---------------------------------------------------------------------
  ! @ public
  !   Find which file is invoked, given its name. Input name may
  ! include:
  !   - an absolute path,
  !   - a relative path,
  !   - only the file name, in which case it is searched in the
  !     input list of directories (might be an environment variable).
  !     This list is ignored in the 2 above cases.
  ! Output is a valid path to the file from current working directory.
  ! It is legal to search for a file which does not exist. The (or a)
  ! full path will be built, but the function value will be false on
  ! return.
  !   This function does the same as 'which' system command if input
  ! name is searched in '$PATH'
  !---------------------------------------------------------------------
  logical :: gag_which                      ! .true. on return if found
  character(len=*), intent(in)  :: name     ! File name to search
  character(len=*), intent(in)  :: dirlist  ! List of directories to search in (optional)
  character(len=*), intent(out) :: full     ! Return the path in this variable
  ! Local
  character(len=path_length) :: path,path2
  character(len=1) :: insep,ousep,disep
  integer(kind=4) :: i,j,pl,pl2
  logical :: error
  !
  call gag_separ(insep,ousep,disep)
  !
  full = name
  gag_which = .false.
  error = .false.
  !
  ! Name may already have an absolute path
#ifdef WIN32
  if (name(2:3).eq.':\') then
#else
  if (name(1:1).eq.disep) then
#endif
    gag_which = (gag_inquire (full,lenc(full)).eq.0)
    return
  !
  ! Name may have a relative path
  elseif (index(name,disep).gt.1 .or. dirlist.eq.'') then
    path = ' '
    pl = 0
    call sic_setdir(path,pl,error)
    if (error) return
    full = path(1:pl)//disep//name
    gag_which = (gag_inquire (full,lenc(full)).eq.0)
    return
  !
  ! Else, scan through the input directory list / environment variable
  else
    call sic_resolve_env(dirlist,path)
#ifndef WIN32
    ! Replace ":" ";", recognized by SIC_QUERY_FILE as separator
    i = index(path,':')
    do while (i.ne.0)
      path(i:i) = ';'
      i = index(path,':')
    enddo
#endif
    ! Add a directory separator at the end of each directory
    ! (this is needed by SIC_QUERY_FILE)
    pl = lenc(path)
    path2 = ''
    pl2 = 0
    j = 1
    do i=1,pl
      if (path(i:i).eq.';') then
        path2 = path2(:pl2)//path(j:i-1)//disep
        pl2 = lenc(path2)
        j = i
      endif
    enddo
    path2 = path2(:pl2)//path(j:pl)//disep
    !
    gag_which = sic_query_file(name,path2,'',full)
    !
  endif
end function gag_which
!
function gag_mtime(file,nanosec)
  use gsys_interfaces, except_this=>gag_mtime
  !---------------------------------------------------------------------
  ! @ public
  ! Return the last modification time in nanoseconds since 01-jan-1970
  ! The file can be a regular file or a directory. If file is a symlink,
  ! evaluation is made on its target.
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_mtime  ! Function value on return (0 for success)
  character(len=*), intent(in)  :: file     ! File name
  integer(kind=8),  intent(out) :: nanosec  !
  ! Local
  integer(kind=8), parameter :: sec2nano=1000000000_8
  integer(kind=4) :: sec,nsec
  !
  gag_mtime = gag_mtime_c(file,sec,nsec)
  if (gag_mtime.ne.0) then
    nanosec = 0
    return
  endif
  !
  nanosec = sec2nano*sec+nsec
  !
end function gag_mtime
!
function gag_time(nanosec)
  use gsys_interfaces, except_this=>gag_time
  !---------------------------------------------------------------------
  ! @ public
  ! Return the current time in nanoseconds since 01-jan-1970
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_time  ! Function value on return (0 for success)
  integer(kind=8), intent(out) :: nanosec  !
  ! Local
  integer(kind=8), parameter :: sec2nano=1000000000_8
  integer(kind=4) :: sec,nsec
  !
  gag_time = gag_time_c(sec,nsec)
  if (gag_time.ne.0) then
    nanosec = 0
    return
  endif
  !
  nanosec = sec2nano*sec+nsec
  !
end function gag_time
!
subroutine gag_filmodif(file,modif,error)
  use gbl_message
  use gsys_types
  use gsys_interfaces, except_this=>gag_filmodif
  !---------------------------------------------------------------------
  ! @ public
  !  (re)compute the 'modified' structure and evaluate if the file
  ! was 'probably' modified since last evaluation. The file can be
  ! a regular file or a directory. If file is a symlink, evaluation is
  ! made on its target.
  !   NB: modif%modified is NOT modified if there is an ambiguity.
  ! It is up to the caller to set it to its best default according to
  ! the context.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file   ! File name
  type(mfile_t),    intent(inout) :: modif  !
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='TIME'
  integer(kind=8), parameter :: granularity=1000000000_8  ! File system granularity (ns)
  integer(kind=4) :: ier
  integer(kind=8) :: time
  !
  if (file.ne.modif%file) then
    ! Not the same file, e.g. at first call
    modif%file = file
    ier = gag_mtime(file,modif%mtime)
    if (ier.ne.0)  goto 101
    ier = gag_time(modif%ptime)
    if (ier.ne.0)  goto 102
    ! modif%modif = unchanged, let caller decide e.g. at first call
    return
  endif
  !
  ! Same file name, has it been modified?
  ier = gag_mtime(file,time)
  if (ier.ne.0)  goto 101
  if (time.ne.modif%mtime) then
    ! File has been modified (in the past or in the the future, this may
    ! happen on NFS file systems)
    ! Note: use .NE. instead of .LT., so that change of directories
    ! with same filename may be handled to first order
    modif%mtime = time
    ier = gag_time(modif%ptime)
    if (ier.ne.0)  goto 102
    modif%modif = .true.
    return
  endif
  !
  ! Same modification time. Modified? May be, may be not... Compare last
  ! read time
  ier = gag_time(time)
  if (ier.ne.0)  goto 102
  if (time-modif%ptime.lt.0) then
    ! Last call was in the past? Should never happen
    call gsys_message(seve%e,rname,  &
      'Internal error: last evaluation in the future!')
    error = .true.
    return
  elseif (time-modif%ptime.le.granularity) then
    ! If there was a modification, this is below the file system
    ! granularity. Ambiguous, change nothing, let the caller decide
    continue
  else
    ! Much more time has elapsed, for sure file has not changed
    modif%modif = .false.
  endif
  ! Do NOT update the proved 'ptime'! Else if called at high rate, the test
  ! above will be perpetually ambiguous.
  return
  !
101 continue  ! Error 1
  call gsys_message(seve%e,rname,  &
    'Error getting modification time for file '//file)
  error = .true.
  return
102 continue  ! Error 2
  call gsys_message(seve%e,rname,'Error getting current time')
  error = .true.
  return
end subroutine gag_filmodif
!
subroutine gag_fillines(file,doblank,nlines,error)
  use gbl_message
  use gsys_interfaces, except_this=>gag_fillines
  !---------------------------------------------------------------------
  ! @ public
  ! Count the number of lines in a FORMATTED file. More precisely, it
  ! counts the number of carriage returns (same as Linux shell "wc -l").
  ! Be careful of missing carriage return at the end of your files.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file     !
  logical,          intent(in)    :: doblank  ! Ignore blank lines?
  integer(kind=4),  intent(out)   :: nlines   !
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='LINES'
  integer(kind=4) :: ier,lun,nl
  character(len=8196) :: local_line
  !
  nlines = 0
  !
  ! Open file
  ier = sic_getlun(lun)
  if (mod(ier,2).eq.0) then
    error = .true.
    return
  endif
  ier = sic_open(lun,file,'OLD',.true.)
  if (ier.ne.0) then
    call gsys_message(seve%e,rname,'Error opening '//file)
    call putios('E-ACCEPT,  ',ier)
    error = .true.
    goto 10
  endif
  !
  ! Read file
  if (doblank)  then
    ! Ignore blank and comment lines
    do
      read(lun,'(A)',iostat=ier)  local_line
      if (ier.ne.0) exit  ! <0: EOF, >0: Error
      ! Same as ACCEPT:
      if (local_line(1:1).eq.'!')  cycle  ! Ignore comments
      nl = len_trim(local_line)
      call sic_blanc(local_line,nl)  ! Suppress everything after a '!'
      if (nl.eq.0)  cycle            ! Ignore empty lines after SIC_BLANC
      nlines = nlines+1
    enddo
    !
  else
    ! Count everything
    do
      read(lun,'(A)',iostat=ier)
      if (ier.ne.0) exit  ! <0: EOF, >0: Error
      nlines = nlines+1
    enddo
  endif
  !
  if (ier.gt.0) then  ! Error
    call gsys_message(seve%e,rname,'Error counting lines')
    call putios('E-LINES,  ',ier)
    error = .true.
    return
  endif
  !
10 continue
  ! Close file
  ier = sic_close(lun)
  call sic_frelun(lun)
  !
end subroutine gag_fillines
!
function gag_filsame(file1,file2)
  use gsys_interfaces, except_this=>gag_filsame
  !---------------------------------------------------------------------
  ! @ public
  ! Check if 2 files are identical or not.
  ! This is based by comparing the devices hosting the files and the
  ! inodes on the devices.
  !---------------------------------------------------------------------
  logical :: gag_filsame
  character(len=*), intent(in) :: file1,file2
  gag_filsame = gag_filsame_c(file1,file2).eq.1
end function gag_filsame

subroutine sampler(line,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>sampler
  use greg_kernel
  use greg_rg
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Support routine for Command
  !	RESAMPLE NX NY/ [/X Xref Xval Xinc] [/Y Yref Yval Yinc]
  !		[/BLANKING Blank]
  ! 	Resample the current Regular Grid onto a different one.
  ! Arguments :
  !	LINE	C*(*)	Command line		Input
  !	ERROR	L	Logical error flag	Output
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='RESAMPLE'
  real*8 :: xmin,xmax,ymin,ymax,aconv(6),bconv(6)
  real*4 :: blank,ablank(2)
  integer :: nrx,nry,ier
  real(kind=4), pointer :: rgbuf(:,:)
  !
  ! Check arguments
  if (sic_narg(0).ne.2) then
    call greg_message(seve%e,rname,'Two arguments required')
    error = .true.
  endif
  if (rg%status.eq.code_pointer_null) then
    call greg_message(seve%e,rname,'No map loaded')
    error = .true.
  endif
  if (error) return
  !
  ! Blanking value: if /BLANK is not present, use current blanking (even if
  ! no blanking available). Otherwise /BLANK overrides the current blanking val.
  ablank(1)=cblank
  ablank(2)=eblank
  if (sic_present(3,1))then
    blank = cblank
    call sic_r4 (line,3,1,blank,.true.,error)
    if (error) return
    ablank(1)=blank
    ablank(2)=0.0
  endif
  if (sic_present(3,2))then
    blank = eblank
    call sic_r4 (line,3,2,blank,.true.,error)
    if (error) return
    ablank(2)=blank
  endif
  !
  call sic_i4 (line,0,2,nry,.true.,error)
  call sic_i4 (line,0,1,nrx,.true.,error)
  if (error) then
    call greg_message(seve%e,rname,'Specify map dimensions')
    return
  endif
  !
  ! /X option
  if (.not.sic_present(1,0)) then
    xmin = (0.5d0-rg%xref)*rg%xinc+rg%xval
    xmax = (rg%nx+0.5d0-rg%xref)*rg%xinc+rg%xval
    bconv(3) = (xmax-xmin)/dble(nrx)
    bconv(2) = xmin
    bconv(1) = 1.0d0
  else
    call sic_r8 (line,1,3,bconv(3),.true.,error)
    if (error) return
    call sic_r8 (line,1,2,bconv(2),.true.,error)
    if (error) return
    call sic_r8 (line,1,1,bconv(1),.true.,error)
    if (error) return
  endif
  ! /Y option
  if (.not.sic_present(2,0)) then
    ymin = (0.5d0-rg%yref)*rg%yinc+rg%yval
    ymax = (rg%ny+0.5d0-rg%yref)*rg%yinc+rg%yval
    bconv(6) = (ymax-ymin)/dble(nry)
    bconv(5) = ymin
    bconv(4) = 1.0d0
  else
    call sic_r8 (line,2,3,bconv(6),.true.,error)
    if (error) return
    call sic_r8 (line,2,2,bconv(5),.true.,error)
    if (error) return
    call sic_r8 (line,2,1,bconv(4),.true.,error)
    if (error) return
  endif
  !
  ! Now resample
  ! Unfavorable case: RG too small: allocate VM for new RG,resample inside,
  ! deallocate old RG
  aconv(1) = rg%xref
  aconv(2) = rg%xval
  aconv(3) = rg%xinc
  aconv(4) = rg%yref
  aconv(5) = rg%yval
  aconv(6) = rg%yinc
  !
  allocate(rgbuf(nrx,nry),stat=ier)
  error = ier.ne.0
  if (error) goto 30
  !
  call resamp(rg%data,rg%nx,rg%ny,aconv,ablank,rgbuf,nrx,nry,bconv)
  !
  call reassociate_rgdata(rgbuf,nrx,nry,error)
  if (error)  goto 30
  rg%status = code_pointer_allocated  ! Steal rgbuf memory allocation
  !
  rg%xref = bconv(1)
  rg%xval = bconv(2)
  rg%xinc = bconv(3)
  rg%yref = bconv(4)
  rg%yval = bconv(5)
  rg%yinc = bconv(6)
  return
  !
30 call greg_message(seve%e,rname,'Not Enough Virtual Memory available')
  error =.true.
  return
end subroutine sampler
!
subroutine resamp(a,mx,my,aconv,ablank,b,nx,ny,bconv)
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Stand alone subroutine
  !	Resample an input map to a different grid. bilinear interpolation.
  ! Arguments
  !	A	R*4(*)	Input map of dimensions MX MY
  !	MX,MY	I
  !	ACONV	R*8(6)	Pixel conversion formulae
  !			CONV(1) = Xref, CONV(2)=Xval, CONV(3)=Xinc
  !	B	R*4(*)	Output map of dimensions NX,NY
  !	NX,NY	I
  !	BCONV	R*8(6)
  !	BLANK	R*4	Blanking value
  !---------------------------------------------------------------------
  integer :: mx                     !
  integer :: my                     !
  real*4 :: a(mx,my)                !
  real*8 :: aconv(6)                !
  real*4 :: ablank(2)               !
  integer :: nx                     !
  integer :: ny                     !
  real*4 :: b(nx,ny)                !
  real*8 :: bconv(6)                !
  ! Local
  real*4 :: bval,eval
  !
  integer :: ib,jb,ia,ja
  real*8 :: axref,axval,axinc,ayref,ayval,ayinc
  real*8 :: bxref,bxval,bxinc,byref,byval,byinc
  real*8 :: xa,ya
  real*8 :: xr,yr,dx,dy
  !
  ! Preliminary processing
  bval=ablank(1)
  eval=ablank(2)
  axref = aconv(1)
  axval = aconv(2)
  axinc = aconv(3)
  ayref = aconv(4)
  ayval = aconv(5)
  ayinc = aconv(6)
  bxref = bconv(1)
  bxval = bconv(2)
  bxinc = bconv(3)
  byref = bconv(4)
  byval = bconv(5)
  byinc = bconv(6)
  !
  ! Take Blanking into account, version #1
  if (eval.lt.0) then
    ! No Blanking. Non-existent values are put to BVAL (whatever it is...)
    ! Loop over Output data points
    do jb = 1,ny
      do ib = 1,nx
        !
        ! Find pixel coordinate in input map
        xa = (ib-bxref)*bxinc + bxval
        ya = (jb-byref)*byinc + byval
        xr = (xa-axval)/axinc + axref
        yr = (ya-ayval)/ayinc + ayref
        ia = int (xr)
        ja = int (yr)
        xr = xr-ia
        yr = yr-ja
        dx = 1.d0-xr
        dy = 1.d0-yr
        ! Avoid edges
        if (ia.lt.1 .or. ia.ge.mx .or. ja.lt.1 .or. ja.ge.my) then
          b(ib,jb) = bval
        else
          ! Interpolate (X or Y first, does not matter in this case)
          b(ib,jb) = dx*dy*a(ia,ja)     + xr*dy*a(ia+1,ja) +  &
                     xr*yr*a(ia+1,ja+1) + dx*yr*a(ia,ja+1)
        endif
      enddo
    enddo
  else
    ! Loop over Output data points
    do jb = 1,ny
      do ib = 1,nx
        xa = (ib-bxref)*bxinc + bxval
        ya = (jb-byref)*byinc + byval
        xr = (xa-axval)/axinc + axref
        yr = (ya-ayval)/ayinc + ayref
        ia = int (xr)
        ja = int (yr)
        xr = xr - ia
        yr = yr - ja
        dx = 1.d0-xr
        dy = 1.d0-yr
        if (ia.lt.1 .or. ia.ge.mx .or. ja.lt.1 .or. ja.ge.my) then
          b(ib,jb) = bval
        elseif (abs(a(ia,ja)-bval).le.eval) then
          b(ib,jb) = bval
        elseif (abs(a(ia+1,ja)-bval).le.eval) then
          b(ib,jb) = bval
        elseif (abs(a(ia,ja+1)-bval).le.eval) then
          b(ib,jb) = bval
        elseif (abs(a(ia+1,ja+1)-bval).le.eval) then
          b(ib,jb) = bval
        else
          b(ib,jb) = dx*dy*a(ia,ja)     + xr*dy*a(ia+1,ja)+  &
                     xr*yr*a(ia+1,ja+1) + dx*yr*a(ia,ja+1)
        endif
      enddo
    enddo
  endif
end subroutine resamp

subroutine dowfact(nv,we,wfact)
  use gildas_def
  use grid_control
  use gkernel_interfaces, only : gr4_median
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- UV_MAP Weight handling routine
  !
  !   Compute renormalisation factor WFACT for Robust Weighting
  !
  !---------------------------------------------------------------------
  integer , intent(in) :: nv      !! Number of visibilities
  real, intent(inout)  :: we(nv)  !! Weights
  real, intent(out) :: wfact      !! Normalisation factor
  !
  ! Local ---
  integer(kind=index_length) :: nv8
  integer :: i, mv
  real :: weight, wmin, wmax, wmed, winf
  logical :: error
  !
  ! Code ----
  weight = 0.0
  wmax = 0.0
  wmin = 1.e36  
  mv = 0
  do i=1,nv
    if (we(i).gt.0.0) then
      wmin = min(we(i),wmin)
      wmax = max(we(i),wmax)
      weight = weight+we(i)
      mv = mv+1
    else if (we(i).lt.0) then
      print *,'Non null ',i     ! This should not occur
      we(i) = 0
    endif
  enddo
  !
  if (grid_weighting.eq.0) then
    ! Historical Min based estimate
    winf = wmin
  else if (grid_weighting.lt.0) then
    ! Mean based estimate
    weight = weight/mv ! Mean weight, but avoiding Flagged visibilities
    winf = weight / sqrt(wmax/weight) 
  else if (grid_weighting.gt.0) then
    ! Median based estimate
    error = .false.
    nv8 = nv
    !Print *,MV,' valid visibilities, ',nv-mv,' flagged'
    call gr4_median(we,nv8,0.0,0.0,wmed,error) 
    winf = wmed / sqrt(wmax/wmed) 
  endif
  wfact = sqrt(winf*wmax)
end subroutine dowfact
!
subroutine dogrid_smooth (nx,ny,mapn,maps,unif)!
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- UV_MAP Weight handling routine
  !
  !   Smooth the natural weights to get the local weight density.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nx         !! X size
  integer, intent(in) :: ny         !! Y size
  real, intent(in)  :: mapn(nx,ny)  !! Initial weights
  real, intent(out) :: maps(nx,ny)  !! Smoothed weights
  real, intent(in) :: unif          !! Smoothing length, in pixel units
  !
  ! Local ---
  integer :: ix,iy, ixl, ixu, iyl, iyu, ir, jx, jy
  real(4) :: r2, u2
  !
  ! Code ----
  maps = 0
  u2 = unif**2
  !
  ir = int(unif/2)+1
  ixl = int(unif/2)+2
  ixu = int(nx-unif/2)-1
  iyl = ixl
  iyu = int(ny-unif/2)-1
  !
  ! This region is guaranteed to be smoothable
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED  (ixl,ixu,iyl,iyu,ir,u2, maps, mapn) &
  !$OMP & PRIVATE (ix,iy,jx,jy,r2)
  !$OMP DO COLLAPSE(2)
  do iy=iyl,iyu
    do ix=ixl,ixu
      !
      maps(ix,iy) = 0.0
      do jy=iy-ir,iy+ir
        do jx=ix-ir,ix+ir
          r2 = (jx-ix)**2 + (iy-jy)**2
          if (r2.le.u2) maps(ix,iy) = maps(ix,iy) + mapn(jx,jy)
        enddo
      enddo
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine dogrid_smooth
!
subroutine doweig_robust(jc,nv,visi,jw,we,wm)
  use imager_interfaces, only : map_message
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- UV_MAP Weight handling routine
  !
  !   Correct the weights from the local density according to the
  !   Robustness factor.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: jc        !! Size of a visibility
  integer, intent(in) :: nv        !! Number of visibilities
  real, intent(in) :: visi(jc,nv)  !! Visibilities
  integer, intent(in) :: jw        !! Weight column
  real, intent(inout) :: we(nv)    !! Weights
  real, intent(in) :: wm           !! Robust factor
  !
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! Local ---
  real(4) :: weight, s2
  integer :: i
  !
  ! Code ----
  call dowfact(nv,we,weight)
  !
  if (wm.lt.0) then
    !
    ! Briggs solution
    ! s = 5*10^(-Briggs)  with (typically) -2 < Briggs < 2
    ! Here we use an input range [-4,0] for "wm" so shift "wm" by 2
    !
    ! Experimentally, not as flexible as our default solution
    s2 = 5*10**(-2-wm)    ! s^2
    s2 = s2*s2
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP & SHARED  (visi, we, jw,weight,s2,nv)  &
    !$OMP & PRIVATE (i)
    !$OMP DO
    do i=1,nv
      if (visi(jw,i).gt.0) then
        we(i) = visi(jw,i)/(s2*we(i)/weight+1.0)
      else
        we(i) = 0.0
      endif
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else
    !
    ! S.Guilloteau solution
    weight = wm*weight
    !$OMP PARALLEL DEFAULT(NONE) &
    !$OMP & SHARED  (visi, we, jw,weight,nv)  &
    !$OMP & PRIVATE (i)
    !$OMP DO
    do i=1,nv
      if (visi(jw,i).gt.0.0) then
        if (we(i).gt.weight) then
          we(i) = visi(jw,i)/we(i)*weight
        else
          we(i) = visi(jw,i)
        endif
      else
        we(i) = 0.0
      endif
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
  !
end subroutine doweig_robust
!
subroutine dogrid_fast (np,nv,visi,jx,jy   &
     &    ,nx,ny,map,mapx,mapy,we)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- UV_MAP Weight handling routine
  !
  !   Grid the weights. Do not apply taper. 
  !   Only for "visibility in cell" gridding.
  !   Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   !! Number of visibilies
  integer, intent(in) :: np                   !! Size of a visibility 
  real, intent(in) :: visi(np,nv)             !! values
  integer, intent(in) :: jx                   !! X coord location in VISI
  integer, intent(in) :: jy                   !! Y coord location in VISI
  integer, intent(in) :: nx                   !! X map size
  integer, intent(in) :: ny                   !! Y map size
  real, intent(out) :: map(nx,ny)             !! gridded visibilities
  real, intent(in) :: mapx(nx)                !! X Coordinates of grid
  real, intent(in) :: mapy(ny)                !! Y Coordinates of grid
  real, intent(in) :: we(nv)                  !! Weight array
  !
  ! Constants
  real(8), parameter :: pi=3.141592653589793d0
  !
  ! Local ---
  integer :: ix,iy,i,my,kx,ky
  real :: result,resima
  real :: u,v
  real(8) :: xinc,xref,yinc,yref
  !
  ! Code ----
  my = ny/2+1
  !
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  !
  ! Start with loop on observed visibilities.
  ! Loop cannot be efficiently parallelized, as different visibilities
  ! may end up in the same pixel.
  do i=1,nv
    !
    ! Weight 
    result = we(i)
    if (result.le.0) cycle ! Skipped flagged visibilities
    !
    u = visi(jx,i)
    v = visi(jy,i)
    ! Define map cell
    if (v.gt.0) then
      ix = nint(-u/xinc+xref)
      iy = nint(-v/yinc+yref)
      resima = -result
    else
      ix = nint(u/xinc+xref)
      iy = nint(v/yinc+yref)
      resima = result
    endif
    if (ix.lt.1.or.ix.gt.nx.or.iy.lt.1.or.iy.gt.my) then
      print *,'Visi ',i,' pixels ',ix,iy,my,v
    else
      map (ix,iy) = map(ix,iy) + result
    endif
    !
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
      ix = nint(-u/xinc+xref)
      map (ix,iy) = map(ix,iy) + result
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      map(ix,iy) = map(kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dogrid_fast
!
subroutine doweig_grid (jc,nv,visi,jx,jy,jw,unif,we,error,code)
  use gildas_def
  use gkernel_interfaces
  use grid_control
  use imager_interfaces, except_this => doweig_grid
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- UV_MAP Weight handling routine
  !
  !     Compute weights of the visibility points.
  !      Pure Gridded method
  !
  !   Pass 1:   Natural Gridding of the weights  
  !   Pass 2:   Smoothing of the Grid   
  !   Pass 3:   Correction of initial weights by Smoothed values
  !!
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          !! number of visibilities
  integer, intent(in) ::  jc          !! Size of a visibilities
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) ::  unif           !! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      !! Weight array
  logical, intent(inout) :: error     !! Error code
  integer, intent(in), optional :: code  !! Number of sub-cells per UV uniform cell size
  !
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! Local ---
  real, allocatable :: w_mapu(:), w_mapv(:), mapn(:,:), maps(:,:)
  real :: umin, umax, vmin, vmax
  real :: sizecell, punif
  integer :: ier, i
  integer :: nx,ny,kw
  !
  ! Code 
  error = .true.
  call imager_tree('DOWEIG_GRID',.false.)
  !
  ! Step 1: define Grid extent
  ! Assume data is unsorted in U.
  vmin = 0.0
  vmax = 0.0 
  umin = 0.0
  umax = 0.0
  do i=1,nv
    if (visi(jx,i).lt.umin) then
      umin = visi(jx,i)
    elseif  (visi(jx,i).gt.umax) then
      umax = visi(jx,i)
    endif
    if (visi(jy,i).lt.vmin) then
      vmin = visi(jy,i)
    elseif  (visi(jy,i).gt.vmax) then
      vmax = visi(jy,i)
    endif
  enddo
  !
  if (-umin.gt.umax) then
    umax = -umin
  else
    umin = -umax
  endif
  if (-vmin.gt.vmax) then
    vmax = -vmin
  else
    vmin = -vmax
  endif
  vmax = 1.1*vmax            ! Allow safe margin
  umax = 1.1*umax
  !
  ! Define a cell size sufficiently smaller than the Uniform cell size
   sizecell  = unif/grid_subcell
  !
  ! Define the Grid now
  nx = 2*umax/sizecell
  ny = 2*vmax/sizecell
  !
  ! 2)  Grid with Natural weighting
  allocate (w_mapu(nx), w_mapv(ny), mapn(nx,ny), maps(nx,ny), stat=ier)
  if (ier.ne.0) return
  !
  error = .false.
  call docoor (nx,-sizecell,w_mapu)
  call docoor (ny,sizecell,w_mapv)
  kw = jw
  we(:) = visi(kw,:)
  !
  write(*,'(A,I0,A,I0,A)',advance='NO') 'Doing Fast gridding (',nx,',',ny,') ... '
  mapn = 0.
  call dogrid_fast (jc,nv,visi,jx,jy,nx,ny,mapn,w_mapu,w_mapv,we) 
  !
  ! 3) Smooth the Weights by Circles
  punif = unif/sizecell ! In pixel units
  write(*,'(A)',advance='NO') ' Smoothing ... '
  call dogrid_smooth (nx,ny,mapn,maps,punif)
  !
  ! 4) Assign a summed weight to each visbility
  write(*,'(A)',advance='NO') ' Summing... '
  call doweig_getsum (jc,nv,visi,jx,jy,nx,ny,w_mapu,w_mapv,maps,we)
  write(*,'(A)') ' Done'
  call imager_tree('DOWEIG_GRID',.true.)
  !
end subroutine doweig_grid
!
subroutine doweig_getsum (jc,nv,visi,jx,jy,nx,ny,w_mapu,w_mapv,maps,we)
  ! @ private
  integer, intent(in) ::  nv          !! number of visibilities
  integer, intent(in) ::  jc          !! Size of a visibilities
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  nx          !! Grid size in X
  integer, intent(in) ::  ny          !! Grid size in Y
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) :: w_mapu(nx)      !! X coordinates
  real, intent(in) :: w_mapv(ny)      !! Y coordinates
  real, intent(in) :: maps(nx,ny)     !! Smoothed gridded weights
  real, intent(inout) ::  we(nv)      !! Weight array
  !
  ! Local ---
  integer :: iu,iv
  integer :: jv
  real :: xinc,xref,yinc,yref,u,v
  real :: aplus, amoin, azero, afin, xr, yr
  !
  ! Code ----
  xref = nx/2+1
  yref = ny/2+1
  xinc = w_mapu(2)-w_mapu(1)
  yinc = w_mapv(2)-w_mapv(1)
  !
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(nv, we, visi, maps, xinc,xref, yinc,yref, jx,jy, nx,ny) &
  !$OMP & PRIVATE(jv, u,v,iu,iv,xr,yr,aplus,amoin,azero,afin)
  !$OMP DO
  do jv=1,nv
    if (we(jv).le.0) then
      we(jv) = 0.
      cycle          ! Ignore flagged visibilities 
    endif
    !
    we(jv) = 0. ! In case of bad call, protect.
    !
    u = visi(jx,jv)
    u = u/xinc+xref
    iu = int(u)
    if (iu.le.1 .or. iu.ge.nx) cycle
    v = visi(jy,jv)
    v = v/yinc+yref
    iv = int(v)
    if (iv.le.1 .or. iv.ge.ny) cycle
    !
    ! Interpolate weight from Neighbours.
    xr = u-iu
    yr = v-iv
    !
    ! Bi-parabolic interpolation
    ! Interpolate (X or Y first, does not matter in this case)
    aplus = ( (maps(iu+1,iv+1)+maps(iu-1,iv+1)   &
   &          - 2.d0*maps(iu,iv+1) )*xr   &
   &          + maps(iu+1,iv+1)-maps(iu-1,iv+1) )*xr*0.5d0   &
   &          + maps(iu,iv+1)
      azero = ( (maps(iu+1,iv)+maps(iu-1,iv)   &
   &          - 2.d0*maps(iu,iv) )*xr   &
   &          + maps(iu+1,iv)-maps(iu-1,iv) )*xr*0.5d0   &
   &          + maps(iu,iv)
      amoin = ( (maps(iu+1,iv-1)+maps(iu-1,iv-1)   &
   &          - 2.d0*maps(iu,iv-1) )*xr   &
   &          + maps(iu+1,iv-1)-maps(iu-1,iv-1) )*xr*0.5d0   &
   &          + maps(iu,iv-1)
    ! Then Y (or X)
    afin = ( (aplus+amoin-2.d0*azero)   &
   &          *yr + aplus-amoin )*yr*0.5d0 + azero
    !
    ! Bi-parabolic interpolation may lead to negative results, 
    !   despite all data being positive 
    if (afin.lt.0) then
      !
      ! Bi-linear does not have this issue
      aplus = maps(iu+1,iv+1)*xr + maps(iu,iv+1)*(1.0-xr)
      amoin = maps(iu+1,iv)*xr + maps(iu,iv)*(1.0-xr)
      afin = aplus*yr + amoin*(1.0-yr)
    endif
    if (afin.le.0) then 
      Print *,jv,' Interpolation issue ',amoin,azero,aplus,afin,yr
      afin = maps(iu,iv)
    endif
    we(jv) = afin
    !
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine doweig_getsum
!
subroutine dotape (jc,nv,visi,jx,jy,taper,we)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- UV_MAP Weight handling routine
  !
  !     Apply taper to the weights of the visibility points.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          !! number of values
  integer, intent(in) :: jc          !! Size of a visibility
  integer, intent(in) :: jx          !! X coord location in VISI
  integer, intent(in) :: jy          !! Y coord location in VISI
  real, intent(in) :: visi(jc,nv)    !! Visibilities
  real, intent(in) :: taper(4)       !! Taper definition
  real, intent(inout) :: we(nv)      !! Weights
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  ! Local ---
  integer iv
  real staper,etaper
  real u,v
  real cx,cy,sx,sy
  !
  ! Code ----
  if (taper(1).eq.0. .and. taper(2).eq.0.) return
  !
  call imager_tree('DOTAPE',.false.)
  !
  staper = taper(3)*pi/180.0
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
  else
    cy = 0.0
    sx = 0.0
  endif
  if (taper(4).ne.0.) then
    etaper = taper(4)/2.0
  else
    etaper = 1
  endif
  !
  do iv=1,nv
    u = visi(jx,iv)
    v = visi(jy,iv)
    !
    staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
    if (etaper.ne.1) staper = staper**etaper
    if (staper.gt.64.0) then
      staper = 0.0
    else
      staper = exp(-staper)
    endif
    we(iv) = we(iv)*staper
  enddo
  call imager_tree('DOTAPE',.true.)
end subroutine dotape
!
subroutine doweig (jc,nv,visi,jx,jy,iw,unif,we,wm,error,code)
  !$ use omp_lib
  use gildas_def
  use gkernel_interfaces
  use grid_control
  use imager_interfaces, except_this => doweig
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER  -- Support for UV_MAP
  !
  !     Compute weights of the visibility points.
  !!
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          !! number of values
  integer, intent(in) ::  jc          !! Number of "visibilities"
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  iw          !! Weight channel. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) ::  unif           !! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      !! Weight array
  real, intent(in) ::  wm             !! on input: % of uniformity
  logical, intent(inout) :: error     !! Logical error flag
  integer, intent(in), optional :: code   !! Code controlling the method
  !
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! Local ---
  integer i,jw
  real umin,umax,vmin,vmax,vstep,vimin,vimax
  real vcmin, vcmax
  integer nbcv, ivmin, ivmax, icv, nbv, new, nflag
  integer icode, ier
  character(len=message_length) :: chain
  real(8) :: elapsed_s, elapsed_e, elapsed
  real(4) :: cpu0, cpu1
  real, allocatable ::  vv(:)         ! V values, pre-sorted
  !
  ! Code ---
  call imager_tree('DOWEIG',.false.)
  error = .false.
  nflag = 0
  !
  if (unif.le.0.0 .or. wm.eq.0.0) then
    !
    ! Natural weighting
    if (iw.gt.0) then
      jw =7+3*iw
      do i=1,nv
        if (visi(jw,i).gt.0.0) then
          we(i) = visi(jw,i)
        else
          nflag = nflag+1
          we(i) = 0.0
        endif
      enddo
      if (nflag.ne.0) then
        write(chain,'(I0,A)') nflag,' flagged visibilities ignored'
        call map_message(seve%i,rname,chain)
      endif
    else
      we(1:nv) = 1.
    endif
    return
  endif
  !
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  !
  ! Robust weighting
  if (present(code)) then
    !
    ! Control the method by selecting the algorithm
    icode = code
  else
    ! Used for old code, as a strict reference to MAPPING
    ! This is essentially for comparative tests. 
    icode = -1    
  endif
  !
  if ((icode.ge.0) .and. (nv.lt.grid_bigvisi)) then
    jw = 7+3*iw
    !
    call gag_cpu(cpu0)
    !$ elapsed_s = omp_get_wtime()
    call doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,error,icode)
    call doweig_robust (jc,nv,visi,jw,we,wm)
    call gag_cpu(cpu1)
    !$ elapsed_e = omp_get_wtime()
    !$ elapsed = elapsed_e - elapsed_s
    write(chain,'(a,f9.2,a,f9.2)') 'Finished Robust computation CPU: ',cpu1-cpu0, &
      & ' elapsed ',elapsed
    call map_message(seve%i,rname,chain)
  else if ((icode.ne.-1).or.(nv.ge.grid_bigvisi)) then
    !
    ! Gridded version 
    jw = 7+3*iw
    !
    call doweig_grid (jc,nv,visi,jx,jy,jw,unif,we,error,icode)
    call doweig_robust (jc,nv,visi,jw,we,wm)
  else if (icode.eq.-1) then
    !
    ! Uniform weight
    allocate(vv(nv),stat=ier)
    vv = visi(jy,:)
    !
    ! 1) Compute VMIN, VMAX, UMIN, UMAX
    vmin = visi(jy,1)
    vmax = visi(jy,nv)
    umin = 0.0
    umax = 0.0
    do i=1,nv
      if (visi(jx,i).lt.umin) then
        umin = visi(jx,i)
      elseif  (visi(jx,i).gt.umax) then
        umax = visi(jx,i)
      endif
    enddo
    !
    ! Symmetry ?...
    if (-umin.gt.umax) then
      umax = -umin
    else
      umin = -umax
    endif
    vmin = 1.001*vmin            ! Allow small margin
    umax = 1.001*umax
    umin = 1.001*umin
    !
    ! Some speed up factor
    nbcv = 128
    vstep = -vmin/nbcv
    !
    ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
    ! than sufficient to get speed up.
    !
    if (vstep.lt.4*unif) then
      nbcv = int(-vmin/(4*unif))
      !Print *,'Vmin ',vmin,'Unif ',unif,' NBCV ',nbcv
      if (mod(nbcv,2).ne.0) nbcv = nbcv-1
      nbcv = max(1,nbcv)
      vstep = -vmin/nbcv
    endif
    !
    ! Loop on U,V cells
    nbv = 0
    ivmin = 1
    do icv = 1,nbcv
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      new = ivmax-ivmin+1
      if (icv.eq.nbcv) then
        vimin = -unif
        call findp (nv,vv,vimin,ivmin)
        new = new + (nv-ivmin+1)
      endif
      nbv = max(new,nbv)
    enddo
    !
    !Print *,'OLD before Unif ',unif,' WM ',wm
    ! Here this is really the Channel Number
    call doweig_quick (jc,nv,visi,jx,jy,iw,unif,we,wm,vv,nbv,   &
       &    umin,umax,vmin,vmax,nbcv)
    !Print *,'OLD after Unif ',unif,' WM ',wm
  endif
  call imager_tree('DOWEIG',.true.)
  !
end subroutine doweig
!
subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,error,code)
  use gildas_def
  use gkernel_interfaces
  use imager_interfaces, except_this => doweig_sph
  use gbl_message
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER  -- Support for UV_MAP
  !
  !     Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          !! number of values
  integer, intent(in) ::  jc          !! Number of "visibilities"
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) ::  unif           !! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      !! Weight array
  logical, intent(inout) :: error
  integer, intent(in), optional :: code  !! Number of sub-cells per UV uniform cell size
  !
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! Local ---
  real, allocatable :: suu(:), svv(:), sww(:), swe(:)
  integer, allocatable :: spi(:)
  real :: umin, umax, vmin, vmax
  real :: sizecell
  integer :: ier, mv, nbv, i, icode
  character(len=120) :: mess
  !
  ! Code ----
  error = .false.
  call imager_tree('DOWEIG_SPH',.false.)
  !
  mv = 2*nv
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),spi(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%f,'DOWEIG_SPH','Memory allocation error')
    return
  endif
  !
  spi = 0
  nbv = 0
  do i=1,nv
    if (visi(jw,i).gt.0) then
      nbv = nbv+1
      suu(nbv) = visi(jx,i)
      svv(nbv) = visi(jy,i)
      sww(nbv) = visi(jw,i) 
      spi(i) = nbv
      nbv = nbv+1
      suu(nbv) = -visi(jx,i)
      svv(nbv) = -visi(jy,i)
      sww(nbv) = visi(jw,i) 
    endif
  enddo
  ! Find out extrema
  vmin = minval(svv(1:nbv))
  vmax = maxval(svv(1:nbv))
  umin = minval(suu(1:nbv))
  umax = maxval(suu(1:nbv))
  error = .false.
  !
  ! Sub-divide the uniform cell size into sub-cells for speed
  ! The optimal depends on the density of UV points.
  !
  if (present(code).and.code.gt.0) then
    ! This is for test only
    icode = max(2,code)
    write(mess,'(A,I0)')  'User requested ICODE ',icode
  else
    icode = 0
    call dowei_icode(umax,umin,vmax,vmin,unif,nbv,icode)
  endif
  sizecell = unif/icode
  !
  if (mv.lt.10000) then
    write(mess,'(A,I0,A,F6.1,F6.1,A)') "Gridding for ", mv,' Visibilities, cell sizes ', &
      & sizecell, unif, " m"
  else if (mv.lt.2000000) then
    write(mess,'(A,I0,A,F6.1,F6.1,A)') "Gridding for ", mv/1000,' kilo Visibilities, cell sizes ', &
      & sizecell, unif, " m"
  else 
    write(mess,'(A,F8.1,A,F6.1,F6.1,A)') "Gridding for ", real(mv)*1E-6,' Mega Visibilities, cell sizes ', &
      & sizecell, unif, " m"
  endif
  call map_message(seve%i,rname,mess)
  write(mess,'(A,4F8.1)') "  and UV range ", umin, umax, vmin, vmax
  call map_message(seve%i,rname,mess)
  !
  call gridless_density(nbv,sizecell,unif,suu,svv,sww,swe, &
    umin,umax,vmin,vmax,error)
  if (error) return
  !
  ! Put in place with the Indirect pointer
  do i=1,nv
    if (spi(i).gt.0) then
      we(i) = swe(spi(i))
    else
      we(i) = 0
    endif
  enddo
  call imager_tree('DOWEIG_SPH',.true.)
end subroutine doweig_sph
!
subroutine gridless_density (npts,sizecell,distmax,evex,evey,eveweight,&
  & evesumweight,xmin,xmax,ymin,ymax,error)
  use gildas_def
  use gbl_message
  use imager_interfaces, except_this => gridless_density
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for Robust weighting
  !
  ! Stephane Paulin   OASU CNRS / U.Bordeaux  2016
  !
  ! Algorithm to compute the weighted neighborhood of each point in a large
  ! catalog. This algorithm was described, among other sources, by Daniel Briggs in
  ! his thesis. The idea is to avoid npts**2 calculations of the distance between
  ! each pair of points (npts is the # points). For that, one defines a grid only used
  ! to speed-up computation (result is independent of the grid).  
  ! Step 1: In a given cell of the grid, all events are linked and the total weight
  !   of the cell is computed and kept in memory.  
  ! Step 2: a pattern is computed, that is the same all over the field, whose radius
  !   is the maximum distance. Grid boxes can have 3 states: entirely inside the
  !   maximum distance, entirely outside, or in between (boxes noted 'intermediate'
  !   or 'mixed').
  !
  ! The idea is to compute the distances only for events in these intermediate boxes.
  ! For other events, or the total weight of the box is added (if the box is inside),
  ! or the box is ignored (if outside). Next, the main loop consists on a loop on every
  ! event. For a given event, all boxes in the pattern are checked and treated accordingly.
  ! With this algorithm, one can have CPU times prop. to factor*npts*log(npts) with
  ! factor~2 (ie. when npts is multiplied by 10, the CPU is multiplied by ~45-50)
  !
  ! Remarks/notes:
  ! - this is a preliminary approach for testing, where symmetries are not
  !   taken into account ==> a given couple of coordinates (evex,evey) corresponds
  !   to one event
  !
  ! Changes by S.Guilloteau:  
  !   Parallel programming Mar-2019   
  !   Optimize parallel programming Oct-2022  
  !!
  !----------------------------------------------------------------------
  real, intent(in) :: sizecell                !! size of a cell.
  !! this is a control parameter that does not change the result but
  !! change the calculation time: to minimize the CPU, the larger the
  !! event density, the smaller sizecell. ex: sizecell~20 (10, 5 resp.)
  !! for a catalog of 10**5 (10**6, 3x10**7) events
  integer, intent(in) :: npts                 !! total # of events
  real, intent(in) :: distmax                 !! maximum distance
  real(kind=4), intent(in) :: evex(npts)      !! X coordinates
  real(kind=4), intent(in) :: evey(npts)      !! Y coordinates
  real(kind=4), intent(in) :: eveweight(npts) !! Weight of event
  real(kind=4), intent(out) :: evesumweight(npts) !! Sum of the weights of all
  !! the events closer nearer than the maximum distance from the current event.
  real(kind=4), intent(in) :: xmin,ymin,xmax,ymax !! Min Max
  logical, intent(out) :: error               !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='DOWEIG'
  !$ logical, external :: ompget_debug_code
  !
  ! Local ---
  integer(kind=4) :: nbboxx,nbboxy,nbbox,i,j,indice1,indice2,ii
  integer :: xbox_cur,ybox_cur,nbcellmaxx,nbcellmaxy
  integer :: nbcellx,nbcelly,nbcellquartx,nbcellquarty
  real :: distmaxsq,temp
  real(kind=4) :: llx_cur,lly_cur,urx_cur,ury_cur,ulx_cen
  real(kind=4) :: llx_cen,lly_cen,lrx_cen,lry_cen,urx_cen,ury_cen,uly_cen
  real(kind=4) :: longest,shortest
  integer :: ier
  !
  ! Dynamic variables used by the gridless algorithm:
  ! each analysis has given # of events (npts) & size of the grid (sizecell==>nbbox)
  !
  real(kind=4), allocatable :: boxx(:),boxy(:)    ! Coordinates along box axis
  real, allocatable :: boxtotweight(:,:)          ! Total weight in boxes
  integer(kind=4), allocatable :: nextevent(:)    ! Chained pointer
  integer(kind=4), allocatable :: eveindx(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: eveindy(:)      ! why not kind=8 ? if very large grid
  integer(kind=4), allocatable :: last(:,:)       ! Work array
  integer(kind=4), allocatable :: firstevent(:,:) ! First pointer of box
  integer(kind=4), allocatable :: boxnbevent(:,:) ! Number of events in box
  integer(kind=4), allocatable :: statebox(:,:)   ! Box status
  !
  integer :: ithread, jthread, nthread
  real(kind=4), allocatable :: sumwe(:,:)
  !
  integer :: nval, ival, mval, nbad
  integer, allocatable :: kval(:)
  !
  real :: MegaByte
  real(8) :: elapsed_s, elapsed_e, elapsed
  real(4) :: cpu0
  logical :: do_report
  !
  ! Code ----
  error = .false.
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  !
  distmaxsq = distmax*distmax
  evesumweight = 0
  !
  nbboxx = ceiling( (xmax-xmin) / sizecell)
  nbboxy = ceiling( (ymax-ymin) / sizecell)
  nbbox = nbboxx * nbboxy
  !
  ! Required elements
  error = .true.
  MegaByte = ((nbboxx+nbboxy)/1024./1024.+(nbboxx/1024.)*(nbboxy/1024.))*4.
  if (MegaByte.gt.1000) then
    write(6,'(A,F8.1,A)') 'W-GRIDDING,  Allocating 4 x ',MegaByte*1D-3,' GBytes for cells'
    write(6,'(A,F8.1,A)') '             Plus 4 x ',npts*4.d0/1024./1024.,' MBytes for weights'
    if (MegaByte.gt.3000) then
      write(6,'(A,F9.1,A)') 'Grid too big, change map_uvcell'
      return
    endif
  endif
  allocate(boxx(nbboxx),boxy(nbboxy),boxtotweight(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
!  if (MegaByte.gt.1000) Print *,'First one OK'
  allocate(firstevent(nbboxx,nbboxy),nextevent(npts),stat=ier)
  if (ier.ne.0) return
!  if (MegaByte.gt.1000) Print *,'Second one OK'
  ! Potentially avoidable arrays
  allocate(eveindx(npts),eveindy(npts),boxnbevent(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
!  if (MegaByte.gt.1000) Print *,'Third one OK'
  ! Work array
  allocate(last(nbboxx,nbboxy),stat=ier)
  if (ier.ne.0) return
!  if (MegaByte.gt.1000) Print *,'Last one OK'
  error = .false.
  !
  call gag_cpu(cpu0)
  !
  ! Basic initialisations
  do i = 1, nbboxy
    boxy(i) = (i-0.5)*sizecell + ymin
  enddo
  do i = 1, nbboxx
    boxx(i) = (i-0.5)*sizecell + xmin
  enddo
  boxnbevent = 0   
  boxtotweight = 0
  last = 0
  !
  ! chaining the events
  eveindx(:) = INT((evex-xmin)/sizecell) + 1  ! could be optimised/avoided, 
  ! but convenient in this preliminary version
  eveindy(:) = INT((evey-ymin)/sizecell) + 1  ! idem
  !
  do i = 1, npts
    !
    ! could be optimised/avoided, but convenient in this preliminary version
    boxnbevent(eveindx(i),eveindy(i)) = boxnbevent(eveindx(i),eveindy(i)) + 1
    if (eveweight(i).gt.0) boxtotweight(eveindx(i),eveindy(i)) &
      & = boxtotweight(eveindx(i),eveindy(i)) + eveweight(i)
    !
    if (last(eveindx(i),eveindy(i)).EQ.0) then
      firstevent(eveindx(i),eveindy(i)) = i
    else
      nextevent(last(eveindx(i),eveindy(i))) = i
    endif
    last(eveindx(i),eveindy(i)) = i
  enddo
  deallocate(last)
  if (MegaByte.gt.1000) write(6,'(A,I0)') 'I-GRIDDING, finished initialization ',npts
  !
  ! defining the pattern
  !
  ! nbcellquart is the integer # of boxes in a quadrant excluding the axes
  temp = distmax / sizecell
  nbcellquartx = ceiling(temp)
  nbcellquarty = nbcellquartx ! working assumption: symmetry ==>
  ! in this preliminary version, only euclidian distances with 
  ! x<==>y (no ellipse but this would very simple to add this feature)
  !
  !nbcellmax is the maximum distance tolerated from 0, expressed in integer # of boxes
  nbcellmaxx = nbcellquartx
  nbcellmaxy = nbcellquarty
  !
  !nbcell is the # of boxes in the pattern
  nbcellx = nbcellmaxx*2
  nbcelly = nbcellmaxy*2
  !
  ! statebox specifies the status of a box : 1 <==> good ; 2 <==> mixed ; 3 <==> bad
  MegaByte = (nbcellmaxx*nbcellmaxy)*4./1024/1024
  if (MegaByte.gt.1000) then
    write(6,'(A,F6.1,A)') 'W-GRIDDING,  Allocating ',MegaByte*1D-3,' GBytes for Cells'
  endif
  allocate(statebox(nbcellmaxx,nbcellmaxy),stat=ier)
  if (ier.ne.0) then
    write(6,'(A)') 'E-GRIDDING, Memory allocation error '
    error = .true.
    return
  endif
  statebox = 0
  statebox(1,1) = 1
  !
  ! Assumption: symmetry. For the moment we will assume all quarters are equivalent.
  ! Historically, the distance tests are performed considering the lower-left corner
  ! (so are the coordinates llx, lly, urx, ury... of the 'cur' pixel)
  ! but in the arrays indice 1 corresponds to the center and indice max corresponds
  ! to the outside, like an upper-right corner
  !
  llx_cen = 0
  lly_cen = 0
  urx_cen = sizecell
  ury_cen = sizecell
  lrx_cen = urx_cen
  lry_cen = lly_cen
  ulx_cen = llx_cen
  uly_cen = ury_cen
  !
  !call gag_cpu(cpu1)
  !write(chain,'(a,f9.2,a,f9.2)') 'Finished Robust setup CPU: ',cpu1-cpu0 
  !write(*,*) chain
  !
  do indice1=1,nbcellquartx
    do indice2=1,nbcellquarty
      if (indice1.NE.1 .OR. indice2.NE.1) then
        ! there must be 2 loops:
        ! with indice2==1 & indice1>1 and shortest computed according to lr_cen ;
        ! with indice2>1 and shortest computed according to ur_cen
        !
        ! here the central pixel is refered with the suffix 'cen' while
        ! the floating pixel is refered by 'cur'
        !update 161017 cen is the upper-right pixel touching 0
        !
        urx_cur = indice1*sizecell
        ury_cur = indice2*sizecell
        !
        longest = calcdistsq(llx_cen,urx_cur,lly_cen,ury_cur)
        !
        if (longest.LE.distmaxsq) then
          statebox(indice1,indice2) = 1 ! reminder: 1 <==> good ; 2 <==> mixed ; 3 <==> bad
        else
          llx_cur = urx_cur - sizecell
          lly_cur = ury_cur - sizecell
          if (indice2.EQ.1) then
            shortest = calcdistsq(lrx_cen,llx_cur,lry_cen,lly_cur)
          else if (indice1.EQ.1) then
            shortest = calcdistsq(ulx_cen,llx_cur,uly_cen,lly_cur)
          else
            shortest = calcdistsq(urx_cen,llx_cur,ury_cen,lly_cur)
          endif
          if (shortest.LT.distmaxsq) then
            statebox(indice1,indice2) = 2
        !2 following lines are only for debugging (useless and slowing down the process)
        !else
        !  statebox(indice1,indice2) = 3 ! useless, was used for debugging but could be
          endif
        endif
      endif
    enddo
  enddo
  ! call gag_cpu(cpu1)
  ! write(chain,'(a,f9.2,a,f9.2)') 'Finished Robust init CPU: ',cpu1-cpu0
  ! write(*,*) chain
  !
  ! main loop
  !
  ! For OMP programming, only evesumweight is updated here, so
  ! each Thread may get a copy, and we sum them later.
  ! All the rest can be shared arrays on input, and local variables
  ! for the loop indices or dependent intermediate variables
  !
  nthread = 1
  ithread = 1
  do_report = npts.gt.1000000
  nbad = 0
  ! !$ do_report = do_report .and. (ompget_outer_threads().eq.1) 
  !$ nthread = ompget_inner_threads() 
  !$ if (ompget_debug_code()) Print *,'GRIDLESS_DENSITY OMP Already parallel ', &
  !$   &      omp_in_parallel(),' Nesting ',omp_get_nested(), 'Nthread ',nthread
  allocate(sumwe(npts,nthread),stat=ier)
  !! Print *,'Thread allocation ',ier,npts*nthread*4/1024./1024.,' Mbytes'
  sumwe = 0
  !
  ! The original code lead to very unbalanced load
  !  do j=1,nbboxy
  !   do i=1,nbboxx
  !    if (boxnbevent(i,j).GT.0) then
  !      CODE
  !    endif
  !   enddo
  !  enddo
  !
  ! Replace by an array of valid indices
  nval = 0
  mval = 0
  allocate (kval(nbboxx*nbboxy),stat=ier)
  do j=1,nbboxy
    do i=1,nbboxx
      if (boxnbevent(i,j).GT.0) then
        nval = nval+1
        kval(nval) = (j-1)*nbboxx+i
        if (boxnbevent(i,j).ge.mval) then
          mval = boxnbevent(i,j)
!          Print *,'Max at ',i,j,nval,mval
        endif
      endif
    enddo
  enddo
  !
  if (do_report) call progress_report('Gridded ',1,1,nval,10)
  ii = 1
  !
  !$OMP PARALLEL DEFAULT(NONE) NUM_THREADS(nthread) &
  !$OMP & SHARED(nval,mval,kval) PRIVATE(ival) &
  !$OMP & SHARED(sumwe,boxnbevent,firstevent,boxtotweight,nextevent) &
  !$OMP & SHARED(statebox, eveweight, evex, evey, distmax, distmaxsq) & 
  !$OMP & SHARED(nbboxx,nbboxy,nbcellmaxx, nbcellmaxy, nthread) &
  !$OMP & PRIVATE(i,j,ithread,jthread,indice1,indice2,xbox_cur,ybox_cur) &
  !$OMP & PRIVATE(elapsed_s,elapsed_e) SHARED(elapsed,npts) &
  !$OMP & SHARED(ii,do_report) REDUCTION(+:nbad) ! Counter for progress report
  !
  !$ ithread = omp_get_thread_num()+1
  !$ elapsed_s = omp_get_wtime()
  !$OMP DO SCHEDULE(DYNAMIC,1)   
  do ival =1,nval
    i = mod(kval(ival)-1,nbboxx)+1
    j = (kval(ival)-i)/nbboxx+1
    !
    if (boxnbevent(i,j).LE.0) then
      nbad = nbad+1
      cycle
    endif
    !
    call linkidenticalbox(boxnbevent(i,j),firstevent(i,j),boxtotweight(i,j), &
    & sumwe(:,ithread),nextevent)
    !Print *,'Done linkidentical box  ',i,j,ithread
    do indice1 = 1, nbcellmaxx
      do indice2 = 1, nbcellmaxy
        if (indice1.NE.1 .OR. indice2.NE.1) then
          xbox_cur = i-1+indice1
          ybox_cur = j-1+indice2
          if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. xbox_cur.LE.nbboxx &
          & .AND.ybox_cur.LE.nbboxy) then
            if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
              if (statebox(indice1,indice2).EQ.1) then
                call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                  & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                  & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                  & sumwe(:,ithread),nextevent)
              else if (statebox(indice1,indice2).EQ.2) then
                call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                  & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                  & sumwe(:,ithread), eveweight, evex, evey, nextevent, &
                  & distmax, distmaxsq)
              endif
            endif
          endif
        endif
        !
        if (indice1.LT.nbcellmaxx .AND. indice2.GT.1) then
          ! warning: left side of the horizontal line is excluded
          xbox_cur = i-indice1 ! warning: symmetry broken since the pattern is not centered
          ybox_cur = j-1+indice2
          if (xbox_cur.GT.0 .AND. ybox_cur.GT.0 .AND. &
              xbox_cur.LE.nbboxx .AND. ybox_cur.LE.nbboxy) then
            if (boxnbevent(xbox_cur,ybox_cur).GT.0) then
              if (statebox(indice1+1,indice2).EQ.1) then
                call linkgoodbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                  & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                  & boxtotweight(i,j),boxtotweight(xbox_cur,ybox_cur), &
                  & sumwe(:,ithread),nextevent)
              else if (statebox(indice1+1,indice2).EQ.2) then
                call linkmixedbox(boxnbevent(i,j),boxnbevent(xbox_cur,ybox_cur), &
                  & firstevent(i,j),firstevent(xbox_cur,ybox_cur), &
                  & sumwe(:,ithread), eveweight, evex, evey, nextevent, &
                  & distmax, distmaxsq)
              endif
            endif
          endif
        endif
      enddo
    enddo
    !$OMP CRITICAL
    ii = ii+1
    if (do_report) call progress_report('Gridded ',ii,1,nval,10)
    !$OMP END CRITICAL
  enddo 
  !$OMP ENDDO
  !$ elapsed_e = omp_get_wtime()
  !$ if (ithread.eq.1) elapsed = elapsed_e - elapsed_s
  !$OMP END PARALLEL
  !
  evesumweight(:) = sumwe(:,1)
  do ithread=2,nthread
    evesumweight(:) = evesumweight(:) + sumwe(:,ithread)
  enddo
  if (do_report) write(*,*) 'Done !'
  if (nbad.ne.0) write(*,*) '--- Programming Error in GRIDLESS Weighting ',nbad
  !
  deallocate(statebox)
  deallocate(boxx,boxy,boxtotweight)
  deallocate(firstevent,nextevent)
  deallocate(eveindx,eveindy,boxnbevent)
  !
contains
!
pure function calcdistsq(x1,x2,y1,y2)
  ! @ private
  real(kind=4) calcdistsq ! intent(out)
  real(kind=4), intent(in) :: x1,y1,x2,y2
  !
  calcdistsq = (x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)
end function calcdistsq
!
subroutine linkidenticalbox(nb, ind_init, boxtotweight, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !!
  !----------------------------------------------------------------------
  real, intent(in) :: boxtotweight                    !! Box total weight
  integer(kind=4), intent(in) :: nb                   !! Size of chain
  integer(kind=4), intent(in) :: ind_init             !! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      !! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         !! Chained pointers
  !
  integer(kind=4) :: ind, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind = ind_init
  do i = 1, nb
    evesumweight(ind) = evesumweight(ind) + boxtotweight
    ind = nextevent(ind)
  enddo
end subroutine linkidenticalbox
!
subroutine linkgoodbox(nb1, nb2, ind1_init, ind2_init, &
  & boxtotweight1, boxtotweight2, evesumweight, nextevent)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for Robust Weighting
  !
  !   Build the chain list of pixels in the same cell with
  !   the same status
  !!
  !----------------------------------------------------------------------
  real, intent(in) :: boxtotweight1, boxtotweight2    !! Total weight of each box
  integer(kind=4), intent(in) :: nb1, nb2             !! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init !! Starting index in each box
  real(kind=4), intent(inout) :: evesumweight(:)      !! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         !! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i
  !
  ! reminder: at the beginning, ind==firstevent of the box
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i = 1, nb1
    evesumweight(ind1) = evesumweight(ind1) + boxtotweight2
    ind1 = nextevent(ind1)
  enddo
  do i = 1, nb2
    evesumweight(ind2) = evesumweight(ind2) + boxtotweight1
    ind2 = nextevent(ind2)
  enddo
  !
end subroutine linkgoodbox
!
subroutine linkmixedbox(nb1, nb2, ind1_init, ind2_init, evesumweight, &
  & eveweight, evex, evey, nextevent, distmax, distmaxsq)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for Robust Weighting
  !
  !   Build chain list of different types
  !!
  !----------------------------------------------------------------------
  integer(kind=4), intent(in) :: nb1, nb2             !! Box sizes
  integer(kind=4), intent(in) :: ind1_init, ind2_init !! Starting index in each box
  real, intent(in) :: distmax, distmaxsq              !! Averaging radius
  real(4), intent(in) :: eveweight(:)                 !! Initial weights
  real(4), intent(in) :: evex(:)                      !! Event X coordinates
  real(4), intent(in) :: evey(:)                      !! Event Y coordinates
  real(kind=4), intent(inout) :: evesumweight(:)      !! Sum of weight at each event
  integer(kind=4), intent(in) :: nextevent(:)         !! Chained pointers
  !
  integer(kind=4) :: ind1, ind2, i, j
  !
  ind1 = ind1_init
  ind2 = ind2_init
  !
  do i =1,nb1
    do j = 1,nb2
      if (abs(evex(ind1)-evex(ind2)).LE.distmax) then
        if (abs(evey(ind1)-evey(ind2)).LE.distmax) then
          if (calcdistsq(evex(ind1),evex(ind2),evey(ind1),evey(ind2)).LE.distmaxsq) then
            evesumweight(ind1) = evesumweight(ind1) + eveweight(ind2)
            evesumweight(ind2) = evesumweight(ind2) + eveweight(ind1)
          endif
        endif
      endif
      ind2 = nextevent(ind2)
    enddo
    ind1 = nextevent(ind1)
    ind2 = ind2_init
  enddo
  !
end subroutine linkmixedbox
!
end subroutine gridless_density
!
subroutine scawei (nv,uni,ori,wall)
  !---------------------------------------------------------
  ! @ public
  !
  !! IMAGER --  Scale the visibility weights
  !---------------------------------------------------------
  integer, intent(in) :: nv     !! Number of visibilities
  real, intent(out) :: uni(nv)  !! Re-weighted weights
  real, intent(in)  :: ori(nv)  !! Original weights
  real, intent(out) :: wall     !! Sum of weights
  !!
  integer i
  real(kind=8) a, s, s2
  !
  s = 0   ! Sum of scaling factors
  s2 = 0  ! Sum of square of scaling factors
  do i=1,nv
    if (uni(i).gt.0) then
      a = uni(i)/ori(i)
      s = s+uni(i)        ! s+a
      s2 = s2+uni(i)*a    ! s2+a*a
    endif
  enddo
  !
  ! Like UV_STAT, better result
  a = s / s2
  uni(1:nv) = uni(1:nv)*a
  wall = a*s
end subroutine scawei
!
subroutine chkfft (a,nx,ny,error)
  !---------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Check if FFT is centered...
  !---------------------------------------------------------
  integer, intent(in)  ::  nx,ny   !! X,Y size
  logical, intent(out)  ::  error  !! Error flag
  real, intent(in)  ::  a(nx,ny)   !! Array
  !
  error = a(nx/2+1,ny/2+1).eq.0.0
end subroutine chkfft
!
subroutine doweig_quick (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,mv, &
     &     umin,umax,vmin,vmax,nbcv)
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  use gildas_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          !! number of values
  integer, intent(in) ::  jc          !! Number of "visibilities"
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
  integer, intent(in) ::  mv          !! Size of work arrays
  integer, intent(in) ::  nbcv        !! Buffering factor
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) ::  unif           !! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      !! Weight array
  real, intent(in) ::  wm             !! on input: % of uniformity
  real, intent(in) ::  vv(nv)         !! V values, pre-sorted
  real, intent(in) :: umin,umax,vmin,vmax !! UV boundaries
  !
  character(len=*), parameter :: rname='DOWEIG'
  !
  ! Local ---
  integer, allocatable :: ipv(:)
  real, allocatable :: utmp(:), vtmp(:), wtmp(:), rtmp(:)
  integer i,iw
  real u,v,weight,wfact
  real vstep,ustep,vimin,vimax,uimin,uimax
  real ucmin, ucmax, vcmin, vcmax
  integer nbcu, ivmin, ivmax, icu, icv, nbv, isub, ier
  character(len=message_length) :: chain
  !
  ! Code ---
  allocate (utmp(mv), vtmp(mv), wtmp(mv), rtmp(mv), ipv(mv), stat=ier)
  !
  we(1:nv) = -1.0
  isub = 0
  !
  ! Some speed up factor
  nbcu = 2*nbcv
  vstep = -vmin/nbcv
  ustep = (umax-umin)/nbcu
  !
  ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
  ! than sufficient to get speed up.  -- Current coding guarantees the
  ! situation below never happens in GILDAS, so allow a fatal crash
  ! in case somebody else breaks the rule...
  if (vstep.lt.4*unif) then
    write (chain,*) 'Vstep is too small',vstep,unif,vmin,nbcv
    call map_message(seve%w,rname,chain)
    if (nbcv.ne.1) call sysexi(fatale)
  endif
  !
  ! There is a weight column
  if (jw.gt.0) then
    iw = 7+3*jw
    !
    ! Loop on U,V cells
    do icv = nbcv,1,-1
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      !
      do icu = 1,nbcu
        ucmin = (icu-1)*ustep+umin
        uimin = ucmin-unif
        ucmax = icu*ustep+umin
        uimax = ucmax+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          ! Note that V stays ordered by increasing values
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.ge.vimin).and.(v.le.vimax)) then
            if ((u.ge.uimin).and.(u.le.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= visi(iw,i)
            endif
          endif
        enddo
        !
        ! Compute the weights
        if (nbv.gt.0) then
          isub = isub+1
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if ( (utmp(i).gt.ucmin.and.utmp(i).le.ucmax)   &
     &              .and. (vtmp(i).gt.vcmin.and.vtmp(i).le.vcmax) )   &
     &              then
              if (ipv(i).ne.0) then
                if (we(ipv(i)).ne.-1.0) then
                  print *,'Computed ',i,ipv(i),we(ipv(i)),rtmp(i)
                endif
                we(ipv(i)) = rtmp(i)
              endif
            endif
          enddo
        endif
        !
      enddo
      if (icv.eq.nbcv) call map_message(seve%i,rname,'Done boundary cells')
    enddo
    !
    ! All weights are computed now, normalize them
    call dowfact(nv,we,wfact)
    weight = wm*wfact
    !!write(6,*) 'Renormalized Weights ',wmax/weight,wmin/weight
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = visi(iw,i)/we(i)*weight
      elseif (we(i).gt.0.0) then
        we(i) = visi(iw,i)
      endif
    enddo
  else
    !
    ! No weighting column
    !
    ! Loop on U,V cells
    do icv = 1,nbcv
      vimin = (icv-1)*vstep+vmin-unif
      vimax = vimin+vstep+unif
      !
      ivmin = 1
      ivmax = nv
      call findp (nv,vv,vimin,ivmin)
      call findp (nv,vv,vimax,ivmax)
      !
      do icu = 1,nbcu
        uimin = (icu-1)*ustep+umin-unif
        uimax = uimin+ustep+unif
        !
        ! Select valid visibilities
        nbv = 0
        do i=ivmin,ivmax
          u = visi(jx,i)
          v = visi(jy,i)
          !
          ! Normal case only...
          if ((v.gt.vimin).and.(v.lt.vimax)) then
            if ((u.gt.uimin).and.(u.gt.uimax)) then
              nbv = nbv+1
              ipv(nbv) = i
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
          !
          ! Limiting case near V=0, inverse the U test...
          if (-v.le.unif) then
            if ((u.lt.-uimin).and.(u.gt.-uimax)) then
              nbv = nbv+1
              ipv(nbv) = 0
              utmp(nbv)= u
              vtmp(nbv)= v
              wtmp(nbv)= 1.0   ! No weight channel
            endif
          endif
        enddo
        !
        ! Compute the weight density
        if (nbv.gt.0) then
          call doweig_sub (nbv,utmp,vtmp,wtmp, rtmp, unif)
          !
          ! IPV is a back pointer
          do i=1,nbv
            if (ipv(i).ne.0) we(ipv(i)) = rtmp(i)
          enddo
        endif
        !
      enddo
    enddo
    !
    call dowfact(nv,we,wfact)
    weight = wm*wfact
    do i=1,nv
      if (we(i).gt.weight) then
        we(i) = 1.0/we(i)
      elseif (we(i).gt.0.0) then
        we(i) = 1.0/weight
      endif
    enddo
  endif
end subroutine doweig_quick
!
subroutine doweig_sub (nv,uu,vv,ww,we,unif)
  !$ use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  !! IMAGER -- Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv          !! number of values
  real, intent(in) ::  uu(nv)        !! U coordinates
  real, intent(in) ::  vv(nv)        !! V coordinates
  real, intent(in) ::  ww(nv)        !! Input Weights
  real, intent(out) ::  we(nv)       !! Output weights
  real, intent(in) ::  unif          !! Cell size
  !!
  !$ logical, external :: ompget_debug_code
  !
  ! Local ---
  integer i,j
  real u,v,weight,v_aux
  integer :: ithread, mthread
  !
  ! Uniform weights only
  call imager_tree('DOWEIG_SUB',.false.)
  !
  mthread = 1
  !$  mthread = omp_get_max_threads()
  !$  if (ompget_debug_code()) Print *,'OMP Already parallel ',omp_in_parallel(),' Nesting ',omp_get_nested(), mthread
  !$OMP PARALLEL &
  !$OMP &   SHARED(ww,uu,vv),  &
  !$OMP &   PRIVATE(ithread,i,j,weight,u,v,v_aux)
  !
  !$OMP DO
  do i=1,nv
    if (ww(i).le.0.0) then
      we(i) = 0.0
    else
      weight = ww(i)
      u = uu(i)
      v = vv(i)
      j = i-1
      v_aux = v-unif
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      j = i+1
      v_aux = v+unif
      do while (j.le.nv .and. vv(j).lt.v_aux)
        if (abs(u-uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j+1
      enddo
      !
      ! Close to (U,V) = (0,0), take symmetry into account
      j = nv
      v_aux = -(v+unif)
      do while (j.gt.0 .and. vv(j).gt.v_aux)
        if (abs(u+uu(j)).lt.unif) then
          if (ww(j).gt.0.0) weight = weight + ww(j)
        endif
        j = j-1
      enddo
      we(i) = weight
    endif
  enddo
  !$OMP END DO
  !$OMP FLUSH
  !$OMP END PARALLEL
  call imager_tree('DOWEIG_SUB',.true.)
  !
end subroutine doweig_sub
!
subroutine doweig_slow (jc,nv,visi,jx,jy,jw,unif,we,wm)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Compute weights of the visibility points.
  !
  !   Stupid, slow, version kept here for reference, but unused
  !
  !----------------------------------------------------------------------
  integer, intent(in) ::  nv          !! number of values
  integer, intent(in) ::  jc          !! Number of "visibilities"
  integer, intent(in) ::  jx          !! X coord location in VISI
  integer, intent(in) ::  jy          !! Y coord location in VISI
  integer, intent(in) ::  jw          !! Location of weights. If .LE.0, uniform weight
  real, intent(in) ::  visi(jc,nv)    !! Visibilities
  real, intent(in) ::  unif           !! uniform cell size in Meters
  real, intent(inout) ::  we(nv)      !! Weight array
  real, intent(in) ::  wm             !! on input: % of uniformity
  !
  ! Local ----
  integer i,j,iw
  real u,v,weight,wfact,v_aux
  !
  ! Code ----
  if (jw.gt.0) then
    ! There is a weight column
    iw = 7+3*jw
    !
    ! Uniform weights
    if (unif.gt.0) then
      do i=1,nv
        if (visi(iw,i).le.0.0) then
          we(i) = 0.0
        else
          weight = visi(iw,i)
          v = visi(jy,i)
          u = visi(jx,i)
          j = i-1
          v_aux = v-unif
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (v-visi(jy,j)).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          j = i+1
          v_aux = v+unif
          do while (j.le.nv .and. visi(jy,j).lt.v_aux)
            ! unoptimized
            !                  do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
            if (abs(u-visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.0)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j+1
          enddo
          !
          ! Close to (U,V) = (0,0), take symmetry into account
          j = nv
          v_aux = -(v+unif)
          do while (j.gt.0 .and. visi(jy,j).gt.v_aux)
            ! unoptimized
            !                  do while (j.gt.0 .and. (-visi(jy,j)-v).lt.unif)
            if (abs(u+visi(jx,j)).lt.unif) then
              if (visi(iw,j).gt.0.)   &
     &                weight = weight + visi(iw,j)
            endif
            j = j-1
          enddo
          we(i) = weight
        endif
      enddo
      !
      call dowfact(nv,we,wfact)
      weight = wm*wfact
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = visi(iw,i)/we(i)*weight
        elseif (we(i).gt.0.0) then
          we(i) = visi(iw,i)
        endif
      enddo
    else
      !
      ! Natural weights
      do i=1,nv
        if (visi(iw,i).gt.0.0) then
          we(i) = visi(iw,i)
        else
          we(i) = 0.0
        endif
      enddo
    endif
  else
    !
    ! No weighting column
    if (unif.ge.0) then
      !
      ! Uniform weights
      do i=1,nv
        weight = 1
        v = visi(jy,i)
        u = visi(jx,i)
        j = i-1
        do while (j.gt.0 .and. (u-visi(jy,j)).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        j = i+1
        do while (j.le.nv .and. (visi(jy,j)-v).lt.unif)
          if (abs(u-visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j+1
        enddo
        j = nv
        do while (j.ge.1 .and. (-visi(jy,j)-v).lt.unif)
          if (abs(u+visi(jx,j)).lt.unif) then
            weight = weight + 1
          endif
          j = j-1
        enddo
        we(i) = weight
      enddo
      !
      call dowfact(nv,we,wfact)
      weight = wm*wfact
      do i=1,nv
        if (we(i).gt.weight) then
          we(i) = 1.0/we(i)
        elseif (we(i).gt.0.0) then
          we(i) = 1.0/weight
        endif
      enddo
    else
      !
      ! Natural weighting
      we(1:nv) = 1.
    endif
  endif
end subroutine doweig_slow
!
subroutine dowei_icode(umax,umin,vmax,vmin,unif,mv,icode)
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Weighting routine
  !
  !   Get the sub-division for the UV cells for Robust weighting
  !!
  !---------------------------------------------------------------------
  real, intent(in) :: umax,umin     !! U range
  real, intent(in) :: vmax,vmin     !! V range
  real, intent(in) :: unif          !! Uniform cell size
  integer, intent(in) :: mv         !! Number of visibilities
  integer, intent(inout) :: icode   !! Number of sub-cells
  !
  ! Local ---
  real :: rboxes, density
  integer :: jcode, kcode
  character(len=120) :: chain
  !
  ! Code ----
  !
  ! Evaluate the average density
  rboxes = (umax-umin)/unif * (vmax-vmin)/unif
  !
  density = mv/rboxes
  ! Experimentally, that works very well
  kcode = nint(sqrt(density))
  ! But one should not make it too large as the buffer size scales 
  ! as Icode^2 - So check rboxes is not too large
  jcode = 2.0/sqrt(rboxes*16E-9) ! Allow a Maximum of 8 Gbyte memory
  rboxes = rboxes*4e-6           ! In MByte each
  write(chain,'(A,F8.1,A,I0,1X,I0,1X,I0,A,F8.1,A)') 'Box memory size ',rboxes, &
    & ' Mbytes -- Icode ',icode,kcode,jcode,'  (',real(mv)*1E-6,' Mega Visibilities)'
  call map_message(seve%d,'DOWEIG',chain)
  if (icode.eq.0) icode = kcode
  icode = min(icode,jcode)    
  !
  ! A minimum of 2 is required by the algorithm anyway...
  icode = max(2,icode)
end subroutine dowei_icode

subroutine eq1950_gal(a,d,lii,bii,n)
  use phys_const
  use gwcs_interfaces, except_this=>eq1950_gal
  !---------------------------------------------------------------------
  ! @ public
  !  Converts (A,D) (1950.0) in LII,BII
  !  Units are radians
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: a(*)    !
  real(kind=8),    intent(in)  :: d(*)    !
  real(kind=8),    intent(out) :: lii(*)  !
  real(kind=8),    intent(out) :: bii(*)  !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  real(kind=8) :: aa,cosa,sina,cosdec,sindec,expr
  real(kind=8), parameter :: c626=0.4601997847838517d0, s626=0.8878153851364013d0
  integer(kind=4) :: i
  !
  ! Formulaes are in degrees (LANG K.R. page 504)
  !
  !       SIN(Bii)             = SIN(D)COS(62.6) - COS(D)SIN(A-282.25)SIN(62.6)
  !       COS(Bii)*COS(Lii-33) = COS(D)COS(A-282.25)
  !       COS(Bii)*SIN(Lii-33) = COS(D)SIN(A-282.25)COS(62.6) + SIN(D)SIN(62.6)
  !
  do i=1,n
    aa = a(i)-282.25d0*pi/180.d0
    cosa = cos(aa)
    sina = sin(aa)
    cosdec = cos(d(i))
    sindec = sin(d(i))
    expr = cosdec*sina
    bii(i) = asin (sindec*c626 - expr*s626)
    lii(i) = atan2( (expr*c626+sindec*s626) , cosdec*cosa ) + 33.d0*pi/180.d0
  enddo
end subroutine eq1950_gal
!
subroutine gal_eq1950(lii,bii,a,d,n)
  use phys_const
  use gwcs_interfaces, except_this=>gal_eq1950
  !---------------------------------------------------------------------
  ! @ public
  !   Converts Lii,Bii to (A,D) (1950.0)
  !   Units are radians
  !---------------------------------------------------------------------
  real(kind=8),    intent(in)  :: lii(*)  !
  real(kind=8),    intent(in)  :: bii(*)  !
  real(kind=8),    intent(out) :: a(*)    !
  real(kind=8),    intent(out) :: d(*)    !
  integer(kind=4), intent(in)  :: n       !
  ! Local
  real(kind=8) :: ll,sinb,cosb,sinl,cosl,expr
  real(kind=8), parameter :: c626=0.4601997847838517d0, s626=0.8878153851364013d0
  integer(kind=4) :: i
  !
  ! The conversion formulae are
  !       COS(D)SIN(A-282.25) = COS(Bii)SIN(Lii-33)COS(62.6) - SIN(Bii)SIN(62.6)
  !       COS(D)COS(A-282.25) = COS(Bii)COS(Lii-33)
  !       SIN(D)              = COS(Bii)SIN(Lii-33)SIN(62.6) + SIN(Bii)COS(62.6)
  !
  do i = 1,n
    ll   = lii(i) - 33.d0*pi/180.d0
    sinb = sin(bii(i))
    cosb = cos(bii(i))
    sinl = sin(ll)
    cosl = cos(ll)
    expr = cosb*sinl
    d(i) = asin ( expr*s626 + sinb*c626 )
    a(i) = atan2 ( expr*c626 - sinb*s626 , cosb*cosl ) + 282.25d0*pi/180.d0
  enddo
end subroutine gal_eq1950
!
subroutine rel_to_abs_0d(proj,x,y,a,d,n)
  use gwcs_interfaces, except_this=>rel_to_abs_0d
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic rel_to_abs
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for scalar values
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: x     ! Offset in X
  real(kind=8),       intent(in)  :: y     ! Offset in Y
  real(kind=8),       intent(out) :: a     ! R.A. (radians)
  real(kind=8),       intent(out) :: d     ! Declinations
  integer(kind=4),    intent(in)  :: n     ! Useless, assumed 1
  ! Local
  real(kind=8) :: x1(1),y1(1),a1(1),d1(1)
  !
  x1(1) = x
  y1(1) = y
  call rel_to_abs_1dn8(proj,x1,y1,a1,d1,1_8)
  a = a1(1)
  d = d1(1)
  !
end subroutine rel_to_abs_0d
!
subroutine rel_to_abs_1dn4(proj,x,y,a,d,n)
  use gwcs_interfaces, except_this=>rel_to_abs_1dn4
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic rel_to_abs
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for 1D arrays, size as I*4
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
  real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(out) :: d(*)  ! Array of declinations
  integer(kind=4),    intent(in)  :: n     ! Size of arrays
  !
  call rel_to_abs_1dn8(proj,x,y,a,d,int(n,kind=8))
  !
end subroutine rel_to_abs_1dn4
!
subroutine rel_to_abs_1dn8(proj,x,y,a,d,n)
  use phys_const
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>rel_to_abs_1dn8
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic rel_to_abs
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for 1D arrays, size as I*8
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
  real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(out) :: d(*)  ! Array of declinations
  integer(kind=8),    intent(in)  :: n     ! Size of arrays
  ! Local
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8) :: r,p,sinr,cosr,sinp,cosp,sindec,da,cosda,cpang,spang,ma0,theta
  integer(kind=8) :: i
  logical :: changesign
  !
  select case(proj%type)
  case(p_cartesian)  ! Cartesian projection
    if (abs(proj%angle).le.precision) then
      do i = 1,n
        a(i) = proj%a0+x(i)
        d(i) = proj%d0+y(i)
      enddo
    else
      cpang = cos(-proj%angle)
      spang = sin(-proj%angle)
      do i = 1,n
        a(i) = proj%a0+x(i)*cpang+y(i)*spang
        d(i) = proj%d0-x(i)*spang+y(i)*cpang
      enddo
    endif
    !
  case(p_gnomonic)  ! Gnomonic projection
    if (proj%sind0.gt.precision) then
      do i = 1,n
        r = atan ( sqrt(x(i)**2+y(i)**2) )
        if (r.gt.precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          if (y(i) .lt. proj%npole) then
            d(i) = arcsin (sindec)
            a(i) = proj%a0 + arcsin ( sinr*sinp/cos(d(i)) )
          else
            d(i) = arcsin (sindec)
            a(i) = proj%a0 - arcsin ( sinr*sinp/cos(d(i)) ) + pi
          endif
        else
          a(i) = proj%a0
          d(i) = proj%d0
        endif
      enddo
    elseif (proj%sind0.lt.-precision) then
      do i = 1,n
        r = atan ( sqrt(x(i)**2+y(i)**2) )
        if (r.gt.precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          if (y(i) .gt. proj%spole) then
            d(i) = arcsin (sindec)
            a(i) = proj%a0 + arcsin ( sinr*sinp/cos(d(i)) )
          else
            d(i) = arcsin (sindec)
            a(i) = proj%a0 - arcsin ( sinr*sinp/cos(d(i)) ) + pi
          endif
        else
          a(i) = proj%a0
          d(i) = proj%d0
        endif
      enddo
    else
      do i=1,n
        r = atan ( sqrt(x(i)**2+y(i)**2) )
        if (r.gt.precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + arcsin ( sinr*sinp/cos(d(i)) )
        else
          a(i) = proj%a0
          d(i) = proj%d0
        endif
      enddo
    endif
    !
  case(p_ortho)  ! Orthographic (Dixon)
    if (proj%sind0.gt.precision) then
      do i = 1,n
        r = x(i)**2+y(i)**2
        if (r.le.1.d0) then
          sinr = sqrt(r)
          r = arcsin ( sinr )
          if (sinr.gt.precision) then
            p = atan2 ( x(i),y(i) ) - proj%angle
            cosr = cos(r)
            sinp = sin(p)
            cosp = cos(p)
            sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
            d(i) = arcsin (sindec)
            a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp )
          else
            a(i) = proj%a0
            d(i) = proj%d0
          endif
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    elseif (proj%sind0.lt.-precision) then
      do i = 1,n
        r = x(i)**2+y(i)**2
        if (r.le.1.d0) then
          sinr = sqrt(r)
          r = arcsin ( sinr )
          if (sinr.gt.precision) then
            p = atan2 ( x(i),y(i) ) - proj%angle
            cosr = cos(r)
            sinp = sin(p)
            cosp = cos(p)
            sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
            d(i) = arcsin (sindec)
            a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp ) + pi
          else
            a(i) = proj%a0
            d(i) = proj%d0
          endif
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        r = x(i)**2+y(i)**2
        if (r.le.1.d0) then
          sinr = sqrt(r)
          r = arcsin ( sinr )
          if (sinr.gt.precision) then
            p = atan2 ( x(i),y(i) ) - proj%angle
            cosr = cos(r)
            sinp = sin(p)
            cosp = cos(p)
            sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
            d(i) = arcsin (sindec)
            a(i) = proj%a0 + atan2( sinr*sinp, cosr + proj%sind0*sinr*cosp)
          else
            a(i) = proj%a0
            d(i) = proj%d0
          endif
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_azimuthal)  ! Azimuthal or Schmidt
    if (proj%sind0.gt.precision) then
      do i = 1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.pi-precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp )
        elseif (r.lt.pi+precision) then
          a(i) = proj%a0
          d(i) = -proj%d0
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    elseif (proj%sind0.lt.-precision) then
      do i = 1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.pi-precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp ) + pi
        elseif (r.lt.pi+precision) then
          a(i) = proj%a0
          d(i) = -proj%d0
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    else
      do i = 1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.pi-precision) then
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp, cosr + proj%sind0*sinr*cosp)
        elseif (r.lt.pi+precision) then
          a(i) = proj%a0
          d(i) = -proj%d0
        else
          a(i) = 0.d0
          d(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_stereo)  ! Stereographic
    if (proj%sind0.gt.precision) then
      do i = 1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        else
          r = 2.d0 * atan (r/2.d0)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp )
        endif
      enddo
    elseif (proj%sind0.lt.-precision) then
      do i = 1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        else
          r = 2.d0 * atan (r)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp ) + pi
        endif
      enddo
    else
      do i=1,n
        r = sqrt(x(i)**2+y(i)**2)
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        else
          r = 2.d0 * atan (r)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          if (0.5d0*pi-abs(d(i)).gt.precision) then
            a(i) = proj%a0 + atan2( sinr*sinp, cosr + proj%sind0*sinr*cosp)
          else
            a(i) = proj%a0
          endif
        endif
      enddo
    endif
    !
  case(p_lambert)  ! Lambert equal area
    !  u = 2*sin(r)/sqrt(2*(1+cos(r))
    !  r = acos (1-0.5*u**2)
    if (proj%sind0.gt.precision) then
      do i = 1,n
        r = x(i)**2+y(i)**2
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.4d0) then
          r = acos (1d0-0.5d0*r)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp )
        else
          a(i) = 0.0
          d(i) = 0.0
        endif
      enddo
    elseif (proj%sind0.lt.-precision) then
      do i = 1,n
        r = x(i)**2+y(i)**2
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.4d0) then
          r = acos (1d0-0.5d0*r)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          a(i) = proj%a0 + atan2( sinr*sinp*proj%sind0, sindec*proj%cosd0-sinr*cosp ) + pi
        else
          a(i) = 0.0
          d(i) = 0.0
        endif
      enddo
    else
      do i=1,n
        r = x(i)**2+y(i)**2
        if (r.le.precision) then
          a(i) = proj%a0
          d(i) = proj%d0
        elseif (r.le.4d0) then
          r = acos (1.d0-0.5d0*r)
          p = atan2 ( x(i),y(i) ) - proj%angle
          sinr = sin(r)
          cosr = cos(r)
          sinp = sin(p)
          cosp = cos(p)
          sindec = (proj%sind0*cosr + proj%cosd0*sinr*cosp)
          d(i) = arcsin (sindec)
          if (0.5d0*pi-abs(d(i)).gt.precision) then
            a(i) = proj%a0 + atan2( sinr*sinp, cosr + proj%sind0*sinr*cosp)
          else
            a(i) = proj%a0
          endif
        else
          a(i) = 0.0
          d(i) = 0.0
        endif
      enddo
    endif
    !
  case(p_aitoff)  ! Aitoff
    do i = 1,n
      changesign = y(i).lt.0.d0
      sinr = 0.5d0*sqrt(0.25d0*x(i)**2+y(i)**2)
      if (sinr.gt.1.d0) then
        a(i) = proj%a0
        d(i) = 0.5d0*pi
      elseif (sinr.gt.precision) then
        r = 2.d0 * arcsin(sinr)
        p = atan2 ( x(i),2.d0*y(i) )
        cosr = cos(r)
        da = atan2 (sin(p)*sin(r),cosr)
        d(i) = arccos ( cosr/cos(da) )
        a(i) = proj%a0 + 2.d0*da
      else
        a(i) = proj%a0                !      + 2.D0*ARCSIN(SINR)
        d(i) = 0.d0
      endif
      if (changesign) d(i) = -d(i)
    enddo
    !
  case(p_radio)  ! GLS:  Classical Single-Dish mapping
    do i=1,n
      if (y(i).le.proj%spole) then
        a(i) = proj%a0
        d(i) = -pi*0.5d0
      elseif (y(i).ge.proj%npole) then
        a(i) = proj%a0
        d(i) = pi*0.5d0
      else
        p = proj%d0 + y(i)
        d(i) = p
        r = x(i)/cos(p)
        if (r.le.-pi) then
          a(i) = proj%a0-pi
        elseif (r.ge.pi) then
          a(i) = proj%a0+pi
        else
          a(i) = proj%a0 + r
        endif
      endif
    enddo
    !
  case(p_sfl)
    call rel_to_abs_sfl(proj,x,y,a,d,n)
    !
  case(p_mollweide)  ! Mollweide
    do i=1,n
      theta = asin(y(i)/sqrt(2.d0))
      a(i) = proj%a0 + pi*x(i) / ( 2.d0*sqrt(2.d0)*cos(theta) )
      d(i) = asin( (2.d0*theta+sin(2.d0*theta)) / pi )
    enddo
    !
  case(p_ncp)  ! North Celestial Pole projection (used by the WSRT)
    do i=1,n
      da = atan2( x(i), proj%cosd0-y(i)*proj%sind0 )
      cosda = cos(da)
      if (abs(cosda).lt.precision) then
        if (x(i).ge.0.d0) then
          a(i) = proj%a0 + pi/2.d0
          d(i) = acos(x(i))
        else
          a(i) = proj%a0 - pi/2.d0
          d(i) = acos(-x(i))
        endif
      else
        a(i) = proj%a0 + da
        d(i) = sign(1d0,proj%d0) * acos( (proj%cosd0-y(i)*proj%sind0) / cosda )
      endif
    enddo
    !
  case(p_none)
    a(1:n) = x(1:n)
    d(1:n) = y(1:n)
    call gwcs_message(seve%w,'PROJECTION','No coordinate conversion for projection NONE (2)')
  case default
    call gwcs_message(seve%e,'PROJECTION','Unsupported projection (2)')
    return
  end select
  !
  ! Modulo the a(:) values. We want
  ! 1)   0   < a0 < 2*pi    to be consistent with e.g. V\HEADER which prints
  !                         it in this range
  ! 2) a0-pi < a  < a0+pi   to ensure that there is no discontinuity when a0
  !                         neighbours 0 or 2*pi. This means that 'a' can be
  !                         slightly under 0 or beyond 2*pi (24h).
  ma0 = modulo(proj%a0,2d0*pi)
  do i=1,n
    if (a(i).lt.ma0-pi) then
      a(i) = a(i) + 2d0*pi
    elseif (a(i).gt.ma0+pi) then
      a(i) = a(i) - 2d0*pi
    endif
  enddo
  !
end subroutine rel_to_abs_1dn8
!
subroutine rel_to_abs_sfl(proj,x,y,a,d,n)
  use phys_const
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ private
  ! SFL: see Calabretta and Greisen 2002
  !
  ! Their general idea, as described in section 2, is that
  ! 1) you convert from (x,y) projected coordinates to the "native"
  !    absolute spherical coordinate: (x,y) are converted to
  !    (phi,theta).
  ! 2) you rotate the absolute native coordinates (phi,theta) to
  !    absolute celestial coordinates (alpha,delta) (Euler rotation of
  !    the native sphere).
  ! => those 2 steps are grouped in Eq. 2, 8, 9, 10.
  !
  ! In the context of SFL, these equations can be simplified. As per
  ! section 5.3, SFL projection is a pseudo-spherical projection with
  ! coordinates of the reference point (phi_0,theta_0) = (0,0). Also,
  ! (phi,theta) are defined in Eq. 92, 93 for SFL projection.
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(in)  :: y(*)  ! Array of offsets in Y
  real(kind=8),       intent(out) :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(out) :: d(*)  ! Array of declinations
  integer(kind=8),    intent(in)  :: n     ! Size of arrays
  ! Local
  real(kind=8) :: phi,theta,cost,sint
  real(kind=8) :: cosppp,sinppp
  integer(kind=8) :: i
  !
  do i=1,n
    theta = y(i)       ! Eq. 92
    cost = cos(theta)
    sint = sin(theta)
    phi  = x(i)/cost   ! Eq. 93
    cosppp = cos(phi-proj%sfl%phi_p)
    sinppp = sin(phi-proj%sfl%phi_p)
    ! Eq. 2:
    a(i) = proj%sfl%alpha_p +  &
              atan2(-cost*sinppp,  &
                     sint*proj%sfl%cosdp - cost*proj%sfl%sindp*cosppp)
    d(i) = asin( sint*proj%sfl%sindp + cost*proj%sfl%cosdp*cosppp )
  enddo
  !
end subroutine rel_to_abs_sfl
!
subroutine abs_to_rel_0d(proj,a,d,x,y,n)
  use gwcs_interfaces, except_this=>abs_to_rel_0d
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic abs_to_rel
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for scalar values
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: a     ! R.A. (radians)
  real(kind=8),       intent(in)  :: d     ! Declinations
  real(kind=8),       intent(out) :: x     ! Offset in X
  real(kind=8),       intent(out) :: y     ! Offset in Y
  integer(kind=4),    intent(in)  :: n     ! Useless, assumed 1
  ! Local
  real(kind=8) :: a1(1),d1(1),x1(1),y1(1)
  !
  a1(1) = a
  d1(1) = d
  call abs_to_rel_1dn8(proj,a1,d1,x1,y1,1_8)
  x = x1(1)
  y = y1(1)
  !
end subroutine abs_to_rel_0d
!
subroutine abs_to_rel_1dn4(proj,a,d,x,y,n)
  use phys_const
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>abs_to_rel_1dn4
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic abs_to_rel
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for 1D arrays, size as I*4
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
  real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
  integer(kind=4),    intent(in)  :: n     ! Size of arrays
  !
  call abs_to_rel_1dn8(proj,a,d,x,y,int(n,kind=8))
  !
end subroutine abs_to_rel_1dn4
!
subroutine abs_to_rel_1dn8(proj,a,d,x,y,n)
  use phys_const
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>abs_to_rel_1dn8
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public-generic abs_to_rel
  !  Convert a set of plane position to spherical coordinates according
  ! to the current projection formulae
  ! ---
  ! This version for 1D arrays, size as I*8
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
  real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
  integer(kind=8),    intent(in)  :: n     ! Size of arrays
  ! Local
  real(kind=8), parameter :: precision=1.0d-10
  real(kind=8) :: r,p,cosdec,sindec,cosa,sina,expr,da,cosda,theta,dtheta,cpang,spang
  integer(kind=8) :: i
  logical :: changesign
  !
  select case(proj%type)
  case(p_cartesian)  ! Cartesian projection
    if (abs(proj%angle).le.precision) then
      do i = 1, n
        x(i) = a(i)-proj%a0
        y(i) = d(i)-proj%d0
      enddo
    else
      cpang = cos(proj%angle)
      spang = sin(proj%angle)
      do i = 1, n
        r = a(i)-proj%a0
        p = d(i)-proj%d0
        x(i) =  r*cpang+p*spang
        y(i) = -r*spang+p*cpang
      enddo
    endif
    !
  case(p_gnomonic)  ! Gnomonic
    if (abs(proj%sind0).ge.precision) then
      do i = 1,n
        sindec = sin(d(i))
        cosdec = cos(d(i))
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        expr = sindec*proj%cosd0-cosdec*proj%sind0*cosa
        r = arccos ( (sindec - proj%cosd0*expr)/proj%sind0 )
        if (r.gt.precision) then
          p = atan2 ( cosdec*sina , expr ) + proj%angle
          expr = tan(r)
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        cosdec = cos(d(i))
        sindec = sin(d(i))
        r = arccos ( cosdec*cosa )
        if (r.ge.precision) then
          p = atan2 ( cosdec*sina,sindec ) + proj%angle
          expr = tan(r)
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_ortho)  ! Dixon or Orthographic
    if (abs(proj%sind0).ge.precision) then
      do i = 1,n
        sindec = sin(d(i))
        cosdec = cos(d(i))
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        expr = sindec*proj%cosd0-cosdec*proj%sind0*cosa
        r = arccos ( (sindec - proj%cosd0*expr)/proj%sind0 )
        if (r.gt.precision) then
          p = atan2 ( cosdec*sina , expr ) + proj%angle
          expr = sin(r)
          !!!                 if (r.ge.pi/2) r=pi/2
          x(i) = expr*sin(p)
          y(i) = expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        cosdec = cos(d(i))
        sindec = sin(d(i))
        r = arccos ( cosdec*cosa )
        if (r.ge.precision) then
          p = atan2 ( cosdec*sina,sindec ) + proj%angle
          expr = sin(r)
          !!!                 if (r.ge.pi/2) r=pi/2
          x(i) = expr*sin(p)
          y(i) = expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_azimuthal)  ! Azimuthal or Schmidt
    if (abs(proj%sind0).ge.precision) then
      do i = 1,n
        sindec = sin(d(i))
        cosdec = cos(d(i))
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        expr = sindec*proj%cosd0-cosdec*proj%sind0*cosa
        r = arccos ( (sindec - proj%cosd0*expr)/proj%sind0 )
        if (r.gt.precision) then
          p = atan2 ( cosdec*sina , expr ) + proj%angle
          x(i) = r*sin(p)
          y(i) = r*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        cosdec = cos(d(i))
        sindec = sin(d(i))
        r = arccos ( cosdec*cosa )
        if (r.ge.precision) then
          p = atan2 ( cosdec*sina,sindec ) + proj%angle
          x(i) = r*sin(p)
          y(i) = r*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_stereo)  ! Stereographic
    if (abs(proj%sind0).ge.precision) then
      do i = 1,n
        sindec = sin(d(i))
        cosdec = cos(d(i))
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        expr = sindec*proj%cosd0-cosdec*proj%sind0*cosa
        r = arccos ( (sindec - proj%cosd0*expr)/proj%sind0 )
        if (r.gt.precision) then
          p = atan2 ( cosdec*sina , expr ) + proj%angle
          expr = 2.d0*tan(r*0.5d0)
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        cosdec = cos(d(i))
        sindec = sin(d(i))
        r = arccos ( cosdec*cosa )
        if (r.ge.precision) then
          p = atan2 ( cosdec*sina,sindec ) + proj%angle
          expr = tan(r*0.5d0)
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_lambert)  ! Lambert equal area
    if (abs(proj%sind0).ge.precision) then
      do i = 1,n
        sindec = sin(d(i))
        cosdec = cos(d(i))
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        expr = sindec*proj%cosd0-cosdec*proj%sind0*cosa
        r = arccos ( (sindec - proj%cosd0*expr)/proj%sind0 )
        if (r.gt.precision) then
          p = atan2 ( cosdec*sina , expr ) + proj%angle
          if (r.ge.pi-precision) then
            expr = 2.0
          else
            expr = 2.d0*sin(r)/sqrt(2.d0*(1.d0+cos(r)))
          endif
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    else
      do i=1,n
        sina = sin(a(i)-proj%a0)
        cosa = cos(a(i)-proj%a0)
        cosdec = cos(d(i))
        sindec = sin(d(i))
        r = arccos ( cosdec*cosa )
        if (r.ge.precision) then
          p = atan2 ( cosdec*sina,sindec ) + proj%angle
          if (r.ge.pi-precision) then
            expr = 2.0
          else
            expr = 2.d0*sin(r)/sqrt(2.d0*(1.d0+cos(r)))
          endif
          x(i) =  expr*sin(p)
          y(i) =  expr*cos(p)
        else
          x(i) = 0.d0
          y(i) = 0.d0
        endif
      enddo
    endif
    !
  case(p_aitoff)  ! Aitoff
    do i=1,n
      changesign = d(i).lt.0.d0
      da = a(i) - proj%a0
      do while (da.lt.-pi)
        da = da + 2.d0*pi
      enddo
      do while (da.gt.pi)
        da = da - 2.d0*pi
      enddo
      da = da*0.5d0
      if (da.eq.0.d0 .and. d(i).eq.0.d0) then
        x(i)=0.d0
        y(i)=0.d0
      else
        cosdec = cos(d(i))
        r = arccos( cosdec*cos(da) )
        expr = min ( max(cosdec*sin(da)/sin(r),-1.d0), 1.d0)
        r = 2.d0*sin(r*0.5d0)
        x(i) = 2.d0*r*expr
        y(i) = r*cos(arcsin(expr))
        if (changesign) y(i)=-y(i)
      endif
    enddo
    !
  case(p_radio)  ! Classical Single-Dish mapping
    do i=1,n
      p = d(i)
      da = a(i)-proj%a0
      do while (da.lt.-pi)
        da = da+2.d0*pi
      enddo
      do while (da.gt.pi)
        da = da-2.d0*pi
      enddo
      x(i) = da*cos(p)
      y(i) = p-proj%d0
    enddo
    !
  case(p_sfl)  ! SFL Calabretta & Greisen
    call abs_to_rel_sfl(proj,a,d,x,y,n)
    !
  case(p_mollweide)  ! Mollweide
    ! References:
    !  - "Map projections - A working manual" by John P. Snyder (U.S. Geological
    !    Survey Professional Paper 1395)
    !  - https://en.wikipedia.org/wiki/Mollweide_projection
    !  - https://fr.wikipedia.org/wiki/Projection_de_Mollweide
    do i=1,n
      !
      if (d(i).ge.pi/2.d0) then
        x(i) = 0.d0
        y(i) = proj%npole
      elseif (d(i).le.-pi/2.d0) then
        x(i) = 0.d0
        y(i) = proj%spole
      else
        ! Determine auxiliary angle theta such as:
        ! 2 theta + sin(2 theta) = pi sin(d)
        ! Use Newton-Raphson iterative method (rapid convergence, slower near
        ! the poles)
        theta = 2.d0*d(i)  ! Start point
        dtheta = pi        ! Precision reached
        ! The minimal precision to be reached has been chosen by checking
        ! that the conversion loop absolute -> relative -> absolute
        ! coordinates is accurate down to the milliarcsec, for a set of
        ! coordinates sampling the whole sphere (especially near the pole).
        do while (abs(dtheta).gt.pi/5.d4)
          dtheta = (theta + sin(theta) - pi*sin(d(i))) /  &
                  (1.d0 + cos(theta))
          theta = theta - dtheta
        enddo
        ! We have resolved theta' = 2 theta. Find theta:
        theta = theta/2.d0
        !
        x(i) = 2.d0*sqrt(2.d0)*(a(i)-proj%a0)*cos(theta)/pi
        y(i) = sqrt(2.d0) * sin(theta)
      endif
      !
    enddo
      !
  case(p_ncp)  ! North Celestial Pole projection (used by the WSRT)
    do i=1,n
      da = a(i)-proj%a0
      x(i) = cos(d(i)) * sin(da)
      cosda = cos(da)
      if (abs(cosda).lt.precision) then
        y(i) = proj%cosd0 / proj%sind0
      else
        y(i) = (proj%cosd0 - cos(d(i))*cos(da)) / proj%sind0
      endif
    enddo
    !
  case(p_none)
    x(1:n) = a(1:n)
    y(1:n) = d(1:n)
    call gwcs_message(seve%w,'PROJECTION','No coordinate conversion for projection NONE (3)')
  case default
    call gwcs_message(seve%e,'PROJECTION','Unsupported projection (3)')
  end select
  !
end subroutine abs_to_rel_1dn8
!
subroutine abs_to_rel_sfl(proj,a,d,x,y,n)
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ private
  ! SFL: see Calabretta and Greisen 2002
  !
  ! See comments in rel_to_abs_sfl
  !---------------------------------------------------------------------
  type(projection_t), intent(in)  :: proj  ! Description of projection
  real(kind=8),       intent(in)  :: a(*)  ! Array of R.A. (radians)
  real(kind=8),       intent(in)  :: d(*)  ! Array of declinations
  real(kind=8),       intent(out) :: x(*)  ! Array of offsets in X
  real(kind=8),       intent(out) :: y(*)  ! Array of offsets in Y
  integer(kind=8),    intent(in)  :: n     ! Size of arrays
  ! Local
  real(kind=8) :: cosd,sind,cosaap,sinaap,phi,theta
  integer(kind=8) :: i
  !
  do i=1,n
    cosd   = cos(d(i))
    sind   = sin(d(i))
    cosaap = cos(a(i)-proj%sfl%alpha_p)
    sinaap = sin(a(i)-proj%sfl%alpha_p)
    ! Eq. 5:
    phi = proj%sfl%phi_p +  &
          atan2( -cosd*sinaap,  &
            sind*proj%sfl%cosdp - cosd*proj%sfl%sindp*cosaap)
    theta = asin(sind*proj%sfl%sindp + cosd*proj%sfl%cosdp*cosaap)
    ! Eq. 90, 91:
    x(i) = phi * cos(theta)
    y(i) = theta
  enddo
  !
end subroutine abs_to_rel_sfl
!
function arcsin (x)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8) :: arcsin         !
  real(kind=8), intent(in) :: x  !
  !
  if (x.le.-1.d0) then
    arcsin = -pi*0.5d0
  elseif (x.ge.1.d0) then
    arcsin = pi*0.5d0
  else
    arcsin = asin(x)
  endif
end function arcsin
!
function arccos (x)
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  real(kind=8) :: arccos         !
  real(kind=8), intent(in) :: x  !
  !
  if (x.le.-1.d0) then
    arccos = pi
  elseif (x.ge.1.d0) then
    arccos = 0.0d0
  else
    arccos = acos(x)
  endif
end function arccos
!
subroutine gwcs_projec(a0,d0,pangle,ptype,proj,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use gwcs_interfaces, except_this=>gwcs_projec
  use gwcs_types
  !---------------------------------------------------------------------
  ! @ public
  !       Define a projection
  !---------------------------------------------------------------------
  real(kind=8),       intent(in)    :: a0      !
  real(kind=8),       intent(in)    :: d0      !
  real(kind=8),       intent(in)    :: pangle  !
  integer(kind=4),    intent(in)    :: ptype   !
  type(projection_t), intent(out)   :: proj    !
  logical,            intent(inout) :: error   !
  ! Local
  character(len=*), parameter :: rname='PROJECTION'
  real(kind=8), parameter :: halfpi=pi/2.d0
  real(kind=8) :: x,delta_p_1,delta_p_2,cospp
  !
  ! Setup necessary constants
  proj%type  = ptype
  proj%a0    = a0
  proj%d0    = d0
  proj%angle = pangle
  if (proj%type.eq.p_none) return
  !
  proj%sind0 = sin(d0)
  proj%cosd0 = cos(d0)
  proj%sina0 = sin(a0)
  proj%cosa0 = cos(a0)
  !
  ! Compute POLE position and values of remarkable points
  select case(proj%type)
  case(p_cartesian)
    proj%npole =  pi*0.5d0 - proj%d0
    proj%spole = -pi*0.5d0 - proj%d0
    !
  case(p_gnomonic)
    if (proj%d0.lt.-1.d-30) then
      proj%spole = 1.d0/tan(proj%d0)
      proj%npole = 1.d38
    elseif (proj%d0.gt.1.d-30) then
      proj%npole = 1.d0/tan(proj%d0)
      proj%spole = 1.d38
    else
      proj%npole = 1.d38
      proj%spole = 1.d38
    endif
    !
  case(p_ortho)
    if (proj%d0.lt.-1.d-30) then    ! North pole invisible
      proj%spole = -proj%cosd0
      proj%npole = 1.d38
    elseif(proj%d0.gt.1.d-30) then  ! South pole invisible
      proj%npole = proj%cosd0
      proj%spole = 1.d38
    else                            ! Both poles visibles
      proj%npole = 1.d0
      proj%spole = -1.d0
    endif
    !
  case(p_azimuthal)
    if (proj%d0.lt.0.d0) then
      proj%spole = -proj%d0-pi*0.5d0
      proj%npole = pi*0.5d0+proj%d0
    else
      proj%spole = proj%d0-pi*0.5d0
      proj%npole = pi*0.5d0-proj%d0
    endif
    !
  case(p_stereo)
    if (abs(proj%d0).gt.1.d-30) then
      call abs_to_rel(proj,0.d0,pi*0.5d0,x,proj%npole,1)
      call abs_to_rel(proj,0.d0,-pi*0.5d0,x,proj%spole,1)
    else
      proj%npole = 1.d0
      proj%spole = -1.d0
    endif
    !
  case(p_lambert)
    ! if (abs(proj%d0).gt.1.d-30) then
    call abs_to_rel(proj,0.d0,pi*0.5d0,x,proj%npole,1)
    call abs_to_rel(proj,0.d0,-pi*0.5d0,x,proj%spole,1)
    ! else
    !   proj%npole = 2.d0
    !   proj%spole = -2.d0
    ! endif
    !
  case(p_aitoff)
    if (proj%angle.ne.0.d0) then
      call gwcs_message(seve%w,rname,'AITOFF does not support a projection angle')
      proj%angle = 0.d0
    endif
    proj%npole = sqrt(2.0d0)
    proj%spole = -proj%npole
    proj%d0 = 0.d0
    proj%cosd0 = 1.d0
    proj%sind0 = 0.d0
    !
  case(p_radio)
    if (proj%angle.ne.0.d0) then
      call gwcs_message(seve%w,rname,'RADIO does not support a projection angle')
      proj%angle = 0.d0
    endif
    proj%npole = pi*0.5d0 - proj%d0
    proj%spole = -proj%d0 - pi*0.5d0
    !
  case(p_sfl)
    if (proj%angle.ne.0.d0) then
      call gwcs_message(seve%w,rname,'SFL does not support a projection angle')
      proj%angle = 0.d0
    endif
    proj%npole = halfpi - proj%d0
    proj%spole = -proj%d0 - halfpi
    ! See Calabretta & Greisen 2002 for references.
    ! Section 2.2 last paragraph: phi_p (LONPOLEa)
    if (proj%d0.ge.0.d0) then
      proj%sfl%phi_p = 0.d0
      cospp = 1.d0
    ! sinpp = 0.d0
    else
      proj%sfl%phi_p = pi
      cospp = -1.d0
    ! sinpp = 0.d0
    endif
    ! Eq 8:
    delta_p_1 = atan2(0.d0,cospp) + acos(proj%sind0)
    delta_p_2 = atan2(0.d0,cospp) - acos(proj%sind0)
    ! Section 2.4 gives a lot of rules to chose between the 2:
    if (delta_p_1.gt.0.d0 .and. delta_p_1.le.halfpi) then
      ! No LATPOLE, northen is the default (rule #4)
      proj%sfl%delta_p = delta_p_1
    else
      proj%sfl%delta_p = delta_p_2
    endif
    if (abs(proj%sfl%delta_p-halfpi).le.1d-10)  then
      ! delta_p = +pi/2 => rule #2
      proj%sfl%sindp = 1.d0
      proj%sfl%cosdp = 0.d0
      proj%sfl%alpha_p = proj%a0 + proj%sfl%phi_p - pi
    elseif (abs(proj%sfl%delta_p+halfpi).le.1d-10)  then
      ! delta_p = -pi/2 => rule #2
      proj%sfl%sindp = -1.d0
      proj%sfl%cosdp =  0.d0
      proj%sfl%alpha_p = proj%a0 - proj%sfl%phi_p
    else
      proj%sfl%sindp = sin(proj%sfl%delta_p)
      proj%sfl%cosdp = cos(proj%sfl%delta_p)
      ! Eq 9+10 combined as atan2(sin,cos)
      proj%sfl%alpha_p = proj%a0 -  &
                        atan2(0.d0,-proj%sfl%sindp*proj%sind0/(proj%sfl%cosdp*proj%cosd0))
    endif
    !
  case(p_mollweide)
    if (proj%angle.ne.0.d0) then
      call gwcs_message(seve%w,rname,'Mollweide does not support a projection angle')
      proj%angle = 0.d0
    endif
    if (proj%d0.ne.0.d0) then
      call gwcs_message(seve%w,rname,'Mollweide projection center must be on equator')
      proj%d0 = 0.d0
      proj%cosd0 = 1.d0
      proj%sind0 = 0.d0
      ! Note that we could tolerate a non-zero declination. However, the tangent
      ! plane would remain on the equator, but the overall projected map would
      ! be Y-shifted (same behaviour as radio projection).
    endif
    proj%npole = sqrt(2.d0)
    proj%spole = -sqrt(2.d0)
    !
  case(p_ncp)
    if (proj%d0.le.0.d0) then
      call gwcs_message(seve%w,rname,  &
        'North Celestial Pole projection center must be in North hemisphere')
      proj%d0 = pi/2.d0
      proj%cosd0 = 0.d0
      proj%sind0 = 1.d0
    endif
    proj%npole = proj%cosd0/proj%sind0
    proj%spole = 1.d38  ! Invisible
    !
  case default
    call gwcs_message(seve%e,rname,'Unsupported projection (1)')
    error = .true.
    return
  end select
  !
end subroutine gwcs_projec
!
subroutine abs_add_distance(lon1,lat1,off,angl,lon2,lat2)
  !---------------------------------------------------------------------
  ! @ public
  !   Add a distance to absolute spherical coordinates and return the
  ! resulting absolute spherical coordinates.
  !  This is basically an inverse Haversine formula.
  !  Angle:
  !    North   0
  !    East   90 (with longitude increasing towards East)
  !    South 180
  !    West  270
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  ::  lon1  ! [rad] Longitude of input coordinates
  real(kind=8), intent(in)  ::  lat1  ! [rad] Latitude of input coordinates
  real(kind=8), intent(in)  ::  off   ! [rad] Offset/distance to be added
  real(kind=8), intent(in)  ::  angl  ! [rad] Angle of offset
  real(kind=8), intent(out) ::  lon2  ! [rad] Longitude of output coordinates
  real(kind=8), intent(out) ::  lat2  ! [rad] Latitude of output coordinates
  ! Local
  real(kind=8) :: slat1,clat1,coff,soff,slat2
  !
  slat1 = sin(lat1)
  clat1 = cos(lat1)
  soff = sin(off)
  coff = cos(off)
  !
  slat2 = slat1*coff + clat1*soff*cos(angl)
  lat2 = asin(slat2)
  !
  lon2 = lon1 + atan2( sin(angl)*soff*clat1 , coff-slat1*slat2 )
  !
end subroutine abs_add_distance

module gfits_buf
  use gildas_def
  !--------------------------------------------------------------------
  ! GIO global variables for FITS I/O support
  !--------------------------------------------------------------------
  !
  ! Device types
  integer(kind=4), parameter :: disk=0   !
  integer(kind=4), parameter :: cdrom=1  !
  integer(kind=4), parameter :: tape=2   !
  !
  ! Variables for current file
  integer(kind=4) :: ifile               ! Current location on sequential device
  integer(kind=4) :: unit                ! Fortran LUN, C file pointer, or RMS channel
  integer(kind=4) :: dev_type            ! Type of physical device (tape, CDrom,...)
  integer(kind=4) :: ib                  ! Pointer within FITS I/O buffer
  integer(kind=record_length) :: irec    ! Next record for direct access (block mode +CD)
  logical :: read                        ! File is opened in read mode?
  logical :: stdio                       ! ??
  integer(kind=record_length) :: hdurec  ! Starting record of current HDU
  !
  ! I/O buffer
  integer(kind=1) :: buffer(2880)
  integer(kind=2) :: i2buf(1440)
  integer(kind=4) :: i4buf(720)
  equivalence (buffer,i2buf,i4buf)
  !
end module gfits_buf

subroutine gdf_uv_size(huvl,nc)
  use image_def
  !
  type(gildas), intent(inout) :: huvl
  integer, intent(in) :: nc(2)
  !
  ! Local ---
  integer :: loff,moff, xoff,yoff, lid
  integer :: nchan, nstok
  !
  ! Code ----
  nchan = nc(2)-nc(1)+1
  huvl%gil%ref(1) = huvl%gil%ref(1)-nc(1)+1
  nstok = max(1,huvl%gil%nstokes)
  huvl%gil%dim(1) = huvl%gil%nlead+huvl%gil%natom*nchan*nstok+huvl%gil%ntrail
  if (huvl%gil%ntrail.eq.0) return
  !
  ! If Mosaic with no Source_ID, add the Source_ID column
  lid  = huvl%gil%column_pointer(code_uvt_id)
  if (lid.ne.0) return
  !
  loff = huvl%gil%column_pointer(code_uvt_loff)
  moff = huvl%gil%column_pointer(code_uvt_moff)
  xoff = huvl%gil%column_pointer(code_uvt_xoff)
  yoff = huvl%gil%column_pointer(code_uvt_yoff)
  if (loff.ne.0) then
    if (moff.eq.0) then
      huvl%gil%column_pointer(code_uvt_moff) = huvl%gil%dim(1)+1
      huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+2
      huvl%gil%ntrail = huvl%gil%ntrail+2
    else
      huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+1
      huvl%gil%ntrail = huvl%gil%ntrail+1
    endif
  else if (moff.ne.0) then
    huvl%gil%column_pointer(code_uvt_loff) = huvl%gil%dim(1)+1
    huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+2
    huvl%gil%ntrail = huvl%gil%ntrail+2
  else if (xoff.ne.0) then
    if (yoff.eq.0) then
      huvl%gil%column_pointer(code_uvt_yoff) = huvl%gil%dim(1)+1
      huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+2
      huvl%gil%ntrail = huvl%gil%ntrail+2
    else
      huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+1
      huvl%gil%ntrail = huvl%gil%ntrail+1
    endif
  else if (yoff.ne.0) then
    huvl%gil%column_pointer(code_uvt_xoff) = huvl%gil%dim(1)+1
    huvl%gil%column_pointer(code_uvt_id) = huvl%gil%dim(1)+2
    huvl%gil%ntrail = huvl%gil%ntrail+2
  endif
  !  
  huvl%gil%dim(1) = huvl%gil%nlead+huvl%gil%natom*nchan*nstok+huvl%gil%ntrail
end subroutine gdf_uv_size
!
subroutine getset_uvdata(rname,head,datauv,fd,fits_fmt,nc,pcount,error)
  use clean_def
  use clean_arrays
  use clean_types
  use clean_beams
  use clean_default
  use uvfit_data
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this=>getset_uvdata
  !
  !------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Read UV_DATA or get it from another buffer
  !!
  !------------------------------------------------------------------
  type (gildas), intent(inout) :: head    !! Header of input data
  character(len=*), intent(in) :: rname   !! Caller name
  real(kind=4), intent(in) :: datauv(head%gil%dim(1),head%gil%dim(2)) !! Data used to fill the values
  type(gfits_hdesc_t), intent(in) :: fd   !! FITS descriptor 
  integer, intent(in) :: fits_fmt         !! Input FITS file format
  integer, intent(in) :: nc(2)            !! Channel range
  integer, intent(in) :: pcount           !! Fits PCOUNT
  logical, intent(out) :: error
  !
  ! Constants
  integer, parameter :: o_trail=5
  !
  ! Local ---
  integer :: local_nc(2)
  type(gildas) :: htmp
  integer :: ioff, joff, itel
  integer :: i, ier, nchan, insize_uv
  character(len=80) :: mess
  integer :: ram_need
  logical :: readit
  logical :: ismosaic
  logical :: sorted
  !
  ! Code ----
  if (head%char%type(1:9).ne.'GILDAS_UV') then
    call map_message(seve%e,rname,'Input data is not a UV data set')
    error = .true.
    return
  endif
  readit = rname.eq."READ"
  !
  ! Free the previous zone
  call uv_free_buffers
  save_data(code_save_uv) = .false.
  ! No UV_PREVIEW done, then...
  call sic_delvariable('PREVIEW',.false.,error)
  call reset_fields(themap)
  !
  error = .false.
  !
  call gildas_null (huvi, type= 'UVT')
  call gildas_null (htmp, type= 'UVT')
  call gdf_copy_header(head, htmp, error)
  ! Check appropriate order
  if (head%char%code(1).eq."RANDOM") then
    call map_message(seve%w,rname,'UV data is transposed')
    call gdf_transpose_header (htmp, huvi, '21', error)
  else
    call gdf_copy_header(head, huvi, error)    
  endif
  if (error)  return
  htmp%loca = head%loca
  huvi%loca  = head%loca   ! Why : to get the image slot !...
  !
  call sic_delvariable ('UV',.false.,error)
  call sic_delvariable ('UVS',.false.,error)
  call sic_delvariable ('DCHANFLAG',.false.,error)
  !
  ! Extract desired channels
  nchan = huvi%gil%nchan
  !
  if (readit) then
    local_nc = nc
    ier = gdf_range (local_nc, nchan)
    call gdf_uv_size(huvi,local_nc)
    nchan = local_nc(2)-local_nc(1)+1
    ! 
    ! Ntrail is manipulated by the /NOTRAIL option
    huvi%gil%dim(1) = huvi%gil%dim(1)-huvi%gil%ntrail
    insize_uv = huvi%gil%dim(1)
    if (fits_fmt.eq.1) then
      insize_uv = huvi%gil%nlead+huvi%gil%natom*nchan
    endif
    !
    ! Only for READ command
    if (huvi%gil%ntrail.gt.0) then
      if (sic_present(o_trail,0).or.(.not.read_trail)) then    ! /NOTRAIL option
        do i=1,code_uvt_last
          if (huvi%gil%column_pointer(i).gt.huvi%gil%dim(1)) then
            call map_message(seve%w,rname,'Found column '//uv_column_name(i))
            huvi%gil%column_size(i) = 0
            huvi%gil%column_pointer(i) = 0
          endif
        enddo
        huvi%gil%ntrail = 0
      endif
      ! use them according to user selection
      huvi%gil%dim(1) = huvi%gil%dim(1) + huvi%gil%ntrail
    endif
    insize_uv = insize_uv+huvi%gil%ntrail
    !
    huvi%gil%nchan = nchan
    !
    ram_need = (huvi%gil%dim(1)*huvi%gil%dim(2))/(512*512)   ! Size of RAM requested
    if (ram_need.gt.sys_ramsize) then
      write(mess,'(A,F8.1,A,F8.1,A)') 'Data size (',1d-3*ram_need, &
        & 'GB) exceeds available RAM (',1d-3*sys_ramsize,' GB)'
      call map_message(seve%e,rname,mess,1)
      error = .true.
      return
    else if (ram_need.gt.sys_ramsize/3) then
      write(mess,'(A,F8.1,A,F8.1,A)') 'Data size (',1d-3*ram_need, &
        & 'GB) exceeds 1/3rd  of available RAM (',1d-3*sys_ramsize,' GB)'
      call map_message(seve%w,rname,mess,3)
    endif
    !
    allocate(duvi(insize_uv,huvi%gil%dim(2)),stat=ier)
    call map_read_uvdataset(fd,fits_fmt,pcount,htmp,huvi,local_nc,duvi,error)
    if (error) then
      deallocate(duvi,stat=ier)
      return
    endif
    ! Additional information if any
    huvi%r2d => duvi     ! Set the pointer towards the UV data area
    call get_more_header(fits_fmt,head%file,huvi)
    !
    ! Check the type and number of fields
    call check_uvdata_type(rname,huvi,duvi,themap,error)
    if (error) return
    !
    ! Automatically sort the UV data by fields if it is a Mosaic
    if (abs(themap%nfields).ne.0) then
      !
      ! Sort the DUV array if needed
      huvi%r2d => duvi
      call get_mosaic_cols(huvi,ioff,joff,itel,ismosaic)  
      call uvsort_check_fields(huvi,ioff,joff,itel,sorted)
      if (.not.sorted) then
        call map_message(seve%w,rname,'Sorting Mosaic UV Table',3)
        call gildas_null(htmp,type='UVT')
        call gdf_copy_header(huvi,htmp,error)
        allocate(htmp%r2d(huvi%gil%dim(1),huvi%gil%dim(2)),stat=ier) 
        htmp%r2d = duvi
        call uvsort_mosaic_mem(htmp,huvi,'FIELDS',ioff,joff,itel,error)
        deallocate(htmp%r2d)
      endif 
    endif
  else
    ! Do not read it, just come back to data specified in call sequence
    allocate(duvi(huvi%gil%dim(1),huvi%gil%dim(2)),stat=ier)
    duvi(:,:) = datauv(:,:)
    ! Check the type and number of fields
    call check_uvdata_type(rname,huvi,duvi,themap,error)
    if (error) return
    !
  endif
  ! Erase undefined part of visibility data
  if (huvi%gil%nvisi.lt.huvi%gil%dim(2)) then
    duvi(:,huvi%gil%nvisi+1:huvi%gil%dim(2)) = 0.
  endif
  !
  ! Set the Channel Flags to 1 (good)
  allocate(dchanflag(nchan),stat=ier)
  dchanflag = 1
  call sic_def_inte('DCHANFLAG',dchanflag,1,nchan,.false.,error)
  !
  ! Finalize
  call gildas_null (huv, type = 'UVT')
  call gdf_copy_header(huvi,huv, error)
  huv%file = huvi%file     ! Transmit File name
  huv%r2d => duvi
  duv => duvi              ! Point on original data
  duvr => duvi             ! Point on original data
  !
  call map_uvgildas('UV',huv,error,duvi) 
  !
  ! Undo the Weights buffers also
  if (allocated(g_weight)) deallocate(g_weight)
  if (allocated(g_v)) deallocate(g_v)
  do_weig = .true.
  !
  ! Unload the PRIMARY array if defined
  call sic_delvariable ('PRIMARY',.false.,error)
  if (allocated(dprim)) deallocate(dprim,stat=ier)
  hprim%loca%size = 0
  !
  ! Delete the BEAM_RANGES array if any
  nbeam_ranges = -1    ! Beam ranges unchecked
  call sic_delvariable ('BEAM_RANGES',.false.,error)
  !
  ! Delete the SELF array if defined
  call sic_delvariable ('UVSELF',.false.,error)
  if (associated(duvself)) then
    if (associated(duvself,duvcalib)) then
      nullify(duvself)
    else
      deallocate(duvself,stat=ier)
    endif 
    hself%loca%size = 0
  endif
  call sic_delvariable('UVCALIB',.false.,error)
  if (allocated(duvcalib)) deallocate(duvcalib,stat=ier)
  hcalib%loca%size = 0
  !
  ! Delete the CONTINUUM array if defined
  call sic_delvariable ('UVCONT',.false.,error)
  if (allocated(duvc)) deallocate(duvc,stat=ier)
  huvc%loca%size = 0
  ! Delete the CONTINUUM image if defined
  call sic_delvariable ('CONTINUUM',.false.,error)
  if (allocated(dcont)) deallocate(dcont,stat=ier)
  hcont%loca%size = 0
  !
  ! Final warning for POLARIZATION
  if (huv%gil%nstokes.gt.1) then
    write(mess,'(A,I0,A)') 'UV data has ',huv%gil%nstokes,' polarization states, use STOKES command'
    call map_message(seve%w,rname,mess,1)
  endif
  !
  ! Final message
  if (readit) then  
    call map_message(seve%i,rname,'UV Data read')
  else
    call map_message(seve%i,rname,'UV Data loaded')
  endif
  !
  ! Finalize the %mos structure
  if (abs(themap%nfields).gt.1) call mosaic_set_header(' ',.false.,error)
end subroutine getset_uvdata
!
subroutine check_uvdata_type(rname,huvl,visi,map,error)
  use image_def
  use clean_def
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use imager_interfaces, only : mosaic_getfields, map_message,  &
    & get_bsize, define_fields
  !-------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Internal routine: Check number and types of fields
  !-------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Calling command  
  type(gildas), intent(inout) :: huvl       !! UV header
  real, intent(inout) :: visi(:,:)          !! UV data
  type(uvmap_par), intent(inout) :: map     !! Map parameters (for the fields)
  logical, intent(inout) :: error           !! Logical error flag
  !
  ! Local ---
  type(projection_t) :: uv_proj
  integer :: np, nv, nf
  integer :: loff, moff, xoff, yoff, lid, itel, i, ier
  character(len=12) :: chain
  real :: value
  real :: bsize(10)
  ! real, allocatable :: doffxy(:,:) !Test SG
  !
  ! Code ----
  huvl%loca%size = huvl%gil%dim(1)*huvl%gil%dim(2)
  call reset_fields(map)
  ! 
  if (huvl%gil%ntrail.eq.0) return
  !
  np = huvl%gil%dim(1)
  nv = huvl%gil%nvisi
  !
  loff = huvl%gil%column_pointer(code_uvt_loff)
  moff = huvl%gil%column_pointer(code_uvt_moff)
  !
  xoff = huvl%gil%column_pointer(code_uvt_xoff)
  yoff = huvl%gil%column_pointer(code_uvt_yoff)
  !
  lid  = huvl%gil%column_pointer(code_uvt_id)
  itel = huvl%gil%column_pointer(code_uvt_tele)
  !
  if (lid.ne.0 .and. (loff.eq.0.or.moff.eq.0) .and. (xoff.eq.0.or.yoff.eq.0)) then
    value = visi(lid,1)
    if (any(visi(lid,:).ne.value)) then 
      nf = maxval(visi(lid,:))
      write(chain,'(I12)') nf
      call map_message(seve%e,rname,'Mosaic of '//adjustl(trim(chain))//' fields with only Source ID column')
      call map_message(seve%w,rname,'Use command UV_FIELDS to specify field coordinates')
      ! Ignore error to be able to patch file...
      ! huvl%loca%size = 0 ! Set UV as undefined
      ! error = .true.
      return
    else
      map%nfields = 0
      call map_message(seve%w,rname,'Degenerate mosaic of 1 field with Source ID column')
    endif    
  else if (loff.ne.0 .or. moff.ne.0) then
    ! Mosaic_GetFields allocates the %offxy arrays
    call mosaic_getfields (visi,np,nv,loff,moff,itel,nf,map%offxy,map%teles)  ! doffxy
    if (nf.gt.1) then
      map%nfields = -nf
      write(chain,'(I12)') nf
      call map_message(seve%i,rname,'Raw mosaic of '//adjustl(trim(chain))//' fields')
    else
      map%nfields = 0
      call map_message(seve%w,rname,'Degenerate raw mosaic of 1 field')
    endif
  else if (xoff.ne.0 .or. yoff.ne.0) then
    call mosaic_getfields (visi,np,nv,xoff,yoff,itel,nf,map%offxy,map%teles) ! doffxy)
    if (nf.gt.1) then
      map%nfields = nf
      write(chain,'(I12)') nf
      call map_message(seve%i,rname,'Phase shifted mosaic of '//adjustl(trim(chain))//' fields')
    else
      map%nfields = 0
      call map_message(seve%w,rname,'Degenerate phase shifted mosaic of 1 field')
    endif
  endif
  !
  if (map%nfields.eq.0) return
  !
  ! Convention for Rotated UV data is still pending for Mosaics
  if (huvl%gil%pang.ne.0.) then
    call map_message(seve%e,rname,'Rotated UV data not yet supported for Mosaics (no convention defined by IRAM)')
    huvl%loca%size = 0 ! Set UV as undefined
    error = .true.
    return
  endif
  !
  if (huvl%gil%nteles.le.0) then
    call map_message(seve%w,rname,'No Telescope section in data') 
    call map_message(seve%r,rname, &
      &   '         Use command "SPECIFY TELESCOPE Name" to add one') 
  endif
  ! 
  nf = abs(map%nfields)
  allocate(map%centers(2,nf),map%bsize(nf),map%teles(nf),stat=ier)
  bsize = 0     ! Must be initialized
  call get_bsize(huvl,rname,' ',bsize,error)  ! Compute the primary beams
  !
  !! call init_fields(.false.,error)
  !
  ! Compute the Pointing Centers
  call gwcs_projec(huvl%gil%a0, huvl%gil%d0, huvl%gil%pang, huvl%gil%ptyp, uv_proj, error)
  !
  do i=1,nf
    call rel_to_abs(uv_proj, dble(map%offxy(1,i)), dble(map%offxy(2,i)), &
      & map%centers(1,i), map%centers(2,i), 1)
    if (itel.ne.0) then
	  map%bsize(i) = bsize(map%teles(i))
	else
	  map%bsize(i) = bsize(1)
	endif
  enddo
  !
  call define_fields(map,error)
end subroutine check_uvdata_type
!
subroutine define_fields(map,error)  
  use image_def
  use clean_def
  use gkernel_interfaces
  !---------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Define the FIELDS% structure for Mosaics
  !!
  !---------------------------------------------------
  type(uvmap_par), intent(in) :: map  !! Mapping structure
  logical, intent(inout) :: error     !! Logical error flag
  !
  ! Local ---
  integer(kind=index_length) :: dim(2)
  !
  ! Code ----
  error = .false.
  call sic_defstructure('FIELDS',.true.,error)
  call sic_def_inte('FIELDS%N',map%nfields,0,dim,.false.,error)
  dim(1:2) = [2,abs(map%nfields)]
  call sic_def_real('FIELDS%OFFSETS',map%offxy,2,dim,.false.,error) 
  call sic_def_dble('FIELDS%CENTERS',map%centers,2,dim,.false.,error) 
  dim(1) = abs(map%nfields)
  call sic_def_real('FIELDS%PRIMARY',map%bsize,1,dim,.false.,error)
  call sic_def_inte('FIELDS%TELESCOPE',map%teles,1,dim,.false.,error)
end subroutine define_fields
!
subroutine reset_fields(map)
  use clean_def
  use clean_arrays
  use clean_default
  use gkernel_interfaces, only : sic_delvariable
  !-------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Internal routine: Reset Fields in Mapping structure
  !!
  !-------------------------------------------------------
  type(uvmap_par), intent(inout) :: map  !! Parameter structure
  !
  logical :: error
  !
  error = .false.
  map%nfields = 0
  if (allocated(map%centers)) deallocate(map%centers)
  if (allocated(map%offxy)) deallocate(map%offxy)
  if (allocated(map%bsize)) deallocate(map%bsize)
  mosaic_mode = 'NONE'
  ! Delete the FIELDS variable in all cases...
  call sic_delvariable('FIELDS',.false.,error)
end subroutine reset_fields

module ast_constant
  real(kind=8),  parameter :: pi=3.141592653589793d0
  real(kind=8),  parameter ::  halfpi=pi/2d0
  real(kind=8),  parameter :: twopi = pi*2d0
  real(kind=8),  parameter :: j2000 = 2451545.0d0
  real(kind=8),  parameter :: light = 299792.458d0   !! km/s
  real(kind=8),  parameter :: radius=6367.435d0      !! earth radius in kilometers
  real(kind=8), parameter :: au_m=149597870700d0     !!astronomical unit in m
  real(kind=8), parameter :: astro_nullr8=-1.2345d36
  real(kind=4), parameter :: astro_nullr4=-1.2345e36
  real(kind=8), parameter :: astro_nulli8=-12345678
  real(kind=4), parameter :: astro_nulli4=-12345678
  character(len=4), parameter :: astro_nulla='NULL'
end module ast_constant
!
module ast_params
  integer(kind=8), parameter :: sourcename_length=128
end module ast_params
!
module ast_astro
  use gildas_def
  use ast_params
  !!
  logical :: library_mode  !! Astro loaded in Library or Interactive mode?
  !!
  !! astro.inc
  real(kind=8) :: jnow_utc              !! date julienne utc
  real(kind=8) :: jnow_ut1              !! date julienne ut1
  real(kind=8) :: jnow_tdt              !! date julienne tdt
  real(kind=8) :: d_ut1                 !! ut1 - utc (seconds)
  real(kind=8) :: d_tdt                 !! tdt - utc (seconds)
  real(kind=8) :: lst                   !! local "true" sidereal time
  real(kind=8) :: lonlat(2)             !! e-longitude, latitude in degrees
  real(kind=8) :: altitude              !! altitude in kilometers
  real(kind=8) :: xsun_0(3)             !! earth_sun vector, in r0 , in km
  real(kind=8) :: xsun_2(3)             !! sun az-el at current time
  real(kind=8) :: xg_0(3)               !! earth_g vector, in r0 , in km
  real(kind=8) :: vg_0(3)               !! earth_g vector derivative, in r0 , in km/s
  real(kind=8) :: trfm_30(9)            !! matrix r0 to r3
  real(kind=8) :: trfm_20(9)            !! matrix r0 to r2
  real(kind=8) :: trfm_23(9)            !! matrix r3 to r2
  real(kind=8) :: trfm_43(9)            !! matrix r3 to r4
  real(kind=8) :: trfm_05(9)            !! matrix r5 (day ecliptic) to r0 (j2000 ecliptic)
  real(kind=8) :: s_1(2)                !! source reference coords.
  real(kind=8) :: azimuth, elevation    !! horizontal coords
  real(kind=8) :: ra, dec               !! present_day equatorial coords
  real(kind=8) :: parallactic_angle     !! parallactic angle
  real(kind=8) :: azimuth_old, elevation_old  !! horizontal coords
  real(kind=8) :: ra_old, dec_old       !! present_day equatorial coords
  real(kind=8) :: slimit                !! sun avoidance radius
  real(kind=8) :: fshift                !! frequency ratio due to doppler effect
  real(kind=8) :: freq                  !! frequency (rest) in ghz
  real(kind=4) :: z_axis
  logical :: projection
  integer(kind=4) :: name_out
  character(len=sourcename_length) :: source_name
  !!
  character(len=24) :: config_prefix = ' '
  !
  !! Possible values for sourcetype
  integer(kind=4), parameter :: msoukind=4
  integer(kind=4), parameter :: soukind_none=1      !! no source defined
  integer(kind=4), parameter :: soukind_full=2      !! source defined, full computations
  integer(kind=4), parameter :: soukind_vlsr=3      !! use only LSR
  integer(kind=4), parameter :: soukind_red=4      !! use only Redshift
  character(len=12), parameter ::soukinds(msoukind)= (/ 'NO SOURCE   ','ASTRO SOURCE', &
                                                        'LSR         ','REDSHIFT    ' /)
  integer(kind=4) :: soukind=soukind_none
  !
  !! Support for ASTRO%SOURCE% variable
  character(len=60) :: source_alpha, source_delta
  real(kind=8):: source_az, source_el
  real(kind=8):: source_ra, source_dec
  character(len=sourcename_length) :: astro_source_name
  real(kind=8) :: source_vlsr, source_dop, source_vshift, source_lsr
  real(kind=8) :: source_redshift
  !
  !! Support for ASTRO%SOURCE%IN variable
  character(len=2)  :: source_incoord
  character(len=2)  :: source_invtype
  character(len=14) :: source_inbetasexa,source_inlambdasexa
  real(kind=4)      :: source_ineq
  real(kind=8)      :: source_invelocity,source_inredshift  
  !   
  !! To save the current astro source      
  type :: astro_source_mem
    integer(kind=4)   :: soukind
    character(len=sourcename_length) :: name
    character(len=2)  :: coord
    real(kind=4)   :: equinox
    real(kind=8)      :: lambda  !! radians
    real(kind=8)      :: beta  !! radians
    character(len=2)  :: vtype
    real(kind=8) :: velocity
    real(kind=8) :: redshift
  end type astro_source_mem
  !
  !!       Planet stuff
  real(kind=4) :: planet_tmb            !! planet main beam brightness
  real(kind=4) :: planet_flux           !! planet flux
  real(kind=4) :: planet_size(3)        !! planet size
!!
  character(len=2) :: z_axis_type
  character(len=12) :: frame           !! 'horizontal','equatorial' display
  character(len=filename_length) :: catalog_name(2) !! for sources
  character(len=1) :: azref
!!       character(len=2) :: vtype           !! velocity system ('ls', 'ea', 'he','re')
  character(len=16) :: obsname=' '          !! observatory name
  integer :: config_count=0
  !!
  !! For plots
  integer(kind=4) :: msplot, nsplot
  !! For UV tracks
  integer(kind=4), parameter :: msize=20  !! max number of differnt sizes for an observatory
  integer(kind=4), parameter :: msta=100  !! max number of selected stations
  !!
  type :: uv_track_in_t
    !! Describe input of uvtrack command
    logical :: three_digit_name_compatible
    logical :: do_frame,do_hour,do_table,do_hori,do_int,do_stations,do_size,do_offset,do_weight
    logical :: do_all
    real(kind=4) :: in_h1,in_h2 !!  /HOUR_ANGLE option user input
    real(kind=4) :: h1,h2 !! /HOUR_ANGLE option actually used value
    real(kind=4) :: horizon !!  /HOUR_ANGLE option
    real(kind=4) :: integ_time !! /INT option
    real(kind=4) :: user_array !! if argument of /FRAME option
    !! For / WEight
    integer(kind=4) :: wkey
    !! For /SIZE
    integer(kind=4) :: nsize
    real(kind=4) :: sizes(msize)      !! size
    integer(kind=4) :: nant_size(msize)  !! number of antennas of this size
    real(kind=4) :: offset            !! option /OFFSET (delay line)
    !! For the stations
  end type uv_track_in_t
  !!
  type:: uv_track_station_t
    character(len=12) :: name
    real(kind=4) :: x,y,z !! station coordinates
    real(kind=4) :: t !! alma case
    real(kind=4) :: asize !! antenna size
    logical :: found
  end type uv_track_station_t
  !!
  type :: uv_track_angles_t
    real(kind=4) :: sd !! sine of declination
    real(kind=4) :: cd !! cosine of dec
    real(kind=4) :: sp !! sine of lat
    real(kind=4) :: cp !! cosine of lat
    real(kind=4) :: zsh !! depends on h
    real(kind=4) :: zch !! depends on h
  end type uv_track_angles_t
  !!
  type :: uv_track_t
    type(uv_track_in_t) :: in
    type(uv_track_angles_t) :: ang
    integer(kind=4)   :: n_stations
    type(uv_track_station_t) :: stations(msta)
  end type uv_track_t
  !!
end module ast_astro
!!
module ast_telescope
  ! Telescope characteristics
  real(kind=8) :: jypk                  !! Jy from K scale factor
  real(kind=4) :: diam                  !! Telescope diameter
  character(len=4) :: teles             !! Short telescope name
end module ast_telescope
!
module atm_params
  !---------------------------------------------------------------------
  !! ATM -- input and output parameters.
  !! For portability, SAVE Fortran variables which are target of SIC
  !! variables.
  !!---------------------------------------------------------------------
  real(kind=4), save :: t0,p0,p1,h0,water,airmass
  real(kind=4), save :: freqs,freqi !! in GHz
  real(kind=4), save :: feff,trec,gim,tsys,tant
  real(kind=4), save :: tauox,tauw,temis,temii,paths,pathi,tatms,tatmi
  real(kind=4), save :: taut=0.05   !! Default Zenith opacity
  logical, save :: atm_initdone=.false.
  !!
  !! Noise information
  real(kind=4) :: bandwidth   !! in MHz
  real(kind=4) :: jy_per_k    !! in Jy/K
  real(kind=4) :: inttime     !! in Seconds
  real(kind=4) :: uvweight
end module atm_params

subroutine limits(line,error)
  use gildas_def
  use gbl_format
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>limits
  use greg_kernel
  use greg_rg
  use greg_wcs
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !   LIMITS [X1 X2 Y1 Y2 [TYPE]]
  ! 1        [/XLOG]
  ! 2        [/YLOG]
  ! 3        [/RGDATA [Var_name]]
  ! 4        [/BLANKING]
  ! 5        [/REVERSE [X] [Y]]
  ! 6        [/VARIABLES Xv Yv]
  !
  ! With:
  !   Automatic computation if Xi     *
  !   Last value if                   =
  !   Union with last values          >
  !   Intersection with last values   <
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_pi.inc'
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='LIMITS'
  integer(kind=4), parameter :: optxlog=1
  integer(kind=4), parameter :: optylog=2
  integer(kind=4), parameter :: optrgda=3
  integer(kind=4), parameter :: optblan=4
  integer(kind=4), parameter :: optreve=5
  integer(kind=4), parameter :: optvari=6
  integer(kind=4), parameter :: optmarg=7
  !
  real(kind=8), parameter :: defmargin=5d0  ! [%]
  character(len=20) :: argum
  character(len=argument_length) :: code(4)
  character(len=12) :: ctype(5),name
  real(kind=8) :: arg(4),garg(4),bval,eval,tmp,absarg(4),abstmp,marg(4),kconv
  logical :: flag(4),optrg,vari,blan,incarnate,domargin
  integer(kind=4) :: i,kboxd,kangle,n,length,iarg
  type(sic_descriptor_t) :: xinca,yinca
  integer(kind=address_length) :: ipx,ipy
  integer(kind=4) :: form,nc
  integer(kind=size_length) :: ixy
  save xinca,yinca
  ! Data
  data ctype /'ABSOLUTE','SECONDS','MINUTES','DEGREES','RADIANS'/
  data arg /0.0,1.0,0.0,1.0/
  !
  ! Some syntax analysis
  axis_xlog = sic_present(optxlog,0)
  axis_ylog = sic_present(optylog,0)
  optrg = sic_present(optrgda,0)
  blan  = sic_present(optblan,0)
  vari  = sic_present(optvari,0)
  if (optrg) then
    if (axis_xlog .or. axis_ylog) then
      call greg_message(seve%e,rname,'No logarithmic axis for regular maps')
      error = .true.
    endif
    if (vari.or.blan) then
      call greg_message(seve%e,rname,'Conflicting options')
      error = .true.
    endif
    if (error) return
  endif
  garg(1) = gux1
  garg(2) = gux2
  garg(3) = guy1
  garg(4) = guy2
  !
  ! UNIT
  if (sic_present(0,5)) then
    call sic_ke (line,0,5,argum,nc,.true.,error)
    call sic_ambigs('LIMITS',argum,name,n,ctype,5,error)
    if (error) return
    if (n.eq.1) then
      kboxd = -2               ! Absolute
      kangle = u_radian        ! Must be defined ...
    else
      kboxd = 0
      kangle = n-1             ! Angular unit
    endif
  else
    kboxd = iboxd
    kangle = u_radian
    if (kboxd.ne.-2) kangle = u_angle
  endif
  select case (kangle)
  case (u_second)
    kconv = pi/180.d0/3600.d0
  case (u_minute)
    kconv = pi/180.d0/60.d0
  case (u_degree)
    kconv = pi/180.d0
  case default
    kconv = 1.d0
  end select
  !
  ! /MARGIN
  domargin = sic_present(optmarg,0)
  if (domargin) then
    marg(:) = defmargin
    ! 0, 1, 2 or 4 arguments
    call sic_r8(line,optmarg,1,marg(1),.false.,error)
    if (error)  return
    if (sic_present(optmarg,4)) then
      ! 4 arguments: all different margins
      call sic_r8(line,optmarg,2,marg(2),.true.,error)
      if (error)  return
      call sic_r8(line,optmarg,3,marg(3),.true.,error)
      if (error)  return
      call sic_r8(line,optmarg,4,marg(4),.true.,error)
      if (error)  return
    elseif (sic_present(optmarg,2)) then
      ! 2 arguments: X margins of same amount, Y margins of another amount
      call sic_r8(line,optmarg,2,marg(3),.true.,error)
      if (error)  return
      marg(2) = marg(1)
      marg(4) = marg(3)
    else
      ! 1 argument to option: all margins of same amount
      marg(2) = marg(1)
      marg(3) = marg(1)
      marg(4) = marg(1)
    endif
  else
    marg(:) = 0.d0
  endif
  ! Convert from % to fraction
  marg(:) = marg(:)*1.d-2
  !
  ! Find automatic settings. FLAG(i) is .true. if i-th limit has to be
  ! computed from data (as opposed to explicit limit on command line).
  if (.not.sic_present(0,1)) then
    flag(:) = .true.  ! All limits computed from data
    code(:) = '*'
  elseif (.not.sic_present(0,4)) then
    call greg_message(seve%e,rname,'4 arguments required or none')
    error = .true.
    return
  else
    do i=1,4
      call sic_ch(line,0,i,code(i),length,.true.,error)
      if (error)  return
      flag(i) = (code(i).eq.'*' .or. code(i).eq.'>' .or. code(i).eq.'<')
      if (code(i).eq.'=') then
        ! Previous value is reused. NB: if ABSOLUTE limits, this means that
        ! the previous margin is reused. Is this a desired feature? (e.g.
        ! overplotting maps with different centers?)
        arg(i) = garg(i)
        !
      elseif (flag(i)) then
        ! Automatic limit involved (see later)
        if (kboxd.eq.-2) then
          ! ABSOLUTE limits. Set an absolute value from previous limit, but
          ! not perfect because the formula used in the abs_to_rel conversion
          ! below is not reversible.
          if (i.le.2) then
            call rel_to_abs(gproj,garg(i),garg(i+2),absarg(i),tmp,1)
          else
            call rel_to_abs(gproj,garg(i-2),garg(i),tmp,absarg(i),1)
          endif
        else
          ! Nothing to be precomputed
        endif
        !
      else
        ! Explicit limit
        if (kboxd.eq.-2) then
          ! ABSOLUTE SEXAGESIMAL value
          call sic_sexa(code(i),length,absarg(i),error)
          if (i.le.2 .and. (i_system.eq.type_eq .or. i_system.eq.type_ic)) then
            absarg(i) = absarg(i)*pi/12.0d0
          else
            absarg(i) = absarg(i)*pi/180.0d0
          endif
        else
          ! Floating point value
          call sic_math_dble(code(i),length,arg(i),error)
          if (error)  return
        endif
      endif
    enddo
    if (kboxd.eq.-2) then
      ! Now absarg(:) contains absolute coordinates in radians. Convert to
      ! relative (offsets) coordinates, exactly symetrical to what is done
      ! in BOX or AXIS, e.g. for relative point [X1,tmp], convert from
      ! absolute point [AX1,mean(AY1,AY2)]
      abstmp = (absarg(3)+absarg(4))/2.d0
      call abs_to_rel(gproj,absarg(1),abstmp,arg(1),tmp,1)
      call abs_to_rel(gproj,absarg(2),abstmp,arg(2),tmp,1)
      abstmp = (absarg(1)+absarg(2))/2.d0
      call abs_to_rel(gproj,abstmp,absarg(3),tmp,arg(3),1)
      call abs_to_rel(gproj,abstmp,absarg(4),tmp,arg(4),1)
    endif
  endif
  !
  ! Limits must be computed if any FLAG is set
  ! Otherwise Limits are explicitely mentionned
  incarnate = .false.
  if (flag(1).or.flag(2).or.flag(3).or.flag(4)) then
    !
    ! Compute limits from X and Y data
    if (.not.optrg) then
      ! We activate implicit margin if not already explictly used, but
      ! not where explicit limits were passed
      if (.not.domargin) then
        domargin = .true.
        do i=1,4
          if (flag(i))  marg(i) = defmargin*1.d-2
        enddo
      endif
      !
      ! Check for explicit variables
      if (vari) then
        if (sic_narg(optvari).ne.2) then
          call greg_message(seve%e,rname,  &
            '/VARIABLES option requires two arguments')
          error = .true.
          return
        endif
        ixy = 0
        form = fmt_r8
        call get_same_inca ('LIMITS',line,optvari,1,form,ixy,xinca,error)
        if (error) return
        call get_same_inca ('LIMITS',line,optvari,2,form,ixy,yinca,error)
        if (error) then
          call sic_volatile(xinca)
          return
        endif
        !
        ! Use X Y default
      else
        form = fmt_r8
        ixy = 0
        call get_greg_inca ('LIMITS','X',form,ixy,xinca,error)
        if (error) return
        call get_greg_inca ('LIMITS','Y',form,ixy,yinca,error)
        if (error) then
          call sic_volatile(xinca)
          return
        endif
      endif
      incarnate = .true.
      !
      ! /BLANKING ?
      bval = cblank
      call sic_r8 (line,optblan,1,bval,.false.,error)
      if (error) goto 97
      eval = eblank
      call sic_r8 (line,optblan,2,eval,.false.,error)
      if (error) goto 97
      !
      ! Compute limits
      ipx = gag_pointer(xinca%addr,memory)
      ipy = gag_pointer(yinca%addr,memory)
      call limaut('X',axis_xlog,arg(1),arg(2),flag(1:2),memory(ipx),ixy,  &
        memory(ipy),bval,eval,error)
      if (error) goto 97
      call limaut('Y',axis_ylog,arg(3),arg(4),flag(3:4),memory(ipy),ixy,  &
        memory(ipy),bval,eval,error)
      if (error) goto 97
      !
    else
      ! /RGDATA Var_Name: compute limits from Regular Grid array
      if (sic_present(optrgda,1)) then
        ! Load Variable as RGDATA
        call rgimag (line,optrgda,.false.,0,error)
        if (error) then
          call greg_message(seve%e,rname,'Variable does not exist')
          return
        endif
      endif
      ! Check RGDATA is loaded
      if (rg%status.eq.code_pointer_null) then
        call greg_message(seve%e,rname,'No map loaded')
        error =.true.
        return
      endif
      ! NB: limits are converted from radians to current unit for a coherent
      ! flow in this subroutine
      if (flag(1)) arg(1) = ( (0.5-rg%xref)*rg%xinc+rg%xval       )/kconv
      if (flag(2)) arg(2) = ( (rg%nx+0.5-rg%xref)*rg%xinc+rg%xval )/kconv
      if (flag(3)) arg(3) = ( (0.5-rg%yref)*rg%yinc+rg%yval       )/kconv
      if (flag(4)) arg(4) = ( (rg%ny+0.5-rg%yref)*rg%yinc+rg%yval )/kconv
    endif
  endif
  !
  ! Apply margins if any
  if (domargin) then
    call limits_margin('X',axis_xlog,arg(1),arg(2),marg(1),marg(2),error)
    if (error)  return
    call limits_margin('Y',axis_ylog,arg(3),arg(4),marg(3),marg(4),error)
    if (error)  return
  endif
  !
  ! Convert from current angle unit to internal radians unit
  do i=1,4
    arg(i) = arg(i)*kconv
  enddo
  !
  ! Set new limits according to code
  do i=1,4
    if (code(i).eq.'<') then
      arg(i)=min(arg(i),garg(i))
    elseif (code(i).eq.'=') then
      arg(i)=garg(i)
    elseif (code(i).eq.'>') then
      arg(i)=max(arg(i),garg(i))
    endif
  enddo
  !
  ! Check if valid limits
  if (arg(1).eq.arg(2)) then
    call greg_message(seve%e,rname,'No range in X')
    error = .true.
    goto 97
  endif
  if (arg(3).eq.arg(4)) then
    call greg_message(seve%e,rname,'No range in Y')
    error = .true.
    goto 97
  endif
  !
  ! Reverse if requested
  if (sic_present(optreve,0)) then
    do iarg=1,max(1,sic_narg(optreve))  ! At least 1 argument
      call sic_ke (line,optreve,iarg,argum,nc,.true.,error)
      if (error) goto 97
      if (argum.eq.'X') then
        tmp = arg(2)
        arg(2) = arg(1)
        arg(1) = tmp
      elseif (argum.eq.'Y') then
        tmp = arg(3)
        arg(3) = arg(4)
        arg(4) = tmp
      endif
    enddo
  endif
  !
  call setlim(arg(1),arg(2),arg(3),arg(4))
  call setrem  ! Set the "remarkable" points
  !
97 continue
  if (incarnate) then
    call sic_volatile(xinca)
    call sic_volatile(yinca)
  endif
  !
end subroutine limits
!
subroutine setlim(ax1,ax2,ay1,ay2)
  use greg_interfaces, except_this=>setlim
  use greg_kernel
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG  Internal routine
  !   Setup new limits and conversion formulae
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: ax1  ! Left limit of X axis
  real(kind=8), intent(in) :: ax2  ! Right limit of X axis
  real(kind=8), intent(in) :: ay1  ! Low limit of Y axis
  real(kind=8), intent(in) :: ay2  ! High limit of Y axis
  ! Local
  character(len=*), parameter :: rname='SETLIM'
  !
  gux1 = ax1
  gux2 = ax2
  guy1 = ay1
  guy2 = ay2
  !
  ! Make a stupid protection against Invalid LOG axis
  if (axis_xlog) then
    if (gux1.le.0 .or. gux2.le.0) then
      call greg_message(seve%w,rname,'Invalid X LOG axis, ignored')
      gux = (gx2-gx1)/(gux2-gux1)
    else
      lux = log(gux1)
      gux = (gx2-gx1)/(log(gux2)-lux)
    endif
  else
    gux = (gx2-gx1)/(gux2-gux1)
  endif
  !
  if (axis_ylog) then
    if (guy1.le.0 .or. guy2.le.0)  then
      call greg_message(seve%w,rname,'Invalid Y LOG axis, ignored')
      guy = (gy2-gy1)/(guy2-guy1)
    else
      luy = log(guy1)
      guy = (gy2-gy1)/(log(guy2)-luy)
    endif
  else
    guy = (gy2-gy1)/(guy2-guy1)
  endif
end subroutine setlim
!
subroutine limaut(name,logf,xmin,xmax,flag,x,n,y,bval,eval,error)
  use gildas_def
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !    Find maxima and minima of X array and set range to be plotted
  ! according to the logical into FLAG
  !---------------------------------------------------------------------
  character(len=*),          intent(in)    :: name     ! Axis name
  logical,                   intent(in)    :: logf     ! Log or linear axis?
  real(kind=8),              intent(inout) :: xmin     ! Minimum value
  real(kind=8),              intent(inout) :: xmax     ! Maximum value
  logical,                   intent(in)    :: flag(2)  ! Logicals for computing extrema
  real(kind=8),              intent(in)    :: x(*)     ! Array to search in
  integer(kind=size_length), intent(in)    :: n        ! Number of data points
  real(kind=8),              intent(in)    :: y(*)     ! Array of blank/non-blank values (used as mask for X array)
  real(kind=8),              intent(in)    :: bval     ! Blanking value
  real(kind=8),              intent(in)    :: eval     ! Blanking tolerance
  logical,                   intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LIMITS'
  real(kind=8) :: xmi,xma
  integer(kind=size_length) :: j,is,ne,in,nmi,nma,ntot
  character(len=message_length) :: mess
  !
  if (.not.flag(1) .and. .not.flag(2)) return
  if (n.lt.1)  return
  !
  if (eval.lt.0.0d0) then
    ! is protected against NaNs
    call gr8_minmax (n,x,bval,eval,xmi,xma,nmi,nma)
    ntot = n
  else
    in = 1
    ! FIND_BLANK8 is protected against NaNs when Blanking enabled
    call find_blank8(y,bval,eval,n,is,ne,in)
    if (ne.lt.1)  return
    ntot = ne
    !
    if (x(is).eq.x(is))then
      xmi = x(is)
      xma = x(is)
    else
      call gr8_minmax (n,x,bval,eval,xmi,xma,nmi,nma)
    endif
    do j=is,is+ne-1
      if (x(j).eq.x(j).and.x(j).lt.xmi) then
        xmi = x(j)
      elseif (x(j).eq.x(j).and.x(j).gt.xma) then
        xma = x(j)
      endif
    enddo
    do while (in.ne.0)
      call find_blank8(y,bval,eval,n,is,ne,in)
      ntot = ntot+ne
      do j=is,is+ne-1
        if (x(j).eq.x(j).and.x(j).lt.xmi) then
          xmi = x(j)
        elseif (x(j).eq.x(j).and.x(j).gt.xma) then
          xma = x(j)
        endif
      enddo
    enddo
  endif
  !
  if (flag(1))  xmin = xmi
  if (flag(2))  xmax = xma
  !
  if (logf) then
    if (xmin.le.0.d0 .or. xmax.le.0.d0) then
      call greg_message(seve%e,rname,'Invalid logarithmic limits in '//name)
      error = .true.
      return
    endif
  endif
  if (xmin.eq.xmax) then
    if (ntot.eq.1) then
      write(mess,'(A,A1,A)')  'No range in ',name,' (only 1 valid value in Y array)'
    else
      write(mess,'(A,A1)')  'No range in ',name
    endif
    call greg_message(seve%w,rname,mess)
  endif
  !
end subroutine limaut
!
subroutine limits_margin(name,logf,xl,xr,lmarg,rmarg,error)
  use gbl_message
  use greg_interfaces, except_this=>limits_margin
  !---------------------------------------------------------------------
  ! @ private
  !  Apply margins on the provided range
  !  NB: margin can be negative, i.e. truncate the [xl-xr] range
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: name         ! Axis name
  logical,          intent(in)    :: logf         ! Log or linear axis?
  real(kind=8),     intent(inout) :: xl,xr        ! Current (in) and new (out) values
  real(kind=8),     intent(in)    :: lmarg,rmarg  ! Left and right margins (fraction of [xl-max])
  logical,          intent(inout) :: error        !
  ! Local
  character(len=*), parameter :: rname='LIMITS'
  real(kind=8) :: xdiff
  !
  if (logf) then
    ! Log axis
    xdiff = log(xr/xl)
    if (xdiff.eq.0.d0)  xdiff = 1.  ! One decade
    xl = xl / exp(lmarg * xdiff)
    xr = xr * exp(rmarg * xdiff)
    !
  else
    ! Linear axis. NB: this is valid even if xl>xr
    xdiff = xr - xl
    if (xdiff.eq.0.d0) then
      xdiff = abs(xr)
      if (xdiff.eq.0.d0) xdiff = 1.d0
    endif
    !
    xl = xl - lmarg*xdiff
    xr = xr + rmarg*xdiff
  endif
  !
end subroutine limits_margin

*DECK S1MERG
      SUBROUTINE S1MERG (TCOS, I1, M1, I2, M2, I3)
C***BEGIN PROLOGUE  S1MERG
C***SUBSIDIARY
C***PURPOSE  Merge two strings of ascending real numbers.
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (S1MERG-S, D1MERG-D, C1MERG-C, I1MERG-I)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   This subroutine merges two ascending strings of numbers in the
C   array TCOS.  The first string is of length M1 and starts at
C   TCOS(I1+1).  The second string is of length M2 and starts at
C   TCOS(I2+1).  The merged string goes into TCOS(I3+1).
C
C***SEE ALSO  GENBUN
C***ROUTINES CALLED  SCOPY
C***REVISION HISTORY  (YYMMDD)
C   801001  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   901120  Modified to use IF-THEN-ELSE.  Previous spaghetti code did
C           not compile correctly with optimization on the IBM RS6000.
C           (RWC)
C   920130  Code name changed from MERGE to S1MERG.  (WRB)
C***END PROLOGUE  S1MERG
      INTEGER I1, I2, I3, M1, M2
      REAL TCOS(*)
C
      INTEGER J1, J2, J3
C
C***FIRST EXECUTABLE STATEMENT  S1MERG
      IF (M1.EQ.0 .AND. M2.EQ.0) RETURN
C
      IF (M1.EQ.0 .AND. M2.NE.0) THEN
         CALL SCOPY (M2, TCOS(I2+1), 1, TCOS(I3+1), 1)
         RETURN
      ENDIF
C
      IF (M1.NE.0 .AND. M2.EQ.0) THEN
         CALL SCOPY (M1, TCOS(I1+1), 1, TCOS(I3+1), 1)
         RETURN
      ENDIF
C
      J1 = 1
      J2 = 1
      J3 = 1
C
   10 IF (TCOS(I1+J1) .LE. TCOS(I2+J2)) THEN
         TCOS(I3+J3) = TCOS(I1+J1)
         J1 = J1+1
         IF (J1 .GT. M1) THEN
            CALL SCOPY (M2-J2+1, TCOS(I2+J2), 1, TCOS(I3+J3+1), 1)
            RETURN
         ENDIF
      ELSE
         TCOS(I3+J3) = TCOS(I2+J2)
         J2 = J2+1
         IF (J2 .GT. M2) THEN
            CALL SCOPY (M1-J1+1, TCOS(I1+J1), 1, TCOS(I3+J3+1), 1)
            RETURN
         ENDIF
      ENDIF
      J3 = J3+1
      GO TO 10
      END
*DECK SBCG
      SUBROUTINE SBCG (N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC,
     +   MSOLVE, MTSOLV, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT, R, Z,
     +   P, RR, ZZ, PP, DZ, RWORK, IWORK)
C***BEGIN PROLOGUE  SBCG
C***PURPOSE  Preconditioned BiConjugate Gradient Sparse Ax = b Solver.
C            Routine to solve a Non-Symmetric linear system  Ax = b
C            using the Preconditioned BiConjugate Gradient method.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  D2A4, D2B4
C***TYPE      SINGLE PRECISION (SBCG-S, DBCG-D)
C***KEYWORDS  BICONJUGATE GRADIENT, ITERATIVE PRECONDITION,
C             NON-SYMMETRIC LINEAR SYSTEM, SLAP, SPARSE
C***AUTHOR  Greenbaum, Anne, (Courant Institute)
C           Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C      INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, ITOL, ITMAX
C      INTEGER ITER, IERR, IUNIT, IWORK(USER DEFINED)
C      REAL    B(N), X(N), A(NELT), TOL, ERR, R(N), Z(N), P(N)
C      REAL    RR(N), ZZ(N), PP(N), DZ(N)
C      REAL    RWORK(USER DEFINED)
C      EXTERNAL MATVEC, MTTVEC, MSOLVE, MTSOLV
C
C      CALL SBCG(N, B, X, NELT, IA, JA, A, ISYM, MATVEC, MTTVEC,
C     $     MSOLVE, MTSOLV, ITOL, TOL, ITMAX, ITER, ERR, IERR, IUNIT,
C     $     R, Z, P, RR, ZZ, PP, DZ, RWORK, IWORK)
C
C *Arguments:
C N      :IN       Integer
C         Order of the Matrix.
C B      :IN       Real B(N).
C         Right-hand side vector.
C X      :INOUT    Real X(N).
C         On input X is your initial guess for solution vector.
C         On output X is the final approximate solution.
C NELT   :IN       Integer.
C         Number of Non-Zeros stored in A.
C IA     :IN       Integer IA(NELT).
C JA     :IN       Integer JA(NELT).
C A      :IN       Real A(NELT).
C         These arrays contain the matrix data structure for A.
C         It could take any form.  See "Description", below, for more
C         details.
C ISYM   :IN       Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the upper
C         or lower triangle of the matrix is stored.
C MATVEC :EXT      External.
C         Name of a routine which  performs the matrix vector multiply
C         operation  Y = A*X  given A and X.  The  name of  the MATVEC
C         routine must  be declared external  in the  calling program.
C         The calling sequence of MATVEC is:
C             CALL MATVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N is the number of unknowns, Y is the product A*X upon
C         return,  X is an input  vector.  NELT, IA,  JA,  A and  ISYM
C         define the SLAP matrix data structure: see Description,below.
C MTTVEC :EXT      External.
C         Name of a routine which performs the matrix transpose vector
C         multiply y = A'*X given A and X (where ' denotes transpose).
C         The name of the MTTVEC routine must be declared external  in
C         the calling program.  The calling sequence to MTTVEC is  the
C         same as that for MTTVEC, viz.:
C             CALL MTTVEC( N, X, Y, NELT, IA, JA, A, ISYM )
C         Where N  is the number  of unknowns, Y is the   product A'*X
C         upon return, X is an input vector.  NELT, IA, JA, A and ISYM
C         define the SLAP matrix data structure: see Description,below.
C MSOLVE :EXT      External.
C         Name of a routine which solves a linear system MZ = R  for Z
C         given R with the preconditioning matrix M (M is supplied via
C         RWORK  and IWORK arrays).   The name  of  the MSOLVE routine
C         must be declared  external  in the  calling   program.   The
C         calling sequence of MSOLVE is:
C             CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, R is  the right-hand side
C         vector, and Z is the solution upon return.  NELT,  IA, JA, A
C         and  ISYM define the SLAP  matrix  data structure: see
C         Description, below.  RWORK is a  real array that can be used
C         to  pass   necessary  preconditioning     information and/or
C         workspace to MSOLVE.  IWORK is an integer work array for the
C         same purpose as RWORK.
C MTSOLV :EXT      External.
C         Name of a routine which solves a linear system M'ZZ = RR for
C         ZZ given RR with the preconditioning matrix M (M is supplied
C         via RWORK and IWORK arrays).  The name of the MTSOLV routine
C         must be declared external in the calling program.  The call-
C         ing sequence to MTSOLV is:
C            CALL MTSOLV(N, RR, ZZ, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C         Where N is the number of unknowns, RR is the right-hand side
C         vector, and ZZ is the solution upon return.  NELT, IA, JA, A
C         and  ISYM define the SLAP  matrix  data structure: see
C         Description, below.  RWORK is a  real array that can be used
C         to  pass   necessary  preconditioning     information and/or
C         workspace to MTSOLV.  IWORK is an integer work array for the
C         same purpose as RWORK.
C ITOL   :IN       Integer.
C         Flag to indicate type of convergence criterion.
C         If ITOL=1, iteration stops when the 2-norm of the residual
C         divided by the 2-norm of the right-hand side is less than TOL.
C         If ITOL=2, iteration stops when the 2-norm of M-inv times the
C         residual divided by the 2-norm of M-inv times the right hand
C         side is less than TOL, where M-inv is the inverse of the
C         diagonal of A.
C         ITOL=11 is often useful for checking and comparing different
C         routines.  For this case, the user must supply the "exact"
C         solution or a very accurate approximation (one with an error
C         much less than TOL) through a common block,
C             COMMON /SSLBLK/ SOLN( )
C         If ITOL=11, iteration stops when the 2-norm of the difference
C         between the iterative approximation and the user-supplied
C         solution divided by the 2-norm of the user-supplied solution
C         is less than TOL.  Note that this requires the user to set up
C         the "COMMON /SSLBLK/ SOLN(LENGTH)" in the calling routine.
C         The routine with this declaration should be loaded before the
C         stop test so that the correct length is used by the loader.
C         This procedure is not standard Fortran and may not work
C         correctly on your system (although it has worked on every
C         system the authors have tried).  If ITOL is not 11 then this
C         common block is indeed standard Fortran.
C TOL    :INOUT    Real.
C         Convergence criterion, as described above.  (Reset if IERR=4.)
C ITMAX  :IN       Integer.
C         Maximum number of iterations.
C ITER   :OUT      Integer.
C         Number of iterations required to reach convergence, or
C         ITMAX+1 if convergence criterion could not be achieved in
C         ITMAX iterations.
C ERR    :OUT      Real.
C         Error estimate of error in final approximate solution, as
C         defined by ITOL.
C IERR   :OUT      Integer.
C         Return error flag.
C           IERR = 0 => All went well.
C           IERR = 1 => Insufficient space allocated for WORK or IWORK.
C           IERR = 2 => Method failed to converge in ITMAX steps.
C           IERR = 3 => Error in user input.
C                       Check input values of N, ITOL.
C           IERR = 4 => User error tolerance set too tight.
C                       Reset to 500*R1MACH(3).  Iteration proceeded.
C           IERR = 5 => Preconditioning matrix, M, is not positive
C                       definite.  (r,z) < 0.
C           IERR = 6 => Matrix A is not positive definite.  (p,Ap) < 0.
C IUNIT  :IN       Integer.
C         Unit number on which to write the error at each iteration,
C         if this is desired for monitoring convergence.  If unit
C         number is 0, no writing will occur.
C R      :WORK     Real R(N).
C Z      :WORK     Real Z(N).
C P      :WORK     Real P(N).
C RR     :WORK     Real RR(N).
C ZZ     :WORK     Real ZZ(N).
C PP     :WORK     Real PP(N).
C DZ     :WORK     Real DZ(N).
C         Real arrays used for workspace.
C RWORK  :WORK     Real RWORK(USER DEFINED).
C         Real array that can be used for workspace in MSOLVE
C         and MTSOLV.
C IWORK  :WORK     Integer IWORK(USER DEFINED).
C         Integer array that can be used for workspace in MSOLVE
C         and MTSOLV.
C
C *Description
C      This routine does not care what matrix data structure is used
C       for A and M.  It simply calls MATVEC, MTTVEC, MSOLVE, MTSOLV
C       routines, with arguments as above.  The user could write any
C       type of structure, and  appropriate  MATVEC, MSOLVE, MTTVEC,
C       and MTSOLV routines.  It  is assumed that A is stored in the
C       IA, JA, A  arrays in some fashion and  that M (or INV(M)) is
C       stored  in  IWORK  and  RWORK   in  some fashion.   The SLAP
C       routines SSDBCG and SSLUBC are examples of this procedure.
C
C       Two  examples  of  matrix  data structures  are the: 1) SLAP
C       Triad  format and 2) SLAP Column format.
C
C       =================== S L A P Triad format ===================
C       In  this   format only the  non-zeros are  stored.  They may
C       appear  in *ANY* order.   The user  supplies three arrays of
C       length NELT, where  NELT  is the number  of non-zeros in the
C       matrix:  (IA(NELT), JA(NELT),  A(NELT)).  For each  non-zero
C       the  user puts   the row  and  column index   of that matrix
C       element in the IA and JA arrays.  The  value of the non-zero
C       matrix  element is  placed in  the corresponding location of
C       the A  array.  This is  an extremely easy data  structure to
C       generate.  On  the other hand it  is  not too  efficient  on
C       vector  computers   for the  iterative  solution  of  linear
C       systems.  Hence, SLAP  changes this input  data structure to
C       the SLAP   Column  format for the  iteration (but   does not
C       change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C       =================== S L A P Column format ==================
C
C       In  this format   the non-zeros are    stored counting  down
C       columns (except  for the diagonal  entry, which must  appear
C       first in each "column") and are  stored in the real array A.
C       In other words,  for  each column    in the matrix   put the
C       diagonal  entry  in A.   Then   put  in the  other  non-zero
C       elements going   down the  column (except  the  diagonal) in
C       order.  The IA array holds the row index  for each non-zero.
C       The JA array holds the offsets into the IA, A arrays for the
C       beginning   of   each  column.      That is,   IA(JA(ICOL)),
C       A(JA(ICOL)) points to the beginning of the ICOL-th column in
C       IA and  A.  IA(JA(ICOL+1)-1), A(JA(ICOL+1)-1)  points to the
C       end of the ICOL-th column.  Note that we always have JA(N+1)
C       = NELT+1, where N is the number of columns in the matrix and
C       NELT is the number of non-zeros in the matrix.
C
C       Here is an example of the  SLAP Column  storage format for a
C       5x5 Matrix (in the A and IA arrays '|'  denotes the end of a
C       column):
C
C           5x5 Matrix      SLAP Column format for 5x5 matrix on left.
C                              1  2  3    4  5    6  7    8    9 10 11
C       |11 12  0  0 15|   A: 11 21 51 | 22 12 | 33 53 | 44 | 55 15 35
C       |21 22  0  0  0|  IA:  1  2  5 |  2  1 |  3  5 |  4 |  5  1  3
C       | 0  0 33  0 35|  JA:  1  4  6    8  9   12
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Cautions:
C     This routine will attempt to write to the Fortran logical output
C     unit IUNIT, if IUNIT .ne. 0.  Thus, the user must make sure that
C     this logical unit is attached to a file or terminal before calling
C     this routine with a non-zero value for IUNIT.  This routine does
C     not check for the validity of a non-zero IUNIT unit number.
C
C***SEE ALSO  SSDBCG, SSLUBC
C***REFERENCES  1. Mark K. Seager, A SLAP for the Masses, in
C                  G. F. Carey, Ed., Parallel Supercomputing: Methods,
C                  Algorithms and Applications, Wiley, 1989, pp.135-155.
C***ROUTINES CALLED  ISSBCG, R1MACH, SAXPY, SCOPY, SDOT
C***REVISION HISTORY  (YYMMDD)
C   871119  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890921  Removed TeX from comments.  (FNF)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   891004  Added new reference.
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   910502  Removed MATVEC, MTTVEC, MSOLVE, MTSOLV from ROUTINES
C           CALLED list.  (FNF)
C   920407  COMMON BLOCK renamed SSLBLK.  (WRB)
C   920511  Added complete declaration section.  (WRB)
C   920929  Corrected format of reference.  (FNF)
C   921019  Changed 500.0 to 500 to reduce SP/DP differences.  (FNF)
C   921113  Corrected C***CATEGORY line.  (FNF)
C***END PROLOGUE  SBCG
C     .. Scalar Arguments ..
      REAL ERR, TOL
      INTEGER IERR, ISYM, ITER, ITMAX, ITOL, IUNIT, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), B(N), DZ(N), P(N), PP(N), R(N), RR(N), RWORK(*),
     +     X(N), Z(N), ZZ(N)
      INTEGER IA(NELT), IWORK(*), JA(NELT)
C     .. Subroutine Arguments ..
      EXTERNAL MATVEC, MSOLVE, MTSOLV, MTTVEC
C     .. Local Scalars ..
      REAL AK, AKDEN, BK, BKDEN, BKNUM, BNRM, FUZZ, SOLNRM, TOLMIN
      INTEGER I, K
C     .. External Functions ..
      REAL R1MACH, SDOT
      INTEGER ISSBCG
      EXTERNAL R1MACH, SDOT, ISSBCG
C     .. External Subroutines ..
      EXTERNAL SAXPY, SCOPY
C     .. Intrinsic Functions ..
      INTRINSIC ABS
C***FIRST EXECUTABLE STATEMENT  SBCG
C
C         Check some of the input data.
C
      ITER = 0
      IERR = 0
      IF( N.LT.1 ) THEN
         IERR = 3
         RETURN
      ENDIF
      FUZZ = R1MACH(3)
      TOLMIN = 500*FUZZ
      FUZZ = FUZZ*FUZZ
      IF( TOL.LT.TOLMIN ) THEN
         TOL = TOLMIN
         IERR = 4
      ENDIF
C
C         Calculate initial residual and pseudo-residual, and check
C         stopping criterion.
      CALL MATVEC(N, X, R, NELT, IA, JA, A, ISYM)
      DO 10 I = 1, N
         R(I)  = B(I) - R(I)
         RR(I) = R(I)
 10   CONTINUE
      CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
      CALL MTSOLV(N, RR, ZZ, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
      IF( ISSBCG(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $     ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, RR, ZZ, PP,
     $     DZ, RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 )
     $     GO TO 200
      IF( IERR.NE.0 ) RETURN
C
C         ***** iteration loop *****
C
      DO 100 K=1,ITMAX
         ITER = K
C
C         Calculate coefficient BK and direction vectors P and PP.
         BKNUM = SDOT(N, Z, 1, RR, 1)
         IF( ABS(BKNUM).LE.FUZZ ) THEN
            IERR = 6
            RETURN
         ENDIF
         IF(ITER .EQ. 1) THEN
            CALL SCOPY(N, Z, 1, P, 1)
            CALL SCOPY(N, ZZ, 1, PP, 1)
         ELSE
            BK = BKNUM/BKDEN
            DO 20 I = 1, N
               P(I) = Z(I) + BK*P(I)
               PP(I) = ZZ(I) + BK*PP(I)
 20         CONTINUE
         ENDIF
         BKDEN = BKNUM
C
C         Calculate coefficient AK, new iterate X, new residuals R and
C         RR, and new pseudo-residuals Z and ZZ.
         CALL MATVEC(N, P, Z, NELT, IA, JA, A, ISYM)
         AKDEN = SDOT(N, PP, 1, Z, 1)
         AK = BKNUM/AKDEN
         IF( ABS(AKDEN).LE.FUZZ ) THEN
            IERR = 6
            RETURN
         ENDIF
         CALL SAXPY(N, AK, P, 1, X, 1)
         CALL SAXPY(N, -AK, Z, 1, R, 1)
         CALL MTTVEC(N, PP, ZZ, NELT, IA, JA, A, ISYM)
         CALL SAXPY(N, -AK, ZZ, 1, RR, 1)
         CALL MSOLVE(N, R, Z, NELT, IA, JA, A, ISYM, RWORK, IWORK)
         CALL MTSOLV(N, RR, ZZ, NELT, IA, JA, A, ISYM, RWORK, IWORK)
C
C         check stopping criterion.
         IF( ISSBCG(N, B, X, NELT, IA, JA, A, ISYM, MSOLVE, ITOL, TOL,
     $        ITMAX, ITER, ERR, IERR, IUNIT, R, Z, P, RR, ZZ,
     $        PP, DZ, RWORK, IWORK, AK, BK, BNRM, SOLNRM) .NE. 0 )
     $        GO TO 200
C
 100  CONTINUE
C
C         *****   end of loop  *****
C
C         stopping criterion not satisfied.
      ITER = ITMAX + 1
      IERR = 2
C
 200  RETURN
C------------- LAST LINE OF SBCG FOLLOWS ----------------------------
      END
*DECK SBHIN
      SUBROUTINE SBHIN (N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB)
C***BEGIN PROLOGUE  SBHIN
C***PURPOSE  Read a Sparse Linear System in the Boeing/Harwell Format.
C            The matrix is read in and if the right hand side is also
C            present in the input file then it too is read in.  The
C            matrix is then modified to be in the SLAP Column format.
C***LIBRARY   SLATEC (SLAP)
C***CATEGORY  N1
C***TYPE      SINGLE PRECISION (SBHIN-S, DBHIN-D)
C***KEYWORDS  LINEAR SYSTEM, MATRIX READ, SLAP SPARSE
C***AUTHOR  Seager, Mark K., (LLNL)
C             Lawrence Livermore National Laboratory
C             PO BOX 808, L-60
C             Livermore, CA 94550 (510) 423-3141
C             seager@llnl.gov
C***DESCRIPTION
C
C *Usage:
C     INTEGER N, NELT, IA(NELT), JA(NELT), ISYM, IUNIT, JOB
C     REAL    A(NELT), SOLN(N), RHS(N)
C
C     CALL SBHIN( N, NELT, IA, JA, A, ISYM, SOLN, RHS, IUNIT, JOB )
C
C *Arguments:
C N      :OUT      Integer
C         Order of the Matrix.
C NELT   :INOUT    Integer.
C         On input NELT is the maximum number of non-zeros that
C         can be stored in the IA, JA, A arrays.
C         On output NELT is the number of non-zeros stored in A.
C IA     :OUT      Integer IA(NELT).
C JA     :OUT      Integer JA(NELT).
C A      :OUT      Real A(NELT).
C         On output these arrays hold the matrix A in the SLAP
C         Triad format.  See "Description", below.
C ISYM   :OUT      Integer.
C         Flag to indicate symmetric storage format.
C         If ISYM=0, all non-zero entries of the matrix are stored.
C         If ISYM=1, the matrix is symmetric, and only the lower
C         triangle of the matrix is stored.
C SOLN   :OUT      Real SOLN(N).
C         The solution to the linear system, if present.  This array
C         is accessed if and only if JOB is set to read it in, see
C         below.  If the user requests that SOLN be read in, but it is
C         not in the file, then it is simply zeroed out.
C RHS    :OUT      Real RHS(N).
C         The right hand side vector.  This array is accessed if and
C         only if JOB is set to read it in, see below.
C         If the user requests that RHS be read in, but it is not in
C         the file, then it is simply zeroed out.
C IUNIT  :IN       Integer.
C         Fortran logical I/O device unit number to read the matrix
C         from.  This unit must be connected in a system dependent
C         fashion to a file, or you will get a nasty message
C         from the Fortran I/O libraries.
C JOB    :INOUT    Integer.
C         Flag indicating what I/O operations to perform.
C         On input JOB indicates what Input operations to try to
C         perform.
C         JOB = 0 => Read only the matrix.
C         JOB = 1 => Read matrix and RHS (if present).
C         JOB = 2 => Read matrix and SOLN (if present).
C         JOB = 3 => Read matrix, RHS and SOLN (if present).
C         On output JOB indicates what operations were actually
C         performed.
C         JOB = -3 => Unable to parse matrix "CODE" from input file
C                     to determine if only the lower triangle of matrix
C                     is stored.
C         JOB = -2 => Number of non-zeros (NELT) too large.
C         JOB = -1 => System size (N) too large.
C         JOB =  0 => Read in only the matrix.
C         JOB =  1 => Read in the matrix and RHS.
C         JOB =  2 => Read in the matrix and SOLN.
C         JOB =  3 => Read in the matrix, RHS and SOLN.
C         JOB = 10 => Read in only the matrix *STRUCTURE*, but no
C                     non-zero entries.  Hence, A(*) is not referenced
C                     and has the return values the same as the input.
C         JOB = 11 => Read in the matrix *STRUCTURE* and RHS.
C         JOB = 12 => Read in the matrix *STRUCTURE* and SOLN.
C         JOB = 13 => Read in the matrix *STRUCTURE*, RHS and SOLN.
C
C *Description:
C       The format for the input is as follows.  The first line contains
C       a title to identify the data file.  On the second line (5I4) are
C       counters: NLINE, NPLS, NRILS, NNVLS, NRHSLS.
C        NLINE  Number of data lines (after the header) in the file.
C        NPLS   Number of lines for the Column Pointer data in the file.
C        NRILS  Number of lines for the Row indices in the file.
C        NNVLS  Number of lines for the Matrix elements in the file.
C        NRHSLS Number of lines for the RHS in the file.
C       The third line (A3,11X,4I4) contains a symmetry code and some
C       additional counters: CODE, NROW, NCOL, NIND, NELE.
C       On the fourth line (2A16,2A20) are formats to be used to read
C       the following data: PNTFNT, RINFMT, NVLFMT, RHSFMT.
C       Following that are the blocks of data in the order indicated.
C
C       =================== S L A P Triad format ===================
C       This routine requires that the  matrix A be   stored in  the
C       SLAP  Triad format.  In  this format only the non-zeros  are
C       stored.  They may appear in  *ANY* order.  The user supplies
C       three arrays of  length NELT, where  NELT is  the number  of
C       non-zeros in the matrix: (IA(NELT), JA(NELT), A(NELT)).  For
C       each non-zero the user puts the row and column index of that
C       matrix element  in the IA and  JA arrays.  The  value of the
C       non-zero  matrix  element is  placed   in  the corresponding
C       location of the A array.   This is  an  extremely  easy data
C       structure to generate.  On  the  other hand it   is  not too
C       efficient on vector computers for  the iterative solution of
C       linear systems.  Hence,   SLAP changes   this  input    data
C       structure to the SLAP Column format  for  the iteration (but
C       does not change it back).
C
C       Here is an example of the  SLAP Triad   storage format for a
C       5x5 Matrix.  Recall that the entries may appear in any order.
C
C           5x5 Matrix      SLAP Triad format for 5x5 matrix on left.
C                              1  2  3  4  5  6  7  8  9 10 11
C       |11 12  0  0 15|   A: 51 12 11 33 15 53 55 22 35 44 21
C       |21 22  0  0  0|  IA:  5  1  1  3  1  5  5  2  3  4  2
C       | 0  0 33  0 35|  JA:  1  2  1  3  5  3  5  2  5  4  1
C       | 0  0  0 44  0|
C       |51  0 53  0 55|
C
C *Portability:
C         You must make sure that IUNIT is a valid Fortran logical
C         I/O device unit number and that the unit number has been
C         associated with a file or the console.  This is a system
C         dependent function.
C
C *Implementation note:
C         SOLN is not read by this version.  It will simply be
C         zeroed out if JOB = 2 or 3 and the returned value of
C         JOB will indicate SOLN has not been read.
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   881107  DATE WRITTEN
C   881213  Previous REVISION DATE
C   890915  Made changes requested at July 1989 CML Meeting.  (MKS)
C   890922  Numerous changes to prologue to make closer to SLATEC
C           standard.  (FNF)
C   890929  Numerous changes to reduce SP/DP differences.  (FNF)
C   910411  Prologue converted to Version 4.0 format.  (BAB)
C   911122  Added loop to zero out RHS if user wants to read RHS, but
C           it's not in the input file. (MKS)
C   911125  Minor improvements to prologue.  (FNF)
C   920511  Added complete declaration section.  (WRB)
C   921007  Corrected description of input format.  (FNF)
C   921208  Added Implementation Note and code to zero out SOLN.  (FNF)
C   930701  Updated CATEGORY section.  (FNF, WRB)
C***END PROLOGUE  SBHIN
C     .. Scalar Arguments ..
      INTEGER ISYM, IUNIT, JOB, N, NELT
C     .. Array Arguments ..
      REAL A(NELT), RHS(N), SOLN(N)
      INTEGER IA(NELT), JA(NELT)
C     .. Local Scalars ..
      REAL TEMP
      INTEGER I, IBGN, ICOL, IEND, ITEMP, J, JOBRET, NCOL, NELE, NIND,
     +        NLINE, NNVLS, NPLS, NRHSLS, NRILS, NROW
      CHARACTER CODE*3, PNTFMT*16, RINFMT*16, NVLFMT*20, RHSFMT*20,
     +          TITLE*80
C     .. Intrinsic Functions ..
      INTRINSIC MOD
C***FIRST EXECUTABLE STATEMENT  SBHIN
C
C         Read Matrices In BOEING-HARWELL format.
C
C TITLE  Header line to identify data file.
C NLINE  Number of data lines (after the header) in the file.
C NPLS   Number of lines for the Column Pointer data in the file.
C NRILS  Number of lines for the Row indices in the data file.
C NNVLS  Number of lines for the Matrix elements in the data file.
C NRHSLS Number of lines for the RHS in the data file.
C ---- Only those variables needed by SLAP are referenced. ----
C
      READ(IUNIT,9000) TITLE
      READ(IUNIT,9010) NLINE, NPLS, NRILS, NNVLS, NRHSLS
      READ(IUNIT,9020) CODE, NROW, NCOL, NIND, NELE
      READ(IUNIT,9030) PNTFMT, RINFMT, NVLFMT, RHSFMT
C
      IF( NROW.GT.N ) THEN
         N = NROW
         JOBRET = -1
         GOTO 999
      ENDIF
      IF( NIND.GT.NELT ) THEN
         NELT = NIND
         JOBRET = -2
         GOTO 999
      ENDIF
C
C         Set the parameters.
C
      N    = NROW
      NELT = NIND
      IF( CODE.EQ.'RUA' ) THEN
         ISYM = 0
      ELSE IF( CODE.EQ.'RSA' ) THEN
         ISYM = 1
      ELSE
         JOBRET = -3
         GOTO 999
      ENDIF
      READ(IUNIT,PNTFMT) (JA(I), I = 1, N+1)
      READ(IUNIT,RINFMT) (IA(I), I = 1, NELT)
      JOBRET = 10
      IF( NNVLS.GT.0 ) THEN
         READ(IUNIT,NVLFMT) (A(I),  I = 1, NELT)
         JOBRET = 0
      ENDIF
      IF( MOD(JOB,2).EQ.1 ) THEN
C
C         User requests that the RHS be read in.  If it is in the input
C         file, read it in; otherwise just zero it out.
C
         IF( NRHSLS.GT.0 ) THEN
            READ(5,RHSFMT) (RHS(I), I = 1, N)
            JOBRET = JOBRET + 1
         ELSE
            DO 10 I = 1, N
               RHS(I) = 0
 10         CONTINUE
         ENDIF
      ENDIF
      IF ( (JOB.EQ.2).OR.(JOB.EQ.3) ) THEN
C
C         User requests that the SOLN be read in.
C         Just zero out the array.
C
         DO 20 I = 1, N
            SOLN(I) = 0
 20      CONTINUE
      ENDIF
C
C         Now loop through the IA array making sure that the diagonal
C         matrix element appears first in the column.  Then sort the
C         rest of the column in ascending order.
C
CVD$R NOCONCUR
CVD$R NOVECTOR
      DO 70 ICOL = 1, N
         IBGN = JA(ICOL)
         IEND = JA(ICOL+1)-1
         DO 30 I = IBGN, IEND
            IF( IA(I).EQ.ICOL ) THEN
C
C              Swap the diagonal element with the first element in the
C              column.
C
               ITEMP = IA(I)
               IA(I) = IA(IBGN)
               IA(IBGN) = ITEMP
               TEMP = A(I)
               A(I) = A(IBGN)
               A(IBGN) = TEMP
               GOTO 40
            ENDIF
 30      CONTINUE
 40      IBGN = IBGN + 1
         IF( IBGN.LT.IEND ) THEN
            DO 60 I = IBGN, IEND
               DO 50 J = I+1, IEND
                  IF( IA(I).GT.IA(J) ) THEN
                     ITEMP = IA(I)
                     IA(I) = IA(J)
                     IA(J) = ITEMP
                     TEMP = A(I)
                     A(I) = A(J)
                     A(J) = TEMP
                  ENDIF
 50            CONTINUE
 60         CONTINUE
         ENDIF
 70   CONTINUE
C
C         Set return flag.
 999  JOB = JOBRET
      RETURN
 9000 FORMAT( A80 )
 9010 FORMAT( 5I14 )
 9020 FORMAT( A3, 11X, 4I14 )
 9030 FORMAT( 2A16, 2A20 )
C------------- LAST LINE OF SBHIN FOLLOWS ------------------------------
      END
*DECK SBOCLS
      SUBROUTINE SBOCLS (W, MDW, MCON, MROWS, NCOLS, BL, BU, IND, IOPT,
     +   X, RNORMC, RNORM, MODE, RW, IW)
C***BEGIN PROLOGUE  SBOCLS
C***PURPOSE  Solve the bounded and constrained least squares
C            problem consisting of solving the equation
C                      E*X = F  (in the least squares sense)
C             subject to the linear constraints
C                            C*X = Y.
C***LIBRARY   SLATEC
C***CATEGORY  K1A2A, G2E, G2H1, G2H2
C***TYPE      SINGLE PRECISION (SBOCLS-S, DBOCLS-D)
C***KEYWORDS  BOUNDS, CONSTRAINTS, INEQUALITY, LEAST SQUARES, LINEAR
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     This subprogram solves the bounded and constrained least squares
C     problem. The problem statement is:
C
C     Solve E*X = F (least squares sense), subject to constraints
C     C*X=Y.
C
C     In this formulation both X and Y are unknowns, and both may
C     have bounds on any of their components.  This formulation
C     of the problem allows the user to have equality and inequality
C     constraints as well as simple bounds on the solution components.
C
C     This constrained linear least squares subprogram solves E*X=F
C     subject to C*X=Y, where E is MROWS by NCOLS, C is MCON by NCOLS.
C
C      The user must have dimension statements of the form
C
C      DIMENSION W(MDW,NCOLS+MCON+1), BL(NCOLS+MCON), BU(NCOLS+MCON),
C     * X(2*(NCOLS+MCON)+2+NX), RW(6*NCOLS+5*MCON)
C       INTEGER IND(NCOLS+MCON), IOPT(17+NI), IW(2*(NCOLS+MCON))
C
C     (here NX=number of extra locations required for the options; NX=0
C     if no options are in use. Also NI=number of extra locations
C     for options 1-9.)
C
C    INPUT
C    -----
C
C    -------------------------
C    W(MDW,*),MCON,MROWS,NCOLS
C    -------------------------
C     The array W contains the (possibly null) matrix [C:*] followed by
C     [E:F].  This must be placed in W as follows:
C          [C  :  *]
C     W  = [       ]
C          [E  :  F]
C     The (*) after C indicates that this data can be undefined. The
C     matrix [E:F] has MROWS rows and NCOLS+1 columns. The matrix C is
C     placed in the first MCON rows of W(*,*) while [E:F]
C     follows in rows MCON+1 through MCON+MROWS of W(*,*). The vector F
C     is placed in rows MCON+1 through MCON+MROWS, column NCOLS+1. The
C     values of MDW and NCOLS must be positive; the value of MCON must
C     be nonnegative. An exception to this occurs when using option 1
C     for accumulation of blocks of equations. In that case MROWS is an
C     OUTPUT variable only, and the matrix data for [E:F] is placed in
C     W(*,*), one block of rows at a time. See IOPT(*) contents, option
C     number 1, for further details. The row dimension, MDW, of the
C     array W(*,*) must satisfy the inequality:
C
C     If using option 1,
C                     MDW .ge. MCON + max(max. number of
C                     rows accumulated, NCOLS) + 1.
C     If using option 8,
C                     MDW .ge. MCON + MROWS.
C     Else
C                     MDW .ge. MCON + max(MROWS, NCOLS).
C
C     Other values are errors, but this is checked only when using
C     option=2.  The value of MROWS is an output parameter when
C     using option number 1 for accumulating large blocks of least
C     squares equations before solving the problem.
C     See IOPT(*) contents for details about option 1.
C
C    ------------------
C    BL(*),BU(*),IND(*)
C    ------------------
C     These arrays contain the information about the bounds that the
C     solution values are to satisfy. The value of IND(J) tells the
C     type of bound and BL(J) and BU(J) give the explicit values for
C     the respective upper and lower bounds on the unknowns X and Y.
C     The first NVARS entries of IND(*), BL(*) and BU(*) specify
C     bounds on X; the next MCON entries specify bounds on Y.
C
C    1.    For IND(J)=1, require X(J) .ge. BL(J);
C          IF J.gt.NCOLS,        Y(J-NCOLS) .ge. BL(J).
C          (the value of BU(J) is not used.)
C    2.    For IND(J)=2, require X(J) .le. BU(J);
C          IF J.gt.NCOLS,        Y(J-NCOLS) .le. BU(J).
C          (the value of BL(J) is not used.)
C    3.    For IND(J)=3, require X(J) .ge. BL(J) and
C                                X(J) .le. BU(J);
C          IF J.gt.NCOLS,        Y(J-NCOLS) .ge. BL(J) and
C                                Y(J-NCOLS) .le. BU(J).
C          (to impose equality constraints have BL(J)=BU(J)=
C          constraining value.)
C    4.    For IND(J)=4, no bounds on X(J) or Y(J-NCOLS) are required.
C          (the values of BL(J) and BU(J) are not used.)
C
C     Values other than 1,2,3 or 4 for IND(J) are errors. In the case
C     IND(J)=3 (upper and lower bounds) the condition BL(J) .gt. BU(J)
C     is  an  error.   The values BL(J), BU(J), J .gt. NCOLS, will be
C     changed.  Significant changes mean that the constraints are
C     infeasible.  (Users must make this decision themselves.)
C     The new values for BL(J), BU(J), J .gt. NCOLS, define a
C     region such that the perturbed problem is feasible.  If users
C     know that their problem is feasible, this step can be skipped
C     by using option number 8 described below.
C
C     See IOPT(*) description.
C
C
C    -------
C    IOPT(*)
C    -------
C     This is the array where the user can specify nonstandard options
C     for SBOCLS( ). Most of the time this feature can be ignored by
C     setting the input value IOPT(1)=99. Occasionally users may have
C     needs that require use of the following subprogram options. For
C     details about how to use the options see below: IOPT(*) CONTENTS.
C
C     Option Number   Brief Statement of Purpose
C     ------ ------   ----- --------- -- -------
C           1         Return to user for accumulation of blocks
C                     of least squares equations.  The values
C                     of IOPT(*) are changed with this option.
C                     The changes are updates to pointers for
C                     placing the rows of equations into position
C                     for processing.
C           2         Check lengths of all arrays used in the
C                     subprogram.
C           3         Column scaling of the data matrix, [C].
C                                                        [E]
C           4         User provides column scaling for matrix [C].
C                                                             [E]
C           5         Provide option array to the low-level
C                     subprogram SBOLS( ).
C           6         Provide option array to the low-level
C                     subprogram SBOLSM( ).
C           7         Move the IOPT(*) processing pointer.
C           8         Do not preprocess the constraints to
C                     resolve infeasibilities.
C           9         Do not pretriangularize the least squares matrix.
C          99         No more options to change.
C
C    ----
C    X(*)
C    ----
C     This array is used to pass data associated with options 4,5 and
C     6. Ignore this parameter (on input) if no options are used.
C     Otherwise see below: IOPT(*) CONTENTS.
C
C
C    OUTPUT
C    ------
C
C    -----------------
C    X(*),RNORMC,RNORM
C    -----------------
C     The array X(*) contains a solution (if MODE .ge.0 or .eq.-22) for
C     the constrained least squares problem. The value RNORMC is the
C     minimum residual vector length for the constraints C*X - Y = 0.
C     The value RNORM is the minimum residual vector length for the
C     least squares equations. Normally RNORMC=0, but in the case of
C     inconsistent constraints this value will be nonzero.
C     The values of X are returned in the first NVARS entries of X(*).
C     The values of Y are returned in the last MCON entries of X(*).
C
C    ----
C    MODE
C    ----
C     The sign of MODE determines whether the subprogram has completed
C     normally, or encountered an error condition or abnormal status. A
C     value of MODE .ge. 0 signifies that the subprogram has completed
C     normally. The value of mode (.ge. 0) is the number of variables
C     in an active status: not at a bound nor at the value zero, for
C     the case of free variables. A negative value of MODE will be one
C     of the cases (-57)-(-41), (-37)-(-22), (-19)-(-2). Values .lt. -1
C     correspond to an abnormal completion of the subprogram. These
C     error messages are in groups for the subprograms SBOCLS(),
C     SBOLSM(), and SBOLS().  An approximate solution will be returned
C     to the user only when max. iterations is reached, MODE=-22.
C
C    -----------
C    RW(*),IW(*)
C    -----------
C     These are working arrays.  (normally the user can ignore the
C     contents of these arrays.)
C
C    IOPT(*) CONTENTS
C    ------- --------
C     The option array allows a user to modify some internal variables
C     in the subprogram without recompiling the source code. A central
C     goal of the initial software design was to do a good job for most
C     people. Thus the use of options will be restricted to a select
C     group of users. The processing of the option array proceeds as
C     follows: a pointer, here called LP, is initially set to the value
C     1. At the pointer position the option number is extracted and
C     used for locating other information that allows for options to be
C     changed. The portion of the array IOPT(*) that is used for each
C     option is fixed; the user and the subprogram both know how many
C     locations are needed for each option. The value of LP is updated
C     for each option based on the amount of storage in IOPT(*) that is
C     required. A great deal of error checking is done by the
C     subprogram on the contents of the option array. Nevertheless it
C     is still possible to give the subprogram optional input that is
C     meaningless. For example option 4 uses the locations
C     X(NCOLS+IOFF),...,X(NCOLS+IOFF+NCOLS-1) for passing scaling data.
C     The user must manage the allocation of these locations.
C
C   1
C   -
C     This option allows the user to solve problems with a large number
C     of rows compared to the number of variables. The idea is that the
C     subprogram returns to the user (perhaps many times) and receives
C     new least squares equations from the calling program unit.
C     Eventually the user signals "that's all" and a solution is then
C     computed. The value of MROWS is an output variable when this
C     option is used. Its value is always in the range 0 .le. MROWS
C     .le. NCOLS+1. It is the number of rows after the
C     triangularization of the entire set of equations. If LP is the
C     processing pointer for IOPT(*), the usage for the sequential
C     processing of blocks of equations is
C
C
C        IOPT(LP)=1
C         Move block of equations to W(*,*) starting at
C         the first row of W(*,*).
C        IOPT(LP+3)=# of rows in the block; user defined
C
C     The user now calls SBOCLS( ) in a loop. The value of IOPT(LP+1)
C     directs the user's action. The value of IOPT(LP+2) points to
C     where the subsequent rows are to be placed in W(*,*). Both of
C     these values are first defined in the subprogram. The user
C     changes the value of IOPT(LP+1) (to 2) as a signal that all of
C     the rows have been processed.
C
C
C      .<LOOP
C      . CALL SBOCLS( )
C      . IF(IOPT(LP+1) .EQ. 1) THEN
C      .    IOPT(LP+3)=# OF ROWS IN THE NEW BLOCK; USER DEFINED
C      .    PLACE NEW BLOCK OF IOPT(LP+3) ROWS IN
C      .    W(*,*) STARTING AT ROW MCON + IOPT(LP+2).
C      .
C      .    IF( THIS IS THE LAST BLOCK OF EQUATIONS ) THEN
C      .       IOPT(LP+1)=2
C      .<------CYCLE LOOP
C      .    ELSE IF (IOPT(LP+1) .EQ. 2) THEN
C      <-------EXIT LOOP SOLUTION COMPUTED IF MODE .GE. 0
C      . ELSE
C      . ERROR CONDITION; SHOULD NOT HAPPEN.
C      .<END LOOP
C
C     Use of this option adds 4 to the required length of IOPT(*).
C
C   2
C   -
C     This option is useful for checking the lengths of all arrays used
C     by SBOCLS( ) against their actual requirements for this problem.
C     The idea is simple: the user's program unit passes the declared
C     dimension information of the arrays. These values are compared
C     against the problem-dependent needs within the subprogram. If any
C     of the dimensions are too small an error message is printed and a
C     negative value of MODE is returned, -41 to -47. The printed error
C     message tells how long the dimension should be. If LP is the
C     processing pointer for IOPT(*),
C
C        IOPT(LP)=2
C        IOPT(LP+1)=Row dimension of W(*,*)
C        IOPT(LP+2)=Col. dimension of W(*,*)
C        IOPT(LP+3)=Dimensions of BL(*),BU(*),IND(*)
C        IOPT(LP+4)=Dimension of X(*)
C        IOPT(LP+5)=Dimension of RW(*)
C        IOPT(LP+6)=Dimension of IW(*)
C        IOPT(LP+7)=Dimension of IOPT(*)
C         .
C        CALL SBOCLS( )
C
C     Use of this option adds 8 to the required length of IOPT(*).
C
C   3
C   -
C     This option can change the type of scaling for the data matrix.
C     Nominally each nonzero column of the matrix is scaled so that the
C     magnitude of its largest entry is equal to the value ONE. If LP
C     is the processing pointer for IOPT(*),
C
C        IOPT(LP)=3
C        IOPT(LP+1)=1,2 or 3
C            1= Nominal scaling as noted;
C            2= Each nonzero column scaled to have length ONE;
C            3= Identity scaling; scaling effectively suppressed.
C         .
C        CALL SBOCLS( )
C
C     Use of this option adds 2 to the required length of IOPT(*).
C
C   4
C   -
C     This options allows the user to provide arbitrary (positive)
C     column scaling for the matrix. If LP is the processing pointer
C     for IOPT(*),
C
C        IOPT(LP)=4
C        IOPT(LP+1)=IOFF
C        X(NCOLS+IOFF),...,X(NCOLS+IOFF+NCOLS-1)
C        = Positive scale factors for cols. of E.
C         .
C        CALL SBOCLS( )
C
C     Use of this option adds 2 to the required length of IOPT(*)
C     and NCOLS to the required length of X(*).
C
C   5
C   -
C     This option allows the user to provide an option array to the
C     low-level subprogram SBOLS( ). If LP is the processing pointer
C     for IOPT(*),
C
C        IOPT(LP)=5
C        IOPT(LP+1)= Position in IOPT(*) where option array
C                    data for SBOLS( ) begins.
C         .
C        CALL SBOCLS( )
C
C     Use of this option adds 2 to the required length of IOPT(*).
C
C   6
C   -
C     This option allows the user to provide an option array to the
C     low-level subprogram SBOLSM( ). If LP is the processing pointer
C     for IOPT(*),
C
C        IOPT(LP)=6
C        IOPT(LP+1)= Position in IOPT(*) where option array
C                    data for SBOLSM( ) begins.
C         .
C        CALL SBOCLS( )
C
C     Use of this option adds 2 to the required length of IOPT(*).
C
C   7
C   -
C     Move the processing pointer (either forward or backward) to the
C     location IOPT(LP+1). The processing pointer moves to locations
C     LP+2 if option number 7 is used with the value -7.  For
C     example to skip over locations 3,...,NCOLS+2,
C
C       IOPT(1)=7
C       IOPT(2)=NCOLS+3
C       (IOPT(I), I=3,...,NCOLS+2 are not defined here.)
C       IOPT(NCOLS+3)=99
C       CALL SBOCLS( )
C
C     CAUTION: Misuse of this option can yield some very hard-to-find
C     bugs. Use it with care. It is intended to be used for passing
C     option arrays to other subprograms.
C
C   8
C   -
C     This option allows the user to suppress the algorithmic feature
C     of SBOCLS( ) that processes the constraint equations C*X = Y and
C     resolves infeasibilities. The steps normally done are to solve
C     C*X - Y = 0 in a least squares sense using the stated bounds on
C     both X and Y. Then the "reachable" vector Y = C*X is computed
C     using the solution X obtained. Finally the stated bounds for Y are
C     enlarged to include C*X. To suppress the feature:
C
C
C       IOPT(LP)=8
C         .
C       CALL SBOCLS( )
C
C     Use of this option adds 1 to the required length of IOPT(*).
C
C   9
C   -
C     This option allows the user to suppress the pretriangularizing
C     step of the least squares matrix that is done within SBOCLS( ).
C     This is primarily a means of enhancing the subprogram efficiency
C     and has little effect on accuracy. To suppress the step, set:
C
C       IOPT(LP)=9
C         .
C       CALL SBOCLS( )
C
C     Use of this option adds 1 to the required length of IOPT(*).
C
C   99
C   --
C     There are no more options to change.
C
C     Only option numbers -99, -9,-8,...,-1, 1,2,...,9, and 99 are
C     permitted. Other values are errors. Options -99,-1,...,-9 mean
C     that the respective options 99,1,...,9 are left at their default
C     values. An example is the option to suppress the preprocessing of
C     constraints:
C
C       IOPT(1)=-8 Option is recognized but not changed
C       IOPT(2)=99
C       CALL SBOCLS( )
C
C    Error Messages for SBOCLS()
C    ----- -------- --- --------
C
C WARNING in...
C SBOCLS(). THE ROW DIMENSION OF W(,)=(I1) MUST BE .GE. THE NUMBER
C OF EFFECTIVE ROWS=(I2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        41
C
C WARNING IN...
C SBOCLS(). THE COLUMN DIMENSION OF W(,)=(I1) MUST BE .GE. NCOLS+
C MCON+1=(I2).
C           IN ABOVE MESSAGE, I1=         2
C           IN ABOVE MESSAGE, I2=         3
C ERROR NUMBER =        42
C
C WARNING IN...
C SBOCLS(). THE DIMENSIONS OF THE ARRAYS BL(),BU(), AND IND()=(I1)
C MUST BE .GE. NCOLS+MCON=(I2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        43
C
C WARNING IN...
C SBOCLS(). THE DIMENSION OF X()=(I1) MUST BE
C .GE. THE REQD.LENGTH=(I2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        44
C
C WARNING IN...
C SBOCLS(). THE .
C SBOCLS() THE DIMENSION OF IW()=(I1) MUST BE .GE. 2*NCOLS+2*MCON=(I2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         4
C ERROR NUMBER =        46
C
C WARNING IN...
C SBOCLS(). THE DIMENSION OF IOPT()=(I1) MUST BE .GE. THE REQD.
C LEN.=(I2).
C           IN ABOVE MESSAGE, I1=        16
C           IN ABOVE MESSAGE, I2=        18
C ERROR NUMBER =        47
C
C WARNING IN...
C SBOCLS(). ISCALE OPTION=(I1) MUST BE 1-3.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =        48
C
C WARNING IN...
C SBOCLS(). OFFSET PAST X(NCOLS) (I1) FOR USER-PROVIDED COLUMN SCALING
C MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =        49
C
C WARNING IN...
C SBOCLS(). EACH PROVIDED COL. SCALE FACTOR MUST BE POSITIVE.
C  COMPONENT (I1) NOW = (R1).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, R1=    0.
C ERROR NUMBER =        50
C
C WARNING IN...
C SBOCLS(). THE OPTION NUMBER=(I1) IS NOT DEFINED.
C           IN ABOVE MESSAGE, I1=      1001
C ERROR NUMBER =        51
C
C WARNING IN...
C SBOCLS(). NO. OF ROWS=(I1) MUST BE .GE. 0 .AND. .LE. MDW-MCON=(I2).
C           IN ABOVE MESSAGE, I1=         2
C           IN ABOVE MESSAGE, I2=         1
C ERROR NUMBER =        52
C
C WARNING IN...
C SBOCLS(). MDW=(I1) MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =        53
C
C WARNING IN...
C SBOCLS(). MCON=(I1) MUST BE NONNEGATIVE.
C           IN ABOVE MESSAGE, I1=        -1
C ERROR NUMBER =        54
C
C WARNING IN...
C SBOCLS(). NCOLS=(I1) THE NO. OF VARIABLES MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =        55
C
C WARNING IN...
C SBOCLS(). FOR J=(I1), IND(J)=(I2) MUST BE 1-4.
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         0
C ERROR NUMBER =        56
C
C WARNING IN...
C SBOCLS(). FOR J=(I1), BOUND BL(J)=(R1) IS .GT. BU(J)=(R2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, R1=     .1000000000E+01
C           IN ABOVE MESSAGE, R2=    0.
C ERROR NUMBER =        57
C           LINEAR CONSTRAINTS, SNLA REPT. SAND82-1517, AUG. (1982).
C
C***REFERENCES  R. J. Hanson, Linear least squares with bounds and
C                 linear constraints, Report SAND82-1517, Sandia
C                 Laboratories, August 1982.
C***ROUTINES CALLED  R1MACH, SASUM, SBOLS, SCOPY, SDOT, SNRM2, SSCAL,
C                    XERMSG
C***REVISION HISTORY  (YYMMDD)
C   821220  DATE WRITTEN
C   870803  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   910819  Added variable M for MOUT+MCON in reference to SBOLS.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SBOCLS
C     REVISED 850604-0900
C     REVISED YYMMDD-HHMM
C
C    PURPOSE
C    -------
C     THIS IS THE MAIN SUBPROGRAM THAT SOLVES THE LEAST SQUARES
C     PROBLEM CONSISTING OF LINEAR CONSTRAINTS
C
C              C*X = Y
C
C     AND LEAST SQUARES EQUATIONS
C
C              E*X = F
C
C     IN THIS FORMULATION THE VECTORS X AND Y ARE BOTH UNKNOWNS.
C     FURTHER, X AND Y MAY BOTH HAVE USER-SPECIFIED BOUNDS ON EACH
C     COMPONENT.  THE USER MUST HAVE DIMENSION STATEMENTS OF THE
C     FORM
C
C     DIMENSION W(MDW,NCOLS+MCON+1), BL(NCOLS+MCON),BU(NCOLS+MCON),
C               X(2*(NCOLS+MCON)+2+NX), RW(6*NCOLS+5*MCON)
C
C     INTEGER IND(NCOLS+MCON), IOPT(16+NI), IW(2*(NCOLS+MCON))
C
C     TO CHANGE THIS SUBPROGRAM FROM SINGLE TO DOUBLE PRECISION BEGIN
C     EDITING AT THE CARD 'C++'.
C     CHANGE THIS SUBPROGRAM TO SBOCLS AND THE STRINGS
C     /SDOT/ TO /DDOT/, /SNRM2/ TO /DNRM2/, /SRELPR/ TO /DRELPR/,
C     /R1MACH/ TO /D1MACH/, /E0/ TO /D0/, /SCOPY/ TO /DCOPY/,
C     /SSCAL/ TO /DSCAL/, /SASUM/ TO /DASUM/, /SBOLS/ TO /DBOLS/,
C     /REAL            / TO /DOUBLE PRECISION/.
C ++
      REAL             W(MDW,*),BL(*),BU(*),X(*),RW(*)
      REAL             ANORM, CNORM, ONE, RNORM, RNORMC, SRELPR
      REAL             T, T1, T2, SDOT, SNRM2, WT, ZERO
      REAL             SASUM, R1MACH
C     THIS VARIABLE REMAINS TYPED REAL.
      INTEGER IND(*),IOPT(*),IW(*),JOPT(05)
      LOGICAL CHECKL,FILTER,ACCUM,PRETRI
      CHARACTER*8 XERN1, XERN2
      CHARACTER*16 XERN3, XERN4
      SAVE IGO,ACCUM,CHECKL
      DATA IGO/0/
C***FIRST EXECUTABLE STATEMENT  SBOCLS
      NERR = 0
      MODE = 0
      IF (IGO.EQ.0) THEN
C     DO(CHECK VALIDITY OF INPUT DATA)
C     PROCEDURE(CHECK VALIDITY OF INPUT DATA)
C
C     SEE THAT MDW IS .GT.0. GROSS CHECK ONLY.
          IF (MDW.LE.0) THEN
              WRITE (XERN1, '(I8)') MDW
              CALL XERMSG ('SLATEC', 'SBOCLS', 'MDW = ' // XERN1 //
     *           ' MUST BE POSITIVE.', 53, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 260
          ENDIF
C
C     SEE THAT NUMBER OF CONSTRAINTS IS NONNEGATIVE.
          IF (MCON.LT.0) THEN
              WRITE (XERN1, '(I8)') MCON
              CALL XERMSG ('SLATEC', 'SBOCLS', 'MCON = ' // XERN1 //
     *           ' MUST BE NON-NEGATIVE', 54, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 260
          ENDIF
C
C     SEE THAT NUMBER OF UNKNOWNS IS POSITIVE.
          IF (NCOLS.LE.0) THEN
              WRITE (XERN1, '(I8)') NCOLS
              CALL XERMSG ('SLATEC', 'SBOCLS', 'NCOLS = ' // XERN1 //
     *           ' THE NO. OF VARIABLES, MUST BE POSITIVE.', 55, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 260
          ENDIF
C
C     SEE THAT CONSTRAINT INDICATORS ARE ALL WELL-DEFINED.
          DO 10 J = 1,NCOLS + MCON
              IF (IND(J).LT.1 .OR. IND(J).GT.4) THEN
                  WRITE (XERN1, '(I8)') J
                  WRITE (XERN2, '(I8)') IND(J)
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *              'IND(' // XERN1 // ') = ' // XERN2 //
     *              ' MUST BE 1-4.', 56, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
   10     CONTINUE
C
C     SEE THAT BOUNDS ARE CONSISTENT.
          DO 20 J = 1,NCOLS + MCON
              IF (IND(J).EQ.3) THEN
                  IF (BL(J).GT.BU(J)) THEN
                     WRITE (XERN1, '(I8)') J
                     WRITE (XERN3, '(1PE15.6)') BL(J)
                     WRITE (XERN4, '(1PE15.6)') BU(J)
                     CALL XERMSG ('SLATEC', 'SBOCLS',
     *                  'BOUND BL(' // XERN1 // ') = ' // XERN3 //
     *                  ' IS .GT. BU(' // XERN1 // ') = ' // XERN4,
     *                  57, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 260
                  ENDIF
              ENDIF
   20     CONTINUE
C     END PROCEDURE
C     DO(PROCESS OPTION ARRAY)
C     PROCEDURE(PROCESS OPTION ARRAY)
          ZERO = 0.E0
          ONE = 1.E0
          SRELPR = R1MACH(4)
          CHECKL = .FALSE.
          FILTER = .TRUE.
          LENX = 2* (NCOLS+MCON) + 2
          ISCALE = 1
          IGO = 1
          ACCUM = .FALSE.
          PRETRI = .TRUE.
          LOPT = 0
          MOPT = 0
          LP = 0
          LDS = 0
C     DO FOREVER
   30     CONTINUE
          LP = LP + LDS
          IP = IOPT(LP+1)
          JP = ABS(IP)
C
C     TEST FOR NO MORE OPTIONS TO CHANGE.
          IF (IP.EQ.99) THEN
              IF (LOPT.EQ.0) LOPT = - (LP+2)
              IF (MOPT.EQ.0) MOPT = - (ABS(LOPT)+7)
              IF (LOPT.LT.0) THEN
                  LBOU = ABS(LOPT)
              ELSE
                  LBOU = LOPT - 15
              ENDIF
C
C     SEND COL. SCALING TO SBOLS().
              IOPT(LBOU) = 4
              IOPT(LBOU+1) = 1
C
C     PASS AN OPTION ARRAY FOR SBOLSM().
              IOPT(LBOU+2) = 5
C
C     LOC. OF OPTION ARRAY FOR SBOLSM( ).
              IOPT(LBOU+3) = 8
C
C     SKIP TO START OF USER-GIVEN OPTION ARRAY FOR SBOLS().
              IOPT(LBOU+4) = 6
              IOPT(LBOU+6) = 99
              IF (LOPT.GT.0) THEN
                  IOPT(LBOU+5) = LOPT - LBOU + 1
              ELSE
                  IOPT(LBOU+4) = -IOPT(LBOU+4)
              ENDIF
              IF (MOPT.LT.0) THEN
                  LBOUM = ABS(MOPT)
              ELSE
                  LBOUM = MOPT - 8
              ENDIF
C
C     CHANGE PRETRIANGULARIZATION FACTOR IN SBOLSM().
              IOPT(LBOUM) = 5
              IOPT(LBOUM+1) = NCOLS + MCON + 1
C
C     PASS WEIGHT TO SBOLSM() FOR RANK TEST.
              IOPT(LBOUM+2) = 6
              IOPT(LBOUM+3) = NCOLS + MCON + 2
              IOPT(LBOUM+4) = MCON
C
C     SKIP TO USER-GIVEN OPTION ARRAY FOR SBOLSM( ).
              IOPT(LBOUM+5) = 1
              IOPT(LBOUM+7) = 99
              IF (MOPT.GT.0) THEN
                  IOPT(LBOUM+6) = MOPT - LBOUM + 1
              ELSE
                  IOPT(LBOUM+5) = -IOPT(LBOUM+5)
              ENDIF
C     EXIT FOREVER
              GO TO 50
          ELSE IF (JP.EQ.99) THEN
              LDS = 1
C     CYCLE FOREVER
              GO TO 50
          ELSE IF (JP.EQ.1) THEN
              IF (IP.GT.0) THEN
C
C     SET UP DIRECTION FLAG LOCATION, ROW STACKING POINTER
C     LOCATION, AND LOCATION FOR NUMBER OF NEW ROWS.
                  LOCACC = LP + 2
C
C                  IOPT(LOCACC-1)=OPTION NUMBER FOR SEQ. ACCUMULATION.
C     CONTENTS..   IOPT(LOCACC  )=USER DIRECTION FLAG, 1 OR 2.
C                  IOPT(LOCACC+1)=ROW STACKING POINTER.
C                  IOPT(LOCACC+2)=NUMBER OF NEW ROWS TO PROCESS.
C     USER ACTION WITH THIS OPTION..
C      (SET UP OPTION DATA FOR SEQ. ACCUMULATION IN IOPT(*).)
C      (MOVE BLOCK OF EQUATIONS INTO W(*,*)  STARTING AT FIRST
C       ROW OF W(*,*) BELOW THE ROWS FOR THE CONSTRAINT MATRIX C.
C       SET IOPT(LOCACC+2)=NO. OF LEAST SQUARES EQUATIONS IN BLOCK.
C              LOOP
C              CALL SBOCLS()
C
C                  IF(IOPT(LOCACC) .EQ. 1) THEN
C                      STACK EQUAS. INTO W(*,*), STARTING AT
C                      ROW IOPT(LOCACC+1).
C                       INTO W(*,*).
C                       SET IOPT(LOCACC+2)=NO. OF EQUAS.
C                      IF LAST BLOCK OF EQUAS., SET IOPT(LOCACC)=2.
C                  ELSE IF IOPT(LOCACC) .EQ. 2) THEN
C                      (PROCESS IS OVER. EXIT LOOP.)
C                  ELSE
C                      (ERROR CONDITION. SHOULD NOT HAPPEN.)
C                  END IF
C              END LOOP
                  IOPT(LOCACC+1) = MCON + 1
                  ACCUM = .TRUE.
                  IOPT(LOCACC) = IGO
              ENDIF
              LDS = 4
C     CYCLE FOREVER
              GO TO 30
          ELSE IF (JP.EQ.2) THEN
              IF (IP.GT.0) THEN
C
C     GET ACTUAL LENGTHS OF ARRAYS FOR CHECKING AGAINST NEEDS.
                  LOCDIM = LP + 2
C
C     LMDW.GE.MCON+MAX(MOUT,NCOLS), IF MCON.GT.0 .AND FILTER
C     LMDW.GE.MCON+MOUT, OTHERWISE
C
C     LNDW.GE.NCOLS+MCON+1
C     LLB .GE.NCOLS+MCON
C     LLX .GE.2*(NCOLS+MCON)+2+EXTRA REQD. IN OPTIONS.
C     LLRW.GE.6*NCOLS+5*MCON
C     LLIW.GE.2*(NCOLS+MCON)
C     LIOP.GE. AMOUNT REQD. FOR OPTION ARRAY.
                  LMDW = IOPT(LOCDIM)
                  LNDW = IOPT(LOCDIM+1)
                  LLB = IOPT(LOCDIM+2)
                  LLX = IOPT(LOCDIM+3)
                  LLRW = IOPT(LOCDIM+4)
                  LLIW = IOPT(LOCDIM+5)
                  LIOPT = IOPT(LOCDIM+6)
                  CHECKL = .TRUE.
              ENDIF
              LDS = 8
C     CYCLE FOREVER
              GO TO 30
C
C     OPTION TO MODIFY THE COLUMN SCALING.
          ELSE IF (JP.EQ.3) THEN
              IF (IP.GT.0) THEN
                  ISCALE = IOPT(LP+2)
C
C     SEE THAT ISCALE IS 1 THRU 3.
                  IF (ISCALE.LT.1 .OR. ISCALE.GT.3) THEN
                      WRITE (XERN1, '(I8)') ISCALE
                      CALL XERMSG ('SLATEC', 'SBOCLS',
     *                   'ISCALE OPTION = ' // XERN1 // ' MUST BE 1-3',
     *                   48, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 260
                  ENDIF
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     IN THIS OPTION THE USER HAS PROVIDED SCALING.  THE
C     SCALE FACTORS FOR THE COLUMNS BEGIN IN X(NCOLS+IOPT(LP+2)).
          ELSE IF (JP.EQ.4) THEN
              IF (IP.GT.0) THEN
                  ISCALE = 4
                  IF (IOPT(LP+2).LE.0) THEN
                      WRITE (XERN1, '(I8)') IOPT(LP+2)
                      CALL XERMSG ('SLATEC', 'SBOCLS',
     *                   'OFFSET PAST X(NCOLS) (' // XERN1 //
     *           ') FOR USER-PROVIDED COLUMN SCALING MUST BE POSITIVE.',
     *                   49, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 260
                  ENDIF
                  CALL SCOPY(NCOLS,X(NCOLS+IOPT(LP+2)),1,RW,1)
                  LENX = LENX + NCOLS
                  DO 40 J = 1,NCOLS
                      IF (RW(J).LE.ZERO) THEN
                          WRITE (XERN1, '(I8)') J
                          WRITE (XERN3, '(1PE15.6)') RW(J)
                          CALL XERMSG ('SLATEC', 'SBOCLS',
     *                       'EACH PROVIDED COLUMN SCALE FACTOR ' //
     *                       'MUST BE POSITIVE.$$COMPONENT ' // XERN1 //
     *                       ' NOW = ' // XERN3, 50, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                          GO TO 260
                      ENDIF
   40             CONTINUE
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     IN THIS OPTION AN OPTION ARRAY IS PROVIDED TO SBOLS().
          ELSE IF (JP.EQ.5) THEN
              IF (IP.GT.0) THEN
                  LOPT = IOPT(LP+2)
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     IN THIS OPTION AN OPTION ARRAY IS PROVIDED TO SBOLSM().
          ELSE IF (JP.EQ.6) THEN
              IF (IP.GT.0) THEN
                  MOPT = IOPT(LP+2)
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     THIS OPTION USES THE NEXT LOC OF IOPT(*) AS A
C     POINTER VALUE TO SKIP TO NEXT.
          ELSE IF (JP.EQ.7) THEN
              IF (IP.GT.0) THEN
                  LP = IOPT(LP+2) - 1
                  LDS = 0
              ELSE
                  LDS = 2
              ENDIF
C     CYCLE FOREVER
              GO TO 30
C
C     THIS OPTION AVOIDS THE CONSTRAINT RESOLVING PHASE FOR
C     THE LINEAR CONSTRAINTS C*X=Y.
          ELSE IF (JP.EQ.8) THEN
              FILTER = .NOT. (IP.GT.0)
              LDS = 1
C     CYCLE FOREVER
              GO TO 30
C
C     THIS OPTION SUPPRESSES PRE-TRIANGULARIZATION OF THE LEAST
C     SQUARES EQUATIONS.
          ELSE IF (JP.EQ.9) THEN
              PRETRI = .NOT. (IP.GT.0)
              LDS = 1
C     CYCLE FOREVER
              GO TO 30
C
C     NO VALID OPTION NUMBER WAS NOTED. THIS IS AN ERROR CONDITION.
          ELSE
              WRITE (XERN1, '(I8)') JP
              CALL XERMSG ('SLATEC', 'SBOCLS', 'OPTION NUMBER = ' //
     *           XERN1 // ' IS NOT DEFINED.', 51, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 260
          ENDIF
C     END FOREVER
C     END PROCEDURE
   50     CONTINUE
          IF (CHECKL) THEN
C     DO(CHECK LENGTHS OF ARRAYS)
C     PROCEDURE(CHECK LENGTHS OF ARRAYS)
C
C     THIS FEATURE ALLOWS THE USER TO MAKE SURE THAT THE
C     ARRAYS ARE LONG ENOUGH FOR THE INTENDED PROBLEM SIZE AND USE.
           IF(FILTER .AND. .NOT.ACCUM) THEN
                MDWL=MCON+MAX(MROWS,NCOLS)
           ELSE
                MDWL=MCON+NCOLS+1
           ENDIF
              IF (LMDW.LT.MDWL) THEN
                  WRITE (XERN1, '(I8)') LMDW
                  WRITE (XERN2, '(I8)') MDWL
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *               'THE ROW DIMENSION OF W(,) = ' // XERN1 //
     *               ' MUST BE .GE. THE NUMBER OF EFFECTIVE ROWS = ' //
     *               XERN2, 41, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LNDW.LT.NCOLS+MCON+1) THEN
                  WRITE (XERN1, '(I8)') LNDW
                  WRITE (XERN2, '(I8)') NCOLS+MCON+1
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *               'THE COLUMN DIMENSION OF W(,) = ' // XERN1 //
     *               ' MUST BE .GE. NCOLS+MCON+1 = ' // XERN2, 42, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LLB.LT.NCOLS+MCON) THEN
                  WRITE (XERN1, '(I8)') LLB
                  WRITE (XERN2, '(I8)') NCOLS+MCON
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *           'THE DIMENSIONS OF THE ARRAYS BS(), BU(), AND IND() = '
     *               // XERN1 // ' MUST BE .GE. NCOLS+MCON = ' // XERN2,
     *               43, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LLX.LT.LENX) THEN
                  WRITE (XERN1, '(I8)') LLX
                  WRITE (XERN2, '(I8)') LENX
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *              'THE DIMENSION OF X() = ' // XERN1 //
     *              ' MUST BE .GE. THE REQD. LENGTH = ' // XERN2, 44, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LLRW.LT.6*NCOLS+5*MCON) THEN
                  WRITE (XERN1, '(I8)') LLRW
                  WRITE (XERN2, '(I8)') 6*NCOLS+5*MCON
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *               'THE DIMENSION OF RW() = ' // XERN1 //
     *               ' MUST BE .GE. 6*NCOLS+5*MCON = ' // XERN2, 45, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LLIW.LT.2*NCOLS+2*MCON) THEN
                  WRITE (XERN1, '(I8)') LLIW
                  WRITE (XERN2, '(I8)') 2*NCOLS+2*MCON
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *               'THE DIMENSION OF IW() = ' // XERN1 //
     *               ' MUST BE .GE. 2*NCOLS+2*MCON = ' // XERN2, 46, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
              IF (LIOPT.LT.LP+17) THEN
                  WRITE (XERN1, '(I8)') LIOPT
                  WRITE (XERN2, '(I8)') LP+17
                  CALL XERMSG ('SLATEC', 'SBOCLS',
     *               'THE DIMENSION OF IOPT() = ' // XERN1 //
     *               ' MUST BE .GE. THE REQD. LEN = ' // XERN2, 47, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 260
              ENDIF
C     END PROCEDURE
          ENDIF
      ENDIF
C
C     OPTIONALLY GO BACK TO THE USER FOR ACCUMULATION OF LEAST SQUARES
C     EQUATIONS AND DIRECTIONS FOR PROCESSING THESE EQUATIONS.
C     DO(ACCUMULATE LEAST SQUARES EQUATIONS)
C     PROCEDURE(ACCUMULATE LEAST SQUARES EQUATIONS)
      IF (ACCUM) THEN
          MROWS = IOPT(LOCACC+1) - 1 - MCON
          INROWS = IOPT(LOCACC+2)
          MNEW = MROWS + INROWS
          IF (MNEW.LT.0 .OR. MNEW+MCON.GT.MDW) THEN
              WRITE (XERN1, '(I8)') MNEW
              WRITE (XERN2, '(I8)') MDW-MCON
              CALL XERMSG ('SLATEC', 'SBOCLS', 'NO. OF ROWS = ' //
     *           XERN1 //  ' MUST BE .GE. 0 .AND. .LE. MDW-MCON = ' //
     *           XERN2, 52, 1)
C    (RETURN TO USER PROGRAM UNIT)
              GO TO 260
          ENDIF
      ENDIF
C
C     USE THE SOFTWARE OF SBOLS( ) FOR THE TRIANGULARIZATION OF THE
C     LEAST SQUARES MATRIX.  THIS MAY INVOLVE A SYSTALTIC INTERCHANGE
C     OF PROCESSING POINTERS BETWEEN THE CALLING AND CALLED (SBOLS())
C     PROGRAM UNITS.
      JOPT(01) = 1
      JOPT(02) = 2
      JOPT(04) = MROWS
      JOPT(05) = 99
      IRW = NCOLS + 1
      IIW = 1
      IF (ACCUM .OR. PRETRI) THEN
          CALL SBOLS(W(MCON+1,1),MDW,MOUT,NCOLS,BL,BU,IND,JOPT,X,RNORM,
     *               MODE,RW(IRW),IW(IIW))
      ELSE
          MOUT = MROWS
      ENDIF
      IF (ACCUM) THEN
          ACCUM = IOPT(LOCACC) .EQ. 1
          IOPT(LOCACC+1) = JOPT(03) + MCON
          MROWS = MIN(NCOLS+1,MNEW)
      ENDIF
C     END PROCEDURE
      IF (ACCUM) RETURN
C     DO(SOLVE CONSTRAINED AND BOUNDED LEAST SQUARES PROBLEM)
C     PROCEDURE(SOLVE CONSTRAINED AND BOUNDED LEAST SQUARES PROBLEM)
C
C     MOVE RIGHT HAND SIDE OF LEAST SQUARES EQUATIONS.
      CALL SCOPY(MOUT,W(MCON+1,NCOLS+1),1,W(MCON+1,NCOLS+MCON+1),1)
      IF (MCON.GT.0 .AND. FILTER) THEN
C
C     PROJECT THE LINEAR CONSTRAINTS INTO A REACHABLE SET.
          DO 60 I = 1,MCON
              CALL SCOPY(NCOLS,W(I,1),MDW,W(MCON+1,NCOLS+I),1)
   60     CONTINUE
C
C      PLACE (-)IDENTITY MATRIX AFTER CONSTRAINT DATA.
          DO 70 J = NCOLS + 1,NCOLS + MCON + 1
              W(1,J) = ZERO
              CALL SCOPY(MCON,W(1,J),0,W(1,J),1)
   70     CONTINUE
          W(1,NCOLS+1) = -ONE
          CALL SCOPY(MCON,W(1,NCOLS+1),0,W(1,NCOLS+1),MDW+1)
C
C     OBTAIN A 'FEASIBLE POINT' FOR THE LINEAR CONSTRAINTS.
          JOPT(01) = 99
          IRW = NCOLS + 1
          IIW = 1
          CALL SBOLS(W,MDW,MCON,NCOLS+MCON,BL,BU,IND,JOPT,X,RNORMC,
     *               MODEC,RW(IRW),IW(IIW))
C
C     ENLARGE THE BOUNDS SET, IF REQUIRED, TO INCLUDE POINTS THAT
C     CAN BE REACHED.
          DO 130 J = NCOLS + 1,NCOLS + MCON
              ICASE = IND(J)
              IF (ICASE.LT.4) THEN
                  T = SDOT(NCOLS,W(MCON+1,J),1,X,1)
              ENDIF
              GO TO (80,90,100,110),ICASE
              GO TO 120
C     CASE 1
   80         BL(J) = MIN(T,BL(J))
              GO TO 120
C     CASE 2
   90         BU(J) = MAX(T,BU(J))
              GO TO 120
C     CASE 3
  100         BL(J) = MIN(T,BL(J))
              BU(J) = MAX(T,BU(J))
              GO TO 120
C     CASE 4
  110         CONTINUE
  120         CONTINUE
  130     CONTINUE
C
C     MOVE CONSTRAINT DATA BACK TO THE ORIGINAL AREA.
          DO 140 J = NCOLS + 1,NCOLS + MCON
              CALL SCOPY(NCOLS,W(MCON+1,J),1,W(J-NCOLS,1),MDW)
  140     CONTINUE
      ENDIF
      IF (MCON.GT.0) THEN
          DO 150 J = NCOLS + 1,NCOLS + MCON
              W(MCON+1,J) = ZERO
              CALL SCOPY(MOUT,W(MCON+1,J),0,W(MCON+1,J),1)
  150     CONTINUE
C
C     PUT IN (-)IDENTITY MATRIX (POSSIBLY) ONCE AGAIN.
          DO 160 J = NCOLS + 1,NCOLS + MCON + 1
              W(1,J) = ZERO
              CALL SCOPY(MCON,W(1,J),0,W(1,J),1)
  160     CONTINUE
          W(1,NCOLS+1) = -ONE
          CALL SCOPY(MCON,W(1,NCOLS+1),0,W(1,NCOLS+1),MDW+1)
      ENDIF
C
C     COMPUTE NOMINAL COLUMN SCALING FOR THE UNWEIGHTED MATRIX.
      CNORM = ZERO
      ANORM = ZERO
      DO 170 J = 1,NCOLS
          T1 = SASUM(MCON,W(1,J),1)
          T2 = SASUM(MOUT,W(MCON+1,1),1)
          T = T1 + T2
          IF (T.EQ.ZERO) T = ONE
          CNORM = MAX(CNORM,T1)
          ANORM = MAX(ANORM,T2)
          X(NCOLS+MCON+J) = ONE/T
  170 CONTINUE
      GO TO (180,190,210,220),ISCALE
      GO TO 230
C     CASE 1
  180 CONTINUE
      GO TO 230
C     CASE 2
C
C     SCALE COLS. (BEFORE WEIGHTING) TO HAVE LENGTH ONE.
  190 DO 200 J = 1,NCOLS
          T = SNRM2(MCON+MOUT,W(1,J),1)
          IF (T.EQ.ZERO) T = ONE
          X(NCOLS+MCON+J) = ONE/T
  200 CONTINUE
      GO TO 230
C     CASE 3
C
C     SUPPRESS SCALING (USE UNIT MATRIX).
  210 X(NCOLS+MCON+1) = ONE
      CALL SCOPY(NCOLS,X(NCOLS+MCON+1),0,X(NCOLS+MCON+1),1)
      GO TO 230
C     CASE 4
C
C     THE USER HAS PROVIDED SCALING.
  220 CALL SCOPY(NCOLS,RW,1,X(NCOLS+MCON+1),1)
  230 CONTINUE
      DO 240 J = NCOLS + 1,NCOLS + MCON
          X(NCOLS+MCON+J) = ONE
  240 CONTINUE
C
C     WEIGHT THE LEAST SQUARES EQUATIONS.
      WT = SRELPR
      IF (ANORM.GT.ZERO) WT = WT/ANORM
      IF (CNORM.GT.ZERO) WT = WT*CNORM
      DO 250 I = 1,MOUT
          CALL SSCAL(NCOLS,WT,W(I+MCON,1),MDW)
  250 CONTINUE
      CALL SSCAL(MOUT,WT,W(MCON+1,MCON+NCOLS+1),1)
      LRW = 1
      LIW = 1
C
C     SET THE NEW TRIANGULARIZATION FACTOR.
      X(2* (NCOLS+MCON)+1) = ZERO
C
C     SET THE WEIGHT TO USE IN COMPONENTS .GT. MCON,
C     WHEN MAKING LINEAR INDEPENDENCE TEST.
      X(2* (NCOLS+MCON)+2) = ONE/WT
      M=MOUT+MCON
      CALL SBOLS(W,MDW,M,NCOLS+MCON,BL,BU,IND,IOPT(LBOU),X,
     *           RNORM,MODE,RW(LRW),IW(LIW))
      RNORM = RNORM/WT
C     END PROCEDURE
C     PROCEDURE(RETURN TO USER PROGRAM UNIT)
  260 IF(MODE.GE.0)MODE = -NERR
      IGO = 0
      RETURN
C     END PROGRAM
      END
*DECK SBOLS
      SUBROUTINE SBOLS (W, MDW, MROWS, NCOLS, BL, BU, IND, IOPT, X,
     +   RNORM, MODE, RW, IW)
C***BEGIN PROLOGUE  SBOLS
C***PURPOSE  Solve the problem
C                 E*X = F (in the least  squares  sense)
C            with bounds on selected X values.
C***LIBRARY   SLATEC
C***CATEGORY  K1A2A, G2E, G2H1, G2H2
C***TYPE      SINGLE PRECISION (SBOLS-S, DBOLS-D)
C***KEYWORDS  BOUNDS, CONSTRAINTS, INEQUALITY, LEAST SQUARES, LINEAR
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C     The user must have dimension statements of the form:
C
C       DIMENSION W(MDW,NCOLS+1), BL(NCOLS), BU(NCOLS),
C      * X(NCOLS+NX), RW(5*NCOLS)
C       INTEGER IND(NCOLS), IOPT(1+NI), IW(2*NCOLS)
C
C     (here NX=number of extra locations required for option 4; NX=0
C     for no options; NX=NCOLS if this option is in use. Here NI=number
C     of extra locations required for options 1-6; NI=0 for no
C     options.)
C
C   INPUT
C   -----
C
C    --------------------
C    W(MDW,*),MROWS,NCOLS
C    --------------------
C     The array W(*,*) contains the matrix [E:F] on entry. The matrix
C     [E:F] has MROWS rows and NCOLS+1 columns. This data is placed in
C     the array W(*,*) with E occupying the first NCOLS columns and the
C     right side vector F in column NCOLS+1. The row dimension, MDW, of
C     the array W(*,*) must satisfy the inequality MDW .ge. MROWS.
C     Other values of MDW are errors. The values of MROWS and NCOLS
C     must be positive. Other values are errors. There is an exception
C     to this when using option 1 for accumulation of blocks of
C     equations. In that case MROWS is an OUTPUT variable ONLY, and the
C     matrix data for [E:F] is placed in W(*,*), one block of rows at a
C     time.  MROWS contains the number of rows in the matrix after
C     triangularizing several blocks of equations. This is an OUTPUT
C     parameter ONLY when option 1 is used. See IOPT(*) CONTENTS
C     for details about option 1.
C
C    ------------------
C    BL(*),BU(*),IND(*)
C    ------------------
C     These arrays contain the information about the bounds that the
C     solution values are to satisfy. The value of IND(J) tells the
C     type of bound and BL(J) and BU(J) give the explicit values for
C     the respective upper and lower bounds.
C
C    1.    For IND(J)=1, require X(J) .ge. BL(J).
C          (the value of BU(J) is not used.)
C    2.    For IND(J)=2, require X(J) .le. BU(J).
C          (the value of BL(J) is not used.)
C    3.    For IND(J)=3, require X(J) .ge. BL(J) and
C                                X(J) .le. BU(J).
C    4.    For IND(J)=4, no bounds on X(J) are required.
C          (the values of BL(J) and BU(J) are not used.)
C
C     Values other than 1,2,3 or 4 for IND(J) are errors. In the case
C     IND(J)=3 (upper and lower bounds) the condition BL(J) .gt. BU(J)
C     is an error.
C
C    -------
C    IOPT(*)
C    -------
C     This is the array where the user can specify nonstandard options
C     for SBOLSM( ). Most of the time this feature can be ignored by
C     setting the input value IOPT(1)=99. Occasionally users may have
C     needs that require use of the following subprogram options. For
C     details about how to use the options see below: IOPT(*) CONTENTS.
C
C     Option Number   Brief Statement of Purpose
C     ------ ------   ----- --------- -- -------
C           1         Return to user for accumulation of blocks
C                     of least squares equations.
C           2         Check lengths of all arrays used in the
C                     subprogram.
C           3         Standard scaling of the data matrix, E.
C           4         User provides column scaling for matrix E.
C           5         Provide option array to the low-level
C                     subprogram SBOLSM( ).
C           6         Move the IOPT(*) processing pointer.
C          99         No more options to change.
C
C    ----
C    X(*)
C    ----
C     This array is used to pass data associated with option 4. Ignore
C     this parameter if this option is not used. Otherwise see below:
C     IOPT(*) CONTENTS.
C
C    OUTPUT
C    ------
C
C    ----------
C    X(*),RNORM
C    ----------
C     The array X(*) contains a solution (if MODE .ge.0 or .eq.-22) for
C     the constrained least squares problem. The value RNORM is the
C     minimum residual vector length.
C
C    ----
C    MODE
C    ----
C     The sign of MODE determines whether the subprogram has completed
C     normally, or encountered an error condition or abnormal status. A
C     value of MODE .ge. 0 signifies that the subprogram has completed
C     normally. The value of MODE (.GE. 0) is the number of variables
C     in an active status: not at a bound nor at the value ZERO, for
C     the case of free variables. A negative value of MODE will be one
C     of the cases -37,-36,...,-22, or -17,...,-2. Values .lt. -1
C     correspond to an abnormal completion of the subprogram. To
C     understand the abnormal completion codes see below: ERROR
C     MESSAGES for SBOLS( ). AN approximate solution will be returned
C     to the user only when max. iterations is reached, MODE=-22.
C     Values for MODE=-37,...,-22 come from the low-level subprogram
C     SBOLSM(). See the section ERROR MESSAGES for SBOLSM() in the
C     documentation for SBOLSM().
C
C    -----------
C    RW(*),IW(*)
C    -----------
C     These are working arrays with 5*NCOLS and 2*NCOLS entries.
C     (normally the user can ignore the contents of these arrays,
C     but they must be dimensioned properly.)
C
C    IOPT(*) CONTENTS
C    ------- --------
C     The option array allows a user to modify internal variables in
C     the subprogram without recompiling the source code. A central
C     goal of the initial software design was to do a good job for most
C     people. Thus the use of options will be restricted to a select
C     group of users. The processing of the option array proceeds as
C     follows: a pointer, here called LP, is initially set to the value
C     1. This value is updated as each option is processed. At the
C     pointer position the option number is extracted and used for
C     locating other information that allows for options to be changed.
C     The portion of the array IOPT(*) that is used for each option is
C     fixed; the user and the subprogram both know how many locations
C     are needed for each option. A great deal of error checking is
C     done by the subprogram on the contents of the option array.
C     Nevertheless it is still possible to give the subprogram optional
C     input that is meaningless. For example option 4 uses the
C     locations X(NCOLS+IOFF),...,X(NCOLS+IOFF+NCOLS-1) for passing
C     scaling data. The user must manage the allocation of these
C     locations.
C
C   1
C   -
C     This option allows the user to solve problems with a large number
C     of rows compared to the number of variables. The idea is that the
C     subprogram returns to the user (perhaps many times) and receives
C     new least squares equations from the calling program unit.
C     Eventually the user signals "that's all" and then computes the
C     solution with one final call to subprogram SBOLS( ). The value of
C     MROWS is an OUTPUT variable when this option is used. Its value
C     is always in the range 0 .le. MROWS .le. NCOLS+1. It is equal to
C     the number of rows after the triangularization of the entire set
C     of equations. If LP is the processing pointer for IOPT(*), the
C     usage for the sequential processing of blocks of equations is
C
C        IOPT(LP)=1
C        Move block of equations to W(*,*) starting at
C        the first row of W(*,*).
C        IOPT(LP+3)=# of rows in the block; user defined
C
C     The user now calls SBOLS( ) in a loop. The value of IOPT(LP+1)
C     directs the user's action. The value of IOPT(LP+2) points to
C     where the subsequent rows are to be placed in W(*,*).
C
C      .<LOOP
C      . CALL SBOLS()
C      . IF(IOPT(LP+1) .EQ. 1) THEN
C      .    IOPT(LP+3)=# OF ROWS IN THE NEW BLOCK; USER DEFINED
C      .    PLACE NEW BLOCK OF IOPT(LP+3) ROWS IN
C      .    W(*,*) STARTING AT ROW IOPT(LP+2).
C      .
C      .    IF( THIS IS THE LAST BLOCK OF EQUATIONS ) THEN
C      .       IOPT(LP+1)=2
C      .<------CYCLE LOOP
C      .    ELSE IF (IOPT(LP+1) .EQ. 2) THEN
C      <-------EXIT LOOP SOLUTION COMPUTED IF MODE .GE. 0
C      . ELSE
C      . ERROR CONDITION; SHOULD NOT HAPPEN.
C      .<END LOOP
C
C     Use of this option adds 4 to the required length of IOPT(*).
C
C
C   2
C   -
C     This option is useful for checking the lengths of all arrays used
C     by SBOLS() against their actual requirements for this problem.
C     The idea is simple: the user's program unit passes the declared
C     dimension information of the arrays. These values are compared
C     against the problem-dependent needs within the subprogram. If any
C     of the dimensions are too small an error message is printed and a
C     negative value of MODE is returned, -11 to -17. The printed error
C     message tells how long the dimension should be. If LP is the
C     processing pointer for IOPT(*),
C
C        IOPT(LP)=2
C        IOPT(LP+1)=Row dimension of W(*,*)
C        IOPT(LP+2)=Col. dimension of W(*,*)
C        IOPT(LP+3)=Dimensions of BL(*),BU(*),IND(*)
C        IOPT(LP+4)=Dimension of X(*)
C        IOPT(LP+5)=Dimension of RW(*)
C        IOPT(LP+6)=Dimension of IW(*)
C        IOPT(LP+7)=Dimension of IOPT(*)
C         .
C        CALL SBOLS()
C
C     Use of this option adds 8 to the required length of IOPT(*).
C
C   3
C   -
C     This option changes the type of scaling for the data matrix E.
C     Nominally each nonzero column of E is scaled so that the
C     magnitude of its largest entry is equal to the value ONE. If LP
C     is the processing pointer for IOPT(*),
C
C        IOPT(LP)=3
C        IOPT(LP+1)=1,2 or 3
C            1= Nominal scaling as noted;
C            2= Each nonzero column scaled to have length ONE;
C            3= Identity scaling; scaling effectively suppressed.
C         .
C        CALL SBOLS()
C
C     Use of this option adds 2 to the required length of IOPT(*).
C
C   4
C   -
C     This option allows the user to provide arbitrary (positive)
C     column scaling for the matrix E. If LP is the processing pointer
C     for IOPT(*),
C
C        IOPT(LP)=4
C        IOPT(LP+1)=IOFF
C        X(NCOLS+IOFF),...,X(NCOLS+IOFF+NCOLS-1)
C        = Positive scale factors for cols. of E.
C         .
C        CALL SBOLS()
C
C     Use of this option adds 2 to the required length of IOPT(*) and
C     NCOLS to the required length of X(*).
C
C   5
C   -
C     This option allows the user to provide an option array to the
C     low-level subprogram SBOLSM(). If LP is the processing pointer
C     for IOPT(*),
C
C        IOPT(LP)=5
C        IOPT(LP+1)= Position in IOPT(*) where option array
C                    data for SBOLSM() begins.
C         .
C        CALL SBOLS()
C
C     Use of this option adds 2 to the required length of IOPT(*).
C
C   6
C   -
C     Move the processing pointer (either forward or backward) to the
C     location IOPT(LP+1). The processing point is moved to entry
C     LP+2 of IOPT(*) if the option is left with -6 in IOPT(LP).  For
C     example to skip over locations 3,...,NCOLS+2 of IOPT(*),
C
C       IOPT(1)=6
C       IOPT(2)=NCOLS+3
C       (IOPT(I), I=3,...,NCOLS+2 are not defined here.)
C       IOPT(NCOLS+3)=99
C       CALL SBOLS()
C
C     CAUTION: Misuse of this option can yield some very hard
C     -to-find bugs.  Use it with care.
C
C   99
C   --
C     There are no more options to change.
C
C     Only option numbers -99, -6,-5,...,-1, 1,2,...,6, and 99 are
C     permitted. Other values are errors. Options -99,-1,...,-6 mean
C     that the respective options 99,1,...,6 are left at their default
C     values. An example is the option to modify the (rank) tolerance:
C
C       IOPT(1)=-3 Option is recognized but not changed
C       IOPT(2)=2  Scale nonzero cols. to have length ONE
C       IOPT(3)=99
C
C    ERROR MESSAGES for SBOLS()
C    ----- -------- --- -------
C
C WARNING IN...
C SBOLS(). MDW=(I1) MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =         2
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). NCOLS=(I1) THE NO. OF VARIABLES MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =         3
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). FOR J=(I1), IND(J)=(I2) MUST BE 1-4.
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         0
C ERROR NUMBER =         4
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). FOR J=(I1), BOUND BL(J)=(R1) IS .GT. BU(J)=(R2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, R1=    0.
C           IN ABOVE MESSAGE, R2=    ABOVE MESSAGE, I1=         0
C ERROR NUMBER =         6
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). ISCALE OPTION=(I1) MUST BE 1-3.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =         7
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). OFFSET PAST X(NCOLS) (I1) FOR USER-PROVIDED  COLUMN SCALING
C MUST BE POSITIVE.
C           IN ABOVE MESSAGE, I1=         0
C ERROR NUMBER =         8
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). EACH PROVIDED COL. SCALE FACTOR MUST BE POSITIVE.
C COMPONENT (I1) NOW = (R1).
C           IN ABOVE MESSAGE, I1=        ND. .LE. MDW=(I2).
C           IN ABOVE MESSAGE, I1=         1
C           IN ABOVE MESSAGE, I2=         0
C ERROR NUMBER =        10
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS().THE ROW DIMENSION OF W(,)=(I1) MUST BE .GE.THE NUMBER OF ROWS=
C (I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         1
C ERROR NUMBER =        11
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). THE COLUMN DIMENSION OF W(,)=(I1) MUST BE .GE. NCOLS+1=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        12
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS().THE DIMENSIONS OF THE ARRAYS BL(),BU(), AND IND()=(I1) MUST BE
C .GE. NCOLS=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         1
C ERROR NUMBER =        13
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). THE DIMENSION OF X()=(I1) MUST BE .GE. THE REQD. LENGTH=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        14
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS(). THE DIMENSION OF RW()=(I1) MUST BE .GE. 5*NCOLS=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         3
C ERROR NUMBER =        15
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS() THE DIMENSION OF IW()=(I1) MUST BE .GE. 2*NCOLS=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         2
C ERROR NUMBER =        16
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C WARNING IN...
C SBOLS() THE DIMENSION OF IOPT()=(I1) MUST BE .GE. THE REQD. LEN.=(I2).
C           IN ABOVE MESSAGE, I1=         0
C           IN ABOVE MESSAGE, I2=         1
C ERROR NUMBER =        17
C (NORMALLY A RETURN TO THE USER TAKES PLACE FOLLOWING THIS MESSAGE.)
C
C***REFERENCES  R. J. Hanson, Linear least squares with bounds and
C                 linear constraints, Report SAND82-1517, Sandia
C                 Laboratories, August 1982.
C***ROUTINES CALLED  ISAMAX, SBOLSM, SCOPY, SNRM2, SROT, SROTG, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   821220  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  SBOLS
C
C     SOLVE LINEAR LEAST SQUARES SYSTEM WITH BOUNDS ON
C     SELECTED VARIABLES.
C     REVISED 850329-1400
C     REVISED YYMMDD-HHMM
C     TO CHANGE THIS SUBPROGRAM FROM SINGLE TO DOUBLE PRECISION BEGIN
C     EDITING AT THE CARD 'C++'.
C     CHANGE THIS SUBPROGRAM NAME TO DBOLS AND THE STRINGS
C     /SCOPY/ TO /DCOPY/, /SBOL/ TO /DBOL/,
C     /SNRM2/ TO /DNRM2/, /ISAMAX/ TO /IDAMAX/,
C     /SROTG/ TO /DROTG/, /SROT/ TO /DROT/, /E0/ TO /D0/,
C     /REAL            / TO /DOUBLE PRECISION/.
C ++
      REAL             W(MDW,*),BL(*),BU(*),X(*),RW(*)
      REAL             SC, SS, ONE, SNRM2, RNORM, ZERO
C
C     THIS VARIABLE SHOULD REMAIN TYPE REAL.
      INTEGER IND(*),IOPT(*),IW(*)
      LOGICAL CHECKL
      CHARACTER*8 XERN1, XERN2
      CHARACTER*16 XERN3, XERN4
      SAVE IGO,LOCACC,LOPT,ISCALE
      DATA IGO/0/
C***FIRST EXECUTABLE STATEMENT  SBOLS
      NERR = 0
      MODE = 0
      IF (IGO.EQ.0) THEN
C     DO(CHECK VALIDITY OF INPUT DATA)
C     PROCEDURE(CHECK VALIDITY OF INPUT DATA)
C
C     SEE THAT MDW IS .GT.0. GROSS CHECK ONLY.
          IF (MDW.LE.0) THEN
              WRITE (XERN1, '(I8)') MDW
              CALL XERMSG ('SLATEC', 'SBOLS', 'MDW = ' // XERN1 //
     *           ' MUST BE POSITIVE.', 2, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 190
          ENDIF
C
C     SEE THAT NUMBER OF UNKNOWNS IS POSITIVE.
          IF (NCOLS.LE.0) THEN
              WRITE (XERN1, '(I8)') NCOLS
              CALL XERMSG ('SLATEC', 'SBOLS', 'NCOLS = ' // XERN1 //
     *           ' THE NO. OF VARIABLES MUST BE POSITIVE.', 3, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 190
          ENDIF
C
C     SEE THAT CONSTRAINT INDICATORS ARE ALL WELL-DEFINED.
          DO 10 J = 1,NCOLS
              IF (IND(J).LT.1 .OR. IND(J).GT.4) THEN
                  WRITE (XERN1, '(I8)') J
                  WRITE (XERN2, '(I8)') IND(J)
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'IND(' // XERN1 // ') = ' // XERN2 //
     *               ' MUST BE 1-4.', 4, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
   10     CONTINUE
C
C     SEE THAT BOUNDS ARE CONSISTENT.
          DO 20 J = 1,NCOLS
              IF (IND(J).EQ.3) THEN
                  IF (BL(J).GT.BU(J)) THEN
                      WRITE (XERN1, '(I8)') J
                      WRITE (XERN3, '(1PE15.6)') BL(J)
                      WRITE (XERN4, '(1PE15.6)') BU(J)
                      CALL XERMSG ('SLATEC', 'SBOLS',
     *                   'BOUND BL(' // XERN1 // ') = ' // XERN3 //
     *                   ' IS .GT. BU(' // XERN1 // ') = ' // XERN4,
     *                   5, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 190
                  ENDIF
              ENDIF
   20     CONTINUE
C     END PROCEDURE
C     DO(PROCESS OPTION ARRAY)
C     PROCEDURE(PROCESS OPTION ARRAY)
          ZERO = 0.E0
          ONE = 1.E0
          CHECKL = .FALSE.
          LENX = NCOLS
          ISCALE = 1
          IGO = 2
          LOPT = 0
          LP = 0
          LDS = 0
   30     CONTINUE
          LP = LP + LDS
          IP = IOPT(LP+1)
          JP = ABS(IP)
C
C     TEST FOR NO MORE OPTIONS.
          IF (IP.EQ.99) THEN
              IF (LOPT.EQ.0) LOPT = LP + 1
              GO TO 50
          ELSE IF (JP.EQ.99) THEN
              LDS = 1
              GO TO 30
          ELSE IF (JP.EQ.1) THEN
              IF (IP.GT.0) THEN
C
C     SET UP DIRECTION FLAG, ROW STACKING POINTER
C     LOCATION, AND LOCATION FOR NUMBER OF NEW ROWS.
                  LOCACC = LP + 2
C
C                  IOPT(LOCACC-1)=OPTION NUMBER FOR SEQ. ACCUMULATION.
C     CONTENTS..   IOPT(LOCACC  )=USER DIRECTION FLAG, 1 OR 2.
C                  IOPT(LOCACC+1)=ROW STACKING POINTER.
C                  IOPT(LOCACC+2)=NUMBER OF NEW ROWS TO PROCESS.
C     USER ACTION WITH THIS OPTION..
C      (SET UP OPTION DATA FOR SEQ. ACCUMULATION IN IOPT(*).
C      MUST ALSO START PROCESS WITH IOPT(LOCACC)=1.)
C      (MOVE BLOCK OF EQUATIONS INTO W(*,*)  STARTING AT FIRST
C       ROW OF W(*,*).  SET IOPT(LOCACC+2)=NO. OF ROWS IN BLOCK.)
C              LOOP
C              CALL SBOLS()
C
C                  IF(IOPT(LOCACC) .EQ. 1) THEN
C                      STACK EQUAS., STARTING AT ROW IOPT(LOCACC+1),
C                       INTO W(*,*).
C                       SET IOPT(LOCACC+2)=NO. OF EQUAS.
C                      IF LAST BLOCK OF EQUAS., SET IOPT(LOCACC)=2.
C                  ELSE IF IOPT(LOCACC) .EQ. 2) THEN
C                      (PROCESS IS OVER. EXIT LOOP.)
C                  ELSE
C                      (ERROR CONDITION. SHOULD NOT HAPPEN.)
C                  END IF
C              END LOOP
C              SET IOPT(LOCACC-1)=-OPTION NUMBER FOR SEQ. ACCUMULATION.
C              CALL SBOLS( )
                  IOPT(LOCACC+1) = 1
                  IGO = 1
              ENDIF
              LDS = 4
              GO TO 30
          ELSE IF (JP.EQ.2) THEN
              IF (IP.GT.0) THEN
C
C     GET ACTUAL LENGTHS OF ARRAYS FOR CHECKING AGAINST NEEDS.
                  LOCDIM = LP + 2
C
C     LMDW.GE.MROWS
C     LNDW.GE.NCOLS+1
C     LLB .GE.NCOLS
C     LLX .GE.NCOLS+EXTRA REQD. IN OPTIONS.
C     LLRW.GE.5*NCOLS
C     LLIW.GE.2*NCOLS
C     LIOP.GE. AMOUNT REQD. FOR IOPTION ARRAY.
                  LMDW = IOPT(LOCDIM)
                  LNDW = IOPT(LOCDIM+1)
                  LLB = IOPT(LOCDIM+2)
                  LLX = IOPT(LOCDIM+3)
                  LLRW = IOPT(LOCDIM+4)
                  LLIW = IOPT(LOCDIM+5)
                  LIOPT = IOPT(LOCDIM+6)
                  CHECKL = .TRUE.
              ENDIF
              LDS = 8
              GO TO 30
C
C     OPTION TO MODIFY THE COLUMN SCALING.
          ELSE IF (JP.EQ.3) THEN
              IF (IP.GT.0) THEN
                  ISCALE = IOPT(LP+2)
C
C     SEE THAT ISCALE IS 1 THRU 3.
                  IF (ISCALE.LT.1 .OR. ISCALE.GT.3) THEN
                      WRITE (XERN1, '(I8)') ISCALE
                      CALL XERMSG ('SLATEC', 'SBOLS', 'ISCALE OPTION = '
     *                   // XERN1 // ' MUST BE 1-3', 7, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 190
                  ENDIF
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     IN THIS OPTION THE USER HAS PROVIDED SCALING.  THE
C     SCALE FACTORS FOR THE COLUMNS BEGIN IN X(NCOLS+IOPT(LP+2)).
          ELSE IF (JP.EQ.4) THEN
              IF (IP.GT.0) THEN
                  ISCALE = 4
                  IF (IOPT(LP+2).LE.0) THEN
                      WRITE (XERN1, '(I8)') IOPT(LP+2)
                      CALL XERMSG ('SLATEC', 'SBOLS',
     *                   'OFFSET PAST X(NCOLS) (' // XERN1 //
     *           ') FOR USER-PROVIDED COLUMN SCALING MUST BE POSITIVE.',
     *                   8, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                      GO TO 190
                  ENDIF
                  CALL SCOPY(NCOLS,X(NCOLS+IOPT(LP+2)),1,RW,1)
                  LENX = LENX + NCOLS
                  DO 40 J = 1,NCOLS
                      IF (RW(J).LE.ZERO) THEN
                          WRITE (XERN1, '(I8)') J
                          WRITE (XERN3, '(1PE15.6)') RW(J)
                          CALL XERMSG ('SLATEC', 'SBOLS',
     *                       'EACH PROVIDED COLUMN SCALE FACTOR ' //
     *                       'MUST BE POSITIVE.$$COMPONENT ' // XERN1 //
     *                       ' NOW = ' // XERN3, 9, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                          GO TO 190
                      ENDIF
   40             CONTINUE
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     IN THIS OPTION AN OPTION ARRAY IS PROVIDED TO SBOLSM().
          ELSE IF (JP.EQ.5) THEN
              IF (IP.GT.0) THEN
                  LOPT = IOPT(LP+2)
              ENDIF
              LDS = 2
C     CYCLE FOREVER
              GO TO 30
C
C     THIS OPTION USES THE NEXT LOC OF IOPT(*) AS AN
C     INCREMENT TO SKIP.
          ELSE IF (JP.EQ.6) THEN
              IF (IP.GT.0) THEN
                  LP = IOPT(LP+2) - 1
                  LDS = 0
              ELSE
                  LDS = 2
              ENDIF
C     CYCLE FOREVER
              GO TO 30
C
C     NO VALID OPTION NUMBER WAS NOTED. THIS IS AN ERROR CONDITION.
          ELSE
              WRITE (XERN1, '(I8)') JP
              CALL XERMSG ('SLATEC', 'SBOLS', 'THE OPTION NUMBER = ' //
     *           XERN1 // ' IS NOT DEFINED.', 6, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
              GO TO 190
          ENDIF
   50     CONTINUE
C     END PROCEDURE
          IF (CHECKL) THEN
C     DO(CHECK LENGTHS OF ARRAYS)
C     PROCEDURE(CHECK LENGTHS OF ARRAYS)
C
C     THIS FEATURE ALLOWS THE USER TO MAKE SURE THAT THE
C     ARRAYS ARE LONG ENOUGH FOR THE INTENDED PROBLEM SIZE AND USE.
              IF (LMDW.LT.MROWS) THEN
                  WRITE (XERN1, '(I8)') LMDW
                  WRITE (XERN2, '(I8)') MROWS
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'THE ROW DIMENSION OF W(,) = ' // XERN1 //
     *               ' MUST BE .GE. THE NUMBER OF ROWS = ' // XERN2,
     *               11, 1)
                  GO TO 190
              ENDIF
              IF (LNDW.LT.NCOLS+1) THEN
                  WRITE (XERN1, '(I8)') LNDW
                  WRITE (XERN2, '(I8)') NCOLS+1
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'THE COLUMN DIMENSION OF W(,) = ' // XERN1 //
     *               ' MUST BE .GE. NCOLS+1 = ' // XERN2, 12, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
              IF (LLB.LT.NCOLS) THEN
                  WRITE (XERN1, '(I8)') LLB
                  WRITE (XERN2, '(I8)') NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *           'THE DIMENSIONS OF THE ARRAYS BL(), BU(), AND IND() = '
     *               // XERN1 // ' MUST BE .GE. NCOLS = ' // XERN2,
     *               13, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
              IF (LLX.LT.LENX) THEN
                  WRITE (XERN1, '(I8)') LLX
                  WRITE (XERN2, '(I8)') LENX
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *              'THE DIMENSION OF X() = ' // XERN1 //
     *              ' MUST BE .GE. THE REQUIRED LENGTH = ' // XERN2,
     *              14, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
              IF (LLRW.LT.5*NCOLS) THEN
                  WRITE (XERN1, '(I8)') LLRW
                  WRITE (XERN2, '(I8)') 5*NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'THE DIMENSION OF RW() = ' // XERN1 //
     *               ' MUST BE .GE. 5*NCOLS = ' // XERN2, 15, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
              IF (LLIW.LT.2*NCOLS) THEN
                  WRITE (XERN1, '(I8)') LLIW
                  WRITE (XERN2, '(I8)') 2*NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'THE DIMENSION OF IW() = ' // XERN1 //
     *               ' MUST BE .GE. 2*NCOLS = ' // XERN2, 16, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
              IF (LIOPT.LT.LP+1) THEN
                  WRITE (XERN1, '(I8)') LIOPT
                  WRITE (XERN2, '(I8)') LP+1
                  CALL XERMSG ('SLATEC', 'SBOLS',
     *               'THE DIMENSION OF IOPT() = ' // XERN1 //
     *               ' MUST BE .GE. THE REQD. LEN = ' // XERN2, 17, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
                  GO TO 190
              ENDIF
C     END PROCEDURE
          ENDIF
      ENDIF
      GO TO (60,90),IGO
      GO TO 180
C
C     GO BACK TO THE USER FOR ACCUMULATION OF LEAST SQUARES
C     EQUATIONS AND DIRECTIONS TO QUIT PROCESSING.
C     CASE 1
   60 CONTINUE
C     DO(ACCUMULATE LEAST SQUARES EQUATIONS)
C     PROCEDURE(ACCUMULATE LEAST SQUARES EQUATIONS)
      MROWS = IOPT(LOCACC+1) - 1
      INROWS = IOPT(LOCACC+2)
      MNEW = MROWS + INROWS
      IF (MNEW.LT.0 .OR. MNEW.GT.MDW) THEN
          WRITE (XERN1, '(I8)') MNEW
          WRITE (XERN2, '(I8)') MDW
          CALL XERMSG ('SLATEC', 'SBOLS', 'NO. OF ROWS = ' // XERN1 //
     *       ' MUST BE .GE. 0 .AND. .LE. MDW = ' // XERN2, 10, 1)
C     DO(RETURN TO USER PROGRAM UNIT)
          GO TO 190
      ENDIF
      DO 80 J = 1,MIN(NCOLS+1,MNEW)
          DO 70 I = MNEW,MAX(MROWS,J) + 1,-1
              IBIG = ISAMAX(I-J,W(J,J),1) + J - 1
C
C     PIVOT FOR INCREASED STABILITY.
              CALL SROTG(W(IBIG,J),W(I,J),SC,SS)
              CALL SROT(NCOLS+1-J,W(IBIG,J+1),MDW,W(I,J+1),MDW,SC,SS)
              W(I,J) = ZERO
   70     CONTINUE
   80 CONTINUE
      MROWS = MIN(NCOLS+1,MNEW)
      IOPT(LOCACC+1) = MROWS + 1
      IGO = IOPT(LOCACC)
C     END PROCEDURE
      IF (IGO.EQ.2) THEN
          IGO = 0
      ENDIF
      GO TO 180
C     CASE 2
   90 CONTINUE
C     DO(INITIALIZE VARIABLES AND DATA VALUES)
C     PROCEDURE(INITIALIZE VARIABLES AND DATA VALUES)
      DO 150 J = 1,NCOLS
          GO TO (100,110,120,130),ISCALE
          GO TO 140
  100     CONTINUE
C     CASE 1
C
C     THIS IS THE NOMINAL SCALING. EACH NONZERO
C     COL. HAS MAX. NORM EQUAL TO ONE.
          IBIG = ISAMAX(MROWS,W(1,J),1)
          RW(J) = ABS(W(IBIG,J))
          IF (RW(J).EQ.ZERO) THEN
              RW(J) = ONE
          ELSE
              RW(J) = ONE/RW(J)
          ENDIF
          GO TO 140
  110     CONTINUE
C     CASE 2
C
C     THIS CHOICE OF SCALING MAKES EACH NONZERO COLUMN
C     HAVE EUCLIDEAN LENGTH EQUAL TO ONE.
          RW(J) = SNRM2(MROWS,W(1,J),1)
          IF (RW(J).EQ.ZERO) THEN
              RW(J) = ONE
          ELSE
              RW(J) = ONE/RW(J)
          ENDIF
          GO TO 140
  120     CONTINUE
C     CASE 3
C
C     THIS CASE EFFECTIVELY SUPPRESSES SCALING BY SETTING
C     THE SCALING MATRIX TO THE IDENTITY MATRIX.
          RW(1) = ONE
          CALL SCOPY(NCOLS,RW,0,RW,1)
          GO TO 160
  130     CONTINUE
C     CASE 4
          GO TO 160
  140     CONTINUE
  150 CONTINUE
  160 CONTINUE
C     END PROCEDURE
C     DO(SOLVE BOUNDED LEAST SQUARES PROBLEM)
C     PROCEDURE(SOLVE BOUNDED LEAST SQUARES PROBLEM)
C
C     INITIALIZE IBASIS(*), J=1,NCOLS, AND IBB(*), J=1,NCOLS,
C     TO =J,AND =1, FOR USE IN SBOLSM( ).
      DO 170 J = 1,NCOLS
          IW(J) = J
          IW(J+NCOLS) = 1
          RW(3*NCOLS+J) = BL(J)
          RW(4*NCOLS+J) = BU(J)
  170 CONTINUE
      CALL SBOLSM(W,MDW,MROWS,NCOLS,RW(3*NCOLS+1),RW(4*NCOLS+1),IND,
     .            IOPT(LOPT),X,RNORM,MODE,RW(NCOLS+1),RW(2*NCOLS+1),RW,
     .            IW,IW(NCOLS+1))
C     END PROCEDURE
      IGO = 0
  180 CONTINUE
      RETURN
C     PROCEDURE(RETURN TO USER PROGRAM UNIT)
  190 IF(MODE.GE.0)MODE = -NERR
      IGO = 0
      RETURN
C     END PROCEDURE
      END
*DECK SBOLSM
      SUBROUTINE SBOLSM (W, MDW, MINPUT, NCOLS, BL, BU, IND, IOPT, X,
     +   RNORM, MODE, RW, WW, SCL, IBASIS, IBB)
C***BEGIN PROLOGUE  SBOLSM
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SBOCLS and SBOLS
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (SBOLSM-S, DBOLSM-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C          Solve E*X = F (least squares sense) with bounds on
C            selected X values.
C     The user must have DIMENSION statements of the form:
C
C       DIMENSION W(MDW,NCOLS+1), BL(NCOLS), BU(NCOLS),
C      * X(NCOLS+NX), RW(NCOLS), WW(NCOLS), SCL(NCOLS)
C       INTEGER IND(NCOLS), IOPT(1+NI), IBASIS(NCOLS), IBB(NCOLS)
C
C     (Here NX=number of extra locations required for options 1,...,7;
C     NX=0 for no options; here NI=number of extra locations possibly
C     required for options 1-7; NI=0 for no options; NI=14 if all the
C     options are simultaneously in use.)
C
C    INPUT
C    -----
C
C    --------------------
C    W(MDW,*),MINPUT,NCOLS
C    --------------------
C     The array W(*,*) contains the matrix [E:F] on entry. The matrix
C     [E:F] has MINPUT rows and NCOLS+1 columns. This data is placed in
C     the array W(*,*) with E occupying the first NCOLS columns and the
C     right side vector F in column NCOLS+1. The row dimension, MDW, of
C     the array W(*,*) must satisfy the inequality MDW .ge. MINPUT.
C     Other values of MDW are errors. The values of MINPUT and NCOLS
C     must be positive. Other values are errors.
C
C    ------------------
C    BL(*),BU(*),IND(*)
C    ------------------
C     These arrays contain the information about the bounds that the
C     solution values are to satisfy. The value of IND(J) tells the
C     type of bound and BL(J) and BU(J) give the explicit values for
C     the respective upper and lower bounds.
C
C    1.    For IND(J)=1, require X(J) .ge. BL(J).
C    2.    For IND(J)=2, require X(J) .le. BU(J).
C    3.    For IND(J)=3, require X(J) .ge. BL(J) and
C                                X(J) .le. BU(J).
C    4.    For IND(J)=4, no bounds on X(J) are required.
C     The values of BL(*),BL(*) are modified by the subprogram. Values
C     other than 1,2,3 or 4 for IND(J) are errors. In the case IND(J)=3
C     (upper and lower bounds) the condition BL(J) .gt. BU(J) is an
C     error.
C
C    -------
C    IOPT(*)
C    -------
C     This is the array where the user can specify nonstandard options
C     for SBOLSM. Most of the time this feature can be ignored by
C     setting the input value IOPT(1)=99. Occasionally users may have
C     needs that require use of the following subprogram options. For
C     details about how to use the options see below: IOPT(*) CONTENTS.
C
C     Option Number   Brief Statement of Purpose
C     ----- ------   ----- --------- -- -------
C           1         Move the IOPT(*) processing pointer.
C           2         Change rank determination tolerance.
C           3         Change blow-up factor that determines the
C                     size of variables being dropped from active
C                     status.
C           4         Reset the maximum number of iterations to use
C                     in solving the problem.
C           5         The data matrix is triangularized before the
C                     problem is solved whenever (NCOLS/MINPUT) .lt.
C                     FAC. Change the value of FAC.
C           6         Redefine the weighting matrix used for
C                     linear independence checking.
C           7         Debug output is desired.
C          99         No more options to change.
C
C    ----
C    X(*)
C    ----
C     This array is used to pass data associated with options 1,2,3 and
C     5. Ignore this input parameter if none of these options are used.
C     Otherwise see below: IOPT(*) CONTENTS.
C
C    ----------------
C    IBASIS(*),IBB(*)
C    ----------------
C     These arrays must be initialized by the user. The values
C         IBASIS(J)=J, J=1,...,NCOLS
C         IBB(J)   =1, J=1,...,NCOLS
C     are appropriate except when using nonstandard features.
C
C    ------
C    SCL(*)
C    ------
C     This is the array of scaling factors to use on the columns of the
C     matrix E. These values must be defined by the user. To suppress
C     any column scaling set SCL(J)=1.0, J=1,...,NCOLS.
C
C    OUTPUT
C    ------
C
C    ----------
C    X(*),RNORM
C    ----------
C     The array X(*) contains a solution (if MODE .ge. 0 or .eq. -22)
C     for the constrained least squares problem. The value RNORM is the
C     minimum residual vector length.
C
C    ----
C    MODE
C    ----
C     The sign of mode determines whether the subprogram has completed
C     normally, or encountered an error condition or abnormal status.
C     A value of MODE .ge. 0 signifies that the subprogram has completed
C     normally. The value of MODE (.ge. 0) is the number of variables
C     in an active status: not at a bound nor at the value ZERO, for
C     the case of free variables. A negative value of MODE will be one
C     of the 18 cases -38,-37,...,-22, or -1. Values .lt. -1 correspond
C     to an abnormal completion of the subprogram. To understand the
C     abnormal completion codes see below: ERROR MESSAGES for SBOLSM
C     An approximate solution will be returned to the user only when
C     maximum iterations is reached, MODE=-22.
C
C    -----------
C    RW(*),WW(*)
C    -----------
C     These are working arrays each with NCOLS entries. The array RW(*)
C     contains the working (scaled, nonactive) solution values. The
C     array WW(*) contains the working (scaled, active) gradient vector
C     values.
C
C    ----------------
C    IBASIS(*),IBB(*)
C    ----------------
C     These arrays contain information about the status of the solution
C     when MODE .ge. 0. The indices IBASIS(K), K=1,...,MODE, show the
C     nonactive variables; indices IBASIS(K), K=MODE+1,..., NCOLS are
C     the active variables. The value (IBB(J)-1) is the number of times
C     variable J was reflected from its upper bound. (Normally the user
C     can ignore these parameters.)
C
C    IOPT(*) CONTENTS
C    ------- --------
C     The option array allows a user to modify internal variables in
C     the subprogram without recompiling the source code. A central
C     goal of the initial software design was to do a good job for most
C     people. Thus the use of options will be restricted to a select
C     group of users. The processing of the option array proceeds as
C     follows: a pointer, here called LP, is initially set to the value
C     1. The value is updated as the options are processed.  At the
C     pointer position the option number is extracted and used for
C     locating other information that allows for options to be changed.
C     The portion of the array IOPT(*) that is used for each option is
C     fixed; the user and the subprogram both know how many locations
C     are needed for each option. A great deal of error checking is
C     done by the subprogram on the contents of the option array.
C     Nevertheless it is still possible to give the subprogram optional
C     input that is meaningless. For example, some of the options use
C     the location X(NCOLS+IOFF) for passing data. The user must manage
C     the allocation of these locations when more than one piece of
C     option data is being passed to the subprogram.
C
C   1
C   -
C     Move the processing pointer (either forward or backward) to the
C     location IOPT(LP+1). The processing pointer is moved to location
C     LP+2 of IOPT(*) in case IOPT(LP)=-1.  For example to skip over
C     locations 3,...,NCOLS+2 of IOPT(*),
C
C       IOPT(1)=1
C       IOPT(2)=NCOLS+3
C       (IOPT(I), I=3,...,NCOLS+2 are not defined here.)
C       IOPT(NCOLS+3)=99
C       CALL SBOLSM
C
C     CAUTION: Misuse of this option can yield some very hard-to-find
C     bugs.  Use it with care.
C
C   2
C   -
C     The algorithm that solves the bounded least squares problem
C     iteratively drops columns from the active set. This has the
C     effect of joining a new column vector to the QR factorization of
C     the rectangular matrix consisting of the partially triangularized
C     nonactive columns. After triangularizing this matrix a test is
C     made on the size of the pivot element. The column vector is
C     rejected as dependent if the magnitude of the pivot element is
C     .le. TOL* magnitude of the column in components strictly above
C     the pivot element. Nominally the value of this (rank) tolerance
C     is TOL = SQRT(R1MACH(4)). To change only the value of TOL, for
C     example,
C
C       X(NCOLS+1)=TOL
C       IOPT(1)=2
C       IOPT(2)=1
C       IOPT(3)=99
C       CALL SBOLSM
C
C     Generally, if LP is the processing pointer for IOPT(*),
C
C       X(NCOLS+IOFF)=TOL
C       IOPT(LP)=2
C       IOPT(LP+1)=IOFF
C        .
C       CALL SBOLSM
C
C     The required length of IOPT(*) is increased by 2 if option 2 is
C     used; The required length of X(*) is increased by 1. A value of
C     IOFF .le. 0 is an error. A value of TOL .le. R1MACH(4) gives a
C     warning message; it is not considered an error.
C
C   3
C   -
C     A solution component is left active (not used) if, roughly
C     speaking, it seems too large. Mathematically the new component is
C     left active if the magnitude is .ge.((vector norm of F)/(matrix
C     norm of E))/BLOWUP. Nominally the factor BLOWUP = SQRT(R1MACH(4)).
C     To change only the value of BLOWUP, for example,
C
C       X(NCOLS+2)=BLOWUP
C       IOPT(1)=3
C       IOPT(2)=2
C       IOPT(3)=99
C       CALL SBOLSM
C
C     Generally, if LP is the processing pointer for IOPT(*),
C
C       X(NCOLS+IOFF)=BLOWUP
C       IOPT(LP)=3
C       IOPT(LP+1)=IOFF
C        .
C       CALL SBOLSM
C
C     The required length of IOPT(*) is increased by 2 if option 3 is
C     used; the required length of X(*) is increased by 1. A value of
C     IOFF .le. 0 is an error. A value of BLOWUP .le. 0.0 is an error.
C
C   4
C   -
C     Normally the algorithm for solving the bounded least squares
C     problem requires between NCOLS/3 and NCOLS drop-add steps to
C     converge. (this remark is based on examining a small number of
C     test cases.) The amount of arithmetic for such problems is
C     typically about twice that required for linear least squares if
C     there are no bounds and if plane rotations are used in the
C     solution method. Convergence of the algorithm, while
C     mathematically certain, can be much slower than indicated. To
C     avoid this potential but unlikely event ITMAX drop-add steps are
C     permitted. Nominally ITMAX=5*(MAX(MINPUT,NCOLS)). To change the
C     value of ITMAX, for example,
C
C       IOPT(1)=4
C       IOPT(2)=ITMAX
C       IOPT(3)=99
C       CALL SBOLSM
C
C     Generally, if LP is the processing pointer for IOPT(*),
C
C       IOPT(LP)=4
C       IOPT(LP+1)=ITMAX
C        .
C       CALL SBOLSM
C
C     The value of ITMAX must be .gt. 0. Other values are errors. Use
C     of this option increases the required length of IOPT(*) by 2.
C
C   5
C   -
C     For purposes of increased efficiency the MINPUT by NCOLS+1 data
C     matrix [E:F] is triangularized as a first step whenever MINPUT
C     satisfies FAC*MINPUT .gt. NCOLS. Nominally FAC=0.75. To change the
C     value of FAC,
C
C       X(NCOLS+3)=FAC
C       IOPT(1)=5
C       IOPT(2)=3
C       IOPT(3)=99
C       CALL SBOLSM
C
C     Generally, if LP is the processing pointer for IOPT(*),
C
C       X(NCOLS+IOFF)=FAC
C       IOPT(LP)=5
C       IOPT(LP+1)=IOFF
C        .
C       CALL SBOLSM
C
C     The value of FAC must be nonnegative. Other values are errors.
C     Resetting FAC=0.0 suppresses the initial triangularization step.
C     Use of this option increases the required length of IOPT(*) by 2;
C     The required length of of X(*) is increased by 1.
C
C   6
C   -
C     The norm used in testing the magnitudes of the pivot element
C     compared to the mass of the column above the pivot line can be
C     changed. The type of change that this option allows is to weight
C     the components with an index larger than MVAL by the parameter
C     WT. Normally MVAL=0 and WT=1. To change both the values MVAL and
C     WT, where LP is the processing pointer for IOPT(*),
C
C       X(NCOLS+IOFF)=WT
C       IOPT(LP)=6
C       IOPT(LP+1)=IOFF
C       IOPT(LP+2)=MVAL
C
C     Use of this option increases the required length of IOPT(*) by 3.
C     The length of X(*) is increased by 1. Values of MVAL must be
C     nonnegative and not greater than MINPUT. Other values are errors.
C     The value of WT must be positive. Any other value is an error. If
C     either error condition is present a message will be printed.
C
C   7
C   -
C     Debug output, showing the detailed add-drop steps for the
C     constrained least squares problem, is desired. This option is
C     intended to be used to locate suspected bugs.
C
C   99
C   --
C     There are no more options to change.
C
C     The values for options are 1,...,7,99, and are the only ones
C     permitted. Other values are errors. Options -99,-1,...,-7 mean
C     that the repective options 99,1,...,7 are left at their default
C     values. An example is the option to modify the (rank) tolerance:
C
C       X(NCOLS+1)=TOL
C       IOPT(1)=-2
C       IOPT(2)=1
C       IOPT(3)=99
C
C    Error Messages for SBOLSM
C    ----- -------- --- ---------
C    -22    MORE THAN ITMAX = ... ITERATIONS SOLVING BOUNDED LEAST
C           SQUARES PROBLEM.
C
C    -23    THE OPTION NUMBER = ... IS NOT DEFINED.
C
C    -24    THE OFFSET = ... BEYOND POSTION NCOLS = ... MUST BE POSITIVE
C           FOR OPTION NUMBER 2.
C
C    -25    THE TOLERANCE FOR RANK DETERMINATION = ... IS LESS THAN
C           MACHINE PRECISION = ....
C
C    -26    THE OFFSET = ... BEYOND POSITION NCOLS = ... MUST BE POSTIVE
C           FOR OPTION NUMBER 3.
C
C    -27    THE RECIPROCAL OF THE BLOW-UP FACTOR FOR REJECTING VARIABLES
C           MUST BE POSITIVE. NOW = ....
C
C    -28    THE MAXIMUM NUMBER OF ITERATIONS = ... MUST BE POSITIVE.
C
C    -29    THE OFFSET = ... BEYOND POSITION NCOLS = ... MUST BE POSTIVE
C           FOR OPTION NUMBER 5.
C
C    -30    THE FACTOR (NCOLS/MINPUT) WHERE PRETRIANGULARIZING IS
C           PERFORMED MUST BE NONNEGATIVE. NOW = ....
C
C    -31    THE NUMBER OF ROWS = ... MUST BE POSITIVE.
C
C    -32    THE NUMBER OF COLUMNS = ... MUST BE POSTIVE.
C
C    -33    THE ROW DIMENSION OF W(,) = ... MUST BE .GE. THE NUMBER OF
C           ROWS = ....
C
C    -34    FOR J = ... THE CONSTRAINT INDICATOR MUST BE 1-4.
C
C    -35    FOR J = ... THE LOWER BOUND = ... IS .GT. THE UPPER BOUND =
C           ....
C
C    -36    THE INPUT ORDER OF COLUMNS = ... IS NOT BETWEEN 1 AND NCOLS
C           = ....
C
C    -37    THE BOUND POLARITY FLAG IN COMPONENT J = ... MUST BE
C           POSITIVE. NOW = ....
C
C    -38    THE ROW SEPARATOR TO APPLY WEIGHTING (...) MUST LIE BETWEEN
C           0 AND MINPUT = .... WEIGHT = ... MUST BE POSITIVE.
C
C***SEE ALSO  SBOCLS, SBOLS
C***ROUTINES CALLED  IVOUT, R1MACH, SAXPY, SCOPY, SDOT, SMOUT, SNRM2,
C                    SROT, SROTG, SSWAP, SVOUT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   821220  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920422  Fixed usage of MINPUT.  (WRB)
C   901009  Editorial changes, code now reads from top to bottom.  (RWC)
C***END PROLOGUE  SBOLSM
C
C     PURPOSE
C     -------
C     THIS IS THE MAIN SUBPROGRAM THAT SOLVES THE BOUNDED
C     LEAST SQUARES PROBLEM.  THE PROBLEM SOLVED HERE IS:
C
C     SOLVE E*X =  F  (LEAST SQUARES SENSE)
C     WITH BOUNDS ON SELECTED X VALUES.
C
C     TO CHANGE THIS SUBPROGRAM FROM SINGLE TO DOUBLE PRECISION BEGIN
C     EDITING AT THE CARD 'C++'.
C     CHANGE THE SUBPROGRAM NAME TO DBOLSM AND THE STRINGS
C     /SAXPY/ TO /DAXPY/, /SCOPY/ TO /DCOPY/,
C     /SDOT/ TO /DDOT/, /SNRM2/ TO /DNRM2/,
C     /SROT/ TO /DROT/, /SROTG/ TO /DROTG/, /R1MACH/ TO /D1MACH/,
C     /SVOUT/ TO /DVOUT/, /SMOUT/ TO /DMOUT/,
C     /SSWAP/ TO /DSWAP/, /E0/ TO /D0/,
C     /REAL            / TO /DOUBLE PRECISION/.
C++
C
      REAL W(MDW,*),BL(*),BU(*)
      REAL X(*),RW(*),WW(*),SCL(*)
      REAL ALPHA,BETA,BOU,COLABV,COLBLO
      REAL CL1,CL2,CL3,ONE,BIG
      REAL FAC,RNORM,SC,SS,T,TOLIND,WT
      REAL TWO,T1,T2,WBIG,WLARGE,WMAG,XNEW
      REAL ZERO,SDOT,SNRM2
      REAL R1MACH,TOLSZE
      INTEGER IBASIS(*),IBB(*),IND(*),IOPT(*)
      LOGICAL FOUND,CONSTR
      CHARACTER*8 XERN1, XERN2
      CHARACTER*16 XERN3, XERN4
C
      PARAMETER (ZERO=0.0E0, ONE=1.0E0, TWO=2.0E0)
C
      INEXT(IDUM) = MIN(IDUM+1,MROWS)
C***FIRST EXECUTABLE STATEMENT  SBOLSM
C
C     Verify that the problem dimensions are defined properly.
C
      IF (MINPUT.LE.0) THEN
          WRITE (XERN1, '(I8)') MINPUT
          CALL XERMSG ('SLATEC', 'SBOLSM', 'THE NUMBER OF ROWS = ' //
     *       XERN1 // ' MUST BE POSITIVE.', 31, 1)
          MODE = -31
          RETURN
      ENDIF
C
      IF (NCOLS.LE.0) THEN
          WRITE (XERN1, '(I8)') NCOLS
          CALL XERMSG ('SLATEC', 'SBOLSM', 'THE NUMBER OF COLUMNS = ' //
     *       XERN1 // ' MUST BE POSITIVE.', 32, 1)
          MODE = -32
          RETURN
      ENDIF
C
      IF (MDW.LT.MINPUT) THEN
          WRITE (XERN1, '(I8)') MDW
          WRITE (XERN2, '(I8)') MINPUT
          CALL XERMSG ('SLATEC', 'SBOLSM',
     *       'THE ROW DIMENSION OF W(,) = ' // XERN1 //
     *       ' MUST BE .GE. THE NUMBER OF ROWS = ' // XERN2, 33, 1)
          MODE = -33
          RETURN
      ENDIF
C
C     Verify that bound information is correct.
C
      DO 10 J = 1,NCOLS
          IF (IND(J).LT.1 .OR. IND(J).GT.4) THEN
              WRITE (XERN1, '(I8)') J
              WRITE (XERN2, '(I8)') IND(J)
              CALL XERMSG ('SLATEC', 'SBOLSM', 'FOR J = ' // XERN1 //
     *           ' THE CONSTRAINT INDICATOR MUST BE 1-4', 34, 1)
              MODE = -34
              RETURN
          ENDIF
   10 CONTINUE
C
      DO 20 J = 1,NCOLS
          IF (IND(J).EQ.3) THEN
              IF (BU(J).LT.BL(J)) THEN
                  WRITE (XERN1, '(I8)') J
                  WRITE (XERN3, '(1PE15.6)') BL(J)
                  WRITE (XERN4, '(1PE15.6)') BU(J)
                  CALL XERMSG ('SLATEC', 'SBOLSM', 'FOR J = ' // XERN1
     *               // ' THE LOWER BOUND = ' // XERN3 //
     *               ' IS .GT. THE UPPER BOUND = ' // XERN4, 35, 1)
                  MODE = -35
                  RETURN
              ENDIF
          ENDIF
   20 CONTINUE
C
C     Check that permutation and polarity arrays have been set.
C
      DO 30 J = 1,NCOLS
          IF (IBASIS(J).LT.1 .OR. IBASIS(J).GT.NCOLS) THEN
              WRITE (XERN1, '(I8)') IBASIS(J)
              WRITE (XERN2, '(I8)') NCOLS
              CALL XERMSG ('SLATEC', 'SBOLSM',
     *           'THE INPUT ORDER OF COLUMNS = ' // XERN1 //
     *           ' IS NOT BETWEEN 1 AND NCOLS = ' // XERN2, 36, 1)
              MODE = -36
              RETURN
          ENDIF
C
          IF (IBB(J).LE.0) THEN
              WRITE (XERN1, '(I8)') J
              WRITE (XERN2, '(I8)') IBB(J)
              CALL XERMSG ('SLATEC', 'SBOLSM',
     *           'THE BOUND POLARITY FLAG IN COMPONENT J = ' // XERN1 //
     *           ' MUST BE POSITIVE.$$NOW = ' // XERN2, 37, 1)
              MODE = -37
              RETURN
          ENDIF
   30 CONTINUE
C
C     Process the option array.
C
      FAC = 0.75E0
      TOLIND = SQRT(R1MACH(4))
      TOLSZE = SQRT(R1MACH(4))
      ITMAX = 5*MAX(MINPUT,NCOLS)
      WT = ONE
      MVAL = 0
      IPRINT = 0
C
C     Changes to some parameters can occur through the option array,
C     IOPT(*).  Process this array looking carefully for input data
C     errors.
C
      LP = 0
      LDS = 0
C
C     Test for no more options.
C
  590 LP = LP + LDS
      IP = IOPT(LP+1)
      JP = ABS(IP)
      IF (IP.EQ.99) THEN
          GO TO 470
      ELSE IF (JP.EQ.99) THEN
          LDS = 1
      ELSE IF (JP.EQ.1) THEN
C
C         Move the IOPT(*) processing pointer.
C
          IF (IP.GT.0) THEN
              LP = IOPT(LP+2) - 1
              LDS = 0
          ELSE
              LDS = 2
          ENDIF
      ELSE IF (JP.EQ.2) THEN
C
C         Change tolerance for rank determination.
C
          IF (IP.GT.0) THEN
              IOFF = IOPT(LP+2)
              IF (IOFF.LE.0) THEN
                  WRITE (XERN1, '(I8)') IOFF
                  WRITE (XERN2, '(I8)') NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLSM', 'THE OFFSET = ' //
     *               XERN1 // ' BEYOND POSITION NCOLS = ' // XERN2 //
     *               ' MUST BE POSITIVE FOR OPTION NUMBER 2.', 24, 1)
                  MODE = -24
                  RETURN
              ENDIF
C
              TOLIND = X(NCOLS+IOFF)
              IF (TOLIND.LT.R1MACH(4)) THEN
                  WRITE (XERN3, '(1PE15.6)') TOLIND
                  WRITE (XERN4, '(1PE15.6)') R1MACH(4)
                  CALL XERMSG ('SLATEC', 'SBOLSM',
     *               'THE TOLERANCE FOR RANK DETERMINATION = ' // XERN3
     *               // ' IS LESS THAN MACHINE PRECISION = ' // XERN4,
     *               25, 0)
                  MODE = -25
              ENDIF
          ENDIF
          LDS = 2
      ELSE IF (JP.EQ.3) THEN
C
C         Change blowup factor for allowing variables to become
C         inactive.
C
          IF (IP.GT.0) THEN
              IOFF = IOPT(LP+2)
              IF (IOFF.LE.0) THEN
                  WRITE (XERN1, '(I8)') IOFF
                  WRITE (XERN2, '(I8)') NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLSM', 'THE OFFSET = ' //
     *               XERN1 // ' BEYOND POSITION NCOLS = ' // XERN2 //
     *               ' MUST BE POSITIVE FOR OPTION NUMBER 3.', 26, 1)
                  MODE = -26
                  RETURN
              ENDIF
C
              TOLSZE = X(NCOLS+IOFF)
              IF (TOLSZE.LE.ZERO) THEN
                  WRITE (XERN3, '(1PE15.6)') TOLSZE
                  CALL XERMSG ('SLATEC', 'SBOLSM', 'THE RECIPROCAL ' //
     *               'OF THE BLOW-UP FACTOR FOR REJECTING VARIABLES ' //
     *               'MUST BE POSITIVE.$$NOW = ' // XERN3, 27, 1)
                  MODE = -27
                  RETURN
              ENDIF
          ENDIF
          LDS = 2
      ELSE IF (JP.EQ.4) THEN
C
C         Change the maximum number of iterations allowed.
C
          IF (IP.GT.0) THEN
              ITMAX = IOPT(LP+2)
              IF (ITMAX.LE.0) THEN
                  WRITE (XERN1, '(I8)') ITMAX
                  CALL XERMSG ('SLATEC', 'SBOLSM',
     *               'THE MAXIMUM NUMBER OF ITERATIONS = ' // XERN1 //
     *               ' MUST BE POSITIVE.', 28, 1)
                  MODE = -28
                  RETURN
              ENDIF
          ENDIF
          LDS = 2
      ELSE IF (JP.EQ.5) THEN
C
C         Change the factor for pretriangularizing the data matrix.
C
          IF (IP.GT.0) THEN
              IOFF = IOPT(LP+2)
              IF (IOFF.LE.0) THEN
                  WRITE (XERN1, '(I8)') IOFF
                  WRITE (XERN2, '(I8)') NCOLS
                  CALL XERMSG ('SLATEC', 'SBOLSM', 'THE OFFSET = ' //
     *               XERN1 // ' BEYOND POSITION NCOLS = ' // XERN2 //
     *               ' MUST BE POSITIVE FOR OPTION NUMBER 5.', 29, 1)
                  MODE = -29
                  RETURN
              ENDIF
C
              FAC = X(NCOLS+IOFF)
              IF (FAC.LT.ZERO) THEN
                  WRITE (XERN3, '(1PE15.6)') FAC
                  CALL XERMSG ('SLATEC', 'SBOLSM',
     *               'THE FACTOR (NCOLS/MINPUT) WHERE PRE-' //
     *               'TRIANGULARIZING IS PERFORMED MUST BE NON-' //
     *               'NEGATIVE.$$NOW = ' // XERN3, 30, 0)
                  MODE = -30
                  RETURN
              ENDIF
          ENDIF
          LDS = 2
      ELSE IF (JP.EQ.6) THEN
C
C         Change the weighting factor (from 1.0) to apply to components
C         numbered .gt. MVAL (initially set to 1.)  This trick is needed
C         for applications of this subprogram to the heavily weighted
C         least squares problem that come from equality constraints.
C
          IF (IP.GT.0) THEN
              IOFF = IOPT(LP+2)
              MVAL = IOPT(LP+3)
              WT = X(NCOLS+IOFF)
          ENDIF
C
          IF (MVAL.LT.0 .OR. MVAL.GT.MINPUT .OR. WT.LE.ZERO) THEN
              WRITE (XERN1, '(I8)') MVAL
              WRITE (XERN2, '(I8)') MINPUT
              WRITE (XERN3, '(1PE15.6)') WT
              CALL XERMSG ('SLATEC', 'SBOLSM',
     *           'THE ROW SEPARATOR TO APPLY WEIGHTING (' // XERN1 //
     *           ') MUST LIE BETWEEN 0 AND MINPUT = ' // XERN2 //
     *           '.$$WEIGHT = ' // XERN3 // ' MUST BE POSITIVE.', 38, 0)
              MODE = -38
              RETURN
          ENDIF
          LDS = 3
      ELSE IF (JP.EQ.7) THEN
C
C         Turn on debug output.
C
          IF (IP.GT.0) IPRINT = 1
          LDS = 2
      ELSE
          WRITE (XERN1, '(I8)') IP
          CALL XERMSG ('SLATEC', 'SBOLSM', 'THE OPTION NUMBER = ' //
     *       XERN1 // ' IS NOT DEFINED.', 23, 1)
          MODE = -23
          RETURN
      ENDIF
      GO TO 590
C
C     Pretriangularize rectangular arrays of certain sizes for
C     increased efficiency.
C
  470 IF (FAC*MINPUT.GT.NCOLS) THEN
          DO 490 J = 1,NCOLS+1
              DO 480 I = MINPUT,J+MVAL+1,-1
                  CALL SROTG(W(I-1,J),W(I,J),SC,SS)
                  W(I,J) = ZERO
                  CALL SROT(NCOLS-J+1,W(I-1,J+1),MDW,W(I,J+1),MDW,SC,SS)
  480         CONTINUE
  490     CONTINUE
          MROWS = NCOLS + MVAL + 1
      ELSE
          MROWS = MINPUT
      ENDIF
C
C     Set the X(*) array to zero so all components are defined.
C
      CALL SCOPY(NCOLS,ZERO,0,X,1)
C
C     The arrays IBASIS(*) and IBB(*) are initialized by the calling
C     program and the column scaling is defined in the calling program.
C     'BIG' is plus infinity on this machine.
C
      BIG = R1MACH(2)
      DO 550 J = 1,NCOLS
          IF (IND(J).EQ.1) THEN
              BU(J) = BIG
          ELSE IF (IND(J).EQ.2) THEN
              BL(J) = -BIG
          ELSE IF (IND(J).EQ.4) THEN
              BL(J) = -BIG
              BU(J) = BIG
          ENDIF
  550 CONTINUE
C
      DO 570 J = 1,NCOLS
          IF ((BL(J).LE.ZERO.AND.ZERO.LE.BU(J).AND.ABS(BU(J)).LT.
     *        ABS(BL(J))) .OR. BU(J).LT.ZERO) THEN
              T = BU(J)
              BU(J) = -BL(J)
              BL(J) = -T
              SCL(J) = -SCL(J)
              DO 560 I = 1,MROWS
                  W(I,J) = -W(I,J)
  560         CONTINUE
          ENDIF
C
C         Indices in set T(=TIGHT) are denoted by negative values
C         of IBASIS(*).
C
          IF (BL(J).GE.ZERO) THEN
              IBASIS(J) = -IBASIS(J)
              T = -BL(J)
              BU(J) = BU(J) + T
              CALL SAXPY(MROWS,T,W(1,J),1,W(1,NCOLS+1),1)
          ENDIF
  570 CONTINUE
C
      NSETB = 0
      ITER = 0
C
      IF (IPRINT.GT.0) THEN
          CALL SMOUT(MROWS,NCOLS+1,MDW,W,'('' PRETRI. INPUT MATRIX'')',
     *               -4)
          CALL SVOUT(NCOLS,BL,'('' LOWER BOUNDS'')',-4)
          CALL SVOUT(NCOLS,BU,'('' UPPER BOUNDS'')',-4)
      ENDIF
C
  580 ITER = ITER + 1
      IF (ITER.GT.ITMAX) THEN
         WRITE (XERN1, '(I8)') ITMAX
         CALL XERMSG ('SLATEC', 'SBOLSM', 'MORE THAN ITMAX = ' // XERN1
     *      // ' ITERATIONS SOLVING BOUNDED LEAST SQUARES PROBLEM.',
     *      22, 1)
         MODE = -22
C
C        Rescale and translate variables.
C
         IGOPR = 1
         GO TO 130
      ENDIF
C
C     Find a variable to become non-active.
C                                                 T
C     Compute (negative) of gradient vector, W = E *(F-E*X).
C
      CALL SCOPY(NCOLS,ZERO,0,WW,1)
      DO 200 J = NSETB+1,NCOLS
          JCOL = ABS(IBASIS(J))
          WW(J) = SDOT(MROWS-NSETB,W(INEXT(NSETB),J),1,
     *            W(INEXT(NSETB),NCOLS+1),1)*ABS(SCL(JCOL))
  200 CONTINUE
C
      IF (IPRINT.GT.0) THEN
          CALL SVOUT(NCOLS,WW,'('' GRADIENT VALUES'')',-4)
          CALL IVOUT(NCOLS,IBASIS,'('' INTERNAL VARIABLE ORDER'')',-4)
          CALL IVOUT(NCOLS,IBB,'('' BOUND POLARITY'')',-4)
      ENDIF
C
C     If active set = number of total rows, quit.
C
  210 IF (NSETB.EQ.MROWS) THEN
          FOUND = .FALSE.
          GO TO 120
      ENDIF
C
C     Choose an extremal component of gradient vector for a candidate
C     to become non-active.
C
      WLARGE = -BIG
      WMAG = -BIG
      DO 220 J = NSETB+1,NCOLS
          T = WW(J)
          IF (T.EQ.BIG) GO TO 220
          ITEMP = IBASIS(J)
          JCOL = ABS(ITEMP)
          T1 = SNRM2(MVAL-NSETB,W(INEXT(NSETB),J),1)
          IF (ITEMP.LT.0) THEN
              IF (MOD(IBB(JCOL),2).EQ.0) T = -T
              IF (T.LT.ZERO) GO TO 220
              IF (MVAL.GT.NSETB) T = T1
              IF (T.GT.WLARGE) THEN
                  WLARGE = T
                  JLARGE = J
              ENDIF
          ELSE
              IF (MVAL.GT.NSETB) T = T1
              IF (ABS(T).GT.WMAG) THEN
                  WMAG = ABS(T)
                  JMAG = J
              ENDIF
          ENDIF
  220 CONTINUE
C
C     Choose magnitude of largest component of gradient for candidate.
C
      JBIG = 0
      WBIG = ZERO
      IF (WLARGE.GT.ZERO) THEN
          JBIG = JLARGE
          WBIG = WLARGE
      ENDIF
C
      IF (WMAG.GE.WBIG) THEN
          JBIG = JMAG
          WBIG = WMAG
      ENDIF
C
      IF (JBIG.EQ.0) THEN
          FOUND = .FALSE.
          IF (IPRINT.GT.0) THEN
              CALL IVOUT(0,I,'('' FOUND NO VARIABLE TO ENTER'')',-4)
          ENDIF
          GO TO 120
      ENDIF
C
C     See if the incoming column is sufficiently independent.  This
C     test is made before an elimination is performed.
C
      IF (IPRINT.GT.0)
     *    CALL IVOUT(1,JBIG,'('' TRY TO BRING IN THIS COL.'')',-4)
C
      IF (MVAL.LE.NSETB) THEN
          CL1 = SNRM2(MVAL,W(1,JBIG),1)
          CL2 = ABS(WT)*SNRM2(NSETB-MVAL,W(INEXT(MVAL),JBIG),1)
          CL3 = ABS(WT)*SNRM2(MROWS-NSETB,W(INEXT(NSETB),JBIG),1)
          CALL SROTG(CL1,CL2,SC,SS)
          COLABV = ABS(CL1)
          COLBLO = CL3
      ELSE
          CL1 = SNRM2(NSETB,W(1,JBIG),1)
          CL2 = SNRM2(MVAL-NSETB,W(INEXT(NSETB),JBIG),1)
          CL3 = ABS(WT)*SNRM2(MROWS-MVAL,W(INEXT(MVAL),JBIG),1)
          COLABV = CL1
          CALL SROTG(CL2,CL3,SC,SS)
          COLBLO = ABS(CL2)
      ENDIF
C
      IF (COLBLO.LE.TOLIND*COLABV) THEN
          WW(JBIG) = BIG
          IF (IPRINT.GT.0)
     *        CALL IVOUT(0,I,'('' VARIABLE IS DEPENDENT, NOT USED.'')',
     *           -4)
          GO TO 210
      ENDIF
C
C     Swap matrix columns NSETB+1 and JBIG, plus pointer information,
C     and gradient values.
C
      NSETB = NSETB + 1
      IF (NSETB.NE.JBIG) THEN
          CALL SSWAP(MROWS,W(1,NSETB),1,W(1,JBIG),1)
          CALL SSWAP(1,WW(NSETB),1,WW(JBIG),1)
          ITEMP = IBASIS(NSETB)
          IBASIS(NSETB) = IBASIS(JBIG)
          IBASIS(JBIG) = ITEMP
      ENDIF
C
C     Eliminate entries below the pivot line in column NSETB.
C
      IF (MROWS.GT.NSETB) THEN
          DO 230 I = MROWS,NSETB+1,-1
              IF (I.EQ.MVAL+1) GO TO 230
              CALL SROTG(W(I-1,NSETB),W(I,NSETB),SC,SS)
              W(I,NSETB) = ZERO
              CALL SROT(NCOLS-NSETB+1,W(I-1,NSETB+1),MDW,W(I,NSETB+1),
     *                  MDW,SC,SS)
  230     CONTINUE
C
          IF (MVAL.GE.NSETB .AND. MVAL.LT.MROWS) THEN
              CALL SROTG(W(NSETB,NSETB),W(MVAL+1,NSETB),SC,SS)
              W(MVAL+1,NSETB) = ZERO
              CALL SROT(NCOLS-NSETB+1,W(NSETB,NSETB+1),MDW,
     *                  W(MVAL+1,NSETB+1),MDW,SC,SS)
          ENDIF
      ENDIF
C
      IF (W(NSETB,NSETB).EQ.ZERO) THEN
          WW(NSETB) = BIG
          NSETB = NSETB - 1
          IF (IPRINT.GT.0) THEN
              CALL IVOUT(0,I,'('' PIVOT IS ZERO, NOT USED.'')',-4)
          ENDIF
          GO TO 210
      ENDIF
C
C     Check that new variable is moving in the right direction.
C
      ITEMP = IBASIS(NSETB)
      JCOL = ABS(ITEMP)
      XNEW = (W(NSETB,NCOLS+1)/W(NSETB,NSETB))/ABS(SCL(JCOL))
      IF (ITEMP.LT.0) THEN
C
C         IF(WW(NSETB).GE.ZERO.AND.XNEW.LE.ZERO) exit(quit)
C         IF(WW(NSETB).LE.ZERO.AND.XNEW.GE.ZERO) exit(quit)
C
          IF ((WW(NSETB).GE.ZERO.AND.XNEW.LE.ZERO) .OR.
     *        (WW(NSETB).LE.ZERO.AND.XNEW.GE.ZERO)) GO TO 240
      ENDIF
      FOUND = .TRUE.
      GO TO 120
C
  240 WW(NSETB) = BIG
      NSETB = NSETB - 1
      IF (IPRINT.GT.0)
     *    CALL IVOUT(0,I,'('' VARIABLE HAS BAD DIRECTION, NOT USED.'')',
     *       -4)
      GO TO 210
C
C     Solve the triangular system.
C
  270 CALL SCOPY(NSETB,W(1,NCOLS+1),1,RW,1)
      DO 280 J = NSETB,1,-1
          RW(J) = RW(J)/W(J,J)
          JCOL = ABS(IBASIS(J))
          T = RW(J)
          IF (MOD(IBB(JCOL),2).EQ.0) RW(J) = -RW(J)
          CALL SAXPY(J-1,-T,W(1,J),1,RW,1)
          RW(J) = RW(J)/ABS(SCL(JCOL))
  280 CONTINUE
C
      IF (IPRINT.GT.0) THEN
          CALL SVOUT(NSETB,RW,'('' SOLN. VALUES'')',-4)
          CALL IVOUT(NSETB,IBASIS,'('' COLS. USED'')',-4)
      ENDIF
C
      IF (LGOPR.EQ.2) THEN
          CALL SCOPY(NSETB,RW,1,X,1)
          DO 450 J = 1,NSETB
              ITEMP = IBASIS(J)
              JCOL = ABS(ITEMP)
              IF (ITEMP.LT.0) THEN
                  BOU = ZERO
              ELSE
                  BOU = BL(JCOL)
              ENDIF
C
              IF ((-BOU).NE.BIG) BOU = BOU/ABS(SCL(JCOL))
              IF (X(J).LE.BOU) THEN
                  JDROP1 = J
                  GO TO 340
              ENDIF
C
              BOU = BU(JCOL)
              IF (BOU.NE.BIG) BOU = BOU/ABS(SCL(JCOL))
              IF (X(J).GE.BOU) THEN
                  JDROP2 = J
                  GO TO 340
              ENDIF
  450     CONTINUE
          GO TO 340
      ENDIF
C
C     See if the unconstrained solution (obtained by solving the
C     triangular system) satisfies the problem bounds.
C
      ALPHA = TWO
      BETA = TWO
      X(NSETB) = ZERO
      DO 310 J = 1,NSETB
          ITEMP = IBASIS(J)
          JCOL = ABS(ITEMP)
          T1 = TWO
          T2 = TWO
          IF (ITEMP.LT.0) THEN
              BOU = ZERO
          ELSE
              BOU = BL(JCOL)
          ENDIF
          IF ((-BOU).NE.BIG) BOU = BOU/ABS(SCL(JCOL))
          IF (RW(J).LE.BOU) T1 = (X(J)-BOU)/ (X(J)-RW(J))
          BOU = BU(JCOL)
          IF (BOU.NE.BIG) BOU = BOU/ABS(SCL(JCOL))
          IF (RW(J).GE.BOU) T2 = (BOU-X(J))/ (RW(J)-X(J))
C
C     If not, then compute a step length so that the variables remain
C     feasible.
C
          IF (T1.LT.ALPHA) THEN
              ALPHA = T1
              JDROP1 = J
          ENDIF
C
          IF (T2.LT.BETA) THEN
              BETA = T2
              JDROP2 = J
          ENDIF
  310 CONTINUE
C
      CONSTR = ALPHA .LT. TWO .OR. BETA .LT. TWO
      IF (.NOT.CONSTR) THEN
C
C         Accept the candidate because it satisfies the stated bounds
C         on the variables.
C
          CALL SCOPY(NSETB,RW,1,X,1)
          GO TO 580
      ENDIF
C
C     Take a step that is as large as possible with all variables
C     remaining feasible.
C
      DO 330 J = 1,NSETB
          X(J) = X(J) + MIN(ALPHA,BETA)* (RW(J)-X(J))
  330 CONTINUE
C
      IF (ALPHA.LE.BETA) THEN
          JDROP2 = 0
      ELSE
          JDROP1 = 0
      ENDIF
C
  340 IF (JDROP1+JDROP2.LE.0 .OR. NSETB.LE.0) GO TO 580
  350 JDROP = JDROP1 + JDROP2
      ITEMP = IBASIS(JDROP)
      JCOL = ABS(ITEMP)
      IF (JDROP2.GT.0) THEN
C
C         Variable is at an upper bound.  Subtract multiple of this
C         column from right hand side.
C
          T = BU(JCOL)
          IF (ITEMP.GT.0) THEN
              BU(JCOL) = T - BL(JCOL)
              BL(JCOL) = -T
              ITEMP = -ITEMP
              SCL(JCOL) = -SCL(JCOL)
              DO 360 I = 1,JDROP
                  W(I,JDROP) = -W(I,JDROP)
  360         CONTINUE
          ELSE
              IBB(JCOL) = IBB(JCOL) + 1
              IF (MOD(IBB(JCOL),2).EQ.0) T = -T
          ENDIF
C
C     Variable is at a lower bound.
C
      ELSE
          IF (ITEMP.LT.ZERO) THEN
              T = ZERO
          ELSE
              T = -BL(JCOL)
              BU(JCOL) = BU(JCOL) + T
              ITEMP = -ITEMP
          ENDIF
      ENDIF
C
      CALL SAXPY(JDROP,T,W(1,JDROP),1,W(1,NCOLS+1),1)
C
C     Move certain columns left to achieve upper Hessenberg form.
C
      CALL SCOPY(JDROP,W(1,JDROP),1,RW,1)
      DO 370 J = JDROP+1,NSETB
          IBASIS(J-1) = IBASIS(J)
          X(J-1) = X(J)
          CALL SCOPY(J,W(1,J),1,W(1,J-1),1)
  370 CONTINUE
C
      IBASIS(NSETB) = ITEMP
      W(1,NSETB) = ZERO
      CALL SCOPY(MROWS-JDROP,W(1,NSETB),0,W(JDROP+1,NSETB),1)
      CALL SCOPY(JDROP,RW,1,W(1,NSETB),1)
C
C     Transform the matrix from upper Hessenberg form to upper
C     triangular form.
C
      NSETB = NSETB - 1
      DO 390 I = JDROP,NSETB
C
C         Look for small pivots and avoid mixing weighted and
C         nonweighted rows.
C
          IF (I.EQ.MVAL) THEN
              T = ZERO
              DO 380 J = I,NSETB
                  JCOL = ABS(IBASIS(J))
                  T1 = ABS(W(I,J)*SCL(JCOL))
                  IF (T1.GT.T) THEN
                      JBIG = J
                      T = T1
                  ENDIF
  380         CONTINUE
              GO TO 400
          ENDIF
          CALL SROTG(W(I,I),W(I+1,I),SC,SS)
          W(I+1,I) = ZERO
          CALL SROT(NCOLS-I+1,W(I,I+1),MDW,W(I+1,I+1),MDW,SC,SS)
  390 CONTINUE
      GO TO 430
C
C     The triangularization is completed by giving up the Hessenberg
C     form and triangularizing a rectangular matrix.
C
  400 CALL SSWAP(MROWS,W(1,I),1,W(1,JBIG),1)
      CALL SSWAP(1,WW(I),1,WW(JBIG),1)
      CALL SSWAP(1,X(I),1,X(JBIG),1)
      ITEMP = IBASIS(I)
      IBASIS(I) = IBASIS(JBIG)
      IBASIS(JBIG) = ITEMP
      JBIG = I
      DO 420 J = JBIG,NSETB
          DO 410 I = J+1,MROWS
              CALL SROTG(W(J,J),W(I,J),SC,SS)
              W(I,J) = ZERO
              CALL SROT(NCOLS-J+1,W(J,J+1),MDW,W(I,J+1),MDW,SC,SS)
  410     CONTINUE
  420 CONTINUE
C
C     See if the remaining coefficients are feasible.  They should be
C     because of the way MIN(ALPHA,BETA) was chosen.  Any that are not
C     feasible will be set to their bounds and appropriately translated.
C
  430 JDROP1 = 0
      JDROP2 = 0
      LGOPR = 2
      GO TO 270
C
C     Find a variable to become non-active.
C
  120 IF (FOUND) THEN
          LGOPR = 1
          GO TO 270
      ENDIF
C
C     Rescale and translate variables.
C
      IGOPR = 2
  130 CALL SCOPY(NSETB,X,1,RW,1)
      CALL SCOPY(NCOLS,ZERO,0,X,1)
      DO 140 J = 1,NSETB
          JCOL = ABS(IBASIS(J))
          X(JCOL) = RW(J)*ABS(SCL(JCOL))
  140 CONTINUE
C
      DO 150 J = 1,NCOLS
          IF (MOD(IBB(J),2).EQ.0) X(J) = BU(J) - X(J)
  150 CONTINUE
C
      DO 160 J = 1,NCOLS
          JCOL = IBASIS(J)
          IF (JCOL.LT.0) X(-JCOL) = BL(-JCOL) + X(-JCOL)
  160 CONTINUE
C
      DO 170 J = 1,NCOLS
          IF (SCL(J).LT.ZERO) X(J) = -X(J)
  170 CONTINUE
C
      I = MAX(NSETB,MVAL)
      RNORM = SNRM2(MROWS-I,W(INEXT(I),NCOLS+1),1)
C
      IF (IGOPR.EQ.2) MODE = NSETB
      RETURN
      END

module gtv_metacode
  !---------------------------------------------------------------------
  ! Support module for command METACODE
  !---------------------------------------------------------------------
  !
  ! Versions
  integer, parameter :: signature_length=15
  character(len=signature_length), parameter :: signature='GTVIRT-Metacode'
  ! integer(kind=4), parameter :: current=20101217  ! 17-dec-2010
  ! integer(kind=4), parameter :: current=20110615  ! 15-jun-2011
  ! integer(kind=4), parameter :: current=20130911  ! 11-sep-2013
  integer(kind=4), parameter :: current=20160908    ! Segment color identifiers changed
  !
  ! Markers
  integer(kind=4), parameter :: seg_sos = -101  ! Start-of-segment
  integer(kind=4), parameter :: seg_sod = -102  ! Start-of-directory
  integer(kind=4), parameter :: seg_eos = -201  ! End-of-segment
  integer(kind=4), parameter :: seg_eod = -202  ! End-of-directory
  !
end module gtv_metacode
!
subroutine gtl_metacode(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_metacode
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !   Support for command METACODE [IMPORT|EXPORT] [...]
  !
  ! Load or save in an binary file a sub-tree of the metacode.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='METACODE'
  integer :: nc,ncom
  integer, parameter :: nvocab=2
  character(len=12) :: vocab(nvocab),to_check,comm
  ! Data
  data vocab /'EXPORT','IMPORT'/
  !
  call sic_ke(line,0,1,to_check,nc,.true.,error)
  if (error) return
  call sic_ambigs(rname,to_check,comm,ncom,vocab,nvocab,error)
  if (error)  return
  !
  if (comm.eq.'EXPORT') then
    call meta_export(line,error)
    !
  elseif (comm.eq.'IMPORT') then
    call meta_import(line,error)
    call gtview('Update')
    !
  else
    call gtv_message(seve%e,rname,'Internal programming error')
    error = .true.
    return
  endif
  !
end subroutine gtl_metacode
!
subroutine meta_export(line,error)
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>meta_export
  use gtv_metacode
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !   Support for command METACODE EXPORT File [Dir]
  !
  ! Permet de sauver dans un fichier binaire une sous arborescence du
  ! metacode.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  character(len=filename_length) :: argum,filename
  character(len=gtvpath_length) :: rep_name  ! Nom du repertoire a sauver
  logical :: isdir,found
  integer :: nc,lun,ier
  type(gt_directory), pointer :: dir
  type(gt_segment), pointer :: segm
  !
  ! No option allowed METACODE EXPORT command
  if (sic_present(1,1)) then
    call gtv_message(seve%e,rname,'No option allowed with EXPORT keyword')
    error = .true.
    return
  endif
  !
  ! Flush the current segment into the metacode
  call gtsegm_flush(error)
  if (error)  return
  !
  ! Recuperation du nom du fichier
  call sic_ch(line,0,2,argum,nc,.true.,error)
  if (error) return
  filename = argum
  call sic_parsef(argum,filename,' ','.meta')
  !
  ! Recuperation du nom du directory
  if (sic_present(0,3)) then
    call sic_ch(line,0,3,rep_name,nc,.true.,error)
    if (error) return
    call sic_upper(rep_name)
    !
    call decode_chemin(rep_name,cw_directory,dir,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,  &
        'Directory '''//trim(rep_name)//''' does not exists')
      error = .true.
      return
    elseif (.not.isdir) then
      call gtv_message(seve%e,rname,trim(rep_name)//  &
        ''' is not a directory')
      error = .true.
      return
    endif
  else
    ! Save Current Working Directory
    dir => cw_directory
  endif
  call cree_chemin_dir(dir,rep_name,nc)
  !
  if (.not.dir%gen%visible) then
    call gtv_message(seve%e,rname,  &
      'Directory '''//trim(rep_name)//''' is not visible')
    error = .true.
    return
  endif
  !
  ! Get a unit for the output file
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    error = .true.
    return
  endif
  !
  ! Open the output file
  if (gag_inquire(filename,len_trim(filename)).eq.0)  &
    call gag_delete(filename)
  !
  open(unit=lun, file=filename, status='NEW', form='UNFORMATTED',  &
       access='SEQUENTIAL', iostat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Open error on output file '//filename)
    error = .true.
    goto 100
  endif
  !
  ! Process
  write(unit=lun,iostat=ier)  signature  ! File signature
  write(unit=lun,iostat=ier)  current    ! Current version
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Write error 1')
    error = .true.
    goto 100
  endif
  !
  call meta_export_dir(dir,lun,error)
  if (error)  goto 100
  !
  call gtv_message(seve%i,rname,  &
    'Directory '//trim(rep_name)//' exported to file '//filename)
  !
100 continue
  !
  ! Close the file
  close(unit=lun)
  call sic_frelun(lun)
  !
end subroutine meta_export
!
recursive subroutine meta_export_dir(dir,lun,error)
  use gtv_interfaces, except_this=>meta_export_dir
  use gbl_message
  use gtv_metacode
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_directory), intent(in)    :: dir    ! Directory to dump
  integer(kind=4),    intent(in)    :: lun    ! Logical unit
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  integer :: ier
  type(gt_segment), pointer :: segm
  type(gt_directory), pointer :: child
  !
  ! Mark the start-of-directory
  write(unit=lun,iostat=ier)  seg_sod
  if (ier.ne.0)  goto 100
  !
  write(unit=lun,iostat=ier)  dir%gen%name
  ! Do not save minmax, we will recompute it dynamically
  write(unit=lun,iostat=ier)  dir%phys_size
  write(unit=lun,iostat=ier)  dir%val_greg
  if (ier.ne.0)  goto 100
  !
  ! Dump all the segments in this directory
  segm => dir%leaf_first
  do while (associated(segm))
    call meta_export_seg(segm,lun,error)
    if (error)  return
    !
    ! Next segment
    segm => segm%nextseg
  enddo
  !
  ! Dump all the directories in this directory
  child => dir%son_first
  do while (associated(child))
    call meta_export_dir(child,lun,error)
    if (error)  return
    !
    ! Next directory
    child => child%brother
  enddo
  !
  ! Mark the end-of-directory
  write(unit=lun,iostat=ier)  seg_eod
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Write error 2')
  error = .true.
  return
end subroutine meta_export_dir
!
subroutine meta_export_seg(segm,lun,error)
  use gtv_interfaces, except_this=>meta_export_seg
  use gbl_message
  use gtv_metacode
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_segment), intent(in)    :: segm   ! Segment to dump
  integer(kind=4),  intent(in)    :: lun    ! Logical unit
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  integer :: ier,icol
  character(len=segname_length) :: name
  type(gt_segment_data), pointer :: segdata
  !
  ! Mark the start-of-segment
  write(unit=lun,iostat=ier)  seg_sos
  if (ier.ne.0)  goto 100
  !
  icol = index(segm%head%gen%name,':')
  if (icol.gt.0) then
    name = segm%head%gen%name(1:icol-1)
  else
    name = segm%head%gen%name
  endif
  write(unit=lun,iostat=ier)  name
  write(unit=lun,iostat=ier)  segm%head%gen%minmax
  write(unit=lun,iostat=ier)  segm%head%attr
  if (ier.ne.0)  goto 100
  !
  ! Export segment data
  segdata => segm%data
  do while (associated(segdata))
    call meta_export_segdata(segdata,lun,error)
    if (error)  return
    !
    segdata => segdata%nextdata
  enddo
  !
  ! Mark the end-of-segment
  write(unit=lun,iostat=ier)  seg_eos
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Write error 3')
  error = .true.
  return
  !
end subroutine meta_export_seg
!
subroutine meta_export_segdata(segdata,lun,error)
  use gtv_interfaces, except_this=>meta_export_segdata
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_segment_data), intent(in)    :: segdata  ! Segment data to dump
  integer(kind=4),       intent(in)    :: lun      ! Logical unit
  logical,               intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  !
  select case (segdata%kind)
  case (seg_points)
    call meta_export_polyline(segdata,lun,error)
  case (seg_poly)
    call meta_export_polyline(segdata,lun,error)
  case (seg_hfpoly)
    call meta_export_polyline(segdata,lun,error)
  case (seg_vfpoly)
    call meta_export_polyline(segdata,lun,error)
  case (seg_image)
    call meta_export_image(segdata%image,lun,error)
  case (seg_lutcol)
    call meta_export_lut(segdata,lun,error)
  case (seg_pencol)
    call meta_export_lut(segdata,lun,error)
  case default
    call gtv_message(seve%w,rname,'Unsupported kind of data skipped')
    return
  end select
  if (error)  return
  !
end subroutine meta_export_segdata
!
subroutine meta_export_polyline(segdata,lun,error)
  use gtv_interfaces, except_this=>meta_export_polyline
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_segment_data), intent(in)    :: segdata  ! Segment data to dump
  integer(kind=4),       intent(in)    :: lun      ! Logical unit
  logical,               intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  integer :: ier
  !
  write(unit=lun,iostat=ier)  segdata%kind
  write(unit=lun,iostat=ier)  segdata%poly%n
  write(unit=lun,iostat=ier)  segdata%poly%x(1:segdata%poly%n)
  write(unit=lun,iostat=ier)  segdata%poly%y(1:segdata%poly%n)
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Write error 4')
  error = .true.
  return
  !
end subroutine meta_export_polyline
!
subroutine meta_export_image(segima,lun,error)
  use gtv_interfaces, except_this=>meta_export_image
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_image),  intent(in)    :: segima  ! Image data to dump
  integer(kind=4), intent(in)    :: lun     ! Logical unit
  logical,         intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  integer :: ier
  integer(kind=8) :: taille(2)
  !
  if (segima%isrgb) then
    call gtv_message(seve%w,rname,'Exporting RGB images is not yet supported. Ignored')
    return
  endif
  !
  ! Descriptor
  write(unit=lun,iostat=ier)  seg_image
  write(unit=lun,iostat=ier)  segima%r%blank
  write(unit=lun,iostat=ier)  segima%scaling
  write(unit=lun,iostat=ier)  segima%r%cuts
  write(unit=lun,iostat=ier)  segima%r%extrema
  write(unit=lun,iostat=ier)  segima%conv
  write(unit=lun,iostat=ier)  segima%limits
  write(unit=lun,iostat=ier)  segima%position
  if (ier.ne.0)  goto 100
  ! Data
  taille(:) = segima%r%taille(:)
  write(unit=lun,iostat=ier)  taille
  write(unit=lun,iostat=ier)  segima%r%values
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Write error 5')
  error = .true.
  return
  !
end subroutine meta_export_image
!
subroutine meta_export_lut(segdata,lun,error)
  use gtv_interfaces, except_this=>meta_export_lut
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_segment_data), intent(in)    :: segdata  ! Segment data to dump
  integer(kind=4),       intent(in)    :: lun      ! Logical unit
  logical,               intent(inout) :: error    ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META EXPORT'
  integer :: ier
  !
  write(unit=lun,iostat=ier)  segdata%kind
  write(unit=lun,iostat=ier)  segdata%lut%size
  write(unit=lun,iostat=ier)  segdata%lut%r
  write(unit=lun,iostat=ier)  segdata%lut%g
  write(unit=lun,iostat=ier)  segdata%lut%b
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Write error 6')
  error = .true.
  return
  !
end subroutine meta_export_lut
!
subroutine meta_import(line,error)
  use gildas_def
  use gbl_message
  use gtv_buffers
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>meta_import
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   METACODE IMPORT File [DirName] [/PATH LoadPath]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  character(len=filename_length) :: filename,argum
  character(len=gtvpath_length) :: path
  integer :: lun,nc,ier
  type(gt_directory), pointer :: parent
  type(gt_segment), pointer :: segm
  logical :: isdir,found
  !
  ! Recuperation du nom de fichier
  call sic_ch(line,0,2,argum,nc,.true.,error)
  if (error) return
  call sic_parsef(argum,filename,' ','.meta')
  !
  if (gag_inquire(filename,len_trim(filename)).ne.0) then
    call gtv_message(seve%e,rname,'No such file '//filename)
    error = .true.
    return
  endif
  !
  ! Get a unit for the output file
  ier = sic_getlun(lun)
  if (ier.ne.1) then
    error = .true.
    return
  endif
  !
  ! Open the output file
  open(unit=lun, file=filename, status='OLD', form='UNFORMATTED',  &
         access='SEQUENTIAL', iostat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,rname,'Open error on output file '//filename)
    error = .true.
    goto 100
  endif
  !
  ! Get the host directory
  if (sic_present(1,0)) then
    call sic_ch(line,1,1,path,nc,.true.,error)
    if (error) goto 100
    call sic_upper(path)
    call decode_chemin(path,cw_directory,parent,isdir,segm,found)
    if (.not.found) then
      call gtv_message(seve%e,rname,'No such directory '//path)
      error = .true.
      goto 100
    endif
    if (.not.isdir) then
      call gtv_message(seve%e,rname,  &
        trim(path)//' is a segment (must be a directory)')
      error = .true.
      goto 100
    endif
  else
    parent => cw_directory
  endif
  !
  ! Process
  call meta_import_load(parent,lun,error)
  if (error)  goto 100
  !
!   ! Recuperons le nom du repertoire devant contenir l'arborescence
!   dirname = argum
!   call sic_ch(line,0,3,dirname,nc,.false.,error)
!   if (error) return
!   call sic_upper(dirname)
  !
  call gtv_message(seve%i,rname,'Metacode imported from file '//filename)
  !
100 continue
  !
  ! Close the file
  close(unit=lun)
  call sic_frelun(lun)
  !
end subroutine meta_import
!
subroutine meta_import_load(parent,lun,error)
  use gbl_message
  use gtv_interfaces, except_this=>meta_import_load
  use gtv_metacode
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_directory), pointer       :: parent  ! Directory to be filled
  integer(kind=4),    intent(in)    :: lun     ! Logical unit opened on the file
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  integer :: ier,marker,version
  character(len=message_length) :: mess
  character(len=signature_length) :: sig
  !
  ! Get signature
  read(unit=lun,iostat=ier) sig
  if (ier.ne.0)  goto 100
  if (sig.ne.signature) then
    call gtv_message(seve%e,rname,'File does not seem to be a GTVIRT metacode')
    error = .true.
    return
  endif
  !
  ! Get version
  read(unit=lun,iostat=ier) version
  if (ier.ne.0)  goto 100
  if (version.ne.current) then
    write(mess,'(A,I0,A)')  &
      'Unknown version of the GTVIRT metacode (',version,')'
    call gtv_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Read first marker. Should be start-of-directory
  read(unit=lun,iostat=ier) marker
  if (ier.ne.0)  goto 100
  !
  if (marker.ne.seg_sod) then
    call gtv_message(seve%e,rname,'Unexpected marker 1')
    error = .true.
    return
  endif
  !
  call meta_import_dir(parent,lun,error)
  if (error)  return
  !
  ! Recompute all the minmax
  call gtv_limits(parent,error)
  if (error)  return
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 1')
  error = .true.
  return
  !
end subroutine meta_import_load
!
recursive subroutine meta_import_dir(parent,lun,error)
  use gbl_message
  use gtv_buffers
  use gtv_metacode
  use gtv_interfaces, except_this=>meta_import_dir
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_directory), pointer       :: parent  ! Parent directory
  integer(kind=4),    intent(in)    :: lun     ! Logical unit opened on the file
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  type(gt_directory), pointer :: newdir
  character(len=segname_length) :: name
  integer :: ier,marker
  real(kind=4) :: phys_size(2)
  logical :: istop
  type(x_output) :: xdisplay
  !
  read(unit=lun,iostat=ier) name
  read(unit=lun,iostat=ier) phys_size
  if (ier.ne.0)  goto 100
  !
  istop = associated(parent,root) ! Host directory is root, i.e. we create a top directory
  if (.not.istop) then
    ! No choice, only top directories can have a custom physical size.
    ! Subdirectories inherit the physical size of their parent.
    if (any(phys_size.ne.parent%phys_size)) then
      call gtv_message(seve%w,rname,'Host and imported directories have different physical size')
      call gtv_message(seve%w,rname,'Plot may be truncated')
    endif
    phys_size = parent%phys_size
  endif
  !
  ! Create the directory
  call gtsegm_dir(name,parent,phys_size(1),phys_size(2),error)
  if (error)  return
  newdir => parent%son_last
  !
  ! Set the remaining attributes
  newdir%gen%visible = .true.  ! Always visible
  read(unit=lun,iostat=ier) newdir%val_greg
  if (ier.ne.0)  goto 100
  !
  ! Create a window if top directory
  if (istop .and. cw_device%protocol.eq.p_x) then
    call x_display_reset(xdisplay)  ! Default values
    call gtv_mkdir_topwindow(newdir,xdisplay,error)
    if (error)  return
  endif
  !
  ! Read next marker
  do
    read(unit=lun,iostat=ier)  marker
    if (ier.ne.0)  goto 100
    !
    if (marker.eq.seg_sos) then
      call meta_import_seg(newdir,lun,error)
    elseif (marker.eq.seg_sod) then
      call meta_import_dir(newdir,lun,error)
    elseif (marker.eq.seg_eod) then
      return
    else
      goto 101
    endif
    if (error)  return
    !
  enddo
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 2')
  error = .true.
  return
  !
101 continue
  call gtv_message(seve%e,rname,'Unexpected marker 2')
  error = .true.
  return
  !
end subroutine meta_import_dir
!
subroutine meta_import_seg(parent,lun,error)
  use gbl_message
  use gtv_interfaces, except_this=>meta_import_seg
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_directory), pointer       :: parent  ! Parent directory
  integer(kind=4),    intent(in)    :: lun     ! Logical unit opened on the file
  logical,            intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  character(len=segname_length) :: name
  type(gt_segment), pointer :: newseg
  integer :: ier
  !
  ! Read the new segment name
  read(unit=lun,iostat=ier) name
  !
  ! Create it in the metacode
  call gtsegm_create(name,parent,error)
  if (error)  return
  !
  newseg => parent%leaf_last
  read(unit=lun,iostat=ier) newseg%head%gen%minmax
  read(unit=lun,iostat=ier) newseg%head%attr
  if (ier.ne.0)  goto 100
  newseg%head%gen%visible = .true.  ! Always visible
  !
  ! Read the segment data
  call meta_import_segdata(newseg%data,lun,error)
  if (error) return
  !
  ! Close the segment
  call gtsegm_close(error)
  if (error)  return
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 3')
  error = .true.
  return
  !
end subroutine meta_import_seg
!
recursive subroutine meta_import_segdata(new,lun,error)
  use gbl_message
  use gtv_interfaces, except_this=>meta_import_segdata
  use gtv_metacode
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_segment_data), pointer       :: new     ! New data segment to be filled
  integer(kind=4),       intent(in)    :: lun     ! Logical unit opened on the file
  logical,               intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  integer :: ier,kind
  !
  read(unit=lun,iostat=ier) kind
  if (ier.ne.0)  goto 100
  !
  select case (kind)
  case (seg_eos)
    return
  case (seg_points)
    call meta_import_polyline(new,kind,lun,error)
  case (seg_poly)
    call meta_import_polyline(new,kind,lun,error)
  case (seg_hfpoly)
    call meta_import_polyline(new,kind,lun,error)
  case (seg_vfpoly)
    call meta_import_polyline(new,kind,lun,error)
  case (seg_image)
    call meta_import_image(lun,error)
  case (seg_lutcol)
    call meta_import_lut(new,kind,lun,error)
  case (seg_pencol)
    call meta_import_lut(new,kind,lun,error)
  case default
    call gtv_message(seve%e,rname,'Unknown kind of data')
    error = .true.
  end select
  if (error)  return
  !
  ! Read next piece of data
  call meta_import_segdata(new%nextdata,lun,error)
  if (error)  return
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 4')
  error = .true.
  return
  !
end subroutine meta_import_segdata
!
subroutine meta_import_polyline(new,kind,lun,error)
  use gtv_interfaces, except_this=>meta_import_polyline
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_segment_data), pointer       :: new     ! New data segment to be filled
  integer(kind=4),       intent(in)    :: kind    ! Kind of polyline
  integer(kind=4),       intent(in)    :: lun     ! Logical unit opened on the file
  logical,               intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  integer :: ier,n
  !
  ! General section
  read(unit=lun,iostat=ier) n
  if (ier.ne.0)  goto 100
  !
  allocate(new,stat=ier)
  if (ier.ne.0)  goto 101
  allocate(new%poly%x(n),new%poly%y(n),stat=ier)
  if (ier.ne.0)  goto 101
  !
  new%kind = kind
  new%poly%n = n
  new%image => null()
  ! new%lut = ?
  new%nextdata => null()
  !
  read(unit=lun,iostat=ier) new%poly%x
  read(unit=lun,iostat=ier) new%poly%y
  if (ier.ne.0)  goto 100
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 5')
  error = .true.
  return
  !
101 continue
  call gtv_message(seve%e,rname,'Allocation error 1')
  error = .true.
  return
  !
end subroutine meta_import_polyline
!
subroutine meta_import_image(lun,error)
  use gtv_interfaces, except_this=>meta_import_image
  use gbl_message
  use gtv_bitmap
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun    ! Logical unit opened on the file
  logical,         intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  integer(kind=4) :: ier,scaling
  integer(kind=8) :: taille(2)
  integer(kind=index_length) :: taille_il(2)
  real(kind=4) :: cuts(2),extrema(2),conv(6),limits(4),position(4),blank(3)
  logical :: is_visible,is_curima
  real(kind=4), allocatable :: data(:,:)
  !
  ! Descriptor
  read(unit=lun,iostat=ier)  blank
  read(unit=lun,iostat=ier)  scaling
  read(unit=lun,iostat=ier)  cuts
  read(unit=lun,iostat=ier)  extrema
  read(unit=lun,iostat=ier)  conv
  read(unit=lun,iostat=ier)  limits
  read(unit=lun,iostat=ier)  position
  if (ier.ne.0)  goto 100
  !
  ! Data
  read(unit=lun,iostat=ier)  taille  ! Always read 2*8 bytes
  if (ier.ne.0)  goto 100
  taille_il(:) = taille(:)
  !
  allocate(data(taille_il(1),taille_il(2)),stat=ier)
  if (ier.ne.0)  goto 101
  read(unit=lun,iostat=ier)  data
  if (ier.ne.0)  goto 100
  !
  ! Create the image slot in GTVIRT
  is_visible = .true.
  is_curima = .false.
  call gtv_image(taille_il(1),taille_il(2),data,position,limits,conv,scaling,  &
    cuts,extrema,blank,is_visible,is_curima,error)
  deallocate(data)
  if (error)  &
    call gtv_message(seve%e,rname,'Error creating the image slot')
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 6')
  error = .true.
  return
  !
101 continue
  call gtv_message(seve%e,rname,'Allocation error 2')
  error = .true.
  return
  !
end subroutine meta_import_image
!
subroutine meta_import_lut(new,kind,lun,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>meta_import_lut
  use gbl_message
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type(gt_segment_data), pointer       :: new     ! New data segment to be filled
  integer(kind=4),       intent(in)    :: kind    ! Kind of polyline
  integer(kind=4),       intent(in)    :: lun     ! Logical unit opened on the file
  logical,               intent(inout) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='META IMPORT'
  integer :: ier,size,icol
  !
  ! General section
  read(unit=lun,iostat=ier) size
  if (ier.ne.0)  goto 100
  !
  allocate(new,stat=ier)
  if (ier.ne.0)  goto 101
  allocate(new%lut%r(size),new%lut%g(size),new%lut%b(size),stat=ier)
  if (ier.ne.0)  goto 101
  !
  new%kind = kind
  new%lut%size = size
  new%image => null()
  new%nextdata => null()
  !
  read(unit=lun,iostat=ier) new%lut%r
  read(unit=lun,iostat=ier) new%lut%g
  read(unit=lun,iostat=ier) new%lut%b
  if (ier.ne.0)  goto 100
  !
  ! Fill the HSV arrays:
  allocate(new%lut%hue(size),new%lut%sat(size),new%lut%val(size),stat=ier)
  if (ier.ne.0)  goto 101
  do icol=1,size
    call rgb_to_hsv(new%lut%r(icol),new%lut%g(icol),new%lut%b(icol),  &
                    new%lut%hue(icol),new%lut%sat(icol),new%lut%val(icol))
  enddo
  !
  return
  !
100 continue
  call gtv_message(seve%e,rname,'Read error 7')
  error = .true.
  return
  !
101 continue
  call gtv_message(seve%e,rname,'Allocation error 3')
  error = .true.
  return
  !
end subroutine meta_import_lut

subroutine gr_where(xa,ya,x,y)
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ public
  !	Returns the pen position with same conventions as GR_CURS
  !---------------------------------------------------------------------
  real(8), intent(out) :: xa     ! X User coordinates
  real(8), intent(out) :: ya     ! Y User coordinates
  real(4), intent(out) :: x      ! X Plot coordinates
  real(4), intent(out) :: y      ! Y Plot coordinates
  !
  x = xp
  y = yp
  if (axis_xlog) then
    xa = exp((x-gx1)/gux + lux)
  else
    xa = (x-gx1)/gux + gux1
  endif
  if (axis_ylog) then
    ya = exp((y-gy1)/guy + luy)
  else
    ya = (y-gy1)/guy + guy1
  endif
end subroutine gr_where

program field_find
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  integer(kind=4) :: n, ier,nfields
  real(kind=4) :: the
  type(gildas) :: x,y
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('THRESHOLD$',the,1)
  call gildas_close
  !
  n = len_trim(namey)
  call gildas_null(y)
  y%gil%ndim = 2
  call gdf_read_gildas(y,namey,'.gdf',error, rank=2)
  if (error) then
    call gagout('F-FIELD_FIND,  Cannot read input file')
    goto 100
  endif
  !
  ! Create output image
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  n = len_trim(namex)
  call sic_parsef(namex(1:n),x%file,' ','.gdf')
  call gdf_create_image(x,error)
  if (error) then
    call gagout('F-FIELD_FIND,  Cannot create output image')
    goto 100
  endif
  !
  allocate (x%r2d(x%gil%dim(1),x%gil%dim(2)),stat=ier)
  if (ier.ne.0) goto 100
  !
  call label001(y%r2d,                      &  ! Input image
                x%gil%dim(1),x%gil%dim(2),  &  ! Size
                x%r2d,                      &  ! Output image
                nfields,                    &  !
                the,                        &  ! Threshold
                y%gil%bval,y%gil%eval,      &  ! Blanking values
                error)
  if (error)  goto 100
  !
  call gdf_write_data(x,x%r2d,error)
  if (error)  continue
  !
  ! Add/update the extrema
  call gdf_get_extrema(x,error)
  if (error)  continue
  call gdf_update_header(x,error)
  if (error)  continue
  !
  call gdf_close_image(x,error)
  if (error)  continue
  deallocate(x%r2d)
  !
  if (nfields.eq.0) then
    call gagout('W-FIELD_FIND,  No field found')
  elseif (nfields.eq.1) then
    call gagout('I-FIELD_FIND,  Found 1 field in image')
  else
    write(namex,'(A,I0,A)') 'I-FIELD_FIND,  Found ',nfields,' fields in image'
    call gagout(namex)
  endif
  call sysexi(1)
  !
100 call sysexi(fatale)
end program field_find
!
subroutine label001(imagein,ncolumns,nlines,labelout,nfields,threshold,  &
  blank,eblank,error)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Modifie S.Guilloteau LAB 20 Janv 2013
  !    Order the field numbers by number of pixels
  ! Modifie S.Guilloteau
  ! Groupe d'Astrophysique de Grenoble 22 Octobre 1985
  ! Valeurs non definies et declaration LabelOut en reel
  !
  ! Origine : A.Bijaoui 25 octobre 1984 Observatoire de Nice
  ! Saidi1 Permet l'etiquettage des domaines a partir d'une
  ! segmentation avec seuil de flux
  !---------------------------------------------------------------------
  integer(kind=index_length), intent(in)    :: ncolumns                   ! Number of "Columns"
  integer(kind=index_length), intent(in)    :: nlines                     ! Number of "lines"
  real(kind=4),               intent(in)    :: imagein(ncolumns,nlines)   ! Input image
  real(kind=4),               intent(out)   :: labelout(ncolumns,nlines)  ! Labels of fields
  integer(kind=4),            intent(out)   :: nfields                    ! Number of fields
  real(kind=4),               intent(in)    :: threshold                  ! Threshold
  real(kind=4),               intent(in)    :: blank                      ! Blanking
  real(kind=4),               intent(in)    :: eblank                     ! and tolerance
  logical,                    intent(inout) :: error                      ! Logical error flag
  ! Local
  integer(kind=index_length) :: iline,icolumn
  integer(kind=4) :: l1,l2,la1,la2,la,ier
  integer(kind=4), allocatable :: buf1(:),buf2(:)
  integer(kind=4) :: mfields,nfieldsi,ifield,jfield
  !
  ! Allocate working buffers
  mfields = nlines*ncolumns  ! Maximum number of fields in image
  allocate(buf1(mfields),buf2(mfields),stat=ier)
  if (failed_allocate('FIELD_FIND','buffers',ier,error))  return
  !
  nfieldsi=0
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (imagein(icolumn,iline).lt.threshold) then
        labelout(icolumn,iline)=0.0
      elseif (abs(imagein(icolumn,iline)-blank).le.eblank) then    !SG
        labelout(icolumn,iline)=0.0    !SG
      else
        labelout (icolumn,iline) = 0.0
        if (icolumn.ne.1) then
          l1=labelout(icolumn-1,iline)
          if (l1.ne.0) labelout(icolumn,iline)=l1
        endif
        if (iline.ne.1) then
          l2=labelout(icolumn,iline-1)
          if (l1.eq.0) then
            if (l2.eq.0) then
              nfieldsi=nfieldsi+1
              buf1(nfieldsi)=nfieldsi
              labelout(icolumn,iline)=nfieldsi
            else
              labelout(icolumn,iline)=l2
            endif
          else
            if (l2.ne.0) then
              if (l2.ne.l1) then
                call descen(buf1,l1,la1)
                call descen(buf1,l2,la2)
                la=min(la1,la2)
                buf1(la1)=la
                buf1(la2)=la
                labelout(icolumn,iline)=la
              endif
            endif
          endif
        endif
      endif
    enddo
  enddo
  !
  nfields=0
  do ifield=1,nfieldsi
    call descen(buf1,ifield,jfield)
    if (ifield.eq.jfield) then
      nfields=nfields+1
      buf2(ifield)=nfields
    endif
  enddo
  do iline=1,nlines
    do icolumn=1,ncolumns
      l1 = labelout(icolumn,iline)
      if (l1.ne.0) then
        call descen(buf1,l1,la1)
        labelout(icolumn,iline)=buf2(la1)
      endif
    enddo
  enddo
  !
  ! Sort the final labels by ascending number of pixels...
  buf1(:) = 0  ! buf1 is now used as the number of pixels per field
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (labelout(icolumn,iline).ne.0) then
        ifield = labelout(icolumn,iline)
        buf1(ifield) = buf1(ifield)+1
      endif
    enddo
  enddo
  !
  ! Compute the sorting array
  do iline=1,nfields
    buf2(iline) = iline  ! buf2 is now used as the sorting array
  enddo
  call gi4_trie(buf1,buf2,nfields,error)
  ! Compute back sorting array
  do iline=1,nfields
    buf1(buf2(iline)) = iline  ! buf1 is now used as the back sorting srray
  enddo
  !
  do iline=1,nlines
    do icolumn=1,ncolumns
      if (labelout(icolumn,iline).ne.0) then
        ifield = labelout(icolumn,iline)
        labelout(icolumn,iline) = buf1(ifield)
      endif
    enddo
  enddo
  !
  deallocate(buf1,buf2)
  !
contains
  !
  subroutine descen(label,labin,labout)
    integer(kind=4), intent(inout) :: label(*)
    integer(kind=4), intent(in)    :: labin
    integer(kind=4), intent(out)   :: labout
    ! Local
    integer(kind=4) :: lab
    !
    labout = labin
    do
      lab = label(labout)
      if (lab.eq.labout) return
      labout = lab
    enddo
  end subroutine descen
  !
end subroutine label001

subroutine dofft_test (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
     &    ,ubias,vbias,ubuff,vbuff,ctype)
  !----------------------------------------------------------------------
  ! @  private
  !
  ! GILDAS  UV_MAP
  !   Compute FFT of image by gridding UV data
  !   Test version to compare speed of various methods
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  integer, intent(in) :: ctype                ! type of gridding
  !
  !
  ! Initialize
  map = 0.0
  !
  if (ctype.eq.1) then
    print *,'DOFFT_FAST '
    call dofft_fast (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  elseif  (ctype.eq.5) then
    print *,'DOFFT_QUICK '
    call dofft_quick (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
  else
    print *,'DOFFT_SLOW '
    call dofft_slow (np,nv,visi,jx,jy,jo,   &
     &      nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &      ubias,vbias,ubuff,vbuff)
  endif
end subroutine dofft_test
!
subroutine dofft_quick1 (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   For any gridding support
  !   Taper before gridding
  !   Does not use symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io,k
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    ! Channels
    ! Define map cell
    do k=1,2
      if (k.eq.1) then
        resima = result
      else
        u = -u
        v = -v
        resima = -result
      endif
      !
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = int((v+sup(2))/yinc+yref+1.0)
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        print *,'Visi ',i,' pixels ',ixm,ixp,iym,iyp
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
end subroutine dofft_quick1
!
subroutine dofft_fast1 (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   Only for "visibility in cell"
  !   Taper before gridding
  !   Do not use symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  !
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io,k
  real result,resima,staper,etaper
  real u,v
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    endif
    !
    ! Weight and taper
    result = staper*we(i)
    ! Channels
    ! Define map cell
    do k=1,2
      if (k.eq.1) then
        ix = nint(u/xinc+xref)
        iy = nint(v/yinc+yref)
        resima = result
      else
        ix = nint(-u/xinc+xref)
        iy = nint(-v/yinc+yref)
        resima = -result
      endif
      if (ix.lt.1.or.ix.gt.nx.or.iy.lt.1.or.iy.gt.ny) then
        print *,'Visi ',i,' pixels ',ix,iy
      else
        iou = 1
        iin = io
        do ic=1,nc
          map (iou,ix,iy) = map (iou,ix,iy) +   &
     &            visi(iin,i)*result
          iou = iou+1
          iin = iin+1
          map (iou,ix,iy) = map (iou,ix,iy) +   &
     &            visi(iin,i)*resima
          iou = iou+1
          iin = iin+2
        enddo
        ! Beam
        map (iou,ix,iy) = map(iou,ix,iy) + result
      endif
    enddo
  enddo                        ! Visibility loop
end subroutine dofft_fast1

subroutine gdf_set_uvt_version(name)
  use image_def
  use gio_uv
  use gbl_message
  use gio_dependencies_interfaces
  !----------------------------------------------------
  ! @ public
  !   Select GDF data format version beyond 2.0
  !----------------------------------------------------
  character(len=*), intent(in) :: name
  !
  character(len=16) :: uname
  character(len=60) :: chain
  !
  uname = name
  call sic_upper(uname)
  select case(uname)
  case('2.0')
    code_version_uvt_current = code_version_uvt_v20
  case('2.1')
    code_version_uvt_current = code_version_uvt_v21
  case('2.2')
    code_version_uvt_current = code_version_uvt_v22
  case('*')
    code_version_uvt_current = code_version_uvt_default
  case('FREQUENCY')
    code_version_uvt_current = code_version_uvt_freq
  case('DOPPLER')
    code_version_uvt_current = code_version_uvt_dopp
  case('SYSTEM')
    code_version_uvt_current = code_version_uvt_syst
  case(' ')
    continue
  case default
    call gio_message(seve%w,'GDF','Unsupported UVT version '//uname)
  end select
  !
  select case(code_version_uvt_current)
  case (code_version_uvt_freq)
    write(chain,'(A,F3.1)') 'UV version Frequency V',0.1*code_version_uvt_current
  case (code_version_uvt_dopp)
    write(chain,'(A,F3.1)') 'UV version Doppler V',0.1*code_version_uvt_current
  case (code_version_uvt_syst)
    write(chain,'(A,F3.1)') 'UV version System V',0.1*code_version_uvt_current
  case default
    write(chain,'(A,F3.1,A)') 'UV version V',0.1*code_version_uvt_current, &
    & ' (yet undocumented)'
  end select
  call gio_message(seve%i,'GDF',chain)
end subroutine gdf_set_uvt_version
!
subroutine gdf_get_uvt_version(code)
  use gio_uv
  !----------------------------------------------------
  ! @ public
  !   Get UVT data format version beyond 2.0
  !----------------------------------------------------
  integer(kind=4), intent(out) :: code
  code = code_version_uvt_current
end subroutine gdf_get_uvt_version

!
subroutine uv_flag_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_flag_comm
  use clean_def
  use clean_arrays
  use clean_support
  use clean_types
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command  
  !     UV_FLAG [/ANTENNA] [/DATE] [/RESET] [/FILE FileIn [FileOut]]
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  !! Command line
  logical,          intent(out) :: error !! Logical error flag
  !
  ! Constants
  integer, parameter :: O_RESET=4
  integer, parameter :: O_FILE=3
  integer, parameter :: O_DATE=2
  integer, parameter :: O_ANT=1
  !
  ! Local ---
  type(polygon_t), save :: flagspol      ! User defined polygon
  integer, allocatable :: iant(:)
  integer :: idate, nc, ic, nchan(2), i, narg
  integer(kind=index_length) :: iv
  real :: rflag
  real(8) :: ut1,ut2
  character(len=16) :: argum
  character(len=16) :: chain
  !
  ! Code ----
  ! Parse input line
  if (sic_present(o_file,0)) then
    call uv_flag_file(line,error)
    return
  endif
  !
  if (sic_present(O_ANT,0) ) then  ! /ANTENNA
    if (.not.associated(duv)) then
      call map_message(seve%e,'UV_FLAG','No UV data')
      error = .true.
      return
    endif
    narg = sic_narg(O_ANT)
    if (narg.eq.0) then
      call map_message(seve%e,'UV_FLAG','Missing argument of option /ANTENNA')
      error = .true.
      return
    endif
    allocate(iant(narg))
    do i=1,narg
      call sic_i4(line,O_ANT,i,iant(i),.true.,error)
      if (error) return
    enddo
    nchan = [1,huv%gil%nchan]
    rflag = -1
    if (sic_present(O_RESET,0)) rflag = 1
    call sub_doflag (duv,huv%gil%dim(1),huv%gil%nvisi,0, &
       &    iant, nchan, rflag) !! , ut1, ut2)
  else if (sic_present(O_DATE,0) ) then  ! /DATE
    allocate(iant(1))
    iant = 0
    call sub_get_datetime_range(line,ut1,ut2,error)
    if (error) return
    nchan = [1,huv%gil%nchan]
    rflag = -1
    if (sic_present(O_RESET,0)) rflag = 1
    call sub_doflag (duv,huv%gil%dim(1),huv%gil%nvisi,0,   &
       &    iant, nchan, rflag, ut1, ut2)
    if (.FALSE.) then
      flagspol%ngon = 0
      call sic_ke(line,O_DATE,1,argum,nc,.true.,error)
      call gag_fromdate(argum(1:nc),idate,error)
      if (error) return
      !
      ! Verify if data ready
      chain = 'UV'
      call display_check_uv('UV_FLAG',chain,error)
      if (error) return
      call get_uvflag_date(duvt,huvt%gil%dim(1),huvt%gil%dim(2),idate)
    endif
  else if (sic_present(O_RESET,0)) then  ! /RESET
    ! Reset flag array
    if (.not.allocated(duvt)) then
      ! No Displayed UV data, work directly
      do iv=1,huv%gil%nvisi
        do ic=1,huv%gil%nchan*huv%gil%nstokes
          duv(7+3*ic,iv) = abs( duv(7+3*ic,iv))
        enddo
      enddo
      return
    endif
    call reset_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    flagspol%ngon = 0
  else     ! Plot data
    chain = 'UV'   !! !dtype//' '//trim(argu1)//' '//trim(argu2) First Last
    call display_uv (chain,line,error)
    if (error) return
    !
    ! Ideally, plot the previous Polygon if any
    if (flagspol%ngon.ge.2) call greg_poly_plot(flagspol,error)
    ! Make user to define a polygon from cursor
    !! call greg_poly_cursor('UV_FLAG',flagspol,error)        !! Does not set the boundaries
    !! call greg_poly_loadsub('UV_FLAG',flagspol,0,' ',error) !! That one is private
    call greg_poly_load('UV_FLAG',.false.,' ',flagspol,error) ! Public entry
    if (error) return
    ! Get flag array
    call get_uvflag(flagspol,duvt,huvt%gil%dim(1),huvt%gil%dim(2))
    ! Apply flag array to buffer
    call apply_uvflag(duvt,huvt%gil%dim(1),huvt%gil%dim(2)-3,duv)
  endif
  do_weig = .true.
  optimize(code_save_uv)%lastnc = -1 !  means UV data.
end subroutine uv_flag_comm
!
subroutine get_uvflag_ant(uvs,nv,nd,iant)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- UV_FIT support routine  
  !   Set uvflag array from antenna number
  !!
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd !! Size of UV data
  real, intent(inout) :: uvs(nv,nd)               !! UV data
  integer, intent(in) :: iant                     !! antenna number
  !
  ! Local variables
  integer :: nf,i
  !
  nf = nd-2
  do i=1,nv
    if (uvs(i,6).eq.iant .or. uvs(i,7).eq.iant) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_ant
!
subroutine get_uvflag_date(uvs,nv,nd,idate)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Set uvflag array from (gildas) Date number
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd  !! Size of UV data
  real, intent(inout) :: uvs(nv,nd)   !! UV Data
  integer, intent(in) :: idate        !! GILDAS Date
  !
  ! Local variables
  integer :: nf,i
  !
  nf = nd-2
  do i=1,nv
    if (uvs(i,4).eq.idate) then
      uvs(i,nf) = 0.0
    endif
  enddo
  !
end subroutine get_uvflag_date
!
subroutine get_uvflag(spol,uvs,nv,nd)
  use gildas_def
  use clean_support
  use gkernel_interfaces, only : gr4_inout
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Get uvflag array from polygon (0 => Flag, 1 => Keep)
  !!
  !----------------------------------------------------------------------
  type(polygon_t), intent(in) :: spol              !! User defined region polygon
  integer(kind=index_length), intent(in) :: nv,nd  !! Size of UV data
  real, intent(inout) :: uvs(nv,nd)                !! UV data
  !
  ! Local ---
  integer :: ne,nf, nv4
  !
  ! Code ----
  ne = nd-1
  nf = nd-2
  nv4 = nv
  !
  ! Oh gosh, all that logic assumes the plotted stuff is in
  ! ne, nd, nf ...
  call gr4_inout(spol,uvs(:,ne),uvs(:,nd),uvs(:,nf),nv4,.true.)
  !
end subroutine get_uvflag
!
subroutine reset_uvflag(uvs,nv,nd)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Reset uvflag array to 1
  !!
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd  !! Size of UV data
  real, intent(inout) :: uvs(nv,nd)                !! UV data set
  !
  ! Local ---
  integer :: nf,i
  !
  ! Code ----
  nf = nd-2
  do i=1,nv
    uvs(i,nf) = 1.0
  enddo
end subroutine reset_uvflag
!
subroutine apply_uvflag(uvs,nv,nd,uv)
  use gildas_def
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Apply uvflag array by making negative the weight of the flagged data
  !!
  !----------------------------------------------------------------------
  integer(kind=index_length), intent(in) :: nv,nd  !! Size of UV data
  real, intent(inout) :: uvs(nv,nd+3)   !! UV data set with Flags
  real, intent(inout) :: uv(nd,nv)      !! Transposed version
  !
  ! Local ---
  real :: factor
  integer :: i,j
  !
  ! Code ----
  ! Loop on visibilities
  do i=1,nv
    ! Apply uvflag array
    factor = 2*uvs(i,nd+1)-1    ! 1 or -1 depending on selected option
    do j=10,nd,3
      uvs(i,j) = abs(uvs(i,j))*factor
    enddo
  enddo
  ! Transpose uvs completely because uv and uvs may be ordered differently...
  do i=1,nv
    uv(1:nd,i) = uvs(i,1:nd)
  enddo
end subroutine apply_uvflag
!
subroutine uv_flag_file(line,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : space_nitems, map_message, sub_doflag, basant
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command  
  !   UV_FLAG /File FileIn [FileOut] [/DATE] [/ANTENNA] [/RESET] 
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(inout) :: error       !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_FLAG'
  real(8), parameter :: pi=3.14159265358979323846d0
  integer, parameter :: O_RESET=4
  integer, parameter :: O_FILE=3
  integer, parameter :: O_DATE=2
  integer, parameter :: O_ANT=1
  !
  ! Local ---
  integer(kind=index_length) :: nvisi, ib
  integer :: nblock, mvisi
  type(gildas) :: hiuv, houv
  character(len=80) :: uvdata, baseline, mess
  integer :: n, nc(2), i, ibase, ier, narg
  integer, allocatable :: iant(:)
  real(8) :: ut1, ut2
  real(4) :: riant, rjant, rflag
  logical :: new
  !
  ! Code ----
  call sic_ch(line,o_file,1,uvdata,n,.true.,error)
  if (error) return
  !
  if (sic_present(o_date,0)) then
    call sub_get_datetime_range(line,ut1,ut2,error)
    if (error) return
  else
    ut1 = -huge(1.d0)
    ut2 = huge(1.d0)
  endif
  !
  ! No /BASELINE option anymore...
  baseline = "ALL"
  if (baseline.eq."ALL") then
    ibase = 0
  else
    read(baseline,*,iostat=ier) riant,rjant
    if (ier.ne.0) then
      error = .true.
      return
    endif
    ibase = basant(riant,rjant)
  endif
  !
  ! /RESET
  rflag = -1
  if (sic_present(o_reset,0)) rflag = 1
  !
  ! /ANTENNA  (only one at a time)
  if (sic_present(O_ANT,0)) then
    narg = sic_narg(O_ANT)
    if (narg.eq.0) then
      call map_message(seve%e,'UV_FLAG','Missing argument of option /ANTENNA')
      error = .true.
      return
    endif
    allocate(iant(narg))
    do i=1,narg
      call sic_i4(line,O_ANT,i,iant(i),.true.,error)
      if (error) return
    enddo
  else
    allocate(iant(1))
    iant = 0
  endif
  !
  ! Input file
  n = len_trim(uvdata)
  call gildas_null(hiuv, type = 'UVT')
  call gildas_null(houv, type = 'UVT')
  call sic_parse_file(uvdata,' ','.uvt',hiuv%file)  !
  ! Open in Read/Write mode if no Output file 
  new = sic_present(o_file,2)
  if (.not.new) hiuv%loca%read = .false. ! Write in place, open in RW
  call gdf_read_header(hiuv,error)
  if (error) return
  !
  call gdf_copy_header(hiuv,houv,error)
  !
  nc = 0 ! Channel range, whole... no /RANGE option here
  ier = gdf_range(nc,hiuv%gil%nchan)
  !
  ! Set the Blocking Factor
  nblock = space_nitems('SPACE_IMAGER',hiuv,1)
  mvisi = nblock
  !
  allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Output file if present
  if (new) then
    call sic_ch(line,o_file,2,uvdata,n,.true.,error)
    if (error) return
    call sic_parse_file(uvdata,' ','.uvt',houv%file)
    call gdf_create_image(houv,error)
    if (error) return
  endif
  !
  do ib=1,hiuv%gil%dim(2),mvisi
    !
    ! Read the data
    write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
    call map_message(seve%i,rname,mess)
    hiuv%blc(2) = ib
    hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
    nvisi = hiuv%trc(2)-hiuv%blc(2)+1
    call gdf_read_data(hiuv,hiuv%r2d,error)
    if (error) return
    !
    call sub_doflag (hiuv%r2d,hiuv%gil%dim(1),nvisi,ibase,   &
       &    iant, nc, rflag, ut1, ut2)
    !
    if (new) then
      houv%blc = hiuv%blc
      houv%trc = hiuv%trc
      call gdf_write_data (houv,hiuv%r2d,error)
    else
      call gdf_write_data (hiuv,hiuv%r2d,error)
    endif
    if (error) return
  enddo
  !
  deallocate(hiuv%r2d)  
  call gdf_close_image(hiuv,error)
  if (new) call gdf_close_image(houv,error)
  if (error) return
  !
  if (new) then
    call map_message(seve%i,rname,'Created '//trim(houv%file))
  else
    call map_message(seve%i,rname,'Updated '//trim(hiuv%file))
  endif
  !
end subroutine uv_flag_file
!
subroutine sub_doflag (out,nx,nv,ibase, iant, nc, rflag, ut_start, ut_end)
  use gildas_def
  use imager_interfaces, only : basant
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- Support routine for UV_FLAG
  !
  ! Conditionally change sign of weights according to RFLAG
  !!
  !---------------------------------------------------------------------
  integer(kind=index_length) :: nx    !! Size of a visibility
  integer(kind=index_length) :: nv    !! Number of visibilities
  real :: out(nx,nv)                  !! Visibilities
  integer :: ibase                    !! Baseline number (0 = any)
  integer :: iant(:)                  !! Antenna number  (0 = any)
  integer :: nc(2)                    !! First and Last channel (0,0 = all)
  real :: rflag                       !! Flag (<0) or Unflag (>0)
  real(8), optional :: ut_start       !! Start time
  real(8), optional :: ut_end         !! End time
  !
  ! Local ---
  integer :: i,j, i1, i2, ib
  real(8) :: t, ut1, ut2
  !------------------------------------------------------------------------
  ! Code ----
  !
  if (present(ut_start).or.present(ut_end)) then
    if (present(ut_start)) then
      ut1 = ut_start
    else
      ut1 = -huge(1.d0)
    endif
    if (present(ut_end)) then
      ut2 = ut_end
    else
      ut2 = huge(1.d0)
    endif
    !
    if (iant(1).ne.0) then
      ! Antenna based
      do j=1,nv
        t = out(4,j)+out(5,j)/86400d0
        i1 = nint(out(6,j))
        i2 = nint(out(7,j))
        if (t.gt.ut1 .and. t.lt.ut2 .and.   &
         & (is_among(iant,i1) .or. is_among(iant,i2)) ) then
          do i = 3*nc(1), 3*nc(2), 3
            out(i+7,j) = sign(out(i+7,j),rflag)
          enddo
        endif
      enddo
    else if (ibase.ne.0) then 
      ! Baseline based
      do j=1,nv
        t = out(4,j)+out(5,j)/86400d0
        ib = basant(out(6,j),out(7,j))
        if (t.gt.ut1 .and. t.lt.ut2 .and.   &
         &      (ib.eq.ibase)) then
          do i = 3*nc(1), 3*nc(2), 3
            out(i+7,j) = sign(out(i+7,j),rflag)
          enddo
        endif
      enddo
    else
      ! Everything
      do j=1,nv
        t = out(4,j)+out(5,j)/86400d0
        if (t.gt.ut1 .and. t.lt.ut2) then
          do i = 3*nc(1), 3*nc(2), 3
            out(i+7,j) = sign(out(i+7,j),rflag)
          enddo
        endif
      enddo
    endif
    !
  else
    !
    !No time range
    if (iant(1).ne.0) then
      ! Antenna based
      do j=1,nv
        i1 = nint(out(6,j))
        i2 = nint(out(7,j))
        if (is_among(iant,i1) .or. is_among(iant,i2)) then
          do i = 3*nc(1), 3*nc(2), 3
            out(i+7,j) = sign(out(i+7,j),rflag)
          enddo
        endif
      enddo
    else if (ibase.ne.0) then 
      ! Baseline based
      do j=1,nv
        ib = basant(out(6,j),out(7,j))
        if (ib.eq.ibase) then
          do i = 3*nc(1), 3*nc(2), 3
            out(i+7,j) = sign(out(i+7,j),rflag)
          enddo
        endif
      enddo
    endif
  endif
  !
contains
  logical function is_among(array,value)
    integer, intent(in) :: array(:)
    integer, intent(in) :: value
    !
    integer :: i
    !
    is_among = .true.
    do i=1,size(array)
      if (array(i).eq.value) return
    enddo
    is_among = .false.
  end function is_among
end subroutine sub_doflag
!
integer function basant(ri,rj)
  ! @ private
  real, intent(in) :: ri,rj
  !
  if (ri.gt.rj) then
    basant = 256*nint(rj)+nint(ri)
  else
    basant = 256*nint(ri)+nint(rj)
  endif
end function basant
!
subroutine sub_get_datetime_range(line,ut1,ut2,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  ! @ private-mandatory
  !*
  ! IMAGER -- Support for command UV_FLAG 
  !
  ! Get date/time range
  !!
  character(len=*), intent(in) :: line    !! Command line
  real(8), intent(inout) :: ut1           !! Start date/time
  real(8), intent(inout) :: ut2           !! End date/time
  logical, intent(inout) :: error         !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_FLAG'
  real(8), parameter :: pi=acos(-1d0) 
  integer, parameter :: O_RESET=4
  integer, parameter :: O_FILE=3
  integer, parameter :: O_DATE=2
  integer, parameter :: O_ANT=1
  !
  ! Local ---
  character(len=80) :: ut_start, ut_end, date_start, date_end
  integer :: i,larg
  real(8) :: tt
  !
  ! Code ----
  call sic_ch(line,o_date,1,date_start,larg,.true.,error)
  call gag_fromdate(date_start(1:larg),i,error)
  if (error) then
    call map_message(seve%e,rname,'Error converting date '//date_start(1:larg))
    return
  endif
  ut1 = i
  !
  select case (sic_narg(o_date))
  case(1)
    ut2 = ut1 + 1.d0
  case (2)
    ! Start_Date End_Date
    call sic_ch(line,o_date,2,date_end,larg,.true.,error)
    call gag_fromdate(date_end(1:larg),i,error)
    if (error) then
      call map_message(seve%e,rname,'Error converting date '//date_start(1:larg))
      return
    endif
    ut2 = ut1+1.d0
    !
  case(3) 
    ! Date Start_Time End_Time
    call sic_ch(line,o_date,2,ut_start,larg,.true.,error)
    call sic_decode(ut_start,tt,24,error)    ! TT in RADIANS
    if (error) then
      call map_message(seve%e,rname,'Error converting time '//date_start(1:larg))
      return
    endif
    ut2 = ut1
    ut1 = ut1+tt/2.d0/pi
    !
    call sic_ch(line,o_date,3,ut_end,larg,.true.,error)
    call sic_decode(ut_end,tt,24,error)    ! TT in RADIANS
    if (error) then
      call map_message(seve%e,rname,'Error converting time '//ut_end(1:larg))
      return
    endif
    ut2 = ut2+tt/2.d0/pi
  case(4)
    ! Start_Date Time End_Date Time
    call sic_ch(line,o_date,2,ut_start,larg,.true.,error)
    call sic_decode(ut_start,tt,24,error)    ! TT in RADIANS
    if (error) then
      call map_message(seve%e,rname,'Error converting time '//date_start(1:larg))
      return
    endif
    ut1 = ut1+tt/2.d0/pi
    !
    call sic_ch(line,o_date,3,date_end,larg,.true.,error)
    call gag_fromdate(date_end(1:larg),i,error)
    if (error) then
      call map_message(seve%e,rname,'Error converting date '//date_start(1:larg))
      return
    endif
    ut2 = i
    !
    call sic_ch(line,o_date,4,ut_end,larg,.true.,error)
    call sic_decode(ut_end,tt,24,error)    ! TT in RADIANS
    if (error) then
      call map_message(seve%e,rname,'Error converting time '//ut_end(1:larg))
      return
    endif
    ut2 = ut2+tt/2.d0/pi
  case default
    call map_message(seve%e,rname,'Invalid syntax')
    error = .true.
    return
  end select
end subroutine sub_get_datetime_range

subroutine do_scalar (func,form,dimr,result,noper,ioper,operand,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  use sic_expressions
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Buffer routine used to call a function whose address is known.
  ! Version for SCALAR functions
  ! Arguments:
  !       FUNC            Ext     Function to call                Input
  !       FORM            I       Precision of result             Input
  !       RESULT          I       Pointer to result               Input
  !       NOPER           I       Number of operands              Input
  !       IOPER           I       Pointers to operands            Input
  !---------------------------------------------------------------------
  external                                 :: func          !
  integer                                  :: form          !
  integer(kind=size_length)                :: dimr          ! Dimension of result (input)
  integer                                  :: result        !
  integer                                  :: noper         !
  integer                                  :: ioper(noper)  !
  type(sic_descriptor_t)                   :: operand(0:maxoper)  ! List of operands (input)
  logical,                   intent(inout) :: error         ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='EVALUATE'
  integer(kind=address_length) :: ipnt1,ipnt2,ipnt3,ipntr
  character(len=message_length) :: mess
  !
  if (noper.gt.3) then
    call sic_message(seve%e,rname,'Internal logic error')
    error = .true.
    return
  endif
  !
  ipnt1 = gag_pointer(operand(ioper(1))%addr,memory)
  ipntr = gag_pointer(operand(result)%addr,memory)
  !
  if (form.eq.fmt_r8) then
    ! Real*8 calls
    if (noper.eq.1) then
      call do_dble_loop1(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),error)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      call do_dble_loop2(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),  &
            operand(ioper(2))%size/2,memory(ipnt2),error)
    elseif (noper.eq.3) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      ipnt3 = gag_pointer(operand(ioper(3))%addr,memory)
      call do_dble_loop3(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),  &
            operand(ioper(2))%size/2,memory(ipnt2),  &
            operand(ioper(3))%size/2,memory(ipnt3),  &
            error)
    endif
    !
  elseif (form.eq.fmt_r4) then
    ! Real*4 calls
    if (noper.eq.1) then
      call do_real_loop1(func,dimr,memory(ipntr),  &
              operand(ioper(1))%size,memory(ipnt1),error)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      call do_real_loop2(func,dimr,memory(ipntr),  &
              operand(ioper(1))%size,memory(ipnt1),  &
              operand(ioper(2))%size,memory(ipnt2),error)
    elseif (noper.eq.3) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      ipnt3 = gag_pointer(operand(ioper(3))%addr,memory)
      call do_real_loop3(func,dimr,memory(ipntr),  &
              operand(ioper(1))%size,memory(ipnt1),  &
              operand(ioper(2))%size,memory(ipnt2),  &
              operand(ioper(3))%size,memory(ipnt3),  &
              error)
    endif
    !
  elseif (form.eq.fmt_i8) then
    ! Integer*8 calls
    if (noper.eq.1) then
      call do_long_loop1(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),error)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      call do_long_loop2(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),  &
            operand(ioper(2))%size/2,memory(ipnt2),error)
    elseif (noper.eq.3) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      ipnt3 = gag_pointer(operand(ioper(3))%addr,memory)
      call do_long_loop3(func,dimr,memory(ipntr),  &
            operand(ioper(1))%size/2,memory(ipnt1),  &
            operand(ioper(2))%size/2,memory(ipnt2),  &
            operand(ioper(3))%size/2,memory(ipnt3),  &
            error)
    endif
    !
  else
    ! Unsupported precision
    write(mess,100) 'Invalid precision ',form
    call sic_message(seve%e,rname,mess)
    error = .true.
  endif
  return
  !
100 format (a,i3,a)
end subroutine do_scalar
!
subroutine do_vector (func,form,dimr,result,noper,ioper,operand,code,error)
  use sic_dependencies_interfaces
  use sic_interfaces
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !  Buffer routine used to call a function whose address is known.
  ! Version for VECTOR function
  ! Arguments:
  !       FUNC            Ext     Function to call                Input
  !       FORM            I       Precision of result             Input
  !       RESULT          I       Pointer to result               Input
  !       NOPER           I       Number of operands              Input
  !       IOPER           I       Pointers to operands            Input
  !       CODE            I       Code of operation               Input
  !       ERROR           L       Logical error flag              Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  integer, external :: func                 !
  integer :: form                           !
  integer(kind=size_length) :: dimr         ! Dimension of result (input)
  integer :: result                         !
  integer :: noper                          !
  integer :: ioper(noper)                   !
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input)
  integer :: code                           !
  logical :: error                          !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='EVALUATE'
  integer(kind=address_length) :: ipnt1,ipnt2,ipntr
  integer ::  i,isgood
  integer(kind=size_length) :: nelem(noper)
  integer(kind=address_length) :: nwords(noper)
  character(len=message_length) :: mess
  !
  ! A Python function can be called with no argument number check.
  if ((noper.gt.2).and.(code.ne.code_pyfunc)) then
    call sic_message(seve%e,rname,'Internal logic error')
    error = .true.
    return
  endif
  !
  ipnt1 = gag_pointer(operand(ioper(1))%addr,memory)
  ipntr = gag_pointer(operand(result)%addr,memory)
  !
  isgood = 0   ! Avoid initialization warning
  if (form.eq.fmt_r8) then
    ! Real*8 calls
    if (code.eq.code_pyfunc) then
      do i=1,noper
        nelem(i)  = operand(ioper(i))%size/2
        nwords(i) = gag_pointer(operand(ioper(i))%addr,memory)
      enddo
      isgood = func (noper,nelem,nwords,dimr,memory(ipntr))
    elseif (noper.eq.1) then
      isgood = func (dimr,memory(ipntr),  &
               operand(ioper(1))%size/2,memory(ipnt1),0,0)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      isgood = func (dimr,memory(ipntr),              &
               operand(ioper(1))%size/2,memory(ipnt1),  &
               operand(ioper(2))%size/2,memory(ipnt2))
    endif
    !
  elseif (form.eq.fmt_r4) then
    ! Real*4 calls
    if (code.eq.code_pyfunc) then
      do i=1,noper
        nelem(i)  = operand(ioper(i))%size
        nwords(i) = gag_pointer(operand(ioper(i))%addr,memory)
      enddo
      isgood = func (noper,nelem,nwords,dimr,memory(ipntr))
    elseif (noper.eq.1) then
      isgood = func (dimr,memory(ipntr),  &
               operand(ioper(1))%size,memory(ipnt1),0,0)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      isgood = func(dimr,memory(ipntr),             &
               operand(ioper(1))%size,memory(ipnt1),  &
               operand(ioper(2))%size,memory(ipnt2))
    endif
    !
  elseif (form.eq.fmt_i8) then
    ! Integer*8 calls
    if (code.eq.code_pyfunc) then
      do i=1,noper
        nelem(i)  = operand(ioper(i))%size/2
        nwords(i) = gag_pointer(operand(ioper(i))%addr,memory)
      enddo
      isgood = func (noper,nelem,nwords,dimr,memory(ipntr))
    elseif (noper.eq.1) then
      isgood = func (dimr,memory(ipntr),  &
               operand(ioper(1))%size/2,memory(ipnt1),0,0)
    elseif (noper.eq.2) then
      ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
      isgood = func (dimr,memory(ipntr),              &
               operand(ioper(1))%size/2,memory(ipnt1),  &
               operand(ioper(2))%size/2,memory(ipnt2))
    endif
    !
  else
    ! Unsupported precision
    write(mess,100) 'Invalid precision ',form
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  error = isgood.ne.0
  !
100 format (a,i3,a)
end subroutine do_vector

* DECK dhgeqz.f
      SUBROUTINE DHGEQZ( JOB, COMPQ, COMPZ, N, ILO, IHI, A, LDA, B, LDB,
     $                   ALPHAR, ALPHAI, BETA, Q, LDQ, Z, LDZ, WORK,
     $                   LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          COMPQ, COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDA, LDB, LDQ, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), ALPHAI( * ), ALPHAR( * ),
     $                   B( LDB, * ), BETA( * ), Q( LDQ, * ), WORK( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DHGEQZ implements a single-/double-shift version of the QZ method for
*  finding the generalized eigenvalues
*
*  w(j)=(ALPHAR(j) + i*ALPHAI(j))/BETAR(j)   of the equation
*
*       det( A - w(i) B ) = 0
*
*  In addition, the pair A,B may be reduced to generalized Schur form:
*  B is upper triangular, and A is block upper triangular, where the
*  diagonal blocks are either 1-by-1 or 2-by-2, the 2-by-2 blocks having
*  complex generalized eigenvalues (see the description of the argument
*  JOB.)
*
*  If JOB='S', then the pair (A,B) is simultaneously reduced to Schur
*  form by applying one orthogonal tranformation (usually called Q) on
*  the left and another (usually called Z) on the right.  The 2-by-2
*  upper-triangular diagonal blocks of B corresponding to 2-by-2 blocks
*  of A will be reduced to positive diagonal matrices.  (I.e.,
*  if A(j+1,j) is non-zero, then B(j+1,j)=B(j,j+1)=0 and B(j,j) and
*  B(j+1,j+1) will be positive.)
*
*  If JOB='E', then at each iteration, the same transformations
*  are computed, but they are only applied to those parts of A and B
*  which are needed to compute ALPHAR, ALPHAI, and BETAR.
*
*  If JOB='S' and COMPQ and COMPZ are 'V' or 'I', then the orthogonal
*  transformations used to reduce (A,B) are accumulated into the arrays
*  Q and Z s.t.:
*
*       Q(in) A(in) Z(in)* = Q(out) A(out) Z(out)*
*       Q(in) B(in) Z(in)* = Q(out) B(out) Z(out)*
*
*  Ref: C.B. Moler & G.W. Stewart, "An Algorithm for Generalized Matrix
*       Eigenvalue Problems", SIAM J. Numer. Anal., 10(1973),
*       pp. 241--256.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E': compute only ALPHAR, ALPHAI, and BETA.  A and B will
*                 not necessarily be put into generalized Schur form.
*          = 'S': put A and B into generalized Schur form, as well
*                 as computing ALPHAR, ALPHAI, and BETA.
*
*  COMPQ   (input) CHARACTER*1
*          = 'N': do not modify Q.
*          = 'V': multiply the array Q on the right by the transpose of
*                 the orthogonal tranformation that is applied to the
*                 left side of A and B to reduce them to Schur form.
*          = 'I': like COMPQ='V', except that Q will be initialized to
*                 the identity first.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N': do not modify Z.
*          = 'V': multiply the array Z on the right by the orthogonal
*                 tranformation that is applied to the right side of
*                 A and B to reduce them to Schur form.
*          = 'I': like COMPZ='V', except that Z will be initialized to
*                 the identity first.
*
*  N       (input) INTEGER
*          The order of the matrices A, B, Q, and Z.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that A is already upper triangular in rows and
*          columns 1:ILO-1 and IHI+1:N.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA, N)
*          On entry, the N-by-N upper Hessenberg matrix A.  Elements
*          below the subdiagonal must be zero.
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to generalized Schur form.
*          If JOB='E', then on exit A will have been destroyed.
*             The diagonal blocks will be correct, but the off-diagonal
*             portion will be meaningless.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max( 1, N ).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB, N)
*          On entry, the N-by-N upper triangular matrix B.  Elements
*          below the diagonal must be zero.  2-by-2 blocks in B
*          corresponding to 2-by-2 blocks in A will be reduced to
*          positive diagonal form.  (I.e., if A(j+1,j) is non-zero,
*          then B(j+1,j)=B(j,j+1)=0 and B(j,j) and B(j+1,j+1) will be
*          positive.)
*          If JOB='S', then on exit A and B will have been
*             simultaneously reduced to Schur form.
*          If JOB='E', then on exit B will have been destroyed.
*             Elements corresponding to diagonal blocks of A will be
*             correct, but the off-diagonal portion will be meaningless.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max( 1, N ).
*
*  ALPHAR  (output) DOUBLE PRECISION array, dimension (N)
*          ALPHAR(1:N) will be set to real parts of the diagonal
*          elements of A that would result from reducing A and B to
*          Schur form and then further reducing them both to triangular
*          form using unitary transformations s.t. the diagonal of B
*          was non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then ALPHAR(j)=A(j,j).
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*
*  ALPHAI  (output) DOUBLE PRECISION array, dimension (N)
*          ALPHAI(1:N) will be set to imaginary parts of the diagonal
*          elements of A that would result from reducing A and B to
*          Schur form and then further reducing them both to triangular
*          form using unitary transformations s.t. the diagonal of B
*          was non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then ALPHAR(j)=0.
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*
*  BETA    (output) DOUBLE PRECISION array, dimension (N)
*          BETA(1:N) will be set to the (real) diagonal elements of B
*          that would result from reducing A and B to Schur form and
*          then further reducing them both to triangular form using
*          unitary transformations s.t. the diagonal of B was
*          non-negative real.  Thus, if A(j,j) is in a 1-by-1 block
*          (i.e., A(j+1,j)=A(j,j+1)=0), then BETA(j)=B(j,j).
*          Note that the (real or complex) values
*          (ALPHAR(j) + i*ALPHAI(j))/BETA(j), j=1,...,N, are the
*          generalized eigenvalues of the matrix pencil A - wB.
*          (Note that BETA(1:N) will always be non-negative, and no
*          BETAI is necessary.)
*
*  Q       (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*          If COMPQ='N', then Q will not be referenced.
*          If COMPQ='V' or 'I', then the transpose of the orthogonal
*             transformations which are applied to A and B on the left
*             will be applied to the array Q on the right.
*
*  LDQ     (input) INTEGER
*          The leading dimension of the array Q.  LDQ >= 1.
*          If COMPQ='V' or 'I', then LDQ >= N.
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ, N)
*          If COMPZ='N', then Z will not be referenced.
*          If COMPZ='V' or 'I', then the orthogonal transformations
*             which are applied to A and B on the right will be applied
*             to the array Z on the right.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.  LDZ >= 1.
*          If COMPZ='V' or 'I', then LDZ >= N.
*
*  WORK    (workspace/output) DOUBLE PRECISION array, dimension (LWORK)
*          On exit, if INFO >= 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK.  LWORK >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -i, the i-th argument had an illegal value
*          = 1,...,N: the QZ iteration did not converge.  (A,B) is not
*                     in Schur form, but ALPHAR(i), ALPHAI(i), and
*                     BETA(i), i=INFO+1,...,N should be correct.
*          = N+1,...,2*N: the shift calculation failed.  (A,B) is not
*                     in Schur form, but ALPHAR(i), ALPHAI(i), and
*                     BETA(i), i=INFO-N+1,...,N should be correct.
*          > 2*N:     various "impossible" errors.
*
*  Further Details
*  ===============
*
*  Iteration counters:
*
*  JITER  -- counts iterations.
*  IITER  -- counts iterations run since ILAST was last
*            changed.  This is therefore reset only when a 1-by-1 or
*            2-by-2 block deflates off the bottom.
*
*  =====================================================================
*
*     .. Parameters ..
*    $                     SAFETY = 1.0E+0 )
      DOUBLE PRECISION   HALF, ZERO, ONE, SAFETY
      PARAMETER          ( HALF = 0.5D+0, ZERO = 0.0D+0, ONE = 1.0D+0,
     $                   SAFETY = 1.0D+2 )
*     ..
*     .. Local Scalars ..
      LOGICAL            ILAZR2, ILAZRO, ILPIVT, ILQ, ILSCHR, ILZ
      INTEGER            ICOMPQ, ICOMPZ, IFIRST, IFRSTM, IITER, ILAST,
     $                   ILASTM, IN, ISCHUR, ISTART, J, JC, JCH, JITER,
     $                   JR, MAXIT
      DOUBLE PRECISION   A11, A12, A1I, A1R, A21, A22, A2I, A2R, AD11,
     $                   AD11L, AD12, AD12L, AD21, AD21L, AD22, AD22L,
     $                   AD32L, AN, ANORM, ASCALE, ATOL, B11, B1A, B1I,
     $                   B1R, B22, B2A, B2I, B2R, BN, BNORM, BSCALE,
     $                   BTOL, C, C11I, C11R, C12, C21, C22I, C22R, CL,
     $                   CQ, CR, CZ, ESHIFT, S, S1, S1INV, S2, SAFMAX,
     $                   SAFMIN, SCALE, SL, SQI, SQR, SR, SZI, SZR, T,
     $                   TAU, TEMP, TEMP2, TEMPI, TEMPR, U1, U12, U12L,
     $                   U2, ULP, VS, W11, W12, W21, W22, WABS, WI, WR,
     $                   WR2
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   V( 3 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANHS, DLAPY2, DLAPY3
      EXTERNAL           LSAME, DLAMCH, DLANHS, DLAPY2, DLAPY3
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAG2, DLARFG, DLARTG, DLASET, DLASV2, DROT,
     $                   XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, MAX, MIN, SQRT
*     ..
*     .. Executable Statements ..
*
*     Decode JOB, COMPQ, COMPZ
*
      IF( LSAME( JOB, 'E' ) ) THEN
         ILSCHR = .FALSE.
         ISCHUR = 1
      ELSE IF( LSAME( JOB, 'S' ) ) THEN
         ILSCHR = .TRUE.
         ISCHUR = 2
      ELSE
         ISCHUR = 0
      END IF
*
      IF( LSAME( COMPQ, 'N' ) ) THEN
         ILQ = .FALSE.
         ICOMPQ = 1
      ELSE IF( LSAME( COMPQ, 'V' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 2
      ELSE IF( LSAME( COMPQ, 'I' ) ) THEN
         ILQ = .TRUE.
         ICOMPQ = 3
      ELSE
         ICOMPQ = 0
      END IF
*
      IF( LSAME( COMPZ, 'N' ) ) THEN
         ILZ = .FALSE.
         ICOMPZ = 1
      ELSE IF( LSAME( COMPZ, 'V' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 2
      ELSE IF( LSAME( COMPZ, 'I' ) ) THEN
         ILZ = .TRUE.
         ICOMPZ = 3
      ELSE
         ICOMPZ = 0
      END IF
*
*     Check Argument Values
*
      INFO = 0
      IF( ISCHUR.EQ.0 ) THEN
         INFO = -1
      ELSE IF( ICOMPQ.EQ.0 ) THEN
         INFO = -2
      ELSE IF( ICOMPZ.EQ.0 ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -4
      ELSE IF( ILO.LT.1 ) THEN
         INFO = -5
      ELSE IF( IHI.GT.N .OR. IHI.LT.ILO-1 ) THEN
         INFO = -6
      ELSE IF( LDA.LT.N ) THEN
         INFO = -8
      ELSE IF( LDB.LT.N ) THEN
         INFO = -10
      ELSE IF( LDQ.LT.1 .OR. ( ILQ .AND. LDQ.LT.N ) ) THEN
         INFO = -15
      ELSE IF( LDZ.LT.1 .OR. ( ILZ .AND. LDZ.LT.N ) ) THEN
         INFO = -17
      ELSE IF( LWORK.LT.MAX( 1, N ) ) THEN
         INFO = -19
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DHGEQZ', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.0 ) THEN
         WORK( 1 ) = DBLE( 1 )
         RETURN
      END IF
*
*     Initialize Q and Z
*
      IF( ICOMPQ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Q, LDQ )
      IF( ICOMPZ.EQ.3 )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Machine Constants
*
      IN = IHI + 1 - ILO
      SAFMIN = DLAMCH( 'S' )
      SAFMAX = ONE / SAFMIN
      ULP = DLAMCH( 'E' )*DLAMCH( 'B' )
      ANORM = DLANHS( 'F', IN, A( ILO, ILO ), LDA, WORK )
      BNORM = DLANHS( 'F', IN, B( ILO, ILO ), LDB, WORK )
      ATOL = MAX( SAFMIN, ULP*ANORM )
      BTOL = MAX( SAFMIN, ULP*BNORM )
      ASCALE = ONE / MAX( SAFMIN, ANORM )
      BSCALE = ONE / MAX( SAFMIN, BNORM )
*
*     Set Eigenvalues IHI+1:N
*
      DO 30 J = IHI + 1, N
         IF( B( J, J ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 10 JR = 1, J
                  A( JR, J ) = -A( JR, J )
                  B( JR, J ) = -B( JR, J )
   10          CONTINUE
            ELSE
               A( J, J ) = -A( J, J )
               B( J, J ) = -B( J, J )
            END IF
            IF( ILZ ) THEN
               DO 20 JR = 1, N
                  Z( JR, J ) = -Z( JR, J )
   20          CONTINUE
            END IF
         END IF
         ALPHAR( J ) = A( J, J )
         ALPHAI( J ) = ZERO
         BETA( J ) = B( J, J )
   30 CONTINUE
*
*     If IHI < ILO, skip QZ steps
*
      IF( IHI.LT.ILO )
     $   GO TO 380
*
*     MAIN QZ ITERATION LOOP
*
*     Initialize dynamic indices
*
*     Eigenvalues ILAST+1:N have been found.
*        Column operations modify rows IFRSTM:whatever.
*        Row operations modify columns whatever:ILASTM.
*
*     If only eigenvalues are being computed, then
*        IFRSTM is the row of the last splitting row above row ILAST;
*        this is always at least ILO.
*     IITER counts iterations since the last eigenvalue was found,
*        to tell when to use an extraordinary shift.
*     MAXIT is the maximum number of QZ sweeps allowed.
*
      ILAST = IHI
      IF( ILSCHR ) THEN
         IFRSTM = 1
         ILASTM = N
      ELSE
         IFRSTM = ILO
         ILASTM = IHI
      END IF
      IITER = 0
      ESHIFT = ZERO
      MAXIT = 30*( IHI-ILO+1 )
*
      DO 360 JITER = 1, MAXIT
*
*        Split the matrix if possible.
*
*        Two tests:
*           1: A(j,j-1)=0  or  j=ILO
*           2: B(j,j)=0
*
         IF( ILAST.EQ.ILO ) THEN
*
*           Special case: j=ILAST
*
            GO TO 80
         ELSE
            IF( ABS( A( ILAST, ILAST-1 ) ).LE.ATOL ) THEN
               A( ILAST, ILAST-1 ) = ZERO
               GO TO 80
            END IF
         END IF
*
         IF( ABS( B( ILAST, ILAST ) ).LE.BTOL ) THEN
            B( ILAST, ILAST ) = ZERO
            GO TO 70
         END IF
*
*        General case: j<ILAST
*
         DO 60 J = ILAST - 1, ILO, -1
*
*           Test 1: for A(j,j-1)=0 or j=ILO
*
            IF( J.EQ.ILO ) THEN
               ILAZRO = .TRUE.
            ELSE
               IF( ABS( A( J, J-1 ) ).LE.ATOL ) THEN
                  A( J, J-1 ) = ZERO
                  ILAZRO = .TRUE.
               ELSE
                  ILAZRO = .FALSE.
               END IF
            END IF
*
*           Test 2: for B(j,j)=0
*
            IF( ABS( B( J, J ) ).LT.BTOL ) THEN
               B( J, J ) = ZERO
*
*              Test 1a: Check for 2 consecutive small subdiagonals in A
*
               ILAZR2 = .FALSE.
               IF( .NOT.ILAZRO ) THEN
                  TEMP = ABS( A( J, J-1 ) )
                  TEMP2 = ABS( A( J, J ) )
                  TEMPR = MAX( TEMP, TEMP2 )
                  IF( TEMPR.LT.ONE .AND. TEMPR.NE.ZERO ) THEN
                     TEMP = TEMP / TEMPR
                     TEMP2 = TEMP2 / TEMPR
                  END IF
                  IF( TEMP*( ASCALE*ABS( A( J+1, J ) ) ).LE.TEMP2*
     $                ( ASCALE*ATOL ) )ILAZR2 = .TRUE.
               END IF
*
*              If both tests pass (1 & 2), i.e., the leading diagonal
*              element of B in the block is zero, split a 1x1 block off
*              at the top. (I.e., at the J-th row/column) The leading
*              diagonal element of the remainder can also be zero, so
*              this may have to be done repeatedly.
*
               IF( ILAZRO .OR. ILAZR2 ) THEN
                  DO 40 JCH = J, ILAST - 1
                     TEMP = A( JCH, JCH )
                     CALL DLARTG( TEMP, A( JCH+1, JCH ), C, S,
     $                            A( JCH, JCH ) )
                     A( JCH+1, JCH ) = ZERO
                     CALL DROT( ILASTM-JCH, A( JCH, JCH+1 ), LDA,
     $                          A( JCH+1, JCH+1 ), LDA, C, S )
                     CALL DROT( ILASTM-JCH, B( JCH, JCH+1 ), LDB,
     $                          B( JCH+1, JCH+1 ), LDB, C, S )
                     IF( ILQ )
     $                  CALL DROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, S )
                     IF( ILAZR2 )
     $                  A( JCH, JCH-1 ) = A( JCH, JCH-1 )*C
                     ILAZR2 = .FALSE.
                     IF( ABS( B( JCH+1, JCH+1 ) ).GE.BTOL ) THEN
                        IF( JCH+1.GE.ILAST ) THEN
                           GO TO 80
                        ELSE
                           IFIRST = JCH + 1
                           GO TO 110
                        END IF
                     END IF
                     B( JCH+1, JCH+1 ) = ZERO
   40             CONTINUE
                  GO TO 70
               ELSE
*
*                 Only test 2 passed -- chase the zero to B(ILAST,ILAST)
*                 Then process as in the case B(ILAST,ILAST)=0
*
                  DO 50 JCH = J, ILAST - 1
                     TEMP = B( JCH, JCH+1 )
                     CALL DLARTG( TEMP, B( JCH+1, JCH+1 ), C, S,
     $                            B( JCH, JCH+1 ) )
                     B( JCH+1, JCH+1 ) = ZERO
                     IF( JCH.LT.ILASTM-1 )
     $                  CALL DROT( ILASTM-JCH-1, B( JCH, JCH+2 ), LDB,
     $                             B( JCH+1, JCH+2 ), LDB, C, S )
                     CALL DROT( ILASTM-JCH+2, A( JCH, JCH-1 ), LDA,
     $                          A( JCH+1, JCH-1 ), LDA, C, S )
                     IF( ILQ )
     $                  CALL DROT( N, Q( 1, JCH ), 1, Q( 1, JCH+1 ), 1,
     $                             C, S )
                     TEMP = A( JCH+1, JCH )
                     CALL DLARTG( TEMP, A( JCH+1, JCH-1 ), C, S,
     $                            A( JCH+1, JCH ) )
                     A( JCH+1, JCH-1 ) = ZERO
                     CALL DROT( JCH+1-IFRSTM, A( IFRSTM, JCH ), 1,
     $                          A( IFRSTM, JCH-1 ), 1, C, S )
                     CALL DROT( JCH-IFRSTM, B( IFRSTM, JCH ), 1,
     $                          B( IFRSTM, JCH-1 ), 1, C, S )
                     IF( ILZ )
     $                  CALL DROT( N, Z( 1, JCH ), 1, Z( 1, JCH-1 ), 1,
     $                             C, S )
   50             CONTINUE
                  GO TO 70
               END IF
            ELSE IF( ILAZRO ) THEN
*
*              Only test 1 passed -- work on J:ILAST
*
               IFIRST = J
               GO TO 110
            END IF
*
*           Neither test passed -- try next J
*
   60    CONTINUE
*
*        (Drop-through is "impossible")
*
         INFO = N + 1
         GO TO 420
*
*        B(ILAST,ILAST)=0 -- clear A(ILAST,ILAST-1) to split off a
*        1x1 block.
*
   70    CONTINUE
         TEMP = A( ILAST, ILAST )
         CALL DLARTG( TEMP, A( ILAST, ILAST-1 ), C, S,
     $                A( ILAST, ILAST ) )
         A( ILAST, ILAST-1 ) = ZERO
         CALL DROT( ILAST-IFRSTM, A( IFRSTM, ILAST ), 1,
     $              A( IFRSTM, ILAST-1 ), 1, C, S )
         CALL DROT( ILAST-IFRSTM, B( IFRSTM, ILAST ), 1,
     $              B( IFRSTM, ILAST-1 ), 1, C, S )
         IF( ILZ )
     $      CALL DROT( N, Z( 1, ILAST ), 1, Z( 1, ILAST-1 ), 1, C, S )
*
*        A(ILAST,ILAST-1)=0 -- Standardize B, set ALPHAR, ALPHAI,
*                              and BETA
*
   80    CONTINUE
         IF( B( ILAST, ILAST ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 90 J = IFRSTM, ILAST
                  A( J, ILAST ) = -A( J, ILAST )
                  B( J, ILAST ) = -B( J, ILAST )
   90          CONTINUE
            ELSE
               A( ILAST, ILAST ) = -A( ILAST, ILAST )
               B( ILAST, ILAST ) = -B( ILAST, ILAST )
            END IF
            IF( ILZ ) THEN
               DO 100 J = 1, N
                  Z( J, ILAST ) = -Z( J, ILAST )
  100          CONTINUE
            END IF
         END IF
         ALPHAR( ILAST ) = A( ILAST, ILAST )
         ALPHAI( ILAST ) = ZERO
         BETA( ILAST ) = B( ILAST, ILAST )
*
*        Go to next block -- exit if finished.
*
         ILAST = ILAST - 1
         IF( ILAST.LT.ILO )
     $      GO TO 380
*
*        Reset counters
*
         IITER = 0
         ESHIFT = ZERO
         IF( .NOT.ILSCHR ) THEN
            ILASTM = ILAST
            IF( IFRSTM.GT.ILAST )
     $         IFRSTM = ILO
         END IF
         GO TO 350
*
*        QZ step
*
*        This iteration only involves rows/columns IFIRST:ILAST. We
*        assume IFIRST < ILAST, and that the diagonal of B is non-zero.
*
  110    CONTINUE
         IITER = IITER + 1
         IF( .NOT.ILSCHR ) THEN
            IFRSTM = IFIRST
         END IF
*
*        Compute single shifts.
*
*        At this point, IFIRST < ILAST, and the diagonal elements of
*        B(IFIRST:ILAST,IFIRST,ILAST) are larger than BTOL (in
*        magnitude)
*
         IF( ( IITER / 10 )*10.EQ.IITER ) THEN
*
*           Exceptional shift.  Chosen for no particularly good reason.
*           (Single shift only.)
*
            IF( ( DBLE( MAXIT )*SAFMIN )*ABS( A( ILAST-1, ILAST ) ).LT.
     $          ABS( B( ILAST-1, ILAST-1 ) ) ) THEN
               ESHIFT = ESHIFT + A( ILAST-1, ILAST ) /
     $                  B( ILAST-1, ILAST-1 )
            ELSE
               ESHIFT = ESHIFT + ONE / ( SAFMIN*DBLE( MAXIT ) )
            END IF
            S1 = ONE
            WR = ESHIFT
*
         ELSE
*
*           Shifts based on the generalized eigenvalues of the
*           bottom-right 2x2 block of A and B. The first eigenvalue
*           returned by DLAG2 is the Wilkinson shift (AEP p.512),
*
            CALL DLAG2( A( ILAST-1, ILAST-1 ), LDA,
     $                  B( ILAST-1, ILAST-1 ), LDB, SAFMIN*SAFETY, S1,
     $                  S2, WR, WR2, WI )
*
            TEMP = MAX( S1, SAFMIN*MAX( ONE, ABS( WR ), ABS( WI ) ) )
            IF( WI.NE.ZERO )
     $         GO TO 200
         END IF
*
*        Fiddle with shift to avoid overflow
*
         TEMP = MIN( ASCALE, ONE )*( HALF*SAFMAX )
         IF( S1.GT.TEMP ) THEN
            SCALE = TEMP / S1
         ELSE
            SCALE = ONE
         END IF
*
         TEMP = MIN( BSCALE, ONE )*( HALF*SAFMAX )
         IF( ABS( WR ).GT.TEMP )
     $      SCALE = MIN( SCALE, TEMP / ABS( WR ) )
         S1 = SCALE*S1
         WR = SCALE*WR
*
*        Now check for two consecutive small subdiagonals.
*
         DO 120 J = ILAST - 1, IFIRST + 1, -1
            ISTART = J
            TEMP = ABS( S1*A( J, J-1 ) )
            TEMP2 = ABS( S1*A( J, J )-WR*B( J, J ) )
            TEMPR = MAX( TEMP, TEMP2 )
            IF( TEMPR.LT.ONE .AND. TEMPR.NE.ZERO ) THEN
               TEMP = TEMP / TEMPR
               TEMP2 = TEMP2 / TEMPR
            END IF
            IF( ABS( ( ASCALE*A( J+1, J ) )*TEMP ).LE.( ASCALE*ATOL )*
     $          TEMP2 )GO TO 130
  120    CONTINUE
*
         ISTART = IFIRST
  130    CONTINUE
*
*        Do an implicit single-shift QZ sweep.
*
*        Initial Q
*
         TEMP = S1*A( ISTART, ISTART ) - WR*B( ISTART, ISTART )
         TEMP2 = S1*A( ISTART+1, ISTART )
         CALL DLARTG( TEMP, TEMP2, C, S, TEMPR )
*
*        Sweep
*
         DO 190 J = ISTART, ILAST - 1
            IF( J.GT.ISTART ) THEN
               TEMP = A( J, J-1 )
               CALL DLARTG( TEMP, A( J+1, J-1 ), C, S, A( J, J-1 ) )
               A( J+1, J-1 ) = ZERO
            END IF
*
            DO 140 JC = J, ILASTM
               TEMP = C*A( J, JC ) + S*A( J+1, JC )
               A( J+1, JC ) = -S*A( J, JC ) + C*A( J+1, JC )
               A( J, JC ) = TEMP
               TEMP2 = C*B( J, JC ) + S*B( J+1, JC )
               B( J+1, JC ) = -S*B( J, JC ) + C*B( J+1, JC )
               B( J, JC ) = TEMP2
  140       CONTINUE
            IF( ILQ ) THEN
               DO 150 JR = 1, N
                  TEMP = C*Q( JR, J ) + S*Q( JR, J+1 )
                  Q( JR, J+1 ) = -S*Q( JR, J ) + C*Q( JR, J+1 )
                  Q( JR, J ) = TEMP
  150          CONTINUE
            END IF
*
            TEMP = B( J+1, J+1 )
            CALL DLARTG( TEMP, B( J+1, J ), C, S, B( J+1, J+1 ) )
            B( J+1, J ) = ZERO
*
            DO 160 JR = IFRSTM, MIN( J+2, ILAST )
               TEMP = C*A( JR, J+1 ) + S*A( JR, J )
               A( JR, J ) = -S*A( JR, J+1 ) + C*A( JR, J )
               A( JR, J+1 ) = TEMP
  160       CONTINUE
            DO 170 JR = IFRSTM, J
               TEMP = C*B( JR, J+1 ) + S*B( JR, J )
               B( JR, J ) = -S*B( JR, J+1 ) + C*B( JR, J )
               B( JR, J+1 ) = TEMP
  170       CONTINUE
            IF( ILZ ) THEN
               DO 180 JR = 1, N
                  TEMP = C*Z( JR, J+1 ) + S*Z( JR, J )
                  Z( JR, J ) = -S*Z( JR, J+1 ) + C*Z( JR, J )
                  Z( JR, J+1 ) = TEMP
  180          CONTINUE
            END IF
  190    CONTINUE
*
         GO TO 350
*
*        Use Francis double-shift
*
*        Note: the Francis double-shift should work with real shifts,
*              but only if the block is at least 3x3.
*              This code may break if this point is reached with
*              a 2x2 block with real eigenvalues.
*
  200    CONTINUE
         IF( IFIRST+1.EQ.ILAST ) THEN
*
*           Special case -- 2x2 block with complex eigenvectors
*
*           Step 1: Standardize, that is, rotate so that
*
*                       ( B11  0  )
*                   B = (         )  with B11 non-negative.
*                       (  0  B22 )
*
            CALL DLASV2( B( ILAST-1, ILAST-1 ), B( ILAST-1, ILAST ),
     $                   B( ILAST, ILAST ), B22, B11, SR, CR, SL, CL )
*
            IF( B11.LT.ZERO ) THEN
               CR = -CR
               SR = -SR
               B11 = -B11
               B22 = -B22
            END IF
*
            CALL DROT( ILASTM+1-IFIRST, A( ILAST-1, ILAST-1 ), LDA,
     $                 A( ILAST, ILAST-1 ), LDA, CL, SL )
            CALL DROT( ILAST+1-IFRSTM, A( IFRSTM, ILAST-1 ), 1,
     $                 A( IFRSTM, ILAST ), 1, CR, SR )
*
            IF( ILAST.LT.ILASTM )
     $         CALL DROT( ILASTM-ILAST, B( ILAST-1, ILAST+1 ), LDB,
     $                    B( ILAST, ILAST+1 ), LDA, CL, SL )
            IF( IFRSTM.LT.ILAST-1 )
     $         CALL DROT( IFIRST-IFRSTM, B( IFRSTM, ILAST-1 ), 1,
     $                    B( IFRSTM, ILAST ), 1, CR, SR )
*
            IF( ILQ )
     $         CALL DROT( N, Q( 1, ILAST-1 ), 1, Q( 1, ILAST ), 1, CL,
     $                    SL )
            IF( ILZ )
     $         CALL DROT( N, Z( 1, ILAST-1 ), 1, Z( 1, ILAST ), 1, CR,
     $                    SR )
*
            B( ILAST-1, ILAST-1 ) = B11
            B( ILAST-1, ILAST ) = ZERO
            B( ILAST, ILAST-1 ) = ZERO
            B( ILAST, ILAST ) = B22
*
*           If B22 is negative, negate column ILAST
*
            IF( B22.LT.ZERO ) THEN
               DO 210 J = IFRSTM, ILAST
                  A( J, ILAST ) = -A( J, ILAST )
                  B( J, ILAST ) = -B( J, ILAST )
  210          CONTINUE
*
               IF( ILZ ) THEN
                  DO 220 J = 1, N
                     Z( J, ILAST ) = -Z( J, ILAST )
  220             CONTINUE
               END IF
            END IF
*
*           Step 2: Compute ALPHAR, ALPHAI, and BETA (see refs.)
*
*           Recompute shift
*
            CALL DLAG2( A( ILAST-1, ILAST-1 ), LDA,
     $                  B( ILAST-1, ILAST-1 ), LDB, SAFMIN*SAFETY, S1,
     $                  TEMP, WR, TEMP2, WI )
*
*           If standardization has perturbed the shift onto real line,
*           do another (real single-shift) QR step.
*
            IF( WI.EQ.ZERO )
     $         GO TO 350
            S1INV = ONE / S1
*
*           Do EISPACK (QZVAL) computation of alpha and beta
*
            A11 = A( ILAST-1, ILAST-1 )
            A21 = A( ILAST, ILAST-1 )
            A12 = A( ILAST-1, ILAST )
            A22 = A( ILAST, ILAST )
*
*           Compute complex Givens rotation on right
*           (Assume some element of C = (sA - wB) > unfl )
*                            __
*           (sA - wB) ( CZ   -SZ )
*                     ( SZ    CZ )
*
            C11R = S1*A11 - WR*B11
            C11I = -WI*B11
            C12 = S1*A12
            C21 = S1*A21
            C22R = S1*A22 - WR*B22
            C22I = -WI*B22
*
            IF( ABS( C11R )+ABS( C11I )+ABS( C12 ).GT.ABS( C21 )+
     $          ABS( C22R )+ABS( C22I ) ) THEN
               T = DLAPY3( C12, C11R, C11I )
               CZ = C12 / T
               SZR = -C11R / T
               SZI = -C11I / T
            ELSE
               CZ = DLAPY2( C22R, C22I )
               IF( CZ.LE.SAFMIN ) THEN
                  CZ = ZERO
                  SZR = ONE
                  SZI = ZERO
               ELSE
                  TEMPR = C22R / CZ
                  TEMPI = C22I / CZ
                  T = DLAPY2( CZ, C21 )
                  CZ = CZ / T
                  SZR = -C21*TEMPR / T
                  SZI = C21*TEMPI / T
               END IF
            END IF
*
*           Compute Givens rotation on left
*
*           (  CQ   SQ )
*           (  __      )  A or B
*           ( -SQ   CQ )
*
            AN = ABS( A11 ) + ABS( A12 ) + ABS( A21 ) + ABS( A22 )
            BN = ABS( B11 ) + ABS( B22 )
            WABS = ABS( WR ) + ABS( WI )
            IF( S1*AN.GT.WABS*BN ) THEN
               CQ = CZ*B11
               SQR = SZR*B22
               SQI = -SZI*B22
            ELSE
               A1R = CZ*A11 + SZR*A12
               A1I = SZI*A12
               A2R = CZ*A21 + SZR*A22
               A2I = SZI*A22
               CQ = DLAPY2( A1R, A1I )
               IF( CQ.LE.SAFMIN ) THEN
                  CQ = ZERO
                  SQR = ONE
                  SQI = ZERO
               ELSE
                  TEMPR = A1R / CQ
                  TEMPI = A1I / CQ
                  SQR = TEMPR*A2R + TEMPI*A2I
                  SQI = TEMPI*A2R - TEMPR*A2I
               END IF
            END IF
            T = DLAPY3( CQ, SQR, SQI )
            CQ = CQ / T
            SQR = SQR / T
            SQI = SQI / T
*
*           Compute diagonal elements of QBZ
*
            TEMPR = SQR*SZR - SQI*SZI
            TEMPI = SQR*SZI + SQI*SZR
            B1R = CQ*CZ*B11 + TEMPR*B22
            B1I = TEMPI*B22
            B1A = DLAPY2( B1R, B1I )
            B2R = CQ*CZ*B22 + TEMPR*B11
            B2I = -TEMPI*B11
            B2A = DLAPY2( B2R, B2I )
*
*           Normalize so beta > 0, and Im( alpha1 ) > 0
*
            BETA( ILAST-1 ) = B1A
            BETA( ILAST ) = B2A
            ALPHAR( ILAST-1 ) = ( WR*B1A )*S1INV
            ALPHAI( ILAST-1 ) = ( WI*B1A )*S1INV
            ALPHAR( ILAST ) = ( WR*B2A )*S1INV
            ALPHAI( ILAST ) = -( WI*B2A )*S1INV
*
*           Step 3: Go to next block -- exit if finished.
*
            ILAST = IFIRST - 1
            IF( ILAST.LT.ILO )
     $         GO TO 380
*
*           Reset counters
*
            IITER = 0
            ESHIFT = ZERO
            IF( .NOT.ILSCHR ) THEN
               ILASTM = ILAST
               IF( IFRSTM.GT.ILAST )
     $            IFRSTM = ILO
            END IF
            GO TO 350
         ELSE
*
*           Usual case: 3x3 or larger block, using Francis implicit
*                       double-shift
*
*                                    2
*           Eigenvalue equation is  w  - c w + d = 0,
*
*                                         -1 2        -1
*           so compute 1st column of  (A B  )  - c A B   + d
*           using the formula in QZIT (from EISPACK)
*
*           We assume that the block is at least 3x3
*
            AD11 = ( ASCALE*A( ILAST-1, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD21 = ( ASCALE*A( ILAST, ILAST-1 ) ) /
     $             ( BSCALE*B( ILAST-1, ILAST-1 ) )
            AD12 = ( ASCALE*A( ILAST-1, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            AD22 = ( ASCALE*A( ILAST, ILAST ) ) /
     $             ( BSCALE*B( ILAST, ILAST ) )
            U12 = B( ILAST-1, ILAST ) / B( ILAST, ILAST )
            AD11L = ( ASCALE*A( IFIRST, IFIRST ) ) /
     $              ( BSCALE*B( IFIRST, IFIRST ) )
            AD21L = ( ASCALE*A( IFIRST+1, IFIRST ) ) /
     $              ( BSCALE*B( IFIRST, IFIRST ) )
            AD12L = ( ASCALE*A( IFIRST, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            AD22L = ( ASCALE*A( IFIRST+1, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            AD32L = ( ASCALE*A( IFIRST+2, IFIRST+1 ) ) /
     $              ( BSCALE*B( IFIRST+1, IFIRST+1 ) )
            U12L = B( IFIRST, IFIRST+1 ) / B( IFIRST+1, IFIRST+1 )
*
            V( 1 ) = ( AD11-AD11L )*( AD22-AD11L ) - AD12*AD21 +
     $               AD21*U12*AD11L + ( AD12L-AD11L*U12L )*AD21L
            V( 2 ) = ( ( AD22L-AD11L )-AD21L*U12L-( AD11-AD11L )-
     $               ( AD22-AD11L )+AD21*U12 )*AD21L
            V( 3 ) = AD32L*AD21L
*
            ISTART = IFIRST
*
            CALL DLARFG( 3, V( 1 ), V( 2 ), 1, TAU )
            V( 1 ) = ONE
*
*           Sweep
*
            DO 290 J = ISTART, ILAST - 2
*
*              All but last elements: use 3x3 Householder transforms.
*
*              Zero (j-1)st column of A
*
               IF( J.GT.ISTART ) THEN
                  V( 1 ) = A( J, J-1 )
                  V( 2 ) = A( J+1, J-1 )
                  V( 3 ) = A( J+2, J-1 )
*
                  CALL DLARFG( 3, A( J, J-1 ), V( 2 ), 1, TAU )
                  V( 1 ) = ONE
                  A( J+1, J-1 ) = ZERO
                  A( J+2, J-1 ) = ZERO
               END IF
*
               DO 230 JC = J, ILASTM
                  TEMP = TAU*( A( J, JC )+V( 2 )*A( J+1, JC )+V( 3 )*
     $                   A( J+2, JC ) )
                  A( J, JC ) = A( J, JC ) - TEMP
                  A( J+1, JC ) = A( J+1, JC ) - TEMP*V( 2 )
                  A( J+2, JC ) = A( J+2, JC ) - TEMP*V( 3 )
                  TEMP2 = TAU*( B( J, JC )+V( 2 )*B( J+1, JC )+V( 3 )*
     $                    B( J+2, JC ) )
                  B( J, JC ) = B( J, JC ) - TEMP2
                  B( J+1, JC ) = B( J+1, JC ) - TEMP2*V( 2 )
                  B( J+2, JC ) = B( J+2, JC ) - TEMP2*V( 3 )
  230          CONTINUE
               IF( ILQ ) THEN
                  DO 240 JR = 1, N
                     TEMP = TAU*( Q( JR, J )+V( 2 )*Q( JR, J+1 )+V( 3 )*
     $                      Q( JR, J+2 ) )
                     Q( JR, J ) = Q( JR, J ) - TEMP
                     Q( JR, J+1 ) = Q( JR, J+1 ) - TEMP*V( 2 )
                     Q( JR, J+2 ) = Q( JR, J+2 ) - TEMP*V( 3 )
  240             CONTINUE
               END IF
*
*              Zero j-th column of B (see DLAGBC for details)
*
*              Swap rows to pivot
*
               ILPIVT = .FALSE.
               TEMP = MAX( ABS( B( J+1, J+1 ) ), ABS( B( J+1, J+2 ) ) )
               TEMP2 = MAX( ABS( B( J+2, J+1 ) ), ABS( B( J+2, J+2 ) ) )
               IF( MAX( TEMP, TEMP2 ).LT.SAFMIN ) THEN
                  SCALE = ZERO
                  U1 = ONE
                  U2 = ZERO
                  GO TO 250
               ELSE IF( TEMP.GE.TEMP2 ) THEN
                  W11 = B( J+1, J+1 )
                  W21 = B( J+2, J+1 )
                  W12 = B( J+1, J+2 )
                  W22 = B( J+2, J+2 )
                  U1 = B( J+1, J )
                  U2 = B( J+2, J )
               ELSE
                  W21 = B( J+1, J+1 )
                  W11 = B( J+2, J+1 )
                  W22 = B( J+1, J+2 )
                  W12 = B( J+2, J+2 )
                  U2 = B( J+1, J )
                  U1 = B( J+2, J )
               END IF
*
*              Swap columns if nec.
*
               IF( ABS( W12 ).GT.ABS( W11 ) ) THEN
                  ILPIVT = .TRUE.
                  TEMP = W12
                  TEMP2 = W22
                  W12 = W11
                  W22 = W21
                  W11 = TEMP
                  W21 = TEMP2
               END IF
*
*              LU-factor
*
               TEMP = W21 / W11
               U2 = U2 - TEMP*U1
               W22 = W22 - TEMP*W12
               W21 = ZERO
*
*              Compute SCALE
*
               SCALE = ONE
               IF( ABS( W22 ).LT.SAFMIN ) THEN
                  SCALE = ZERO
                  U2 = ONE
                  U1 = -W12 / W11
                  GO TO 250
               END IF
               IF( ABS( W22 ).LT.ABS( U2 ) )
     $            SCALE = ABS( W22 / U2 )
               IF( ABS( W11 ).LT.ABS( U1 ) )
     $            SCALE = MIN( SCALE, ABS( W11 / U1 ) )
*
*              Solve
*
               U2 = ( SCALE*U2 ) / W22
               U1 = ( SCALE*U1-W12*U2 ) / W11
*
  250          CONTINUE
               IF( ILPIVT ) THEN
                  TEMP = U2
                  U2 = U1
                  U1 = TEMP
               END IF
*
*              Compute Householder Vector
*
               T = SQRT( SCALE**2+U1**2+U2**2 )
               TAU = ONE + SCALE / T
               VS = -ONE / ( SCALE+T )
               V( 1 ) = ONE
               V( 2 ) = VS*U1
               V( 3 ) = VS*U2
*
*              Apply transformations from the right.
*
               DO 260 JR = IFRSTM, MIN( J+3, ILAST )
                  TEMP = TAU*( A( JR, J )+V( 2 )*A( JR, J+1 )+V( 3 )*
     $                   A( JR, J+2 ) )
                  A( JR, J ) = A( JR, J ) - TEMP
                  A( JR, J+1 ) = A( JR, J+1 ) - TEMP*V( 2 )
                  A( JR, J+2 ) = A( JR, J+2 ) - TEMP*V( 3 )
  260          CONTINUE
               DO 270 JR = IFRSTM, J + 2
                  TEMP = TAU*( B( JR, J )+V( 2 )*B( JR, J+1 )+V( 3 )*
     $                   B( JR, J+2 ) )
                  B( JR, J ) = B( JR, J ) - TEMP
                  B( JR, J+1 ) = B( JR, J+1 ) - TEMP*V( 2 )
                  B( JR, J+2 ) = B( JR, J+2 ) - TEMP*V( 3 )
  270          CONTINUE
               IF( ILZ ) THEN
                  DO 280 JR = 1, N
                     TEMP = TAU*( Z( JR, J )+V( 2 )*Z( JR, J+1 )+V( 3 )*
     $                      Z( JR, J+2 ) )
                     Z( JR, J ) = Z( JR, J ) - TEMP
                     Z( JR, J+1 ) = Z( JR, J+1 ) - TEMP*V( 2 )
                     Z( JR, J+2 ) = Z( JR, J+2 ) - TEMP*V( 3 )
  280             CONTINUE
               END IF
               B( J+1, J ) = ZERO
               B( J+2, J ) = ZERO
  290       CONTINUE
*
*           Last elements: Use Givens rotations
*
*           Rotations from the left
*
            J = ILAST - 1
            TEMP = A( J, J-1 )
            CALL DLARTG( TEMP, A( J+1, J-1 ), C, S, A( J, J-1 ) )
            A( J+1, J-1 ) = ZERO
*
            DO 300 JC = J, ILASTM
               TEMP = C*A( J, JC ) + S*A( J+1, JC )
               A( J+1, JC ) = -S*A( J, JC ) + C*A( J+1, JC )
               A( J, JC ) = TEMP
               TEMP2 = C*B( J, JC ) + S*B( J+1, JC )
               B( J+1, JC ) = -S*B( J, JC ) + C*B( J+1, JC )
               B( J, JC ) = TEMP2
  300       CONTINUE
            IF( ILQ ) THEN
               DO 310 JR = 1, N
                  TEMP = C*Q( JR, J ) + S*Q( JR, J+1 )
                  Q( JR, J+1 ) = -S*Q( JR, J ) + C*Q( JR, J+1 )
                  Q( JR, J ) = TEMP
  310          CONTINUE
            END IF
*
*           Rotations from the right.
*
            TEMP = B( J+1, J+1 )
            CALL DLARTG( TEMP, B( J+1, J ), C, S, B( J+1, J+1 ) )
            B( J+1, J ) = ZERO
*
            DO 320 JR = IFRSTM, ILAST
               TEMP = C*A( JR, J+1 ) + S*A( JR, J )
               A( JR, J ) = -S*A( JR, J+1 ) + C*A( JR, J )
               A( JR, J+1 ) = TEMP
  320       CONTINUE
            DO 330 JR = IFRSTM, ILAST - 1
               TEMP = C*B( JR, J+1 ) + S*B( JR, J )
               B( JR, J ) = -S*B( JR, J+1 ) + C*B( JR, J )
               B( JR, J+1 ) = TEMP
  330       CONTINUE
            IF( ILZ ) THEN
               DO 340 JR = 1, N
                  TEMP = C*Z( JR, J+1 ) + S*Z( JR, J )
                  Z( JR, J ) = -S*Z( JR, J+1 ) + C*Z( JR, J )
                  Z( JR, J+1 ) = TEMP
  340          CONTINUE
            END IF
*
*           End of Double-Shift code
*
         END IF
*
         GO TO 350
*
*        End of iteration loop
*
  350    CONTINUE
  360 CONTINUE
*
*     Drop-through = non-convergence
*
  370 CONTINUE
      INFO = ILAST
      GO TO 420
*
*     Successful completion of all QZ steps
*
  380 CONTINUE
*
*     Set Eigenvalues 1:ILO-1
*
      DO 410 J = 1, ILO - 1
         IF( B( J, J ).LT.ZERO ) THEN
            IF( ILSCHR ) THEN
               DO 390 JR = 1, J
                  A( JR, J ) = -A( JR, J )
                  B( JR, J ) = -B( JR, J )
  390          CONTINUE
            ELSE
               A( J, J ) = -A( J, J )
               B( J, J ) = -B( J, J )
            END IF
            IF( ILZ ) THEN
               DO 400 JR = 1, N
                  Z( JR, J ) = -Z( JR, J )
  400          CONTINUE
            END IF
         END IF
         ALPHAR( J ) = A( J, J )
         ALPHAI( J ) = ZERO
         BETA( J ) = B( J, J )
  410 CONTINUE
*
*     Normal Termination
*
      INFO = 0
*
*     Exit (other than argument error) -- return optimal workspace size
*
  420 CONTINUE
      WORK( 1 ) = DBLE( N )
      RETURN
*
*     End of DHGEQZ
*
      END
* DECK dhsein.f
      SUBROUTINE DHSEIN( SIDE, EIGSRC, INITV, SELECT, N, H, LDH, WR, WI,
     $                   VL, LDVL, VR, LDVR, MM, M, WORK, IFAILL,
     $                   IFAILR, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          EIGSRC, INITV, SIDE
      INTEGER            INFO, LDH, LDVL, LDVR, M, MM, N
*     ..
*     .. Array Arguments ..
      LOGICAL            SELECT( * )
      INTEGER            IFAILL( * ), IFAILR( * )
      DOUBLE PRECISION   H( LDH, * ), VL( LDVL, * ), VR( LDVR, * ),
     $                   WI( * ), WORK( * ), WR( * )
*     ..
*
*  Purpose
*  =======
*
*  DHSEIN uses inverse iteration to find specified right and/or left
*  eigenvectors of a real upper Hessenberg matrix H.
*
*  The right eigenvector x and the left eigenvector y of the matrix H
*  corresponding to an eigenvalue w are defined by:
*
*               H * x = w * x,     y**h * H = w * y**h
*
*  where y**h denotes the conjugate transpose of the vector y.
*
*  Arguments
*  =========
*
*  SIDE    (input) CHARACTER*1
*          = 'R': compute right eigenvectors only;
*          = 'L': compute left eigenvectors only;
*          = 'B': compute both right and left eigenvectors.
*
*  EIGSRC  (input) CHARACTER*1
*          Specifies the source of eigenvalues supplied in (WR,WI):
*          = 'Q': the eigenvalues were found using DHSEQR; thus, if
*                 H has zero subdiagonal elements, and so is
*                 block-triangular, then the j-th eigenvalue can be
*                 assumed to be an eigenvalue of the block containing
*                 the j-th row/column.  This property allows DHSEIN to
*                 perform inverse iteration on just one diagonal block.
*          = 'N': no assumptions are made on the correspondence
*                 between eigenvalues and diagonal blocks.  In this
*                 case, DHSEIN must always perform inverse iteration
*                 using the whole matrix H.
*
*  INITV   (input) CHARACTER*1
*          = 'N': no initial vectors are supplied;
*          = 'U': user-supplied initial vectors are stored in the arrays
*                 VL and/or VR.
*
*  SELECT  (input/output) LOGICAL array, dimension (N)
*          Specifies the eigenvectors to be computed. To select the
*          real eigenvector corresponding to a real eigenvalue WR(j),
*          SELECT(j) must be set to .TRUE.. To select the complex
*          eigenvector corresponding to a complex eigenvalue
*          (WR(j),WI(j)), with complex conjugate (WR(j+1),WI(j+1)),
*          either SELECT(j) or SELECT(j+1) or both must be set to
*          .TRUE.; then on exit SELECT(j) is .TRUE. and SELECT(j+1) is
*          .FALSE..
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  H       (input) DOUBLE PRECISION array, dimension (LDH,N)
*          The upper Hessenberg matrix H.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H.  LDH >= max(1,N).
*
*  WR      (input/output) DOUBLE PRECISION array, dimension (N)
*  WI      (input) DOUBLE PRECISION array, dimension (N)
*          On entry, the real and imaginary parts of the eigenvalues of
*          H; a complex conjugate pair of eigenvalues must be stored in
*          consecutive elements of WR and WI.
*          On exit, WR may have been altered since close eigenvalues
*          are perturbed slightly in searching for independent
*          eigenvectors.
*
*  VL      (input/output) DOUBLE PRECISION array, dimension (LDVL,MM)
*          On entry, if INITV = 'U' and SIDE = 'L' or 'B', VL must
*          contain starting vectors for the inverse iteration for the
*          left eigenvectors; the starting vector for each eigenvector
*          must be in the same column(s) in which the eigenvector will
*          be stored.
*          On exit, if SIDE = 'L' or 'B', the left eigenvectors
*          specified by SELECT will be stored consecutively in the
*          columns of VL, in the same order as their eigenvalues. A
*          complex eigenvector corresponding to a complex eigenvalue is
*          stored in two consecutive columns, the first holding the real
*          part and the second the imaginary part.
*          If SIDE = 'R', VL is not referenced.
*
*  LDVL    (input) INTEGER
*          The leading dimension of the array VL.
*          LDVL >= max(1,N) if SIDE = 'L' or 'B'; LDVL >= 1 otherwise.
*
*  VR      (input/output) DOUBLE PRECISION array, dimension (LDVR,MM)
*          On entry, if INITV = 'U' and SIDE = 'R' or 'B', VR must
*          contain starting vectors for the inverse iteration for the
*          right eigenvectors; the starting vector for each eigenvector
*          must be in the same column(s) in which the eigenvector will
*          be stored.
*          On exit, if SIDE = 'R' or 'B', the right eigenvectors
*          specified by SELECT will be stored consecutively in the
*          columns of VR, in the same order as their eigenvalues. A
*          complex eigenvector corresponding to a complex eigenvalue is
*          stored in two consecutive columns, the first holding the real
*          part and the second the imaginary part.
*          If SIDE = 'L', VR is not referenced.
*
*  LDVR    (input) INTEGER
*          The leading dimension of the array VR.
*          LDVR >= max(1,N) if SIDE = 'R' or 'B'; LDVR >= 1 otherwise.
*
*  MM      (input) INTEGER
*          The number of columns in the arrays VL and/or VR. MM >= M.
*
*  M       (output) INTEGER
*          The number of columns in the arrays VL and/or VR required to
*          store the eigenvectors; each selected real eigenvector
*          occupies one column and each selected complex eigenvector
*          occupies two columns.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension ((N+2)*N)
*
*  IFAILL  (output) INTEGER array, dimension (MM)
*          If SIDE = 'L' or 'B', IFAILL(i) = j > 0 if the left
*          eigenvector in the i-th column of VL (corresponding to the
*          eigenvalue w(j)) failed to converge; IFAILL(i) = 0 if the
*          eigenvector converged satisfactorily. If the i-th and (i+1)th
*          columns of VL hold a complex eigenvector, then IFAILL(i) and
*          IFAILL(i+1) are set to the same value.
*          If SIDE = 'R', IFAILL is not referenced.
*
*  IFAILR  (output) INTEGER array, dimension (MM)
*          If SIDE = 'R' or 'B', IFAILR(i) = j > 0 if the right
*          eigenvector in the i-th column of VR (corresponding to the
*          eigenvalue w(j)) failed to converge; IFAILR(i) = 0 if the
*          eigenvector converged satisfactorily. If the i-th and (i+1)th
*          columns of VR hold a complex eigenvector, then IFAILR(i) and
*          IFAILR(i+1) are set to the same value.
*          If SIDE = 'L', IFAILR is not referenced.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, i is the number of eigenvectors which
*                failed to converge; see IFAILL and IFAILR for further
*                details.
*
*  Further Details
*  ===============
*
*  Each eigenvector is normalized so that the element of largest
*  magnitude has magnitude 1; here the magnitude of a complex number
*  (x,y) is taken to be |x|+|y|.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            BOTHV, FROMQR, LEFTV, NOINIT, PAIR, RIGHTV
      INTEGER            I, IINFO, K, KL, KLN, KR, KSI, KSR, LDWORK
      DOUBLE PRECISION   BIGNUM, EPS3, HNORM, SMLNUM, ULP, UNFL, WKI,
     $                   WKR
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DLAMCH, DLANHS
      EXTERNAL           LSAME, DLAMCH, DLANHS
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLAEIN, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters.
*
      BOTHV = LSAME( SIDE, 'B' )
      RIGHTV = LSAME( SIDE, 'R' ) .OR. BOTHV
      LEFTV = LSAME( SIDE, 'L' ) .OR. BOTHV
*
      FROMQR = LSAME( EIGSRC, 'Q' )
*
      NOINIT = LSAME( INITV, 'N' )
*
*     Set M to the number of columns required to store the selected
*     eigenvectors, and standardize the array SELECT.
*
      M = 0
      PAIR = .FALSE.
      DO 10 K = 1, N
         IF( PAIR ) THEN
            PAIR = .FALSE.
            SELECT( K ) = .FALSE.
         ELSE
            IF( WI( K ).EQ.ZERO ) THEN
               IF( SELECT( K ) )
     $            M = M + 1
            ELSE
               PAIR = .TRUE.
               IF( SELECT( K ) .OR. SELECT( K+1 ) ) THEN
                  SELECT( K ) = .TRUE.
                  M = M + 2
               END IF
            END IF
         END IF
   10 CONTINUE
*
      INFO = 0
      IF( .NOT.RIGHTV .AND. .NOT.LEFTV ) THEN
         INFO = -1
      ELSE IF( .NOT.FROMQR .AND. .NOT.LSAME( EIGSRC, 'N' ) ) THEN
         INFO = -2
      ELSE IF( .NOT.NOINIT .AND. .NOT.LSAME( INITV, 'U' ) ) THEN
         INFO = -3
      ELSE IF( N.LT.0 ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDVL.LT.1 .OR. ( LEFTV .AND. LDVL.LT.N ) ) THEN
         INFO = -11
      ELSE IF( LDVR.LT.1 .OR. ( RIGHTV .AND. LDVR.LT.N ) ) THEN
         INFO = -13
      ELSE IF( MM.LT.M ) THEN
         INFO = -14
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DHSEIN', -INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Set machine-dependent constants.
*
      UNFL = DLAMCH( 'Safe minimum' )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( N / ULP )
      BIGNUM = ( ONE-ULP ) / SMLNUM
*
      LDWORK = N + 1
*
      KL = 1
      KLN = 0
      IF( FROMQR ) THEN
         KR = 0
      ELSE
         KR = N
      END IF
      KSR = 1
*
      DO 120 K = 1, N
         IF( SELECT( K ) ) THEN
*
*           Compute eigenvector(s) corresponding to W(K).
*
            IF( FROMQR ) THEN
*
*              If affiliation of eigenvalues is known, check whether
*              the matrix splits.
*
*              Determine KL and KR such that 1 <= KL <= K <= KR <= N
*              and H(KL,KL-1) and H(KR+1,KR) are zero (or KL = 1 or
*              KR = N).
*
*              Then inverse iteration can be performed with the
*              submatrix H(KL:N,KL:N) for a left eigenvector, and with
*              the submatrix H(1:KR,1:KR) for a right eigenvector.
*
               DO 20 I = K, KL + 1, -1
                  IF( H( I, I-1 ).EQ.ZERO )
     $               GO TO 30
   20          CONTINUE
   30          CONTINUE
               KL = I
               IF( K.GT.KR ) THEN
                  DO 40 I = K, N - 1
                     IF( H( I+1, I ).EQ.ZERO )
     $                  GO TO 50
   40             CONTINUE
   50             CONTINUE
                  KR = I
               END IF
            END IF
*
            IF( KL.NE.KLN ) THEN
               KLN = KL
*
*              Compute infinity-norm of submatrix H(KL:KR,KL:KR) if it
*              has not ben computed before.
*
               HNORM = DLANHS( 'I', KR-KL+1, H( KL, KL ), LDH, WORK )
               IF( HNORM.GT.ZERO ) THEN
                  EPS3 = HNORM*ULP
               ELSE
                  EPS3 = SMLNUM
               END IF
            END IF
*
*           Perturb eigenvalue if it is close to any previous
*           selected eigenvalues affiliated to the submatrix
*           H(KL:KR,KL:KR). Close roots are modified by EPS3.
*
            WKR = WR( K )
            WKI = WI( K )
   60       CONTINUE
            DO 70 I = K - 1, KL, -1
               IF( SELECT( I ) .AND. ABS( WR( I )-WKR )+
     $             ABS( WI( I )-WKI ).LT.EPS3 ) THEN
                  WKR = WKR + EPS3
                  GO TO 60
               END IF
   70       CONTINUE
            WR( K ) = WKR
*
            PAIR = WKI.NE.ZERO
            IF( PAIR ) THEN
               KSI = KSR + 1
            ELSE
               KSI = KSR
            END IF
            IF( LEFTV ) THEN
*
*              Compute left eigenvector.
*
               CALL DLAEIN( .FALSE., NOINIT, N-KL+1, H( KL, KL ), LDH,
     $                      WKR, WKI, VL( KL, KSR ), VL( KL, KSI ),
     $                      WORK, LDWORK, WORK( N*N+N+1 ), EPS3, SMLNUM,
     $                      BIGNUM, IINFO )
               IF( IINFO.GT.0 ) THEN
                  IF( PAIR ) THEN
                     INFO = INFO + 2
                  ELSE
                     INFO = INFO + 1
                  END IF
                  IFAILL( KSR ) = K
                  IFAILL( KSI ) = K
               ELSE
                  IFAILL( KSR ) = 0
                  IFAILL( KSI ) = 0
               END IF
               DO 80 I = 1, KL - 1
                  VL( I, KSR ) = ZERO
   80          CONTINUE
               IF( PAIR ) THEN
                  DO 90 I = 1, KL - 1
                     VL( I, KSI ) = ZERO
   90             CONTINUE
               END IF
            END IF
            IF( RIGHTV ) THEN
*
*              Compute right eigenvector.
*
               CALL DLAEIN( .TRUE., NOINIT, KR, H, LDH, WKR, WKI,
     $                      VR( 1, KSR ), VR( 1, KSI ), WORK, LDWORK,
     $                      WORK( N*N+N+1 ), EPS3, SMLNUM, BIGNUM,
     $                      IINFO )
               IF( IINFO.GT.0 ) THEN
                  IF( PAIR ) THEN
                     INFO = INFO + 2
                  ELSE
                     INFO = INFO + 1
                  END IF
                  IFAILR( KSR ) = K
                  IFAILR( KSI ) = K
               ELSE
                  IFAILR( KSR ) = 0
                  IFAILR( KSI ) = 0
               END IF
               DO 100 I = KR + 1, N
                  VR( I, KSR ) = ZERO
  100          CONTINUE
               IF( PAIR ) THEN
                  DO 110 I = KR + 1, N
                     VR( I, KSI ) = ZERO
  110             CONTINUE
               END IF
            END IF
*
            IF( PAIR ) THEN
               KSR = KSR + 2
            ELSE
               KSR = KSR + 1
            END IF
         END IF
  120 CONTINUE
*
      RETURN
*
*     End of DHSEIN
*
      END
* DECK dhseqr.f
      SUBROUTINE DHSEQR( JOB, COMPZ, N, ILO, IHI, H, LDH, WR, WI, Z,
     $                   LDZ, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ, JOB
      INTEGER            IHI, ILO, INFO, LDH, LDZ, LWORK, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   H( LDH, * ), WI( * ), WORK( * ), WR( * ),
     $                   Z( LDZ, * )
*     ..
*
*  Purpose
*  =======
*
*  DHSEQR computes the eigenvalues of a real upper Hessenberg matrix H
*  and, optionally, the matrices T and Z from the Schur decomposition
*  H = Z T Z**T, where T is an upper quasi-triangular matrix (the Schur
*  form), and Z is the orthogonal matrix of Schur vectors.
*
*  Optionally Z may be postmultiplied into an input orthogonal matrix Q,
*  so that this routine can give the Schur factorization of a matrix A
*  which has been reduced to the Hessenberg form H by the orthogonal
*  matrix Q:  A = Q*H*Q**T = (QZ)*T*(QZ)**T.
*
*  Arguments
*  =========
*
*  JOB     (input) CHARACTER*1
*          = 'E':  compute eigenvalues only;
*          = 'S':  compute eigenvalues and the Schur form T.
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  no Schur vectors are computed;
*          = 'I':  Z is initialized to the unit matrix and the matrix Z
*                  of Schur vectors of H is returned;
*          = 'V':  Z must contain an orthogonal matrix Q on entry, and
*                  the product Q*Z is returned.
*
*  N       (input) INTEGER
*          The order of the matrix H.  N >= 0.
*
*  ILO     (input) INTEGER
*  IHI     (input) INTEGER
*          It is assumed that H is already upper triangular in rows
*          and columns 1:ILO-1 and IHI+1:N. ILO and IHI are normally
*          set by a previous call to DGEBAL, and then passed to SGEHRD
*          when the matrix output by DGEBAL is reduced to Hessenberg
*          form. Otherwise ILO and IHI should be set to 1 and N
*          respectively.
*          1 <= ILO <= IHI <= N, if N > 0; ILO=1 and IHI=0, if N=0.
*
*  H       (input/output) DOUBLE PRECISION array, dimension (LDH,N)
*          On entry, the upper Hessenberg matrix H.
*          On exit, if JOB = 'S', H contains the upper quasi-triangular
*          matrix T from the Schur decomposition (the Schur form);
*          2-by-2 diagonal blocks (corresponding to complex conjugate
*          pairs of eigenvalues) are returned in standard form, with
*          H(i,i) = H(i+1,i+1) and H(i+1,i)*H(i,i+1) < 0. If JOB = 'E',
*          the contents of H are unspecified on exit.
*
*  LDH     (input) INTEGER
*          The leading dimension of the array H. LDH >= max(1,N).
*
*  WR      (output) DOUBLE PRECISION array, dimension (N)
*  WI      (output) DOUBLE PRECISION array, dimension (N)
*          The real and imaginary parts, respectively, of the computed
*          eigenvalues. If two eigenvalues are computed as a complex
*          conjugate pair, they are stored in consecutive elements of
*          WR and WI, say the i-th and (i+1)th, with WI(i) > 0 and
*          WI(i+1) < 0. If JOB = 'S', the eigenvalues are stored in the
*          same order as on the diagonal of the Schur form returned in
*          H, with WR(i) = H(i,i) and, if H(i:i+1,i:i+1) is a 2-by-2
*          diagonal block, WI(i) = sqrt(H(i+1,i)*H(i,i+1)) and
*          WI(i+1) = -WI(i).
*
*  Z       (input/output) DOUBLE PRECISION array, dimension (LDZ,N)
*          If COMPZ = 'N': Z is not referenced.
*          If COMPZ = 'I': on entry, Z need not be set, and on exit, Z
*          contains the orthogonal matrix Z of the Schur vectors of H.
*          If COMPZ = 'V': on entry Z must contain an N-by-N matrix Q,
*          which is assumed to be equal to the unit matrix except for
*          the submatrix Z(ILO:IHI,ILO:IHI); on exit Z contains Q*Z.
*          Normally Q is the orthogonal matrix generated by DORGHR after
*          the call to DGEHRD which formed the Hessenberg matrix H.
*
*  LDZ     (input) INTEGER
*          The leading dimension of the array Z.
*          LDZ >= max(1,N) if COMPZ = 'I' or 'V'; LDZ >= 1 otherwise.
*
*  WORK    (workspace) DOUBLE PRECISION array, dimension (N)
*
*  LWORK   (input) INTEGER
*          This argument is currently redundant.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, DHSEQR failed to compute all of the
*                eigenvalues in a total of 30*(IHI-ILO+1) iterations;
*                elements 1:ilo-1 and i+1:n of WR and WI contain those
*                eigenvalues which have been successfully computed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO, ONE, TWO
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0, TWO = 2.0D+0 )
      DOUBLE PRECISION   CONST
      PARAMETER          ( CONST = 1.5D+0 )
      INTEGER            NSMAX, LDS
      PARAMETER          ( NSMAX = 15, LDS = NSMAX )
*     ..
*     .. Local Scalars ..
      LOGICAL            INITZ, WANTT, WANTZ
      INTEGER            I, I1, I2, IERR, II, ITEMP, ITN, ITS, J, K, L,
     $                   MAXB, NH, NR, NS, NV
      DOUBLE PRECISION   ABSW, OVFL, SMLNUM, TAU, TEMP, TST1, ULP, UNFL
*     ..
*     .. Local Arrays ..
      DOUBLE PRECISION   S( LDS, NSMAX ), V( NSMAX+1 ), VV( NSMAX+1 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            IDAMAX, ILAENV
      DOUBLE PRECISION   DLAMCH, DLANHS, DLAPY2
      EXTERNAL           LSAME, IDAMAX, ILAENV, DLAMCH, DLANHS, DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           DCOPY, DGEMV, DLABAD, DLACPY, DLAHQR, DLARFG,
     $                   DLARFX, DLASET, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Decode and test the input parameters
*
      WANTT = LSAME( JOB, 'S' )
      INITZ = LSAME( COMPZ, 'I' )
      WANTZ = INITZ .OR. LSAME( COMPZ, 'V' )
*
      INFO = 0
      IF( .NOT.LSAME( JOB, 'E' ) .AND. .NOT.WANTT ) THEN
         INFO = -1
      ELSE IF( .NOT.LSAME( COMPZ, 'N' ) .AND. .NOT.WANTZ ) THEN
         INFO = -2
      ELSE IF( N.LT.0 ) THEN
         INFO = -3
      ELSE IF( ILO.LT.1 .OR. ILO.GT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( IHI.LT.MIN( ILO, N ) .OR. IHI.GT.N ) THEN
         INFO = -5
      ELSE IF( LDH.LT.MAX( 1, N ) ) THEN
         INFO = -7
      ELSE IF( LDZ.LT.1 .OR. WANTZ .AND. LDZ.LT.MAX( 1, N ) ) THEN
         INFO = -11
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DHSEQR', -INFO )
         RETURN
      END IF
*
*     Initialize Z, if necessary
*
      IF( INITZ )
     $   CALL DLASET( 'Full', N, N, ZERO, ONE, Z, LDZ )
*
*     Store the eigenvalues isolated by DGEBAL.
*
      DO 10 I = 1, ILO - 1
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   10 CONTINUE
      DO 20 I = IHI + 1, N
         WR( I ) = H( I, I )
         WI( I ) = ZERO
   20 CONTINUE
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
      IF( ILO.EQ.IHI ) THEN
         WR( ILO ) = H( ILO, ILO )
         WI( ILO ) = ZERO
         RETURN
      END IF
*
*     Set rows and columns ILO to IHI to zero below the first
*     subdiagonal.
*
      DO 40 J = ILO, IHI - 2
         DO 30 I = J + 2, N
            H( I, J ) = ZERO
   30    CONTINUE
   40 CONTINUE
      NH = IHI - ILO + 1
*
*     Determine the order of the multi-shift QR algorithm to be used.
*
      NS = ILAENV( 4, 'DHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      MAXB = ILAENV( 8, 'DHSEQR', JOB // COMPZ, N, ILO, IHI, -1 )
      IF( NS.LE.2 .OR. NS.GT.NH .OR. MAXB.GE.NH ) THEN
*
*        Use the standard double-shift algorithm
*
         CALL DLAHQR( WANTT, WANTZ, N, ILO, IHI, H, LDH, WR, WI, ILO,
     $                IHI, Z, LDZ, INFO )
         RETURN
      END IF
      MAXB = MAX( 3, MAXB )
      NS = MIN( NS, MAXB, NSMAX )
*
*     Now 2 < NS <= MAXB < NH.
*
*     Set machine-dependent constants for the stopping criterion.
*     If norm(H) <= sqrt(OVFL), overflow should not occur.
*
      UNFL = DLAMCH( 'Safe minimum' )
      OVFL = ONE / UNFL
      CALL DLABAD( UNFL, OVFL )
      ULP = DLAMCH( 'Precision' )
      SMLNUM = UNFL*( NH / ULP )
*
*     I1 and I2 are the indices of the first row and last column of H
*     to which transformations must be applied. If eigenvalues only are
*     being computed, I1 and I2 are set inside the main loop.
*
      IF( WANTT ) THEN
         I1 = 1
         I2 = N
      END IF
*
*     ITN is the total number of multiple-shift QR iterations allowed.
*
      ITN = 30*NH
*
*     The main loop begins here. I is the loop index and decreases from
*     IHI to ILO in steps of at most MAXB. Each iteration of the loop
*     works with the active submatrix in rows and columns L to I.
*     Eigenvalues I+1 to IHI have already converged. Either L = ILO or
*     H(L,L-1) is negligible so that the matrix splits.
*
      I = IHI
   50 CONTINUE
      L = ILO
      IF( I.LT.ILO )
     $   GO TO 170
*
*     Perform multiple-shift QR iterations on rows and columns ILO to I
*     until a submatrix of order at most MAXB splits off at the bottom
*     because a subdiagonal element has become negligible.
*
      DO 150 ITS = 0, ITN
*
*        Look for a single small subdiagonal element.
*
         DO 60 K = I, L + 1, -1
            TST1 = ABS( H( K-1, K-1 ) ) + ABS( H( K, K ) )
            IF( TST1.EQ.ZERO )
     $         TST1 = DLANHS( '1', I-L+1, H( L, L ), LDH, WORK )
            IF( ABS( H( K, K-1 ) ).LE.MAX( ULP*TST1, SMLNUM ) )
     $         GO TO 70
   60    CONTINUE
   70    CONTINUE
         L = K
         IF( L.GT.ILO ) THEN
*
*           H(L,L-1) is negligible.
*
            H( L, L-1 ) = ZERO
         END IF
*
*        Exit from loop if a submatrix of order <= MAXB has split off.
*
         IF( L.GE.I-MAXB+1 )
     $      GO TO 160
*
*        Now the active submatrix is in rows and columns L to I. If
*        eigenvalues only are being computed, only the active submatrix
*        need be transformed.
*
         IF( .NOT.WANTT ) THEN
            I1 = L
            I2 = I
         END IF
*
         IF( ITS.EQ.20 .OR. ITS.EQ.30 ) THEN
*
*           Exceptional shifts.
*
            DO 80 II = I - NS + 1, I
               WR( II ) = CONST*( ABS( H( II, II-1 ) )+
     $                    ABS( H( II, II ) ) )
               WI( II ) = ZERO
   80       CONTINUE
         ELSE
*
*           Use eigenvalues of trailing submatrix of order NS as shifts.
*
            CALL DLACPY( 'Full', NS, NS, H( I-NS+1, I-NS+1 ), LDH, S,
     $                   LDS )
            CALL DLAHQR( .FALSE., .FALSE., NS, 1, NS, S, LDS,
     $                   WR( I-NS+1 ), WI( I-NS+1 ), 1, NS, Z, LDZ,
     $                   IERR )
            IF( IERR.GT.0 ) THEN
*
*              If DLAHQR failed to compute all NS eigenvalues, use the
*              unconverged diagonal elements as the remaining shifts.
*
               DO 90 II = 1, IERR
                  WR( I-NS+II ) = S( II, II )
                  WI( I-NS+II ) = ZERO
   90          CONTINUE
            END IF
         END IF
*
*        Form the first column of (G-w(1)) (G-w(2)) . . . (G-w(ns))
*        where G is the Hessenberg submatrix H(L:I,L:I) and w is
*        the vector of shifts (stored in WR and WI). The result is
*        stored in the local array V.
*
         V( 1 ) = ONE
         DO 100 II = 2, NS + 1
            V( II ) = ZERO
  100    CONTINUE
         NV = 1
         DO 120 J = I - NS + 1, I
            IF( WI( J ).GE.ZERO ) THEN
               IF( WI( J ).EQ.ZERO ) THEN
*
*                 real shift
*
                  CALL DCOPY( NV+1, V, 1, VV, 1 )
                  CALL DGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, VV, 1, -WR( J ), V, 1 )
                  NV = NV + 1
               ELSE IF( WI( J ).GT.ZERO ) THEN
*
*                 complex conjugate pair of shifts
*
                  CALL DCOPY( NV+1, V, 1, VV, 1 )
                  CALL DGEMV( 'No transpose', NV+1, NV, ONE, H( L, L ),
     $                        LDH, V, 1, -TWO*WR( J ), VV, 1 )
                  ITEMP = IDAMAX( NV+1, VV, 1 )
                  TEMP = ONE / MAX( ABS( VV( ITEMP ) ), SMLNUM )
                  CALL DSCAL( NV+1, TEMP, VV, 1 )
                  ABSW = DLAPY2( WR( J ), WI( J ) )
                  TEMP = ( TEMP*ABSW )*ABSW
                  CALL DGEMV( 'No transpose', NV+2, NV+1, ONE,
     $                        H( L, L ), LDH, VV, 1, TEMP, V, 1 )
                  NV = NV + 2
               END IF
*
*              Scale V(1:NV) so that max(abs(V(i))) = 1. If V is zero,
*              reset it to the unit vector.
*
               ITEMP = IDAMAX( NV, V, 1 )
               TEMP = ABS( V( ITEMP ) )
               IF( TEMP.EQ.ZERO ) THEN
                  V( 1 ) = ONE
                  DO 110 II = 2, NV
                     V( II ) = ZERO
  110             CONTINUE
               ELSE
                  TEMP = MAX( TEMP, SMLNUM )
                  CALL DSCAL( NV, ONE / TEMP, V, 1 )
               END IF
            END IF
  120    CONTINUE
*
*        Multiple-shift QR step
*
         DO 140 K = L, I - 1
*
*           The first iteration of this loop determines a reflection G
*           from the vector V and applies it from left and right to H,
*           thus creating a nonzero bulge below the subdiagonal.
*
*           Each subsequent iteration determines a reflection G to
*           restore the Hessenberg form in the (K-1)th column, and thus
*           chases the bulge one step toward the bottom of the active
*           submatrix. NR is the order of G.
*
            NR = MIN( NS+1, I-K+1 )
            IF( K.GT.L )
     $         CALL DCOPY( NR, H( K, K-1 ), 1, V, 1 )
            CALL DLARFG( NR, V( 1 ), V( 2 ), 1, TAU )
            IF( K.GT.L ) THEN
               H( K, K-1 ) = V( 1 )
               DO 130 II = K + 1, I
                  H( II, K-1 ) = ZERO
  130          CONTINUE
            END IF
            V( 1 ) = ONE
*
*           Apply G from the left to transform the rows of the matrix in
*           columns K to I2.
*
            CALL DLARFX( 'Left', NR, I2-K+1, V, TAU, H( K, K ), LDH,
     $                   WORK )
*
*           Apply G from the right to transform the columns of the
*           matrix in rows I1 to min(K+NR,I).
*
            CALL DLARFX( 'Right', MIN( K+NR, I )-I1+1, NR, V, TAU,
     $                   H( I1, K ), LDH, WORK )
*
            IF( WANTZ ) THEN
*
*              Accumulate transformations in the matrix Z
*
               CALL DLARFX( 'Right', NH, NR, V, TAU, Z( ILO, K ), LDZ,
     $                      WORK )
            END IF
  140    CONTINUE
*
  150 CONTINUE
*
*     Failure to converge in remaining number of iterations
*
      INFO = I
      RETURN
*
  160 CONTINUE
*
*     A submatrix of order <= MAXB in rows and columns L to I has split
*     off. Use the double-shift QR algorithm to handle it.
*
      CALL DLAHQR( WANTT, WANTZ, N, L, I, H, LDH, WR, WI, ILO, IHI, Z,
     $             LDZ, INFO )
      IF( INFO.GT.0 )
     $   RETURN
*
*     Decrement number of remaining iterations, and return to start of
*     the main loop with a new value of I.
*
      ITN = ITN - ITS
      I = L - 1
      GO TO 50
*
  170 CONTINUE
      RETURN
*
*     End of DHSEQR
*
      END

function gio_riox (lun,ibl,buf,size)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !       Read one direct acess block
  !       The file must have been opened with the appropriate block size
  !---------------------------------------------------------------------
  integer(kind=4) :: gio_riox  !
  integer(kind=4),             intent(in)  :: lun        ! Logical unit number
  integer(kind=record_length), intent(in)  :: ibl        ! Block number
  integer(kind=4),             intent(in)  :: size       ! Block size
  integer(kind=4),             intent(out) :: buf(size)  ! Buffer to be read
  read (unit=lun,rec=ibl,iostat=gio_riox) buf
end function gio_riox
!
function gio_wiox (lun,ibl,buf,size)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  !       Write one direct acess block
  !       The file must have been opened with the appropriate block size
  !---------------------------------------------------------------------
  integer(kind=4) :: gio_wiox  !
  integer(kind=4),             intent(in) :: lun        ! Logical unit number
  integer(kind=record_length), intent(in) :: ibl        ! Block number
  integer(kind=4),             intent(in) :: size       ! Block size
  integer(kind=4),             intent(in) :: buf(size)  ! Buffer to be read
  write (unit=lun,rec=ibl,iostat=gio_wiox) buf
end function gio_wiox
!
subroutine gdf_fill(n,x,v)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !       Fill array with value
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: n  ! Number of elements
  integer(kind=4), intent(out) :: x(n)         ! Data array
  integer(kind=4), intent(in)  :: v            ! Filling value
  ! Local
  integer(kind=size_length) :: i
  do i=1,n
    x(i) = v
  enddo
end subroutine gdf_fill
!
subroutine gdf_index_to_where(inone,ndim,dims,iwhere)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! GDF Convert a (rank-1) position in a pixel number for arbitrary dimensions
  ! Will need an INTERFACE from outside
  !---------------------------------------------------------------------
  integer(kind=8), intent(in)  :: inone         ! Relative position in rank-1 array
  integer(kind=4), intent(in)  :: ndim          ! Number of dimensions
  integer(kind=index_length), intent(in)  :: dims(ndim)    ! Number of dimensions
  integer(kind=index_length), intent(out) :: iwhere(ndim)  ! Pixel position
  !
  integer(kind=8) :: tdim(ndim)
  integer(kind=8) :: jnone, jsize
  integer :: i, j, k
  !
  tdim = max(1,dims)
  !
  jnone = inone-1
  do i=ndim,2,-1
    jsize = 1
    do j=1,i-1
      jsize = jsize*tdim(j)
    enddo
    k = jnone / jsize
    jnone = jnone - k*jsize
    iwhere(i) = k+1
  enddo
  iwhere(1) = jnone+1
  !! Print *,'GDF_INDEX_TO_WHERE ',inone,' = ',iwhere
end subroutine gdf_index_to_where
!
subroutine gdf_where_to_index(inone,ndim,dims,iwhere)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! GDF Convert a pixel number in a (rank-1) position for arbitrary dimensions
  ! Will need an INTERFACE from outside
  !---------------------------------------------------------------------
  integer(kind=8), intent(out) :: inone         ! Relative position in rank-1 array
  integer(kind=4), intent(in)  :: ndim          ! Number of dimensions
  integer(kind=index_length), intent(in)  :: dims(ndim)    ! Number of dimensions
  integer(kind=index_length), intent(in)  :: iwhere(ndim)  ! Pixel position
  !
  integer(kind=8) :: tdim(ndim)
  integer(kind=8) :: jnone, step
  integer i
  !
  tdim = max(1,dims)
  !
  jnone = iwhere(1)
  step = tdim(1)
  do i=2,ndim
    jnone = jnone +  (iwhere(i)-1)*step
    step = step*tdim(i)
  enddo
  inone = jnone
  !! Print *,'GDF_WHERE_TO_INDEX ',inone,' = ',iwhere
end subroutine gdf_where_to_index
!
subroutine gio_form (inform,ouform)
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !       Determine machine dependent data format from image
  !       data format
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: inform                 ! Input Format
  integer(kind=4), intent(out) :: ouform                ! Output Format
  ! Local
  integer :: forms(9),if
  data forms/fmt_r4,fmt_r8,fmt_i4,fmt_l,fmt_i2,fmt_by,fmt_c4,fmt_c8,fmt_i8/
  !
  if (inform.eq.0 .or. inform.eq.6) then
    ouform = inform
  else
    if = mod(-inform,10)       ! From 1 to 9
    ouform = forms(if)         ! Output format
  endif
end subroutine gio_form
!
function gio_block (form,size)
  use gildas_def
  use gio_params
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !       Compute number of blocks from image size
  !---------------------------------------------------------------------
  integer(kind=record_length) :: gio_block  !
  integer(kind=4),           intent(in) :: form  ! Input format
  integer(kind=size_length), intent(in) :: size  ! Array  size
  !
  if (form.eq.fmt_r8.or.form.eq.fmt_c4.or.form.eq.fmt_i8) then
    gio_block = (size+63)/64
  elseif (form.eq.fmt_by) then
    gio_block = (size+511)/512
  elseif (form.eq.fmt_c8) then
    gio_block = (size+31)/32
  elseif (form.lt.0) then
    gio_block = (size+127)/128
  else
    gio_block = 0
  endif
end function gio_block
!
subroutine gdf_style (is,gtype)
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  !       Returns image type
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: is             ! Image Slot
  character(len=*), intent(out) :: gtype        ! Image type
  !
  if (islot(is).eq.code_gio_empty) then
    gtype = ' '
  else
    gtype = gheads(is)%char%type
  endif
end subroutine gdf_style
!
subroutine gio_idim (is,size)
  use gio_params
  use gio_image
  !---------------------------------------------------------------------
  ! @ private
  !  Define image dimensions and compute image size
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)  :: is    ! Image Slot
  integer(kind=size_length), intent(out) :: size  ! Array  size
  ! Local
  integer(kind=4) :: i
  !
  indim(is)   = gheads(is)%gil%ndim
  idims(:,is) = gheads(is)%gil%dim(:)
  do i=gdf_maxdims,2,-1
    if (idims(i,is).eq.0) then
      idims(i,is) = 1
      indim(is)   = min(indim(is),i-1)
    endif
  enddo
  !
  size = 1
  do i=1,gdf_maxdims
    size = size*idims(i,is)
  enddo
end subroutine gio_idim
!
subroutine gdf_dims(is,ndim,dims)
  use gildas_def
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! GDF  API routine
  !             Return image dimensions (for SIC, in fact)
  ! The output dimensions are kind=index_length
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: is                  ! Image slot
  integer(kind=4), intent(out) :: ndim               ! Number of dimensions
  integer(kind=index_length), intent(out) :: dims(:) ! Dimensions
  !
  integer i
  !
  ndim = indim(is)
  do i=1,gdf_maxdims
     dims(i) = idims(i,is)
  enddo
end subroutine gdf_dims
!
subroutine convgcod (sycode,imcode,conver,mess,isev)
  use gio_interfaces, only : gdf_conversion
  use gio_convert
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !       SYCODE system code
  !       '-'    IEEE
  !       '.'    EEEI (IBM like)
  !       '_'    VAX
  !       IMCODE file code
  !       '<'    IEEE  64 bits    (Little Endian, 99.9 % of recent computers)
  !       '>'    EEEI  64 bits    (Big Endian, HPUX, IBM-RISC, and SPARC ...)
  !---------------------------------------------------------------------
  character(len=1), intent(in) :: sycode        !  System code
  character(len=1), intent(inout) :: imcode     !  File code
  integer, intent(out)  :: conver               !  Conversion code number
  character(len=*), intent(out) :: mess         !  Message trailer
  integer, intent(out)  :: isev                 !  Severity of message (D or I)
  ! Local
  character(len=16) :: conversion
  logical is64bit
  !
  conver = unknown
  if (imcode.eq.'<') then
    is64bit = .true.
    imcode = '-'
  else if (imcode.eq.'>') then
    is64bit = .true.
    imcode = '.'
  else
    is64bit = .false.
  endif
  isev = seve%i
  !
  if (imcode.eq.sycode) then
    conver = 0
    isev = seve%d
    ! print *,'No conversion'
  elseif (imcode.eq.'_') then
    if (sycode.eq.'-') then
      conver = vax_to_ieee     ! (VAX to DEC)
    elseif (sycode.eq.'.') then
      conver = vax_to_eeei     ! (VAX to IBM)
    endif
  elseif (imcode.eq.'-') then
    if (sycode.eq.'_') then
      conver = ieee_to_vax     ! (DEC to VAX)
    elseif (sycode.eq.'.') then
      conver = ieee_to_eeei    ! (DEC to IBM)
    endif
  elseif (imcode.eq.'.') then
    if (sycode.eq.'_') then
      conver = eeei_to_vax     ! (IBM to VAX)
    elseif (sycode.eq.'-') then
      conver = eeei_to_ieee    ! (IBM to DEC)
      ! print *,'IBM to DEC ',conver,' EEEI_TO_IEEE'
    endif
  endif
  if (conver.gt.mconve) conver  = unknown
  call gdf_conversion(conver,conversion)
  if (is64bit) then
     mess = 'File is '//trim(conversion)//', Header Version 2 (64 bit) '
     conver = conver+off_64bit
  else
     mess = 'File is '//conversion//', Header Version 1 (32 bit)'
     isev = seve%i
  endif
end subroutine convgcod
!
function gio_rih (is,gtype,form,lndb)
  use gio_interfaces, except_this=>gio_rih
  use gildas_def
  use gio_image
  use gio_convert
  use gio_headers
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO  Internal routine
  !       Read full header from internal buffer, with format conversion
  !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
  !             the data format of the header
  !---------------------------------------------------------------------
  integer(kind=4) :: gio_rih  !
  integer(kind=4),             intent(in)  :: is     ! Image Slot
  character(len=*),            intent(out) :: gtype  ! Image type
  integer(kind=4),             intent(out) :: form   ! Data format
  integer(kind=record_length), intent(out) :: lndb   ! Number of 512 byte blocks
  ! Global
  external :: iei4ei,eii4ie
  external :: ier8va,ier4va, var8ie,var4ie
  external :: ier8ei,ier4ei, eir8ie,eir4ie
  external :: var8ei,var4ei, eir8va,eir4va
  external :: r8tor8,r4tor4, i4toi4,i8toi8
  ! Local
  character(len=*), parameter :: rname = 'GIO_RIH'
  integer(kind=record_length) :: js
  integer(kind=4) :: ier, len64, isev
  character(len=12) :: gdftit
  character(len=1) :: sycode
  character(len=128) :: chain
  logical error
  integer(kind=4) :: abuf32(128)
  type(gildas_header_v2) :: hd64
  type(gildas_header_v1) :: hd32
  integer(kind=4) :: indb
  integer(kind=8) :: jndb
  integer(kind=4) :: jconv, lc
  !
  call bytoch (gdfbuf,gdftit,12)
  !
  error = .false.
  gio_rih = 0
  if (gdftit(1:6).ne.'GILDAS') return
  call gio_syscod (sycode)
  call convgcod (sycode,gdftit(7:7),iconv(is),chain,isev)
  if (iconv(is).lt.0) return
  !
  call gildas_null(gheads(is))
  !
  ! File to Memory
  !
  gtype = gdftit
  gtype(7:7) = '_'
  !
  ! This is a little awkward, but identifies old non-versioned data format
  if (iconv(is).lt.off_64bit) then  ! iconv(is) must be positive
    istbl(is) = 1   ! Only one Header Block
    !
    if (iconv(is).eq.vax_to_ieee) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,var8ie,var4ie,i4toi4)
    elseif (iconv(is).eq.ieee_to_vax) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,ier8va,ier4va,i4toi4)
    elseif (iconv(is).eq.vax_to_eeei) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,var8ei,var4ei,iei4ei)
    elseif (iconv(is).eq.ieee_to_eeei) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,ier8ei,ier4ei,iei4ei)
    elseif (iconv(is).eq.eeei_to_vax) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,eir8va,eir4va,eii4ie)
    elseif (iconv(is).eq.eeei_to_ieee) then
      call gio_cvhd32 (lenbuf,gdfbuf,abuf32,eir8ie,eir4ie,eii4ie)
    else
      call r4tor4 (gdfbuf,abuf32,lenbuf)
    endif
    !
    iform(is) = abuf32(4)
    indb = abuf32(5)
    !
    call gio_read32header(hd32,abuf32,error)
    call chtoby(gtype,hd32%ijtyp,12)
    !! call gio_hd32_to_gildas_v1 (hd32,gheads(is))
    call gio_hd32_to_gildas_v2 (hd32,gheads(is))
    !
    lndb = indb
    !
    call gio_message(isev,rname,chain)
  else
    !
    jconv = iconv(is)-off_64bit
    !
    ! Prepare required information
    if (jconv.ne.0) then
      call iei4ei(gdfbuf(4),iform(is),1)   ! Just a simple swap
      call iei8ei(gdfbuf(5),jndb,1)        ! This is an I*8 integer
      call iei4ei(gdfbuf(7),istbl(is),1)
    else
      call i4toi4(gdfbuf(4),iform(is),1)
      call i8toi8(gdfbuf(5),jndb,1)        ! This is an I*8 integer
      call i4toi4(gdfbuf(7),istbl(is),1)
    endif
    !
    if (gio_gdfbuf(rname,istbl(is)).eq.0) then
      gio_rih = 0
      return
    endif
    lc = len_trim(chain)
    write(chain(lc+1:),'(A,I4)') ', Blocks: ',istbl(is)
    call gio_message(isev,rname,chain)
    !
    len64 = lenbuf*istbl(is)
    do js=1,istbl(is)
      read(iunit(is),rec=js,iostat=ier) gdfbig(:,js)
    enddo
    !
    if (jconv.eq.vax_to_ieee) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,var8ie,var4ie,i4toi4,i8toi8,error)
    elseif (jconv.eq.ieee_to_vax) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,ier8va,ier4va,i4toi4,i8toi8,error)
    elseif (jconv.eq.vax_to_eeei) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,var8ei,var4ei,iei4ei,ier8ei,error)
    elseif (jconv.eq.ieee_to_eeei) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,ier8ei,ier4ei,iei4ei,ier8ei,error)
    elseif (jconv.eq.eeei_to_vax) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,eir8va,eir4va,eii4ie,eir8ie,error)
    elseif (jconv.eq.eeei_to_ieee) then
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,eir8ie,eir4ie,eii4ie,eir8ie,error)
    else
      call gio_buffer_to_hd64 (len64,gdfbig,hd64,r8tor8,r4tor4,i4toi4,i8toi8,error)
    endif
    if (error) then
      gio_rih = 0
      return
    endif
    !
    ! Check data type and version number
    if (hd64%version_gdf.gt.code_version_gdf_current) then
      write(chain,'(A,I2,A,I2,A,I2)') 'Unsupported version ', hd64%version_gdf &
           & ,' > ',code_version_gdf_current,' for slot ',is
      call gio_message(seve%e,rname,chain)
      gio_rih = 0
      return
    endif
    !
    call chtoby(gtype,hd64%ijtyp,12)
    call gio_hd64_to_gildas_v2 (hd64,gheads(is),error)
    !
    lndb = jndb
  endif
  !
  ! Sanity check: warn and patch if Nvisi > visibility dimension
  if (gdf_check_nvisi(is,chain).gt.0) then
    call gio_message(seve%w,rname,chain)
    ! Force Nvisi to correct value:
    if (gheads(is)%gil%type_gdf.eq.code_gdf_uvt) then
      gheads(is)%gil%nvisi = gheads(is)%gil%dim(2)
    else
      gheads(is)%gil%nvisi = gheads(is)%gil%dim(1)
    endif
  endif
  !
  ! Check Big Block Size
  isbig(is) = gio_blocking(lndb,istbl(is),.false.)
  !
  ! Define last existing Buffer
  imblock(is) = lndb+istbl(is)
  !
  call gio_form (iform(is),form)
  !
  ! Put additional informations at their appropriate location
  gtype = gheads(is)%char%type ! For the return call
  ivers(is) = gheads(is)%gil%type_gdf
  gheads(is)%gil%form = form
  !
  ! At this stage, we have a true GILDAS header
  gio_rih = 1
end function gio_rih
!
function gio_wih (is,gtype,form,lndb)
  use gio_interfaces, except_this=>gio_wih
  use gildas_def
  use gbl_message
  use gio_image
  use gio_convert
  use gio_headers
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO  Internal routine
  !       Write full header to internal buffer, with format conversion
  !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
  !             the data format of the header
  !---------------------------------------------------------------------
  integer(kind=4) :: gio_wih  !
  integer(kind=4),             intent(in) :: is     ! Image Slot
  character(len=*),            intent(in) :: gtype  ! Image type
  integer(kind=4),             intent(in) :: form   ! Data format
  integer(kind=record_length), intent(in) :: lndb   ! Number of 512 byte blocks
  ! Global
  external :: iei4ei,eii4ie
  external :: ier8va,ier4va, var8ie,var4ie
  external :: ier8ei,ier4ei, eir8ie,eir4ie
  external :: var8ei,var4ei, eir8va,eir4va
  external :: r8tor8,r4tor4, i4toi4,i8toi8
  ! Local
  character(len=1) :: ficode
  character(len=12) :: gdftit
  logical :: error
  integer(kind=4) :: abuf32(lenbuf)
  type(gildas_header_v1) :: hd32
  type(gildas_header_v2) :: hd64
  integer(kind=4) :: lenb64
  integer(kind=4) :: indb
  integer(kind=8) :: jndb
  integer(kind=4) :: jconv, ier
  integer(kind=record_length), parameter :: lndb_limit=ndb_64bit
  character(len=message_length) :: mess
  character(len=*), parameter :: rname = 'GIO_WIH'
  !
  ! Sanity check ASAP
  if (gdf_check_nvisi(is,mess).gt.0) then
    call gio_message(seve%e,rname,mess)
    call gio_message(seve%e,rname,'Header NOT written')
    gio_wih = 0  ! Error
    return
  endif
  !
  ! Depending on Lndb, we shall select the 32bit or 64bit representation
  if (lndb.gt.lndb_limit.and.istbl(is).lt.2) then
    write (mess,*) 'LNDB ',lndb,' > ',lndb_limit,', forcing 64 bit implementation'
    istbl(is) = 2
  else
    write(mess,*) 'LNDB ',lndb,' < ',lndb_limit,', using default implementation'
  endif
  call gio_message(seve%d,'GDF_WIH',mess)
  !
  ier = gio_gdfbuf(rname,istbl(is))
  if (ier.eq.0) then
    gio_wih = 0
    return
  endif
  !
  error = .false.
  if (istbl(is).eq.1) then
    call bytoch(gtype,hd32%ijtyp,12)
    call gio_gildas_v2_to_hd32 (gheads(is),hd32)
    call gio_write32header(hd32,abuf32,error)
    !
    abuf32(4) = form          ! = iform(is)
    ! print *,'Form ',form,'  = type = ',iform(is),' ',gtype
    indb = lndb
    abuf32(5) = indb
    ! 6 to 11 not used...
    !
    ! Memory to File = - File from Memory
    if (iconv(is).eq.-ieee_fr_vax) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,ier8va,ier4va,i4toi4)
      ficode = '_'
    elseif (iconv(is).eq.-eeei_fr_vax) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,eir8va,eir4va,eii4ie)
      ficode = '_'
    elseif (iconv(is).eq.-vax_fr_ieee) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,var8ie,var4ie,i4toi4)
      ficode = '.'               ! not '-'
    elseif (iconv(is).eq.-eeei_fr_ieee) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,eir8ie,eir4ie,eii4ie)
      ficode = '.'               ! not '-'
    elseif (iconv(is).eq.-vax_fr_eeei) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,var8ei,var4ei,iei4ei)
      ficode = '-'               ! not '.'
    elseif (iconv(is).eq.-ieee_fr_eeei) then
      call gio_cvhd32 (lenbuf,abuf32,gdfbig,ier8ei,ier4ei,iei4ei)
      ficode = '-'               ! not '.'
    else
      call r4tor4 (abuf32,gdfbig,lenbuf)
      call gio_syscod(ficode)
    endif
    gdftit = gtype
    gdftit(7:7) = ficode
    !
    if (gtype.eq.'GILDAS_IMAGE') then
      ivers(is) = code_gdf_image
    elseif  (gtype.eq.'GILDAS_UVFIL') then
      ivers(is) = code_gdf_uvt
    else
      ivers(is) = 0
    endif
    !
    call chtoby(gdftit,gdfbig,12)
  else
    jndb = lndb
    !
    if (iconv(is).ge.off_64bit) then
      jconv = mod(iconv(is),off_64bit)
    else if (iconv(is).le.-off_64bit) then
      jconv = -mod(-iconv(is),off_64bit)
    else
      jconv = iconv(is)
    endif
    !
    ! This is a patch until the default GILDAS data type contains type_gdf
    if (gtype.eq.'GILDAS_IMAGE') then
      ivers(is) = code_gdf_image
    elseif  (gtype.eq.'GILDAS_UVFIL') then
      ivers(is) = code_gdf_uvt
    else
      ivers(is) = 0
    endif
    !
    ! Convert the current GILDAS header to a 64-bit capable one
    call bytoch(gtype,hd64%ijtyp,12)
    !!call gio_gildas_v1_to_hd64(gheads(is),hd64,error)
    call gio_gildas_v2_to_hd64(gheads(is),hd64,error)
    !
    ! Add missing information
    hd64%form = form
    hd64%ndb = jndb
    hd64%nhb = istbl(is)
    !
    !
    hd64%ntb = 0
    hd64%version_gdf = code_version_gdf_current
    !! hd64%type_gdf = ivers(is) ! No longer correct...
    if (hd64%type_gdf.eq.0) hd64%type_gdf = ivers(is) ! Better, but perhaps also not correct
    !
    !!Print *,'GDF_WIH, Calling GIO_HD64_TO_BUFFER ',jconv
    !
    ! Memory to File = - File from Memory
    call gio_syscod(ficode)
    lenb64 = istbl(is)*lenbuf
    if (jconv.eq.-ieee_fr_vax) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,ier8va,ier4va,i4toi4,i8toi8)
      ficode = '_'
    elseif (jconv.eq.-eeei_fr_vax) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,eir8va,eir4va,eii4ie,eir8ie)
      ficode = '_'
    elseif (jconv.eq.-vax_fr_ieee) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,var8ie,var4ie,i4toi4,i8toi8)
      ficode = '.'               ! not '-'
    elseif (jconv.eq.-eeei_fr_ieee) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,eir8ie,eir4ie,eii4ie,eir8ie)
      ficode = '.'               ! not '-'
    elseif (jconv.eq.-vax_fr_eeei) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,var8ei,var4ei,iei4ei,ier8ei)
      ficode = '-'               ! not '.'
    elseif (jconv.eq.-ieee_fr_eeei) then
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,ier8ei,ier4ei,iei4ei,ier8ei)
      ficode = '-'               ! not '.'
    else
      !!Print *,'No conversion '
      call gio_hd64_to_buffer (lenb64,hd64,gdfbig,r8tor8,r4tor4,i4toi4,i8toi8)
      call gio_syscod(ficode)
    endif
    !
    ! Set the output file type..
    gdftit = gtype
    if (ficode.eq.'-') then
      ficode = '<'
    else if (ficode.eq.'.') then
      ficode = '>'
    endif
    gdftit(7:7) = ficode
    !
    call chtoby(gdftit,gdfbig,12)
    !!Print *,  'DONE GDF_WIH ',gdftit
  endif
  gio_wih = 1
end function gio_wih
!
function gio_eih (is,gtype,form,lndb)
  use gio_interfaces, except_this=>gio_eih
  use gildas_def
  use gbl_message
  use gio_image
  use gio_convert
  !---------------------------------------------------------------------
  ! @ private
  !  GDF        API routine
  !             Read partial header to prepare an update
  !             Return the Type, the data format and the number of blocks
  !     GIO_RIH / GIO_WIH / GIO_EIH are the only routine addressing
  !             the data format of the header
  !---------------------------------------------------------------------
  integer(kind=4) :: gio_eih
  integer(kind=4),             intent(in)    :: is     ! Image Slot
  character(len=*),            intent(inout) :: gtype  ! Image type
  integer(kind=4),             intent(inout) :: form   ! Data format
  integer(kind=record_length), intent(inout) :: lndb   ! Number of 512 byte blocks
  ! Local
  character(len=12) :: gdftit
  character(len=1) :: sycode
  character(len=128) :: chain
  character(len=*), parameter :: rname = 'GIO_EIH'
  integer :: lc, isev
  integer(kind=4) :: l4ndb
  integer(kind=8) :: l8ndb
  !
  call bytoch (gdfbuf,gdftit,12)
  gio_eih = 0
  if (gdftit(1:6).ne.'GILDAS') return
  call gio_syscod(sycode)
  call convgcod (sycode,gdftit(7:7),iconv(is),chain,isev)
  !
  ! This means not a valid GILDAS file
  if (iconv(is).lt.0) return
  !
  ! We should translate that here, as gio_eih is a standalone routine
  if (iconv(is).lt.off_64bit) then  ! iconv(is) must be positive
    !
    call gio_message(seve%i,rname,chain)
    if (iconv(is).eq.vax_to_ieee) then
      iform(is) = gdfbuf(4)
      l4ndb = gdfbuf(5)
    elseif (iconv(is).eq.ieee_to_vax) then
      iform(is) = gdfbuf(4)
      l4ndb = gdfbuf(5)
    elseif (iconv(is).eq.vax_to_eeei) then
      call iei4ei(gdfbuf(4),iform(is),1)
      call iei4ei(gdfbuf(5),l4ndb,1)
    elseif (iconv(is).eq.ieee_to_eeei) then
      call iei4ei(gdfbuf(4),iform(is),1)
      call iei4ei(gdfbuf(5),l4ndb,1)
    elseif (iconv(is).eq.eeei_to_vax) then
      call eii4ie(gdfbuf(4),iform(is),1)
      call eii4ie(gdfbuf(5),l4ndb,1)
    elseif (iconv(is).eq.eeei_to_ieee) then
      call eii4ie(gdfbuf(4),iform(is),1)
      call eii4ie(gdfbuf(5),l4ndb,1)
    else
      iform(is) = gdfbuf(4)
      l4ndb = gdfbuf(5)
    endif
    !
    ! This is "old" V1 format...
    lndb = l4ndb
    istbl(is) = 1
    !
  else
    if (iconv(is).eq.vax_to_ieee) then
      iform(is) = gdfbuf(4)
      call i8toi8(gdfbuf(5),l8ndb,1)
      istbl(is) = gdfbuf(7)
    elseif (iconv(is).eq.ieee_to_vax) then
      iform(is) = gdfbuf(4)
      call i8toi8(gdfbuf(5),l8ndb,1)
      istbl(is) = gdfbuf(7)
    elseif (iconv(is).eq.vax_to_eeei) then
      call iei4ei(gdfbuf(4),iform(is),1)
      call iei8ei(gdfbuf(5),l8ndb,1)
      call iei4ei(gdfbuf(7),istbl(is),1)
    elseif (iconv(is).eq.ieee_to_eeei) then
      call iei4ei(gdfbuf(4),iform(is),1)
      call iei8ei(gdfbuf(5),l8ndb,1)
      call iei4ei(gdfbuf(7),istbl(is),1)
    elseif (iconv(is).eq.eeei_to_vax) then
      call eii4ie(gdfbuf(4),iform(is),1)
      call eii8ie(gdfbuf(5),l8ndb,1)
      call eii4ie(gdfbuf(7),istbl(is),1)
    elseif (iconv(is).eq.eeei_to_ieee) then
      call eii4ie(gdfbuf(4),iform(is),1)
      call eii8ie(gdfbuf(5),l8ndb,1)
      call eii4ie(gdfbuf(7),istbl(is),1)
    else
      iform(is) = gdfbuf(4)
      call i8toi8(gdfbuf(5),l8ndb,1)
      istbl(is) = gdfbuf(7)
    endif
    lndb = l8ndb
    lc = len_trim(chain)
    write(chain(lc+1:),'(A,I4)') ', Blocks: ',istbl(is)
  endif
  call gio_message(isev,rname,chain)
  !
  call gio_form (iform(is),form)
  gtype = gdftit
  gtype(7:7) = '_'
  gio_eih = 1
  !
  !!Print *,'GDF_EIH ',gdftit,gdfbuf(4),gdfbuf(5)
  !!Print *,'GDF_EIH ',gdftit,iform(is),lndb
end function gio_eih
!
subroutine gio_buffer_to_hd64 (len,inbuf,outhd64,r8,r4,i4,i8,error)
  use gio_headers
  use gio_uv
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: len       ! Length of buffer
  integer(kind=4),        intent(in)    :: inbuf(*)  ! Input values in file format
  type(gildas_header_v2), intent(out)   :: outhd64   ! Converted values in machine format
  external                              :: r8        ! Real*8 conversion routine
  external                              :: r4        ! Real*4 conversion routine
  external                              :: i4        ! Integer*4 conversion routine
  external                              :: i8        ! Integer*8 conversion routine
  logical,                intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='GIO_BUFFER_TO_HD64'
  integer :: dim_start, blan_start, extr_start, coor_start, desc_start
  integer :: posi_start, proj_start, spec_start, reso_start, nois_start
  integer :: astr_start, uvda_start, tele_start
  integer :: max_uvda_words
  integer, allocatable :: column_codes(:,:)
  integer :: i, k, ier, nlt
  integer, parameter :: offset=128
  integer(kind=8) :: dim8(gdf_maxdims), ilong
  !
  !  type :: gildas_header_v2
  !
  ! Spread on two or more (stbl) blocks
  !
  ! Block 1: Basic Header and Dimension information
  !  sequence
  !
  !
  ! --- Trailer --------------------------------------------------------
  !  integer(kind=4) :: ityp(3) = 0        !  1  Image Type
  !  integer(kind=4) :: form    = fmt_r4   !  4  Data format (FMT_xx)
  !  integer(kind=8) :: ndb     = 0        !  5  Number of blocks
  !  integer(kind=4) :: nhb     = 2        !  7  Number of header blocks
  !  integer(kind=4) :: ntb     = 0        !  8  Number of trailing blocks
  !  integer(kind=4) :: version_gdf  = code_version_gdf_current  !  9  Data format Version number
  !  integer(kind=4) :: type_gdf  = code_gdf_image   !  10  Or _table, _vo, _uvt, _tuv, _class
  !  integer(kind=4) :: dim_start   = gdf_startdim           !  11  Start offset for DIMENSION, should be odd, >12
  !  ! The maximum value would be 17 to hold up to 8 dimensions.
  call bytoby(inbuf(1),outhd64%ijtyp,12)
  call i4(inbuf(4),outhd64%form,1)
  call i8(inbuf(5),outhd64%ndb,1)
  call i4(inbuf(7),outhd64%nhb,1)
  call i4(inbuf(8),outhd64%ntb,1)
  call i4(inbuf(9),outhd64%version_gdf,1)
  call i4(inbuf(10),outhd64%type_gdf,1)
  call read_and_check_start('DIMENSION',inbuf(11),outhd64%dim_start,error)
  if (error)  return
  !
  ! --- DIMENSION section. Caution about alignment... ------------------
  !  integer(kind=4) :: dim_words   = 2*gdf_maxdims+2            ! at dim_start=11  Dimension section length
  !  integer(kind=4) :: blan_start  !! = dim_start + dim_words + 2   ! 12  Pointer to next section
  !  integer(kind=4) :: mdim    = 4  !or > ! 13  Maximum number of dimensions in this data format
  !  integer(kind=4) :: ndim    = 0        ! 14  Number of dimensions
  !  integer(kind=8) :: dim(gdf_maxdims) = 0      ! 15  Dimensions
  !  !
  dim_start = outhd64%dim_start
  call read_and_check_words('DIMENSION',def_dim_words,inbuf(dim_start),outhd64%dim_words,error)
  if (error)  return
  call read_and_check_start('BLANKING',inbuf(dim_start+1),outhd64%blan_start,error)
  if (error)  return
  call i4(inbuf(dim_start+2),outhd64%mdim,1)
  call i4(inbuf(dim_start+3),outhd64%ndim,1)
  outhd64%dim = 1  ! In case there is 0 dimension
  if (index_length.eq.4) then
     call i8(inbuf(dim_start+4),dim8,outhd64%ndim)
     outhd64%dim = dim8
  else
     call i8(inbuf(dim_start+4),outhd64%dim,outhd64%ndim)
  endif
  !
  ! --- BLANKING section -----------------------------------------------
  !  integer(kind=4) :: blan_words = 2         ! at 41  Blanking section length
  !  integer(kind=4) :: extr_start !! = blan_start + blan_words + 2  ! Pointer to next section
  !  real(kind=4) :: bval = +1.23456e+38   ! 42  Blanking value
  !  real(kind=4) :: eval = -1.0           ! 43  Tolerance
  blan_start = outhd64%blan_start
  call read_and_check_words('BLANKING',def_blan_words,inbuf(blan_start),outhd64%blan_words,error)
  if (error)  return
  call read_and_check_start('EXTREMA',inbuf(blan_start+1),outhd64%extr_start,error)
  if (error)  return
  if (outhd64%blan_words.ne.0) then
    call r4(inbuf(blan_start+2),outhd64%bval,1)
    call r4(inbuf(blan_start+3),outhd64%eval,1)
  endif
  !
  ! --- EXTREMA section ------------------------------------------------
  !  integer(kind=4) :: extr_words = 6         ! Extrema section length
  !  integer(kind=4) :: coor_start !! = extr_start + extr_words +2     !
  !  real(kind=4) :: rmin    = 0.0         ! Minimum
  !  real(kind=4) :: rmax    = 0.0         ! Maximum
  !  integer(kind=8) :: mini = 0           ! Rank 1 pixel of minimum
  !  integer(kind=8) :: maxi = 0           ! Rank 1 pixel of maximum
  extr_start = outhd64%extr_start
  call read_and_check_words('EXTREMA',def_extr_words,inbuf(extr_start),outhd64%extr_words,error)
  if (error)  return
  call read_and_check_start('COORDINATE',inbuf(extr_start+1),outhd64%coor_start,error)
  if (error)  return
  if (outhd64%extr_words.ne.0) then
    call r4(inbuf(extr_start+2),outhd64%rmin,1)
    call r4(inbuf(extr_start+3),outhd64%rmax,1)
    call i8(inbuf(extr_start+4),ilong,1)
    call gdf_index_to_where (ilong,outhd64%ndim,outhd64%dim,outhd64%minloc)
    call i8(inbuf(extr_start+6),ilong,1)
    call gdf_index_to_where (ilong,outhd64%ndim,outhd64%dim,outhd64%maxloc)
    !    call i8(inbuf(extr_start+4),outhd64%mini,1)
    !    call i8(inbuf(extr_start+6),outhd64%maxi,1)
  endif
  !
  ! --- COORDINATE section ---------------------------------------------
  !  integer(kind=4) :: coor_words  = 6*gdf_maxdims   ! at coor_start  Section length
  !  integer(kind=4) :: desc_start  !! = coor_startd + coor_wordsd +2     !
  !  real(kind=8) :: convert(3,gdf_maxdims)       !  Ref, Val, Inc for each dimension
  coor_start = outhd64%coor_start
  call read_and_check_words('COORDINATE',def_coor_words,inbuf(coor_start),outhd64%coor_words,error)
  if (error)  return
  call read_and_check_start('DESCRIPTION',inbuf(coor_start+1),outhd64%desc_start,error)
  if (error)  return
  outhd64%convert = 1.
  if (outhd64%coor_words.ne.0) then
    call r8(inbuf(coor_start+2),outhd64%convert,outhd64%coor_words/2)
  endif
  !
  ! --- DESCRIPTION section --------------------------------------------
  !  integer(kind=4) :: desc_words  = 3*(gdf_maxdims+1) ! at desc_start, Description section length
  !  integer(kind=4) :: null_start  !! = desc_start + desc_words +2     !
  !  integer(kind=4) :: iuni(3)   = 0      ! Data Unit
  !  integer(kind=4) :: icod(3,gdf_maxdims) = 0   ! Axis names
  desc_start = outhd64%desc_start
  call read_and_check_words('DESCRIPTION',def_desc_words,inbuf(desc_start),outhd64%desc_words,error)
  if (error)  return
  call read_and_check_start('NULL',inbuf(desc_start+1),outhd64%null_start,error)
  if (error)  return
  if (outhd64%desc_words.ne.0) then
    call bytoby(inbuf(desc_start+2),outhd64%ijuni,12)
    call bytoby(inbuf(desc_start+2+3),outhd64%ijcod,12*outhd64%ndim)
  endif
  !
  !  ! The first block length is thus
  !  !  dim_start-1 + (2*mdim+4) + (4) + (8) +  (6*mdim+2) + (3*mdim+5)
  !  ! = dim_start-1 + mdim*(2+6+3) + (4+4+2+5+8)
  !  ! = dim_start-1 + 11*mdim + 23
  !  ! With mdim = 7, dim_start=11, this is 110 spaces
  !  ! With mdim = 8, dim_start=11, this is 121 spaces
  !  ! MDIM > 8 would NOT fit in one block...
  !  !
  !  ! Block 2: Ancillary information
  !  !
  !  ! The same logic of Length + Pointer is used there too, although the
  !  ! length are fixed. Note rounding to even number for the pointer offsets
  !  ! in order to preserve alignement...
  !  !
  !  integer(kind=4) :: posi_start  = 1
  !
  ! --- POSITION section -----------------------------------------------
  !  integer(kind=4) :: posi_words    = 15     ! 74  Position section length
  !  integer(kind=4) :: proj_start    !! = posi_start + 18     ! Pointer to next section
  !  integer(kind=4) :: isou(3) = 0        ! 75  Source name
  !  integer(kind=4) :: isys(3) = 0        ! 71  Coordinate System (moved from Description section)
  !  real(kind=8) :: ra         = 0.0      ! 78  Right Ascension
  !  real(kind=8) :: dec        = 0.0      ! 80  Declination
  !  real(kind=8) :: lii        = 0.0      ! 82  Galactic longitude
  !  real(kind=8) :: bii        = 0.0      ! 84           latitude
  !  real(kind=4) :: epoc       = 0.0      ! 86  Epoch of coordinates
  posi_start = offset + 1
  call read_and_check_words('POSITION',def_posi_words,inbuf(posi_start),outhd64%posi_words,error)
  if (error)  return
  call read_and_check_start('PROJECTION',inbuf(posi_start+1),outhd64%proj_start,error)
  if (error)  return
  if (outhd64%posi_words.ne.0) then
    call bytoby(inbuf(posi_start+2),outhd64%ijsou,12)
    call bytoby(inbuf(posi_start+5),outhd64%ijsys,12)
    call r8(inbuf(posi_start+8),outhd64%ra,1)
    call r8(inbuf(posi_start+10),outhd64%dec,1)
    call r8(inbuf(posi_start+12),outhd64%lii,1)
    call r8(inbuf(posi_start+14),outhd64%bii,1)
    call r4(inbuf(posi_start+16),outhd64%epoc,1)
  endif
  !
  ! --- PROJECTION section ---------------------------------------------
  !  integer(kind=4) :: proj_words = 9         ! 87  Projection section length
  !  integer(kind=4) :: spec_start !! = proj_start + 10
  !  real(kind=8) :: a0      = 0.0         ! 89  X of projection center
  !  real(kind=8) :: d0      = 0.0         ! 91  Y of projection center
  !  real(kind=8) :: pang    = 0.0         ! 93  Projection angle
  !  integer(kind=4) :: ptyp = p_none      ! 88  Projection type (see p_... codes)
  !  integer(kind=4) :: xaxi = 0           ! 95  X axis
  !  integer(kind=4) :: yaxi = 0           ! 96  Y axis
  proj_start = outhd64%proj_start
  call read_and_check_words('PROJECTION',def_proj_words,inbuf(proj_start),outhd64%proj_words,error)
  if (error)  return
  call read_and_check_start('SPECTROSCOPY',inbuf(proj_start+1),outhd64%spec_start,error)
  if (error)  return
  if (outhd64%proj_words.ne.0) then
    call r8(inbuf(proj_start+2),outhd64%a0,1)
    call r8(inbuf(proj_start+4),outhd64%d0,1)
    call r8(inbuf(proj_start+6),outhd64%pang,1)
    call i4(inbuf(proj_start+8),outhd64%ptyp,1)
    call i4(inbuf(proj_start+9),outhd64%xaxi,1)
    call i4(inbuf(proj_start+10),outhd64%yaxi,1)
  endif
  !
  ! --- SPECTROSCOPY section -------------------------------------------
  !  integer(kind=4) :: spec_words  = 12       ! 97  Spectroscopy section length
  !  integer(kind=4) :: reso_start  !! = spec_start + 14
  !  real(kind=8) :: fres       = 0.0      !101  Frequency resolution
  !  real(kind=8) :: fima       = 0.0      !103  Image frequency
  !  real(kind=8) :: freq       = 0.0      !105  Rest Frequency
  !  real(kind=4) :: vres       = 0.0      !107  Velocity resolution
  !  real(kind=4) :: voff       = 0.0      !108  Velocity offset
  !  real(kind=4) :: dopp       = 0.0
  !  integer(kind=4) :: faxi    = 0        !109  Frequency axis
  !  integer(kind=4) :: ilin(3) = 0        ! 98  Line name
  spec_start = outhd64%spec_start
  call read_and_check_words('SPECTROSCOPY',def_spec_words,inbuf(spec_start),outhd64%spec_words,error)
  if (error)  return
  call read_and_check_start('RESOLUTION',inbuf(spec_start+1),outhd64%reso_start,error)
  if (error)  return
  if (outhd64%spec_words.ne.0) then
    call r8(inbuf(spec_start+2),outhd64%fres,1)
    call r8(inbuf(spec_start+4),outhd64%fima,1)
    call r8(inbuf(spec_start+6),outhd64%freq,1)
    call r4(inbuf(spec_start+8),outhd64%vres,1)
    call r4(inbuf(spec_start+9),outhd64%voff,1)
    call r4(inbuf(spec_start+10),outhd64%dopp,1)
    call i4(inbuf(spec_start+11),outhd64%faxi,1)
    call bytoby(inbuf(spec_start+12),outhd64%ijlin,12)
    if (outhd64%spec_words.gt.13) then
      call i4(inbuf(spec_start+15),outhd64%vtyp,1)
    else
      outhd64%vtyp = 0
    endif
  endif
  !
  ! --- RESOLUTION section ---------------------------------------------
  !  integer(kind=4) :: reso_words = 3         !110  Resolution section length
  !  integer(kind=4) :: nois_start !! = reso_start + 6
  !  real(kind=4) :: majo    = 0.0         !111  Major axis
  !  real(kind=4) :: mino    = 0.0         !112  Minor axis
  !  real(kind=4) :: posa    = 0.0         !113  Position angle
  reso_start = outhd64%reso_start
  call read_and_check_words('RESOLUTION',def_reso_words,inbuf(reso_start),outhd64%reso_words,error)
  if (error)  return
  call read_and_check_start('NOISE',inbuf(reso_start+1),outhd64%nois_start,error)
  if (error)  return
  if (outhd64%reso_words.ne.0) then
    call r4(inbuf(reso_start+2),outhd64%majo,1)
    call r4(inbuf(reso_start+3),outhd64%mino,1)
    call r4(inbuf(reso_start+4),outhd64%posa,1)
  endif
  !
  ! --- NOISE section --------------------------------------------------
  !  integer(kind=4) :: nois_words = 2         ! 114 Noise section length
  !  integer(kind=4) :: astr_start !! = nois_start + 4
  !  real(kind=4) :: noise   = 0.0         ! 115 Theoretical noise
  !  real(kind=4) :: rms     = 0.0         ! 116 Actual noise
  nois_start = outhd64%nois_start
  call read_and_check_words('NOISE',def_nois_words,inbuf(nois_start),outhd64%nois_words,error)
  if (error)  return
  call read_and_check_start('ASTROMETRY',inbuf(nois_start+1),outhd64%astr_start,error)
  if (error)  return
  if (outhd64%nois_words.ne.0) then
    call r4(inbuf(nois_start+2),outhd64%noise,1)
    call r4(inbuf(nois_start+3),outhd64%rms,1)
  endif
  !
  ! --- ASTROMETRY section ---------------------------------------------
  !  integer(kind=4) :: astr_words  = 4         ! 117 Proper motion section length
  !  integer(kind=4) :: uvda_start !! = astr_start + 4
  !  real(kind=4) :: mura     = 0.0        ! 118 along RA, in mas/yr
  !  real(kind=4) :: mudec    = 0.0        ! 119 along Dec, in mas/yr
  !  real(kind=4) :: parallax = 0.0        ! 120 in mas
  !!  ! real(kind=4) :: pepoch   = 2000.0     ! 121 in yrs ?
  astr_start = outhd64%astr_start
  call read_and_check_words('ASTROMETRY',def_astr_words,inbuf(astr_start),outhd64%astr_words,error)
  if (error)  return
  call read_and_check_start('UV_DATA',inbuf(astr_start+1),outhd64%uvda_start,error)
  if (error) return
  if (outhd64%astr_words.ne.0) then
    call r4(inbuf(astr_start+2),outhd64%mura,1)
    call r4(inbuf(astr_start+3),outhd64%mudec,1)
    call r4(inbuf(astr_start+4),outhd64%parallax,1)
  endif
  !
  ! --- UV_DATA information --------------------------------------------
  !  integer(kind=4) :: uvda_words  =  ! Length of section, variable
  !  integer(kind=4) :: tele_start  !! = uvda_start + uvda_words + 2
  !  integer(kind=4) :: version            ! version number. Will allow us to change the data format
  !  integer(kind=4) :: nchan              ! Number of channels
  !
  uvda_start = outhd64%uvda_start
  !  The length of this section is variable
  !  It can be def_uvdata_words + 3*outhd64%nchan
  !  but outhd64%nchan is not yet defined. We use dim(1) instead
  max_uvda_words = def_uvda_words+3*outhd64%dim(1)
  call read_and_check_words('UV_DATA',max_uvda_words,inbuf(uvda_start),outhd64%uvda_words,error)
  if (error)  then
    Print *,'Expected UVDA length ',def_uvda_words, max_uvda_words
    Print *,'Found length ',outhd64%uvda_words
    error = .false.
  endif
  call read_and_check_start('TELESCOPE',inbuf(uvda_start+1),outhd64%tele_start,error)
  if (error)  return
  if (outhd64%uvda_words.ne.0) then
    call i4(inbuf(uvda_start+2),outhd64%version_uv,1)
    call i4(inbuf(uvda_start+3),outhd64%nchan,1)
    call i8(inbuf(uvda_start+4),outhd64%nvisi,1)
    call i4(inbuf(uvda_start+6),outhd64%nstokes,1)
    call r4(inbuf(uvda_start+7),outhd64%basemin,1)
    call r4(inbuf(uvda_start+8),outhd64%basemax,1)
    !
    ! All the rest is being debated
    !  ! All the rest is being debated
    !  integer(kind=4) :: fcol              ! "Column" of first channel
    !  integer(kind=4) :: lcol              ! "Column" of last channel
    call i4(inbuf(uvda_start+9),outhd64%fcol,1)
    call i4(inbuf(uvda_start+10),outhd64%lcol,1)
    ! the number of information per channel can be obtained by (lcol-fcol+1)/nchan
    ! so this could allow to derive the number of Stokes parameters
    !
    !  ! Leading data at start of each visibility contains specific information
    !  integer(kind=4) :: nlead              ! Number of leading informations (at lest 7)
    !  ! Trailing data at end of each visibility may hold additional information
    !  integer(kind=4) :: ntrail             ! Number of trailing informations
    call i4(inbuf(uvda_start+11),outhd64%nlead,1)
    call i4(inbuf(uvda_start+12),outhd64%ntrail,1)
    !
    nlt = outhd64%nlead + outhd64%ntrail
    !! Print *,'Lead / Trail ', outhd64%fcol, outhd64%lcol, outhd64%nlead, outhd64%ntrail
    allocate (column_codes(2,nlt),stat=ier)
    call i4(inbuf(uvda_start+13),column_codes,2*nlt)
    !! Print *,(column_codes(1:2,i),i=1,nlt)
    !
    ! Set the back pointers
    outhd64%column_pointer = code_null
    outhd64%column_size = 0
    do i = 1, outhd64%nlead+outhd64%ntrail
      if (column_codes(2,i).ne.0) then
        if (column_codes(1,i).gt.code_uvt_last) then
          Print *,'ERROR : This version of GILDAS does not support Code ',column_codes(1,i)
        else
          if (i.gt.outhd64%nlead) then
            outhd64%column_pointer(column_codes(1,i)) = i+outhd64%lcol-outhd64%nlead
          else
            outhd64%column_pointer(column_codes(1,i)) = i
          endif
          outhd64%column_size(column_codes(1,i)) = column_codes(2,i)
        endif
      endif
    enddo
    deallocate(column_codes)
    !
    ! Get the additional Frequency / Stokes information
    call i4(inbuf(uvda_start+13+2*nlt),outhd64%order,1)
    call i4(inbuf(uvda_start+14+2*nlt),outhd64%nfreq,1)
    call i4(inbuf(uvda_start+15+2*nlt),outhd64%atoms,4)
    if (outhd64%nfreq.ne.0) then
      ! Has Freqs AND Stokes
      allocate(outhd64%stokes(outhd64%nfreq),outhd64%freqs(outhd64%nfreq), stat=ier)
      call r8(inbuf(uvda_start+19+2*nlt),outhd64%freqs,outhd64%nfreq)
      call i4(inbuf(uvda_start+19+2*nlt+2*outhd64%nfreq),outhd64%stokes,outhd64%nfreq)
    else if (abs(outhd64%order).eq.abs(code_stok_chan)) then
      ! Only Stokes
      allocate(outhd64%stokes(outhd64%nstokes), stat=ier)
      call i4(inbuf(uvda_start+19+2*nlt),outhd64%stokes,outhd64%nstokes)
    endif
  endif
  !
  ! --- TELESCOPE section ----------------------------------------------
  ! The tele section here follows the UV Data section
  !   integer(kind=4) :: tele_words  ! Telescope section length
  !   integer(kind=4) :: void_start  ! Pointer to next section (unused)
  !   integer(kind=4) :: nteles      ! Number of telescopes
  ! Then for each telescope
  !   real(kind=8)    :: lon         ! Longitude (radians)
  !   real(kind=8)    :: lat         ! Latitude  (radians)
  !   real(kind=4)    :: alt         ! Altitude (m)
  !   real(kind=4)    :: diam        ! Diameter
  !   integer(kind=4) :: ijtele(3)   ! Telescope name
  tele_start = outhd64%tele_start
  call read_and_check_words('TELESCOPE',3+100*9,  &  ! Allow for up to 100 (!!!) telescopes
     inbuf(tele_start),outhd64%tele_words,error)
  if (error)  return
  if (outhd64%tele_words.ne.0) then
    !!Print *,'W-GIO_BUFFER_TO_HD64, Telescope section still experimental'
    call i4(inbuf(tele_start+2),outhd64%nteles,1)
    !!Print *,'W-GIO_BUFFER_TO_HD64, # Telescopes ',outhd64%nteles
    allocate(outhd64%teles(outhd64%nteles),stat=ier)
    if (outhd64%tele_words.gt.3) then
      call i4(inbuf(tele_start+3),outhd64%magic,1)
      !!Print *,'MagicT  ',outhd64%magic
      k = 4
      do i=1,outhd64%nteles
        !!Print *,'I ',i,k,outhd64%tele_words,' LEN ',len,tele_start+outhd64%tele_words
        if (k .gt. outhd64%tele_words) exit
        call r8(inbuf(k+tele_start),outhd64%teles(i)%lon,1)
        !!Print *,'Lon ',outhd64%teles(i)%lon
        k = k+2
        if (k .gt. outhd64%tele_words) exit
        call r8(inbuf(k+tele_start),outhd64%teles(i)%lat,1)
        !!Print *,'Lat ',outhd64%teles(i)%lat
        k = k+2
        if (k .gt. outhd64%tele_words) exit
        call r4(inbuf(k+tele_start),outhd64%teles(i)%alt,1)
        !!Print *,'Alt ',outhd64%teles(i)%alt
        k = k+1
        if (k .gt. outhd64%tele_words) exit
        call r4(inbuf(k+tele_start),outhd64%teles(i)%diam,1)
        !!Print *,'Diam ',outhd64%teles(i)%diam
        k = k+1
        if (k .gt. outhd64%tele_words) exit
        call bytoby(inbuf(k+tele_start),outhd64%teles(i)%ctele,12)
        !!Print *,'Telescope ',outhd64%teles(i)%ctele
        k = k+3
        if (k .gt. outhd64%tele_words) exit
        ! Skip padding
        k = k+1
        if (k .gt. outhd64%tele_words) exit
      enddo
    endif
  endif
  !
contains
  !
  subroutine read_and_check_words(name,mwords,buf,nwords,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Read the number of words of the current section, check for a valid
    ! value, raise error message if relevant.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name    ! Related section name
    integer(kind=4),  intent(in)    :: mwords  ! Max value expected
    integer(kind=4),  intent(in)    :: buf     ! Raw value
    integer(kind=4),  intent(out)   :: nwords  ! Converted value
    logical,          intent(inout) :: error   !
    ! Local
    character(len=message_length) :: mess
    !
    call i4(buf,nwords,1)
    if (nwords.ge.0 .and. nwords.le.mwords)  return
    !
    ! There is hardly anything we can do with this header nor the data.
    ! May be dumping what we have read up to now for debugging.
    write(mess,'(3A,2(I0,A))')  'Number of words of the ',name,  &
      ' section is unexpected (found ',nwords,', max is ',mwords,')'
    call gio_message(seve%e,rname,mess)
    call gio_message(seve%e,rname,'Can not read header beyond this point. File corrupted?')
    error = .true.
    return
  end subroutine read_and_check_words
  !
  subroutine read_and_check_start(name,buf,start,error)
    use gbl_message
    !-------------------------------------------------------------------
    ! Read the starting position of the next section, check for a valid
    ! value, raise an error message if relevant.
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: name   ! Related section name
    integer(kind=4),  intent(in)    :: buf    ! Raw value
    integer(kind=4),  intent(out)   :: start  ! Converted value
    logical,          intent(inout) :: error  !
    ! Local
    character(len=message_length) :: mess
    !
    call i4(buf,start,1)
    ! By design, the section start lies in the buffer
    if (start.ge.1 .and. start.le.len)  return
    !
    ! There is hardly anything we can do with this header nor the data.
    ! May be dumping what we have read up to now for debugging.
    write(mess,'(A,A,A,I0,A)')  'Start of ',name,' section is unexpected (',start,')'
    call gio_message(seve%e,rname,mess)
    call gio_message(seve%e,rname,'Can not read header beyond this point. File corrupted?')
    error = .true.
    return
  end subroutine read_and_check_start
  !
end subroutine gio_buffer_to_hd64
!
subroutine gio_hd64_to_buffer (len,inhd64,outbuf,r8,r4,i4,i8)
  use gio_headers
  use gio_uv
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(inout)  :: len    ! Length of buffer
  integer(kind=4), intent(out) :: outbuf(*) ! Input values in file format
  type (gildas_header_v2), intent(inout) :: inhd64  ! Converted values in machine format
  external :: r8                    ! Real*8 conversion routine
  external :: r4                    ! Real*4 conversion routine
  external :: i4                    ! Integer*4 conversion routine
  external :: i8                    ! Integer*8 conversion routine
  ! Local
  integer :: i, j, k, ier, nlt, itrail
  !
  integer :: dim_start, blan_start, extr_start, coor_start, desc_start
  integer :: posi_start, proj_start, spec_start, reso_start, nois_start
  integer :: astr_start, uvda_start, tele_start
  integer, parameter :: offset=128
  integer, allocatable :: column_codes(:,:)
  integer(kind=8) :: dim8(gdf_maxdims), ilong
  !
  outbuf(1:len) = 0
  !
  !  type :: gildas_header_v2
  !
  ! Spread on two or more blocks
  !
  ! Block 1: Basic Header and Dimension information
  !  sequence
  !
  !
  ! Trailer:
  !  integer(kind=4) :: ityp(3) = 0        !  1  Image Type
  !  integer(kind=4) :: form    = fmt_r4   !  4  Data format (FMT_xx)
  !  integer(kind=8) :: ndb     = 0        !  5  Number of blocks
  !  integer(kind=4) :: nhb     = 2        !  7  Number of header blocks
  !  integer(kind=4) :: ntb     = 0        !  8  Number of trailing blocks
  !  integer(kind=4) :: version_gdf  = code_version_gdf_current  !  9  Data format Version number
  !  integer(kind=4) :: type_gdf  = data_image       !  10  Or data_table, data_uvt, data_tuv, data_class
  !  integer(kind=4) :: dim_start   = gdf_startdim   !  11  Start offset for DIMENSION, should be odd, >12
  !  ! The maximum value would be 17 to hold up to 8 dimensions.
  call bytoby(inhd64%ijtyp,outbuf(1),12)
  call i4(inhd64%form,outbuf(4),1)
  call i8(inhd64%ndb,outbuf(5),1)
  call i4(inhd64%nhb,outbuf(7),1)
  call i4(inhd64%ntb,outbuf(9),1)
  call i4(inhd64%version_gdf,outbuf(9),1)
  call i4(inhd64%type_gdf,outbuf(10),1)
  inhd64%dim_start = gdf_startdim
  call i4(inhd64%dim_start,outbuf(11),1)
  !
  ! DIMENSION Section. Caution about alignment...
  !
  dim_start = inhd64%dim_start
  !!Print *,'GIO_HD64_TO_BUFFER dim_start',dim_start
  inhd64%mdim = gdf_maxdims                     !
  inhd64%dim_words = 2 + 2*inhd64%mdim   !
  call i4(inhd64%dim_words,outbuf(dim_start),1)
  inhd64%blan_start = dim_start + inhd64%dim_words + 2
  call i4(inhd64%blan_start,outbuf(dim_start+1),1)
  call i4(inhd64%mdim,outbuf(dim_start+2),1)
  call i4(inhd64%ndim,outbuf(dim_start+3),1)
  !
  if (index_length.eq.4) then
    dim8 = inhd64%dim
    call i8(dim8,outbuf(dim_start+4),inhd64%ndim)
  else
    call i8(inhd64%dim,outbuf(dim_start+4),inhd64%ndim)
  endif
  !!Print *,'dim',inhd64%ndim,inhd64%dim
  ! BLANKING
  blan_start = inhd64%blan_start
  !!Print *,'GIO_HD64_TO_BUFFER blan_start',blan_start,inhd64%blan_words
  if (inhd64%blan_words.ne.0) inhd64%blan_words = def_blan_words
  call i4(inhd64%blan_words,outbuf(blan_start),1)
  inhd64%extr_start = blan_start + inhd64%blan_words + 2
  call i4(inhd64%extr_start,outbuf(blan_start+1),1)
  if (inhd64%blan_words.ne.0) then
    call r4(inhd64%bval,outbuf(blan_start+2),1)
    call r4(inhd64%eval,outbuf(blan_start+3),1)
  endif
  !
  ! EXTREMA
  extr_start = inhd64%extr_start
  if (inhd64%extr_words.ne.0) inhd64%extr_words = def_extr_words
  !!Print *,'GIO_HD64_TO_BUFFER extr_start',extr_start,inhd64%extr_words
  call i4(inhd64%extr_words,outbuf(extr_start),1)
  inhd64%coor_start = extr_start + inhd64%extr_words + 2
  call i4(inhd64%coor_start,outbuf(extr_start+1),1)
  if (inhd64%extr_words.ne.0) then
    call r4(inhd64%rmin,outbuf(extr_start+2),1)
    call r4(inhd64%rmax,outbuf(extr_start+3),1)
    call gdf_where_to_index (ilong,inhd64%ndim,inhd64%dim,inhd64%minloc)
    call i8(ilong,outbuf(extr_start+4),1)
    call gdf_where_to_index (ilong,inhd64%ndim,inhd64%dim,inhd64%maxloc)
    call i8(ilong,outbuf(extr_start+6),1)
!    call i8(inhd64%mini,outbuf(extr_start+4),1)
!    call i8(inhd64%maxi,outbuf(extr_start+6),1)
  endif
  !
  ! COORDINATE Section
  coor_start = inhd64%coor_start
  if (inhd64%coor_words.ne.0) inhd64%coor_words = 6*gdf_maxdims
  !!Print *,'GIO_HD64_TO_BUFFER coor_start',coor_start,inhd64%coor_words
  call i4(inhd64%coor_words,outbuf(coor_start),1)
  inhd64%desc_start = coor_start + inhd64%coor_words + 2
  call i4(inhd64%desc_start,outbuf(coor_start+1),1)
  if (inhd64%coor_words.ne.0) then
    call r8(inhd64%convert,outbuf(coor_start+2),inhd64%coor_words/2)
  endif
  !
  ! DESCRIPTION Section
  inhd64%desc_start = coor_start+2+inhd64%coor_words
  desc_start = inhd64%desc_start
  if (inhd64%desc_words.ne.0) inhd64%desc_words = 3+3*gdf_maxdims
  !!Print *,'GIO_HD64_TO_BUFFER desc_start',desc_start,inhd64%desc_words
  call i4(inhd64%desc_words,outbuf(desc_start),1)
  inhd64%null_start = desc_start + inhd64%desc_words + 2
  call i4(inhd64%null_start,outbuf(desc_start+1),1)
  if (inhd64%desc_words.ne.0) then
    call bytoby(inhd64%ijuni,outbuf(desc_start+2),12)
    call bytoby(inhd64%ijcod,outbuf(desc_start+5),12*inhd64%ndim)
  endif
  !  !
  !  ! The first block length is thus
  !  !  dim_start-1 + (2*mdim+4) + (4) + (8) +  (6*mdim+2) + (3*mdim+5)
  !  ! = dim_start-1 + mdim*(2+6+3) + (4+4+2+5+8)
  !  ! = dim_start-1 + 11*mdim + 23
  !  ! With mdim = 7, dim_start=11, this is 110 spaces
  !  ! With mdim = 8, dim_start=11, this is 121 spaces
  !  ! MDIM > 8 would NOT fit in one block...
  !  !
  !  ! Block 2: Ancillary information
  !  !
  !  ! The same logic of Length + Pointer is used there too, although the
  !  ! lengths are fixed. Note rounding to even number for the pointer offsets
  !  ! in order to preserve alignement...
  !  !
  ! POSITION
  posi_start = offset + 1
  if (inhd64%posi_words.ne.0) inhd64%posi_words = def_posi_words
  !!Print *,'GIO_HD64_TO_BUFFER posi_start',posi_start,inhd64%posi_words
  call i4(inhd64%posi_words,outbuf(posi_start),1)
  inhd64%proj_start = posi_start + inhd64%posi_words + 2
  call i4(inhd64%proj_start,outbuf(posi_start+1),1)
  if (inhd64%posi_words.ne.0) then
    call bytoby(inhd64%ijsou,outbuf(posi_start+2),12)
    call bytoby(inhd64%ijsys,outbuf(posi_start+5),12)
    call r8(inhd64%ra,outbuf(posi_start+8),1)
    call r8(inhd64%dec,outbuf(posi_start+10),1)
    call r8(inhd64%lii,outbuf(posi_start+12),1)
    call r8(inhd64%bii,outbuf(posi_start+14),1)
    call r4(inhd64%epoc,outbuf(posi_start+16),1)
  endif
  ! !
  !  ! PROJECTION
  !  integer(kind=4) :: proj_words = 9         ! 87  Projection section length
  !  integer(kind=4) :: spec_start !! = proj_start + 12
  !  real(kind=8) :: a0      = 0.0         ! 89  X of projection center
  !  real(kind=8) :: d0      = 0.0         ! 91  Y of projection center
  !  real(kind=8) :: pang    = 0.0         ! 93  Projection angle
  !  integer(kind=4) :: ptyp = p_none      ! 88  Projection type (see p_... codes)
  !  integer(kind=4) :: xaxi = 0           ! 95  X axis
  !  integer(kind=4) :: yaxi = 0           ! 96  Y axis
  !  !
  proj_start = inhd64%proj_start
  if (inhd64%proj_words.ne.0) inhd64%proj_words = def_proj_words
  !!Print *,'GIO_HD64_TO_BUFFER proj_start',proj_start,inhd64%proj_words
  call i4(inhd64%proj_words,outbuf(proj_start),1)
  inhd64%spec_start = proj_start + inhd64%proj_words + 2
  call i4(inhd64%spec_start,outbuf(proj_start+1),1)
  if (inhd64%proj_words.ne.0) then
    call r8(inhd64%a0,outbuf(proj_start+2),1)
    call r8(inhd64%d0,outbuf(proj_start+4),1)
    call r8(inhd64%pang,outbuf(proj_start+6),1)
    call i4(inhd64%ptyp,outbuf(proj_start+8),1)
    call i4(inhd64%xaxi,outbuf(proj_start+9),1)
    call i4(inhd64%yaxi,outbuf(proj_start+10),1)
  endif
  !
  !  ! SPECTROSCOPY
  !  integer(kind=4) :: spec_words  = 12       ! 97  Spectroscopy section length
  !  integer(kind=4) :: reso_start  !! = spec_start + 14
  !  real(kind=8) :: fres       = 0.0      !101  Frequency resolution
  !  real(kind=8) :: fima       = 0.0      !103  Image frequency
  !  real(kind=8) :: freq       = 0.0      !105  Rest Frequency
  !  real(kind=4) :: vres       = 0.0      !107  Velocity resolution
  !  real(kind=4) :: voff       = 0.0      !108  Velocity offset
  !  integer(kind=4) :: faxi    = 0        !109  Frequency axis
  !  integer(kind=4) :: ilin(3) = 0        ! 98  Line name
  spec_start = inhd64%spec_start
  if (inhd64%spec_words.ne.0) inhd64%spec_words = def_spec_words
  !!Print *,'GIO_HD64_TO_BUFFER spec_start',spec_start,inhd64%spec_words
  call i4(inhd64%spec_words,outbuf(spec_start),1)
  inhd64%reso_start = spec_start + inhd64%spec_words + 2
  call i4(inhd64%reso_start,outbuf(spec_start+1),1)
  if (inhd64%spec_words.ne.0) then
    call r8(inhd64%fres,outbuf(spec_start+2),1)
    call r8(inhd64%fima,outbuf(spec_start+4),1)
    call r8(inhd64%freq,outbuf(spec_start+6),1)
    call r4(inhd64%vres,outbuf(spec_start+8),1)
    call r4(inhd64%voff,outbuf(spec_start+9),1)
    call r4(inhd64%dopp,outbuf(spec_start+10),1)
    call i4(inhd64%faxi,outbuf(spec_start+11),1)
    call bytoby(inhd64%ijlin,outbuf(spec_start+12),12)
    call i4(inhd64%vtyp,outbuf(spec_start+15),1)
  endif
  !  !
  !  ! RESOLUTION
  !  integer(kind=4) :: reso_words = 3         !110  Resolution section length
  !  integer(kind=4) :: nois_start !! = reso_start + 6
  !  real(kind=4) :: majo    = 0.0         !111  Major axis
  !  real(kind=4) :: mino    = 0.0         !112  Minor axis
  !  real(kind=4) :: posa    = 0.0         !113  Position angle
  reso_start = inhd64%reso_start
  if (inhd64%reso_words.ne.0) inhd64%reso_words = def_reso_words
  !!Print *,'GIO_HD64_TO_BUFFER reso_start',reso_start,inhd64%reso_words
  call i4(inhd64%reso_words,outbuf(reso_start),1)
  inhd64%nois_start = reso_start + inhd64%reso_words + 2
  call i4(inhd64%nois_start,outbuf(reso_start+1),1)
  if (inhd64%reso_words.ne.0) then
    call r4(inhd64%majo,outbuf(reso_start+2),1)
    call r4(inhd64%mino,outbuf(reso_start+3),1)
    call r4(inhd64%posa,outbuf(reso_start+4),1)
  endif
  !  !
  !  ! NOISE
  !  integer(kind=4) :: nois_words = 2         ! 114 Noise section length
  !  integer(kind=4) :: astr_start !! = nois_start + 4
  !  real(kind=4) :: noise   = 0.0         ! 115 Theoretical noise
  !  real(kind=4) :: rms     = 0.0         ! 116 Actual noise
  nois_start = inhd64%nois_start
  if (inhd64%nois_words.ne.0) inhd64%nois_words = def_nois_words
  call i4(inhd64%nois_words,outbuf(nois_start),1)
  inhd64%astr_start = nois_start + inhd64%nois_words + 2
  call i4(inhd64%astr_start,outbuf(nois_start+1),1)
  if (inhd64%nois_words.ne.0) then
    call r4(inhd64%noise,outbuf(nois_start+2),1)
    call r4(inhd64%rms,outbuf(nois_start+3),1)
  endif
  !  !
  !  ! ASTROMETRY
  !  integer(kind=4) :: astr_words  = 4         ! 117 Proper motion section length
  !  integer(kind=4) :: uvda_start !! = astr_start + 4
  !  real(kind=4) :: mura     = 0.0        ! 118 along RA, in mas/yr
  !  real(kind=4) :: mudec    = 0.0        ! 119 along Dec, in mas/yr
  !  real(kind=4) :: parallax = 0.0        ! 120 in mas
  !!  ! real(kind=4) :: pepoch   = 2000.0     ! 121 in yrs ?
  astr_start = inhd64%astr_start
  if (inhd64%astr_words.ne.0) inhd64%astr_words = def_astr_words
  call i4(inhd64%astr_words,outbuf(astr_start),1)
  inhd64%uvda_start = astr_start + inhd64%astr_words + 2
  call i4(inhd64%uvda_start,outbuf(astr_start+1),1)
  if (inhd64%astr_words.ne.0) then
    call r4(inhd64%mura,outbuf(astr_start+2),1)
    call r4(inhd64%mudec,outbuf(astr_start+3),1)
    call r4(inhd64%parallax,outbuf(astr_start+4),1)
  endif
  ! !
  !  ! UV_DATA information
  !  integer(kind=4) :: uvda_words  =  ! Length of section, variable
  !  integer(kind=4) :: tele_start  !! = uvda_start + uvda_words + 2
  !  integer(kind=4) :: version            ! version number. Will allow us to change the data format
  !  integer(kind=4) :: nchan              ! Number of channels
  !  !
  uvda_start = inhd64%uvda_start
  !!Print *,'GIO_HD64_TO_BUFFER uvda_start',uvda_start, inhd64%nfreq
  if (inhd64%uvda_words.ne.0) then
    ! Compute the length
    nlt = inhd64%nlead + inhd64%ntrail
    ! If we use the current number of additional information, we
    !   cannot extend the Table (in tuv order) without possibly
    !   changing the number of Header Blocks.
    inhd64%uvda_words = 12+2*nlt+6
    ! so a possible solution is to pre-allocate the maximum number
    !   but is it worth ?
    ! inhd64%uvda_words = 12+2*code_uvt_last+6
    !
    if (inhd64%nfreq.ne.0) then
      inhd64%uvda_words = inhd64%uvda_words+3*inhd64%nfreq
    else
      if (abs(inhd64%order).eq.abs(code_stok_chan)) then
        inhd64%uvda_words = inhd64%uvda_words+inhd64%nstokes
      endif
    endif
    ! Make it even
    if (mod(inhd64%uvda_words,2).ne.0) inhd64%uvda_words = inhd64%uvda_words + 1
    !
    call i4(inhd64%uvda_words,outbuf(uvda_start),1)
    inhd64%tele_start = uvda_start + inhd64%uvda_words + 2
    call i4(inhd64%tele_start,outbuf(uvda_start+1),1)
    !
    ! Bug correction Nov-06 2014: was incorrectly version_gdf before
    call i4(inhd64%version_uv,outbuf(uvda_start+2),1)
    call i4(inhd64%nchan,outbuf(uvda_start+3),1)
    call i8(inhd64%nvisi,outbuf(uvda_start+4),1)
    call i4(inhd64%nstokes,outbuf(uvda_start+6),1)
    call r4(inhd64%basemin,outbuf(uvda_start+7),1)
    call r4(inhd64%basemax,outbuf(uvda_start+8),1)
    !
    !  ! All the rest is being debated
    !  integer(kind=4) :: fcol              ! "Column" of first channel
    !  integer(kind=4) :: lcol              ! "Column" of last channel
    !! Print *,'Lead / Trail ',inhd64%fcol,inhd64%lcol,inhd64%nlead,inhd64%ntrail
    call i4(inhd64%fcol,outbuf(uvda_start+9),1)
    call i4(inhd64%lcol,outbuf(uvda_start+10),1)
    ! the number of information per channel can be obtained by (lcol-fcol+1)/nchan
    ! so this could allow to derive the number of Stokes parameters
    !  !
    !  ! Leading data at start of each visibility contains specific information
    !  integer(kind=4) :: nlead              ! Number of leading informations (at lest 7)
    !  ! Trailing data at end of each visibility may hold additional information
    !  integer(kind=4) :: ntrail             ! Number of trailing informations
    call i4(inhd64%nlead,outbuf(uvda_start+11),1)
    if (inhd64%nlead.ne.7) then
      Print *,'Suspicious value of NLEAD ',inhd64%nlead, ' correct if needed'
      !! inhd64%nlead = 7
      read(5,*) inhd64%nlead
    endif
    if (inhd64%ntrail.gt.code_uvt_last) then
      Print *,'Suspicious value of NTRAIL ',inhd64%ntrail, ' correct if needed'
      read(5,*) inhd64%ntrail
      !! inhd64%ntrail = 2
    endif
    call i4(inhd64%ntrail,outbuf(uvda_start+12),1)
    !!Print *,'NLT ',nlt,inhd64%nlead,inhd64%ntrail
    !
    ! This coding is redundant : fcol = nlead+1  and lcol+ntrail = visi_size
    !
    ! Leading / Trailing information codes have been specified before
    ! integer(kind=4) :: column_pointer(code_uvt_last) = 0 ! Back pointer to the columns...
    ! ! In the data, we instead have the codes for each column
    ! integer(kind=4) :: column_codes(2,nlead+ntrail)    ! Leading / Trailing information codes
    allocate (column_codes(2,nlt),stat=ier)
    if (inhd64%ntrail.gt.code_uvt_last.or.ier.ne.0) then
      Print *,'Cannot allocate column codes'
      return
    endif
    column_codes = 0
    do j = 1,nlt
      do i = 1, code_uvt_last
        if (inhd64%column_pointer(i).lt.inhd64%fcol) then
          if (inhd64%column_pointer(i).eq.j) then
            column_codes(1,j) = i
            column_codes(2,j) = inhd64%column_size(i)
            exit
          endif
        else if (inhd64%column_pointer(i).gt.inhd64%lcol) then
           ! A little more vicious if > nlead
          itrail = inhd64%column_pointer(i)-inhd64%lcol+inhd64%nlead
          !! Print *,'Trail ',j,i,itrail
          if (itrail.eq.j) then
            column_codes(1,j) = i
            column_codes(2,j) = inhd64%column_size(i)
            exit
          endif
        else
          Print *,'Inconsistent Column Pointer #',i,' = ', inhd64%column_pointer(i), &
          &   ' in data range',inhd64%fcol,inhd64%lcol
        endif
      enddo
    enddo
    !! Print *,"(column_codes(1:2,i),i=1,nlt)"
    !! Print *,(column_codes(1:2,i),i=1,nlt)
    !
    call i4(column_codes,outbuf(uvda_start+13),2*nlt)
    deallocate(column_codes)
    !
    ! Is this the place for such information ?
    ! It can be arbitrarily long, so it can use an arbitrary size for the header ...
    !
    !    integer(kind=4) :: nfreq                 ! 0 or = nchan*nstokes
    call i4(inhd64%order,outbuf(uvda_start+13+2*nlt),1)
    call i4(inhd64%nfreq,outbuf(uvda_start+14+2*nlt),1)
    call i4(inhd64%atoms,outbuf(uvda_start+15+2*nlt),4)
    if (inhd64%nfreq.ne.0) then
      ! Has Freqs AND Stokes
      !    real(kind=8), pointer :: freqs(:) => null()        ! (nchan*nstokes) = 0d0
      call r8(inhd64%freqs,outbuf(uvda_start+19+2*nlt),inhd64%nfreq)
      !    integer(kind=4), pointer :: stokes(:) => null()    ! (nchan*nstokes) = code_stoke
      call i4(inhd64%stokes,outbuf(uvda_start+19+2*nlt+2*inhd64%nfreq),inhd64%nfreq)
    else if (abs(inhd64%order).eq.abs(code_stok_chan)) then
      ! Only Stokes
      call i4(inhd64%stokes,outbuf(uvda_start+19+2*nlt), inhd64%nstokes)
    endif
    !
  else
    ! No UV Data section
    call i4(inhd64%uvda_words,outbuf(uvda_start),1)
    inhd64%tele_start = uvda_start + inhd64%uvda_words + 2
    call i4(inhd64%tele_start,outbuf(uvda_start+1),1)
  endif
  !
  !!Print *,'GIO_HD64_TO_BUFFER tele_start',tele_start
  tele_start = inhd64%tele_start
  if (inhd64%tele_words.ne.0) inhd64%tele_words = 2+inhd64%nteles*10
  call i4(inhd64%tele_words,outbuf(tele_start),1)
  inhd64%void_start = tele_start + inhd64%tele_words + 2
  call i4(inhd64%void_start,outbuf(tele_start+1),1)
  !
  if (inhd64%tele_words.ne.0) then
    call i4(inhd64%nteles,outbuf(tele_start+2),1)
    call i4(inhd64%magic,outbuf(tele_start+3),1)
    k = tele_start+4
    do i=1,inhd64%nteles
      call r8(inhd64%teles(i)%lon,outbuf(k),1)
      k = k+2
      call r8(inhd64%teles(i)%lat,outbuf(k),1)
      k = k+2
      call r4(inhd64%teles(i)%alt,outbuf(k),1)
      k = k+1
      call r4(inhd64%teles(i)%diam,outbuf(k),1)
      k = k+1
      call bytoby(inhd64%teles(i)%ctele,outbuf(k),12)
      k = k+3
      ! Skip padding
      k = k+1
    enddo
  endif
  !
end subroutine gio_hd64_to_buffer
!
function gio_gdfbuf(rname,iblock)
  use gio_image
  use gbl_message
  ! @ private
  !
  integer :: gio_gdfbuf
  character(len=*), intent(in) :: rname
  integer, intent(in) :: iblock
  character(len=40) :: mess
  !
  integer :: ier
  !
  ! Re-Allocate sufficient work space for GDFBIG here
  gio_gdfbuf = 0
  if (iblock.gt.mstbl) then
    if (mstbl.ne.0) deallocate(gdfbig,stat=ier)
    mstbl = 0
    allocate (gdfbig(lenbuf,iblock),stat=ier)
     if (ier.ne.0) then
       call gio_message(seve%e,rname,'GDFBIG allocation error')
       return
     else
       write(mess,'(A,I6)') 'GDFBIG re-allocation ',iblock
       call gio_message(seve%d,rname,mess)
     endif
     mstbl = iblock
  endif
  gio_gdfbuf = 1
  !
end function gio_gdfbuf
!
function gdf_check_nvisi(is,mess)
  use gio_image
  !---------------------------------------------------------------------
  ! @ public
  ! Return value:
  !  = 0 if visibility axis exists and Nvisi is equal to this axis, or
  !      if visibility axis does not exist
  !  < 0 if visibility axis exists and Nvisi is valid (lower than this
  !      axis: 0<=Nvisi<axis. Note 0 is still valid).
  !  > 0 if visibility axis exists but Nvisi is invalid (greater than
  !      this axis, or negative)
  ! A message is also set describing this status. The caller can use it
  ! or ignore it.
  !---------------------------------------------------------------------
  integer(kind=4) :: gdf_check_nvisi
  integer(kind=4),  intent(in)  :: is    ! Image slot
  character(len=*), intent(out) :: mess  ! Message in return
  ! Local
  integer(kind=index_length) :: nvisi,vdim
  !
  select case (gheads(is)%gil%type_gdf)
  case (code_gdf_uvt)
    vdim = gheads(is)%gil%dim(2)
  case (code_gdf_tuv)
    vdim = gheads(is)%gil%dim(1)
  case default
    ! No visibility axis
    gdf_check_nvisi = 0
    return
  end select
  !
  ! This is a UV table
  nvisi = gheads(is)%gil%nvisi
  if (nvisi.eq.vdim) then
    gdf_check_nvisi = 0  ! => Valid, nothing to say
  elseif (nvisi.lt.0) then
    gdf_check_nvisi = 1  ! => Invalid
    write(mess,'(A,I0,A)')  &
      'Number of visibilities (',nvisi,') is lower than 0'
  elseif (nvisi.lt.vdim) then
    gdf_check_nvisi = -1  ! => Valid, with a message
    write(mess,'(A,I0,A,I0,A)')  &
      'Number of visibilities (',nvisi, &
      ') is lower than the visibility axis (',vdim,')'
  else  ! if (nvisi.gt.vdim) then
    gdf_check_nvisi = 1  ! => Invalid
    write(mess,'(A,I0,A,I0,A)')  &
      'Number of visibilities (',nvisi, &
      ') is greater than the visibility axis (',vdim,')'
  endif
  !
end function gdf_check_nvisi

*DECK FAC
      FUNCTION FAC (N)
C***BEGIN PROLOGUE  FAC
C***PURPOSE  Compute the factorial function.
C***LIBRARY   SLATEC (FNLIB)
C***CATEGORY  C1
C***TYPE      SINGLE PRECISION (FAC-S, DFAC-D)
C***KEYWORDS  FACTORIAL, FNLIB, SPECIAL FUNCTIONS
C***AUTHOR  Fullerton, W., (LANL)
C***DESCRIPTION
C
C FAC(N) evaluates the factorial function of N.  FAC is single
C precision.  N must be an integer between 0 and 25 inclusive.
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  GAMLIM, R9LGMC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   770601  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C***END PROLOGUE  FAC
      DIMENSION FACN(26)
      SAVE FACN, SQ2PIL, NMAX
      DATA FACN( 1) / 1.0E0 /
      DATA FACN( 2) / 1.0E0 /
      DATA FACN( 3) / 2.0E0 /
      DATA FACN( 4) / 6.0E0 /
      DATA FACN( 5) / 24.0E0 /
      DATA FACN( 6) / 120.0E0 /
      DATA FACN( 7) / 720.0E0 /
      DATA FACN( 8) / 5040.0E0 /
      DATA FACN( 9) / 40320.0E0 /
      DATA FACN(10) / 362880.0E0 /
      DATA FACN(11) / 3628800.0E0 /
      DATA FACN(12) / 39916800.0E0 /
      DATA FACN(13) / 479001600.0E0 /
      DATA FACN(14) / 6227020800.0E0 /
      DATA FACN(15) / 87178291200.0E0 /
      DATA FACN(16) / 1307674368000.0E0 /
      DATA FACN(17) / 20922789888000.0E0 /
      DATA FACN(18) / 355687428096000.0E0 /
      DATA FACN(19) / 6402373705728000.0E0 /
      DATA FACN(20) /  .12164510040883200E18 /
      DATA FACN(21) /  .24329020081766400E19 /
      DATA FACN(22) /  .51090942171709440E20 /
      DATA FACN(23) /  .11240007277776077E22 /
      DATA FACN(24) /  .25852016738884977E23 /
      DATA FACN(25) /  .62044840173323944E24 /
      DATA FACN(26) /  .15511210043330986E26 /
      DATA SQ2PIL / 0.9189385332 0467274E0/
      DATA NMAX / 0 /
C***FIRST EXECUTABLE STATEMENT  FAC
      IF (NMAX.NE.0) GO TO 10
      CALL GAMLIM (XMIN, XMAX)
      NMAX = XMAX - 1.
C
 10   IF (N .LT. 0) CALL XERMSG ('SLATEC', 'FAC',
     +   'FACTORIAL OF NEGATIVE INTEGER UNDEFINED', 1, 2)
C
      IF (N.LE.25) FAC = FACN(N+1)
      IF (N.LE.25) RETURN
C
      IF (N .GT. NMAX) CALL XERMSG ('SLATEC', 'FAC',
     +   'N SO BIG FACTORIAL(N) OVERFLOWS', 2, 2)
C
      X = N + 1
      FAC = EXP ( (X-0.5)*LOG(X) - X + SQ2PIL + R9LGMC(X) )
C
      RETURN
      END
*DECK FC
      SUBROUTINE FC (NDATA, XDATA, YDATA, SDDATA, NORD, NBKPT, BKPT,
     +   NCONST, XCONST, YCONST, NDERIV, MODE, COEFF, W, IW)
C***BEGIN PROLOGUE  FC
C***PURPOSE  Fit a piecewise polynomial curve to discrete data.
C            The piecewise polynomials are represented as B-splines.
C            The fitting is done in a weighted least squares sense.
C            Equality and inequality constraints can be imposed on the
C            fitted curve.
C***LIBRARY   SLATEC
C***CATEGORY  K1A1A1, K1A2A, L8A3
C***TYPE      SINGLE PRECISION (FC-S, DFC-D)
C***KEYWORDS  B-SPLINE, CONSTRAINED LEAST SQUARES, CURVE FITTING,
C             WEIGHTED LEAST SQUARES
C***AUTHOR  Hanson, R. J., (SNLA)
C***DESCRIPTION
C
C      This subprogram fits a piecewise polynomial curve
C      to discrete data.  The piecewise polynomials are
C      represented as B-splines.
C      The fitting is done in a weighted least squares sense.
C      Equality and inequality constraints can be imposed on the
C      fitted curve.
C
C      For a description of the B-splines and usage instructions to
C      evaluate them, see
C
C      C. W. de Boor, Package for Calculating with B-Splines.
C                     SIAM J. Numer. Anal., p. 441, (June, 1977).
C
C      For further documentation and discussion of constrained
C      curve fitting using B-splines, see
C
C      R. J. Hanson, Constrained Least Squares Curve Fitting
C                   to Discrete Data Using B-Splines, a User's
C                   Guide. Sandia Labs. Tech. Rept. SAND-78-1291,
C                   December, (1978).
C
C  Input..
C      NDATA,XDATA(*),
C      YDATA(*),
C      SDDATA(*)
C                         The NDATA discrete (X,Y) pairs and the Y value
C                         standard deviation or uncertainty, SD, are in
C                         the respective arrays XDATA(*), YDATA(*), and
C                         SDDATA(*).  No sorting of XDATA(*) is
C                         required.  Any non-negative value of NDATA is
C                         allowed.  A negative value of NDATA is an
C                         error.  A zero value for any entry of
C                         SDDATA(*) will weight that data point as 1.
C                         Otherwise the weight of that data point is
C                         the reciprocal of this entry.
C
C      NORD,NBKPT,
C      BKPT(*)
C                         The NBKPT knots of the B-spline of order NORD
C                         are in the array BKPT(*).  Normally the
C                         problem data interval will be included between
C                         the limits BKPT(NORD) and BKPT(NBKPT-NORD+1).
C                         The additional end knots BKPT(I),I=1,...,
C                         NORD-1 and I=NBKPT-NORD+2,...,NBKPT, are
C                         required to compute the functions used to fit
C                         the data.  No sorting of BKPT(*) is required.
C                         Internal to  FC( ) the extreme end knots may
C                         be reduced and increased respectively to
C                         accommodate any data values that are exterior
C                         to the given knot values.  The contents of
C                         BKPT(*) is not changed.
C
C                         NORD must be in the range 1 .LE. NORD .LE. 20.
C                         The value of NBKPT must satisfy the condition
C                         NBKPT .GE. 2*NORD.
C                         Other values are considered errors.
C
C                         (The order of the spline is one more than the
C                         degree of the piecewise polynomial defined on
C                         each interval.  This is consistent with the
C                         B-spline package convention.  For example,
C                         NORD=4 when we are using piecewise cubics.)
C
C      NCONST,XCONST(*),
C      YCONST(*),NDERIV(*)
C                         The number of conditions that constrain the
C                         B-spline is NCONST.  A constraint is specified
C                         by an (X,Y) pair in the arrays XCONST(*) and
C                         YCONST(*), and by the type of constraint and
C                         derivative value encoded in the array
C                         NDERIV(*).  No sorting of XCONST(*) is
C                         required.  The value of NDERIV(*) is
C                         determined as follows.  Suppose the I-th
C                         constraint applies to the J-th derivative
C                         of the B-spline.  (Any non-negative value of
C                         J < NORD is permitted.  In particular the
C                         value J=0 refers to the B-spline itself.)
C                         For this I-th constraint, set
C                          XCONST(I)=X,
C                          YCONST(I)=Y, and
C                          NDERIV(I)=ITYPE+4*J, where
C
C                          ITYPE = 0,      if (J-th deriv. at X) .LE. Y.
C                                = 1,      if (J-th deriv. at X) .GE. Y.
C                                = 2,      if (J-th deriv. at X) .EQ. Y.
C                                = 3,      if (J-th deriv. at X) .EQ.
C                                             (J-th deriv. at Y).
C                          (A value of NDERIV(I)=-1 will cause this
C                          constraint to be ignored.  This subprogram
C                          feature is often useful when temporarily
C                          suppressing a constraint while still
C                          retaining the source code of the calling
C                          program.)
C
C        MODE
C                         An input flag that directs the least squares
C                         solution method used by FC( ).
C
C                         The variance function, referred to below,
C                         defines the square of the probable error of
C                         the fitted curve at any point, XVAL.
C                         This feature of  FC( ) allows one to use the
C                         square root of this variance function to
C                         determine a probable error band around the
C                         fitted curve.
C
C                         =1  a new problem.  No variance function.
C
C                         =2  a new problem.  Want variance function.
C
C                         =3  an old problem.  No variance function.
C
C                         =4  an old problem.  Want variance function.
C
C                         Any value of MODE other than 1-4 is an error.
C
C                         The user with a new problem can skip directly
C                         to the description of the input parameters
C                         IW(1), IW(2).
C
C                         If the user correctly specifies the new or old
C                         problem status, the subprogram FC( ) will
C                         perform more efficiently.
C                         By an old problem it is meant that subprogram
C                         FC( ) was last called with this same set of
C                         knots, data points and weights.
C
C                         Another often useful deployment of this old
C                         problem designation can occur when one has
C                         previously obtained a Q-R orthogonal
C                         decomposition of the matrix resulting from
C                         B-spline fitting of data (without constraints)
C                         at the breakpoints BKPT(I), I=1,...,NBKPT.
C                         For example, this matrix could be the result
C                         of sequential accumulation of the least
C                         squares equations for a very large data set.
C                         The user writes this code in a manner
C                         convenient for the application.  For the
C                         discussion here let
C
C                                      N=NBKPT-NORD, and K=N+3
C
C                         Let us assume that an equivalent least squares
C                         system
C
C                                      RC=D
C
C                         has been obtained.  Here R is an N+1 by N
C                         matrix and D is a vector with N+1 components.
C                         The last row of R is zero.  The matrix R is
C                         upper triangular and banded.  At most NORD of
C                         the diagonals are nonzero.
C                         The contents of R and D can be copied to the
C                         working array W(*) as follows.
C
C                         The I-th diagonal of R, which has N-I+1
C                         elements, is copied to W(*) starting at
C
C                                      W((I-1)*K+1),
C
C                         for I=1,...,NORD.
C                         The vector D is copied to W(*) starting at
C
C                                      W(NORD*K+1)
C
C                         The input value used for NDATA is arbitrary
C                         when an old problem is designated.  Because
C                         of the feature of FC( ) that checks the
C                         working storage array lengths, a value not
C                         exceeding NBKPT should be used.  For example,
C                         use NDATA=0.
C
C                         (The constraints or variance function request
C                         can change in each call to FC( ).)  A new
C                         problem is anything other than an old problem.
C
C      IW(1),IW(2)
C                         The amounts of working storage actually
C                         allocated for the working arrays W(*) and
C                         IW(*).  These quantities are compared with the
C                         actual amounts of storage needed in FC( ).
C                         Insufficient storage allocated for either
C                         W(*) or IW(*) is an error.  This feature was
C                         included in FC( ) because misreading the
C                         storage formulas for W(*) and IW(*) might very
C                         well lead to subtle and hard-to-find
C                         programming bugs.
C
C                         The length of W(*) must be at least
C
C                           NB=(NBKPT-NORD+3)*(NORD+1)+
C                               2*MAX(NDATA,NBKPT)+NBKPT+NORD**2
C
C                         Whenever possible the code uses banded matrix
C                         processors BNDACC( ) and BNDSOL( ).  These
C                         are utilized if there are no constraints,
C                         no variance function is required, and there
C                         is sufficient data to uniquely determine the
C                         B-spline coefficients.  If the band processors
C                         cannot be used to determine the solution,
C                         then the constrained least squares code LSEI
C                         is used.  In this case the subprogram requires
C                         an additional block of storage in W(*).  For
C                         the discussion here define the integers NEQCON
C                         and NINCON respectively as the number of
C                         equality (ITYPE=2,3) and inequality
C                         (ITYPE=0,1) constraints imposed on the fitted
C                         curve.  Define
C
C                           L=NBKPT-NORD+1
C
C                         and note that
C
C                           NCONST=NEQCON+NINCON.
C
C                         When the subprogram FC( ) uses LSEI( ) the
C                         length of the working array W(*) must be at
C                         least
C
C                           LW=NB+(L+NCONST)*L+
C                              2*(NEQCON+L)+(NINCON+L)+(NINCON+2)*(L+6)
C
C                         The length of the array IW(*) must be at least
C
C                           IW1=NINCON+2*L
C
C                         in any case.
C
C  Output..
C      MODE
C                         An output flag that indicates the status
C                         of the constrained curve fit.
C
C                         =-1  a usage error of FC( ) occurred.  The
C                              offending condition is noted with the
C                              SLATEC library error processor, XERMSG.
C                              In case the working arrays W(*) or IW(*)
C                              are not long enough, the minimal
C                              acceptable length is printed.
C
C                         = 0  successful constrained curve fit.
C
C                         = 1  the requested equality constraints
C                              are contradictory.
C
C                         = 2  the requested inequality constraints
C                              are contradictory.
C
C                         = 3  both equality and inequality constraints
C                              are contradictory.
C
C      COEFF(*)
C                         If the output value of MODE=0 or 1, this array
C                         contains the unknowns obtained from the least
C                         squares fitting process.  These N=NBKPT-NORD
C                         parameters are the B-spline coefficients.
C                         For MODE=1, the equality constraints are
C                         contradictory.  To make the fitting process
C                         more robust, the equality constraints are
C                         satisfied in a least squares sense.  In this
C                         case the array COEFF(*) contains B-spline
C                         coefficients for this extended concept of a
C                         solution.  If MODE=-1,2 or 3 on output, the
C                         array COEFF(*) is undefined.
C
C  Working Arrays..
C      W(*),IW(*)
C                         These arrays are respectively typed REAL and
C                         INTEGER.
C                         Their required lengths are specified as input
C                         parameters in IW(1), IW(2) noted above.  The
C                         contents of W(*) must not be modified by the
C                         user if the variance function is desired.
C
C  Evaluating the
C  Variance Function..
C                         To evaluate the variance function (assuming
C                         that the uncertainties of the Y values were
C                         provided to  FC( ) and an input value of
C                         MODE=2 or 4 was used), use the function
C                         subprogram  CV( )
C
C                           VAR=CV(XVAL,NDATA,NCONST,NORD,NBKPT,
C                                  BKPT,W)
C
C                         Here XVAL is the point where the variance is
C                         desired.  The other arguments have the same
C                         meaning as in the usage of FC( ).
C
C                         For those users employing the old problem
C                         designation, let MDATA be the number of data
C                         points in the problem.  (This may be different
C                         from NDATA if the old problem designation
C                         feature was used.)  The value, VAR, should be
C                         multiplied by the quantity
C
C                         REAL(MAX(NDATA-N,1))/MAX(MDATA-N,1)
C
C                         The output of this subprogram is not defined
C                         if an input value of MODE=1 or 3 was used in
C                         FC( ) or if an output value of MODE=-1, 2, or
C                         3 was obtained.  The variance function, except
C                         for the scaling factor noted above, is given
C                         by
C
C                           VAR=(transpose of B(XVAL))*C*B(XVAL)
C
C                         The vector B(XVAL) is the B-spline basis
C                         function values at X=XVAL.
C                         The covariance matrix, C, of the solution
C                         coefficients accounts only for the least
C                         squares equations and the explicitly stated
C                         equality constraints.  This fact must be
C                         considered when interpreting the variance
C                         function from a data fitting problem that has
C                         inequality constraints on the fitted curve.
C
C  Evaluating the
C  Fitted Curve..
C                         To evaluate derivative number IDER at XVAL,
C                         use the function subprogram BVALU( ).
C
C                           F = BVALU(BKPT,COEFF,NBKPT-NORD,NORD,IDER,
C                                      XVAL,INBV,WORKB)
C
C                         The output of this subprogram will not be
C                         defined unless an output value of MODE=0 or 1
C                         was obtained from  FC( ), XVAL is in the data
C                         interval, and IDER is nonnegative and .LT.
C                         NORD.
C
C                         The first time BVALU( ) is called, INBV=1
C                         must be specified.  This value of INBV is the
C                         overwritten by BVALU( ).  The array WORKB(*)
C                         must be of length at least 3*NORD, and must
C                         not be the same as the W(*) array used in
C                         the call to FC( ).
C
C                         BVALU( ) expects the breakpoint array BKPT(*)
C                         to be sorted.
C
C***REFERENCES  R. J. Hanson, Constrained least squares curve fitting
C                 to discrete data using B-splines, a users guide,
C                 Report SAND78-1291, Sandia Laboratories, December
C                 1978.
C***ROUTINES CALLED  FCMN
C***REVISION HISTORY  (YYMMDD)
C   780801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900510  Convert references to XERRWV to references to XERMSG.  (RWC)
C   900607  Editorial changes to Prologue to make Prologues for EFC,
C           DEFC, FC, and DFC look as much the same as possible.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  FC
      REAL             BKPT(*), COEFF(*), SDDATA(*), W(*), XCONST(*),
     *   XDATA(*), YCONST(*), YDATA(*)
      INTEGER IW(*), MODE, NBKPT, NCONST, NDATA, NDERIV(*), NORD
C
      EXTERNAL FCMN
C
      INTEGER I1, I2, I3, I4, I5, I6, I7, MDG, MDW
C
C***FIRST EXECUTABLE STATEMENT  FC
      MDG = NBKPT - NORD + 3
      MDW = NBKPT - NORD + 1 + NCONST
C                         USAGE IN FCMN( ) OF W(*)..
C     I1,...,I2-1      G(*,*)
C
C     I2,...,I3-1      XTEMP(*)
C
C     I3,...,I4-1      PTEMP(*)
C
C     I4,...,I5-1      BKPT(*) (LOCAL TO FCMN( ))
C
C     I5,...,I6-1      BF(*,*)
C
C     I6,...,I7-1      W(*,*)
C
C     I7,...           WORK(*) FOR LSEI( )
C
      I1 = 1
      I2 = I1 + MDG*(NORD+1)
      I3 = I2 + MAX(NDATA,NBKPT)
      I4 = I3 + MAX(NDATA,NBKPT)
      I5 = I4 + NBKPT
      I6 = I5 + NORD*NORD
      I7 = I6 + MDW*(NBKPT-NORD+1)
      CALL  FCMN(NDATA, XDATA, YDATA, SDDATA, NORD, NBKPT, BKPT, NCONST,
     1   XCONST, YCONST, NDERIV, MODE, COEFF, W(I5), W(I2), W(I3),
     2   W(I4), W(I1), MDG, W(I6), MDW, W(I7), IW)
      RETURN
      END
*DECK FCMN
      SUBROUTINE FCMN (NDATA, XDATA, YDATA, SDDATA, NORD, NBKPT, BKPTIN,
     +   NCONST, XCONST, YCONST, NDERIV, MODE, COEFF, BF, XTEMP, PTEMP,
     +   BKPT, G, MDG, W, MDW, WORK, IWORK)
C***BEGIN PROLOGUE  FCMN
C***SUBSIDIARY
C***PURPOSE  Subsidiary to FC
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FCMN-S, DFCMN-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This is a companion subprogram to FC( ).
C     The documentation for FC( ) has complete usage instructions.
C
C***SEE ALSO  FC
C***ROUTINES CALLED  BNDACC, BNDSOL, BSPLVD, BSPLVN, LSEI, SAXPY, SCOPY,
C                    SSCAL, SSORT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   780801  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890618  Completely restructured and extensively revised (WRB & RWC)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C***END PROLOGUE  FCMN
      INTEGER IWORK(*), MDG, MDW, MODE, NBKPT, NCONST, NDATA, NDERIV(*),
     *   NORD
      REAL             BF(NORD,*), BKPT(*), BKPTIN(*), COEFF(*),
     *   G(MDG,*), PTEMP(*), SDDATA(*), W(MDW,*), WORK(*),
     *   XCONST(*), XDATA(*), XTEMP(*), YCONST(*), YDATA(*)
C
      EXTERNAL BNDACC, BNDSOL, BSPLVD, BSPLVN, LSEI, SAXPY, SCOPY,
     *    SSCAL, SSORT, XERMSG
C
      REAL             DUMMY, PRGOPT(10), RNORM, RNORME, RNORML, XMAX,
     *   XMIN, XVAL, YVAL
      INTEGER I, IDATA, IDERIV, ILEFT, INTRVL, INTW1, IP, IR, IROW,
     *   ITYPE, IW1, IW2, L, LW, MT, N, NB, NEQCON, NINCON, NORDM1,
     *   NORDP1, NP1
      LOGICAL BAND, NEW, VAR
      CHARACTER*8 XERN1
C
C***FIRST EXECUTABLE STATEMENT  FCMN
C
C     Analyze input.
C
      IF (NORD.LT.1 .OR. NORD.GT.20) THEN
         CALL XERMSG ('SLATEC', 'FCMN',
     +      'IN FC, THE ORDER OF THE B-SPLINE MUST BE 1 THRU 20.',
     +      2, 1)
         MODE = -1
         RETURN
C
      ELSEIF (NBKPT.LT.2*NORD) THEN
         CALL XERMSG ('SLATEC', 'FCMN',
     +      'IN FC, THE NUMBER OF KNOTS MUST BE AT LEAST TWICE ' //
     +      'THE B-SPLINE ORDER.', 2, 1)
         MODE = -1
         RETURN
      ENDIF
C
      IF (NDATA.LT.0) THEN
         CALL XERMSG ('SLATEC', 'FCMN',
     +      'IN FC, THE NUMBER OF DATA POINTS MUST BE NONNEGATIVE.',
     +      2, 1)
         MODE = -1
         RETURN
      ENDIF
C
C     Amount of storage allocated for W(*), IW(*).
C
      IW1 = IWORK(1)
      IW2 = IWORK(2)
      NB = (NBKPT-NORD+3)*(NORD+1) + 2*MAX(NDATA,NBKPT) + NBKPT +
     +     NORD**2
C
C     See if sufficient storage has been allocated.
C
      IF (IW1.LT.NB) THEN
         WRITE (XERN1, '(I8)') NB
         CALL XERMSG ('SLATEC', 'FCMN',
     *      'IN FC, INSUFFICIENT STORAGE FOR W(*).  CHECK NB = ' //
     *      XERN1, 2, 1)
         MODE = -1
         RETURN
      ENDIF
C
      IF (MODE.EQ.1) THEN
         BAND = .TRUE.
         VAR = .FALSE.
         NEW = .TRUE.
      ELSEIF (MODE.EQ.2) THEN
         BAND = .FALSE.
         VAR = .TRUE.
         NEW = .TRUE.
      ELSEIF (MODE.EQ.3) THEN
         BAND = .TRUE.
         VAR = .FALSE.
         NEW = .FALSE.
      ELSEIF (MODE.EQ.4) THEN
         BAND = .FALSE.
         VAR = .TRUE.
         NEW = .FALSE.
      ELSE
         CALL XERMSG ('SLATEC', 'FCMN',
     +      'IN FC, INPUT VALUE OF MODE MUST BE 1-4.', 2, 1)
         MODE = -1
         RETURN
      ENDIF
      MODE = 0
C
C     Sort the breakpoints.
C
      CALL SCOPY (NBKPT, BKPTIN, 1, BKPT, 1)
      CALL SSORT (BKPT, DUMMY, NBKPT, 1)
C
C     Initialize variables.
C
      NEQCON = 0
      NINCON = 0
      DO 100 I = 1,NCONST
         L = NDERIV(I)
         ITYPE = MOD(L,4)
         IF (ITYPE.LT.2) THEN
            NINCON = NINCON + 1
         ELSE
            NEQCON = NEQCON + 1
         ENDIF
  100 CONTINUE
C
C     Compute the number of variables.
C
      N = NBKPT - NORD
      NP1 = N + 1
      LW = NB + (NP1+NCONST)*NP1 + 2*(NEQCON+NP1) + (NINCON+NP1) +
     +     (NINCON+2)*(NP1+6)
      INTW1 = NINCON + 2*NP1
C
C     Save interval containing knots.
C
      XMIN = BKPT(NORD)
      XMAX = BKPT(NP1)
C
C     Find the smallest referenced independent variable value in any
C     constraint.
C
      DO 110 I = 1,NCONST
         XMIN = MIN(XMIN,XCONST(I))
         XMAX = MAX(XMAX,XCONST(I))
  110 CONTINUE
      NORDM1 = NORD - 1
      NORDP1 = NORD + 1
C
C     Define the option vector PRGOPT(1-10) for use in LSEI( ).
C
      PRGOPT(1) = 4
C
C     Set the covariance matrix computation flag.
C
      PRGOPT(2) = 1
      IF (VAR) THEN
         PRGOPT(3) = 1
      ELSE
         PRGOPT(3) = 0
      ENDIF
C
C     Increase the rank determination tolerances for both equality
C     constraint equations and least squares equations.
C
      PRGOPT(4) = 7
      PRGOPT(5) = 4
      PRGOPT(6) = 1.E-4
C
      PRGOPT(7) = 10
      PRGOPT(8) = 5
      PRGOPT(9) = 1.E-4
C
      PRGOPT(10) = 1
C
C     Turn off work array length checking in LSEI( ).
C
      IWORK(1) = 0
      IWORK(2) = 0
C
C     Initialize variables and analyze input.
C
      IF (NEW) THEN
C
C        To process least squares equations sort data and an array of
C        pointers.
C
         CALL SCOPY (NDATA, XDATA, 1, XTEMP, 1)
         DO 120 I = 1,NDATA
            PTEMP(I) = I
  120    CONTINUE
C
         IF (NDATA.GT.0) THEN
            CALL SSORT (XTEMP, PTEMP, NDATA, 2)
            XMIN = MIN(XMIN,XTEMP(1))
            XMAX = MAX(XMAX,XTEMP(NDATA))
         ENDIF
C
C        Fix breakpoint array if needed.
C
         DO 130 I = 1,NORD
            BKPT(I) = MIN(BKPT(I),XMIN)
  130    CONTINUE
C
         DO 140 I = NP1,NBKPT
            BKPT(I) = MAX(BKPT(I),XMAX)
  140    CONTINUE
C
C        Initialize parameters of banded matrix processor, BNDACC( ).
C
         MT = 0
         IP = 1
         IR = 1
         ILEFT = NORD
         DO 160 IDATA = 1,NDATA
C
C           Sorted indices are in PTEMP(*).
C
            L = PTEMP(IDATA)
            XVAL = XDATA(L)
C
C           When interval changes, process equations in the last block.
C
            IF (XVAL.GE.BKPT(ILEFT+1)) THEN
               CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
               MT = 0
C
C              Move pointer up to have BKPT(ILEFT).LE.XVAL,
C                 ILEFT.LT.NP1.
C
  150          IF (XVAL.GE.BKPT(ILEFT+1) .AND. ILEFT.LT.N) THEN
                  ILEFT = ILEFT + 1
                  GO TO 150
               ENDIF
            ENDIF
C
C           Obtain B-spline function value.
C
            CALL BSPLVN (BKPT, NORD, 1, XVAL, ILEFT, BF)
C
C           Move row into place.
C
            IROW = IR + MT
            MT = MT + 1
            CALL SCOPY (NORD, BF, 1, G(IROW,1), MDG)
            G(IROW,NORDP1) = YDATA(L)
C
C           Scale data if uncertainty is nonzero.
C
            IF (SDDATA(L).NE.0.E0) CALL SSCAL (NORDP1, 1.E0/SDDATA(L),
     +                                  G(IROW,1), MDG)
C
C           When staging work area is exhausted, process rows.
C
            IF (IROW.EQ.MDG-1) THEN
               CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
               MT = 0
            ENDIF
  160    CONTINUE
C
C        Process last block of equations.
C
         CALL BNDACC (G, MDG, NORD, IP, IR, MT, ILEFT-NORDM1)
C
C        Last call to adjust block positioning.
C
         CALL SCOPY (NORDP1, 0.E0, 0, G(IR,1), MDG)
         CALL BNDACC (G, MDG, NORD, IP, IR, 1, NP1)
      ENDIF
C
      BAND = BAND .AND. NCONST.EQ.0
      DO 170 I = 1,N
         BAND = BAND .AND. G(I,1).NE.0.E0
  170 CONTINUE
C
C     Process banded least squares equations.
C
      IF (BAND) THEN
         CALL BNDSOL (1, G, MDG, NORD, IP, IR, COEFF, N, RNORM)
         RETURN
      ENDIF
C
C     Check further for sufficient storage in working arrays.
C
      IF (IW1.LT.LW) THEN
         WRITE (XERN1, '(I8)') LW
         CALL XERMSG ('SLATEC', 'FCMN',
     *      'IN FC, INSUFFICIENT STORAGE FOR W(*).  CHECK LW = ' //
     *      XERN1, 2, 1)
         MODE = -1
         RETURN
      ENDIF
C
      IF (IW2.LT.INTW1) THEN
         WRITE (XERN1, '(I8)') INTW1
         CALL XERMSG ('SLATEC', 'FCMN',
     *      'IN FC, INSUFFICIENT STORAGE FOR IW(*).  CHECK IW1 = ' //
     *      XERN1, 2, 1)
         MODE = -1
         RETURN
      ENDIF
C
C     Write equality constraints.
C     Analyze constraint indicators for an equality constraint.
C
      NEQCON = 0
      DO 220 IDATA = 1,NCONST
         L = NDERIV(IDATA)
         ITYPE = MOD(L,4)
         IF (ITYPE.GT.1) THEN
            IDERIV = L/4
            NEQCON = NEQCON + 1
            ILEFT = NORD
            XVAL = XCONST(IDATA)
C
  180       IF (XVAL.LT.BKPT(ILEFT+1) .OR. ILEFT.GE.N) GO TO 190
            ILEFT = ILEFT + 1
            GO TO 180
C
  190       CALL BSPLVD (BKPT, NORD, XVAL, ILEFT, BF, IDERIV+1)
            CALL SCOPY (NP1, 0.E0, 0, W(NEQCON,1), MDW)
            CALL SCOPY (NORD, BF(1,IDERIV+1), 1, W(NEQCON,ILEFT-NORDM1),
     +                  MDW)
C
            IF (ITYPE.EQ.2) THEN
               W(NEQCON,NP1) = YCONST(IDATA)
            ELSE
               ILEFT = NORD
               YVAL = YCONST(IDATA)
C
  200          IF (YVAL.LT.BKPT(ILEFT+1) .OR. ILEFT.GE.N) GO TO 210
               ILEFT = ILEFT + 1
               GO TO 200
C
  210          CALL BSPLVD (BKPT, NORD, YVAL, ILEFT, BF, IDERIV+1)
               CALL SAXPY (NORD, -1.E0, BF(1, IDERIV+1), 1,
     +                     W(NEQCON, ILEFT-NORDM1), MDW)
            ENDIF
         ENDIF
  220 CONTINUE
C
C     Transfer least squares data.
C
      DO 230 I = 1,NP1
         IROW = I + NEQCON
         CALL SCOPY (N, 0.E0, 0, W(IROW,1), MDW)
         CALL SCOPY (MIN(NP1-I, NORD), G(I,1), MDG, W(IROW,I), MDW)
         W(IROW,NP1) = G(I,NORDP1)
  230 CONTINUE
C
C     Write inequality constraints.
C     Analyze constraint indicators for inequality constraints.
C
      NINCON = 0
      DO 260 IDATA = 1,NCONST
         L = NDERIV(IDATA)
         ITYPE = MOD(L,4)
         IF (ITYPE.LT.2) THEN
            IDERIV = L/4
            NINCON = NINCON + 1
            ILEFT = NORD
            XVAL = XCONST(IDATA)
C
  240       IF (XVAL.LT.BKPT(ILEFT+1) .OR. ILEFT.GE.N) GO TO 250
            ILEFT = ILEFT + 1
            GO TO 240
C
  250       CALL BSPLVD (BKPT, NORD, XVAL, ILEFT, BF, IDERIV+1)
            IROW = NEQCON + NP1 + NINCON
            CALL SCOPY (N, 0.E0, 0, W(IROW,1), MDW)
            INTRVL = ILEFT - NORDM1
            CALL SCOPY (NORD, BF(1, IDERIV+1), 1, W(IROW, INTRVL), MDW)
C
            IF (ITYPE.EQ.1) THEN
               W(IROW,NP1) = YCONST(IDATA)
            ELSE
               W(IROW,NP1) = -YCONST(IDATA)
               CALL SSCAL (NORD, -1.E0, W(IROW, INTRVL), MDW)
            ENDIF
         ENDIF
  260 CONTINUE
C
C     Solve constrained least squares equations.
C
      CALL LSEI(W, MDW, NEQCON, NP1, NINCON, N, PRGOPT, COEFF, RNORME,
     +          RNORML, MODE, WORK, IWORK)
      RETURN
      END
*DECK FDJAC1
      SUBROUTINE FDJAC1 (FCN, N, X, FVEC, FJAC, LDFJAC, IFLAG, ML, MU,
     +   EPSFCN, WA1, WA2)
C***BEGIN PROLOGUE  FDJAC1
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SNSQ and SNSQE
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FDJAC1-S, DFDJC1-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine computes a forward-difference approximation
C     to the N by N Jacobian matrix associated with a specified
C     problem of N functions in N VARIABLES. If the Jacobian has
C     a banded form, then function evaluations are saved by only
C     approximating the nonzero terms.
C
C     The subroutine statement is
C
C       SUBROUTINE FDJAC1(FCN,N,X,FVEC,FJAC,LDFJAC,IFLAG,ML,MU,EPSFCN,
C                         WA1,WA2)
C
C     where
C
C       FCN is the name of the user-supplied subroutine which
C         calculates the functions. FCN must be declared
C         in an external statement in the user calling
C         program, and should be written as follows.
C
C         SUBROUTINE FCN(N,X,FVEC,IFLAG)
C         INTEGER N,IFLAG
C         REAL X(N),FVEC(N)
C         ----------
C         Calculate the functions at X and
C         return this vector in FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless
C         the user wants to terminate execution of FDJAC1.
C         In this case set IFLAG to a negative integer.
C
C       N Is a positive integer input variable set to the number
C         of functions and variables.
C
C       X is an input array of length N.
C
C       FVEC is an input array of length N which must contain the
C         functions evaluated at X.
C
C       FJAC is an output N by N array which contains the
C         approximation to the Jacobian matrix evaluated at X.
C
C       LDFJAC is a positive integer input variable not less than N
C         which specifies the leading dimension of the array FJAC.
C
C       IFLAG is an integer variable which can be used to terminate
C         the execution of FDJAC1. See description of FCN.
C
C       ML is a nonnegative integer input variable which specifies
C         the number of subdiagonals within the band of the
C         Jacobian matrix. If the Jacobian is not banded, set
C         ML to at least N - 1.
C
C       EPSFCN is an input variable used in determining a suitable
C         step length for the forward-difference approximation. This
C         approximation assumes that the relative errors in the
C         functions are of the order of EPSFCN. If EPSFCN is less
C         than the machine precision, it is assumed that the relative
C         errors in the functions are of the order of the machine
C         precision.
C
C       MU is a nonnegative integer input variable which specifies
C         the number of superdiagonals within the band of the
C         Jacobian matrix. If the Jacobian is not banded, set
C         MU to at least N - 1.
C
C       WA1 and WA2 are work arrays of length N. If ML + MU + 1 is at
C         least N, then the Jacobian is considered dense, and WA2 is
C         not referenced.
C
C***SEE ALSO  SNSQ, SNSQE
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  FDJAC1
      INTEGER N,LDFJAC,IFLAG,ML,MU
      REAL EPSFCN
      REAL X(*),FVEC(*),FJAC(LDFJAC,*),WA1(*),WA2(*)
      INTEGER I,J,K,MSUM
      REAL EPS,EPSMCH,H,TEMP,ZERO
      REAL R1MACH
      SAVE ZERO
      DATA ZERO /0.0E0/
C***FIRST EXECUTABLE STATEMENT  FDJAC1
      EPSMCH = R1MACH(4)
C
      EPS = SQRT(MAX(EPSFCN,EPSMCH))
      MSUM = ML + MU + 1
      IF (MSUM .LT. N) GO TO 40
C
C        COMPUTATION OF DENSE APPROXIMATE JACOBIAN.
C
         DO 20 J = 1, N
            TEMP = X(J)
            H = EPS*ABS(TEMP)
            IF (H .EQ. ZERO) H = EPS
            X(J) = TEMP + H
            CALL FCN(N,X,WA1,IFLAG)
            IF (IFLAG .LT. 0) GO TO 30
            X(J) = TEMP
            DO 10 I = 1, N
               FJAC(I,J) = (WA1(I) - FVEC(I))/H
   10          CONTINUE
   20       CONTINUE
   30    CONTINUE
         GO TO 110
   40 CONTINUE
C
C        COMPUTATION OF BANDED APPROXIMATE JACOBIAN.
C
         DO 90 K = 1, MSUM
            DO 60 J = K, N, MSUM
               WA2(J) = X(J)
               H = EPS*ABS(WA2(J))
               IF (H .EQ. ZERO) H = EPS
               X(J) = WA2(J) + H
   60          CONTINUE
            CALL FCN(N,X,WA1,IFLAG)
            IF (IFLAG .LT. 0) GO TO 100
            DO 80 J = K, N, MSUM
               X(J) = WA2(J)
               H = EPS*ABS(WA2(J))
               IF (H .EQ. ZERO) H = EPS
               DO 70 I = 1, N
                  FJAC(I,J) = ZERO
                  IF (I .GE. J - MU .AND. I .LE. J + ML)
     1               FJAC(I,J) = (WA1(I) - FVEC(I))/H
   70             CONTINUE
   80          CONTINUE
   90       CONTINUE
  100    CONTINUE
  110 CONTINUE
      RETURN
C
C     LAST CARD OF SUBROUTINE FDJAC1.
C
      END
*DECK FDJAC3
      SUBROUTINE FDJAC3 (FCN, M, N, X, FVEC, FJAC, LDFJAC, IFLAG,
     +   EPSFCN, WA)
C***BEGIN PROLOGUE  FDJAC3
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SNLS1 and SNLS1E
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FDJAC3-S, DFDJC3-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     This subroutine computes a forward-difference approximation
C     to the M by N Jacobian matrix associated with a specified
C     problem of M functions in N variables.
C
C     The subroutine statement is
C
C       SUBROUTINE FDJAC3(FCN,M,N,X,FVEC,FJAC,LDFJAC,IFLAG,EPSFCN,WA)
C
C     where
C
C       FCN is the name of the user-supplied subroutine which
C         calculates the functions. FCN must be declared
C         in an external statement in the user calling
C         program, and should be written as follows.
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER LDFJAC,M,N,IFLAG
C         REAL X(N),FVEC(M),FJAC(LDFJAC,N)
C         ----------
C         When IFLAG.EQ.1 calculate the functions at X and
C         return this vector in FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless
C         the user wants to terminate execution of FDJAC3.
C         In this case set IFLAG to a negative integer.
C
C       M is a positive integer input variable set to the number
C         of functions.
C
C       N is a positive integer input variable set to the number
C         of variables. N must not exceed M.
C
C       X is an input array of length N.
C
C       FVEC is an input array of length M which must contain the
C         functions evaluated at X.
C
C       FJAC is an output M by N array which contains the
C         approximation to the Jacobian matrix evaluated at X.
C
C       LDFJAC is a positive integer input variable not less than M
C         which specifies the leading dimension of the array FJAC.
C
C       IFLAG is an integer variable which can be used to terminate
C         THE EXECUTION OF FDJAC3. See description of FCN.
C
C       EPSFCN is an input variable used in determining a suitable
C         step length for the forward-difference approximation. This
C         approximation assumes that the relative errors in the
C         functions are of the order of EPSFCN. If EPSFCN is less
C         than the machine precision, it is assumed that the relative
C         errors in the functions are of the order of the machine
C         precision.
C
C       WA is a work array of length M.
C
C***SEE ALSO  SNLS1, SNLS1E
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Removed duplicate information from DESCRIPTION section.
C           (WRB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  FDJAC3
      INTEGER M,N,LDFJAC,IFLAG
      REAL EPSFCN
      REAL X(*),FVEC(*),FJAC(LDFJAC,*),WA(*)
      INTEGER I,J
      REAL EPS,EPSMCH,H,TEMP,ZERO
      REAL R1MACH
      SAVE ZERO
      DATA ZERO /0.0E0/
C***FIRST EXECUTABLE STATEMENT  FDJAC3
      EPSMCH = R1MACH(4)
C
      EPS = SQRT(MAX(EPSFCN,EPSMCH))
C      SET IFLAG=1 TO INDICATE THAT FUNCTION VALUES
C           ARE TO BE RETURNED BY FCN.
      IFLAG = 1
      DO 20 J = 1, N
         TEMP = X(J)
         H = EPS*ABS(TEMP)
         IF (H .EQ. ZERO) H = EPS
         X(J) = TEMP + H
         CALL FCN(IFLAG,M,N,X,WA,FJAC,LDFJAC)
         IF (IFLAG .LT. 0) GO TO 30
         X(J) = TEMP
         DO 10 I = 1, M
            FJAC(I,J) = (WA(I) - FVEC(I))/H
   10       CONTINUE
   20    CONTINUE
   30 CONTINUE
      RETURN
C
C     LAST CARD OF SUBROUTINE FDJAC3.
C
      END
*DECK FDUMP
      SUBROUTINE FDUMP
C***BEGIN PROLOGUE  FDUMP
C***PURPOSE  Symbolic dump (should be locally written).
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3
C***TYPE      ALL (FDUMP-A)
C***KEYWORDS  ERROR, XERMSG
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C        ***Note*** Machine Dependent Routine
C        FDUMP is intended to be replaced by a locally written
C        version which produces a symbolic dump.  Failing this,
C        it should be replaced by a version which prints the
C        subprogram nesting list.  Note that this dump must be
C        printed on each of up to five files, as indicated by the
C        XGETUA routine.  See XSETUA and XGETUA for details.
C
C     Written by Ron Jones, with SLATEC Common Math Library Subcommittee
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C***END PROLOGUE  FDUMP
C***FIRST EXECUTABLE STATEMENT  FDUMP
      RETURN
      END
*DECK FFTDOC
      SUBROUTINE FFTDOC
C***BEGIN PROLOGUE  FFTDOC
C***PURPOSE  Documentation for FFTPACK, a collection of Fast Fourier
C            Transform routines.
C***LIBRARY   SLATEC
C***CATEGORY  J1, Z
C***TYPE      ALL (FFTDOC-A)
C***KEYWORDS  DOCUMENTATION, FAST FOURIER TRANSFORM, FFT
C***AUTHOR  Swarztrauber, P. N., (NCAR)
C***DESCRIPTION
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C                       Version 3  June 1979
C
C          A Package of Fortran Subprograms for The Fast Fourier
C           Transform of Periodic and Other Symmetric Sequences
C                              By
C                       Paul N Swarztrauber
C
C    National Center For Atmospheric Research, Boulder, Colorado 80307
C        which is sponsored by the National Science Foundation
C
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C
C     This package consists of programs which perform Fast Fourier
C     Transforms for both complex and real periodic sequences and
C     certain other symmetric sequences that are listed below.
C
C     1.   RFFTI     Initialize RFFTF and RFFTB
C     2.   RFFTF     Forward transform of a real periodic sequence
C     3.   RFFTB     Backward transform of a real coefficient array
C
C     4.   EZFFTI    Initialize EZFFTF and EZFFTB
C     5.   EZFFTF    A simplified real periodic forward transform
C     6.   EZFFTB    A simplified real periodic backward transform
C
C     7.   SINTI     Initialize SINT
C     8.   SINT      Sine transform of a real odd sequence
C
C     9.   COSTI     Initialize COST
C     10.  COST      Cosine transform of a real even sequence
C
C     11.  SINQI     Initialize SINQF and SINQB
C     12.  SINQF     Forward sine transform with odd wave numbers
C     13.  SINQB     Unnormalized inverse of SINQF
C
C     14.  COSQI     Initialize COSQF and COSQB
C     15.  COSQF     Forward cosine transform with odd wave numbers
C     16.  COSQB     Unnormalized inverse of COSQF
C
C     17.  CFFTI     Initialize CFFTF and CFFTB
C     18.  CFFTF     Forward transform of a complex periodic sequence
C     19.  CFFTB     Unnormalized inverse of CFFTF
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   780201  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900723  PURPOSE section revised.  (WRB)
C***END PROLOGUE  FFTDOC
C***FIRST EXECUTABLE STATEMENT  FFTDOC
       RETURN
      END
*DECK FIGI
      SUBROUTINE FIGI (NM, N, T, D, E, E2, IERR)
C***BEGIN PROLOGUE  FIGI
C***PURPOSE  Transforms certain real non-symmetric tridiagonal matrix
C            to symmetric tridiagonal matrix.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1C
C***TYPE      SINGLE PRECISION (FIGI-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     Given a NONSYMMETRIC TRIDIAGONAL matrix such that the products
C     of corresponding pairs of off-diagonal elements are all
C     non-negative, this subroutine reduces it to a symmetric
C     tridiagonal matrix with the same eigenvalues.  If, further,
C     a zero product only occurs when both factors are zero,
C     the reduced matrix is similar to the original matrix.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameter, T, as declared in the calling program
C          dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix T.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        T contains the nonsymmetric matrix.  Its subdiagonal is
C          stored in the last N-1 positions of the first column,
C          its diagonal in the N positions of the second column,
C          and its superdiagonal in the first N-1 positions of
C          the third column.  T(1,1) and T(N,3) are arbitrary.
C          T is a two-dimensional REAL array, dimensioned T(NM,3).
C
C     On OUTPUT
C
C        T is unaltered.
C
C        D contains the diagonal elements of the tridiagonal symmetric
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the tridiagonal
C          symmetric matrix in its last N-1 positions.  E(1) is not set.
C          E is a one-dimensional REAL array, dimensioned E(N).
C
C        E2 contains the squares of the corresponding elements of E.
C          E2 may coincide with E if the squares are not needed.
C          E2 is a one-dimensional REAL array, dimensioned E2(N).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          N+I        if T(I,1)*T(I-1,3) is negative and a symmetric
C                     matrix cannot be produced with FIGI,
C          -(3*N+I)   if T(I,1)*T(I-1,3) is zero with one factor
C                     non-zero.  In this case, the eigenvectors of
C                     the symmetric matrix are not simply related
C                     to those of  T  and should not be sought.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  FIGI
C
      INTEGER I,N,NM,IERR
      REAL T(NM,3),D(*),E(*),E2(*)
C
C***FIRST EXECUTABLE STATEMENT  FIGI
      IERR = 0
C
      DO 100 I = 1, N
         IF (I .EQ. 1) GO TO 90
         E2(I) = T(I,1) * T(I-1,3)
         IF (E2(I)) 1000, 60, 80
   60    IF (T(I,1) .EQ. 0.0E0 .AND. T(I-1,3) .EQ. 0.0E0) GO TO 80
C     .......... SET ERROR -- PRODUCT OF SOME PAIR OF OFF-DIAGONAL
C                ELEMENTS IS ZERO WITH ONE MEMBER NON-ZERO ..........
         IERR = -(3 * N + I)
   80    E(I) = SQRT(E2(I))
   90    D(I) = T(I,2)
  100 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- PRODUCT OF SOME PAIR OF OFF-DIAGONAL
C                ELEMENTS IS NEGATIVE ..........
 1000 IERR = N + I
 1001 RETURN
      END
*DECK FIGI2
      SUBROUTINE FIGI2 (NM, N, T, D, E, Z, IERR)
C***BEGIN PROLOGUE  FIGI2
C***PURPOSE  Transforms certain real non-symmetric tridiagonal matrix
C            to symmetric tridiagonal matrix.
C***LIBRARY   SLATEC (EISPACK)
C***CATEGORY  D4C1C
C***TYPE      SINGLE PRECISION (FIGI2-S)
C***KEYWORDS  EIGENVALUES, EIGENVECTORS, EISPACK
C***AUTHOR  Smith, B. T., et al.
C***DESCRIPTION
C
C     Given a NONSYMMETRIC TRIDIAGONAL matrix such that the products
C     of corresponding pairs of off-diagonal elements are all
C     non-negative, and zero only when both factors are zero, this
C     subroutine reduces it to a SYMMETRIC TRIDIAGONAL matrix
C     using and accumulating diagonal similarity transformations.
C
C     On INPUT
C
C        NM must be set to the row dimension of the two-dimensional
C          array parameters, T and Z, as declared in the calling
C          program dimension statement.  NM is an INTEGER variable.
C
C        N is the order of the matrix T.  N is an INTEGER variable.
C          N must be less than or equal to NM.
C
C        T contains the nonsymmetric matrix.  Its subdiagonal is
C          stored in the last N-1 positions of the first column,
C          its diagonal in the N positions of the second column,
C          and its superdiagonal in the first N-1 positions of
C          the third column.  T(1,1) and T(N,3) are arbitrary.
C          T is a two-dimensional REAL array, dimensioned T(NM,3).
C
C     On OUTPUT
C
C        T is unaltered.
C
C        D contains the diagonal elements of the tridiagonal symmetric
C          matrix.  D is a one-dimensional REAL array, dimensioned D(N).
C
C        E contains the subdiagonal elements of the tridiagonal
C          symmetric matrix in its last N-1 positions.  E(1) is not set.
C          E is a one-dimensional REAL array, dimensioned E(N).
C
C        Z contains the diagonal transformation matrix produced in the
C          symmetrization.  Z is a two-dimensional REAL array,
C          dimensioned Z(NM,N).
C
C        IERR is an INTEGER flag set to
C          Zero       for normal return,
C          N+I        if T(I,1)*T(I-1,3) is negative,
C          2*N+I      if T(I,1)*T(I-1,3) is zero with one factor
C                     non-zero.  In these cases, there does not exist
C                     a symmetrizing similarity transformation which
C                     is essential for the validity of the later
C                     eigenvector computation.
C
C     Questions and comments should be directed to B. S. Garbow,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C     ------------------------------------------------------------------
C
C***REFERENCES  B. T. Smith, J. M. Boyle, J. J. Dongarra, B. S. Garbow,
C                 Y. Ikebe, V. C. Klema and C. B. Moler, Matrix Eigen-
C                 system Routines - EISPACK Guide, Springer-Verlag,
C                 1976.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   760101  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  FIGI2
C
      INTEGER I,J,N,NM,IERR
      REAL T(NM,3),D(*),E(*),Z(NM,*)
      REAL H
C
C***FIRST EXECUTABLE STATEMENT  FIGI2
      IERR = 0
C
      DO 100 I = 1, N
C
         DO 50 J = 1, N
   50    Z(I,J) = 0.0E0
C
         IF (I .EQ. 1) GO TO 70
         H = T(I,1) * T(I-1,3)
         IF (H) 900, 60, 80
   60    IF (T(I,1) .NE. 0.0E0 .OR. T(I-1,3) .NE. 0.0E0) GO TO 1000
         E(I) = 0.0E0
   70    Z(I,I) = 1.0E0
         GO TO 90
   80    E(I) = SQRT(H)
         Z(I,I) = Z(I-1,I-1) * E(I) / T(I-1,3)
   90    D(I) = T(I,2)
  100 CONTINUE
C
      GO TO 1001
C     .......... SET ERROR -- PRODUCT OF SOME PAIR OF OFF-DIAGONAL
C                ELEMENTS IS NEGATIVE ..........
  900 IERR = N + I
      GO TO 1001
C     .......... SET ERROR -- PRODUCT OF SOME PAIR OF OFF-DIAGONAL
C                ELEMENTS IS ZERO WITH ONE MEMBER NON-ZERO ..........
 1000 IERR = 2 * N + I
 1001 RETURN
      END
*DECK FULMAT
      SUBROUTINE FULMAT (I, J, AIJ, INDCAT, PRGOPT, DATTRV, IFLAG)
C***BEGIN PROLOGUE  FULMAT
C***SUBSIDIARY
C***PURPOSE  Subsidiary to SPLP
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (FULMAT-S, DFULMT-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C     DECODES A STANDARD TWO-DIMENSIONAL FORTRAN ARRAY PASSED
C     IN THE ARRAY DATTRV(IA,*).  THE ROW DIMENSION IA AND THE
C     MATRIX DIMENSIONS MRELAS AND NVARS MUST SIMULTANEOUSLY BE
C     PASSED USING THE OPTION ARRAY, PRGOPT(*).  IT IS AN ERROR
C     IF THIS DATA IS NOT PASSED TO FULMAT( ).
C     EXAMPLE-- (FOR USE TOGETHER WITH SPLP().)
C      EXTERNAL USRMAT
C      DIMENSION DATTRV(IA,*)
C      PRGOPT(01)=7
C      PRGOPT(02)=68
C      PRGOPT(03)=1
C      PRGOPT(04)=IA
C      PRGOPT(05)=MRELAS
C      PRGOPT(06)=NVARS
C      PRGOPT(07)=1
C     CALL SPLP(  ... FULMAT INSTEAD OF USRMAT...)
C
C***SEE ALSO  SPLP
C***ROUTINES CALLED  XERMSG
C***REVISION HISTORY  (YYMMDD)
C   811215  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  FULMAT
      REAL            AIJ,ZERO,DATTRV(*),PRGOPT(*)
      INTEGER IFLAG(10)
      SAVE ZERO
C***FIRST EXECUTABLE STATEMENT  FULMAT
      IF (.NOT.(IFLAG(1).EQ.1)) GO TO 50
C     INITIALIZE POINTERS TO PROCESS FULL TWO-DIMENSIONAL FORTRAN
C     ARRAYS.
      ZERO = 0.
      LP = 1
   10 NEXT = PRGOPT(LP)
      IF (.NOT.(NEXT.LE.1)) GO TO 20
      NERR = 29
      LEVEL = 1
      CALL XERMSG ('SLATEC', 'FULMAT',
     +   'IN SPLP PACKAGE, ROW DIM., MRELAS, NVARS ARE MISSING FROM ' //
     +   'PRGOPT.', NERR, LEVEL)
      IFLAG(1) = 3
      GO TO 110
   20 KEY = PRGOPT(LP+1)
      IF (.NOT.(KEY.NE.68)) GO TO 30
      LP = NEXT
      GO TO 10
   30 IF (.NOT.(PRGOPT(LP+2).EQ.ZERO)) GO TO 40
      LP = NEXT
      GO TO 10
   40 IFLAG(2) = 1
      IFLAG(3) = 1
      IFLAG(4) = PRGOPT(LP+3)
      IFLAG(5) = PRGOPT(LP+4)
      IFLAG(6) = PRGOPT(LP+5)
      GO TO 110
   50 IF (.NOT.(IFLAG(1).EQ.2)) GO TO 100
   60 I = IFLAG(2)
      J = IFLAG(3)
      IF (.NOT.(J.GT.IFLAG(6))) GO TO 70
      IFLAG(1) = 3
      GO TO 110
   70 IF (.NOT.(I.GT.IFLAG(5))) GO TO 80
      IFLAG(2) = 1
      IFLAG(3) = J + 1
      GO TO 60
   80 AIJ = DATTRV(IFLAG(4)*(J-1)+I)
      IFLAG(2) = I + 1
      IF (.NOT.(AIJ.EQ.ZERO)) GO TO 90
      GO TO 60
   90 INDCAT = 0
      GO TO 110
  100 CONTINUE
  110 RETURN
      END
*DECK FUNDOC
      SUBROUTINE FUNDOC
C***BEGIN PROLOGUE  FUNDOC
C***PURPOSE  Documentation for FNLIB, a collection of routines for
C            evaluating elementary and special functions.
C***LIBRARY   SLATEC
C***CATEGORY  C, Z
C***TYPE      ALL (FUNDOC-A)
C***KEYWORDS  DOCUMENTATION, ELEMENTARY FUNCTIONS, SPECIAL FUNCTIONS
C***AUTHOR  Kahaner, D. K., (NBS)
C***DESCRIPTION
C
C The SLATEC Library --  Elementary And Special Functions
C
C This describes the elementary and special function routines available
C in the SLATEC library.  Most of the these routines were written by
C Wayne Fullerton while at LANL.  Some were written by Don Amos of SNLA.
C There are approximately 63 single precision, 63 double precision and
C 25 complex user callable elementary and special function routines.
C
C The table below gives a breakdown of routines according to their
C function.  Unless otherwise indicated all routines are function
C subprograms.
C                                             Sngl.      Dble.
C Description              Notation           Prec.      Prec.   Complex
C
C         ***Intrinsic Functions and Fundamental Functions***
C Unpack floating point              Call R9UPAK(X,Y,N)  D9UPAK    --
C  number
C Pack floating point                        R9PAK(Y,N)  D9PAK     --
C  number
C Initialize orthogonal               INITS(OS,NOS,ETA)  INITDS    --
C  polynomial series
C Evaluate Chebyshev       summation for  CSEVL(X,CS,N)  DCSEVL    --
C series                  i = 1 to n of
C                          cs(i)*(2*x)**(i-1)
C
C                  ***Elementary Functions***
C Argument = theta in      z = \ z \ *          --         --    CARG(Z)
C  radians                 e**(i * theta)
C Cube root                                   CBRT(X)    DCBRT   CCBRT
C Relative error exponen-  ((e**x) -1) / x    EXPREL(X)  DEXPRL  CEXPRL
C  tial from first order
C Common logarithm         log to the base 10   --         --  CLOG10(Z)
C                          of z
C Relative error logarithm ln(1 + x)          ALNREL(X)  DLNREL  CLNREL
C Relative error logarithm (ln(1 + x) - x     R9LN2R(X)  D9LN2R  C9LN2R
C from second order        + x**2/2) / x**3
C               ***Trigonometric and Hyperbolic Functions***
C Tangent                  tan z                --         --    CTAN(Z)
C Cotangent                cot x              COT(X)     DCOT    CCOT
C Sine x in degrees        sin((2*pi*x)/360)  SINDG(X)   DSINDG    --
C Cosine x in degrees      cos((2*pi*x)/360)  COSDG(X)   DCOSDG    --
C Arc sine                 arcsin (z)           --         --   CASIN(Z)
C Arc cosine               arccos (z)           --         --   CACOS(Z)
C Arc tangent              arctan (z)           --         --   CATAN(Z)
C Quadrant correct         arctan (z1/z2)       --         -- CATAN2(Z1,
C  arc tangent                                                       Z2)
C Hyperbolic sine          sinh z               --         --   CSINH(Z)
C Hyperbolic cosine        cosh z               --         --   CCOSH(Z)
C Hyperbolic tangent       tanh z               --         --   CTANH(Z)
C Arc hyperbolic sine      arcsinh (x)        ASINH(X)   DASINH  CASINH
C Arc hyperbolic cosine    arccosh (x)        ACOSH(X)   DACOSH  CACOSH
C Arc hyperbolic tangent   arctanh (x)        ATANH(X)   DATANH  CATANH
C Relative error arc       (arctan (x) - x)   R9ATN1(X)  D9ATN1    --
C  tangent from first order   / x**3
C              ***Exponential Integrals and Related Functions***
C Exponential integral     Ei(x) = (minus)    EI(X)      DEI       --
C                          the integral from
C                          -x to infinity of
C                            (e**-t / t)dt
C Exponential integral     E sub 1 (x) =      E1(X)      DE1       --
C                          the integral from x
C                            to infinity of
C                          (e**-t / t) dt
C Logarithmic integral     li(x) = the        ALI(X)     DLI       --
C                          integral from 0 to
C                          x of (1 / ln t) dt
C   Sequences of exponential integrals.
C   M values are computed where
C   k=0,1,...M-1 and n>=1
C Exponential integral     E sub n+k (x) Call EXINT(X,   DEXINT    --
C                        =the integral from   N,KODE,M,TOL,
C                         1 to infinity of    EN,IERR)
C                       (e**(-x*t)/t**(n+k))dt
C                 ***Gamma Functions and Related Functions***
C Factorial                n!                 FAC(N)     DFAC      --
C Binomial                 n!/(m!*(n-m)!)     BINOM(N,M) DBINOM    --
C Gamma                    gamma(x)           GAMMA(X)   DGAMMA  CGAMMA
C Gamma(x) under and                     Call GAMLIM(    DGAMLM    --
C  overflow limits                           XMIN,XMAX)
C Reciprocal gamma         1 / gamma(x)       GAMR(X)    DGAMR   CGAMR
C Log abs gamma            ln \gamma(x)\      ALNGAM(X)  DLNGAM    --
C Log gamma                ln gamma(z)          --         --    CLNGAM
C Log abs gamma       g = ln \gamma(x)\  Call ALGAMS(X,  DLGAMS    --
C with sign           s = sign gamma(x)      G,S)
C Incomplete gamma         gamma(a,x) =       GAMI(A,X)  DGAMI     --
C                          the integral from
C                          0 to x of
C                         (t**(a-1) * e**-t)dt
C Complementary            gamma(a,x) =       GAMIC(A,X) DGAMIC    --
C  incomplete gamma        the integral from
C                          x to infinity of
C                         (t**(a-1) * e**-t)dt
C Tricomi's             gamma super star(a,x) GAMIT(A,X) DGAMIT    --
C  incomplete gamma        = x**-a *
C                         incomplete gamma(a,x)
C                          / gamma(a)
C Psi (Digamma)            psi(x) = gamma'(x) PSI(X)     DPSI    CPSI
C                          / gamma(x)
C Pochhammer's         (a) sub x = gamma(a+x) POCH(A,X)  DPOCH     --
C  generalized symbol      / gamma(a)
C Pochhammer's symbol    ((a) sub x -1) / x   POCH1(A,X) DPOCH1    --
C  from first order
C Beta                     b(a,b) = (gamma(a) BETA(A,B)  DBETA   CBETA
C                          * gamma(b))
C                          / gamma(a+b)
C                           = the integral
C                           from 0 to 1 of
C                           (t**(a-1) *
C                           (1-t)**(b-1))dt
C Log beta                 ln b(a,b)         ALBETA(A,B) DLBETA  CLBETA
C Incomplete beta          i sub x (a,b) =  BETAI(X,A,B) DBETAI    __
C                          b sub x (a,b) / b(a,b)
C                           = 1 / b(a,b) *
C                          the integral
C                          from 0 to x of
C                          (t**(a-1) *
C                          (1-t)**(b-1))dt
C Log gamma correction     ln gamma(x) -      R9LGMC(X)  D9LGMC  C9LGMC
C  term when Stirling's    (ln(2 * pi))/2 -
C  approximation is valid  (x - 1/2) * ln(x) + x
C                ***Error Functions and Fresnel Integrals***
C Error function           erf x = (2 /       ERF(X)     DERF      --
C                          square root of pi) *
C                          the integral from
C                          0 to x of
C                          e**(-t**2)dt
C Complementary            erfc x = (2 /      ERFC(X)    DERFC     --
C  error function          square root of pi) *
C                          the integral from
C                          x to infinity of
C                          e**(-t**2)dt
C Dawson's function        F(x) = e**(-x**2)  DAWS(X)    DDAWS     --
C                          * the integral from
C                          from 0 to x of
C                          e**(t**2)dt
C                         ***Bessel Functions***
C   Bessel functions of special integer order
C First kind, order zero   J sub 0 (x)        BESJ0(X)   DBESJ0    --
C First kind, order one    J sub 1 (x)        BESJ1(X)   DBESJ1    --
C Second kind, order zero  Y sub 0 (x)        BESY0(X)   DBESY0    --
C Second kind, order one   Y sub 1 (x)        BESY1(X)   DBESY1    --
C   Modified (hyperbolic) Bessel functions of special integer order
C First kind, order zero   I sub 0 (x)        BESI0(X)   DBESI0    --
C First kind, order one    I sub 1 (x)        BESI1(X)   DBESI1    --
C Third kind, order zero   K sub 0 (x)        BESK0(X)   DBESK0    --
C Third kind, order one    K sub 1 (x)        BESK1(X)   DBESK1    --
C   Modified (hyperbolic) Bessel functions of special integer order
C   scaled by an exponential
C First kind, order zero   e**-\x\ * I sub 0(x) BESI0E(X) DBSI0E   --
C First kind, order one    e**-\x\ * I sub 1(x) BESI1E(X) DBSI1E   --
C Third kind, order zero   e**x * K sub 0 (x)   BESK0E(X) DBSK0E   --
C Third kind, order one    e**x * K sub 1 (x)   BESK1E(X) DBSK1E   --
C   Sequences of Bessel functions of general order.
C   N values are computed where  k = 1,2,...N and v .ge. 0.
C Modified first kind      I sub v+k-1 (x) Call BESI(X,   DBESI    --
C                          optional scaling  ALPHA,KODE,N,
C                          by e**(-x)        Y,NZ)
C First kind               J sub v+k-1 (x) Call BESJ(X,   DBESJ    --
C                                            ALPHA,N,Y,NZ)
C Second kind              Y sub v+k-1 (x) Call BESY(X,   DBESY    --
C                                            FNU,N,Y)
C Modified third kind      K sub v+k-1 (x) Call BESK(X,   DBESK    --
C                          optional scaling  FNU,KODE,N,Y,
C                          by e**(x)         NZ)
C   Sequences of Bessel functions.  \N\ values are computed where
C   I = 0, 1, 2, ..., N-1  for N > 0  or I = 0, -1, -2, ..., N+1
C   for N < 0.
C Modified third kind      K sub v+i (x)   Call BESKS(    DBESKS   --
C                                           XNU,X,N,BK)
C   Sequences of Bessel functions scaled by an exponential.
C   \N\ values are computed where  I = 0, 1, 2, ..., N-1
C   for N > 0  or  I = 0, -1, -2, ..., N+1  for N < 0.
C Modified third kind      e**x *         Call BESKES(    DBSKES   --
C                          K sub v+i (x)     XNU,X,N,BK)
C                ***Bessel Functions of Fractional Order***
C   Airy functions
C Airy                     Ai(x)              AI(X)      DAI       --
C Bairy                    Bi(x)              BI(X)      DBI       --
C   Exponentially scaled Airy functions
C Airy                     Ai(x), x <= 0      AIE(X)     DAIE      --
C                          exp(2/3 * x**(3/2))
C                          * Ai(x), x >= 0
C Bairy                    Bi(x), x <= 0      BIE(X)     DBIE      --
C                          exp(-2/3 * x**(3/2))
C                          * Bi(x), x >= 0
C                 ***Confluent Hypergeometric Functions***
C Confluent                U(a,b,x)           CHU(A,B,X) DCHU      --
C  hypergeometric
C                     ***Miscellaneous Functions***
C Spence                   s(x) = - the       SPENC(X)   DSPENC    --
C  dilogarithm             integral from
C                          0 to x of
C                          ((ln \1-y\) / y)dy
C
C***REFERENCES  (NONE)
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   801015  DATE WRITTEN
C   861211  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900326  Routine name changed from FNLIBD to FUNDOC.  (WRB)
C   900723  PURPOSE section revised.  (WRB)
C***END PROLOGUE  FUNDOC
C***FIRST EXECUTABLE STATEMENT  FUNDOC
      RETURN
      END
*DECK FZERO
      SUBROUTINE FZERO (F, B, C, R, RE, AE, IFLAG)
C***BEGIN PROLOGUE  FZERO
C***PURPOSE  Search for a zero of a function F(X) in a given interval
C            (B,C).  It is designed primarily for problems where F(B)
C            and F(C) have opposite signs.
C***LIBRARY   SLATEC
C***CATEGORY  F1B
C***TYPE      SINGLE PRECISION (FZERO-S, DFZERO-D)
C***KEYWORDS  BISECTION, NONLINEAR EQUATIONS, ROOTS, ZEROS
C***AUTHOR  Shampine, L. F., (SNLA)
C           Watts, H. A., (SNLA)
C***DESCRIPTION
C
C     FZERO searches for a zero of a REAL function F(X) between the
C     given REAL values B and C until the width of the interval (B,C)
C     has collapsed to within a tolerance specified by the stopping
C     criterion,
C        ABS(B-C) .LE. 2.*(RW*ABS(B)+AE).
C     The method used is an efficient combination of bisection and the
C     secant rule and is due to T. J. Dekker.
C
C     Description Of Arguments
C
C   F     :EXT   - Name of the REAL external function.  This name must
C                  be in an EXTERNAL statement in the calling program.
C                  F must be a function of one REAL argument.
C
C   B     :INOUT - One end of the REAL interval (B,C).  The value
C                  returned for B usually is the better approximation
C                  to a zero of F.
C
C   C     :INOUT - The other end of the REAL interval (B,C)
C
C   R     :OUT   - A (better) REAL guess of a zero of F which could help
C                  in speeding up convergence.  If F(B) and F(R) have
C                  opposite signs, a root will be found in the interval
C                  (B,R); if not, but F(R) and F(C) have opposite signs,
C                  a root will be found in the interval (R,C);
C                  otherwise, the interval (B,C) will be searched for a
C                  possible root.  When no better guess is known, it is
C                  recommended that r be set to B or C, since if R is
C                  not interior to the interval (B,C), it will be
C                  ignored.
C
C   RE    :IN    - Relative error used for RW in the stopping criterion.
C                  If the requested RE is less than machine precision,
C                  then RW is set to approximately machine precision.
C
C   AE    :IN    - Absolute error used in the stopping criterion.  If
C                  the given interval (B,C) contains the origin, then a
C                  nonzero value should be chosen for AE.
C
C   IFLAG :OUT   - A status code.  User must check IFLAG after each
C                  call.  Control returns to the user from FZERO in all
C                  cases.
C
C                1  B is within the requested tolerance of a zero.
C                   The interval (B,C) collapsed to the requested
C                   tolerance, the function changes sign in (B,C), and
C                   F(X) decreased in magnitude as (B,C) collapsed.
C
C                2  F(B) = 0.  However, the interval (B,C) may not have
C                   collapsed to the requested tolerance.
C
C                3  B may be near a singular point of F(X).
C                   The interval (B,C) collapsed to the requested tol-
C                   erance and the function changes sign in (B,C), but
C                   F(X) increased in magnitude as (B,C) collapsed, i.e.
C                     ABS(F(B out)) .GT. MAX(ABS(F(B in)),ABS(F(C in)))
C
C                4  No change in sign of F(X) was found although the
C                   interval (B,C) collapsed to the requested tolerance.
C                   The user must examine this case and decide whether
C                   B is near a local minimum of F(X), or B is near a
C                   zero of even multiplicity, or neither of these.
C
C                5  Too many (.GT. 500) function evaluations used.
C
C***REFERENCES  L. F. Shampine and H. A. Watts, FZERO, a root-solving
C                 code, Report SC-TM-70-631, Sandia Laboratories,
C                 September 1970.
C               T. J. Dekker, Finding a zero by means of successive
C                 linear interpolation, Constructive Aspects of the
C                 Fundamental Theorem of Algebra, edited by B. Dejon
C                 and P. Henrici, Wiley-Interscience, 1969.
C***ROUTINES CALLED  R1MACH
C***REVISION HISTORY  (YYMMDD)
C   700901  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890531  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  FZERO
      REAL A,ACBS,ACMB,AE,AW,B,C,CMB,ER,FA,FB,FC,FX,FZ,P,Q,R,
     +     RE,RW,T,TOL,Z
      INTEGER IC,IFLAG,KOUNT
C***FIRST EXECUTABLE STATEMENT  FZERO
C
C   ER is two times the computer unit roundoff value which is defined
C   here by the function R1MACH.
C
      ER = 2.0E0 * R1MACH(4)
C
C   Initialize.
C
      Z = R
      IF (R .LE. MIN(B,C)  .OR.  R .GE. MAX(B,C)) Z = C
      RW = MAX(RE,ER)
      AW = MAX(AE,0.E0)
      IC = 0
      T = Z
      FZ = F(T)
      FC = FZ
      T = B
      FB = F(T)
      KOUNT = 2
      IF (SIGN(1.0E0,FZ) .EQ. SIGN(1.0E0,FB)) GO TO 1
      C = Z
      GO TO 2
    1 IF (Z .EQ. C) GO TO 2
      T = C
      FC = F(T)
      KOUNT = 3
      IF (SIGN(1.0E0,FZ) .EQ. SIGN(1.0E0,FC)) GO TO 2
      B = Z
      FB = FZ
    2 A = C
      FA = FC
      ACBS = ABS(B-C)
      FX = MAX(ABS(FB),ABS(FC))
C
    3 IF (ABS(FC) .GE. ABS(FB)) GO TO 4
C
C   Perform interchange.
C
      A = B
      FA = FB
      B = C
      FB = FC
      C = A
      FC = FA
C
    4 CMB = 0.5E0*(C-B)
      ACMB = ABS(CMB)
      TOL = RW*ABS(B) + AW
C
C   Test stopping criterion and function count.
C
      IF (ACMB .LE. TOL) GO TO 10
      IF (FB .EQ. 0.E0) GO TO 11
      IF (KOUNT .GE. 500) GO TO 14
C
C   Calculate new iterate implicitly as B+P/Q, where we arrange
C   P .GE. 0.  The implicit form is used to prevent overflow.
C
      P = (B-A)*FB
      Q = FA - FB
      IF (P .GE. 0.E0) GO TO 5
      P = -P
      Q = -Q
C
C   Update A and check for satisfactory reduction in the size of the
C   bracketing interval.  If not, perform bisection.
C
    5 A = B
      FA = FB
      IC = IC + 1
      IF (IC .LT. 4) GO TO 6
      IF (8.0E0*ACMB .GE. ACBS) GO TO 8
      IC = 0
      ACBS = ACMB
C
C   Test for too small a change.
C
    6 IF (P .GT. ABS(Q)*TOL) GO TO 7
C
C   Increment by TOLerance.
C
      B = B + SIGN(TOL,CMB)
      GO TO 9
C
C   Root ought to be between B and (C+B)/2.
C
    7 IF (P .GE. CMB*Q) GO TO 8
C
C   Use secant rule.
C
      B = B + P/Q
      GO TO 9
C
C   Use bisection (C+B)/2.
C
    8 B = B + CMB
C
C   Have completed computation for new iterate B.
C
    9 T = B
      FB = F(T)
      KOUNT = KOUNT + 1
C
C   Decide whether next step is interpolation or extrapolation.
C
      IF (SIGN(1.0E0,FB) .NE. SIGN(1.0E0,FC)) GO TO 3
      C = A
      FC = FA
      GO TO 3
C
C   Finished.  Process results for proper setting of IFLAG.
C
   10 IF (SIGN(1.0E0,FB) .EQ. SIGN(1.0E0,FC)) GO TO 13
      IF (ABS(FB) .GT. FX) GO TO 12
      IFLAG = 1
      RETURN
   11 IFLAG = 2
      RETURN
   12 IFLAG = 3
      RETURN
   13 IFLAG = 4
      RETURN
   14 IFLAG = 5
      RETURN
      END

subroutine gdf_compare_shape(first,second,equal)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Compare shapes of two GILDAS images
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: first       ! First GILDAS data set
  type (gildas), intent(in) :: second      ! Second GILDAS data set
  logical, intent(out) :: equal         ! are they equal ?
  ! Local
  integer :: i
  !
  equal = .true.
  if (first%gil%ndim.eq.second%gil%ndim) then
    do i = 1,first%gil%ndim
      if (first%gil%dim(i).ne.second%gil%dim(i)) then
        equal = .false.
        return
      endif
    enddo
  else if (first%gil%ndim.gt.second%gil%ndim) then
    do i=second%gil%ndim+1, first%gil%ndim
      if (first%gil%dim(i).gt.1) then
        equal = .false.
        return
      endif
    enddo
  else
    do i=first%gil%ndim+1,second%gil%ndim
      if (second%gil%dim(i).gt.1) then
        equal = .false.
        return
      endif
    enddo
  endif
end subroutine gdf_compare_shape
!
subroutine gdf_read_gdforfits_header(name,isfits,hgdf,hfits,error)
  use gbl_message
  use image_def
  use gfits_types
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_read_gdforfits_header
  !------------------------------------------------------------------
  ! @ public
  ! Read the named file and store its header under GDF format
  ! in 'hgdf' structure. The input file can be either a standard GDF
  ! or a supported FITS.
  ! In return, the internal buffers are set to be ready to read data.
  !------------------------------------------------------------------
  character(len=*),    intent(in)    :: name    ! File name
  logical,             intent(out)   :: isfits  ! Found a GDF or a FITS?
  type(gildas),        intent(inout) :: hgdf    ! GDF image structure
  type(gfits_hdesc_t), intent(inout) :: hfits   ! FITS internal description, if relevant
  logical,             intent(inout) :: error   ! Error flag
  ! Local
  character(len=*), parameter :: rname='GDF_READ_HEADER'
  integer(kind=4), parameter :: hdu=1  ! 1 is Primary
  integer(kind=4) :: filekind
  !
  ! Read header to get the file information
  call gag_file_guess(rname,name,filekind,error)
  if (error)  return
  select case (filekind)
  case (1)
    isfits = .false.
    hgdf%file = name
    hgdf%blc = 0
    hgdf%trc = 0
    call gdf_read_header(hgdf,error)
    if (error) return
  case (2)
    isfits = .true.
    call gfits_open(name,'IN',error)
    if (error)  return
    call gfits_goto_hdu(hfits,hdu,error)
    if (error)  return
    call fitscube2gdf_header(name,hdu,hfits,hgdf,gfits_getnosymbol,error)
    if (error)  return
    ! Make sure the FITS file is at the right position for later data accesses
    call gfits_flush_data(error)
    if (error)  return
  case default
    isfits = .false.
    call gio_message(seve%e,rname,'Unsupported file kind')
    error = .true.
    return
  end select
  !
end subroutine gdf_read_gdforfits_header
!
subroutine gdf_read_header(imag,error,rank)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_read_header
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Read an image header from the requested file
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag   ! Image structure
  logical,      intent(out)   :: error  ! Error flag
  integer,      intent(in), optional :: rank  ! Desired rank
  ! Local
  character(len=filename_length) :: file
  integer :: islo
  !
  error = .false.
  imag%status = code_read_header
  file = imag%file
  call sic_parsef(file,imag%file,' ','.gdf')
  call gio_geis (islo,error)
  if (error) return
  if (imag%loca%read) then
    call gio_reis(islo,imag%char%type,imag%file,imag%gil%form,imag%loca%size,  &
    error)
  else
    call gio_wris(islo,imag%char%type,imag%file,imag%gil%form,imag%loca%size,  &
    error)
  endif
  if (error) then
    call gio_message(seve%e, 'GDF_READ_HEADER', 'Cannot read input file')
    call gio_fris(islo,error)
    return
  endif
  !
  call gio_read_header(imag,islo,error)
  !
  ! Optional RANK= argument
  if (present(rank)) then
    call sub_trim_header('GDF_READ_HEADER',imag,rank,error)
  endif
  !
  ! Check for errors
  if (error) then
    call gio_fris(islo,error)
    return
  endif
  !
  ! Set success indicators
  imag%loca%islo = islo
  imag%loca%mslo = 0
  imag%status = 0
  !
end subroutine gdf_read_header
!
subroutine gdf_trim_header(imag,rank,error)
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Read an image header from the requested file
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: imag    ! Image structure
  integer(4),   intent(in)    :: rank    ! Requested Rank
  logical,      intent(out)   :: error   ! Error flag
  !
  call sub_trim_header('GDF_TRIM_HEADER',imag,rank,error)
end subroutine gdf_trim_header
!
subroutine sub_trim_header(caller,imag,therank,error)
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !       Read an image header from the requested file
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: caller  ! Name of caller
  type(gildas), intent(inout)  :: imag    ! Image structure
  integer(4),   intent(in)     :: therank ! Requested Rank
  logical,      intent(inout)  :: error   ! Error flag
  !
  integer :: i
  character(len=60) :: mess
  !
  if (therank.lt.0) then
    if (imag%gil%ndim.ne.-therank) then
      write(mess,'(A,I1,A,I1)') 'Rank mismatch: Image ',imag%gil%ndim, &
        &   ', Requested ',-therank
      call gio_message(seve%e,caller, mess)
      error = .true.
      return
    endif
  else if (therank.eq.0) then
    !
    ! Trim all degenerate trailing dimensions
    if (imag%gil%dim(imag%gil%ndim).gt.1) then
      call gio_message(seve%e,caller,'Image cannot be trimmed')
      error = .true.
      return
    else
      do while (imag%gil%dim(imag%gil%ndim).eq.1)
        imag%gil%ndim = imag%gil%ndim - 1
      enddo
    endif
  else if (therank.lt.imag%gil%ndim) then
    do i=therank+1,gdf_maxdims
      if (imag%gil%dim(i).gt.1) then
        write(mess,'(A,I1)') 'File has rank > ',therank
        call gio_message(seve%e,caller, mess)
        error = .true.
        return
      endif
      imag%gil%ndim = therank
    enddo
  else if (therank.gt.imag%gil%ndim) then
    do i=imag%gil%ndim+1,therank
      imag%gil%dim(i) = 1
    enddo
    imag%gil%ndim = therank    
  endif
  !
  ! This should not be done: gheads% is a pure copy of the image file 
  !   header, and thus must be left untouched.
  ! if (imag%loca%islo.ne.0) gheads%gil%ndim(islo) = imag%gil%ndim
  !
end subroutine sub_trim_header
!
subroutine gdf_update_header(imag,error)
  use gio_interfaces, except_this=>gdf_update_header
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API routine
  !     Update an image header
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: imag      ! Image structure
  logical, intent(out) :: error             ! Flag
  ! Local
  integer(kind=4) :: islo
  !
  error = .false.
  islo = imag%loca%islo
  imag%status = code_update_header
  if (gdf_stis(islo).eq.-1) then
    call gio_message(seve%e, 'GDF_UPDATE_HEADER', 'Slot is not mapped')
    error = .true.
    return
  endif
  !
  call gio_write_header(imag,islo,error)
  if (error) return
  !
  ! FLush the image header
  call gdf_flih (islo,.false.,error)   ! Force writing even if slot is READO
  imag%status = 0
  !
  ! The image is left open...
  !!write(99,*) 'Tested gdf_update_header'
end subroutine gdf_update_header
!
subroutine gdf_copy_header(input,output, error)
  use image_def
  use gbl_message
  use gio_interfaces, only : gio_init_gildas, gdf_copy_gil, gio_message
  !---------------------------------------------------------------------
  ! @ public
  ! Copy (a part of) the input header into the output header.
  ! Since the arguments are the full gildas type, 'output' must be
  ! inout to avoid resetting the data part of the type. This implies that
  ! the other header components must also have been set/initialized
  ! before.
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: input   ! Input header
  type(gildas), intent(inout) :: output  ! Output header
  logical,      intent(inout) :: error   !
  !
  character(len=12) :: otype
  !
  if (input%header.ne.1) then
    call gio_message(seve%e,'GDF_COPY_HEADER','Input Header not initialized by GILDAS_NULL')
    error = .true.
    return
  endif
  call gio_init_gildas(output, 'GDF_COPY_HEADER - Output')
  !
  ! This overrides the pointers ... A Fortran-90 feature !...
  !   output%gil = input%gil
  ! So we use a dedicated routine
  call gdf_copy_gil (input,output,error)
  !
  otype = output%char%type
  output%char = input%char
  output%char%type = otype
  !
  output%loca%size = input%loca%size
  !
  ! Undefine other LOCAtion variables
  output%loca%addr = 0
  output%loca%islo = 0
  output%loca%mslo = 0
  output%loca%read = .true.   ! .false. was inconsistent with the Default
  output%loca%getvm = .false.
end subroutine gdf_copy_header
!
subroutine gdf_transpose_header(input,output,order,error,drop)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_transpose_header
  !---------------------------------------------------------------------
  ! @ public
  !       Transpose a header information
  !---------------------------------------------------------------------
  type (gildas),     intent(in)    :: input   ! Initial Header
  type (gildas),     intent(inout) :: output  ! Transposed Header
  character(len=*),  intent(in)    :: order   ! Transposition code
  logical,           intent(inout) :: error   ! Flag
  logical, optional, intent(in)    :: drop    ! Drop trailing dimensions?
  ! Local
  character(len=*), parameter :: rname='TRANSPOSE'
  integer(kind=4) :: itr(gdf_maxdims), mtr, i
  character(len=message_length) :: mess
  logical :: drop_trailing_dims
  !
  ! Interpret the transposition code
  call transpose_getorder(order,itr,gdf_maxdims,error)
  if (error) return
  mtr = maxval (itr)
  !
  ! Copy header:
  ! output = input ! No, this re-affects improperly the pointers...
  call gildas_null (output)
  ! To get started with because the copy depends on Header types.
  output%gil%type_gdf = input%gil%type_gdf
  output%char%type = input%char%type
  call gdf_copy_header(input,output,error)
  !
  ! Make sure all axes mentioned in the transposition code do exist
  !
  if (mtr.gt.input%gil%ndim) then
    if (input%gil%type_gdf.eq.code_gdf_image) then
      ! Implicitely extend missing dimensions by degenerate ones (only for
      ! images/cubes).
      write(mess,201)  &
        'Forcing image dimension from ',input%gil%ndim,' to ',mtr,' for code ',order
      call gio_message(seve%w, rname, mess)
      output%gil%ndim = mtr
      do i=1,gdf_maxdims
        output%gil%dim(i) = max (1,output%gil%dim(i))
      enddo
    else
      ! Enlarging the number of dimensions is forbidden (non-sense for
      ! tables)
      write(mess,'(A,A,A,I0,A)')  &
        'Invalid code ',trim(order),' (data has only ',input%gil%ndim,' dimensions)'
      call gio_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  ! Allow trailing dimensions to remain unspecified and untouched if present
  do i=1,input%gil%ndim
    if (itr(i).eq.0) itr(i) = i
  enddo
  !
  ! General
  do i=1,output%gil%ndim
    output%gil%dim(i) = max(input%gil%dim(itr(i)),1)
    output%gil%convert(:,i) = input%gil%convert(:,itr(i))
  enddo
  !
  ! Extrema
  if (input%gil%extr_words.ne.0) then
    do i=1,gdf_maxdims
      output%gil%minloc(i) = input%gil%minloc(itr(i))
    enddo
    do i=1,gdf_maxdims
      output%gil%maxloc(i) = input%gil%maxloc(itr(i))
    enddo
  else
    output%gil%extr_words = 0
  endif
  ! Units
  do i=1,output%gil%ndim
    output%char%code(i) = input%char%code(itr(i))
  enddo
  !
  ! Define the projection axes
  if (output%gil%proj_words.ne.0) then
    do i=1,output%gil%ndim
      if (itr(i).eq.input%gil%xaxi) then
        output%gil%xaxi = i
      elseif (itr(i).eq.input%gil%yaxi) then
        output%gil%yaxi = i
      endif
    enddo
  endif
  ! Define the Spectral axis
  if (output%gil%spec_words.ne.0) then
    do i=1,output%gil%ndim
      if (itr(i).eq.input%gil%faxi) output%gil%faxi = i
    enddo
  endif
  !
  ! In case of 21 transposition and Only TWO dimensions:
  ! indicate the transposition status in the type_gdf item.
  ! This can apply to UV Tables, Table (GILDAS and VO),
  ! Class Tables (a subset of UV Tables actually),
  ! SpreadSheets (if ever implemented)
  if (order.eq.'21'.and.output%gil%ndim.eq.2) then
    output%gil%type_gdf = -output%gil%type_gdf
  endif
  !!Print *,output%gil%type_gdf,'CODE ',code,' Dim ',output%gil%ndim,output%gil%dim
  !
  ! Reshape if needed (re-compute number of effective dimensions)
  if (present(drop)) then
    drop_trailing_dims = drop
  else
    drop_trailing_dims = .true.
  endif
  if (drop_trailing_dims) then
    do i=1,gdf_maxdims
      if (output%gil%dim(i).gt.1) output%gil%ndim = i
    enddo
  endif
  !
201 format(a,i1,a,i1,a,a)
end subroutine gdf_transpose_header
!
function gildas_error(header,name,error)
  use gio_interfaces, only : gio_message
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API routine
  !     Translate any possible error code, and return an error if needed
  !---------------------------------------------------------------------
  logical gildas_error                  ! intent(out)
  type (gildas), intent(in) :: header   ! Image header
  character(len=*), intent(in) :: name  ! Calling facility name
  logical, intent(out) :: error         ! Error flag
  ! Local
  integer :: icode, myseve
  character(len=32) :: codename(8)
  character(len=message_length) :: chain
  !
  data codename /  &
    'GDF_READ_DATA',   'GDF_READ_HEADER','GDF_UPDATE_HEADER',  &
    'GDF_WRITE_HEADER','GDF_WRITE_DATA', 'GDF_READ_VMIMAGE',   &
    'GDF_FREE_IMAGE',  'GDF_CREATE_IMAGE'/
  !
  if (header%header.ne.1) then
    chain = 'Header not initialized by GILDAS_NULL'
    call gio_message(seve%e,name,chain)
    error = .true.
  else if (header%status.eq.0) then
    error = .false.
  elseif (header%status.gt.0) then
    chain = 'Allocate error'
    call gio_message(seve%e, name, chain)
    error = .true.
  else
    icode = abs(header%status)
    if (header%status.eq.code_gio_extcol) then
      myseve = seve%w
      chain = 'Extra column in table'
    elseif (header%status.lt.code_gio_miscol) then
      myseve = seve%e
      chain = 'Missing column in table'
      error = .true.
    else
      myseve = seve%e
      chain = 'Error in '//codename(icode)
      call gio_message(seve%e,name,chain)
      error = .true.
    endif
    call gio_message(myseve,name,chain)
    if (myseve.eq.seve%e) then
      write(chain,'(A)') 'File: '//header%file
      call gio_message(myseve,name,chain)
    endif
  endif
  gildas_error = error
end function gildas_error
!
integer function gio_word_length(header)
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF / GIO Internal routine
  !       Return the word length (in Bytes) of a GILDAS image
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: header           !
  !
  if (header%gil%form.eq.fmt_r8 .or. header%gil%form.eq.fmt_c4 &
    .or. header%gil%form.eq.fmt_i8) then
    gio_word_length = 8
  else if (header%gil%form.eq.fmt_c8) then
    gio_word_length = 16
  else
    gio_word_length = 4
  endif
end function gio_word_length
!
subroutine gio_read_header(imag,islo,error)
  use gio_interfaces, only : gio_init_gildas, gdf_copy_gil
  use image_def
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF / GIO Internal routine
  !       Read an image header on a specified image slot
  !           The slot must have been opened before
  !---------------------------------------------------------------------
  type(gildas),    intent(inout) :: imag   !
  logical,         intent(inout) :: error  !
  integer(kind=4), intent(in)    :: islo   !
  !
  character(len=*), parameter :: rname='GIO_READ_HEADER'
  !
  call gio_message(seve%t,rname,'Entering...')
  !
  call gio_init_gildas(imag,rname)
  imag%gil%type_gdf = gheads(islo)%gil%type_gdf ! Can be done ?
  call gdf_copy_gil (gheads(islo), imag, error)
  imag%char = gheads(islo)%char
  !
  call gio_message(seve%t,rname,'Leaving !..')
end subroutine gio_read_header
!
subroutine gio_write_header(imag,islo,error)
  use image_def
  use gio_image
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GDF / GIO Internal routine
  !       Update an image header on a specified image slot
  !           The slot must have been opened before
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: imag  !
  logical, intent(out) :: error      !
  integer(kind=4), intent(in) :: islo
  !
  character(len=*), parameter :: rname='GIO_WRITE_HEADER'
  !
  call gio_message(seve%t,rname,'Entering...')
  gheads(islo) = imag  ! What about the pointers ?
  !
  !!gheads(islo)%gil%type_gdf =  imag%gil%type_gdf  ! Can be done for sure
  !!call gdf_copy_gil (imag, gheads(islo), error)
  !!gheads(islo)%char = imag%char 
  !
  ! Set the number of starting blocks consistently
  istbl(islo) = max(istbl(islo),imag%gil%nhb)
  error = .false.
  call gio_message(seve%t,rname,'Leaving !..')
end subroutine gio_write_header
!
subroutine gdf_get_extrema (mine,error)
  use gbl_format
  use image_def
  use gbl_message
  use gio_dependencies_interfaces, no_interface1=>gr4_extrema,  &
                                   no_interface2=>gr8_extrema
  use gio_interfaces, only : gio_message, gdf_index_to_where
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !   Compute the extrema from a Virtual Memory image (one with the
  !   appropriate address field). Note that the address field
  !   can have been set independently of the %getvm status
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: mine   !
  logical,       intent(out)   :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='EXTREMA'
  integer(kind=address_length) :: ip
  integer(kind=size_length) :: imin,imax
  integer(kind=8) :: ilong
  !
  ! Map the image Readonly if needed
  if (mine%loca%addr.eq.0) then
    call gio_message(seve%e,rname,'Image data is not defined')
    error = .true.
    return
  endif
  if (mine%gil%form.ne.fmt_r4 .and. mine%gil%form.ne.fmt_r8) then
    call gio_message(seve%e,rname,'Invalid format')
    error = .true.
    return
  endif
  !
  ! Set the blanking
  error = .false.
  if (mine%gil%blan_words.eq.0) then
    mine%gil%bval = 0.0
    mine%gil%eval = -1.0
  endif
  !
  ! Compute the Extrema
  ip = gag_pointer(mine%loca%addr,memory)
  if (mine%gil%form.eq.fmt_r4) then
    call gr4_extrema (mine%loca%size,memory(ip),     &
                      mine%gil%bval, mine%gil%eval,  &
                      mine%gil%rmin, mine%gil%rmax,imin,imax)
  elseif (mine%gil%form.eq.fmt_r8) then
    call gr8_extrema (mine%loca%size,memory(ip),     &
                      mine%gil%bval, mine%gil%eval,  &
                      mine%gil%rmin, mine%gil%rmax,imin,imax)
  endif
  !
  if (imin.eq.0 .or. imax.eq.0)  &
    call gio_message(seve%w,rname,'No valid value, extrema not updated')
  !
  ilong = imin
  call gdf_index_to_where(ilong,mine%gil%ndim,mine%gil%dim,mine%gil%minloc)
  ilong = imax
  call gdf_index_to_where(ilong,mine%gil%ndim,mine%gil%dim,mine%gil%maxloc)
  mine%gil%extr_words = def_extr_words
end subroutine gdf_get_extrema
!
subroutine gdf_get_baselines (mine,error)
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  use image_def
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !   Compute the baseline range from a Virtual Memory UV data (one with the
  !   appropriate address field). Note that the address field
  !   can have been set independently of the %getvm status
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: mine   !
  logical,       intent(out)   :: error  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer :: iu,iv
  integer(kind=address_length) :: ip
  real(4) :: base,baseuv(2)
  integer(kind=index_length) :: i
  !
  ! Check consistency
  if (mine%loca%addr.eq.0) then
    call gio_message(seve%e,'GET_BASELINES','UV data is not defined')
    error = .true.
    return
  endif
  if (abs(mine%gil%type_gdf).ne.code_gdf_uvt) then
    call gio_message(seve%e,'GET_BASELINES','This is not a UV data')
    error = .true.
    return
  endif
  if (mine%gil%form.ne.fmt_r4 .and. mine%gil%form.ne.fmt_r8) then
    call gio_message(seve%e,'GET_BASELINES','Invalid format')
    error = .true.
    return
  endif
  !
  mine%gil%basemin = 1.E12
  mine%gil%basemax = 0.0
  ip = gag_pointer(mine%loca%addr,memory)
  !
  iu = mine%gil%column_pointer(code_uvt_u)
  iv = mine%gil%column_pointer(code_uvt_v)
  !
  if (mine%gil%type_gdf.eq.code_gdf_uvt) then
    if (mine%gil%column_size(code_uvt_u).eq.2) then
      do i=1,mine%gil%nvisi !! not %dim(2)
        call r8tor4(memory(ip+2*(iu-1)),baseuv(1),1)
        call r8tor4(memory(ip+2*(iv-1)),baseuv(2),1)
        base = baseuv(1)**2+baseuv(2)**2
        mine%gil%basemin = min(base,mine%gil%basemin)
        mine%gil%basemax = max(base,mine%gil%basemax)
        ip = ip+2*mine%gil%dim(1)
      enddo
    else
      do i=1,mine%gil%nvisi !! not %dim(2)
        call r4tor4(memory(ip+iu-1),baseuv(1),1)
        call r4tor4(memory(ip+iv-1),baseuv(2),1)
        base = baseuv(1)**2+baseuv(2)**2
        mine%gil%basemin = min(base,mine%gil%basemin)
        mine%gil%basemax = max(base,mine%gil%basemax)
        ip = ip+mine%gil%dim(1)
      enddo
    endif
  else
    if (mine%gil%column_size(code_uvt_u).eq.2) then
      do i=1,mine%gil%nvisi !! not %dim(1)
        call r8tor4(memory(ip+2*mine%gil%dim(1)*(iu-1)),baseuv(1),1)
        call r8tor4(memory(ip+2*mine%gil%dim(1)*(iv-1)),baseuv(2),1)
        base = baseuv(1)**2+baseuv(2)**2
        mine%gil%basemin = min(base,mine%gil%basemin)
        mine%gil%basemax = max(base,mine%gil%basemax)
        ip = ip+2
      enddo
    else
      do i=1,mine%gil%nvisi !! not %dim(1)
        call r4tor4(memory(ip+mine%gil%dim(1)*(iu-1)),baseuv(1),1)
        call r4tor4(memory(ip+mine%gil%dim(1)*(iv-1)),baseuv(2),1)
        base = baseuv(1)**2+baseuv(2)**2
        mine%gil%basemin = min(base,mine%gil%basemin)
        mine%gil%basemax = max(base,mine%gil%basemax)
        ip = ip+1
      enddo
    endif
  endif
  mine%gil%basemin = sqrt(mine%gil%basemin)
  mine%gil%basemax = sqrt(mine%gil%basemax)
  !! Print *,'Base ',mine%gil%basemin,mine%gil%basemax
  !
end subroutine gdf_get_baselines
!
subroutine gildas_null(hx, type)
  use gio_dependencies_interfaces
  use image_def
  use gio_interfaces, only : gio_init_gildas, gio_zero_gildas
  use gio_uv
  !---------------------------------------------------------------------
  ! @ public
  ! GDF API
  !   Initialize a Gildas structure and reset its content
  !---------------------------------------------------------------------
  type(gildas), intent(out), target :: hx ! Gildas structure
  character(len=*), intent(in), optional :: type
  !
  call gio_init_gildas(hx, 'GILDAS_NULL')
  call gio_zero_gildas(hx)
  !
  hx%gil%uvda_words = 0 ! Set section to be absent by default
  if (.not.present(type)) return
  !
  if (type.eq.'UVT' .or. type.eq.'TUV') then
    hx%gil%ndim = 2
    hx%gil%form = fmt_r4
    hx%gil%uvda_words = 1  ! Set section to be present
    !
    ! V 2.0 version: fixed layout of the 7 mandatory daps...
    ! V 2.1 version: with Doppler information
    hx%gil%version_uv = code_version_uvt_current
    hx%gil%column_pointer = 0
    hx%gil%column_pointer(code_uvt_u) = 1
    hx%gil%column_pointer(code_uvt_v) = 2
    hx%gil%column_pointer(code_uvt_w) = 3
    hx%gil%column_pointer(code_uvt_date) = 4
    hx%gil%column_pointer(code_uvt_time) = 5
    hx%gil%column_pointer(code_uvt_anti) = 6
    hx%gil%column_pointer(code_uvt_antj) = 7
    !
    hx%gil%column_size = 0
    where (hx%gil%column_pointer.ne.0) hx%gil%column_size = 1
    !
    hx%gil%fcol = 8
    hx%gil%lcol = 0 ! Not yet defined
    hx%gil%nlead = 7
    hx%gil%ntrail = 0
    hx%gil%nstokes = 1
    hx%gil%natom = 3
    hx%gil%order = 0
    !
    if (type.eq.'UVT') then
      hx%gil%type_gdf = code_gdf_uvt
      hx%char%code(1) = 'UV-DATA'
      hx%char%code(2) = 'RANDOM'
    elseif (type.eq.'TUV') then
      hx%gil%type_gdf = code_gdf_tuv
      hx%char%code(1) = 'RANDOM'
      hx%char%code(2) = 'UV-DATA'
    endif
    hx%char%code(3:gdf_maxdims) = ' '
    hx%char%type = 'GILDAS_UVFIL'
    ! No blanking in UV Tables
    hx%gil%blan_words = 0
    !
    hx%mos%nfields = 0
    !
  else if (type.eq.'TABLE') then
    hx%gil%type_gdf = code_gdf_table
    hx%gil%ndim = 2
    hx%gil%dim(3:gdf_maxdims) = 1
    hx%gil%blan_words = 0
    hx%gil%extr_words = 0
    hx%gil%desc_words = 0
    hx%gil%posi_words = 0
    hx%gil%proj_words = 0
    hx%gil%spec_words = 0
    hx%gil%reso_words = 0
    hx%gil%coor_words = 0
    hx%gil%uvda_words = 0
  else if (type.eq.'IMAGE') then
    hx%gil%extr_words = 0
    continue
  else if (type.eq.'VOTABLE') then
    hx%gil%type_gdf = code_gdf_vo
    hx%gil%ndim = 2
    hx%gil%dim(3:gdf_maxdims) = 1
    hx%gil%blan_words = 0
    hx%gil%extr_words = 0
    hx%gil%desc_words = 0
    hx%gil%posi_words = 0
    hx%gil%proj_words = 0
    hx%gil%spec_words = 0
    hx%gil%reso_words = 0
    hx%gil%coor_words = 0
    hx%gil%uvda_words = 0
    !
  else
    PRINT *,"Programming error, unsupported type ",type," in call to GILDAS_NULL"
    call sysexi(fatale)
  endif
  !
end subroutine gildas_null
!
subroutine gio_init_gildas(hx, caller)
  use gio_interfaces, only : gio_message
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GDF API
  !   Initialize a Gildas structure: set the required pointers
  !---------------------------------------------------------------------
  type(gildas), intent(inout), target :: hx ! Gildas structure
  character(len=*), intent(in) :: caller    ! Caller's name
  !
  if (.not.associated(hx%gil%ref,hx%gil%convert(1,:))) then
    ! Do not bother anymore: this may happen in parallel programming
    ! just reset the pointer as needed
    !
    !if (associated(hx%gil%ref)) then
    !  call gio_message(seve%e,caller,'Ref pointer badly associated')
    !endif
    !
    ! Use elaborate pointers with stride...
    hx%gil%ref => hx%gil%convert(1,:)
    hx%gil%val => hx%gil%convert(2,:)
    hx%gil%inc => hx%gil%convert(3,:)
  endif
  ! Unclear whether this must be here or in GILDAS_NULL actually...
  hx%header = 1 ! Header is initialized
  !
  ! We should clear any possible trailing pointer array
  if (associated(hx%gil%freqs)) deallocate(hx%gil%freqs)
  if (associated(hx%gil%stokes)) deallocate(hx%gil%stokes)
  if (allocated(hx%gil%teles)) deallocate(hx%gil%teles)
  !
  ! and reset to zero their associated sizes
  hx%gil%nfreq = 0
  hx%gil%nstokes = 0
  hx%gil%nteles = 0
  !
  if (allocated(hx%mos%fields)) deallocate(hx%mos%fields)
  hx%mos%nfields = 0
end subroutine gio_init_gildas
!
subroutine gio_zero_gildas(header)
  use image_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! GDF API routine
  !    Initialize a Gildas header content to default values
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: header           !
  ! Local
  integer :: i
  !
  !     Location
  header%loca%al64 = 0
  header%loca%size = 0
  header%loca%addr = 0
  header%loca%islo = 0
  header%loca%mslo = 0
  header%loca%read = .true.
  header%loca%getvm = .false.
  !     Strings
  header%char%type = 'GILDAS_IMAGE'
  header%char%unit = ' '       ! 56
  do i=1,gdf_maxdims
    header%char%code(i) = ' '  ! 59
  enddo
  header%char%syst = ' '       ! 71
  header%char%name = ' '       ! 75,76,77
  header%char%line = ' '
  !! header%char%tele = ' '
  header%file = ' '            ! File name
  ! Header
  header%gil%type_gdf = code_null ! or code_gdf_image
  !!header%gil%ijtyp = 0          !  1
  header%gil%form = fmt_r4     !  4
  header%gil%ndb  = 0          !  5
  !! header%gil%fill = 0          !  6 (unused)
  !
  header%gil%ndim = 0          ! 12
  header%gil%dim  = 0          ! 13
  header%gil%dim_words = 2+2*gdf_maxdims    ! Max Dim, N Dim, + All Dimensions
  header%gil%coor_words = 6*gdf_maxdims     ! Conversion coordinates
  header%gil%convert = 1.0
  !
  header%gil%blan_words = 2          ! 41
  header%gil%bval = +1.23456e+38   ! 42
  header%gil%eval = -1.0       ! 43
  !
  header%gil%extr_words = 0
  header%gil%rmin = 0.0
  header%gil%rmax = 0.0
  header%gil%minloc = 0
  header%gil%maxloc = 0
  !
  header%gil%desc_words  = def_desc_words        ! 55
  !!header%gil%ijuni = 0          ! 56
  !!header%gil%ijcod = 0          ! 59
  !!header%gil%ijsys = 0          ! 71
  !
  header%gil%posi_words = def_posi_words         ! 74
  !!header%gil%ijsou = 0          ! 75
  header%gil%ra  = 0.0         ! 78
  header%gil%dec = 0.0         ! 80
  header%gil%lii = 0.0         ! 82
  header%gil%bii = 0.0         ! 84
  header%gil%epoc = equinox_null        ! 86
  !
  header%gil%proj_words = def_proj_words          ! 87
  header%gil%ptyp = p_none     ! 88
  header%gil%a0 = 0.0d0        ! 89
  header%gil%d0 = 0.0d0        ! 91
  header%gil%pang = 0.0d0      ! 93
  header%gil%xaxi = 0          ! 95
  header%gil%yaxi = 0          ! 96
  !
  header%gil%spec_words = def_spec_words   !
  !!header%gil%ijlin = 0       ! 98
  header%gil%fres = 0.0        ! 101
  header%gil%fima = 0.0        ! 103
  header%gil%freq = 0.0        ! 105
  header%gil%vres = 0.0        ! 107
  header%gil%voff = 0.0        ! 108
  header%gil%faxi = 0          ! 109
  header%gil%dopp = 0.0
  header%gil%vtyp = vel_lsr    ! LSR by default
!
  header%gil%reso_words = 0
  header%gil%majo = 0.0        ! 111
  header%gil%mino = 0.0        ! 112
  header%gil%posa = 0.0        ! 113
  !
  header%gil%nois_words = 0
  header%gil%noise = 0.0       ! 115
  header%gil%rms = 0.0         ! 116
  !
  header%gil%astr_words = 0
  header%gil%mura = 0.0        ! 118
  header%gil%mudec = 0.0       ! 119
  header%gil%parallax = 0.0    ! 120
  !!      HEADER%GIL%PEPOCH = 2000.0         ! 121
  !
  header%gil%uvda_words = 0
  !
  header%gil%tele_words = 0
  header%gil%nteles = 0
  header%gil%magic  = 1000
  !
  header%blc = 0
  header%trc = 0
  header%status = 0
  !
  header%mos%nfields = 0
end subroutine gio_zero_gildas
!
subroutine gdf_copy_gil(input,output,error)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, only : gio_message
  !---------------------------------------------------------------------
  ! @ public
  ! Copy the %gil%  part of the input header into the output header.
  !   Only used by SIC outside of GIO...
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: input   ! Input header
  type (gildas), intent(inout) :: output  ! Output header
  logical, intent(out) :: error
  !
  integer(kind=address_length) :: inlen, outlen, uvtlen, curlen
  integer :: ier, ifi
  integer :: save_type, save_chain(3)
  character(len=64) :: chain
  !
  error = .false.
  ier = 0
  !
  ! Maximum length
  uvtlen = (locwrd(input%gil%nfreq) - locwrd(input%gil%ijtyp)) / 4 + 1
  if (abs(input%gil%type_gdf).ne.abs(code_gdf_uvt)) then
    inlen = (locwrd(input%gil%uvda_words) - locwrd(input%gil%ijtyp)) / 4
  else
    inlen = (locwrd(input%gil%nfreq) - locwrd(input%gil%ijtyp)) / 4 + 1
  endif
  !
  if (abs(output%gil%type_gdf).ne.abs(code_gdf_uvt)) then
    outlen = (locwrd(output%gil%uvda_words) - locwrd(output%gil%ijtyp)) / 4
  else
    outlen = (locwrd(output%gil%nfreq) - locwrd(output%gil%ijtyp)) / 4 + 1
  endif
  !
  curlen = min(inlen, outlen)
  !!Print *,'curlen ',curlen,' uvtlen ',uvtlen,' inlen ',inlen,' outlen ',outlen
  !!Print *,'Input ',input%gil%type_gdf, ' output ',output%gil%type_gdf
  !
  ! If both are UV data sets,
  ! need to copy %freq & %stokes items if they are defined...
  if (curlen.eq.uvtlen) then
    if (input%gil%nfreq.ne.0) then
      write(chain,*) input%gil%nfreq
      call gio_message(seve%d,'GDF_COPY_HEADER','Copying '//trim(chain)//' Frequency & Stokes')
    endif
    !DEBUG! Print *,'FREQ Input ',input%gil%nfreq, ' output ',output%gil%nfreq
    ! Would also need to copy %freq & %stokes
    if (output%gil%nfreq.ne.input%gil%nfreq) then
      if (associated(output%gil%freqs)) then
        !DEBUG! Print *,'Deallocating FREQS'    !Under TEST
        deallocate(output%gil%freqs, output%gil%stokes, stat=ier)
        if (ier.ne.0) then
          call gio_message(seve%w,'GDF_COPY_HEADER','Frequency & Stokes array deallocation error')
        endif
      endif
      if (input%gil%nfreq.ne.0) then
        !DEBUG! Print *,'Allocating FREQS',input%gil%nfreq !Under TEST
        allocate(output%gil%freqs(input%gil%nfreq), output%gil%stokes(input%gil%nfreq), stat=ier)
        if (ier.ne.0) then
          call gio_message(seve%e,'GDF_COPY_HEADER','Frequency & Stokes array allocation error')
          error = .true.
        else
          !DEBUG! Print *,'Input ',ubound(input%gil%freqs), ubound(input%gil%stokes)    !Under TEST
          !DEBUG! Print *,'Output ',ubound(output%gil%freqs), ubound(output%gil%stokes) !Under TEST
          !DEBUG! Print *,'Input Stokes ',input%gil%stokes(:)
          output%gil%freqs(:) = input%gil%freqs(:)
          output%gil%stokes(:) = input%gil%stokes(:)
        endif
        output%gil%nfreq = input%gil%nfreq 
      endif
    else if (input%gil%nfreq.gt.0) then
      ! Size matches and are non-zero...
      output%gil%freqs(:) = input%gil%freqs(:)
      output%gil%stokes(:) = input%gil%stokes(:)
    endif
    !
    if ((input%gil%nfreq.eq.0).and.(abs(input%gil%order).eq.abs(code_stok_chan))) then
      !DEBUG! Print *,' Stokes order ',input%gil%order, code_stok_chan
      !
      write(chain,'(A,I0,A)') 'Copying ',input%gil%nstokes,' pure Stokes'
      call gio_message(seve%d,'GDF_COPY_HEADER',chain)
      !DEBUG! Print *,'Stokes sizes ',input%gil%nstokes, output%gil%nstokes
      !
      if (output%gil%nstokes.ne.input%gil%nstokes) then
        if (associated(output%gil%stokes)) then
          deallocate(output%gil%stokes, stat=ier)
          if (ier.ne.0) then
            call gio_message(seve%w,'GDF_COPY_HEADER','Stokes array deallocation error')
          endif
        endif
        if (input%gil%nstokes.gt.1) then
          allocate(output%gil%stokes(input%gil%nstokes), stat=ier)
          if (ier.ne.0) then
            call gio_message(seve%e,'GDF_COPY_HEADER','Stokes array allocation error')
            error = .true.
          else
            output%gil%stokes(:) = input%gil%stokes(:)
          endif
        endif
      else if (input%gil%nstokes.gt.1) then
        ! Size matches and are non-zero...
        !DEBUG! Print *,'Copying Stokes ',ubound(output%gil%stokes)
        output%gil%stokes(:) = input%gil%stokes(:)
      endif
    endif
    !
  endif
  !
  ! Telescope information
!  if (input%gil%nteles.ne.0) then
!    write(chain,*) input%gil%nteles
!    call gio_message(seve%w,'GDF_COPY_HEADER','Copying '//trim(chain)//' telescope information')
!  endif
  !! Print *,'NTELES ',input%gil%nteles, ' output ',output%gil%nteles
  ! Would also need to copy the Telescope data
  if (output%gil%nteles.ne.input%gil%nteles) then
    if (allocated(output%gil%teles)) then
      deallocate(output%gil%teles, stat=ier)
      if (ier.ne.0) then
        call gio_message(seve%w,'GDF_COPY_HEADER','Telescope deallocation error')
      endif
    endif
    if (input%gil%nteles.ne.0) then
      allocate(output%gil%teles(input%gil%nteles), stat=ier)
      if (ier.ne.0) then
        call gio_message(seve%e,'GDF_COPY_HEADER','Telescope allocation error')
        error = .true.
      else
        output%gil%teles(:) = input%gil%teles(:)
      endif
    endif
  else if (input%gil%nteles.gt.0) then
    output%gil%teles(:) = input%gil%teles(:)
  endif
  !
  ! Only copy what is defined otherwise
  save_type = output%gil%type_gdf  ! Save the requested type
  save_chain = output%gil%ijtyp
  call r4tor4(input%gil, output%gil, curlen)
  ! Restore it, but preserve the Transposition status...
  if (abs(save_type).ne.abs(output%gil%type_gdf)) then
    output%gil%type_gdf = save_type
    !!Print *,'Restoring desired destination type ',save_type, input%gil%type_gdf, output%gil%type_gdf
  else
    !!Print *,'Restoring initial transposition state ',save_type, input%gil%type_gdf, output%gil%type_gdf
  endif
  output%gil%ijtyp = save_chain
  if (abs(output%gil%type_gdf).eq.abs(code_gdf_uvt)) then
    call gdf_setuv(output,error)
  endif
  !
  if (input%mos%nfields.ne.0) then
    !
    write(chain,'(A,I0,A)') 'Copying ',input%mos%nfields,' Fields mosaic information'
    call gio_message(seve%d,'GDF_COPY_HEADER',chain)
    if (output%mos%nfields.ne.input%mos%nfields) then
      if (allocated(output%mos%fields)) deallocate(output%mos%fields)      
      allocate(output%mos%fields(input%mos%nfields))
      output%mos%nfields = input%mos%nfields
    endif
    do ifi = 1,input%mos%nfields
      output%mos%fields(ifi) = input%mos%fields(ifi)
    enddo
  endif
end subroutine gdf_copy_gil

subroutine compare_comm(line,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER
  !   Support for command COMPARE Left Right [/DIRECTORY <top]  
  !   and COMPARE ? or COMPARE ??
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  logical, intent(inout) :: error            !! Error flag
  !
  ! Constants
  integer, parameter :: o_dir=1
  character(len=*), parameter :: rname='COMPARE'
  integer, parameter :: mvoc=4
  character(len=8) :: argum, vocab(mvoc), key
  data vocab /'LEFT','RIGHT','JOINT','EACH'/
  !
  ! Local
  type(sic_descriptor_t) :: ldesc, rdesc
  character(len=256) :: chain
  character(len=64), save :: cleft, cright
  character(len=4) :: trail
  integer :: i, n, narg, ikey
  logical, save :: todo=.true.
  logical, save :: is2d=.false.
  logical :: found, do_insert
  !
  ! Code
  do_insert = (sic_lire().eq.0)
  narg = sic_narg(0)
  trail = ' '
  if (narg.eq.1) then
    call sic_ch(line,0,1,chain,i,.true.,error)
    if (error) return
    if ((chain.eq.'?').or.(chain.eq.'??')) then
      call exec_program('@ i_compare '//chain)
      return
    else
      call sic_ke(line,0,1,argum,n,.true.,error)
      call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
      if (error) return
      trail(2:3) = key(1:2)
    endif
  endif
  !
  if ((narg.gt.1).or.todo) then
    todo = .true.
    if (narg.gt.2) then
      call sic_ke(line,0,3,argum,n,.true.,error)
      call sic_ambigs (rname,argum,key,ikey,vocab,mvoc,error)
      if (error) return
      trail(2:3) = key(1:2)
    endif
    ! Define CMP_LEFT or CMP_RIGHT if any argument is a File
    ! or dataset imported in Cube
    call compare_comm_args(line,cleft,cright,error)
    if (error) return
    !
    call sic_descriptor(cleft,ldesc,found)
    if ((ldesc%ndim.eq.3).and.(ldesc%dims(3).eq.1)) ldesc%ndim = 2
    call sic_descriptor(cright,rdesc,found)
    if ((rdesc%ndim.eq.3).and.(rdesc%dims(3).eq.1)) rdesc%ndim = 2
    !
    if ( (ldesc%ndim.eq.2).and.(rdesc%ndim.eq.2) ) then
      is2d = .true.
    else 
      is2d = .false.
    endif
    if (sic_varexist('CMP%FIRST')) call exec_program('LET CMP%FIRST YES')
    !!Print *,'Is 2D ? ',is2d,' Left ',ldesc%dims(1:ldesc%ndim),' Right ',rdesc%dims(1:rdesc%ndim)
    !
  endif
  !
  todo = .false.
  call get_topdir(line,o_dir)
  call exec_program('@ p_clear')
  !
  if (is2d) then  
    call exec_program('@ p_compare_map '//trim(cleft)//' '//trim(cright)//trail)
  else
    call exec_program('@ p_compare_sub '//trim(cleft)//' '//trim(cright)//trail)
  endif
  !
  if (do_insert) call sic_insert_log(line)
end subroutine compare_comm
!
subroutine compare_comm_args(line,cleft,cright,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for command COMPARE Left Right [/DIRECTORY <top]
  !   and COMPARE ? or COMPARE ??
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(out) :: cleft     !! Left variable name
  character(len=*), intent(out) :: cright    !! Right variable name
  logical, intent(out) :: error              !! Error flag
  !
  ! Constants
  integer, parameter :: o_dir=1
  character(len=*), parameter :: rname='COMPARE'
  !
  ! Local ---
  character(len=filename_length) :: leftfile, rightfile
  integer :: n, ileft, iright
  type(gildas), save :: hleft, hright
  !
  ! Code ----
  call sic_ch(line,0,1,leftfile,n,.true.,error)
  if (error) return
  cleft = 'CMP_LEFT'
  call sub_load_var(rname,line,leftfile,cleft,ileft,error)
  if (error) return
  !
  call sic_ch(line,0,2,rightfile,n,.true.,error)
  if (error) return
  cright = 'CMP_RIGHT'
  call sub_load_var(rname,line,rightfile,cright,iright,error)
  if (error) return
  !
  if (ileft.eq.2) call read_and_map(cleft,hleft,leftfile,error)
  if (iright.eq.2) call read_and_map(cright,hright,rightfile,error)
end subroutine compare_comm_args
!
subroutine read_and_map(name,head,file,error)
  use gkernel_types
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, only : map_message
  !*
  ! IMAGER -- Utility routine 
  !   Read a data cube and define an associated SIC variable
  !!
  character(len=*), intent(in) :: name      !! SIC Variable name
  character(len=*), intent(inout) :: file   !! Data file
  type(gildas), intent(inout) :: head       !! Data cube header
  logical, intent(out) :: error             !! Logical error flag
  !
  character(len=*), parameter :: rname='COMPARE'
  logical :: err
  integer :: ier
  !
  err = .false.
  error = .false.
  ier = 0
  if (associated(head%r3d)) deallocate(head%r3d,stat=ier)
  if (ier.ne.0) call map_message(seve%w,rname,'Deallocation error')
  call gildas_null(head)
  call gdf_read_gildas(head, file,' ', error, data=.false.)
  if (error) return
  !
  if (product(head%gil%dim(4:)).gt.1) then
    call map_message(seve%e,rname,'Only Maps and Cubes supported')
    call gdf_close_image(head,err)
    error = .true.
    return
  endif
  !
  allocate(head%r3d(head%gil%dim(1),head%gil%dim(2),   &
   &        head%gil%dim(3)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%w,rname,'Data Allocation error')
    call gdf_close_image(head,err)
    error = .true.
    return
  endif
  call gdf_read_data(head,head%r3d,error)
  call gdf_close_image(head,err)
  if (error) return
  if (product(head%gil%dim(3:)).le.1) head%gil%ndim = 2
  call sic_mapgildas (name,head,error,head%r3d)
  !  
end subroutine read_and_map
!
subroutine sub_load_var(comm,line,arg,varname,iscode,error)
  use gkernel_interfaces
  use gkernel_types
  use gbl_message
  use clean_default
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- Support for (implicit) LOAD command
  !
  !     "Load"  ?|File.ext|InVAR|CubeName|CubeNumber (as) OutVAR
  !
  !   Support for command COMPARE, VIEW, SHOW, etc...
  !!
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: comm       !! Caller
  character(len=*), intent(inout) :: line    !! Command line
  character(len=*), intent(inout) :: arg     !! Argument
  character(len=*), intent(inout) :: varname !! Desired / Returned name
  integer, intent(out) :: iscode             !! 0-4
  logical, intent(out) :: error              !! Error flag
  !
  ! Constants 
  integer, parameter :: is_help=0
  integer, parameter :: is_varname=1
  integer, parameter :: is_filename=2
  integer, parameter :: is_cubename=3
  integer, parameter :: is_cubeid=4
  character(len=*), parameter :: rname='LOAD'
  character(len=8) :: name(4)
  data name /'VARIABLE','FILE','CUBENAME','CUBEID'/
  !
  ! Local ---
  character(len=filename_length) :: chain
  character(len=filename_length) :: file
  character(len=32) :: argu
  integer :: n,na,ier,nline,lc
  !
  logical :: found
  !
  ! Code ----
  error = .false.
  iscode = is_help
  if (arg.eq.'?'.or.arg.eq.'??') return
  !
  chain = arg
  n = len_trim(chain)
  !
  if (index(chain,'.').ne.0) then
    !
    ! Discard the default image
    if (sic_varexist(varname)) call sic_delvariable(varname,.false.,error)
    found = sic_findfile(chain,file,' ',' ')
    if (.not.found) then
      call map_message(seve%e,rname,'No such file '//trim(file))
      error = .true.
      return
    else
      iscode = is_filename
      arg = file        ! Return the file name
    endif
  else if (chain(n:n).eq.':') then
    iscode = is_cubename
    file = '@ cube_load '//chain(1:n-1)//' '//trim(varname)
  else
    call sic_upper(chain)
    lc = len_trim(chain)
    if (chain(lc:lc).eq.'%') then
      ! A structure, with possibly %DATA array variable
      if (sic_varexist(chain(lc-1:lc-1))) then
        varname = chain
        iscode = -1
        Print *,chain(1:lc)//'%DATAs exists'
      endif
    else if (sic_varexist(chain)) then
      iscode = is_varname
      varname = chain
    else
      read(chain,*,iostat=ier) na
      if ((ier.eq.0).and.(na.gt.0)) then
        ! This is a positive integer, possibly a Cube index
        write(file,'(A,I0,1X,A)') '@ cube_load +',na,trim(varname)
        iscode = is_cubeid
      else
        error = .false.
      endif
    endif
  endif
  !
  select case (iscode)
  case (0)
    call map_message(seve%e,comm,'No such Buffer or SIC variable ' &
    & //trim(arg))
    error =.true.
  case (is_cubename,is_cubeid)
    call exec_program(file)
    ! Reset the command line pointers
    nline = len_trim(line)
    argu = comm
    call sic_analyse(argu,line,nline,error) ! Reset command line pointers
    error = ImagerError
  end select
  if (error) return
  call map_message(seve%i,comm,'Loading '//trim(arg)//' as a '//name(iscode)//' '//trim(varname))
end subroutine sub_load_var

subroutine greg_show(line,error)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_show
  use greg_kernel
  use greg_pen
  use greg_axes
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !  GREG  Support routine for command
  !  SHOW
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Logical error flag
  ! Global
  include 'gbl_pi.inc'
  ! Local
  character(len=*), parameter :: rname='SHOW'
  integer :: i,j,nc
  logical :: all
  character(len=16) :: chain
  character(len=2) :: what
  character(len=14) :: angu(4),syst(5)
  character(len=message_length) :: mess
  ! Data
  data syst/'UNKNOWN','EQUATORIAL','GALACTIC','HORIZONTAL','ICRS'/
  data angu/'SECOND','MINUTE','DEGREE','RADIAN'/
  !
  error = .true.               ! Will be resetted by any SHOW
  chain = 'WHere'              ! Default
  call sic_ke (line,0,1,chain,nc,.false.,error)
  if (error) return
  all = (chain(1:2).eq.'AL' .or. chain.eq.'*')
  what = chain(1:2)
  !
  ! Accuracy
  if (all.or.what.eq.'AC') then
    write(mess,100) 'Accuracy ',accurd
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! ANgle
  if (all.or.what.eq.'AN') then
    if (gproj%type.ne.p_none) then
      write(mess,102) 'Angle Unit ',angu(u_angle)
    else
      write(mess,102) 'Angle Unit ','NOT CHECKED'
    endif
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! AXis
  if (all.or.what.eq.'AX') then
    if (axis_xdecim_brief) then
      write(mess,111) 'Axis ','XDECIMAL','BRIEF'
    else
      write(mess,111) 'Axis ','XDECIMAL','NOBRIEF'
    endif
    call greg_message(seve%r,rname,mess)
    !
    if (axis_ydecim_brief) then
      write(mess,111) 'Axis ','YDECIMAL','BRIEF'
    else
      write(mess,111) 'Axis ','YDECIMAL','NOBRIEF'
    endif
    call greg_message(seve%r,rname,mess)
    !
    if (axis_xsexag_brief) then
      write(mess,111) 'Axis ','XSEXAGESIMAL','BRIEF'
    else
      write(mess,111) 'Axis ','XSEXAGESIMAL','NOBRIEF'
    endif
    call greg_message(seve%r,rname,mess)
    !
    if (axis_ysexag_brief) then
      write(mess,111) 'Axis ','YSEXAGESIMAL','BRIEF'
    else
      write(mess,111) 'Axis ','YSEXAGESIMAL','NOBRIEF'
    endif
    call greg_message(seve%r,rname,mess)
    !
    if (.not.all) return
  endif
  !
  ! BLanking
  if (all.or.what.eq.'BL') then
    if (eblank.lt.0) then
      write(mess,102) 'Blanking ','TURNED OFF'
      call greg_message(seve%r,rname,mess)
    else
      write(mess,106) 'Blanking value    ',cblank
      call greg_message(seve%r,rname,mess)
      write(mess,106) 'Blanking tolerance',eblank
      call greg_message(seve%r,rname,mess)
    endif
    if (.not.all) return
  endif
  !
  ! CEntering
  if (all.or.what.eq.'CE') then
    write(mess,101) 'Centering option ',icente
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! CHaracter size
  if (all.or.what.eq.'CH') then
    write(mess,100) 'Character size ',cdef
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! COordinate system
  if (all.or.what.eq.'CO') then
    if (iboxd.eq.-1) then
      write(mess,102) 'Coordinate system','USER'
      call greg_message(seve%r,rname,mess)
    else
      i = mod(iboxd,10)
      j = iboxd/10
      if (j.eq.0) then
        write(mess,102) 'Coordinate system','BOX',i
      else
        write(mess,102) 'Coordinate system','CHARACTER',i
      endif
      call greg_message(seve%r,rname,mess)
    endif
    if (.not.all) return
  endif
  !
  ! DEcimal or SExagesimal
  if (all.or.what.eq.'SE'.or.what.eq.'DE') then
    if (xsixty.ne.format_decimal) then
      write(mess,102) 'X labelling is ','SEXAGESIMAL with ',ndecimx,' decimals'
    else
      write(mess,102) 'X labelling is ','DECIMAL'
    endif
    call greg_message(seve%r,rname,mess)
    if (ysixty.ne.format_decimal) then
      write(mess,102) 'Y labelling is ','SEXAGESIMAL with ',ndecimy,' decimals'
    else
      write(mess,102) 'Y labelling is ','DECIMAL'
    endif
    call greg_message(seve%r,rname,mess)
  endif
  !
  ! EXpansion factor for characters and symbols
  if (all.or.what.eq.'EX') then
    write(mess,100) 'Expansion factor ',expand
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! FOnt of characters
  if (all.or.what.eq.'FO') then
    if (i_font.eq.0) then
      write(mess,102) 'Character font ','SIMPLEX'
    else
      write(mess,102) 'Character font ','DUPLEX'
    endif
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! BOx location
  if (all.or.what.eq.'BO'.or.what.eq.'VI') then
    write(mess,100) 'Box Location ',gx1,gx2,gy1,gy2
    call greg_message(seve%r,rname,mess)
    write(mess,100) 'View Port    ',gx1/(lx2-lx1),gx2/(lx2-lx1), &
      gy1/(ly2-ly1),gy2/(ly2-ly1)
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! PLot_PAge size
  if (all .or. what.eq.'PA' .or. what.eq.'PL') then
    write(mess,100) 'Plot page size ',lx2-lx1,ly2-ly1
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! MArker style and size
  if (all.or.what.eq.'MA') then
    write(mess,101) 'Marker type  ',nsides,istyle
    call greg_message(seve%r,rname,mess)
    write(mess,100) 'Marker size  ',csymb
    call greg_message(seve%r,rname,mess)
    write(mess,100) 'Marker angle ',sangle
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! Orientation of characters
  if (all.or.what.eq.'OR') then
    write(mess,100) 'Orientation of Text    ',tangle
    call greg_message(seve%r,rname,mess)
    write(mess,100) 'Orientation of Markers ',sangle
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! Projection
  if (all.or.what.eq.'PR') then
    if (gproj%type.ne.p_none) then
      write (mess,110) projnam(gproj%type),gproj%angle*180.d0/pi
      call sexfor(0.d0,0.d0)
    else
      write (mess,102) 'Projection','DISABLED'
    endif
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! SYstem
  if (all.or.what.eq.'SY') then
    write(mess,102) 'System is ',syst(i_system)
    if (i_system.eq.type_eq) then
      if (i_equinox.eq.equinox_null) then
        write(mess,'(A,1X,A)')  trim(mess),'(equinox unset)'
      else
        write(mess,'(A,1X,F0.1)')  trim(mess),i_equinox
      endif
    endif
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! TIck size
  if (all.or.what.eq.'TI') then
    write(mess,100) 'Tick size ',ctick
    call greg_message(seve%r,rname,mess)
    write(mess,107) 'Tick space',smallx,bigx
    call greg_message(seve%r,rname,mess)
    write(mess,108) 'Tick space',smally,bigy
    call greg_message(seve%r,rname,mess)
    if (.not.all) return
  endif
  !
  ! PEn attributes
  if (all.or.what.eq.'PE') then
    write(mess,*) ' PEN    Dashed    Weight    Colour'
    call greg_message(seve%r,rname,mess)
    do i=0,maxpen
      if (i.eq.cpen) then
        write(mess,103) i,ldashe(i),gtv_penwei_tostr(lweigh(i)),  &
          gtv_pencol_id2name(lcolou(i)),'(Current pen)'
      else
        write(mess,103) i,ldashe(i),gtv_penwei_tostr(lweigh(i)),  &
          gtv_pencol_id2name(lcolou(i))
      endif
      call greg_message(seve%r,rname,mess)
    enddo
    if (.not.all) return
  endif
  !
  ! WHere is the pen. Synonym for SHOW LImits.
  if (all .or. what.eq.'WH' .or. what.eq.'LI') then
    call show_limits(line,error)
    if (error)  return
    if (.not.all) return
  endif
  !
  if (.not.all) then
    call greg_message(seve%e,rname,'Argument not understood: '//chain)
    error = .true.
    return
  endif
  !
  return
100 format(a,t25,4(f8.3,2x))
101 format(a,t24,4(i6,4x))
102 format(a,t29,a,i2,a)
103 format(1x,2(i3,6x),a,2x,a,2x,a)
106 format(a,t25,1pg11.4)
107 format(a,t29,'X  Small ',1pg16.8,'    Big ',1pg16.8)
108 format(a,t29,'Y  Small ',1pg16.8,'    Big ',1pg16.8)
110 format('Projection ',t29,a,' at angle ',f12.6,' from center')
111 format(a,t24,a12,1x,a)
end subroutine greg_show
!
subroutine show_limits(line,error)
  use phys_const
  use gbl_constant
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>show_limits
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='SHOW'
  integer(kind=4) :: w_angle,n,nc
  real(kind=8) :: uxp,uyp,uxp2,uyp2,x1,x2,y1,y2,abstmp,reltmp
  character(len=12) :: cuxp,cuyp,cx1,cx2,cy1,cy2
  character(len=message_length) :: mess
  integer(kind=4), parameter :: nangu=5
  character(len=8) :: angu(nangu),dummy,uname
  ! Data
  data angu/'SECOND','MINUTE','DEGREE','RADIAN','ABSOLUTE'/
  !
  if (gproj%type.eq.p_none .and. sic_present(0,2)) then
    call greg_message(seve%w,rname,  &
      'No projection defined, default to user units')
  endif
  !
  w_angle = u_angle
  if (axis_xlog) then
    uxp = exp((xp-gx1)/gux + lux)
  else
    uxp = (xp-gx1)/gux + gux1
  endif
  if (axis_ylog) then
    uyp = exp((yp-gy1)/guy + luy)
  else
    uyp = (yp-gy1)/guy + guy1
  endif
  !
  write(mess,104)
  call greg_message(seve%r,rname,mess)
  !
  write(cuxp,99) xp
  write(cuyp,99) yp
  write(cx1,99)  gx1
  write(cx2,99)  gx2
  write(cy1,99)  gy1
  write(cy2,99)  gy2
  write(mess,105) 'Plot',cuxp,cuyp,cx1,cx2,cy1,cy2
  call greg_message(seve%r,rname,mess)
  !
  if (gproj%type.ne.p_none) then
    if (sic_present(0,2))then
      call sic_ke (line,0,2,dummy,nc,.true.,error)
      if (error) return
      call sic_ambigs(rname,dummy,uname,n,angu,nangu,error)
      if (error) then
        call greg_message(seve%e,rname,'Wrong expected angle type')
        return
      endif
      w_angle=n
    endif
    if (w_angle.eq.u_degree) then
      uname = 'Degrees'
      write(cuxp,99) uxp*180.0d0/pi
      write(cuyp,99) uyp*180.0d0/pi
      write(cx1,99)  gux1*180.0d0/pi
      write(cx2,99)  gux2*180.0d0/pi
      write(cy1,99)  guy1*180.0d0/pi
      write(cy2,99)  guy2*180.0d0/pi
    elseif (w_angle.eq.u_minute) then
      uname = 'Minutes'
      write(cuxp,99) uxp*1.08d4/pi
      write(cuyp,99) uyp*1.08d4/pi
      write(cx1,99)  gux1*1.08d4/pi
      write(cx2,99)  gux2*1.08d4/pi
      write(cy1,99)  guy1*1.08d4/pi
      write(cy2,99)  guy2*1.08d4/pi
    elseif (w_angle.eq.u_second) then
      uname = 'Seconds'
      write(cuxp,99) uxp*6.48d5/pi
      write(cuyp,99) uyp*6.48d5/pi
      write(cx1,99)  gux1*6.48d5/pi
      write(cx2,99)  gux2*6.48d5/pi
      write(cy1,99)  guy1*6.48d5/pi
      write(cy2,99)  guy2*6.48d5/pi
    elseif (w_angle.eq.u_radian) then
      uname = 'Radians'
      write(cuxp,99) uxp
      write(cuyp,99) uyp
      write(cx1,99) gux1
      write(cx2,99) gux2
      write(cy1,99) guy1
      write(cy2,99) guy2
    else
      uname = 'Absolute'
      call rel_to_abs(gproj,uxp,uyp,uxp2,uyp2,1)
      ! In order to be symetric to LIMITS ... ABSOLUTE, we must display the
      ! coordinates of the middle of the box sides.
      reltmp = (gux1+gux2)/2.d0
      call rel_to_abs(gproj,reltmp,guy1,abstmp,y1,1)
      call rel_to_abs(gproj,reltmp,guy2,abstmp,y2,1)
      reltmp = (guy1+guy2)/2.d0
      call rel_to_abs(gproj,gux1,reltmp,x1,abstmp,1)
      call rel_to_abs(gproj,gux2,reltmp,x2,abstmp,1)
      if (i_system.eq.type_eq .or. i_system.eq.type_ic) then
        call sexag(cuxp,uxp2,24)
        call sexag(cx1,x1,24)
        call sexag(cx2,x2,24)
      else
        call sexag(cuxp,uxp2,360)
        call sexag(cx1,x1,360)
        call sexag(cx2,x2,360)
      endif
      call sexag(cuyp,uyp2,360)
      call sexag(cy1,y1,360)
      call sexag(cy2,y2,360)
    endif
  else
    uname = 'User'
    write(cuxp,99) uxp
    write(cuyp,99) uyp
    write(cx1,99) gux1
    write(cx2,99) gux2
    write(cy1,99) guy1
    write(cy2,99) guy2
  endif
  write(mess,105)  uname,cuxp,cuyp,cx1,cx2,cy1,cy2
  call greg_message(seve%r,rname,mess)
  !
  if (axis_xlog) then
    write(mess,102) 'X axis scale is','LOGARITHMIC'
    call greg_message(seve%r,rname,mess)
  endif
  if (axis_ylog) then
    write(mess,102) 'Y axis scale is','LOGARITHMIC'
    call greg_message(seve%r,rname,mess)
  endif
  !
102 format(a,t29,a,i2,a)
104 format(  t9,'|---- Current X and Y ----|----------------- X and Y ranges ------------------')
105 format(a,t9,'|',a,1x,a,               '|',4(a,1x))
99  format(1pg11.4)
end subroutine show_limits

subroutine gwrite(val,x,y)
  use greg_interfaces, except_this=>gwrite
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! GREG	Internal routine
  !	This subroutine writes the value VAL at location X,Y in User
  ! 	Coordinates. VAL is encoded in shortest format.
  ! Arguments :
  !	VAL	R*4	Value to be encoded
  !	X	R*4	X coordinate
  !	Y	R*4	Y coordinate
  !---------------------------------------------------------------------
  real*4 :: val                     !
  real*4 :: x                       !
  real*4 :: y                       !
  ! Local
  character(len=24) :: chain
  character(len=20) :: string
  !
  integer :: nchar
  character(len=1), parameter :: backslash=char(92)
  !
  call conecd (val,string,nchar)
  call grelocate(y,x)
  nchar = nchar+3
  chain = backslash//backslash//'1'//string
  call putlabel(nchar,chain,5,tangle,.false.)
end subroutine gwrite
!
subroutine conecd (arg,string,ns)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>conecd
  !---------------------------------------------------------------------
  ! @ private
  ! GREG	Internal routine
  !	Encode the ARG value in the string STRING in the shortest
  !	possible format
  ! Arguments :
  !	ARG	R*4	Value to be encoded
  !	STRING	C*(*)	String to receive the coded value
  !	NS	I	Length of string
  ! Subroutines :
  !	(SIC)
  !---------------------------------------------------------------------
  real :: arg                       !
  character(len=*) :: string        !
  integer :: ns                     !
  ! Local
  character(len=1), parameter :: dot='.'
  character(len=2) :: buf1, buf2
  character(len=3) :: fspec
  character(len=20) :: fmt
  logical :: llfixe
  !
  integer :: nfig,nfield,iexpo,ndec,nchar,nplace
  real :: value,expo
  !
  nfig = 3
  nfield = 10
  !
  value = abs(arg)
  if (value.eq.0) then
    string='0.0'
    ns=1
    return
  elseif (value.lt.1e6.and.value.gt.1e-4) then
    expo = alog10(value)
    iexpo = ifix(expo)
    if (expo.lt.0) iexpo = iexpo - 1
    ndec = max(nfig-iexpo-1,0)
    nchar = ndec + 2 + max(iexpo+1,0)
    fspec = '0PF'
    llfixe=.true.
  else
    ndec = nfig - 1
    nchar = nfig + 6
    fspec = '1PE'
    llfixe=.false.
  endif
  nplace = max(nchar,nfield)
  write(buf1,1000) nplace
  write(buf2,1000) ndec
  fmt = '('//fspec//buf1//dot//buf2//')'
  write(string,fmt) arg
  ns = len(string)
  call sic_blanc(string,ns)
  !
  ! Fixed Format: Strip trailing zeroes and decimal point if needed
  if (llfixe) then
    do while (string(ns:ns).eq.'0')
      ns=ns-1
    enddo
    if (string(ns:ns).eq.dot) ns=ns-1
  endif
1000 format(i2)
end subroutine conecd

subroutine define_imager_vars (error)
  use gildas_def
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_support
  use clean_beams
  use grid_control
  !----------------------------------------------------
  !! IMAGER -- Define internal SIC variables
  !----------------------------------------------------
  logical :: error    !! Logical error flag
  !
  ! Local ---
  logical :: warning
  integer :: ier
  integer(kind=index_length) :: dim(4) = 0
  ! 
  ! Code ----
  !
  ! CLEAN program variables
  clean_stop = ' '
  call sic_def_charn('CLEAN_STOP',clean_stop,1,2,.false.,error)
  user_method%m_iter = 0
  call sic_def_inte ('NITER',user_method%m_iter,0,dim,.false.,error)
  call sic_def_inte ('CLEAN_NITER',user_method%m_iter,0,dim,.false.,error)
  user_method%p_iter = 0
  call sic_def_inte ('CLEAN_POSITIVE',user_method%p_iter,0,dim,.false.,error)
  user_method%n_major = 50
  call sic_def_inte ('CLEAN_NCYCLE',user_method%n_major,0,dim,.false.,error)
  user_method%gain = 0.2
  call sic_def_real ('GAIN',user_method%gain,0,dim,.false.,error)
  call sic_def_real ('CLEAN_GAIN',user_method%gain,0,dim,.false.,error)
  user_method%fres = 0.01
  call sic_def_real ('FRES',user_method%fres,0,dim,.false.,error)
  call sic_def_real ('CLEAN_FRES',user_method%fres,0,dim,.false.,error)
  user_method%ares = 0.0
  call sic_def_real ('ARES',user_method%ares,0,dim,.false.,error)
  call sic_def_real ('CLEAN_ARES',user_method%ares,0,dim,.false.,error)
  user_method%converge = 0
  call sic_def_inte ('CLEAN_NKEEP',user_method%converge,0,dim,.false.,error)
  user_method%spexp = 1.0
  call sic_def_real ('CLEAN_SPEEDY',user_method%spexp,0,dim,.false.,error)
  user_method%ngoal = 10000
  call sic_def_inte ('CLEAN_NGOAL',user_method%ngoal,0,dim,.false.,error)
  !
  ! MultiScale
  user_method%nker = (/1,7,13,19,25/) ! & dim 3 or 5 do not work 
  user_method%nker = (/1,7,11,19,25/) ! Need to have at most 11 as 3rd value
  dim(1) = 3 ! or 5, but 5 is dangerous
  call sic_def_inte ('CLEAN_KERNEL',user_method%nker,1,dim,.false.,error)
  user_method%ninflate = 169   ! Safe method for 2 scale, but uses Memory...
  call sic_def_inte ('CLEAN_INFLATE',user_method%ninflate,0,0,.false.,error)
  user_method%smooth = sqrt(3.0)
  call sic_def_real ('CLEAN_SMOOTH',user_method%smooth,0,dim,.false.,error)
  user_method%worry = 0.0
  call sic_def_real ('CLEAN_WORRY',user_method%worry,0,dim,.false.,error)
  ! MultiGauss
  user_method%nscale = 0
  call sic_def_inte ('CLEAN_NSCALE',user_method%nscale,0,0,.false.,error)
  dim(1) = clean_mscale
  user_method%gsize = 0.
  call sic_def_real ('CLEAN_SCALES',user_method%gsize,1,dim,.false.,error)
  !
  ! Search area
  dim(1) = 2
  user_method%blc = 0
  call sic_def_inte ('BLC',user_method%blc,1,dim,.false.,error)
  user_method%trc = 0
  call sic_def_inte ('TRC',user_method%trc,1,dim,.false.,error)
  !
  ! Beam fitting
  user_method%thresh = 0.35
  call sic_def_real ('CLEAN_SIDELOBE',user_method%thresh,0,dim,.false.,error)
  beam_size = 0.0
  dim(1) = 3
  call sic_def_real ('BEAM_SIZE',beam_size,1,dim,.false.,error)
  call sic_def_real ('BEAM_TOLERANCE',beam_tolerance,0,dim,.false.,error)
  !
  !  call sic_def_real ('MAJOR',beam,0,dim,.false.,error)
  !  call sic_def_real ('MINOR',minor_sec,0,dim,.false.,error)
  ! Delete the ANGLE variable defined by define.greg 
  call sic_delvariable('ANGLE',.true.,warning)
  !
  ! Restoration
  user_method%residual = 0
  call sic_def_inte ('CLEAN_RESIDUAL',user_method%residual,0,dim,.false.,error)
  !
  ! MRC
  user_method%ratio = 0
  call sic_def_real ('CLEAN_RATIO',user_method%ratio,0,dim,.false.,error)
  call sic_def_real ('CLEAN_DMIN',d_min,0,dim,.false.,error)
  call sic_def_real ('CLEAN_DMAX',d_max,0,dim,.false.,error)
  !
  ! Mosaic mode
  user_method%search = 0.2
  call sic_def_real ('CLEAN_SEARCH',user_method%search,0,dim,.false.,error)
  ! Sky restoration threshold (CLEAN on Mosaics, or PRIMARY)
  user_method%restor = 0.2
  call sic_def_real ('CLEAN_TRUNCATE',user_method%restor,0,dim,.false.,error)
  ! Delete the MOSAIC variable defined by define.greg (if any) 
  call sic_delvariable('MOSAIC',.true.,warning)
  user_method%mosaic = .false.
  call sic_def_real ('MOSAIC_TOLERANCE',mosaic_tolerance,0,dim,.false.,error)
  call sic_def_logi ('MOSAIC_ACTIVE',user_method%mosaic,.false.,error)
  call sic_def_inte ('MOSAIC_ENLARGE',mosaic_enlarge,0,dim,.false.,error)
  call sic_def_real ('MOSAIC_FIELD',field_size,0,dim,.false.,error)
  call sic_def_real ('MOSAIC_GUARD',guard_size,0,dim,.false.,error)
  call sic_def_real ('MOSAIC_TRUNCATE',user_method%restor,0,dim,.false.,error)
  call sic_def_real ('MOSAIC_SEARCH',user_method%search,0,dim,.false.,error)
  call sic_def_real ('MOSAIC_BEAM',default_map%truncate,0,dim,.false.,error)
  call sic_def_char ('MOSAIC_MODE',mosaic_mode,.false.,error)
  !
  ! Printout level
  call sic_def_inte ('CLEAN_PRINT',multi_print,0,dim,.false.,error)
  !
  ! Rather obscure parameters
  ! Beam subset used in CLARK method
  dim(1) = 2
  user_method%patch = 0
  call sic_def_inte ('BEAM_PATCH',user_method%patch,1,dim,.false.,error)
  !
  user_method%verbose = .false.
  call sic_def_logi ('VERBOSE',user_method%verbose,.false.,error)
  ! Compact Array parameters
  cuse_method%gain = 0.4
  call sic_def_real ('C_GAIN',cuse_method%gain,0,dim,.false.,error)
  !
  ! UV_REWEIGHT result
  call sic_def_real ('UV_WEIGHT_SCALE',uv_weight_scale,0,dim,.false.,error)
  !
  ! UV_MAP variables
  nbeam_ranges = -1
  call sic_def_inte('NBEAM_RANGES',nbeam_ranges,0,dim,.false.,error)
  beam_gap = 3
  call sic_def_inte ('BEAM_GAP ',beam_gap,0,dim,.false.,error)
  default_map%precis = 0.1       ! Requested precision
  call sic_def_real ('MAP_PRECIS',default_map%precis,0,dim,.false.,error)
  default_map%beam = 0           ! Number of channels per beam
  call sic_def_inte ('BEAM_STEP',default_map%beam,0,dim,.false.,error)
  dim = [2,0,0,0]
  default_map%field = 0          ! Map field in arcsecond
  call sic_def_real ('MAP_FIELD',default_map%field,1,dim,.false.,error)
  default_map%size = 0           ! Map size in Pixels
  call sic_def_inte ('MAP_SIZE',default_map%size,1,dim,.false.,error)
  default_map%xycell = 0         ! Map cell size in arcsecond
  call sic_def_real ('MAP_CELL',default_map%xycell,1,dim,.false.,error)
  dim = [3,0,0,0]
  default_map%taper = 0          ! UV Taper in m and Degree
  call sic_def_real ('MAP_UVTAPER',default_map%taper,1,dim,.false.,error)
  default_map%taper(4) = 2       ! Taper exponent
  call sic_def_real ('MAP_TAPEREXPO',default_map%taper(4),0,dim,.false.,error)
  !
  default_map%uniform(1) = 0.0      ! UV cell size
  call sic_def_real ('MAP_UVCELL',default_map%uniform(1),0,dim,.false.,error)
  default_map%uniform(2) = 1.0      ! Robustness coefficient
  call sic_def_real ('MAP_ROBUST',default_map%uniform(2),0,dim,.false.,error)
  ! No longer used 
  ! default_map%mode = 'NATURAL'   ! Weighting mode
  ! call sic_def_char ('MAP_WEIGHT',default_map%mode,.false.,error)
  !
  default_map%truncate = 0.0       ! Truncation level (Primary beam in Mosaic)
  call sic_def_real ('MAP_TRUNCATE',default_map%truncate,0,dim,.false.,error)
  !
  default_map%ctype = 5    ! Convolution code
  call sic_def_inte ('MAP_CONVOLUTION',default_map%ctype,0,dim,.false.,error)
  !
  ! Recommended Values
  dim = [2,0,0,0]
  recmap_field = 0          ! Map field in arcsecond
  call sic_def_real ('REC_FIELD',recmap_field,1,dim,.false.,error)
  recmap_size = 0           ! Map size in Pixels
  call sic_def_inte ('REC_SIZE',recmap_size,1,dim,.false.,error)
  recmap_xycell = 0         ! Map cell size in arcsecond
  call sic_def_real ('REC_CELL',recmap_xycell,1,dim,.false.,error)
  recmap_uvcell = 0         ! Map cell size in arcsecond
  call sic_def_real ('REC_UVCELL',recmap_uvcell,0,0,.false.,error)
  !
  ! Old names for compatibility
  default_map%shift = .false.
  call sic_def_logi ('MAP_SHIFT',default_map%shift,.false.,error)
  default_map%ra_c = ' '   ! Weighting mode
  call sic_def_char ('MAP_RA',default_map%ra_c,.false.,error)
  default_map%dec_c = ' '   ! Weighting mode
  call sic_def_char ('MAP_DEC',default_map%dec_c,.false.,error)
  default_map%angle = 0.0      ! Robustness coefficient
  call sic_def_real ('MAP_ANGLE',default_map%angle,0,dim,.false.,error)
  !
  !   define logical uv_shift /global
  !   define integer convolution /global
  !   define double uv_cell[2] uv_taper[3] taper_expo /global
  old_map = default_map
  call sic_def_inte ('CONVOLUTION',old_map%ctype,0,dim,.false.,error)
  call sic_def_logi ('UV_SHIFT',old_map%shift,.false.,error)
  old_map%mode = 'NATURAL'     ! Make sur this matches define.map
  call sic_def_char ('WEIGHT_MODE',old_map%mode,.false.,error)
  dim = [2,0,0,0]
  old_map%uniform = [7.5,1.0]  ! Make sure this matches define.map
  call sic_def_real ('UV_CELL',old_map%uniform(1),1,dim,.false.,error)
  dim = [3,0,0,0]
  call sic_def_real ('UV_TAPER',old_map%taper,1,dim,.false.,error)
  call sic_def_real ('TAPER_EXPO',old_map%taper(4),0,dim,.false.,error)
  ! Initialize status
  save_map = old_map
  !
  ! File types and Extensions
  dim(1) = mtype
  call sic_def_charn('FILE_TYPE',vtype,1,dim,.true.,error)
  call sic_def_charn('FILE_EXT',etype,1,dim,.false.,error)
  !
  ! Delete the TYPE variable defined by define.greg and recreate it
  ! such as it maps 'display_type' - Actually only used by p_over.ima
  ! which is no longer accessible
  call sic_delvariable('TYPE',.true.,warning)
!  dim(1) = 0
  display_type = ' '  ! Make sure it is initialized
!  call sic_def_char('TYPE',display_type,.false.,error)
  !
  call gildas_null(hbeam)
  call gildas_null(hclean)
  call gildas_null(hresid)
  call gildas_null(hdirty)
  !
  call gildas_null(hprim)
  call gildas_null(huv, type = 'UVT')
  call gildas_null(huvi, type = 'UVT')
  call gildas_null(huvt, type = 'UVT')
  call gildas_null(huvm, type = 'UVT')
  call gildas_null(huvf, type = 'UVT')
  call gildas_null(hcct)
  call gildas_null(hmask)
  call gildas_null(hsky)
  call gildas_null(hview)
  call gildas_null(hsingle)
  !
  ! Read/Write Optimization
  rw_optimize = 0
  ier = sic_getlog ('MAPPING_OPTIMIZE',rw_optimize)
  call sic_def_inte('MAPPING_OPTIMIZE',rw_optimize,0,dim,.false.,error)
  !
  ! Debug
  call sic_defstructure('GRIDDING',.true.,error)
  call sic_def_logi('GRIDDING%WEIGHT',do_weig,.false.,error)
  call sic_def_inte('GRIDDING%BIG',grid_bigvisi,0,1,.false.,error)
  call sic_def_inte('GRIDDING%CELL',grid_subcell,0,1,.false.,error)
  call sic_def_inte('GRIDDING%MODE',grid_weighting,0,1,.false.,error)
  !
  ! Type of current UV_DATA
  call sic_def_char('CURRENT_UV',current_uvdata,.false.,error)
  !
  ! Default MAP_CENTER
  defmap_center = ' '
  call sic_def_char('MAP_CENTER',defmap_center,.false.,error)
  !
  ! SHOW structure
  call sic_defstructure('SHOW',.false.,error)
  call sic_defstructure('SHOW%NOISE',.false.,error)
  call sic_def_logi('show%noise%one',noise_one,.false.,error)
  noise_fit = .true.
  call sic_def_logi('show%noise%fit',noise_fit,.false.,error)
  noise_plot = .true.
  call sic_def_logi('show%noise%plot',noise_plot,.false.,error)
  noise_type = 0
  call sic_def_inte('show%noise%type',noise_type,0,dim,.false.,error)
end subroutine  define_imager_vars
!

subroutine setrem
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>setrem
  use greg_kernel
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! MAP	Computes the coordinates in the absolute system
  !	of the remarkable points of the projection
  !
  ! There are 6 privileged points
  !
  !	2------------4-------------6
  !	|                          |
  !	|                          |	RX,RY	Relative coordinates
  !	|                          |
  !	|                          |	AX,AY	Absolute coordinates
  !	|                          |
  !	1------------3-------------5
  !
  !
  ! En fait en cas d'angle non nul, la methode ci-dessus ne marche plus.
  ! Une astuce COLOSSALE consiste a considerer le plus petit cercle contenant
  ! le rectangle et centre sur le centre de projection. Ce cercle est la
  ! projection de points angulairement equidistants du centre de projection.
  ! Or, en projection GNOMONIC, les points d'elongations extremes
  ! correspondent aux tangentes au cercle passant par le pole.
  ! i.e.	Xgnom	= 	SQRT(Yg(POLE)**2 - D**2) * D / Yg(POLE)
  !	Ygnom	=	D**2 / Yg(POLE)
  ! Les coordonnees absolues s'en deduise trivialement
  !
  ! Pour la declinaison, le probleme est evident.
  !
  ! Bien sur tout ca ne marche pas avec les projections AITOFF et RADIO .
  !---------------------------------------------------------------------
  ! Global
  include 'gbl_pi.inc'
  ! Local
  real*8, parameter :: precision=1.0d-10
  real*8 :: c,w,ax1,ax2,ay1,ay2
  real*8 :: pradius,gradius,radius,gpole,sindec,sinp,sinr,cosr,cosp
  real*8 :: extra
  !
  if (gproj%type.eq.p_none) then
    ax1 = max(gux1,gux2)
    ax2 = min(gux1,gux2)
    ay1 = min(guy1,guy2)
    ay2 = max(guy1,guy2)
    axrem1 = ax1
    ayrem1 = ay1
    axrem2 = ax1
    ayrem2 = ay2
    axrem3 = 0
    ayrem3 = ay1
    axrem4 = 0
    ayrem4 = ay2
    axrem5 = ax2
    ayrem5 = ay1
    axrem6 = ax2
    ayrem6 = ay2
    ramin  = ax2
    ramax  = ax1
    decmin = ay1
    decmax = ay2
    return
  endif
  !
  ! NULL ANGLE CASE
  !----------------------------------------------------------------------
  if (abs(gproj%angle).le.precision) then
    ax1 = max(gux1,gux2)
    ax2 = min(gux1,gux2)
    ay1 = min(guy1,guy2)
    ay2 = max(guy1,guy2)
    !
    ! Gnomonic
    call rel_to_abs (gproj,ax1,ay1,axrem1,ayrem1,1)
    call rel_to_abs (gproj,ax1,ay2,axrem2,ayrem2,1)
    call rel_to_abs (gproj,0.d0,ay1,axrem3,ayrem3,1)
    call rel_to_abs (gproj,0.d0,ay2,axrem4,ayrem4,1)
    call rel_to_abs (gproj,ax2,ay1,axrem5,ayrem5,1)
    call rel_to_abs (gproj,ax2,ay2,axrem6,ayrem6,1)
    !
    ! Orthographic, Lambert and Azimuthal have a finite area
    if (gproj%type.eq.p_ortho) then
      w = ay2**2
      if (w.le.1.d0) then
        c = sqrt(1.d0-w)
        if (-c .gt. ax2) call rel_to_abs(gproj,-c,ay2,axrem6,ayrem6,1)
        if (c .lt. ax1) call rel_to_abs(gproj,c,ay2,axrem2,ayrem2,1)
      endif
      w = ay1**2
      if (w.le.1.d0) then
        c = sqrt(1.d0-w)
        if (-c .gt. ax2) call rel_to_abs(gproj,-c,ay1,axrem5,ayrem5,1)
        if (c .lt. ax1) call rel_to_abs(gproj,c,ay1,axrem1,ayrem1,1)
      endif
      if (ay1+1.d0 .le. 0.d0) ayrem3 = gproj%d0-pi*0.5d0
      if (ay2-1.d0 .ge. 0.d0) ayrem4 = gproj%d0+pi*0.5d0
      !
    elseif (gproj%type.eq.p_azimuthal) then
      w = ay2**2
      if (w.le.pi**2) then
        c = sqrt(pi**2-w)
        if (c .lt. ax2) call rel_to_abs(gproj,c,ay2,axrem6,ayrem6,1)
        if (-c .gt. ax1) call rel_to_abs(gproj,-c,ay2,axrem2,ayrem2,1)
      endif
      w = ay1**2
      if (w.le.pi**2) then
        c = sqrt(pi**2-w)
        if (c .lt. ax2) call rel_to_abs(gproj,c,ay1,axrem5,ayrem5,1)
        if (-c .gt. ax1) call rel_to_abs(gproj,-c,ay1,axrem1,ayrem1,1)
      endif
      if (ay1+0.5d0*pi .le. 0.d0) ayrem3 = gproj%d0-pi*0.5d0
      if (ay2-0.5d0*pi .ge. 0.d0) ayrem4 = gproj%d0+pi*0.5d0
      !
    elseif (gproj%type.eq.p_lambert) then
      w = ay2**2
      if (w.le.4) then
        c = sqrt(4-w)
        if (c .lt. ax2) call rel_to_abs(gproj,c,ay2,axrem6,ayrem6,1)
        if (-c .gt. ax1) call rel_to_abs(gproj,-c,ay2,axrem2,ayrem2,1)
      endif
      w = ay1**2
      if (w.le.4) then
        c = sqrt(4-w)
        if (c .lt. ax2) call rel_to_abs(gproj,c,ay1,axrem5,ayrem5,1)
        if (-c .gt. ax1) call rel_to_abs(gproj,-c,ay1,axrem1,ayrem1,1)
      endif
      if (ay1+1.0 .le. 0.d0) ayrem3 = gproj%d0-pi*0.5d0
      if (ay2-1.0 .ge. 0.d0) ayrem4 = gproj%d0+pi*0.5d0
    endif
    !
    ! Find RA min and RA max
    if (gproj%npole.ge.ay1 .and. gproj%npole.le.ay2) then
      if (gproj%spole.ge.ay1 .and. gproj%spole.le.ay2) then
        ramin = gproj%a0-pi
        ramax = gproj%a0+pi
        decmin = -0.5d0*pi
        decmax = 0.5d0*pi
        ipole = 3
      else
        ramin = gproj%a0-pi
        ramax = gproj%a0+pi
        ipole = 1
      endif
    elseif (gproj%spole.ge.ay1 .and. gproj%spole.le.ay2) then
      ramin = gproj%a0-pi
      ramax = gproj%a0+pi
      ipole = 2
    else
      ipole = 0
      ramin = min(axrem5,axrem6)
      ramax = max(axrem1,axrem2)
      ! This does not work...
      !            IF (RAMIN.GT.RAMAX) RAMIN = RAMIN-2.D0*PI
      ! So select the "equivalent" solution
      if (ramin.gt.ramax) ramax = ramax+2.d0*pi
    endif
    !
    ! Find DEC min and DEC max
    if (ipole.eq.1) then
      decmax = pi*0.5d0
      decmin = min(ayrem1,ayrem2,ayrem3,ayrem4,ayrem5,ayrem6)
    elseif (ipole.eq.2) then
      decmin = -pi*0.5d0
      decmax = max(ayrem1,ayrem2,ayrem3,ayrem4,ayrem5,ayrem6)
    elseif (ipole.ne.3) then
      decmin = min(ayrem1,ayrem3,ayrem5)
      decmax = max(ayrem2,ayrem4,ayrem6)
    endif
    return
  endif
  !----------------------------------------------------------------------
  !
  ! Case ANGLE not zero
  !
  ! Compute radius of projected circle
  pradius = sqrt(max(gux1**2,gux2**2)+max(guy1**2,guy2**2))
  if (gproj%type.eq.p_ortho) then
    if (pradius.lt.1.d0-precision) then
      radius = asin(pradius)
      gradius = tan(radius)
    else
      radius = 0.5d0*pi
      gradius = 1.d38
    endif
  elseif (gproj%type.eq.p_stereo) then
    radius = 2.d0*atan(pradius)
    gradius = tan(radius)
    if (gradius.lt.0.d0) gradius = 1.d38
  elseif (gproj%type.eq.p_azimuthal) then
    if (pradius.lt.pi-precision) then
      radius = pradius
      gradius = tan(radius)
    else
      radius = pi
      gradius = 1.d38
    endif
  elseif (gproj%type.eq.p_gnomonic) then
    radius = atan(pradius)
    gradius = pradius
  endif
  !
  ! Get right ascension extreme
  ! Get Gnomonic pole distance (1.D0/TAN(gproj%d0))
  if (abs(gproj%d0).gt.precision) then
    gpole = abs(1.d0/tan(gproj%d0))
  else
    gpole = 1.d38
  endif
  !
  if (gradius.gt.gpole-precision) then
    ramin = gproj%a0 - pi
    ramax = gproj%a0 + pi
  elseif (gpole.ne.1.d38) then
    if (radius.gt.precision) then
      sinr = sin(radius)
      cosr = cos(radius)
      !		p = atan2 (sqrt(1.d0-(gradius/gpole)**2)),gradius)
      !		cosp = cos(p)
      !		sinp = sin(p)
      cosp = abs(gradius/gpole)
      sinp = sqrt(1.d0-cosp**2)
      sindec = (abs(sin(gproj%d0))*cosr + cos(gproj%d0)*sinr*cosp)
      !		delta = asin (SINDEC)
      !	    	extra = asin ( sinr*sinp/cos(delta) )
      extra = asin ( sinr*sinp/sqrt(1.d0-sindec**2) ) + precision
    else
      extra = 2.d0*precision
    endif
    ramin = gproj%a0 - extra
    ramax = gproj%a0 + extra
  else
    extra = min(radius+precision,pi)   ! RADIUS pas PRADIUS....
    ramin = gproj%a0 - extra
    ramax = gproj%a0 + extra
  endif
  !
  ! Get declination extreme
  if (pradius.gt.abs(gproj%npole)-precision) then
    decmax = 0.5*pi
  else
    decmax = gproj%d0 + radius
  endif
  if (pradius.gt.abs(gproj%spole)-precision) then
    decmin = -0.5*pi
  else
    decmin = gproj%d0 - radius
  endif
end subroutine setrem

subroutine pencil(line,error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>pencil
  use greg_kernel
  use greg_pen
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !  PEN [I|*]
  !      [/COLOUR Name]
  !      [/DASHED ND]
  !      [/WEIGHT NW|Valmm]
  !      [/DEFAULT]
  ! Define the status of the pen(s) or change the default pen
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PENCIL'
  integer(kind=4) :: kpen,ipen,kdashe,kcolou,nc,first,last
  real(kind=4) :: kweigh
  character(len=argument_length) :: argum
  logical :: dodefau,dodashe,doweigh,docolou
  character(len=message_length) :: mess
  integer(kind=4), parameter :: allpen=-1000
  integer(kind=4), parameter :: optcolour =1
  integer(kind=4), parameter :: optdashed =2
  integer(kind=4), parameter :: optweight =3
  integer(kind=4), parameter :: optdefault=4
  !
  ! Pen index: no arg = current pen, * = all pen
  argum = ' '
  call sic_ch(line,0,1,argum,nc,.false.,error)
  if (error) return
  if (argum.eq.' ') then
    kpen = cpen
  elseif (argum.eq.'*') then
    kpen = allpen
  else
    call sic_math_inte(argum,nc,kpen,error)
    if (error) return
    if (kpen.lt.0 .or. kpen.gt.maxpen) then
      write(mess,'(A,I0,A,I0)') 'Pen number out of range ',0,':',maxpen
      call greg_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  endif
  !
  ! Parsing
  dodefau = sic_present(optdefault,0)
  dodashe = sic_present(optdashed,1)
  if (dodashe) then
    call gtv_pendash_arg2id(rname,line,optdashed,1,kdashe,error)
    if (error) return
  endif
  doweigh = sic_present(optweight,1)
  if (doweigh) then
    call gtv_penwei_arg2val(rname,line,optweight,1,kweigh,error)
    if (error)  return
  endif
  docolou = sic_present(optcolour,1)
  if (docolou) then
    call gtv_pencol_arg2id(rname,line,optcolour,1,kcolou,error)
    if (error)  return
  endif
  !
  ! Apply
  ! PEN /DEF (no pen number) historical behaviour is to reset and exit
  if (argum.eq.' ' .and. dodefau) then
    call setpendef()
    return
  endif
  !
  if (kpen.eq.allpen) then
    first = 0
    last = maxpen
  else
    first = kpen
    last = kpen
  endif
  !
  do ipen=first,last
    if (dodefau)  call setpendef(ipen)
    if (dodashe)  ldashe(ipen) = kdashe
    if (doweigh)  lweigh(ipen) = kweigh
    if (docolou)  lcolou(ipen) = kcolou
  enddo
  !
  ! Also change current pen?
  if (kpen.ne.allpen) then
    call gr_pen(ipen=kpen,error=error)
    if (error)  return
  endif
  !
end subroutine pencil
!
subroutine gr_pen(ipen,icolour,colour,idash,iweight,weight,error)
  use gbl_message
  use greg_interfaces, except_this=>gr_pen
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  ! This subroutine:
  !  - sets the pen to be used (if present) or uses the current pen, AND/OR
  !  - sets the new color (if present) of this pen, AND/OR
  !  - sets the new dashing (if present) of this pen, AND/OR
  !  - sets the new weight (if present) of this pen.
  ! All arguments are optional but at least 1 must be present
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in), optional :: ipen
  integer(kind=4),  intent(in), optional :: icolour  ! By Greg colour number OR
  character(len=*), intent(in), optional :: colour   ! By colour name
  integer(kind=4),  intent(in), optional :: idash
  integer(kind=4),  intent(in), optional :: iweight  ! By Greg weight number OR
  real(kind=4),     intent(in), optional :: weight   ! By weight value (cm)
  logical,          intent(inout)        :: error
  ! Local
  character(len=*), parameter :: rname='PEN'
  integer(kind=4) :: kpen,kcol
  character(len=message_length) :: mess
  real(kind=4) :: wei
  !
  ! Pen index
  if (present(ipen)) then
    kpen = ipen
    if (kpen.lt.0 .or. kpen.gt.maxpen) then
      write(mess,100) 'Pen number',0,maxpen
      call greg_message(seve%e,rname,mess)
      call greg_message(seve%e,rname,'Default pen not changed')
      error = .true.
      return
    endif
  else
    kpen = cpen
  endif
  !
  ! Colour index or name (exclusive)
  if (present(icolour) .and. present(colour)) then
    call greg_message(seve%e,rname,'Exclusive arguments ''icolour'' and ''colour''')
    error = .true.
    return
  endif
  if (present(icolour)) then
    call gtv_pencol_num2id(rname,icolour,kcol,error)
    if (error)  return
    lcolou(kpen) = kcol
  endif
  if (present(colour)) then
    call gtv_pencol_name2id(rname,colour,kcol,error)
    if (error)  return
    lcolou(kpen) = kcol
  endif
  !
  ! Dashed pattern
  if (present(idash)) then
    if (idash.lt.mindashed .or. idash.gt.maxdashed) then
      write(mess,100) 'Dashed pattern',mindashed,maxdashed
      call greg_message(seve%e,rname,mess)
      error = .true.
      return
    endif
    ldashe(kpen) = idash
  endif
  !
  ! Line thickness
  if (present(iweight) .and. present(weight)) then
    call greg_message(seve%e,rname,'Exclusive arguments ''iweight'' and ''weight''')
    error = .true.
    return
  endif
  if (present(iweight)) then
    call gtv_penwei_num2val(rname,iweight,wei,error)
    if (error)  return
    lweigh(kpen) = wei
  endif
  if (present(weight)) then
    if (weight.le.0.) then
      call gtv_message(seve%e,rname,'Weight value must be positive')
      error = .true.
      return
    endif
    lweigh(kpen) = weight
  endif
  !
  ! Update the globals
  cpen = kpen
  cdashe = ldashe(cpen)
  cweigh = lweigh(cpen)
  ccolou = lcolou(cpen)
  penupd = .true.
  !
100 format(A,' out of range ',I0,':',I0)
end subroutine gr_pen
!
subroutine setpendef(kpen)
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private
  !  Update all or single the pen attributes to their default, and
  ! reset the pen number
  !---------------------------------------------------------------------
  integer(kind=4), intent(in), optional :: kpen
  ! Local
  integer(kind=4) :: i,first,last,jpen
  !
  if (present(kpen)) then
    if (kpen.lt.0 .or. kpen.gt.maxpen)  return
    first = kpen
    last = kpen
    jpen = kpen
  else
    first = 0
    last = maxpen
    jpen = defpen  ! Also reset current pen to default
  endif
  !
  do i = first,last
    ldashe(i) = defdashe(i)
    lcolou(i) = defcolid(i)
    lweigh(i) = defweival(i)
  enddo
  !
  ! Update the globals
  cpen = jpen
  cdashe = ldashe(cpen)
  cweigh = lweigh(cpen)
  ccolou = lcolou(cpen)
  penupd = .true.
  !
end subroutine setpendef
!
subroutine greset
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ public
  ! Reset the current Pen position to "undefined"
  !---------------------------------------------------------------------
  !
  gxp = -1e10
  gyp = -1e10
  penupd = .true.
end subroutine greset

!
subroutine no_check_mask(method,head)
  use clean_def
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  ! 
  !! IMAGER  -- Dummy replacement for "check_mask"
  !---------------------------------------------------------------------
  type(gildas),    intent(in)    :: head   !
  type(clean_par), intent(inout) :: method !
  !
  Print *,'Called NO check_mask'
end subroutine no_check_mask
!
subroutine check_mask(amethod,head)
  use clean_def
  use image_def
  use gbl_message
  use gkernel_types
  use imager_interfaces, except_this=>check_mask
  use clean_support
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for CLEAN
  !
  !     Check that the search mask is defined, and computes its
  !     Box boundaries, returned in amethod%box
  !!
  !---------------------------------------------------------------------
  type(gildas),    intent(in)    :: head         !! Image   header
  type(clean_par), intent(inout) :: amethod      !! Clean method parameters
  !
  character(len=10) :: rname = 'CHECK_MASK'
  !
  ! Local ---
  integer, save :: last_box(4)=0
  integer nx,ny
  character(len=80) :: msg
  !
  ! Code ----
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  write(msg,'(A,L4,1X,I0,A,I0,A,I0,A)') 'DO Mask and Type ',amethod%do_mask, support_type,&
    &' (Mask ',support_mask,' Polygon ',support_poly,' ) '
  call map_message(seve%t,rname,msg)
  if (amethod%do_mask) then
    !
    if (support_type.eq.support_mask) then
      if (hmask%gil%dim(1).ne.nx .or. hmask%gil%dim(2).ne.ny) then
        call map_message(seve%w,rname,'Mask size differ')
      endif
      !
      ! Setup the Logical mask from the Real mask and its bounding box
      call get_lmask (hmask,dmask,head,d_mask,amethod%box)
      call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
      amethod%imask = 1
    else
      !
      ! Compute the logical mask from the bounding polygon
      call gr8_glmsk(supportpol,d_mask,nx,ny,   &
                     head%gil%convert(1,1),head%gil%convert(1,2),amethod%box)
      call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
      amethod%imask = -1
    endif
    amethod%do_mask = .false.
    last_box = amethod%box
  else
    if (all(last_box.eq.0)) last_box=[nx/4+1,3*nx/4,ny/4+1,3*ny/4]
    amethod%box = last_box
  endif
  write(msg,'(A,3(I0,","),I0,A)') 'Box: [',amethod%box,']'
  call map_message(seve%t,rname,msg)
end subroutine check_mask

!-----------------------------------------------------------------------
! Support file to decode a list of number from the following format
!    (chain =) n1 n2 n3 to n4 n5 n6 n7 to n8 by n9
! The list will include
!    n1,n2, n3,n3+1,...,n4, n5, n6,n6+n9,n6+2*n9,...,n8
! There are 3 flavors of the subroutine:
!  - sic_parse_listi4, which returns a list of integer*4
!  - sic_parse_listi8, which returns a list of integer*8
!  - sic_parse_listr8, which returns a list of real*8
! Two have slightly diverged, it would be nice to merge them again.
!-----------------------------------------------------------------------
subroutine sic_parse_listi4(rname,chain,l4,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_listi4
  use sic_types
  !----------------------------------------------------------------------
  ! @ public
  !  Decode a list as integer*4 values
  !----------------------------------------------------------------------
  character(len=*),   intent(in)    :: rname  ! Procedure name
  character(len=*),   intent(in)    :: chain  ! Input line to be decoded
  type(sic_listi4_t), intent(inout) :: l4     ! The lists
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  type(sic_listi8_t) :: l8
  !
  call sic_parse_listi8(rname,chain,l8,mlist,error)
  if (error .or. l8%nlist.eq.0)  return
  !
  call sic_allocate_listi4(l4,mlist,error)
  if (error)  return
  !
  ! Copy 'l8' into 'l4'
  l4%nlist = l8%nlist
  call i8toi4_fini(l8%i1,l4%i1,l4%nlist,error)
  if (error)  return
  call i8toi4_fini(l8%i2,l4%i2,l4%nlist,error)
  if (error)  return
  call i8toi4_fini(l8%i3,l4%i3,l4%nlist,error)
  if (error)  return
  !
end subroutine sic_parse_listi4
!
subroutine sic_parse_listi8(rname,chain,l,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_listi8
  use sic_types
  !----------------------------------------------------------------------
  ! @ public
  !  Decode a list as integer*8 values
  !----------------------------------------------------------------------
  character(len=*),   intent(in)    :: rname  ! Procedure name
  character(len=*),   intent(in)    :: chain  ! Input line to be decoded
  type(sic_listi8_t), intent(inout) :: l      ! The lists
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=20) :: par
  integer(kind=4) :: j,long, next, lpar
  integer(kind=8) :: i8
  character(len=message_length) :: mess
  !
  call sic_allocate_listi8(l,mlist,error)
  if (error)  return
  !
  j=0
  l%nlist=0
  long=lenc(chain)
  if (long.eq.0) then
     goto 30
  else
     next=1
     call sic_next(chain,par,lpar,next)
     goto 20
  endif
  !
  ! Is the decoding finished ?
10 continue
  if (next.gt.long) goto 30
  call sic_next(chain(next:),par,lpar,next)
  !
  ! Increment the loop counter and decode the next loop parameters
20 continue
  j=j+1
  if (j.gt.l%mlist) then
     write(mess,'(A,I0,A)')  'Too many loops (max ',l%mlist,' allowed)'
     call sic_message(seve%e,rname,mess)
     l%nlist = l%mlist
     error = .true.
     return
  endif
  !
  ! First parameter
  call sic_math_long(par,lpar,i8,error)
  if (error) goto 100
  l%i1(j) = i8
  l%i2(j) = l%i1(j)
  l%i3(j) = 1_8
  !
  ! Is there a second parameter
  if (next.gt.long) goto 10
  call sic_next(chain(next:),par,lpar,next)
  call sic_upper(par(1:lpar))
  !
  ! If so, what is its numerical value
  if (par(1:lpar).eq.'TO') then
     if (next.gt.long) goto 110
     call sic_next(chain(next:),par,lpar,next)
     call sic_math_long(par,lpar,i8,error)
     if (error) goto 100
     l%i2(j) = i8
     !
     ! Value of increment (default=1)
     if (next.gt.long) goto 10
     call sic_next(chain(next:),par,lpar,next)
     call sic_upper(par(1:lpar))
     if (par(1:lpar).eq.'BY') then
        if (next.gt.long) goto 110
        call sic_next(chain(next:),par,lpar,next)
        call sic_math_long(par,lpar,i8,error)
        if (error) goto 100
        l%i3(j) = i8
        goto 10
     endif
  endif
  goto 20
  !
  ! End of processing
30 continue
  l%nlist=j
  if (l%nlist.eq.0) then
     call sic_message(seve%e,rname,'Empty list')
     error=.true.
  else
     !
     ! Are the loops meaningfull ?
     do j=1,l%nlist
        if (l%i3(j).eq.0_8 .or. (l%i2(j)-l%i1(j))*l%i3(j).lt.0_8) then
           call sic_message(seve%e,rname,'Invalid list :')
           write (6,103) l%i1(j),l%i2(j),l%i3(j)
           error=.true.
           return
        endif
     enddo
  endif
  return
  !
100 continue
  call sic_message(seve%e,rname,'Syntax error in list :')
  write (6,102) chain(1:min(next,long))
  error = .true.
  return
  !
110 continue
  call sic_message(seve%e,rname,'Incomplete list :')
  write (6,104) chain(1:min(next,long))
  error = .true.
  return
  !
102 format(t12,a,'...')
103 format(t10,i6,' TO ',i6,' BY ',i6)
104 format(t10,a,' !!')
end subroutine sic_parse_listi8
!
subroutine sic_parse_listr8(rname,chain,l,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_parse_listr8
  use sic_types
  !----------------------------------------------------------------------
  ! @ public
  !  Decode a list as real*8 values
  !----------------------------------------------------------------------
  character(len=*),   intent(in)    :: rname  ! Procedure name
  character(len=*),   intent(in)    :: chain  ! Input line to be decoded
  type(sic_listr8_t), intent(inout) :: l      ! The lists
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  integer(kind=4) :: j,long,next,lpar,length
  real(kind=8) :: dble
  character(len=132) :: par,argum
  character(len=message_length) :: mess
  logical :: readnext
  !
  call sic_allocate_listr8(l,mlist,error)
  if (error)  return
  !
  j = 0
  l%nlist = 0
  long = len_trim(chain)
  next = 1
  readnext = .true.
  !
  do
    if (readnext) then
       if (next.gt.long)  exit  ! while loop
       call sic_next(chain(next:),par,lpar,next)
    endif
    !
    ! Increment the loop counter and decode the next loop parameters
    j=j+1
    if (j.gt.l%mlist)  goto 105
    !
    ! First parameter
    call sic_shape(argum,par,1,lpar,length,error)
    par = argum
    lpar = length
    call sic_math_dble(par,lpar,dble,error)
    if (error) goto 100
    !
    l%r1(j) = dble
    l%r2(j) = l%r1(j)
    l%r3(j) = 0.d0  ! Make Zero the default...
    !
    ! Is there a second parameter?
    if (next.gt.long)  exit  ! while loop
    call sic_next(chain(next:),par,lpar,next)
    readnext = .false.
    !
    ! If so, what is its numerical value
    call sic_upper(par)
    if (par(1:lpar).ne.'TO')  cycle
    !
    ! 'TO' was found, expect the upper limit
    if (next.gt.long) goto 110
    call sic_next(chain(next:),par,lpar,next)
    call sic_shape(argum,par,1,lpar,length,error)
    par = argum
    lpar = length
    call sic_math_dble(par,lpar,dble,error)
    if (error) goto 100
    l%r2(j) = dble
    !
    ! Value of increment
    if (next.gt.long)  exit  ! while loop
    call sic_next(chain(next:),par,lpar,next)
    !
    call sic_upper(par)
    if (par(1:lpar).ne.'BY')  cycle
    !
    ! 'BY' was found, expect the increment
    if (next.gt.long) goto 110
    call sic_next (chain(next:),par,lpar,next)
    call sic_shape(argum,par,1,lpar,length,error)
    par = argum
    lpar = length
    call sic_math_dble(par,lpar,dble,error)
    if (error) goto 100
    if (dble.eq.0.d0) then
      call sic_message(seve%e,rname,'Invalid loop :')
      write(mess,103) l%r1(j),l%r2(j),dble
      call sic_message(seve%e,rname,mess)
      error=.true.
      return
    endif
    l%r3(j) = dble
    readnext = .true.
    !
  end do
  !
  ! End of processing
  l%nlist = j
  if (l%nlist.eq.0) then
    call sic_message(seve%e,rname,'Empty list')
    error=.true.
    return
  endif
  !
  ! Are the loops meaningfull ?
  do j=1,l%nlist
    if (l%r3(j).eq.0.0d0) then
      ! It has not been specified by user:
      ! set if to something meaningful if l%r2(J) = l%r1(J)
      if (l%r2(j).eq.l%r1(j)) then
        l%r3(j) = max(1.0d0,abs(l%r1(j)))  ! set it to 1 by default...
        cycle  ! No need to check precision
      elseif (l%r2(j).gt.l%r1(j)) then
        l%r3(j) = 1.0d0
      else  ! l%r2 < l%r1
        ! Loop is meaningless, leave to zero (do not execute)
        cycle  ! No more check
      endif
    endif
    !
    if (l%r1(j)+l%r3(j).eq.l%r1(j) .or. l%r2(j)+l%r3(j).eq.l%r2(j)) then
      ! Avoid infinite loops
      call sic_message(seve%e,rname,  &
        'Invalid loop (increment lower than precision):')
      write(mess,103) l%r1(j),l%r2(j),l%r3(j)
      call sic_message(seve%e,rname,mess)
      error=.true.
      return
      !
    elseif ((l%r2(j)-l%r1(j))*l%r3(j).lt.0.d0) then
      ! Increment has wrong sign for given range
      l%r3(j) = 0.0d0            ! Do not execute loop
    endif
  enddo
  !
  return
  !
100 call sic_message(seve%e,rname,'Syntax error in list :')
  write(mess,102) chain(1:min(next,long))
  call sic_message(seve%e,rname,mess)
  error = .true.
  return
  !
105 write(mess,'(A,I0,A)')  'Too many loops (max ',l%mlist,' allowed)'
  call sic_message(seve%e,rname,mess)
  l%nlist = l%mlist
  error = .true.
  return
  !
110 call sic_message(seve%e,rname,'Incomplete list :')
  write(mess,104) chain(1:min(next,long))
  call sic_message(seve%e,rname,mess)
  error = .true.
  return
  !
102 format(a,'...')
103 format(1pg13.6,' TO',1pg13.6,' BY',1pg13.6)
104 format(a,' !!')
end subroutine sic_parse_listr8
!
subroutine sic_build_listr4(levels,nlev,mlev,chain,rname,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_build_listr4
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Decode a list of numbers in the following format
  !    (CHAIN =) n1 n2 n3 TO n4 n5 n6 n7 TO n8 BY n9
  !  The list will contain
  !    n1,n2, n3,n3+1,...,n4, n5, n6,n6+n9,n6+2*n9,...,n7
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: mlev          ! Size of levels array
  real(kind=4),     intent(out)   :: levels(mlev)  ! Array to receive the list of values
  integer(kind=4),  intent(out)   :: nlev          ! Number of values
  character(len=*), intent(in)    :: chain         ! Input line to be decoded
  character(len=*), intent(in)    :: rname         ! Procedure name
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=4), parameter :: mlist=40
  type(sic_listr8_t) :: l
  real(kind=8) :: rr
  integer(kind=4) :: i
  character(len=message_length) :: mess
  !
  nlev = 0  ! In case of error
  !
  call sic_parse_listr8(rname,chain,l,mlist,error)
  if (error) return
  !
  do i=1,l%nlist
    if (l%r3(i).eq.0d0)  cycle  ! Means do not execute loop
    !
    rr = l%r1(i)
    if (l%r3(i).gt.0d0) then
      do while (rr.le.l%r2(i))
        nlev=nlev+1
        levels(nlev)=rr
        if (nlev.ge.mlev) goto 10
        rr = rr+l%r3(i)
      enddo
    else
      do while (rr.ge.l%r2(i))
        nlev=nlev+1
        levels(nlev)=rr
        if (nlev.ge.mlev) goto 10
        rr = rr+l%r3(i)
      enddo
    endif
    !
  enddo
  return
  !
10 continue
  write(mess,'(A,I0,A)')  'List too long, truncated to ',nlev,' values'
  call sic_message(seve%w,rname,mess)
end subroutine sic_build_listr4
!
subroutine sic_build_listi4 (level,nlev,mlev,chain,rname,error)
  use gbl_message
  use sic_interfaces, except_this=>sic_build_listi4
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Decode a list of numbers in the following format
  !    (CHAIN =) n1 n2 n3 TO n4 n5 n6 n7 TO n8 BY n9
  !  The list will contain
  !    n1,n2, n3,n3+1,...,n4, n5, n6,n6+n9,n6+2*n9,...,n7
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: mlev         ! Size of LEVEL array
  integer(kind=4),  intent(out)   :: level(mlev)  ! Array to receive the list of values
  integer(kind=4),  intent(out)   :: nlev         ! Number of values
  character(len=*), intent(in)    :: chain        ! String to be decoded
  character(len=*), intent(in)    :: rname        ! Header of message
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=4), parameter :: mlist=15
  type(sic_listi4_t) :: l
  integer(kind=4) :: i,rr
  character(len=message_length) :: mess
  !
  nlev = 0  ! In case of error
  !
  call sic_parse_listi4(rname,chain,l,mlist,error)
  if (error) return
  !
  do i=1,l%nlist
    if (l%i3(i).eq.0)  cycle  ! Means do not execute loop
    !
    do rr=l%i1(i),l%i2(i),l%i3(i)
      nlev = nlev+1
      level(nlev) = rr
      if (nlev.ge.mlev) goto 10
    enddo
    !
  enddo
  return
  !
10 continue
  write(mess,'(A,I0,A)')  'List too long, truncated to ',nlev,' values'
  call sic_message(seve%w,rname,mess)
end subroutine sic_build_listi4
!
subroutine list2(l,k,r,error)
  use gbl_message
  use sic_interfaces, except_this=>list2
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Execute a set of loops defined by sic_parse_listr8
  !       R               Current value
  !       K               Current loop number
  !---------------------------------------------------------------------
  type(sic_listr8_t), intent(in)    :: l      !
  integer(kind=4),    intent(inout) :: k      !
  real(kind=8),       intent(inout) :: r      !
  logical,            intent(out)   :: error  !
  ! Local
  integer(kind=4) :: i
  character(len=message_length) :: mess
  !
  error = .false.
  if (k.lt.0 .or. k.gt.l%nlist) then
    write(mess,'(A,I3,I3)') 'Internal logic error',k,l%nlist
    call sic_message(seve%e,'LIST2',mess)
    error = .true.
    return
  endif
  if (k.ne.0) then
    r = r + l%r3(k)
    if (l%r3(k).gt.0.d0) then
      if (r.le.(l%r2(k)+1.d-8*l%r3(k))) return
    else
      if (r.ge.(l%r2(k)+1.d-8*l%r3(k))) return
    endif
  endif
  do i=k+1,l%nlist
    if (l%r3(i).ne.0.d0) then
      k = i
      r = l%r1(k)
      return
    endif
  enddo
  error = .true.
  k = 0
end subroutine list2
!
subroutine sic_allocate_listi4(l,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_allocate_listi4
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Allocate the input sic_list type.
  ! No deallocation subroutine, Fortran ensure that allocatable arrays
  ! are implicitly deallocated before destruction.
  !---------------------------------------------------------------------
  type(sic_listi4_t), intent(inout) :: l      !
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ALLOCATE'
  integer(kind=4) :: ier
  !
  if (mlist.le.0) then
    call sic_message(seve%e,rname,'Requested empty listi4 array')
    error = .true.
    return
  endif
  !
  if (allocated(l%i1)) then
    if (size(l%i1).eq.mlist)  return
    deallocate(l%i1,l%i2,l%i3)
  endif
  !
  allocate(l%i1(mlist),l%i2(mlist),l%i3(mlist),stat=ier)
  if (failed_allocate(rname,'list i1/i2/i3',ier,error))  return
  l%mlist = mlist
  l%nlist = 0
  !
end subroutine sic_allocate_listi4
!
subroutine sic_allocate_listi8(l,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_allocate_listi8
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Allocate the input sic_list type.
  ! No deallocation subroutine, Fortran ensure that allocatable arrays
  ! are implicitly deallocated before destruction.
  !---------------------------------------------------------------------
  type(sic_listi8_t), intent(inout) :: l      !
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ALLOCATE'
  integer(kind=4) :: ier
  !
  if (mlist.le.0) then
    call sic_message(seve%e,rname,'Requested empty listi8 array')
    error = .true.
    return
  endif
  !
  if (allocated(l%i1)) then
    if (size(l%i1).eq.mlist)  return
    deallocate(l%i1,l%i2,l%i3)
  endif
  !
  allocate(l%i1(mlist),l%i2(mlist),l%i3(mlist),stat=ier)
  if (failed_allocate(rname,'list i1/i2/i3',ier,error))  return
  l%mlist = mlist
  l%nlist = 0
  !
end subroutine sic_allocate_listi8
!
subroutine sic_allocate_listr8(l,mlist,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_allocate_listr8
  use sic_types
  !---------------------------------------------------------------------
  ! @ public
  !  Allocate the input sic_list type.
  ! No deallocation subroutine, Fortran ensure that allocatable arrays
  ! are implicitly deallocated before destruction.
  !---------------------------------------------------------------------
  type(sic_listr8_t), intent(inout) :: l      !
  integer(kind=4),    intent(in)    :: mlist  ! Maximum number of lists
  logical,            intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='ALLOCATE'
  integer(kind=4) :: ier
  !
  if (mlist.le.0) then
    call sic_message(seve%e,rname,'Requested empty listr8 array')
    error = .true.
    return
  endif
  !
  if (allocated(l%r1)) then
    if (size(l%r1).eq.mlist)  return
    deallocate(l%r1,l%r2,l%r3)
  endif
  !
  allocate(l%r1(mlist),l%r2(mlist),l%r3(mlist),stat=ier)
  if (failed_allocate(rname,'list r1/r2/r3',ier,error))  return
  l%mlist = mlist
  l%nlist = 0
  !
end subroutine sic_allocate_listr8

subroutine gdf_print_header(img)
  use gio_dependencies_interfaces
  use gio_interfaces, except_this=>gdf_print_header
  use image_def
  use gbl_format
  use gbl_constant
  use phys_const
  use gio_uv
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! GIO Library
  !       Support routine for command HEADER
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: img  ! Header to be printed
  ! Local
  character(len=*), parameter :: rname='PRTHEADER'
  real, parameter :: sec=180.*3600./acos(-1.0)
  !
  integer mstoke !!!!
  integer, parameter :: mform=9
  character(len=9) :: form(mform)
  character(len=15) :: chde,chra,cha0,chd0
  real :: fm,fp,ff
  integer :: i,ll,n
  integer, parameter :: mline=32, mcol=80
  integer :: kline, ksour, vtyp, ilead
  character(len=79) :: cline(mline), clead
  character(len=12) :: code(gdf_maxdims)
  character(len=54) :: fich
  character(len=16) :: prefix
  logical :: error, ok
  character(len=12), save :: vtype(0:4)
  data vtype /'Unknown', 'LSR', 'Heliocentric', 'Observatory', 'Earth'/
  integer :: k
  data form/'REAL*4','REAL*8','INTEGER*4','LOGICAL','INTEGER*2','BYTE',  &
            'COMPLEX*4','COMPLEX*8','INTEGER*8'/
  !
  call gio_message(seve%t,rname,'Entering...')
  !
  !
  if (abs(img%gil%type_gdf).eq.code_gdf_uvt) then
    prefix = 'UV Table : '
  else if (img%gil%type_gdf.eq.code_gdf_image) then
    prefix = 'DATA Cube : '
  else if (img%gil%type_gdf.eq.code_gdf_table) then
    prefix = 'Simple Table :'
  else if (img%gil%type_gdf.eq.code_gdf_vo) then
    prefix = 'VO Table'
  else
    prefix = 'Unknown : '
  endif
  !
  cline = ' '
  error = .false.
  !
  ! General
  ll = len_trim(img%file)
  if (ll.eq.0) then
    fich = '  (in memory)  '
  elseif (ll.gt.54) then
    fich = img%file(1:20)//'...'//img%file(ll-34:ll)
  else
    fich = img%file(1:ll)
  endif
  write (cline(1),101) prefix,fich,form(hardware-img%gil%form)
101 format (A,A,T70,A)
  !
  kline = 2
  cline(kline) = 'Size        Reference Pixel           Value'//  &
             '                  Increment'
  do i=1,img%gil%ndim
    kline = kline+1
    write(cline(kline),100) img%gil%dim(i), img%gil%convert(1,i), img%gil%convert(2,i), img%gil%convert(3,i)
  enddo
100 format(i10,1x,1pg22.15,1x,1pg22.15,1x,1pg22.15)
  !
  ! Blanking
  kline = kline+1
  if (img%gil%blan_words.ne.0) then
    write(cline(kline),200) img%gil%bval, img%gil%eval
  else
    write(cline(kline),200) 0.e0,-1.e0
  endif
200 format('Blanking value and tolerance',5x,1pg15.8,1x,1pg15.8)
  ksour = kline+1
  kline = kline+2
  !
  ! Description
  if (img%gil%desc_words.ne.0) then
    cline(kline) = 'Map unit'
    cline(kline)(21:) = img%char%unit
    kline = kline+1
    cline(kline) = 'Axis type'
    code = ' '
    do i=1,img%gil%ndim
      if (len_trim(img%char%code(i)).ne.0) then
        code(i) = img%char%code(i)
      else
        code(i) = 'Unknown'
      endif
    enddo
    cline(kline)(21:) = code(1)//' '//code(2)//' '//  &
                     code(3)//' '//code(4)
    if (img%gil%ndim.gt.4) then
      kline = kline+1
      cline(kline)(21:) = code(5)//' '//code(6)//' '//  &
                     code(7)
    endif
    kline = kline+1
    cline(kline) = 'Coordinate system                       Velocity'
    cline(kline)(21:32) = img%char%syst
  else
    cline(kline) = 'Map unit'
    cline(kline)(21:) = 'Unknown      '
    kline = kline+1
    cline(kline) = 'Axis type'
    cline(kline)(21:) = 'Unknown      Unknown      Unknown      Unknown      '
    kline = kline+1
    cline(kline) = 'Coordinate system                       Velocity'
    cline(kline)(21:32) = 'Unknown      '
  endif
  vtyp = img%gil%vtyp
  if (vtyp.lt.0 .or. vtyp.gt.4) vtyp = 0
  cline(kline)(21+32:) = vtype(vtyp)
  !
  ! Position
  kline = kline+1
  cline(ksour)= 'Source name'
  cline(kline)= 'Right Ascension                         Declination'
  cline(kline+1)= 'Lii                                     Bii'
  cline(kline+2)= 'Equinox'
  if (img%gil%posi_words.ne.0) then
    cline(ksour)(21:32) = img%char%name
    ! Note that source coordinates in the alternate system are not
    ! recomputed. Header content is displayed "as is".
    call rad2sexa (img%gil%ra,24,chra)
    call rad2sexa (img%gil%dec,360,chde)
    cline(kline)(18:32) = chra     ! For 15 char
    cline(kline)(57:71) = chde     ! 
    kline = kline+1
    write(cline(kline)(10:32),'(1PG23.16)') img%gil%lii*180.d0/pi
    write(cline(kline)(49:71),'(1PG23.16)') img%gil%bii*180.d0/pi
    if (img%char%syst.eq.'EQUATORIAL') then
      ! Equinox is displayed only when relevant (i.e. EQUATORIAL system)
      kline = kline+1
      if (img%gil%epoc.eq.equinox_null) then
        write(cline(kline)(21:32),'(A)') 'Unknown'
      else
        write(cline(kline)(18:32),'(1PG15.8)') img%gil%epoc
      endif
    else if (img%char%syst.eq.'ICRS') then
      kline = kline+1
      cline(kline)= 'Epoch: '
      write(cline(kline)(18:32),'(1PG15.8)') img%gil%epoc
    endif
  endif
  !
  ! Projection
  kline = kline+1
  cline(kline) = 'Projection type                         Angle'
  cline(kline+1) = 'Axis       A0                           Axis       D0'
  if (img%gil%proj_words.ne.0) then
    if (img%char%syst.eq.'GALACTIC') then
      cline(kline)(21:32) = projnam(img%gil%ptyp)
      write(cline(kline)(49:71),'(1PG23.16)') img%gil%pang*180d0/pi
      write (chra,'(1PG13.7)')  img%gil%a0 * 180.0d0 /pi
      write (chde,'(1PG13.7)')  img%gil%d0 * 180.0d0 /pi
    else  ! EQUATORIAL or ICRS
      cline(kline)(21:32) = projnam(img%gil%ptyp)
      write(cline(kline)(49:71),'(1PG23.16)') img%gil%pang*180d0/pi
      call rad2sexa(img%gil%a0,24,chra)
      call rad2sexa(img%gil%d0,360,chde)
    endif
    kline = kline+1
    write(cline(kline)(6:6),'(I1)') img%gil%xaxi
    write(cline(kline)(46:46),'(I1)') img%gil%yaxi
    cline(kline)(18:32) = chra
    cline(kline)(57:71) = chde
  else
    cline(kline)(21:32) = 'Not Defined '
  endif
  !
  ! Extrema
  kline = kline+1
  if (img%gil%type_gdf.eq.code_gdf_uvt.or.img%gil%type_gdf.eq.code_gdf_tuv) then
    cline(kline) = 'Baselines '
    write(cline(kline)(18:),'(F10.1,F10.1)') img%gil%basemin,img%gil%basemax
  else
    if (img%gil%extr_words.ne.0) then
      if (img%gil%ndim.gt.4) then
        cline(kline) = 'Minimum'
        write(cline(kline)(18:),300) img%gil%rmin,img%gil%minloc(1:4)
        kline = kline+1
        write(cline(kline)(44:),'(i8,i6,i6)') img%gil%minloc(5:img%gil%ndim)
        kline = kline+1
        cline(kline) = 'Maximum'
        write(cline(kline)(18:),300) img%gil%rmax,img%gil%maxloc(1:4)
        kline = kline+1
        write(cline(kline)(44:),'(i8,i6,i6)') img%gil%maxloc(5:img%gil%ndim)
      else
        cline(kline) = 'Minimum'
        write(cline(kline)(18:),300) img%gil%rmin,img%gil%minloc(1:img%gil%ndim)
        kline = kline+1
        cline(kline) = 'Maximum'
        write(cline(kline)(18:),300) img%gil%rmax,img%gil%maxloc(1:img%gil%ndim)
      endif
    else
      cline(kline) = 'Minimum'
      kline = kline+1
      cline(kline) = 'Maximum'
    endif
  endif
  !
  ! Spectroscopy
  kline = kline+1
  if (img%gil%spec_words.ne.0) then
    cline(kline)     = 'Axis   Line Name                        Rest Frequency'
    cline(kline+1)   = 'Resolution in Velocity                  in Frequency'
    if (img%gil%fima.ne.0.0) then
      cline(kline+2) = 'Offset in Velocity                      Image Frequency'
    else
      cline(kline+2) = 'Offset in Velocity                      Doppler Velocity'
    endif
    write(cline(kline)(6:6),'(I1)')  img%gil%faxi
    cline(kline)(21:32) = img%char%line
    write(cline(kline)(56:),'(1PG23.16)') img%gil%freq
    kline = kline+1
    write(cline(kline)(25:39),'(1PG15.8)') img%gil%vres
    write(cline(kline)(61:),'(1PG15.8)') img%gil%fres
    kline = kline+1
    write(cline(kline)(25:39),'(1PG15.8)') img%gil%voff
    if (img%gil%fima.ne.0.0) then
      write(cline(kline)(56:),'(1PG23.16)') img%gil%fima
    else
      write(cline(kline)(61:),'(1PG15.8)') img%gil%dopp*clight_kms
    endif
  else
    cline(kline) = 'NO Spectroscopic information'
  endif
  !
  ! Resolution
  kline = kline+1
  if (img%gil%reso_words.ne.0) then
    cline(kline) = 'Beam '
    write(cline(kline)(20:31),'(1PG12.3)') img%gil%majo*3600*180/pi
    write(cline(kline)(40:51),'(1PG12.3)') img%gil%mino*3600*180/pi
    write(cline(kline)(61:69),'(F8.2)') img%gil%posa*180/pi
  else
    cline(kline) = 'NO Beam information'
  endif
  !
  ! Noise
  kline = kline+1
  if (img%gil%nois_words.ne.0) then
    cline(kline) = 'Noise '
    write(cline(kline)(25:39),'(1PG15.8)') img%gil%noise
    write(cline(kline)(56:),'(1PG15.8)') img%gil%rms
  else
    cline(kline) = 'NO Noise level'
  endif
  !
  ! Proper Motion
  kline = kline+1
  if (img%gil%astr_words.ne.0) then
    cline(kline) = 'Proper motion'
    cline(kline)(40:48) = 'Parallax'
    write(cline(kline)(20:28),'(F8.2)') img%gil%mura
    write(cline(kline)(30:38),'(F8.2)') img%gil%mudec
    write(cline(kline)(50:58),'(F8.2)') img%gil%parallax
    !!         WRITE(CLINE(25)(40:48),'(F8.2)') IMG%gil%PEPOCH
  else
    cline(kline) = 'NO Proper motion'
  endif
  !
  ! Observatory, starting from Version V2.2 (SYST)
  if (code_version_uvt_current.ge.code_version_uvt_syst) then
    kline = kline+1
    if (img%gil%tele_words.ne.0) then
      if (img%gil%nteles.gt.0) then
        do k=1,img%gil%nteles
          call gwcs_print_telescope(img%gil%teles(k),cline(kline))
          kline = kline+1
        enddo
        kline = kline-1
      else
        cline(kline) = 'NO Telescope in section'
      endif
    else
      cline(kline) = 'NO Telescope section'
    endif
  endif
  !
  ! UV Data
  if (img%gil%uvda_words.ne.0) then
    !!Print *,'Doing UVDA_WORDS ',img%gil%uvda_words
    kline = kline+1
    cline(kline) = 'UV Data'
    cline(kline)(12:20) = 'Channels:'
    write(cline(kline)(21:27),'(I7)') img%gil%nchan
    cline(kline)(28:36) = ', Stokes:'
    write(cline(kline)(37:38),'(I2)') img%gil%nstokes
    n = 40
    if (abs(img%gil%order).eq.abs(code_stok_chan)) then
      !!Print *,'Found code_stok_chan ',img%gil%nstokes
      do i=1,img%gil%nstokes
        cline(kline)(n:) = gdf_stokes_name(img%gil%stokes(i))
        n = n+3
      enddo
    else
      cline(kline)(n:) = gdf_stokes_name(img%gil%order)
    endif
    cline(kline)(52:64) = 'Visibilities:'
    write(cline(kline)(65:76),'(I12)') img%gil%nvisi
    !
  endif
  !
  do i=1,kline
    write(6,'(A)') trim(cline(i))
  enddo
  !
  ! Here print the UV data layout
  if (img%gil%uvda_words.ne.0) then
    ! 
    ! The Leading columns first
    write(6,'(A)') "Column names, pointers & size"
    do k=1,2
      ilead = 1
      clead = ' '
      do i=1,code_uvt_last
        if (img%gil%column_pointer(i).ne.0) then
          ok = .false.
          if ((k.eq.1).and.(img%gil%column_pointer(i).le.img%gil%nlead)) ok = .true.
          if ((k.eq.2).and.(img%gil%column_pointer(i).gt.img%gil%nlead)) ok = .true. 
          if (ok) then
            write(clead(ilead:),'(A,1X,I6,I2)') uv_column_name(i),img%gil%column_pointer(i),& 
            & img%gil%column_size(i)
            ilead = len_trim(clead)+2
            if (ilead.gt.60) then
              write(6,'(A)') clead(1:ilead)
              clead = ' '
              ilead = 1
            endif
          endif
        endif
      enddo
      if (ilead.gt.2) write(6,'(A)') clead(1:ilead)
    enddo
  endif
  !
  ! The Stokes and Frequency layout
  if (img%gil%nfreq.ne.0) then
    ! This assumes the Stokes first, Channel next layout...
    if (associated(img%gil%stokes)) then    
      mstoke = ubound(img%gil%stokes,1)
    else
      mstoke = 0
    endif
    !
    ! Printout assumes there are as many Stokes information as Frequency information,
    ! or no Stokes information at all.
    Print *,'Nfreq ',img%gil%nfreq,' Nstokes ',img%gil%nstokes,mstoke !!Under TEST
    write(*,*) img%gil%order,' Channel  Stokes  Frequency '
    do i=1,img%gil%nfreq
      if (mstoke.eq.0) then
        write(*,*) i, 0, "NONE", img%gil%freqs(i)      
      else
        !!k = mod(i-1,img%gil%nstokes)+1
        !!Print *,'K ',k,i
        write(*,*) i, img%gil%stokes(i), gdf_stokes_name(img%gil%stokes(i)), img%gil%freqs(i)
      endif
    enddo
  endif
  !
  if (img%mos%nfields.ne.0) then
    write(*,'(A,I0,A)') 'Mosaic of ',img%mos%nfields,' pointings'
    if (img%gil%nteles.gt.1) then
      write(6,'(A)') "Field     Ra               Dec            A0               D0           Nvisi Tel#"
    else
      write(6,'(A)') "Field     Ra               Dec            A0               D0           Nvisi"
    endif
    do i=1,img%mos%nfields
      call rad2sexa (img%mos%fields(i)%apoint(1),24,chra)
      call rad2sexa (img%mos%fields(i)%apoint(2),360,chde)
      call rad2sexa (img%mos%fields(i)%aphase(1),24,cha0)
      call rad2sexa (img%mos%fields(i)%aphase(2),360,chd0)
      if (img%gil%nteles.gt.1) then
        write(6,'(I4,4(1X,A),I9,I3)') i,chra,chde,cha0,chd0,img%mos%fields(i)%nvisi,img%mos%fields(i)%jteles
      else
        write(6,'(I4,4(1X,A),I9,I3)') i,chra,chde,cha0,chd0,img%mos%fields(i)%nvisi
      endif
    enddo
    !
    write(6,'(A)') "Field     dRa     dDec     dA0      dD0    DeltaX   DeltaY    Jx    Jy  Noise"
    !
    ! Adapt Field offset format to the range of Position offsets
    fm = 0
    fp = 0
    do i=1,img%mos%nfields
      ff = maxval(abs(img%mos%fields(i)%opoint))
      fm = max(fm,ff)
      ff = maxval(abs(img%mos%fields(i)%ophase))
      fp = max(fp,ff)
    enddo
    ff = max(fm,fp)*sec
    if (ff.gt.1) then
      do i=1,img%mos%nfields
        write(6,'(I4,4(1X,F8.2),2(1X,F8.2),2(1X,I5),1X,1PG10.3)') i, & 
          & img%mos%fields(i)%opoint(1)*sec, img%mos%fields(i)%opoint(2)*sec, & 
          & img%mos%fields(i)%ophase(1)*sec, img%mos%fields(i)%ophase(2)*sec, & 
          & img%mos%fields(i)%oxy(1)*sec, img%mos%fields(i)%oxy(2)*sec, & 
          & img%mos%fields(i)%jxy(1), img%mos%fields(i)%jxy(2), img%mos%fields(i)%sigma
      enddo
    else
      do i=1,img%mos%nfields
        write(6,'(I4,4(1X,F8.4),2(1X,F8.4),2(1X,I5),1X,1PG10.3)') i, & 
          & img%mos%fields(i)%opoint(1)*sec, img%mos%fields(i)%opoint(2)*sec, & 
          & img%mos%fields(i)%ophase(1)*sec, img%mos%fields(i)%ophase(2)*sec, & 
          & img%mos%fields(i)%oxy(1)*sec, img%mos%fields(i)%oxy(2)*sec, & 
          & img%mos%fields(i)%jxy(1), img%mos%fields(i)%jxy(2), img%mos%fields(i)%sigma
      enddo
    endif
  endif
  !
  call gio_message(seve%t,rname,'Leaving !..')
  !
300 format(1pg15.8,'  at ',i8,i8,i6,i6)
end subroutine gdf_print_header
!
subroutine gio_dump_header (imag)
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  type (gildas), intent(in) :: imag                !
  integer i
  !
  ! Debugging routine: dump an image header, without messages "a la SIC" so far
  !
  write(6,100) imag%char%type,' IMAG%gil%ityp'
  write(6,*) imag%gil%form,' IMAG%gil%form'
  write(6,*) imag%gil%ndb,' IMAG%gil%ndb'
  !!write(6,*) imag%gil%fill,' IMAG%gil%fill'
!V! write(6,*) imag%gil%gene,' IMAG%gil%gene'
  write(6,*) imag%gil%ndim,' IMAG%gil%ndim'
  write(6,*) imag%gil%dim,' IMAG%gil%dim'
  write(6,*) imag%gil%convert,' IMAG%gil%  Convert'
  write(6,*) imag%gil%blan_words,' IMAG%gil%blan_words'
  write(6,*) imag%gil%bval, imag%gil%eval,' IMAG%gil%blank'
!
  write(6,*) imag%gil%extr_words,' IMAG%gil%extr_words'
  write(6,*) imag%gil%rmin,' IMAG%gil%min'
  write(6,*) imag%gil%rmax,' IMAG%gil%max'
  write(6,*) imag%gil%minloc,' IMAG%gil%minloc'
  write(6,*) imag%gil%maxloc, 'IMAG%gil%maxloc'
  !
  write(6,*) imag%gil%desc_words,' IMAG%gil%desc_words'
  write(6,100) imag%char%unit,' IMAG%gil%iuni'
  write(6,101) imag%char%code,' IMAG%gil%icod'
  write(6,100) imag%char%syst,' IMAG%gil%isys'

  write(6,*) imag%gil%posi_words,' IMAG%gil%posi_words'
  write(6,100) imag%char%name,' IMAG%gil%isou'
  write(6,*) imag%gil%ra,' IMAG%gil%ra'
  write(6,*) imag%gil%dec,' IMAG%gil%dec'
  write(6,*) imag%gil%lii,' IMAG%gil%lii'
  write(6,*) imag%gil%bii,' IMAG%gil%bii'
  write(6,*) imag%gil%epoc,' IMAG%gil%epoc'
!
  write(6,*) imag%gil%proj_words,' IMAG%gil%proj_words'
  write(6,*) imag%gil%ptyp,' IMAG%gil%ptyp'
  write(6,*) imag%gil%a0,' IMAG%gil%a0'
  write(6,*) imag%gil%d0,' IMAG%gil%d0'
  write(6,*) imag%gil%pang,' IMAG%gil%angle'
  write(6,*) imag%gil%xaxi,' IMAG%gil%x_axis'
  write(6,*) imag%gil%yaxi,' IMAG%gil%y_axis'
!
  write(6,*) imag%gil%spec_words,' IMAG%gil%spec_words'
  write(6,100) imag%char%line,' IMAG%gil%ilin'
  write(6,*) imag%gil%fres,' IMAG%gil%freqres'
  write(6,*) imag%gil%fima,' IMAG%gil%imagfre'
  write(6,*) imag%gil%freq,' IMAG%gil%restfre'
  write(6,*) imag%gil%vres,' IMAG%gil%velres'
  write(6,*) imag%gil%voff,' IMAG%gil%veloff'
  write(6,*) imag%gil%faxi,' IMAG%gil%f_axis'
!
  write(6,*) imag%gil%reso_words,' IMAG%gil%reso_words'
  write(6,*) imag%gil%majo,' IMAG%gil%major'
  write(6,*) imag%gil%mino,' IMAG%gil%minor'
  write(6,*) imag%gil%posa,' IMAG%gil%pa'
!
  print *,imag%gil%nois_words, ' IMAG%gil%nois_words'
  print *,imag%gil%noise, ' IMAG%gil%noise'
  print *,imag%gil%rms, ' IMAG%gil%rms'
!
  print *,imag%gil%astr_words, ' IMAG%gil%astr_words'
  print *,imag%gil%mura, ' IMAG%gil%mura'
  print *,imag%gil%mudec, ' IMAG%gil%mudec'
  print *,imag%gil%parallax, ' IMAG%gil%parallax'
!
  print *,imag%gil%uvda_words, ' IMAG%gil%uvda_words'
  print *,imag%gil%nchan, ' IMAG%gil%nchan'
  print *,imag%gil%nstokes, ' IMAG%gil%nstokes'
  print *,imag%gil%nvisi, ' IMAG%gil%nvisi'
!
  do i=1,code_uvt_last
    if (imag%gil%column_pointer(i).ne.0) then
      Print *,'Column ',imag%gil%column_pointer(i),', Size ',imag%gil%column_size(i)!
      !! ' contains ',items(i)
    endif
  enddo
  !
  print *,imag%gil%tele_words, ' IMAG%gil%tele_words'
  print *,imag%gil%nteles, ' IMAG%gil%nteles'
!  print *,imag%char%tele, ' IMAG%gil%teles(1)%ctele'
!
100 format(1x,a,1x,a)
101 format(1x,4(a,1x),a)
end subroutine gio_dump_header
!
subroutine gdf_addteles(fits,key,name,value,error)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except=>gdf_addteles
  !---------------------------------------------------------------
  ! @ public
  ! GDF
  !   Add a new telescope
  !---------------------------------------------------------------
  type(gildas),     intent(inout) :: fits      ! Output GILDAS structure
  character(len=*), intent(in)    :: key       ! Operation Key
  character(len=*), intent(in)    :: name      ! Telescope name
  real(kind=8),     intent(in)    :: value(3)  ! Input values
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='ADDTELES'
  character(len=message_length) :: mess
  character(len=12) :: cname  ! Telescope name
  integer(kind=4) :: itel,ier
  !
  if (fits%gil%nteles.eq.0) then
    ! Print *,'No previous telescope defined, adding one...'
    ! No telescope defined
    fits%gil%nteles = 1
    allocate(fits%gil%teles(1),stat=ier)
  else if (.not.allocated(fits%gil%teles)) then
    ! Number of telescope set, but nothing already done
    fits%gil%nteles = 1
    allocate(fits%gil%teles(fits%gil%nteles),stat=ier)
  endif
  !
  select case (key)
  case('TELE')
    ! Patch for some files created at IRAM...
    if (len(name).ge.4 .and. name(1:4).eq.'IRAM') then
      if (name(6:8).eq.'PDB') then
        cname ='PDBI'
      elseif (name(5:5).eq.'-') then
        cname = name(6:)  ! e.g. "IRAM-30M"
      else
        cname = name(5:)  ! e.g. "IRAM30M"
      endif
    else
      cname = name
    endif
    if (fits%gil%teles(fits%gil%nteles)%ctele.ne.' ') then
      ! The latest slot is not free. Need to add one, except
      ! if this telescope is already in the list (else skip this
      ! addition)
      do itel=1,fits%gil%nteles
        if (fits%gil%teles(itel)%ctele.eq.cname) then
          ! call gio_message(seve%w,rname,'Telescope '//trim(cname)//  &
          !   ' is already in the telescope section, skipping')
          return
        endif
      enddo
      call enlarge_section(fits,error)
      if (error)  return
    endif
    call gwcs_observatory(cname,fits%gil%teles(fits%gil%nteles),error)
    if (error) then
      fits%gil%nteles = fits%gil%nteles-1  ! Forgive slot which was added
      ! Section length unchanged, can leave now
      return
    endif
    call gwcs_print_telescope(fits%gil%teles(fits%gil%nteles),mess)
    call gio_message(seve%i,rname,mess)
    !
  case('NAME')
    if (fits%gil%teles(fits%gil%nteles)%ctele.ne.' ') then
      call enlarge_section(fits,error)
      if (error)  return
    endif
    fits%gil%teles(fits%gil%nteles)%ctele = name
    !
  case('GEO')
    if (fits%gil%teles(fits%gil%nteles)%alt.lt.-1000.) then
      call enlarge_section(fits,error)
      if (error)  return
    endif
    fits%gil%teles(fits%gil%nteles)%lon = value(1)
    fits%gil%teles(fits%gil%nteles)%lat = value(2)
    fits%gil%teles(fits%gil%nteles)%alt = value(3)
    !
  case('DIAM')
    if (fits%gil%teles(fits%gil%nteles)%diam.eq.0.) then
      call enlarge_section(fits,error)
      if (error)  return
    endif
    fits%gil%teles(fits%gil%nteles)%diam = value(1)
    !
  end select
  !
  fits%gil%tele_words = 2+fits%gil%nteles*10
  !!Print *,'UVFITS Tele_Words ',fits%gil%tele_words
  !
contains
  !
  subroutine enlarge_section(x,error)
    !-------------------------------------------------------------------
    ! Add one more telescope to the existing list
    !-------------------------------------------------------------------
    type(gildas), intent(inout) :: x
    logical,      intent(inout) :: error
    ! Local
    type(telesco), allocatable :: tmp(:)
    !
    allocate(tmp(x%gil%nteles),stat=ier)
    if (failed_allocate(rname,'teles buffer',ier,error))  return
    tmp(:) = x%gil%teles(1:x%gil%nteles)
    deallocate(x%gil%teles)
    !
    x%gil%nteles = x%gil%nteles+1
    allocate(x%gil%teles(x%gil%nteles),stat=ier)
    if (failed_allocate(rname,'teles buffer',ier,error))  return
    x%gil%teles(1:x%gil%nteles-1) = tmp(:)
  end subroutine enlarge_section
  !
end subroutine gdf_addteles
!
subroutine gdf_rmteles(fits,name,error)
  use image_def
  use gbl_message
  use gio_dependencies_interfaces
  use gio_interfaces, except=>gdf_rmteles
  !---------------------------------------------------------------
  ! @ public
  !  Remove a telescope from section, identified by its name
  !---------------------------------------------------------------
  type(gildas),     intent(inout) :: fits      ! Output GILDAS structure
  character(len=*), intent(in)    :: name      ! Telescope name
  logical,          intent(inout) :: error     !
  ! Local
  character(len=*), parameter :: rname='RMTELES'
  character(len=12) :: cname  ! Telescope name
  integer(kind=4) :: itel,ier
  !
  if (fits%gil%nteles.eq.0) then
    ! No telescope defined => nothing to do
    return
  else if (.not.allocated(fits%gil%teles)) then
    ! Number of telescope set, but nothing defined yet => nothing to do
    return
  endif
  !
  ! Patch for some files created at IRAM...
  if (len(name).ge.4 .and. name(1:4).eq.'IRAM') then
    if (name(6:8).eq.'PDB') then
      cname ='PDBI'
    elseif (name(5:5).eq.'-') then
      cname = name(6:)  ! e.g. "IRAM-30M"
    else
      cname = name(5:)  ! e.g. "IRAM30M"
    endif
  else
    cname = name
  endif
  !
  itel = 1
  do while (itel.le.fits%gil%nteles)
    if (fits%gil%teles(itel)%ctele.eq.cname) then
      call gio_message(seve%i,rname,'Removing telescope '//cname)
      ! Decrease fits%gil%nteles
      call reduce_section(fits,itel,error)
      if (error)  return
    else
      ! Increase itel
      itel = itel+1
    endif
  enddo
  !
  if (fits%gil%nteles.gt.0) then
    fits%gil%tele_words = 2+fits%gil%nteles*10
  else
    fits%gil%tele_words = 0
  endif
  !!Print *,'UVFITS Tele_Words ',fits%gil%tele_words
  !
contains
  !
  subroutine reduce_section(x,jtel,error)
    !-------------------------------------------------------------------
    ! Remove one telescope from the existing list
    !-------------------------------------------------------------------
    type(gildas),    intent(inout) :: x
    integer(kind=4), intent(in)    :: jtel
    logical,         intent(inout) :: error
    ! Local
    type(telesco), allocatable :: tmp(:)
    !
    if (jtel.lt.1 .or. jtel.gt.x%gil%nteles) then
      print *,"Internal error: invalid telescope number ",jtel
      error = .true.
      return
    endif
    !
    if (x%gil%nteles.eq.1) then
      ! jtel must be 1 from above check
      deallocate(x%gil%teles)
    else
      allocate(tmp(x%gil%nteles),stat=ier)
      if (failed_allocate(rname,'teles buffer',ier,error))  return
      tmp(:) = x%gil%teles(1:x%gil%nteles)
      !
      deallocate(x%gil%teles)
      allocate(x%gil%teles(x%gil%nteles-1),stat=ier)
      if (failed_allocate(rname,'teles buffer',ier,error))  return
      if (jtel.gt.1)             x%gil%teles(1:jtel-1) = tmp(1:jtel-1)
      if (jtel.lt.x%gil%nteles)  x%gil%teles(jtel:x%gil%nteles-1) = tmp(jtel+1:x%gil%nteles)
    endif
    !
    x%gil%nteles = x%gil%nteles-1
  end subroutine reduce_section
  !
end subroutine gdf_rmteles

!-----------------------------------------------------------------------
! Support module for CFITSIO interactions. Use module 'cfitsio_api'
! in your programs.
!-----------------------------------------------------------------------
module cfitsio_parameters
  !
  integer(kind=4), parameter :: code_cfitsio_readonly=0
  !
  integer(kind=4), parameter :: code_cfitsio_any_hdu=-1
  integer(kind=4), parameter :: code_cfitsio_image_hdu=0
  integer(kind=4), parameter :: code_cfitsio_ascii_tbl=1
  integer(kind=4), parameter :: code_cfitsio_binary_tbl=2
  !
  integer(kind=4), parameter :: code_cfitsio_error_missingkey=202
  !
end module cfitsio_parameters
!
module cfitsio_interfaces
  !
  interface
    subroutine ftvers(version)
    !-------------------------------------------------------------------
    !  Return the current version number of the fitsio library. The
    ! version number will be incremented with each new release of
    ! CFITSIO.
    !-------------------------------------------------------------------
    real(kind=4), intent(out) :: version
    end subroutine ftvers
    !
    subroutine ftopen(iunit,name,rwmode,block,status)
    !-------------------------------------------------------------------
    ! Open an existing FITS file with readonly or read/write access
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: name    ! Name of file to be opened
    integer(kind=4)                 :: rwmode  ! File access mode: 0 = readonly; else = read and write
    integer(kind=4),  intent(out)   :: block   ! Returned record length blocking factor
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftopen
    !
    subroutine ftinit(iunit,filename,blocksize,status)
    !-------------------------------------------------------------------
    ! Close a FITS file that was previously opened with ftopen or ftinit
    !------------------------------------------ -------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    character(len=*), intent(in)    :: filename   ! Name of file to be initialized
    integer(kind=4),  intent(in)    :: blocksize  ! Block size (ignored?)
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftinit
    !
    subroutine ftclos(iunit,status)
    !-------------------------------------------------------------------
    ! Close a FITS file that was previously opened with ftopen or ftinit
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftclos
    !
    subroutine ftrprt(stream,status)
    !-------------------------------------------------------------------
    ! Display the error status message and flush the error stack
    !-------------------------------------------------------------------
    character(len=*), intent(in) :: stream  ! 'STDOUT' or 'STDERR'
    integer(kind=4),  intent(in) :: status  ! Error status
    end subroutine ftrprt
    !
    subroutine ftcmsg
    !-------------------------------------------------------------------
    ! Clear the error message stack
    !-------------------------------------------------------------------
    end subroutine ftcmsg
    !
    subroutine ftgerr(status,errtext)
    !-------------------------------------------------------------------
    !  Return the descriptive text string corresponding to a FITSIO
    ! error status code. The 30-character length string contains a brief
    ! description of the cause of the error.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)  :: status
    character(len=*), intent(out) :: errtext
    end subroutine ftgerr
    !
    subroutine ftflus(iunit,status)
    !-------------------------------------------------------------------
    ! Flush internal buffers of data to the output FITS file previously
    ! opened with ftopen or ftinit.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftflus
    !
    subroutine ftphps(iunit,bitpix,naxis,naxes,status)
    !-------------------------------------------------------------------
    ! Put the primary header or IMAGE extension keywords into the CHU.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit         ! Fortran I/O unit number
    integer(kind=4), intent(in)    :: bitpix        ! Number of bits per value
    integer(kind=4), intent(in)    :: naxis         ! Number of dimensions
    integer(kind=4), intent(in)    :: naxes(naxis)  ! Dimensions
    integer(kind=4), intent(inout) :: status        ! Returned error status (0=ok)
    end subroutine ftphps
    !
    subroutine ftthdu(iunit,nhdu,status)
    !-------------------------------------------------------------------
    ! Return the total number of HDUs in the FITS file. The CHDU
    ! remains unchanged.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(out)   :: nhdu    !
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftthdu
    !
    subroutine ftgkyd(iunit,keywrd,dval,comm,status)
    !-------------------------------------------------------------------
    ! Read a double precision value and comment string from a header
    ! record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    real(kind=8),     intent(out)   :: dval    ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyd
    !
    subroutine ftgkyj(iunit,keywrd,intval,comm,status)
    !-------------------------------------------------------------------
    ! Read an integer value and the comment string from a header record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    integer(kind=4),  intent(out)   :: intval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyj
    !
    subroutine ftgkyl(iunit,keywrd,logval,comm,status)
    !-------------------------------------------------------------------
    ! Read a logical value and the comment string from a header record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    logical,          intent(out)   :: logval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkyl
    !
    subroutine ftgkys(iunit,keywrd,strval,comm,status)
    !-------------------------------------------------------------------
    ! Read a character string value and comment string from a header
    ! record
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    character(len=*), intent(out)   :: strval  ! Output keyword value
    character(len=*), intent(out)   :: comm    ! Output keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftgkys
    !
    subroutine ftmahd(iunit,extno,xtend,status)
    !-------------------------------------------------------------------
    ! Move to Absolute Header Data unit
    ! Move the i/o pointer to the specified HDU and initialize all the
    ! common block parameters which describe the extension
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit   ! Fortran I/O unit number
    integer(kind=4), intent(in)    :: extno   ! Number of the extension to point to
    integer(kind=4), intent(out)   :: xtend   ! Returned type of extension
    integer(kind=4), intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftmahd
    !
    subroutine ftmnhd(iunit,hdutype,extname,extver,status)
    !-------------------------------------------------------------------
    ! Move to the (first) HDU which has the specified extension type and
    ! EXTNAME (or HDUNAME) and EXTVER keyword values. The hdutype
    ! parameter may have a value of IMAGE_HDU (0), ASCII_TBL (1),
    ! BINARY_TBL (2), or ANY_HDU (-1) where ANY_HDU means that only the
    ! extname and extver values will be used to locate the correct
    ! extension. If the input value of extver is 0 then the EXTVER
    ! keyword is ignored and the first HDU with a matching EXTNAME (or
    ! HDUNAME) keyword will be found. If no matching HDU is found in the
    ! file then the current HDU will remain unchanged and a status =
    ! BAD_HDU_NUM (301) will be returned.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit    ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: hdutype  !
    character(len=*), intent(in)    :: extname  !
    integer(kind=4),  intent(in)    :: extver   !
    integer(kind=4),  intent(inout) :: status   ! Returned error status (0=ok)
    end subroutine ftmnhd
    !
    subroutine ftgcno(iunit,casesn,templt,colnum,status)
    !-------------------------------------------------------------------
    ! Determine the column number corresponding to an input column name.
    ! This supports the * and ? wild cards in the input template.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran i/o unit number
    logical,          intent(in)    :: casesn  ! .true. if an exact case match of the names is required
    character(len=*), intent(in)    :: templt  ! Name of column as specified in a TTYPE keyword
    integer(kind=4),  intent(out)   :: colnum  ! Number of the column (first column = 1, a value of 0 is returned if the column is not found)
    integer(kind=4),  intent(inout) :: status  ! Returned error status
    end subroutine ftgcno
    !
    subroutine ftgcfe(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of R*4 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    real(kind=4),    intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfe
    !
    subroutine ftgcfd(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of R*8 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    real(kind=8),    intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfd
    !
    subroutine ftgcfj(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of I*4 values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    integer(kind=4), intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfj
    !
    subroutine ftgcfs(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of character strings from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow       ! First row to read
    integer(kind=4),  intent(in)    :: felem      ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem      ! Number of elements to read
    character(len=*), intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,          intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,          intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4),  intent(inout) :: status     ! Returned error status
    end subroutine ftgcfs
    !
    subroutine ftgcfl(iunit,colnum,frow,felem,nelem,array,flgval,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of logical values from a specified column of the table.
    ! Any undefined pixels will be have the corresponding value of FLGVAL
    ! set equal to .true., and ANYNUL will be set equal to .true. if any
    ! pixels are undefined.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum     ! Number of the column to read
    integer(kind=4), intent(in)    :: frow       ! First row to read
    integer(kind=4), intent(in)    :: felem      ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem      ! Number of elements to read
    logical,         intent(out)   :: array(*)   ! Returned array of data values that was read from FITS file
    logical,         intent(out)   :: flgval(*)  ! Set to .true. if corresponding element undefined
    logical,         intent(inout) :: anynul     ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftgcfl
    !
    subroutine ftgcvd(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of real*8 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    real(kind=8),    intent(in)    :: nulval    ! Value that undefined pixels will be set to
    real(kind=8),    intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcvd
    !
    subroutine ftgcve(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of real*4 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    real(kind=4),    intent(in)    :: nulval    ! Value that undefined pixels will be set to
    real(kind=4),    intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcve
    !
    subroutine ftgcvj(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of integer*4 values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4), intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4), intent(in)    :: frow      ! First row to read
    integer(kind=4), intent(in)    :: felem     ! First element within the row to read
    integer(kind=4), intent(in)    :: nelem     ! Number of elements to read
    integer(kind=4), intent(in)    :: nulval    ! Value that undefined pixels will be set to
    integer(kind=4), intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,         intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4), intent(inout) :: status    ! Returned error status
    end subroutine ftgcvj
    !
    subroutine ftgcvs(iunit,colnum,frow,felem,nelem,nulval,array,anynul,status)
    !-------------------------------------------------------------------
    ! Read an array of character strings from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow      ! First row to read
    integer(kind=4),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem     ! Number of elements to read
    character(len=*), intent(in)    :: nulval    ! Value that undefined pixels will be set to
    character(len=*), intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    logical,          intent(inout) :: anynul    ! Set to .true. if any of the returned values are undefined
    integer(kind=4),  intent(inout) :: status    ! Returned error status
    end subroutine ftgcvs
    !
    subroutine ftgcl(iunit,colnum,frow,felem,nelem,array,status)
    !-------------------------------------------------------------------
    ! Read an array of logical values from a specified column of the table.
    ! Any undefined pixels will be set equal to the value of NULVAL,
    ! unless NULVAL=0, in which case no checks for undefined pixels will
    ! be made.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit     ! Fortran i/o unit number
    integer(kind=4),  intent(in)    :: colnum    ! Number of the column to read
    integer(kind=4),  intent(in)    :: frow      ! First row to read
    integer(kind=4),  intent(in)    :: felem     ! First element within the row to read
    integer(kind=4),  intent(in)    :: nelem     ! Number of elements to read
    logical,          intent(out)   :: array(*)  ! Returned array of data values that was read from FITS file
    integer(kind=4),  intent(inout) :: status    ! Returned error status
    end subroutine ftgcl
    !
    subroutine ftghps(iunit,keysexist,key_no,status)
    !-------------------------------------------------------------------
    ! Return the number of keywords in the header and the current
    ! position in the header. This returns the number of the keyword
    ! record that will be read next (or one greater than the position of
    ! the last keyword that was read or written). A value of 1 is
    ! returned if the pointer is positioned at the beginning of the
    ! header.
    !-------------------------------------------------------------------
    integer(kind=4), intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4), intent(out)   :: keysexist  ! Number of available keys
    integer(kind=4), intent(out)   :: key_no     ! Next key to read
    integer(kind=4), intent(inout) :: status     ! Returned error status
    end subroutine ftghps
    !
    subroutine ftgkyn(iunit,key_no,keyword,value,comment,status)
    !-------------------------------------------------------------------
    ! Get the name, value (as a string), and comment of the nth keyword
    ! in CHU. This routine also checks that the returned keyword name
    ! (KEYWORD) contains only legal ASCII characters. Call FTGREC and
    ! FTPSVC to bypass this error check.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit    ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: key_no   ! The key number
    character(len=*), intent(out)   :: keyword  !
    character(len=*), intent(out)   :: value    !
    character(len=*), intent(out)   :: comment  !
    integer(kind=4),  intent(inout) :: status   ! Returned error status
    end subroutine ftgkyn
    !
    subroutine ftukys(iunit,keywrd,strval,comm,status)
    !-------------------------------------------------------------------
    ! Update the value and comment fields of a keyword in the CHU.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    character(len=*), intent(in)    :: strval  ! Keyword value
    character(len=*), intent(in)    :: comm    ! Keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftukys
    !
    subroutine ftukyj(iunit,keywrd,intval,comm,status)
    !-------------------------------------------------------------------
    ! Update the value and comment fields of a keyword in the CHU.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit   ! Fortran I/O unit number
    character(len=*), intent(in)    :: keywrd  ! Keyword name
    integer(kind=4),  intent(in)    :: intval  ! Keyword value
    character(len=*), intent(in)    :: comm    ! Keyword comment
    integer(kind=4),  intent(inout) :: status  ! Returned error status (0=ok)
    end subroutine ftukyj
    !
    subroutine ftgsfe(iunit,group,naxis,naxes,fpixels,lpixels,incs, &
                      array,flagvals,anyf,status)
    !-------------------------------------------------------------------
    ! Get an arbitrary data subsection from the data array. Any
    ! Undefined pixels in the array will have the corresponding
    ! 'flagvals' element set equal to .TRUE.
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit        ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group        !
    integer(kind=4),  intent(in)    :: naxis        ! Number of axes
    integer(kind=4),  intent(in)    :: naxes(*)     ! Axes length
    integer(kind=4),  intent(in)    :: fpixels(*)   ! BLC
    integer(kind=4),  intent(in)    :: lpixels(*)   ! TRC
    integer(kind=4),  intent(in)    :: incs(*)      ! Step in each dimension
    real(kind=4),     intent(out)   :: array(*)     ! Data array to read
    logical,          intent(out)   :: flagvals(*)  ! NULL flag for each value
    logical,          intent(out)   :: anyf         ! At least one NULL value?
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftgsfe
    !
    subroutine ftppre(iunit,group,fpixel,nelements,values,status)
    !-------------------------------------------------------------------
    ! Put elements into the data array
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group      !
    integer(kind=4),  intent(in)    :: fpixel     ! Position within the 1-D array of the first pixel to write
    integer(kind=4),  intent(in)    :: nelements  ! Number of elements to write
    real(kind=4),     intent(in)    :: values(*)  ! Data array to write
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftppre
    !
    subroutine ftpsse(iunit,group,naxis,naxes,fpixels,lpixels,array,status)
    !-------------------------------------------------------------------
    ! Put an arbitrary data subsection into the data array
    !-------------------------------------------------------------------
    integer(kind=4),  intent(in)    :: iunit      ! Fortran I/O unit number
    integer(kind=4),  intent(in)    :: group      !
    integer(kind=4),  intent(in)    :: naxis      ! Number of axes
    integer(kind=4),  intent(in)    :: naxes(*)   ! Axes length
    integer(kind=4),  intent(in)    :: fpixels(*) ! BLC
    integer(kind=4),  intent(in)    :: lpixels(*) ! TRC
    real(kind=4),     intent(in)    :: array(*)   ! Data array to write
    integer(kind=4),  intent(inout) :: status     ! Returned error status (0=ok)
    end subroutine ftpsse
    !
  end interface
  !
end module cfitsio_interfaces
!
module cfitsio_api
  use cfitsio_parameters
  use cfitsio_interfaces
  !
contains
  subroutine cfitsio_errormsg(status,msg)
  !---------------------------------------------------------------------
  ! Convert a CFITSIO error status into an error message
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in) :: status
  character(len=*), intent(out) :: msg
  !
  select case (status)
  case (0)
    msg = 'OK, no error'
  case (101)
    msg = 'Input and output files are the same'
  case (103)
    msg = 'Tried to open too many FITS files at once'
  case (104)
    msg = 'Could not open the named file'
  case (105)
    msg = 'Could not create the named file'
  case (106)
    msg = 'Error writing to FITS file'
  case (107)
    msg = 'Tried to move past end of file'
  case (108)
    msg = 'Error reading from FITS file'
  case (110)
    msg = 'Could not close the file'
  case (111)
    msg = 'Array dimensions exceed internal limit'
  case (112)
    msg = 'Cannot write to readonly file'
  case (113)
    msg = 'Could not allocate memory'
  case (114)
    msg = 'Invalid fitsfile pointer'
  case (115)
    msg = 'NULL input pointer to routine'
  case (116)
    msg = 'Error seeking position in file'
  !
  case (121)
    msg = 'Invalid URL prefix on file name'
  case (122)
    msg = 'Tried to register too many IO drivers'
  case (123)
    msg = 'Driver initialization failed'
  case (124)
    msg = 'Matching driver is not registered'
  case (125)
    msg = 'Failed to parse input file URL'
  !
  case (151)
    msg = 'Bad argument in shared memory driver'
  case (152)
    msg = 'Null pointer passed as an argument'
  case (153)
    msg = 'No more free shared memory handles'
  case (154)
    msg = 'Shared memory driver is not initialized'
  case (155)
    msg = 'IPC error returned by a system call'
  case (156)
    msg = 'No memory in shared memory driver'
  case (157)
    msg = 'Resource deadlock would occur'
  case (158)
    msg = 'Attempt to open/create lock file failed'
  case (159)
    msg = 'Shared memory block cannot be resized at the moment'
  !
  case (201)
    msg = 'Header already contains keywords'
  case (202)
    msg = 'Keyword not found in header'
  case (203)
    msg = 'Keyword record number is out of bounds'
  case (204)
    msg = 'Keyword value field is blank'
  case (205)
    msg = 'String is missing the closing quote'
  case (207)
    msg = 'Illegal character in keyword name or card'
  case (208)
    msg = 'Required keywords out of order'
  case (209)
    msg = 'Keyword value is not a positive integer'
  case (210)
    msg = 'Couldn''t find END keyword'
  case (211)
    msg = 'Illegal BITPIX keyword value'
  case (212)
    msg = 'Illegal NAXIS keyword value'
  case (213)
    msg = 'Illegal NAXISn keyword value'
  case (214)
    msg = 'Illegal PCOUNT keyword value'
  case (215)
    msg = 'Illegal GCOUNT keyword value'
  case (216)
    msg = 'Illegal TFIELDS keyword value'
  case (217)
    msg = 'Negative table row size'
  case (218)
    msg = 'Negative number of rows in table'
  case (219)
    msg = 'Column with this name not found in table'
  case (220)
    msg = 'Illegal value of SIMPLE keyword'
  case (221)
    msg = 'Primary array doesn''t start with SIMPLE'
  case (222)
    msg = 'Second keyword not BITPIX'
  case (223)
    msg = 'Third keyword not NAXIS'
  case (224)
    msg = 'Couldn''t find all the NAXISn keywords'
  case (225)
    msg = 'HDU doesn''t start with XTENSION keyword'
  case (226)
    msg = 'The CHDU is not an ASCII table extension'
  case (227)
    msg = 'The CHDU is not a binary table extension'
  case (228)
    msg = 'Couldn''t find PCOUNT keyword'
  case (229)
    msg = 'Couldn''t find GCOUNT keyword'
  case (230)
    msg = 'Couldn''t find TFIELDS keyword'
  case (231)
    msg = 'Couldn''t find TBCOLn keyword'
  case (232)
    msg = 'Couldn''t find TFORMn keyword'
  case (233)
    msg = 'The CHDU is not an IMAGE extension'
  case (234)
    msg = 'TBCOLn keyword value < 0 or > rowlength'
  case (235)
    msg = 'The CHDU is not a table'
  case (236)
    msg = 'Column is too wide to fit in table'
  case (237)
    msg = 'More than 1 column name matches template'
  case (241)
    msg = 'Sum of column widths not = NAXIS1'
  case (251)
    msg = 'Unrecognizable FITS extension type'
  case (252)
    msg = 'Unknown record; 1st keyword not SIMPLE or XTENSION'
  case (253)
    msg = 'END keyword is not blank'
  case (254)
    msg = 'Header fill area contains non-blank chars'
  case (255)
    msg = 'Illegal data fill bytes (not zero or blank)'
  case (261)
    msg = 'Illegal TFORM format code'
  case (262)
    msg = 'Unrecognizable TFORM datatype code'
  case (263)
    msg = 'Illegal TDIMn keyword value'
  case (264)
    msg = 'Invalid BINTABLE heap pointer is out of range'
  !
  case (301)
    msg = 'HDU number < 1 or > MAXHDU'
  case (302)
    msg = 'Column number < 1 or > tfields'
  case (304)
    msg = 'Tried to move to negative byte location in file'
  case (306)
    msg = 'Tried to read or write negative number of bytes'
  case (307)
    msg = 'Illegal starting row number in table'
  case (308)
    msg = 'Illegal starting element number in vector'
  case (309)
    msg = 'This is not an ASCII string column'
  case (310)
    msg = 'This is not a logical datatype column'
  case (311)
    msg = 'ASCII table column has wrong format'
  case (312)
    msg = 'Binary table column has wrong format'
  case (314)
    msg = 'Null value has not been defined'
  case (317)
    msg = 'This is not a variable length column'
  case (320)
    msg = 'Illegal number of dimensions in array'
  case (321)
    msg = 'First pixel number greater than last pixel'
  case (322)
    msg = 'Illegal BSCALE or TSCALn keyword = 0'
  case (323)
    msg = 'Illegal axis length < 1'
  !
  case (340:350)
    msg = 'Grouping function error'
  !
  case (360)
    msg = 'Malloc failed'
  case (361)
    msg = 'Read error from file'
  case (362)
    msg = 'Null pointer passed as an argument. Passing null pointer as a name of template file raises this error'
  case (363)
    msg = 'Line read seems to be empty (used internally)'
  case (364)
    msg = 'Cannot unread more then 1 line (or single line twice)'
  case (365)
    msg = 'Too deep include file nesting (infinite loop, template includes itself ?)'
  case (366)
    msg = 'Fopen() failed, cannot open template file'
  case (367)
    msg = 'End of file encountered and not expected'
  case (368)
    msg = 'Bad arguments passed. Usually means internal parser error. Should not happen'
  case (369)
    msg = 'Token not expected here'
  !
  case (401)
    msg = 'Bad int to formatted string conversion'
  case (402)
    msg = 'Bad float to formatted string conversion'
  case (403)
    msg = 'Can''t interpret keyword value as integer'
  case (404)
    msg = 'Can''t interpret keyword value as logical'
  case (405)
    msg = 'Can''t interpret keyword value as float'
  case (406)
    msg = 'Can''t interpret keyword value as double'
  case (407)
    msg = 'Bad formatted string to int conversion'
  case (408)
    msg = 'Bad formatted string to float conversion'
  case (409)
    msg = 'Bad formatted string to double conversion'
  case (410)
    msg = 'Illegal datatype code value'
  case (411)
    msg = 'Bad number of decimal places specified'
  case (412)
    msg = 'Overflow during datatype conversion'
  case (413)
    msg = 'Error compressing image'
  case (414)
    msg = 'Error uncompressing image'
  !
  case (420)
    msg = 'Error in date or time conversion'
  !
  case (431)
    msg = 'Syntax error in parser expression'
  case (432)
    msg = 'Expression did not evaluate to desired type'
  case (433)
    msg = 'Vector result too large to return in array'
  case (434)
    msg = 'Data parser failed not sent an out column'
  case (435)
    msg = 'Bad data encounter while parsing column'
  case (436)
    msg = 'Output file not of proper type'
  !
  case (501)
    msg = 'Celestial angle too large for projection'
  case (502)
    msg = 'Bad celestial coordinate or pixel value'
  case (503)
    msg = 'Error in celestial coordinate calculation'
  case (504)
    msg = 'Unsupported type of celestial projection'
  case (505)
    msg = 'Celestial coordinate keywords not found'
  case (506)
    msg = 'Approximate wcs keyword values were returned'
  !
  case default
    msg = 'Unknown error status'
  end select
  !
  end subroutine cfitsio_errormsg
end module cfitsio_api

subroutine load_greg (line)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>load_greg
  use greg_kernel
  use greg_pen
  use greg_xyz
  !---------------------------------------------------------------------
  ! @ public
  ! LOAD_GREG('INTERACTIVE GREGi')
  ! LOAD_GREG('LIBRARY GREGi')
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  ! Local
  integer, parameter :: mcom1=76, mcom2=79, mcom3=7+4
  character(len=12) :: ccom1(mcom1),ccom2(mcom2),ccom3(mcom3)
  character(len=12) :: name
  character(len=128) :: chain
  integer :: istatus,i,lv
  character(len=1), parameter :: backslash=char(92)
  logical :: error
  character(len=72) :: vers
  ! Data
  data vers/'9.2-00  19-Jun-2012   S.Guilloteau, J.Pety, S.Bardeau'/
  !
  ! Language initialisation
  data ccom1/                                                                &
    ' AXIS',      '/TICK','/LABEL','/LOCATION','/LOG','/NOLOG','/ABSOLUTE',  &
                  '/UNIT','/BRIEF','/NOBRIEF',                               &
    ' BOX',       '/ABSOLUTE','/UNIT','/LABEL','/FILL','/BRIEF','/NOBRIEF',  &
    ' COLUMN',    '/FILE','/LINES','/TABLE','/COMMENT','/CLOSE',             &
    ' CONNECT',   '/BLANKING','/FILL',                                       &
    ' CORNERS',                                                              &
    ' CURVE',     '/ACCURACY','/VARIABLE','/PERIODIC','/BLANKING',           &
    '*DRAW',      '/USER','/BOX','/CHARACTER','/CLIP',                       &
    ' ERRORBAR',                                                             &
    ' HISTOGRAM', '/BLANKING','/FILL','/BASE','/HATCH','/Y',                 &
    ' LABEL',     '/X','/Y','/CENTERING','/APPEND',                          &
    ' LIMITS',    '/XLOG','/YLOG','/RGDATA','/BLANKING','/REVERSE',          &
                  '/VARIABLES','/MARGIN',                                    &
    '*LOOK',                                                                 &
    ' PENCIL',    '/COLOUR','/DASHED','/WEIGHT','/DEFAULT',                  &
    ' POINTS',    '/BLANKING','/SIZE','/MARKER',                             &
    ' RULE',      '/MAJOR','/MINOR',                                         &
    ' SET',       '/DEFAULT',                                                &
    ' SHOW',                                                                 &
    ' TICKSPACE',                                                            &
    ' VALUES',    '/BLANKING' /
  data ccom2 /                                                                 &
    ' ARROW',                                                                  &
    ' CONVERT',     '/TYPE','/UNIT','/SYSTEM','/VARIABLE',                     &
    ' ELLIPSE',     '/BOX','/USER','/ARC','/FILL','/HATCH','/SAVE',            &
    '$EXTREMA',     '/BLANKING','/PLOT','/COMPUTE','/LOCAL',                   &
    ' GRID',        '/ALTERNATE','/LABEL',                                     &
    ' LEVELS',                                                                 &
    ' MASK',        '/BLANKING',                                               &
    ' MEAN',        '/CLIP',                                                   &
    ' PLOT',        '/BLANKING','/SCALING','/POSITION','/BOUNDARIES',          &
                    '/VISIBLE',                                                &
    ' PROJECTION',  '/TYPE',                                                   &
    ' PERSPECTIVE', '/FACTOR','/LOWER','/LINES','/STEP','/AXES','/CENTER',     &
                    '/VERTICAL',                                               &
    ' POLYGON',     '/PLOT','/VARIABLE','/FILL','/RESET','/HATCH',             &
    ' RANDOM_MAP',  '/BLANKING','/NEIGHBOURS','/TRIANGLES','/EXTRAPOLATE',     &
                    '/VARIABLE','/SKIP',                                       &
    ' RESAMPLE',    '/X','/Y','/BLANKING',                                     &
    ' RGDATA',      '/SUBSET','/VARIABLE','/FORMAT','/INCREMENT','/BLANKING',  &
    ' RGMAP',       '/ABSOLUTE','/PERCENT','/KEEP','/BLANKING','/GREY',        &
                    '/PENS','/ONLY',                                           &
    ' STRIP',                                                                  &
    ' WRITE',       '/TABLE',                                                  &
    ' WEDGE',       '/SCALING','/LEVELS'/
  data ccom3 /                                       &
    ' IMAGE', '/PLANE','/SUBSET','/WRITE','/CLOSE',  &
    ' KILL',                                         &
    ' SPECTRUM','/CORNER','/MEAN','/PLANES', '/SUM'  /
  !
  ! Initialize module variables
  call greg_mod_init
  !
  error = gterrtst()
  !
  ! Set up language
  i = index(line,' ')
  if (i.eq.0) then
    i = lenc(line)
    name = ' '
  else
    name = line(i+1:)
    i = i-1
  endif
  lv = lenc(vers)
  if (line(1:i).eq.'LIBRARY') then
    if (jtmp.eq.0) library = .true.
    if (name.eq.' ' .or. name.eq.'GREG1') then
      call sic_begin('GREG1',' ',mcom1,ccom1,vers(1:lv),run_greg1,gterrtst)
    endif
    if (name.eq.' ' .or. name.eq.'GREG2') then
      call sic_begin('GREG2',' ',mcom2,ccom2,vers(1:lv),run_greg2,gterrtst)
    elseif (name.eq.'GREG3') then
      call sic_begin('GREG3',' ',mcom3,ccom3,vers(1:lv),run_greg3,gterrtst)
    endif
  else
    library = .false.
    if (name.eq.' ' .or. name.eq.'GREG1') then
      call sic_begin('GREG1','GAG_HELP_GREG1',mcom1,ccom1,vers(1:lv),  &
      run_greg1,gterrtst)
    endif
    if (name.eq.' ' .or. name.eq.'GREG2') then
      call sic_begin('GREG2','GAG_HELP_GREG2',mcom2,ccom2,vers(1:lv),  &
      run_greg2,gterrtst)
    elseif (name.eq.'GREG3') then
      call sic_begin('GREG3','GAG_HELP_GREG3',mcom3,ccom3,vers(1:lv),  &
      run_greg3,gterrtst)
    endif
  endif
  !
  ! If already set return
  if (jtmp.ne.0) return
  !
  ! Initialize X Y Z buffers
  maxxy = 0
  nxy = 0
  !
  ! Allocate logical units
  istatus = sic_getlun(jtmp)
  if (mod(istatus,2).eq.0) call sysexi(istatus)
  !
  ! Initialize GTVIRT
  if (lung.eq.0) istatus = sic_getlun(lung)
  if (lunh.eq.0) istatus = sic_getlun(lunh)
  call gtinit(lxs_d,lys_d,lung,lunh,'<GREG',greg_user,error)
  if (error)  return
  call gterflag(.true.)  ! Set GTVIRT to error recovery mode
  !
  ! Resolve default pen:
  ! - colours (translate human names to GTV internal IDs)
  ! - weights (translate Greg numbers to cm)
  do i=0,maxpen
    call gtv_pencol_name2id('GREG',defcolname(i),defcolid(i),error)
    if (error)  return
    call gtv_penwei_num2val('GREG',defweinum(i),defweival(i),error)
    if (error)  return
  enddo
  !
  ! And initialise GREG
  call greg_variables
  call gr_exec1('SET /DEFAULT')
  call gr_exec1('PENCIL /DEFAULT')
  call gr_exec1('TICKSPACE 0 0 0 0')
  chain = 'GREG1'//backslash//'SET /DEFAULT'
  call sic_insert(chain)
  chain = 'GREG1'//backslash//'PENCIL /DEFAULT'
  call sic_insert(chain)
  chain = 'GREG1'//backslash//'TICKSPACE 0 0 0 0'
  call sic_insert(chain)
  !
  ! Initialize graphic library
#if defined(GAG_USE_STATICLINK)
  call init_graph_api
#endif
  !
end subroutine load_greg
!
subroutine exit_greg(error)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>exit_greg
  use greg_kernel
  !---------------------------------------------------------------------
  ! @ private
  ! Clean the GREG-related components on exit
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call sic_frelun(jtmp)
  call sic_frelun(lung)
  call sic_frelun(lunh)
  !
  call greg3_close
  !
end subroutine exit_greg
!
subroutine greg_user(flagin,array)
  use greg_interfaces, except_this=>greg_user
  use greg_kernel
  use greg_pen
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  !   Give or retrieve coordinate conversion formula to/from GTVIRT.
  ! The buffer is of size 26, same as the type 'greg_values' in the
  ! GTVIRT.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in) :: flagin     !
  integer(kind=4)             :: array(26)  !
  !
  if (flagin.lt.0) then
    ! Change Directory
    call r8tor8(array( 1),gux1,     8)
    call l4tol4(array(17),axis_xlog,1)
    call l4tol4(array(18),axis_ylog,1)
    call r4tor4(array(19),gx1,      4)
    call r4tor4(array(23),lx1,      4)
    gxp = -1e10
    gyp = -1e10
    penupd = .true.
    call setrem  ! Trial ... does not restore the PANGLE correctly
  elseif  (flagin.eq.0) then
    ! Clear Plot
    gxp = -1e10
    gyp = -1e10
    penupd = .true.
  else
    ! Transmit values
    call r8tor8(gux1,     array( 1),8)
    call l4tol4(axis_xlog,array(17),1)
    call l4tol4(axis_ylog,array(18),1)
    call r4tor4(gx1,      array(19),4)
  ! call r4tor4(lx1,      array(23),4)
  endif
  !
end subroutine greg_user

!
! Binary real conversion routines
!
subroutine ieee32_to_real(ieee32,ni,map,ndata,nfill,bscal,bzero,bval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Convert 4-bytes floating point numbers to native format (single
  ! precision).
  !
  ! Endianness vs IEEE-754, what's the status?
  ! - "[In FITS format,] the individual data values shall be stored in
  !   big-endian byte order". Note that x86 CPUs are little-endian.
  ! - "Transmission of 32- and 64-bit floating-point data within the
  !   FITS format shall use the ANSI/IEEE-754 standard". Note that
  !   IEEE-754 does not enforce endianness.
  !
  ! Both rules combined mean that, in FITS, floating points are stored
  ! using big-endian. Note that Gildas refers to IEEE for little-endian
  ! machines, and to EEEI to big-endian. Don't be confused: IEEE-754 is
  ! just a standard which defines how to describe floating points, it
  ! does not describe endianness.
  !
  ! Reference:
  !   "Definition of the Flexible Image Transport System"
  !    Version 3.0: approved 2008 July 10 by the IAUFWG
  !    Document publication date: 2010 November 18
  !---------------------------------------------------------------------
  integer(kind=4),           intent(in)    :: ieee32(*)   ! Input buffer in IEEE format
  integer(kind=size_length), intent(in)    :: ni          ! Buffer size
  integer(kind=size_length), intent(in)    :: ndata       ! Output array size
  real(kind=4),              intent(out)   :: map(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
  real(kind=4),              intent(in)    :: bscal       ! Scaling factor
  real(kind=4),              intent(in)    :: bzero       ! Offset
  real(kind=4),              intent(in)    :: bval        ! Blanking value
  ! Local
  integer(kind=size_length) :: n
  !
  n = min(ndata-nfill,ni)
#if defined(VAX)
  call setblnk4(bval)
  call eir4va_sl(ieee32,map(nfill+1),n)
  call rsetblnk
#endif
#if defined(IEEE)
  call eir4ie_sl(ieee32,map(nfill+1),n)
#endif
#if defined(EEEI)
  map(nfill+1:nfill+n) = ieee32(1:n)
#endif
  !
  ! Scaling is poor style for floats, but not strictly forbidden...
  if (bzero.ne.0.0 .or. bscal.ne.1.0) then
    map(nfill+1:nfill+n) = map(nfill+1:nfill+n)*bscal+bzero
  endif
  nfill = nfill+n
end subroutine ieee32_to_real
!
subroutine real_to_ieee32 (ieee32,ni,map,ndata,nfill,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface obsolete
  !  Blanking values are NOT correctly translated to a NaN in present
  ! version. This must be fixed before floating FITS can be routinely
  ! written!!!
  ! => Obsolete! Use instead 'real_to_real4' which translates correctly
  ! blanks into NaNs
  !---------------------------------------------------------------------
  real(kind=4),              intent(out)   :: ieee32(*)   ! Output buffer in IEEE format
  integer(kind=size_length), intent(in)    :: ni          ! Buffer size
  integer(kind=size_length), intent(in)    :: ndata       ! Input array size
  real(kind=4),              intent(in)    :: map(ndata)  ! Input array
  integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
  real(kind=4),              intent(in)    :: bval        ! Blanking value
  real(kind=4),              intent(in)    :: eval        ! Blanking tolerance
  ! Local
  integer(kind=size_length) :: n
  !
  n = min(ndata-nfill,ni)
#if defined(VAX)
  call setblnk4(bval)
  call var4ei_sl(map(nfill+1),ieee32,n)
  call rsetblnk
#endif
#if defined(IEEE)
  call ier4ei_sl(map(nfill+1),ieee32,n)
#endif
#if defined(EEEI)
  ieee32(1:n) = map(nfill+1:nfill+n) 
#endif
  nfill = nfill+n
end subroutine real_to_ieee32
!
subroutine ieee64_to_dble (ieee64,ni,map,ndata,nfill,bscal,bzero,bval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Convert 8-bytes floating point numbers to native format (double
  ! precision).
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)    :: ieee64(*)   ! Input buffer in IEEE format
  integer(kind=size_length), intent(in)    :: ni          ! Buffer size
  integer(kind=size_length), intent(in)    :: ndata       ! Output array size
  real(kind=8),              intent(out)   :: map(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
  real(kind=8),              intent(in)    :: bscal       ! Scaling factor
  real(kind=8),              intent(in)    :: bzero       ! Offset
  real(kind=8),              intent(in)    :: bval        ! Blanking value
  ! Local
  integer(kind=size_length) :: n
  !
  n = min(ndata-nfill,ni)
#if defined(VAX)
  call setblnk8(bval)
  call eir8va_sl(ieee64,map(nfill+1),n)
  call rsetblnk
#endif
#if defined(IEEE)
  call eir8ie_sl(ieee64,map(nfill+1),n)
#endif
#if defined(EEEI)
  map(nfill+1:nfill+n) = ieee64(1:n)
#endif
  !
  ! Scaling is poor style for floats, but not strictly forbidden...
  if (bzero.ne.0.0 .or. bscal.ne.1.0) then
    map(nfill+1:nfill+n) = map(nfill+1:nfill+n) * bscal + bzero 
  endif
  nfill = nfill+n
end subroutine ieee64_to_dble
!
subroutine dble_to_ieee64 (ieee64,ni,map,ndata,nfill,bval,eval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! Blanking values are NOT correctly translated to a NaN in present
  ! version. This must be fixed before floating FITS can be routinely
  ! written!!!
  !---------------------------------------------------------------------
  real(kind=8),              intent(out)   :: ieee64(*)   ! Output buffer in IEEE format
  integer(kind=size_length), intent(in)    :: ni          ! Buffer size
  integer(kind=size_length), intent(in)    :: ndata       ! Input array size
  real(kind=8),              intent(in)    :: map(ndata)  ! Input array
  integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
  real(kind=8),              intent(in)    :: bval        ! Blanking value
  real(kind=8),              intent(in)    :: eval        ! Blanking tolerance
  ! Local
  integer(kind=size_length) :: n
  !
  n = min(ndata-nfill,ni)
#if defined(VAX)
  call setblnk8(bval)
  call var8ei_sl(map(nfill+1),ieee64,n)
  call rsetblnk
#endif
#if defined(IEEE)
  call ier8ei_sl(map(nfill+1),ieee64,n)
#endif
#if defined(EEEI)
  ieee64(1:n) = map(nfill+1:nfill+n)
#endif
  nfill = nfill+n
end subroutine dble_to_ieee64
!
subroutine ieee64_to_real(ieee64,ni,map,ndata,nfill,bscal,bzero,bval)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Convert 8-bytes floating point numbers to native format (single
  ! precision).
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)    :: ni          ! Buffer size
  real(kind=8),              intent(inout) :: ieee64(ni)  ! Input buffer in IEEE format, modified...
  integer(kind=size_length), intent(in)    :: ndata       ! Output array size
  real(kind=4),              intent(out)   :: map(ndata)  ! Output array
  integer(kind=size_length), intent(inout) :: nfill       ! Counter in output array
  real(kind=4),              intent(in)    :: bscal       ! Scaling factor
  real(kind=4),              intent(in)    :: bzero       ! Offset
  real(kind=4),              intent(in)    :: bval        ! Blanking value
  ! Local
  integer(kind=size_length) :: n
  !
  n = min(ndata-nfill,ni)
  !
  ! Convert the REAL*8 array into an automatic array
#if defined(VAX) 
  call setblnk8(bval)
  call eir8va_sl(ieee64,ieee64,n)
  call rsetblnk
#elif defined(IEEE)
  call eir8ie_sl(ieee64,ieee64,n)
#endif
  ! Copy converted doubles to single precision output array
  ! Scaling is poor style for floats, but not strictly forbidden...
  if (bscal.eq.1.0 .and. bzero.eq.0.0) then
    map(nfill+1:nfill+n) = ieee64(1:n)
  else
    map(nfill+1:nfill+n) = ieee64(1:n)*bscal + bzero
  endif
  nfill = nfill+n
end subroutine ieee64_to_real

program moments
  use gildas_def
  use image_def
  use gkernel_interfaces
  use gbl_format
  !---------------------------------------------------------------------
  ! GILDAS
  !	A dedicated routine to compute the moment of an input data cube.
  !	Input: a LMV cube
  !	Output: 3 images
  !           1) the integrated intensity map
  !           2) The mean velocity
  !           3) The line width
  !	Method:
  !       For each spectrum, make a gate in velocity and clip based on
  !       intensity. Sum up weighted velocity and mean intensity.
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey,namez
  character(len=80) :: chain
  logical :: error,smooth
  real(kind=4) :: velo(2),seuil,dv,vfirst,vlast
  integer(kind=4) :: ier,n
  integer(kind=index_length) :: nv,ifirst,ilast,itmp
  integer(kind=size_length) :: nxy
  real(kind=4), allocatable :: ipb(:)
  type(gildas) :: x,y,z,w
  !
  call gildas_open
  call gildas_char('IN$',namey)
  call gildas_char('OUT$',namez)
  call gildas_real('VELOCITY$',velo,2)
  call gildas_real('THRESHOLD$',seuil,1)
  call gildas_logi('SMOOTH$',smooth,1)
  call gildas_close
  !
  n = len_trim(namey)
  if (n.eq.0) goto 100
  n = len_trim(namez)
  if (n.eq.0) goto 100
  !
  ! Open first input map, the one to be placed in Y place
  call gildas_null(y)
  ! Force reading in y%r3d (an error will be raised if in can not
  ! accomodate in a 3D cube)
  call gdf_read_gildas(y,namey,'.lmv',error,rank=+3)
  if (error)  goto 100
  !
  ! Compute the channel range
  if (velo(1).eq.0.0 .and. velo(2).eq.0.0) then
    ifirst = 1
    ilast = y%gil%dim(3)
  else
    ifirst = nint((velo(1) - y%gil%val(3)) / y%gil%inc(3) + y%gil%ref(3), kind=index_length)
    ilast = nint((velo(2) - y%gil%val(3)) / y%gil%inc(3) + y%gil%ref(3), kind=index_length)
    if (y%gil%inc(3).lt.0) then
      itmp = ifirst
      ifirst = ilast
      ilast = itmp
    endif
    ifirst = min(max(1,ifirst),y%gil%dim(3))
    ilast = min(max(1,ilast),y%gil%dim(3))
  endif
  !
  ! Same as above for X image
  namex = namez
  call gildas_null(x)
  call gdf_copy_header(y,x,error)
  call sic_parsef(namex,x%file,' ','.mean')
  !
  ! Modify the requested part of the X Header
  x%gil%dim(3) = 1
  x%char%code(3) = 'UNKNOWN'
  x%gil%convert(:,3) = 1.d0
  x%gil%extr_words = 0
  x%gil%blan_words = 2
  if (y%char%code(3).eq.'VELOCITY') then
    x%char%unit = trim(y%char%unit)//'.km/s'
  elseif (y%char%code(3).eq.'FREQUENCY') then
    x%char%unit = trim(y%char%unit)//'.MHz'
  else
    x%char%unit = 'UNKNOWN'
  endif
  x%gil%faxi = 0
  x%gil%bval = 0
  x%gil%eval = 0
  !
  ! Create the image (with write access of course)
  call gdf_create_image(x,error)
  if (error) then
    write(6,*) 'F-MOMENTS,  Cannot create output image'
    goto 100
  endif
  !
  ! As above for Z image
  call gildas_null(z)
  call gdf_copy_header(y,z,error)
  z%gil%extr_words = 0
  z%gil%ndim = 2
  z%char%code(3) = 'UNKNOWN'
  z%gil%dim(3) = 1
  if (y%char%code(3).eq.'VELOCITY') then
    z%char%unit = 'km/s'
  elseif (y%char%code(3).eq.'FREQUENCY') then
    z%char%unit = 'MHz'
  else
    z%char%unit = 'UNKNOWN'
  endif
  z%gil%faxi = 0
  z%gil%bval = 0
  z%gil%eval = 0
  namex = namez
  call sic_parsef(namex,z%file,' ','.velo')
  call gdf_create_image(z,error)
  if (error) then
    write(6,*) 'F-MOMENTS,  Cannot create output image'
    goto 100
  endif
  !
  ! And line width
  call gildas_null(w)
  call gdf_copy_header(z,w,error)
  w%gil%extr_words = 0
  namex = namez
  call sic_parsef(namex,w%file,' ','.width')
  call gdf_create_image(w,error)
  !
  ! Do some useful job
  nxy = z%gil%dim(1)*z%gil%dim(2)
  allocate (x%r2d(x%gil%dim(1), x%gil%dim(2)), z%r2d(z%gil%dim(1), z%gil%dim(2)),  &
            w%r2d(x%gil%dim(1), x%gil%dim(2)), ipb(y%gil%dim(3)), stat=ier)
  if (ier.ne.0) goto 100
  x%r2d = 0.0
  z%r2d = 0.0
  w%r2d = 0.0
  !
  nv = y%gil%dim(3)
  call set_velo(nv,ipb,y%gil%ref(3),y%gil%val(3),y%gil%inc(3))
  dv = abs(y%gil%inc(3))
  !
  ! Loop in valid range
  write(chain,*) 'I-MOMENT,  Channel range ',ifirst,ilast
  call gagout(chain)
  if (y%gil%inc(3).gt.0) then
    vfirst = (ifirst-0.5-y%gil%ref(3))*y%gil%inc(3)+y%gil%val(3)
    vlast  = (ilast+0.5-y%gil%ref(3))*y%gil%inc(3)+y%gil%val(3)
  else
    vlast = (ifirst-0.5-y%gil%ref(3))*y%gil%inc(3)+y%gil%val(3)
    vfirst  = (ilast+0.5-y%gil%ref(3))*y%gil%inc(3)+y%gil%val(3)
  endif
  write(chain,*) 'I-MOMENTS,  Velocity range ',vfirst,vlast
  call gagout(chain)
  !
  call compute_moments(y%r3d,nxy,nv,x%r2d,z%r2d,w%r2d,ipb,ifirst,ilast,  &
    seuil,y%gil%bval,y%gil%eval)
  ! Scale intensity map
  x%r2d = x%r2d * dv
  ! Scale line width to equivalent Gaussian profile
  dv = sqrt(8.0*alog(2.0))
  w%r2d = w%r2d * dv
  !
  call gdf_write_data (x,x%r2d,error)
  call gdf_write_data (z,z%r2d,error)
  call gdf_write_data (w,w%r2d,error)
  !
  deallocate(x%r2d,z%r2d,w%r2d,ipb)
  !
  ! STOP with some acknowledgement message
  call gagout('S-MOMENTS,  Successful completion')
  call sysexi (1)
  !
  ! Error processing
100 call sysexi (fatale)
end program moments
!
subroutine compute_moments(a,nxy,nv,a0,a1,a2,v,ivmin,ivmax,s,bval,eval)
  use gildas_def
  integer(kind=size_length),  intent(in)  :: nxy
  integer(kind=index_length), intent(in)  :: nv
  real(kind=4),               intent(in)  :: a(nxy,nv)
  real(kind=4),               intent(out) :: a0(nxy)
  real(kind=4),               intent(out) :: a1(nxy)
  real(kind=4),               intent(out) :: a2(nxy)
  real(kind=4),               intent(in)  :: v(nv)
  integer(kind=index_length), intent(in)  :: ivmin
  integer(kind=index_length), intent(in)  :: ivmax
  real(kind=4),               intent(in)  :: s
  real(kind=4),               intent(in)  :: bval,eval
  ! Local
  integer(kind=size_length) :: i
  integer(kind=index_length) :: k
  real(kind=4) :: a12
  !
  if (eval.lt.0.) then
    do k=ivmin,ivmax
      do i=1,nxy
        if (a(i,k).ge.s) then
          a0(i) = a0(i) + a(i,k)
          a1(i) = a1(i) + v(k)*a(i,k)
          a2(i) = a2(i) + v(k)*v(k)*a(i,k)
        endif
      enddo
    enddo
  else
    do k=ivmin,ivmax
      do i=1,nxy
        if (a(i,k).ge.s .and. abs(a(i,k)-bval).gt.eval) then
          a0(i) = a0(i) + a(i,k)
          a1(i) = a1(i) + v(k)*a(i,k)
          a2(i) = a2(i) + v(k)*v(k)*a(i,k)
        endif
      enddo
    enddo
  endif
  !
  do i=1,nxy
    if (a0(i).ne.0.0) then
      a1(i) = a1(i)/a0(i)
      a2(i) = a2(i)/a0(i)
      a12 = a1(i)*a1(i)
      if (a12.gt.a2(i)) then
        a2(i) = 0.0
      else
        a2(i) = sqrt(a2(i) - a12)
      endif
    else
      a1(i) = 0.0
      a2(i) = 0.0
    endif
  enddo
end subroutine compute_moments
!
subroutine set_velo(nv,av,ref,val,inc)
  use gildas_def
  integer(kind=index_length), intent(in)  :: nv
  real(kind=4),               intent(out) :: av(nv)
  real(kind=8),               intent(in)  :: ref,val,inc
  ! Local
  integer(kind=index_length) :: iv
  do iv=1,nv
    av(iv) = (iv-ref)*inc+val
  enddo
end subroutine set_velo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gcont_contour
  !--------------------------------------------------------------------
  ! ???
  !-------------------------------------------------------------------- 
  !
  ! Error management??? (old conerr.inc)
  integer :: nit   !
  integer :: itipv !
  integer :: irec  !
  integer :: nerr  !
  !
  ! ??? (old conran.inc)
  integer :: ncp, ncpsz
  real :: xst, yst, xed, yed, stpsx, stpsy
  integer :: igrad, ig
  integer :: np, itll, ibll, itrl, ibrl, jx, jy, iloc, ioc, nc
  real :: tr, br, tl, bl, conv, xn, yn, xc, yc, xo, yo
  integer :: nt, nl, ntnl, jwipt, jwiwl, jwiwp, jwipl, ipr, itpv
  integer :: ixmax, iymax
  real :: xumax, yumax
  logical :: repeat, extrap, look, pldvls
  logical :: pmimx, extri, loaded
  !
  ! Contour levels
  integer, parameter :: maxcl=40
  !
  ! Regular grid mapping
  integer :: ioffp            ! Blanking or not
  integer :: ix,iy            ! X and Y pixels currently processed
  integer :: idx,idy
  integer :: ixbits,iybits    ! Number of bits in arithmetic
  integer :: is,iss
  integer :: np2              ! Number of points used in contour storage
  integer :: nr               ! Size of contour storage
  integer :: inx(8),iny(8)    ! Number of contour values
  integer :: ncl
  real :: spval               ! Blanking value
  real :: epsval              ! Tolerance in blanking
  real :: clev(maxcl)         ! Array of contour values
  real :: qlev                ! Multiplicative factor for contour values
  real :: cv
end module gcont_contour
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gcont_gridder
  !--------------------------------------------------------------------
  ! Setup of user preferences for the gridding (command GREG\RANDOM_MAP)
  !--------------------------------------------------------------------
  logical :: lextrp           ! Extrapolate or not?
  real :: rblank              ! Blanking value if not
end module gcont_gridder
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module field_type
  type field            !! Field data 
    integer :: nvisi    !! Current visibility pointer
    integer :: mvisi    !! Maximum number of visibilities
    real, allocatable :: visi(:,:) !! Visibilities
  end type
end module field_type
!
subroutine uv_sort_comm(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this => uv_sort_comm
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for command
  !   UV_SORT [TIME|BASE|UV]
  !
  ! Sort the UV data in the specified order
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: line  !! Command line
  logical,          intent(out) :: error !! Logical error flag
  !
  character(len=*), parameter :: rname='UV_SORT'
  integer, parameter :: mvoc=4
  character(len=12) :: voc1(mvoc)
  data voc1/'BASE','TIME','FIELDS','FREQUENCY'/ ! ,'UV'/ not needed here - respect order...
  !
  ! Local ---
  type(gildas) :: htmp, hiuv, houv
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  integer :: ioff, joff, itel, nu, kv
  logical :: err, ismosaic, sorted
  integer :: code,jcode,na
  character(len=12) :: argu,vvoc
  ! 
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data')
    error = .true.
    return
  endif
  call get_mosaic_cols(huv,ioff,joff,itel,ismosaic)  
  !
  ! Parse input line. Default argument is TIME for Single-Fields, FIELDS for Mosaics
  if (ismosaic) then
    argu = 'FIELDS'
  else
    argu = 'TIME'
  endif
  call sic_ke(line,0,1,argu,na,.false.,error)
  if (error) return
  call sic_ambigs(rname,argu,vvoc,code,voc1,mvoc,error)
  if (error) return
  !
  if (ismosaic) then
    !
    ! For Mosaic, the behaviour is to Sort the UV data
    if (vvoc.eq.'FIELDS') then
      huv%r2d => duv
      call uvsort_check_fields(huv,ioff,joff,itel,sorted)
      if (sorted) then
        call map_message(seve%i,rname,'Mosaic is already sorted by FIELDS')
        return
      endif
    endif
    nullify (duv_previous, duv_next)
    kv = huv%gil%nvisi
    nu = huv%gil%dim(1)
    call uv_find_buffers (rname,nu,kv,duv_previous,duv_next,error)
    call gildas_null(hiuv,type='UVT')
    call gdf_copy_header(huv,hiuv,error)
    hiuv%r2d => duv_previous
    call gildas_null(houv,type='UVT')
    call gdf_copy_header(huv,houv,error)
    houv%r2d => duv_next
    call uvsort_mosaic_mem(hiuv,houv,vvoc,ioff,joff,itel,error)
    call uv_clean_buffers (duv_previous, duv_next,error)
    ! Indicate UV data has changed, and weight must be computed
    call gdf_copy_header(houv,huv,error)
    call uv_new_data(weight=.true.)
    if (error) return  
  else if (vvoc.ne.'FIELDS') then
    !
    ! For Single Fields, the output is a transposed version of the UV data
    ! for further display
    if (vvoc.eq.'FREQUENCY') then
      call uvsort_frequency_mem(huv,duv,error)
    else
      !
      ! Sort uv buffer
      call gildas_null(htmp,type='UVT')
      call uv_buffer_finduv(jcode) 
      call gdf_copy_header(huv,htmp,error)
      call uvdata_select(rname,error)
      if (error) return
      call uv_tri(code,huv,duv,error)
      ! Reset the previous UV data pointers
      call uv_buffer_resetuv(jcode) 
      call gdf_copy_header(htmp,huv,err)
      if (error) return
    endif
    !
  else  
    call map_message(seve%e,rname,'FIELDS keyword is only valid for Mosaics')
    error = .true.
  endif
  !
end subroutine uv_sort_comm
!
subroutine uvsort_check_fields(hiuv,ioff,joff,itel,sorted)
  use image_def
  !
  type(gildas), intent(in) :: hiuv  !! Input UV header
  integer, intent(in) :: ioff       !! X column pointer
  integer, intent(in) :: joff       !! Y column pointer
  integer, intent(in) :: itel       !! Telescope ID pointer
  logical, intent(out) :: sorted    !! Is data sorted ?
  !
  ! Local ---
  integer, parameter :: mf=1024 ! Max number of fields, hardly ever used
  real :: offi(mf), offj(mf)
  integer :: telid(mf)
  real :: offx, offy
  integer :: otel
  integer :: nv,iv
  integer :: nf,jf
  !
  ! Code ----
  sorted = .false.
  nv = hiuv%gil%nvisi
  nf = 1
  !
  offi(1) = hiuv%r2d(ioff,1)
  if (itel.eq.0) then
    if (joff.eq.0) then
      do iv=2,nv
        offx = hiuv%r2d(ioff,iv)
        if (offx.ne.offi(nf)) then
          ! Not the same as the previous one. Is it among the already existing ones ?
          do jf=1,nf-1
            if (offx.eq.offi(jf)) return  ! Yes. Then the data is not sorted
          enddo
          ! No. It is a new one
          nf = nf+1
          offi(nf) = offx
        endif
      enddo
    else
      offj(1) = hiuv%r2d(joff,1)
      do iv=2,nv
        offx = hiuv%r2d(ioff,iv)
        offy = hiuv%r2d(joff,iv)
        if ((offx.ne.offi(nf)).or.(offy.ne.offj(nf))) then
          ! Not the same as the previous one. Is it among the already existing ones ?
          do jf=1,nf-1
            if ((offx.eq.offi(jf)).and.(offy.eq.offj(jf))) return  ! Yes. Then the data is not sorted
          enddo
          ! No. It is a new one
          nf = nf+1
          offi(nf) = offx
          offj(nf) = offy
        endif
      enddo
    endif
  else
    telid(1) = hiuv%r2d(itel,1)
    if (joff.eq.0) then
      do iv=2,nv
        offx = hiuv%r2d(ioff,iv)
        otel = hiuv%r2d(itel,iv)
        if ((offx.ne.offi(nf)).or.(otel.ne.telid(nf))) then
          ! Not the same as the previous one. Is it among the already existing ones ?
          do jf=1,nf-1
            if ((offx.eq.offi(jf)).and.(otel.eq.telid(jf))) return  ! Yes. Then the data is not sorted
          enddo
          ! No. It is a new one
          nf = nf+1
          offi(nf) = offx
          telid(nf) = otel
        endif
      enddo
    else
      offj(1) = hiuv%r2d(joff,1)
      do iv=2,nv
        offx = hiuv%r2d(ioff,iv)
        offy = hiuv%r2d(joff,iv)
        otel = hiuv%r2d(itel,iv)
        if ((offx.ne.offi(nf)).or.(offy.ne.offj(nf)).or.(otel.ne.telid(nf))) then
          ! Not the same as the previous one. Is it among the already existing ones ?
          do jf=1,nf-1
            if ((offx.eq.offi(jf)).and.(offy.eq.offj(jf)).and.(otel.eq.telid(jf))) return  ! Yes. Then the data is not sorted
          enddo
          ! No. It is a new one
          nf = nf+1
          offi(nf) = offx
          offj(nf) = offy
          telid(nf) = otel
        endif
      enddo
    endif
  endif
  sorted = .true.
end subroutine uvsort_check_fields
!
subroutine uv_tri(code,huvin,duvin,error)
  use gkernel_interfaces
  use imager_interfaces, only : uv_findtb, map_message
  use clean_def
  use clean_arrays
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER Support routine for command
  !   UV_SORT [TIME|BASE|UV]
  !
  !     BASE is code 1  
  !     TIME is code 2  
  !     UV is code 3  
  !!
  !---------------------------------------------------------------------
  integer, intent(in)  :: code        !! Sorting code
  type(gildas), intent(in) :: huvin   !! UV data to be sorted
  real, intent(in) :: duvin(huvin%gil%dim(1),huvin%gil%dim(2)) !! Visibilities
  logical, intent(out) :: error       !! Logical error flag
  !
  character(len=7) :: rname = 'UV_SORT'
  !
  ! Local ---
  integer code_bt,code_tb
  parameter(code_bt=1)
  parameter(code_tb=2)
  integer ier,nd,mv,nv,id,iv
  integer, allocatable :: it(:),ot(:)
  real(kind=8), allocatable :: order(:)
  logical sorted, warning, alloc
  !
  ! Code ----
  error = .false.
  !
  ! Create Sorted UV data
  call sic_delvariable('UVS',.false.,warning)
  !
  ! Check first if UVT is already matching UV
  alloc = .false.
  if (allocated(duvt)) then
    if ( (huvin%gil%dim(2).ne.huvt%gil%nvisi) .or. &
      & (10+3*huvin%gil%nchan+huvin%gil%ntrail.ne.huvt%gil%dim(2)) ) then
      deallocate (duvt)
    else
      alloc = .true.
    endif
  endif
  !
  call gildas_null (huvt, type = 'TUV')
  call gdf_transpose_header(huvin,huvt,'21  ',error)
  if (error)  return
  mv = huvin%gil%dim(1)    ! Including trailing columns
  nd = 7+3*huvin%gil%nchan+huv%gil%ntrail ! Also count trailing columns
  nv = huvin%gil%nvisi     ! Number of visibilities
  huvt%gil%dim(2) = nd+3
  !
  if (.not.alloc) then
    allocate(duvt(huvt%gil%dim(1),huvt%gil%dim(2)),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Error getting UV memory ')
      error = .true.
      return
    endif
  endif
  call sic_def_real('UVS',duvt,huvt%gil%ndim,huvt%gil%dim,.false.,error)
  if (error) return
  !
  allocate(order(nv),it(nv),ot(nv),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Error getting memory ')
    error = .true.
    return
  endif
  !
  call uv_findtb(code,duvin,mv,nv,order,it,ot,sorted)
  if (sorted) then
    ! !Print *,'****  SHOW UV -- already sorted for code ',code
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duvin(id,iv)
      enddo
    enddo
  else
    do id=1,nd
      do iv=1,nv
        duvt(iv,id) = duvin(id,it(iv))
      enddo
    enddo
  endif
  do iv=1,nv
    duvt(iv,nd+1) = 1.0
  enddo
  deallocate(order,it,ot)
end subroutine uv_tri
!
subroutine uv_findtb(code,uv,mv,nv,order,it,ot,sorted)
  use imager_interfaces, only : triuv8
  !---------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER --  Support for SHOW UV
  !
  !   Check if ordered according to Code, and return sorting
  ! order if needed.
  !---------------------------------------------------------------
  integer, intent(in)       :: code      !! Code for sort operation
  integer, intent(in)       :: mv,nv     !! Size of visibility table
  real, intent(in)          :: uv(mv,nv) !! Input UV data
  real(kind=8), intent(out) :: order(nv) !! Sorting array
  integer, intent(out)      :: it(nv)    !! Sort index
  integer, intent(out)      :: ot(nv)    !! Reverse order
  logical, intent(out)      :: sorted    !! Is already sorted
  !
  ! Constants
  integer, parameter :: code_bt=1
  integer, parameter :: code_tb=2
  !
  ! Local variables
  real(kind=4) rdate
  real(kind=8) olast
  integer iv
  logical error
  !
  ! Code ----
  if (code.eq.code_bt) then
    ! Order BASE(primary) then TIME(secondary)
    rdate = uv(4,1)
    do iv=1,nv
      order(iv) = 1000.d0*86400.0d0*(100.0*uv(6,iv)+uv(7,iv))   &
           &        +(uv(4,iv)-rdate)*86400.d0 + uv(5,iv)
      it(iv) = iv
    enddo
  elseif (code.eq.code_tb) then
    ! Order TIME(primary) then BASE(secondary)
    rdate = uv(4,1)
    do iv=1,nv
      order(iv) =(uv(4,iv)-rdate)*86400.d0 + uv(5,iv) +   &
           &       (100.0d0*uv(6,iv)+uv(7,iv))*1.0d-4
      it(iv) = iv
    enddo
  endif
  !
  ! Check order... This is for dummy UV Tables produced by e.g. UV_CIRCLE
  ! which have no unique ordering...
  olast = order(1)
  sorted = .true.
  do iv=1,nv
    if (order(iv).lt.olast) then
      sorted = .false.
      exit
    endif
    olast = order(iv)
  enddo
  if (sorted) return
  !
  call triuv8(order,it,nv,error)
  if (error) return
  do iv=1,nv
    ot(it(iv)) = iv
  enddo
end subroutine uv_findtb
!
subroutine triuv8(x,it,n,error)
  use gbl_message
  use imager_interfaces, only : map_message
  !------------------------------------------------------------------------
  ! @ private
  !
  !   Sorting program that uses a quicksort algorithm.
  ! Applies for an input array of real*8 values, which are left
  ! unchanged. Returns an array of indexes sorted for increasing
  ! order of X. Use GR8_SORT to reorder X.
  !------------------------------------------------------------------------
  integer,      intent(in)    :: n     !! Array length
  real(kind=8), intent(inout) :: x(n)  !! Unsorted array
  integer,      intent(out)   :: it(n) !! Sort index
  logical,      intent(out)   :: error !! Logical return flag
  !
  ! Local variables
  integer mstack, nstop
  parameter(mstack=1000,nstop=15)
  integer i, j, k, itemp, l, r, m, lstack(mstack), rstack(mstack), sp
  real(kind=8) temp, key
  logical mgtl, lgtr, rgtm
  character(len=message_length) :: mess
  !
  ! Initial pointers are already loaded
  !
  if (n.le.nstop) goto 50
  sp = 0
  sp = sp + 1
  lstack(sp) = 1
  rstack(sp) = n
  !
  ! Sort a subrecord off the stack
  ! Set KEY = median of X(L), X(M), X(R)
  ! No! This is not reasonable, as systematic very inequal partitioning will
  ! occur in some cases(especially for nearly already sorted files)
  ! To fix this problem, I found(but I cannot prove it) that it is best to
  ! select the estimation of the median value from intermediate records. P.V.
1 l = lstack(sp)
  r = rstack(sp)
  sp = sp - 1
  m =(l + r) / 2
  !
  mgtl = x(m) .gt. x(l)
  rgtm = x(r) .gt. x(m)
  !
  ! Algorithm to select the median key. The original one from MONGO
  ! was completely wrong. P. Valiron, 24-Jan-84 .
  !
  !       MGTL  RGTM  LGTR  MGTL.EQV.LGTR MEDIAN_KEY
  !
  ! KL < KM < KR  T T * *   KM
  ! KL > KM > KR  F F * *   KM
  !
  ! KL < KM > KR  T F F F   KR
  ! KL < KM > KR  T F T T   KL
  !
  ! KL > KM < KR  F T F T   KL
  ! KL > KM < KR  F T T F   KR
  !
  if (mgtl .eqv. rgtm) then
     key = x(m)
  else
     lgtr = x(l) .gt. x(r)
     if (mgtl .eqv. lgtr) then
        key = x(l)
     else
        key = x(r)
     endif
  endif
  i = l
  j = r
  !
  ! Find a big record on the left
10 continue
  if (x(i).ge.key) goto 11
  i = i + 1
  goto 10
11 continue
  ! Find a small record on the right
20 if (x(j).le.key) goto 21
  j = j - 1
  goto 20
21 continue
  if (i.ge.j) goto 2
  !
  ! Exchange records
  temp = x(i)
  x(i) = x(j)
  x(j) = temp
  itemp = it(i)
  it(i) = it(j)
  it(j) = itemp
  i = i + 1
  j = j - 1
  goto 10
  !
  ! Subfile is partitioned into two halves, left .le. right
  ! Push the two halves on the stack
2 continue
  if (j-l+1 .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = l
     rstack(sp) = j
  endif
  if (r-j .gt. nstop) then
     sp = sp + 1
     if (sp.gt.mstack) then
        write(mess,*) 'Stack overflow ',sp
        call map_message(seve%e,'SORT',mess)
        error = .true.
        return
     endif
     lstack(sp) = j+1
     rstack(sp) = r
  endif
  !
  ! Anything left to process?
  if (sp.gt.0) goto 1
  !
50 continue
  !
  do j = n-1,1,-1
     k = j
     do i = j+1,n
        if (x(j).le.x(i)) goto 121
        k = i
     enddo
121  continue
     if (k.eq.j) goto 110
     temp = x(j)
     do i = j+1,k
        x(i-1) = x(i)
     enddo
     x(k) = temp
     itemp = it(j)
     do i = j+1,k
        it(i-1) = it(i)
     enddo
     it(k) = itemp
110  continue
  enddo
  error = .false.
end subroutine triuv8
!
subroutine uv_sort_file(line,error)
  use image_def
  use gkernel_interfaces
  use field_type
  use gbl_message
  use imager_interfaces, except_this => uv_sort_file
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER --  Support routine for command  
  !   UV_SORT [TIME|BASE|FIELDS|FREQUENCY] /FILE FileIn FileSort
  !!
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  !! Command line
  logical,          intent(out) :: error !! Logical error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_SORT'
  integer, parameter :: o_file=1 ! /FILE option order
  integer, parameter :: mvoc=4
  character(len=12) voc1(mvoc)
  data voc1/'BASE','TIME','FIELDS','FREQUENCY'/ ! ,'UV'/ not needed here
    !
  ! Local ---
  character(len=12) argu,vvoc
  integer :: iunit, code, na
  type(gildas) :: hiuv, houv
  integer :: ioff,joff,itel
  character(len=filename_length) :: in_file, ou_file
  character(len=120) :: mess
  logical :: ismosaic
  integer :: n, nblock
  !
  ! Code ----
  !
  ! Parse input line. Default argument is TIME
  argu = 'BASE'
  call sic_ke(line,0,1,argu,na,.false.,error)
  if (error) return
  call sic_ambigs('UV_SORT',argu,vvoc,code,voc1,mvoc,error)
  if (error) return
  !
  call gildas_null(hiuv,type='UVT')
  call gildas_null(houv,type='UVT')
  !
  ! Get the file names
  call sic_ch(line,o_file,1,in_file,n,.true.,error)
  if (error) return
  call sic_parse_file(in_file,' ','.uvt',hiuv%file)
  !
  ! Strip extension if present
  call sic_parsef(in_file,ou_file,' ','.uvt')
  ou_file = in_file
  !
  ! Sorted  UV table
  if (sic_present(o_file,2)) then
    call sic_ch(line,o_file,2,ou_file,n,.true.,error)
  else
    ou_file = trim(in_file)//'-sort'
  endif
  !
  ! Treat the Frequency re-ordering separately
  if (vvoc.eq.'FREQUENCY') then
    call uvsort_frequency_file(in_file,ou_file,error)
    return
  endif
  !
  ! Other UV_SORT cases
  call gdf_read_header(hiuv,error)
  if (error) return
  !
  ! Prepare a proper output Header
  call gdf_copy_header(hiuv,houv,error)
  if (error) return
  !
  ! Finalize output file name
  call sic_parse_file(ou_file,' ','.uvt',houv%file)
  !
  ! Set the Blocking Factor
  nblock = space_nitems('SPACE_IMAGER',hiuv,1) 
  iunit = 6
  !
  ! Get the offset columns
  call get_mosaic_cols(hiuv,ioff,joff,itel,ismosaic)
  !
  if (ismosaic) then
    write(mess,'(A,I0,A,I0,A,I0)') 'Mosaic of file size ',hiuv%gil%dim(2), &
      & ' and blocking factor ',nblock      
    call map_message(seve%i,rname,mess)
      call uvsort_mosaic_disk(hiuv,houv,vvoc,ioff,joff,itel,error)
    !
  else
    !
    if (nblock.ge.hiuv%gil%dim(2)) then
      call map_message(seve%i,rname,'Doing in-memory sort')
      call uvsort_single_mem(hiuv,houv,vvoc,error)
      !
    else
      !
      ! Must be made from disk...
      !call big_stupid_uvsort(hiuv%file, houv%file, vvoc, error)
      call uvsort_single_disk(hiuv, houv, vvoc, error)
    endif
  endif
  !
end subroutine uv_sort_file
!
subroutine get_mosaic_cols(hiuv,ioff,joff,itel,ismosaic)
  use image_def
  ! @ private
  !!  Returns 
  type(gildas), intent(in) :: hiuv    !! Input UV header
  integer, intent(out) :: ioff        !! Pointer to X offset
  integer, intent(out) :: joff        !! Pointer to Y offset
  integer, intent(out) :: itel        !! Pointer to Telescope ID
  logical, intent(out) :: ismosaic    !! Mosaic indicator
  !
  ! Local
  integer :: loff,moff,poff,qoff,idoff
  !
  ismosaic = .true.
  loff = hiuv%gil%column_pointer(code_uvt_loff)
  moff = hiuv%gil%column_pointer(code_uvt_moff)
  poff = hiuv%gil%column_pointer(code_uvt_xoff)
  qoff = hiuv%gil%column_pointer(code_uvt_yoff)
  idoff = hiuv%gil%column_pointer(code_uvt_id)
  itel = hiuv%gil%column_pointer(code_uvt_tele)
  if ((loff.ne.0).and.(moff.ne.0)) then
    ioff = loff
    joff = moff
  else if ((poff.ne.0).and.(qoff.ne.0)) then
    ioff = poff
    joff = qoff
  else if (idoff.ne.0) then
    ioff = idoff
    joff = 0
  else if (itel.ne.0) then
    ioff = 0
    joff = 0
  else
    ismosaic = .false.
  endif
end subroutine get_mosaic_cols

subroutine resize_real_array(array,osize,nsize)
  !
  ! @ public-mandatory
  !! IMAGER - Utility routine to extend a REAL array
  !
  real, allocatable, intent(inout) :: array(:) !! Array to be resized
  integer, intent(in) :: osize    !! Old size
  integer, intent(in) :: nsize    !! New size
  !
  real, allocatable :: tmp_arr(:)
  !
  !!write(iunit,*) 'Real resize from ',osize,' to ',nsize
  if (osize.eq.0) then
    allocate(array(nsize))
  else
    allocate(tmp_arr(nsize))
    tmp_arr(1:osize) = array
    deallocate(array)
    call move_alloc(tmp_arr, array)
  endif
  ! tmp_arr is now deallocated
end subroutine resize_real_array
!
subroutine resize_inte_array(array,osize,nsize)
  !
  ! @ public-mandatory
  !! IMAGER - Utility routine to extend a INTEGER array
  !
  integer, allocatable, intent(inout) :: array(:) !! Array to be resized
  integer, intent(in) :: osize    !! Old size
  integer, intent(in) :: nsize    !! New size
  !
  integer, allocatable :: tmp_arr(:)
  !
  if (osize.eq.0) then
    allocate(array(nsize))
  else
    allocate(tmp_arr(nsize))
    tmp_arr(1:osize) = array
    deallocate(array)
    call move_alloc(tmp_arr, array)
  endif
  ! tmp_arr is now deallocated
end subroutine resize_inte_array
!
subroutine resize_dble_array(array,osize,nsize)
  !
  ! @ public-mandatory
  !! IMAGER - Utility routine to extend a DBLE array
  !
  real(8), allocatable, intent(inout) :: array(:) !! Array to be resized
  integer, intent(in) :: osize    !! Old size
  integer, intent(in) :: nsize    !! New size
  !
  real(kind=8), allocatable :: tmp_arr(:)
  !
  if (osize.eq.0) then
    allocate(array(nsize))
  else
    allocate(tmp_arr(nsize))
    tmp_arr(1:osize) = array
    deallocate(array)
    call move_alloc(tmp_arr, array)
  endif
  ! tmp_arr is now deallocated
end subroutine resize_dble_array
!
!
subroutine uvsort_tb (hin,hou,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Sorting utility routine  
  !
  !     Sort a UV data set by Time-Baseline order.
  !     Data must be in the %R2D pointer
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: hin    !! Input UV data
  type(gildas), intent(inout) :: hou    !! Output UV data
  logical, intent(out) :: error         !! Error flage
  !
  ! Local ---
  character(len=*), parameter :: rname='UVSORT_TB'
  character(len=60) :: mess
  integer :: ier
  integer :: nv
  integer :: np
  real(8), allocatable :: times(:)
  integer, allocatable :: indx(:)
  logical :: sorted
  !
  ! Code ----
  if (hin%gil%nvisi.gt.huge(nv)) then
    write(mess,*) 'Cannot handle more than ',huge(nv),' visibilities'
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  nv = hin%gil%nvisi
  np = hin%gil%dim(1)
  !
  allocate(times(nv),indx(nv), stat=ier)
  error = ier.ne.0
  if (error) return
  call loadtb (hin%r2d,np,nv,times,indx,sorted,4)
  !
  ! Sort if needed
  if (.not.sorted) then
    call gr8_trie(times,indx,nv,error)
    if (error) then
      call map_message(seve%e,rname,'Sorting error')
    else
      call sortiv (hin%r2d,hou%r2d,np,nv,indx)
    endif
  else
    call map_message(seve%w,rname,'Table is already sorted')
    hou%r2d = hin%r2d
  endif
  deallocate(times,indx)
end subroutine uvsort_tb
!
subroutine sortiv (vin,vout,np,nv,it)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_SORT
  !
  !     Sort an input UV table into an output one, according
  !     to an index array
  !!
  !----------------------------------------------------------------------
  integer, intent(in) :: np         !! Size of a visibility
  integer, intent(in) ::  nv        !! Number of visibilities
  real, intent(in) ::  vin(np,nv)   !! Input visibilities
  real, intent(out) ::  vout(np,nv) !! Output visibilities
  integer, intent(in) ::  it(nv)    !! Sorting pointer
  !
  integer iv,kv,ic
  !
  ! Simple case
  do iv=1,nv
    kv = it(iv)
    vout(:,iv) = vin(:,kv)
    if (vout(6,iv).gt.vout(7,iv)) then
      vout(6,iv) = vin(7,kv)
      vout(7,iv) = vin(6,kv)
      do ic=9,np,3
        vout(ic,iv) = -vout(ic,iv)
      enddo
    endif
  enddo
end subroutine sortiv
!
subroutine uvsort_bt (hin,hou,error)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, only : map_message
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_SORT
  !
  !     Sort by Baseline - Time.
  !     Data must be in the %R2D pointers
  !!
  !----------------------------------------------------------------------
  type(gildas), intent(inout) :: hin  !! Input header
  type(gildas), intent(inout) :: hou  !! Output header
  logical, intent(out) :: error       !! Error flag
  !
  character(len=*), parameter :: rname='UVSORT_BT'
  character(len=60) :: mess
  integer :: ier
  integer :: nv
  integer :: np
  real(8), allocatable :: times(:)
  integer, allocatable :: indx(:)
  logical :: sorted
  !
  if (hin%gil%nvisi.gt.huge(nv)) then
    write(mess,*) 'Cannot handle more than ',huge(nv),' visibilities'
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  nv = hin%gil%nvisi
  np = hin%gil%dim(1)
  !
  allocate(times(nv),indx(nv), stat=ier)
  error = ier.ne.0
  if (error) return
  call loadbt (hin%r2d,np,nv,times,indx,sorted,4)
  !
  ! Sort if needed
  if (.not.sorted) then
    call gr8_trie(times,indx,nv,error)
    if (error) then
      call map_message(seve%e,rname,'Sorting error')
    else
      call sortiv (hin%r2d,hou%r2d,np,nv,indx)
    endif
  else
    call map_message(seve%w,rname,'Table is already sorted')
    hou%r2d = hin%r2d
  endif
  deallocate(times,indx)
end subroutine uvsort_bt
!
subroutine loadbt (visi,np,nv,tb,it,sorted,idate)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER --  Support routine for UV_SORT 
  !
  !     Load Baseline / Time combination into work arrays for sorting
  !   and check if data is already sorted.
  !!
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   !! Size of a visibility
  integer, intent(in)  :: nv                   !! Number of visibilities
  real, intent(in) :: visi(np,nv)              !! Input visibilities
  real(8), intent(out) :: tb(nv)               !! Output Date+Time
  integer, intent(out) :: it(nv)               !! Indexes
  logical, intent(out) :: sorted               !! Is data sorted ?
  integer, intent(in)  :: idate                !! Date pointer
  !
  integer, external :: uvshort_basenum
  !
  integer :: iv, itime, iant, jant, id, jd, nd,ier
  real(8) :: vmax, dd
  integer, allocatable :: dates(:),jdate(:)
  !
  itime = idate+1
  iant = itime+1
  jant = iant+1
  !
  ! Compact the dates - We could be less Memory hungry 
  !   - dates could be much smaller
  !   - jdate can be avoided (see the Disk version in same file)
  allocate(dates(nv),jdate(nv),stat=ier)
  if (ier.ne.0) return
  nd = 1
  dates(nd) = visi(idate,1)
  jdate(1) = 0
  do iv=2,nv
    jd = 0
    do id = 1,nd
      if (visi(idate,iv).eq.dates(id)) then
        jd = id
        jdate(iv) = jd-1
        exit
      endif
    enddo
    if (jd.eq.0) then
      nd = nd+1
      dates(nd) = visi(idate,iv)
      jdate(iv) = nd-1
    endif
  enddo
  !
  dd = nd+2
  do iv=1,nv
    ! Time compacted value:
    ! This is a date in Days, with a minimun range
    tb(iv) = ( dble(jdate(iv))+dble(visi(itime,iv))/86400d0 ) 
    tb(iv) = tb(iv) / dd  ! That is between [0,1]
    ! Add the baseline number code as major driver
    tb(iv) = tb(iv) + uvshort_basenum(visi(iant,iv),visi(jant,iv))
  enddo
  !
  do iv=1,nv
    it(iv) = iv
  enddo
  !
  vmax = tb(1)
  do iv = 1,nv
    if (tb(iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = tb(iv)
  enddo
  sorted = .true.
end subroutine loadbt
!
!
subroutine loadtb (visi,np,nv,tb,it,sorted,idate)
  !----------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_SORT
  !
  !     Load new U,V coordinates and sign indicator into work arrays
  !     for  Time-Basline sorting.
  !!
  !----------------------------------------------------------------------
  integer, intent(in)  :: np                   !! Size of a visibility
  integer, intent(in)  :: nv                   !! Number of visibilities
  real, intent(in) :: visi(np,nv)              !! Input visibilities
  real(8), intent(out) :: tb(nv)               !! Output Date+Time
  integer, intent(out) :: it(nv)               !! Indexes
  logical, intent(out) :: sorted               !! Is data sorted
  integer, intent(in)  :: idate                !! Date pointer
  !
  integer :: iv, itime, iant, jant, id, jd, nd,ier
  integer, allocatable :: dates(:),jdate(:)
  integer :: imin, imax
  real(8) :: vmax
  !
  ! Scan how many days
  itime = idate+1
  iant = itime+1
  jant = iant+1
  allocate(dates(nv),jdate(nv),stat=ier)
  if (ier.ne.0) return
  nd = 1
  dates(nd) = visi(idate,1)
  jdate(1) = 0
  do iv=2,nv
    jd = 0
    do id = 1,nd
      if (visi(idate,iv).eq.dates(id)) then
        jd = id
        jdate(iv) = jd-1
        exit
      endif
    enddo
    if (jd.eq.0) then
      nd = nd+1
      dates(nd) = visi(idate,iv)
      jdate(iv) = nd-1
    endif
  enddo
  !
  do iv=1,nv
    ! Time compacted value in seconds
    tb(iv) = dble(jdate(iv))*86400d0+dble(visi(itime,iv))
    ! The baseline is not accounted for into this yet...
    ! Do it by adding the baseline number as a sub-item.
    ! This assumes time differ by more than 1 second here, and there
    ! are less than 256 antennas
    imax = max(visi(iant,iv),visi(jant,iv))
    imin = min(visi(iant,iv),visi(jant,iv))    
    tb(iv) = tb(iv) + (256.0*imin+imax)/(256.0*256.0)
  enddo
  !
  do iv=1,nv
    it(iv) = iv
  enddo
  !
  vmax = tb(1)
  do iv = 1,nv
    if (tb(iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = tb(iv)
  enddo
  sorted = .true.
end subroutine loadtb
!
subroutine uvsort_single_mem(hiuv,houv,ctype,error)
  use gkernel_types
  use imager_interfaces, except_this => uvsort_single_mem
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER --  Support for UV_SORT /FILE
  !
  !   Sort the UV data file by loading all in Memory 
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: hiuv   !! Input UV header
  type(gildas), intent(inout) :: houv   !! Output UV header
  character(len=*), intent(in) :: ctype !! sort type
  logical, intent(out) :: error         !! Error flag
  !
  character(len=*), parameter :: rname='UV_SORT'
  !
  integer :: ier
  character(len=80) :: mess
  integer :: np, nv
  real(4) :: uvmax, uvmin, xy(2), cs(2)
  logical :: an_error
  !
  if (hiuv%file .eq. houv%file) then
    call map_message(seve%e,rname,'In place sorting not allowed')
    error = .true.
    return
  endif
  !
  allocate(hiuv%r2d(hiuv%gil%dim(1),hiuv%gil%dim(2)), & 
    & houv%r2d(houv%gil%dim(1),houv%gil%dim(2)),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot Allocate UV data')
    error = .true.
    return
  endif
  !
  call gdf_read_data(hiuv, hiuv%r2d, error)
  if (error) then
    call map_message(seve%e,rname,'Cannot read UV data')
    deallocate(hiuv%r2d,houv%r2d)
    return
  endif
  !
  select case (ctype)
  case ('TIME')
    call uvsort_tb(hiuv,houv,error)
  case ('BASE')
    call uvsort_bt(hiuv,houv,error)
  case ('UV')
    if (hiuv%gil%nvisi.gt.huge(nv)) then
      write(mess,*) 'Cannot handle more than ',huge(nv),' visibilities'
      call map_message(seve%e,rname,mess)
      error = .true.
    else
      nv = hiuv%gil%nvisi
      np = hiuv%gil%dim(1)
      xy = 0.
      call uvsort_uv (np,nv,hiuv%gil%ntrail,     &
        &      hiuv%r2d,houv%r2d,                &
        &      xy,cs,uvmax,uvmin,error)
      write (mess,'(A,F10.2,F10.2)') 'Min - Max UV-spacing: ',uvmin,uvmax
      call map_message(seve%i,rname,mess)
    endif
  !case ('FIELDS')
  !  call uvsort_fi(hiuv,houv,error)
  case default
    call map_message(seve%e,rname,'Does not yet handle '//ctype)
    error = .true.
  end select
  !
  if (.not.error) then
    call gdf_write_image(houv,houv%r2d,error)
  endif
  !
  ! Free memory and close images if opened
  deallocate(hiuv%r2d,houv%r2d,stat=ier)
  an_error = .false.
  call gdf_close_image(hiuv,an_error)
  if (error) then
    an_error = .false.
    call gdf_close_image(houv,an_error)
  endif
end subroutine uvsort_single_mem
!
subroutine big_stupid_uvsort(uvdata,uvtri,type,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message, sub_sortuv, chksuv, loaduv
  !----------------------------------------------------------------------
  ! IMAGER -- Sort an input UV table
  !
  !       Add CC code to implement precession
  !----------------------------------------------------------------------
  character(len=*), intent(in) :: type
  character(len=*), intent(in) :: uvdata,uvtri
  logical, intent(out) :: error
  !
  ! Local variables:
  character(len=*), parameter :: rname='BIG_UVSORT'
  character(len=60) :: mess
  type (gildas) :: in, out
  character(len=12) :: xtype
  character(len=filename_length) :: name
  real, allocatable :: din(:,:)
  real(8), allocatable :: times(:)
  integer, allocatable :: indx(:)
  real(4), allocatable :: u(:), v(:)
  logical, allocatable :: s(:)
  integer :: codes(4)
  logical :: sorted
  integer :: iv,jv,kv,mv,ib
  integer :: nblock
  integer :: one(1)
  !
  real xy(2),cs(2), uvmax, uvmin
  integer :: ier, np, nv
  data xy/0.0,0.0/, cs/1.0,0.0/
  data xtype /'UV-DATA'/
  !
  error = .false.
  call map_message(seve%w,rname,'Doing '//trim(type)//' sorting for huge file')
  !
  ! Input file
  call gildas_null(in, type = 'UVT')
  name = trim(uvdata)
  call gdf_read_gildas(in, name, '.uvt', error, data=.false.)
  !
  nv = in%gil%nvisi
  allocate (indx(nv),times(nv),stat=ier)
  error = ier.ne.0
  if (error) return
  !
  sorted = .false.
  if  (type.eq.'TIME') then
    allocate (din(4,nv),stat=ier)
    codes(1:4) = [code_uvt_date, code_uvt_time, code_uvt_anti, code_uvt_antj]
    call gdf_read_uvonly_codes(in, din, codes, 4, error)
    call loadtb (din,4,nv,times,indx,sorted,1)
  elseif  (type.eq.'BASE') then
    allocate (din(4,nv),stat=ier)
    codes(1:4) = [code_uvt_date, code_uvt_time, code_uvt_anti, code_uvt_antj]
    call gdf_read_uvonly_codes(in, din, codes, 4, error)
    call loadbt (din,4,nv,times,indx,sorted,1)
  elseif (type.eq.'UV') then
    allocate (din(2,in%gil%nvisi),stat=ier)
    codes(1:2) = [code_uvt_u,code_uvt_v]
    call gdf_read_uvonly_codes(in, din, codes, 2, error)
    !
    allocate(u(nv),v(nv),s(nv),stat=ier)
    call loaduv (din,2,nv,cs,u,v,s,uvmax,uvmin)
    call chksuv (nv,v,indx,sorted)
    if (.not.sorted) then
      allocate (in%r2d(in%gil%dim(1),1), stat=ier)
      times(1:nv) = v(1:nv)
    endif
  endif
  !
  ! Sort if needed
  if (sorted) then
    call map_message(seve%e,rname,'Input file is already sorted')
    error = .true.
    return ! Do not even copy the input file ?...
  endif
  !
  call gr8_trie(times,indx,nv,error)
  if (error) return
  !
  ! Simple case
  call gildas_null(out, type = 'UVT')
  call gdf_copy_header(in,out,error)
  name = trim(uvtri)
  call sic_parsef(name,out%file,' ','.uvt')
  if (in%file .eq. out%file) then
    call map_message(seve%e,rname,'In place sorting not allowed')
    error = .true.
    return
  endif
  call gdf_create_image (out,error)
  if (error) return
  !
  call gdf_nitems('SPACE_GILDAS',nblock,out%gil%dim(1))
  nblock = min(out%gil%dim(2),nblock)
  allocate (out%r2d(out%gil%dim(1),nblock), stat=ier)
  !
  ! Loop over line table
  out%blc = 0
  out%trc = 0
  in%blc = 0
  in%trc = 0
  iv = 0
  one(1) = 1
  np = in%gil%dim(1)
  !
  ! Create output by block
  do ib = 1,out%gil%nvisi,nblock
    write(mess,*) ib,' / ',out%gil%nvisi,nblock
    call map_message(seve%d,rname,mess)
    out%blc(2) = ib
    out%trc(2) = min(out%gil%dim(2),ib-1+nblock)
    mv = out%trc(2)-out%blc(2)+1
    !
    ! Build the output only one visibility at once
    ! This can be VERY slow, but no other choice here...
    do jv=1,mv
      iv = iv+1
      kv = indx(iv)
      in%blc(2) = kv
      in%trc(2) = kv
      if (type.eq.'UV') then
        ! Read and modify the visibility because of
        ! the possible phase shift
        call gdf_read_data(in,in%r2d,error)
        call sub_sortuv (in%r2d,out%r2d(:,jv),np,1,in%gil%ntrail, &
          &   xy,1,1,u(kv),v(kv),s(kv),one)
      else
        ! Just read in appropriate place
        call gdf_read_data(in,out%r2d(:,jv),error)
      endif
    enddo
    call gdf_write_data (out,out%r2d,error)
    if (error) return
  enddo
  !
  call gdf_close_image(out,error)
  if (error) then
    call map_message(seve%e,rname,'Error writing UV table')
    return
  endif
end subroutine big_stupid_uvsort
!
subroutine uvsort_mosaic_disk(hiuv,houv,ctype,ioff,joff,itel,error)
  use gkernel_types
  use imager_interfaces, except_this => uvsort_mosaic_disk
  use gkernel_interfaces
  use field_type
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- 
  !   Support for UV_SORT /FILE
  !
  !   Sort a Mosaic UV table - Each field must be independently sorted.
  !     by Time-Baseline 
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: hiuv       !! Input UV header
  type(gildas), intent(inout) :: houv       !! Output UV header
  character(len=*), intent(in) :: ctype     !! Type of sorting
  integer, intent(in) :: ioff               !! Offset column pointer
  integer, intent(in) :: joff               !! Offset column pointer
  integer, intent(in) :: itel               !! Telescope column pointer
  logical, intent(out) :: error             !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_SORT'
  !
  ! Local ---
  real :: xoff,yoff,rtel
  real, allocatable :: xfield(:), yfield(:),tfield(:) ! Field coordinates
  integer, allocatable :: iblc(:), itrc(:)  ! File pointers 
  integer, allocatable :: ifield(:)         ! Field pointer for each visibility
  integer, allocatable :: vfield(:)         ! Number of visibilities per field
  type (field), allocatable :: fields(:)    ! Fields data
  integer :: vsize ! Visibility size
  integer :: nvisi, mvisi
  integer(kind=index_length) :: mvis, kv
  integer :: if, iv, jv, ib, kf, mf, nf, of, jf
  integer :: ier, nblock
  !
  integer :: basenum
  real(kind=8) :: ti,rti,vmax
  real(kind=8), allocatable :: ddates(:), tb(:)
  real(kind=4), allocatable, target :: avisi(:,:), bvisi(:,:)
  integer(kind=4), allocatable :: indx(:)
  integer:: j,jt,mdates,ndates
  real(kind=8) :: maxdat, mindat, spadat
  logical :: sorted, an_error
  !
  character(len=120) :: mess
  character(len=filename_length) :: final_file
  !
  ! Code ----
  nblock = space_nitems('SPACE_GILDAS',hiuv,1)  
  mdates = 10 ! A good starting number of dates...
  !
  final_file = houv%file ! Save 
  !
  vsize = hiuv%gil%dim(1)
  nf = 0
  of = 0
  !
  ! Read the input file by block
  mvisi = nblock
  !
  allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),ifield(mvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Input Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Get the fields by Block
  do ib=1,hiuv%gil%dim(2),mvisi
    !
    ! Read the data
    write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
    call map_message(seve%i,rname,mess)
    hiuv%blc(2) = ib
    hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
    nvisi = hiuv%trc(2)-hiuv%blc(2)+1
    call gdf_read_data(hiuv,hiuv%r2d,an_error)
    if (an_error) exit 
    !
    nf = 0 ! We start with an empty number of Fields
    rtel = 0
    !
    do iv=1,nvisi
      kf = 0
      xoff = hiuv%r2d(ioff,iv)
      yoff = hiuv%r2d(joff,iv)
      if (itel.ne.0) rtel = hiuv%r2d(itel,iv)
      do if=1,nf
        if (xfield(if).eq.xoff .and. yfield(if).eq.yoff &
        & .and. tfield(if).eq.rtel) then
          kf = if
          exit
        endif
      enddo
      !
      ! Prepare buffers to handle the Fields characteristics
      if (kf.eq.0) then
        nf = nf+1
        if (nf.gt.of) then
          if (of.eq.0) then
            mf = 10   ! Start with 10 fields
          else
            mf = 2*of ! Double the field numbers
          endif
          call resize_real_array(xfield,of,mf)
          call resize_real_array(yfield,of,mf)
          call resize_real_array(tfield,of,mf)
          call resize_inte_array(itrc,of,mf)
          call resize_inte_array(iblc,of,mf)
          call resize_inte_array(vfield,of,mf)
          of = mf
        endif
        xfield(nf) = xoff
        yfield(nf) = yoff
        iblc(nf) = 1
        itrc(nf) = 1
        vfield(nf) = 1
        kf = nf
      else
        ! Increment the visibilities here...
        itrc(kf) = itrc(kf)+1
        vfield(kf) = vfield(kf)+1
      endif
      !
      ! Remember the field pointer
      ifield(iv) = kf
      !
    enddo
    write(mess,'(A,I0,A)') 'Found ',nf,' fields'
    call map_message(seve%i,rname,mess)
    !
    ! Allocate work space per field to the field size computed before
    allocate(fields(nf),stat=ier)
    do if=1,nf
      nvisi = itrc(if)-iblc(if)+1
      nvisi = vfield(if)
      if (nvisi.gt.0) then
        allocate(fields(if)%visi(vsize,nvisi),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Field Memory allocation error')
          an_error = .true.
          exit
        endif
      endif
      fields(if)%mvisi = nvisi
      fields(if)%nvisi = 0
    enddo
    !
    if (an_error) return 
    !
    ! Second pass, split into the workspaces
    nvisi = hiuv%trc(2)-hiuv%blc(2)+1
    do iv=1,nvisi
      if = ifield(iv)
      !
      if (fields(if)%nvisi.eq.fields(if)%mvisi) then
        write(mess,'(A,I0,A,I0,A,I0)') 'Fields ',if,' visibility overrun ',vfield(if),' at visi ',iv
        call map_message(seve%e,rname,mess)
        an_error = .true.
        exit
      endif
      fields(if)%nvisi = fields(if)%nvisi +1
      jv = fields(if)%nvisi
      !! write(iunit,*) 'Field ',if,' In visi ',iv,' outvisi ',jv
      fields(if)%visi(:,jv) = hiuv%r2d(:,iv)
    enddo
    !
    ! Write the workspaces to different files
    if (.not.an_error) then
      jf = 0
      do if=1,nf
        if (fields(if)%nvisi.gt.0) then
          write(houv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
          if (iblc(if).eq.1) then
            write(mess,'(A,I0,A)') 'Creating '//trim(houv%file)//' with ',fields(if)%nvisi,' visi...'
            call map_message(seve%i,rname,mess)
            ! Field must be created
            houv%blc = 0
            houv%trc = 0
            houv%gil%nvisi = fields(if)%nvisi
            houv%gil%dim(2) = houv%gil%nvisi
            call gdf_write_image(houv,fields(if)%visi,an_error)
            if (an_error) exit
          else
            ! Field already existed
            call gdf_read_header(houv,an_error)
            if (an_error) exit
            mvis = houv%gil%nvisi + fields(if)%nvisi
            !
            if (mvis.gt.houv%gil%dim(2)) then
              write(mess,'(A,I0,A,I0,A)') 'Extending '//trim(houv%file)//' from ', &
                & houv%gil%dim(2), ' to  ',mvis
              call map_message(seve%i,rname,mess)
              call gdf_close_image(houv,an_error)
              call gdf_extend_image(houv,mvis,an_error)
              if (an_error) exit
            endif
            houv%blc(2) = iblc(if)
            houv%trc(2) = itrc(if)
            call gdf_write_data (houv,fields(if)%visi,an_error)
            if (an_error) exit
            !
            ! Update header
            houv%gil%nvisi = houv%trc(2)
            houv%gil%dim(2) = houv%trc(2)
            call gdf_update_header(houv,an_error)
            if (an_error) exit
            call gdf_close_image(houv,an_error)
            if (an_error) exit
          endif
        endif
        jf = if
      enddo
      !
      ! De-Allocate work space and Set Blc/Trc again
      do if=1,nf
        if (fields(if)%nvisi.gt.0) then
          deallocate(fields(if)%visi,stat=ier)
          iblc(if) = itrc(if)+1
        endif
      enddo
      deallocate(fields,stat=ier)
    endif
    !
    ! Clean up in case of error
    error = error.or.an_error
    if (error) then
      call map_message(seve%e,rname,'Error reading input file')
      do if=1,jf
        write(houv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
        call gag_filrm(houv%file)
      enddo
      error = .true.
      return
    endif
    !
  enddo
  !
  ! at end, collect all output files :
  !   - sort them by Time-Baseline
  !   - and gather them together
  ! This can be done file by file.
  !
  houv%file = final_file
  houv%gil%nvisi = 0 
  houv%blc(2) = 1
  write(mess,'(A,I0,A)') 'Creating '//trim(houv%file)//' with initial size ',houv%gil%dim(2)
  call map_message(seve%i,rname,mess)
  call gdf_create_image(houv,error)
  if (error) return
  !
  houv%gil%nvisi = 0 
  houv%blc(2) = 1
  !
  jf = 0
  do if=1,nf    
    write(hiuv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
    hiuv%blc = 0
    hiuv%trc = 0
    ndates = 0
    !
    ! No blocking factor here (we assume a field is small enough)
    call gdf_read_header(hiuv,an_error)
    if (an_error) exit 
    !
    allocate(avisi(hiuv%gil%dim(1),hiuv%gil%dim(2)),stat=ier)
    call gdf_read_data(hiuv,avisi,error)
    if (an_error) then
      write(mess,'(A,I0,1X,A)') 'Error reading field ',if,trim(hiuv%file)
      call map_message(seve%e,rname,mess)
      error = .true.
      exit ! Abort 
    endif
    !
    ! Sort it by BASELINE or TIME
    if (ctype.ne.'FIELDS') then
      !
      ! Check the order
      nvisi = hiuv%gil%nvisi ! Current number of visibilities
      allocate (tb(nvisi),ddates(mdates),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'TB Memory allocation error')
        an_error = .true.
        exit
      endif
      !
      ! Count the dates first
      do iv=1,nvisi
        rti = dble(avisi(4,iv))+dble(avisi(5,iv))/86400.0d0
        if (rti.ge.0) then
          ti = int(rti)
        else
          ti = int(rti)-1
        endif
        !
        jt = 0
        do j=1,ndates
          if (ti.eq.ddates(j)) then
            jt = j
            exit
          endif
        enddo
        if (jt.eq.0) then
          if (ndates.gt.mdates) then
            call resize_dble_array(ddates,mdates,2*mdates)
            mdates = 2*mdates
          endif
          ndates = ndates+1
          ddates(ndates) = ti
          jt = ndates
        endif
        ! Compress the Dates by sequence to get times in Days 
        tb(iv) = dble(avisi(4,iv)-ddates(jt)+jt) + dble(avisi(5,iv))/86400.d0
      enddo
      !
      select case(ctype)
      ! tb(iv) is in Seconds
      case ('BASE')
        !
        maxdat = maxval(ddates(1:ndates))
        mindat = minval(ddates(1:ndates))
        spadat = (maxdat-mindat+1)
        !! Print *,'Date range ',mindat,maxdat,spadat
        !
        do iv=1,nvisi
          !
          ! Convert TB into Days, positive. The rescale to [0,1] interval
          tb(iv) = (tb(iv)-1)/(ndates+1)  ! After date compression
          if (tb(iv).lt.0 .or. tb(iv).gt.1) then
            Print *,'Programming error ',iv,tb(iv)
          endif
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the Baseline Number as major driver
          ! Times enter only in the decimal field
          ! We get enough precision here...
          ! 5 digits for the baseline numbers 
          ! 7 digits for a reasonable number of observing dates
          tb(iv) = basenum + tb(iv) 
        enddo
      case ('TIME')
        !
        do iv=1,nvisi
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the time as major driver
          ! We get enough precision here...
          ! 7 digits for a reasonable number of observing times in seconds
          ! 5 digits for the baseline numbers 
          tb(iv) = tb(iv)*86400.d0 + dble(basenum)/(256*256) 
        enddo
      end select
      !
      ! Verify if sorted
      sorted = .true.
      vmax = tb(1)
      do iv = 1,nvisi
        if (tb(iv).lt.vmax) then
          sorted = .false.
          exit
        endif
        vmax = tb(iv)
      enddo
      !
      ! Sort it if needed
      if (.not.sorted) then
        allocate(indx(nvisi),bvisi(hiuv%gil%dim(1),nvisi),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Sort Memory allocation error')
          an_error = .true.
          exit 
        endif
        do iv = 1,nvisi
          indx(iv) = iv
        enddo
        call gr8_trie(tb,indx,nvisi,an_error)
        if (an_error) then
          call map_message(seve%e,rname,'Sorting error')
          exit
        endif
        do iv=1,nvisi
          kv = indx(iv)
          bvisi(:,iv) = avisi(:,kv)
        enddo
        hiuv%r2d => bvisi
        !
        deallocate(indx)
      else
        hiuv%r2d => avisi
      endif
    else
      hiuv%r2d => avisi
    endif
    !
    ! Write at appropriate place
    houv%blc(2) = houv%gil%nvisi+1
    houv%trc(2) = houv%blc(2)+hiuv%gil%nvisi-1
    mvis = houv%trc(2)
    !
    if (mvis.gt.houv%gil%dim(2)) then
      write(mess,'(A,I9,A,I9)') 'Extending '//trim(houv%file)//' from ',houv%gil%dim(2), ' to  ',mvis
      call map_message(seve%i,rname,mess)
      call gdf_close_image(houv,an_error)
      call gdf_extend_image(houv,mvis,an_error)
    else
      write(mess,'(A,I9)') 'Filling '//trim(houv%file)//' up to  ',mvis
      call map_message(seve%i,rname,mess)        
    endif
    houv%gil%nvisi = mvis
    call gdf_write_data (houv,hiuv%r2d,an_error)
    !
    deallocate(avisi,tb,ddates,stat=ier)
    if (allocated(bvisi)) deallocate(bvisi,stat=ier)
    !
    jf = jf+1
  enddo
  !
  ! Remove temporary files in all cases
  do if=1,nf
    write(hiuv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
    call gag_filrm(hiuv%file)
  enddo
  !
  ! Clean up in case of error
  error = error.or.an_error
  if (error) then
    call gdf_close_image(houv,an_error)
    call map_message(seve%e,rname,'Error collecting output file')
    call gag_filrm(houv%file)
    error = .true.
    return
  endif      
  !
  ! Finalize the image
  houv%gil%nvisi = houv%trc(2)
  houv%gil%dim(2) = houv%trc(2)
  call gdf_update_header(houv,error)
  call gdf_close_image(houv,error)
  if (error) then
    call map_message(seve%e,rname,'Error finishing output file')
    call gag_filrm(houv%file)
    error = .true.
    return
  endif      
  !
  ! In total, we will have read 2x the size of the initial
  ! input file, and written also 2x its initial size
end subroutine uvsort_mosaic_disk
!
subroutine uvsort_mosaic_mem(hiuv,houv,ctype,ioff,joff,itel,error)
  use gkernel_types
  use imager_interfaces, except_this => uvsort_mosaic_mem
  use gkernel_interfaces
  use field_type
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !* 
  ! IMAGER -- 
  !   Support for UV_SORT 
  !
  !   Sort a Mosaic UV table  
  !   Each field must be independently sorted by Time-Baseline. 
  !   The method splits the Input UV data per Field, creating a virtual
  !   single-field UV data for each Field. These per-Field UV data are
  !   sorted by Time-Baseline, and the results is put back in place at
  !   the same time. 3 copies are required, unless HOUV points to HIUV
  !
  !   Data sets are assumed to be in the %R2D pointers
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: hiuv       !! Input UV header
  type(gildas), intent(inout) :: houv       !! Output UV header
  character(len=*), intent(in) :: ctype     !! Type of sorting
  integer, intent(in) :: ioff               !! Offset column pointer
  integer, intent(in) :: joff               !! Offset column pointer
  integer, intent(in) :: itel               !! Telescope column pointer
  logical, intent(out) :: error             !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_SORT'
  !
  ! Local ---
  real :: xoff,yoff,rtel
  real, allocatable :: xfield(:), yfield(:), tfield(:) ! Field coordinates
  integer, allocatable :: iblc(:), itrc(:)  ! File pointers 
  integer, allocatable :: ifield(:)         ! Field pointer for each visibility
  integer, allocatable :: vfield(:)         ! Number of visibilities per field
  type (field), allocatable, target :: fields(:)    ! Fields data
  integer :: vsize ! Visibility size
  integer :: nvisi 
  integer(kind=index_length) :: kv
  integer :: if, iv, jv, kf, mf, nf, of
  integer :: ier
  integer :: fvisi, lvisi
  !
  integer :: basenum
  real(kind=8) :: ti,rti,vmax
  real(kind=8), allocatable :: ddates(:), tb(:)
  real(kind=4), pointer :: avisi(:,:), bvisi(:,:)
  integer(kind=4), allocatable :: indx(:)
  integer:: j,jt,mdates,ndates
  real(kind=8) :: maxdat, mindat, spadat
  logical :: sorted, an_error
  !
  character(len=120) :: mess
  !
  ! Code ----
  mdates = 10 ! A good starting number of dates...
  !
  if (.not.associated(hiuv%r2d)) then
    call map_message(seve%e,rname,'Input UV data is not associated')
    error = .true.
  endif
  if (.not.associated(houv%r2d)) then
    call map_message(seve%e,rname,'Output UV data is not associated')
    error = .true.
  endif
  if (size(hiuv%r2d).ne.size(houv%r2d)) then
    call map_message(seve%e,rname,'Input and Output UV data  do not match')
    error = .true.
  endif
  if (error) return
  !
  vsize = hiuv%gil%dim(1)
  nvisi = hiuv%gil%nvisi
  allocate(ifield(nvisi),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  of = 0      ! Arrays are not allocated
  nf = 0      ! We start with an empty number of Fields
  ndates = 0  ! Initialize
  rtel = 0    ! No telescope
  !
  do iv=1,nvisi
    kf = 0
    xoff = hiuv%r2d(ioff,iv)
    yoff = hiuv%r2d(joff,iv)
    if (itel.ne.0) rtel = hiuv%r2d(itel,iv)
    do if=1,nf
      if (xfield(if).eq.xoff .and. yfield(if).eq.yoff &
        & .and. tfield(if).eq.rtel) then
        kf = if
        exit
      endif
    enddo
    !
    ! Prepare buffers to handle the Fields characteristics
    if (kf.eq.0) then
      nf = nf+1
      ! !Print *,'Visi IV ',iv,' xoff yoff ',xoff,yoff,' NF ',nf,' OF ',of 
      if (nf.gt.of) then
        if (of.eq.0) then
          mf = 10   ! Start with 10 fields
        else
          mf = 2*of ! Double the field numbers
        endif
        call resize_real_array(xfield,of,mf)
        call resize_real_array(yfield,of,mf)
        call resize_real_array(tfield,of,mf)
        call resize_inte_array(itrc,of,mf)
        call resize_inte_array(iblc,of,mf)
        call resize_inte_array(vfield,of,mf)
        of = mf
      endif
      xfield(nf) = xoff
      yfield(nf) = yoff
      tfield(nf) = rtel
      iblc(nf) = 1
      itrc(nf) = 1
      vfield(nf) = 1
      kf = nf
    else
      ! Increment the visibilities here...
      itrc(kf) = itrc(kf)+1
      vfield(kf) = vfield(kf)+1
    endif
    !
    ! Remember the field pointer
    ifield(iv) = kf
    !
  enddo
  write(mess,'(A,I0,A)') 'Found ',nf,' fields'
  call map_message(seve%i,rname,mess)
  !
  ! Allocate work space per field to the field size computed before
  allocate(fields(nf),stat=ier)
  do if=1,nf
    nvisi = vfield(if)
    if (nvisi.gt.0) then
      allocate(fields(if)%visi(vsize,nvisi),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Field Memory allocation error')
        error = .true.
        exit
      endif
    endif
    fields(if)%mvisi = nvisi
    fields(if)%nvisi = 0
  enddo
  if (error) return 
  !
  ! Second pass, split into the workspaces
  nvisi = hiuv%gil%nvisi
  do iv=1,nvisi
    if = ifield(iv)
    !
    if (fields(if)%nvisi.eq.fields(if)%mvisi) then
      write(mess,'(A,I0,A,I0,A,I0)') 'Fields ',if,' visibility overrun ',vfield(if),' at visi ',iv
      call map_message(seve%e,rname,mess)
      an_error = .true.
      exit
    endif
    fields(if)%nvisi = fields(if)%nvisi +1
    jv = fields(if)%nvisi
    !! write(iunit,*) 'Field ',if,' In visi ',iv,' outvisi ',jv
    fields(if)%visi(:,jv) = hiuv%r2d(:,iv)
  enddo
  !
  ! Now we have a WorkSpace per field
  write(mess,'(A,I0,A)') 'Allocating UV with initial size ',houv%gil%dim(2)
  call map_message(seve%i,rname,mess)
  houv%gil%nvisi = 0 
  houv%blc(2) = 1
  !
  an_error = .false.
  !
  fvisi = 1                   ! Pointer to first Visi
  do if=1,nf    
    nvisi = fields(if)%nvisi  ! Current number of visibilities
    lvisi = fvisi+nvisi-1     ! Pointer to last Visi
    avisi => fields(if)%visi
    bvisi => houv%r2d(:,fvisi:lvisi)
    !
    ! Sort it by BASELINE or TIME
    if (ctype.ne.'FIELDS') then
      !
      ! Check the order
      allocate (tb(nvisi),ddates(mdates),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'TB Memory allocation error')
        an_error = .true.
        exit
      endif
      !
      ! Count the dates first
      do iv=1,nvisi
        rti = dble(avisi(4,iv))+dble(avisi(5,iv))/86400.0d0
        if (rti.ge.0) then
          ti = int(rti)
        else
          ti = int(rti)-1
        endif
        !
        jt = 0
        do j=1,ndates
          if (ti.eq.ddates(j)) then
            jt = j
            exit
          endif
        enddo
        if (jt.eq.0) then
          if (ndates.gt.mdates) then
            call resize_dble_array(ddates,mdates,2*mdates)
            mdates = 2*mdates
          endif
          ndates = ndates+1
          ddates(ndates) = ti
          jt = ndates
        endif
        ! Compress the Dates by sequence to get times in Days 
        tb(iv) = dble(avisi(4,iv)-ddates(jt)+jt) + dble(avisi(5,iv))/86400.d0
      enddo
      !
      select case(ctype)
      ! tb(iv) is in Seconds
      case ('BASE')
        !
        maxdat = maxval(ddates(1:ndates))
        mindat = minval(ddates(1:ndates))
        spadat = (maxdat-mindat+1)
        !! Print *,'Date range ',mindat,maxdat,spadat
        !
        do iv=1,nvisi
          !
          ! Convert TB into Days, positive. The rescale to [0,1] interval
          tb(iv) = (tb(iv)-1)/(ndates+1)  ! After date compression
          if (tb(iv).lt.0 .or. tb(iv).gt.1) then
            Print *,'Programming error ',iv,tb(iv)
          endif
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the Baseline Number as major driver
          ! Times enter only in the decimal field
          ! We get enough precision here...
          ! 5 digits for the baseline numbers 
          ! 7 digits for a reasonable number of observing dates
          tb(iv) = basenum + tb(iv) 
        enddo
      case ('TIME')
        !
        do iv=1,nvisi
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the time as major driver
          ! We get enough precision here...
          ! 7 digits for a reasonable number of observing times in seconds
          ! 5 digits for the baseline numbers 
          tb(iv) = tb(iv)*86400.d0 + dble(basenum)/(256*256) 
        enddo
      end select
      !
      ! Verify if sorted
      sorted = .true.
      vmax = tb(1)
      do iv = 1,nvisi
        if (tb(iv).lt.vmax) then
          sorted = .false.
          exit
        endif
        vmax = tb(iv)
      enddo
      !
      ! Sort it if needed
      if (.not.sorted) then
        allocate(indx(nvisi),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Sort Memory allocation error')
          an_error = .true.
          exit 
        endif
        do iv = 1,nvisi
          indx(iv) = iv
        enddo
        call gr8_trie(tb,indx,nvisi,an_error)
        if (an_error) then
          call map_message(seve%e,rname,'Sorting error')
          deallocate(indx)
          exit
        endif
        do iv=1,nvisi
          kv = indx(iv)
          bvisi(:,iv) = avisi(:,kv)
        enddo
        !
        deallocate(indx)
      else
        bvisi = avisi
      endif
    else
      bvisi = avisi
    endif
    fvisi = lvisi+1 ! Prepare next field
    nullify(avisi)
    if (allocated(tb)) deallocate(tb,ddates,stat=ier)
  enddo
  !
  ! Clean up in case of error
  error = error.or.an_error
  !
  ! Finalize the image
  houv%gil%nvisi = fvisi-1
  houv%gil%dim(2) = fvisi-1
  houv%gil%ntrail = hiuv%gil%ntrail
  ! !Print *,'Returning with ', houv%gil%nvisi,' Visibilities of size ',houv%gil%dim(1), houv%gil%ntrail
end subroutine uvsort_mosaic_mem

subroutine uvsort_single_disk(hiuv,houv,ctype,error)
  use gkernel_types
  use field_type
  use imager_interfaces, except_this => uvsort_single_disk
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support for UV_SORT /FILE  
  ! Sort a Single Field UV table on disk
  !
  ! A more intelligent way of sorting that strictly follows
  ! the algorithm for the Mosaics.
  !
  ! 1) Define the number of input Blocks  
  ! 2) Define the Time and/or Base range of the input file
  !     and relative percentiles of the distribution...  
  ! 3) Partition the Time and/or Base range in a number
  !   of output files equal to the number of input Blocks  
  ! 4) Collect the temporary output files
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(inout) :: hiuv       !! Input UV header
  type(gildas), intent(inout) :: houv       !! Output UV header
  character(len=*), intent(in) :: ctype     !! Type of sorting
  logical, intent(out) :: error             !! Error flag
  !
  ! Constants
  character(len=*), parameter :: rname='UV_SORT'
  !
  ! Local ---
  integer, allocatable :: iblc(:), itrc(:)  ! File pointers 
  integer :: vsize ! Visibility size
  integer :: nvisi, mvisi
  integer :: basenum
  integer(kind=index_length) :: mvis, kv
  integer :: if, iv, jv, ib, nf, of, jf, ik
  integer :: ier, nblock, mblock
  integer :: codes(4)
  type (field), allocatable :: fields(:)    ! Fields data
  !
  real(kind=8) :: ti,rti,vmax
  real(kind=8), allocatable :: ddates(:), valt(:)
  real(kind=8), allocatable, target :: tb(:)
  real(kind=8), pointer :: bt(:)
  real(kind=4), allocatable, target :: avisi(:,:), bvisi(:,:), din(:,:)
  integer(kind=4), allocatable :: indx(:), ifield(:), count(:)
  integer:: j,jt,mdates,ndates
  real(kind=8) :: maxdat, mindat, spadat
  logical :: sorted, an_error, no_error
  logical, allocatable :: occupied(:)
  integer :: maxant
  !
  character(len=120) :: mess
  character(len=filename_length) :: final_file
  !
  ! Code ----
  nblock = space_nitems('SPACE_IMAGER',hiuv,1)  ! Space Imager is large enough
  mdates = 10 ! A good starting number of dates...
  !
  final_file = houv%file ! Save 
  !
  !print *,'Input ',trim(hiuv%file)
  !print *,'Output ',trim(houv%file)
  !
  vsize = hiuv%gil%dim(1)
  nf = 0
  of = 0
  !
  ! We do not know in advance how to partition the file.
  ! How many baselines ? How many antennas ? How many time steps ?
  !
  ! So make a first pass to figure out this properly
  !
  ! Read the input file by block
  mvisi = nblock                                ! Block size
  mblock = (hiuv%gil%dim(2)+nblock-1)/nblock    ! Number of Blocks
  nvisi = hiuv%gil%nvisi
  ! 
  nf = mblock  ! Number of "fields" for analogy with the Mosaic case
  !
  allocate(hiuv%r2d(hiuv%gil%dim(1),mvisi),tb(nvisi),din(4,nvisi),& 
    & ddates(mdates),valt(nf),count(nf),ifield(mvisi),iblc(nf),itrc(nf),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Input Memory allocation error')
    error = .true.
    return
  endif
  codes(1:4) = [code_uvt_date, code_uvt_time, code_uvt_anti, code_uvt_antj]
  call gdf_read_uvonly_codes(hiuv, din, codes, 4, error)
  if (error) return
  !
  ndates = 0 ! Initialize
  !
  ! Initialize
  iblc = 0
  itrc = 0
  !
  select case(ctype)
  case ('TIME') 
    ! Count the dates first
    do iv=1,nvisi
      rti = dble(din(1,iv))+dble(din(2,iv))/86400.0d0
      if (rti.ge.0) then
        ti = int(rti)
      else
        ti = int(rti)-1
      endif
      !
      jt = 0
      do j=1,ndates
        if (ti.eq.ddates(j)) then
          jt = j
          exit
        endif
      enddo
      if (jt.eq.0) then
        if (ndates.gt.mdates) then
          call resize_dble_array(ddates,mdates,2*mdates)
          mdates = 2*mdates
        endif
        ndates = ndates+1
        ddates(ndates) = ti
        jt = ndates
      endif
      ! Compress the Dates by sequence to get times in Days 
      tb(iv) = dble(din(1,iv)-ddates(jt)+jt) + dble(din(2,iv))/86400.d0
    enddo
    !
    ! OK, here we have the distribution of TB(iv) in "Consecutive days"
    mindat = minval(tb)-1.d0/86400.d0
    maxdat = maxval(tb)+1.d0/86400.d0
    !
    ! It is reasonably evenly spaced, so equally divide the output.
    ! Set the thresholds
    do if=1,nf
      valt(if) = if*(maxdat-mindat)/nf + mindat
    enddo
    !!Print *,'TIME thresholds ',valt
  case ('BASE')
    maxant = 0
    do iv=1,nvisi
      ! Get the Baseline Number
      basenum = uvshort_basenum(din(3,iv),din(4,iv)) 
      ! Use the Baseline Number as major driver
      ! Times enter only in the decimal field
      ! We get enough precision here...
      ! 5 digits for the baseline numbers 
      ! 6 digits for a reasonable number of observing dates
      tb(iv) = dble(basenum) 
      maxant = max(maxant,nint(max(din(3,iv),din(4,iv))))
    enddo
    !
    ! Now we have MAXANT, the largest number of antennas.
    ! But the baselines are not well spaced because they go
    ! as MAXANT*(MAXANT-1)/2
    !
    ! Set the thresholds
    valt(nf) = maxant+1
    do if=nf-1,1,-1
      valt(if) = sqrt(valt(if+1))
    enddo
    valt = nint(256.0*valt)
    !Print *,'BASE thresholds ',valt
  case default
    call map_message(seve%e,rname,'Cannot handle '//ctype)
    error = .true.
    return
  end select
  !
  ! Verify if sorted
  sorted = .true.
  vmax = tb(1)
  do iv = 1,nvisi
    if (tb(iv).lt.vmax) then
      sorted = .false.
      !!Print *,'Unordered visibility ',iv,tb(iv),vmax
      exit
    endif
    vmax = tb(iv)
  enddo
  if (sorted) then
    call map_message(seve%e,rname,'Input file is already sorted')
    call gdf_close_image(hiuv,error) ! Close input file
    error = .true.
    return
  endif
  !
  ! Occupancy indicator
  allocate(occupied(nf))
  occupied = .false.
  !
  ! Now loop over the blocks
  !
  ik = 0
  do ib=1,hiuv%gil%dim(2),mvisi
    ik = ik+1 ! Block Kounter
    !
    ! Read the data
    write(mess,*) ib,' / ',hiuv%gil%dim(2),mvisi
    call map_message(seve%i,rname,mess)
    hiuv%blc(2) = ib
    hiuv%trc(2) = min(hiuv%gil%dim(2),ib-1+mvisi)
    nvisi = hiuv%trc(2)-hiuv%blc(2)+1
    call gdf_read_data(hiuv,hiuv%r2d,an_error)
    if (an_error) exit 
    !
    ! The sorting key is already known: point to the right place
    !!Print *,'BT range ',hiuv%blc(2),hiuv%trc(2)
    bt => tb(hiuv%blc(2):hiuv%trc(2))
    !
    ! Convert it to a file number index, and count size of output 
    count = 0
    do iv=1,nvisi
      do if = 1,nf ! == mblock
        if (bt(iv).le.valt(if)) then
          ifield(iv) = if
          count(if) = count(if)+1
          exit
        endif
      enddo
    enddo
    !
    ! Allocate work space
    allocate(fields(nf),stat=ier)
    do if=1,nf
      nvisi = count(if)
      if (nvisi.gt.0) then
        allocate(fields(if)%visi(vsize,nvisi),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Field Memory allocation error')
          an_error = .true.
          exit
        endif
        ! Increment the BLC / TRC
        iblc(if) = itrc(if)+1
        itrc(if) = itrc(if)+nvisi
      endif
      fields(if)%mvisi = nvisi
      fields(if)%nvisi = 0
    enddo
    !
    if (an_error) return 
    !
    ! Second pass, split into the workspaces
    nvisi = hiuv%trc(2)-hiuv%blc(2)+1
    do iv=1,nvisi
      if = ifield(iv)
      !
      fields(if)%nvisi = fields(if)%nvisi +1
      jv = fields(if)%nvisi
      !! write(iunit,*) 'Field ',if,' In visi ',iv,' outvisi ',jv
      fields(if)%visi(:,jv) = hiuv%r2d(:,iv)
    enddo
    !
    ! Write the workspaces to different files
    jf = 0
    do if=1,nf
      if (fields(if)%nvisi.gt.0) then
        occupied(if) = .true.
        write(houv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
        !
        if (iblc(if).eq.1) then
          write(mess,'(A,I0,A)') 'Creating '//trim(houv%file)//' with ',fields(if)%nvisi,' visi...'
          call map_message(seve%i,rname,mess)
          ! Field must be created
          houv%blc = 0
          houv%trc = 0
          houv%gil%nvisi = fields(if)%nvisi
          houv%gil%dim(2) = houv%gil%nvisi
          call gdf_write_image(houv,fields(if)%visi,an_error)
          if (an_error) exit
        else
          ! Field already existed
          call gdf_read_header(houv,an_error)
          if (an_error) exit
          mvis = houv%gil%nvisi + fields(if)%nvisi
          !
          if (mvis.gt.houv%gil%dim(2)) then
            write(mess,'(A,I0,A,I0,A)') 'Extending '//trim(houv%file)//' from ', &
              & houv%gil%dim(2), ' to  ',mvis
            call map_message(seve%i,rname,mess)
            call gdf_close_image(houv,an_error)
            call gdf_extend_image(houv,mvis,an_error)
            if (an_error) exit
          endif
          houv%blc(2) = iblc(if)
          houv%trc(2) = itrc(if)
          call gdf_write_data (houv,fields(if)%visi,an_error)
          if (an_error) exit
          !
          ! Update header
          houv%gil%nvisi = houv%trc(2)
          houv%gil%dim(2) = houv%trc(2)
          call gdf_update_header(houv,an_error)
          if (an_error) exit
          call gdf_close_image(houv,an_error)
          if (an_error) exit
        endif
      endif
      jf = if
    enddo
    !
    ! De-Allocate work space and Set Blc/Trc again
    do if=1,nf
      if (fields(if)%nvisi.gt.0) then
        deallocate(fields(if)%visi,stat=ier)
      endif
    enddo
    deallocate(fields,stat=ier)
    !
    ! Clean up in case of error
    error = error.or.an_error
    if (error) exit
    !
  enddo
  !
  ! Clean up Input File and sorting arrays
  call gdf_close_image(hiuv,no_error)
  deallocate(tb,ddates)
  !
  if (error) then
    call map_message(seve%e,rname,'Error reading input file')
    do if=1,nf
      if (occupied(if)) then
        write(houv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
        call gag_filrm(hiuv%file)
      endif
    enddo
    return
  endif
  !
  ! That part is strictly identical to the Mosaic case
  !
  ! at end, collect all output files :
  !   - sort them by Time or Baseline
  !   - and gather them together
  ! This can be done file by file.
  !
  houv%file = final_file
  houv%gil%nvisi = 0 
  houv%blc(2) = 1
  write(mess,'(A,I0,A)') 'Creating '//trim(houv%file)//' with initial size ',houv%gil%dim(2)
  call map_message(seve%i,rname,mess)
  call gdf_create_image(houv,error)
  if (error) return
  !
  houv%gil%nvisi = 0 
  houv%blc(2) = 1
  !
  jf = 0
  do if=1,nf    
    !
    ! File may be empty
    if (.not.occupied(if)) cycle
    write(hiuv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
    !
    hiuv%blc = 0
    hiuv%trc = 0
    ndates = 0
    !
    ! No blocking factor here (we assume a region is small enough)
    call gdf_read_header(hiuv,an_error)
    if (an_error) exit 
    !
    allocate(avisi(hiuv%gil%dim(1),hiuv%gil%dim(2)),stat=ier)
    call gdf_read_data(hiuv,avisi,error)
    if (an_error) then
      write(mess,'(A,I0,1X,A)') 'Error reading field ',if,trim(hiuv%file)
      call map_message(seve%e,rname,mess)
      exit ! Abort 
    endif
    !
    ! Sort it by BASELINE or TIME
    if (ctype.ne.'FIELDS') then
      !
      ! Check the order
      nvisi = hiuv%gil%nvisi ! Current number of visibilities
      allocate (tb(nvisi),ddates(mdates),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'TB Memory allocation error')
        an_error = .true.
        exit
      endif
      !
      ! Count the dates first
      do iv=1,nvisi
        rti = dble(avisi(4,iv))+dble(avisi(5,iv))/86400.0d0
        if (rti.ge.0) then
          ti = int(rti)
        else
          ti = int(rti)-1
        endif
        !
        jt = 0
        do j=1,ndates
          if (ti.eq.ddates(j)) then
            jt = j
            exit
          endif
        enddo
        if (jt.eq.0) then
          if (ndates.gt.mdates) then
            call resize_dble_array(ddates,mdates,2*mdates)
            mdates = 2*mdates
          endif
          ndates = ndates+1
          ddates(ndates) = ti
          jt = ndates
        endif
        ! Compress the Dates by sequence to get times in Days 
        tb(iv) = dble(avisi(4,iv)-ddates(jt)+jt) + dble(avisi(5,iv))/86400.d0
      enddo
      !
      select case(ctype)
      ! tb(iv) is in Seconds
      case ('BASE')
        !
        maxdat = maxval(ddates(1:ndates))
        mindat = minval(ddates(1:ndates))
        spadat = (maxdat-mindat+1)
        !! Print *,'Date range ',mindat,maxdat,spadat
        !
        do iv=1,nvisi
          !
          ! Convert TB into Days, positive. The rescale to [0,1] interval
          tb(iv) = (tb(iv)-1)/(ndates+1)  ! After date compression
          if (tb(iv).lt.0 .or. tb(iv).gt.1) then
            Print *,'Programming error ',iv,tb(iv)
          endif
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the Baseline Number as major driver
          ! Times enter only in the decimal field
          ! We get enough precision here...
          ! 5 digits for the baseline numbers 
          ! 6 digits for a reasonable number of observing dates
          tb(iv) = dble(basenum) + tb(iv) 
        enddo
      case ('TIME')
        !
        do iv=1,nvisi
          ! Get the Baseline Number
          basenum = uvshort_basenum(avisi(6,iv),avisi(7,iv)) 
          ! Use the time as major driver
          ! We get enough precision here...
          ! 6 digits for a reasonable number of observing times in seconds
          ! 5 digits for the baseline numbers 
          tb(iv) = tb(iv)*86400.d0 + dble(basenum)/(256*256)
        enddo
      end select
      !
      ! Verify if sorted
      sorted = .true.
      vmax = tb(1)
      do iv = 1,nvisi
        if (tb(iv).lt.vmax) then
          sorted = .false.
          exit
        endif
        vmax = tb(iv)
      enddo
      !
      ! Sort it if needed
      if (.not.sorted) then
        allocate(indx(nvisi),bvisi(hiuv%gil%dim(1),nvisi),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Sort Memory allocation error')
          an_error = .true.
          exit 
        endif
        do iv = 1,nvisi
          indx(iv) = iv
        enddo
        call gr8_trie(tb,indx,nvisi,an_error)
        if (an_error) then
          call map_message(seve%e,rname,'Sorting error')
          exit
        endif
        do iv=1,nvisi
          kv = indx(iv)
          bvisi(:,iv) = avisi(:,kv)
        enddo
        hiuv%r2d => bvisi
        !
        deallocate(indx)
      else
        Print *,'Data is already sorted ',if
        hiuv%r2d => avisi
      endif
    else
      hiuv%r2d => avisi
    endif
    !
    ! Write at appropriate place
    houv%blc(2) = houv%gil%nvisi+1
    houv%trc(2) = houv%blc(2)+hiuv%gil%nvisi-1
    mvis = houv%trc(2)
    !
    if (mvis.gt.houv%gil%dim(2)) then
      write(mess,'(A,I9,A,I9)') 'Extending '//trim(houv%file)//' from ',houv%gil%dim(2), ' to  ',mvis
      call map_message(seve%i,rname,mess)
      call gdf_close_image(houv,an_error)
      call gdf_extend_image(houv,mvis,an_error)
    else
      write(mess,'(A,I9)') 'Filling '//trim(houv%file)//' up to  ',mvis
      call map_message(seve%i,rname,mess)        
    endif
    houv%gil%nvisi = mvis
    call gdf_write_data (houv,hiuv%r2d,an_error)
    !
    deallocate(avisi,tb,ddates,stat=ier)
    if (allocated(bvisi)) deallocate(bvisi,stat=ier)
    !
    call gdf_close_image(hiuv,no_error)
    !
    jf = jf+1
  enddo
  !
  ! Remove temporary files in all cases
  do if=1,nf
    if (occupied(if)) then
      write(hiuv%file,'(A,I0,A)') 'tmp-',if,'.uvt'
      call gag_filrm(hiuv%file)
    endif
  enddo
  !
  ! Clean up in case of error
  error = error.or.an_error
  if (error) then
    call map_message(seve%e,rname,'Error collecting output file')
    call gag_filrm(houv%file)
    error = .true.
    return
  endif      
  !
  ! Finalize the image
  houv%gil%nvisi = houv%trc(2)
  houv%gil%dim(2) = houv%trc(2)
  call gdf_update_header(houv,error)
  call gdf_close_image(houv,error)
  if (error) then
    call map_message(seve%e,rname,'Error finishing output file')
    call gag_filrm(houv%file)
    error = .true.
    return
  endif      
  !
  ! In total, we will have read 2x the size of the initial
  ! input file, plus the key area (< 1x), and written also 2x its initial size
end subroutine uvsort_single_disk
!
integer function uvshort_basenum(iant,jant)
  ! @ private
  real, intent(in) :: iant  !! Starting antenna
  real, intent(in) :: jant  !! Ending antenna
  !! integer, intent(out) :: uvshort_basenum ! Baseline number
  !
  if (iant.lt.jant) then
    uvshort_basenum = 256*iant+jant
  else if (iant.gt.jant) then
    uvshort_basenum = 256*jant+iant
  else
    ! No Baseline code for Short spacings which have Iant = Jant
    uvshort_basenum = 0
  endif
end function uvshort_basenum
!
subroutine uvsort_frequency_file(nami,namo,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command   
  ! UV_SORT FREQUENCY /FILE FileIn FileOut
  !!
  !---------------------------------------------------------------------------------
  character(len=*), intent(inout) :: nami  !! Input file name
  character(len=*), intent(inout) :: namo  !! Output file name
  logical, intent(out) :: error            !! Error flah
  !
  character(len=*), parameter :: rname='UVSORT FREQUENCY'
  ! 
  ! Local ---
  type (gildas) :: hin, hou
  real(kind=4), allocatable :: din(:,:), dou(:,:)
  integer :: nif
  !
  integer :: stoke
  !
  integer :: iv, iloop, nblock, nvisi
  integer, allocatable :: indx(:)
  integer :: ic, kc, ier
  !
  ! Code ----
  error = .false.
  !
  ! Read Header of the UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  nif = hin%gil%nchan
  if (hin%gil%nstokes.gt.1) then
    call map_message(seve%e,rname,'UV table has more than 1 Stoke parameter')
    error = .true.
    return
  endif  
  ! Initialize the output one
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  call sic_parsef (namo,hou%file,'  ','.uvt')
  !
  stoke = 0
  if (hin%gil%nstokes.eq.1) then
    if (associated(hin%gil%stokes)) stoke = hin%gil%stokes(1)
  endif
  !
  allocate(hou%gil%freqs(nif), hou%gil%stokes(nif), indx(nif), stat=ier)
  !
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif  
  !
  ! Sort the frequencies by increasing order
  hou%gil%freqs = hin%gil%freqs
  do ic = 1,nif
    indx(ic) = ic
  enddo
  call gr8_trie(hou%gil%freqs,indx,nif,error)
  hou%gil%stokes = stoke
  hou%gil%nstokes = 1
  hou%gil%nfreq = nif  
  !
  ! Reset the mean frequency in the header...
  hou%gil%freq = sum(hou%gil%freqs)/nif
  ! and in the first axis too
  hou%gil%val(1) = hou%gil%freq
  !
  call gdf_setuv(hou,error)
  !
  ! OK copy the whole stuff...
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  allocate (din(hin%gil%dim(1),nblock),dou(hin%gil%dim(1),nblock),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error ')
    error = .true.
    return
  endif
  !
  hin%blc = 0
  hin%trc = 0
  hou%blc = 0
  hou%trc = 0
  call gdf_create_image(hou,error)
  if (error) return
  !
  call map_message(seve%i,rname,'Copying UV data ')
  do iloop = 1,hin%gil%dim(2),nblock
    hin%blc(2) = iloop
    hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
    hou%blc(2) = iloop
    hou%trc(2) = hin%trc(2)
    call gdf_read_data (hin,din,error)
    if (error) return
    !
    nvisi = hin%trc(2)-iloop+1
    do iv=1,nvisi
      dou(1:7,iv) = din(1:7,iv)
      do ic=1,nif
        kc = indx(ic)
        dou(5+3*ic:7+3*ic,iv) = din(5+3*kc:7+3*kc,iv)
      enddo
      if (hou%gil%ntrail.gt.0) then
        dou(8+3*nif:,iv) = din(8+3*nif:,iv)
      endif
    enddo
    call gdf_write_data (hou, dou, error)
    if (error) return
  enddo
  call gdf_close_image(hou,error)
  call gdf_close_image(hin,error)
  !
end subroutine uvsort_frequency_file
!
subroutine uvsort_frequency_mem(huvl,visi,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !-------------------------------------------------------------------------------
  ! @ private
  !*
  !   IMAGER -- Support for command   
  !     UV_SORT FREQUENCY in memory. Applies to UV data.
  !
  !   Only works for 1 Stokes parameter
  !!
  !-------------------------------------------------------------------------------
  type(gildas), intent(inout) :: huvl     !! UV Header
  real, intent(inout) :: visi(huvl%gil%dim(1),huvl%gil%dim(2))   !! UV data
  logical, intent(inout) :: error         !! Error flag
  !
  character(len=*), parameter :: rname='UV_SORT'
  !
  integer :: nif, stoke, ier
  integer, allocatable :: indx(:)
  integer :: ic,iv,kc
  logical :: ordered
  real(kind=8) :: freqs
  real, allocatable :: dtmp(:)
  real(kind=8), allocatable :: frequencies(:)
  !
  ! Code ----
  error = .false.
  if (huvl%gil%nfreq.le.1) then
    call map_message(seve%i,rname,'UV table is already ordered by Frequency',3)
    return
  endif  
  if (huvl%gil%nstokes.gt.1) then
    call map_message(seve%e,rname,'UV table has more than 1 Stoke parameter',1)
    error = .true.
    return
  endif  
  nif = huvl%gil%nchan
  !
  freqs = huvl%gil%freqs(1)
  ordered = .true.
  do ic=2,nif
    if (huvl%gil%freqs(ic).gt.freqs) then
      freqs = huvl%gil%freqs(ic)
    else
      ordered = .false.
      exit
    endif
  enddo
  if (ordered) then
    call map_message(seve%w,rname,'UV table is already ordered by Frequency',3)
    return
  endif  
  !
  stoke = 0
  if (huvl%gil%nstokes.eq.1) then
    if (associated(huvl%gil%stokes)) stoke = huvl%gil%stokes(1)
  endif
  !
  allocate(indx(nif), dtmp(huvl%gil%dim(1)), frequencies(nif), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif  
  !
  ! Sort the frequencies by increasing order
  do ic = 1,nif
    indx(ic) = ic
  enddo
  call gr8_trie(huvl%gil%freqs,indx,nif,error)
  huvl%gil%nstokes = 1
  huvl%gil%nfreq = nif  
  !
  ! Reset the mean frequency in the header...
  huvl%gil%freq = sum(huvl%gil%freqs)/nif
  ! and in the first axis too
  huvl%gil%val(1) = huvl%gil%freq
  !
  ! Verify Header
  call gdf_setuv(huvl,error)
  !
  ! Sort the data visibility per visibility
  do iv=1,huvl%gil%nvisi
    dtmp(:) = visi(:,iv)
    do ic=1,nif
      kc = indx(ic)
      visi(5+3*ic:7+3*ic,iv) = dtmp(5+3*kc:7+3*kc)
    enddo
  enddo
  !
end subroutine uvsort_frequency_mem

!-----------------------------------------------------------------------
! RANDOM SEED functions
!
subroutine gmath_random_seed_init(error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gmath_random_seed_init
  !---------------------------------------------------------------------
  ! @ public
  !  Initialize the Fortran random seed. Should be called by interactive
  ! programs or tasks
  !  NB: the Fortran standard does not promise that calling
  ! RANDOM_SEED() without argument will reuse again and again the same
  ! seed. We use our own default, which is a random seed based on date
  ! and time
  !---------------------------------------------------------------------
  logical, intent(inout) :: error
  ! Local
  character(len=40) :: argum
  integer(kind=4) :: ier
  !
  argum = 'DATETIME'  ! Default
  ier = sic_getlog('GILDAS_RANDOM_SEED',argum)
  !
  call gmath_random_seed_set(argum,error)
  if (error)  return
  !
end subroutine gmath_random_seed_init
!
subroutine gmath_random_seed_set(argum,error)
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gmath_random_seed_set
  !---------------------------------------------------------------------
  ! @ public
  ! (Re)set the Fortran random seed, based on the input argument:
  !  - "DATETIME": based on current date and time
  !  - "URANDOM":  based on the OS /dev/urandom, if any
  !  - "Value":    caller choice
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  integer(kind=4), parameter :: mkey=2
  character(len=8), parameter :: keys(mkey) = (/ 'DATETIME','URANDOM ' /)
  integer(kind=4) :: nkey
  character(len=8) :: key
  !
  call sic_ambigs_sub('RANDOM_SEED',argum,key,nkey,keys,mkey,error)
  if (error)  return
  !
  select case (nkey)
  case (1)
    call gmath_random_seed_datetime(error)
    if (error)  return
  case (2)
    call gmath_random_seed_urandom(error)
    if (error)  return
  case default
    ! Argument not understood, try to parse the value
    call gmath_random_seed_value(argum,error)
    if (error)  return
  end select
  !
end subroutine gmath_random_seed_set
!
subroutine gmath_random_seed_datetime(error)
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)set the Fortran random seed, based on current date and time
  !  Based on Gfortran online help
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer, allocatable :: seed(:)
  integer(kind=4) :: i,n,dt(8),t(2),s,pid
  integer(kind=8) :: count, tms
  !
  ! Get the minimum size of the seed array
  call random_seed(size=n)
  allocate(seed(n))
  !
  call system_clock(count)
  if (count.ne.0) then
    t = transfer(count, t)
  else
    call date_and_time(values=dt)
    tms = (dt(1) - 1970) * 365_8 * 24 * 60 * 60 * 1000 +  &
          dt(2) * 31_8 * 24 * 60 * 60 * 1000  +           &
          dt(3) * 24 * 60 * 60 * 60 * 1000 +              &
          dt(5) * 60 * 60 * 1000 +                        &
          dt(6) * 60 * 1000 +                             &
          dt(7) * 1000 +                                  &
          dt(8)
    t = transfer(tms,t)
  end if
  s = ieor(t(1), t(2))
  pid = 1099279 ! Add a prime
  s = ieor(s, pid)
  if (n.ge.3) then
    seed(1) = t(1) + 36269
    seed(2) = t(2) + 72551
    seed(3) = pid
    if (n.gt.3) then
      seed(4:) = s + 37 * (/ (i,i=0,n-4) /)
    endif
  else
    seed(:) = s + 37 * (/ (i,i=0,n-1 ) /)
  end if
  !
  call random_seed(put=seed)
  !
  deallocate(seed)
  !
end subroutine gmath_random_seed_datetime
!
subroutine gmath_random_seed_urandom(error)
  use gbl_message
  use gmath_dependencies_interfaces
  use gmath_interfaces, except_this=>gmath_random_seed_urandom
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)set the Fortran random seed, based on the OS random generator
  ! (if any)
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer, allocatable :: seed(:)
  integer(kind=4) :: n,ier,un
  !
  ! Get the minimum size of the seed array
  call random_seed(size=n)
  allocate(seed(n))
  !
  ! Try if the OS provides a random number generator
  ier = sic_getlun(un)
#if defined(IFORT) && IFORT_VERSION>=110
  open(unit=un,file="/dev/urandom",access="stream", &
       form="unformatted",action="read",status="old",iostat=ier)
#else
  ! access="stream" is not supported by ifort 9
  ier = 1
#endif
  if (ier.ne.0) then
    call gmath_message(seve%e,'RANDOM_SEED',  &
      'Your OS does not provide the /dev/urandom generator')
    error = .true.
    goto 100
  endif
  !
  read(un) seed
  close(un)
  !
  call random_seed(put=seed)
  !
100 continue
  deallocate(seed)
  call sic_frelun(un)
  !
end subroutine gmath_random_seed_urandom
!
subroutine gmath_random_seed_value(argum,error)
  use gbl_message
  use gmath_interfaces, except_this=>gmath_random_seed_value
  !---------------------------------------------------------------------
  ! @ private
  !  (Re)set the Fortran random seed by using the caller input value,
  ! so that the seed and the random number sequence will be the same
  ! for an identical value.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: argum  !
  logical,          intent(inout) :: error  !
  ! Local
  integer, allocatable :: seed(:)
  integer(kind=4) :: ier,n
  integer(kind=8) :: value
  !
  read(argum,*,iostat=ier)  value
  if (ier.ne.0) then
    call gmath_message(seve%e,'RANDOM_SEED',  &
      'Argument '//trim(argum)//' not understood')
    error = .true.
    return
  endif
  !
  ! Get the minimum size of the seed array
  call random_seed(size=n)
  allocate(seed(n))
  !
  seed(:) = value
  call random_seed(put=seed)
  !
  deallocate(seed)
  !
end subroutine gmath_random_seed_value
!
subroutine gmath_random_seed_print(error)
  use gbl_message
  use gmath_interfaces, except_this=>gmath_random_seed_print
  !---------------------------------------------------------------------
  ! @ private
  ! Print the current Fortran random seed
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  integer, allocatable :: seed(:)
  integer(kind=4) :: n,i
  character(len=message_length) :: mess
  !
  ! Get the size of the seed array
  call random_seed(size=n)
  allocate(seed(n))
  call random_seed(get=seed)
  !
  write(mess,*) 'Current random seed is ',(/ (seed(i),i=1,n) /)
  call gmath_message(seve%i,'RANDOM_SEED',mess)
  !
  deallocate(seed)
  !
end subroutine gmath_random_seed_print
!
!-----------------------------------------------------------------------
! RANDOM related functions
!
function rangau(sigma)
  use gmath_interfaces, except_this=>rangau
  !---------------------------------------------------------------------
  ! @ public
  ! Normal gaussian distribution with R.M.S. equal to sigma
  ! Version 1.1 8-jun-83
  ! Algorithm from Handbook of mathematical functions
  ! Ed. Abramowitz M. and Stegun I. A. , 26.2.23 (page 933)
  !---------------------------------------------------------------------
  real(kind=4) :: rangau  !
  real(kind=4), intent(in) :: sigma  !
  ! Local
  real(kind=4) :: x0,x,s,t
  real(kind=4), parameter :: c0=2.515517, c1=0.802853, c2=0.010328
  real(kind=4), parameter :: d1=1.432788, d2=0.189269, d3=0.001308
  !
  x0 = gag_random()
  if (x0.le.0.0) then
    x=1.23456e-37
    s=1.0
  elseif (x0.ge.1.0) then
    x=1.23456e-37
    s=-1.0
  elseif (x0.gt.0.5) then
    x=1.0-x0
    s=-1.0
  else
    x=x0
    s=1.0
  endif
  t = sqrt(-2.0*alog(x))
  rangau = s*sigma * (t - (c0+t*(c1+c2*t)) / (1.0+t*(d1+t*(d2+d3*t))) )
end function rangau
!
function gag_random()
  use gmath_interfaces, except_this=>gag_random
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  real(kind=4) :: gag_random              !
  ! Local
  logical :: first,error
  save first
  data first/.true./
  !
  if (first) then
    error = .false.
    call gmath_random_seed_init(error)
    first = .false.
  endif
  call random_number(gag_random)
end function gag_random
!
function d_noise(a)
  use gmath_interfaces, except_this=>d_noise
  !---------------------------------------------------------------------
  ! @ public
  ! Double precision version
  !---------------------------------------------------------------------
  real(kind=8) :: d_noise                 !
  real(kind=8), intent(in) :: a           !
  ! Local
  real(kind=4) :: b
  b = a
  d_noise = rangau(b)
end function d_noise
!
function d_random(a)
  use gmath_interfaces, except_this=>d_random
  !---------------------------------------------------------------------
  ! @ public
  ! Double precision version
  !---------------------------------------------------------------------
  real(kind=8) :: d_random                !
  real(kind=8), intent(in) :: a           !
  !
  d_random = a*gag_random()
end function d_random
!
function s_noise(a)
  use gmath_interfaces, except_this=>s_noise
  !---------------------------------------------------------------------
  ! @ public
  ! Single precision version
  !---------------------------------------------------------------------
  real(kind=4) :: s_noise                 !
  real(kind=4), intent(in) :: a           !
  !
  s_noise = rangau(a)
end function s_noise
!
function s_random(a)
  use gmath_interfaces, except_this=>s_random
  !---------------------------------------------------------------------
  ! @ public
  ! Single precision version
  !---------------------------------------------------------------------
  real(kind=4) :: s_random                !
  real(kind=4), intent(in) :: a           !
  !
  s_random = a*gag_random()
end function s_random

subroutine gfits_get(comm,argu,check,error,quiet,continue,comment,eof)
  use gfits_dependencies_interfaces
  use gfits_interfaces, except_this=>gfits_get
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  !  Retrieve the next line of the FITS header
  !---------------------------------------------------------------------
  character(len=*), intent(out)           :: comm      ! Returned FITS keyword
  character(len=*), intent(out)           :: argu      ! Returned keyword value
  logical,          intent(in)            :: check     ! Printout FITS card
  logical,          intent(out)           :: error     ! Logical error flag
  logical,          intent(in),  optional :: quiet     ! Verbosity flag
  logical,          intent(in),  optional :: continue  ! Merge CONTINUE'd lines?
  character(len=*), intent(out), optional :: comment   !
  logical,          intent(out), optional :: eof       !
  ! Local
  integer(kind=4) :: ll,iamp
  logical :: doquiet,docontinue,goteof
  character(len=8) :: nextkey
  character(len=70) :: contvalue
  !
  ! Arguments
  error = .false.
  doquiet = .false.
  if (present(quiet))  doquiet = quiet
  docontinue = .false.
  if (present(continue))  docontinue = continue
  goteof = .false.
  !
  ! Read keyword
  call get_keyword(comm,doquiet,goteof,error)
  if (goteof .or. error) then
    if (present(eof))  eof = goteof
    return
  endif
  !
  ! Read value
  call get_value(comm,argu,ll)
  !
  ! Strip or save any comments
  if (present(comment)) then
    call get_comment(argu,ll,comment)
  else
    call get_comment(argu,ll)
  endif
  !
  ! Put the pointer at end of current line / just before beginning of next line
  ib = ib+80
  !
  ! Support for CONTINUE'd lines, if requested
  if (docontinue .and. comm.ne.'END') then
    do  ! Infinite succession of CONTINUE
      call get_keyword(nextkey,doquiet,goteof,error)
      ! if (goteof) can this happen?
      ! if (error) ?
      if (nextkey.ne.'CONTINUE')  exit
      !
      iamp = index(argu,'&',.true.)
      if (iamp.eq.0)  exit
      !
      ! This is a valid CONTINUE'd pair of lines (else, leave them as is,
      ! CONTINUE'd lines should be considered as comments)
      call get_value(nextkey,contvalue,ll)
      !
      ! comm = unchanged
      ! comment =
      if (present(comment)) then
        call get_comment(contvalue,ll,comment)
      else
        call get_comment(contvalue,ll)
      endif
      ! argu =
      argu = argu(1:iamp-1)//contvalue(2:)
      !
      ib = ib+80
      !
    enddo
  endif
  !
contains
  subroutine get_keyword(key,doquiet,goteof,error)
    !-------------------------------------------------------------------
    ! Get the keyword at the current 'pointer' position, but do not
    ! change the cursor position. If pointer points to the end of
    ! current buffer, load the next buffer and set the pointer position
    ! so that its absolute position is unchanged.
    !-------------------------------------------------------------------
    character(len=*), intent(out)   :: key      !
    logical,          intent(in)    :: doquiet  !
    logical,          intent(inout) :: goteof   ! inout: may not be changed
    logical,          intent(inout) :: error    !
    ! Local
    character(len=76) :: chain
    !
    if (ib.ge.2880) then
      if (doquiet) then
        call fgetrecquiet(buffer,error,goteof)   ! This ERROR means EOF
        if (goteof)  return
        if (error)  return
      else
        call gfits_getrec(buffer,error)
      endif
      if (error) return
      ib = 0
    endif
    !
    if (check) then
      call bytoch(buffer(ib+1),chain,76)
      call gagout(chain)
    endif
    !
    key = ''  ! Blank the whole string first (beyond 8-th character)
    call bytoch(buffer(ib+1),key,8)
    call sic_upper(key)  ! Should not be necessary, but doesn't hurt...
    !
  end subroutine get_keyword
  !
  subroutine get_value(key,value,ll)
    !-------------------------------------------------------------------
    ! Read the value in current line. Limit is either the passed-length
    ! or the fact that the comment/value extends up to byte 80
    !-------------------------------------------------------------------
    character(len=*), intent(in)  :: key    ! Keyword
    character(len=*), intent(out) :: value  ! Value extracted
    integer(kind=4),  intent(out) :: ll     ! Length of value
    ! Local
    integer(kind=4) :: istart
    !
    select case (key)
    case ('COMMENT','HISTORY','')
      istart = 9
    case ('HIERARCH')
      istart = 10
    case default
      istart = 11
    end select
    !
    ll = min(len(value),80-istart+1)
    call bytoch(buffer(ib+istart),value,ll)  ! Assume 'ib' is at position 0 on line
    !
  end subroutine get_value
  !
  subroutine get_comment(value,ll,comment)
    character(len=*), intent(inout)         :: value
    integer(kind=4),  intent(in)            :: ll
    character(len=*), intent(out), optional :: comment
    ! Local
    logical :: string
    integer(kind=4) :: i
    !
    string = .false.
    if (present(comment))  comment = ''
    do i=1,ll
      if (value(i:i).eq.'''') then
        string = .not.string  ! Doesn't handle quotes within strings
      endif
      if (value(i:i).eq.'/' .and. .not.string) then  ! Comment, erase
        if (present(comment))  comment = value(i+1:)
        value(i:) = ' '
        exit
      endif
    enddo
  end subroutine get_comment
  !
end subroutine gfits_get
!
subroutine gfits_put(line,check,error)
  use gfits_interfaces, except_this=>gfits_put
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  !       Write a FITS line of the header
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! FITS card image
  logical,          intent(in)    :: check  ! Verbose flag
  logical,          intent(inout) :: error  ! Error flag
  ! Local
  integer :: i,j,k
  !
  if (check) write (*,'(A)') trim(line)
  k = min(len(line),80)
  do i=1,k
    buffer(ib+i) = ichar(line(i:i))
  enddo
  do j=k+1,80
    !           BUFFER(IB+J) = 0
    buffer(ib+j) = ichar(' ')
  enddo
  ib = ib+80
  if (ib.eq.2880) then
    call gfits_putrec(buffer,error)
    ib = 0
    if (error) return
  endif
end subroutine gfits_put
!
subroutine gfits_flush_data(error)
  use gfits_interfaces, except_this=>gfits_flush_data
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Write current FITS buffer to disk. It the buffer is not full, DATA
  ! is padded with ZEROES (Wells et al, A&A Sup. Ser 44, P.364, line 47)
  !---------------------------------------------------------------------
  logical, intent(out) :: error                 ! Error flag
  ! Local
  integer :: i
  !
  if (read) then
    ! Mark current buffer as completely read
    ib = 2880
  else
    ! Pad buffer with zeroes and write it
    if (ib.eq.0) return
    do i=ib+1,2880
      buffer(i) = 0
    enddo
    error = .false.
    call gfits_putrec(buffer,error)
    ib = 0
    if (error) return
  endif
end subroutine gfits_flush_data
!
subroutine gfits_flush_header(error)
  use gfits_interfaces, except_this=>gfits_flush_header
  use gfits_buf
  !---------------------------------------------------------------------
  ! @ public
  ! Write current FITS buffer to disk. It the buffer is not full, HEADER
  ! is padded with BLANKS (Wells et al, A&A Sup. Ser 44, P.365, line 57)
  !---------------------------------------------------------------------
  logical, intent(out) :: error                 ! Error flag
  ! Local
  integer :: i
  !
  if (read) then
    ! Mark current buffer as completely read
    ib = 2880
  else
    ! Pad buffer with blanks (0x20=32d) and write it
    if (ib.eq.0) return
    do i=ib+1,2880
      buffer(i) = 32
    enddo
    error = .false.
    call gfits_putrec(buffer,error)
    ib = 0
    if (error) return
  endif
end subroutine gfits_flush_header
!
subroutine gfits_hierarch(key,value,error)
  use gbl_message
  use gfits_interfaces, except_this=>gfits_hierarch
  !---------------------------------------------------------------------
  ! @ public
  !  Decode the 'value' as 'key' + new 'value' if input 'key' is
  ! HIERARCH.
  ! ---
  !  HIERARCH keyword convention is described here:
  !    http://fits.gsfc.nasa.gov/registry/hierarch_keyword.html
  !  Note that this is only a convention.
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: key    ! Output key
  character(len=*), intent(inout) :: value  ! Input/Output value
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='FITS'
  integer(kind=4) :: isepar
  !
  isepar = index(value,'=')
  !
  if (isepar.le.0) then
    call gfits_message(seve%e,rname,'Not a valid HIERARCH keyword: '//value)
    error = .true.
    return
  endif
  !
  ! Key
  key = adjustl(value(1:isepar-1))  ! NB: key may be truncated if output
                                    ! variable is too short...
  !
  ! Value
  value = adjustl(value(isepar+1:))
  !
end subroutine gfits_hierarch
!
function gfits_unquote(value)
  !---------------------------------------------------------------------
  ! @ public
  !  Unquote the input string (if any quotes) and return the value.
  ! Useful in the context of FITS headers where the strings are often
  ! single-quoted.
  !---------------------------------------------------------------------
  character(len=80) :: gfits_unquote  ! Function value on return
  character(len=*), intent(in) :: value
  ! Local
  integer(kind=4) :: i1,i2,nc
  character(len=1), parameter :: quote=''''
  !
  if (value(1:1).eq.quote) then
    i1 = 2
  else
    i1 = 1
  endif
  !
  nc = len_trim(value)
  if (value(nc:nc).eq.quote) then
    i2 = nc-1
  else
    i2 = nc
  endif
  !
  gfits_unquote = value(i1:i2)
  !
  ! NB: this function would much better return a pointer on the substring
  ! This has both advantages 1) to avoid copies (waste of time) and 2) to
  ! avoid internal limits on the returned string (here max length is 80)
  ! Unfortunately, this is a F2003 syntax.
  !   function myfunc(value)
  !     character(len=:), pointer :: myfunc
  !     character(len=*), intent(in), target :: value
  !     myfunc => value(i1:i2)
  !   end function myfunc
  !
end function gfits_unquote

subroutine gtl_device(line,error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gtl_device
  use gtv_protocol
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GTVIRT Support routine for command
  ! DEVICE [Dev_type [Options]]
  ! 1  [/OUTPUT Dev_name]
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DEVICE'
  logical :: optout
  character(len=132) :: file
  character(len=12) :: term1,term2
  character(len=1), parameter :: backslash=char(92)
  integer :: haut,larg,ncol,nc
  !
  ! If no argument, print the current device
  if (.not.sic_present(0,1)) then
    call gtv_message(seve%i,rname,  &
      'Current device is '//device_list(cw_device%ident))
    return
  endif
  !
  ! Option /OUTPUT ?
  file = ' '
  optout = sic_present(1,1)
  call sic_ch (line,1,1,file,nc,.false.,error)
  if (error) return
  !
  ! Get the terminal names
  term1 = ' '
  term2 = ' '
  call sic_ke (line,0,1,term1,nc,.false.,error)
  call sic_ke (line,0,2,term2,nc,.false.,error)
  if (error) return
  !
  ! Device NONE
  if (term1(1:2).eq.'NO') then
    if (index('NONE',trim(term1)).eq.1 .and. term2.eq.' ') then
      call gtclos(error)  ! Close the current device
      call gtnone  ! Open the "none" device
      call gtv_message(seve%w,rname,'No device active')
      return
    endif
  endif
  !
  ! Output device
  error = gterrtst()
  if (error) return
  haut = 0
  larg = 0
  call gtopen(term1,file,term2,haut,larg,ncol,error)
  error = error .or. gterrtst()
  if (error) return
  !
  ! Format LINE
  line = 'GTVL'//backslash//'DEVICE '//trim(term1)//' '//term2
  if (optout) then
    line = trim(line)//' /OUTPUT '//file
  endif
  !
end subroutine gtl_device

!
subroutine getuv_conversion(uvout,nc,convert)
  use gildas_def
  use image_def
  use phys_const
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER -- Utility routine for Velocity resampling
  !
  !   Derive the frequency axis corresponding to a specified
  !   Velocity sampling.
  !!
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: uvout   !! Output UV table header
  integer, intent(in) :: nc               !! Number of desired channels
  real(8), intent(inout) :: convert(3)    !! Velocity conversion formula
  !
  ! Local ---
  real(8) :: n_iref
  !
  ! Convert(3) is initially on a Velocity Scale.
  ! Code ----
  !
  ! Compute the Reference pixel at which VOFF will occur
  ! in this new sampling, to preserve the VOFF / FREQ / IREF 
  ! correspondance
  !      voff = (n_iref - convert(1))*convert(3) + convert(2)
  n_iref = (uvout%gil%voff - convert(2)) / convert(3) + convert(1)
  !
  convert(1) = n_iref
  convert(2) = uvout%gil%voff
  uvout%gil%vres = convert(3)
  uvout%gil%fres = - uvout%gil%vres * 1d3 / clight * uvout%gil%freq
  uvout%gil%ref(1) = convert(1)
  uvout%gil%val(1) = uvout%gil%freq  ! This is already the case
  uvout%gil%inc(1) = uvout%gil%fres  
  uvout%gil%nchan = nc
  !
  uvout%gil%nchan = nc
  uvout%gil%dim(1) = uvout%gil%nlead+uvout%gil%ntrail + uvout%gil%natom*nc
end subroutine getuv_conversion
!
subroutine resample_uv (uvint,uvout,uvint_data,uvout_data,nv,nt,filtered)
  use image_def
  !------------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER --   Support for commands UV_RESAMPLE and UV_MERGE
  !
  !   Resample (in memory) a UV data set
  !------------------------------------------------------------------------
  type (gildas), intent(in) :: uvint  !! Input UV header
  type (gildas), intent(in) :: uvout  !! Output UV header
  real(4), intent(in) :: uvint_data(uvint%gil%dim(1),uvint%gil%dim(2))
  real(4), intent(out) :: uvout_data(uvout%gil%dim(1),uvout%gil%dim(2))
  integer(kind=index_length), intent(in) :: nv  !! Actual number of visibilities
  integer, intent(in) :: nt           !! Number of trailing informations
  integer, intent(in), optional :: filtered(:)  !! Filtered channels
  !
  ! Local
  integer(kind=index_length) :: iv
  real(4), allocatable :: uvtmp(:)
  integer :: nin, nou, k, kk
  real(8) :: xref,xval,xinc
  real(8) :: yref,yval,yinc
  logical :: ok
  !
  xref = uvout%gil%ref(1)
  yref = uvint%gil%ref(1)
  xval =   uvout%gil%voff
  xinc =   uvout%gil%vres
  yval =   uvint%gil%voff
  yinc =   uvint%gil%vres
  !
  nou = uvout%gil%dim(1)
  nin = uvint%gil%dim(1)
  !
  ok = .false. !TEST! present(filtered)
  if (ok) then
    Print *,'Filtered ',filtered
    allocate(uvtmp(uvint%gil%dim(1)))
    !$OMP PARALLEL &
    !$OMP    & SHARED(uvout_data,uvint_data, uvout, uvint, filtered) &
    !$OMP    & SHARED(xinc,xref,xval, yinc,yref,yval, nv,nt,nou,nin) & 
    !$OMP    & PRIVATE(iv, uvtmp, k, kk)
    !$OMP DO SCHEDULE(STATIC)
    do iv = 1,nv  						  
      uvtmp(:) = uvint_data(:,iv)
      uvout_data(1:7,iv) = uvtmp(1:7)
      do k=1,uvint%gil%nchan
        kk = 7+3*k
        uvtmp(kk) = filtered(k)*uvtmp(kk)
      enddo
      call interpolate_uv (uvout_data(8:,iv), uvout%gil%nchan, xinc,xref,xval, &
          uvtmp(8:),uvint%gil%nchan,yinc,yref,yval)
      if (nt.ne.0) then
        uvout_data(nou-nt+1:nou,iv) = uvtmp(nin-nt+1:nin)
      endif
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  else
    !$OMP PARALLEL &
    !$OMP    & SHARED(uvout_data,uvint_data, uvout, uvint) &
    !$OMP    & SHARED(xinc,xref,xval, yinc,yref,yval, nv,nt,nou,nin) & 
    !$OMP    & PRIVATE(iv)
    !$OMP DO SCHEDULE(STATIC)
    do iv = 1,nv  						  
      uvout_data(1:7,iv) = uvint_data(1:7,iv)
      call interpolate_uv (uvout_data(8:,iv), uvout%gil%nchan, xinc,xref,xval, &
          uvint_data(8:,iv),uvint%gil%nchan,yinc,yref,yval)
      if (nt.ne.0) then
        uvout_data(nou-nt+1:nou,iv) = uvint_data(nin-nt+1:nin,iv)
      endif
    enddo
    !$OMP END DO
    !$OMP END PARALLEL
  endif
end subroutine resample_uv
!
subroutine interpolate_uv(x,xdim,xinc,xref,xval, y,ydim,yinc,yref,yval)
  !-----------------------------------------------------------------------
  ! @ no-interface
  !*
  ! IMAGER   Support for UV_RESAMPLE and UV_MERGE
  !
  ! Performs the linear interpolation/integration for visibilities
  !
  ! 1) if actual interpolation (XINC <= YINC)  
  !     this is a 2-point linear interpolation formula.
  !     the data is untouched if the resolution is unchanged and the shift
  !     is an integer number of channels.
  !
  ! 2) if not (XINC > YINC)  
  !     boxcar convolution (width xinc-yinc) followed by linear interpolation
  !!
  !-----------------------------------------------------------------------------
  integer, intent(in) :: ydim             !! Input axis size
  integer, intent(in) :: xdim             !! Output axis size
  real(8), intent(in) :: yref,yval,yinc   !! Input conversion formula
  real(8), intent(in) :: xref,xval,xinc   !! Output conversion formula
  real(4), intent(in) :: y(3,xdim)        !! Input values
  real(4), intent(out) :: x(3,ydim)       !! Output values
  !
  ! Local ---
  integer :: i,imax,imin, j
  real(8) :: pix, val, expand
  real(4) :: scale, ww
  !
  ! Code ----
  expand = abs(xinc/yinc)
  do i = 1, xdim
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    if (expand.gt.1.) then
      imin = int(pix-expand/2d0+0.5d0)
      imax = int(pix+expand/2d0+0.5d0)
      if (imin.gt.ydim .or. imax.lt.1) cycle
      if (imin.lt.1) then
        imin = 1
        ww = 1.0  ! the whole channel is in...
      else
        ww = imin-(pix-expand/2d0-0.5d0)
      endif
      x(1:3,i) = y(1:3,imin)*ww
      scale = ww
      !
      if (imax.gt.ydim) then
        imax = ydim
        ww = 1.0
      else
        ww = pix+expand/2d0+0.5d0-imax
      endif
      x(1:3,i) = x(1:3,i) + y(1:3,imax)*ww
      scale = scale + ww
      !
      do j=imin+1, imax-1
        x(1:3,i) = x(1:3,i) + y(1:3,j)
        scale = scale+1.
      enddo
      ! Normalize
      !!            w(i) = scale/expand  ! This is the fraction of channel covered
      x(1:2,i) = x(1:2,i)/scale
    else
      imin = int(pix)
      imax = imin+1
      if ((imin.lt.1).or.(imax.gt.ydim)) then
        x(1:3,i) = 0.
      else
        x(1:3,i) = y(1:3,imin)*(imin+1-pix) + y(1:3,imin+1)*(pix-imin)
      endif
      ! Re-scale the weight
      x(3,i) = x(3,i)*expand
    endif
  enddo
end subroutine interpolate_uv
!
subroutine interpolate_axis(xdim,xinc,xref,xval, ydim,yinc,yref,yval, &
  & jmin,jmax,wmin,wmax)
  !-----------------------------------------------------------------------
  ! @ public
  !*
  ! IMAGER   Support for UV_RESAMPLE and UV_MERGE
  !
  ! Performs the linear interpolation/integration for visibilities
  !
  ! 1) if actual interpolation (XINC <= YINC)  
  !     this is a 2-point linear interpolation formula.
  !     the data is untouched if the resolution is unchanged and the shift
  !     is an integer number of channels.
  !
  ! 2) if not (XINC > YINC)  
  !     boxcar convolution (width xinc-yinc) followed by linear interpolation
  !!
  !-----------------------------------------------------------------------------
  integer, intent(in) :: ydim             !! Input axis size
  integer, intent(in) :: xdim             !! Output axis size
  real(8), intent(in) :: yref,yval,yinc   !! Input conversion formula
  real(8), intent(in) :: xref,xval,xinc   !! Output conversion formula
  integer, intent(out) :: jmin(xdim)      !! Min pixel in current output one
  integer, intent(out) :: jmax(xdim)      !! Max pixel in current output one
  real, intent(out) :: wmin(xdim)         !! Weight of jmin()
  real, intent(out) :: wmax(xdim)         !! Weight of jmax()
  !
  ! Local ---
  integer :: i,j,imin,imax
  real(8) :: pix, val, expand
  real(4) :: scale, ww
  integer :: wall
  !
  ! Code ----
  expand = abs(xinc/yinc)
  !Print *,'Expand  ',expand
  !Print *,'Channel    Wleft    middle     Right     Imin     Imax ' 
  do i = 1, xdim
    !
    ! Compute interval
    val = xval + (i-xref)*xinc
    pix = (val-yval)/yinc + yref
    if (expand.gt.1.) then
      imin = int(pix-expand/2d0+0.5d0)
      imax = int(pix+expand/2d0+0.5d0)
      if (imin.gt.ydim .or. imax.lt.1) cycle
      if (imin.lt.1) then
        imin = 1
        ww = 1.0  ! the whole channel is in...
      else
        ww = imin-(pix-expand/2d0-0.5d0)
      endif
      wmin(i) = ww
      !
      if (imax.gt.ydim) then
        imax = ydim
        ww = 1.0
      else
        ww = pix+expand/2d0+0.5d0-imax
      endif
      wmax(i) = ww
      scale = scale + ww
      !
      wall = imax-imin-1
      do j=imin+1, imax-1
        scale = scale+1.
      enddo
    else
      imin = int(pix)
      imax = imin+1
      wall = 0
      if ((imin.lt.1).or.(imax.gt.ydim)) then
        wmin(i) = 0
        wmax(i) = 0
      else
        wmin(i) = imin+1-pix
        wmax(i) = pix-imin
      endif
    endif
    jmin(i) = imin
    jmax(i) = imax
    !Print *,i,wmin(i),wall,wmax(i),jmin(i),jmax(i) !', Expand ',expand 
  enddo
end subroutine interpolate_axis
!
subroutine average_uv (out,nx,nv,inp,ny,nc,num,nt)
  !------------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Support for tasks UV_AVERAGE    -- Unused by IMAGER
  !   Average (in memory) a series of channels of a UV data set
  !------------------------------------------------------------------------
  integer, intent(in) :: num        ! Number of selected channels
  integer, intent(in) :: nx         ! Output Visibility size
  integer, intent(in) :: nv         ! Number of visibilities
  real, intent(out) :: out(nx,nv)   ! Output Visibilities
  integer, intent(in) :: ny         ! Input visibility size
  real, intent(in) :: inp(ny,nv)    ! Input visibilities
  integer, intent(in) :: nc(num)    ! Selected Channels, first & last pairs
  integer, intent(in) :: nt         ! Number of trailing informations
  ! Local
  integer :: j,k,kk,l
  real :: a,b,c
  !
  do j=1,nv
    out(1:7,j) = inp(1:7,j)
    a = 0.0
    b = 0.0
    c = 0.0
    do l=2,num,2
      do k=nc(l-1),nc(l)
        kk = 7+3*k
        if (inp(kk,j).gt.0) then
          a = a+inp(kk-2,j)*inp(kk,j)
          b = b+inp(kk-1,j)*inp(kk,j)
          c = c+inp(kk  ,j)
        endif
      enddo
    enddo
    if (c.ne.0.0) then
      out(8,j) =a/c
      out(9,j) =b/c
      out(10,j)=c              ! time*band
    else
      out(8,j) =0.0
      out(9,j) =0.0
      out(10,j)=0.0
    endif
    !
    if (nt.ne.0) then
      out(nx-nt+1:nx,j) = inp(ny-nt+1:ny,j)
    endif
  enddo
end subroutine average_uv
!
subroutine compress_uv(out,nx,nv,mx,inp,ny,nc,nt, filtered)
  !------------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER
  !   Support for command UV_COMPRESS
  !   Compress (in memory) by NC channels a UV data set
  !------------------------------------------------------------------------
  integer, intent(in) :: nx         ! Output Visibility size
  integer, intent(in) :: nv         ! Number of visibilities
  integer, intent(in) :: mx         ! Number of Output Channels
  real, intent(out) :: out(nx,nv)   ! Output Visibilities
  integer, intent(in) :: ny         ! Input visibility size
  real, intent(in) :: inp(ny,nv)    ! Input visibilities
  integer, intent(in) :: nc         ! Number of Channels to average
  integer, intent(in) :: nt         ! Number of trailing informations
  integer, intent(in), optional :: filtered(:) 
  ! Local
  integer :: i,j,k,kk,ifi,mc
  real :: a,b,c
  integer, allocatable :: filtre(:)
  !
  ! Code
  if (present(filtered)) then
    mc = size(filtered)
    allocate(filtre(mc)) 
    filtre(:) = filtered
  else
    allocate(filtre(nc))
    filtre = 1
  endif
  !$OMP PARALLEL &
  !$OMP    & SHARED(out,inp, nx,nv,mx,ny,nc,nt, filtered)  &
  !$OMP    & PRIVATE(j,ifi,a,b,c,k,kk)
  !$OMP DO SCHEDULE(STATIC)
  do j=1,nv
    out(1:7,j) = inp(1:7,j)
    ifi = 1
    do i=1,mx
      a = 0.
      b = 0.
      c = 0.
      do k=ifi,ifi+nc-1
        kk = 7+3*k
        if (kk.gt.ny-nt) exit   ! Avoid overflow
        if ((inp(kk,j).gt.0).and.(filtre(k).gt.0)) then
          a = a+inp(kk-2,j)*inp(kk,j)
          b = b+inp(kk-1,j)*inp(kk,j)
          c = c+inp(kk  ,j)
        endif
      enddo
      ifi = ifi+nc
      kk = 7+3*i
      if (c.ne.0) then
        out(kk-2,j) = a/c
        out(kk-1,j) = b/c
        out(kk  ,j) = c         ! time*band
      else
        out(kk-2,j) = 0.
        out(kk-1,j) = 0.
        out(kk  ,j) = 0.
      endif
    enddo
    !
    if (nt.ne.0) then
      out(nx-nt+1:nx,j) = inp(ny-nt+1:ny,j)
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL    
end subroutine compress_uv

subroutine mosaic_uvmap_sault(task,line,error)
  !$ use omp_lib
  use gkernel_interfaces
  use imager_interfaces, except_this=>mosaic_uvmap_sault
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use clean_beams 
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- 
  !     Support for command UV_MAP, Mosaic case, SAULT method
  !
  !   Compute a Mosaic from a UV Table, Phase (ideally) or Pointing
  !   (for historical reasons) Offsets information.
  !
  ! Input quantities :  
  !     a Mosaic UV table with Phase or Pointing offset information.  
  !     its associated Mosaic table.
  !
  !   NX NY are the mosaic image sizes  
  !   FX FY are the Field image sizes   
  !   NC is the number of channels   
  !   NF is the number of different frequencies  
  !   NP is the number of pointing centers  
  !   NB is the number of frequency-dependent beam cubes  
  !
  ! Now, we obtain
  !   HDirty      a 3-d cube containing the uniform noise
  !              combined mosaic, i.e. the sum of the product
  !               of the fields by the primary beam. (NX,NY,NC)
  !   HBeam       a 4-d cube where each cube contains the synthesised
  !               beam for one field (NX,NY,NB,NP)
  !   HPrim       the primary beams pseudo-cube (NP,NX,NY,NB)
  !
  ! Ideally, only the Dirty image should be large. 
  ! Dirty and Primary beams can be smaller, with the Pixel shifts
  ! stored in the POINTINGS table.
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task  !! Caller (MOSAIC)
  character(len=*), intent(in) :: line  !! Command line
  logical, intent(out) :: error         !! Logical error flag
  !
  ! Constants
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_in_rad = pi/3600d0/180d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  character(len=*), parameter :: rname='UV_SAULT'
  logical, parameter :: subtract=.true.
  !
  ! Local ---
  type(channel_par) :: channels
  character(len=80) :: mess
  real, allocatable :: w_mapu(:), w_mapv(:), w_grid(:,:)
  real(8) newabs(3)
  real(4) rmega,uvmax,uvmin,uvma
  integer wcol,mcol(2),nfft,sblock
  integer ier
  logical one, sorted
  character(len=message_length) :: chain
  real cpu0, cpu1
  real(8) :: freq
  real, allocatable :: fft(:)
  real, allocatable :: noises(:)
  integer :: nu   ! Local size of a visibility
  integer :: mu   ! Global size of a visibility
  integer :: nc   ! Number of channels
  integer :: mp   ! Total number of fields
  integer :: np   ! Selected number of pointings
  !
  integer :: debug
  logical :: abort
  type(gildas) :: htmp, pdirty, pbeam, local_huv
  real :: btrunc, bsize(10), beamsize 
  !
  real, allocatable, target :: dmap(:,:,:), dtmp(:,:,:,:)
  real, allocatable :: dtrunc(:,:)
  real, allocatable :: doff(:,:)
  integer, allocatable :: teles(:)
  real, pointer :: my_dirty(:,:,:)        ! Global dirty cube
  real, allocatable :: ic_dirty(:,:)      ! Local plane dirty image
  !
  real :: xm, xp, off_range(2)
  integer :: ifield, jfield, jc, fstart, fend
  integer :: ib, nb, old_ib
  integer, parameter :: o_trunc=1
  integer, parameter :: o_field=2
  type(projection_t) :: proj
  real(8) :: pos(2)
  !
  logical :: per_field
  integer(kind=8) :: ram_map, ram_uv, ram_beam
  integer :: nthread, othread, ithread
  logical :: omp_nested
  logical :: do_jvm, do_cct
  real :: jvm_factor
  !
  integer :: ndim, nn(2)
  integer(kind=index_length) :: dim(4)
  complex, allocatable :: comp(:,:)
  !
  real, allocatable :: gfield_w(:)              ! Per field Weights 
  real, allocatable, target :: dfield_uv(:,:)   ! Per field Visibilites
  integer :: idcol          ! ID column number
  integer :: im,ip,jm,jp    ! Input Subset ranges of Field in Dirty sky map
  integer :: km,kp,lm,lp    ! Output Subset ranges of Field in Dirty sky map
  integer :: nx,ny          ! Size of a single field image/beam
  integer :: mx,my          ! Size of dirty sky cube
  integer :: kx,ky          ! Final size of beam cube
  integer :: mv             ! Total Number of visibilities
  integer :: nv             ! per field number of visibilities
  real :: cs(2)             ! Rotation matrix
  real(8) :: dxy(2,1)       ! Per field offset 
  real(4) :: rxy(2,1)       ! Idem, but Real*4
  real(8) :: a0,d0,ap,dp
  !
  logical :: slow
  integer :: ksign=-1       ! Sign of phase correction
  !
  real, allocatable :: dtmp_uv(:,:)
  real, allocatable, target :: ccou(:,:,:)  ! Clean component list
  real, pointer  :: fcou(:,:,:)             ! possibly compressed component list
  integer, allocatable :: omic(:), nmic(:)
  integer :: maxic, icmax,  fcol, lcol, nchan, ic, lc
  integer :: it ! Debug only
  !
  real, pointer :: fctmp(:,:,:)
  real, allocatable :: duv_tmp(:,:)
  integer(kind=index_length) :: iv
  integer :: chunk, oic, olc
  integer :: itrail, nvisi
  real :: bstep ! Words per image pixel
  !-------------------------------------------------------------------------
  ! 
  ! Code ----
  debug = 0
  call sic_get_inte('DEBUG_'//task,debug,error)
  Print *,'Debug DEBUG_'//task, debug
  !
  error = .false.
  call imager_tree(rname,.false.)
  !
  ! A few debug (obsolescent) controls for debugging
  if (mosaic_enlarge.lt.0 .or. mosaic_enlarge.gt.2) mosaic_enlarge = 2
  ksign = -1
  call sic_get_inte('KSIGN',ksign,error) ! For debug only Ksign = -1 is the solution
  !
  !
  if (huv%mos%nfields.gt.1) then
    idcol = huv%gil%column_pointer(code_uvt_id)
  else
    idcol = 0
  endif
  !
  wcol = 0
  abort = .false.
  !
  do_cct = task.eq.'MOSAIC_RESTORE' 
  do_jvm = do_cct .and. beam_defined
  !
  ! Get beam size from data or command line
  call sic_get_real('MAP_TRUNCATE',btrunc,error)
  if (error) return
  write(chain,'(A,F4.2,1X,F4.2)') 'Truncation level ',default_map%truncate, btrunc
  call map_message(seve%i,task,chain,3)
  bsize = 0  ! Must be initialized
  if (sic_present(o_trunc,0)) then
    call get_bsize(huv,rname,line,bsize,error,OTRUNC=o_trunc,BTRUNC=btrunc)
  else
    call get_bsize(huv,rname,line,bsize,error,BTRUNC=btrunc)
  endif
  if (error) return
  beamsize = maxval(bsize)
  write(chain,'(a,f10.2,a,f6.0,a)') 'Correcting for a beam size of ',&
    & beamsize/pi*180*3600,'" down to ',100*btrunc,'% '
  call map_message(seve%i,rname,chain)
  !
  call map_prepare(task,huv,themap,error)
  if (error) return
  if (debug.gt.1) Print *,'Done MAP_PREPARE  Fields ',huv%mos%nfields
  !
  one = .true.  
  call uvmap_cols(rname,line,huv,channels,error)
  if (error) return 
  if (debug.gt.1) Print *,'Done UVMAP_COLS Fields ',huv%mos%nfields, allocated(huv%mos%fields)
  mcol = channels%bounds
  wcol = channels%weight
  !
  mp = abs(themap%nfields) ! Number of pointings
  !
  ! Define Visibility expansion for Continuum data
  nvisi = 0
  do jfield=1,mp
    nvisi = nvisi + huv%mos%fields(jfield)%nvisi
  enddo
  if (huv%gil%nvisi.ne.nvisi*expand_cont) then
    expand_cont = huv%gil%nvisi / nvisi
    write(chain,'(A,I0,A,I0)') 'Set EXPAND_CONT to ',expand_cont,' Number of visi ',nvisi*expand_cont
    call map_message(seve%i,rname,chain,1)
  endif
  !
  ! Select Fields first
  if (.not.do_cct) then
    call sic_delvariable('FIELDS%N_SELECT',.false.,error)
    call sic_delvariable('FIELDS%SELECTED',.false.,error)
    error = .false.
    !
    ! Get the field lists from the /FIELDS option if any
    if (allocated(selected_fields)) deallocate(selected_fields)
    selected_fieldsize = 0
    if (sic_present(o_field,0)) then
      call select_fields(rname,line,o_field,mp,np,selected_fields,error)
      if (error) return
      selected_fieldsize = np
      call sic_def_inte('FIELDS%N_SELECT',selected_fieldsize,0,0,.true.,error)
      dim(1) = selected_fieldsize
      call sic_def_inte('FIELDS%SELECTED',selected_fields,1,dim,.true.,error) 
    endif
  else if (selected_fieldsize.ne.0) then
    write(chain,'(A,I0,A,20(1X,I0))') 'Restoring only ',selected_fieldsize, &
    & ' Fields: ',selected_fields(1:min(20,selected_fieldsize))
    call map_message(seve%i,rname,chain,3)
    np = selected_fieldsize
  else
    np = mp
  endif  
  if (selected_fieldsize.eq.0) then
    np = mp
    if (allocated(selected_fields)) deallocate(selected_fields)
    allocate(selected_fields(mp),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation on Selected Fields')
    endif
    do jfield=1,np
      selected_fields(jfield) = jfield
    enddo
  endif
  !
  call gag_cpu(cpu0)
  !
  call uvgmax(huv,duv,uvmax,uvmin)
  if (debug.gt.1) Print *,'Done UVGMAX ',uvmax,uvmin
  freq = gdf_uv_frequency(huv)
  uvmin = uvmin*freq*f_to_k
  uvmax = uvmax*freq*f_to_k
  !
  mp = abs(themap%nfields) ! Number of fields
  xm = minval(huv%mos%fields(:)%opoint(1))
  xp = maxval(huv%mos%fields(:)%opoint(1))
  off_range(1) = xp-xm
  xm = minval(huv%mos%fields(:)%opoint(2))
  xp = maxval(huv%mos%fields(:)%opoint(2))
  off_range(2) = xp-xm
  !
  ! Point or Phase ?
  allocate(doff(2,mp),teles(mp),stat=ier)
  doff(1,1:mp) = huv%mos%fields(:)%opoint(1)
  doff(2,1:mp) = huv%mos%fields(:)%opoint(2)
  teles(1:mp) = huv%mos%fields(:)%jteles
  !
  ! Never sort, never touch the UV data here
  sorted = .true.
  if (.not.sorted) then
    ! ! Print *,'Done mosaic_sort UV range ',uvmin,uvmax,' sorted ',sorted
    ! ! call uv_dump_buffers('UV_MOSAIC')
    ! Redefine SIC variables (mandatory)
    ! Caution: this overrides command line pointers
    call map_uvgildas ('UV',huv,error,duv) 
  else
    ! ! Print *,'Mosaic was sorted ',uvmin,uvmax,' sorted ',sorted
  endif
  !
  nv = huv%mos%fields(ifield)%nvisi * expand_cont          ! Number of visibilities
  !
  call gag_cpu(cpu1)
  write(chain,102) 'Finished sorting ',cpu1-cpu0
  call map_message(seve%i,task,chain)
  !
  ! Get map parameters
  call map_parameters(task,themap,huv,freq,uvmax,uvmin,error,print=.true.)
  if (error) return
  uvma = uvmax/(freq*f_to_k)
  !
  themap%xycell = themap%xycell*pi/180.0/3600.0
  !
  ! Get work space, ideally before mapping first image, for
  ! memory contiguity reasons.
  !
  ! Dirty sky size
  mx = themap%size(1)
  my = themap%size(2)
  ! Per field size
  kx = nint(abs(field_size*beamsize/themap%xycell(1)))
  call gi4_round_forfft(kx,nx,error,map_rounding,map_power)
  nx = min(nx,mx)
  nx = min(nx,my)
  ny = nx
  write(mess,'(A,I0,A,I0,A,I0,A,I0,A)') 'Field size [',nx,',',ny, &
    & ']  -- Map size [',mx,',',my,']'
  call map_message(seve%i,task,mess,1)
  !
  ! Visibility size and range
  mu = huv%gil%dim(1)  
  mv = huv%gil%nvisi     ! not huv%gil%dim(2)
  nc = mcol(2)-mcol(1)+1 ! not huv%gil%nchan
  nu = mu-2              ! Remove the trailing columns... Why only 2 ???
  !
  allocate(w_mapu(nx),w_mapv(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Gridding allocation error')
    goto 98
  endif
  !
  do_weig = .true.
  if (do_weig) then
    call map_message(seve%i,task,'Computing weights (Sault)')
    if (allocated(g_weight)) deallocate(g_weight)
    allocate(g_weight(mv),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Weight allocation error')
      goto 98
    endif
  else
    call map_message(seve%i,task,'Re-using weights')
  endif
  nfft = 2*max(nx,ny)
  allocate(fft(nfft),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'FFT allocation error')
    goto 98
  endif
  !
  rmega = 8.0
  ier = sic_ramlog('SPACE_IMAGER',rmega)
  sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  !
  ! New Beam place
  if (allocated(dbeam)) then
    call sic_delvariable ('BEAM',.false.,error)
    deallocate(dbeam)
  endif
  call gildas_null(hbeam)
  !
  ! New dirty image
  allocate(dmap(nx,ny,nc),dtrunc(nx,ny),ic_dirty(mx,my),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Map allocation error')
    goto 98
  endif
  !
  if (.not.do_cct) then
    if (allocated(ddirty)) then
      call sic_delvariable ('DIRTY',.false.,error)
      deallocate(ddirty)
    endif
    allocate(ddirty(mx,my,nc),stat=ier)
    my_dirty => ddirty
  else
    if (allocated(dresid)) then
      call sic_delvariable ('RESIDUAL',.false.,error)
      deallocate(dresid)
    endif
    allocate(dresid(mx,my,nc),stat=ier)
    my_dirty => dresid
  endif
  if (ier.ne.0) then
    call map_message(seve%e,task,'Map allocation error')
    goto 98
  endif
  !
  call gildas_null(hdirty)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1:3) = (/nx,ny,nc/)
  !
  ! Compute the primary beams and weight image
  call gildas_null(hprim)
  if (allocated(dprim)) then
    call sic_delvariable ('PRIMARY',.false.,error)
    deallocate(dprim)
  endif
  if (allocated(dfields)) then
    deallocate(dfields)
  endif
  !
  if (debug.gt.1) Print *,'Done MAP_BEAMS ',themap%beam,nb
  !
  ! Find out how many beams are required
  call define_beams(rname,themap%beam,nx,ny,huv,mcol,nb,error)
  if (error) return
  ! Define the map characteristics
  call mosaic_headers(rname,themap,huv,hbeam,hdirty,hprim,nb,np,mcol)
  !
  ! Re-size the per-field data
  hprim%gil%dim(2:3) = [nx,ny]
  hprim%gil%ref(2) = nx/2+1
  hprim%gil%ref(3) = ny/2+1
  hprim%gil%inc(1) = 1
  !
  hbeam%gil%dim(1:2) = [nx,ny]
  hbeam%gil%ref(1) = nx/2+1
  hbeam%gil%ref(2) = ny/2+1
  !
  hdirty%gil%dim(1:2) = [nx,ny]
  hdirty%gil%ref(1) = nx/2+1
  hdirty%gil%ref(2) = ny/2+1
  !
  write(chain,'(A,I0,A,I0,A)') 'Imaging channel range [',mcol(1),',',mcol(2),']'
  call map_message(seve%i,task,chain)
  !
  ! Check if Weights have changed by MCOL choice
  if (any(saved_chan%bounds.ne.mcol)) do_weig = .true. ! Useless ???? NEW !!!! At least mis-placed
  saved_chan%bounds = mcol
  !
  ! Define the projection about the Phase center
  call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
  !
  ! POS is here the Offset of the Pointing center relative to the Phase center
  ! (This may be Zero in most cases) 
  call abs_to_rel (proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
  !
  ! Code ready and now tested for several channels per Beam
  hbeam%gil%ndim = 4
  hbeam%gil%dim(1:4)=(/nx,ny,nb,np/)
  !
  ! Small memory Foot print case
  allocate (dtmp(nx,ny,nb,1), dbeam(nx,ny,np,nb), dprim(np,nx,ny,nb), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'NB>1 Primary beam allocation error')
    goto 98
  endif
  !
  ! For things to work, doff & pos must be related to the fractional 
  ! pixel offset only at this stage 
  !
  ! Re-compute the offsets ...
  newabs = [huv%gil%a0,huv%gil%d0,huv%gil%pang]
  call change_fields(rname,abs(themap%nfields),huv%mos%fields,newabs,error)
  ! Get the shifts and fractions
  call fraction_fields(rname,huv%mos%fields,themap,mx,my,nx,ny,error)
  !
  ! The indirection on Selected Fields is done in Primary_Mosaic
  do ifield = 1,mp
    doff(1,ifield) = huv%mos%fields(ifield)%oxy(1)
    doff(2,ifield) = huv%mos%fields(ifield)%oxy(2)
    teles(ifield) = huv%mos%fields(ifield)%jteles
  enddo
  ! Pos MUST be zero in fact (except for Pointing Mosaics ???)
  pos = 0
  ! 
  hprim%r4d => dprim
  call primary_mosaic(line,np,hprim,hdirty,selected_fields, &
	& selected_fieldsize,doff,pos,teles,bsize,error)
  if (error) return
  call map_message(seve%i,rname,'Done Primary Beams')
  hprim%gil%inc(1) = btrunc  ! Convention to store the truncation level
  hprim%gil%extr_words = 2
  hprim%gil%rmin = 0.
  hprim%gil%rmax = 1.
  !
  ! Loop on fields for imaging
  ! Use Dtmp and Dmap as work arrays for beam and image
  hbeam%r3d => dtmp(:,:,:,1)
  hbeam%gil%dim(4) = 1
  !
  ! In Parallel part, DMAP will be copied per Thread
  ! So we have to verify that the Parallel mode actually fits into Memory
  !
  othread = 1  
  !$ othread = omp_get_max_threads()
  !
  ! Verify memory requirements - Must be adjusted more seriously, considering
  !   Private vs Shared arrays
  ram_uv = huv%gil%dim(1)*huv%gil%dim(2)/512/512
  ram_map = 2*hdirty%gil%dim(1)*hdirty%gil%dim(2)*hdirty%gil%dim(3)/512/512
  ram_beam = 2*hbeam%gil%dim(1)*hbeam%gil%dim(2)*hbeam%gil%dim(3)*hbeam%gil%dim(4)/512/512
!    Print *,'   RAM Map ',ram_map,hdirty%gil%dim(1:4)    Print *,'   RAM Beam ',ram_beam,hbeam%gil%dim(1:4)
  ram_map = ram_map+ram_beam
  !
  nthread = min(othread,np)
  if (ram_map*nthread.gt.sys_ramsize) nthread = nint(real(sys_ramsize)/real(ram_map))
  nthread = max(nthread,1) ! Just in case
  ram_map = ram_map * min(nthread, np)
  !
  if (ram_map.gt.0.2*sys_ramsize) then
    write(chain,'(A,F8.1,A,F8.1,A,F8.1,A)') 'Data size (UV ',1d-3*ram_uv,& 
      & 'GB + Map ',1D-3*ram_map, &
      & 'GB), available RAM (',1d-3*sys_ramsize,' GB)'
    call map_message(seve%w,rname,chain,3)
    if (ram_map.gt.sys_ramsize) then
      call map_message(seve%e,'Data size exceeds RAM',chain,3)
      error = .true.
      return
    endif
  endif
  !
  per_field = .false.  ! Make sure it is initialized
  !
  !$ call ompset_thread_nesting(rname, nthread, othread, omp_nested)    
  !$ nthread = ompget_outer_threads()
  if (nthread.gt.1) then
    per_field = .true.    
    write(chain,'(A,I0,A,I0,A)') 'Using per-field parallel mode. - Threads ',nthread,' Fields ',np
    call map_message(seve%i,rname,chain,3)
  endif
  !
  hdirty%r3d => dmap
  !
  my_dirty = 0.
  ic_dirty = 0.
  allocate(noises(np))  ! To remember the noise
  abort = .false.
  if (sic_ctrlc()) then
    error = .true.
    call map_message(seve%e,rname,'Aborted by user')
    return
  endif
  !
  ! Compress the Clean Component List if needed
  fcol = mcol(1)
  lcol = mcol(2)
  nchan = lcol-fcol+1
  !
  if (do_cct) then
    !
    allocate (omic(nchan),nmic(nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    !
    ! Compact the Clean components first
    ic = fcol
    lc = lcol
    hcct%r3d => dcct
    call uv_clean_sizes(hcct,hcct%r3d,omic,ic-fcol+1,lc-fcol+1)
    icmax = maxval(omic)
    if (debug.gt.1) Print *,'U-DEBUG, Max number of clean components ',icmax
    !
    ! Nothing to do if no Clean component
    if (icmax.eq.0) then
      call map_message(seve%w,task,'No valid Clean Component')
      return
    endif  
    !
    ! Spatially compress the Clean Component List
    allocate(ccou(3,icmax,nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    if (debug.gt.2) Print *,'U-DEBUG, uv_squeeze_clean ',nchan,omic,ic,lc
    call uv_squeeze_clean(nchan,hcct%r3d,ccou, omic,ic,lc)
    if (debug.gt.2) Print *,'U-DEBUG, Done uv_squeeze_clean' 
    ! 
    ! Remember the Full Clean Component List size
    nmic(:) = omic
    !
    ! TRICKY !...
    if (beamsize.ne.0) then  ! This indicates a restoration process  ?
      maxic = maxval(omic)
      write(chain,'(A,I0,A,I0,A)') 'Compressing CCT from ',icmax,' to ',maxic,' components'
      call map_message(seve%i,task,chain)
    endif
    freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
    !
  endif
  !
  !
  if (per_field) then
    write(chain,'(A,I0,A,I0,A)') 'Starting per-field parallel loop on channel range [', &
      & mcol(1),'-',mcol(2),']'
    call map_message(seve%i,rname,chain)
  else
    call map_message(seve%i,rname,'Using per-Plane parallelism')
  endif
  !
  slow = .true.   ! Small number of visibilities per field ?
  ! FFTW plan 
  ndim = 2
  nn(1) = nx !! hdirty%gil%dim(1)
  nn(2) = ny !! hdirty%gil%dim(2)
  allocate(comp(nx,ny),stat=ier)
  if (ier.ne.0) then
    write(chain,'(A,I0,A,I0)') 'FFT Allocation error IER ',ier
    call map_message(seve%e,task,chain)
    error = .true.
    return
  endif
  call fourt_plan(comp,nn,ndim,-1,1)
  cs = [1.,0.]
  a0 = huv%gil%a0
  d0 = huv%gil%d0
  !
  ! Resize the Map
  themap%size = [nx,ny]
  !
  ! Compute Chunk Size.  Nthread should depend on per_field logic
  if (do_cct) then
    bstep = 0.1                  ! Small memory imprint
    if (.not.slow) bstep = 2     ! 1 complex word
    mx = (hcct%gil%convert(1,1)-1)*2
    my = (hcct%gil%convert(1,3)-1)*2
    call uv_get_block(.not.slow,mx,my,nc,nthread,bstep,chunk)
    call map_message(seve%w,task,'FFT Clean subtraction still under test',3) 
  endif
  itrail = -huv%gil%lcol + huv%gil%dim(1) 
  !
  !$OMP PARALLEL DEFAULT(none) if (per_field) NUM_THREADS (nthread) &
  !$OMP   & SHARED(np,debug,task,themap,huv,dprim,dbeam,my_dirty) & 
  !$OMP   & SHARED(hdirty,hbeam,idcol,hcct) &
  !$OMP   & SHARED(selected_fields, noises, nthread) &
  !$OMP   & SHARED(nx,ny,nu,mu,nc,mv,duv,channels,sblock,cpu0,uvma,btrunc,abort) &
  !$OMP   & SHARED(g_weight,beams_param,do_jvm,cs,doff,a0,d0,mx,my) &
  !$OMP   & SHARED(do_cct,nmic,ccou,bsize,nchan,slow,ic,lc,freq,maxic,ksign) &
  !$OMP   & PRIVATE(local_huv,dtmp_uv,omic,fcou) &
  !$OMP   & PRIVATE(pdirty,pbeam,dfield_uv,gfield_w,ic_dirty) &
  !$OMP   & PRIVATE(fstart,fend,nv,do_weig,error,chain,ier)     &
  !$OMP   & PRIVATE(old_ib,jc,ib,dtrunc,dmap,dtmp, ithread, km,kp,lm,lp)     &
  !$OMP   & PRIVATE(dxy,rxy,ap,dp,jvm_factor,im,ip,jm,jp,ifield,jfield,beamsize) &
  !$OMP   & SHARED(itrail,chunk, expand_cont) PRIVATE(oic,olc,duv_tmp,fctmp)
  !
  ithread = 1
  !$ ithread = omp_get_thread_num()+1
  call gildas_null(pdirty)
  call gildas_null(pbeam)
  call gildas_null(local_huv,type='UVT')
  call gdf_copy_header(hdirty,pdirty,error)
  call gdf_copy_header(hbeam,pbeam,error)
  call gdf_copy_header(huv,local_huv,error)
  local_huv%gil%dim(1) = nu
  !
  !$OMP DO
  do jfield = 1,np
    write(chain,'(A,I0,A,I0,A,I0)') 'Starting FIELD ',jfield,' Size ',nu,' x ',nv
    call map_message(seve%t,task,chain)
    if (sic_ctrlc()) then
      abort = .true.
    endif
    if (abort) cycle ! Quick jump if Abort (EXIT not allowed in Parallel mode)
    !
    ifield = selected_fields(jfield)
    !
    ! Extract the specified field
    nv = huv%mos%fields(ifield)%nvisi * expand_cont          ! Number of visibilities
    if (.not.do_cct) then
      ! Imaging of whole data 
      allocate(dfield_uv(nu,nv),gfield_w(nv),stat=ier)
      if (ier.ne.0) then
        write(chain,'(A,I0,A,I0)') 'Allocation error IER ',ier,' Field ',ifield
        call map_message(seve%e,task,chain)
        abort = .true.
        cycle
      endif
      call sault_extract_field(duv,mu,mv,nu,idcol,g_weight, &
        & ifield,dfield_uv,gfield_w,nv)
    else
      ! Imaging of Residuals
      if (beamsize.ne.0) then
        allocate(fcou(3,maxic,nchan),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,task,'Memory allocation error')
          error = .true.
          cycle
        endif
      else
        fcou => ccou
      endif
      !
      ! Need an intermediate array
      allocate(dfield_uv(nu,nv),gfield_w(nv),dtmp_uv(nu,nv),stat=ier)
      if (ier.ne.0) then
        write(chain,'(A,I0,A,I0)') 'Allocation error IER ',ier,' Field ',ifield
        call map_message(seve%e,task,chain)
        abort = .true.
        cycle
      endif
      !
      ! And one more for FFTs
      if (.not.slow) then
        allocate(duv_tmp(7+3*chunk+itrail,nv),stat=ier) !! kvend-kvstart+1),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,task,'FFT memory allocation error')
          abort = .true.
          cycle
        endif
      endif
      !
      ! Extract the Field
      call sault_extract_field(duv,mu,mv,nu,idcol,g_weight, &
        & ifield,dtmp_uv,gfield_w,nv)
      local_huv%gil%nvisi = nv
      local_huv%gil%dim(2) = nv
      !
      ! The Clean Components are in Offsets compared to the Reference value
      call map_message(seve%i,task,'Computing UV residuals')
      omic(:) = nmic(:)       ! Restart from un-attenuate Clean Component List size
      rxy(1,1) = huv%mos%fields(ifield)%opoint(1)
      rxy(2,1) = huv%mos%fields(ifield)%opoint(2)
      !
      ! The sub-images will be shifted by their respective Phase offsets
      dxy(1,1) = huv%mos%fields(ifield)%ophase(1)
      dxy(2,1) = huv%mos%fields(ifield)%ophase(2)
      beamsize = bsize(huv%mos%fields(ifield)%jteles)
      call attenuate_clean(nchan,ccou,rxy,beamsize,fcou,omic,dxy(:,1))
      if (debug.gt.2) then
        print *,'Field ',ifield,rxy(1:2,1)/sec_in_rad,huv%mos%fields(ifield)%opoint(1:2)/sec_in_rad
        do it=1,min(10,omic(1))
          Print *,it,fcou(1:2,it,1)/sec_in_rad,ccou(3,it,1),fcou(3,it,1) !,omic(1),nmic(1)
        enddo
      endif
      !
      if (slow) then
        if (debug.gt.1) Print *,'U-DEBUG, Slow case IC ',ic,' LC ',lc,' OMIC ',omic
        call uv_removes_clean(nv,dtmp_uv,dfield_uv,lc-ic+1,omic, &
          & fcou,freq,ic,lc,subtract)
        if (debug.gt.1) Print *,'U-DEBUG, Done Slow ',ifield  
      else
        if (debug.gt.1) Print *,'U-DEBUG, Fast case '
        !
        ! By channel chunks
        do oic=ic,lc,chunk 
          olc = min(lc,oic+chunk-1)
          duv_tmp = 0.
          !
          ! Offset in OMIC but Also in FCOU
          fctmp => fcou(:,:,oic-ic+1:)
          call uv_removef_clean(hcct,dtmp_uv,duv_tmp,olc-oic+1,omic(oic:olc), &
            & fctmp,freq, oic, olc, subtract)
          !
          do iv=1,nv
            dfield_uv(5+3*oic:7+3*olc,iv) = duv_tmp(8:7+3*(olc-oic+1),iv)
          enddo
        enddo
        deallocate(duv_tmp,stat=ier) 
        !
        ! Start & Trail after the loop
        do iv=1,nv
          dfield_uv(1:7,iv) = dtmp_uv(1:7,iv)
          if (itrail.gt.0) then
            dfield_uv(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
              & dtmp_uv(huv%gil%lcol+1:huv%gil%dim(1),iv)  
          endif
        enddo
        !
        if (debug.gt.1) Print *,'U-DEBUG, Done Fast ',ifield  
        !
      endif
      if (debug.gt.3) then
        write(local_huv%file,'(A,I0)') 'test', ifield
        call gdf_write_image(local_huv,dfield_uv,error)
        write(local_huv%file,'(A,I0)') 'all', ifield
        call gdf_write_image(local_huv,dtmp_uv,error)
      endif
      deallocate(dtmp_uv)  ! Per field intermediate array
    endif
    !
    ! Shift the Phases for the Fractional pixel & difference between Pointing and Phase centers
    dxy(1,1) = ksign*huv%mos%fields(ifield)%oxy(1)+(huv%mos%fields(ifield)%opoint(1)-huv%mos%fields(ifield)%ophase(1))
    dxy(2,1) = ksign*huv%mos%fields(ifield)%oxy(2)+(huv%mos%fields(ifield)%opoint(2)-huv%mos%fields(ifield)%ophase(2))
    if (debug.gt.0) then
      write(chain,'(A,I0,A,I0,A,F8.3,F8.3,A,F8.3,F8.3)')  'Field ',ifield,': Visi ',nv, &
        & ' Offsets :',huv%mos%fields(ifield)%opoint(1)/sec_in_rad,huv%mos%fields(ifield)%opoint(2)/sec_in_rad, &
        & ', Phases :',dxy(1,1)/sec_in_rad,dxy(2,1)/sec_in_rad
      call map_message(seve%d,task,chain,1)
    endif
    dxy = - freq * f_to_k * dxy ! Convert to Wavelength units
    call sault_shiftuv (nu,nv,huv%gil%nchan,dfield_uv,cs,1,dxy)
    if (debug.gt.0) call map_message(seve%i,task,'Done SAULT_SHIFT_UV',1)
    !
    ! Correct the u,v values for the Global projection since it is not yet done.
    ap = huv%mos%fields(ifield)%apoint(1)
    dp = huv%mos%fields(ifield)%apoint(2)
    call sault_uv_change(nu,nv,dfield_uv,ap,dp,a0,d0)  
    if (debug.gt.0) call map_message(seve%i,task,'Done SAULT_SHIFT_UV',1)
    !
    ! Assign the Pointers in each Thread for Parallel case
    pdirty%r3d => dmap
    pbeam%r3d => dtmp(:,:,:,1)
    local_huv%r2d => dfield_uv
    dtmp = 0.
    dmap = 0.
    !
    do_weig = .true.
    !
    ! We could write the Thread or Field number in "task" argument...
    ! SG: does "themap" contains the proper sizes ?... Not obvious
    local_huv%gil%nvisi = nv
    call many_beams_para (task,themap, channels, local_huv, pbeam, pdirty,   &
       &    nx,ny,nu,nv,dfield_uv,   &
       &    gfield_w, do_weig,  &
       &    sblock,cpu0,error,uvma,ifield,abort,ithread)
    deallocate(gfield_w,dfield_uv,stat=ier)
    if (debug.gt.0) call map_message(seve%i,task,'Done MANY_BEAMS_PARA',1)
    !
    noises(jfield) = pdirty%gil%noise   ! Remember the noise
    huv%mos%fields(ifield)%sigma = pdirty%gil%noise   ! Remember the noise
    if (abort) cycle                    ! Cannot Return
    !
    old_ib = 0
    !
    ! Define the subset range to be added
    call pixel_range(huv%mos%fields(ifield)%jxy(1),im,ip,km,kp,nx,mx)
    call pixel_range(huv%mos%fields(ifield)%jxy(2),jm,jp,lm,lp,ny,my)
    write(chain,'(A,I0,A,6(1X,I0))') 'Field ',ifield,' Pixel range ',im,ip,jm,jp,mx,my
    call map_message(seve%d,task,chain)
    write(chain,'(A,I0,A,6(1X,I0))') 'Sky   ',ifield,' Pixel range ',km,kp,lm,lp,nx,ny
    call map_message(seve%d,task,chain)
    !
    do jc=1,nc
      ib = beam_for_channel(jc,pdirty,pbeam)
      if (do_jvm) then
        jvm_factor = beams_param(4,ib,jfield)
        if (jvm_factor.eq.0.) jvm_factor = 1.
        write(chain,'(A,I0,A,I0,A,F7.3,A,I0)')  &
          & 'Field ',jfield,', Beam ',ib,', JvM factor ',jvm_factor,'; Thread ',ithread
        call map_message(seve%i,task,chain)
      else
        jvm_factor = 1.
      endif
      if (debug.gt.3) Print *,'Selected beam ',ib, jvm_factor
      ! Add it to the "mosaic dirty" image, by multiplying by
      ! the truncated primary beam
      if (ib.ne.old_ib) then
        dtrunc(:,:) = dprim(jfield,:,:,ib)
        if (debug.gt.3) Print *,'Set DTRUNC ',ib,' # ',old_ib
        where (dtrunc.lt.btrunc) dtrunc = 0
        old_ib = ib
      endif
      !
      ! Here we should add the (smaller) field to the global Dirty image
      ! The intermediate array ic_dirty(:,:) is required to avoid
      ! memory collision in Parallel programming
      ic_dirty = 0.
      ! We use here the JvM factor for the Residual image 
      ic_dirty(im:ip,jm:jp) = dmap(km:kp,lm:lp,jc)*dtrunc(km:kp,lm:lp)*jvm_factor
      !$OMP CRITICAL
      my_dirty(:,:,jc) = my_dirty(:,:,jc) + ic_dirty(:,:)
      !$OMP END CRITICAL
    enddo
    !
    ! Save the beam - Transposition is done here as needed -
    dbeam(:,:,jfield,:) = dtmp(:,:,:,1) ! Transpose      
    if (.not.do_jvm) then
      write(chain,'(A,I0,A,I0)') 'Ending Field ',ifield,' Thread ',ithread
      call map_message(seve%t,task,chain)
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (debug.gt.0) call map_message(seve%i,task,'Done loop on fields',1)
  if (per_field) then
    !$  call omp_set_nested(omp_nested)
    !$  call omp_set_num_threads(othread)
    !$  call map_message(seve%d,task,'Finished parallel section')
  endif
  if (abort) then
    call map_message(seve%w,task,'Aborted by user')
    error = .true.
    return
  endif
  hdirty%gil%noise = sum(noises)/np
  !
  ! Set the BEAM header 
  call gildas_null(htmp)
  call gdf_copy_header(hbeam,htmp,error)
  htmp%gil%ndim = 4
  call gdf_transpose_header(htmp,hbeam,'1243',error)
  if (error) return
  !
  if (mosaic_enlarge.gt.0) then
    ! 
    ! Temporary stuff : plunge Beam & Primary into Bigger arrays for CLEAN
    if (allocated(dtmp)) deallocate(dtmp)
    !
    ! Do Dirty Beams only if needed and requested
    if (mosaic_enlarge.gt.1) then
      if (nx.ne.mx .or. ny.ne.my) then
        call map_message(seve%w,rname,'Enlarging Dirty Beam')
        allocate(dtmp(nx,ny,np,nb),stat=ier)
        dtmp(:,:,:,:) = dbeam
        if (allocated(dbeam)) deallocate(dbeam)
        allocate(dbeam(mx,my,np,nb),stat=ier)
        dbeam = 0.0
        im = mx/2-nx/2+1
        ip = im+nx-1
        jm = my/2-ny/2+1
        jp = jm+ny-1
        !
        do ib=1,nb
          do jfield=1,np
            dbeam(im:ip,jm:jp,jfield,ib) = dtmp(:,:,jfield,ib)
          enddo
        enddo
        deallocate(dtmp)
      endif
      hbeam%gil%dim(1:2) = [mx,my]
      hbeam%gil%ref(1) = mx/2+1
      hbeam%gil%ref(2) = my/2+1
    else
      call map_message(seve%w,rname,'Dirty Beam not Enlarged')
    endif
    !
    write(mess,'(A,I0,A,I0,A,I0,A,I0,A)') 'Enlarging from [',nx,',',ny &
      & ,'] to [',mx,',',my,']'
    call map_message(seve%i,rname,mess)
    !
    ! Do Primary Beams in all cases
    allocate(dtmp(np,nx,ny,nb),stat=ier)
    dtmp(:,:,:,:) = dprim
    if (allocated(dprim)) deallocate(dprim)
    allocate(dprim(np,mx,my,nb),stat=ier)
    dprim(:,:,:,:) = 0
    do ib=1,nb
      do jfield=1,np
        ! Define the subset range to be added
        ifield = selected_fields(jfield)
        call pixel_range(huv%mos%fields(ifield)%jxy(1),im,ip,km,kp,nx,mx)
        call pixel_range(huv%mos%fields(ifield)%jxy(2),jm,jp,lm,lp,ny,my)
        write(chain,'(A,I0,A,6(1X,I0))') 'Field  ',ifield,' Pixel range ',km,kp,lm,lp,nx,ny
        call map_message(seve%d,task,chain)
        write(chain,'(A,I0,A,6(1X,I0))') 'Output ',ifield,' Pixel range ',im,ip,jm,jp,mx,my
        call map_message(seve%d,task,chain)
        dprim(jfield,im:ip,jm:jp,ib)  = dtmp(jfield,km:kp,lm:lp,ib)
      enddo
    enddo
    deallocate(dtmp)
    !    
    hprim%gil%dim(2:3) = [mx,my] 
    hprim%gil%ref(2) = mx/2+1
    hprim%gil%ref(3) = my/2+1
    !
    kx = mx
    ky = my
  else
    ! We have unfortunately no way yet to store the appropriate pixel shifts
    ! with the Primary Beams. 
    !
    call map_message(seve%w,rname,'MOSAIC_ENLARGE = 0 mode is still only for tests',1)
    !
    !   It would not matter for the Dirty Beams, since
    ! this can be done automatically when starting CLEAN. In fact,
    ! CLEAN could easily handle Dirty Beams that are smaller (or larger)
    ! than the full image. To be verified at some point later...
    kx = nx
    ky = ny
  endif
  !
  ! Finish the Beam header - Change address & size
  hbeam%r4d => dbeam  
  hbeam%gil%dim(3:4)=(/np,nb/)
  hbeam%gil%ndim = 4
  hbeam%loca%addr = locwrd(dbeam)
  hbeam%loca%size = product(hbeam%gil%dim(1:4))
  call sic_delvariable('BEAM',.false.,error)
  call sic_mapgildas('BEAM',hbeam,error,dbeam)
  !
  hprim%r4d => dprim
  call sic_mapgildas('PRIMARY',hprim,error,dprim)
  !
  ! OK we are almost done 
  !
  ! Reset the Dirty pointer and the Sizes
  hdirty%r3d => my_dirty
  hdirty%gil%dim(1:2) = [mx,my] ! Correct the size now
  hdirty%gil%ref(1) = mx/2+1
  hdirty%gil%ref(2) = my/2+1
  hdirty%loca%addr = locwrd(my_dirty)
  themap%size = [mx,my]
  !
  ! Nullify Filtered channels and Compute Dirty extrema 
  call cube_flag_extrema(huv%gil%nchan,'DIRTY',mcol,hdirty)
  !
  ! Correct the noise for the approximate gain at mosaic center
  ! for HWHM hexagonal spacing (normally it is sqrt(1+6/4)) 
  hdirty%gil%noise = hdirty%gil%noise/sqrt(2.5)
  if (.not.do_cct) then
    !
    ! UV_MAP only - We have the Dirty image 
    call sic_mapgildas('DIRTY',hdirty,error,ddirty)
    !
    save_data(code_save_beam) = .true.
    save_data(code_save_dirty) = .true.
    save_data(code_save_primary) = .true.
    save_data(code_save_fields) = .true.
    !
    call new_dirty_beam
    !
    ! Define Min Max
    call cube_minmax('DIRTY',hdirty,error)
    !
    d_max = hdirty%gil%rmax
    if (hdirty%gil%rmin.eq.0) then
      d_min = -0.03*hdirty%gil%rmax
    else
      d_min = hdirty%gil%rmin
    endif
  else
    ! Define the RESIDUAL
    call gdf_copy_header(hdirty,hresid,error)
    hresid%r3d => dresid
    call cube_minmax('RESIDUAL',hresid,error)
    call sic_mapgildas('RESIDUAL',hresid,error,dresid)
    ! Restore the DIRTY image pointer
    hdirty%r3d => ddirty
  endif
  !
  error = .false.
  !
  ! Backward compatibility with previous methods
  user_method%trunca = btrunc     ! By convention
  hprim%gil%convert(3,4) = beamsize  ! Primary beam size convention
  call sub_mosaic('ON',error)
  !
  if (allocated(w_mapu)) deallocate(w_mapu)
  if (allocated(w_mapv)) deallocate(w_mapv)
  if (allocated(w_grid)) deallocate(w_grid)
  if (allocated(fft)) deallocate(fft)
  call imager_tree(rname,.true.)
  return
  !
98 call map_message(seve%e,task,'Memory allocation failure')
  error = .true.
  return
  !
102 format(a,f9.2)
end subroutine mosaic_uvmap_sault
!
subroutine sault_extract_field(visi,mu,mv,nu,id,g_w, &
  & ifield,dfield_uv,gf_w,nv)
  use image_def
  !-------------------------------------------------------------------
  ! @ private
  !* 
  !  IMAGER -- Support routine for commands UV_MAP and UV_RESTORE
  !
  ! Extract a field for the SAULT method, based on the Field ID number
  !!
  !-------------------------------------------------------------------  
  integer, intent(in) :: mu             !! Input Visibility size
  integer, intent(in) :: mv             !! Number of visibilities
  real(4), intent(in) :: visi(mu,mv)    !! Visibilities
  integer, intent(in) :: nu             !! Output Visibility size
  integer, intent(in) :: id             !! ID column number
  real(4), intent(in) :: g_w(mv)        !! Weights
  integer, intent(in) :: ifield         !! Field to be loaded
  integer, intent(in) :: nv             !! Number of output visibilities
  real(4), intent(out) :: dfield_uv(nu,nv)  !! Field visibilities
  real(4), intent(out) :: gf_w(nv)      !! Field weights
  !
  ! Local ---
  integer :: iv, kv
  !  
  ! Code ----
  kv = 0
  do iv=1,mv
    if (visi(id,iv).eq.ifield) then
      kv = kv+1
      if (kv.le.nv) then
        dfield_uv(:,kv) = visi(1:nu,iv)
      endif
    endif
  enddo
  if (kv.ne.nv) then
    Print *,'F-SAULT_EXTRACT_FIELDS,  Programming error KV ',kv,' # NV ',nv
    Print *,'F-SAULT_EXTRACT_FIELDS,  Field number ',id,ifield,' -- UV size ',mu,mv
    Print *,'F-SAULT_EXTRACT_FIELDS,  Input UV sizes ',mu,mv,' -- Output size ',nu,nv
  endif
end subroutine sault_extract_field
!
subroutine sault_shiftuv (nu,nv,nchan,visi,cs,nc,xy)
  !$ use omp_lib
  use image_def
  use gkernel_interfaces
  use gkernel_types
  use clean_arrays 
  use gbl_message
  use imager_interfaces, only : map_message
  use phys_const
  !-------------------------------------------------------------------
  ! @ private
  !*
  !  IMAGER  -- Support routine for commands UV_MAP, Mosaic SAULT method
  !
  !   Shift phase center and apply U,V coordinates rotation if needed
  !   Note that Offsets are not shifted, neither rotated by this
  !   subroutine.
  !!
  !-------------------------------------------------------------------
  integer, intent(in) :: nu             !! Size of a visibility
  integer, intent(in) :: nv             !! Number of visibilities
  integer, intent(in) :: nchan          !! Number of channels
  real, intent(inout) :: visi(nu,nv)    !! Visibilities
  real, intent(in) :: cs(2)             !! Cos/Sin of Rotation
  integer, intent(in) :: nc             !! Number of Channels
  real(8), intent(in) :: xy(2,nc)       !! Position Shift per channel
  !
  ! Local ---
  integer :: i,jc,iu,iv,ix
  real(8) :: phi, sphi, cphi
  real :: u, v, reel, imag
  !
  ! Code ----
  if (all(xy.eq.0)) then
    if (cs(1).ne.1.0 .or. cs(2).ne.0.0) then
      iu = 1
      iv = 2
      !$OMP PARALLEL DEFAULT(none) &
      !$OMP SHARED(nv,cs,visi,iu,iv) &
      !$OMP PRIVATE(i,u,v) 
      !$OMP DO
      do i = 1,nv
        u = visi(iu,i)
        v = visi(iv,i)
        visi(iu,i) = cs(1)*u - cs(2)*v
        visi(iv,i) = cs(2)*u + cs(1)*v
      enddo
      !$OMP ENDDO
      !$OMP END PARALLEL
    endif
    return
  endif
  !
  ! Shift and rotation of a specified phase center
  !
  cphi = 1.0
  sphi = 0.0
  !
  iu = 1
  iv = 2
  !
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP SHARED(nchan,nv,nc,cs,xy,visi,iu,iv) &
  !$OMP PRIVATE(i,u,v,phi,jc,ix,reel,imag) &
  !$OMP FIRSTPRIVATE(cphi,sphi) 
  !
  !$OMP DO
  do i = 1,nv
    u = visi(iu,i)
    v = visi(iv,i)
    visi(iu,i) = cs(1)*u - cs(2)*v
    visi(iv,i) = cs(2)*u + cs(1)*v
    !
    if (nc.eq.1) then
      phi = xy(1,1)*u + xy(2,1)*v
      cphi = cos(phi)
      sphi = sin(phi)
    endif
    !
    do jc=1,nchan
      ix = 8+(jc-1)*3 
      if (nc.gt.1) then
        phi = xy(1,jc)*u + xy(2,jc)*v
        cphi = cos(phi)
        sphi = sin(phi)
      endif
      reel = visi(ix,i) * cphi - visi(ix+1,i) * sphi
      imag = visi(ix,i) * sphi + visi(ix+1,i) * cphi
      visi(ix,i) = reel
      visi(ix+1,i) = imag
    enddo
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine sault_shiftuv
!
subroutine loadfiuv_id (visi,np,nv,dtr,it,sorted,idoff,rpv,nf,doff)
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER    UV_MAP -- Mosaic SAULT sorting routines  
  !     Load field numbers into work arrays for sorting.
  !!
  !---------------------------------------------------------------------
  integer, intent(in)  :: np                     !! Size of a visibility
  integer, intent(in)  :: nv                     !! Number of visibilities
  real, intent(in) :: visi(np,nv)                !! Input visibilities
  real(8), intent(out) :: dtr(nv)                !! Output field number
  integer, intent(out) :: it(nv)                 !! Indexes
  logical, intent(out) :: sorted                 !! Is data sorted by Fields ?
  integer, intent(in)  :: idoff                  !! ID pointer
  real(4), intent(in)  :: rpv(nv)                !! V Values
  integer, intent(inout) :: nf                   !! Number of fields
  real(kind=4), intent(out) :: doff(:,:)         !! Fields offsets
  !
  ! Local ---
  integer :: iv, i
  integer :: mfi 
  real(8) :: vmax
  !
  ! Code ----
  !
  ! Scan how many fields
  mfi = ubound(doff,2)
  if (nf.ne.mfi) Print *,'Warning Number of field mismatch ',nf, mfi
  !
  ! V are negative values, so this 1 + max(abs(V))
  vmax = 1.0d0-minval(rpv)
  !
  do iv=1,nv
    if (rpv(iv).gt.0) then
      Print *,'Unsorted Visibility with V > 0 ',iv,rpv(iv)
    endif
    if ((visi(idoff,iv).lt.1).or.(visi(idoff,iv).gt.nf)) then
      Print *,'Out of bound field number at # ',iv, visi(idoff,iv)
    endif
    dtr(iv) = dble(visi(idoff,iv)) + rpv(iv)/vmax
    it(iv) = iv
  enddo
  !
  do i=1,nf
    doff(1,i) = huv%mos%fields(i)%opoint(1)
    doff(2,i) = huv%mos%fields(i)%opoint(2)
  enddo
  !
  ! DTR must in the end be ordered and increasing.
  vmax = dtr(1)
  do iv = 1,nv
    if (dtr(iv).lt.vmax) then
      sorted = .false.
      return
    endif
    vmax = dtr(iv)
  enddo
  sorted = .true.
  !
end subroutine loadfiuv_id
!
subroutine pixel_range(r,im,ip,km,kp,nx,mx)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- UV_MAP utility routine for SAULT method.
  !   
  !   Define input & output pixel ranges
  ! when placing an input array into an output one.
  !     Load field numbers into work arrays for sorting.
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: r                !! Pixel shift
  integer, intent(in) :: nx,mx            !! Input & Output sizes
  integer, intent(out) :: im,ip           !! Input pixel range
  integer, intent(out) :: km,kp           !! Output pixel range
  !
  ! Code ----
  im =  1+r
  ip = nx+im-1
  if (ip.gt.mx) then
    kp = nx-ip+mx
    ip = mx
  else 
    kp = nx
  endif
  if (im.lt.1) then
    km = 2-im
    im = 1
  else
    km = 1
  endif
end subroutine pixel_range

program plugjax
  !
  ! (Copyright 2024)    S.Guilloteau   LAB/OASU CNRS   
  ! Plug in the <HEAD> section of an HTML file created by Latex2Html 
  ! the plugin to allow MathJax to be used for equations and Math symbols.
  !
  ! The original .tex file must not use \begin{equation}\end{equation}
  ! Instead it must distinguish between latex and html cases for equations
  ! which should be noted between $$ and $$
  !
  ! Examples
  !
  ! Normal use of Latex
  !  \begin{equation}
  !     A : \pi r^2
  !  \end{equation}
  ! Replace by
  !  \begin{latexonly}
  !   $$  A : \pi r^2  $$
  !  \end{latexonly}
  !  \begin{rawhtml}
  !   $$  A : \pi r^2  $$
  !  \end{rawhtml}
  !
  ! In addition, in-line Math equations should not be cut over two lines.
  !   $ a = pi r^2$     is valid
  ! while  $ a =
  !              \pi r^2 $  is NOT valid
  !
  ! This code should be compiled and is used by the makehtml.sh script
  ! for the IMAGER and VIEWER documentation, through a simple pipe
  ! plug-jax < input.html > output.html
  !
  ! This whole (clumsy) process is a workaround for failures of some
  ! versions of latex2html to do the conversion properly: inline images
  ! used for math symbols being with wrong scaling and bounding box.
  !
  character(len=1024) :: line
  character(len=80) :: comm
  character(len=256) :: fich
  integer :: nl,nd,ni,nj,ier
  !
  CALL GET_ENVIRONMENT_VARIABLE('GAG_PATH',FICH)
  !! ier = sic_getlog('$GAG_PATH',fich)
  nl = len_trim(fich)
  fich(nl+1:) = '/jaxheader.txt'
  !
  open(unit=1,file=fich,status='OLD')
  !
  read(*,'(A)',iostat=ier) line
  do while (ier.eq.0) 
    nl = len_trim(line)
    !
    ! Insert the MathJax Header
    if (index(line,'<HEAD>').ne.0) then
      write(*,'(A)') line(1:nl)
      !
      rewind(1)
      do 
        read(1,'(A)',iostat=ier) line
        if (ier.ne.0) exit
        nl = len_trim(line)
        write(*,'(A)') line(1:nl)
      enddo
      ier = 0
    else 
      ni = index(line(1:nl),'<SPAN CLASS="MATH"><IMG')
      if (ni.eq.0) then
        write(*,'(A)') line(1:nl)
        read(*,'(A)',iostat=ier) line
      else 
        if (ni.gt.1) then
          write(*,'(A)') line(1:ni-1)
        endif
        !
        ni = 0
        nj = 0
        do 
          read(*,'(A)',iostat=ier) line
          if (ier.ne.0) exit
          ni = index(line,'ALT')
          nj = index(line,'</SPAN>')
          !! write(*,*) '<!-- '//trim(line)//' [',ni,nj,'] -->' ! Comment for debug
          if (ni.ne.0) exit
          if (nj.ne.0) exit
        enddo
        if (ni.eq.0) then
          ier = 1
          Print *,'No ALT found'
          exit
        endif
        ! translate ALT=" "><SPAN>
        comm = line(ni+4:)
        !! write(*,*) '<!-- '//trim(comm)//' [#1] -->' ! Comment for debug
        nl = len_trim(comm)
        ! Replace first $ by \(
        nd = index(comm,'$')+1
        !!Print *,'NI ND ',NI,ND,NL, line(1:nl)
        comm = '\('//comm(nd:)
        ! Replace last $ by \)
        nd = index(comm(1:nl),'$')
        comm(nd:) = '\)'
        write(*,'(A)') trim(comm)
        !! write(*,*) '<!-- '//trim(comm)//' [#2] -->' ! Comment for debug
        !
        ! Now scan until </SPAN> is found
        ni = index(line,'</SPAN>')
        do while(ni.eq.0)
          read(*,'(A)',iostat=ier) line
          if (ier.ne.0) exit
          ni = index(line,'</SPAN>')
        enddo  
        !
        ! OK </SPAN> is found. Skip the whole region
        line = line(ni+7:)  ! Length of </SPAN>
      endif
    endif
  enddo
end program

module gsys_interfaces_public_c
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Public interfaces to C routines (hand made)
  !---------------------------------------------------------------------
  !
  integer(kind=4), external :: gag_isreal  ! Actually a Fortran function, not C
  integer(kind=4), external :: gag_isdble  ! Actually a Fortran function, not C
  integer(kind=address_length), external :: locwrd  ! no-interface
  !
  interface sic_getvm
    ! Generic interface to sic_getvm4/sic_getvm8, depending on the kind
    ! of the integer storing Nwords.
    function sic_getvm4(nwords,address)
    use gildas_def
    integer(kind=4) :: sic_getvm4  ! Function value on return
    integer(kind=4),              intent(in)  :: nwords   ! As a 32-bit integer
    integer(kind=address_length), intent(out) :: address
    end function sic_getvm4
    !
    function sic_getvm8(nwords,address)
    use gildas_def
    integer(kind=4) :: sic_getvm8  ! Function value on return
    integer(kind=8),              intent(in)  :: nwords   ! As a 64-bit integer
    integer(kind=address_length), intent(out) :: address
    end function sic_getvm8
    !
#if defined(FORTRAN2003)
    function sic_getvm4c(nwords,address)
    use iso_c_binding
    integer(kind=4) :: sic_getvm4c  ! Function value on return
    integer(kind=4), intent(in)  :: nwords   ! As a 32-bit integer
    type(c_ptr), intent(out) :: address
    end function sic_getvm4c
    !
    function sic_getvm8c(nwords,address)
    use iso_c_binding
    integer(kind=4) :: sic_getvm8c  ! Function value on return
    integer(kind=8), intent(in)  :: nwords   ! As a 64-bit integer
    type(c_ptr), intent(out) :: address
    end function sic_getvm8c
#endif
  end interface
  !
  interface free_vm
    subroutine free_vm4(nwords,addr)
    use gildas_def
    integer(kind=4),              intent(in) :: nwords
    integer(kind=address_length), intent(in) :: addr
    end subroutine free_vm4
    !
    subroutine free_vm8(nwords,addr)
    use gildas_def
    integer(kind=8),              intent(in) :: nwords
    integer(kind=address_length), intent(in) :: addr
    end subroutine free_vm8
  end interface
  !
  interface
    function gag_getpid()
    integer(kind=4) :: gag_getpid
    end function gag_getpid
    !
    function locstr(string)
    use gildas_def
    integer(kind=address_length) :: locstr
    character(len=*), intent(in) :: string
    end function locstr
    !
    function gag_pointer(addr,mem)
    use gildas_def
    integer(kind=address_length) :: gag_pointer
    integer(kind=address_length), intent(in) :: addr
    integer(kind=4),              intent(in) :: mem(*)
    end function gag_pointer
    !
    function bytpnt(addr,mem)
    use gildas_def
    integer(kind=address_length) :: bytpnt
    integer(kind=address_length), intent(in) :: addr
    integer(kind=1),              intent(in) :: mem(*)
    end function bytpnt
    !
    subroutine gag_fillook(fd,file)
    integer(kind=4),  intent(out) :: fd
    character(len=*), intent(in)  :: file
    end subroutine gag_fillook
    !
    subroutine gag_filclose(fd)
    integer(kind=4), intent(in) :: fd
    end subroutine gag_filclose
    !
    function gag_filseek(fd,offset)
    integer(kind=4) :: gag_filseek
    integer(kind=4), intent(in) :: fd
    integer(kind=4), intent(in) :: offset
    end function gag_filseek
    !
    function gag_system(string)
    integer(kind=4) :: gag_system
    character(len=*), intent(in) :: string
    end function gag_system
    !
    subroutine gag_debug_system(sw)
    integer(kind=4), intent(in) :: sw
    end subroutine gag_debug_system
    !
    subroutine gag_filrm(file)
    character(len=*), intent(in) :: file
    end subroutine gag_filrm
    !
    function gag_filcopy(fromfile,tofile)
    integer(kind=4) :: gag_filcopy
    character(len=*), intent(in) :: fromfile
    character(len=*), intent(in) :: tofile
    end function gag_filcopy
    !
    function gag_filmove(fromfile,tofile)
    integer(kind=4) :: gag_filmove
    character(len=*), intent(in) :: fromfile
    character(len=*), intent(in) :: tofile
    end function gag_filmove
    !
    function gag_filrename(fromfile,tofile)
    integer(kind=4) :: gag_filrename
    character(len=*), intent(in) :: fromfile
    character(len=*), intent(in) :: tofile
    end function gag_filrename
    !
    function gag_filsize(file,fsize)
    integer(kind=4) :: gag_filsize
    character(len=*), intent(in)  :: file
    integer(kind=8),  intent(out) :: fsize
    end function gag_filsize
    !
    function gag_filappend(fromfile,tofile)
    integer(kind=4) :: gag_filappend
    character(len=*), intent(in) :: fromfile
    character(len=*), intent(in) :: tofile
    end function gag_filappend
    !
    function gag_rmdir(dirname)
    integer(kind=4) :: gag_rmdir
    character(len=*), intent(in) :: dirname
    end function gag_rmdir
    !
    function gag_isdir(dirname)
    integer(kind=4) :: gag_isdir
    character(len=*), intent(in) :: dirname
    end function gag_isdir
    !
    subroutine sic_getenv(name,trans)
    character(len=*), intent(in) :: name
    character(len=*), intent(out) :: trans
    end subroutine sic_getenv
    !
    function sic_setenv(name,trans)
    integer(kind=4) :: sic_setenv
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: trans
    end function sic_setenv
    !
    function gag_inquire(infile,length)
    integer(kind=4) :: gag_inquire
    character(len=*), intent(in) :: infile
    integer(kind=4),  intent(in) :: length
    end function gag_inquire
    !
    function gag_mdate(path,date)
    integer(kind=4) :: gag_mdate
    character(len=*), intent(in)  :: path
    integer(kind=4),  intent(out) :: date
    end function gag_mdate
    !
    subroutine sic_c_date(returned_date)
    character(len=*), intent(out) :: returned_date
    end subroutine sic_c_date
    !
    subroutine sic_wait(time)
    real(kind=4), intent(in) :: time
    end subroutine sic_wait
    !
    subroutine executable_extension(ext)
    character(len=*), intent(out) :: ext
    end subroutine executable_extension
    !
    subroutine sic_c_assert(condition,message)
    logical,          intent(in) :: condition
    character(len=*), intent(in) :: message
    end subroutine sic_c_assert
    !
    subroutine gag_mkpath(path,error)
    character(len=*), intent(in)  :: path
    logical,          intent(out) :: error
    end subroutine gag_mkpath
    !
    subroutine gag_show_locked_files()
    end subroutine gag_show_locked_files
    !
    function gag_lock_file(filename)
    integer(kind=4) :: gag_lock_file
    character(len=*), intent(in) :: filename
    end function gag_lock_file
    !
    subroutine gag_resources()
    end subroutine gag_resources
    !
    function gag_setlocale(locname)
    integer(kind=4) :: gag_setlocale
    character(len=*), intent(in) :: locname
    end function gag_setlocale
    !
    subroutine gag_printlocale()
    end subroutine gag_printlocale
    !
    subroutine gag_ramsize(ramsize)
    integer(kind=8), intent(out) :: ramsize
    end subroutine gag_ramsize
    !
    subroutine gag_cachesize(l1size,l2size,l3size,l4size)
    integer(kind=8), intent(out) :: l1size
    integer(kind=8), intent(out) :: l2size
    integer(kind=8), intent(out) :: l3size
    integer(kind=8), intent(out) :: l4size
    end subroutine gag_cachesize
    !
    function sic_isatty()
    integer(kind=4) :: sic_isatty
    end function sic_isatty
    !
    function sic_ttyncol()
    integer(kind=4) :: sic_ttyncol
    end function sic_ttyncol
    !
    function sic_ttynlin()
    integer(kind=4) :: sic_ttynlin
    end function sic_ttynlin
    !
    function sic_fini4(x)
    logical :: sic_fini4
    real(kind=4), intent(in) :: x
    end function sic_fini4
    !
    function sic_fini8(x)
    logical :: sic_fini8
    real(kind=8), intent(in) :: x
    end function sic_fini8
    !
  end interface
  !
end module gsys_interfaces_public_c
!
module gsys_interfaces_private_c
  !---------------------------------------------------------------------
  ! @ private
  ! Private interfaces to C routines (hand made)
  !---------------------------------------------------------------------
  !
  interface
    subroutine gag_crash()
    end subroutine gag_crash
    !
    subroutine gag_errno(error,string)
    integer(kind=4), intent(in) :: error
    character(len=*), intent(out) :: string
    end subroutine gag_errno
    !
    subroutine sic_resolve_env(src,dst)
    character(len=*), intent(in) :: src
    character(len=*), intent(out) :: dst
    end subroutine sic_resolve_env
    !
    subroutine sic_c_datetime_from_raw(rawtime,returned_asciitime)
    integer(kind=4),  intent(in)  :: rawtime
    character(len=*), intent(out) :: returned_asciitime
    end subroutine sic_c_datetime_from_raw
    !
    subroutine sic_c_idatetime(vals,frac)
    integer(kind=4), intent(out) :: vals(6)
    real(kind=4),    intent(out) :: frac
    end subroutine sic_c_idatetime
    !
    subroutine sic_c_datetime(returned_asciitime)
    character(len=*), intent(out) :: returned_asciitime
    end subroutine sic_c_datetime
    !
    subroutine sic_c_isodatetime(returned_asciitime)
    character(len=*), intent(out) :: returned_asciitime
    end subroutine sic_c_isodatetime
    !
    subroutine gag_c_cputime(t)
    real(kind=8), intent(out) :: t(5)
    end subroutine gag_c_cputime
    !
    function set_dir(dir)
    integer(kind=4) :: set_dir
    character(len=*), intent(in) :: dir
    end function set_dir
    !
    function gag_directory_num_C(dirname,count)
    integer(kind=4) :: gag_directory_num_C
    character(len=*), intent(in) :: dirname
    integer(kind=4), intent(out) :: count
    end function gag_directory_num_C
    !
    function gag_mtime_c(path,sec,nsec)
    integer(kind=4) :: gag_mtime_c
    character(len=*), intent(in)  :: path
    integer(kind=4),  intent(out) :: sec
    integer(kind=4),  intent(out) :: nsec
    end function gag_mtime_c
    !
    function gag_time_c(sec,nsec)
    integer(kind=4) :: gag_time_c
    integer(kind=4), intent(out) :: sec
    integer(kind=4), intent(out) :: nsec
    end function gag_time_c
    !
    function gag_filsame_c(file1,file2)
    integer(kind=4) :: gag_filsame_c
    character(len=*), intent(in) :: file1
    character(len=*), intent(in) :: file2
    end function gag_filsame_c
  end interface
  !
end module gsys_interfaces_private_c
!
module gsys_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GSYS interfaces, all kinds (private or public). Do not use directly
  ! out of the library.
  !---------------------------------------------------------------------
  !
  use gsys_interfaces_public
  use gsys_interfaces_public_c
  use gsys_interfaces_private
  use gsys_interfaces_private_c
  !
end module gsys_interfaces

subroutine init_pen(error)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>init_pen
  use gtv_protocol
  use gtv_plot
  !---------------------------------------------------------------------
  ! @ private
  !  Initialize the look-up-table for coloured Pens
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  !
  call load_pen(cw_output,gbl_pen,.false.,.false.,error)
  if (error)  return
  !
  ! Define the SIC variables related to pen LUT
  call sic_defstructure('LUT%PEN',.true.,error)
  if (error)  return
  call sic_def_real('LUT%PEN%HUE',       gbl_pen%hue, 1,gbl_pen%size,.false.,error)
  call sic_def_real('LUT%PEN%SATURATION',gbl_pen%sat, 1,gbl_pen%size,.false.,error)
  call sic_def_real('LUT%PEN%VALUE',     gbl_pen%val, 1,gbl_pen%size,.false.,error)
  call sic_def_real('LUT%PEN%RED',       gbl_pen%r,   1,gbl_pen%size,.false.,error)
  call sic_def_real('LUT%PEN%GREEN',     gbl_pen%g,   1,gbl_pen%size,.false.,error)
  call sic_def_real('LUT%PEN%BLUE',      gbl_pen%b,   1,gbl_pen%size,.false.,error)
  if (error)  return
  !
end subroutine init_pen
!
subroutine load_pen(out,pen,reuse,color,error)
  use gtv_interfaces, except_this=>load_pen
  use gtv_plot
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  ! Load the appropriate LUT in the input 'pen' set of pen.
  !---------------------------------------------------------------------
  type(gt_display), intent(in)    :: out    !
  type(gt_lut),     intent(inout) :: pen    !
  logical,          intent(in)    :: reuse  ! Reuse current user's colormap?
  logical,          intent(in)    :: color  ! If not reuse, generate colors?
  logical,          intent(inout) :: error  !
  !
  error = .false.
  call gt_lut_alloc(pen,pen_size,error)
  if (error)  return
  !
  if (reuse .and. gbl_pen%size.gt.0) then
    pen = gbl_pen
    !
  elseif (color) then
    ! Use default color LUT
    call gt_lut_default(pen,pen%size)
    !
  elseif (out%background.eq.1) then
    ! Black LUT
    call gt_lut_rgb(pen,pen%size,1.,0.,1.,0.,1.,0.)
    !
  else
    ! White LUT
    call gt_lut_rgb(pen,pen%size,0.,1.,0.,1.,0.,1.)
  endif
  !
end subroutine load_pen
!
subroutine pen_lut(line,error)
  use gildas_def
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>pen_lut
  use gtv_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command:
  !   LUT [Argum] /PEN
  ! LOADS a color table read in a file written in free format,
  !   or defined by the Hue, Saturation, Value
  !   or Red Green Blue arrays,
  ! depending upon the current representation.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='PENLUT'
  character(len=80) :: argum,arguml
  integer :: i
  integer :: nc
  !
  arguml = 'LUT'
  call sic_ch (line,0,1,arguml,nc,.false.,error)
  if (error)  return
  argum=arguml
  call sic_upper(argum(1:nc))
  !
  select case (argum)
  case('DEFAULT')
    call gt_lut_default(gbl_pen,gbl_pen%size)
    !
  case('COLOR')
    call gt_lut_color(gbl_pen,gbl_pen%size)
    !
  case('BLACK')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,1.,0.,1.,0.,1.,0.)
    !
  case('WHITE')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,1.,0.,1.,0.,1.)
    !
  case('RED')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,1.,0.,0.,0.,0.)
    !
  case('GREEN')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,0.,0.,1.,0.,0.)
    !
  case('BLUE')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,0.,0.,0.,0.,1.)
    !
  case('YELLOW')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,1.,0.,1.,0.,0.)
    !
  case('CYAN')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,0.,0.,1.,0.,1.)
    !
  case('MAGENTA')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,1.,0.,0.,0.,1.)
    !
  case('NULL')
    call gt_lut_rgb(gbl_pen,gbl_pen%size,0.,0.,0.,0.,0.,0.)
    !
  case('LUT')
    if (lut_mode.eq.hsv_mode) then
      do i=1,gbl_pen%size
        gbl_pen%sat(i) = max(0.0,min(gbl_pen%sat(i),1.0))
        gbl_pen%val(i) = max(0.0,min(gbl_pen%val(i),1.0))
        gbl_pen%hue(i) = max(0.0,min(gbl_pen%hue(i),360.0))
        call hsv_to_rgb(gbl_pen%hue(i),gbl_pen%sat(i),gbl_pen%val(i),  &
                        gbl_pen%r(i),gbl_pen%g(i),gbl_pen%b(i))
      enddo
    else
      do i=1,gbl_pen%size
        gbl_pen%r(i) = max(0.0,min(1.0,gbl_pen%r(i)))
        gbl_pen%g(i) = max(0.0,min(1.0,gbl_pen%g(i)))
        gbl_pen%b(i) = max(0.0,min(1.0,gbl_pen%b(i)))
        call rgb_to_hsv(gbl_pen%r(i),gbl_pen%g(i),gbl_pen%b(i),  &
                        gbl_pen%hue(i),gbl_pen%sat(i),gbl_pen%val(i))
      enddo
    endif
    !
  case('?')
    call gt_lut_list(error)
    return  ! This was just a display, no action to perform on graphical window
    !
  case default
    ! Read from file, blanking is excluded
    call gt_lut_fromfile(arguml,gbl_pen,gbl_pen%size,error)
    if (error)  return
    !
  end select
  !
  ! /REVERSE reverts the PENLUT just loaded
  if (sic_present(3,0)) then
    call gt_lut_revert(gbl_pen,gbl_pen%size,error)
    if (error)  return
  endif
  !
end subroutine pen_lut
!
subroutine gtv_penlut(error)
  use gtv_interfaces, except_this=>gtv_penlut
  use gtv_tree
  use gtv_buffers
  use gtv_plot
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Defines the color pens Look Up Table in the METACODE
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_PENLUT'
  !
  call gtsegm('PENLUT',error)
  if (error)  return
  !
  call gt_penlut_segdata(error)
  ! if (error) close the segment
  !
  call gtsegm_close(error)  ! Thread-safe
  if (error)  return
  !
end subroutine gtv_penlut
!
subroutine gt_penlut_segdata(error)
  use gtv_interfaces, except_this=>gt_penlut_segdata
  use gtv_tree
  use gtv_buffers
  use gtv_plot
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !  Save the current pen color Look Up Table into the METACODE
  ! ---
  !   Threads status: thread safe
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='GTV_PENLUT'
  integer(kind=4) :: ier
  !
  call gtv_open_segments_for_writing_from_main()
  !
  if (.not.associated(co_segment_data)) then
    allocate(co_segment%data,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (1)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment%data
  else
    allocate(co_segment_data%nextdata,stat=ier)
    if (ier.ne.0) then
      call gtv_message(seve%e,rname,'Internal error: allocation failure (2)')
      error = .true.
      goto 10
    endif
    co_segment_data => co_segment_data%nextdata
  endif
  co_segment_data%nextdata => null()
  !
  ! Store the data
  call gt_lut_alloc(co_segment_data%lut,gbl_pen%size,error)
  if (error)  goto 10
  !
  ! Copy
  co_segment_data%kind = seg_pencol
  co_segment_data%lut%size = gbl_pen%size
  co_segment_data%lut%r(:) = gbl_pen%r(:)
  co_segment_data%lut%g(:) = gbl_pen%g(:)
  co_segment_data%lut%b(:) = gbl_pen%b(:)
  !
  ! Save the pen lut address for later use by polylines
  co_segment%head%lut => co_segment_data%lut
  !
10 continue
  !
  call gtv_close_segments_for_writing_from_main()
  !
end subroutine gt_penlut_segdata
!
subroutine gti_penlut(out,lut)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gti_penlut
  use gtv_tree
  use gtv_types
  use gtv_graphic
  use gtv_plot
  use gtv_protocol
  !---------------------------------------------------------------------
  ! @ private
  ! Defines the color pens Look Up Table on the DISPLAY
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: out  ! Input gt_display
  type(gt_lut),     intent(in) :: lut  !
  ! Local
  integer :: nn,i
  !
  if (.not.awake .or. error_condition) return
  !
  if (.not.lut_static)  return  ! The image LUT known by the device remains
    ! the global one (gbl_colormap). It should be a custom one only in the
    ! LUT STATIC case.
  !
  nn = min(gbl_pen%size,lut%size)
  if (nn.gt.0) then
    call r4tor4 (lut%r,gbl_pen%r,nn)
    call r4tor4 (lut%g,gbl_pen%g,nn)
    call r4tor4 (lut%b,gbl_pen%b,nn)
  endif
  !
  do i=1,gbl_pen%size
    call rgb_to_hsv(gbl_pen%r(i),gbl_pen%g(i),gbl_pen%b(i),  &
                    gbl_pen%hue(i),gbl_pen%sat(i),gbl_pen%val(i))
  enddo
  !
end subroutine gti_penlut

*DECK DNLS1
      SUBROUTINE DNLS1 (FCN, IOPT, M, N, X, FVEC, FJAC, LDFJAC, FTOL,
     +   XTOL, GTOL, MAXFEV, EPSFCN, DIAG, MODE, FACTOR, NPRINT, INFO,
     +   NFEV, NJEV, IPVT, QTF, WA1, WA2, WA3, WA4)
C***BEGIN PROLOGUE  DNLS1
C***PURPOSE  Minimize the sum of the squares of M nonlinear functions
C            in N variables by a modification of the Levenberg-Marquardt
C            algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      DOUBLE PRECISION (SNLS1-S, DNLS1-D)
C***KEYWORDS  LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNLS1 is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  The user must provide a subrou-
C       tine which calculates the functions.  The user has the option
C       of how the Jacobian will be supplied.  The user can supply the
C       full Jacobian, or the rows of the Jacobian (to avoid storing
C       the full Jacobian), or let the code approximate the Jacobian by
C       forward-differencing.   This code is the combination of the
C       MINPACK codes (Argonne) LMDER, LMDIF, and LMSTR.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNLS1(FCN,IOPT,M,N,X,FVEC,FJAC,LDFJAC,FTOL,XTOL,
C      *                 GTOL,MAXFEV,EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO
C      *                 ,NFEV,NJEV,IPVT,QTF,WA1,WA2,WA3,WA4)
C       INTEGER IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV
C       INTEGER IPVT(N)
C       DOUBLE PRECISION FTOL,XTOL,GTOL,EPSFCN,FACTOR
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(LDFJAC,N),DIAG(N),QTF(N),
C      *     WA1(N),WA2(N),WA3(N),WA4(M)
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to DNLS1 and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNLS1.
C
C      FCN is the name of the user-supplied subroutine which calculate
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         DOUBLE PRECISION X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored       , if IOPT=1.
C         DOUBLE PRECISION FJAC(LDFJAC,N)      , if IOPT=2.
C         DOUBLE PRECISION FJAC(N)             , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNLS1.  In this case, set
C         IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       FJAC is an output array.  For IOPT=1 and 2, FJAC is an M by N
C         array.  For IOPT=3, FJAC is an N by N array.  The upper N by N
C         submatrix of FJAC contains an upper triangular matrix R with
C         diagonal elements of nonincreasing magnitude such that
C
C                T     T           T
C               P *(JAC *JAC)*P = R *R,
C
C         where P is a permutation matrix and JAC is the final calcu-
C         lated Jacobian.  Column J of P is column IPVT(J) (see below)
C         of the identity matrix.  The lower part of FJAC contains
C         information generated during the computation of R.
C
C       LDFJAC is a positive integer input variable which specifies
C         the leading dimension of the array FJAC.  For IOPT=1 and 2,
C         LDFJAC must not be less than M.  For IOPT=3, LDFJAC must not
C         be less than N.
C
C       FTOL is a non-negative input variable.  Termination occurs when
C         both the actual and predicted relative reductions in the sum
C         of squares are at most FTOL.  Therefore, FTOL measures the
C         relative error desired in the sum of squares.  Section 4 con-
C         tains more details about FTOL.
C
C       XTOL is a non-negative input variable.  Termination occurs when
C         the relative error between two consecutive iterates is at most
C         XTOL.  Therefore, XTOL measures the relative error desired in
C         the approximate solution.  Section 4 contains more details
C         about XTOL.
C
C       GTOL is a non-negative input variable.  Termination occurs when
C         the cosine of the angle between FVEC and any column of the
C         Jacobian is at most GTOL in absolute value.  Therefore, GTOL
C         measures the orthogonality desired between the function vector
C         and the columns of the Jacobian.  Section 4 contains more
C         details about GTOL.
C
C       MAXFEV is a positive integer input variable.  Termination occurs
C         when the number of calls to FCN to evaluate the functions
C         has reached MAXFEV.
C
C       EPSFCN is an input variable used in determining a suitable step
C         for the forward-difference approximation.  This approximation
C         assumes that the relative errors in the functions are of the
C         order of EPSFCN.  If EPSFCN is less than the machine preci-
C         sion, it is assumed that the relative errors in the functions
C         are of the order of the machine precision.  If IOPT=2 or 3,
C         then EPSFCN can be ignored (treat it as a dummy argument).
C
C       DIAG is an array of length N.  If MODE = 1 (see below), DIAG is
C         internally set.  If MODE = 2, DIAG must contain positive
C         entries that serve as implicit (multiplicative) scale factors
C         for the variables.
C
C       MODE is an integer input variable.  If MODE = 1, the variables
C         will be scaled internally.  If MODE = 2, the scaling is speci-
C         fied by the input DIAG.  Other values of MODE are equivalent
C         to MODE = 1.
C
C       FACTOR is a positive input variable used in determining the ini-
C         tial step bound.  This bound is set to the product of FACTOR
C         and the Euclidean norm of DIAG*X if nonzero, or else to FACTOR
C         itself.  In most cases FACTOR should lie in the interval
C         (.1,100.).  100. is a generally recommended value.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls to FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C        execution, INFO is set to the (negative) value of IFLAG.  See
C        description of FCN and JAC. Otherwise, INFO is set as follows
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  both actual and predicted relative reductions in the
C                   sum of squares are at most FTOL.
C
C         INFO = 2  relative error between two consecutive iterates is
C                   at most XTOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  the cosine of the angle between FVEC and any column
C                   of the Jacobian is at most GTOL in absolute value.
C
C         INFO = 5  number of calls to FCN for function evaluation
C                   has reached MAXFEV.
C
C         INFO = 6  FTOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  XTOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 8  GTOL is too small.  FVEC is orthogonal to the
C                   columns of the Jacobian to machine precision.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       NFEV is an integer output variable set to the number of calls to
C         FCN for function evaluation.
C
C       NJEV is an integer output variable set to the number of
C         evaluations of the full Jacobian.  If IOPT=2, only one call to
C         FCN is required for each evaluation of the full Jacobian.
C         If IOPT=3, the M calls to FCN are required.
C         If IOPT=1, then NJEV is set to zero.
C
C       IPVT is an integer output array of length N.  IPVT defines a
C         permutation matrix P such that JAC*P = Q*R, where JAC is the
C         final calculated Jacobian, Q is orthogonal (not stored), and R
C         is upper triangular with diagonal elements of nonincreasing
C         magnitude.  Column J of P is column IPVT(J) of the identity
C         matrix.
C
C       QTF is an output array of length N which contains the first N
C         elements of the vector (Q transpose)*FVEC.
C
C       WA1, WA2, and WA3 are work arrays of length N.
C
C       WA4 is a work array of length M.
C
C
C 4. Successful Completion.
C
C       The accuracy of DNLS1 is controlled by the convergence parame-
C       ters FTOL, XTOL, and GTOL.  These parameters are used in tests
C       which make three types of comparisons between the approximation
C       X and a solution XSOL.  DNLS1 terminates when any of the tests
C       is satisfied.  If any of the convergence parameters is less than
C       the machine precision (as defined by the function R1MACH(4)),
C       then DNLS1 only attempts to satisfy the test defined by the
C       machine precision.  Further progress is not usually possible.
C
C       The tests assume that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then DNLS1 may incorrectly indicate conver-
C       gence.  If the Jacobian is coded correctly or IOPT=1,
C       then the validity of the answer can be checked, for example, by
C       rerunning DNLS1 with tighter tolerances.
C
C       First Convergence Test.  If ENORM(Z) denotes the Euclidean norm
C         of a vector Z, then this test attempts to guarantee that
C
C               ENORM(FVEC) .LE. (1+FTOL)*ENORM(FVECS),
C
C         where FVECS denotes the functions evaluated at XSOL.  If this
C         condition is satisfied with FTOL = 10**(-K), then the final
C         residual norm ENORM(FVEC) has K significant decimal digits and
C         INFO is set to 1 (or to 3 if the second test is also satis-
C         fied).  Unless high precision solutions are required, the
C         recommended value for FTOL is the square root of the machine
C         precision.
C
C       Second Convergence Test.  If D is the diagonal matrix whose
C         entries are defined by the array DIAG, then this test attempts
C         to guarantee that
C
C               ENORM(D*(X-XSOL)) .LE. XTOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with XTOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 2 (or to 3 if the first test is also satis-
C         fied).  There is a danger that the smaller components of D*X
C         may have large relative errors, but if MODE = 1, then the
C         accuracy of the components of X is usually related to their
C         sensitivity.  Unless high precision solutions are required,
C         the recommended value for XTOL is the square root of the
C         machine precision.
C
C       Third Convergence Test.  This test is satisfied when the cosine
C         of the angle between FVEC and any column of the Jacobian at X
C         is at most GTOL in absolute value.  There is no clear rela-
C         tionship between this test and the accuracy of DNLS1, and
C         furthermore, the test is equally well satisfied at other crit-
C         ical points, namely maximizers and saddle points.  Therefore,
C         termination caused by this test (INFO = 4) should be examined
C         carefully.  The recommended value for GTOL is zero.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of DNLS1 can be due to improper input
C       parameters, arithmetic interrupts, or an excessive number of
C       function evaluations.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1
C         or IOPT .GT. 3, or N .LE. 0, or M .LT. N, or for IOPT=1 or 2
C         LDFJAC .LT. M, or for IOPT=3 LDFJAC .LT. N, or FTOL .LT. 0.E0,
C         or XTOL .LT. 0.E0, or GTOL .LT. 0.E0, or MAXFEV .LE. 0, or
C         FACTOR .LE. 0.E0.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by DNLS1.  In this
C         case, it may be possible to remedy the situation by rerunning
C         DNLS1 with a smaller value of FACTOR.
C
C       Excessive Number of Function Evaluations.  A reasonable value
C         for MAXFEV is 100*(N+1) for IOPT=2 or 3 and 200*(N+1) for
C         IOPT=1.  If the number of calls to FCN reaches MAXFEV, then
C         this indicates that the routine is converging very slowly
C         as measured by the progress of FVEC, and INFO is set to 5.
C         In this case, it may be helpful to restart DNLS1 with MODE
C         set to 1.
C
C
C 6. Characteristics of the Algorithm.
C
C       DNLS1 is a modification of the Levenberg-Marquardt algorithm.
C       Two of its main characteristics involve the proper use of
C       implicitly scaled variables (if MODE = 1) and an optimal choice
C       for the correction.  The use of implicitly scaled variables
C       achieves scale invariance of DNLS1 and limits the size of the
C       correction in any direction where the functions are changing
C       rapidly.  The optimal choice of the correction guarantees (under
C       reasonable conditions) global convergence from starting points
C       far from the solution and a fast rate of convergence for
C       problems with small residuals.
C
C       Timing.  The time required by DNLS1 to solve a given problem
C         depends on M and N, the behavior of the functions, the accu-
C         racy requested, and the starting point.  The number of arith-
C         metic operations needed by DNLS1 is about N**3 to process each
C         evaluation of the functions (call to FCN) and to process each
C         evaluation of the Jacobian it takes M*N**2 for IOPT=2 (one
C         call to FCN), M*N**2 for IOPT=1 (N calls to FCN) and
C         1.5*M*N**2 for IOPT=3 (M calls to FCN).  Unless FCN
C         can be evaluated quickly, the timing of DNLS1 will be
C         strongly influenced by the time spent in FCN.
C
C       Storage.  DNLS1 requires (M*N + 2*M + 6*N) for IOPT=1 or 2 and
C         (N**2 + 2*M + 6*N) for IOPT=3 single precision storage
C         locations and N integer storage locations, in addition to
C         the storage required by the program.  There are no internally
C         declared storage arrays.
C
C *Long Description:
C
C 7. Example.

module ggui_interfaces_public_c
  !---------------------------------------------------------------------
  ! Fortran interfaces to C public subroutines (hand made)
  !---------------------------------------------------------------------
  !
  interface
    function hlp_more()
      integer(kind=4) :: hlp_more
    end function hlp_more
  end interface
  !
  interface
    subroutine gkbd_f_histo_set_filename(filename)
      character(len=*), intent(in) :: filename
    end subroutine gkbd_f_histo_set_filename
  end interface
  !
  interface
    function kbd_line(prompt,line,code)
      integer(kind=4) :: kbd_line
      character(len=*), intent(in)    :: prompt
      character(len=*), intent(out)   :: line
      integer(kind=4),  intent(inout) :: code
    end function kbd_line
  end interface
  !
  interface
    subroutine prompt_loop(code)
      integer(kind=4), intent(inout) :: code
    end subroutine prompt_loop
  end interface
  !
  interface
    function read_linec(prompt,line,code,wait_command)
      integer(kind=4) :: read_linec
      character(len=*), intent(inout) :: prompt
      character(len=*), intent(inout) :: line
      integer(kind=4),  intent(inout) :: code
      integer(kind=4),  intent(in)    :: wait_command
    end function read_linec
  end interface
  !
  interface
    subroutine xgag_command(label,command)
      character(len=*), intent(in) :: label
      character(len=*), intent(in) :: command
    end subroutine xgag_command
  end interface
  !
  interface
    subroutine xgag_detach(title,name)
      character(len=*), intent(in) :: title
      character(len=*), intent(in) :: name
    end subroutine xgag_detach
  end interface
  !
  interface
    subroutine xgag_end_detach(name)
      character(len=*), intent(in) :: name
    end  subroutine xgag_end_detach
  end interface
  !
  interface
    subroutine xgag_endmenu()
    end subroutine xgag_endmenu
  end interface
  !
  interface
    subroutine xgag_launch()
    end subroutine xgag_launch
  end interface
  !
  interface
    subroutine xgag_menu(label)
      character(len=*), intent(in) :: label
    end subroutine xgag_menu
  end interface
  !
  interface
    subroutine xgag_settimer_status(ns)
      integer(kind=4), intent(in) :: ns
    end subroutine xgag_settimer_status
    subroutine xgag_gettimer_status(ns)
      integer(kind=4), intent(out) :: ns
    end subroutine xgag_gettimer_status
    subroutine xgag_settimer(ns)
      integer(kind=4), intent(in) :: ns
    end subroutine xgag_settimer
    subroutine xgag_gettimer(ns)
      integer(kind=4), intent(out) :: ns
    end subroutine xgag_gettimer
    subroutine xgag_gettimer_command(command)
      character(len=*), intent(out) :: command
    end subroutine xgag_gettimer_command
    subroutine xgag_settimer_command(command)
      character(len=*), intent(in) :: command
    end subroutine xgag_settimer_command
  end interface
  !
  interface
    subroutine xgag_wait()
    end subroutine xgag_wait
  end interface
  !
  interface
    subroutine end_dialog()
    end subroutine end_dialog
  end interface
  !
  interface
    subroutine get_user_input(err_code)
      integer(kind=4), intent(out) :: err_code
    end subroutine get_user_input
  end interface
  !
  interface
    subroutine xgag_button(title,command,label,length,helptxt,moretxt)
      character(len=*), intent(in) :: title
      character(len=*), intent(in) :: command
      character(len=*), intent(in) :: label
      integer(kind=4),  intent(in) :: length
      character(len=*), intent(in) :: helptxt
      character(len=*), intent(in) :: moretxt
    end subroutine xgag_button
  end interface
  !
  interface
    subroutine xgag_dialog(return_command,err_code)
      character(len=*), intent(in) :: return_command
      integer(kind=4)              :: err_code
    end subroutine xgag_dialog
  end interface
  !
  interface
    subroutine xgag_open(txt,name,code)
      character(len=*), intent(in) :: txt
      character(len=*), intent(in) :: name
      integer(kind=4)              :: code
    end subroutine xgag_open
  end interface
  !
  interface
    subroutine xgag_separator(win_id)
      integer(kind=4), intent(in) :: win_id
    end subroutine xgag_separator
  end interface
  !
  interface
    subroutine xgag_update(variable,update)
      character(len=*), intent(in) :: variable
      character(len=*), intent(in) :: update
    end subroutine xgag_update
  end interface
  !
  interface
    subroutine xgag_begin_group(label)
      character(len=*) :: label
    end subroutine xgag_begin_group
  end interface
  !
  interface
    subroutine xgag_end_group()
    end subroutine xgag_end_group
  end interface
  !
  interface
    subroutine gprompt_set_command_line(command_line)
      character(len=*), intent(in) :: command_line
    end subroutine gprompt_set_command_line
  end interface
  !
  interface
    subroutine xgag_end_detach_all()
    end subroutine xgag_end_detach_all
  end interface
  !
  interface
    subroutine xgag_uri_menu(label,uri)
      character(len=*), intent(in) :: label
      character(len=*), intent(in) :: uri
    end subroutine xgag_uri_menu
  end interface
  !
  interface
    subroutine xgag_set_callback_help(sub)
      external :: sub
    end subroutine xgag_set_callback_help
  end interface
  !
end module ggui_interfaces_public_c

module sic_runs
  use gildas_def
  use sic_dictionaries
  !---------------------------------------------------------------------
  ! Support for nested calls of programs and languages
  !---------------------------------------------------------------------
  integer, parameter :: sic_maxlang=64
  integer(kind=address_length), save :: run_address(2,sic_maxlang)=0
  logical, save :: debug_mode
  integer, save :: sic_icall=0
  character(len=command_length), save :: sic_stack(sic_maxlang)
end module sic_runs
!
subroutine sic_begin(lang,help,scom,ccom,version,inter,prob)
  use sic_runs
  use sic_dictionaries
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_begin
  !---------------------------------------------------------------------
  ! @ public
  ! Main initialisation routine for Languages
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: lang     !
  character(len=*), intent(in) :: help     !
  integer,          intent(in) :: scom     !
  character(len=*), intent(in) :: ccom(1)  !
  character(len=*), intent(in) :: version  !
  external :: inter                        ! Subroutine for executable code
  logical, external :: prob                ! Logical error function
  ! Local
  logical, save :: first=.true.
  logical :: error
  !
  call sic_load(lang,help,scom,ccom,version)
  run_address(1,nlang) = locwrd(inter)
  run_address(2,nlang) = locwrd(prob)
  !
  if (run_address(1,1).eq.0) then
    run_address(1,1) = locwrd(run_sic)
    run_address(2,1) = locwrd(sic_error)
  endif
  !
  if (first) then
    error = .false.
    call sic_def_logi('DEBUG_RECURSIVE',debug_mode,.false.,error)
    first = .false.
  endif
  !
end subroutine sic_begin
!
recursive subroutine exec_program(buffer)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exec_program
  use sic_runs
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public
  ! Main routine to execute a command or enter a program
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: buffer  !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ip,ie
  character(len=command_length) :: command
  character(len=language_length) :: lang
  character(len=2048) :: line
  integer :: icode,ocode
  logical :: error
  !
  line = buffer
  icode = code_exec
  goto 10
  !
entry play_program(buffer)  ! @ public
  line = buffer
  icode = code_play
  goto 10
  !
entry enter_program  ! @ public
  icode = code_enter
  goto 10
  !
10 continue
  !
  ! Return Ocode -1 : End of subroutine mode
  !        Ocode  1 : End of interactive mode
  !
  error = .false.
  do while (.true.)
    call sic_run(line,lang,command,error,icode,ocode)
    if (ocode.ne.code_next) then
#if defined(GAG_USE_PYTHON)
      if (ocode.eq.code_exit)  &  ! SIC\EXIT has been called from SIC
        call gpy_onsicexit
#endif
      return
    endif
    icode = code_run
    !
    ! Activate the language dependent code
    if (run_address(1,ccomm%ilang).eq.0) then
      call sic_message(seve%f,'SIC',  &
        trim(lang)//'\ language has not been initialized by SIC_BEGIN')
      call sysexi(fatale)
    endif
    ip = bytpnt(run_address(1,ccomm%ilang),membyt)
    ie = bytpnt(run_address(2,ccomm%ilang),membyt)
    call sub_program (membyt(ip),line,command,error,membyt(ie))
  enddo
  !
end subroutine exec_program
!
subroutine exec_adjust(buffer,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exec_adjust
  use sic_runs
  use sic_dictionaries
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Execute any command, possibly a procedure. Non recursive version
  ! used by ADJUST only
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: buffer  !
  logical,          intent(out) :: error   !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=address_length) :: ip,ie
  !
  character(len=command_length) :: command
  character(len=language_length) :: lang
  character(len=2048) :: line
  integer :: icode,ocode
  !
  error = .false.
  line = buffer
  icode = code_exec
  !
  ! Return Ocode -1 : End of subroutine mode
  !        Ocode  1 : End of interactive mode
  !
  do while (.true.)
    call sic_run(line,lang,command,error,icode,ocode)
    if (ocode.ne.code_next) return
    icode = code_run
    !
    if (run_address(1,ccomm%ilang).eq.0) then
      call sic_message(seve%f,'SIC',  &
        trim(lang)//'\ language has not been initialized by SIC_BEGIN')
      error = .true.
      return
    endif
    ip = bytpnt(run_address(1,ccomm%ilang),membyt)
    ie = bytpnt(run_address(2,ccomm%ilang),membyt)
    call sub_program (membyt(ip),line,command,error,membyt(ie))
    if (error) return
    error = sic_ctrlc()
    if (error) return
  enddo
  !
end subroutine exec_adjust
!
recursive subroutine sub_program(sub,line,command,error,problem)
  use sic_interfaces
  use sic_runs
  use gbl_message
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! This subroutine executes the call to the command dispatching
  ! routine for a specific language. It also calls the problem
  ! specific routine.
  !---------------------------------------------------------------------
  external                        :: sub      ! Subroutine to call intent(in)
  character(len=*), intent(in)    :: line     ! Command line
  character(len=*), intent(in)    :: command  ! Command name
  logical,          intent(inout) :: error    ! Error flag
  logical, external               :: problem  ! Test error function intent(in)
  ! Local
  integer :: i
  character(len=message_length) :: mess
  !
  ! Increment nesting level and optionally printout call stack
  if (debug_mode .and. sic_icall.gt.0) then
    write (mess,*) 'Nesting ',sic_icall,command,(sic_stack(i),i=sic_icall,1,-1)
    call sic_message(seve%d,'SUB',mess)
  endif
  sic_icall = sic_icall+1
  if (sic_icall.lt.sic_maxlang) sic_stack(sic_icall) = command
  !
  call sub(line,command,error)
  error = error .or. problem()
  ! Decrement nesting level
  sic_icall = sic_icall-1
  !
end subroutine sub_program
!
subroutine exec_string (line,error)
  use sic_interfaces, only : exec_command
  use sic_runs
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Executes a single command. Input line is protected 
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Line to execute
  logical,          intent(inout) :: error  ! Error flag
  !
  character(len=commandline_length) :: local_line
  !
  local_line = line
  call exec_command(local_line,error)
end subroutine exec_string
!
subroutine exec_command(line,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>exec_command
  use sic_runs
  use sic_dictionaries
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (because symbol is used elsewhere)
  ! Executes a single command. Input line is also resolved on output.
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line   ! Line to execute
  logical,          intent(inout) :: error  ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='SIC'
  integer(kind=address_length) :: ip,ie
  integer :: nl
  character(len=command_length) :: command
  !
  ! Analyse line
10 continue
  nl = len_trim(line)
  call sic_blanc(line,nl)
  call sic_analyse(command,line,nl,error)
  if (error) then
    call sic_message(seve%e,rname,'Error interpreting line:')
    call sic_message(seve%e,rname,line(1:nl))
    return
  endif
  !
  ! Support for user languages
  if (languages(ccomm%ilang)%user) then
    ! Command is a user language
    call replace_usercom(languages(ccomm%ilang),command,line,nl,error)
    if (error)  return
    goto 10
  endif
  !
  if (run_address(1,ccomm%ilang).eq.0) then
    call sic_message(seve%f,rname,  &
      trim(ccomm%lang)//'\ language has not been initialized by SIC_BEGIN')
    error = .true.
    return
  endif
  !
  ! Execute line
  ip = bytpnt(run_address(1,ccomm%ilang),membyt)
  ie = bytpnt(run_address(2,ccomm%ilang),membyt)
  call sub_program(membyt(ip),line,command,error,membyt(ie))
  !
end subroutine exec_command
!
subroutine run_sic(line,command,error)
  use sic_interfaces, except_this=>run_sic
  use gbl_message
  use sic_interactions
  use sic_macros_interfaces
  !---------------------------------------------------------------------
  ! @ public-mandatory (public but should probably not) (mandatory
  ! because symbol is used elsewhere)
  ! Execute an elemental SIC command
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line     ! Command line, can be updated on return
  character(len=*), intent(in)    :: command  !
  logical,          intent(out)   :: error    !
  ! Local
  integer :: nline,lire
  !
  error = .false.
  !
  call sic_message(seve%c,'SIC',line)
  !
  ! SIC commands
  select case (command)
  !
  case('ACCEPT')
    call sic_accept(line,error)
  !
  case('COMPUTE')
    nline = len_trim(line)
    call sic_compute(line,nline,error)
  !
  case('DATETIME')
    call sic_datetime(line,error)
  !
  case('DEFINE')
    nline = len_trim(line)
    call sic_define(line,nline,error)
  !
  case('DELETE')
    call sic_delete(line,error)
  !
  case('DIFF')
    call sic_diff(line,error)
  !
  case('EXAMINE')
    call examine_variable(line,error)
  !
  case('EXECUTE')
    call sic_execute(line,error)
  !
  case('HELP')
    call sic_help(line,error)
  !
  case('LET')
    nline = len_trim(line)
    if (lxwindow) then
      call xgag_variable(line,nline,error)
    else
      call let_variable(line,nline,error)
    endif
  !
  case('MESSAGE')
    call sic_message_command(line,error)
  !
  case('MFIT')
    call fit_expression(command,line,error)
  !
  case('MODIFY')
    call sic_modify(line,error)
  !
  case('ON')
    call sic_on(line,error)
  !
  case('IMPORT')
#if defined(GAG_USE_STATICLINK)
    call sic_message(seve%e,'IMPORT','Command is only available when '//  &
    'using shared libraries')
    error = .true.
#else
    call import_package(line,error)
#endif
  !
  case('PYTHON')
    call sic_run_python(line,.false.,error)
    !
  case('PARSE')
    call sic_macros_parse(line,error)
  !
  case('SAY')
    nline = len_trim(line)
    call sicsay(line,nline,error)
  !
  case('SIC')
    lire = 0  ! ???
    call sicset(line,lire,error)
  !
  case('SORT')
    call sicsort(line,error)
  !
  case('SYMBOL')
    nline = len_trim(line)
    call define_symbol(line,nline,error)
  !
  case('SYSTEM')
    call sic_dcl(line,error)
  !
  case ('TIMER')
    call sic_timer(line,error)
  !
  ! Invalid
  case default
    call sic_message(seve%e,'SIC','Command '//trim(command)//' is invalid '// &
    'in this context')
    error = .true.
  end select
  !
end subroutine run_sic
!
function sic_error()
  !---------------------------------------------------------------------
  ! @ private
  ! Default error function
  !---------------------------------------------------------------------
  logical :: sic_error              ! Value on return
  sic_error = .false.
end function sic_error
!
subroutine run_gui(line,command,error)
  use sic_interfaces, except_this=>run_gui
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Execute an elemental GUI command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line     !
  character(len=*), intent(in)    :: command  !
  logical,          intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='GUI'
  !
  call sic_message(seve%c,rname,line)
  !
  if (sic_window) then
    !
    select case (command)
    case('PANEL')
      call xgag_input(line,error)
      !
    case('BUTTON')
      call xgag_comm(line,error)
      !
    case('URI')
      call xgag_uri(line,error)
      !
    case('MENU')
      call xgag_menus(line,error)
      !
    case('SUBMENU')
      call xgag_submenu(line,error)
      !
    case('GO')
      call xgag_go(line,error)
      !
    case('END')
      call xgag_end(0,error)
      call sic_nolog ! Avoid writing it in Stack
      !
    case('ERASE')
      call end_dialog
      !
    case('WAIT')
      call xgag_wait
      call xgag_end(1,error)
      !
    case default
      call sic_message(seve%e,rname,'No code to execute for '//command)
      error = .true.
    end select
    !
  else
    call sic_message(seve%e,rname,  &
      "Command '"//trim(command)//"' invalid in this context")
    error = .true.
  endif
  !
end subroutine run_gui
!
function err_gui()
  !-----------------------------------------------------------------------
  ! @ private
  ! Default error function
  !-----------------------------------------------------------------------
  logical :: err_gui  ! Value en return
  !
  err_gui = .false.
end function err_gui

subroutine greg_convert(line,error)
  use gildas_def
  use phys_const
  use gbl_format
  use gbl_message
  use gwcs_types
  use sic_types
  use greg_dependencies_interfaces, no_interface1=>equ_gal_1d,       &
                                    no_interface2=>gal_equ_1d,       &
                                    no_interface3=>equ_equ_1d,       &
                                    no_interface4=>rel_to_abs_1dn8,  &
                                    no_interface5=>abs_to_rel_1dn8
  use greg_interfaces, except_this=>greg_convert
  use greg_xyz
  use greg_wcs
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !    CONVERT RA0 DEC0 [ANGLE]
  !    1  [/TYPE P_TYPE]
  !    2  [/UNIT]
  !    3  [/SYSTEM EQUATORIAL|GALACTIC [Equinox]]
  !    4  [/VARIABLE A B]
  ! Converts from one projection system or absolute coordinates to the
  ! current projection system.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='CONVERT'
  integer(kind=4) :: nc,ier
  integer(kind=4), parameter :: msys=3
  character(len=13) :: keywor,argum,system(msys)
  character(len=32) :: chra,chdec
  real(kind=8) :: ra,dec,ang
  integer(kind=4) :: nkey,type,nsys
  integer(kind=size_length) :: nn
  integer(kind=address_length) :: ipx,ipy
  character(len=6) :: unit(4)
  character(len=13) :: projnam_array(0:mproj)
  real(kind=4) :: equinox
  character(len=message_length) :: mess
  ! Array support
  type(sic_descriptor_t) :: desc1,desc2
  integer(kind=index_length) :: npx,npy
  integer(kind=4) :: vtype
  character(len=80) :: chain
  logical :: found
  real(kind=8), allocatable :: bufx(:),bufy(:)
  type(projection_t) :: oldproj
  ! Data
  data system /'UNKNOWN','EQUATORIAL','GALACTIC'/
  data unit /'SECOND','MINUTE','DEGREE','RADIAN'/
  !
  if (sic_present(1,0)) then
    call sic_ke (line,1,1,argum,nc,.true.,error)
    if (error) return
    !
    call projnam_list(projnam_array)
    call sic_ambigs('CONVERT',argum,keywor,nkey,projnam_array,mproj+1,error)
    if (error) return
    type = nkey-1
  else
    type = p_none
  endif
  !
  ! Find input System
  if (sic_present(3,0)) then
    if (i_system.le.type_un) then
      call greg_message(seve%e,rname,'Cannot convert to UNKNOWN system')
      error = .true.
      return
    endif
    call sic_ke (line,3,1,argum,nc,.true.,error)
    if (error) return
    call sic_ambigs('CONVERT',argum,keywor,nsys,system,3,error)
    if (error) return
    if (nsys.le.type_un) then
      call greg_message(seve%e,rname,'Cannot convert from UNKNOWN system')
      error = .true.
      return
    endif
    if (nsys.eq.type_eq) then
      equinox = i_equinox_def
      call sic_r4(line,3,2,equinox,.false.,error)
      if (error)  return
    endif
  endif
  !
  ! Find input projection center
  if (type.ne.p_none) then
    ! Declination / latitude
    if (type.ne.p_aitoff) then
      call sic_ch(line,0,2,chdec,nc,.true.,error)
      if (error) return
      call sic_sexa(chdec,nc,dec,error)
      if (error)  return
      dec = dec*pi/180.0d0
    elseif (sic_present(0,2)) then
      call greg_message(seve%w,rname,'Declination ignored in AITOFF')
    endif
    ! Right ascension / longitude
    call sic_ch(line,0,1,chra,nc,.true.,error)
    if (error) return
    call sic_sexa(chra,nc,ra,error)
    if (error)  return
    if (nsys.eq.type_eq) then
      ra = ra*pi/12.0d0
    else
      ra = ra*pi/180.0d0
    endif
    ! Angle
    if (sic_present(0,3)) then
      if (type.eq.p_aitoff) then
        call greg_message(seve%w,rname,'Angle ignored in AITOFF')
      elseif (type.eq.p_radio) then
        call greg_message(seve%w,rname,'Angle ignored in RADIO')
      else
        call sic_r8(line,0,3,ang,.true.,error)
        if (error)  return
        ang = ang*pi/180.0d0
      endif
    else
      ang = 0.d0
    endif
  elseif (sic_present(0,1)) then
    call greg_message(seve%w,rname,'Projection center ignored in /TYPE NONE')
  endif
  !
  ! If option /VAR is present, take it, otherwise work on X and Y
  if (sic_present(4,0)) then
    call sic_ke (line,4,1,chain,nc,.true.,error)
    if (error) return
    found = .true.
    call sic_descriptor (chain,desc1,found)
    if (.not.found) then
      call greg_message(seve%e,rname,'Variable is Unknown')
      error = .true.
      return
    endif
    vtype = desc1%type
    if (desc1%readonly) then
      call greg_message(seve%e,rname,'Variable is Protected')
      error = .true.
      return
    endif
    if (vtype.ne.fmt_r8) then
      call greg_message(seve%e,rname,'Variable must be R*8')
      error = .true.
      return
    endif
    npx = desc_nelem(desc1)
    ipx = gag_pointer(desc1%addr,memory)
    !
    call sic_ke (line,4,2,chain,nc,.true.,error)
    if (error) return
    found = .true.
    call sic_descriptor (chain,desc2,found)
    if (.not.found) then
      call greg_message(seve%e,rname,'Variable is Unknown')
      error = .true.
      return
    endif
    vtype = desc2%type
    if (desc2%readonly) then
      call greg_message(seve%e,rname,'Variable is Protected')
      error = .true.
      return
    endif
    if (vtype.ne.fmt_r8) then
      call greg_message(seve%e,rname,'Variable must be R*8')
      error = .true.
      return
    endif
    npy = desc_nelem(desc2)
    if (npy.ne.npx) then
      call greg_message(seve%e,rname,'Inconsistent sizes')
      error = .true.
      return
    endif
    nn = npx
    ipy = gag_pointer(desc2%addr,memory)
  else
    ipx = gag_pointer(locwrd(column_x),memory)
    ipy = gag_pointer(locwrd(column_y),memory)
    nn=nxy
  endif
  if (nn.le.0) then
    call greg_message(seve%w,rname,'No data points, nothing done')
    return
  endif
  !
  ! Allocate working buffers
  allocate(bufx(nn),bufy(nn),stat=ier)
  if (failed_allocate(rname,'buffers',ier,error))  return
  !
  ! Convert angular unit
  if (sic_present(2,0)) then
    if (sic_present(2,1)) then
      call sic_ke (line,2,1,argum,nc,.false.,error)
      if (error)  goto 100
      call sic_ambigs('CONVERT',argum,keywor,nkey,unit,4,error)
      if (error)  goto 100
    else
      nkey = u_angle
    endif
    if (nkey.ne.u_radian) then
      call r8tor8_sl(memory(ipx),bufx,nn)
      call r8tor8_sl(memory(ipy),bufy,nn)
      call uni_to_rad(bufx,memory(ipx),nn,nkey)
      call uni_to_rad(bufy,memory(ipy),nn,nkey)
    endif
  endif
  !
  ! Convert to absolute coordinates
  if (type.ne.p_none) then
    oldproj = gproj
    call gwcs_projec(ra,dec,ang,type,gproj,error)
    call r8tor8_sl(memory(ipx),bufx,nn)
    call r8tor8_sl(memory(ipy),bufy,nn)
    call rel_to_abs_1dn8(gproj,bufx,bufy,memory(ipx),memory(ipy),nn)
    gproj = oldproj
  endif
  !
  ! Convert to current system
  if (sic_present(3,0)) then
    ! Work only if different systems, or different equinoxes for equatorial systems
    if (nsys.ne.i_system .or.  &
       (nsys.eq.type_eq.and.i_system.eq.type_eq.and.equinox.ne.i_equinox)) then
      !
      ! Sanity check for unimplemented ICRS
      if (i_system.eq.type_ic) then
        call greg_message(seve%e,rname,'Conversion to ICRS is not implemented')
        error = .true.
        return
      elseif (nsys.eq.type_ic) then
        call greg_message(seve%e,rname,'Conversion from ICRS is not implemented')
        error = .true.
        return
      endif
      ! Sanity check for unknown equinox
      if (i_system.eq.type_eq .and. i_equinox.eq.equinox_null) then
        call greg_message(seve%e,rname,  &
          'Can not convert to Equatorial system with unset equinox')
        error = .true.
        return
      elseif (nsys.eq.type_eq .and. equinox.eq.equinox_null) then
        call greg_message(seve%e,rname,  &
          'Can not convert from Equatorial system with unknown equinox')
        error = .true.
        return
      endif
      !
      if (nsys.eq.type_eq) then
        write(mess,'(A,1X,F0.1)') 'Converting from Equatorial',equinox
      else
        write(mess,'(A)')         'Converting from Galactic'
      endif
      nc = len_trim(mess)
      if (i_system.eq.type_eq) then
        write(mess(nc+2:),'(A,1X,F0.1)') 'to Equatorial',i_equinox
      else
        write(mess(nc+2:),'(A)')         'to Galactic'
      endif
      call greg_message(seve%i,rname,mess)
      !
      call r8tor8_sl(memory(ipx),bufx,nn)
      call r8tor8_sl(memory(ipy),bufy,nn)
      if (nsys.eq.type_eq) then
        ! From Nsys=Equatorial+Equinox...
        if (i_system.eq.type_eq) then
          ! ... to I_system=Equatorial+I_Equinox
          call equ_equ_1d(bufx,bufy,equinox,memory(ipx),memory(ipy),i_equinox,nn,error)
        else
          ! ... to I_system=Gal
          call equ_gal_1d(bufx,bufy,equinox,memory(ipx),memory(ipy),nn,error)
        endif
      else
        ! From Nsys=Gal to I_system=Equatorial+I_equinox
        call gal_equ_1d(bufx,bufy,memory(ipx),memory(ipy),i_equinox,nn,error)
      endif
      if (error)  return
    endif
  endif
  !
  ! Convert to offsets in current projection
  if (gproj%type.ne.p_none) then
    call r8tor8_sl(memory(ipx),bufx,nn)
    call r8tor8_sl(memory(ipy),bufy,nn)
    call abs_to_rel_1dn8(gproj,bufx,bufy,memory(ipx),memory(ipy),nn)
  endif
  !
100 continue
  deallocate(bufx,bufy)
end subroutine greg_convert
!
subroutine uni_to_rad(in,out,n,unit)
  use gildas_def
  use gbl_constant
  use phys_const
  use greg_interfaces
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  !---------------------------------------------------------------------
  real(kind=8),              intent(in)  :: in(*)   !
  real(kind=8),              intent(out) :: out(*)  !
  integer(kind=size_length), intent(in)  :: n       !
  integer(kind=4),           intent(in)  :: unit    !
  ! Local
  real(kind=8) :: f
  integer(kind=size_length) :: i
  !
  if (unit.eq.u_second) then
    f = pi/3600.d0/180.d0
  elseif (unit.eq.u_minute) then
    f = pi/60.d0/180.d0
  elseif (unit.eq.u_degree) then
    f = pi/180.d0
  else
    return
  endif
  !
  do i=1,n
    out(i) = in(i)*f
  enddo
end subroutine uni_to_rad
!
subroutine find_blank4(y,bval,eval,nxy,is,ne,in)
  use gildas_def
  use greg_interfaces, except_this=>find_blank4
  !---------------------------------------------------------------------
  ! @ public
  !  Find the next non-blanked interval in array Y
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in)  :: nxy     ! Size of Y
  real(kind=4),              intent(in)  :: y(nxy)  ! Array to be checked against blanking
  real(kind=4),              intent(in)  :: bval    ! Blanking value
  real(kind=4),              intent(in)  :: eval    ! Tolerance
  integer(kind=size_length) :: is                   ! First element
  integer(kind=size_length) :: ne                   ! Number of elements
  integer(kind=size_length) :: in                   ! Start of next interval
  ! Local
  integer(kind=size_length) :: ie
  !
  if (nxy.lt.1) return
  ie = in
  is = in
  do while (.true.)
    !Protect against NaNs
    if (y(ie).eq.y(ie).and.abs(y(ie)-bval).gt.eval) then
      if (ie.eq.nxy) then
        in = 0
        ne = ie-is+1
        return
      endif
      ie = ie+1
    elseif (ie.eq.nxy) then
      in = 0
      ne = ie-is
      return
    elseif (ie.ne.1) then
      in = ie+1
      ne = ie-is
      do while (.not.(y(in).eq.y(in)) .or. abs(y(in)-bval).le.eval)
        if (in.eq.nxy) then
          in = 0
          return
        endif
        in = in+1
      enddo
      return
    else
      is = is+1
      if (nxy.eq.1) then
        in = 0
        ne = 0
        return
      endif
      do while(.not.(y(is).eq.y(is)) .or. abs(y(is)-bval).le.eval)
        if (is.eq.nxy) then
          ne = 0
          in = 0
          return
        endif
        is = is+1
      enddo
      ie = is
    endif
  enddo
end subroutine find_blank4
!
subroutine find_blank8(y,bval,eval,nxy,is,ne,in)
  use gildas_def
  use greg_interfaces, except_this=>find_blank8
  !---------------------------------------------------------------------
  ! @ public-mandatory
  !  Find the next non-blanked interval in array Y
  !---------------------------------------------------------------------
  integer(kind=size_length), intent(in) :: nxy     ! Size of Y
  real(kind=8),              intent(in) :: y(nxy)  ! Array to be checked against blanking
  real(kind=8),              intent(in) :: bval    ! Blanking value
  real(kind=8),              intent(in) :: eval    ! Tolerance
  integer(kind=size_length) :: is                  ! First element
  integer(kind=size_length) :: ne                  ! Number of elements
  integer(kind=size_length) :: in                  ! Start of next interval
  ! Local
  integer(kind=size_length) :: ie
  !
  if (nxy.lt.1) return
  ie = in
  is = in
  do while (.true.)
    !Protect against NaNs
    if (y(ie).eq.y(ie).and.abs(y(ie)-bval).gt.eval) then
      if (ie.eq.nxy) then
        in = 0
        ne = ie-is+1
        return
      endif
      ie = ie+1
    elseif (ie.eq.nxy) then
      in = 0
      ne = ie-is
      return
    elseif (ie.ne.1) then
      in = ie+1
      ne = ie-is
      do while(.not.(y(in).eq.y(in)) .or. abs(y(in)-bval).le.eval)
        if (in.eq.nxy) then
          in = 0
          return
        endif
        in = in+1
      enddo
      return
    else
      is = is+1
      if (nxy.eq.1) then
        in = 0
        ne = 0
        return
      endif
      do while(.not.(y(is).eq.y(is)) .or. abs(y(is)-bval).le.eval)
        if (is.eq.nxy) then
          ne = 0
          in = 0
          return
        endif
        is = is+1
      enddo
      ie = is
    endif
  enddo
end subroutine find_blank8

subroutine gti_flush(output)
  use gtv_dependencies_interfaces
  use gtv_interfaces, except_this=>gti_flush
  use gtv_types
  use gtv_graphic
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !
  !---------------------------------------------------------------------
  type(gt_display) :: output         ! Output instance
  ! Local
  integer :: ier
  !
  ! Close and reopen the output device.
  close(unit=output%iunit)
  !
  open(unit=output%iunit,file=output%file,status='OLD',iostat=ier)
  if (ier.ne.0) then
    call gtv_message(seve%e,'GTFLUSH','Cannot flush graphics device '//  &
    output%file)
    call putios ('E-GTFLUSH,  ',ier)
    call gtx_err
  endif
  !
end subroutine gti_flush
!
subroutine gti_trace(output,trace)
  use gtv_interfaces, except_this=>gti_trace
  use gtv_protocol
  use gtv_types
  !---------------------------------------------------------------------
  ! @ private
  !  Handle traces, if supported by the device
  !---------------------------------------------------------------------
  type(gt_display), intent(in) :: output  ! Output instance
  character(len=*), intent(in) :: trace   ! The message trace
  !
  select case (output%dev%protocol)
  case (p_postscript)
    call ps_trace(trace)
  ! Other protocols: not implemented
  end select
  !
end subroutine gti_trace

program blanking
  use gildas_def
  use image_def
  use gbl_format
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! GILDAS
  !	Main program to change the blanked pixels
  ! Work in place for efficiency
  !---------------------------------------------------------------------
  ! Local
  character(len=filename_length) :: namex,namey
  logical :: error
  integer :: n
  real :: blank(2)
  type(gildas) :: x
  !
  call gildas_open
  call gildas_char('Y_NAME$',namey)
  call gildas_char('X_NAME$',namex)
  call gildas_real('BLANKING$',blank(1),1)
  call gildas_real('TOLERANCE$',blank(2),1)
  call gildas_close
  !
  n = len_trim(namey)
  if (n.eq.0) goto 100
  n = len_trim(namex)
  if (n.eq.0) goto 100
  !
  ! Get a "flat" version of the input data
  call gildas_null(x)
  x%gil%form = fmt_r4
  call gdf_read_gildas(x,namey,'.gdf',error,rank=0)
  if (error) then
    call gagout('F-BLANKING, Cannot read input file')
    goto 100
  endif
  !
  ! Change the blanking
  if (x%gil%blan_words.ne.2 .or. x%gil%eval.lt.0) then
    where (x%r1d.ne.x%r1d) x%r1d = blank(1)
  else
    where (x%r1d.ne.x%r1d) 
      x%r1d = blank(1)
    else where (abs(x%r1d-x%gil%bval).le.x%gil%eval)
      x%r1d = blank(1)
    end where
  endif
  !
  ! Set the header
  x%gil%blan_words = 2
  x%gil%bval = blank(1)
  x%gil%eval = blank(2)
  !
  ! Write the output image
  call sic_parsef(namex,x%file,' ','.gdf') 
  call gdf_write_image(x,x%r1d,error)
  if (error) goto 100
  call gagout('I-BLANKING, Successful completion') 
  call sysexi(1)
  !
100 call sysexi(fatale)
end program blanking

subroutine evaluate_tree(operand,tree,last_node,max_level,min_level,result,  &
  type,err)
  use gildas_def
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>evaluate_tree
  use sic_dictionaries
  use sic_expressions
  use sic_interactions
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Transforms tree into result. Each node of the tree
  !       contains:
  !       - level of the node
  !       - code of operator
  !       - pointer to previous node
  !       - pointer to next node
  !       - number of associated operands
  !       - for each operand a pointer to operand descriptor
  !
  ! Arguments:
  !       TREE            I       Tree structure                  Input
  !       LAST_NODE       I       Pointer to last node in tree    Input
  !       MAX_LEVEL       I       Maximum parenthesis level       Input
  !       RESULT          I       Descriptor of Result            Input
  !       TYPE            I       Type of RESULT                  Output
  !       ERR             L       Logical error flag              Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input)
  integer :: tree(formula_length*2)             !
  integer :: last_node                      !
  integer :: max_level                      !
  integer :: min_level                      !
  type(sic_descriptor_t) :: result          !
  integer :: type                           !
  logical :: err                            !
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: i
  character(len=message_length) :: mess
  !
  ! Setup output descriptor
  ! The COMPLETE output descriptor must be set from 1 to 9 (STATUS)
  operand(0) = result
  call do_tree(operand,tree,last_node,max_level,min_level,type,err)
  !
  ! Free everything (in principle, no scratch status remains,
  ! except for NOP operations
  do i=1,maxoper
    if (operand(i)%status.eq.free_operand) then
      call free_vm (operand(i)%size,operand(i)%addr)
      !
    elseif (operand(i)%status.eq.scratch_operand) then
      if (.not.err) then
        write(mess,101) 'Scratch operand remaining ',i
        call sic_message(seve%w,rname,mess)
      endif
      call free_vm (operand(i)%size,operand(i)%addr)
      !
    elseif (operand(i)%status.eq.interm_operand) then
      if (operand(i)%addr.ne.operand(0)%addr) then
        if (.not.err) then
          write(mess,101) 'Lost intermediate result ',i
          call sic_message(seve%e,rname,mess)
          call sic_message(seve%e,rname,'Please submit an SPR')
        endif
        call free_vm (operand(i)%size,operand(i)%addr)
      endif
    endif
    operand(i)%status = empty_operand
  enddo
  result%type = operand(0)%type
  result%readonly = operand(0)%readonly
  !
101 format(a,i2,a)
end subroutine evaluate_tree
!
subroutine do_tree(operand,tree,last_node,max_level,min_level,type,err)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_dictionaries
  use sic_expressions
  use sic_types
  use sic_interfaces, except_this=>do_tree, &
                      no_interface1=>sic_descriptor_fill_r41d, &
                      no_interface2=>sic_descriptor_fill_r81d, &
                      no_interface3=>sic_descriptor_fill_i41d, &
                      no_interface4=>sic_descriptor_fill_i81d, &
                      no_interface5=>sic_descriptor_fill_c41d, &
                      no_interface6=>sic_descriptor_fill_l1d
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Transforms tree into result. Each node of the tree
  !       contains:
  !       - level of the node
  !       - code of operator
  !       - pointer to previous node
  !       - pointer to next node
  !       - number of associated operands
  !       - for each operand, a pointer to operand descriptor
  !
  ! Arguments:
  !       TREE            I       Tree structure                  Input
  !       LAST_NODE       I       Pointer to last node in tree    Input
  !       MAX_LEVEL       I       Maximum parenthesis level       Input
  !       TYPE            I       Type of RESULT                  Output
  !       ERR             L       Logical error flag              Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input)
  integer :: tree(formula_length*2)             !
  integer :: last_node                      !
  integer :: max_level                      !
  integer :: min_level                      !
  integer :: type                           !
  logical :: err                            !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  logical :: error,unknown
  integer :: level,first_node,l
  integer(kind=size_length) :: neleml,nelem0
  integer(kind=address_length) :: ipntl,ipnt0
  character(len=message_length) :: mess
  !
  ! This flag is set to .TRUE. by default, and cleared if no error occured. If
  ! an error occurs, the routine returns via the handler,
  ! and flag is not cleared.
  if (operand(0)%type.eq.fmt_un) then
    unknown = .true.
    operand(0)%type = fmt_r8
  else
    unknown = .false.
  endif
  err = .true.
  error = .false.
  first_node = 1
  level = max_level
  do while (level.gt.0)
    call execute(operand,tree,first_node,last_node,level,min_level,error)
    if (error) return
  enddo
  !
  ! A few checks on the internal logic (can be removed after extensive testing)
  if (last_node.ne.first_node) then
    call sic_message(seve%e,rname,'First node is not equal to last node')
    error = .true.
  elseif (tree(last_node+2).ne.0 .or. tree(last_node+3).ne.0) then
    error = .true.
  endif
  if (error) then
    call sic_message(seve%e,rname,'Internal logic error in EVALUATE_TREE')
    return
  endif
  l = tree(last_node+5)
  !
  ! To be checked for stupid cases :
  !       A = +1.0        A = +B
  !       A[] = 1         A[] = B[]
  !
  ipntl = gag_pointer(operand(l)%addr,memory)
  ipnt0 = gag_pointer(operand(0)%addr,memory)
  if (operand(l)%type.eq.fmt_r8 .or.  &
      operand(l)%type.eq.fmt_i8 .or.  &
      operand(l)%type.eq.fmt_c4) then
    neleml = operand(l)%size/2
  else
    neleml = operand(l)%size
  endif
  if (operand(0)%type.eq.fmt_r8 .or.  &
      operand(0)%type.eq.fmt_i8 .or.  &
      operand(0)%type.eq.fmt_c4) then
    nelem0 = operand(0)%size/2
  else
    nelem0 = operand(0)%size
  endif
  !
  if (unknown) operand(0)%type = fmt_un
  !
  if (operand(l)%addr.eq.operand(0)%addr) then
    ! Result was assigned
    !
    ! Automatic data type assignment. Note that RESULT can always accomodate
    ! a long-word (Real*8).
    if (operand(0)%type.eq.fmt_un) then
      if (operand(l)%type.eq.fmt_r4 .or. &
          operand(l)%type.eq.fmt_r8 .or. &
          operand(l)%type.eq.fmt_i4 .or.  &
          operand(l)%type.eq.fmt_l) then
        if (neleml.ne.nelem0) then
          write (mess,102) nelem0,neleml
          call sic_message(seve%e,rname,mess)
          return
        endif
      elseif (operand(l)%type.eq.fmt_i8) then
        call sic_message(seve%e,rname,'Long integers not supported (1)')
        return
      elseif (operand(l)%type.eq.fmt_c4) then
        call sic_message(seve%e,rname,'Complex not supported (1)')
        return
      else
        call sic_message(seve%e,rname,'Data type not supported (1)')
        return
      endif
      operand(0)%type = operand(l)%type
      operand(0)%readonly = operand(l)%readonly
    endif
    !
  else
    ! Result was not assigned
    if (operand(0)%type.eq.fmt_un) then
      ! Automatic data type assignment (see SIC_MATH_AUTO). Note that RESULT
      ! can always accomodate a long-word (2 4-bytes words have been
      ! reserved)
      if (operand(l)%type.eq.fmt_r4 .or.  &
          operand(l)%type.eq.fmt_r8 .or.  &
          operand(l)%type.eq.fmt_i4 .or.  &
          operand(l)%type.eq.fmt_i8 .or.  &
          operand(l)%type.eq.fmt_l) then
        if (neleml.ne.nelem0) then
          write (mess,102) nelem0,neleml
          call sic_message(seve%e,rname,mess)
          return
        endif
      elseif (operand(l)%type.eq.fmt_c4) then
        call sic_message(seve%e,rname,'Complex not supported (2)')
        return
      else
        call sic_message(seve%e,rname,'Data type not supported (2)')
        return
      endif
      operand(0)%type = operand(l)%type
      operand(0)%readonly = operand(l)%readonly
      call w4tow4_sl(memory(ipntl),memory(ipnt0),operand(l)%size)
      !
    ! Genuine non-assignment
    elseif (operand(l)%type.eq.fmt_r4) then
      call sic_descriptor_fill_r41d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    elseif (operand(l)%type.eq.fmt_r8) then
      call sic_descriptor_fill_r81d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    elseif (operand(l)%type.eq.fmt_i4) then
      call sic_descriptor_fill_i41d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    elseif (operand(l)%type.eq.fmt_i8) then
      call sic_descriptor_fill_i81d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    elseif (operand(l)%type.eq.fmt_c4) then
      call sic_descriptor_fill_c41d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    elseif (operand(l)%type.eq.fmt_l) then
      call sic_descriptor_fill_l1d(operand(0),memory(ipntl),neleml,error)
      if (error)  return
      !
    else
      call sic_message(seve%e,rname,'Data type not supported (3)')
      return
    endif
    !
    if (operand(l)%status.eq.scratch_operand) operand(l)%status = free_operand
  endif
  type = tree(last_node+5)
  err  = .false.
  !
102 format('Mathematics on arrays of inconsistent dimensions ',i12,i12)
end subroutine do_tree
!
subroutine execute(operand,tree,first_node,last_node,level,min_level,error)
  use sic_interfaces, except_this=>execute
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Executes all operations at level LEVEL
  !
  ! Arguments:
  !       TREE            I       Tree structure                  Input-Output
  !       FIRST_NODE      I       Pointer to first node in tree   Input-Output
  !       LAST_NODE       I       Pointer to last node in tree    Input-Output
  !       LEVEL           I       Parenthesis level               Input-Output
  !---------------------------------------------------------------------
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input-output)
  integer                           :: tree(formula_length*2)  !
  integer                           :: first_node      !
  integer                           :: last_node       !
  integer                           :: level           !
  integer                           :: min_level       !
  logical,            intent(inout) :: error           ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: itree,i,j,next,next_lev
  character(len=message_length) :: mess
  !
  ! Exponentiation is evaluated from right to left, while all other operations are
  ! evaluated from left to right.
  if (mod(level,10).eq.6) then
    itree = last_node
    next  = 2
  else
    itree = first_node
    next  = 3
  endif
  next_lev = 0
  !
  do while (itree.ne.0)
    !
    ! Defer evaluation for lower levels, but keep track of next level
    if (tree(itree).lt.level) then
      next_lev = max(next_lev,tree(itree))
      itree = tree(itree+next)
      ! Higher levels should already have been evaluated. This test can be removed
      ! once the program is reliable.
    elseif (tree(itree).gt.level) then
      write(mess,101) 'Level ',tree(itree),' should already have been evaluated'
      call sic_message(seve%e,rname,mess)
      goto 99
      ! This the right level
    else
      if (tree(itree+4).gt.maxoper) then
        call sic_message(seve%e,rname,'Too many operands in function call')
        goto 99
      endif
      !
      ! Optimize storage
      if (level.eq.min_level) then
        if (tree(itree+next).eq.0) then
          operand(0)%status = free_operand
        endif
      endif
      ! Actual computations
      ! print *, 'Calling DO_CALL'
      call do_call(tree(itree+1),tree(itree+4),tree(itree+5),operand,error)
      ! print *, 'Called DO_CALL'
      if (error) return
      ! Suppress node from chained list:
      ! Clears operator field as a safety (useless, but...).
      !               TREE(ITREE+1) = 0
      !               TREE(ITREE) = 0
      ! - For previous node, new next node is next node of
      !   current node.
      if (itree.ne.first_node) then
        tree(tree(itree+2)+3) = tree(itree+3)
        ! This was the first node: no previous node to update, but FIRST_NODE  changes.
      else
        if ( tree(itree+3).ne.0) then
          first_node = tree(itree+3)
        endif
      endif
      ! - For next node, new previous node is previous node of current node.
      ! This was the last node: no next node to update, but LAST_NODE changes.
      if (itree.eq.last_node) then
        ! This was not also the first one
        if ( tree(itree+2).ne.0) then
          last_node = tree(itree+2)
        endif
        ! This was not the last node. Update next one
      else
        tree(tree(itree+3)+2) = tree(itree+2)
        ! If node had two or more operators and next node had one of its operands (the
        ! first one in practice) equal to second operand of current node, replace it
        ! with first one. To be checked...
        do i=2, tree(itree+4)
          do j=1, tree(tree(itree+3)+4)
            if (tree(itree+4+i) .eq. tree(tree(itree+3)+4+j)) then
              tree(tree(itree+3)+4+j) = tree(itree+5)
            endif
          enddo
        enddo
      endif
      itree = tree(itree+next)
    endif
  enddo
  level = next_lev
  return
  !
99 call sic_message(seve%e,rname,'Internal logic error in EXECUTE')
  error = .true.
  return
  !
101 format(a,i6,a)
end subroutine execute
!
subroutine do_call(code,noper,ioper,operand,error)
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_interactions
  use sic_interfaces, except_this=>do_call
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Evaluate one elementary numerical operation
  !
  ! Arguments:
  !       CODE            I       Code for operation              Input
  !       NOPER           I       Number of operands              Input
  !       IOPER           I       Pointers to operands            Input
  !       ERROR           L       Logical error flag              Output
  ! Written       11-Oct-1987     S.Guilloteau, T.Forveille
  !---------------------------------------------------------------------
  integer :: code                           !
  integer :: noper                          !
  integer :: ioper(noper)                   !
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input-output)
  logical :: error                          !
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: kind(maxoper),i,j,precis
  type(sic_descriptor_t) :: desc
  character(len=message_length) :: mess
  !
  !!Print *,'DO_CALL ',code,noper,(operand(ioper(i))%type,i=1,noper)
  !
  ! Handle dummy nodes
  if (code.eq.code_nop) then
    do i=1,noper
      if (operand(ioper(i))%status.eq.scratch_operand)  &
        operand(ioper(i))%status = free_operand
    enddo
    return
  endif
  !
  ! Handle (some) function nodes
  if (code.eq.code_size) then
    call size_call(noper,ioper,operand,error)
    return
  else if (code.eq.code_index) then
    call index_call(noper,ioper,operand,error) !SG
    return  ! Always    SG
  endif
  !
  ! Check everything is consistent
  do i = 1,noper
    kind(i) = operand(ioper(i))%type
    if ( ((kind(1).gt.0)    .neqv.(kind(i).gt.0)) .or.  &
         ((kind(1).eq.fmt_l).neqv.(kind(i).eq.fmt_l)) ) then
      call sic_message(seve%e,rname,'Inconsistent mixture of Arithmetic, '//  &
      'Logic and Character expressions')
      write(mess,101) (kind(j),j=1,i)
      call sic_message(seve%e,rname,mess)
      error = .true.
      return
    endif
  enddo
  !
  if (kind(1).gt.0) then
    call char_call(code,noper,ioper,operand,error)
  elseif (kind(1).eq.fmt_l) then
    call logic_call(code,noper,ioper,operand,error)
  else                         ! Operation with numerical inputs
    if (code.le.code_not) then
      call sic_message(seve%e,rname,'Logical operator with numerical arguments')
      error = .true.
      return
    endif
    ! Determine precision used for intermediate result
    if (sicprecis.ne.0) then
      precis = sicprecis
    else
      call get_precis(kind,noper,precis,error)
      if (error) return
    endif
    ! Get an "incarnation" of each operand with the requested precision
    do i=1,noper
      call sic_incarnate(precis,operand(ioper(i)),desc,error)
      if (error) return        ! Not clean...
      ! Free scratch operands if they have been incarnated
      if (desc%addr.ne.operand(ioper(i))%addr) then
        call sic_volatile(operand(ioper(i)))
        operand(ioper(i)) = desc
      endif
    enddo
    call numeric_call(code,noper,ioper,operand,error)
  endif
101 format (15(i4))
end subroutine do_call
!
subroutine numeric_call(code,noper,ioper,operand,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>numeric_call
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Evaluate one elementary numerical operation
  !
  ! Arguments:
  !       CODE            I       Code for operation    Input
  !       NOPER           I       Number of operands    Input
  !       IOPER           I       Pointers to operands  Input
  !       ERROR           L       Logical error flag    Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  integer :: code                           !
  integer :: noper                          !
  integer :: ioper(noper)                   !
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input-output)
  logical :: error                          !
  ! Global
  integer :: lsic_d_eq,lsic_s_eq,lsic_i_eq
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: i,iresul,form,rform,fcode,size
  integer(kind=size_length) :: k,dim1,dil
  integer :: isgood
  logical :: lop
  integer(kind=address_length) :: ipnt1,ipnt2,ipntr,ipntf
  character(len=message_length) :: mess
  !
  ! Static storage ?
  save ipnt1,ipnt2,ipntr,ipntf
  !
  ! Get the format of operations (FORM)
  if (operand(ioper(1))%type.eq.fmt_r4) then
    fcode = 0
    form = fmt_r4
    size = 1
  elseif (operand(ioper(1))%type.eq.fmt_r8) then
    fcode = 1
    form = fmt_r8
    size = 2
  elseif (operand(ioper(1))%type.eq.fmt_i8) then
    fcode = 2
    form = fmt_i8
    size = 2
  else
    call sic_message(seve%e,rname,'Internal error: unsupported precision')
    error = .true.
    return
  endif
  !
  ! Get the format of result (RFORM)
  dil = 0
  rform = form
  if (code.ge.code_ne .and. code.le.code_gt) then
    rform = fmt_l
    if (code.eq.code_ne .or. code.eq.code_eq)  dil = operand(0)%size
  endif
  !
  if (dil.eq.1) then
    !
    ! Check identity of two arrays
    dim1 = operand(ioper(1))%size
    if ( dim1.ne.operand(ioper(2))%size ) then
      call sic_message(seve%e,rname,'Comparing arrays of inconsistent '//  &
      'dimensions')
      error = .true.
      return
    endif
    !
    ! Allocate, compute and assign result
    call get_resu (rform,dil,noper,ioper,operand,iresul,error)
    if (error) return
    ipnt1 = gag_pointer(operand(ioper(1))%addr,memory)
    ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
    if (form.eq.fmt_r8) then
      dim1 = dim1/2
      isgood = lsic_d_eq (dil,lop,dim1,memory(ipnt1),dim1,memory(ipnt2))
    elseif (form.eq.fmt_r4) then
      isgood = lsic_s_eq (dil,lop,dim1,memory(ipnt1),dim1,memory(ipnt2))
    elseif (form.eq.fmt_i8) then
      dim1 = dim1/2
      isgood = lsic_i_eq (dil,lop,dim1,memory(ipnt1),dim1,memory(ipnt2))
    endif
    if (code.eq.code_ne) lop = .not.lop
    ipntr = gag_pointer(operand(iresul)%addr,memory)
    call l4tol4_sl(lop,memory(ipntr),dil)
    !
  else
    !
    ! True arithmetic or element by element logic
    !
    ! Check size
    dim1 = 1
    do i=1,noper
      k = operand(ioper(i))%size/size
      if (k.ne.dim1) then
        if (k.ne.1 .and. dim1.ne.1) then
          write(mess,*) 'Mathematics on arrays of inconsistent dimensions ',  &
          k,dim1
          call sic_message(seve%e,rname,mess)
          error = .true.
          return
        elseif (k.ne.1) then
          dim1 = k
        endif
      endif
    enddo
    !
    ! Allocate the result (with RFORM format)
    call get_resu (rform,dim1,noper,ioper,operand,iresul,error)
    if (error) return
    !
    ! Compute the result (with FORM arithmetic)
    ! Could use the HPUX/CONVEX code for all cases
    ipntf = bytpnt(addr_function(100*fcode+code),membyt)
    if (code.le.code_scalar) then
      call do_vector (membyt(ipntf),form,dim1,iresul,noper,ioper,operand,  &
      code,error)
    else
      call do_scalar (membyt(ipntf),form,dim1,iresul,noper,ioper,operand,error)
    endif
  endif
  ! print *,'Format ',RFORM,operand(iresul)%type,IRESUL
  !
  ! Free scratch operands & move result to next node (note use
  ! of RFORM, the Result format...)
  call free_oper (rform,dim1,noper,ioper,operand,iresul,error)
end subroutine numeric_call
!
subroutine logic_call(code,noper,ioper,operand,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>logic_call
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Evaluate one elementary logical operation
  !
  ! Arguments:
  !       CODE            I       Code for operation              Input
  !       NOPER           I       Number of operands              Input
  !       IOPER           I       Pointers to operands            Input
  !       ERROR           L       Logical error flag              Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  integer :: code                           !
  integer :: noper                          !
  integer :: ioper(noper)                   !
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input-output)
  logical :: error                          !
  ! Global
  integer :: lsic_l_not,lsic_l_or,lsic_l_and,lsic_l_eq,lsic_l_ne,lsic_l_exist
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer(kind=address_length) :: ipnt1,ipnt2,ipntr
  integer :: iresul,form,isgood,i
  integer(kind=size_length) :: dimr,dim1,k
  character(len=message_length) :: mess
  !
  ! Check for arithmetic operators
  if ( (code.gt.code_eq.or.code.lt.code_nop) .and.  &
       (code.ne.code_exist)                  .and.  &
       (code.ne.code_file)                   .and.  &
       (code.ne.code_function)               .and.  &
       (code.ne.code_all)                    .and.  &
       (code.ne.code_any)                    .and.  &
       (code.ne.code_isnan)                  .and.  &
       (code.ne.code_isnum)                  .and.  &
       (code.ne.code_symbol)  )   then
    write(mess,'(A,I6)') 'Attempted operation is not allowed on logical '//  &
    'operands for operator ',code
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! Check size
  dimr = 1
  do i=1,noper
    k = operand(ioper(i))%size
    if (k.ne.dimr) then
      if (k.ne.1 .and. dimr.ne.1) then
        write (mess,'(A,I3,I3)') 'Mathematics on arrays of inconsistent '//  &
        'dimensions ',k,dimr
        call sic_message(seve%e,rname,mess)
        error = .true.
        return
      elseif (k.ne.1) then
        dimr = k
      endif
    endif
  enddo
  !
  ! Allocate result
  form = fmt_l
  call get_resu (form,dimr,noper,ioper,operand,iresul,error)
  if (error) return
  ipnt1 = gag_pointer(operand(ioper(1))%addr,memory)
  ipntr = gag_pointer(operand(iresul)%addr,memory)
  !
  ! Now compute
  if (code.eq.code_not) then
    if (noper.ne.1) goto 99
    isgood = lsic_l_not (dimr,memory(ipntr),operand(ioper(1))%size,memory(ipnt1))
  elseif (code.eq.code_exist .or.  &
          code.eq.code_file  .or.  &
          code.eq.code_function  .or.  &
          code.eq.code_all   .or.  &
          code.eq.code_any   .or.  &
          code.eq.code_isnum .or.  &
          code.eq.code_isnan .or.  &
          code.eq.code_symbol) then
    ! Just copy the result of the Logical test operation (YES or NO)
    ! to destination...
    dim1 = 1
    isgood = lsic_l_exist (dimr,memory(ipntr),dim1,memory(ipnt1) )
  elseif (code.ge.code_or) then
    !!print *, 'Calling COMPARE operation'
    !!print *,'Operands ',operand(ioper(1))%type,operand(ioper(2))%type,fmt_l
    if (noper.ne.2) goto 99
    ipnt2 = gag_pointer(operand(ioper(2))%addr,memory)
    if (code.eq.code_or) then
      isgood = lsic_l_or (dimr,memory(ipntr),  &
          operand(ioper(1))%size,memory(ipnt1),  &
          operand(ioper(2))%size,memory(ipnt2))
    elseif (code.eq.code_and) then
      isgood = lsic_l_and (dimr,memory(ipntr),  &
          operand(ioper(1))%size,memory(ipnt1),  &
          operand(ioper(2))%size,memory(ipnt2))
    elseif (code.eq.code_ne) then
      isgood = lsic_l_ne (dimr,memory(ipntr),  &
          operand(ioper(1))%size,memory(ipnt1),  &
          operand(ioper(2))%size,memory(ipnt2))
    elseif (code.eq.code_eq) then
      isgood = lsic_l_eq (dimr,memory(ipntr),  &
          operand(ioper(1))%size,memory(ipnt1),  &
          operand(ioper(2))%size,memory(ipnt2))
    else
      goto 99
    endif
    ! print *, 'Done COMPARE operation '
  endif
  !
  ! Free scratch operands
  ! print *, 'Freeing operand'
  call free_oper(form,dimr,noper,ioper,operand,iresul,error)
  ! print *, 'Done Freeing operand'
  return
  !
99 call sic_message(seve%e,rname,'Internal logic error in LOGIC_CALL')
  error = .true.
end subroutine logic_call
!
subroutine char_call(code,noper,ioper,operand,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>char_call
  use gildas_def
  use sic_expressions
  use sic_dictionaries
  use sic_types
  use gbl_message
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Evaluate one elementary character operation
  !
  ! Arguments:
  !       CODE            I       Code for operation              Input
  !       NOPER           I       Number of operands              Input
  !       IOPER           I       Pointers to operands            Input
  !       ERROR           L       Logical error flag              Output
  ! Written       11-Feb-1987     T.Forveille
  !---------------------------------------------------------------------
  integer :: code                           !
  integer :: noper                          !
  integer :: ioper(noper)                   !
  type(sic_descriptor_t) :: operand(0:maxoper)  ! List of operands (input-output)
  logical :: error                          !
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='MTH'
  integer :: iresul,form,i,len1,len2
  integer(kind=size_length) :: dimo(2),dimr,k
  integer(kind=address_length) :: addr1,addr2,ipntr
  logical :: lop
  character(len=message_length) :: mess
  character(len=1024) :: local_line1,local_line2
  !
  ! Check for forbidden operators. Function LEN could be added one day.
  if (code.ne.code_eq .and. code.ne.code_ne) then
    write(mess,'(A,I6)') 'Attempted operation is not allowed on character '//  &
    'operands for operator ',code
    call sic_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  if (noper.ne.2) goto 99
  !
  ! Check size
  dimr = 1  ! Dimension of result
  do i=1,noper
    ! Compute dimension of operands and thus of result. Can not use %size
    ! for the number of elements in array. Recompute them...
    dimo(i) = desc_nelem(operand(ioper(i)))
    if (dimo(i).ne.dimr) then
      if (dimo(i).ne.1 .and. dimr.ne.1) then
        write (mess,'(A,I3,I3)') 'Mathematics on arrays of inconsistent '//  &
        'dimensions ',dimo(i),dimr
        call sic_message(seve%e,rname,mess)
        error = .true.
        return
      elseif (dimo(i).ne.1) then
        dimr = dimo(i)
      endif
    endif
  enddo
  !
  ! Get work space for result
  form = fmt_l
  call get_resu (form,dimr,noper,ioper,operand,iresul,error)
  if (error) return
  !
  len1 = operand(ioper(1))%type
  addr1 = operand(ioper(1))%addr
  len2 = operand(ioper(2))%type
  addr2 = operand(ioper(2))%addr
  ipntr = gag_pointer(operand(iresul)%addr,memory)
  !
  do k=1,dimr
    ! Compute result. Using destoc is probably a huge waste of time
    call destoc(len1,addr1,local_line1)
    call destoc(len2,addr2,local_line2)
    lop = local_line1.eq.local_line2
    if (code.eq.code_ne) lop = .not.lop
    !
    ! Assign to result
    call l4tol4(lop,memory(ipntr),1)
    !
    ! Next element
    if (dimo(1).ne.1) addr1 = addr1+len1
    if (dimo(2).ne.1) addr2 = addr2+len2
    ipntr = ipntr+1  ! Next element in output logical array
  enddo
  !
  ! Free scratch operands
  call free_oper (form,dimr,noper,ioper,operand,iresul,error)
  return
  !
99 call sic_message(seve%e,rname,'Internal logic error in CHAR_CALL')
  error = .true.
end subroutine char_call
!
subroutine size_call(noper,ioper,operand,error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>size_call
  use sic_expressions
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for function SIZE(Var,Dim)
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: noper               ! Number of operators involved
  integer(kind=4),        intent(in)    :: ioper(noper)        ! Pointers to operands
  type(sic_descriptor_t), intent(inout) :: operand(0:maxoper)  !
  logical,                intent(inout) :: error               ! Logical error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: idime,iresul
  integer(kind=size_length), parameter :: one=1
  integer(kind=8) :: value
  integer(kind=address_length) :: ipntr
  !
  ! Foreword: result should be actually integer(kind=size_length) or
  ! integer(kind=index_length), but using integer(kind=8) simplifies
  ! the code.
  !
  ! --- Compute result BEFORE dealing with operands ---
  !
  if (noper.eq.1) then  ! SIZE(VAR)
    ! Return the total number of elements
    value = desc_nelem(operand(ioper(1)))
  else                  ! SIZE(VAR,IDIM)
    ! Get dimension number. Check this operand is scalar!
    if (desc_nelem(operand(ioper(2))).gt.1) then
      call sic_message(seve%e,'SIZE','Dimension operand must be scalar')
      error = .true.
      return
    endif
    call sic_descriptor_getval(operand(ioper(2)),one,idime,error)
    if (error)  return
    ! Number of elements along this dimension
    if (idime.ge.1 .and. idime.le.operand(ioper(1))%ndim) then
      value = operand(ioper(1))%dims(idime)
    else
      value = 0
    endif
  endif
  ! NB: other number of operators already checked and rejected
  !
  ! --- Now save the result ---
  !
  ! Find a place to save the result
  call get_resu(fmt_i8,one,noper,ioper,operand,iresul,error)
  if (error)  return
  !
  ! Copy at correct memory location
  ipntr = gag_pointer(operand(iresul)%addr,memory)
  call i8toi8(value,memory(ipntr),1)
  !
  ! Free scratch operands & move result to next node (note use
  ! of RFORM, the Result format...)
  call free_oper(fmt_i8,one,noper,ioper,operand,iresul,error)
  !
end subroutine size_call
!
subroutine index_call(noper,ioper,operand,error)
  use gbl_format
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>index_call
  use sic_expressions
  use sic_types
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for function INDEX(String,SubStr)
  !---------------------------------------------------------------------
  integer(kind=4),        intent(in)    :: noper               ! Number of operators involved
  integer(kind=4),        intent(in)    :: ioper(noper)        ! Pointers to operands
  type(sic_descriptor_t), intent(inout) :: operand(0:maxoper)  !
  logical,                intent(inout) :: error               ! Logical error flag
  ! Global
  include 'gbl_memory.inc' 
  ! Local
  integer(kind=4) :: iresul
  integer(kind=size_length), parameter :: one=1
  integer(kind=8) :: value
  integer(kind=address_length) :: ipntr, addr1, addr2
  integer :: len1, len2
  character(len=1024) :: local_line1
  character(len=128) :: local_line2
  !
  ! Foreword: result should be actually integer(kind=size_length) or
  ! integer(kind=index_length), but using integer(kind=8) simplifies
  ! the code.
  !
  ! --- Compute result BEFORE dealing with operands ---
  !
  len1 = operand(ioper(1))%type
  addr1 = operand(ioper(1))%addr
  len2 = operand(ioper(2))%type
  addr2 = operand(ioper(2))%addr
  !
  ! Compute result. Using destoc is probably a huge waste of time
  call destoc(len1,addr1,local_line1)
  call destoc(len2,addr2,local_line2)
  value = index(local_line1(1:len1),local_line2(1:len2))
  ! NB: other number of operators already checked and rejected
  !
  ! --- Now save the result ---
  !
  ! Find a place to save the result
  call get_resu(fmt_i8,one,noper,ioper,operand,iresul,error)
  if (error)  return
  !
  ! Copy at correct memory location
  ipntr = gag_pointer(operand(iresul)%addr,memory)
  call i8toi8(value,memory(ipntr),1)
  !
  ! Free scratch operands & move result to next node (note use
  ! of RFORM, the Result format...)
  call free_oper(fmt_i8,one,noper,ioper,operand,iresul,error)
  !
end subroutine index_call
!
subroutine get_precis(kind,noper,precis,error)
  use sic_interfaces, except_this=>get_precis
  use sic_expressions
  use gbl_format
  !---------------------------------------------------------------------
  ! @ private
  !  Determine automatically the precision (format) of elementary
  ! operation result from format of input operands.
  !
  !  fmt_i8 NOT returned in automatic precision (on purpose) because
  ! of the roundings it provides (not suited for scientific
  ! computations)
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: noper        ! Number of operands
  integer(kind=4), intent(in)    :: kind(noper)  ! Format of input operands
  integer(kind=4), intent(out)   :: precis       ! Format of operation results
  logical,         intent(inout) :: error        ! Logical error flag
  ! Local
  integer :: i,dokind
  logical :: dodouble
  !
  ! I*4 < I*8
  !  /\    /\
  ! R*4 < R*8
  !  /\    /\
  ! C*4 < C*8
  !
  dokind = 1  ! 1=inte, 2=float, 3=complex
  dodouble = .false.
  !
  do i=1,noper
    !
    ! Single or double , short or long?
    if (kind(i).eq.fmt_r8 .or.  &
        kind(i).eq.fmt_i8 .or.  &
        kind(i).eq.fmt_c8)      &
      dodouble = .true.
    !
    if (dokind.eq.3)  cycle
    !
    ! Go to floating point computations?
    if (kind(i).eq.fmt_r4.or.kind(i).eq.fmt_r8)  dokind = 2
    if (kind(i).eq.fmt_c4.or.kind(i).eq.fmt_c8)  dokind = 3
    !
  enddo
  !
  if (dokind.eq.1) then  ! Integers
    ! Always use R*8 precision. There is enough precision for I*4 computations,
    ! but not for (large) I*8. Let us live with this for now.
    ! Note that we can not go to I*8 computations as the Sic functions are
    ! not expected to return a float when an integer is given as input (think
    ! about sqrt(2) and look at lsic_i_sqrt where all input and output operands
    ! are integers). This would require refurbishing the whole code...
    precis = fmt_r8
    !
  elseif (dokind.eq.2) then  ! Floats
    if (dodouble) then
      precis = fmt_r8
    else
      precis = fmt_r4
    endif
    !
  elseif (dokind.eq.3) then  ! Complex
    if (dodouble) then
      precis = fmt_c8
    else
      precis = fmt_c4
    endif
  endif
  !
end subroutine get_precis

subroutine gclean_major (rname,method,head,   &
     &    beam,nx,ny,mx,my,            &
     &    dirty,resid,mask,clean,      &
     &    cct_list,siter,miter,limit,niter, &
     &    ms, gauss, cc_scales, tfbeam, wfft,  &
     &    np, primary, weight, othread, iplane)    ! For mosaics
  use gbl_ansicodes
  use imager_interfaces, except_this=>gclean_major
  use gkernel_interfaces
  use image_def
  use gbl_message
  use clean_def
  use clean_default
  use gclean_mod
  use omp_control
  !$  use omp_lib
  !-----------------------------------------------------------------------
  ! @ public-mandatory
  !*
  ! IMAGER -- CLEAN Method GAUSS  -- GCLEAN command  
  !     Multi-Resolution CLEAN - with NS (parameter) scales
  !
  !     Algorithm  
  !     For each iteration, search at which scale the signal to noise
  !     is largest. Use the strongest S/N to determine the "component"
  !     intensity and shape at this iteration.
  !
  !     Restore the ("infinite" resolution) image from the list of location
  !     types, and intensities of the "components"
  !
  !     The noise level at each scale is computed from the Fourier transform
  !     of the smoothed dirty beams, since the FT is the weight distribution
  !     and the noise level is the inverse square root of the sum of the
  !     weights.
  !!
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller name
  type(clean_par), intent(inout) :: method  !! Clean Method parameters
  type(gildas), intent(inout) :: head       !! Unused, but here for consistency...
  real, intent(in)  :: beam(:,:,:)          !! Dirty beams
  integer, intent(in)  :: nx,ny             !! Beam sizes
  integer, intent(in)  :: mx,my             !! Image size
  integer, intent(in) :: np                 !! Number of Pointings
  integer, intent(in)  :: siter             !! Starting Iteration
  integer, intent(in)  :: miter             !! Maximum number of clean components
  integer, intent(out) :: niter             !! Number of found components
  real, intent(in)  :: dirty(:,:)           !! Dirty image
  real, intent(inout) :: resid(:,:)         !! Residual image (initialized to Dirty image)
  real, intent(inout) :: clean(:,:)         !! "CLEAN" image (not convolved yet)
  real, intent(in) :: weight(:,:)           !! Combined weights
  integer, intent(in) :: ms                 !! Number of size scales
  real, intent(in) :: gauss(ms)             !! Size scales
  real, intent(out) :: cc_scales(ms)        !! Flux scaling factor ?
  logical, intent(in)  :: mask(:,:)         !! Search area
  real, intent(in)  :: limit                !! Maximum residual
  real, intent(in)  :: tfbeam(:,:,:)        !! Real Beam FT for final Clean restoration
  real, intent(inout) :: wfft(*)            !! Work space for FFT
  type(cct_lst), intent(inout) :: cct_list  !! Clean Component List
  real, intent(in) :: primary(np, mx, my)   !! Primary beams
  integer, intent(in) :: othread            !! Thread number (for messages and debugging)
  integer, intent(in) :: iplane             !! Current plane number (for messages and debugging)
  !
  ! Local ---
  integer :: dimcum, ncum, nchain
  integer :: kx,ky
  integer :: is,i,j, oldis, goodis, nl
  real, allocatable :: oldcum(:)
  real :: value, converge, sign, lastcum
  real :: maxa, maxp, flux,smooth,gain,maxsn,worry
  logical :: ok, plot, printout, interrupt
  character(len=message_length) :: chain
  character(len=28) :: string
  character(len=32) :: cname
  !
  ! Scales related ones, automatic arrays of small sizes
  real, allocatable :: sn(:)                  ! Signal / Noise 
  real, allocatable :: gains(:)               ! Gain per kernel 
  real, allocatable :: fluxes(:)              ! Cumulative flux per kernel
  integer, allocatable :: ncase(:)            ! Number of components per kernel case
  real, allocatable :: bruit(:)               ! Residual level for each kernel
  integer, allocatable :: ix(:),iy(:)         ! Coordinates of each iteration maximum
  !
  ! Smoothed Dirty images
  real, allocatable ::  gresid(:,:,:)
  !
  integer :: ip                ! Current pointing
  integer :: lx,ly             ! Current pixel and Offset from center
  integer :: counter
  integer :: clean_slow=0      ! Precision and Speed control code (for tests)
  integer :: step_iter         ! Printout every Step_Iter component
  logical :: error, detail
  !
  ! real, allocatable :: lbeam(:,:)  ! Local beam (average of all dirty beams)
  real :: flux_asymptote=0.    ! Asymptotic flux convergence test
  real :: flux_convergence
  integer :: same_scale =0     ! Do we keep same_scale iterations at the Same Scale before changing ?
  logical :: debug=.false.
  logical :: lcl_debug
  logical :: err
  integer :: nnt(3)
  !
  integer :: fs,ls, ncount, mthread
  integer :: ns,js,ks,ier
  !
  type(gildas) :: hdebug        ! Debug header
  real :: fact
  integer :: ng ! Number of sizes
  !
  ! Code ----
  call sic_get_logi('DEBUG',debug,error)
  error = .false.
  !
  if (debug) then
    nnt = [mx,my,1]
    err = .false.
    call v_size_r4_2('DIRTY',dirty,nnt,err)
    call v_size_r4_2('RESID',resid,nnt,err)
    call v_size_r4_2('CLEAN',clean,nnt,err)
    nnt(3) = max(np,1) ! For Mosaics PLEASE CHECK
    call v_size_r4_3('TFBEAM',tfbeam,nnt,err)
    if (np.gt.1) call v_size_r4_2('WEIGHT',weight,nnt,err)
    nnt = [nx,ny,np]
    call v_size_r4_3('BEAM',beam,nnt,err)
    nnt = [nx,ny,3]
    if (err) then
      call map_message(seve%e,rname,'Size error')
      error = .true.
      return
    endif
  endif
  cname = rname
  !
  step_iter = multi_print
  if (multi_print.eq.0) step_iter = 1000
  !
  ! Test Flux stability to 1 Sigma or a user specified fraction of the Maximum (default 1E-4)
  flux_convergence = max(1E-4,method%gain*head%gil%noise/head%gil%rmax)
  call sic_get_real('CLEAN_CONVERGE',flux_convergence,error)
  flux_convergence = head%gil%rmax * flux_convergence  
  error = .false.
  !
  call sic_get_inte('CLEAN_SLOW',clean_slow,error)
  clean_slow = min(clean_slow,3)
  if (clean_slow.lt.0) then
    call map_message(seve%w,cname,'Using approximate MultiScale method - Try CLEAN_SLOW = 0 for better result')
  else if (clean_slow.ne.0) then
    call map_message(seve%w,cname,"Speed set to CLEAN_SLOW "//char(clean_slow+ichar('0')))
  endif
  !
  call sic_get_real('CLEAN_END',flux_asymptote,error)
  call sic_get_inte('GCLEAN_PACK',same_scale,error)
  same_scale = max(0,same_scale)
  !
  dimcum = method%converge
  allocate(oldcum(max(1,dimcum)))
  !
  ! Initialize the Beams
  error = .false.
  call gclean_beams(cname,head,nx,ny,np,ms, gauss,beam, error) ! , gbeam,beamindex,scale)
  if (error) return
  !
  ! Local (per thread) arrays
  allocate(gresid(nx,ny,ms),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Smoothed arrays allocation error')
    error = .true.
    return
  endif  
  !
  allocate(sn(ms),gains(ms),fluxes(ms),ncase(ms),bruit(ms),ix(ms),iy(ms),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Scale arrays allocation error')
    error = .true.
    return
  endif    
  gains(1:ms) = method%gains(1:ms)   ! Now that it is allocated to size MS
  !
  ! Mosaic case still unclear
  do ip=1,np                         ! NP = 1 so far
    gresid(:,:,1) = resid(:,:)       ! Only one beam per field so far 
    call gclean_smooth(head,nx,ny,ms,gauss,gresid) 
  enddo
  !TEST!write(chain,'(A,I0)') 'Done       Smoothed beams for GCLEAN Thread ',othread
  !TEST!call map_message(seve%i,cname,chain)
  !
  smooth = method%smooth
  gain = method%gain
  plot = method%pflux
  printout = method%verbose  .or. debug ! Default behaviour
  worry = method%worry
  !
  ! Debug messages
  if (debug) then
    ng = (ms*(ms+1))/2
    call gildas_null(hdebug)
    call gdf_copy_header(head,hdebug,error)
    hdebug%gil%ndim = 4
    hdebug%gil%dim(3:4) = [ng,np]
    hdebug%gil%convert(:,3) = [1.,1.,1.]
    hdebug%file = 'beams.gdf'
    call gdf_write_image(hdebug,gbeam,error)
    ! For progress files
    hdebug%file = 'progress.gdf'
    hdebug%gil%ndim = 4
    hdebug%gil%dim(3) = ms
  endif
  !
  ! loss = sqrt(scale(1:ms))   ! Sensitivity loss
  !
  interrupt = .false.
  ncase(1:ms) = 0
  fluxes(:) = 0.0
  !
  kx = nx/2+1
  ky = ny/2+1
  ! 
  ! Main clean loop
  niter = siter-1      ! Start at siter
  ok = niter.lt.miter
  flux = 0.0
  lastcum = 0.
  !
  ! Initialize convergence test
  call amaxmask (resid,mask,mx,my,ix(1),iy(1))
  if (resid(ix(1),iy(1)).gt.0.0) then
    sign = 1.0
  else
    sign =-1.0
  endif
  ncum = 1
  converge = 0.0
  oldcum = 0.0
  oldis = 0
  goodis = 1    ! To prevent compiler warning only..
  maxsn = 0     ! Also
  sn =    0     ! Make sure they are all initialized
  counter = 0
  ncount = 0
  if (clean_slow.lt.0) then
    ncount = -clean_slow ! Test
    clean_slow = -2
  endif
  !
  detail = .false.    ! Debug test message
  ns = ms ! Number of scales
  !
  ! scale = 1.0  ! at this stage
  !
  if (debug) then
    if (miter.ne.0) write(hdebug%file,'(A,I0,A)') 'progress-',niter,'.gdf'
    call gdf_write_image(hdebug,gresid,error)
  endif
  fact = 1.0
  !
  ! Main code
  mthread = 1
  !$  lcl_debug = omp_debug
  !$  mthread = omp_get_max_threads()
  !$  if (omp_in_parallel()) then
  !$    if (omp_get_nested()) then
  !$      ! Further optimisation requires to know the number of Outer Threads
  !$      mthread = omp_inner_thread
  !$      if (lcl_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' Inner ',omp_inner_thread
  !$    else
  !$      mthread = 1
  !$      if (lcl_debug) Print *,'Already in parallel mode, Outer THREAD ',omp_outer_thread,' No Inner threads'
  !$    endif
  !$  else
  !$    mthread = omp_inner_thread
  !$    if (omp_get_nested()) then
  !$      if (lcl_debug) Print *,'Activating nesting ',omp_get_max_threads(),' possible, used ',mthread
  !$    else
  !$      if (lcl_debug) Print *,'No parallel, and No nesting either, ',mthread
  !$    endif
  !$  endif
  fs = 1
  ls = ns
  !
  !TEST!write(chain,'(A,I0)') 'Starting   Loop for GCLEAN Thread ',othread
  !TEST!call map_message(seve%i,cname,chain)
  !
  do           ! For ever...
    ! Conceptually, one may stay onto the same scale of a while
    ! based on the Mod(counter, step)
    !
    counter = counter+1
    !
    ! Locate the Clean Component - The Smoothed Beams do not intervene here,
    ! only the Normalized Kernel and Smoothed Mask
    maxa = -1.0
    bruit = 0.
    sn = 0.
    ! 
    ! Search only in the selected scales [fs,ls]
    do is = fs,ls
      call amaxmask (gresid(:,:,is),mask,mx,my,ix(is),iy(is))
      bruit(is) = gresid(ix(is),iy(is),is)
      !
      if (debug) print *,is, 'Bruit ',bruit(is),' Loss ',loss(is)
      sn(is) = abs(bruit(is)*loss(is))
      if (sn(is).gt.maxa) then
        maxa = sn(is)
        goodis = is
      endif
    enddo
    !
    if (debug) then
      write(*,*) 'Good ',goodis,'Bruit ',bruit,' Loss ',loss,' S/N ',sn  !Debug
      if (counter.lt.10) then
        is = goodis
        write(*,*) Counter,is,' IX IY ',ix(is),iy(is),' Resid ',gresid(ix(is),iy(is),is),bruit(is) !Debug
      endif
    endif
    !
    if (niter.lt.siter) maxsn = sn(goodis)
    !
    ! Check criterium
    ok = niter.lt.miter
    ok = ok .and. abs(bruit(1)).ge.limit
    if (.not.ok) exit
    if (sn(goodis).gt.maxsn) then
      if (niter.gt.2) then
        if (debug) write(*,*) 'Stopping by S/N ',sn(:),' Max is ',maxsn,' NITER ',niter
        ok = .false.  ! Stop if S/N has degraded
        exit
      else
        maxsn = sn(goodis)
      endif
    endif
    maxsn = worry*sn(goodis)+(1.0-worry)*maxsn  ! Propagate S/N estimate
    if (debug) write(*,*) 'Counter ',counter,' Maxsn ',maxsn,goodis,sn(goodis)
    !
    niter = niter+1
    if (niter.ge.cct_list%max_size) call cct_list%reallocate()
    !
    value = gains(goodis)*bruit(goodis)
    if (np.gt.1) then
      value = value * weight(ix(goodis),iy(goodis))    ! Convert to Clean component
    endif
    cct_list%cc(niter)%value = value*scale(goodis)     ! Scale the flux  
    cct_list%cc(niter)%ix = ix(goodis)
    cct_list%cc(niter)%iy = iy(goodis)
    cct_list%cc(niter)%size = goodis                   ! Scale size pointer
    cct_list%cur_size = niter
    !
    ! Do not Scale component flux : See Note Later (#1)
    flux = flux + value*scale(goodis)
    !
    ! Check flux stability - Switch to the accurate method when
    ! approaching convergence 
    if (dimcum.ne.0) then
      ! Keep last DIMCUM cumulative fluxes to test convergence
      oldcum(mod(niter,dimcum)+1) = flux
      lastcum = oldcum(mod(niter+1,dimcum)+1)
      converge = sign * (flux - lastcum) 
    endif
    !
    ! Print the new point
    if ((printout.and.(goodis.ne.oldis)).or.(mod(niter,step_iter).eq.0)) then
      select case(ms)
      case(1)
        write(chain,201) niter,ix(goodis),iy(goodis),   &
          &   c_red,sn(1),c_clear,sn(2),bruit(goodis)*loss(goodis)
      case(2)
        if (goodis.eq.1) then
          write(chain,201) niter,ix(goodis),iy(goodis),   &
            &   c_red,sn(1),c_clear,sn(2),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.2) then
          write(chain,202) niter,ix(goodis),iy(goodis),   &
            &   sn(1),c_green,sn(2),c_clear,bruit(goodis)*loss(goodis)
        endif
      case(3)
        if (goodis.eq.1) then
          write(chain,301) niter,ix(goodis),iy(goodis),   &
            &   c_red,sn(1),c_clear,sn(2),sn(3),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.2) then
          write(chain,302) niter,ix(goodis),iy(goodis),   &
            &   sn(1),c_green,sn(2),c_clear,sn(3),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.3) then
          write(chain,303) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),c_blue,sn(3),c_clear,bruit(goodis)*loss(goodis)
        endif
      case(4)
        if (goodis.eq.1) then
          write(chain,401) niter,ix(goodis),iy(goodis),   &
            &   c_red,sn(1),c_clear,sn(2),sn(3),sn(4),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.2) then
          write(chain,402) niter,ix(goodis),iy(goodis),   &
            &   sn(1),c_green,sn(2),c_clear,sn(3),sn(4),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.3) then
          write(chain,403) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),c_blue,sn(3),c_clear,sn(4),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.4) then
          write(chain,404) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),sn(3),c_magenta,sn(4),c_clear,bruit(goodis)*loss(goodis)
        endif
      case(5)
        if (goodis.eq.1) then
          write(chain,501) niter,ix(goodis),iy(goodis),   &
            &   c_red,sn(1),c_clear,sn(2),sn(3),sn(4),sn(5),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.2) then
          write(chain,502) niter,ix(goodis),iy(goodis),   &
            &   sn(1),c_green,sn(2),c_clear,sn(3),sn(4),sn(5),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.3) then
          write(chain,503) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),c_blue,sn(3),c_clear,sn(4),sn(5),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.4) then
          write(chain,504) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),sn(3),c_magenta,sn(4),c_clear,sn(5),bruit(goodis)*loss(goodis)
        elseif (goodis.eq.5) then
          write(chain,505) niter,ix(goodis),iy(goodis),   &
            &   sn(1),sn(2),sn(3),sn(4),c_cyan,sn(5),c_clear,bruit(goodis)*loss(goodis)
        endif
      case default
        write(*,*) "Unknown case ",ms
      end select
      nl = len_trim(chain)
      if (np.gt.1) then
        write(chain(nl+1:),'(1pg11.4)') weight(ix(goodis),iy(goodis))
        nl = nl+11
      endif
      if (nl.ne.0) call map_message(seve%i,cname,chain)
    endif
    ! In all cases
    oldis = goodis
    ncase(goodis) = ncase(goodis)+1
    ! Scale cumulative flux : See Note Later
    fluxes(goodis) = fluxes(goodis) + value*scale(goodis)
    if (plot) then
      is = goodis
      call next_flux90(niter,flux,is)
    endif
    !
    ! Subtract from residual
    !
    maxa = -value*scale(goodis)  ! This is the Clean Component to be subtracted 
    !
    ! Pixel offset in small beam (not in large map)
    kx = ix(goodis)-nx/2-1 
    ky = iy(goodis)-ny/2-1
    lx = ix(goodis)
    ly = iy(goodis)
    !
    ! Finish by Precise mode at end, or stay on the same size for a while...
    if (ns.ne.1) then
      if (flux_asymptote.gt.0.) then
        if (abs((flux-lastcum)/flux).le.flux_asymptote) then
          call map_message(seve%i,cname,'Switching to Point Source mode') 
          ns = 1
          fs = 1
          ls = 1
          oldis = 0
        endif
      else if (same_scale.ne.0) then
        ! Every "same_scale" iteration, go back to all scales.
        ! Otherwise, keep current scale
        if (mod(counter,same_scale).ne.0) then
          fs = oldis
          ls = oldis
        else
          fs = 1
          ls = ns
        endif
      endif
    endif
    !
    ! Remove in all scales
    if (np.eq.1) then
      !
      ! Translate appropriate beam
      do ks=1,ns    ! A priori, only these ones are needed at this stage
        js = beamindex(goodis,ks)
        !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
        !$OMP   &   SHARED(gresid,gbeam)  &
        !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,maxa,js,ks) &
        !$OMP   &   PRIVATE(i,j)
        !$OMP DO COLLAPSE(2)
        do j=max(1,ky+1),min(my,ny+ky)
          do i=max(1,kx+1),min(mx,nx+kx)
            gresid(i,j,ks) = gresid(i,j,ks) + maxa * gbeam(i-kx,j-ky,js,1)
          enddo
        enddo
        !$OMP ENDDO
        !$OMP END PARALLEL
      enddo
      !
      if (debug) then
        if (miter.ne.0) write(hdebug%file,'(A,I0,A)') 'progress-',niter,'.gdf'
        call gdf_write_image(hdebug,gresid,error)
      endif
    else
      ! Approximate code - does not take the non-commuting
      !   Convolution/Attenuation issue correctly, but correct for
      !   Point sources, and self correcting...
      !
      do ks=1,ns    ! NS is the largest scale considered at this stage
        js = beamindex(goodis,ks)
        ! Most efficient
        do ip=1,np
          !
          ! Globally attenuate by primary beam -- There is an issue here
          ! since normally each individual Clean Component should
          ! have a different attenuation
          !
          maxp = maxa * primary(ip,lx,ly)
          !
          !$OMP PARALLEL DEFAULT(none) NUM_THREADS(mthread) &
          !$OMP   &   SHARED(gresid,gbeam,primary,weight) &
          !$OMP   &   SHARED(mx,my,nx,ny,kx,ky,ip,maxp,js,ks) &
          !$OMP   &   PRIVATE(i,j)
          !$OMP DO COLLAPSE(2)
          do j=max(1,ky+1),min(my,ny+ky)
            do i=max(1,kx+1),min(mx,nx+kx)
              gresid(i,j,ks) = gresid(i,j,ks) + &
              & maxp*gbeam(i-kx,j-ky,js,ip)*primary(ip,i,j)*weight(i,j)
            enddo
          enddo
          !$OMP ENDDO
          !$OMP END PARALLEL
        enddo     ! Pointings
      enddo      ! Scales
    endif
    !
    if (dimcum.gt.0) then
      ok = ok.and.(converge.ge.0.0)
      ok = ok.and.(abs(converge).gt.flux_convergence)
    endif
    if (.not.ok) exit
    if (sic_ctrlc()) then
      interrupt = .true.
      exit
    endif
  enddo
  !
  if (niter.eq.miter) then
    string = 'iteration limit'
  else if (sn(goodis).gt.maxsn) then
    write(*,*) 'MaxSN ',maxsn,' current SN ',sn(goodis),' All sn ',sn
    string = 'signal to noise stability'
  else if (dimcum.gt.0.and.(abs(converge).le.flux_convergence) ) then
    write(string,'(A,1PG10.2)') 'Convergence ',flux_convergence ! ' > ',converge
  else if (interrupt) then
    string = 'User ^C interrupt'
  else
    string = 'residual limit'
  endif
  write(chain,100) 'Stopped by ',trim(string),niter,bruit(1),limit
  call map_message(seve%i,cname,chain)
  nchain = 1
  do is=1,ns
    write(chain(nchain:),101) is,ncase(is),fluxes(is)
    nchain = len_trim(chain)+2
  enddo
  call map_message(seve%i,cname,chain)
  !
  ! Done: RESTORATION Process now
  clean = 0.0
  !
  ! If CCT component flux are not scaled, use the Kernel as they are
  ! If they are scaled,  normalize them to 1 back again...
  !
  ! Here they are not scaled (see comment #1 Above)
  !
  do i=1,niter
    is = nint(cct_list%cc(i)%size)          ! Get the size Pointer
    cct_list%cc(i)%size = gauss(is)         ! Set the true Size
  enddo
  !
  method%n_iter = niter
  call clean_make(method,head,clean,cct_list%cc,gauss)
  !TEST!write(chain,'(A,I0)') 'Done       Clean_make for GCLEAN Thread ',othread
  !TEST!call map_message(seve%i,cname,chain)
  !
  ! Final residual
  if (np.eq.1) then
    resid = gresid(:,:,1) 
    clean = clean+resid   
  else  
    ! For mosaic, use the Weight - We already have the Residual here...
    ! resid = dirty-real(cdata)*weight
    ! Convolution with clean beam is done outside (Mosaic ???)
    resid = gresid(:,:,1) 
    clean = clean+resid   
  endif
  !
  deallocate (sn,gains,fluxes,ncase,bruit,ix,iy,stat=ier)
  deallocate (gresid, stat=ier)
  return
  !
  100   format(a,a,i6,1x,1pg11.4,1x,1pg11.4)
  101   format(('#',i0,' Ncct ',i0,' Flux ',1pg11.4))
  !
  201   format(i6,i5,i5,a,' [',1pg11.4,'] ',a,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  202   format(i6,i5,i5,2x,1pg11.4,a,' [',1pg11.4,'] ',a,' = ',   &
     &    1pg11.4,1pg11.4)
  301   format(i6,i5,i5,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  302   format(i6,i5,i5,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  303   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,']',a,' = ',   &
     &    1pg11.4,1pg11.4)
  401   format(i6,i5,i5,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  402   format(i6,i5,i5,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  403   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  404   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,']',a,' = ',   &
     &    1pg11.4,1pg11.4)
  501   format(i6,i5,i5,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,2x,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  502   format(i6,i5,i5,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  503   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,2x,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  504   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,2x,1pg11.4,a,' [',1pg11.4,'] ',a,1pg11.4,'  = ',   &
     &    1pg11.4,1pg11.4)
  505   format(i6,i5,i5,2x,1pg11.4,2x,1pg11.4,2x,1pg11.4,a,2x,1pg11.4,2x,a,' [',1pg11.4,']',a,' = ',   &
     &    1pg11.4,1pg11.4)
end subroutine gclean_major
!  
subroutine gclean_smooth(head,nx,ny,ms,gauss,gbeam,bmax)
  use image_def
  use imager_interfaces, only : mulgau
  use gkernel_interfaces, only : fourt
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !*
  ! IMAGER -- CLEAN Method GAUSS -- GCLEAN command  
  !   Compute smoothed beams or smoothed dirty
  !   Return max value if asked for.
  !!
  !---------------------------------------------------------------------
  type(gildas), intent(in) :: head          !! Image header
  integer, intent(in) :: nx,ny,ms           !! Array sizes)
  real, intent(in)    :: gauss(ms)          !! Smoothing Gaussian in Radians
  real, intent(inout) :: gbeam(:,:,:)       !! Smoothed dirty beams
  real, intent(out), optional :: bmax(ms)   !! Renormalization factor
  !
  ! Local ---
  complex, allocatable :: ft(:,:)
  real, allocatable :: wfft(:)
  integer :: ndim, dim(2)
  integer :: is
  real(4) :: fact
  real(4) :: xinc,yinc
  !
  ! Code ----
  ndim = 2
  dim(1) = nx
  dim(2) = ny
  xinc = head%gil%convert(3,1)
  yinc = head%gil%convert(3,2)
  allocate(ft(nx,ny), wfft(2*max(nx,ny)))
  !
  fact = 1.0/(nx*ny)
  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP & SHARED(ms,dim,ndim,fact,xinc,yinc,nx,ny) &
  !$OMP & SHARED(gbeam,gauss) PRIVATE(ft,wfft,is)
  !
  !$OMP DO
  do is=1,ms
    if (gauss(is).ne.0) then
      !
      ft = cmplx(gbeam(:,:,1),0.0)
      call fourt(ft,dim,ndim,-1,0,wfft)
      !
      ! Beam Area = PI * BMAJ * BMIN / (4 * LOG(2) ) for flux density
      ! normalisation
      ! fact = cmajor*cminor*pi/(4.0*log(2.0))   &
      !     &    /abs(xinc*yinc)/(nx*ny)
      ! For simple FFT normalization
      !D Print *,'Calling MULGAU ',method%major, method%minor, method%angle
      call mulgau(ft,nx,ny,   &
           &    gauss(is),gauss(is),0.0,  &
           &    fact,xinc,yinc,-1)
      !D Print *,'Calling FOURT'
      call fourt(ft,dim,ndim,1,1,wfft)
      !
      gbeam(:,:,is) = real(ft)
    endif
    !Print *,'SCALE ',is,scale(is)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (present(bmax)) then
    bmax(:) = gbeam(nx/2+1,ny/2+1,:)
  endif
end subroutine gclean_smooth
!
subroutine gclean_init
  use gclean_mod
  !! IMAGER - CLEAN Method GAUSS -- GCLEAN command  
  !!  Initialize scale arrays
  if (allocated(beamindex)) then
    deallocate(beamindex, scales, scale, loss, gbeam)
  endif
  !
  n_scales = 0
end subroutine gclean_init
!
subroutine gclean_beams(cname,head,nx,ny,np,ms,gauss,beam,error) !, gbeam,beamindex,scale)
  use image_def
  use imager_interfaces, only : gclean_smooth, map_message
  use gbl_message
  use gclean_mod
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER - CLEAN Method GAUSS -- GCLEAN command  
  !   Compute smoothed beams for all Pointings, and set
  !   the corresponding Scale and Loss factors.
  !*
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: cname !! Callers name
  type(gildas), intent(in) :: head      !! Image header for pixel size
  integer, intent(in) :: nx             !! X size
  integer, intent(in) :: ny             !! Y size
  integer, intent(in) :: np             !! Number of pointings
  integer, intent(in) :: ms             !! Number of scales
  real, intent(in) :: gauss(ms)         !! Scale sizes
  real, intent(in) :: beam(:,:,:)       !! Original dirty beams
  logical, intent(inout) :: error       !! Logical error flag
  !
  ! Local ---
  integer :: ng, is,js, ig,ip, ier
  real, allocatable :: bgauss(:)
  real, allocatable :: bmax(:)
  integer, allocatable :: bi(:)
  integer, allocatable :: bj(:)
  character(len=128) :: chain
  !
  ! Code ----
  if (n_scales.eq.0) then
    continue
  else if (n_scales.ne.ms) then
    Print *,'Scales mismatch ',n_scales, ms
    if (allocated(beamindex)) then
      deallocate(beamindex, scales, scale, loss, gbeam)
      Print *,'Deallocating arrays ...'
    endif
  else if (allocated(beamindex)) then
    return  ! Already computed
  endif
  ng = (ms*(ms+1))/2
  allocate (beamindex(ms,ms),scales(ng,np),scale(ng),loss(ng),gbeam(nx,ny,ng,np), stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Smoothed arrays allocation error')
    error = .true.
    return
  endif 
  !
  allocate(bgauss(ng),bmax(ng),bi(ng),bj(ng))
  !
  ! Double Gaussian Index pointers
  do is=1,ms
    beamindex(1,is) = is
    beamindex(is,1) = is
    bi(is) = is
    bj(is) = is
  enddo
  ig = ms
  do is=2,ms
    do js=is,ms
      ig = ig+1
      beamindex(is,js) = ig
      beamindex(js,is) = ig
      bi(ig) = is
      bj(ig) = js
    enddo
  enddo
  ! Simple & Double Gaussians beam sizes
  do is=1,ms
    do js=is,ms
      ig = beamindex(is,js)
      bgauss(ig) = sqrt(gauss(is)**2+gauss(js)**2)
    enddo
  enddo
  !TEST!write(chain,'(A,I0)') 'Done       Index for GCLEAN Thread ',othread
  !TEST!call map_message(seve%i,cname,chain)
  !
  ! Compute all  Gaussian Smoothed beams
  do ip=1,np
    gbeam(:,:,1,ip) = beam(:,:,ip)    ! Per pointing
    call gclean_smooth(head,nx,ny,ng,bgauss,gbeam(:,:,:,ip),bmax) !
    ! Scales contains the scaling factor of Smoothed beams
    scales(:,ip) = 1./bmax ! That should be IP dependent
  enddo
  !
  ! We need the mean scale and loss over the Mosaic
  scale = 0.
  do ip=1,np
    scale = scale+scales(:,ip)
  enddo
  scale = scale/np
  loss(1:ms) = sqrt(scale(1:ms))
  !
  if (np.eq.1) then
    write(chain,'(A,6(F9.3))') 'Scales     : ',scale(1:ms)
    call map_message(seve%i,cname,chain)
  else
    write(chain,'(A,6(F9.3))') 'Scales     : ',scale(1:ms)
    call map_message(seve%i,cname,chain)
    do ip=1,np
      write(chain,'(A,I0,A,6(F9.3))') 'Scales for field ',ip,'  : ',scales(1:ms,ip)
      call map_message(seve%i,cname,chain)
    enddo
  endif
  write(chain,'(A,6(F9.3))') 'Noise loss : ',loss(1:ms)
  call map_message(seve%i,cname,chain)
  n_scales = ms     ! Needed at end only
  ! 
end subroutine gclean_beams

subroutine sic_directory(line,error)
  use sic_dependencies_interfaces
  use gildas_def
  use sic_types
  use sic_interfaces, except_this=>sic_directory
  use iso_c_binding
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SIC\SIC FIND [Filter [Directory] [LOCAL|GLOBAL RootName]
  ! Define  RootName%NFILE and RootName%FILE variables, either LOCAL
  !   or GLOBAL. Default RootName is DIR. Default status is GLOBAL so far
  !-----------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  !
  ! Local
  integer(kind=4) :: nc
  character(len=filename_length) :: filestring,tmpstring,dirstring
  integer(kind=address_length) :: addr
  type(sic_descriptor_t) :: desc
  type(c_ptr) :: cptr
  integer, pointer :: i1ptr(:)
  logical :: global, found
  integer :: ndir, narg, n, type, i, leng 
  character(len=8) :: ctype
  character(len=32) :: croot
  character(len=128) :: chain
  character(len=filename_length), allocatable :: tmp_file(:)
  integer :: tmp_nfile
  !
  narg = sic_narg(0)
  !
  filestring = '*.*'
  call sic_ch(line,0,2,filestring,nc,.false.,error)
  if (error) return
  !
  if (narg.le.3) then
    global = .true.     ! Change it to .false. if default status LOCAL preferred
    croot = 'DIR'
    n = 3
    ndir = 3
  else
    call sic_findwhich_key('SIC FIND',line,narg-1,global,error)
    if (error) return
    call sic_ke(line,0,narg,croot,n,.true.,error)
    ndir = narg-2
  endif
  !
  if (ndir.gt.2) then
    tmpstring = ' '
    call sic_ch(line,0,ndir,tmpstring,nc,.false.,error)
    if (error) return
    call sic_parse_file(tmpstring,'','',dirstring)  ! Translate Sic logicals and others
  else
    dirstring = ' '
  endif
  !
  ! Delete stuff if it exists
  if (sic_varexist(croot(1:n))) call sic_delvariable(croot(1:n),.false.,error)
  !
  call sic_defstructure(croot(1:n),global,error)
  type = fmt_i4
  call sic_defvariable (type,croot(1:n)//'%NFILE',global,error)
  !
  call gag_directory(dirstring,filestring,tmp_file,tmp_nfile,error)
  if (error) return
  !
  if (tmp_nfile.ne.0) then
    leng = 0
    do i=1,tmp_nfile
      leng = max(leng,len_trim(tmp_file(i)))
    enddo
    write(chain,'(A,I0,A)') croot(1:n)//'%FILE[',tmp_nfile,']'
    call sic_defvariable (leng,chain,global,error)
    !
    ! Copy tmp_ ... to the destination variables
    call sic_descriptor(croot(1:n)//'%NFILE',desc,found)
    call adtoad(desc%addr,cptr,1)
    call c_f_pointer(cptr,i1ptr,[1]) 
    i1ptr(1) = tmp_nfile
    !
    call sic_descriptor(croot(1:n)//'%FILE',desc,found)
    addr = desc%addr
    do i=1,tmp_nfile
      call ctodes(tmp_file(i),leng,addr) 
      addr = addr+leng
    enddo
    deallocate(tmp_file)
  endif
end subroutine sic_directory
!
subroutine sic_which(line,error)
  use sic_interfaces, except_this=>sic_which
  use sic_types
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   SIC\SIC WHICH  Procedure [LOCAL|GLOBAL OutVariable]
  ! Print or Saves the full name of a procedure or file (in case the
  ! filename contains a search path) into OutVariable
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Full filename
  logical, intent(inout) :: error
  !
  character(len=*), parameter :: rname='SIC WHICH '
  character(len=filename_length) :: file
  character(len=varname_length) :: croot
  type(sic_descriptor_t) :: desc
  logical :: global
  logical :: found
  integer :: nc, nf, narg
  character(len=filename_length) :: fich
  !
  narg = sic_narg(0)
  call sic_ch(line,0,2,fich,nf,.true.,error)
  if (error) return
  call find_procedure(fich,file,found)
  if (.not.found) then
    call sic_message(seve%w,rname,'No such procedure '//fich(1:nf))
    return
  endif
  !
  nf = len_trim(file)
  if (narg.le.2) then
    call sic_message(seve%r,rname,file(1:nf))
    return
  endif
  !
  call sic_findwhich_key('SIC WHICH',line,3,global,error)
  call sic_ke(line,0,4,croot,nc,.true.,error)
  if (error) return
  !
  call sic_delvariable(croot,.false.,error)
  !
  ! Re-Create the variable 
  call sic_defvariable (nf,croot,global,error)
  if (error) return
  !
  ! Copy local to variable
  call sic_descriptor(croot(1:nc),desc,found)
  call ctodes(file,nf,desc%addr) 
end subroutine sic_which
!
subroutine sic_findwhich_key(rname,line,iarg,global,error)
  use gbl_message
  use sic_interfaces, only : sic_ke, sic_message
  !--------------------------------------------------------
  !  @ private
  !     Support for SIC FIND and SIC WHICH 
  ! Parse the LOCAL or GLOBAL keyword
  !--------------------------------------------------------
  character(len=*), intent(in) :: rname
  character(len=*), intent(in) :: line
  integer, intent(in) :: iarg
  logical, intent(out) :: global
  logical, intent(inout) :: error
  !
  character(len=8) :: clocal ='LOCAL   '
  character(len=8) :: cglobal='GLOBAL  '
  character(len=16) :: ctype
  integer :: nc
  !
  global = .false.
  !
  call sic_ke(line,0,iarg,ctype,nc,.true.,error)
  if (error) return
  if (nc.le.6) then
    if (ctype(1:nc).eq.clocal(1:nc)) then
      global = .false.
      return
    else if (ctype(1:nc).eq.cglobal(1:nc)) then
      global = .true.
      return
    endif
  endif
  call sic_message(seve%e,rname,'Invalid keyword '//ctype(1:nc))
  error = .true.
end subroutine

*DECK NUMXER
      FUNCTION NUMXER (NERR)
C***BEGIN PROLOGUE  NUMXER
C***PURPOSE  Return the most recent error number.
C***LIBRARY   SLATEC (XERROR)
C***CATEGORY  R3C
C***TYPE      INTEGER (NUMXER-I)
C***KEYWORDS  ERROR NUMBER, XERROR
C***AUTHOR  Jones, R. E., (SNLA)
C***DESCRIPTION
C
C     Abstract
C        NUMXER returns the most recent error number,
C        in both NUMXER and the parameter NERR.
C
C***REFERENCES  R. E. Jones and D. K. Kahaner, XERROR, the SLATEC
C                 Error-handling Package, SAND82-0800, Sandia
C                 Laboratories, 1982.
C***ROUTINES CALLED  J4SAVE
C***REVISION HISTORY  (YYMMDD)
C   790801  DATE WRITTEN
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900402  Added TYPE section.  (WRB)
C   910411  Made user-callable and added KEYWORDS section.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  NUMXER
C***FIRST EXECUTABLE STATEMENT  NUMXER
      NERR = J4SAVE(1,0,.FALSE.)
      NUMXER = NERR
      RETURN
      END

!
subroutine eq_planet(i_planet, s_3, error)
  use ast_astro
  use ast_constant
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !  @ private
  !*
  ! ASTRO
  !
  !  Get Apparent RA and DEC of planet I_PLANET
  !
  ! NOTE:  There is a leftover equivalence to be replaced by Pointers
  !!
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: i_planet    !! Planet "number"
  real(kind=8),    intent(out) :: s_3(3)      !! Ra,Dec source vector
  logical,         intent(out) :: error       !! Logical error flag
  !
  ! Constants
  real(kind=8), external :: sun_distance
  integer(kind=4), parameter :: m_body=9
  integer(kind=4) :: vector(m_body)
  data vector /1, 2, 3, 3, 3, 3, 3, 3, 3/
  ! Local
  real(kind=8) :: x_0(3), x_2(3), v_0(3), v_2(3), result(6), trfm_32(3,3)
  real(kind=8) :: x_3(3), distance
  equivalence (result(1), x_0(1)), (result(4),v_0(1))
  integer(kind=4) :: i
  !
  ! Code ----
  ! Save Current RA & DEC in case
  ra_old=ra
  dec_old=dec
  ! Compute new values
  error = .false.
  call ephsta(vector(i_planet), i_planet, error)
  if (error) return
  !
  ! Get ecliptic J2000 coordinates
  call ephvec(jnow_tdt, 1, result, error)
  !
  ! Get Apparent Horizontal coordinates
  call matvec(x_0, trfm_20, x_2)
  call matvec(v_0, trfm_20, v_2)
  !
  ! Light-time correction
  distance = dsqrt(x_2(1)**2 + x_2(2)**2 + x_2(3)**2)
  do i = 1, 3
    x_2(i) = x_2(i) - distance / light*v_2(i)
  enddo
  s_3(3) = sun_distance(x_2)
  !
  ! Apparent equatorial coordinates (without parallax)
  call transp(trfm_23, trfm_32)
  call matvec(x_2, trfm_32, x_3)
  call spher(x_3, s_3(1:2))
  ra = s_3(1)
  dec = s_3(2)
end subroutine eq_planet
!
subroutine do_astro_time(jutc,jut1,jtdt,error)
  use gbl_message
  use gkernel_interfaces
  use ast_astro
  use ast_constant
  use imager_interfaces, only : oblimo, tsmg 
  !---------------------------------------------------------------------
  ! @ public
  !*
  ! ASTRO -- Ephemeris routine
  !
  !  Compute Earth rotation parameters and related quantities giving  
  !  - orientation of Earth rotation axis in space (i.e. precession and nutation)   
  !  - position angle around this axis (i.e. sidereal time)  
  !  - orientation of the CIO (Conventional International Origin) with respect  
  !	to the Celestial Ephemeris frame (i.e. pole motion)
  !
  !	Earth rotation velocity (J2000.0) = 7.2921151467e-5 rd/s
  !	see Aoki et al. (1982) or Astron. Almanach Suppl. (1984)
  !	if considered constant : error 1.e-8 (i.e. 0.01" after 24 hours)
  !!
  !---------------------------------------------------------------------
  real(kind=8), intent(in) :: jutc              !
  real(kind=8), intent(in) :: jut1              !
  real(kind=8), intent(in) :: jtdt              !
  logical, intent(inout) :: error               !
  !
  real(kind=8), parameter :: ua=149597870.d0 !! Astronomical unit
  ! Local
  real(kind=8) :: dpsi,deps             ! nutation parameters
  real(kind=8) :: gst                   ! Greenwich mean sidereal time (radians)
  real(kind=8) :: epsm
  real(kind=8) :: result(6), angles(6), psi, the, phi, ct, st, mat1(9), mat2(9)
  real(kind=8) :: mat3(9), trfm_24(9), l(2), g(2), x_5(3), v_5(3), s_5(2)
  real(kind=8) :: distance, n
  integer(kind=4) :: i, j
  logical :: first
  character(len=10) :: rname
  ! Data
  data rname /'ASTRO_TIME'/
  data first/.true./
  !------------------------------------------------------------------------
  jnow_utc = jutc
  d_tdt = jtdt
  d_ut1 = jut1
  jnow_tdt = jnow_utc + d_tdt/86400.d0
  jnow_ut1 = jnow_utc + d_ut1/86400.d0
  call qprec (j2000,jnow_utc,angles)  ! compute precession angles
  psi=angles(5)                       ! Euler angles of transformation
  the=angles(4)                       ! mean ecliptic J2000.0 to JNOW
  phi=-angles(6)-angles(5)
  call eulmat (psi,the,phi,mat1)      ! compute matrix
  epsm=oblimo (jnow_utc)              ! mean obliquity at JNOW
  call nuta (jnow_utc,dpsi,deps)      ! compute nutation at JNOW
  psi=-dpsi                           ! Euler angles of transformation
  the=0.d0                            ! mean ecliptic to "true" ecliptic
  phi=0.d0                            ! reference system
  call eulmat (psi,the,phi,mat2)      ! compute matrix
  call mulmat (mat1,mat2,mat3)        ! product MAT2 x MAT1
  psi=0.d0                            ! Euler angles of transformation
  the=-epsm-deps                      ! "true" ecliptic to true equatorial
  phi=0.d0                            ! reference system
  call eulmat (psi,the,phi,mat1)      ! compute matrix
  call mulmat (mat3,mat1,trfm_30)     ! product MAT1 x MAT3
  !
  !  Compute sidereal time
  !  The true sidereal time is equal to the mean sidereal time plus a nutation
  !  correction DPSI * cos (EPSM+DEPS) + terms smaller than 0.003"
  !  (see Guinot's BIH internal note and Aoki + al 1983, Celest. mech. 29, 335).
  !  According to G. Francou one should use DPSI * ( cosEPSM - 1/2 DEPS sinEPSM)
  !  This point has to be checked.
  !  %%% Take DUT1 = UT1 - UTC from TO$DUT	RL 21-oct-85
  !
  gst=tsmg(jnow_ut1)                  ! Greenwich mean ST at UTC=0. (radians)
  gst=gst+dpsi*dcos(epsm+deps)        ! nutation correction (already computed)
  ! East longitude is positive
  lst=gst+ pi/180d0*lonlat(1)         ! Local "true" sidereal time
  if (lst .lt. 0d0) lst = lst + twopi
  if (lst .ge. twopi) lst = lst - twopi
  !
  ! Earth rotation matrix (M43)
  do i=1, 3
    do j=1,3
      trfm_43(i+3*(j-1)) = 0
    enddo
  enddo
  ct = cos(lst)
  st = sin(lst)
  trfm_43(1) = ct
  trfm_43(5) = ct
  trfm_43(4) = st
  trfm_43(2) = - st
  trfm_43(9) = 1.d0
  !
  !  Compute Earth orientation, with respect to the instantaneous axis of rotation
  !  ### Pole motion should be included in TRFM24
  psi=halfpi                   ! 90 degrees
  the=halfpi-pi/180d0*lonlat(2)    ! 90 degrees minus latitude
  phi=-halfpi                  ! -90 degrees
  call eulmat (psi,the,phi,trfm_24)    ! compute transformation matrix
  call mulmat(trfm_43, trfm_24, trfm_23)   ! (M23) = M24 * M43
  call mulmat(trfm_30, trfm_23, trfm_20)   ! M20 = (M23) * M30
  ! Default G and Sun ephemeris ... (Page C24)
  do i=1,2
    n = jnow_tdt-j2000+i-1
    l(i) = mod(280.460d0 + 0.9856474*n + 36000.d0,360.d0)
    g(i) = mod(357.528d0 + 0.9856003*n + 36000.d0,360.d0)
    s_5(1) = (l(i) + 1.915*sin(pi*(g(i))/180.d0) + 0.020*sin(pi*(2*g(i))/  &
             180.0d0))*pi/180.
    s_5(2) = 0.0
    if (i.eq.1) then
      call rect(s_5, x_5)
    else
      call rect(s_5, v_5)
    endif
  enddo
  distance = (1.00014d0-0.01671d0*cos(pi*(g(1))/180.0d0)- 0.00014d0*   &
             cos(pi*(2*g(1))/180.0d0))*ua
  do i=1,3
    v_5(i) = (v_5(i)-x_5(i)) / 86400.d0 * distance
    x_5(i) = x_5(i) * distance
  enddo
  call qprec (jnow_tdt,j2000,angles)   ! compute precession angles
  psi=angles(5)                ! Euler angles of transformation
  the=angles(4)
  phi=-angles(6)-angles(5)
  ! compute matrix from ecl (now) to (R0)
  call eulmat (psi,the,phi,trfm_05)
  call matvec (x_5, trfm_05, xsun_0)
  call matvec (v_5, trfm_05, vg_0) ! use for velocity determination
  do i=1, 3
    xg_0(i) = xsun_0(i)
  enddo
  !
  ! Start ephemeride
  error = .false.
  !
  ! Get Earth motion (/ Sol Sys Barycenter)
  call ephsta (0, 0, error)
  if (error) then
    call astro_message(seve%f,rname,'Error in EPHSTA')
    return
  endif
  call ephvec (jnow_tdt, 1, result, error)
  if (.not.error) then
    do i=1, 3
      xg_0(i) = result(i)
      vg_0(i) = result(i+3)
    enddo
  else
    error = .false.
    call astro_message(seve%w,rname,'Using approximate Earth motion')
  endif
  !
  ! Get Sun position
  call ephsta( 2, 2, error)
  if (error) then
    call astro_message(seve%f,rname,'Error in EPHSTA')
    return
  endif
  !
  ! Get ecliptic J2000 coordinates
  call ephvec(jnow_tdt, 1, result, error)
  if (error) then
    error = .false.
    call astro_message(seve%w,rname,'Using approximate Sun position')
  else
    do i=1, 3
      xsun_0(i) = result(i)
    enddo
  endif
  call matvec(xsun_0, trfm_20, xsun_2)
  nsplot = 0
  !
  !call sunrise(error)
  !sunrise_ut= (mod(jnow_utc+0.5d0,1d0)+(sunriz(1)-lst)/twopi)*24.
  !sunset_ut= (mod(jnow_utc+0.5d0,1d0)+(sunset(1)-lst)/twopi)*24.
  !if (first) then
  !  call sic_def_dble ('SUNSET',sunset_ut,1,1,.true.,error)
  !  call sic_def_dble ('SUNRISE',sunrise_ut,1,1,.true.,error)
  !  first = .false.
  !endif
  !return
end subroutine do_astro_time
!
subroutine cdaten(cdate,ndate,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !  Convert the date '01-JAN-1984' in integers for year, month, and day
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: cdate     !! String date
  integer(kind=4),  intent(out)   :: ndate(3)  !! Integer values
  logical,          intent(inout) :: error     !! Logical error flag
  !
  ! Constants
  character(len=3), parameter :: cm(0:12) = (/ '***','JAN','FEB','MAR',  &
    'APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC' /)
  integer(kind=4), parameter :: cd(0:12) = (/0,31,29,31,30,31,30,31,31, 30,31,30,31/)
  !
  ! Local ---
  character(len=40) :: kdate
  character(len=3) :: m
  integer(kind=4) :: id, iy, im, idate(7), i, idx1, idx2, iend
  !
  ! Code ----
  kdate = cdate
  call sic_upper(kdate)
  iend = lenc(kdate)
  call sic_blanc(kdate, iend)
  if (kdate(1:1) .eq. '*') then
    call utc(idate)
    do i=1, 3
      ndate(i) = idate(i)
    enddo
    return
  endif
  do i=1, iend
    if ((kdate(i:i).lt.'0' .and. kdate(i:i).ne.' ') .or. (kdate(i:i).gt.'9'  &
        .and. kdate(i:i).lt.'A') .or. kdate(i:i).gt.'Z') then
      kdate(i:i) = '-'
    endif
  enddo
  idx1 = index(kdate,'-')
  if (idx1 .le. 1) then
    goto 900
  else
    read(kdate(1:idx1-1),*,err=900) id
    idx2 = idx1 + index(kdate(idx1+1:iend),'-')
    if (idx2.le.idx1+1 .or. idx2.eq.iend) then
      goto 900
    else
      m = kdate(idx1+1:idx2-1)
      do im=1,12
        if (cm(im).eq.m) then
          goto 100
        endif
      enddo
      read(kdate(idx1+1:idx2-1),*,err=900) im
      100         read(kdate(idx2+1:iend),*,err=900) iy
    endif
    if (id.gt.cd(im)) goto 900
  endif
  ndate(1) = iy
  ndate(2) = im
  ndate(3) = id
  return
  !
  ! Wrong date
900  call astro_message(seve%e,'CDATEN','Date conversion error')
  error = .true.
  return
end subroutine cdaten
!
subroutine ndatec(ndate,cdate,error)
  use gbl_message
  !------------------------------------------------------------------------
  !  Convert the integers for year, month, and day into date '01-JAN-1984'
  !------------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: ndate(3)  !! Year Month Day
  character(len=*), intent(out)   :: cdate     !! DD-MMM-YYYY
  logical,          intent(inout) :: error     !! Logical error flag
  !
  ! Local
  character(len=3), parameter :: cm(0:12) = (/ '***','JAN','FEB','MAR',  &
    'APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC' /)
  integer(kind=4) :: ier
  !
  write(cdate,1001,iostat=ier) ndate(3), cm(ndate(2)), ndate(1)
  if (ier.ne.0) then
    call astro_message(seve%e,'NDATEC','Date conversion error')
    error = .true.
    return
  endif
  !
1001  format(i2.2,'-',a3,'-',i4.4)
end subroutine ndatec
!
subroutine ctimen(ctime,ntime,error)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! Converts the TIME '12:34:56.1234' in integers for Hours, Minutes,
  ! Seconds, and milliSeconds
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: ctime     !! Time string
  integer(kind=4),  intent(out)   :: ntime(4)  !! H, M, S and milliSec
  logical,          intent(inout) :: error     !! Logical error flag
  !
  ! Local
  integer(kind=4) :: i, ndate(7), ltime
  real(kind=8) :: tt
  character(len=32) :: chain
  !
  ltime = len_trim(ctime)
  if (ctime(1:ltime).eq.'*') then
    call utc(ndate)            ! get current time
    do i = 1, 4
      ntime(i) = ndate(i+3)
    enddo
    return
  endif
  call sic_sexa (ctime,ltime,tt,error) ! TT in hours
  if (error) then
    call astro_message(seve%e,'CTIMEN','TIME conversion error')
    return
  endif
  if (tt.lt.0 .or. tt.gt.24d0) then
    write(chain,*) tt
    call astro_message(seve%e,'CTIMEN','Invalid time '//ctime(1:ltime)//' = '//chain)
    return
  endif
  ntime(1) = tt
  tt = (tt-ntime(1)) * 60.d0
  ntime(2) = tt
  tt = (tt-ntime(2)) * 60.d0
  ntime(3) = tt
  ntime(4) = (tt - ntime(3)) * 1000.d0
end subroutine ctimen
  !
subroutine ntimec(ntime,ctime,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! Converts the integers for Hours, Minutes, Seconds, milliSeconds to
  ! formatted TIME
  !---------------------------------------------------------------------
  character(len=*), intent(out)   :: ctime     !
  integer(kind=4),  intent(in)    :: ntime(4)  !
  logical,          intent(inout) :: error     !
  ! Local
  integer(kind=4) :: ier
  !
  write(ctime,1001,iostat=ier) ntime
  if (ier.ne.0) then
    call astro_message(seve%e,'NTIMEC','TIME conversion error')
    error = .true.
    return
  endif
1001  format(i2.2,':',i2.2,':',i2.2,'.',i3.3)
end subroutine ntimec
!
subroutine utc(date)
  use gbl_message
  !---------------------------------------------------------------------
  !  Lecture de l'heure du systeme par appel des routines systeme
  ! SIC_DATE en sortie : DATE date gregorienne (year, month, day, hour,
  ! minute, second)
  !---------------------------------------------------------------------
  integer(kind=4), intent(out) :: date(7)  !! Gregorian day
  !
  ! Local
  character(len=*), parameter :: rname='UTC'
  logical :: error
  character(len=30) :: date_chain
  !
  date(:) = 0
  call sic_date(date_chain)
  !
  error = .false.
  call cdaten (date_chain,date(1:3),error)
  if (error)  goto 10
  call ctimen (date_chain(13:),date(4:7),error)
  if (error)  goto 10
  !
  return
  !
10 continue
  call astro_message(seve%e,rname,'Error decoding '''//trim(date_chain)//'''')
end subroutine utc
!
subroutine jdate_to_datetime(jdate,datetime,error)
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! Convert input Julian date to Astro's specific date-time formatted
  ! string e.g.: 
  !    18-JAN-2018 11:03:33.400  
  ! At least 24 characters are needed for the full output string.
  ! However, shorter strings are accepted. Result will be truncated,
  ! this may be useful to get e.g. the leading date part.
  !!
  !---------------------------------------------------------------------
  real(kind=8),     intent(in)    :: jdate     !! Juliean date
  character(len=*), intent(out)   :: datetime  !! Date-Time string
  logical,          intent(inout) :: error     !! Logical error flag
  !
  ! Local ---
  integer(kind=4) :: code(7),nd
  character(len=32) :: chain
  !
  ! Split date into 7 integers
  call jjdate(jdate,code)
  !
  ! Date part
  call ndatec(code(1:3),chain,error)
  if (error)  return
  nd = len_trim(chain)
  ! call sic_blanc(chain,nd)  ! Is this useful?
  !
  ! Time part
  call ntimec(code(4:7),chain(nd+2:),error)
  if (error)  return
  ! nt = len_trim(chain)
  ! call sic_blanc(chain,nt)  ! Is this useful?
  !
  datetime = chain  ! Copy/truncate here
  !
end subroutine jdate_to_datetime

*DECK VNWRMS
      REAL FUNCTION VNWRMS (N, V, W)
C***BEGIN PROLOGUE  VNWRMS
C***SUBSIDIARY
C***PURPOSE  Subsidiary to DEBDF
C***LIBRARY   SLATEC
C***TYPE      SINGLE PRECISION (VNWRMS-S, DVNRMS-D)
C***AUTHOR  (UNKNOWN)
C***DESCRIPTION
C
C   VNWRMS computes a weighted root-mean-square vector norm for the
C   integrator package DEBDF.
C
C***SEE ALSO  DEBDF
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800901  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900328  Added TYPE section.  (WRB)
C***END PROLOGUE  VNWRMS
C
C
CLLL. OPTIMIZE
C-----------------------------------------------------------------------
C THIS FUNCTION ROUTINE COMPUTES THE WEIGHTED ROOT-MEAN-SQUARE NORM
C OF THE VECTOR OF LENGTH N CONTAINED IN THE ARRAY V, WITH WEIGHTS
C CONTAINED IN THE ARRAY W OF LENGTH N..
C   VNWRMS = SQRT( (1/N) * SUM( V(I)/W(I) )**2 )
C-----------------------------------------------------------------------
      INTEGER N, I
      REAL V, W, SUM
      DIMENSION V(*), W(*)
C***FIRST EXECUTABLE STATEMENT  VNWRMS
      SUM = 0.0E0
      DO 10 I = 1,N
 10     SUM = SUM + (V(I)/W(I))**2
      VNWRMS = SQRT(SUM/N)
      RETURN
C----------------------- END OF FUNCTION VNWRMS ------------------------
      END

subroutine greg_arrow(line,error)
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_arrow
  !---------------------------------------------------------------------
  ! @ private
  ! Support file for command
  !   G\ARROW Xref Yref Length Angle [Reference]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  type(sic_descriptor_t) :: xdesc,ydesc,ldesc,adesc
  real(kind=4) :: reference
  !
  ! Retrieve descriptors of arguments (can be explicit scalar value,
  ! scalar variable name, vector variable name).
  call sic_de(line,0,1,xdesc,.true.,error)
  if (error)  goto 10
  call sic_de(line,0,2,ydesc,.true.,error)
  if (error)  goto 10
  call sic_de(line,0,3,ldesc,.true.,error)
  if (error)  goto 10
  call sic_de(line,0,4,adesc,.true.,error)
  if (error)  goto 10
  !
  ! Reference point definition
  reference = 0.5
  call sic_r4(line,0,5,reference,.false.,error)
  if (error)  goto 10
  !
  call greg_arrow_desc(xdesc,ydesc,ldesc,adesc,reference,error)
  if (error)  goto 10
  !
10 continue
  call sic_volatile(xdesc)
  call sic_volatile(ydesc)
  call sic_volatile(ldesc)
  call sic_volatile(adesc)
  !
end subroutine greg_arrow
!
subroutine greg_arrow_desc(xdesc,ydesc,ldesc,adesc,reference,error)
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_arrow_desc
  !---------------------------------------------------------------------
  ! @ private
  ! Incarnate the arguments as R*4
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: xdesc
  type(sic_descriptor_t), intent(in)    :: ydesc
  type(sic_descriptor_t), intent(in)    :: ldesc
  type(sic_descriptor_t), intent(in)    :: adesc
  real(kind=4),           intent(in)    :: reference
  logical,                intent(inout) :: error
  ! Local
  type(sic_descriptor_t) :: xinca,yinca,linca,ainca
  !
  ! Incarnate all arguments as R*4
  call sic_incarnate(fmt_r4,xdesc,xinca,error)
  if (error)  goto 20
  call sic_incarnate(fmt_r4,ydesc,yinca,error)
  if (error)  goto 20
  call sic_incarnate(fmt_r4,ldesc,linca,error)
  if (error)  goto 20
  call sic_incarnate(fmt_r4,adesc,ainca,error)
  if (error)  goto 20
  !
  call greg_arrow_do(xinca,yinca,linca,ainca,reference,error)
  if (error)  goto 20
  !
20 continue
  call sic_volatile(xinca)
  call sic_volatile(yinca)
  call sic_volatile(linca)
  call sic_volatile(ainca)
  !
end subroutine greg_arrow_desc
!
subroutine greg_arrow_do(xdesc,ydesc,ldesc,adesc,reference,error)
  use gbl_message
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>greg_arrow_do
  !---------------------------------------------------------------------
  ! @ private
  ! Incarnate the arguments as R*4
  !---------------------------------------------------------------------
  type(sic_descriptor_t), intent(in)    :: xdesc
  type(sic_descriptor_t), intent(in)    :: ydesc
  type(sic_descriptor_t), intent(in)    :: ldesc
  type(sic_descriptor_t), intent(in)    :: adesc
  real(kind=4),           intent(in)    :: reference
  logical,                intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  ! Local
  character(len=*), parameter :: rname='ARROW'
  integer(kind=size_length) :: nelem(4),ntot
  integer(kind=address_length) :: ipx,ipy,ipl,ipa
  !
  ! Sanity
  nelem(1) = desc_nelem(xdesc)
  nelem(2) = desc_nelem(ydesc)
  nelem(3) = desc_nelem(ldesc)
  nelem(4) = desc_nelem(adesc)
  ntot = maxval(nelem)
  if (any(nelem.ne.1.and.nelem.ne.ntot)) then
    call greg_message(seve%e,rname,'Array mismatch')
    error = .true.
    return
  endif
  !
  ipx = gag_pointer(xdesc%addr,memory)
  ipy = gag_pointer(ydesc%addr,memory)
  ipl = gag_pointer(ldesc%addr,memory)
  ipa = gag_pointer(adesc%addr,memory)
  !
  call greg_arrow_loop(memory(ipx),memory(ipy),memory(ipl),memory(ipa),  &
    nelem,reference,error)
  if (error)  return
  !
end subroutine greg_arrow_do
!
subroutine greg_arrow_loop(xarray,yarray,larray,aarray,nelem,reference,error)
  use gildas_def
  use phys_const
  use greg_dependencies_interfaces
  use greg_interfaces
  use greg_pen
  !---------------------------------------------------------------------
  ! @ no-interface
  !---------------------------------------------------------------------
  real(kind=4),              intent(in)    :: xarray(*)  ! [user]
  real(kind=4),              intent(in)    :: yarray(*)  ! [user]
  real(kind=4),              intent(in)    :: larray(*)  ! [cm]
  real(kind=4),              intent(in)    :: aarray(*)  ! [deg]
  integer(kind=size_length), intent(in)    :: nelem(4)
  real(kind=4),              intent(in)    :: reference
  logical,                   intent(inout) :: error
  ! Local
  integer(kind=size_length) :: ielem
  logical :: many(4)
  real(kind=4) :: xc,yc,length,angle
  real(kind=4) :: xp,yp,x1,y1,x2,y2
  !
  call gtsegm('ARROW',error)
  if (penupd) call setpen(cpen)
  call setdas(1)
  !
  many(:) = nelem(:).gt.1
  do ielem=1,maxval(nelem)
    ! Retrieve the 4 values
    if (many(1)) then
      xc = xarray(ielem)
    else
      xc = xarray(1)
    endif
    if (many(2)) then
      yc = yarray(ielem)
    else
      yc = yarray(1)
    endif
    if (many(3)) then
      length = larray(ielem)
    else
      length = larray(1)
    endif
    if (many(4)) then
      angle = aarray(ielem)*rad_per_deg
    else
      angle = aarray(1)*rad_per_deg
    endif
    !
    ! Convert position (user coordinates) to physical
    call gr4_user_phys (xc,yc,xp,yp,1)
    !
    ! NB: the reference can also go beyond the range [0:1], this means
    ! the reference point is not on the arrow but before or after.
    x1 = xp-length*reference*cos(angle)
    y1 = yp-length*reference*sin(angle)
    !
    x2 = xp+length*(1-reference)*cos(angle)
    y2 = yp+length*(1-reference)*sin(angle)
    !
    call grelocate(x1,y1)
    call garrow2(x2,y2)
  enddo
  !
  call gtsegm_close(error)
  !
end subroutine greg_arrow_loop

subroutine sic_trap
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_trap
  use sic_interactions
  use gbl_message
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !
  !       Abort execution in non-interactive session after any error
  !---------------------------------------------------------------------
  if (inter_state) return
  call sic_message(seve%f,'PAUSE','Session is not interactive')
  call sysexi(fatale)
end subroutine sic_trap
!
subroutine break
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>break
  use gildas_def
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !
  !       Make a PAUSE
  !----------------------------------------------------------------------
  !
  ! Generate a traceback if in interactive mode
  if (nlire.ne.0) then
    if (mlire(nlire).eq.0) then
      call traceback
      return
    endif
  endif
  !
  ! Else pause
  nlire=nlire+1
  if (nlire.gt.maxlev) then
    call sic_message(seve%f,'PAUSE','Level depth too large')
    call sysexi(fatale)
  endif
  ! Set IF block first depth for this level
  if_depth (nlire) = if_current+1
  mlire(nlire)=0
end subroutine break
!
subroutine traceback
  use sic_interfaces, except_this=>traceback
  use sic_macros_interfaces
  use sic_structures
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   Internal routine
  !       Generate traceback information
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='ERROR'
  integer :: i,j,l
  character(len=message_length) :: mess
  !
  do i=nlire-1,2,-1
    l=mlire(i)
    if (l.eq.-1) then
      write(mess,100)
      call sic_message(seve%i,rname,mess)
    elseif (l.le.-2) then
      j = cloop
      do while(j.gt.0)
        write(mess,101) j,indice(j),jloo-firllo(j)
        call sic_message(seve%i,rname,mess)
        j = ploop(j)
      enddo
    elseif (l.eq.0) then
      write(mess,102)
      call sic_message(seve%i,rname,mess)
    else
      write(mess,103) trim(macnam(l)),jmac(l)
      call sic_message(seve%i,rname,mess)
    endif
  enddo
  !
100 format('Called by Program')
101 format('Called by Loop ',i2,' (#',1pg11.4,')',t65,'at line ',i4)
102 format('Called by Pause')
103 format('Called by ',a,1x,'at Line ',i4)
end subroutine traceback
!
subroutine erreur(error,line,nline,lect,err)
  use sic_interfaces, except_this=>erreur
  use sic_macros_interfaces
  use sic_interactions
  use sic_dictionaries
  use gbl_message
  use gbl_ansicodes
  !---------------------------------------------------------------------
  ! @ private
  ! SIC   (Internal routine) Error handler
  !
  ! This routine traps all errors and take appropriate action:
  !  - Generate a PAUSE with traceback (Default)
  !  - or activate an error recovery command defined by the user in
  !    command "ON ERROR Command"
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  ! Logical flag indicating if an error occured
  character(len=*) :: line         ! Command line to be executed     Output
  integer :: nline                 ! Length of line                  Output
  integer :: lect                  ! Level of execution              Input
  logical, intent(out)   :: err    !
  ! Local
  character(len=*), parameter :: rname='ERROR'
  integer :: l,i,lerr,ierr
  logical :: flag
  character(len=message_length) :: mess
  character(len=32) :: eprompt
  integer :: leprompt
  logical :: empty ! In Error Recovery Mode, empty lines reset the Error Prompt
  ! Data
  save flag
  data flag /.false./
  !
  ! Set SIC%ERROR, indicating if last command was a success or not.
  sicvar_error = error
  !
  ! Check wether one is already in error recovery mode (FLAG = .TRUE.)
  err = .false.
  ierr = var_level
  lerr = nerr(ierr)
  if (flag) then
    if (.not.error) then
      !
      ! Else end error recovery mode, since it has been completed successfully
      flag = .false.
      !
      ! ON ERROR QUIT : Stop after one recovery
    elseif (lerr.eq.e_quit) then
      ! print *,'E_QUIT on error '
      line = errcom(ierr)
      nline = 23
      flag = .false.
      error = .true.
      err = .true.
    elseif (lerr.eq.e_retu) then
      ! print *,'E_RETU on error '
      line = errcom(ierr)
      nline = 10
      flag = .false.
      error = .false.
      err = .true.
      !
      ! Avoid infinite loops by Pausing
    elseif (lerr.eq.e_pause) then  ! .AND. VAR_LEVEL.EQ.0) THEN
      line = errcom(ierr)
      nline = 9
      flag = .false.
      error = .true.
      err = .true.
    else
      error = .false.
      flag  = .false.
      write(mess,205)
      call sic_message(seve%i,rname,mess)
      call break
      call sic_trap
    endif
    return
  endif
  !
  ! Any other mode, Return if no error
  if (.not.error) return
  !
  ! Else, generate traceback if needed, and activate error recovery action
  !
  error = .false.
  call delcom  ! Delete pending command lines
  !
  ! NLIRE = 0 means subroutine mode of the SIC monitor
  !
  if (nlire.eq.0) then
    write(mess,204)
    call sic_message(seve%i,rname,mess)
    !
    ! Classical error recovery mode : PAUSE and EDIT if possible
    if (lerr.eq.e_pause) then
      call break
      call sic_trap
      if (edit_mode) then
        call bldprt(nlire)
        call edit_line(line,nline,gprompt,lgprompt)
        lect = 0
        err = .true.
      endif
    elseif (lerr.ne.e_cont) then
      !
      ! Set error recovery mode and define line to be executed
      flag = .true.
      line  = errcom(ierr)
      nline = lerr
      if (lerr.eq.e_quit) then
        nline = 23
      elseif (lerr.eq.e_retu) then
        nline = 10
      else
        nline = lerr
      endif
      err = .true.
    endif
    return
  endif
  !
  ! Any positive value of NLIRE means a level of execution
  !
  ! Signal where the error occured
  l=mlire(nlire)
  if (l.eq.-1) then
    write(mess,200)
    call sic_message(seve%i,rname,mess)
  elseif (l.le.-2) then
    i = cloop
    do while(i.gt.0)
      write(mess,201) i,indice(i),jloo-firllo(i)
      call sic_message(seve%i,rname,mess)
      i = ploop(i)
    enddo
  elseif (l.eq.0) then
    !
    ! No traceback if one was already in interactive mode, and no PAUSE either
    if (lerr.eq.e_pause) then
      call sic_trap
      if (edit_mode) then
        call bldprt(nlire)
        if (.not.history_old_behaviour(0)) then
          if (nlire.le.1) then
            line = ' '
            nline = 0
          endif
        endif
        ! Prompt in Reverse video
        eprompt = trim(c_reverse)//gprompt(1:lgprompt)//trim(c_clear)
        leprompt = len_trim(eprompt)
        empty = .true.
        call getcom(line,nline,l,eprompt,leprompt,err,empty)
        lect = 0
        ! Carry on the error, set the temporary one to .TRUE.
        error = err  
        err = .true.  
      endif
    elseif (lerr.ne.e_cont) then
      flag = .true.
      line  = errcom(ierr)
      nline = lerr
      if (lerr.eq.e_quit) then
        nline = 23
      elseif (lerr.eq.e_retu) then
        nline = 10
      else
        nline = lerr
      endif
      err = .true.
      ! Give feedback to user: we will execute a custom command which he
      ! might understand himself (e.g. "ON ERROR EXIT"...)
      call sic_message(seve%w,rname,'Error trapped on user request: ON ERROR '//line)
    endif
    return
  else
    if (macnam(nmacro).ne.' ') then
      write(mess,203) trim(macnam(nmacro)),jmac(l)
      call sic_message(seve%i,rname,mess)
    endif
  endif
  !
  ! Give the Traceback information
  call traceback
  !
  ! Default error handling PAUSE
  if (lerr.eq.e_pause) then
    call break
    call sic_trap
    if (edit_mode) then
      call bldprt(nlire)
      call edit_line(line,nline,gprompt,lgprompt)
      lect = 0
      err = .true.
    endif
  elseif (lerr.ne.e_cont) then
    !
    ! Set error recovery mode and define line to be executed
    flag = .true.
    line  = errcom(ierr)
    nline = lerr
    if (lerr.eq.e_quit) then
      nline = 23
    elseif (lerr.eq.e_retu) then
      nline = 10
    else
      nline = lerr
    endif
    err = .true.
  endif
  return
  !
200 format('Occured in Program')
201 format('Occured in Loop ',i2,' (#',1pg11.4,')',' at Line ',i4)
203 format('Occured in ',a,' at Line ',i4)
204 format('Occured in Execute mode')
205 format('Occured in Error recovery mode')
end subroutine erreur
!
subroutine sic_on(line,error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>sic_on
  !---------------------------------------------------------------------
  ! @ private
  !  Support routine for command
  !    ON Arg
  !  Disambiguise the first argument.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='ON'
  integer(kind=4), parameter :: nkey=1
  character(len=5), parameter :: keys(nkey) = (/ 'ERROR' /)
  integer(kind=4) :: nc,ikey
  character(len=6) :: argum,key
  !
  call sic_ke(line,0,1,argum,nc,.true.,error)
  if (error) return
  !
  call sic_ambigs(rname,argum,key,ikey,keys,nkey,error)
  if (error)  return
  !
  if (ikey.eq.1) then  ! ERROR
    call seterr(line,error)
    if (error)  return
  else
    call sic_message(seve%e,'ON',trim(key)//' is not implemented')
    error = .true.
    return
  endif
  !
end subroutine sic_on
!
subroutine seterr(line,error)
  use gildas_def
  use gbl_message
  use sic_structures
  use sic_dictionaries
  use sic_interfaces, except_this=>seterr
  !---------------------------------------------------------------------
  ! @ private
  !   Defines the error recovery action by command ON ERROR Command
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=12) :: keyword
  character(len=commandline_length) :: cerr
  integer(kind=4) :: nl,action
  !
  ! Retrieve and analyse the error command line
  if (.not.sic_present(0,2)) then
    ! Select default error recovery mode if no argument is given
    cerr = ' '
    nl = 1
    action = e_pause
    !
  else
    ! Otherwise switch to the alternate error recovery mode
    !
    if (sic_narg(0).eq.2) then
      ! Only a single argument after ON ERROR, can be a double-quoted string
      call sic_ch(line,0,2,cerr,nl,.true.,error)
      if (error)  return
    else
      ! Several arguments after ON ERROR
      cerr = line( sic_start(0,2) : sic_end(0,sic_narg(0)) )
      nl = len_trim(cerr)
    endif
    !
    ! Patch blank after @, if any
    call aroba(cerr,nl,error)
    if (error)  return
    !
    ! Resolve the command
    call sic_find (keyword,cerr,nl,error)
    if (error) return
    !
    ! Catch predefined cases (negative or null codes)
    if (cerr(1:nl).eq.'SIC'//backslash//'CONTINUE') then
      action = e_cont
    elseif (cerr(1:nl).eq.'SIC'//backslash//'QUIT') then
      action = e_quit
      write (cerr,'(A,I2)') 'SIC'//backslash//'RETURN ERROR FROM ',var_level
      nl = 23
    elseif (cerr(1:nl).eq.'SIC'//backslash//'PAUSE') then
      action = e_pause
    elseif (cerr(1:nl).eq.'SIC'//backslash//'RETURN') then
      action = e_retu
    else
      ! Default: any other command, positive code
      action = nl
    endif
  endif
  !
  errcom(var_level) = cerr(1:nl)
  nerr(var_level) = action
  !
end subroutine seterr

!-----------------------------------------------------------------------
! Entry points for SIC_DEF_REAL
!
subroutine sic_def_real_0d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel       ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel,ndim,jdim,readonly,error)
end subroutine sic_def_real_0d_1i4
!
subroutine sic_def_real_0d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel       ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel,ndim,jdim,readonly,error)
end subroutine sic_def_real_0d_1i8
!
subroutine sic_def_real_0d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=4),                intent(in)    :: rel        ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_real_addr(symb,rel,ndim,dim,readonly,error)
end subroutine sic_def_real_0d_nil
!
subroutine sic_def_real_1d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel(:)    ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1),ndim,jdim,readonly,error)
end subroutine sic_def_real_1d_1i4
!
subroutine sic_def_real_1d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel(:)    ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1),ndim,jdim,readonly,error)
end subroutine sic_def_real_1d_1i8
!
subroutine sic_def_real_1d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=4),                intent(in)    :: rel(:)     ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_real_addr(symb,rel(1),ndim,dim,readonly,error)
end subroutine sic_def_real_1d_nil
!
subroutine sic_def_real_2d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_2d_1i4
!
subroutine sic_def_real_2d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_2d_1i8
!
subroutine sic_def_real_2d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=4),                intent(in)    :: rel(:,:)   ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_real_addr(symb,rel(1,1),ndim,dim,readonly,error)
end subroutine sic_def_real_2d_nil
!
subroutine sic_def_real_3d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb        ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim        ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim         ! Dimensions
  logical,          intent(in)    :: readonly    ! Read only?
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_3d_1i4
!
subroutine sic_def_real_3d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb        ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim        ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim         ! Dimensions
  logical,          intent(in)    :: readonly    ! Read only?
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_3d_1i8
!
subroutine sic_def_real_3d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb        ! Variable name
  real(kind=4),                intent(in)    :: rel(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim        ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)   ! Dimensions
  logical,                     intent(in)    :: readonly    ! Read only?
  logical,                     intent(inout) :: error       ! Logical error flag
  !
  call sic_def_real_addr(symb,rel(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_real_3d_nil
!
subroutine sic_def_real_4d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb          ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim          ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim           ! Dimensions
  logical,          intent(in)    :: readonly      ! Read only?
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_4d_1i4
!
subroutine sic_def_real_4d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb          ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim          ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim           ! Dimensions
  logical,          intent(in)    :: readonly      ! Read only?
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_4d_1i8
!
subroutine sic_def_real_4d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb          ! Variable name
  real(kind=4),                intent(in)    :: rel(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim          ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)     ! Dimensions
  logical,                     intent(in)    :: readonly      ! Read only?
  logical,                     intent(inout) :: error         ! Logical error flag
  !
  call sic_def_real_addr(symb,rel(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_real_4d_nil
!
subroutine sic_def_real_5d_1i4(symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb            ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim            ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim             ! Dimensions
  logical,          intent(in)    :: readonly        ! Read only?
  logical,          intent(inout) :: error           ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_5d_1i4
!
subroutine sic_def_real_5d_1i8 (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb            ! Variable name
  real(kind=4),     intent(in)    :: rel(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim            ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim             ! Dimensions
  logical,          intent(in)    :: readonly        ! Read only?
  logical,          intent(inout) :: error           ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_real_addr(symb,rel(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_real_5d_1i8
!
subroutine sic_def_real_5d_nil (symb,rel,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_real
  !  Define a REAL Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb            ! Variable name
  real(kind=4),                intent(in)    :: rel(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim            ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)       ! Dimensions
  logical,                     intent(in)    :: readonly        ! Read only?
  logical,                     intent(inout) :: error           ! Logical error flag
  !
  call sic_def_real_addr(symb,rel(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_real_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_DBLE
!
subroutine sic_def_dble_0d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=8),     intent(in)    :: dble      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble,ndim,jdim,readonly,error)
end subroutine sic_def_dble_0d_1i4
!
subroutine sic_def_dble_0d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=8),     intent(in)    :: dble      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble,ndim,jdim,readonly,error)
end subroutine sic_def_dble_0d_1i8
!
subroutine sic_def_dble_0d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=8),                intent(in)    :: dble       ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble,ndim,dim,readonly,error)
end subroutine sic_def_dble_0d_nil
!
subroutine sic_def_dble_1d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=8),     intent(in)    :: dble(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_1d_1i4
!
subroutine sic_def_dble_1d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  real(kind=8),     intent(in)    :: dble(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_1d_1i8
!
subroutine sic_def_dble_1d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=8),                intent(in)    :: dble(:)    ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble(1),ndim,dim,readonly,error)
end subroutine sic_def_dble_1d_nil
!
subroutine sic_def_dble_2d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_2d_1i4
!
subroutine sic_def_dble_2d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_2d_1i8
!
subroutine sic_def_dble_2d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  real(kind=8),                intent(in)    :: dble(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble(1,1),ndim,dim,readonly,error)
end subroutine sic_def_dble_2d_nil
!
subroutine sic_def_dble_3d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_3d_1i4
!
subroutine sic_def_dble_3d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_3d_1i8
!
subroutine sic_def_dble_3d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb         ! Variable name
  real(kind=8),                intent(in)    :: dble(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim         ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)    ! Dimensions
  logical,                     intent(in)    :: readonly     ! Read only?
  logical,                     intent(inout) :: error        ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_dble_3d_nil
!
subroutine sic_def_dble_4d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_4d_1i4
!
subroutine sic_def_dble_4d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_4d_1i8
!
subroutine sic_def_dble_4d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb           ! Variable name
  real(kind=8),                intent(in)    :: dble(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim           ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)      ! Dimensions
  logical,                     intent(in)    :: readonly       ! Read only?
  logical,                     intent(inout) :: error          ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_dble_4d_nil
!
subroutine sic_def_dble_5d_1i4(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_5d_1i4
!
subroutine sic_def_dble_5d_1i8(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  real(kind=8),     intent(in)    :: dble(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_dble_addr(symb,dble(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_dble_5d_1i8
!
subroutine sic_def_dble_5d_nil(symb,dble,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_dble
  !  Define a DOUBLE Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb             ! Variable name
  real(kind=8),                intent(in)    :: dble(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim             ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)        ! Dimensions
  logical,                     intent(in)    :: readonly         ! Read only?
  logical,                     intent(inout) :: error            ! Logical error flag
  !
  call sic_def_dble_addr(symb,dble(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_dble_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_INTE
!
subroutine sic_def_inte_0d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=4),  intent(in)    :: inte      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte,ndim,jdim,readonly,error)
end subroutine sic_def_inte_0d_1i4
!
subroutine sic_def_inte_0d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=4),  intent(in)    :: inte      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte,ndim,jdim,readonly,error)
end subroutine sic_def_inte_0d_1i8
!
subroutine sic_def_inte_0d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=4),             intent(in)    :: inte       ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte,ndim,dim,readonly,error)
end subroutine sic_def_inte_0d_nil
!
subroutine sic_def_inte_1d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=4),  intent(in)    :: inte(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_1d_1i4
!
subroutine sic_def_inte_1d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=4),  intent(in)    :: inte(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_1d_1i8
!
subroutine sic_def_inte_1d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=4),             intent(in)    :: inte(:)    ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte(1),ndim,dim,readonly,error)
end subroutine sic_def_inte_1d_nil
!
subroutine sic_def_inte_2d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_2d_1i4
!
subroutine sic_def_inte_2d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_2d_1i8
!
subroutine sic_def_inte_2d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=4),             intent(in)    :: inte(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte(1,1),ndim,dim,readonly,error)
end subroutine sic_def_inte_2d_nil
!
subroutine sic_def_inte_3d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_3d_1i4
!
subroutine sic_def_inte_3d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_3d_1i8
!
subroutine sic_def_inte_3d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb         ! Variable name
  integer(kind=4),             intent(in)    :: inte(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim         ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)    ! Dimensions
  logical,                     intent(in)    :: readonly     ! Read only?
  logical,                     intent(inout) :: error        ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_inte_3d_nil
!
subroutine sic_def_inte_4d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_4d_1i4
!
subroutine sic_def_inte_4d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_4d_1i8
!
subroutine sic_def_inte_4d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb           ! Variable name
  integer(kind=4),             intent(in)    :: inte(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim           ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)      ! Dimensions
  logical,                     intent(in)    :: readonly       ! Read only?
  logical,                     intent(inout) :: error          ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_inte_4d_nil
!
subroutine sic_def_inte_5d_1i4(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_5d_1i4
!
subroutine sic_def_inte_5d_1i8(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  integer(kind=4),  intent(in)    :: inte(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_inte_addr(symb,inte(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_inte_5d_1i8
!
subroutine sic_def_inte_5d_nil(symb,inte,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_inte
  !  Define an INTEGER Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb             ! Variable name
  integer(kind=4),             intent(in)    :: inte(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim             ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)        ! Dimensions
  logical,                     intent(in)    :: readonly         ! Read only?
  logical,                     intent(inout) :: error            ! Logical error flag
  !
  call sic_def_inte_addr(symb,inte(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_inte_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_LONG
!
subroutine sic_def_long_0d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=8),  intent(in)    :: long      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long,ndim,jdim,readonly,error)
end subroutine sic_def_long_0d_1i4
!
subroutine sic_def_long_0d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=8),  intent(in)    :: long      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long,ndim,jdim,readonly,error)
end subroutine sic_def_long_0d_1i8
!
subroutine sic_def_long_0d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=8),             intent(in)    :: long       ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_long_addr(symb,long,ndim,dim,readonly,error)
end subroutine sic_def_long_0d_nil
!
subroutine sic_def_long_1d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=8),  intent(in)    :: long(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1),ndim,jdim,readonly,error)
end subroutine sic_def_long_1d_1i4
!
subroutine sic_def_long_1d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  integer(kind=8),  intent(in)    :: long(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1),ndim,jdim,readonly,error)
end subroutine sic_def_long_1d_1i8
!
subroutine sic_def_long_1d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=8),             intent(in)    :: long(:)    ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_long_addr(symb,long(1),ndim,dim,readonly,error)
end subroutine sic_def_long_1d_nil
!
subroutine sic_def_long_2d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_2d_1i4
!
subroutine sic_def_long_2d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_2d_1i8
!
subroutine sic_def_long_2d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  integer(kind=8),             intent(in)    :: long(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_long_addr(symb,long(1,1),ndim,dim,readonly,error)
end subroutine sic_def_long_2d_nil
!
subroutine sic_def_long_3d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_3d_1i4
!
subroutine sic_def_long_3d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_3d_1i8
!
subroutine sic_def_long_3d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb         ! Variable name
  integer(kind=8),             intent(in)    :: long(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim         ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)    ! Dimensions
  logical,                     intent(in)    :: readonly     ! Read only?
  logical,                     intent(inout) :: error        ! Logical error flag
  !
  call sic_def_long_addr(symb,long(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_long_3d_nil
!
subroutine sic_def_long_4d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_4d_1i4
!
subroutine sic_def_long_4d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_4d_1i8
!
subroutine sic_def_long_4d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb           ! Variable name
  integer(kind=8),             intent(in)    :: long(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim           ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)      ! Dimensions
  logical,                     intent(in)    :: readonly       ! Read only?
  logical,                     intent(inout) :: error          ! Logical error flag
  !
  call sic_def_long_addr(symb,long(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_long_4d_nil
!
subroutine sic_def_long_5d_1i4(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_5d_1i4
!
subroutine sic_def_long_5d_1i8(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  integer(kind=8),  intent(in)    :: long(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_long_addr(symb,long(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_long_5d_1i8
!
subroutine sic_def_long_5d_nil(symb,long,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_long
  !  Define a LONG Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb             ! Variable name
  integer(kind=8),             intent(in)    :: long(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim             ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)        ! Dimensions
  logical,                     intent(in)    :: readonly         ! Read only?
  logical,                     intent(inout) :: error            ! Logical error flag
  !
  call sic_def_long_addr(symb,long(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_long_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_CPLX
!
subroutine sic_def_cplx_0d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  complex(kind=4),  intent(in)    :: cplx      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx,ndim,jdim,readonly,error)
end subroutine sic_def_cplx_0d_1i4
!
subroutine sic_def_cplx_0d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  complex(kind=4),  intent(in)    :: cplx      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx,ndim,jdim,readonly,error)
end subroutine sic_def_cplx_0d_1i8
!
subroutine sic_def_cplx_0d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  complex(kind=4),             intent(in)    :: cplx       ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx,ndim,dim,readonly,error)
end subroutine sic_def_cplx_0d_nil
!
subroutine sic_def_cplx_1d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_1d_1i4
!
subroutine sic_def_cplx_1d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_1d_1i8
!
subroutine sic_def_cplx_1d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  complex(kind=4),             intent(in)    :: cplx(:)    ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx(1),ndim,dim,readonly,error)
end subroutine sic_def_cplx_1d_nil
!
subroutine sic_def_cplx_2d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_2d_1i4
!
subroutine sic_def_cplx_2d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_2d_1i8
!
subroutine sic_def_cplx_2d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  complex(kind=4),             intent(in)    :: cplx(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx(1,1),ndim,dim,readonly,error)
end subroutine sic_def_cplx_2d_nil
!
subroutine sic_def_cplx_3d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_3d_1i4
!
subroutine sic_def_cplx_3d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_3d_1i8
!
subroutine sic_def_cplx_3d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb         ! Variable name
  complex(kind=4),             intent(in)    :: cplx(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim         ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)    ! Dimensions
  logical,                     intent(in)    :: readonly     ! Read only?
  logical,                     intent(inout) :: error        ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_cplx_3d_nil
!
subroutine sic_def_cplx_4d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_4d_1i4
!
subroutine sic_def_cplx_4d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_4d_1i8
!
subroutine sic_def_cplx_4d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb           ! Variable name
  complex(kind=4),             intent(in)    :: cplx(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim           ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)      ! Dimensions
  logical,                     intent(in)    :: readonly       ! Read only?
  logical,                     intent(inout) :: error          ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_cplx_4d_nil
!
subroutine sic_def_cplx_5d_1i4(symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_5d_1i4
!
subroutine sic_def_cplx_5d_1i8 (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  complex(kind=4),  intent(in)    :: cplx(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_cplx_addr(symb,cplx(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_cplx_5d_1i8
!
subroutine sic_def_cplx_5d_nil (symb,cplx,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_cplx
  !  Define a COMPLEX Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb             ! Variable name
  complex(kind=4),             intent(in)    :: cplx(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim             ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)        ! Dimensions
  logical,                     intent(in)    :: readonly         ! Read only?
  logical,                     intent(inout) :: error            ! Logical error flag
  !
  call sic_def_cplx_addr(symb,cplx(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_cplx_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_LOGIN
!
subroutine sic_def_login_0d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  logical,          intent(in)    :: logi      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi,ndim,jdim,readonly,error)
end subroutine sic_def_login_0d_1i4
!
subroutine sic_def_login_0d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  logical,          intent(in)    :: logi      ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi,ndim,jdim,readonly,error)
end subroutine sic_def_login_0d_1i8
!
subroutine sic_def_login_0d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  logical,                     intent(in)    :: logi       ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_login_addr(symb,logi,ndim,dim,readonly,error)
end subroutine sic_def_login_0d_nil
!
subroutine sic_def_login_1d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  logical,          intent(in)    :: logi(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1),ndim,jdim,readonly,error)
end subroutine sic_def_login_1d_1i4
!
subroutine sic_def_login_1d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  logical,          intent(in)    :: logi(:)   ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1),ndim,jdim,readonly,error)
end subroutine sic_def_login_1d_1i8
!
subroutine sic_def_login_1d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  logical,                     intent(in)    :: logi(:)    ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_login_addr(symb,logi(1),ndim,dim,readonly,error)
end subroutine sic_def_login_1d_nil
!
subroutine sic_def_login_2d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  logical,          intent(in)    :: logi(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_2d_1i4
!
subroutine sic_def_login_2d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb       ! Variable name
  logical,          intent(in)    :: logi(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim       ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim        ! Dimensions
  logical,          intent(in)    :: readonly   ! Read only?
  logical,          intent(inout) :: error      ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_2d_1i8
!
subroutine sic_def_login_2d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  logical,                     intent(in)    :: logi(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_login_addr(symb,logi(1,1),ndim,dim,readonly,error)
end subroutine sic_def_login_2d_nil
!
subroutine sic_def_login_3d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  logical,          intent(in)    :: logi(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_3d_1i4
!
subroutine sic_def_login_3d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb         ! Variable name
  logical,          intent(in)    :: logi(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim         ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim          ! Dimensions
  logical,          intent(in)    :: readonly     ! Read only?
  logical,          intent(inout) :: error        ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_3d_1i8
!
subroutine sic_def_login_3d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb         ! Variable name
  logical,                     intent(in)    :: logi(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim         ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)    ! Dimensions
  logical,                     intent(in)    :: readonly     ! Read only?
  logical,                     intent(inout) :: error        ! Logical error flag
  !
  call sic_def_login_addr(symb,logi(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_login_3d_nil
!
subroutine sic_def_login_4d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  logical,          intent(in)    :: logi(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_4d_1i4
!
subroutine sic_def_login_4d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb           ! Variable name
  logical,          intent(in)    :: logi(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim           ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim            ! Dimensions
  logical,          intent(in)    :: readonly       ! Read only?
  logical,          intent(inout) :: error          ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_4d_1i8
!
subroutine sic_def_login_4d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb           ! Variable name
  logical,                     intent(in)    :: logi(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim           ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)      ! Dimensions
  logical,                     intent(in)    :: readonly       ! Read only?
  logical,                     intent(inout) :: error          ! Logical error flag
  !
  call sic_def_login_addr(symb,logi(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_login_4d_nil
!
subroutine sic_def_login_5d_1i4(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  logical,          intent(in)    :: logi(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_5d_1i4
!
subroutine sic_def_login_5d_1i8(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb             ! Variable name
  logical,          intent(in)    :: logi(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim             ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim              ! Dimensions
  logical,          intent(in)    :: readonly         ! Read only?
  logical,          intent(inout) :: error            ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_login_addr(symb,logi(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_login_5d_1i8
!
subroutine sic_def_login_5d_nil(symb,logi,ndim,dim,readonly,error)
  use gildas_def
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_login
  !  Define a LOGICAL array Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb             ! Variable name
  logical,                     intent(in)    :: logi(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim             ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)        ! Dimensions
  logical,                     intent(in)    :: readonly         ! Read only?
  logical,                     intent(inout) :: error            ! Logical error flag
  !
  call sic_def_login_addr(symb,logi(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_login_5d_nil
!
!-----------------------------------------------------------------------
! Entry points for SIC_DEF_CHARN
!
subroutine sic_def_charn_0d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  character(len=*), intent(in)    :: chain     ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain,ndim,jdim,readonly,error)
end subroutine sic_def_charn_0d_1i4
!
subroutine sic_def_charn_0d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  Scalar target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  character(len=*), intent(in)    :: chain     ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain,ndim,jdim,readonly,error)
end subroutine sic_def_charn_0d_1i8
!
subroutine sic_def_charn_0d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  Scalar target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  character(len=*),            intent(in)    :: chain      ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain,ndim,dim,readonly,error)
end subroutine sic_def_charn_0d_nil
!
subroutine sic_def_charn_1d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  character(len=*), intent(in)    :: chain(:)  ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_1d_1i4
!
subroutine sic_def_charn_1d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  1D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb      ! Variable name
  character(len=*), intent(in)    :: chain(:)  ! Target
  integer(kind=4),  intent(in)    :: ndim      ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim       ! Dimensions
  logical,          intent(in)    :: readonly  ! Read only?
  logical,          intent(inout) :: error     ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_1d_1i8
!
subroutine sic_def_charn_1d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  1D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb       ! Variable name
  character(len=*),            intent(in)    :: chain(:)   ! Target
  integer(kind=4),             intent(in)    :: ndim       ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)  ! Dimensions
  logical,                     intent(in)    :: readonly   ! Read only?
  logical,                     intent(inout) :: error      ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain(1),ndim,dim,readonly,error)
end subroutine sic_def_charn_1d_nil
!
subroutine sic_def_charn_2d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb        ! Variable name
  character(len=*), intent(in)    :: chain(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim        ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim         ! Dimensions
  logical,          intent(in)    :: readonly    ! Read only?
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_2d_1i4
!
subroutine sic_def_charn_2d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  2D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb        ! Variable name
  character(len=*), intent(in)    :: chain(:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim        ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim         ! Dimensions
  logical,          intent(in)    :: readonly    ! Read only?
  logical,          intent(inout) :: error       ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_2d_1i8
!
subroutine sic_def_charn_2d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  2D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb        ! Variable name
  character(len=*),            intent(in)    :: chain(:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim        ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)   ! Dimensions
  logical,                     intent(in)    :: readonly    ! Read only?
  logical,                     intent(inout) :: error       ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain(1,1),ndim,dim,readonly,error)
end subroutine sic_def_charn_2d_nil
!
subroutine sic_def_charn_3d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb          ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim          ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim           ! Dimensions
  logical,          intent(in)    :: readonly      ! Read only?
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_3d_1i4
!
subroutine sic_def_charn_3d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  3D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb          ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim          ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim           ! Dimensions
  logical,          intent(in)    :: readonly      ! Read only?
  logical,          intent(inout) :: error         ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_3d_1i8
!
subroutine sic_def_charn_3d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  3D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb          ! Variable name
  character(len=*),            intent(in)    :: chain(:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim          ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)     ! Dimensions
  logical,                     intent(in)    :: readonly      ! Read only?
  logical,                     intent(inout) :: error         ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain(1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_charn_3d_nil
!
subroutine sic_def_charn_4d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb            ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim            ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim             ! Dimensions
  logical,          intent(in)    :: readonly        ! Read only?
  logical,          intent(inout) :: error           ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_4d_1i4
!
subroutine sic_def_charn_4d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  4D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb            ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim            ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim             ! Dimensions
  logical,          intent(in)    :: readonly        ! Read only?
  logical,          intent(inout) :: error           ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_4d_1i8
!
subroutine sic_def_charn_4d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  4D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb            ! Variable name
  character(len=*),            intent(in)    :: chain(:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim            ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)       ! Dimensions
  logical,                     intent(in)    :: readonly        ! Read only?
  logical,                     intent(inout) :: error           ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain(1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_charn_4d_nil
!
subroutine sic_def_charn_5d_1i4(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 4
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb              ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim              ! Number of dimensions
  integer(kind=4),  intent(in)    :: dim               ! Dimensions
  logical,          intent(in)    :: readonly          ! Read only?
  logical,          intent(inout) :: error             ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_5d_1i4
!
subroutine sic_def_charn_5d_1i8(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  5D target
  !  Dimension as a scalar integer of kind 8
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: symb              ! Variable name
  character(len=*), intent(in)    :: chain(:,:,:,:,:)  ! Target
  integer(kind=4),  intent(in)    :: ndim              ! Number of dimensions
  integer(kind=8),  intent(in)    :: dim               ! Dimensions
  logical,          intent(in)    :: readonly          ! Read only?
  logical,          intent(inout) :: error             ! Logical error flag
  ! Local
  integer(kind=index_length) :: jdim(sic_maxdims)
  !
  jdim(1) = dim
  call sic_def_charn_addr(symb,chain(1,1,1,1,1),ndim,jdim,readonly,error)
end subroutine sic_def_charn_5d_1i8
!
subroutine sic_def_charn_5d_nil(symb,chain,ndim,dim,readonly,error)
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public-generic sic_def_charn
  !  Define a CHARACTER array Sic variable
  !---
  !  5D target
  !  Dimensions as an integer array of kind index_length
  !---------------------------------------------------------------------
  character(len=*),            intent(in)    :: symb              ! Variable name
  character(len=*),            intent(in)    :: chain(:,:,:,:,:)  ! Target
  integer(kind=4),             intent(in)    :: ndim              ! Number of dimensions
  integer(kind=index_length),  intent(in)    :: dim(ndim)         ! Dimensions
  logical,                     intent(in)    :: readonly          ! Read only?
  logical,                     intent(inout) :: error             ! Logical error flag
  !
  call sic_def_charn_addr(symb,chain(1,1,1,1,1),ndim,dim,readonly,error)
end subroutine sic_def_charn_5d_nil

 
! A number of tools for UV_MAP to control the Image headers
! and the range of channels being processed
!
subroutine uvmap_cols(task,line,huv,channels,error)
  use image_def
  use clean_def
  use gkernel_interfaces, only : sic_present, sic_get_inte, sic_ambigs
  !---------------------------------------------------------------------
  ! IMAGER
  !   @ private
  !     Define the channel range, Weight channel, and Channel defining 
  !     the observing frequency
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task  !! Callers name
  character(len=*), intent(in) :: line  !! Command line with /RANGE option
  type(gildas), intent(in) :: huv       !! UV data header
  type(channel_par), intent(inout) :: channels   !! Channels to be used
  logical, intent(out) :: error         !! Error flag
  !
  integer, parameter :: o_range=3       ! For UV_MAP
  integer :: mcol(2)     ! Ordered channel min max
  integer :: wcol        ! Weight channel
  real(8) :: rcol        ! Channel defining the frequency
  integer :: nc, fcol, lcol
  real(8) :: drange(2)
  character(len=12) :: csort
  integer(kind=4), parameter :: msort=3
  integer :: isort, nn
  character(len=12) :: types(msort),mysort
  data types /'CHANNEL','VELOCITY','FREQUENCY'/
  !
  nc = huv%gil%nchan
  wcol = 0
  rcol = 0.0
  !
  ! Backward compatibility
  call sic_get_inte('WCOL',wcol,error)
  call sic_get_inte('MCOL[1]',mcol(1),error)
  call sic_get_inte('MCOL[2]',mcol(2),error) 
  call sic_get_dble('RCOL',rcol,error) 
  !
  error = .false.
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  !
  ! /RANGE (for flexibility)
  if (sic_present(o_range,0)) then
    call sic_r8 (line,o_range,1,drange(1),.true.,error)
    if (error) return
    call sic_r8 (line,o_range,2,drange(2),.true.,error)
    if (error) return
    call sic_ke (line,o_range,3,csort,nn,.true.,error)
    if (error) return
    error = .false.
    call sic_ambigs(task,csort,mysort,isort,types,msort,error)
    if (error)  return
    call out_range(task,csort,drange,mcol,huv,error)
    if (error) return
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  nc = lcol-fcol+1
  mcol(1) = fcol
  mcol(2) = lcol
  !
  ! Do not use the center channel (some times flagged)
  if (wcol.eq.0) then
    wcol = fcol+nc/3
  else
    wcol = max(1,wcol)
    wcol = min(wcol,huv%gil%nchan)
  endif
  !
  if (rcol.eq.0) then
    rcol = dble(fcol+lcol)*0.5d0
  else
    rcol = max(1.d0,rcol)
    rcol = min(rcol,dble(huv%gil%nchan))
  endif
  !
  channels%bounds = mcol
  channels%weight = wcol
  channels%freq   = rcol
end subroutine uvmap_cols
!
subroutine map_copy_par(in,out)
  use clean_def
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Utility routine
  !
  !   Copy a MAP structure to another one, but avoid erasing
  !   the number of fields in it. The result must have an intent(inout)
  !   to avoid erasing the allocatable array in the derived type.
  !!
  !---------------------------------------------------------------------
  type(uvmap_par), intent(in) :: in
  type(uvmap_par), intent(inout) :: out
  !
  out%taper = in%taper         !! UV Taper
  out%size = in%size           !! Map size
  out%xycell = in%xycell       !! Map cell
  out%uvcell = in%uvcell       !! UV cell
  out%uniform = in%uniform     !! Weighting parameters
  out%wcol = in%wcol           !! Weighting channel
  out%ctype = in%ctype         !! Convolution mode
  out%support = in%support     !! Support of gridding function
  out%beam = in%beam           !! One beam every N channels
  out%field = in%field         !! Field of view in arcsecond
  out%precis = in%precis       !! Precision at map edges
  out%mode = in%mode           !! Weighting mode
  out%shift = in%shift         !! Shift or rotate UV data
  out%ra_c = in%ra_c           !! Right ascension
  out%dec_c = in%dec_c         !! Declination
  out%angle = in%angle         !! New position angle of UV data
  out%truncate = in%truncate   !! Truncation radius
  !
end subroutine map_copy_par
!
subroutine map_prepare(task,huv,map,error)
  use image_def
  use clean_def
  use clean_default
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, only : map_message
  !---------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER  -- Support for UV_MAP
  !   
  !             Prepares the imaging parameters from the UV data header
  !!
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: task  !! Caller name
  type(gildas), intent(in) :: huv       !! UV data header
  type(uvmap_par), intent(inout) :: map !! Imaging parameters
  logical, intent(out) :: error         !! Error flag
  !
  ! Constants
  ! character(len=*), parameter :: obsol='obsolete'   ! Later
  character(len=*), parameter :: obsol='obsolescent'
  !
  ! Local ---
  character(len=80) :: chain
  character(len=6) :: cmode
  real :: fact
  !
  ! Code -----
  !
  ! Check version
  if (map_version.lt.-1 .or. map_version.gt.1) then
    call map_message(seve%e,task,'Invalid MAP_VERSION, should be -1,0 or 1')
    error = .true.
    return
  endif
  !
  ! Check old syntax
  if (old_map%uniform(1).ne.save_map%uniform(1)) then
    call map_message(seve%w,task,'UV_CELL is '//obsol//', use MAP_UVCELL instead')
    default_map%uniform(1) = old_map%uniform(1)
  endif
  if (old_map%uniform(2).ne.save_map%uniform(2)) then
    call map_message(seve%w,task,'UV_CELL is '//obsol//', use MAP_ROBUST instead')
    default_map%uniform(2) = old_map%uniform(2)
  endif
  if (old_map%taper(4).ne.save_map%taper(4)) then
    call map_message(seve%w,task,'TAPER_EXPO is '//obsol//', use MAP_TAPER_EXPO instead')
    save_map%taper(4) = old_map%taper(4)
    default_map%taper(4) = old_map%taper(4)
  endif
  if (any(old_map%taper.ne.save_map%taper)) then
    call map_message(seve%w,task,'UV_TAPER is '//obsol//', use MAP_UVTAPER instead')
    default_map%taper = old_map%taper
  endif
  if (old_map%ctype.ne.save_map%ctype) then
    call map_message(seve%w,task,'CONVOLUTION is '//obsol//', use MAP_CONVOLUTION instead')
    default_map%ctype = old_map%ctype
  endif
  if (old_map%mode.ne.save_map%mode) then
    call map_message(seve%w,task,'WEIGHT_MODE is '// &
      & 'obsolete, set MAP_ROBUST=0 instead') 
    ! Attempt to catch the Natural case
    call get_weightmode(task,old_map%mode,error)
    if (old_map%mode.eq.'NATURAL') default_map%uniform(2) = 0.0
    default_map%mode = old_map%mode
  endif
  if (old_map%shift.neqv.save_map%shift) then
    call map_message(seve%w,task,'UV_SHIFT is '//obsol//', use MAP_SHIFT instead')
    default_map%shift = old_map%shift
  endif
  !
  ! Copy the current default to the actual structure
  call map_copy_par(default_map,map)
  !
  ! Weighting scheme
  error = .false.
  map%uniform(1) = max(0.0,map%uniform(1))
  if (map%uniform(2).ne.0) then
    if (huv%gil%nteles.gt.0) then
      if (map%uniform(2).gt.0) then
        cmode = 'Robust'
        fact = 2.0
      else
        cmode = 'Briggs'
        fact = 1.0
      endif
      if (map%uniform(1).eq.0) then
        map%uniform(1) = huv%gil%teles(1)%diam/fact 
        write(chain,'(A,A,F6.2,A,F6.2)') cmode,' weighting ',map%uniform(2),' with UV cell size ',map%uniform(1)
        call map_message(seve%i,task,chain)
      else if (map%uniform(1).gt.huv%gil%teles(1)%diam/fact) then
        write(chain,'(A,A,F6.2,A,F6.2)') cmode,' weighting ',map%uniform(2),' with UV cell size ',map%uniform(1)
        call map_message(seve%i,task,trim(chain)//' (super-uniform)')
      endif
    else if (map%uniform(1).eq.0) then
      call map_message(seve%e,task, &
      & 'No UV cell size and no Telescope defined, use SPECIFY TELESCOPE or LET MAP_UVCELL Value')
      error = .true.
    endif
  endif
  !
  ! Here, we do not care about the fields issue
  old_map = default_map
  save_map = default_map
end subroutine map_prepare
!
subroutine uvmap_headers(huv,nx,ny,nb,ns,map,mcol,hbeam,hdirty,error)
  use clean_def
  use image_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER -- Utility routine
  !
  !   Define the Beam and Dirty image headers 
  !!
  !---------------------------------------------------------------------
  integer, intent(in) :: nx,ny           !! Map size
  integer, intent(in) :: ns              !! Number of channels per single beam
  integer, intent(in) :: nb              !! Number of beams
  integer, intent(in) :: mcol(2)         !! Channel range
  type (uvmap_par), intent(in) :: map    !! Mapping parameters
  type(gildas), intent(in) :: huv        !! UV headers
  type(gildas), intent(inout) :: hbeam   !! Beam headers
  type(gildas), intent(inout) :: hdirty  !! Dirty image header
  logical, intent(inout) :: error
  !
  ! Local ---
  integer :: nc   ! Number of channels
  integer :: i
  integer :: fcol
  real(8) :: vref,voff,vinc
  real(4) :: loff,boff
  !
  ! Code ----
  nc = huv%gil%nchan
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  !
  error = .false.
  if (mcol(1).gt.mcol(2)) error = .true.
  do i=1,2
    if (mcol(i).lt.1 .or. mcol(i).gt.nc) then
      error = .true.
    endif
  enddo
  if (error) then
    Print *,'F-UVMAP_HEADERS,  MCOL not initialized ',mcol
    return
  endif
  !
  nc = mcol(2) - mcol(1)+1
  fcol = mcol(1)
  !
  ! Make beam, not normalized
  call gdf_copy_header(huv,hbeam,error)
  hbeam%gil%dopp = 0    ! Nullify the Doppler factor
  !
  hbeam%gil%ndim = 3
  hbeam%gil%dim(1) = nx
  hbeam%gil%dim(2) = ny
  hbeam%gil%dim(3) = nb
  hbeam%gil%dim(4) = 1
  hbeam%gil%convert(1,1) = nx/2+1
  hbeam%gil%convert(1,2) = ny/2+1
  hbeam%gil%convert(2,1) = 0
  hbeam%gil%convert(2,2) = 0
  hbeam%gil%convert(3,1) = -map%xycell(1)  ! Assume EQUATORIAL system
  hbeam%gil%convert(3,2) = map%xycell(2)
!    hbeam%gil%convert(1,3) = vref-fcol+1     ! for 1 per channel
! From UV_COMPRESS
!    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
!    uvout%gil%ref(1) = (2.0*uvout%gil%ref(1)+nc-1.0)/2/nc
!    uvout%gil%vres = nc*uvout%gil%vres
!    uvout%gil%fres = nc*uvout%gil%fres
!
  hbeam%gil%convert(1,3) = (2.d0*(vref-fcol)+ns+1.d0)/2/ns ! Correct
  hbeam%gil%convert(2,3) = voff
  hbeam%gil%blan_words = 0        ! No blanking test SG
  hbeam%gil%extr_words = 0
  hbeam%gil%reso_words = 0
  hbeam%gil%uvda_words = 0
  hbeam%gil%type_gdf = code_gdf_image
  !
  hbeam%char%code(1) = 'ANGLE'
  hbeam%char%code(2) = 'ANGLE'
  hbeam%char%code(3) = 'VELOCITY'
  hbeam%gil%majo = 0.0
  hbeam%loca%size = hbeam%gil%dim(1)*hbeam%gil%dim(2)*hbeam%gil%dim(3)
  !
  ! Also define the Projection, for a better "show beam"
  hbeam%gil%proj_words = def_proj_words
  hbeam%char%code(1) = 'RA'
  hbeam%char%code(2) = 'DEC'
  hbeam%char%code(3) = 'VELOCITY'
  call equ_to_gal(hbeam%gil%ra,hbeam%gil%dec,0.0,0.0,   &
                  hbeam%gil%epoc,hbeam%gil%lii,hbeam%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hbeam%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hbeam%gil%pang = 0.d0     ! Defined in table.
    hbeam%gil%a0 = hbeam%gil%ra
    hbeam%gil%d0 = hbeam%gil%dec
  else
    hbeam%gil%ptyp = p_azimuthal
    hbeam%gil%pang = huv%gil%pang ! Defined in table.
    hbeam%gil%a0 = huv%gil%a0
    hbeam%gil%d0 = huv%gil%d0
  endif
  if (hbeam%char%syst.eq.' ') hbeam%char%syst = 'EQUATORIAL'
  hbeam%gil%xaxi = 1
  hbeam%gil%yaxi = 2
  hbeam%gil%faxi = 3  
  !
  ! Prepare the dirty map header
  call gdf_copy_header(hbeam,hdirty,error)
  hdirty%gil%ndim = 3
  hdirty%gil%dim(1) = nx
  hdirty%gil%dim(2) = ny
  hdirty%gil%dim(3) = nc
  hdirty%gil%dim(4) = 1
  hdirty%gil%convert(1,3) = vref-fcol+1
  hdirty%gil%convert(2,3) = voff
  hdirty%gil%convert(3,3) = vinc
  hdirty%gil%proj_words = def_proj_words
  hdirty%gil%uvda_words = 0
  hdirty%gil%type_gdf = code_gdf_image
  hdirty%char%code(1) = 'RA'
  hdirty%char%code(2) = 'DEC'
  hdirty%char%code(3) = 'VELOCITY'
  call equ_to_gal(hdirty%gil%ra,hdirty%gil%dec,0.0,0.0,   &
                  hdirty%gil%epoc,hdirty%gil%lii,hdirty%gil%bii,loff,boff,error)
  if (huv%gil%ptyp.eq.p_none) then
    hdirty%gil%ptyp = p_azimuthal  ! Azimuthal (Sin)
    hdirty%gil%pang = 0.d0         ! Defined in table.
    hdirty%gil%a0 = hdirty%gil%ra
    hdirty%gil%d0 = hdirty%gil%dec
  else
    hdirty%gil%ptyp = p_azimuthal
    hdirty%gil%pang = huv%gil%pang ! Defined in table.
    hdirty%gil%a0 = huv%gil%a0
    hdirty%gil%d0 = huv%gil%d0
  endif
  hdirty%gil%xaxi = 1
  hdirty%gil%yaxi = 2
  hdirty%gil%faxi = 3
  hdirty%gil%blan_words = 0        ! No blanking test SG
  hdirty%gil%extr_words = 0        ! extrema not computed
  hdirty%gil%reso_words = 0        ! no beam defined
  hdirty%gil%nois_words = 2
  hdirty%gil%majo = 0
  hdirty%char%unit = 'Jy/beam'
  hdirty%loca%size = hdirty%gil%dim(1)*hdirty%gil%dim(2)*hdirty%gil%dim(3)
  !
  ! Smooth the beam in Frequency
  hbeam%gil%convert(3,3) = vinc*ns
  hbeam%gil%vres = ns*vinc
  hbeam%gil%fres = ns*hbeam%gil%fres
  !
end subroutine uvmap_headers

subroutine level(line,error)
  use gildas_def
  use sic_types
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>level
  use greg_contours
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GREG Support routine for command
  !   LEVELS n1 TO n2 BY n3 ...
  ! or
  !   LEVELS EXPO [Step [Number [Factor]]
  ! or
  !   LEVELS LevelArray
  !
  ! Contour definition for RGMAP or RANDOM_MAP
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='LEVELS'
  character(len=varname_length) :: argum
  integer(kind=4) :: nc,istart,i
  type(sic_descriptor_t) :: descr
  integer(4), save :: memory(2)
  integer(kind=address_length) :: ipt
  !
  ! Exponentially spaced level definition
  real(8), save :: step=1.0d0
  integer(4), save :: nlin=3
  real(8), save :: fact=sqrt(2.0d0)
  logical :: found
  !
  if (sic_present(0,1)) then
    ncl = 0  ! i.e. GREG%NLEVEL=0
    call sic_delvariable('GREG%LEVELS',.false.,error)
    error = .false.  ! Attempt to delete non-existent variables is not an error
    !
    argum = ' '
    if (sic_narg(0).ge.1) then
      call sic_ch (line,0,1,argum,nc,.true.,error)
      if (error)  return
      call sic_upper(argum)
      if (argum.eq.'NONE') return
    endif
    !
    if (argum.eq.'EXPO') then
      !   LEVELS EXPO [Step [Number_of_Linear [Factor]]
      call sic_r8 (line,0,2,step,.false.,error)
      call sic_i4 (line,0,3,nlin,.false.,error)
      call sic_r8 (line,0,4,fact,.false.,error)
      !
      do i=1,nlin
        cl(i) = -(nlin-i+1)*step
      enddo
      do i=nlin+1,2*nlin
        cl(i) = (i-nlin)*step
      enddo
      do i=2*nlin+1,maxl
        cl(i) = fact*cl(i-1)
      enddo
      ncl = maxl
    else if (sic_varexist(argum).and.(sic_narg(0).eq.1)) then
      ! This is a Variable
      call sic_descriptor(argum,descr,found)
      if (descr%type.eq.fmt_r4) then
        ncl = min(maxl,descr%size)
        ipt = gag_pointer(descr%addr,memory)
        call r4tor4(memory(ipt),cl,ncl)
      else if (descr%type.eq.fmt_r8) then
        ncl = min(maxl,descr%size/2)
        ipt = gag_pointer(descr%addr,memory)
        call r8tor4(memory(ipt),cl,ncl)
      else if (descr%type.eq.fmt_i4) then
        ncl = min(maxl,descr%size)
        ipt = gag_pointer(descr%addr,memory)
        call i4tor4(memory(ipt),cl,ncl)
      else
        call greg_message(seve%e,rname,'Level variable '//trim(argum)//' must be numeric')
        error = .true.
        return
      endif
    else
      istart = sic_start(0,1)
      call sic_build_listr4(cl,ncl,maxl,line(istart:),rname,error)
      if (error) return
    endif
  endif
  !
  if (ncl.gt.0) then
    ! Create GREG%LEVELS only if it does not exist any more (otherwise,
    ! command LEVELS without argument gives an error message here)
    if (sic_present(0,1)) then
      call sic_def_real('GREG%LEVELS',cl,1,ncl,.false.,error)
    else
      call greg_message(seve%r,rname,'Contour levels are :')
      call levels_type(ncl,cl)
    endif
  else
    call greg_message(seve%w,rname,'No contour levels')
  endif
  !
contains
  subroutine levels_type(n,arr)
    !-------------------------------------------------------------------
    ! Same as Sic r4_type, but messages can be filtered with
    !   SIC MESSAGE GREG S-R
    !-------------------------------------------------------------------
    integer(kind=4), intent(in) :: n
    real(kind=4),    intent(in) :: arr(n)
    ! Local
    character(len=75) :: mess
    integer(kind=4) :: i,j,m
    !
    m = n/5
    do i=1,5*m,5
      write(mess,100) (arr(j),j=i,i+4)
      call greg_message(seve%r,rname,mess)
    enddo
    if (5*m.ne.n) then
      write(mess,100) (arr(j),j=5*m+1,n)
      call greg_message(seve%r,rname,mess)
    endif
  100 format (5(1x,1pg14.7))
  end subroutine levels_type
end subroutine level
!
subroutine gr4_levels(nl,zlevel)
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr4_levels
  use greg_error
  use greg_contours
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer,intent(in) :: nl           ! Number of levels
  real(4), intent(in) :: zlevel(*)   ! level values
  ! Local
  character(len=*), parameter :: rname='GR4_LEVELS'
  integer :: i
  character(len=60) :: chain
  logical :: error
  !
  if (nl.lt.0) then
    call greg_message(seve%e,rname,'Number of levels negative')
    errorg = .true.
    return
  elseif (nl.gt.maxl) then
    write(chain,'(A,I2,A,I6,A)') 'Levels ',maxl+1,' to ',nl,' have been lost'
    call greg_message(seve%w,rname,chain)
  endif
  ncl = min (nl,maxl)
  do i=1,ncl
    cl(i) = zlevel(i)
  enddo
  call sic_delvariable('GREG%LEVELS',.false.,error)
  if (ncl.eq.0) return
  error = .false.  ! Attempt to delete non-existent variables is not an error
  call sic_def_real('GREG%LEVELS',cl,1,ncl,.false.,error)
end subroutine gr4_levels
!
subroutine gr8_levels(nl,zlevel)
  use gbl_message
  use greg_dependencies_interfaces
  use greg_interfaces, except_this=>gr8_levels
  use greg_error
  use greg_contours
  !---------------------------------------------------------------------
  ! @ public
  !---------------------------------------------------------------------
  integer, intent(in) :: nl          ! Number of levels
  real(8), intent(in) :: zlevel(*)   ! Level values
  ! Local
  character(len=*), parameter :: rname='GR8_LEVELS'
  character(len=60) :: chain
  integer :: i
  logical :: error
  !
  if (nl.lt.0) then
    call greg_message(seve%e,rname,'Number of levels negative')
    errorg = .true.
    return
  elseif (nl.gt.maxl) then
    write(chain,'(A,I2,A,I6,A)') 'Levels ',maxl+1,' to ',nl,' have been lost'
    call greg_message(seve%w,rname,chain)
  endif
  ncl = min (nl,maxl)
  do i=1,ncl
    cl(i) = zlevel(i)
  enddo
  call sic_delvariable('GREG%LEVELS',.false.,error)
  if (ncl.eq.0) return
  error = .false.  ! Attempt to delete non-existent variables is not an error
  call sic_def_real('GREG%LEVELS',cl,1,ncl,.false.,error)
end subroutine gr8_levels

module gcont_interfaces_public
  interface
    subroutine concal (xd,yd,zd,nt,ipt,nl,ipl,pdd,iti,xii,yii,zii,itpv)
      use gcont_gridder
      !---------------------------------------------------------------------
      ! @ public
      ! 	This subroutine performs punctual interpolation or extrapolation
      ! 	i.e., determines the Z value at a point.
      ! Arguments :
      !	XD	R*4 (*)	Array of X coordinates			Input
      !	YD	R*4 (*)	Array of Y coordinates			Input
      !	ZD	R*4 (*) Array of values				Input
      !	NT	I	Number of triangles			Input
      !	IPT	I (*)	Array containing the point numbers of
      !			the vertexes of the triangles		Input
      !	NL	I	Number of border line segments		Input
      !	IPL	I (*)	Array containing the point numbers of
      !			the end points of the border line
      !			segments and their respective triangle
      !			numbers					Input
      !	PDD	R*4 (*)	Array containing the partial derivatives
      !			at the data points			Input
      !	ITI	I	triangle number of the triangle in which
      !			lies the point for which interpolation
      !			is to be performed			Input
      !	XII	R*4	X coordinate of the point for which
      !			interpolation is to be performed.	Input
      !	YII	R*4	Y coordinate of this point		Input
      !	ZII	R*4	Interpolated Z value			Output
      ! No subroutine referenced
      !---------------------------------------------------------------------
      real :: xd(*)                     !
      real :: yd(*)                     !
      real :: zd(*)                     !
      integer :: nt                     !
      integer :: ipt(*)                 !
      integer :: nl                     !
      integer :: ipl(*)                 !
      real :: pdd(*)                    !
      integer :: iti                    !
      real :: xii                       !
      real :: yii                       !
      real :: zii                       !
      integer :: itpv                   !
    end subroutine concal
  end interface
  !
  interface
    subroutine condet (ndp,xd,yd,ncp,ipc)
      !---------------------------------------------------------------------
      ! @ public
      !	This subroutine selects several data points that are closest
      !	to each of the data point.
      ! Arguments :
      !	NDP	I	Number of data points
      !	XD	R*4 (*)	Arrays containing the X coordinates
      !             		of data points.
      !	YD	R*4 (*) Array of Y coordinates
      !	NCP	I	number of data points closest to each
      !			data point.
      !	IPC	I (*)	Array of dimension NCP*NDP, where the
      !			point numbers of NCP data points closest
      !			to each of the NDP data points are to be
      !			stored.
      !----------------------------------------------------------------------
      !
      ! this subroutine arbitrarily sets a restriction that NCP must
      ! not exceed 25 without modification to the arrays DSQ0 and IPC0.
      ! Declaration statements
      !---------------------------------------------------------------------
      integer :: ndp                    !
      real :: xd(ndp)                   !
      real :: yd(ndp)                   !
      integer :: ncp                    !
      integer :: ipc(*)                 !
    end subroutine condet
  end interface
  !
  interface
    subroutine conint (ndp,xd,yd,zd,ncp,ipc,pd)
      !---------------------------------------------------------------------
      ! @ public
      !	This subroutine estimates partial derivatives of the first and
      !	second order at the data points.
      ! Arguments :
      !	NDP	I	Number of data points			Input
      !	XD	R*4 (*)	Array of X coordinates			Input
      !	YD	R*4 (*)	Array of Y coordinates			Input
      !	ZD	R*4 (*)	Array of values				Input
      !	NCP	I	Number of data points to be used for
      !			estimation of partial derivatives at
      !			each data point				Input
      !	IPC	I (*)	Array containing the point numbers of
      !			NCP data points closest to each of the
      !			NDP data point.				Input
      !	PD	R*4 (*) Array of dimension 5*NDP, where the
      !			estimated ZX, ZY, ZXX, ZXY, and ZYY
      !			values at the data points are to be
      !			stored.					Output
      ! No subroutines referenced
      !---------------------------------------------------------------------
      integer :: ndp                    !
      real :: xd(ndp)                   !
      real :: yd(ndp)                   !
      real :: zd(ndp)                   !
      integer :: ncp                    !
      integer :: ipc(*)                 !
      real :: pd(*)                     !
    end subroutine conint
  end interface
  !
  interface
    subroutine conloc (ndp,xd,yd,ntr,ipt,nli,ipl,xii,yii,iti,iwk,wk)
      use gcont_contour
      !---------------------------------------------------------------------
      ! @ public
      !	This subroutine locates a point, i.e., determines to what
      !	triangle a given point (xii,yii) belongs.  When the given
      !	point does not lie inside the data area, this subroutine
      !	determines the border line segment when the point lies in
      !	an outside rectangular area, and two border line segments
      !	when the point lies in an outside triangular area.
      ! Arguments :
      !	NDP	I	number of data points			Input
      !	XD	R*4 (*)	Arrays of dimension NDP containing the
      !			X coordinates of the data points	Input
      !	YD	R*4 (*) Array of Y coordinates			Input
      !	NTR	I	Number of triangles			Input
      !	IPT	I (*)	Array of dimension 3*NTR containing the
      !			point numbers of the vertexes of the
      !			triangles				Input
      !	NLI	I	Number of border line segments		Input
      !	IPL	I (*)	Array of dimension 3*NLI containing the
      !			point numbers of the end points of the
      !			border line segments and their respective
      !			triangle numbers			Input
      !	XII	R*4	X coordinate of point to locate		Input
      !	YII 	R*4	Y coordinate of point to locate		Input
      !	ITI 	I	Triangle number, when the point is
      !			inside the data area, or two border
      !			line segment numbers, IL1 and IL2,
      !			coded to IL1*(NTR+NLI)+IL2, when the
      !			point is outside the data area.		Output
      !	IWK 	I (*)	Array of dimension 18*NDP used
      !			internally as a work area
      !	WK  	R*4 (*)	Array of dimension 8*NDP used internally
      !			as a work area.
      !---------------------------------------------------------------------
      integer :: ndp                    !
      real :: xd(*)                     !
      real :: yd(*)                     !
      integer :: ntr                    !
      integer :: ipt(*)                 !
      integer :: nli                    !
      integer :: ipl(*)                 !
      real :: xii                       !
      real :: yii                       !
      integer :: iti                    !
      integer :: iwk(*)                 !
      real :: wk(*)                     !
    end subroutine conloc
  end interface
  !
  interface
    subroutine conreg (nx,ny,z,frstd,vectd,lastd,flushd,ir,n,error)
      use gcont_contour
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !	Draw contour levels according to the parameters set up by
      !	subroutine MAP
      ! Arguments :
      !	NX	I	Number of X pixels			Input
      !	NY	I	Number of Y pixels			Input
      !	Z	R*4	Array of values				Input
      !	VECTD	Ext 	Vector drawing function			Input
      !	LASTD	Ext	End of contour drawing function		Input
      !	FRSTD	Ext	First vector drawing routine 		Input
      !	FLUSHD	Ext	A plot flushing routine			Input
      !	IR	I	Work space for contour storage
      !	N	I	Size of work space
      ! Subroutines :
      !	CONBIT
      !	STLINE
      !---------------------------------------------------------------------
      integer :: nx                     !
      integer :: ny                     !
      real :: z(*)                      !
      external :: frstd                 !
      external :: vectd                 !
      external :: lastd                 !
      external :: flushd                !
      integer :: ir(*)                  !
      integer :: n                      !
      logical, intent(inout) :: error   ! Error return
    end subroutine conreg
  end interface
  !
  interface
    subroutine conblk(blank,value,tol)
      use gcont_contour
      !---------------------------------------------------------------------
      ! @ public
      !	Set blanking value for Regular mapping
      ! Arguments :
      !	BLANK	L	Blanking or not			Input
      !	VALUE	R*4	The blanking value		Input
      !	TOL	R*4	The tolerance			Input
      ! No subroutines
      !---------------------------------------------------------------------
      logical :: blank                  !
      real :: value                     !
      real :: tol                       !
    end subroutine conblk
  end interface
  !
  interface
    subroutine conlev(fact,array,n)
      use gcont_contour
      !---------------------------------------------------------------------
      ! @ public
      !	Setup the array of contour values
      ! Arguments :
      !	FACT	R*4	Multiplicative factor
      !	ARRAY	R*4	Contour value array
      !	N	I	Dimension of array
      ! No subroutine
      !---------------------------------------------------------------------
      real :: fact                      !
      real :: array(*)                  !
      integer :: n                      !
    end subroutine conlev
  end interface
  !
  interface
    subroutine contng (ndp,xd,yd,ntr,ipt,nli,ipl,iwl,iwp,wk)
      use gcont_contour
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !	This subroutine performs triangulation.  It divides the X-Y
      !	plane into a number of triangles according to given data
      !	points in the plane, determines line segments that form the
      !	border of data area, and determines the triangle numbers
      !	corresponding to the border line segments.
      !	At completion, point numbers of the vertexes of each triangle
      !	are listed counter-clockwise.  Point numbers of the end points
      !	of each border line segment are listed counter-clockwise,
      !	listing order of the line segments being counter-clockwise.
      ! Arguments :
      !	NDP 	I	Number of data points			Input
      !	XD  	R*4 (*)	Array of dimension NDP containing the
      !			X coordinates of the data points	Input
      !	YD  	R*4 (*) Array of Y coordinates			Input
      !	NTR  	I	Number of triangles			Output
      !	IPT 	I (*)	Array of dimension 6*NDP-15, where the
      !			point numbers of the vertexes of the
      !			(IT)th triangle are to be stored as the
      !			(3*IT-2)nd, (3*IT-1)st, and (3*IT)th
      !			elements, IT=1,2,...,NTR		Output
      !	NLI  	I	Number of border line segments		Output
      !	IPL 	I (*)	Array of dimension 6*NDP, where the point
      !			numbers of the end points of the (IL)th
      !			border line segment and its respective
      !			triangle number are to be stored as the
      !			(3*IL-2)nd, (3*IL-1)st, and (3*IL)th
      !			elements, IL=1,2,..., NLI.		Output
      !	IWL 	I (*)	Array of dimension 18*NDP used
      !			internally as a work area
      !	IWP 	I (*)	Array of dimension NDP used
      !			internally as a work area
      !	WK  	R*4 (*)	Array of dimension NDP used
      !			internally as a work area.
      ! No subroutine referenced
      !---------------------------------------------------------------------
      integer :: ndp                    !
      real :: xd(*)                     !
      real :: yd(*)                     !
      integer :: ntr                    !
      integer :: ipt(*)                 !
      integer :: nli                    !
      integer :: ipl(*)                 !
      integer :: iwl(*)                 !
      integer :: iwp(*)                 !
      real :: wk(*)                     !
    end subroutine contng
  end interface
  !
  interface
    subroutine gcont_message_set_id(id)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Alter library id into input id. Should be called by the library
      ! which wants to share its id with the current one.
      !---------------------------------------------------------------------
      integer, intent(in) :: id
    end subroutine gcont_message_set_id
  end interface
  !
  interface
    subroutine gridran (yd,xd,zd,ndp,wk,iwk,scrarr,vectd,frstd,label,error)
      use gcont_contour
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory (because symbol is used elsewhere)
      !	Stephane Guilloteau modification of CONRAN from ULIB 10-MAY-1984
      !	This is the pilot routine for random interpolation. Note that
      !	array XD and YD have been exchanged in order to obtain an
      !	interpolated grid with same organisation as the regular grid array.
      ! Arguments :
      !	YD	R*4 (*)	Array of X coordinates			Input
      !	XD	R*4 (*)	Array of Y coordinates			Input
      !	ZD	R*4 (*)	Array of values				Input
      !	NDP	I	Number of data points			Input
      !	WK	R*4 (*)	Work space
      !	IWK	I (*)	Work space
      !	SCRARR	R*4 (*)	Gridded space				Output
      !	VECTD	Ext	Vector drawing function			External
      !	FRTSD	Ext	Pen up drawing function			External
      !	LABEL	Ext	Label drawing function			External
      !	ERROR   L       Logical error flag
      ! Subroutines :
      !	CONTNG, CONDET, CONINT, CONBDN
      !---------------------------------------------------------------------
      real :: yd(*)                     !
      real :: xd(*)                     !
      real :: zd(*)                     !
      integer :: ndp                    !
      real :: wk(*)                     !
      integer :: iwk(*)                 !
      real :: scrarr(*)                 !
      external :: vectd                 !
      external :: frstd                 !
      external :: label                 !
      logical :: error                  !
    end subroutine gridran
  end interface
  !
  interface
    subroutine gridset(n,blank,log)
      use gcont_contour
      use gcont_gridder
      !---------------------------------------------------------------------
      ! @ public
      !	Setup internal parameters of Random_Map
      ! Arguments :
      !	N	I	Number of closest points NCP
      !	BLANK	R*4	Blanking value
      !	LOG	L (*)	Extrapolate or not
      !---------------------------------------------------------------------
      integer :: n                      !
      real :: blank                     !
      logical :: log(7)                 !
    end subroutine gridset
  end interface
  !
  interface
    subroutine gridini(nx,xref,xval,xinc,ny,yref,yval,yinc)
      use gcont_contour
      !---------------------------------------------------------------------
      ! @ public
      !	Transmit Random_Map gridded array parameters to external space
      ! Arguments :
      !	NX	I	Number of X (I) pixels
      !	XREF	R*8	X Reference pixel
      !	XVAL	R*8	X Value at reference pixel
      !	XINC	R*8	X Increment per I pixel
      !	NY	I	Number of Y (J) pixels
      !	YREF	R*8	Y Reference pixel
      !	YVAL	R*8	Y Value at reference pixel
      !	YINC	R*8	Y Increment per J pixel
      !---------------------------------------------------------------------
      integer :: nx                     !
      real*8 :: xref                    !
      real*8 :: xval                    !
      real*8 :: xinc                    !
      integer :: ny                     !
      real*8 :: yref                    !
      real*8 :: yval                    !
      real*8 :: yinc                    !
    end subroutine gridini
  end interface
  !
end module gcont_interfaces_public

subroutine cwrite(output,chain,n)
  use gtv_types
  use gtv_protocol
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(gt_display) :: output        ! Output instance
  integer          :: n             ! Number of characters in chain
  character(len=*) :: chain         ! Input character string
  !
  ! Cannot do this way on image devices:
  if (output%dev%protocol.eq.p_x .or. &
      output%dev%protocol.eq.p_postscript )  return
  !
  if (output%opened)  write(output%iunit,1) chain(1:n)
  !
1 format(a,$)
  ! This format may be required on some systems, but does not compile on others
! 2  FORMAT(<N>A,$)
end subroutine cwrite

*DECK DNBCO
      SUBROUTINE DNBCO (ABE, LDA, N, ML, MU, IPVT, RCOND, Z)
C***BEGIN PROLOGUE  DNBCO
C***PURPOSE  Factor a band matrix using Gaussian elimination and
C            estimate the condition number.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      DOUBLE PRECISION (SNBCO-S, DNBCO-D, CNBCO-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, MATRIX FACTORIZATION,
C             NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     DNBCO factors a double precision band matrix by Gaussian
C     elimination and estimates the condition of the matrix.
C
C     If RCOND is not needed, DNBFA is slightly faster.
C     To solve  A*X = B , follow DNBCO by DNBSL.
C     To compute  INVERSE(A)*C , follow DNBCO by DNBSL.
C     To compute  DETERMINANT(A) , follow DNBCO by DNBDI.
C
C     On Entry
C
C        ABE     DOUBLE PRECISION(LDA, NC)
C                contains the matrix in band storage.  The rows
C                of the original matrix are stored in the rows
C                of ABE and the diagonals of the original matrix
C                are stored in columns 1 through ML+MU+1 of ABE.
C                NC must be .GE. 2*ML+MU+1 .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array ABE.
C                LDA must be .GE.  N .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT.  N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT.  N .
C                More efficient if ML .LE. MU .
C
C     On Return
C
C        ABE     an upper triangular matrix in band storage
C                and the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U  where
C                L is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        RCOND   DOUBLE PRECISION
C                an estimate of the reciprocal condition of  A .
C                For the system  A*X = B , relative perturbations
C                in  A  and  B  of size  EPSILON  may cause
C                relative perturbations in  X  of size  EPSILON/RCOND .
C                If  RCOND  is so small that the logical expression
C                         1.0 + RCOND .EQ. 1.0
C                is true, then  A  may be singular to working
C                precision.  In particular,  RCOND  is zero  if
C                exact singularity is detected or the estimate
C                underflows.
C
C        Z       DOUBLE PRECISION(N)
C                a work vector whose contents are usually unimportant.
C                If  A  is close to a singular matrix, then  Z  is
C                an approximate null vector in the sense that
C                NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   DO 20 I = 1, N
C                      J1 = MAX(1, I-ML)
C                      J2 = MIN(N, I+MU)
C                      DO 10 J = J1, J2
C                         K = J - I + ML + 1
C                         ABE(I,K) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses columns  1  through  ML+MU+1  of ABE .
C           Furthermore,  ML  additional columns are needed in
C           ABE  starting with column  ML+MU+2  for elements
C           generated during the triangularization.  The total
C           number of columns needed in  ABE  is  2*ML+MU+1 .
C
C     Example:  If the original matrix is
C
C           11 12 13  0  0  0
C           21 22 23 24  0  0
C            0 32 33 34 35  0
C            0  0 43 44 45 46
C            0  0  0 54 55 56
C            0  0  0  0 65 66
C
C      then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C            * 11 12 13  +     , * = not used
C           21 22 23 24  +     , + = used for pivoting
C           32 33 34 35  +
C           43 44 45 46  +
C           54 55 56  *  +
C           65 66  *  *  +
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DASUM, DAXPY, DDOT, DNBFA, DSCAL
C***REVISION HISTORY  (YYMMDD)
C   800728  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNBCO
      INTEGER LDA,N,ML,MU,IPVT(*)
      DOUBLE PRECISION ABE(LDA,*),Z(*)
      DOUBLE PRECISION RCOND
C
      DOUBLE PRECISION DDOT,EK,T,WK,WKM
      DOUBLE PRECISION ANORM,S,DASUM,SM,YNORM
      INTEGER I,INFO,J,JU,K,KB,KP1,L,LDB,LM,LZ,M,ML1,MM,NL,NU
C***FIRST EXECUTABLE STATEMENT  DNBCO
      ML1=ML+1
      LDB = LDA - 1
      ANORM = 0.0D0
      DO 10 J = 1, N
        NU = MIN(MU,J-1)
        NL = MIN(ML,N-J)
        L = 1 + NU + NL
        ANORM = MAX(ANORM,DASUM(L,ABE(J+NL,ML1-NL),LDB))
   10 CONTINUE
C
C     FACTOR
C
      CALL DNBFA(ABE,LDA,N,ML,MU,IPVT,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE  A*Z = Y  AND TRANS(A)*Y = E .
C     TRANS(A)  IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF  W WHERE
C     TRANS(U)*W = E .  THE VECTORS ARE FREQUENTLY RESCALED TO AVOID
C     OVERFLOW.
C
C     SOLVE TRANS(U)*W = E
C
      EK = 1.0D0
      DO 20 J = 1, N
        Z(J) = 0.0D0
   20 CONTINUE
      M = ML + MU + 1
      JU = 0
      DO 100 K = 1, N
        IF (Z(K) .NE. 0.0D0) EK = SIGN(EK,-Z(K))
        IF (ABS(EK-Z(K)) .LE. ABS(ABE(K,ML1))) GO TO 30
          S = ABS(ABE(K,ML1))/ABS(EK-Z(K))
          CALL DSCAL(N,S,Z,1)
          EK = S*EK
   30   CONTINUE
        WK = EK - Z(K)
        WKM = -EK - Z(K)
        S = ABS(WK)
        SM = ABS(WKM)
        IF (ABE(K,ML1) .EQ. 0.0D0) GO TO 40
          WK = WK/ABE(K,ML1)
          WKM = WKM/ABE(K,ML1)
        GO TO 50
   40   CONTINUE
          WK = 1.0D0
          WKM = 1.0D0
   50   CONTINUE
        KP1 = K + 1
        JU = MIN(MAX(JU,MU+IPVT(K)),N)
        MM = ML1
        IF (KP1 .GT. JU) GO TO 90
          DO 60 I = KP1, JU
            MM = MM + 1
            SM = SM + ABS(Z(I)+WKM*ABE(K,MM))
            Z(I) = Z(I) + WK*ABE(K,MM)
            S = S + ABS(Z(I))
   60     CONTINUE
          IF (S .GE. SM) GO TO 80
            T = WKM -WK
            WK = WKM
            MM = ML1
            DO 70 I = KP1, JU
              MM = MM + 1
              Z(I) = Z(I) + T*ABE(K,MM)
   70       CONTINUE
   80     CONTINUE
   90   CONTINUE
      Z(K) = WK
  100 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
C
C     SOLVE TRANS(L)*Y = W
C
      DO 120 KB = 1, N
        K = N + 1 - KB
        NL = MIN(ML,N-K)
        IF (K .LT. N) Z(K) = Z(K) + DDOT(NL,ABE(K+NL,ML1-NL),-LDB,Z(K+1)
     1  ,1)
        IF (ABS(Z(K)) .LE. 1.0D0) GO TO 110
          S = 1.0D0/ABS(Z(K))
          CALL DSCAL(N,S,Z,1)
  110   CONTINUE
        L = IPVT(K)
        T = Z(L)
        Z(L) = Z(K)
        Z(K) = T
  120 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
C
      YNORM = 1.0D0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
        L = IPVT(K)
        T = Z(L)
        Z(L) = Z(K)
        Z(K) = T
        NL = MIN(ML,N-K)
        IF (K .LT. N) CALL DAXPY(NL,T,ABE(K+NL,ML1-NL),-LDB,Z(K+1),1)
        IF (ABS(Z(K)) .LE. 1.0D0) GO TO 130
          S = 1.0D0/ABS(Z(K))
          CALL DSCAL(N,S,Z,1)
          YNORM = S*YNORM
  130   CONTINUE
  140 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = V
C
      DO 160 KB = 1, N
        K = N + 1 - KB
        IF (ABS(Z(K)) .LE. ABS(ABE(K,ML1))) GO TO 150
          S = ABS(ABE(K,ML1))/ABS(Z(K))
          CALL DSCAL(N,S,Z,1)
          YNORM = S*YNORM
  150   CONTINUE
        IF (ABE(K,ML1) .NE. 0.0D0) Z(K) = Z(K)/ABE(K,ML1)
        IF (ABE(K,ML1) .EQ. 0.0D0) Z(K) = 1.0D0
        LM = MIN(K,M) - 1
        LZ = K - LM
        T = -Z(K)
        CALL DAXPY(LM,T,ABE(K-1,ML+2),-LDB,Z(LZ),1)
  160 CONTINUE
C     MAKE ZNORM = 1.0D0
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0D0) RCOND = YNORM/ANORM
      IF (ANORM .EQ. 0.0D0) RCOND = 0.0D0
      RETURN
      END
*DECK DNBDI
      SUBROUTINE DNBDI (ABE, LDA, N, ML, MU, IPVT, DET)
C***BEGIN PROLOGUE  DNBDI
C***PURPOSE  Compute the determinant of a band matrix using the factors
C            computed by DNBCO or DNBFA.
C***LIBRARY   SLATEC
C***CATEGORY  D3A2
C***TYPE      DOUBLE PRECISION (SNBDI-S, DNBDI-D, CNBDI-C)
C***KEYWORDS  BANDED, DETERMINANT, LINEAR EQUATIONS, NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     DNBDI computes the determinant of a band matrix
C     using the factors computed by DNBCO or DNBFA.
C     If the inverse is needed, use DNBSL  N  times.
C
C     On Entry
C
C        ABE     DOUBLE PRECISION(LDA, NC)
C                the output from DNBCO or DNBFA.
C                NC must be .GE. 2*ML+MU+1 .
C
C        LDA     INTEGER
C                the leading dimension of the array  ABE .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from DNBCO or DNBFA.
C
C     On Return
C
C        DET     DOUBLE PRECISION(2)
C                determinant of original matrix.
C                Determinant = DET(1) * 10.0**DET(2)
C                with  1.0 .LE. ABS(DET(1)) .LT. 10.0
C                or  DET(1) = 0.0 .
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   800728  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNBDI
      INTEGER LDA,N,ML,MU,IPVT(*)
      DOUBLE PRECISION ABE(LDA,*),DET(2)
C
      DOUBLE PRECISION TEN
      INTEGER I
C***FIRST EXECUTABLE STATEMENT  DNBDI
      DET(1) = 1.0D0
      DET(2) = 0.0D0
      TEN = 10.0D0
      DO 50 I = 1, N
         IF (IPVT(I) .NE. I) DET(1) = -DET(1)
         DET(1) = ABE(I,ML+1)*DET(1)
         IF (DET(1) .EQ. 0.0D0) GO TO 60
   10    IF (ABS(DET(1)) .GE. 1.0D0) GO TO 20
            DET(1) = TEN*DET(1)
            DET(2) = DET(2) - 1.0D0
         GO TO 10
   20    CONTINUE
   30    IF (ABS(DET(1)) .LT. TEN) GO TO 40
            DET(1) = DET(1)/TEN
            DET(2) = DET(2) + 1.0D0
         GO TO 30
   40    CONTINUE
   50 CONTINUE
   60 CONTINUE
      RETURN
      END
*DECK DNBFA
      SUBROUTINE DNBFA (ABE, LDA, N, ML, MU, IPVT, INFO)
C***BEGIN PROLOGUE  DNBFA
C***PURPOSE  Factor a band matrix by elimination.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      DOUBLE PRECISION (SNBFA-S, DNBFA-D, CNBFA-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, MATRIX FACTORIZATION,
C             NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     DNBFA factors a double precision band matrix by elimination.
C
C     DNBFA is usually called by DNBCO, but it can be called
C     directly with a saving in time if RCOND is not needed.
C
C     On Entry
C
C        ABE     DOUBLE PRECISION(LDA, NC)
C                contains the matrix in band storage.  The rows
C                of the original matrix are stored in the rows
C                of ABE and the diagonals of the original matrix
C                are stored in columns 1 through ML+MU+1 of ABE.
C                NC must be .GE. 2*ML+MU+1 .
C                See the comments below for details.
C
C        LDA     INTEGER
C                the leading dimension of the array ABE.
C                LDA must be .GE.  N .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C                0 .LE. ML .LT.  N .
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C                0 .LE. MU .LT.  N .
C                More efficient if ML .LE. MU .
C
C     On Return
C
C        ABE     an upper triangular matrix in band storage
C                and the multipliers which were used to obtain it.
C                The factorization can be written  A = L*U  where
C                L is a product of permutation and unit lower
C                triangular matrices and  U  is upper triangular.
C
C        IPVT    INTEGER(N)
C                an integer vector of pivot indices.
C
C        INFO    INTEGER
C                =0  normal value
C                =K  if  U(K,K) .EQ. 0.0 .  This is not an error
C                condition for this subroutine, but it does
C                indicate that DNBSL will divide by zero if
C                called.  Use RCOND in DNBCO for a reliable
C                indication of singularity.
C
C     Band Storage
C
C           If  A  is a band matrix, the following program segment
C           will set up the input.
C
C                   ML = (band width below the diagonal)
C                   MU = (band width above the diagonal)
C                   DO 20 I = 1, N
C                      J1 = MAX(1, I-ML)
C                      J2 = MIN(N, I+MU)
C                      DO 10 J = J1, J2
C                         K = J - I + ML + 1
C                         ABE(I,K) = A(I,J)
C                10    CONTINUE
C                20 CONTINUE
C
C           This uses columns  1  through  ML+MU+1  of ABE .
C           Furthermore,  ML  additional columns are needed in
C           ABE  starting with column  ML+MU+2  for elements
C           generated during the triangularization.  The total
C           number of columns needed in  ABE  is  2*ML+MU+1 .
C
C     Example:  If the original matrix is
C
C           11 12 13  0  0  0
C           21 22 23 24  0  0
C            0 32 33 34 35  0
C            0  0 43 44 45 46
C            0  0  0 54 55 56
C            0  0  0  0 65 66
C
C      then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C            * 11 12 13  +     , * = not used
C           21 22 23 24  +     , + = used for pivoting
C           32 33 34 35  +
C           43 44 45 46  +
C           54 55 56  *  +
C           65 66  *  *  +
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DAXPY, DSCAL, DSWAP, IDAMAX
C***REVISION HISTORY  (YYMMDD)
C   800728  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNBFA
      INTEGER LDA,N,ML,MU,IPVT(*),INFO
      DOUBLE PRECISION ABE(LDA,*)
C
      INTEGER ML1,MB,M,N1,LDB,I,J,K,L,LM,LM1,LM2,MP,IDAMAX
      DOUBLE PRECISION T
C***FIRST EXECUTABLE STATEMENT  DNBFA
      ML1=ML+1
      MB=ML+MU
      M=ML+MU+1
      N1=N-1
      LDB=LDA-1
      INFO=0
C
C     SET FILL-IN COLUMNS TO ZERO
C
      IF(N.LE.1)GO TO 50
      IF(ML.LE.0)GO TO 7
      DO 6 J=1,ML
        DO 5 I=1,N
          ABE(I,M+J)=0.0D0
    5   CONTINUE
    6 CONTINUE
    7 CONTINUE
C
C     GAUSSIAN ELIMINATION WITH PARTIAL ELIMINATION
C
      DO 40 K=1,N1
        LM=MIN(N-K,ML)
        LM1=LM+1
        LM2=ML1-LM
C
C     SEARCH FOR PIVOT INDEX
C
        L=-IDAMAX(LM1,ABE(LM+K,LM2),LDB)+LM1+K
        IPVT(K)=L
        MP=MIN(MB,N-K)
C
C     SWAP ROWS IF NECESSARY
C
        IF(L.NE.K)CALL DSWAP(MP+1,ABE(K,ML1),LDA,ABE(L,ML1+K-L),LDA)
C
C     SKIP COLUMN REDUCTION IF PIVOT IS ZERO
C
        IF(ABE(K,ML1).EQ.0.0D0) GO TO 20
C
C     COMPUTE MULTIPLIERS
C
        T=-1.0/ABE(K,ML1)
        CALL DSCAL(LM,T,ABE(LM+K,LM2),LDB)
C
C     ROW ELIMINATION WITH COLUMN INDEXING
C
        DO 10 J=1,MP
          CALL DAXPY (LM,ABE(K,ML1+J),ABE(LM+K,LM2),LDB,ABE(LM+K,LM2+J),
     1                LDB)
   10   CONTINUE
        GO TO 30
   20   CONTINUE
        INFO=K
   30   CONTINUE
   40 CONTINUE
   50 CONTINUE
      IPVT(N)=N
      IF(ABE(N,ML1).EQ.0.0D0) INFO=N
      RETURN
      END
*DECK DNBFS
      SUBROUTINE DNBFS (ABE, LDA, N, ML, MU, V, ITASK, IND, WORK, IWORK)
C***BEGIN PROLOGUE  DNBFS
C***PURPOSE  Solve a general nonsymmetric banded system of linear
C            equations.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      DOUBLE PRECISION (SNBFS-S, DNBFS-D, CNBFS-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, NONSYMMETRIC
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C    Subroutine DNBFS solves a general nonsymmetric banded NxN
C    system of double precision real linear equations using
C    SLATEC subroutines DNBCO and DNBSL.  These are adaptations
C    of the LINPACK subroutines DGBCO and DGBSL which require
C    a different format for storing the matrix elements.  If
C    A  is an NxN double precision matrix and if  X  and  B  are
C    double precision N-vectors, then DNBFS solves the equation
C
C                          A*X=B.
C
C    A band matrix is a matrix whose nonzero elements are all
C    fairly near the main diagonal, specifically  A(I,J) = 0
C    if  I-J is greater than  ML  or  J-I  is greater than
C    MU .  The integers ML and MU are called the lower and upper
C    band widths and  M = ML+MU+1  is the total band width.
C    DNBFS uses less time and storage than the corresponding
C    program for general matrices (DGEFS) if 2*ML+MU .LT.  N .
C
C    The matrix A is first factored into upper and lower tri-
C    angular matrices U and L using partial pivoting.  These
C    factors and the pivoting information are used to find the
C    solution vector X.  An approximate condition number is
C    calculated to provide a rough estimate of the number of
C    digits of accuracy in the computed solution.
C
C    If the equation A*X=B is to be solved for more than one vector
C    B, the factoring of A does not need to be performed again and
C    the option to only solve (ITASK .GT. 1) will be faster for
C    the succeeding solutions.  In this case, the contents of A,
C    LDA, N and IWORK must not have been altered by the user follow-
C    ing factorization (ITASK=1).  IND will not be changed by DNBFS
C    in this case.
C
C
C    Band Storage
C
C          If  A  is a band matrix, the following program segment
C          will set up the input.
C
C                  ML = (band width below the diagonal)
C                  MU = (band width above the diagonal)
C                  DO 20 I = 1, N
C                     J1 = MAX(1, I-ML)
C                     J2 = MIN(N, I+MU)
C                     DO 10 J = J1, J2
C                        K = J - I + ML + 1
C                        ABE(I,K) = A(I,J)
C               10    CONTINUE
C               20 CONTINUE
C
C          This uses columns  1  through  ML+MU+1  of ABE .
C          Furthermore,  ML  additional columns are needed in
C          ABE  starting with column  ML+MU+2  for elements
C          generated during the triangularization.  The total
C          number of columns needed in  ABE  is  2*ML+MU+1 .
C
C    Example:  If the original matrix is
C
C          11 12 13  0  0  0
C          21 22 23 24  0  0
C           0 32 33 34 35  0
C           0  0 43 44 45 46
C           0  0  0 54 55 56
C           0  0  0  0 65 66
C
C     then  N = 6, ML = 1, MU = 2, LDA .GE. 5  and ABE should contain
C
C           * 11 12 13  +     , * = not used
C          21 22 23 24  +     , + = used for pivoting
C          32 33 34 35  +
C          43 44 45 46  +
C          54 55 56  *  +
C          65 66  *  *  +
C
C
C  Argument Description ***
C
C    ABE    DOUBLE PRECISION(LDA,NC)
C             on entry, contains the matrix in band storage as
C               described above.  NC  must not be less than
C               2*ML+MU+1 .  The user is cautioned to specify  NC
C               with care since it is not an argument and cannot
C               be checked by DNBFS.  The rows of the original
C               matrix are stored in the rows of  ABE  and the
C               diagonals of the original matrix are stored in
C               columns  1  through  ML+MU+1  of  ABE .
C             on return, contains an upper triangular matrix U and
C               the multipliers necessary to construct a matrix L
C               so that A=L*U.
C    LDA    INTEGER
C             the leading dimension of array ABE.  LDA must be great-
C             er than or equal to N.  (terminal error message IND=-1)
C    N      INTEGER
C             the order of the matrix A.  N must be greater
C             than or equal to 1 .  (terminal error message IND=-2)
C    ML     INTEGER
C             the number of diagonals below the main diagonal.
C             ML  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-5)
C    MU     INTEGER
C             the number of diagonals above the main diagonal.
C             MU  must not be less than zero nor greater than or
C             equal to  N .  (terminal error message IND=-6)
C    V      DOUBLE PRECISION(N)
C             on entry, the singly subscripted array(vector) of di-
C               mension N which contains the right hand side B of a
C               system of simultaneous linear equations A*X=B.
C             on return, V contains the solution vector, X .
C    ITASK  INTEGER
C             If ITASK=1, the matrix A is factored and then the
C               linear equation is solved.
C             If ITASK .GT. 1, the equation is solved using the existing
C               factored matrix A and IWORK.
C             If ITASK .LT. 1, then terminal error message IND=-3 is
C               printed.
C    IND    INTEGER
C             GT. 0  IND is a rough estimate of the number of digits
C                     of accuracy in the solution, X.
C             LT. 0  See error message corresponding to IND below.
C    WORK   DOUBLE PRECISION(N)
C             a singly subscripted array of dimension at least N.
C    IWORK  INTEGER(N)
C             a singly subscripted array of dimension at least N.
C
C  Error Messages Printed ***
C
C    IND=-1  terminal   N is greater than LDA.
C    IND=-2  terminal   N is less than 1.
C    IND=-3  terminal   ITASK is less than 1.
C    IND=-4  terminal   The matrix A is computationally singular.
C                         A solution has not been computed.
C    IND=-5  terminal   ML is less than zero or is greater than
C                         or equal to N .
C    IND=-6  terminal   MU is less than zero or is greater than
C                         or equal to N .
C    IND=-10 warning    The solution has no apparent significance.
C                         The solution may be inaccurate or the matrix
C                         A may be poorly scaled.
C
C               Note-  The above terminal(*fatal*) error messages are
C                      designed to be handled by XERMSG in which
C                      LEVEL=1 (recoverable) and IFLAG=2 .  LEVEL=0
C                      for warning error messages from XERMSG.  Unless
C                      the user provides otherwise, an error message
C                      will be printed followed by an abort.
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  D1MACH, DNBCO, DNBSL, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800812  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls, changed GOTOs to
C           IF-THEN-ELSEs.  (RWC)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNBFS
C
      INTEGER LDA,N,ITASK,IND,IWORK(*),ML,MU
      DOUBLE PRECISION ABE(LDA,*),V(*),WORK(*),D1MACH
      DOUBLE PRECISION RCOND
      CHARACTER*8 XERN1, XERN2
C***FIRST EXECUTABLE STATEMENT  DNBFS
      IF (LDA.LT.N) THEN
         IND = -1
         WRITE (XERN1, '(I8)') LDA
         WRITE (XERN2, '(I8)') N
         CALL XERMSG ('SLATEC', 'DNBFS', 'LDA = ' // XERN1 //
     *      ' IS LESS THAN N = ' // XERN2, -1, 1)
         RETURN
      ENDIF
C
      IF (N.LE.0) THEN
         IND = -2
         WRITE (XERN1, '(I8)') N
         CALL XERMSG ('SLATEC', 'DNBFS', 'N = ' // XERN1 //
     *      ' IS LESS THAN 1', -2, 1)
         RETURN
      ENDIF
C
      IF (ITASK.LT.1) THEN
         IND = -3
         WRITE (XERN1, '(I8)') ITASK
         CALL XERMSG ('SLATEC', 'DNBFS', 'ITASK = ' // XERN1 //
     *      ' IS LESS THAN 1', -3, 1)
         RETURN
      ENDIF
C
      IF (ML.LT.0 .OR. ML.GE.N) THEN
         IND = -5
         WRITE (XERN1, '(I8)') ML
         CALL XERMSG ('SLATEC', 'DNBFS',
     *      'ML = ' // XERN1 // ' IS OUT OF RANGE', -5, 1)
         RETURN
      ENDIF
C
      IF (MU.LT.0 .OR. MU.GE.N) THEN
         IND = -6
         WRITE (XERN1, '(I8)') MU
         CALL XERMSG ('SLATEC', 'DNBFS',
     *      'MU = ' // XERN1 // ' IS OUT OF RANGE', -6, 1)
         RETURN
      ENDIF
C
      IF (ITASK.EQ.1) THEN
C
C        FACTOR MATRIX A INTO LU
C
         CALL DNBCO(ABE,LDA,N,ML,MU,IWORK,RCOND,WORK)
C
C        CHECK FOR COMPUTATIONALLY SINGULAR MATRIX
C
         IF (RCOND.EQ.0.0D0) THEN
            IND = -4
            CALL XERMSG ('SLATEC', 'DNBFS',
     *         'SINGULAR MATRIX A - NO SOLUTION', -4, 1)
            RETURN
         ENDIF
C
C        COMPUTE IND (ESTIMATE OF NO. OF SIGNIFICANT DIGITS)
C        AND CHECK FOR IND GREATER THAN ZERO
C
         IND = -LOG10(D1MACH(4)/RCOND)
         IF (IND.LE.0) THEN
            IND = -10
            CALL XERMSG ('SLATEC', 'DNBFS',
     *         'SOLUTION MAY HAVE NO SIGNIFICANCE', -10, 0)
         ENDIF
      ENDIF
C
C     SOLVE AFTER FACTORING
C
      CALL DNBSL(ABE,LDA,N,ML,MU,IWORK,V,0)
      RETURN
      END
*DECK DNBSL
      SUBROUTINE DNBSL (ABE, LDA, N, ML, MU, IPVT, B, JOB)
C***BEGIN PROLOGUE  DNBSL
C***PURPOSE  Solve a real band system using the factors computed by
C            DNBCO or DNBFA.
C***LIBRARY   SLATEC
C***CATEGORY  D2A2
C***TYPE      DOUBLE PRECISION (SNBSL-S, DNBSL-D, CNBSL-C)
C***KEYWORDS  BANDED, LINEAR EQUATIONS, NONSYMMETRIC, SOLVE
C***AUTHOR  Voorhees, E. A., (LANL)
C***DESCRIPTION
C
C     DNBSL solves the double precision band system
C     A * X = B  or  TRANS(A) * X = B
C     using the factors computed by DNBCO or DNBFA.
C
C     On Entry
C
C        ABE     DOUBLE PRECISION(LDA, NC)
C                the output from DNBCO or DNBFA.
C                NC must be .GE. 2*ML+MU+1 .
C
C        LDA     INTEGER
C                the leading dimension of the array  ABE .
C
C        N       INTEGER
C                the order of the original matrix.
C
C        ML      INTEGER
C                number of diagonals below the main diagonal.
C
C        MU      INTEGER
C                number of diagonals above the main diagonal.
C
C        IPVT    INTEGER(N)
C                the pivot vector from DNBCO or DNBFA.
C
C        B       DOUBLE PRECISION(N)
C                the right hand side vector.
C
C        JOB     INTEGER
C                = 0         to solve  A*X = B .
C                = nonzero   to solve  TRANS(A)*X = B , where
C                            TRANS(A)  is the transpose.
C
C     On Return
C
C        B       the solution vector  X .
C
C     Error Condition
C
C        A division by zero will occur if the input factor contains a
C        zero on the diagonal.  Technically this indicates singularity
C        but it is often caused by improper arguments or improper
C        setting of LDA.  It will not occur if the subroutines are
C        called correctly and if DNBCO has set RCOND .GT. 0.0
C        or DNBFA has set INFO .EQ. 0 .
C
C     To compute  INVERSE(A) * C  where  C  is a matrix
C     with  P  columns
C           CALL DNBCO(ABE,LDA,N,ML,MU,IPVT,RCOND,Z)
C           IF (RCOND is too small) GO TO ...
C           DO 10 J = 1, P
C             CALL DNBSL(ABE,LDA,N,ML,MU,IPVT,C(1,J),0)
C        10 CONTINUE
C
C***REFERENCES  J. J. Dongarra, J. R. Bunch, C. B. Moler, and G. W.
C                 Stewart, LINPACK Users' Guide, SIAM, 1979.
C***ROUTINES CALLED  DAXPY, DDOT
C***REVISION HISTORY  (YYMMDD)
C   800728  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNBSL
      INTEGER LDA,N,ML,MU,IPVT(*),JOB
      DOUBLE PRECISION ABE(LDA,*),B(*)
C
      DOUBLE PRECISION DDOT,T
      INTEGER K,KB,L,LB,LDB,LM,M,MLM,NM1
C***FIRST EXECUTABLE STATEMENT  DNBSL
      M=MU+ML+1
      NM1=N-1
      LDB=1-LDA
      IF(JOB.NE.0)GO TO 50
C
C       JOB = 0 , SOLVE  A * X = B
C       FIRST SOLVE L*Y = B
C
        IF(ML.EQ.0)GO TO 30
        IF(NM1.LT.1)GO TO 30
          DO 20 K=1,NM1
            LM=MIN(ML,N-K)
            L=IPVT(K)
            T=B(L)
            IF(L.EQ.K)GO TO 10
              B(L)=B(K)
              B(K)=T
   10       CONTINUE
            MLM=ML-(LM-1)
            CALL DAXPY(LM,T,ABE(K+LM,MLM),LDB,B(K+1),1)
   20     CONTINUE
   30   CONTINUE
C
C       NOW SOLVE  U*X = Y
C
        DO 40 KB=1,N
          K=N+1-KB
          B(K)=B(K)/ABE(K,ML+1)
          LM=MIN(K,M)-1
          LB=K-LM
          T=-B(K)
          CALL DAXPY(LM,T,ABE(K-1,ML+2),LDB,B(LB),1)
   40   CONTINUE
      GO TO 100
   50 CONTINUE
C
C       JOB = NONZERO, SOLVE TRANS(A) * X = B
C       FIRST SOLVE  TRANS(U)*Y = B
C
        DO 60 K = 1, N
          LM = MIN(K,M) - 1
          LB = K - LM
          T = DDOT(LM,ABE(K-1,ML+2),LDB,B(LB),1)
          B(K) = (B(K) - T)/ABE(K,ML+1)
   60   CONTINUE
C
C       NOW SOLVE TRANS(L)*X = Y
C
        IF (ML .EQ. 0) GO TO 90
        IF (NM1 .LT. 1) GO TO 90
          DO 80 KB = 1, NM1
            K = N - KB
            LM = MIN(ML,N-K)
            MLM = ML - (LM - 1)
            B(K) = B(K) + DDOT(LM,ABE(K+LM,MLM),LDB,B(K+1),1)
            L = IPVT(K)
            IF (L .EQ. K) GO TO 70
              T = B(L)
              B(L) = B(K)
              B(K) = T
   70       CONTINUE
   80     CONTINUE
   90   CONTINUE
  100 CONTINUE
      RETURN
      END
*DECK DNLS1
      SUBROUTINE DNLS1 (FCN, IOPT, M, N, X, FVEC, FJAC, LDFJAC, FTOL,
     +   XTOL, GTOL, MAXFEV, EPSFCN, DIAG, MODE, FACTOR, NPRINT, INFO,
     +   NFEV, NJEV, IPVT, QTF, WA1, WA2, WA3, WA4)
C***BEGIN PROLOGUE  DNLS1
C***PURPOSE  Minimize the sum of the squares of M nonlinear functions
C            in N variables by a modification of the Levenberg-Marquardt
C            algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      DOUBLE PRECISION (SNLS1-S, DNLS1-D)
C***KEYWORDS  LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNLS1 is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  The user must provide a subrou-
C       tine which calculates the functions.  The user has the option
C       of how the Jacobian will be supplied.  The user can supply the
C       full Jacobian, or the rows of the Jacobian (to avoid storing
C       the full Jacobian), or let the code approximate the Jacobian by
C       forward-differencing.   This code is the combination of the
C       MINPACK codes (Argonne) LMDER, LMDIF, and LMSTR.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNLS1(FCN,IOPT,M,N,X,FVEC,FJAC,LDFJAC,FTOL,XTOL,
C      *                 GTOL,MAXFEV,EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO
C      *                 ,NFEV,NJEV,IPVT,QTF,WA1,WA2,WA3,WA4)
C       INTEGER IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV
C       INTEGER IPVT(N)
C       DOUBLE PRECISION FTOL,XTOL,GTOL,EPSFCN,FACTOR
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(LDFJAC,N),DIAG(N),QTF(N),
C      *     WA1(N),WA2(N),WA3(N),WA4(M)
C
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to DNLS1 and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNLS1.
C
C      FCN is the name of the user-supplied subroutine which calculate
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         DOUBLE PRECISION X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored       , if IOPT=1.
C         DOUBLE PRECISION FJAC(LDFJAC,N)      , if IOPT=2.
C         DOUBLE PRECISION FJAC(N)             , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNLS1.  In this case, set
C         IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       FJAC is an output array.  For IOPT=1 and 2, FJAC is an M by N
C         array.  For IOPT=3, FJAC is an N by N array.  The upper N by N
C         submatrix of FJAC contains an upper triangular matrix R with
C         diagonal elements of nonincreasing magnitude such that
C
C                T     T           T
C               P *(JAC *JAC)*P = R *R,
C
C         where P is a permutation matrix and JAC is the final calcu-
C         lated Jacobian.  Column J of P is column IPVT(J) (see below)
C         of the identity matrix.  The lower part of FJAC contains
C         information generated during the computation of R.
C
C       LDFJAC is a positive integer input variable which specifies
C         the leading dimension of the array FJAC.  For IOPT=1 and 2,
C         LDFJAC must not be less than M.  For IOPT=3, LDFJAC must not
C         be less than N.
C
C       FTOL is a non-negative input variable.  Termination occurs when
C         both the actual and predicted relative reductions in the sum
C         of squares are at most FTOL.  Therefore, FTOL measures the
C         relative error desired in the sum of squares.  Section 4 con-
C         tains more details about FTOL.
C
C       XTOL is a non-negative input variable.  Termination occurs when
C         the relative error between two consecutive iterates is at most
C         XTOL.  Therefore, XTOL measures the relative error desired in
C         the approximate solution.  Section 4 contains more details
C         about XTOL.
C
C       GTOL is a non-negative input variable.  Termination occurs when
C         the cosine of the angle between FVEC and any column of the
C         Jacobian is at most GTOL in absolute value.  Therefore, GTOL
C         measures the orthogonality desired between the function vector
C         and the columns of the Jacobian.  Section 4 contains more
C         details about GTOL.
C
C       MAXFEV is a positive integer input variable.  Termination occurs
C         when the number of calls to FCN to evaluate the functions
C         has reached MAXFEV.
C
C       EPSFCN is an input variable used in determining a suitable step
C         for the forward-difference approximation.  This approximation
C         assumes that the relative errors in the functions are of the
C         order of EPSFCN.  If EPSFCN is less than the machine preci-
C         sion, it is assumed that the relative errors in the functions
C         are of the order of the machine precision.  If IOPT=2 or 3,
C         then EPSFCN can be ignored (treat it as a dummy argument).
C
C       DIAG is an array of length N.  If MODE = 1 (see below), DIAG is
C         internally set.  If MODE = 2, DIAG must contain positive
C         entries that serve as implicit (multiplicative) scale factors
C         for the variables.
C
C       MODE is an integer input variable.  If MODE = 1, the variables
C         will be scaled internally.  If MODE = 2, the scaling is speci-
C         fied by the input DIAG.  Other values of MODE are equivalent
C         to MODE = 1.
C
C       FACTOR is a positive input variable used in determining the ini-
C         tial step bound.  This bound is set to the product of FACTOR
C         and the Euclidean norm of DIAG*X if nonzero, or else to FACTOR
C         itself.  In most cases FACTOR should lie in the interval
C         (.1,100.).  100. is a generally recommended value.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls to FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C        execution, INFO is set to the (negative) value of IFLAG.  See
C        description of FCN and JAC. Otherwise, INFO is set as follows
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  both actual and predicted relative reductions in the
C                   sum of squares are at most FTOL.
C
C         INFO = 2  relative error between two consecutive iterates is
C                   at most XTOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  the cosine of the angle between FVEC and any column
C                   of the Jacobian is at most GTOL in absolute value.
C
C         INFO = 5  number of calls to FCN for function evaluation
C                   has reached MAXFEV.
C
C         INFO = 6  FTOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  XTOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 8  GTOL is too small.  FVEC is orthogonal to the
C                   columns of the Jacobian to machine precision.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       NFEV is an integer output variable set to the number of calls to
C         FCN for function evaluation.
C
C       NJEV is an integer output variable set to the number of
C         evaluations of the full Jacobian.  If IOPT=2, only one call to
C         FCN is required for each evaluation of the full Jacobian.
C         If IOPT=3, the M calls to FCN are required.
C         If IOPT=1, then NJEV is set to zero.
C
C       IPVT is an integer output array of length N.  IPVT defines a
C         permutation matrix P such that JAC*P = Q*R, where JAC is the
C         final calculated Jacobian, Q is orthogonal (not stored), and R
C         is upper triangular with diagonal elements of nonincreasing
C         magnitude.  Column J of P is column IPVT(J) of the identity
C         matrix.
C
C       QTF is an output array of length N which contains the first N
C         elements of the vector (Q transpose)*FVEC.
C
C       WA1, WA2, and WA3 are work arrays of length N.
C
C       WA4 is a work array of length M.
C
C
C 4. Successful Completion.
C
C       The accuracy of DNLS1 is controlled by the convergence parame-
C       ters FTOL, XTOL, and GTOL.  These parameters are used in tests
C       which make three types of comparisons between the approximation
C       X and a solution XSOL.  DNLS1 terminates when any of the tests
C       is satisfied.  If any of the convergence parameters is less than
C       the machine precision (as defined by the function R1MACH(4)),
C       then DNLS1 only attempts to satisfy the test defined by the
C       machine precision.  Further progress is not usually possible.
C
C       The tests assume that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then DNLS1 may incorrectly indicate conver-
C       gence.  If the Jacobian is coded correctly or IOPT=1,
C       then the validity of the answer can be checked, for example, by
C       rerunning DNLS1 with tighter tolerances.
C
C       First Convergence Test.  If ENORM(Z) denotes the Euclidean norm
C         of a vector Z, then this test attempts to guarantee that
C
C               ENORM(FVEC) .LE. (1+FTOL)*ENORM(FVECS),
C
C         where FVECS denotes the functions evaluated at XSOL.  If this
C         condition is satisfied with FTOL = 10**(-K), then the final
C         residual norm ENORM(FVEC) has K significant decimal digits and
C         INFO is set to 1 (or to 3 if the second test is also satis-
C         fied).  Unless high precision solutions are required, the
C         recommended value for FTOL is the square root of the machine
C         precision.
C
C       Second Convergence Test.  If D is the diagonal matrix whose
C         entries are defined by the array DIAG, then this test attempts
C         to guarantee that
C
C               ENORM(D*(X-XSOL)) .LE. XTOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with XTOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 2 (or to 3 if the first test is also satis-
C         fied).  There is a danger that the smaller components of D*X
C         may have large relative errors, but if MODE = 1, then the
C         accuracy of the components of X is usually related to their
C         sensitivity.  Unless high precision solutions are required,
C         the recommended value for XTOL is the square root of the
C         machine precision.
C
C       Third Convergence Test.  This test is satisfied when the cosine
C         of the angle between FVEC and any column of the Jacobian at X
C         is at most GTOL in absolute value.  There is no clear rela-
C         tionship between this test and the accuracy of DNLS1, and
C         furthermore, the test is equally well satisfied at other crit-
C         ical points, namely maximizers and saddle points.  Therefore,
C         termination caused by this test (INFO = 4) should be examined
C         carefully.  The recommended value for GTOL is zero.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of DNLS1 can be due to improper input
C       parameters, arithmetic interrupts, or an excessive number of
C       function evaluations.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1
C         or IOPT .GT. 3, or N .LE. 0, or M .LT. N, or for IOPT=1 or 2
C         LDFJAC .LT. M, or for IOPT=3 LDFJAC .LT. N, or FTOL .LT. 0.E0,
C         or XTOL .LT. 0.E0, or GTOL .LT. 0.E0, or MAXFEV .LE. 0, or
C         FACTOR .LE. 0.E0.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by DNLS1.  In this
C         case, it may be possible to remedy the situation by rerunning
C         DNLS1 with a smaller value of FACTOR.
C
C       Excessive Number of Function Evaluations.  A reasonable value
C         for MAXFEV is 100*(N+1) for IOPT=2 or 3 and 200*(N+1) for
C         IOPT=1.  If the number of calls to FCN reaches MAXFEV, then
C         this indicates that the routine is converging very slowly
C         as measured by the progress of FVEC, and INFO is set to 5.
C         In this case, it may be helpful to restart DNLS1 with MODE
C         set to 1.
C
C
C 6. Characteristics of the Algorithm.
C
C       DNLS1 is a modification of the Levenberg-Marquardt algorithm.
C       Two of its main characteristics involve the proper use of
C       implicitly scaled variables (if MODE = 1) and an optimal choice
C       for the correction.  The use of implicitly scaled variables
C       achieves scale invariance of DNLS1 and limits the size of the
C       correction in any direction where the functions are changing
C       rapidly.  The optimal choice of the correction guarantees (under
C       reasonable conditions) global convergence from starting points
C       far from the solution and a fast rate of convergence for
C       problems with small residuals.
C
C       Timing.  The time required by DNLS1 to solve a given problem
C         depends on M and N, the behavior of the functions, the accu-
C         racy requested, and the starting point.  The number of arith-
C         metic operations needed by DNLS1 is about N**3 to process each
C         evaluation of the functions (call to FCN) and to process each
C         evaluation of the Jacobian it takes M*N**2 for IOPT=2 (one
C         call to FCN), M*N**2 for IOPT=1 (N calls to FCN) and
C         1.5*M*N**2 for IOPT=3 (M calls to FCN).  Unless FCN
C         can be evaluated quickly, the timing of DNLS1 will be
C         strongly influenced by the time spent in FCN.
C
C       Storage.  DNLS1 requires (M*N + 2*M + 6*N) for IOPT=1 or 2 and
C         (N**2 + 2*M + 6*N) for IOPT=3 single precision storage
C         locations and N integer storage locations, in addition to
C         the storage required by the program.  There are no internally
C         declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), and X(3)
C       which provide the best fit (in the least squares sense) of
C
C             X(1) + U(I)/(V(I)*X(2) + W(I)*X(3)),  I = 1, 15
C
C       to the data
C
C             Y = (0.14,0.18,0.22,0.25,0.29,0.32,0.35,0.39,
C                  0.37,0.58,0.73,0.96,1.34,2.10,4.39),
C
C       where U(I) = I, V(I) = 16 - I, and W(I) = MIN(U(I),V(I)).  The
C       I-th component of FVEC is thus defined by
C
C             Y(I) - (X(1) + U(I)/(V(I)*X(2) + W(I)*X(3))).
C
C       **********
C
C       PROGRAM TEST
C C
C C     Driver for DNLS1 example.
C C
C       INTEGER J,IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV,
C      *        NWRITE
C       INTEGER IPVT(3)
C       DOUBLE PRECISION FTOL,XTOL,GTOL,FACTOR,FNORM,EPSFCN
C       DOUBLE PRECISION X(3),FVEC(15),FJAC(15,3),DIAG(3),QTF(3),
C      *     WA1(3),WA2(3),WA3(3),WA4(15)
C       DOUBLE PRECISION DENORM,D1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 1
C       M = 15
C       N = 3
C C
C C     The following starting values provide a rough fit.
C C
C       X(1) = 1.E0
C       X(2) = 1.E0
C       X(3) = 1.E0
C C
C       LDFJAC = 15
C C
C C     Set FTOL and XTOL to the square root of the machine precision
C C     and GTOL to zero.  Unless high precision solutions are
C C     required, these are the recommended settings.
C C
C       FTOL = SQRT(R1MACH(4))
C       XTOL = SQRT(R1MACH(4))
C       GTOL = 0.E0
C C
C       MAXFEV = 400
C       EPSFCN = 0.0
C       MODE = 1
C       FACTOR = 1.E2
C       NPRINT = 0
C C
C       CALL DNLS1(FCN,IOPT,M,N,X,FVEC,FJAC,LDFJAC,FTOL,XTOL,
C      *           GTOL,MAXFEV,EPSFCN,DIAG,MODE,FACTOR,NPRINT,
C      *           INFO,NFEV,NJEV,IPVT,QTF,WA1,WA2,WA3,WA4)
C       FNORM = ENORM(M,FVEC)
C       WRITE (NWRITE,1000) FNORM,NFEV,NJEV,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' NUMBER OF FUNCTION EVALUATIONS',I10 //
C      *        5X,' NUMBER OF JACOBIAN EVALUATIONS',I10 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // 5X,3E15.7)
C       END
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,DUM,IDUM)
C C     This is the form of the FCN routine if IOPT=1,
C C     that is, if the user does not calculate the Jacobian.
C       INTEGER I,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C       END
C
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.9063596E-01
C
C       NUMBER OF FUNCTION EVALUATIONS        25
C
C       NUMBER OF JACOBIAN EVALUATIONS         0
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C        0.8241058E-01  0.1133037E+01  0.2343695E+01
C
C
C       For IOPT=2, FCN would be modified as follows to also
C       calculate the full Jacobian when IFLAG=2.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C
C C     This is the form of the FCN routine if IOPT=2,
C C     that is, if the user calculates the full Jacobian.
C C
C       INTEGER I,LDFJAC,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(LDFJAC,N),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF(IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the full Jacobian.
C C
C    20    CONTINUE
C C
C       DO 30 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(I,1) = -1.E0
C          FJAC(I,2) = TMP1*TMP2/TMP4
C          FJAC(I,3) = TMP1*TMP3/TMP4
C    30    CONTINUE
C       RETURN
C       END
C
C
C       For IOPT = 3, FJAC would be dimensioned as FJAC(3,3),
C         LDFJAC would be set to 3, and FCN would be written as
C         follows to calculate a row of the Jacobian when IFLAG=3.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C     This is the form of the FCN routine if IOPT=3,
C C     that is, if the user calculates the Jacobian row by row.
C       INTEGER I,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(N),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF( IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the LDFJAC-th row of the Jacobian.
C C
C    20 CONTINUE
C
C       I = LDFJAC
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(1) = -1.E0
C          FJAC(2) = TMP1*TMP2/TMP4
C          FJAC(3) = TMP1*TMP3/TMP4
C       RETURN
C       END
C
C***REFERENCES  Jorge J. More, The Levenberg-Marquardt algorithm:
C                 implementation and theory.  In Numerical Analysis
C                 Proceedings (Dundee, June 28 - July 1, 1977, G. A.
C                 Watson, Editor), Lecture Notes in Mathematics 630,
C                 Springer-Verlag, 1978.
C***ROUTINES CALLED  D1MACH, DCKDER, DENORM, DFDJC3, DMPAR, DQRFAC,
C                    DWUPDT, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   900510  Convert XERRWV calls to XERMSG calls.  (RWC)
C   920205  Corrected XERN1 declaration.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNLS1
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER IOPT,M,N,LDFJAC,MAXFEV,MODE,NPRINT,INFO,NFEV,NJEV
      INTEGER IJUNK,NROW,IPVT(*)
      DOUBLE PRECISION FTOL,XTOL,GTOL,FACTOR,EPSFCN
      DOUBLE PRECISION X(*),FVEC(*),FJAC(LDFJAC,*),DIAG(*),QTF(*),
     1     WA1(*),WA2(*),WA3(*),WA4(*)
      LOGICAL SING
      EXTERNAL FCN
      INTEGER I,IFLAG,ITER,J,L,MODECH
      DOUBLE PRECISION ACTRED,DELTA,DIRDER,EPSMCH,FNORM,FNORM1,GNORM,
     1     ONE,PAR,PNORM,PRERED,P1,P5,P25,P75,P0001,RATIO,SUM,TEMP,
     2     TEMP1,TEMP2,XNORM,ZERO
      DOUBLE PRECISION D1MACH,DENORM,ERR,CHKLIM
      CHARACTER*8 XERN1
      CHARACTER*16 XERN3
      CHARACTER*80 MESSAGE
      SAVE CHKLIM, ONE, P1, P5, P25, P75, P0001, ZERO
C
      DATA CHKLIM/.1D0/
      DATA ONE,P1,P5,P25,P75,P0001,ZERO
     1     /1.0D0,1.0D-1,5.0D-1,2.5D-1,7.5D-1,1.0D-4,0.0D0/
C***FIRST EXECUTABLE STATEMENT  DNLS1
      EPSMCH = D1MACH(4)
C
      INFO = 0
      IFLAG = 0
      NFEV = 0
      NJEV = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 3 .OR. N .LE. 0 .OR.
     1    M .LT. N .OR. LDFJAC .LT. N .OR. FTOL .LT. ZERO
     2    .OR. XTOL .LT. ZERO .OR. GTOL .LT. ZERO
     3    .OR. MAXFEV .LE. 0 .OR. FACTOR .LE. ZERO) then
        Print *,'Iopt   ',iopt, '! 0 < iopt < 4'
        Print *,'N      ',n, '! 0 < N'
        Print *,'M      ',m, '!', N+1,' < M'
        Print *,'LDFJAC ',ldfjac, '!', N+1 ,' < LDFJAC'
        Print *,'FTOL   ',ftol,' ! > 0'
        Print *,'XTOL   ',xtol,' ! > 0'
        Print *,'GTOL   ',gtol,' ! > 0'
        Print *,'MAXFEV ',maxfev,' ! > 0'
        Print *,'FACTOR ',factor,' ! > 0'
        GO TO 300
      endif
      IF (IOPT .LT. 3 .AND. LDFJAC .LT. M) GO TO 300
      IF (MODE .NE. 2) GO TO 20
      DO 10 J = 1, N
         IF (DIAG(J) .LE. ZERO) GO TO 300
   10    CONTINUE
   20 CONTINUE
C
C     EVALUATE THE FUNCTION AT THE STARTING POINT
C     AND CALCULATE ITS NORM.
C
      IFLAG = 1
      IJUNK = 1
      CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
      NFEV = 1
      IF (IFLAG .LT. 0) GO TO 300
      FNORM = DENORM(M,FVEC)
C
C     INITIALIZE LEVENBERG-MARQUARDT PARAMETER AND ITERATION COUNTER.
C
      PAR = ZERO
      ITER = 1
C
C     BEGINNING OF THE OUTER LOOP.
C
   30 CONTINUE
C
C        IF REQUESTED, CALL FCN TO ENABLE PRINTING OF ITERATES.
C
         IF (NPRINT .LE. 0) GO TO 40
         IFLAG = 0
         IF (MOD(ITER-1,NPRINT) .EQ. 0)
     1      CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
         IF (IFLAG .LT. 0) GO TO 300
   40    CONTINUE
C
C        CALCULATE THE JACOBIAN MATRIX.
C
      IF (IOPT .EQ. 3) GO TO 475
C
C     STORE THE FULL JACOBIAN USING M*N STORAGE
C
      IF (IOPT .EQ. 1) GO TO 410
C
C     THE USER SUPPLIES THE JACOBIAN
C
         IFLAG = 2
         CALL FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
         NJEV = NJEV + 1
C
C             ON THE FIRST ITERATION, CHECK THE USER SUPPLIED JACOBIAN
C
         IF (ITER .LE. 1) THEN
            IF (IFLAG .LT. 0) GO TO 300
C
C           GET THE INCREMENTED X-VALUES INTO WA1(*).
C
            MODECH = 1
            CALL DCKDER(M,N,X,FVEC,FJAC,LDFJAC,WA1,WA4,MODECH,ERR)
C
C           EVALUATE FUNCTION AT INCREMENTED VALUE AND PUT IN WA4(*).
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA1,WA4,FJAC,LDFJAC)
            NFEV = NFEV + 1
            IF(IFLAG .LT. 0) GO TO 300
            DO 350 I = 1, M
               MODECH = 2
               CALL DCKDER(1,N,X,FVEC(I),FJAC(I,1),LDFJAC,WA1,
     1              WA4(I),MODECH,ERR)
               IF (ERR .LT. CHKLIM) THEN
                  WRITE (XERN1, '(I8)') I
                  WRITE (XERN3, '(1PE15.6)') ERR
                  MESSAGE =  'DERIVATIVE OF ' //
     *               'FUNCTION ' // XERN1 // ' MAY BE WRONG, ERR = ' //
     *               XERN3 // ' TOO CLOSE TO 0.'
                  CALL XERMSG ('SLATEC', 'DNLS1', MESSAGE, 7, 0)
               ENDIF
  350       CONTINUE
         ENDIF
C
         GO TO 420
C
C     THE CODE APPROXIMATES THE JACOBIAN
C
410      IFLAG = 1
         CALL DFDJC3(FCN,M,N,X,FVEC,FJAC,LDFJAC,IFLAG,EPSFCN,WA4)
         NFEV = NFEV + N
  420    IF (IFLAG .LT. 0) GO TO 300
C
C        COMPUTE THE QR FACTORIZATION OF THE JACOBIAN.
C
         CALL DQRFAC(M,N,FJAC,LDFJAC,.TRUE.,IPVT,N,WA1,WA2,WA3)
C
C        FORM (Q TRANSPOSE)*FVEC AND STORE THE FIRST N COMPONENTS IN
C        QTF.
C
         DO 430 I = 1, M
            WA4(I) = FVEC(I)
  430         CONTINUE
         DO 470 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) GO TO 460
            SUM = ZERO
            DO 440 I = J, M
               SUM = SUM + FJAC(I,J)*WA4(I)
  440          CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 450 I = J, M
               WA4(I) = WA4(I) + FJAC(I,J)*TEMP
  450          CONTINUE
  460       CONTINUE
            FJAC(J,J) = WA1(J)
            QTF(J) = WA4(J)
  470       CONTINUE
         GO TO 560
C
C        ACCUMULATE THE JACOBIAN BY ROWS IN ORDER TO SAVE STORAGE.
C        COMPUTE THE QR FACTORIZATION OF THE JACOBIAN MATRIX
C        CALCULATED ONE ROW AT A TIME, WHILE SIMULTANEOUSLY
C        FORMING (Q TRANSPOSE)*FVEC AND STORING THE FIRST
C        N COMPONENTS IN QTF.
C
  475    DO 490 J = 1, N
            QTF(J) = ZERO
            DO 480 I = 1, N
               FJAC(I,J) = ZERO
  480          CONTINUE
  490        CONTINUE
         DO 500 I = 1, M
            NROW = I
            IFLAG = 3
            CALL FCN(IFLAG,M,N,X,FVEC,WA3,NROW)
            IF (IFLAG .LT. 0) GO TO 300
C
C            ON THE FIRST ITERATION, CHECK THE USER SUPPLIED JACOBIAN.
C
            IF(ITER .GT. 1) GO TO 498
C
C            GET THE INCREMENTED X-VALUES INTO WA1(*).
C
            MODECH = 1
            CALL DCKDER(M,N,X,FVEC,FJAC,LDFJAC,WA1,WA4,MODECH,ERR)
C
C            EVALUATE AT INCREMENTED VALUES, IF NOT ALREADY EVALUATED.
C
            IF(I .NE. 1) GO TO 495
C
C            EVALUATE FUNCTION AT INCREMENTED VALUE AND PUT INTO WA4(*).
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA1,WA4,FJAC,NROW)
            NFEV = NFEV + 1
            IF(IFLAG .LT. 0) GO TO 300
495         CONTINUE
            MODECH = 2
            CALL DCKDER(1,N,X,FVEC(I),WA3,1,WA1,WA4(I),MODECH,ERR)
            IF (ERR .LT. CHKLIM) THEN
               WRITE (XERN1, '(I8)') I
               WRITE (XERN3, '(1PE15.6)') ERR
               CALL XERMSG ('SLATEC', 'DNLS1', 'DERIVATIVE OF FUNCTION '
     *            // XERN1 // ' MAY BE WRONG, ERR = ' // XERN3 //
     *            ' TOO CLOSE TO 0.', 7, 0)
            ENDIF
498         CONTINUE
C
            TEMP = FVEC(I)
            CALL DWUPDT(N,FJAC,LDFJAC,WA3,QTF,TEMP,WA1,WA2)
  500       CONTINUE
         NJEV = NJEV + 1
C
C        IF THE JACOBIAN IS RANK DEFICIENT, CALL DQRFAC TO
C        REORDER ITS COLUMNS AND UPDATE THE COMPONENTS OF QTF.
C
         SING = .FALSE.
         DO 510 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) SING = .TRUE.
            IPVT(J) = J
            WA2(J) = DENORM(J,FJAC(1,J))
  510       CONTINUE
         IF (.NOT.SING) GO TO 560
         CALL DQRFAC(N,N,FJAC,LDFJAC,.TRUE.,IPVT,N,WA1,WA2,WA3)
         DO 550 J = 1, N
            IF (FJAC(J,J) .EQ. ZERO) GO TO 540
            SUM = ZERO
            DO 520 I = J, N
               SUM = SUM + FJAC(I,J)*QTF(I)
  520         CONTINUE
            TEMP = -SUM/FJAC(J,J)
            DO 530 I = J, N
               QTF(I) = QTF(I) + FJAC(I,J)*TEMP
  530          CONTINUE
  540       CONTINUE
            FJAC(J,J) = WA1(J)
  550       CONTINUE
  560    CONTINUE
C
C        ON THE FIRST ITERATION AND IF MODE IS 1, SCALE ACCORDING
C        TO THE NORMS OF THE COLUMNS OF THE INITIAL JACOBIAN.
C
         IF (ITER .NE. 1) GO TO 80
         IF (MODE .EQ. 2) GO TO 60
         DO 50 J = 1, N
            DIAG(J) = WA2(J)
            IF (WA2(J) .EQ. ZERO) DIAG(J) = ONE
   50       CONTINUE
   60    CONTINUE
C
C        ON THE FIRST ITERATION, CALCULATE THE NORM OF THE SCALED X
C        AND INITIALIZE THE STEP BOUND DELTA.
C
         DO 70 J = 1, N
            WA3(J) = DIAG(J)*X(J)
   70       CONTINUE
         XNORM = DENORM(N,WA3)
         DELTA = FACTOR*XNORM
         IF (DELTA .EQ. ZERO) DELTA = FACTOR
   80    CONTINUE
C
C        COMPUTE THE NORM OF THE SCALED GRADIENT.
C
         GNORM = ZERO
         IF (FNORM .EQ. ZERO) GO TO 170
         DO 160 J = 1, N
            L = IPVT(J)
            IF (WA2(L) .EQ. ZERO) GO TO 150
            SUM = ZERO
            DO 140 I = 1, J
               SUM = SUM + FJAC(I,J)*(QTF(I)/FNORM)
  140          CONTINUE
            GNORM = MAX(GNORM,ABS(SUM/WA2(L)))
  150       CONTINUE
  160       CONTINUE
  170    CONTINUE
C
C        TEST FOR CONVERGENCE OF THE GRADIENT NORM.
C
         IF (GNORM .LE. GTOL) INFO = 4
         IF (INFO .NE. 0) GO TO 300
C
C        RESCALE IF NECESSARY.
C
         IF (MODE .EQ. 2) GO TO 190
         DO 180 J = 1, N
            DIAG(J) = MAX(DIAG(J),WA2(J))
  180       CONTINUE
  190    CONTINUE
C
C        BEGINNING OF THE INNER LOOP.
C
  200    CONTINUE
C
C           DETERMINE THE LEVENBERG-MARQUARDT PARAMETER.
C
            CALL DMPAR(N,FJAC,LDFJAC,IPVT,DIAG,QTF,DELTA,PAR,WA1,WA2,
     1                 WA3,WA4)
C
C           STORE THE DIRECTION P AND X + P. CALCULATE THE NORM OF P.
C
            DO 210 J = 1, N
               WA1(J) = -WA1(J)
               WA2(J) = X(J) + WA1(J)
               WA3(J) = DIAG(J)*WA1(J)
  210          CONTINUE
            PNORM = DENORM(N,WA3)
C
C           ON THE FIRST ITERATION, ADJUST THE INITIAL STEP BOUND.
C
            IF (ITER .EQ. 1) DELTA = MIN(DELTA,PNORM)
C
C           EVALUATE THE FUNCTION AT X + P AND CALCULATE ITS NORM.
C
            IFLAG = 1
            CALL FCN(IFLAG,M,N,WA2,WA4,FJAC,IJUNK)
            NFEV = NFEV + 1
            IF (IFLAG .LT. 0) GO TO 300
            FNORM1 = DENORM(M,WA4)
C
C           COMPUTE THE SCALED ACTUAL REDUCTION.
C
            ACTRED = -ONE
            IF (P1*FNORM1 .LT. FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C
C           COMPUTE THE SCALED PREDICTED REDUCTION AND
C           THE SCALED DIRECTIONAL DERIVATIVE.
C
            DO 230 J = 1, N
               WA3(J) = ZERO
               L = IPVT(J)
               TEMP = WA1(L)
               DO 220 I = 1, J
                  WA3(I) = WA3(I) + FJAC(I,J)*TEMP
  220             CONTINUE
  230          CONTINUE
            TEMP1 = DENORM(N,WA3)/FNORM
            TEMP2 = (SQRT(PAR)*PNORM)/FNORM
            PRERED = TEMP1**2 + TEMP2**2/P5
            DIRDER = -(TEMP1**2 + TEMP2**2)
C
C           COMPUTE THE RATIO OF THE ACTUAL TO THE PREDICTED
C           REDUCTION.
C
            RATIO = ZERO
            IF (PRERED .NE. ZERO) RATIO = ACTRED/PRERED
C
C           UPDATE THE STEP BOUND.
C
            IF (RATIO .GT. P25) GO TO 240
               IF (ACTRED .GE. ZERO) TEMP = P5
               IF (ACTRED .LT. ZERO)
     1            TEMP = P5*DIRDER/(DIRDER + P5*ACTRED)
               IF (P1*FNORM1 .GE. FNORM .OR. TEMP .LT. P1) TEMP = P1
               DELTA = TEMP*MIN(DELTA,PNORM/P1)
               PAR = PAR/TEMP
               GO TO 260
  240       CONTINUE
               IF (PAR .NE. ZERO .AND. RATIO .LT. P75) GO TO 250
               DELTA = PNORM/P5
               PAR = P5*PAR
  250          CONTINUE
  260       CONTINUE
C
C           TEST FOR SUCCESSFUL ITERATION.
C
            IF (RATIO .LT. P0001) GO TO 290
C
C           SUCCESSFUL ITERATION. UPDATE X, FVEC, AND THEIR NORMS.
C
            DO 270 J = 1, N
               X(J) = WA2(J)
               WA2(J) = DIAG(J)*X(J)
  270          CONTINUE
            DO 280 I = 1, M
               FVEC(I) = WA4(I)
  280          CONTINUE
            XNORM = DENORM(N,WA2)
            FNORM = FNORM1
            ITER = ITER + 1
  290       CONTINUE
C
C           TESTS FOR CONVERGENCE.
C
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     1          .AND. P5*RATIO .LE. ONE) INFO = 1
            IF (DELTA .LE. XTOL*XNORM) INFO = 2
            IF (ABS(ACTRED) .LE. FTOL .AND. PRERED .LE. FTOL
     1          .AND. P5*RATIO .LE. ONE .AND. INFO .EQ. 2) INFO = 3
            IF (INFO .NE. 0) GO TO 300
C
C           TESTS FOR TERMINATION AND STRINGENT TOLERANCES.
C
            IF (NFEV .GE. MAXFEV) INFO = 5
            IF (ABS(ACTRED) .LE. EPSMCH .AND. PRERED .LE. EPSMCH
     1          .AND. P5*RATIO .LE. ONE) INFO = 6
            IF (DELTA .LE. EPSMCH*XNORM) INFO = 7
            IF (GNORM .LE. EPSMCH) INFO = 8
            IF (INFO .NE. 0) GO TO 300
C
C           END OF THE INNER LOOP. REPEAT IF ITERATION UNSUCCESSFUL.
C
            IF (RATIO .LT. P0001) GO TO 200
C
C        END OF THE OUTER LOOP.
C
         GO TO 30
  300 CONTINUE
C
C     TERMINATION, EITHER NORMAL OR USER IMPOSED.
C
      IF (IFLAG .LT. 0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT .GT. 0) CALL FCN(IFLAG,M,N,X,FVEC,FJAC,IJUNK)
      IF (INFO .LT. 0) CALL XERMSG ('SLATEC', 'DNLS1',
     +   'EXECUTION TERMINATED BECAUSE USER SET IFLAG NEGATIVE.', 1, 1)
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'DNLS1',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      IF (INFO .EQ. 4) CALL XERMSG ('SLATEC', 'DNLS1',
     +   'THIRD CONVERGENCE CONDITION, CHECK RESULTS BEFORE ACCEPTING.',
     +   1, 1)
      IF (INFO .EQ. 5) CALL XERMSG ('SLATEC', 'DNLS1',
     +   'TOO MANY FUNCTION EVALUATIONS.', 9, 1)
      IF (INFO .GE. 6) CALL XERMSG ('SLATEC', 'DNLS1',
     +   'TOLERANCES TOO SMALL, NO FURTHER IMPROVEMENT POSSIBLE.', 3, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE DNLS1.
C
      END
*DECK DNLS1E
      SUBROUTINE DNLS1E (FCN, IOPT, M, N, X, FVEC, TOL, NPRINT, INFO,
     +   IW, WA, LWA)
C***BEGIN PROLOGUE  DNLS1E
C***PURPOSE  An easy-to-use code which minimizes the sum of the squares
C            of M nonlinear functions in N variables by a modification
C            of the Levenberg-Marquardt algorithm.
C***LIBRARY   SLATEC
C***CATEGORY  K1B1A1, K1B1A2
C***TYPE      DOUBLE PRECISION (SNLS1E-S, DNLS1E-D)
C***KEYWORDS  EASY-TO-USE, LEVENBERG-MARQUARDT, NONLINEAR DATA FITTING,
C             NONLINEAR LEAST SQUARES
C***AUTHOR  Hiebert, K. L., (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNLS1E is to minimize the sum of the squares of M
C       nonlinear functions in N variables by a modification of the
C       Levenberg-Marquardt algorithm.  This is done by using the more
C       general least-squares solver DNLS1.  The user must provide a
C       subroutine which calculates the functions.  The user has the
C       option of how the Jacobian will be supplied.  The user can
C       supply the full Jacobian, or the rows of the Jacobian (to avoid
C       storing the full Jacobian), or let the code approximate the
C       Jacobian by forward-differencing.  This code is the combination
C       of the MINPACK codes (Argonne) LMDER1, LMDIF1, and LMSTR1.
C
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNLS1E(FCN,IOPT,M,N,X,FVEC,TOL,NPRINT,
C      *                  INFO,IW,WA,LWA)
C       INTEGER IOPT,M,N,NPRINT,INFO,LWAC,IW(N)
C       DOUBLE PRECISION TOL,X(N),FVEC(M),WA(LWA)
C       EXTERNAL FCN
C
C
C 3. Parameters. ALL TYPE REAL parameters are DOUBLE PRECISION
C
C       Parameters designated as input parameters must be specified on
C       entry to DNLS1E and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNLS1E.
C
C      FCN is the name of the user-supplied subroutine which calculates
C         the functions.  If the user wants to supply the Jacobian
C         (IOPT=2 or 3), then FCN must be written to calculate the
C         Jacobian, as well as the functions.  See the explanation
C         of the IOPT argument below.
C         If the user wants the iterates printed (NPRINT positive), then
C         FCN must do the printing.  See the explanation of NPRINT
C         below.  FCN must be declared in an EXTERNAL statement in the
C         calling program and should be written as follows.
C
C
C         SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C         INTEGER IFLAG,LDFJAC,M,N
C         DOUBLE PRECISION X(N),FVEC(M)
C         ----------
C         FJAC and LDFJAC may be ignored       , if IOPT=1.
C         DOUBLE PRECISION FJAC(LDFJAC,N)      , if IOPT=2.
C         DOUBLE PRECISION FJAC(N)             , if IOPT=3.
C         ----------
C           If IFLAG=0, the values in X and FVEC are available
C           for printing.  See the explanation of NPRINT below.
C           IFLAG will never be zero unless NPRINT is positive.
C           The values of X and FVEC must not be changed.
C         RETURN
C         ----------
C           If IFLAG=1, calculate the functions at X and return
C           this vector in FVEC.
C         RETURN
C         ----------
C           If IFLAG=2, calculate the full Jacobian at X and return
C           this matrix in FJAC.  Note that IFLAG will never be 2 unless
C           IOPT=2.  FVEC contains the function values at X and must
C           not be altered.  FJAC(I,J) must be set to the derivative
C           of FVEC(I) with respect to X(J).
C         RETURN
C         ----------
C           If IFLAG=3, calculate the LDFJAC-th row of the Jacobian
C           and return this vector in FJAC.  Note that IFLAG will
C           never be 3 unless IOPT=3.  FVEC contains the function
C           values at X and must not be altered.  FJAC(J) must be
C           set to the derivative of FVEC(LDFJAC) with respect to X(J).
C         RETURN
C         ----------
C         END
C
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNLS1E.  In this case,
C         set IFLAG to a negative integer.
C
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=2 or 3, then the user must supply the
C         Jacobian, as well as the function values, through the
C         subroutine FCN.  If IOPT=2, the user supplies the full
C         Jacobian with one call to FCN.  If IOPT=3, the user supplies
C         one row of the Jacobian with each call.  (In this manner,
C         storage can be saved because the full Jacobian is not stored.)
C         If IOPT=1, the code will approximate the Jacobian by forward
C         differencing.
C
C       M is a positive integer input variable set to the number of
C         functions.
C
C       N is a positive integer input variable set to the number of
C         variables.  N must not exceed M.
C
C       X is an array of length N.  On input, X must contain an initial
C         estimate of the solution vector.  On output, X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length M which contains the functions
C         evaluated at the output X.
C
C       TOL is a non-negative input variable.  Termination occurs when
C         the algorithm estimates either that the relative error in the
C         sum of squares is at most TOL or that the relative error
C         between X and the solution is at most TOL.  Section 4 contains
C         more details about TOL.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN (see example) and
C         FVEC should not be altered.  If NPRINT is not positive, no
C         special calls of FCN with IFLAG = 0 are made.
C
C       INFO is an integer output variable.  If the user has terminated
C        execution, INFO is set to the (negative) value of IFLAG.  See
C        description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  improper input parameters.
C
C         INFO = 1  algorithm estimates that the relative error in the
C                   sum of squares is at most TOL.
C
C         INFO = 2  algorithm estimates that the relative error between
C                   X and the solution is at most TOL.
C
C         INFO = 3  conditions for INFO = 1 and INFO = 2 both hold.
C
C         INFO = 4  FVEC is orthogonal to the columns of the Jacobian to
C                   machine precision.
C
C         INFO = 5  number of calls to FCN has reached 100*(N+1)
C                   for IOPT=2 or 3 or 200*(N+1) for IOPT=1.
C
C         INFO = 6  TOL is too small.  No further reduction in the sum
C                   of squares is possible.
C
C         INFO = 7  TOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       IW is an INTEGER work array of length N.
C
C       WA is a work array of length LWA.
C
C       LWA is a positive integer input variable not less than
C         N*(M+5)+M for IOPT=1 and 2 or N*(N+5)+M for IOPT=3.
C
C
C 4. Successful Completion.
C
C       The accuracy of DNLS1E is controlled by the convergence parame-
C       ter TOL.  This parameter is used in tests which make three types
C       of comparisons between the approximation X and a solution XSOL.
C       DNLS1E terminates when any of the tests is satisfied.  If TOL is
C       less than the machine precision (as defined by the function
C       R1MACH(4)), then DNLS1E only attempts to satisfy the test
C       defined by the machine precision.  Further progress is not usu-
C       ally possible.  Unless high precision solutions are required,
C       the recommended value for TOL is the square root of the machine
C       precision.
C
C       The tests assume that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then DNLS1E may incorrectly indicate conver-
C       gence.  If the Jacobian is coded correctly or IOPT=1,
C       then the validity of the answer can be checked, for example, by
C       rerunning DNLS1E with tighter tolerances.
C
C       First Convergence Test.  If ENORM(Z) denotes the Euclidean norm
C         of a vector Z, then this test attempts to guarantee that
C
C               ENORM(FVEC) .LE. (1+TOL)*ENORM(FVECS),
C
C         where FVECS denotes the functions evaluated at XSOL.  If this
C         condition is satisfied with TOL = 10**(-K), then the final
C         residual norm ENORM(FVEC) has K significant decimal digits and
C         INFO is set to 1 (or to 3 if the second test is also satis-
C         fied).
C
C       Second Convergence Test.  If D is a diagonal matrix (implicitly
C         generated by DNLS1E) whose entries contain scale factors for
C         the variables, then this test attempts to guarantee that
C
C               ENORM(D*(X-XSOL)) .LE.  TOL*ENORM(D*XSOL).
C
C         If this condition is satisfied with TOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 2 (or to 3 if the first test is also satis-
C         fied).  There is a danger that the smaller components of D*X
C         may have large relative errors, but the choice of D is such
C         that the accuracy of the components of X is usually related to
C         their sensitivity.
C
C       Third Convergence Test.  This test is satisfied when FVEC is
C         orthogonal to the columns of the Jacobian to machine preci-
C         sion.  There is no clear relationship between this test and
C         the accuracy of DNLS1E, and furthermore, the test is equally
C         well satisfied at other critical points, namely maximizers and
C         saddle points.  Therefore, termination caused by this test
C         (INFO = 4) should be examined carefully.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of DNLS1E can be due to improper input
C       parameters, arithmetic interrupts, or an excessive number of
C       function evaluations.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1
C         or IOPT .GT. 3, or N .LE. 0, or M .LT. N, or TOL .LT. 0.E0,
C         or for IOPT=1 or 2 LWA .LT. N*(M+5)+M, or for IOPT=3
C         LWA .LT. N*(N+5)+M.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by DNLS1E.  In this
C         case, it may be possible to remedy the situation by not evalu-
C         ating the functions here, but instead setting the components
C         of FVEC to numbers that exceed those in the initial FVEC.
C
C       Excessive Number of Function Evaluations.  If the number of
C         calls to FCN reaches 100*(N+1) for IOPT=2 or 3 or 200*(N+1)
C         for IOPT=1, then this indicates that the routine is converging
C         very slowly as measured by the progress of FVEC, and INFO is
C         set to 5.  In this case, it may be helpful to restart DNLS1E,
C         thereby forcing it to disregard old (and possibly harmful)
C         information.
C
C
C 6. Characteristics of the Algorithm.
C
C       DNLS1E is a modification of the Levenberg-Marquardt algorithm.
C       Two of its main characteristics involve the proper use of
C       implicitly scaled variables and an optimal choice for the cor-
C       rection.  The use of implicitly scaled variables achieves scale
C       invariance of DNLS1E and limits the size of the correction in
C       any direction where the functions are changing rapidly.  The
C       optimal choice of the correction guarantees (under reasonable
C       conditions) global convergence from starting points far from the
C       solution and a fast rate of convergence for problems with small
C       residuals.
C
C       Timing.  The time required by DNLS1E to solve a given problem
C         depends on M and N, the behavior of the functions, the accu-
C         racy requested, and the starting point.  The number of arith-
C         metic operations needed by DNLS1E is about N**3 to process
C         each evaluation of the functions (call to FCN) and to process
C         each evaluation of the Jacobian DNLS1E takes M*N**2 for IOPT=2
C         (one call to JAC), M*N**2 for IOPT=1 (N calls to FCN) and
C         1.5*M*N**2 for IOPT=3 (M calls to FCN).  Unless FCN
C         can be evaluated quickly, the timing of DNLS1E will be
C         strongly influenced by the time spent in FCN.
C
C       Storage.  DNLS1E requires (M*N + 2*M + 6*N) for IOPT=1 or 2 and
C         (N**2 + 2*M + 6*N) for IOPT=3 single precision storage
C         locations and N integer storage locations, in addition to
C         the storage required by the program.  There are no internally
C         declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), and X(3)
C       which provide the best fit (in the least squares sense) of
C
C             X(1) + U(I)/(V(I)*X(2) + W(I)*X(3)),  I = 1, 15
C
C       to the data
C
C             Y = (0.14,0.18,0.22,0.25,0.29,0.32,0.35,0.39,
C                  0.37,0.58,0.73,0.96,1.34,2.10,4.39),
C
C       where U(I) = I, V(I) = 16 - I, and W(I) = MIN(U(I),V(I)).  The
C       I-th component of FVEC is thus defined by
C
C             Y(I) - (X(1) + U(I)/(V(I)*X(2) + W(I)*X(3))).
C
C       **********
C
C       PROGRAM TEST
C C
C C     Driver for DNLS1E example.
C C
C       INTEGER I,IOPT,M,N,NPRINT,JNFO,LWA,NWRITE
C       INTEGER IW(3)
C       DOUBLE PRECISION TOL,FNORM,X(3),FVEC(15),WA(75)
C       DOUBLE PRECISION DENORM,D1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 1
C       M = 15
C       N = 3
C C
C C     The following starting values provide a rough fit.
C C
C       X(1) = 1.E0
C       X(2) = 1.E0
C       X(3) = 1.E0
C C
C       LWA = 75
C       NPRINT = 0
C C
C C     Set TOL to the square root of the machine precision.
C C     Unless high precision solutions are required,
C C     this is the recommended setting.
C C
C       TOL = SQRT(R1MACH(4))
C C
C       CALL DNLS1E(FCN,IOPT,M,N,X,FVEC,TOL,NPRINT,
C      *            INFO,IW,WA,LWA)
C       FNORM = ENORM(M,FVEC)
C       WRITE (NWRITE,1000) FNORM,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' EXIT
C      *        5X,' FINAL APPROXIMATE SOLUTION' // 5X,3E15.7)
C       END
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,DUM,IDUM)
C C     This is the form of the FCN routine if IOPT=1,
C C     that is, if the user does not calculate the Jacobian.
C       INTEGER I,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C       END
C
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.9063596E-01
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C        0.8241058E-01  0.1133037E+01  0.2343695E+01
C
C
C       For IOPT=2, FCN would be modified as follows to also
C       calculate the full Jacobian when IFLAG=2.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C
C C     This is the form of the FCN routine if IOPT=2,
C C     that is, if the user calculates the full Jacobian.
C C
C       INTEGER I,LDFJAC,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(LDFJAC,N),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF(IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the full Jacobian.
C C
C    20    CONTINUE
C C
C       DO 30 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(I,1) = -1.E0
C          FJAC(I,2) = TMP1*TMP2/TMP4
C          FJAC(I,3) = TMP1*TMP3/TMP4
C    30    CONTINUE
C       RETURN
C       END
C
C
C       For IOPT = 3, FJAC would be dimensioned as FJAC(3,3),
C         LDFJAC would be set to 3, and FCN would be written as
C         follows to calculate a row of the Jacobian when IFLAG=3.
C
C       SUBROUTINE FCN(IFLAG,M,N,X,FVEC,FJAC,LDFJAC)
C C     This is the form of the FCN routine if IOPT=3,
C C     that is, if the user calculates the Jacobian row by row.
C       INTEGER I,M,N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(M),FJAC(N),Y(15)
C       DOUBLE PRECISION TMP1,TMP2,TMP3,TMP4
C       DATA Y(1),Y(2),Y(3),Y(4),Y(5),Y(6),Y(7),Y(8),
C      *     Y(9),Y(10),Y(11),Y(12),Y(13),Y(14),Y(15)
C      *     /1.4E-1,1.8E-1,2.2E-1,2.5E-1,2.9E-1,3.2E-1,3.5E-1,3.9E-1,
C      *      3.7E-1,5.8E-1,7.3E-1,9.6E-1,1.34E0,2.1E0,4.39E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     Insert print statements here when NPRINT is positive.
C C
C       RETURN
C     5 CONTINUE
C       IF( IFLAG.NE.1) GO TO 20
C       DO 10 I = 1, M
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          FVEC(I) = Y(I) - (X(1) + TMP1/(X(2)*TMP2 + X(3)*TMP3))
C    10    CONTINUE
C       RETURN
C C
C C     Below, calculate the LDFJAC-th row of the Jacobian.
C C
C    20 CONTINUE
C
C       I = LDFJAC
C          TMP1 = I
C          TMP2 = 16 - I
C          TMP3 = TMP1
C          IF (I .GT. 8) TMP3 = TMP2
C          TMP4 = (X(2)*TMP2 + X(3)*TMP3)**2
C          FJAC(1) = -1.E0
C          FJAC(2) = TMP1*TMP2/TMP4
C          FJAC(3) = TMP1*TMP3/TMP4
C       RETURN
C       END
C
C***REFERENCES  Jorge J. More, The Levenberg-Marquardt algorithm:
C                 implementation and theory.  In Numerical Analysis
C                 Proceedings (Dundee, June 28 - July 1, 1977, G. A.
C                 Watson, Editor), Lecture Notes in Mathematics 630,
C                 Springer-Verlag, 1978.
C***ROUTINES CALLED  DNLS1, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   891006  Cosmetic changes to prologue.  (WRB)
C   891006  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNLS1E
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER M,N,NPRINT,INFO,LWA,IOPT
      INTEGER INDEX,IW(*)
      DOUBLE PRECISION TOL
      DOUBLE PRECISION X(*),FVEC(*),WA(*)
      EXTERNAL FCN
      INTEGER MAXFEV,MODE,NFEV,NJEV
      DOUBLE PRECISION FACTOR,FTOL,GTOL,XTOL,ZERO,EPSFCN
      SAVE FACTOR, ZERO
      DATA FACTOR,ZERO /1.0D2,0.0D0/
C***FIRST EXECUTABLE STATEMENT  DNLS1E
      INFO = 0
C
C     CHECK THE INPUT PARAMETERS FOR ERRORS.
C
      IF (IOPT .LT. 1 .OR. IOPT .GT. 3 .OR.
     1    N .LE. 0 .OR. M .LT. N .OR. TOL .LT. ZERO
     2    .OR. LWA .LT. N*(N+5) + M) THEN
        Print *,'LWA ',lwa,' not < M*(N+5) ',M,N,' N*(M+5) ',n*(m+5)
        GO TO 10
      ENDIF
      IF (IOPT .LT. 3 .AND. LWA .LT. N*(M+5) + M) GO TO 10
C
C     CALL DNLS1.
C
      MAXFEV = 100*(N + 1)
      IF (IOPT .EQ. 1) MAXFEV = 2*MAXFEV
      FTOL = TOL
      XTOL = TOL
      GTOL = ZERO
      EPSFCN = ZERO
      MODE = 1
      INDEX = 5*N+M
      CALL DNLS1(FCN,IOPT,M,N,X,FVEC,WA(INDEX+1),M,FTOL,XTOL,GTOL,
     1           MAXFEV,EPSFCN,WA(1),MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
     2           IW,WA(N+1),WA(2*N+1),WA(3*N+1),WA(4*N+1),WA(5*N+1))
      IF (INFO .EQ. 8) INFO = 4
   10 CONTINUE
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'DNLS1E',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE DNLS1E.
C
      END
*DECK DNSQ
      SUBROUTINE DNSQ (FCN, JAC, IOPT, N, X, FVEC, FJAC, LDFJAC, XTOL,
     +   MAXFEV, ML, MU, EPSFCN, DIAG, MODE, FACTOR, NPRINT, INFO, NFEV,
     +   NJEV, R, LR, QTF, WA1, WA2, WA3, WA4)
C***BEGIN PROLOGUE  DNSQ
C***PURPOSE  Find a zero of a system of a N nonlinear functions in N
C            variables by a modification of the Powell hybrid method.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      DOUBLE PRECISION (SNSQ-S, DNSQ-D)
C***KEYWORDS  NONLINEAR SQUARE SYSTEM, POWELL HYBRID METHOD, ZEROS
C***AUTHOR  Hiebert, K. L. (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNSQ is to find a zero of a system of N nonlinear
C       functions in N variables by a modification of the Powell
C       hybrid method.  The user must provide a subroutine which
C       calculates the functions.  The user has the option of either to
C       provide a subroutine which calculates the Jacobian or to let the
C       code calculate it by a forward-difference approximation.
C       This code is the combination of the MINPACK codes (Argonne)
C       HYBRD and HYBRDJ.
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNSQ(FCN,JAC,IOPT,N,X,FVEC,FJAC,LDFJAC,XTOL,MAXFEV,
C      *                 ML,MU,EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO,NFEV,
C      *                 NJEV,R,LR,QTF,WA1,WA2,WA3,WA4)
C       INTEGER IOPT,N,MAXFEV,ML,MU,MODE,NPRINT,INFO,NFEV,LDFJAC,NJEV,LR
C       DOUBLE PRECISION XTOL,EPSFCN,FACTOR
C       DOUBLE PRECISION
C       X(N),FVEC(N),DIAG(N),FJAC(LDFJAC,N),R(LR),QTF(N),
C      *     WA1(N),WA2(N),WA3(N),WA4(N)
C       EXTERNAL FCN,JAC
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to DNSQ and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNSQ.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  FCN must be declared in an EXTERNAL statement
C         in the user calling program, and should be written as follows.
C
C         SUBROUTINE FCN(N,X,FVEC,IFLAG)
C         INTEGER N,IFLAG
C         DOUBLE PRECISION X(N),FVEC(N)
C         ----------
C         CALCULATE THE FUNCTIONS AT X AND
C         RETURN THIS VECTOR IN FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNSQ.  In this case set
C         IFLAG to a negative integer.
C
C       JAC is the name of the user-supplied subroutine which calculates
C         the Jacobian.  If IOPT=1, then JAC must be declared in an
C         EXTERNAL statement in the user calling program, and should be
C         written as follows.
C
C         SUBROUTINE JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
C         INTEGER N,LDFJAC,IFLAG
C         DOUBLE PRECISION X(N),FVEC(N),FJAC(LDFJAC,N)
C         ----------
C         Calculate the Jacobian at X and return this
C         matrix in FJAC.  FVEC contains the function
C         values at X and should not be altered.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by JAC unless the
C         user wants to terminate execution of DNSQ.  In this case set
C         IFLAG to a negative integer.
C
C         If IOPT=2, JAC can be ignored (treat it as a dummy argument).
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=1, then the user must supply the
C         Jacobian through the subroutine JAC.  If IOPT=2, then the
C         code will approximate the Jacobian by forward-differencing.
C
C       N is a positive integer input variable set to the number of
C         functions and variables.
C
C       X is an array of length N.  On input X must contain an initial
C         estimate of the solution vector.  On output X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length N which contains the functions
C         evaluated at the output X.
C
C       FJAC is an output N by N array which contains the orthogonal
C         matrix Q produced by the QR factorization of the final
C         approximate Jacobian.
C
C       LDFJAC is a positive integer input variable not less than N
C         which specifies the leading dimension of the array FJAC.
C
C       XTOL is a nonnegative input variable.  Termination occurs when
C         the relative error between two consecutive iterates is at most
C         XTOL.  Therefore, XTOL measures the relative error desired in
C         the approximate solution.  Section 4 contains more details
C         about XTOL.
C
C       MAXFEV is a positive integer input variable.  Termination occurs
C         when the number of calls to FCN is at least MAXFEV by the end
C         of an iteration.
C
C       ML is a nonnegative integer input variable which specifies the
C         number of subdiagonals within the band of the Jacobian matrix.
C         If the Jacobian is not banded or IOPT=1, set ML to at
C         least N - 1.
C
C       MU is a nonnegative integer input variable which specifies the
C         number of superdiagonals within the band of the Jacobian
C         matrix.  If the Jacobian is not banded or IOPT=1, set MU to at
C         least N - 1.
C
C       EPSFCN is an input variable used in determining a suitable step
C         for the forward-difference approximation.  This approximation
C         assumes that the relative errors in the functions are of the
C         order of EPSFCN.  If EPSFCN is less than the machine
C         precision, it is assumed that the relative errors in the
C         functions are of the order of the machine precision.  If
C         IOPT=1, then EPSFCN can be ignored (treat it as a dummy
C         argument).
C
C       DIAG is an array of length N.  If MODE = 1 (see below), DIAG is
C         internally set.  If MODE = 2, DIAG must contain positive
C         entries that serve as implicit (multiplicative) scale factors
C         for the variables.
C
C       MODE is an integer input variable.  If MODE = 1, the variables
C         will be scaled internally.  If MODE = 2, the scaling is
C         specified by the input DIAG.  Other values of MODE are
C         equivalent to MODE = 1.
C
C       FACTOR is a positive input variable used in determining the
C         initial step bound.  This bound is set to the product of
C         FACTOR and the Euclidean norm of DIAG*X if nonzero, or else to
C         FACTOR itself.  In most cases FACTOR should lie in the
C         interval (.1,100.).  100. is a generally recommended value.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. appropriate
C         print statements must be added to FCN(see example).  If NPRINT
C         is not positive, no special calls of FCN with IFLAG = 0 are
C         made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  Improper input parameters.
C
C         INFO = 1  Relative error between two consecutive iterates is
C                   at most XTOL.
C
C         INFO = 2  Number of calls to FCN has reached or exceeded
C                   MAXFEV.
C
C         INFO = 3  XTOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 4  Iteration is not making good progress, as measured
C                   by the improvement from the last five Jacobian
C                   evaluations.
C
C         INFO = 5  Iteration is not making good progress, as measured
C                   by the improvement from the last ten iterations.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       NFEV is an integer output variable set to the number of calls to
C         FCN.
C
C       NJEV is an integer output variable set to the number of calls to
C         JAC. (If IOPT=2, then NJEV is set to zero.)
C
C       R is an output array of length LR which contains the upper
C         triangular matrix produced by the QR factorization of the
C         final approximate Jacobian, stored rowwise.
C
C       LR is a positive integer input variable not less than
C         (N*(N+1))/2.
C
C       QTF is an output array of length N which contains the vector
C         (Q transpose)*FVEC.
C
C       WA1, WA2, WA3, and WA4 are work arrays of length N.
C
C
C 4. Successful completion.
C
C       The accuracy of DNSQ is controlled by the convergence parameter
C       XTOL.  This parameter is used in a test which makes a comparison
C       between the approximation X and a solution XSOL.  DNSQ
C       terminates when the test is satisfied.  If the convergence
C       parameter is less than the machine precision (as defined by the
C       function D1MACH(4)), then DNSQ only attempts to satisfy the test
C       defined by the machine precision.  Further progress is not
C       usually possible.
C
C       The test assumes that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently.  If these conditions
C       are not satisfied, then DNSQ may incorrectly indicate
C       convergence.  The coding of the Jacobian can be checked by the
C       subroutine DCKDER. If the Jacobian is coded correctly or IOPT=2,
C       then the validity of the answer can be checked, for example, by
C       rerunning DNSQ with a tighter tolerance.
C
C       Convergence Test.  If DENORM(Z) denotes the Euclidean norm of a
C         vector Z and D is the diagonal matrix whose entries are
C         defined by the array DIAG, then this test attempts to
C         guarantee that
C
C               DENORM(D*(X-XSOL)) .LE. XTOL*DENORM(D*XSOL).
C
C         If this condition is satisfied with XTOL = 10**(-K), then the
C         larger components of D*X have K significant decimal digits and
C         INFO is set to 1.  There is a danger that the smaller
C         components of D*X may have large relative errors, but the fast
C         rate of convergence of DNSQ usually avoids this possibility.
C         Unless high precision solutions are required, the recommended
C         value for XTOL is the square root of the machine precision.
C
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of DNSQ can be due to improper input
C       parameters, arithmetic interrupts, an excessive number of
C       function evaluations, or lack of good progress.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT .1,
C         or IOPT .GT. 2, or N .LE. 0, or LDFJAC .LT. N, or
C         XTOL .LT. 0.E0, or MAXFEV .LE. 0, or ML .LT. 0, or MU .LT. 0,
C         or FACTOR .LE. 0.E0, or LR .LT. (N*(N+1))/2.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by DNSQ.  In this
C         case, it may be possible to remedy the situation by rerunning
C         DNSQ with a smaller value of FACTOR.
C
C       Excessive Number of Function Evaluations.  A reasonable value
C         for MAXFEV is 100*(N+1) for IOPT=1 and 200*(N+1) for IOPT=2.
C         If the number of calls to FCN reaches MAXFEV, then this
C         indicates that the routine is converging very slowly as
C         measured by the progress of FVEC, and INFO is set to 2. This
C         situation should be unusual because, as indicated below, lack
C         of good progress is usually diagnosed earlier by DNSQ,
C         causing termination with info = 4 or INFO = 5.
C
C       Lack of Good Progress.  DNSQ searches for a zero of the system
C         by minimizing the sum of the squares of the functions.  In so
C         doing, it can become trapped in a region where the minimum
C         does not correspond to a zero of the system and, in this
C         situation, the iteration eventually fails to make good
C         progress.  In particular, this will happen if the system does
C         not have a zero.  If the system has a zero, rerunning DNSQ
C         from a different starting point may be helpful.
C
C
C 6. Characteristics of The Algorithm.
C
C       DNSQ is a modification of the Powell Hybrid method.  Two of its
C       main characteristics involve the choice of the correction as a
C       convex combination of the Newton and scaled gradient directions,
C       and the updating of the Jacobian by the rank-1 method of
C       Broyden.  The choice of the correction guarantees (under
C       reasonable conditions) global convergence for starting points
C       far from the solution and a fast rate of convergence.  The
C       Jacobian is calculated at the starting point by either the
C       user-supplied subroutine or a forward-difference approximation,
C       but it is not recalculated until the rank-1 method fails to
C       produce satisfactory progress.
C
C       Timing.  The time required by DNSQ to solve a given problem
C         depends on N, the behavior of the functions, the accuracy
C         requested, and the starting point.  The number of arithmetic
C         operations needed by DNSQ is about 11.5*(N**2) to process
C         each evaluation of the functions (call to FCN) and 1.3*(N**3)
C         to process each evaluation of the Jacobian (call to JAC,
C         if IOPT = 1).  Unless FCN and JAC can be evaluated quickly,
C         the timing of DNSQ will be strongly influenced by the time
C         spent in FCN and JAC.
C
C       Storage.  DNSQ requires (3*N**2 + 17*N)/2 single precision
C         storage locations, in addition to the storage required by the
C         program.  There are no internally declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), ..., X(9),
C       which solve the system of tridiagonal equations
C
C       (3-2*X(1))*X(1)           -2*X(2)                   = -1
C               -X(I-1) + (3-2*X(I))*X(I)         -2*X(I+1) = -1, I=2-8
C                                   -X(8) + (3-2*X(9))*X(9) = -1
C C     **********
C
C       PROGRAM TEST
C C
C C     Driver for DNSQ example.
C C
C       INTEGER J,IOPT,N,MAXFEV,ML,MU,MODE,NPRINT,INFO,NFEV,LDFJAC,LR,
C      *        NWRITE
C       DOUBLE PRECISION XTOL,EPSFCN,FACTOR,FNORM
C       DOUBLE PRECISION X(9),FVEC(9),DIAG(9),FJAC(9,9),R(45),QTF(9),
C      *     WA1(9),WA2(9),WA3(9),WA4(9)
C       DOUBLE PRECISION DENORM,D1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 2
C       N = 9
C C
C C     THE FOLLOWING STARTING VALUES PROVIDE A ROUGH SOLUTION.
C C
C       DO 10 J = 1, 9
C          X(J) = -1.E0
C    10    CONTINUE
C C
C       LDFJAC = 9
C       LR = 45
C C
C C     SET XTOL TO THE SQUARE ROOT OF THE MACHINE PRECISION.
C C     UNLESS HIGH PRECISION SOLUTIONS ARE REQUIRED,
C C     THIS IS THE RECOMMENDED SETTING.
C C
C       XTOL = SQRT(D1MACH(4))
C C
C       MAXFEV = 2000
C       ML = 1
C       MU = 1
C       EPSFCN = 0.E0
C       MODE = 2
C       DO 20 J = 1, 9
C          DIAG(J) = 1.E0
C    20    CONTINUE
C       FACTOR = 1.E2
C       NPRINT = 0
C C
C       CALL DNSQ(FCN,JAC,IOPT,N,X,FVEC,FJAC,LDFJAC,XTOL,MAXFEV,ML,MU,
C      *           EPSFCN,DIAG,MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
C      *           R,LR,QTF,WA1,WA2,WA3,WA4)
C       FNORM = DENORM(N,FVEC)
C       WRITE (NWRITE,1000) FNORM,NFEV,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' NUMBER OF FUNCTION EVALUATIONS',I10 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // (5X,3E15.7))
C       END
C       SUBROUTINE FCN(N,X,FVEC,IFLAG)
C       INTEGER N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(N)
C       INTEGER K
C       DOUBLE PRECISION ONE,TEMP,TEMP1,TEMP2,THREE,TWO,ZERO
C       DATA ZERO,ONE,TWO,THREE /0.E0,1.E0,2.E0,3.E0/
C C
C       IF (IFLAG .NE. 0) GO TO 5
C C
C C     INSERT PRINT STATEMENTS HERE WHEN NPRINT IS POSITIVE.
C C
C       RETURN
C     5 CONTINUE
C       DO 10 K = 1, N
C          TEMP = (THREE - TWO*X(K))*X(K)
C          TEMP1 = ZERO
C          IF (K .NE. 1) TEMP1 = X(K-1)
C          TEMP2 = ZERO
C          IF (K .NE. N) TEMP2 = X(K+1)
C          FVEC(K) = TEMP - TEMP1 - TWO*TEMP2 + ONE
C    10    CONTINUE
C       RETURN
C       END
C
C       Results obtained with different compilers or machines
C       may be slightly different.
C
C       Final L2 norm of the residuals  0.1192636E-07
C
C       Number of function evaluations        14
C
C       Exit parameter                         1
C
C       Final approximate solution
C
C       -0.5706545E+00 -0.6816283E+00 -0.7017325E+00
C       -0.7042129E+00 -0.7013690E+00 -0.6918656E+00
C       -0.6657920E+00 -0.5960342E+00 -0.4164121E+00
C
C***REFERENCES  M. J. D. Powell, A hybrid method for nonlinear equa-
C                 tions. In Numerical Methods for Nonlinear Algebraic
C                 Equations, P. Rabinowitz, Editor.  Gordon and Breach,
C                 1988.
C***ROUTINES CALLED  D1MACH, D1MPYQ, D1UPDT, DDOGLG, DENORM, DFDJC1,
C                    DQFORM, DQRFAC, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNSQ
      DOUBLE PRECISION D1MACH,DENORM
      INTEGER I, IFLAG, INFO, IOPT, ITER, IWA(1), J, JM1, L, LDFJAC,
     1     LR, MAXFEV, ML, MODE, MU, N, NCFAIL, NCSUC, NFEV, NJEV,
     2     NPRINT, NSLOW1, NSLOW2
      DOUBLE PRECISION ACTRED, DELTA, DIAG(*), EPSFCN, EPSMCH, FACTOR,
     1     FJAC(LDFJAC,*), FNORM, FNORM1, FVEC(*), ONE, P0001, P001,
     2     P1, P5, PNORM, PRERED, QTF(*), R(*), RATIO, SUM, TEMP,
     3     WA1(*), WA2(*), WA3(*), WA4(*), X(*), XNORM, XTOL, ZERO
      EXTERNAL FCN
      LOGICAL JEVAL,SING
      SAVE ONE, P1, P5, P001, P0001, ZERO
      DATA ONE,P1,P5,P001,P0001,ZERO
     1     /1.0D0,1.0D-1,5.0D-1,1.0D-3,1.0D-4,0.0D0/
C
C     BEGIN BLOCK PERMITTING ...EXITS TO 320
C***FIRST EXECUTABLE STATEMENT  DNSQ
         EPSMCH = D1MACH(4)
C
         INFO = 0
         IFLAG = 0
         NFEV = 0
         NJEV = 0
C
C        CHECK THE INPUT PARAMETERS FOR ERRORS.
C
C     ...EXIT
         IF (IOPT .LT. 1 .OR. IOPT .GT. 2 .OR. N .LE. 0
     1       .OR. XTOL .LT. ZERO .OR. MAXFEV .LE. 0 .OR. ML .LT. 0
     2       .OR. MU .LT. 0 .OR. FACTOR .LE. ZERO .OR. LDFJAC .LT. N
     3       .OR. LR .LT. (N*(N + 1))/2) GO TO 320
         IF (MODE .NE. 2) GO TO 20
            DO 10 J = 1, N
C     .........EXIT
               IF (DIAG(J) .LE. ZERO) GO TO 320
   10       CONTINUE
   20    CONTINUE
C
C        EVALUATE THE FUNCTION AT THE STARTING POINT
C        AND CALCULATE ITS NORM.
C
         IFLAG = 1
         CALL FCN(N,X,FVEC,IFLAG)
         NFEV = 1
C     ...EXIT
         IF (IFLAG .LT. 0) GO TO 320
         FNORM = DENORM(N,FVEC)
C
C        INITIALIZE ITERATION COUNTER AND MONITORS.
C
         ITER = 1
         NCSUC = 0
         NCFAIL = 0
         NSLOW1 = 0
         NSLOW2 = 0
C
C        BEGINNING OF THE OUTER LOOP.
C
   30    CONTINUE
C           BEGIN BLOCK PERMITTING ...EXITS TO 90
               JEVAL = .TRUE.
C
C              CALCULATE THE JACOBIAN MATRIX.
C
               IF (IOPT .EQ. 2) GO TO 40
C
C                 USER SUPPLIES JACOBIAN
C
                  CALL JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
                  NJEV = NJEV + 1
               GO TO 50
   40          CONTINUE
C
C                 CODE APPROXIMATES THE JACOBIAN
C
                  IFLAG = 2
                  CALL DFDJC1(FCN,N,X,FVEC,FJAC,LDFJAC,IFLAG,ML,MU,
     1                        EPSFCN,WA1,WA2)
                  NFEV = NFEV + MIN(ML+MU+1,N)
   50          CONTINUE
C
C     .........EXIT
               IF (IFLAG .LT. 0) GO TO 320
C
C              COMPUTE THE QR FACTORIZATION OF THE JACOBIAN.
C
               CALL DQRFAC(N,N,FJAC,LDFJAC,.FALSE.,IWA,1,WA1,WA2,WA3)
C
C              ON THE FIRST ITERATION AND IF MODE IS 1, SCALE ACCORDING
C              TO THE NORMS OF THE COLUMNS OF THE INITIAL JACOBIAN.
C
C           ...EXIT
               IF (ITER .NE. 1) GO TO 90
               IF (MODE .EQ. 2) GO TO 70
                  DO 60 J = 1, N
                     DIAG(J) = WA2(J)
                     IF (WA2(J) .EQ. ZERO) DIAG(J) = ONE
   60             CONTINUE
   70          CONTINUE
C
C              ON THE FIRST ITERATION, CALCULATE THE NORM OF THE SCALED
C              X AND INITIALIZE THE STEP BOUND DELTA.
C
               DO 80 J = 1, N
                  WA3(J) = DIAG(J)*X(J)
   80          CONTINUE
               XNORM = DENORM(N,WA3)
               DELTA = FACTOR*XNORM
               IF (DELTA .EQ. ZERO) DELTA = FACTOR
   90       CONTINUE
C
C           FORM (Q TRANSPOSE)*FVEC AND STORE IN QTF.
C
            DO 100 I = 1, N
               QTF(I) = FVEC(I)
  100       CONTINUE
            DO 140 J = 1, N
               IF (FJAC(J,J) .EQ. ZERO) GO TO 130
                  SUM = ZERO
                  DO 110 I = J, N
                     SUM = SUM + FJAC(I,J)*QTF(I)
  110             CONTINUE
                  TEMP = -SUM/FJAC(J,J)
                  DO 120 I = J, N
                     QTF(I) = QTF(I) + FJAC(I,J)*TEMP
  120             CONTINUE
  130          CONTINUE
  140       CONTINUE
C
C           COPY THE TRIANGULAR FACTOR OF THE QR FACTORIZATION INTO R.
C
            SING = .FALSE.
            DO 170 J = 1, N
               L = J
               JM1 = J - 1
               IF (JM1 .LT. 1) GO TO 160
               DO 150 I = 1, JM1
                  R(L) = FJAC(I,J)
                  L = L + N - I
  150          CONTINUE
  160          CONTINUE
               R(L) = WA1(J)
               IF (WA1(J) .EQ. ZERO) SING = .TRUE.
  170       CONTINUE
C
C           ACCUMULATE THE ORTHOGONAL FACTOR IN FJAC.
C
            CALL DQFORM(N,N,FJAC,LDFJAC,WA1)
C
C           RESCALE IF NECESSARY.
C
            IF (MODE .EQ. 2) GO TO 190
               DO 180 J = 1, N
                  DIAG(J) = MAX(DIAG(J),WA2(J))
  180          CONTINUE
  190       CONTINUE
C
C           BEGINNING OF THE INNER LOOP.
C
  200       CONTINUE
C
C              IF REQUESTED, CALL FCN TO ENABLE PRINTING OF ITERATES.
C
               IF (NPRINT .LE. 0) GO TO 210
                  IFLAG = 0
                  IF (MOD(ITER-1,NPRINT) .EQ. 0)
     1               CALL FCN(N,X,FVEC,IFLAG)
C     ............EXIT
                  IF (IFLAG .LT. 0) GO TO 320
  210          CONTINUE
C
C              DETERMINE THE DIRECTION P.
C
               CALL DDOGLG(N,R,LR,DIAG,QTF,DELTA,WA1,WA2,WA3)
C
C              STORE THE DIRECTION P AND X + P. CALCULATE THE NORM OF P.
C
               DO 220 J = 1, N
                  WA1(J) = -WA1(J)
                  WA2(J) = X(J) + WA1(J)
                  WA3(J) = DIAG(J)*WA1(J)
  220          CONTINUE
               PNORM = DENORM(N,WA3)
C
C              ON THE FIRST ITERATION, ADJUST THE INITIAL STEP BOUND.
C
               IF (ITER .EQ. 1) DELTA = MIN(DELTA,PNORM)
C
C              EVALUATE THE FUNCTION AT X + P AND CALCULATE ITS NORM.
C
               IFLAG = 1
               CALL FCN(N,WA2,WA4,IFLAG)
               NFEV = NFEV + 1
C     .........EXIT
               IF (IFLAG .LT. 0) GO TO 320
               FNORM1 = DENORM(N,WA4)
C
C              COMPUTE THE SCALED ACTUAL REDUCTION.
C
               ACTRED = -ONE
               IF (FNORM1 .LT. FNORM) ACTRED = ONE - (FNORM1/FNORM)**2
C
C              COMPUTE THE SCALED PREDICTED REDUCTION.
C
               L = 1
               DO 240 I = 1, N
                  SUM = ZERO
                  DO 230 J = I, N
                     SUM = SUM + R(L)*WA1(J)
                     L = L + 1
  230             CONTINUE
                  WA3(I) = QTF(I) + SUM
  240          CONTINUE
               TEMP = DENORM(N,WA3)
               PRERED = ZERO
               IF (TEMP .LT. FNORM) PRERED = ONE - (TEMP/FNORM)**2
C
C              COMPUTE THE RATIO OF THE ACTUAL TO THE PREDICTED
C              REDUCTION.
C
               RATIO = ZERO
               IF (PRERED .GT. ZERO) RATIO = ACTRED/PRERED
C
C              UPDATE THE STEP BOUND.
C
               IF (RATIO .GE. P1) GO TO 250
                  NCSUC = 0
                  NCFAIL = NCFAIL + 1
                  DELTA = P5*DELTA
               GO TO 260
  250          CONTINUE
                  NCFAIL = 0
                  NCSUC = NCSUC + 1
                  IF (RATIO .GE. P5 .OR. NCSUC .GT. 1)
     1               DELTA = MAX(DELTA,PNORM/P5)
                  IF (ABS(RATIO-ONE) .LE. P1) DELTA = PNORM/P5
  260          CONTINUE
C
C              TEST FOR SUCCESSFUL ITERATION.
C
               IF (RATIO .LT. P0001) GO TO 280
C
C                 SUCCESSFUL ITERATION. UPDATE X, FVEC, AND THEIR NORMS.
C
                  DO 270 J = 1, N
                     X(J) = WA2(J)
                     WA2(J) = DIAG(J)*X(J)
                     FVEC(J) = WA4(J)
  270             CONTINUE
                  XNORM = DENORM(N,WA2)
                  FNORM = FNORM1
                  ITER = ITER + 1
  280          CONTINUE
C
C              DETERMINE THE PROGRESS OF THE ITERATION.
C
               NSLOW1 = NSLOW1 + 1
               IF (ACTRED .GE. P001) NSLOW1 = 0
               IF (JEVAL) NSLOW2 = NSLOW2 + 1
               IF (ACTRED .GE. P1) NSLOW2 = 0
C
C              TEST FOR CONVERGENCE.
C
               IF (DELTA .LE. XTOL*XNORM .OR. FNORM .EQ. ZERO) INFO = 1
C     .........EXIT
               IF (INFO .NE. 0) GO TO 320
C
C              TESTS FOR TERMINATION AND STRINGENT TOLERANCES.
C
               IF (NFEV .GE. MAXFEV) INFO = 2
               IF (P1*MAX(P1*DELTA,PNORM) .LE. EPSMCH*XNORM) INFO = 3
               IF (NSLOW2 .EQ. 5) INFO = 4
               IF (NSLOW1 .EQ. 10) INFO = 5
C     .........EXIT
               IF (INFO .NE. 0) GO TO 320
C
C              CRITERION FOR RECALCULATING JACOBIAN
C
C           ...EXIT
               IF (NCFAIL .EQ. 2) GO TO 310
C
C              CALCULATE THE RANK ONE MODIFICATION TO THE JACOBIAN
C              AND UPDATE QTF IF NECESSARY.
C
               DO 300 J = 1, N
                  SUM = ZERO
                  DO 290 I = 1, N
                     SUM = SUM + FJAC(I,J)*WA4(I)
  290             CONTINUE
                  WA2(J) = (SUM - WA3(J))/PNORM
                  WA1(J) = DIAG(J)*((DIAG(J)*WA1(J))/PNORM)
                  IF (RATIO .GE. P0001) QTF(J) = SUM
  300          CONTINUE
C
C              COMPUTE THE QR FACTORIZATION OF THE UPDATED JACOBIAN.
C
               CALL D1UPDT(N,N,R,LR,WA1,WA2,WA3,SING)
               CALL D1MPYQ(N,N,FJAC,LDFJAC,WA2,WA3)
               CALL D1MPYQ(1,N,QTF,1,WA2,WA3)
C
C              END OF THE INNER LOOP.
C
               JEVAL = .FALSE.
            GO TO 200
  310       CONTINUE
C
C           END OF THE OUTER LOOP.
C
         GO TO 30
  320 CONTINUE
C
C     TERMINATION, EITHER NORMAL OR USER IMPOSED.
C
      IF (IFLAG .LT. 0) INFO = IFLAG
      IFLAG = 0
      IF (NPRINT .GT. 0) CALL FCN(N,X,FVEC,IFLAG)
      IF (INFO .LT. 0) CALL XERMSG ('SLATEC', 'DNSQ',
     +   'EXECUTION TERMINATED BECAUSE USER SET IFLAG NEGATIVE.', 1, 1)
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'DNSQ',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      IF (INFO .EQ. 2) CALL XERMSG ('SLATEC', 'DNSQ',
     +   'TOO MANY FUNCTION EVALUATIONS.', 9, 1)
      IF (INFO .EQ. 3) CALL XERMSG ('SLATEC', 'DNSQ',
     +   'XTOL TOO SMALL. NO FURTHER IMPROVEMENT POSSIBLE.', 3, 1)
      IF (INFO .GT. 4) CALL XERMSG ('SLATEC', 'DNSQ',
     +   'ITERATION NOT MAKING GOOD PROGRESS.', 1, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE DNSQ.
C
      END
*DECK DNSQE
      SUBROUTINE DNSQE (FCN, JAC, IOPT, N, X, FVEC, TOL, NPRINT, INFO,
     +   WA, LWA)
C***BEGIN PROLOGUE  DNSQE
C***PURPOSE  An easy-to-use code to find a zero of a system of N
C            nonlinear functions in N variables by a modification of
C            the Powell hybrid method.
C***LIBRARY   SLATEC
C***CATEGORY  F2A
C***TYPE      DOUBLE PRECISION (SNSQE-S, DNSQE-D)
C***KEYWORDS  EASY-TO-USE, NONLINEAR SQUARE SYSTEM,
C             POWELL HYBRID METHOD, ZEROS
C***AUTHOR  Hiebert, K. L. (SNLA)
C***DESCRIPTION
C
C 1. Purpose.
C
C       The purpose of DNSQE is to find a zero of a system of N
C       nonlinear functions in N variables by a modification of the
C       Powell hybrid method.  This is done by using the more general
C       nonlinear equation solver DNSQ.  The user must provide a
C       subroutine which calculates the functions.  The user has the
C       option of either to provide a subroutine which calculates the
C       Jacobian or to let the code calculate it by a forward-difference
C       approximation.  This code is the combination of the MINPACK
C       codes (Argonne) HYBRD1 and HYBRJ1.
C
C 2. Subroutine and Type Statements.
C
C       SUBROUTINE DNSQE(FCN,JAC,IOPT,N,X,FVEC,TOL,NPRINT,INFO,
C      *                  WA,LWA)
C       INTEGER IOPT,N,NPRINT,INFO,LWA
C       DOUBLE PRECISION TOL
C       DOUBLE PRECISION X(N),FVEC(N),WA(LWA)
C       EXTERNAL FCN,JAC
C
C 3. Parameters.
C
C       Parameters designated as input parameters must be specified on
C       entry to DNSQE and are not changed on exit, while parameters
C       designated as output parameters need not be specified on entry
C       and are set to appropriate values on exit from DNSQE.
C
C       FCN is the name of the user-supplied subroutine which calculates
C         the functions.  FCN must be declared in an external statement
C         in the user calling program, and should be written as follows.
C
C         SUBROUTINE FCN(N,X,FVEC,IFLAG)
C         INTEGER N,IFLAG
C         DOUBLE PRECISION X(N),FVEC(N)
C         ----------
C         Calculate the functions at X and
C         return this vector in FVEC.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by FCN unless the
C         user wants to terminate execution of DNSQE.  In this case set
C         IFLAG to a negative integer.
C
C       JAC is the name of the user-supplied subroutine which calculates
C         the Jacobian.  If IOPT=1, then JAC must be declared in an
C         external statement in the user calling program, and should be
C         written as follows.
C
C         SUBROUTINE JAC(N,X,FVEC,FJAC,LDFJAC,IFLAG)
C         INTEGER N,LDFJAC,IFLAG
C         DOUBLE PRECISION X(N),FVEC(N),FJAC(LDFJAC,N)
C         ----------
C         Calculate the Jacobian at X and return this
C         matrix in FJAC.  FVEC contains the function
C         values at X and should not be altered.
C         ----------
C         RETURN
C         END
C
C         The value of IFLAG should not be changed by JAC unless the
C         user wants to terminate execution of DNSQE. In this case set
C         IFLAG to a negative integer.
C
C         If IOPT=2, JAC can be ignored (treat it as a dummy argument).
C
C       IOPT is an input variable which specifies how the Jacobian will
C         be calculated.  If IOPT=1, then the user must supply the
C         Jacobian through the subroutine JAC.  If IOPT=2, then the
C         code will approximate the Jacobian by forward-differencing.
C
C       N is a positive integer input variable set to the number of
C         functions and variables.
C
C       X is an array of length N.  On input X must contain an initial
C         estimate of the solution vector.  On output X contains the
C         final estimate of the solution vector.
C
C       FVEC is an output array of length N which contains the functions
C         evaluated at the output X.
C
C       TOL is a nonnegative input variable.  Termination occurs when
C         the algorithm estimates that the relative error between X and
C         the solution is at most TOL.  Section 4 contains more details
C         about TOL.
C
C       NPRINT is an integer input variable that enables controlled
C         printing of iterates if it is positive.  In this case, FCN is
C         called with IFLAG = 0 at the beginning of the first iteration
C         and every NPRINT iterations thereafter and immediately prior
C         to return, with X and FVEC available for printing. Appropriate
C         print statements must be added to FCN(see example).  If NPRINT
C         is not positive, no special calls of FCN with IFLAG = 0 are
C         made.
C
C       INFO is an integer output variable.  If the user has terminated
C         execution, INFO is set to the (negative) value of IFLAG.  See
C         description of FCN and JAC. Otherwise, INFO is set as follows.
C
C         INFO = 0  Improper input parameters.
C
C         INFO = 1  Algorithm estimates that the relative error between
C                   X and the solution is at most TOL.
C
C         INFO = 2  Number of calls to FCN has reached or exceeded
C                   100*(N+1) for IOPT=1 or 200*(N+1) for IOPT=2.
C
C         INFO = 3  TOL is too small.  No further improvement in the
C                   approximate solution X is possible.
C
C         INFO = 4  Iteration is not making good progress.
C
C         Sections 4 and 5 contain more details about INFO.
C
C       WA is a work array of length LWA.
C
C       LWA is a positive integer input variable not less than
C         (3*N**2+13*N))/2.
C
C 4. Successful Completion.
C
C       The accuracy of DNSQE is controlled by the convergence parameter
C       TOL.  This parameter is used in a test which makes a comparison
C       between the approximation X and a solution XSOL.  DNSQE
C       terminates when the test is satisfied.  If TOL is less than the
C       machine precision (as defined by the  function D1MACH(4)), then
C       DNSQE only attempts to satisfy the test defined by the machine
C       precision.  Further progress is not usually possible.  Unless
C       high precision solutions are required, the recommended value
C       for TOL is the square root of the machine precision.
C
C       The test assumes that the functions are reasonably well behaved,
C       and, if the Jacobian is supplied by the user, that the functions
C       and the Jacobian are coded consistently. If these conditions are
C       not satisfied, then DNSQE may incorrectly indicate convergence.
C       The coding of the Jacobian can be checked by the subroutine
C       DCKDER.  If the Jacobian is coded correctly or IOPT=2, then
C       the validity of the answer can be checked, for example, by
C       rerunning DNSQE with a tighter tolerance.
C
C       Convergence Test.  If DENORM(Z) denotes the Euclidean norm of a
C         vector Z, then this test attempts to guarantee that
C
C               DENORM(X-XSOL) .LE. TOL*DENORM(XSOL).
C
C         If this condition is satisfied with TOL = 10**(-K), then the
C         larger components of X have K significant decimal digits and
C         INFO is set to 1.  There is a danger that the smaller
C         components of X may have large relative errors, but the fast
C         rate of convergence of DNSQE usually avoids this possibility.
C
C 5. Unsuccessful Completion.
C
C       Unsuccessful termination of DNSQE can be due to improper input
C       parameters, arithmetic interrupts, an excessive number of
C       function evaluations, errors in the functions, or lack of good
C       progress.
C
C       Improper Input Parameters.  INFO is set to 0 if IOPT .LT. 1, or
C         IOPT .GT. 2, or N .LE. 0, or TOL .LT. 0.E0, or
C         LWA .LT. (3*N**2+13*N)/2.
C
C       Arithmetic Interrupts.  If these interrupts occur in the FCN
C         subroutine during an early stage of the computation, they may
C         be caused by an unacceptable choice of X by DNSQE.  In this
C         case, it may be possible to remedy the situation by not
C         evaluating the functions here, but instead setting the
C         components of FVEC to numbers that exceed those in the initial
C         FVEC.
C
C       Excessive Number of Function Evaluations.  If the number of
C         calls to FCN reaches 100*(N+1) for IOPT=1 or 200*(N+1) for
C         IOPT=2, then this indicates that the routine is converging
C         very slowly as measured by the progress of FVEC, and INFO is
C         set to 2.  This situation should be unusual because, as
C         indicated below, lack of good progress is usually diagnosed
C         earlier by DNSQE, causing termination with INFO = 4.
C
C       Errors In the Functions.  When IOPT=2, the choice of step length
C         in the forward-difference approximation to the Jacobian
C         assumes that the relative errors in the functions are of the
C         order of the machine precision.  If this is not the case,
C         DNSQE may fail (usually with INFO = 4).  The user should
C         then either use DNSQ and set the step length or use IOPT=1
C         and supply the Jacobian.
C
C       Lack of Good Progress.  DNSQE searches for a zero of the system
C         by minimizing the sum of the squares of the functions.  In so
C         doing, it can become trapped in a region where the minimum
C         does not correspond to a zero of the system and, in this
C         situation, the iteration eventually fails to make good
C         progress.  In particular, this will happen if the system does
C         not have a zero.  If the system has a zero, rerunning DNSQE
C         from a different starting point may be helpful.
C
C 6. Characteristics of The Algorithm.
C
C       DNSQE is a modification of the Powell Hybrid method.  Two of
C       its main characteristics involve the choice of the correction as
C       a convex combination of the Newton and scaled gradient
C       directions, and the updating of the Jacobian by the rank-1
C       method of Broyden.  The choice of the correction guarantees
C       (under reasonable conditions) global convergence for starting
C       points far from the solution and a fast rate of convergence.
C       The Jacobian is calculated at the starting point by either the
C       user-supplied subroutine or a forward-difference approximation,
C       but it is not recalculated until the rank-1 method fails to
C       produce satisfactory progress.
C
C       Timing.  The time required by DNSQE to solve a given problem
C         depends on N, the behavior of the functions, the accuracy
C         requested, and the starting point.  The number of arithmetic
C         operations needed by DNSQE is about 11.5*(N**2) to process
C         each evaluation of the functions (call to FCN) and 1.3*(N**3)
C         to process each evaluation of the Jacobian (call to JAC,
C         if IOPT = 1).  Unless FCN and JAC can be evaluated quickly,
C         the timing of DNSQE will be strongly influenced by the time
C         spent in FCN and JAC.
C
C       Storage.  DNSQE requires (3*N**2 + 17*N)/2 single precision
C         storage locations, in addition to the storage required by the
C         program.  There are no internally declared storage arrays.
C
C *Long Description:
C
C 7. Example.
C
C       The problem is to determine the values of X(1), X(2), ..., X(9),
C       which solve the system of tridiagonal equations
C
C       (3-2*X(1))*X(1)           -2*X(2)                   = -1
C               -X(I-1) + (3-2*X(I))*X(I)         -2*X(I+1) = -1, I=2-8
C                                   -X(8) + (3-2*X(9))*X(9) = -1
C
C       **********
C
C       PROGRAM TEST
C C
C C     DRIVER FOR DNSQE EXAMPLE.
C C
C       INTEGER J,N,IOPT,NPRINT,INFO,LWA,NWRITE
C       DOUBLE PRECISION TOL,FNORM
C       DOUBLE PRECISION X(9),FVEC(9),WA(180)
C       DOUBLE PRECISION DENORM,D1MACH
C       EXTERNAL FCN
C       DATA NWRITE /6/
C C
C       IOPT = 2
C       N = 9
C C
C C     THE FOLLOWING STARTING VALUES PROVIDE A ROUGH SOLUTION.
C C
C       DO 10 J = 1, 9
C          X(J) = -1.E0
C    10    CONTINUE
C
C       LWA = 180
C       NPRINT = 0
C C
C C     SET TOL TO THE SQUARE ROOT OF THE MACHINE PRECISION.
C C     UNLESS HIGH PRECISION SOLUTIONS ARE REQUIRED,
C C     THIS IS THE RECOMMENDED SETTING.
C C
C       TOL = SQRT(D1MACH(4))
C C
C       CALL DNSQE(FCN,JAC,IOPT,N,X,FVEC,TOL,NPRINT,INFO,WA,LWA)
C       FNORM = DENORM(N,FVEC)
C       WRITE (NWRITE,1000) FNORM,INFO,(X(J),J=1,N)
C       STOP
C  1000 FORMAT (5X,' FINAL L2 NORM OF THE RESIDUALS',E15.7 //
C      *        5X,' EXIT PARAMETER',16X,I10 //
C      *        5X,' FINAL APPROXIMATE SOLUTION' // (5X,3E15.7))
C       END
C       SUBROUTINE FCN(N,X,FVEC,IFLAG)
C       INTEGER N,IFLAG
C       DOUBLE PRECISION X(N),FVEC(N)
C       INTEGER K
C       DOUBLE PRECISION ONE,TEMP,TEMP1,TEMP2,THREE,TWO,ZERO
C       DATA ZERO,ONE,TWO,THREE /0.E0,1.E0,2.E0,3.E0/
C C
C       DO 10 K = 1, N
C          TEMP = (THREE - TWO*X(K))*X(K)
C          TEMP1 = ZERO
C          IF (K .NE. 1) TEMP1 = X(K-1)
C          TEMP2 = ZERO
C          IF (K .NE. N) TEMP2 = X(K+1)
C          FVEC(K) = TEMP - TEMP1 - TWO*TEMP2 + ONE
C    10    CONTINUE
C       RETURN
C       END
C
C       RESULTS OBTAINED WITH DIFFERENT COMPILERS OR MACHINES
C       MAY BE SLIGHTLY DIFFERENT.
C
C       FINAL L2 NORM OF THE RESIDUALS  0.1192636E-07
C
C       EXIT PARAMETER                         1
C
C       FINAL APPROXIMATE SOLUTION
C
C       -0.5706545E+00 -0.6816283E+00 -0.7017325E+00
C       -0.7042129E+00 -0.7013690E+00 -0.6918656E+00
C       -0.6657920E+00 -0.5960342E+00 -0.4164121E+00
C
C***REFERENCES  M. J. D. Powell, A hybrid method for nonlinear equa-
C                 tions. In Numerical Methods for Nonlinear Algebraic
C                 Equations, P. Rabinowitz, Editor.  Gordon and Breach,
C                 1988.
C***ROUTINES CALLED  DNSQ, XERMSG
C***REVISION HISTORY  (YYMMDD)
C   800301  DATE WRITTEN
C   890531  Changed all specific intrinsics to generic.  (WRB)
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   900315  CALLs to XERROR changed to CALLs to XERMSG.  (THJ)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DNSQE
      INTEGER INDEX, INFO, IOPT, J, LR, LWA, MAXFEV, ML, MODE, MU, N,
     1     NFEV, NJEV, NPRINT
      DOUBLE PRECISION EPSFCN, FACTOR, FVEC(*), ONE, TOL, WA(*),
     1     X(*), XTOL, ZERO
      EXTERNAL FCN, JAC
      SAVE FACTOR, ONE, ZERO
      DATA FACTOR,ONE,ZERO /1.0D2,1.0D0,0.0D0/
C     BEGIN BLOCK PERMITTING ...EXITS TO 20
C***FIRST EXECUTABLE STATEMENT  DNSQE
         INFO = 0
C
C        CHECK THE INPUT PARAMETERS FOR ERRORS.
C
C     ...EXIT
         IF (IOPT .LT. 1 .OR. IOPT .GT. 2 .OR. N .LE. 0
     1       .OR. TOL .LT. ZERO .OR. LWA .LT. (3*N**2 + 13*N)/2)
     2      GO TO 20
C
C        CALL DNSQ.
C
         MAXFEV = 100*(N + 1)
         IF (IOPT .EQ. 2) MAXFEV = 2*MAXFEV
         XTOL = TOL
         ML = N - 1
         MU = N - 1
         EPSFCN = ZERO
         MODE = 2
         DO 10 J = 1, N
            WA(J) = ONE
   10    CONTINUE
         LR = (N*(N + 1))/2
         INDEX = 6*N + LR
         CALL DNSQ(FCN,JAC,IOPT,N,X,FVEC,WA(INDEX+1),N,XTOL,MAXFEV,ML,
     1             MU,EPSFCN,WA(1),MODE,FACTOR,NPRINT,INFO,NFEV,NJEV,
     2             WA(6*N+1),LR,WA(N+1),WA(2*N+1),WA(3*N+1),WA(4*N+1),
     3             WA(5*N+1))
         IF (INFO .EQ. 5) INFO = 4
   20 CONTINUE
      IF (INFO .EQ. 0) CALL XERMSG ('SLATEC', 'DNSQE',
     +   'INVALID INPUT PARAMETER.', 2, 1)
      RETURN
C
C     LAST CARD OF SUBROUTINE DNSQE.
C
      END

module greg_image
  !--------------------------------------------------------------------
  ! GILDAS and FITS images support in GREG
  !--------------------------------------------------------------------
  !
  ! FITS image: RGDATA input
  real(8) :: fxref, fyref               !
  real(8) :: fxval, fyval               !
  real(8) :: fxinc, fyinc               !
  real(8) :: bscal                      !
  real(8) :: bzero                      !
  real(8) :: datamin,datamax            !
  integer(4) :: ninfx, nsupx            !
  integer(4) :: ninfy, nsupy            !
  integer(4) :: nbit                    !
  integer(4) :: fnx, fny                !
  character(len=20) :: coffx, coffy     !
  character(len=80) :: xunit, yunit     !
  character(len=1) :: comment='!'       !
  !
end module greg_image
!
module greg_rg
  use gildas_def
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !  Support module for the RG data buffer
  !---------------------------------------------------------------------
  !
  ! THIS TYPE SHOULD GO IN MODULE GREG_TYPES!!!
  ! Type describing the Greg Regular Grid
  type :: greg_rg_t
    real(kind=8)          :: xref,xval,xinc            ! X axis description (user coord.)
    real(kind=8)          :: yref,yval,yinc            ! Y axis description (user coord.)
    integer(kind=4)       :: nx=0                      ! Number of X pixels
    integer(kind=4)       :: ny=0                      ! Number of Y pixels
    real(kind=4), pointer :: data(:,:)=>null()         ! RG data buffer
    integer(kind=4)       :: status=code_pointer_null  ! Pointer allocation status
    logical               :: minmax=.false.            ! Extremas computed ?
    real(kind=4)          :: zmin,zmax                 ! Mini and maximum map value
    real(kind=4)          :: zxmin,zymin               ! Position of mini map value
    real(kind=4)          :: zxmax,zymax               ! Position of maxi map value
    type(gildas)          :: imag                      ! Associated image, if relevant
  end type greg_rg_t
  !
  type(greg_rg_t), save :: rg
end module greg_rg
!
module greg_contours
  use gildas_def
  !--------------------------------------------------------------------
  ! Contours support in GREG
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  ! RG array description and extremas, and contour levels description
  integer, parameter :: maxl=40     !
  integer, save :: ncl=0            ! Current number of contours
  !
  real(4), save :: cl(maxl)         ! Values of contours
  real(4) :: qlev                   ! Multiplicative factor for contours
  !
  integer, parameter :: maxu=512    ! Maximum number of pixels for which
                                    ! we attempt contour-filling
  integer, parameter :: chunksize=65536 !
  !
  real(4) :: xu(maxu),yu(maxu)      ! Buffers for contour coordinates
  real(4) :: gzmin,gzmax            ! Max-min of subset of map (for Grey-fill).
  real(4) :: blankfk                ! Blanking value for keeping
  integer :: icolo                  ! Color index used for filling
  integer :: ncolo                  ! Color index used of contours
  integer :: nstep                  ! Trying parameter for filling
  integer :: ilev                   ! Contour level counter
  logical :: lgrey                  ! Grey filling ?
  logical :: link                   ! Connect buffers ?
  logical :: lout                   ! Keeping copy on formatted file ?
  ! Used by Contour Filling:
  logical :: highwater
  logical :: chunkpatch
  integer(kind=4), allocatable :: ixu(:)  ! Buffer for contour X coordinates
  integer(kind=4), allocatable :: iyu(:)  ! Buffer for contour Y coordinates
  integer(kind=address_length) :: ipxu,ipyu
  logical :: noclip_gris
  !
  ! Positive/negative contours
  integer :: ipen_pos, ipen_neg     !
  integer(kind=size_length) :: ldd  !
  integer :: mxu                    !
  logical :: quietmode              !
  !
  ! Physical box for the drawing output
  real :: xbox1, ybox1, xbox2, ybox2         ! In REAL centimeters
  integer :: xxbox1, xxbox2, yybox1, yybox2  ! In INTEGER microns
  !
end module greg_contours
!
module greg_poly
  use greg_types
  !--------------------------------------------------------------------
  ! Variables for polygon support in GREG
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  !
  type(polygon_t), save :: gpoly
end module greg_poly

module gauss_1d_data
  use gildas_def
  ! Former 'rdata.inc'
  integer(kind=4) :: nxy
  real, pointer :: my_x(:), my_y(:)
  real, allocatable :: my_w(:)
  real(kind=4) :: cbad
end module gauss_1d_data
!
program gaussfit
  use gildas_def
  use image_def
  use gbl_format
  use fit_minuit
  use gkernel_interfaces
  use gauss_1d_data
  !---------------------------------------------------------------------
  ! Make a gaussfit to two columns of a Table
  !---------------------------------------------------------------------
  ! Global
  include 'gauss.inc'
  ! Local
  logical :: error
  type(fit_minuit_t) :: fit
  integer :: lt(mxline),lv(mxline),ld(mxline)
  integer :: ifatal,nout(mxline),jcol,i
  equivalence  (kt1,lt(1)), (kv1,lv(1)), (kd1,ld(1))
  real :: intens(mxline),pos(mxline),width(mxline),array(6)
  external :: mingauss
  real(kind=4), external :: progauss
  character(len=7) :: prompt
  character(len=filename_length) :: name,file
  type(gildas) :: x
  integer :: cols(2),ier
  !
  ! Open file
  call gildas_open
  call gildas_char('IN$',name)
  call gildas_char('LIST$',name)
  call sic_parsef(name,file,' ','.dat')
  call gildas_inte('COLUMN_IN$',cols,2)
  call gildas_inte('NLINE$',nline,1)
  nline = min(nline,mxline)
  call gildas_inte('COLUMN_OUT$',nout,max(nline,1))
  do i=1,nline
    write(prompt,1000) i
    call gildas_real(prompt,array,6)
    intens(i) = array(2)
    lt(i) = nint(array(1))
    pos(i) = array(4)
    lv(i) = nint(array(3))
    width(i) = array(6)
    ld(i) = nint(array(5))
  enddo
  call gildas_close
  !
  call gildas_null (x, type = 'TABLE')
  call gdf_read_gildas (x, name, '.tab', error)
  if (error) then 
    write(6,*) 'E-GAUSS_1D,  Error reading table'
    goto 99
  endif
  !
  fit%isyswr=1
  ier = sic_open(1,file,'NEW',.false.)
  if (ier.ne.0) then
    write(6,*) 'E-GAUSS_1D,  Cannot create output file'
    call putios('E-GAUSS_1D,  ',ier)
    goto 99
  endif
  jcol = nout(1)
  do i=2,nline
    jcol = max(nout(i),jcol)
  enddo
  !
  if (nline.lt.1) goto 100
  spar(1) = intens(1)
  spar(2) = pos(1)
  spar(3) = width(1)
  if (nline.lt.2) goto 100
  spar(4) = intens(2)
  spar(5) = pos(2)
  spar(6) = width(2)
  if (nline.lt.3) goto 100
  spar(7) = intens(3)
  spar(8) = pos(3)
  spar(9) = width(3)
  if (nline.lt.4) goto 100
  spar(10) = intens(4)
  spar(11) = pos(4)
  spar(12) = width(4)
  if (nline.lt.5) goto 100
  spar(13) = intens(5)
  spar(14) = pos(5)
  spar(15) = width(5)
  !
100 continue
  call check(lt,nline,kt0,1,ifatal)
  call check(lv,nline,kv0,2,ier)
  ifatal=ifatal+ier
  call check(ld,nline,kd0,3,ier)
  ifatal=ifatal+ier
  if (kt0.ne.0 .and. kd0.ne.0 .and. kt0.ne.kd0) ifatal=ifatal+1
  if (ifatal.ne.0) then
    write(6,'(1X,I3,A)') ifatal,'Fatal errors on parameters'
    call sysexi (fatale)
  endif
  !
  ! Compute Data Address
  if (cols(1).gt.x%gil%dim(2) .or. cols(2).gt.x%gil%dim(2)) then
    write(6,*) 'E-GAUSS_1D,  Columns out of range'
    call sysexi (fatale)
  endif
  nxy = x%gil%dim(1)
  my_x => x%r2d(:,cols(1))
  my_y => x%r2d(:,cols(2))
  ! Get some work space
  allocate (my_w(nxy),stat=ier)
  if (ier.ne.0) goto 99
  cbad = -1e28                 ! ....
  !
  call fitgauss(fit,mingauss,.false.,error)
  if (error) goto 99
  !
  ! Write the fits
  call extend_table(x,jcol,error)
  if (error) goto 99
  !
  my_x => x%r2d(:,cols(1))
  do i=1,max(nline,1)
    if (nout(i).gt.0) then
      my_y => x%r2d(:,nout(i)) 
      call fill_fit(my_x,my_y,x%gil%dim(1),progauss,i)
    endif
  enddo
  call gdf_write_data (x, x%r2d, error)
  stop 'S-FITGAUSS,  Successful completion'
  !
99 call sysexi (fatale)
1000 format('LINE_',i1,'$')
end program gaussfit
!
subroutine extend_table(x,ncol,error)
  use gildas_def
  use image_def
  use gkernel_interfaces
  type(gildas) :: x                 !
  integer :: ncol                   !
  logical :: error                  !
  ! Local
  integer(kind=index_length) :: mcol
  !
  error = .false.
  if (ncol.le.x%gil%dim(2)) return
  !
  mcol = ncol
  call gdf_extend_image (x,mcol, error)
  if (error) then
    write(6,*) 'E-GAUSS_1D,  Table extension failed'
    return
  endif
  !
  ! The whole thing must be mapped
  x%blc = 0
  x%trc = 0
  call gdf_allocate (x,error)
end subroutine extend_table
!
subroutine fill_fit(x,y,n,fcn,il)
  use gildas_def
  integer(kind=index_length) :: n
  real(kind=4)               :: x(n)
  real(kind=4)               :: y(n)
  real(kind=4), external     :: fcn
  integer(kind=4)            :: il
  ! Local
  integer(kind=index_length) :: i
  !
  do i=1,n
    y(i) = fcn(x(i),il)
  enddo
end subroutine fill_fit
!
subroutine check(kflag,nline,kt,ivar,ierr)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! SAS	Internal routine (GAUSS)
  !	Control the gauss fit parameter flags
  ! Arguments :
  !	KFLAG 	I(5)	Flags to be checked		Input
  !	NLINE 	I*2	Number of lines			Input
  !	KT    	I	Independante line		Output
  !	IVAR  	I	Variable code			Input
  !	IERR  	I	Error code			Output
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  integer :: kflag(5)               !
  integer :: nline                  !
  integer :: kt                     !
  integer :: ivar                   !
  integer :: ierr                   !
  ! Local
  integer :: ktdep,i
  character(len=9) :: chain(3)
  character(len=1) :: ch
  ! Data
  data chain /'Intensity',' Position','   Width '/
  !
  ierr=0
  if (nline.eq.0) then
    kflag(1)=mod(kflag(1),2)
    kt=0
    return
  endif
  ! Find dependent
  if (kflag(1).gt.4) then
    call gagout('E-CHECK,  Flag greater than 4')
    ierr=1
    return
  endif
  kt=0
  ktdep=0
  if (kflag(1).eq.2.or.kflag(1).eq.4) kt=1
  if (kflag(1).eq.3) ktdep=1
  !
  do i=2,nline
    if (kflag(i).gt.4) then
      call gagout('E-CHECK,  Flag greater than 4')
      ierr=1
      return
    endif
    if (kflag(i).eq.2.or.kflag(i).eq.4) then
      if (kt.eq.0) then
        kt=i
      else
        ierr=ierr+1
      endif
    endif
    if (kflag(i).eq.3) ktdep=ktdep+1
  enddo
  !
  if (ierr.ne.0) then
    call gagout('E-CHECK,  Several groups in '//chain(ivar))
    ierr=1
  endif
  if (ktdep.eq.0 .and. kt.ne.0) then
    write(ch,'(I1)') kt
    call gagout('E-CHECK,  Line '//ch//' alone in a '//  &
    chain(ivar)//' Group')
  endif
  if (ktdep.ne.0 .and. kt.eq.0) then
    call gagout('E-CHECK,  No independent '//chain(ivar))
    ierr=1
  endif
  return
end subroutine check
!
subroutine fitgauss(fit,fcn,liter,error)
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use fit_minuit
  use gauss_1d_data
  !---------------------------------------------------------------------
  ! SAS	Internal routine
  !	Setup and starts a GAUSS fit minimisation using MINUIT
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit    !
  external                          :: fcn    ! Function to be mininized
  logical, intent(in)               :: liter  ! Logical of iterate fit
  logical                           :: error  ! Logical error flag (output)
  ! Global
  include 'gauss.inc'
  ! Local
  integer :: i,k,l,k1,k2, ifatal,ier
  real*8 :: dx, al, ba, du1, du2
  character(len=message_length) :: mess
  !
  ! Added error Patch for Initialisation
  ngline = nline
  error = .false.
  fit%maxext=ntot
  fit%maxint=nvar
  !
  ! Initialise values
  call initva(sigbas,sigrai,cbad,deltav,my_x,my_y,my_w,nxy)
  call midgauss(fit,ifatal,liter)
  if (ifatal.ne.0) then
    write(mess,*) 'Fatal ',ifatal
    call gagout('E-FITGAUSS,  '//mess)
    error = .true.
    return
  endif
  call intoex(fit,fit%x)
  fit%up = max(sigbas**2,sigrai**2)
  fit%nfcnmx = 1000
  fit%epsi   = 0.1d0 * fit%up
  fit%newmin = 0
  fit%itaur  = 0
  fit%isw(1) = 0
  fit%isw(3) = 1
  fit%nfcn   = 1
  fit%vtest  = 0.04
  call fcn(fit%npar,fit%g,fit%amin,fit%u,1)
  !
  ! Simplex Minimization
  if (.not.liter) then
    call simplx(fit,fcn,ier)
    write(mess,*) 'Simplex returned status: ',ier
    call gagout('I-FITGAUSS,  '//mess)
    if (ier.ne.0) then
      error=.true.
      return
    endif
    k=1
    do i=1,max(nline,1)
      par(k)  =fit%u(k+3)*fit%u(1)*1.7724538
      par(k+1)=fit%u(k+4)+fit%u(2)
      par(k+2)=fit%u(k+5)*1.665109*fit%u(3)
      k=k+3
    enddo
  endif
  !
  ! Gradient Minimization
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  write(fit%isyswr,1002) sigbas,sigrai
  fit%up = max(sigbas**2,sigrai**2)
  fit%epsi = 0.1d0 * fit%up
  fit%apsi = fit%epsi
  call hesse(fit,fcn)
  call migrad(fit,fcn,ier)
  if (ier.eq.1) then
    ier=0
    call hesse(fit,fcn)
    error=.false.
  endif
  !
  ! Print Results
  k=1
  do i=1,max(nline,1)
    par(k)  =fit%u(k+3)*fit%u(1)*1.7724538
    par(k+1)=fit%u(k+4)+fit%u(2)
    par(k+2)=fit%u(k+5)*fit%u(3)*1.665109
    k=k+3
  enddo
  call intoex(fit,fit%x)
  call fcn(fit%npar,fit%g,fit%amin,fit%u,3)
  write(fit%isyswr,1002) sigbas,sigrai
  fit%up  = max(sigbas**2,sigrai**2)
  !
  ! Calculate External Errors
  do i=1,fit%nu
    l  = fit%lcorsp(i)
    if (l .eq. 0)  then
      fit%werr(i)=0.
      write(mess,*) 'Error ',i,fit%werr(i)
      call gagout('E-FITGAUSS,  '//mess)
    else
      if (fit%isw(2) .ge. 1)  then
        dx = dsqrt(dabs(fit%v(l,l)*fit%up))
        if (fit%lcode(i) .gt. 1) then
          al = fit%alim(i)
          ba = fit%blim(i) - al
          du1 = al + 0.5d0 *(dsin(fit%x(l)+dx) +1.0d0) * ba - fit%u(i)
          du2 = al + 0.5d0 *(dsin(fit%x(l)-dx) +1.0d0) * ba - fit%u(i)
          if (dx .gt. 1.0d0)  du1 = ba
          dx = 0.5d0 * (dabs(du1) + dabs(du2))
        endif
        fit%werr(i) = dx
        write(mess,*) 'Error ',i,fit%werr(i)
        call gagout('E-FITGAUSS,  '//mess)
      endif
    endif
  enddo
  !
  k=1
  if (sigbas.lt.sigrai/1.5 .or. sigbas.gt.1.5*sigrai) then
    write(fit%isyswr,1003)
  else
    write(fit%isyswr,1001)
  endif
  do i=1,max(nline,1)
    k1=k+1
    k2=k+2
    err(k)=fit%werr(k+3)
    if (i.eq.kt0) err(k)=fit%werr(1)
    err(k1)=fit%werr(k1+3)
    if (i.eq.kv0) err(k1)=fit%werr(2)
    err(k2)=fit%werr(k2+3)
    if (i.eq.kd0) err(k2)=fit%werr(3)
    write(fit%isyswr,1000) i,par(k),par(k1),par(k2),par(k)/par(k2)/1.064467,  &
                           err(k),err(k1),err(k2)
    k=k+3
  enddo
  return
  !
1000 format (1x,i1,2x,4(4x,1pg11.4),/,4x,3(4x,1pg11.4))
1001 format (/,'		FIT Results   ',//,  &
       ' Line      Area           Position      Width       Intensity')
1002 format (' RMS of Residuals :  Base = ',1pg11.3,'  Line = ',1pg11.3)
1003 format (/,'         Bad or Doubtful FIT',//,  &
       ' Line      Area               Position  Width       Intensity')
end subroutine fitgauss
!
subroutine initva (sigbas,sigrai,cbad,deltav,rdatax,rdatay,wfit,n)
  !---------------------------------------------------------------------
  ! ANALYSE	Internal routine
  !	Initialise the parameters for a gaussian fit using Minuit
  ! (10-Oct-1986)
  !---------------------------------------------------------------------
  real*4 :: sigbas                  !
  real*4 :: sigrai                  !
  real :: cbad                      !
  real :: deltav                    !
  integer :: n                      !
  real :: rdatax(n)                 !
  real :: rdatay(n)                 !
  real :: wfit(n)                   !
  ! Local
  real*4 :: aega,asup,ainf
  integer :: i,kbas,krai
  !
  ! Avoid bad channels
  do i=1, n
    if (rdatay(i).eq.cbad) then
      wfit(i)=0
    else
      wfit(i)=1
    endif
  enddo
  !
  ! Compute the Sigma
  kbas=0
  krai=0
  sigbas=0.
  sigrai=0.
  aega = rdatay(1)*wfit(1)
  asup = aega
  do i=1,n
    ainf=aega
    aega=asup
    asup=rdatay(i)*wfit(i)
    if ( ainf*aega.lt.0. .and. aega*asup.lt.0. ) then
      sigbas=sigbas+aega**2
      kbas=kbas+1
    else
      sigrai=sigrai+aega**2
      krai=krai+wfit(i-1)
    endif
  enddo
  !
  ! Try to avoid zero sigmas
  if (kbas.ne.0) sigbas=sqrt(sigbas/kbas)
  if (krai.ne.0) then
    sigrai=sqrt(sigrai/krai)
    if (sigbas.eq.0.) sigbas=sigrai
  else
    sigrai=sigbas
  endif
  deltav = abs(rdatax(2)-rdatax(1))
end subroutine initva
!
subroutine midgauss(fit,ifatal,liter)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  use gkernel_interfaces
  use fit_minuit
  use gauss_1d_data
  !---------------------------------------------------------------------
  ! ANALYSE	Internal routine
  !	Start a gaussian fit by building the PAR array and internal
  !	variable used by Minuit
  !---------------------------------------------------------------------
  type(fit_minuit_t), intent(inout) :: fit     !
  integer                           :: ifatal  ! Number of fatal errors Output
  logical, intent(in)               :: liter   ! Iterate a fit
  ! Global
  include 'gauss.inc'
  ! Local
  integer :: kt(5),kv(5),kd(5),i, nint, j1, j2, k, j
  equivalence (kt(1),kt1), (kv(1),kv1), (kd(1),kd1)
  real*8 :: sav, sav2, vplu, vminu
  character(len=message_length) :: mess
  !
  do i= 1, 7
    fit%isw(i) = 0
  enddo
  fit%sigma = 0.d0
  fit%npfix = 0
  nint = 0
  fit%nu = 0
  fit%npar = 0
  ifatal = 0
  do i= 1, fit%maxext
    fit%u(i) = 0.0d0
    fit%lcode(i) = 0
    fit%lcorsp (i) = 0
  enddo
  fit%isw(5) = 1
  !
  ! Starting values
  if (nline.eq.0) then
    call auto_guess(my_x,my_y,my_w,nxy,par)
    fit%nu=3
  else
    !
    ! Take initial guesses in SPAR
    fit%nu=3*nline
    j=1
    do i=1,nline
      j2=j+2
      !
      ! That is quite tricky, since the area is the product of the original
      !	intensity by the width. But for dependant gaussian, it is
      !	much more subtle
      if (kd(i).ne.3) then
        par(j)=spar(j)*spar(j2)*1.064467
      else
        par(j)=spar(j)
      endif
      j1=j+1
      par(j1)=spar(j1)
      par(j2)=spar(j2)
      j=j+3
    enddo
  endif
  !
  ! Type initial guesses
  fit%nu=fit%nu+3
  write(mess,597) par(1),par(2),par(3)
  call gagout('I-MIDGAUSS,  '//mess)
  k = 4
  do i=2,max(nline,1)
    write(mess,598) par(k),par(k+1),par(k+2)
    call gagout('I-MIDGAUSS,  '//mess)
    k=k+3
  enddo
598 format('                    ',1pg10.3,2x,1pg10.3,2x,1pg10.3)
597 format('Input Parameters :  ',1pg10.3,2x,1pg10.3,2x,1pg10.3)
  !
  ! Set up Parameters for Major Variables
  !
  ! Velocities
  if (kv0.eq.0) then
    fit%u(2)=0.
    fit%werr(2)=0.
  else
    fit%u(2)=par(3*kv0-1)
    if (kv(kv0).eq.4) then
      fit%werr(2)=0.
    else
      fit%werr(2)=deltav
      ! if (liter) fit%werr(2)=err(3*kv0-1)
      fit%alim(2)=fit%u(2)-40*deltav
      fit%blim(2)=fit%u(2)+40*deltav
    endif
  endif
  !
  ! Line Widths
  if (kd0.eq.0) then
    fit%u(3)=1./1.665109           ! 1 / (2*SQRT(LN(2)))
    fit%werr(3)=0.
  else
    fit%u(3)=abs(par(3*kd0))/1.665109
    if (kd(kd0).eq.4) then
      fit%werr(3)=0.
    else
      fit%werr(3)=deltav
      ! if (liter) fit%werr(3)=err(3*kd0)
      fit%alim(3)=deltav/4.
      fit%blim(3)=100.*deltav
    endif
  endif
  !
  ! Areas
  if (kt0.eq.0) then
    fit%u(1)=0.564189584           ! 1 / SQRT(PI)
    fit%werr(1)=0.
  else
    fit%u(1)=par(3*kt0-2)
    if (kt(kt0).eq.4) then
      fit%werr(1)=0.
    else
      fit%werr(1)=sigbas*deltav
      ! if (liter) fit%werr(1)=err(3*kt0-2)
      if (fit%u(1).ne.0.) then
        fit%alim(1)=dmin1(0.d0,4*fit%u(1))
        fit%blim(1)=dmax1(0.d0,4*fit%u(1))
      else
        fit%lcode(1)=1
      endif
    endif
  endif
  !
  ! Set up parameters for Secondary Variables
  !
  k=4
  do i=1,max(nline,1)
    ! Area
    fit%u(k)=par(k-3)
    if (kt(i).eq.0 .or. nline.eq.0) then
      fit%werr(k)=sigbas*deltav
      ! if (liter) fit%werr(k)=err(k-3)
      if (fit%u(k).ne.0.) then
        fit%alim(k)=dmin1(0.d0,4*fit%u(k))
        fit%blim(k)=dmax1(0.d0,4*fit%u(k))
      else
        fit%lcode(k)=1             ! No Boundaries if fit%u(k)=0.
      endif
    else
      fit%werr(k)=0.
      if (i.eq.kt0) then
        fit%u(k)=0.564189584
      else
        fit%u(k)=fit%u(k)*0.564189584
      endif
    endif
    k=k+1
    !
    ! Velocity
    fit%u(k)=par(k-3)
    if (kv(i).eq.0 .or. nline.eq.0) then
      fit%werr(k)=deltav
      ! if (liter) fit%werr(k)=err(k-3)
      fit%alim(k)=fit%u(k)-40*deltav
      fit%blim(k)=fit%u(k)+40*deltav
    else
      fit%werr(k)=0.
      if (i.eq.kv0) fit%u(k)=0.
    endif
    k=k+1
    !
    ! Line Width
    fit%u(k)=abs(par(k-3))
    if (kd(i).eq.0 .or. nline.eq.0) then
      fit%werr(k)=deltav
      ! if (liter) fit%werr(k)=err(k-3)
      fit%alim(k)=deltav
      fit%blim(k)=100.*deltav
    else
      fit%werr(k)=0.
      if (i.eq.kd0) fit%u(k)=1.
    endif
    k=k+1
  enddo
  !
  ! Various checks
  do k=1,fit%nu
    if (k .le. fit%maxext)  go to 115
    ifatal = ifatal + 1
    go to 160
115 if (fit%werr(k) .gt. 0.0d0)  go to 122
    ! Fixed parameter
    fit%lcode(k) = 0
    if (k.gt.3) then
      write(mess,1010) k-3,' is fixed'
      call gagout('W-MIDGAUSS,  '//mess)
    endif
    go to 160
    ! Variable parameter
122 nint = nint + 1
    if (fit%lcode(k).eq.1) go to 160
    fit%lcode(k) = 4
    if ((fit%blim(k)-fit%u(k))*(fit%u(k)-fit%alim(k)))  153,155,160
153 ifatal = ifatal + 1
    write(fit%isyswr,1011) k-3
    go to 160
155 if (k.gt.3) then
      write(mess,1010) k-3,' is at limit'
      call gagout('W-MIDGAUSS,  '//mess)
    endif
160 continue
  enddo
  !
  ! End parameter cards
  ! Stop if fatal error
  if (nint .gt. fit%maxint)  then
    write(fit%isyswr,1008)  nint,fit%maxint
    ifatal = ifatal + 1
  endif
  if (nint .eq. 0) then
    write(fit%isyswr,1009)
    ifatal = ifatal + 1
  endif
  if (ifatal .gt. 0)  then
    write(fit%isyswr,1013)  ifatal
    return
  endif
  !
  ! O.K. Start
  ! Calculate step sizes DIRIN
  fit%npar = 0
  do k= 1, fit%nu
    if (fit%lcode(k) .gt. 0)  then
      fit%npar = fit%npar + 1
      fit%lcorsp(k) = fit%npar
      sav = fit%u(k)
      fit%x(fit%npar) = pintf(fit,sav,k)
      fit%xt(fit%npar) = fit%x(fit%npar)
      sav2 = sav + fit%werr(k)
      vplu = pintf(fit,sav2,k) - fit%x(fit%npar)
      sav2 = sav - fit%werr(k)
      vminu = pintf(fit,sav2,k) - fit%x(fit%npar)
      fit%dirin(fit%npar) = 0.5d0 * (dabs(vplu) +dabs(vminu))
    endif
  enddo
  return
  !
1008 format (' Too many variable parameters.  You request ',i5/,  &
                ' This version of MINUIT is only dimensioned for ',i4)
1009 format (' All input parameters are fixed')
1010 format (' Warning - Parameter ',i2,' ',a)
1011 format (' Error - Parameter ',i2,' outside limits')
1013 format (1x,i3,' Errors on input parameters. ABORT.')
end subroutine midgauss
!
subroutine auto_guess(rdatax,rdatay,wfit,nxy,par)
  integer :: nxy                    !
  real :: rdatax(nxy)               !
  real :: rdatay(nxy)               !
  real :: wfit(nxy)                 !
  real :: par(3)                    !
  ! Local
  real :: ymax,ymin,aire,yy,vinf,vsup
  integer :: i
  !
  ! Automatic guess if NLINE = 0
  ymax=0.
  ymin=0.
  aire=0.
  do i=2,nxy-1
    if (wfit(i).ne.0) then
      yy = ( rdatay(i) + wfit(i-1)*rdatay(i-1) + wfit(i+1)*rdatay(i+1) ) /  &
           (1+wfit(i-1)+wfit(i+1))
      if (yy.ge.ymax) then
        ymax = yy
        vsup = rdatax(i)
      endif
      if (yy.le.ymin) then
        ymin = yy
        vinf = rdatax(i)
      endif
    endif
    aire=aire+yy*abs((rdatax(i+1)-rdatax(i-1)))
  enddo
  aire = aire*0.5
  if (abs(ymin).lt.abs(ymax)) then
    par(2)=vsup
    par(1)=ymax
  else
    par(2)=vinf
    par(1)=ymin
  endif
  par(3)=abs(aire/par(1)/1.064467)
  par(1)=aire
end subroutine auto_guess
!
subroutine mingauss (npar,g,f,x,iflag)
  use gildas_def
  use gauss_1d_data
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Function to be minimized in the gaussian fit.
  !	By using 3 hidden parameters, the method allows dependent
  !	and independent gaussians to be fitted. The computation is
  !	highly optimised, but take care of R*4 and R*8 values !...
  !	Basic parameters are Area, Position and Width.
  ! Arguments :
  !	NPAR	I	Number of parameters		Input
  !	G	R*8(1)	Array of derivatives		Output
  !	F	R*8	Function value			Output
  !	X	R*8(1)	Parameter values		Input
  !	IFLAG	I	Code operation			Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  integer :: npar                   !
  real*8 :: g(*)                    !
  real*8 :: f                       !
  real*8 :: x(*)                    !
  integer :: iflag                  !
  !
  call mingau(npar,g,f,x,iflag,my_x,my_y,my_w,nxy)
end subroutine mingauss
!
subroutine mingau (npar,g,f,x,iflag,rdatax,rdatay,weight,nxy)
  !---------------------------------------------------------------------
  ! LAS	Internal routine
  !	Function to be minimized in the gaussian fit.
  !	By using 3 hidden parameters, the method allows dependent
  !	and independent gaussians to be fitted. The computation is
  !	highly optimised, but take care of R*4 and R*8 values !...
  !	Basic parameters are Area, Position and Width.
  ! Arguments :
  !	NPAR	I	Number of parameters		Input
  !	G	R*8(1)	Array of derivatives		Output
  !	F	R*8	Function value			Output
  !	X	R*8(1)	Parameter values		Input
  !	IFLAG	I	Code operation			Input
  ! (5-mar-1985)
  !---------------------------------------------------------------------
  integer :: npar                   !
  real*8 :: g(*)                    !
  real*8 :: f                       !
  real*8 :: x(*)                    !
  integer :: iflag                  !
  integer :: nxy                    !
  real :: rdatax(nxy)               !
  real :: rdatay(nxy)               !
  real :: weight(nxy)               !
  ! Global
  include 'gauss.inc'
  ! Local
  real, external :: progauss
  logical :: dograd
  !
  real :: tt,vv,dd,gt,gv,gd,t1,v1,d1,g1,g2,g3,t5,v5,d5,g13,g14,g15
  real :: t4,v4,d4,g10,g11,g12,t3,v3,d3,g7,g8,g9,t2,v2,d2,g4,g5,g6
  real :: xvel,arg1,f1,ff,arg2,arg3,f2,f3,arg4,arg5,f4,f5,arg
  real :: ybas,yrai,seuil,ta
  integer :: i,kbas,krai
  !
  ! Final computations
  if (iflag.eq.3) goto 20
  dograd = iflag.eq.2
  !
  f=0.
  tt=x(1)
  vv=x(2)
  dd=x(3)
  gt=0.
  gv=0.
  gd=0.
  t1=x(4)*tt
  v1=x(5)+vv
  d1=x(6)*dd
  goto (1,2,3,4,5) nline
  goto 1
5 t5=x(16)*tt
  v5=x(17)+vv
  d5=x(18)*dd
  g13=0.
  g14=0.
  g15=0.
  !
4 t4=x(13)*tt
  v4=x(14)+vv
  d4=x(15)*dd
  g10=0.
  g11=0.
  g12=0.
  !
3 t3=x(10)*tt
  v3=x(11)+vv
  d3=x(12)*dd
  g7=0.
  g8=0.
  g9=0.
  !
2 t2=x(7)*tt
  v2=x(8)+vv
  d2=x(9)*dd
  g4=0.
  g5=0.
  g6=0.
  !
1 g1=0.
  g2=0.
  g3=0.
  !
  !	g1 derivee / aire
  !	g2 derivee / vlsr
  !	g3 derivee / delt
  !
  ! Compute gaussians
  do i=1,nxy
    if (weight(i).eq.0) cycle
    xvel = rdatax(i)
    ! First
    arg1 = (xvel - v1) / d1
    if (abs(arg1).gt.4.) then
      f1 = 0.
      ff = 0.
    else
      f1 = exp(-arg1**2)
      ff = f1 * t1 / d1
    endif
    if (nline.le.1) goto 610
    ! Second
    arg2 = (xvel - v2) / d2
    if (abs(arg2).gt.4.) then
      f2=0.
    else
      f2 = exp(-arg2**2)
      ff = ff + f2 * t2 / d2
    endif
    if (nline.le.2) goto 610
    ! Third
    arg3 = (xvel - v3) / d3
    if (abs(arg3).gt.4.) then
      f3=0.
    else
      f3 = exp(-arg3**2)
      ff = ff + f3 * t3 / d3
    endif
    if (nline.le.3) goto 610
    ! Fourth
    arg4 = (xvel - v4) / d4
    if (abs(arg4).gt.4.) then
      f4=0.
    else
      f4 = exp(-arg4**2)
      ff = ff + f4 * t4 / d4
    endif
    if (nline.le.4) goto 610
    ! Fifth
    arg5 = (xvel - v5) / d5
    if (abs(arg5).gt.4.) then
      f5=0.
    else
      f5 = exp(-arg5**2)
      ff = ff + f5 * t5 / d5
    endif
    !
610 continue
    !
    ! Compute du Chi-2 (No ponderation, WEIGHT is ignored)
    ff =  (ff - rdatay(i))
    f = f + ff**2
    !
    ! Compute Gradients
    if (.not.dograd) goto 620
    ff = 2.*ff
    ! First
    if (f1.ne.0.) then
      arg = f1*ff/d1
      g1  = g1 + arg
      gt  = gt + arg*t1
      arg = t1/d1*arg
      g3  = g3 - arg
      gd  = gd - arg*d1
      arg = arg*arg1*2.
      g2  = g2 + arg
      gv  = gv + arg
      g3  = g3 + arg*arg1
      gd  = gd + arg*arg1*d1
    endif
    if (nline.le.1) goto 620
    ! Second
    if (f2.ne.0.) then
      arg = f2*ff/d2
      g4  = g4 + arg
      gt  = gt + arg*t2
      arg = arg*t2/d2
      g6  = g6 - arg
      gd  = gd - arg*d2
      arg = arg*arg2*2.
      g5  = g5 + arg
      gv  = gv + arg
      g6  = g6 + arg*arg2
      gd  = gd + arg*arg2*d2
    endif
    if (nline.le.2) goto 620
    ! Third
    if (f3.ne.0.) then
      arg = f3*ff/d3
      g7  = g7 + arg
      gt  = gt + arg*t3
      arg = arg*t3/d3
      g9  = g9 - arg
      gd  = gd - arg*d3
      arg = arg*arg3*2.
      g8  = g8 + arg
      gv  = gv + arg
      g9  = g9 + arg*arg3
      gd  = gd + arg*arg3*d3
    endif
    if (nline.le.3) goto 620
    ! Fourth
    if (f4.ne.0.) then
      arg = f4*ff/d4
      g10 = g10 + arg
      gt  = gt + arg*t4
      arg = arg*t4/d4
      g12 = g12 - arg
      gd  = gd - arg*d4
      arg = arg*arg4*2.
      g11 = g11 + arg
      gv  = gv + arg
      g12 = g12 + arg*arg4
      gd  = gd + arg*arg4*d4
    endif
    if (nline.le.4) goto 620
    ! Fifth
    if (f5.ne.0.) then
      arg = f5*ff/d5
      g13 = g13 + arg
      gt  = gt  + arg*t5
      arg = arg*t5/d5
      g15 = g15 - arg
      gd  = gd - arg*d5
      arg = arg*arg5*2.
      g14 = g14 + arg
      gv  = gv  + arg
      g15 = g15 + arg*arg5
      gd  = gd  + arg*arg5*d5
    endif
620 continue
    !
  enddo                        ! I
  !
  ! Setup values and return
  f = f
  g(1)=gt/tt
  g(2)=gv
  g(3)=gd/dd
  !
  g(4)=g1*tt
  g(5)=g2
  g(6)=g3*dd
  goto (701,702,703,704,705) nline
701 return
705 g(16)=g13*tt
  g(17)=g14
  g(18)=g15*dd
704 g(13)=g10*tt
  g(14)=g11
  g(15)=g12*dd
703 g(10)=g7*tt
  g(11)=g8
  g(12)=g9*dd
702 g(7)=g4*tt
  g(8)=g5
  g(9)=g6*dd
  return
  !
  ! Compute Sigma after Minimisation
20 kbas=0
  ybas=0.
  krai=0
  yrai=0.
  seuil= sigbas/3.
  !
  do i=1,nxy
    if (weight(i).eq.0) cycle
    ta = progauss (rdatax(i),0)
    if (abs(ta).lt.seuil) then
      kbas=kbas+1
      ybas=ybas+rdatay(i)**2
    else
      krai=krai+1
      yrai=yrai+(ta-rdatay(i))**2
    endif
  enddo
  if (kbas.ne.0) then
    sigbas=sqrt(ybas/kbas)
  else
    sigbas=0.d0
  endif
  if (krai.ne.0) then
    sigrai=sqrt(yrai/krai)
  else
    sigrai=0.d0
  endif
end subroutine mingau
!
function progauss (a,m)
  !---------------------------------------------------------------------
  ! ANALYSE	(Internal routine)
  !	M = 0
  ! 	Computes the composite profile from sum of all gaussians.
  !	M # 0
  !	Computes the profile from gaussian number M
  !
  ! S. Guilloteau 19-Dec-1984
  !---------------------------------------------------------------------
  real*4 :: progauss                !
  real*4 :: a                       !
  integer :: m                      !
  ! Global
  include 'gauss.inc'
  ! Local
  real*4 :: arg
  !
  progauss=0.
  arg=0.
  goto (1,2,3,4,5) m
  !
1 continue
  if (par(1).ne.0 .and. par(3).ne.0.) then
    arg = abs((a - par(2)) / par(3)*1.665109)
    if (arg.lt.4.) then
      progauss = exp(-arg**2)*par(1)/par(3)/1.064467
    endif
  endif
  if (ngline.le.1 .or. m.eq.1) return
  !
2 continue
  if (par(4).ne.0 .and. par(6).ne.0.) then
    arg = abs((a - par(5)) / par(6)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(4)/par(6)/1.064467
    endif
  endif
  if (ngline.le.2 .or. m.eq.2) return
  !
3 continue
  if (par(7).ne.0 .and. par(9).ne.0.) then
    arg = abs((a - par(8)) / par(9)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(7)/par(9)/1.064467
    endif
  endif
  if (ngline.le.3 .or. m.eq.3) return
  !
4 continue
  if (par(10).ne.0. .and. par(12).ne.0.) then
    arg = abs((a - par(11)) / par(12)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(10)/par(12)/1.064467
    endif
  endif
  if (ngline.le.4 .or. m.eq.4) return
  !
5 continue
  if (par(13).ne.0. .and. par(15).ne.0.) then
    arg = abs((a - par(14)) / par(15)*1.665109)
    if (arg.lt.4.) then
      progauss = progauss + exp(-arg**2)*par(13)/par(15)/1.064467
    endif
  endif
end function progauss

module gpack_private
  use gpack_def
  !---------------------------------------------------------------------
  ! @private
  ! Definitions for internal package management
  !---------------------------------------------------------------------
  !
  integer(kind=4) :: gpack_registered_count = 0  ! Current number of registered packages
  type(gpack_prop_t), save :: gpack_packages(gpack_max_count)
  !
end module gpack_private
!
function gpack_get_count()
  use gpack_private
  !---------------------------------------------------------------------
  ! @ public
  ! Return number of registered packages
  !---------------------------------------------------------------------
  integer(kind=4) :: gpack_get_count
  !
  gpack_get_count = gpack_registered_count
  !
end function gpack_get_count
!
function gpack_get_info(ipack)
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ public
  ! Return package information structure
  !---------------------------------------------------------------------
  type(gpack_info_t) :: gpack_get_info
  integer(kind=4), intent(in) :: ipack
  !
  gpack_get_info = gpack_packages(ipack)%info
  !
end function gpack_get_info
!
subroutine gpack_get_name(id,packname,error)
  use gpack_def
  use gpack_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! Get package name from the given package id
  !---------------------------------------------------------------------
  integer(kind=4),  intent(in)    :: id
  character(len=*), intent(out)   :: packname
  logical,          intent(inout) :: error
  ! Local
  character(len=message_length) :: mess
  !
  if (id.eq.0) then
     packname = gpack_global_name
  else if (1.le.id .and. id.le.gpack_registered_count) then
     packname = gpack_packages(id)%info%name
  else
     write(mess,*) "Unknown package id #",id
     call gsys_message(seve%e,"PACK",mess)
     packname = 'UNKNOWN'
     error = .true.
     return
  endif
  !
end subroutine gpack_get_name
!
function gpack_get_id(gpack_name,present,error)
  use gsys_interfaces, except_this=>gpack_get_id
  use gpack_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Private function to get the package id from the package name
  !---------------------------------------------------------------------
  integer(kind=4)  :: gpack_get_id ! Returned package id
  character(len=*), intent(in)    :: gpack_name   ! Package name
  logical,          intent(in)    :: present      ! Must the package be already registered?
  logical,          intent(inout) :: error        ! Error flag
  !
  if (gpack_name.eq.gpack_global_name) then
     gpack_get_id = gpack_global_id
     return
  else
     do gpack_get_id=1,gpack_registered_count
        if (gpack_packages(gpack_get_id)%info%name.eq.gpack_name) return
     end do
  endif
  !
  ! Unknown package name may be licit at init time, not after:
  gpack_get_id = gpack_null_id
  if (present) then
     call gsys_message(seve%e,"PACK",'Unknown package name '''//gpack_name//'''')
     error = .true.
  endif
  !
end function gpack_get_id
!
function gpack_register(pack,error)
  use gsys_interfaces, except_this=>gpack_register
  use gpack_def
  use gpack_private
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  ! Private function to register a package and return a new package id
  !----------------------------------------------------------------------
  integer(kind=4) :: gpack_register
  type(gpack_prop_t), intent(in)    :: pack
  logical,            intent(inout) :: error
  !
  gpack_register = 0
  !
  ! Check package registration status
  if (gpack_get_id(pack%info%name,.false.,error).ne.gpack_null_id) then
     ! Already registred
     call gag_message(seve%e,'GAG_REGISTER','Package '//pack%info%name//' already registered')
     error = .true.
     return
  else if (gpack_registered_count.eq.gpack_max_count) then
     call gag_message(seve%e,'GAG_REGISTER','Too many registered packages: Increase gpack_max_count')
     error = .true.
     return
  endif
  !
  gpack_registered_count = gpack_registered_count+1
  gpack_packages(gpack_registered_count) = pack
  gpack_packages(gpack_registered_count)%id = gpack_registered_count
  !
  if (pack%info%toscreen.ne.'') then
     call gmessage_parse_and_set(gpack_registered_count,pack%info%toscreen,error)
     if (error) return
  endif
  if (pack%info%tofile.ne.'') then
     call gmessage_parse_and_set(gpack_registered_count,pack%info%tofile,error)
     if (error) return
  endif
  !
  gpack_register = gpack_registered_count
  !
end function gpack_register
!
subroutine gpack_resolve(packname,found,error)
  use gsys_interfaces, except_this=>gpack_resolve
  use gbl_message
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ public
  ! Resolve packname string ambiguities
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: packname  ! Package name
  logical,          intent(out)   :: found     ! Found package?
  logical,          intent(inout) :: error     ! Error flag
  ! Local
  character(len=*), parameter :: rname='gpack_resolve'
  integer(kind=4) :: id,ipack
  character(len=gpack_name_length) :: outname                      ! Resolved package name
  character(len=gpack_name_length) :: allnames(gpack_max_count+1)  ! All packages name
  !
  found = .false.
  call sic_lower(packname)
  allnames(1:1+gpack_registered_count) =  &
    (/ gpack_global_name,(gpack_packages(ipack)%info%name,ipack=1,gpack_registered_count) /)
  !
  call sic_ambigs_sub(rname,packname,outname,id,allnames,gpack_registered_count+1,error)
  if (error) return  ! There was an ambiguity
  !
  if (id.gt.0) then  ! Found 1 and only 1 correspondance
    found = .true.
    packname = outname
  endif
  !
end subroutine gpack_resolve
!
function gpack_is_registered(gpack_name)
  use gsys_interfaces, except_this=>gpack_is_registered
  use gpack_private
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! Check registration status of a package
  !---------------------------------------------------------------------
  logical                      :: gpack_is_registered  ! Package registration status
  character(len=*), intent(in) :: gpack_name           ! Package name
  ! Local
  logical :: error
  !
  ! Check package status
  error = .false.
  if (gpack_get_id(gpack_name,.false.,error).ne.gpack_null_id) then
     gpack_is_registered = .true.
  else
     gpack_is_registered = .false.
  endif
  !
end function gpack_is_registered
!
subroutine gexec0(routine)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Call a routine from its address with no argument
  !---------------------------------------------------------------------
  external :: routine
  !
  call routine
end subroutine gexec0
!
subroutine gexec1(routine,a1)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Call a routine from its address with 1 argument
  !---------------------------------------------------------------------
  external        :: routine
  integer(kind=4) :: a1
  !
  call routine(a1)
end subroutine gexec1
!
subroutine gexec2(routine,a1,a2)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Call a routine from its address with 2 arguments
  !---------------------------------------------------------------------
  external        :: routine
  integer(kind=4) :: a1
  integer(kind=4) :: a2
  !
  call routine(a1,a2)
end subroutine gexec2
!
recursive subroutine gexec3(routine,a1,a2,a3)
  !---------------------------------------------------------------------
  ! @ no-interface
  ! Call a routine from its address with 3 arguments. Subroutine is
  ! recursive because of recursive calls in gpack_recurse_depend
  !---------------------------------------------------------------------
  external        :: routine
  integer(kind=4) :: a1
  integer(kind=4) :: a2
  integer(kind=4) :: a3
  !
  call routine(a1,a2,a3)
end subroutine gexec3
!
recursive subroutine gpack_recurse(pack_fct,pack_id,error)
  use gsys_interfaces, except_this=>gpack_recurse
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private
  ! Call pack_fct on all package from the dependency hierarchy, starting
  ! from low level packages and ending with the root package given by
  ! pack_id
  !---------------------------------------------------------------------
  external                       :: pack_fct
  integer(kind=4), intent(in)    :: pack_id
  logical,         intent(inout) :: error
  ! Local
  logical :: pack_reach_flags(gpack_max_count)
  integer(kind=4) :: ipack
  !
  pack_reach_flags = (/ (.false., ipack=1,gpack_max_count) /)
  !
  call gpack_recurse_depend(pack_fct,gpack_packages(pack_id),  &
    gpack_packages(pack_id),.true.,0,pack_reach_flags,error)
  !
end subroutine gpack_recurse
!
subroutine gpack_recurse_high_first(pack_fct,pack_id,error)
  use gsys_interfaces, except_this=>gpack_recurse_high_first
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private
  ! Call pack_fct on all package from the dependency hierarchy, starting
  ! from the root package given by pack_id and ending with low level
  ! packages
  !---------------------------------------------------------------------
  external                       :: pack_fct
  integer(kind=4), intent(in)    :: pack_id
  logical,         intent(inout) :: error
  ! Local
  logical :: pack_reach_flags(gpack_max_count)
  integer(kind=4) :: ipack
  !
  pack_reach_flags = (/ (.false., ipack=1,gpack_max_count) /)
  !
  call gpack_recurse_depend(pack_fct,gpack_packages(pack_id),  &
    gpack_packages(pack_id),.false.,0,pack_reach_flags,error)
  !
end subroutine gpack_recurse_high_first
!
recursive subroutine gpack_recurse_depend(pack_fct,pack,parent_pack,low_first,  &
  recurse_level,pack_reach_flags,error)
  use gsys_interfaces, except_this=>gpack_recurse_depend
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private
  ! Generic routine to recurse through all dependent packages of package
  ! pack
  !---------------------------------------------------------------------
  external                          :: pack_fct       ! Function to call on each package
  type(gpack_prop_t), intent(in)    :: pack           ! Package to start from
  type(gpack_prop_t), intent(in)    :: parent_pack    ! Initial recursion package
  logical,            intent(in)    :: low_first      ! Call pack_fct from low level package to high level
  integer(kind=4),    intent(in)    :: recurse_level  !
  logical,            intent(inout) :: pack_reach_flags(gpack_max_count)
  logical,            intent(inout) :: error          ! Error flag
  ! Global
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ipack, pack_depend_id
  !
  ! call pack_fct
  if (.not.low_first) then
     call gexec3(pack_fct,pack,parent_pack,error)
     if (error) return
  endif
  !
  ! Loop over the registered packages
  do ipack=1,gpack_registered_count,1
     pack_depend_id = pack%depend_id(ipack)
     if (pack_depend_id.eq.0) exit
     !
     ! Flag reached package
     if (pack_reach_flags(pack_depend_id)) cycle
     pack_reach_flags(pack_depend_id) = .true.
     !
     ! Do recursion
     call gpack_recurse_depend(pack_fct,gpack_packages(pack_depend_id),parent_pack,  &
       low_first,recurse_level+1,pack_reach_flags,error)
     if (error) return
  end do
  !
  ! Recurse again or call pack_fct
  if (low_first) then
     call gexec3(pack_fct,pack,parent_pack,error)
     if (error) return
  endif
  !
end subroutine gpack_recurse_depend
!
recursive subroutine gpack_set_dependencies(pack,error)
  use gsys_interfaces, except_this=>gpack_set_dependencies
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private
  ! Intermediate routine to call gpack_set recursively and build package
  ! depend_id member
  !---------------------------------------------------------------------
  type(gpack_prop_t), intent(inout) :: pack
  logical,            intent(inout) :: error
  ! Global
  integer(kind=4) :: gpack_set
  include 'gbl_memory.inc'
  ! Local
  integer(kind=4) :: ipack
  logical :: already_registered
  !
  do ipack = 1,gpack_max_count
     if (pack%info%depend(ipack).eq.0) exit
     pack%depend_id(ipack) = gpack_set(membyt(bytpnt(pack%info%depend(ipack),membyt)),already_registered,error)
     if (error) return
  end do
  !
end subroutine gpack_set_dependencies
!
recursive function gpack_set(pack_set,already_registered,error)
  use gsys_interfaces
  use gpack_private
  !---------------------------------------------------------------------
  ! @ no-interface (because of argument type mismatch)
  ! Private routine to define and register a package and all its
  !  dependencies.
  !---------------------------------------------------------------------
  integer(kind=4) :: gpack_set
  external               :: pack_set   ! package definition method
  logical, intent(out)   :: already_registered
  logical, intent(inout) :: error
  ! Local
  type(gpack_prop_t) :: pack
  !
  gpack_set = 0
  !
  call pack_set(pack%info)
  !
  ! Check package registration status
  if (gpack_is_registered(pack%info%name)) then
     gpack_set = gpack_get_id(pack%info%name,.true.,error)
     already_registered = .true.
     return
  endif
  already_registered = .false.
  !
  ! Take care of dependencies:
  ! This must be done before registration of current package
  call gpack_set_dependencies(pack,error)
  if (error) return
  !
  ! Store registration information
  gpack_set = gpack_register(pack,error)
  if (error) return
  !
end function gpack_set
!
subroutine gpack_init(pack,parent_pack,error)
  use gsys_interfaces, except_this=>gpack_init
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Call package init method from gpack_recurse
  !---------------------------------------------------------------------
  type(gpack_prop_t), intent(inout) :: pack
  type(gpack_prop_t), intent(in)    :: parent_pack
  logical,            intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  !
  if (pack%init_done) return
  !
  if (pack%info%init.ne.0) then
     call gexec2(membyt(bytpnt(pack%info%init,membyt)),pack%id,error)
  endif
  !
  call gpack_recurse(gpack_exec_on_child,pack%id,error)
  if (error) return
  !
  pack%init_done = .true.
  !
end subroutine gpack_init
!
subroutine gpack_exec_on_child(pack,parent_pack,error)
  use gsys_interfaces, except_this=>gpack_exec_on_child
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private-mandatory (because symbol is used elsewhere)
  ! Call package exec_on_child method from gpack_recurse_again
  !---------------------------------------------------------------------
  type(gpack_prop_t), intent(in)    :: pack
  type(gpack_prop_t), intent(in)    :: parent_pack
  logical,            intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  !
  if (pack%info%exec_on_child.ne.0.and..not.parent_pack%init_done) then
     call gexec2(membyt(bytpnt(pack%info%exec_on_child,membyt)),parent_pack%info,error)
  endif
end subroutine gpack_exec_on_child
!
subroutine gpack_clean(pack,parent_pack,error)
  use gsys_interfaces, except_this=>gpack_clean
  use gpack_def
  use gpack_private
  !---------------------------------------------------------------------
  ! @ private
  ! Call package start method from gpack_recurse_high_first
  !---------------------------------------------------------------------
  type(gpack_prop_t), intent(in)    :: pack
  type(gpack_prop_t), intent(in)    :: parent_pack
  logical,            intent(inout) :: error
  ! Global
  include 'gbl_memory.inc'
  !
  if (pack%info%clean.ne.0) then
     call gexec1(membyt(bytpnt(pack%info%clean,membyt)),error)
  endif
end subroutine gpack_clean
!
function gpack_build(pack_set,already_registered,error)
  use gsys_interfaces, except_this=>gpack_build
  !---------------------------------------------------------------------
  ! @ public
  ! Builds a package and its dependencies, returns package registration
  ! id
  !---------------------------------------------------------------------
  integer(kind=4) :: gpack_build
  external               :: pack_set
  logical, intent(out)   :: already_registered
  logical, intent(inout) :: error
  ! Global
  integer(kind=4) :: gpack_set
  ! Local
  integer(kind=4) :: pack_id
  !
  gpack_build = 0
  !
  pack_id = gpack_set(pack_set,already_registered,error)
  if (error) return
  !
  if (already_registered) then
     gpack_build = pack_id
     return
  endif
  !
  call gpack_recurse(gpack_init,pack_id,error)
  if (error) return
  !
  gpack_build = pack_id
  !
end function gpack_build

subroutine many_beams_para (rname,map,channels,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
     &    r_weight, do_weig,    &
     &    sblock,cpu0,error,uvmax,jfield,abort,cthread)
  use gkernel_interfaces
  use imager_interfaces, except_this=>many_beams_para
  use clean_def
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_MAP  
  !   Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   a different beam per channel.
  !
  ! Input :  
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  ! Output :  
  ! a beam image  
  ! a VLM cube  
  !
  ! Work space :  
  ! a  VLM complex Fourier cube (first V value is for beam)
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Caller name
  type (uvmap_par), intent(inout) :: map    !! Mapping parameters
  type (channel_par), intent(inout) :: channels   !! Control of range & beam
  type (gildas), intent(inout) :: huv       !! UV data set header
  type (gildas), intent(inout) :: hbeam     !! Dirty beam data set
  type (gildas), intent(inout) :: hdirty    !! Dirty image data set
  integer, intent(in) :: nx     !! X size
  integer, intent(in) :: ny     !! Y size
  integer, intent(in) :: nu     !! Size of a visibility
  integer, intent(in) :: nv     !! Number of visibilities
  real, intent(in) :: uvdata(nu,nv)  !! Visibilities
  real, intent(inout), target :: r_weight(nv)      !! Weight of visibilities
  logical, intent(inout) :: do_weig  !! Compute weights ? 
  integer, intent(in) :: jfield      !! Field number (for mosaic)
  real, intent(inout) :: cpu0        !! Running CPU time
  real, intent(inout) :: uvmax       !! Maximum baseline
  integer, intent(inout) :: sblock   !! Blocking factor (in visibilities)
  logical, intent(inout) :: error    !! Logical error flag
  logical, intent(inout) :: abort    !! User Abort flag
  integer, intent(in)    :: cthread  !! Calling Thread number for bookeeping
  ! 
  ! Constants
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  !
  ! Local ---
  type (gridding) :: conv   ! Gridding convolution control
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer :: nb   ! Number of beams
  integer :: ns   ! Number of channels per single beam
  integer :: wcol     ! Weight channel
  integer :: mcol(2)  ! First and last channel
  integer :: lcol,fcol,ier
  real(kind=8) :: freq
  integer ctypx,ctypy
  real wall,cpu1
  real xparm(10),yparm(10)
  real(8) :: vref,voff,vinc
  integer ndim, nn(2), lx, ly, kz1
  integer kz,iz,ic,kc,kb,jc,lc
  character(len=message_length) :: chain
  !
  real :: rms, null_taper(4), wold
  complex, allocatable :: ftbeam(:,:)
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_xgrid(:),w_ygrid(:), w_w(:),  w_grid(:,:), walls(:)
  real, allocatable :: w_weight(:)
  real, allocatable :: w_v(:)         ! V values
  real, allocatable :: beam(:,:)
  real, allocatable :: w_mapu(:), w_mapv(:)
  real, allocatable :: local_wfft(:)
  real uvcell(2)
  real support(2)
  real(8) local_freq
  !
  integer :: ithread, nthread
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  real :: toto
  logical :: local_error
  integer :: grid_code
  !
  ! Code ----
  call imager_tree('MANY_BEAMS_PARA in many_beams.f90',.false.)
  !
  ! Code:
  grid_code = 0
  error = .false.
  abort = .false.
  nd = nx*ny
  nc = huv%gil%nchan
  nb = hbeam%gil%dim(3)
  !
  ns = map%beam
  null_taper = 0
  !
  if (ns.ne.1 .and. nb.gt.1) then
    write(chain,'(a,i6,a)') 'Processing ',ns,' channels per beam'
    call map_message(seve%w,rname,chain)
  endif
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  !
  ! Channel range and Weight
  mcol = channels%bounds
  wcol = channels%weight 
  fcol = channels%bounds(1)
  lcol = channels%bounds(2)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  if (channels%freq.ne.0) then
    freq = gdf_uv_frequency(huv, channels%freq)
  else
    freq = gdf_uv_frequency(huv)
  endif
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Process sorted UV Table according to the type of beam produced
  !
  allocate (w_w(nv),w_v(nv),w_weight(nv),walls(nb),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Weight & V arrays')
    error = .true.
    return
  endif
  w_v(:) = uvdata(2,1:nv)
  !
  !
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%w,rname,chain,3)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  !
  ! Get FFTs and beam work spaces
  allocate (tfgrid(ns+1,lx,ly),ftbeam(nx,ny),beam(nx,ny),&
    & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)), &
    & w_xgrid(nx),w_ygrid(ny),w_grid(nx,ny),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate TF arrays')
    error = .true.
    return
  endif
  !
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  ! Prepare grid correction,
  call grdtab (ny, conv%vbuff, conv%vbias, w_ygrid)
  call grdtab (nx, conv%ubuff, conv%ubias, w_xgrid)
  !
  ! Make beam, not normalized
  call uvmap_headers(huv,nx,ny,nb,ns,map,mcol,hbeam,hdirty,error)
  if (error) return
  if (sic_ctrlc()) then
    abort = .true. ! Quick abort
    return
  endif
  !
  ndim =2
  nn(1) = nx
  nn(2) = ny
  !
  nthread = 1
  if (nb.gt.1) then
    !$ nthread = ompget_inner_threads()
  endif
  !TEST!Print *,'MANY_BEAMS_PARA Thread ',nthread,' NB ',nb,' NS ',ns
  !
  ! Loop over blocks
  !
  !$OMP PARALLEL IF (nb.gt.1) DEFAULT(none) NUM_THREADS (nthread) &
  !$OMP PRIVATE(tfgrid,ftbeam,beam,w_weight,w_w) &  ! Big arrays
  !$OMP PRIVATE(w_mapu,w_mapv,w_grid) &
  !$OMP PRIVATE(local_wfft,chain) &
  !$OMP PRIVATE(local_freq,support,wall,wold,rms,uvcell,local_error) &
  !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1, toto, jc,lc) &
  !$OMP SHARED(walls,ns,nb) &
  !$OMP SHARED(nu,nv,nx,ny,nc,nd,fcol,lcol,lx,ly, nthread) &
  !$OMP SHARED(map,null_taper,error,abort,grid_code) &
  !$OMP SHARED(conv,freq,do_weig, r_weight) &
  !$OMP SHARED(nn,ndim,huv,hbeam,hdirty,rname) &
  !$OMP SHARED(w_xgrid,w_ygrid,w_v,uvdata) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
  !
  kz = 1 ! test for bug below
  !
  !TEST!Print *,'KZ ',kz,' NC ',nc,' nd ',nd
  !$OMP DO
  do ic = fcol,lcol,ns ! ,ns or ,1
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    kz = min(ns,lcol-ic+1)
    jc = min(huv%gil%nchan,ic+ns/3)   ! The default weight channel here...
    !TEST!Print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' NS ',ns
    ithread = 1
    !$ elapsed_s = omp_get_wtime()
    !$ ithread = omp_get_thread_num()+1
    !TEST!Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', NS ',ns
    !
    kb = (ic-fcol)/ns+1
    if (kb.gt.nb .or. kb.lt.1) then
      Print *,'Programming error, expected 0 < ',kb,' < ',nb+1
      kb = nb
    endif
    !
    w_w(:) = uvdata(7+3*jc,:)
    wold = sump(nv,w_w)
    !
    ! Search for a non empty weight channel
    if (wold.eq.0) then
      do lc=ic,min(ic+ns,lcol) ! not  ,huv%gil%nchan)
        if (lc.ne.jc) then
          w_w(:) = uvdata(7+3*lc,:)
          wold = sump(nv,w_w)
          if (wold.ne.0) then
            jc = lc
            exit
          endif
        endif
      enddo
    endif
    !
    if (wold.eq.0) then
      write(chain,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
      hbeam%r3d(:,:,kb) = 0
      hdirty%r3d(:,:,kb) = 0
      walls(kb) = 0.0
      if (nb.eq.1) then
        call map_message(seve%e,rname,chain)
        error = .true.
      else
        call map_message(seve%w,rname,chain)
      endif
      cycle
    else
      wall = 1e-3/sqrt(wold)
      !TEST!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
      !TEST!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Compute the weights from this
    if (do_weig) then
      local_error = .false.
      call doweig (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,    &            ! U, V pointers
         &    jc,     &            ! Weight channel
         &    map%uniform(1),   &  ! Uniform UV cell size
         &    w_weight,   &        ! Weight array
         &    map%uniform(2),   &  ! Fraction of weight
         &    local_error,      &
         &    grid_code)
         
      if (sic_ctrlc()) abort = .true. ! Quick abort
      if (abort) cycle
      if (local_error)  then
        error = .true.
        cycle
      endif
  !    Print *,ic,'doweig',w_v
  !    read(5,*) toto
      !
      ! Should also plug the TAPER here, rather than in DOFFT later  !
      call dotape (nu,nv,   &
         &    uvdata,   &          ! Visibilities
         &    1,2,   &             ! U, V pointers
         &    map%taper,  &        ! Taper
         &    w_weight)            ! Weight array
      if (sic_ctrlc()) abort = .true. ! Quick abort
      if (abort) cycle
    else
      call map_message(seve%i,rname,'Reusing weights')
      w_weight(:) = r_weight
    endif
    !
    ! Re-normalize the weights and re-count the noise
    wall = sump(nv,w_weight)
    if (wall.ne.wold) then
      call scawei (nv,w_weight,w_w,wall)
      wall = 1e-3/sqrt(wall)
      !TEST!write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
      !TEST!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Then compute the Dirty Beam
    local_freq = gdf_uv_frequency(huv, dble(ic))
    uvcell = map%uvcell * (freq / local_freq)
    support = map%support * (freq / local_freq)
    call docoor (lx,-uvcell(1),w_mapu)
    call docoor (ly,uvcell(2),w_mapv)
    !TEST!Print *,ic,'docoor'
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    ! Compute FFTs
    call dofft (nu,nv,          &   ! Size of visibility array
         &    uvdata,           &   ! Visibilities
         &    1,2,              &   ! U, V pointers
         &    ic,               &   ! First channel to map
         &    kz,lx,ly,         &   ! Cube size
         &    tfgrid,           &   ! FFT cube
         &    w_mapu,w_mapv,    &   ! U and V grid coordinates
         &    support,uvcell,null_taper, &  ! Gridding parameters
         &    w_weight,         &    ! Weight array 
         &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       !TEST!Print *,ic,'dofft'
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    kz1 = kz+1
    call extracs(kz1,nx,ny,kz1,tfgrid,ftbeam,lx,ly)
    call fourt  (ftbeam, nn,ndim,-1,1,local_wfft)
    beam = 0.0
    call cmtore (ftbeam, beam ,nx,ny)
    call chkfft (beam, nx,ny, error)
    !TEST!   Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
    !TEST!Print *,'NU,NV ',nu,nv
    !TEST!Print *,'IC ',ic
    !TEST!Print *,'KZ,LX,LY ',kz,lx,ly
    !TEST!Print *,'support ',support,' uvcell ',uvcell, ' null_taper ',null_taper
    !TEST!Print *,'conv%ubias,conv%vbias,map%ctype ',conv%ubias,conv%vbias,map%ctype
    !TEST!Print *, ' '
    if (error) then
      Print *,ic,'BEAM ',nx,ny,beam(nx/2+1,ny/2+1)
      Print *,'Local freq ',local_freq
      Print *,'KZ, LX, LY ', kz,lx,ly, ' nx,ny ',nx,ny, ' NS ',ns
      call gagout('E-UV_MAP,  Inconsistent pixel size')
!      read(5,*) ians
!      if (ians.eq.1) then
!        Print *,tfgrid(kz+1,:,ly/2)
!      endif
      cycle
    endif
    !
    ! Compute grid correction,
    ! Normalization factor is applied to grid correction, for further
    ! use on channel maps.
    !
    ! Make beam, not normalized
    call dogrid (w_grid,w_xgrid,w_ygrid,nx,ny,beam)  ! grid correction
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    ! Normalize and Free beam
    call docorr (beam,w_grid,nx*ny)
       !TEST!Print *,ic,'docorr'
    !
    ! Write beam
    hbeam%r3d(:,:,kb) = beam
       !TEST!Print *,ic,'Done Beam ',kc,nc
    ! --- Done beam
    !
    ! Now extracts the Image planes...
    do iz=1,kz
      if (sic_ctrlc()) abort = .true. ! Quick abort
      if (abort) cycle
      call extracs(kz+1,nx,ny,iz,tfgrid,ftbeam,lx,ly)
      call fourt  (ftbeam,nn,ndim,-1,1,local_wfft)
      call cmtore (ftbeam,beam,nx,ny)
      call docorr (beam,w_grid,nd)
      ! Write the subset
      kc = ic-fcol+iz
      hdirty%r3d(:,:,kc) = beam
    enddo
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End plane ',kc,' Time ',elapsed &
      & ,' Thread ',ithread
    call map_message(seve%d,rname,chain)
    if (do_weig .and. nb.eq.1) then
      do_weig = .false.
      r_weight = w_weight
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
!TEST!  !$ if (nb.gt.1) call omp_set_num_threads(othread)
  if (error) return
  if (abort) return
  !
  call gag_cpu(cpu1)
  if (jfield.eq.0) then
    write(chain,102) 'Finished maps ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
  endif
  !
  wall = maxval(walls(1:nb))
  if (jfield.eq.0) then
    chain = 'Expected'
  else
    write(chain,'(A,I0,A)') 'Field ',jfield,'; Expected'
  endif
  call prnoise(rname,trim(chain),wall,rms)
  hdirty%gil%noise = wall
  !  !
  ! Delete scratch space
  error = .false.
  if (nb.ne.1)  deallocate(w_grid)
  if (allocated(tfgrid)) deallocate(tfgrid)
  if (allocated(ftbeam)) deallocate(ftbeam)
  if (allocated(w_xgrid)) deallocate(w_xgrid)
  if (allocated(w_ygrid)) deallocate(w_ygrid)
  !
  call imager_tree('MANY_BEAMS_PARA',.true.)
  return
  !
102 format(a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
end subroutine many_beams_para
!
subroutine uv_grid_comm(line,comm,error)
  use clean_arrays
  use clean_default
  use gkernel_interfaces
  use imager_interfaces
  !! Test routine -- not yet used
  character(len=*), intent(in) :: comm
  character(len=*), intent(in) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec_in_rad = pi/3600d0/180d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  !
  logical :: abort
  type(channel_par) :: channels
  real :: cpu0
  character(len=16) :: task
  integer :: cthread=1 ! Not needed ?
  real(8) :: freq
  integer :: nu,nv,nx,ny
  real :: uvmin, uvmax,rmega
  integer :: sblock,ier
  !
  task = comm
  !
  error = .false.
  !
  call uvmap_cols(task,line,huv,channels,error)
  if (error) return 
  !
  call uvgmax (huv,duv,uvmax,uvmin)
  freq = gdf_uv_frequency(huv)
    Print *,'Doing map-parameters', freq, uvmin, uvmax
    Print *,'MAP ',themap%size, themap%field, themap%xycell
  uvmax = uvmax*(freq*f_to_k)
  uvmin = uvmin*(freq*f_to_k)
  call map_parameters(task,themap,huv,freq,uvmax,uvmin,error,.true.) ! huv%gil%majo)
  if (error) return
  uvmax = uvmax/(freq*f_to_k)
  themap%xycell = themap%xycell*pi/180.0/3600.0   ! Must be in Radian
  !
  nx = themap%size(1)
  ny = themap%size(2)
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi ! not %%dim(2)
  !
  rmega = 8.0
  ier = sic_ramlog('SPACE_IMAGER',rmega)
  sblock = max(int(256.0*rmega*1024.0)/(nx*ny),1)
  !
  Print *,'NX, NY ',nx,ny
  themap%ctype = 5
  call uv_grid_para (task,themap,channels,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,duv,   &
!     &    r_weight, do_weig,    &
     &    sblock,cpu0,error,uvmax,1,abort,cthread)
  !
end subroutine uv_grid_comm
!
subroutine uv_grid_para (rname,map,channels,huv,hbeam,hdirty,   &
     &    nx,ny,nu,nv,uvdata,   &
!     &    r_weight, do_weig,    &
     &    sblock,cpu0,error,uvmax,jfield,abort,cthread)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_grid_para
  use clean_def
  use image_def
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !*
  ! IMAGER -- Support routine for UV_MAP  
  !   Re-grid (normally huge) sorted UV table
  !   by Gridding and return the result as a new UV Table
  !
  ! Input :  
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  ! Output :  
  ! a UV table, with no antenna numbers
  !
  ! Work space :  
  ! a  VLM complex Fourier cube (first V value is for beam)
  !!
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: rname     !! Calling Task name
  type (uvmap_par), intent(inout) :: map    !! Mapping parameters
  type (channel_par), intent(inout) :: channels   !! Control of range & beam
  type (gildas), intent(inout) :: huv       !! UV data set
  type (gildas), intent(inout) :: hbeam     !! Dirty beam data set
  type (gildas), intent(inout) :: hdirty    !! Dirty image data set
  integer, intent(in) :: nx     !! X size
  integer, intent(in) :: ny     !! Y size
  integer, intent(in) :: nu     !! Size of a visibility
  integer, intent(in) :: nv     !! Number of visibilities
  real, intent(in) :: uvdata(nu,nv)  !! Visibilities
  integer, intent(in) :: jfield      !! Field number (for mosaic)
  real, intent(inout) :: cpu0        !! Running CPU counter
  real, intent(inout) :: uvmax       !! Maximum baseline
  integer, intent(inout) :: sblock   !! Blocking factor
  logical, intent(inout) :: error    !! Logical error flag
  logical, intent(inout) :: abort    !! User abort flag
  integer, intent(in)    :: cthread  !! Calling Thread number
  !
  ! Constants
  real(kind=8), parameter :: clight=299792458d-6 ! Frequency in  MHz
  !
  ! Local ---
  type (gridding) :: conv
  integer :: nc   ! Number of channels
  integer :: nd   ! Size of data
  integer :: nb   ! Number of beams
  integer :: ns   ! Number of channels per single beam
  integer :: wcol     ! Weight channel
  integer :: mcol(2)  ! First and last channel
  integer lcol,fcol
  integer ier
  real(kind=8) :: freq
  integer ctypx,ctypy
  real wall,cpu1
  real xparm(10),yparm(10)
  real(8) :: vref,voff,vinc
  integer :: lx, ly, kz1
  integer kz,iz,ic,kc,kb,jc,lc
  character(len=message_length) :: chain
  !
  real :: rms, null_taper(4), wold
  complex, allocatable :: tfgrid(:,:,:)
  real, allocatable :: w_weight(:), w_w(:), walls(:)
  real, allocatable :: w_v(:)         ! V values
  real, allocatable :: w_mapu(:), w_mapv(:)
  real, allocatable :: local_wfft(:)
  real :: uvcell(2)
  real :: support(2)
  real(8) :: local_freq
  !
  integer :: ithread, nthread
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  logical :: local_error
  integer :: grid_code
  !
  real, allocatable :: duv_grid(:,:)
  type(gildas) :: hgrid
  integer :: iv,ix,iy
  !
  ! Code ----
  call imager_tree('UV_GRID_PARA',.false.)
  !
  grid_code = 0
  error = .false.
  abort = .false.
  nd = nx*ny
  nc = huv%gil%nchan
  nb = 1 ! hbeam%gil%dim(3)
  !
  ns = map%beam
  Print *,'MAP%BEAM ',map%beam
  if (ns.eq.0) ns = nc !MODIF
  null_taper = 0
  !
  if (ns.ne.1 .and. nb.gt.1) then
    write(chain,'(a,i6,a)') 'Processing ',ns,' channels per beam'
    call map_message(seve%w,rname,chain)
  endif
  !
  ! Reset the parameters
  xparm = 0.0
  yparm = 0.0
  !
  vref = huv%gil%ref(1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  !
  ! Channel range and Weight
  mcol = channels%bounds
  wcol = channels%weight 
  fcol = channels%bounds(1)
  lcol = channels%bounds(2)
  nc = lcol-fcol+1
  !
  ! Compute observing sky frequency for U,V cell size
  if (channels%freq.ne.0) then
    freq = gdf_uv_frequency(huv, channels%freq)
  else
    freq = gdf_uv_frequency(huv)
  endif
  !
  ! Compute gridding function
  ctypx = map%ctype
  ctypy = map%ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, conv%ubuff, conv%ubias)
  call convfn (ctypy, yparm, conv%vbuff, conv%vbias)
  map%uvcell = clight/freq/(map%xycell*map%size)
  map%support(1) = xparm(1)*map%uvcell(1)  ! In meters
  map%support(2) = yparm(1)*map%uvcell(2)
  !
  ! Process sorted UV Table according to the type of beam produced
  !
  allocate (w_w(nv),w_v(nv),w_weight(nv),walls(nb),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate Weight & V arrays')
    error = .true.
    return
  endif
  w_v(:) = uvdata(2,1:nv)
  !
  !
  Print *,'MAP_SUPPoRT ',map%support
  Print *,'MAP_SUPPoRT ',map%uvcell
  Print *,'UVMAX ', uvmax
  lx = (uvmax+map%support(1))/map%uvcell(1) + 2
  ly = (uvmax+map%support(2))/map%uvcell(2) + 2
  lx = 2*lx
  ly = 2*ly
  Print *,'LX LY', lx,ly,nx,ny
  if (ly.gt.ny) then
    write(chain,'(A,A,F8.3)') 'Map cell is too large ',   &
        &      ' Undersampling ratio ',float(ly)/float(ny)
    call map_message(seve%w,rname,chain,3)
    ly = min(ly,ny)
    lx = min(lx,nx)
  endif
  !
  ! Get FFTs and beam work spaces
  allocate (tfgrid(ns+1,lx,ly),& 
    & w_mapu(lx),w_mapv(ly),local_wfft(2*max(nx,ny)),stat=ier) 
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate TF arrays')
    error = .true.
    return
  endif
  !
  call docoor (lx,-map%uvcell(1),w_mapu)
  call docoor (ly,map%uvcell(2),w_mapv)
  !
  if (sic_ctrlc()) then
    abort = .true. ! Quick abort
    return
  endif
  !
  allocate(duv_grid(huv%gil%dim(1),lx*ly),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'UV Grid Memory allocation error')
    error = .true.
    return
  endif
  !
  nthread = 1
  if (nb.gt.1) then
    !$ nthread = ompget_inner_threads()
  endif
  Print *,'MANY_BEAMS_PARA Thread ',nthread,' NB ',nb,' NS ',ns
  !
  ! Loop over blocks
  !
  !$OMP PARALLEL IF (nb.gt.1) DEFAULT(none) NUM_THREADS (nthread) &
  !$OMP PRIVATE(tfgrid,w_weight,w_w) &  ! Big arrays
  !$OMP PRIVATE(w_mapu,w_mapv) &
  !$OMP PRIVATE(local_wfft,chain) &
  !$OMP PRIVATE(local_freq,support,wall,wold,rms,uvcell,local_error) &
  !$OMP PRIVATE(kz,kb,kc,iz,ic, kz1, jc,lc) &
  !$OMP SHARED(walls,ns,nb) PRIVATE(ix,iy,iv) &
  !$OMP SHARED(nu,nv,nx,ny,nc,nd,fcol,lcol,lx,ly, nthread) &
  !$OMP SHARED(map,null_taper,error,abort,grid_code) &
  !$OMP SHARED(conv,freq) &
  !$OMP SHARED(huv,rname) & 
  !$OMP SHARED(w_v,uvdata) SHARED(duv_grid) &
  !$OMP SHARED(cpu0,cpu1) PRIVATE(elapsed_s, elapsed_e, elapsed, ithread)
    ! !$OMP SHARED(w_xgrid,w_ygrid) PRIVATE(w_grid,tfbeam,beam)
    
  kz = 1 ! test for bug below
  !
  ! Print *,'KZ ',kz,' NC ',nc,' nd ',nd
  !$OMP DO
  do ic = fcol,lcol,ns ! ,ns or ,1
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    kz = min(ns,lcol-ic+1)
    jc = min(huv%gil%nchan,ic+ns/3)   ! The default weight channel here...
    !TEST!Print *,'IC ',ic,' JC ',jc,'MCOL ',fcol,lcol,' NS ',ns
    ithread = 1
    !$ elapsed_s = omp_get_wtime()
    !$ ithread = omp_get_thread_num()+1
    !TEST!Print *,'Thread ',ithread,' IC ',ic,', KZ ',kz,', NS ',ns
    !
    kb = (ic-fcol)/ns+1
    if (kb.gt.nb .or. kb.lt.1) then
      Print *,'Programming error, expected 0 < ',kb,' < ',nb+1
      kb = nb
    endif
    !
    w_w(:) = uvdata(7+3*jc,:)
    wold = sump(nv,w_w)
    !
    ! Search for a non empty weight channel
    if (wold.eq.0) then
      do lc=ic,min(ic+ns,lcol) ! not  ,huv%gil%nchan)
        if (lc.ne.jc) then
          w_w(:) = uvdata(7+3*lc,:)
          wold = sump(nv,w_w)
          if (wold.ne.0) then
            jc = lc
            exit
          endif
        endif
      enddo
    endif
    !
    if (wold.eq.0) then
      write(chain,'(A,I6,A)') 'Channel ',jc, ' has zero weight'
      walls(kb) = 0.0
      if (nb.eq.1) then
        call map_message(seve%e,rname,chain)
        error = .true.
      else
        call map_message(seve%w,rname,chain)
      endif
      cycle
    else
      wall = 1e-3/sqrt(wold)
      !TEST!write(chain,'(a,i6,a)') 'Plane ',ic,' Natural '
      !TEST!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Compute the weights from this
    local_error = .false.
    call doweig (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,    &            ! U, V pointers
       &    jc,     &            ! Weight channel
       &    map%uniform(1),   &  ! Uniform UV cell size
       &    w_weight,   &        ! Weight array
       &    map%uniform(2),   &  ! Fraction of weight
       &    local_error,      &
       &    grid_code)
       
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    if (local_error)  then
      error = .true.
      cycle
    endif
    !
    ! Should also plug the TAPER here, rather than in DOFFT later  !
    call dotape (nu,nv,   &
       &    uvdata,   &          ! Visibilities
       &    1,2,   &             ! U, V pointers
       &    map%taper,  &        ! Taper
       &    w_weight)            ! Weight array
       !TEST!Print *,ic,'dotape'
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    ! Re-normalize the weights and re-count the noise
    wall = sump(nv,w_weight)
    if (wall.ne.wold) then
      call scawei (nv,w_weight,w_w,wall)
      wall = 1e-3/sqrt(wall)
      !TEST!write(chain,'(a,i6,a)') 'Plane ',ic,' Expected '
      !TEST!call prnoise('UV_MAP',trim(chain),wall,rms)
      walls(kb) = wall
    endif
    !
    ! Then compute the Dirty Beam
    local_freq = gdf_uv_frequency(huv, dble(ic))
    uvcell = map%uvcell * (freq / local_freq)
    support = map%support * (freq / local_freq)
    call docoor (lx,-uvcell(1),w_mapu)
    call docoor (ly,uvcell(2),w_mapv)
       !TEST!Print *,ic,'docoor'
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    ! Compute FFTs
    call dofft (nu,nv,          &   ! Size of visibility array
         &    uvdata,           &   ! Visibilities
         &    1,2,              &   ! U, V pointers
         &    ic,               &   ! First channel to map
         &    kz,lx,ly,         &   ! Cube size
         &    tfgrid,           &   ! FFT cube
         &    w_mapu,w_mapv,    &   ! U and V grid coordinates
         &    support,uvcell,null_taper, &  ! Gridding parameters
         &    w_weight,         &   ! Weight array 
         &    conv%ubias,conv%vbias,conv%ubuff,conv%vbuff,map%ctype)
       !TEST!Print *,ic,'dofft'
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    ! Plunge the Gridded TFGRID into a UV Table
    iv = 0
    do iy=1,ly
      do ix=1,lx
        iv = iv+1
        duv_grid(1,iv) = w_mapu(ix)  ! Units to be checked, must be in Meters
        duv_grid(2,iv) = w_mapv(iy)
        duv_grid(3,iv) = 0.0       ! No W term
        duv_grid(4:7,iv) = 0.      ! No valid information here
        do iz=1,kz
          duv_grid(8+(iz-1)*3,iv) = real(tfgrid(iz,ix,iy))
          duv_grid(9+(iz-1)*3,iv) = imag(tfgrid(iz,ix,iy))
          duv_grid(10+(iz-1)*3,iv) = real(tfgrid(kz+1,ix,iy) )! Weight (in some sense)
        enddo
      enddo
    enddo
    !
    if (sic_ctrlc()) abort = .true. ! Quick abort
    if (abort) cycle
    !
    !$  elapsed_e = omp_get_wtime()
    elapsed = elapsed_e - elapsed_s
    write(chain,103) 'End plane ',kc,' Time ',elapsed &
      & ,' Thread ',ithread
    call map_message(seve%d,rname,chain)
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  if (error) return
  if (abort) return
  !
  call gildas_null(hgrid,type='UVT')
  call gdf_copy_header(huv, hgrid, error)
  hgrid%gil%dim(2) = lx*ly
  hgrid%gil%nvisi = lx*ly
  hgrid%file = 'toto.uvt'
  call gdf_write_image(hgrid,duv_grid,error)
  !
  call gag_cpu(cpu1)
  if (jfield.eq.0) then
    write(chain,102) 'Finished maps ',cpu1-cpu0
    call map_message(seve%i,rname,chain)
  endif
  !
  wall = maxval(walls(1:nb))
  if (jfield.eq.0) then
    chain = 'Expected'
  else
    write(chain,'(A,I0,A)') 'Field ',jfield,'; Expected'
  endif
  call prnoise(rname,trim(chain),wall,rms)
  !  !
  ! Delete scratch space
  error = .false.
  if (allocated(tfgrid)) deallocate(tfgrid)
  !
  call imager_tree('UV_GRID_PARA',.true.)
  return
  !
102 format(a,f9.2)
103 format(a,i5,a,f9.2,a,i2,a,i2)
end subroutine uv_grid_para

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_tree
  use gildas_def
  !--------------------------------------------------------------------
  ! GTV tree support.
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  !
  ! GTV tree key-symbols
  character(len=1), parameter :: dir_sep  = '<'      ! Directory separator
  character(len=1), parameter :: dir_root = dir_sep  ! Root directory
  character(len=1), parameter :: dir_top  = '^'      ! Shortcut for top-level dir
  character(len=2), parameter :: dir_up   = '..'     ! Upper directory
  !
  integer(kind=4), parameter :: segname_length=32
  integer(kind=4), parameter :: gtvpath_length=128
  !
  ! Segment identifiers
  integer(kind=4), parameter :: seg_points = -1    ! Points (dots)
  integer(kind=4), parameter :: seg_poly   = -2    ! Polyline
  integer(kind=4), parameter :: seg_image  = -3    ! Image
  integer(kind=4), parameter :: seg_hfpoly = -4    ! Horizontal filled polygon
  integer(kind=4), parameter :: seg_vfpoly = -5    ! Vertical filled polygon
  integer(kind=4), parameter :: seg_pencol = -6    ! Pen colors
  integer(kind=4), parameter :: seg_lutcol = -7    ! Lut colors
  !
  integer(kind=4), parameter :: nrdim=8192/2
  !
end module gtv_tree
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_segatt
  !--------------------------------------------------------------------
  ! Segment attributes
  !--------------------------------------------------------------------
  ! Visibility
  integer(kind=4), parameter :: att_vis=0
  integer(kind=4), parameter :: att_dash=1      ! Internal id for dash style
  integer(kind=4), parameter :: att_weight=2    ! Internal id for weight
  integer(kind=4), parameter :: att_colour=3    ! Internal id for colour
  integer(kind=4), parameter :: att_depth=4     ! Internal id for depth
  !
  integer(kind=4), parameter :: min_dash=1
  integer(kind=4), parameter :: max_dash=8
  integer(kind=4), parameter :: min_weight=1
  integer(kind=4), parameter :: max_weight=5
  !
  integer(kind=4), parameter :: min_depth=1
  integer(kind=4), parameter :: max_depth=40
  !
  ! The following array provides the possible widths in cm. These data
  ! are redundant because of the technic used for the other protocols
  ! (X and PS), but isn't it better to show it directly?
  real(4), parameter :: graisse(max_weight) =  &
             (/ 0.015, 0.030, 0.045, 0.075, 0.120 /)
  real(4), parameter :: onoff(4,2:max_dash) = reshape((/  &
             .250, .200, .250, .200,     &  ! 2
             .025, .100, .025, .100,     &  ! 3
             .250, .200, .075, .200,     &  ! 4
             .500, .400, .500, .400,     &  ! 5
             .500, .200, .075, .200,     &  ! 6
             .500, .200, .250, .200,     &  ! 7
             .100, .150, .100, .150  /), &  ! 8
             (/4,max_dash-1/) )
  real(4), parameter :: onofflen(2:max_dash) = &
             (/ .900, .250, .725, 1.800, .975, 1.150, .500 /)
  !
end module gtv_segatt
!
module gtv_colors
  use gtv_segatt
  !
  ! <0:           user colors (LUT /PEN)
  ! >0:           standard colors
  ! >X11_ncolors: special color codes
  !
  integer(kind=4), parameter :: X11_ncolors=142            ! Number of fixed colors
  integer(kind=4), parameter :: pen_ncolors=X11_ncolors+3  ! GTV provides 3 more special "colors"
  !
  integer(kind=4), parameter :: pen_color_black=7
  integer(kind=4), parameter :: pen_color_white=139
  integer(kind=4), parameter :: pen_color_background=X11_ncolors+1
  integer(kind=4), parameter :: pen_color_foreground=X11_ncolors+2
  integer(kind=4), parameter :: pen_color_negative=X11_ncolors+3
  !
  integer(kind=4), parameter :: colname_length=19
  character(len=colname_length), parameter :: pen_colors(pen_ncolors) =  (/  &
    'ALICE_BLUE         ','ANTIQUE_WHITE      ','AQUAMARINE         ',  &
    'AZURE              ','BEIGE              ','BISQUE             ',  &
    'BLACK              ','BLANCHED_ALMOND    ','BLUE               ',  &
    'BLUE_VIOLET        ','BROWN              ','BURLYWOOD          ',  &
    'CADET_BLUE         ','CHARTREUSE         ','CHOCOLATE          ',  &
    'CORAL              ','CORNFLOWER         ','CORNSILK           ',  &
    'CRIMSON            ','CYAN               ','DARK_BLUE          ',  &
    'DARK_CYAN          ','DARK_GOLDENROD     ','DARK_GREEN         ',  &
    'DARK_GREY          ','DARK_KHAKI         ','DARK_MAGENTA       ',  &
    'DARK_OLIVE_GREEN   ','DARK_ORANGE        ','DARK_ORCHID        ',  &
    'DARK_RED           ','DARK_SALMON        ','DARK_SEA_GREEN     ',  &
    'DARK_SLATE_BLUE    ','DARK_SLATE_GREY    ','DARK_TURQUOISE     ',  &
    'DARK_VIOLET        ','DEEP_PINK          ','DEEP_SKY_BLUE      ',  &
    'DIM_GREY           ','DODGER_BLUE        ','FIREBRICK          ',  &
    'FLORAL_WHITE       ','FOREST_GREEN       ','GAINSBORO          ',  &
    'GHOST_WHITE        ','GOLD               ','GOLDENROD          ',  &
    'GREEN              ','GREEN_YELLOW       ','GREY               ',  &
    'HONEYDEW           ','HOT_PINK           ','INDIAN_RED         ',  &
    'INDIGO             ','IVORY              ','KHAKI              ',  &
    'LAVENDER           ','LAVENDER_BLUSH     ','LAWN_GREEN         ',  &
    'LEMON_CHIFFON      ','LIGHT_BLUE         ','LIGHT_CORAL        ',  &
    'LIGHT_CYAN         ','LIGHT_GOLDENROD    ','LIGHT_GREEN        ',  &
    'LIGHT_GREY         ','LIGHT_PINK         ','LIGHT_SALMON       ',  &
    'LIGHT_SEA_GREEN    ','LIGHT_SKY_BLUE     ','LIGHT_SLATE_GREY   ',  &
    'LIGHT_STEEL_BLUE   ','LIGHT_YELLOW       ','LIME_GREEN         ',  &
    'LINEN              ','MAGENTA            ','MAROON             ',  &
    'MEDIUM_AQUAMARINE  ','MEDIUM_BLUE        ','MEDIUM_ORCHID      ',  &
    'MEDIUM_PURPLE      ','MEDIUM_SEA_GREEN   ','MEDIUM_SLATE_BLUE  ',  &
    'MEDIUM_SPRING_GREEN','MEDIUM_TURQUOISE   ','MEDIUM_VIOLET_RED  ',  &
    'MIDNIGHT_BLUE      ','MINT_CREAM         ','MISTY_ROSE         ',  &
    'MOCCASIN           ','NAVAJO_WHITE       ','NAVY_BLUE          ',  &
    'OLD_LACE           ','OLIVE              ','OLIVE_DRAB         ',  &
    'ORANGE             ','ORANGE_RED         ','ORCHID             ',  &
    'PALE_GOLDENROD     ','PALE_GREEN         ','PALE_TURQUOISE     ',  &
    'PALE_VIOLET_RED    ','PAPAYA_WHIP        ','PEACH_PUFF         ',  &
    'PERU               ','PINK               ','PLUM               ',  &
    'POWDER_BLUE        ','PURPLE             ','REBECCA_PURPLE     ',  &
    'RED                ','ROSY_BROWN         ','ROYAL_BLUE         ',  &
    'SADDLE_BROWN       ','SALMON             ','SANDY_BROWN        ',  &
    'SEA_GREEN          ','SEASHELL           ','SIENNA             ',  &
    'SILVER             ','SKY_BLUE           ','SLATE_BLUE         ',  &
    'SLATE_GREY         ','SNOW               ','SPRING_GREEN       ',  &
    'STEEL_BLUE         ','TAN                ','TEAL               ',  &
    'THISTLE            ','TOMATO             ','TURQUOISE          ',  &
    'VIOLET             ','WEB_GREEN          ','WEB_GREY           ',  &
    'WEB_MAROON         ','WEB_PURPLE         ','WHEAT              ',  &
    'WHITE              ','WHITE_SMOKE        ','YELLOW             ',  &
    'YELLOW_GREEN       ',                                              &
    ! Special colors
    'BACKGROUND         ','FOREGROUND         ','NEGATIVE           '  /)
  !
  integer(kind=4), parameter :: X11_rgb(3,X11_ncolors) = reshape( (/  &
    240,  248,  255,  &  ! ALICE_BLUE
    250,  235,  215,  &  ! ANTIQUE_WHITE
    127,  255,  212,  &  ! AQUAMARINE
    240,  255,  255,  &  ! AZURE
    245,  245,  220,  &  ! BEIGE
    255,  228,  196,  &  ! BISQUE
      0,    0,    0,  &  ! BLACK
    255,  235,  205,  &  ! BLANCHED_ALMOND
      0,    0,  255,  &  ! BLUE
    138,   43,  226,  &  ! BLUE_VIOLET
    165,   42,   42,  &  ! BROWN
    222,  184,  135,  &  ! BURLYWOOD
     95,  158,  160,  &  ! CADET_BLUE
    127,  255,    0,  &  ! CHARTREUSE
    210,  105,   30,  &  ! CHOCOLATE
    255,  127,   80,  &  ! CORAL
    100,  149,  237,  &  ! CORNFLOWER
    255,  248,  220,  &  ! CORNSILK
    220,   20,   60,  &  ! CRIMSON
      0,  255,  255,  &  ! CYAN
      0,    0,  139,  &  ! DARK_BLUE
      0,  139,  139,  &  ! DARK_CYAN
    184,  134,   11,  &  ! DARK_GOLDENROD
      0,  100,    0,  &  ! DARK_GREEN
    169,  169,  169,  &  ! DARK_GREY
    189,  183,  107,  &  ! DARK_KHAKI
    139,    0,  139,  &  ! DARK_MAGENTA
     85,  107,   47,  &  ! DARK_OLIVE_GREEN
    255,  140,    0,  &  ! DARK_ORANGE
    153,   50,  204,  &  ! DARK_ORCHID
    139,    0,    0,  &  ! DARK_RED
    233,  150,  122,  &  ! DARK_SALMON
    143,  188,  143,  &  ! DARK_SEA_GREEN
     72,   61,  139,  &  ! DARK_SLATE_BLUE
     47,   79,   79,  &  ! DARK_SLATE_GREY
      0,  206,  209,  &  ! DARK_TURQUOISE
    148,    0,  211,  &  ! DARK_VIOLET
    255,   20,  147,  &  ! DEEP_PINK
      0,  191,  255,  &  ! DEEP_SKY_BLUE
    105,  105,  105,  &  ! DIM_GREY
     30,  144,  255,  &  ! DODGER_BLUE
    178,   34,   34,  &  ! FIREBRICK
    255,  250,  240,  &  ! FLORAL_WHITE
     34,  139,   34,  &  ! FOREST_GREEN
    220,  220,  220,  &  ! GAINSBORO
    248,  248,  255,  &  ! GHOST_WHITE
    255,  215,    0,  &  ! GOLD
    218,  165,   32,  &  ! GOLDENROD
      0,  255,    0,  &  ! GREEN
    173,  255,   47,  &  ! GREEN_YELLOW
    190,  190,  190,  &  ! GREY
    240,  255,  240,  &  ! HONEYDEW
    255,  105,  180,  &  ! HOT_PINK
    205,   92,   92,  &  ! INDIAN_RED
     75,    0,  130,  &  ! INDIGO
    255,  255,  240,  &  ! IVORY
    240,  230,  140,  &  ! KHAKI
    230,  230,  250,  &  ! LAVENDER
    255,  240,  245,  &  ! LAVENDER_BLUSH
    124,  252,    0,  &  ! LAWN_GREEN
    255,  250,  205,  &  ! LEMON_CHIFFON
    173,  216,  230,  &  ! LIGHT_BLUE
    240,  128,  128,  &  ! LIGHT_CORAL
    224,  255,  255,  &  ! LIGHT_CYAN
    250,  250,  210,  &  ! LIGHT_GOLDENROD
    144,  238,  144,  &  ! LIGHT_GREEN
    211,  211,  211,  &  ! LIGHT_GREY
    255,  182,  193,  &  ! LIGHT_PINK
    255,  160,  122,  &  ! LIGHT_SALMON
     32,  178,  170,  &  ! LIGHT_SEA_GREEN
    135,  206,  250,  &  ! LIGHT_SKY_BLUE
    119,  136,  153,  &  ! LIGHT_SLATE_GREY
    176,  196,  222,  &  ! LIGHT_STEEL_BLUE
    255,  255,  224,  &  ! LIGHT_YELLOW
     50,  205,   50,  &  ! LIME_GREEN
    250,  240,  230,  &  ! LINEN
    255,    0,  255,  &  ! MAGENTA
    176,   48,   96,  &  ! MAROON
    102,  205,  170,  &  ! MEDIUM_AQUAMARINE
      0,    0,  205,  &  ! MEDIUM_BLUE
    186,   85,  211,  &  ! MEDIUM_ORCHID
    147,  112,  219,  &  ! MEDIUM_PURPLE
     60,  179,  113,  &  ! MEDIUM_SEA_GREEN
    123,  104,  238,  &  ! MEDIUM_SLATE_BLUE
      0,  250,  154,  &  ! MEDIUM_SPRING_GREEN
     72,  209,  204,  &  ! MEDIUM_TURQUOISE
    199,   21,  133,  &  ! MEDIUM_VIOLET_RED
     25,   25,  112,  &  ! MIDNIGHT_BLUE
    245,  255,  250,  &  ! MINT_CREAM
    255,  228,  225,  &  ! MISTY_ROSE
    255,  228,  181,  &  ! MOCCASIN
    255,  222,  173,  &  ! NAVAJO_WHITE
      0,    0,  128,  &  ! NAVY_BLUE
    253,  245,  230,  &  ! OLD_LACE
    128,  128,    0,  &  ! OLIVE
    107,  142,   35,  &  ! OLIVE_DRAB
    255,  165,    0,  &  ! ORANGE
    255,   69,    0,  &  ! ORANGE_RED
    218,  112,  214,  &  ! ORCHID
    238,  232,  170,  &  ! PALE_GOLDENROD
    152,  251,  152,  &  ! PALE_GREEN
    175,  238,  238,  &  ! PALE_TURQUOISE
    219,  112,  147,  &  ! PALE_VIOLET_RED
    255,  239,  213,  &  ! PAPAYA_WHIP
    255,  218,  185,  &  ! PEACH_PUFF
    205,  133,   63,  &  ! PERU
    255,  192,  203,  &  ! PINK
    221,  160,  221,  &  ! PLUM
    176,  224,  230,  &  ! POWDER_BLUE
    160,   32,  240,  &  ! PURPLE
    102,   51,  153,  &  ! REBECCA_PURPLE
    255,    0,    0,  &  ! RED
    188,  143,  143,  &  ! ROSY_BROWN
     65,  105,  225,  &  ! ROYAL_BLUE
    139,   69,   19,  &  ! SADDLE_BROWN
    250,  128,  114,  &  ! SALMON
    244,  164,   96,  &  ! SANDY_BROWN
     46,  139,   87,  &  ! SEA_GREEN
    255,  245,  238,  &  ! SEASHELL
    160,   82,   45,  &  ! SIENNA
    192,  192,  192,  &  ! SILVER
    135,  206,  235,  &  ! SKY_BLUE
    106,   90,  205,  &  ! SLATE_BLUE
    112,  128,  144,  &  ! SLATE_GREY
    255,  250,  250,  &  ! SNOW
      0,  255,  127,  &  ! SPRING_GREEN
     70,  130,  180,  &  ! STEEL_BLUE
    210,  180,  140,  &  ! TAN
      0,  128,  128,  &  ! TEAL
    216,  191,  216,  &  ! THISTLE
    255,   99,   71,  &  ! TOMATO
     64,  224,  208,  &  ! TURQUOISE
    238,  130,  238,  &  ! VIOLET
      0,  128,    0,  &  ! WEB_GREEN
    128,  128,  128,  &  ! WEB_GREY
    127,    0,    0,  &  ! WEB_MAROON
    127,    0,  127,  &  ! WEB_PURPLE
    245,  222,  179,  &  ! WHEAT
    255,  255,  255,  &  ! WHITE
    245,  245,  245,  &  ! WHITE_SMOKE
    255,  255,    0,  &  ! YELLOW
    154,  205,   50   &  ! YELLOW_GREEN
    /), (/ 3,X11_ncolors /) )
  !
end module gtv_colors
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_bitmap_parameters
  !--------------------------------------------------------------------
  ! Bitmap images parameters
  !--------------------------------------------------------------------
  !
  ! Size of integers the bitmaps are computed in. If you are willing to
  ! change this, you also have to change things from the C side (see
  ! x_affiche_image and subsequent routines)
  integer(kind=4), parameter :: bitmap_depth=2  ! Depth of bitmaps
  integer(kind=2*bitmap_depth) :: bitmap_dynamic_max  ! Maximum number of levels
  !
  integer(kind=4), parameter :: scale_lin=1  ! Linear
  integer(kind=4), parameter :: scale_log=2  ! Logarithmic
  integer(kind=4), parameter :: scale_equ=3  ! Equalised
  integer(kind=4), parameter :: scale_lup=4  ! Lupton (for RGB images only)
  !
end module gtv_bitmap_parameters
!
module gtv_types
  use gildas_def
  use gtv_bitmap_parameters
  use gtv_segatt
  use gtv_tree
  !---------------------------------------------------------------------
  !   Derived types and associated parameters. No variables or instances
  ! here.
  !---------------------------------------------------------------------
  !
  type :: gt_segment_general
    character(len=segname_length) :: name
    real(kind=4)                  :: minmax(4)
    logical                       :: visible
  end type gt_segment_general
  !
  type :: gt_segment_attr
    integer(kind=4) :: dash    ! [code]
    real(kind=4)    :: weight  ! [cm]   Pen weight
    integer(kind=4) :: colour  ! [code] GTV internal colour code
    integer(kind=4) :: depth   ! [1-3]
  end type gt_segment_attr
  !
  type :: greg_values
    ! Used GREG saved values (might certainly be reduced). The sequence
    ! is required since the whole block of values is attached to the
    ! directory, and set from/put to the corresponding Greg global
    ! variables. One instance has a length of 26 words now: it must be
    ! the same for the buffer size in the routine 'greg_user' in GreG.
    !
    ! LX1, LX2, LY1, LY2 are a property of top-directories (e.g. <GREG
    ! is landscape and <FOO is portrait, and changing from one to another
    ! ensures Greg always knows the correct plot page).
    sequence
    real(kind=8) :: gux1, gux2  !  1- 4 user_xmin, user_xmax
    real(kind=8) :: guy1, guy2  !  5- 8 user_ymin, user_ymax
    real(kind=8) :: gux, guy    !  9-12 Conversion factor
    real(kind=8) :: lux, luy    ! 13-16 Logarithmique conversion offset
    logical      :: xlog, ylog  ! 17-18 X and Y axes log status
    real(kind=4) :: gx1, gx2    ! 19-20 X coordinates of the box
    real(kind=4) :: gy1, gy2    ! 21-22 Y coordinates of the box
    real(kind=4) :: lx1, lx2    ! 23-24 Plot X physical limits
    real(kind=4) :: ly1, ly2    ! 25-26 Plot Y physical limits
  end type greg_values
  !
  type :: polyline_buffer  ! Should use type 'gt_polyline'
    integer(kind=4) :: n
    real(kind=4) :: x(nrdim)  ! X, World units
    real(kind=4) :: y(nrdim)  ! Y, World units
  end type polyline_buffer
  !
  type :: gt_polyline
    integer(kind=4)       :: n                 ! Number of points
    real(kind=4), pointer :: x(:) => null()    ! X coordinates
    real(kind=4), pointer :: y(:) => null()    ! Y coordinates
    type(gt_lut), pointer :: penlut => null()  ! PENLUT to be used
  end type gt_polyline
  !
  ! Colormap description
  type :: gt_lut
    integer(kind=4) :: size=0              ! Size. Last value is blanking.
    integer(kind=address_length) :: xlut=0 ! Pointer the equivalent LUT for X window
    ! Data
    real(kind=4), allocatable :: r(:)    ! Red
    real(kind=4), allocatable :: g(:)    ! Green
    real(kind=4), allocatable :: b(:)    ! Blue
    real(kind=4), allocatable :: hue(:)  ! Hue
    real(kind=4), allocatable :: sat(:)  ! Saturation
    real(kind=4), allocatable :: val(:)  ! Value
  end type gt_lut
  !
  ! Image type for original (not resampled) GTV images: data
  type :: gt_image_data
    ! Data
    integer(kind=index_length) :: taille(2)                     ! Image size
    real(kind=4), pointer      :: values(:,:)                   ! True values
    integer(kind=2*bitmap_depth), allocatable :: eqvalues(:,:)  ! Equalized values
    ! Display
    real(kind=4)    :: blank(3)    ! Blanking
    real(kind=4)    :: cuts(2)     ! Low and high cuts of image
    real(kind=4)    :: extrema(2)  ! Actual extrema of image
  end type gt_image_data
  !
  ! Image type for original (not resampled) GTV images: descriptor + data
  type :: gt_image
    logical :: isrgb  ! Indexed image or RGB?
    ! Descriptor
    real(kind=4)    :: conv(6)              ! Conversion formula for image
    real(kind=4)    :: limits(4)            ! User limits of the image
    real(kind=4)    :: position(4)          ! Centimetric position of the image
    integer(kind=4) :: scaling              ! Scaling mode
    ! Specific to indexed images
    type(gt_lut), pointer :: lut => null()  ! LUT to be used (if indexed image)
    ! Specific to RGB images
    real(kind=4)    :: scaling_lup_b        ! Beta parameter for Lupton scaling mode
    ! Data
    type(gt_image_data) :: r  ! True values (indexed image or R value)
    type(gt_image_data) :: g  ! True G values (if RGB image). Allocatable?
    type(gt_image_data) :: b  ! True B values (if RGB image). Allocatable?
    ! Linked list
    type(gt_image), pointer :: next => null()  ! Next image in the linked list
  end type gt_image
  !
  type :: gt_segment_head
    ! Generic attributes
    type(gt_segment_general) :: gen
    type(gt_segment_attr)    :: attr         ! Pen attributes
    type(gt_lut), pointer    :: lut=>null()  ! Pointer to the LUT to be used by this segment
    !
  end type gt_segment_head
  !
  ! Segment data
  type :: gt_segment_data
    ! Kind
    integer(kind=4) :: kind  ! Kind of data stored here
    ! Data
    type(gt_polyline)       :: poly             ! Polylines or polygons
    type(gt_lut)            :: lut              ! Image LUT or pen LUT
    type(gt_image), pointer :: image => null()  ! Images
    ! Linked list:
    !   a GTV segment can be a collection of different data
    type(gt_segment_data), pointer :: nextdata => null()  ! Pointer to next block of data
  end type gt_segment_data
  !
  ! Polyline type for polyline and polygon segments: header+data
  type :: gt_segment
    ! Header
    type(gt_segment_head) :: head
    ! Data
    type(gt_segment_data), pointer :: data
    ! Tree
    type(gt_directory), pointer :: father  ! Parent directory
    ! Chain
    type(gt_segment), pointer :: nextseg  ! Next leaf in the directory
  end type gt_segment
  !
  ! X specific attributes for directories
  type :: gt_directory_x
    integer(kind=4)              :: curwin      ! Current window
    integer(kind=4)              :: nbwin       ! Number of windows attached
    integer(kind=address_length) :: genv        ! Pointer on the active window
    integer(kind=address_length) :: genv_array  ! Pointer on the table of addresses
  end type gt_directory_x
  !
  type :: gt_directory
    ! Generic attributes
    type(gt_segment_general) :: gen
    ! Directory-specific attributes
    real(kind=4)         :: phys_size(2)  ! Physical paper size
    type(greg_values)    :: val_greg      ! GREG values
    type(gt_directory_x) :: x             ! X specific attributes
    ! Tree
    type(gt_directory), pointer :: ancestor   ! Parent just under the root
    type(gt_directory), pointer :: father     ! Parent directory
    type(gt_directory), pointer :: brother    ! Next brother
    type(gt_directory), pointer :: son_first  ! First son
    type(gt_directory), pointer :: son_last   ! Last son
    ! Segments
    type(gt_segment), pointer :: leaf_first  ! First leaf in the directory
    type(gt_segment), pointer :: leaf_last   ! Last leaf in the directory
    integer(kind=4)           :: segn        ! Number of segments (maximum reached,
                                             ! NOT the actual number). It is used to
                                             ! build a unique name for each segment.
  end type gt_directory
  !
  ! Image type for GTV images resampled (virtual memory or disk)
  type :: gt_bitmap
    integer(kind=bitmap_depth), pointer :: irvalues(:,:)  ! Scaled R values
    integer(kind=bitmap_depth), pointer :: igvalues(:,:)  ! Scaled G values
    integer(kind=bitmap_depth), pointer :: ibvalues(:,:)  ! Scaled B values
    integer(kind=4) :: size(2)      ! Size on the display
    integer(kind=4) :: position(2)  ! Position offset on the display
    real(kind=4)    :: trans(4)     ! Image to display conversion
    !
    type(gt_image), pointer  :: image => null()  ! Backward pointer to the original image
    type(gt_bitmap), pointer :: next => null()   ! Next bitmap, if used in a chained list (see x_output)
  end type gt_bitmap
  !
  ! Variables describing a position or a size in screen units
  type :: x_coordinates
    real(kind=4)     :: x
    character(len=1) :: unitx
    real(kind=4)     :: y
    character(len=1) :: unity
  end type x_coordinates
  !
  ! X output specific variables
  type :: x_output
    ! General subsection
    integer(kind=address_length) :: graph_env=0      ! Window address
    integer(kind=4)              :: number           ! Window number seen by the user
    logical                      :: is_zoom=.false.  ! Is a zoom window?
    character(len=32)            :: name             ! Window name
    type(x_coordinates)          :: geometry         ! Initial window geometry
    type(x_coordinates)          :: position         ! Initial window position
    ! Associated bitmaps subsection
    integer(kind=4)          :: update_status
    type(gt_bitmap), pointer :: bitmap_first => null() ! Chained list of the resampled
    type(gt_bitmap), pointer :: bitmap_last => null()  ! images for the instance
  end type x_output
  !
  ! PS output specific variables
  type :: ps_output
    logical :: encapsulated  ! PS or EPS?
    logical :: fast          ! Fast i.e. use hardware generated lines?
    logical :: exact         ! PS/EPS /EXACT (i.e. use GTV coordinates as is)
  end type ps_output
  !
  ! PNG output specific variables
  type :: png_output
    ! Properties
    logical :: transparency  ! Transparent background (different from the 'black' logical)
    logical :: cropped       ! Should the white margins be kept or not?
    logical :: noblank       ! Should blanked pixels be replaced by background color?
    ! Channels
    integer(kind=4) :: nchan                ! Number of channels (R/G/B/A)
    integer(kind=1), allocatable :: R(:,:)  !
    integer(kind=1), allocatable :: G(:,:)  !
    integer(kind=1), allocatable :: B(:,:)  !
    integer(kind=1), allocatable :: A(:,:)  !
    ! Pen in use in the filler
    integer(kind=1) :: rpen      ! Red intensity of the current pen
    integer(kind=1) :: gpen      ! Green intensity of the current pen
    integer(kind=1) :: bpen      ! Blue intensity of the current pen
    logical         :: negative  ! Negate colors?
    integer(kind=4) :: width     ! Pen width (pixels)
    real(kind=4)    :: xpos      ! Pen current X location
    real(kind=4)    :: ypos      ! Pen current Y location
  end type png_output
  !
  ! SVG output specific variables
  type :: svg_output
    ! Properties
    logical :: cropped       ! Should the white margins be kept or not?
  end type svg_output
  !
  ! Device definition and defaults from gtvdef.
  type :: gt_device
    ! Miscellaneous informations
    integer(kind=4)   :: protocol=0    ! Protocol identifier
    integer(kind=4)   :: ident=0       ! Device identifier
    character(len=64) :: defout        ! Default /OUTPUT terminal device
    integer(kind=4)   :: background    ! 0 Black, 1 White
    ! Initialisation sequences
    integer(kind=4)    :: linit1       !
    character(len=255) :: init1        ! Initialisation sequence in GTOPEN
    character(len=1)   :: pad1         ! Padding which ensures 4-bytes alignment
    integer(kind=4)    :: linit2       !
    character(len=255) :: init2        !
    character(len=1)   :: pad2         !
    ! Device default size in "pixels"
    integer(kind=4) :: px1,px2         ! First and last pixels in X
    integer(kind=4) :: py1,py2         ! First and last pixels in Y
    real(kind=4)    :: rxy             !
    real(kind=4)    :: poff            ! Pixel offset (from int to real axis):
                                       !  0.0 -> pixel #1 runs from 0.0 to 1.0
                                       !  0.5 -> pixel #1 runs from 0.5 to 1.5
    ! Colormap capabilities of the device
    integer(kind=4) :: map_size        ! Size of usable color map
    integer(kind=4) :: map_offset      ! Offset of usable color map
    logical         :: map_color       ! Use colors?
    logical         :: map_static      !
    ! Hardware capabilities
    logical         :: hardw_line_weig ! Hardware can generate weight?
    logical         :: hardw_line_dash ! Hardware can generate dashed?
    logical         :: hardw_cursor    ! Hardware cursor available?
  end type gt_device
  !
  ! Device description
  type :: gt_display
    !
    ! Subsections
    type(gt_device), pointer :: dev  ! Device section (MUST BE FIRST!)
    type(x_output)           :: x    ! X protocol section
    type(ps_output)          :: ps   ! PostScript protocol section
    type(png_output)         :: png  ! PNG protocol section
    type(svg_output)         :: svg  ! SVG protocol section
    !
    ! Miscellanous attributes
    logical :: used=.false.        ! Is the instance currently in use?
    logical :: autorotate=.false.  ! Should rotate the drawing to adapt at most the display?
    logical :: autoscale=.true.    ! Should scale the drawing to adapt at most the display?
    !
    logical         :: tofile  ! Write in a file or terminal?
    integer(kind=4) :: iunit   ! Logical Unit for Output, for devices which require one
    logical         :: opened  ! Is the Output currently opened on Iunit?
    character(len=filename_length) :: file  ! File connected to Iunit, for devices which require one
    !
    integer(kind=4) :: px1,px2     ! Actual instance size in pixels
    integer(kind=4) :: py1,py2     !
    real(kind=4)    :: gx1,gx2     ! Clipping Window in world coordinates.
    real(kind=4)    :: gy1,gy2     !
    !
    integer(kind=4) :: background  ! Actual background color
    logical         :: color       ! A color or grey output?
    !
    real(kind=4) :: totdist        !
    !
    ! Attributes of the pen in current use in this display
    integer(kind=4) :: idashe=1           ! [code] Dashed attribute
    real(kind=4)    :: iweigh=graisse(1)  ! [cm]   Weight attribute
    integer(kind=4) :: icolou=1           ! [code] Colour attribute
  end type gt_display
  !
end module gtv_types
!
module gtv_bitmap
  use gtv_types
  use gtv_bitmap_parameters
  !--------------------------------------------------------------------
  ! Bitmap images
  ! For portability, SAVE Fortran variables which are target of SIC
  ! variables.
  !--------------------------------------------------------------------
  !
  integer, save :: nb_image=0  ! Number of images currently in use
  type(gt_image), pointer :: image_first => null()  ! First image in the linked list
  type(gt_image), pointer :: image_last => null()   ! Last image in the linked list
  !
  ! Support for equalization SIC variables
  integer(kind=4),                        save :: eqnlev    ! CURIMA%EQUAL%NLEV: number of levels
  real(kind=4),              allocatable, save :: eqlev(:)  ! CURIMA%EQUAL%LEV: levels
  integer(kind=size_length), allocatable, save :: eqbin(:)  ! CURIMA%EQUAL%HIST: bin number
  !
end module gtv_bitmap
!
module gtv_graphic
  use gildas_def
  use gtv_tree
  !--------------------------------------------------------------------
  ! Conversion factors, internal values, and interactive buffer support
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  !
  ! Conversion factors
  procedure(), pointer :: gt_greg_user => null()
  logical :: flag_greg  ! Is 'gt_greg_user' set?
  !
  ! Physical paper size (PLOT_PAGE): default values used when creating
  ! a new tree, when user does not provide custom values.
  real(4) :: phys_sizex_def   ! Default size of world plot area in X
  real(4) :: phys_sizey_def   ! Default size of world plot area in Y
  !
  logical       :: erflag=.false.           ! Error recovery?
  logical       :: error_condition=.false.  ! Set on error
  logical, save :: user_hardw_line=.true.   ! User prefers hardware generated?
  logical       :: awake=.false.            ! GTLIB awake?
  !
  character(len=segname_length+1) :: top_dir  ! "Login" directory name
  !
  ! GTVIRT Specials
  logical, save :: nofail=.false.                ! GTV%NOFAIL: no precaution for hardcopy
  logical, save :: stdout=.false.                ! GTV%STDOUT
  logical, save :: fitpage=.false.               ! GTV%FITPAGE
  logical, save :: dexist=.false.                ! GTV%EXIST
  character(len=gtvpath_length), save :: pwd     ! GTV%PWD
  character(len=10), save :: gtv_device          ! GTV%DEVICE
  logical,           save :: strict2011=.false.  ! GTV%STRICT2011: .false.
                   ! means that obsolete commands and behaviours will only
                   ! raise a warning, .true. that they will raise an error.
  !
end module gtv_graphic
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_protocol
  use gtv_types
  !--------------------------------------------------------------------
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  !
  !--------------------------------------------------------------------
  !    Protocols should be defined as contiguous integer values
  !    in the range [1...NPROT]. Protocols are always checked as
  !    integers excepted in the external terminal definition file
  !    in which they are defined as character strings.
  !--------------------------------------------------------------------
  integer, parameter :: nprot=13         ! Number of protocols (p_null excluded)
  integer, parameter :: p_null      = 0  ! No device
  integer, parameter :: p_tektro    = 1  ! Obsolete. Tektro 4010 compatible
  integer, parameter :: p_regis     = 2  ! Obsolete. Regis (VT125)
  integer, parameter :: p_hpgl      = 3  ! Obsolete. HP-GL (Hewlett-Packard devices)
  integer, parameter :: p_args      = 4  ! Obsolete. ARGS-Sigma colour image display
  integer, parameter :: p_gt600     = 5  ! Obsolete. GT600 graphics card for VT100 terminals
  integer, parameter :: p_vicom     = 6  ! Obsolete. Vicom colour image display
  integer, parameter :: p_hp2648    = 7  ! Obsolete. HP-2648
  integer, parameter :: p_mvax_gpx  = 8  ! Obsolete. m-Vax GPX graphics workstation
  integer, parameter :: p_x         = 9  ! Terminal X
  integer, parameter :: p_postscript=10  ! PostScript
  integer, parameter :: p_pict      =11  ! Unused. PICT for MacIntosh
  integer, parameter :: p_svg       =12  ! Scalable Vector Graphics
  integer, parameter :: p_png       =13  ! Portable Network Graphics
  !
  character(len=12), parameter :: protocol_list(0:nprot) =  (/ &
    'NONE        ',  &  !  0
    'TEKTRO      ',  &  !  1
    'REGIS       ',  &  !  2
    'HPGL        ',  &  !  3
    'ARGS        ',  &  !  4
    'GT600       ',  &  !  5
    'VICOM       ',  &  !  6
    'HP2648      ',  &  !  7
    'MVAX_GPX    ',  &  !  8
    'X           ',  &  !  9
    'POSTSCRIPT  ',  &  ! 10
    'PICT        ',  &  ! 11
    'SVG         ',  &  ! 12
    'PNG         '  /)  ! 13
  !
  ! List of currently supported devices (command GTV\DEVICE)
  integer(kind=4), parameter :: ndevices=9
  character(len=10), parameter :: device_list(0:ndevices) =  &
              (/ 'NONE      ',  &
                 'IMAGE     ',  &
                 'XPORTRAIT ',  &
                 'XLANDSCAPE',  &
                 'PS        ',  &
                 'EPS       ',  &
                 'PDF       ',  &
                 'EPDF      ',  &
                 'SVG       ',  &
                 'PNG       ' /)
  !
  ! Devices instances. "Devices" are opened with the command GTV\DEVICE,
  ! e.g DEVICE IMAGE or DEVICE PNG
  type(gt_device), target, save :: cw_device  ! Current working Device
  !
  ! Output instances which have a permanent life. "Outputs" are instances of
  ! a "device", e.g. 2 white X windows. Hardcopies create a temporary output
  ! with no permanent life, they do not consume a slot here.
  integer, parameter :: moutputs=20      ! Arbitrary limited
  type(gt_display), target, save :: all_outputs(moutputs)  ! All opened outputs
  type(gt_display), target, save :: null_output  ! Dummy output when no active output
  type(gt_display), pointer :: cw_output  ! Current Working Output
  !
  ! Parameter(s) and variable(s) specific to X protocol (ZZZ move
  ! somewhere else?)
  integer, parameter :: mwindows=5  ! Maximum number of windows viewing a directory
  !
end module gtv_protocol
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_buffers
  use gtv_tree
  use gtv_types
  !
  ! Segments
  type(gt_segment), pointer      :: co_segment => null()       ! Currently opened segment
  type(gt_segment_data), pointer :: co_segment_data => null()  ! Currently opened data segment
  !
  ! Directories
  type(gt_directory), pointer :: root => null()  ! The root directory "<"
  type(gt_directory), pointer :: cw_directory => null()  ! User's current working directory
  !
  integer(kind=4) :: cdepth             ! Max Depth Level in use
  logical         :: vdepth(max_depth)  ! Which levels are in use?
  !
  ! Current attributes for new segments
  type(gt_segment_attr) :: cattr
  !
  type(polyline_buffer) :: polyl  ! Buffer RELOC/DRAW (for storing internal metacode)
  !
end module gtv_buffers
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gtv_plot
  use gtv_types
  !--------------------------------------------------------------------
  ! Variables and parameters for plot support (color map, line styles)
  ! For portability, SAVE Fortran variables (or their common) which are
  ! target of SIC variables.
  !--------------------------------------------------------------------
  !
  integer, parameter :: hsv_mode=1
  integer, parameter :: rgb_mode=2
  !
  integer, parameter :: pen_size=16       ! Pens from 8 to 23
  !
  integer, save :: lut_size          ! Support variable for LUT%SIZE
  integer, save :: lut_mode=hsv_mode ! Support variable for LUT%MODE
  logical, save :: lut_static        ! Support variable for LUT%STATIC
  !
  ! Colormaps. One is global for use in case of LUT DYNAMIC. Save because it
  ! contains variables which are target of SIC variables. The other is a
  ! pointer which can be used in case of LUT STATIC.
  type(gt_lut), target, save :: gbl_colormap
  !
  ! Current Working Pens (for pens 8 to 23)
  type(gt_lut), target, save :: gbl_pen  ! Save because it contains variables which are target of SIC variables
  !
end module gtv_plot
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#!/usr/bin/env bash

echo "###################################"
echo "#                                 #"
echo "#  IMAGER software installation   #"
echo "#                                 #"
echo "###################################"
echo ""

# Script parameter
# empty -> get last available version
# or
# version number (ex: sep25) -> get the specified version


url="https://share.oasu.u-bordeaux.fr/imager"    # Archives url
Version=""

# Function: check_connection
# --------------------------
# Checks if a given URL is reachable using curl.
# Returns:
#   0 - if the connection is successful
#   1 - if the URL cannot be reached
check_connection() {
    local url=$1
    # Try to connect to the given URL with curl (HEAD request, silent mode, 5s timeout)
    if curl --head --silent --output /dev/null --connect-timeout 5 "$url"; then
        return 0
    else
        return 1
    fi
}

# Function: check_remote_file_exists
# ----------------------------------
# Checks if a specific file exists on a remote server using curl.
# Returns:
#   0 - if the file exists (server responds with success status)
#   1 - if the file does not exist (e.g., 404 Not Found)
check_remote_file_exists() {
    local url=$1
    local filename=$2
    # Try to check if the file exists by sending a HEAD request
    if curl --head --silent --output /dev/null --fail "$url/$filename"; then
        return 0
    else
        return 1
    fi
}


# MAIN CODE
# ---------

# 1. Retrieve the source code
if [[ "$#" = "0" ]] ; then
    Version="last"
    
    echo "Recovering last IMAGER sources from $url"

    # Check connexion
    check_connection $url
    rc=$?

    if [[ $rc = 1 ]]; then
        echo "Impossible to connect to $url. Exiting."
        exit 1
    fi

    # Check file existence
    check_remote_file_exists $url "imager-$Version.tgz"
    rcc=$?

    if [[ $rcc = 1 ]]; then
        echo "Impossible to get IMAGER version $Version. Exiting."
        exit 1
    fi

    # Get file
    curl -o imager-$Version.tgz $url/imager-$Version.tgz

    echo "Extracting imager-$Version.tgz to imager-src-* directory"
    tar -xf imager-last.tgz
    
    # Detect and store the real code version
    for dirname in */
    do
        if [[ "${dirname:0:10}" = "imager-src" ]] ; then
            if [[ "${dirname:16:1}" = "/" ]] ; then
                Version="${dirname:11:5}"
            fi
        fi
    done

else
    Version=$1
    
    # Check locally if an archive file is available for this version
    if [[ -f imager-$Version.tgz ]] || [[ -f imager-$Version.tar.gz ]] ; then

        # Get the first maching file
        filename=$(find . -name "imager-$Version.*" -type f | head -n 1 | cut -d"/" -f2)

        echo "Using the file $filename found locally"
        
        echo "Extracting $filename to imager-src-$Version directory"
        tar -xf "$filename"

    # Otherwise check remote url
    else
    
        echo "Recovering IMAGER version $Version from $url"

        # Check connexion
        check_connection $url
        rc=$?

        if [[ $rc = 1 ]]; then
            echo "Impossible to connect to $url. Exiting."
            exit 1
        fi

        # Check file existence
        check_remote_file_exists $url "imager-$Version.tgz"
        rcc=$?

        if [[ $rcc = 1 ]]; then
            echo "Impossible to get IMAGER version $Version. Exiting."
            exit 1
        else
            # Get file
            curl -o "imager-$Version.tgz" "$url/imager-$Version.tgz"
            echo "Extracting imager-$Version.tgz to imager-src-$Version directory"
            tar -xf "imager-$Version.tgz"
        fi

    fi

fi

echo "Using version $Version"
echo ""

unset answer
read -rp "-> Ready to continue (y/N) ? : " answer && [[ $answer == [yY] || $answer == [yY][eE][sS] ]] || exit 1


# 2. Compilation
if [[ -d "imager-src-$Version" ]]; then
    echo "Moving to imager-src-$Version"
elif [[ -d "imager-$Version" ]]; then
    mv "imager-$Version"  "imager-src-$Version"
else 
    echo "ERR: IMAGER version $Version not found. Exiting."
    exit 1
fi

# Patch until imager-env.sh has been updated (safe in all cases)
export my_exedir=$PWD/imager-exe-$Version         # Patch

# Ensure no conflict with other versions being compiled
unset gagsrcdir
unset gagexedir
unset gagadmdir


cd "imager-src-$Version" || exit 1

# Prepare the compilation scripts from Admin-Source
cd Admin-Source || exit 1
source substitute.compile.sh

cd .. || exit 1
# Execute the environment definition script
source admin/imager-env.sh -o openmp
export gagexedir=$my_exedir         # Patch

# Get the number of cores and leave one core free (but at least 1 job)
ncores=$(getconf _NPROCESSORS_ONLN)
jobs=$((ncores > 1 ? ncores - 1 : 1))

if [[ jobs > 16 ]]; then
  jobs=16
fi
echo "Compilation will use $jobs threads in parallel"
#
# Get confirmation
echo "Ready to compile IMAGER in $gagsrcdir."
read -rp "-> Continue (y/N)? : " answer && [[ $answer == [yY] || $answer == [yY][eE][sS] ]] || exit 1

make -j"$jobs"

echo "Ready to install IMAGER on $gagexedir."
read -rp "-> Continue (y/N)? : " answer && [[ $answer == [yY] || $answer == [yY][eE][sS] ]] || exit 1

make install

cd .. || exit 1

# No change usually
# for fdir in gchar gcont gcore ggtk ggui gkernel gwindows # gx11 gmotif

for fdir in gio gmath greg gsys gtv gwcs gxml sic
do
  echo $fdir
  source diff-f90.sh kernel/lib/$fdir > diff-$fdir.txt
  cd $OLDPWD
  source diff-c.sh kernel/lib/$fdir >> diff-$fdir.txt
  cd $OLDPWD
done

export VersionNumber="4.6-03"
export VersionDate="30-Nov-2025"
cp -rf .git RELEASE/imager-$VersionNumber.git
#
cd RELEASE
echo 'git clone imager-'$VersionNumber'.git' > install.sh
echo 'cd imager-'$VersionNumber >> install.sh
#
echo "source admin/imager-env.sh -o openmp" >> install.sh
echo "make -j16"  >> install.sh
echo "make install" >> install.sh
#
tar -cvzf imager-$VersionNumber-$VersionDate.tgz imager-$VersionNumber.git install.sh 
rm -rf imager-$VersionNumber.git 
cd ..

#! /bin/sh
Version=" "
Dest=" "
Branch="newgio"
#
if [ "$#" = "3" ] ; then
  Branch=$3
  Dest=$2
  Version=$1
elif [ "$#" = "2" ] ; then
  Dest=$2
  Version=$1
elif [ "$#" = "1" ] ; then
  Version=$1
  Dest=$1
elif [ "$#" = "0" ] ; then
  echo "Usage: source release.sh VersioName  [Short Name]"
  return 1
fi
#
# Move to RELEASE storage area
cd RELEASE
# Clone the GIT repository
rm -rf imager-src-$Version
git clone --branch $Branch https://forge.oasu.u-bordeaux.fr/ums-porea/projets/imager/alma_imager imager-src-$Version
# Prepare the "admin" files for MacPorts 
cd imager-src-$Version
echo "Converting to MacPorts script files in tree $PWD" 
cd Admin-Source
echo $PWD
source substitute.macport.sh
cd ../..
#
echo "Creating imager-$Version.tgz in tree $PWD"
rm imager-$Version.tgz
tar -cvzf imager-$Version.tgz --exclude imager-src-$Version/.git imager-src-$Version
if [ "$Dest" = "$Version" ] ; then
  echo "No link needed"
else
  rm imager-$Dest.tgz
  ln -s imager-$Version.tgz imager-$Dest.tgz
fi
echo "Pushing imager-$Dest.tgz to SHARE area "
#curl --user stephane:lab5804 -T imager-last.tgz https://dave.oasu.u-bordeaux.fr:5000/5964614a-44f2-47fd-ba18-5f155543044e/imager-last.tgz
# Now on https://share.oasu.u-bordeaux.fr/imager
curl --user stephane:lab5804 -T imager-$Dest.tgz https://share.oasu.u-bordeaux.fr/imager/imager-$Dest.tgz
echo "Updating get-and-install script"
cd ..
curl --user stephane:lab5804 -T get-and-install.sh  https://share.oasu.u-bordeaux.fr/imager/get-and-install.sh
#

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "define-version.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagdefver() {
    #
    # Variable and function definitions
    #
    DEFVER_AUTHOR='J. Pety <pety@iram.fr>'
    DEFVER_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    DEFVER_PROGNAME='gagdefver'
    #
    defver_usage() {
	cat <<EOF 1>&2

Define standard directory name conventions used by the "build" and
"source-gag.sh" scripts to enable easy coexistence of different GILDAS
version. To do this, define the following environment variables: 
   GAG_VERS, GAG_TAG, SRCDIR, EXEDIR, LOGDIR

usage: source $DEFVER_PROGNAME [version]

options:
  -d     Refine GAG_VERS with tag date if possible
  -n     Do not translate 'day' or 'month' to current day or month, but
         assume that directories (or symlinks to) exist with the input
         version name.
  -r     Mark the version as reference
  -h     Show this help page
  -v     Show version information

EOF
	defver_clean
    }
    #
    defver_showversion() {
	echo "$DEFVER_PROGNAME, by $DEFVER_AUTHOR"
	echo "Project: $DEFVER_PROJECT"
	defver_clean
    }
    #
    defver_message() {
	echo "$DEFVER_PROGNAME: $1"
    }
    #
    defver_error() {
	echo 1>&2
	echo "$DEFVER_PROGNAME error: $1" 1>&2
	echo 1>&2
	defver_clean
    }
    #
    defver_clean() {
	unset defver_usage defver_showversion defver_message 
	unset defver_error defver_clean defver_ref
	unset defver_tagdate defver_date
	unset DEFVER_AUTHOR DEFVER_PROGNAME DEFVER_PROJECT
	unset DEFVER_INVERS DEFVER_OUTVERS
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    temp=`getopt "dnrhv" "$@"`
    if [ $? -ne 0 ]; then defver_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-d) defver_date=1 ;;
	-r) defver_ref=1 ;;
	-n) defver_not=1 ;;
	-v) defver_showversion; return 0 ;;
	-h) defver_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) DEFVER_INVERS="default";; # Default version defined below!
	1) DEFVER_INVERS=$1;;
	*) defver_usage;  return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # day is an alias for the current day
    # (ie 2 digit day + the first 3 letters of the current month)
    #
    # month is an alias for the current month
    # (ie the first 3 letters of the current month + last 2 digits of current year).
    #
    case $DEFVER_INVERS in
	day)     if [ "$defver_not" ]; then DEFVER_OUTVERS=$DEFVER_INVERS; else DEFVER_OUTVERS=`date '+%d%b' | tr '[:upper:]' '[:lower:]'`; fi ;;
	month)   if [ "$defver_not" ]; then DEFVER_OUTVERS=$DEFVER_INVERS; else DEFVER_OUTVERS=`date '+%b%y' | tr '[:upper:]' '[:lower:]'`; fi ;;
	default) DEFVER_OUTVERS="last";;
	*)       if [ "$defver_ref" ]; then DEFVER_OUTVERS="ref"; else DEFVER_OUTVERS=$DEFVER_INVERS; fi
    esac
    #
    #######################################################################
    #
    # dev is equivalent to main trunk.
    #
    case $DEFVER_INVERS in
	default|month) GAG_TAG=$DEFVER_OUTVERS;;
	dev)           GAG_TAG="HEAD";;
	*)             GAG_TAG=$DEFVER_INVERS
    esac
    export GAG_TAG
    #
    #######################################################################
    #
    # Refine GAG_VERS with tag date when asked and possible
    #
    GAG_VERS=$DEFVER_OUTVERS
    if [ "$defver_date" ]; then
	unset defver_tagdate
	if [ "$GAG_TAG" = "HEAD" ]; then
	    defver_tagdate=`date -R`
	elif cvs history -aT 2> /dev/null  | grep "${GAG_TAG}" > /dev/null; then
	    defver_tagdate=`cvs history -aT | grep ${GAG_TAG} | tail -1 | cut -d' ' -f2-4`
	fi
	if [ -n "$defver_tagdate" ]; then
	    defver_date=`date -d "${defver_tagdate}" "+%d%b%y %H:%M %Z"` || defver_date=$defver_tagdate
	    if [ $? -eq 0 ]; then
		defver_date=`echo ${defver_date} | tr '[:upper:]' '[:lower:]'`
	    fi
	    GAG_VERS="${GAG_VERS} (${defver_date})"
	fi
    fi
    export GAG_VERS
    #
    #######################################################################
    #
    if [ -z "$gaghome" ]; then
	gaghome=$HOME/gildas
    fi
    export gaghome
    #
    #######################################################################
    #
    SRCDIR=$gaghome/gildas-src-$DEFVER_OUTVERS
    EXEDIR=$gaghome/gildas-exe-$DEFVER_OUTVERS
    LOGDIR=$gaghome/logs/$DEFVER_OUTVERS
    export SRCDIR EXEDIR LOGDIR
    #
    #######################################################################
    #
    defver_clean
}
#
###########################################################################

#!/bin/sh
if [ -d "imager-src-$1" ]; then
  echo "Moving to imager-src-$1"
elif [ -d "imager-$1" ]; then
  mv imager-$1 imager-src-$1
  source admin/imager-env.sh -o openmp
elif [ -f "imager-$1.tar.gz" ]; then
  tar -xvf imager-$1.tar.gz
  mv imager-$1 imager-src-$1
else 
  echo "No such version $1"
  return
fi
# Patch until imager-env.sh has been updated
export my_exedir=$PWD/imager-exe-$1 # Patch
cd imager-src-$1
source admin/imager-env.sh -o openmp
export gagexedir=$my_exedir         # Patch
echo $gagexedir # Patch
#
# get confirmation
read -t 10 -p "Ready to compile Imager in $gagsrcdir. Continue (y/N)? " answer
# if answer is yes within 10 seconds start updating cluster nodes ...
if [ "${answer}" == "y" ]
then
  make -j16
fi
#
unset answer
read -t 10 -p "Ready to install Imager on $gagexedir. Continue (y/N)? " answer
if [ "${answer}" == "y" ]
then
  make install
fi
cd ..

# Script to prepare the MacPort/Linux dependent files for Linux or Local compilation
#   substitute.macport.sh does the equivalent for MacPort construction
#
sed 's|@PREFIX@/bin/gsort|sort|g; s/@CPP@/cpp/g; s/@CC@/gcc/g; s/@CXX@/g++/g; s/@FC@/gfortran/g; s/@PYTHON@/python/g ' define-system.sh.orig > define-system.sh
sed 's/@CPPFLAGS@/ /g; s/@LDFLAGS@/ /g; s/@FCFLAGS@/ /g; s/@CCFLAGS@/ /g; s/@CPP@/cpp/g; s/@PYTHON@/python/g' Makefile.def.orig > Makefile.def
cp imager-env.sh.orig imager-env.sh
cp Makefile.build.orig Makefile.build
#sed 's/@PYTHON@/python/g' Makefile.python.orig > Makefile.python
#
# Compare
diff -bB define-system.sh ../admin
diff -bB imager-env.sh ../admin
diff Makefile.def ../admin
diff Makefile.build ../admin
#
# Move
mv define-system.sh ../admin
mv imager-env.sh ../admin
mv Makefile.def ../admin
mv Makefile.build ../admin
#
echo "Files configured for Local compilation"
  

# Script to prepare the MacPort/Linux dependent files for MacPorts distribution
#   substitute.compile.sh does the equivalent for Linux or local construction
# Compare
diff -bB define-system.sh.orig ../admin/define-system.sh
diff -bB imager-env.sh.orig ../admin/imager-env.sh
diff Makefile.def.orig ../admin/Makefile.def
diff Makefile.build.orig ../admin/Makefile.build
#
# In principle, all files are Non modified
cp define-system.sh.orig ../admin/define-system.sh
cp imager-env.sh.orig ../admin/imager-env.sh
cp Makefile.def.orig ../admin/Makefile.def
cp Makefile.build.orig ../admin/Makefile.build
#
echo "Files configured for MacPort distribution"

###########################################################################
#
# Warnings:
#
#   This files is loaded very early in the logging process.
#   You thus must put here only fonction and variable definitions.
#
#   Forbidden stuffs:
#      1. DISPLAY and KEYBOARD related variable definitions.
#      2. Any executable commands.
#
# J.Pety and P.Dumontroty 2004
#
###########################################################################
#
function gagbure() {
    export gaghome=/users/softs/gildas/off-line
    source $gaghome/gildas-admin/source-gag.sh "$@"
    set --
    if [ -f ~gildas/bin/set-bure-paths ]; then
        source ~gildas/bin/set-bure-paths
    fi
}
#
# Shortcut for parallel version compiled at BURE This hides details
# about compiler (kind and version) and config used:
function gagpara() {
    gagbure -c gfortran72 -o openmp "$@"
}
#
export -f gagbure gagpara
#
###########################################################################

# No change usually
# for fdir in gchar gcont gcore ggtk ggui gkernel gmotif windows 
alias diff="diff -q"
for fdir in gfits gio gmath greg gsys gtv gwcs gwidget gwindows gx11 gxml gcore ggtk sic
do
  echo $fdir
  source diff-f90.sh kernel/lib/$fdir > DIFF-GILDAS/diff-$fdir.test
  cd $OLDPWD
  source diff-c.sh kernel/lib/$fdir >> DIFF-GILDAS/diff-$fdir.test
  cd $OLDPWD
done
unalias diff
#
cd DIFF-GILDAS
grep differ diff-*.test > all-differences.txt
cd ..
